deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fflush (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a___stream.c_pointer)
		end

	c_fflush (a___stream: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return fflush($a___stream);"
		end

	fgets (a___s: CE_POINTER [INTEGER_8]; a___n: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a___s.c_pointer, a___n, a___stream.c_pointer))
		end

	c_fgets (a___s: POINTER; a___n: INTEGER_32; a___stream: POINTER): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return fgets($a___s, $a___n, $a___stream);"
		end

	fopen (a___filename: CE_POINTER [INTEGER_8]; a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a___filename.c_pointer, a___modes.c_pointer))
		end

	c_fopen (a___filename: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return fopen($a___filename, $a___modes);"
		end

	perror (a___s: CE_POINTER [INTEGER_8])
		do
			c_perror (a___s.c_pointer)
		end

	c_perror (a___s: POINTER)
		external
			"C inline use <micro_httpd.h>"
		alias
			"perror($a___s);"
		end

	printf (a_args: TUPLE [a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &printf;"
		end

	putchar (a___c: INTEGER_32): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return putchar($a___c);"
		end

	snprintf (a_args: TUPLE [a___s: CE_POINTER [INTEGER_8]; a___maxlen: NATURAL_32; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_snprintf)).integer_32_item (a_args)
		end

	c_snprintf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &snprintf;"
		end

	sprintf (a_args: TUPLE [a___s: CE_POINTER [INTEGER_8]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &sprintf;"
		end

	sscanf (a_args: TUPLE [a___s: CE_POINTER [INTEGER_8]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &sscanf;"
		end

end
