expanded class
	JUMP_STATE

feature {ANY} -- return

	return_called: BOOLEAN
			-- "return" called

	return
		do
			return_called := True
		end


feature {ANY} -- loops

	break_called: BOOLEAN
			-- "break" called

	break
		do
			break_called := True
		end

	continue_called: BOOLEAN
			-- "continue" called

	continue
		do
			continue_called := True
		end

feature {ANY} -- queries

	loop_jumped: BOOLEAN
			-- "break", "continue" or "return" called
		do
			Result := break_called or continue_called or return_called
		end

	loop_increment: BOOLEAN
			-- should increment statements be executed
		do
			Result := not break_called and not return_called
		end

	loop_done: BOOLEAN
			-- was "break" or "return" called?
			-- also resets `break_called' and `continue_called' to False
		do
			Result := break_called or return_called
			break_called := False
			continue_called := False
		end

end
