class
	PD_EYESCLASSREC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create core_class.make
			create eyes_class.make
		end

feature {ANY} -- fields

	core_class: SD_CORECLASSPART assign set_core_class

	eyes_class: PD_EYESCLASSPART assign set_eyes_class

feature {ANY} -- setters

	set_core_class (a_core_class: SD_CORECLASSPART)
		do
			core_class := a_core_class
			update_memory_field ("core_class")
		end

	set_eyes_class (a_eyes_class: PD_EYESCLASSPART)
		do
			eyes_class := a_eyes_class
			update_memory_field ("eyes_class")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			core_class := a_other.core_class.twin
			eyes_class := a_other.eyes_class.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				core_class.is_equal (a_other.core_class) and
				eyes_class.is_equal (a_other.eyes_class)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("core_class"),
					create {CE_STRUCTURE_FIELD}.make ("eyes_class")
				>>)
			init_structure_info
		end

end
