class
	PD_EYESPART

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create outGC.make
			create pupGC.make
			create centerGC.make
			create shapeGC.make
			create mouse.make
			create pupil.make (<<2>>)
			create t.make
			create maskt.make
		end

feature {ANY} -- fields

	puppixel: NATURAL_32 assign set_puppixel

	outline: NATURAL_32 assign set_outline

	center: NATURAL_32 assign set_center

	outGC: CE_POINTER [ANY] assign set_outGC

	pupGC: CE_POINTER [ANY] assign set_pupGC

	centerGC: CE_POINTER [ANY] assign set_centerGC

	shapeGC: CE_POINTER [ANY] assign set_shapeGC

	backing_store: INTEGER_32 assign set_backing_store

	reverse_video: INTEGER_8 assign set_reverse_video

	shape_window: INTEGER_8 assign set_shape_window

	update: INTEGER_32 assign set_update

	mouse: PD_TPOINT assign set_mouse

	pupil: CE_ARRAY [PD_TPOINT]

	t: PD_TRANSFORM assign set_t

	maskt: PD_TRANSFORM assign set_maskt

	interval_id: NATURAL_32 assign set_interval_id

	shape_mask: NATURAL_32 assign set_shape_mask

feature {ANY} -- setters

	set_puppixel (a_puppixel: NATURAL_32)
		do
			puppixel := a_puppixel
			update_memory_field ("puppixel")
		end

	set_outline (a_outline: NATURAL_32)
		do
			outline := a_outline
			update_memory_field ("outline")
		end

	set_center (a_center: NATURAL_32)
		do
			center := a_center
			update_memory_field ("center")
		end

	set_outGC (a_outGC: CE_POINTER [ANY])
		do
			outGC := a_outGC
			update_memory_field ("outGC")
		end

	set_pupGC (a_pupGC: CE_POINTER [ANY])
		do
			pupGC := a_pupGC
			update_memory_field ("pupGC")
		end

	set_centerGC (a_centerGC: CE_POINTER [ANY])
		do
			centerGC := a_centerGC
			update_memory_field ("centerGC")
		end

	set_shapeGC (a_shapeGC: CE_POINTER [ANY])
		do
			shapeGC := a_shapeGC
			update_memory_field ("shapeGC")
		end

	set_backing_store (a_backing_store: INTEGER_32)
		do
			backing_store := a_backing_store
			update_memory_field ("backing_store")
		end

	set_reverse_video (a_reverse_video: INTEGER_8)
		do
			reverse_video := a_reverse_video
			update_memory_field ("reverse_video")
		end

	set_shape_window (a_shape_window: INTEGER_8)
		do
			shape_window := a_shape_window
			update_memory_field ("shape_window")
		end

	set_update (a_update: INTEGER_32)
		do
			update := a_update
			update_memory_field ("update")
		end

	set_mouse (a_mouse: PD_TPOINT)
		do
			mouse := a_mouse
			update_memory_field ("mouse")
		end

	set_t (a_t: PD_TRANSFORM)
		do
			t := a_t
			update_memory_field ("t")
		end

	set_maskt (a_maskt: PD_TRANSFORM)
		do
			maskt := a_maskt
			update_memory_field ("maskt")
		end

	set_interval_id (a_interval_id: NATURAL_32)
		do
			interval_id := a_interval_id
			update_memory_field ("interval_id")
		end

	set_shape_mask (a_shape_mask: NATURAL_32)
		do
			shape_mask := a_shape_mask
			update_memory_field ("shape_mask")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			puppixel := a_other.puppixel
			outline := a_other.outline
			center := a_other.center
			outGC := a_other.outGC
			pupGC := a_other.pupGC
			centerGC := a_other.centerGC
			shapeGC := a_other.shapeGC
			backing_store := a_other.backing_store
			reverse_video := a_other.reverse_video
			shape_window := a_other.shape_window
			update := a_other.update
			mouse := a_other.mouse.twin
			pupil := a_other.pupil.twin
			t := a_other.t.twin
			maskt := a_other.maskt.twin
			interval_id := a_other.interval_id
			shape_mask := a_other.shape_mask
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				puppixel = a_other.puppixel and
				outline = a_other.outline and
				center = a_other.center and
				outGC.is_equal (a_other.outGC) and
				pupGC.is_equal (a_other.pupGC) and
				centerGC.is_equal (a_other.centerGC) and
				shapeGC.is_equal (a_other.shapeGC) and
				backing_store = a_other.backing_store and
				reverse_video = a_other.reverse_video and
				shape_window = a_other.shape_window and
				update = a_other.update and
				mouse.is_equal (a_other.mouse) and
				pupil.is_equal (a_other.pupil) and
				t.is_equal (a_other.t) and
				maskt.is_equal (a_other.maskt) and
				interval_id = a_other.interval_id and
				shape_mask = a_other.shape_mask
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("puppixel"),
					create {CE_STRUCTURE_FIELD}.make ("outline"),
					create {CE_STRUCTURE_FIELD}.make ("center"),
					create {CE_STRUCTURE_FIELD}.make ("outGC"),
					create {CE_STRUCTURE_FIELD}.make ("pupGC"),
					create {CE_STRUCTURE_FIELD}.make ("centerGC"),
					create {CE_STRUCTURE_FIELD}.make ("shapeGC"),
					create {CE_STRUCTURE_FIELD}.make ("backing_store"),
					create {CE_STRUCTURE_FIELD}.make ("reverse_video"),
					create {CE_STRUCTURE_FIELD}.make ("shape_window"),
					create {CE_STRUCTURE_FIELD}.make ("update"),
					create {CE_STRUCTURE_FIELD}.make ("mouse"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pupil", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("t"),
					create {CE_STRUCTURE_FIELD}.make ("maskt"),
					create {CE_STRUCTURE_FIELD}.make ("interval_id"),
					create {CE_STRUCTURE_FIELD}.make ("shape_mask")
				>>)
			init_structure_info
		end

end
