class
	PD_TRANSFORM

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	mx: REAL_64 assign set_mx

	bx: REAL_64 assign set_bx

	my: REAL_64 assign set_my

	by: REAL_64 assign set_by

feature {ANY} -- setters

	set_mx (a_mx: REAL_64)
		do
			mx := a_mx
			update_memory_field ("mx")
		end

	set_bx (a_bx: REAL_64)
		do
			bx := a_bx
			update_memory_field ("bx")
		end

	set_my (a_my: REAL_64)
		do
			my := a_my
			update_memory_field ("my")
		end

	set_by (a_by: REAL_64)
		do
			by := a_by
			update_memory_field ("by")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mx := a_other.mx
			bx := a_other.bx
			my := a_other.my
			by := a_other.by
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mx = a_other.mx and
				bx = a_other.bx and
				my = a_other.my and
				by = a_other.by
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mx"),
					create {CE_STRUCTURE_FIELD}.make ("bx"),
					create {CE_STRUCTURE_FIELD}.make ("my"),
					create {CE_STRUCTURE_FIELD}.make ("by")
				>>)
			init_structure_info
		end

end
