class
	SD_XEVENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	xany: SD_XANYEVENT assign set_xany

	xkey: SD_XKEYEVENT assign set_xkey

	xbutton: SD_XBUTTONEVENT assign set_xbutton

	xmotion: SD_XMOTIONEVENT assign set_xmotion

	xcrossing: SD_XCROSSINGEVENT assign set_xcrossing

	xfocus: SD_XFOCUSCHANGEEVENT assign set_xfocus

	xexpose: SD_XEXPOSEEVENT assign set_xexpose

	xgraphicsexpose: SD_XGRAPHICSEXPOSEEVENT assign set_xgraphicsexpose

	xnoexpose: SD_XNOEXPOSEEVENT assign set_xnoexpose

	xvisibility: SD_XVISIBILITYEVENT assign set_xvisibility

	xcreatewindow: SD_XCREATEWINDOWEVENT assign set_xcreatewindow

	xdestroywindow: SD_XDESTROYWINDOWEVENT assign set_xdestroywindow

	xunmap: SD_XUNMAPEVENT assign set_xunmap

	xmap: SD_XMAPEVENT assign set_xmap

	xmaprequest: SD_XMAPREQUESTEVENT assign set_xmaprequest

	xreparent: SD_XREPARENTEVENT assign set_xreparent

	xconfigure: SD_XCONFIGUREEVENT assign set_xconfigure

	xgravity: SD_XGRAVITYEVENT assign set_xgravity

	xresizerequest: SD_XRESIZEREQUESTEVENT assign set_xresizerequest

	xconfigurerequest: SD_XCONFIGUREREQUESTEVENT assign set_xconfigurerequest

	xcirculate: SD_XCIRCULATEEVENT assign set_xcirculate

	xcirculaterequest: SD_XCIRCULATEREQUESTEVENT assign set_xcirculaterequest

	xproperty: SD_XPROPERTYEVENT assign set_xproperty

	xselectionclear: SD_XSELECTIONCLEAREVENT assign set_xselectionclear

	xselectionrequest: SD_XSELECTIONREQUESTEVENT assign set_xselectionrequest

	xselection: SD_XSELECTIONEVENT assign set_xselection

	xcolormap: SD_XCOLORMAPEVENT assign set_xcolormap

	xclient: SD_XCLIENTMESSAGEEVENT assign set_xclient

	xmapping: SD_XMAPPINGEVENT assign set_xmapping

	xerror: SD_XERROREVENT assign set_xerror

	xkeymap: SD_XKEYMAPEVENT assign set_xkeymap

	pad: CE_ARRAY [INTEGER_32]

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_xany (a_xany: SD_XANYEVENT)
		do
			xany := a_xany
			update_memory_field ("xany")
		end

	set_xkey (a_xkey: SD_XKEYEVENT)
		do
			xkey := a_xkey
			update_memory_field ("xkey")
		end

	set_xbutton (a_xbutton: SD_XBUTTONEVENT)
		do
			xbutton := a_xbutton
			update_memory_field ("xbutton")
		end

	set_xmotion (a_xmotion: SD_XMOTIONEVENT)
		do
			xmotion := a_xmotion
			update_memory_field ("xmotion")
		end

	set_xcrossing (a_xcrossing: SD_XCROSSINGEVENT)
		do
			xcrossing := a_xcrossing
			update_memory_field ("xcrossing")
		end

	set_xfocus (a_xfocus: SD_XFOCUSCHANGEEVENT)
		do
			xfocus := a_xfocus
			update_memory_field ("xfocus")
		end

	set_xexpose (a_xexpose: SD_XEXPOSEEVENT)
		do
			xexpose := a_xexpose
			update_memory_field ("xexpose")
		end

	set_xgraphicsexpose (a_xgraphicsexpose: SD_XGRAPHICSEXPOSEEVENT)
		do
			xgraphicsexpose := a_xgraphicsexpose
			update_memory_field ("xgraphicsexpose")
		end

	set_xnoexpose (a_xnoexpose: SD_XNOEXPOSEEVENT)
		do
			xnoexpose := a_xnoexpose
			update_memory_field ("xnoexpose")
		end

	set_xvisibility (a_xvisibility: SD_XVISIBILITYEVENT)
		do
			xvisibility := a_xvisibility
			update_memory_field ("xvisibility")
		end

	set_xcreatewindow (a_xcreatewindow: SD_XCREATEWINDOWEVENT)
		do
			xcreatewindow := a_xcreatewindow
			update_memory_field ("xcreatewindow")
		end

	set_xdestroywindow (a_xdestroywindow: SD_XDESTROYWINDOWEVENT)
		do
			xdestroywindow := a_xdestroywindow
			update_memory_field ("xdestroywindow")
		end

	set_xunmap (a_xunmap: SD_XUNMAPEVENT)
		do
			xunmap := a_xunmap
			update_memory_field ("xunmap")
		end

	set_xmap (a_xmap: SD_XMAPEVENT)
		do
			xmap := a_xmap
			update_memory_field ("xmap")
		end

	set_xmaprequest (a_xmaprequest: SD_XMAPREQUESTEVENT)
		do
			xmaprequest := a_xmaprequest
			update_memory_field ("xmaprequest")
		end

	set_xreparent (a_xreparent: SD_XREPARENTEVENT)
		do
			xreparent := a_xreparent
			update_memory_field ("xreparent")
		end

	set_xconfigure (a_xconfigure: SD_XCONFIGUREEVENT)
		do
			xconfigure := a_xconfigure
			update_memory_field ("xconfigure")
		end

	set_xgravity (a_xgravity: SD_XGRAVITYEVENT)
		do
			xgravity := a_xgravity
			update_memory_field ("xgravity")
		end

	set_xresizerequest (a_xresizerequest: SD_XRESIZEREQUESTEVENT)
		do
			xresizerequest := a_xresizerequest
			update_memory_field ("xresizerequest")
		end

	set_xconfigurerequest (a_xconfigurerequest: SD_XCONFIGUREREQUESTEVENT)
		do
			xconfigurerequest := a_xconfigurerequest
			update_memory_field ("xconfigurerequest")
		end

	set_xcirculate (a_xcirculate: SD_XCIRCULATEEVENT)
		do
			xcirculate := a_xcirculate
			update_memory_field ("xcirculate")
		end

	set_xcirculaterequest (a_xcirculaterequest: SD_XCIRCULATEREQUESTEVENT)
		do
			xcirculaterequest := a_xcirculaterequest
			update_memory_field ("xcirculaterequest")
		end

	set_xproperty (a_xproperty: SD_XPROPERTYEVENT)
		do
			xproperty := a_xproperty
			update_memory_field ("xproperty")
		end

	set_xselectionclear (a_xselectionclear: SD_XSELECTIONCLEAREVENT)
		do
			xselectionclear := a_xselectionclear
			update_memory_field ("xselectionclear")
		end

	set_xselectionrequest (a_xselectionrequest: SD_XSELECTIONREQUESTEVENT)
		do
			xselectionrequest := a_xselectionrequest
			update_memory_field ("xselectionrequest")
		end

	set_xselection (a_xselection: SD_XSELECTIONEVENT)
		do
			xselection := a_xselection
			update_memory_field ("xselection")
		end

	set_xcolormap (a_xcolormap: SD_XCOLORMAPEVENT)
		do
			xcolormap := a_xcolormap
			update_memory_field ("xcolormap")
		end

	set_xclient (a_xclient: SD_XCLIENTMESSAGEEVENT)
		do
			xclient := a_xclient
			update_memory_field ("xclient")
		end

	set_xmapping (a_xmapping: SD_XMAPPINGEVENT)
		do
			xmapping := a_xmapping
			update_memory_field ("xmapping")
		end

	set_xerror (a_xerror: SD_XERROREVENT)
		do
			xerror := a_xerror
			update_memory_field ("xerror")
		end

	set_xkeymap (a_xkeymap: SD_XKEYMAPEVENT)
		do
			xkeymap := a_xkeymap
			update_memory_field ("xkeymap")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			xany := a_other.xany.twin
			xkey := a_other.xkey.twin
			xbutton := a_other.xbutton.twin
			xmotion := a_other.xmotion.twin
			xcrossing := a_other.xcrossing.twin
			xfocus := a_other.xfocus.twin
			xexpose := a_other.xexpose.twin
			xgraphicsexpose := a_other.xgraphicsexpose.twin
			xnoexpose := a_other.xnoexpose.twin
			xvisibility := a_other.xvisibility.twin
			xcreatewindow := a_other.xcreatewindow.twin
			xdestroywindow := a_other.xdestroywindow.twin
			xunmap := a_other.xunmap.twin
			xmap := a_other.xmap.twin
			xmaprequest := a_other.xmaprequest.twin
			xreparent := a_other.xreparent.twin
			xconfigure := a_other.xconfigure.twin
			xgravity := a_other.xgravity.twin
			xresizerequest := a_other.xresizerequest.twin
			xconfigurerequest := a_other.xconfigurerequest.twin
			xcirculate := a_other.xcirculate.twin
			xcirculaterequest := a_other.xcirculaterequest.twin
			xproperty := a_other.xproperty.twin
			xselectionclear := a_other.xselectionclear.twin
			xselectionrequest := a_other.xselectionrequest.twin
			xselection := a_other.xselection.twin
			xcolormap := a_other.xcolormap.twin
			xclient := a_other.xclient.twin
			xmapping := a_other.xmapping.twin
			xerror := a_other.xerror.twin
			xkeymap := a_other.xkeymap.twin
			pad := a_other.pad.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				xany.is_equal (a_other.xany) and
				xkey.is_equal (a_other.xkey) and
				xbutton.is_equal (a_other.xbutton) and
				xmotion.is_equal (a_other.xmotion) and
				xcrossing.is_equal (a_other.xcrossing) and
				xfocus.is_equal (a_other.xfocus) and
				xexpose.is_equal (a_other.xexpose) and
				xgraphicsexpose.is_equal (a_other.xgraphicsexpose) and
				xnoexpose.is_equal (a_other.xnoexpose) and
				xvisibility.is_equal (a_other.xvisibility) and
				xcreatewindow.is_equal (a_other.xcreatewindow) and
				xdestroywindow.is_equal (a_other.xdestroywindow) and
				xunmap.is_equal (a_other.xunmap) and
				xmap.is_equal (a_other.xmap) and
				xmaprequest.is_equal (a_other.xmaprequest) and
				xreparent.is_equal (a_other.xreparent) and
				xconfigure.is_equal (a_other.xconfigure) and
				xgravity.is_equal (a_other.xgravity) and
				xresizerequest.is_equal (a_other.xresizerequest) and
				xconfigurerequest.is_equal (a_other.xconfigurerequest) and
				xcirculate.is_equal (a_other.xcirculate) and
				xcirculaterequest.is_equal (a_other.xcirculaterequest) and
				xproperty.is_equal (a_other.xproperty) and
				xselectionclear.is_equal (a_other.xselectionclear) and
				xselectionrequest.is_equal (a_other.xselectionrequest) and
				xselection.is_equal (a_other.xselection) and
				xcolormap.is_equal (a_other.xcolormap) and
				xclient.is_equal (a_other.xclient) and
				xmapping.is_equal (a_other.xmapping) and
				xerror.is_equal (a_other.xerror) and
				xkeymap.is_equal (a_other.xkeymap) and
				pad.is_equal (a_other.pad)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("xany"),
					create {CE_STRUCTURE_FIELD}.make ("xkey"),
					create {CE_STRUCTURE_FIELD}.make ("xbutton"),
					create {CE_STRUCTURE_FIELD}.make ("xmotion"),
					create {CE_STRUCTURE_FIELD}.make ("xcrossing"),
					create {CE_STRUCTURE_FIELD}.make ("xfocus"),
					create {CE_STRUCTURE_FIELD}.make ("xexpose"),
					create {CE_STRUCTURE_FIELD}.make ("xgraphicsexpose"),
					create {CE_STRUCTURE_FIELD}.make ("xnoexpose"),
					create {CE_STRUCTURE_FIELD}.make ("xvisibility"),
					create {CE_STRUCTURE_FIELD}.make ("xcreatewindow"),
					create {CE_STRUCTURE_FIELD}.make ("xdestroywindow"),
					create {CE_STRUCTURE_FIELD}.make ("xunmap"),
					create {CE_STRUCTURE_FIELD}.make ("xmap"),
					create {CE_STRUCTURE_FIELD}.make ("xmaprequest"),
					create {CE_STRUCTURE_FIELD}.make ("xreparent"),
					create {CE_STRUCTURE_FIELD}.make ("xconfigure"),
					create {CE_STRUCTURE_FIELD}.make ("xgravity"),
					create {CE_STRUCTURE_FIELD}.make ("xresizerequest"),
					create {CE_STRUCTURE_FIELD}.make ("xconfigurerequest"),
					create {CE_STRUCTURE_FIELD}.make ("xcirculate"),
					create {CE_STRUCTURE_FIELD}.make ("xcirculaterequest"),
					create {CE_STRUCTURE_FIELD}.make ("xproperty"),
					create {CE_STRUCTURE_FIELD}.make ("xselectionclear"),
					create {CE_STRUCTURE_FIELD}.make ("xselectionrequest"),
					create {CE_STRUCTURE_FIELD}.make ("xselection"),
					create {CE_STRUCTURE_FIELD}.make ("xcolormap"),
					create {CE_STRUCTURE_FIELD}.make ("xclient"),
					create {CE_STRUCTURE_FIELD}.make ("xmapping"),
					create {CE_STRUCTURE_FIELD}.make ("xerror"),
					create {CE_STRUCTURE_FIELD}.make ("xkeymap"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pad", <<24>>)
				>>)
			init_structure_info
		end

end
