class
	SD_XNOEXPOSEEVENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create display.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	drawable: NATURAL_32 assign set_drawable

	major_code: INTEGER_32 assign set_major_code

	minor_code: INTEGER_32 assign set_minor_code

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_drawable (a_drawable: NATURAL_32)
		do
			drawable := a_drawable
			update_memory_field ("drawable")
		end

	set_major_code (a_major_code: INTEGER_32)
		do
			major_code := a_major_code
			update_memory_field ("major_code")
		end

	set_minor_code (a_minor_code: INTEGER_32)
		do
			minor_code := a_minor_code
			update_memory_field ("minor_code")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			drawable := a_other.drawable
			major_code := a_other.major_code
			minor_code := a_other.minor_code
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				drawable = a_other.drawable and
				major_code = a_other.major_code and
				minor_code = a_other.minor_code
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("drawable"),
					create {CE_STRUCTURE_FIELD}.make ("major_code"),
					create {CE_STRUCTURE_FIELD}.make ("minor_code")
				>>)
			init_structure_info
		end

end
