class
	SD_XTCALLBACKREC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create callback.make
			create closure.make
		end

feature {ANY} -- fields

	callback: CE_ROUTINE assign set_callback

	closure: CE_POINTER [ANY] assign set_closure

feature {ANY} -- setters

	set_callback (a_callback: CE_ROUTINE)
		do
			callback := a_callback
			update_memory_field ("callback")
		end

	set_closure (a_closure: CE_POINTER [ANY])
		do
			closure := a_closure
			update_memory_field ("closure")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			callback := a_other.callback
			closure := a_other.closure
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				callback.is_equal (a_other.callback) and
				closure.is_equal (a_other.closure)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("callback"),
					create {CE_STRUCTURE_FIELD}.make ("closure")
				>>)
			init_structure_info
		end

end
