class
	SD_XTWIDGETGEOMETRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sibling.make
		end

feature {ANY} -- fields

	request_mode: NATURAL_32 assign set_request_mode

	x: INTEGER_16 assign set_x

	y: INTEGER_16 assign set_y

	width: NATURAL_16 assign set_width

	height: NATURAL_16 assign set_height

	border_width: NATURAL_16 assign set_border_width

	sibling: CE_POINTER [SD_WIDGETREC] assign set_sibling

	stack_mode: INTEGER_32 assign set_stack_mode

feature {ANY} -- setters

	set_request_mode (a_request_mode: NATURAL_32)
		do
			request_mode := a_request_mode
			update_memory_field ("request_mode")
		end

	set_x (a_x: INTEGER_16)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_16)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_width (a_width: NATURAL_16)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: NATURAL_16)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_border_width (a_border_width: NATURAL_16)
		do
			border_width := a_border_width
			update_memory_field ("border_width")
		end

	set_sibling (a_sibling: CE_POINTER [SD_WIDGETREC])
		do
			sibling := a_sibling
			update_memory_field ("sibling")
		end

	set_stack_mode (a_stack_mode: INTEGER_32)
		do
			stack_mode := a_stack_mode
			update_memory_field ("stack_mode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			request_mode := a_other.request_mode
			x := a_other.x
			y := a_other.y
			width := a_other.width
			height := a_other.height
			border_width := a_other.border_width
			sibling := a_other.sibling
			stack_mode := a_other.stack_mode
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				request_mode = a_other.request_mode and
				x = a_other.x and
				y = a_other.y and
				width = a_other.width and
				height = a_other.height and
				border_width = a_other.border_width and
				sibling.is_equal (a_other.sibling) and
				stack_mode = a_other.stack_mode
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("request_mode"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("border_width"),
					create {CE_STRUCTURE_FIELD}.make ("sibling"),
					create {CE_STRUCTURE_FIELD}.make ("stack_mode")
				>>)
			init_structure_info
		end

end
