class
	PD_FILESTATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buf_next.make
			create buf_prev.make
			create hashtbl.make (<<64>>)
		end

feature {ANY} -- fields

	buf_next: CE_POINTER [PD_BUF] assign set_buf_next

	buf_prev: CE_POINTER [PD_BUF] assign set_buf_prev

	hashtbl: CE_ARRAY [PD_BUFLIST]

	file: INTEGER_32 assign set_file

	flags: INTEGER_32 assign set_flags

	fpos: INTEGER_32 assign set_fpos

	nbufs: INTEGER_32 assign set_nbufs

	block: INTEGER_32 assign set_block

	offset: NATURAL_32 assign set_offset

	fsize: INTEGER_32 assign set_fsize

feature {ANY} -- setters

	set_buf_next (a_buf_next: CE_POINTER [PD_BUF])
		do
			buf_next := a_buf_next
			update_memory_field ("buf_next")
		end

	set_buf_prev (a_buf_prev: CE_POINTER [PD_BUF])
		do
			buf_prev := a_buf_prev
			update_memory_field ("buf_prev")
		end

	set_file (a_file: INTEGER_32)
		do
			file := a_file
			update_memory_field ("file")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_fpos (a_fpos: INTEGER_32)
		do
			fpos := a_fpos
			update_memory_field ("fpos")
		end

	set_nbufs (a_nbufs: INTEGER_32)
		do
			nbufs := a_nbufs
			update_memory_field ("nbufs")
		end

	set_block (a_block: INTEGER_32)
		do
			block := a_block
			update_memory_field ("block")
		end

	set_offset (a_offset: NATURAL_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

	set_fsize (a_fsize: INTEGER_32)
		do
			fsize := a_fsize
			update_memory_field ("fsize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buf_next := a_other.buf_next
			buf_prev := a_other.buf_prev
			hashtbl := a_other.hashtbl.twin
			file := a_other.file
			flags := a_other.flags
			fpos := a_other.fpos
			nbufs := a_other.nbufs
			block := a_other.block
			offset := a_other.offset
			fsize := a_other.fsize
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buf_next.is_equal (a_other.buf_next) and
				buf_prev.is_equal (a_other.buf_prev) and
				hashtbl.is_equal (a_other.hashtbl) and
				file = a_other.file and
				flags = a_other.flags and
				fpos = a_other.fpos and
				nbufs = a_other.nbufs and
				block = a_other.block and
				offset = a_other.offset and
				fsize = a_other.fsize
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buf_next"),
					create {CE_STRUCTURE_FIELD}.make ("buf_prev"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("hashtbl", <<64>>),
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("fpos"),
					create {CE_STRUCTURE_FIELD}.make ("nbufs"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("offset"),
					create {CE_STRUCTURE_FIELD}.make ("fsize")
				>>)
			init_structure_info
		end

end
