class
	PD_HILITE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create hl_next.make
		end

feature {ANY} -- fields

	hl_next: CE_POINTER [PD_HILITE] assign set_hl_next

	hl_startpos: INTEGER_32 assign set_hl_startpos

	hl_endpos: INTEGER_32 assign set_hl_endpos

feature {ANY} -- setters

	set_hl_next (a_hl_next: CE_POINTER [PD_HILITE])
		do
			hl_next := a_hl_next
			update_memory_field ("hl_next")
		end

	set_hl_startpos (a_hl_startpos: INTEGER_32)
		do
			hl_startpos := a_hl_startpos
			update_memory_field ("hl_startpos")
		end

	set_hl_endpos (a_hl_endpos: INTEGER_32)
		do
			hl_endpos := a_hl_endpos
			update_memory_field ("hl_endpos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hl_next := a_other.hl_next
			hl_startpos := a_other.hl_startpos
			hl_endpos := a_other.hl_endpos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hl_next.is_equal (a_other.hl_next) and
				hl_startpos = a_other.hl_startpos and
				hl_endpos = a_other.hl_endpos
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hl_next"),
					create {CE_STRUCTURE_FIELD}.make ("hl_startpos"),
					create {CE_STRUCTURE_FIELD}.make ("hl_endpos")
				>>)
			init_structure_info
		end

end
