class
	PD_TAG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create tag_file.make
			create tag_pattern.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TAG] assign set_next

	prev: CE_POINTER [PD_TAG] assign set_prev

	tag_file: CE_POINTER [INTEGER_8] assign set_tag_file

	tag_linenum: INTEGER_32 assign set_tag_linenum

	tag_pattern: CE_POINTER [INTEGER_8] assign set_tag_pattern

	tag_endline: INTEGER_8 assign set_tag_endline

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_TAG])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TAG])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_tag_file (a_tag_file: CE_POINTER [INTEGER_8])
		do
			tag_file := a_tag_file
			update_memory_field ("tag_file")
		end

	set_tag_linenum (a_tag_linenum: INTEGER_32)
		do
			tag_linenum := a_tag_linenum
			update_memory_field ("tag_linenum")
		end

	set_tag_pattern (a_tag_pattern: CE_POINTER [INTEGER_8])
		do
			tag_pattern := a_tag_pattern
			update_memory_field ("tag_pattern")
		end

	set_tag_endline (a_tag_endline: INTEGER_8)
		do
			tag_endline := a_tag_endline
			update_memory_field ("tag_endline")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			tag_file := a_other.tag_file
			tag_linenum := a_other.tag_linenum
			tag_pattern := a_other.tag_pattern
			tag_endline := a_other.tag_endline
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				tag_file.is_equal (a_other.tag_file) and
				tag_linenum = a_other.tag_linenum and
				tag_pattern.is_equal (a_other.tag_pattern) and
				tag_endline = a_other.tag_endline
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("tag_file"),
					create {CE_STRUCTURE_FIELD}.make ("tag_linenum"),
					create {CE_STRUCTURE_FIELD}.make ("tag_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("tag_endline")
				>>)
			init_structure_info
		end

end
