class
	PD_TAGLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create tl_first.make
			create tl_last.make
		end

feature {ANY} -- fields

	tl_first: CE_POINTER [PD_TAG] assign set_tl_first

	tl_last: CE_POINTER [PD_TAG] assign set_tl_last

feature {ANY} -- setters

	set_tl_first (a_tl_first: CE_POINTER [PD_TAG])
		do
			tl_first := a_tl_first
			update_memory_field ("tl_first")
		end

	set_tl_last (a_tl_last: CE_POINTER [PD_TAG])
		do
			tl_last := a_tl_last
			update_memory_field ("tl_last")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tl_first := a_other.tl_first
			tl_last := a_other.tl_last
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tl_first.is_equal (a_other.tl_first) and
				tl_last.is_equal (a_other.tl_last)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tl_first"),
					create {CE_STRUCTURE_FIELD}.make ("tl_last")
				>>)
			init_structure_info
		end

end
