class
	PD_TEXTLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create string.make
			create endstring.make
		end

feature {ANY} -- fields

	string: CE_POINTER [INTEGER_8] assign set_string

	endstring: CE_POINTER [INTEGER_8] assign set_endstring

feature {ANY} -- setters

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_endstring (a_endstring: CE_POINTER [INTEGER_8])
		do
			endstring := a_endstring
			update_memory_field ("endstring")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			string := a_other.string
			endstring := a_other.endstring
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				string.is_equal (a_other.string) and
				endstring.is_equal (a_other.endstring)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("endstring")
				>>)
			init_structure_info
		end

end
