#ifndef LESS_H
#define LESS_H

#include <ffi.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <time.h>
#include <libio.h>
#include <sys/stat.h>
#include <bits/sigset.h>
#include <regex.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <termcap.h>
#include <stdio.h>
#include <ctype.h>
#include <locale.h>
#include <fcntl.h>
#include <signal.h>
#include <bits/errno.h>

#undef pos
#undef ln
#undef p_string
#undef p_int
#undef p_linenum
#undef c2_iflag
#undef c2_oflag
#undef c2_cflag
#undef c2_lflag
#undef c2_line
#undef c2_cc
#undef c2_ispeed
#undef c2_ospeed
#undef ws_row
#undef ws_col
#undef ws_xpixel
#undef ws_ypixel
#undef next
#undef prev
#undef hnext
#undef hprev
#undef block
#undef datasize
#undef data
#undef buf_next
#undef buf_prev
#undef buf_hnext
#undef buf_hprev
#undef hashtbl
#undef file
#undef flags
#undef fpos
#undef nbufs
#undef offset
#undef fsize
#undef name
#undef p_flag
#undef desc
#undef oname
#undef string
#undef endstring
#undef curr_mp
#undef onext
#undef oletter
#undef onames
#undef otype
#undef odefault
#undef ovar
#undef ofunc
#undef odesc
#undef t_next
#undef t_start
#undef t_end
#undef tv_sec
#undef tv_nsec
#undef sbuf
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef mode
#undef unused2
#undef st_dev
#undef st_ino
#undef st_mode
#undef st_nlink
#undef st_uid
#undef st_gid
#undef st_rdev
#undef st_size
#undef st_blksize
#undef st_blocks
#undef st_atim
#undef st_mtim
#undef st_ctim
#undef unused4
#undef unused5
#undef h_next
#undef h_prev
#undef h_filename
#undef h_filestate
#undef h_index
#undef h_hold
#undef h_opened
#undef h_scrpos
#undef gap
#undef line
#undef m_ifile
#undef m_scrpos
#undef val
#undef buffer
#undef allocated
#undef used
#undef syntax
#undef fastmap
#undef translate
#undef re_nsub
#undef can_be_null
#undef regs_allocated
#undef fastmap_accurate
#undef no_sub
#undef not_bol
#undef not_eol
#undef newline_anchor
#undef rm_so
#undef rm_eo
#undef hl_next
#undef hl_startpos
#undef hl_endpos
#undef tl_first
#undef tl_last
#undef tag_file
#undef tag_linenum
#undef tag_pattern
#undef tag_endline
#undef isatty
#undef __fd
#undef calloc
#undef __nmemb
#undef __size
#undef exit
#undef __status
#undef strcpy
#undef __dest
#undef __src
#undef strcmp
#undef __s1
#undef __s2
#undef strlen
#undef __s
#undef fsync
#undef atoi
#undef __nptr
#undef strcat
#undef cfgetospeed
#undef __termios_p
#undef tcgetattr
#undef tcsetattr
#undef __optional_actions
#undef ioctl
#undef __request
#undef tgetstr
#undef tgoto
#undef tgetent
#undef tgetflag
#undef tgetnum
#undef tputs
#undef lseek
#undef __offset
#undef __whence
#undef close
#undef write
#undef __buf
#undef __n
#undef sleep
#undef __seconds
#undef free
#undef __ptr
#undef sprintf
#undef __format
#undef ctype_b_loc
#undef strstr
#undef __haystack
#undef __needle
#undef setlocale
#undef __category
#undef __locale
#undef strncpy
#undef strncmp
#undef toupper
#undef __c
#undef open
#undef __file
#undef __oflag
#undef read
#undef __nbytes
#undef getenv
#undef __name
#undef creat
#undef __mode
#undef IO_getc
#undef __fp
#undef __stream
#undef popen
#undef __command
#undef __modes
#undef pclose
#undef stat
#undef fstat
#undef strchr
#undef memcpy
#undef IO_putc
#undef dup
#undef system
#undef signal
#undef __sig
#undef __handler
#undef strerror
#undef __errnum
#undef sigsetmask
#undef __mask
#undef time
#undef __timer
#undef errno_location
#undef tolower
#undef abs
#undef __x
#undef regcomp
#undef __preg
#undef __pattern
#undef __cflags
#undef regexec
#undef __string
#undef __nmatch
#undef __pmatch
#undef __eflags
#undef regfree
#undef getpid
#undef kill
#undef __pid
#undef fclose
#undef fopen
#undef __filename
#undef fgetc
#undef fgets

enum PC_TAG_RESULT {
	TAG_FOUND = 0,
	TAG_NOFILE = 1,
	TAG_NOTAG = 2,
	TAG_NOTYPE = 3,
	TAG_INTR = 4
};

struct scrpos;
union parg;
struct buf;
struct buflist;
struct filestate;
struct charset;
struct cs_alias;
struct textlist;
struct mlist;
struct optname;
struct loption;
struct tablelist;
struct ifile;
struct linenum_info;
struct mark;
struct __anonstruct___sigset_t_2;
struct __anonstruct_regmatch_t_32;
struct hilite;
struct taglist;
struct tag;

struct scrpos {
	long pos;
	int ln;
};
union parg {
	char * p_string;
	int p_int;
	long p_linenum;
};
struct buf {
	struct buf * next;
	struct buf * prev;
	struct buf * hnext;
	struct buf * hprev;
	long block;
	unsigned int datasize;
	unsigned char data[8192];
};
struct buflist {
	struct buf * buf_next;
	struct buf * buf_prev;
	struct buf * buf_hnext;
	struct buf * buf_hprev;
};
struct filestate {
	struct buf * buf_next;
	struct buf * buf_prev;
	struct buflist hashtbl[64];
	int file;
	int flags;
	long fpos;
	int nbufs;
	long block;
	unsigned int offset;
	long fsize;
};
struct charset {
	char * name;
	int * p_flag;
	char * desc;
};
struct cs_alias {
	char * name;
	char * oname;
};
struct textlist {
	char * string;
	char * endstring;
};
struct mlist {
	struct mlist * next;
	struct mlist * prev;
	struct mlist * curr_mp;
	char * string;
};
struct optname {
	char * oname;
	struct optname * onext;
};
struct loption {
	char oletter;
	struct optname * onames;
	int otype;
	int odefault;
	int * ovar;
	void( * ofunc)();
	char * odesc[3];
};
struct tablelist {
	struct tablelist * t_next;
	char * t_start;
	char * t_end;
};
struct ifile {
	struct ifile * h_next;
	struct ifile * h_prev;
	char * h_filename;
	void * h_filestate;
	int h_index;
	int h_hold;
	char h_opened;
	struct scrpos h_scrpos;
};
struct linenum_info {
	struct linenum_info * next;
	struct linenum_info * prev;
	long pos;
	long gap;
	long line;
};
struct mark {
	void * m_ifile;
	struct scrpos m_scrpos;
};
struct __anonstruct___sigset_t_2 {
	unsigned long __val[1024u / (8u * sizeof(unsigned long))];
};
struct __anonstruct_regmatch_t_32 {
	int rm_so;
	int rm_eo;
};
struct hilite {
	struct hilite * hl_next;
	long hl_startpos;
	long hl_endpos;
};
struct taglist {
	struct tag * tl_first;
	struct tag * tl_last;
};
struct tag {
	struct tag * next;
	struct tag * prev;
	char * tag_file;
	long tag_linenum;
	char * tag_pattern;
	char tag_endline;
};

#endif
