class
	P_CHARSET

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create binfmt.make
			create buf.make (<<8>>)
			create chardef.make (<<256>>)
			create charsets.make (<<9>>)
			create cs_aliases.make (<<3>>)
			create utf_mode.make (<<1>>)
		end

feature {ANY} -- attributes

	binattr: INTEGER_32 assign set_binattr

	set_binattr (a_binattr: INTEGER_32)
		do
			binattr := a_binattr
		end

	binfmt: CE_POINTER [INTEGER_8] assign set_binfmt

	set_binfmt (a_binfmt: CE_POINTER [INTEGER_8])
		do
			binfmt := a_binfmt
		end

	buf: CE_ARRAY [INTEGER_8]

	chardef: CE_ARRAY [INTEGER_8]

	charsets: CE_ARRAY [PD_CHARSET]

	cs_aliases: CE_ARRAY [PD_CS_ALIAS]

	utf_mode: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	binary_char (a_c: NATURAL_8): INTEGER_32
		local
			l_c: NATURAL_8
		do
			l_c := a_c
			l_c := ((l_c.to_integer_32).bit_and (255)).to_natural_8
			Result := (((chardef[l_c.to_integer_32]).to_integer_32).bit_and (1))
		end

	control_char (a_c: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
		do
			l_c := a_c
			l_c := (l_c).bit_and ((255))
			Result := (((chardef[l_c]).to_integer_32).bit_and (2))
		end

	ichardef (a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_cp___0: CE_POINTER [INTEGER_8]
			l_n: INTEGER_32
			l_v: INTEGER_8
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_cp___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_n := 0
					l_v := (0).to_integer_8
					l_cp___0 := chardef
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_s[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp := l_s
						l_s := l_s + 1
						inspect (l_tmp[0]).to_integer_32 -- switch 1 head
						when 46 then l_pos := -1 + 3
						when 99 then l_pos := -1 + 4
						when 98 then l_pos := -1 + 5
						when 48 then l_pos := -1 + 6
						when 49 then l_pos := -1 + 6
						when 50 then l_pos := -1 + 6
						when 51 then l_pos := -1 + 6
						when 52 then l_pos := -1 + 6
						when 53 then l_pos := -1 + 6
						when 54 then l_pos := -1 + 6
						when 55 then l_pos := -1 + 6
						when 56 then l_pos := -1 + 6
						when 57 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 46
						l_v := (0).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 99
						l_v := (2).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 98
						l_v := (3).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 48 | switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_n := 10 * l_n + ((l_s[-1]).to_integer_32 - 48)
						js.continue
				when 7 then -- switch 1, default:
						if not js.loop_jumped then
							output_inst.error (ce_string ("invalid chardef"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							main_inst.quit (1)
						end
				when 8 then -- switch 1, done:
						if not js.loop_jumped then
							from
							until
								js.loop_done
							loop
								if (l_cp___0.c_pointer.to_integer_32).to_natural_32 >= ((chardef + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
									output_inst.error (ce_string ("chardef longer than 256"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
									main_inst.quit (1)
								end
								l_tmp___0 := l_cp___0
								l_cp___0 := l_cp___0 + 1
								l_tmp___0[0] := l_v
								l_n := l_n - 1
								if not (l_n > 0) then
									js.break
								end
							end
							l_n := 0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					from
					until
						not ((l_cp___0.c_pointer.to_integer_32).to_natural_32 < ((chardef + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32)
					loop
						l_tmp___1 := l_cp___0
						l_cp___0 := l_cp___0 + 1
						l_tmp___1[0] := l_v
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	icharset (a_name: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_name: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [PD_CHARSET]
			l_a: CE_POINTER [PD_CS_ALIAS]
			js: JUMP_STATE
		do
			create l_name.make
			create l_p.make
			create l_a.make

			l_name := a_name
			if l_name.is_void then
				Result := 0
				js.return
			elseif (l_name[0]).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_a := cs_aliases
				from
				until
					not (not js.loop_done and then (not (l_a.item.name).is_void))
				loop
					if (strcmp (l_name, l_a.item.name)) = 0 then
						l_name := l_a.item.oname
						js.break
					end
					if not js.loop_jumped then
						l_a := l_a + 1
					end
				end
				l_p := charsets
				from
				until
					not (not js.loop_done and then (not (l_p.item.name).is_void))
				loop
					if (strcmp (l_name, l_p.item.name)) = 0 then
						ichardef (l_p.item.desc)
						if not (l_p.item.p_flag).is_void then
							(l_p.item.p_flag).item := 1
						end
						Result := 1
						js.return
					end
					if not js.return_called then
						l_p := l_p + 1
					end
				end
			end
			if not js.return_called then
				output_inst.error (ce_string ("invalid charset name"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				main_inst.quit (1)
				Result := 0
			end
		end

	ilocale
		local
			l_c: INTEGER_32
		do
			setlocale (6, ce_string ("")).do_nothing
			l_c := 0
			from
			until
				not (l_c < ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)
			loop
				if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (16_384)).to_boolean then
					chardef[l_c] := (0).to_integer_8
				elseif ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (2)).to_boolean then
					chardef[l_c] := (2).to_integer_8
				else
					chardef[l_c] := (3).to_integer_8
				end
				l_c := l_c + 1
			end
		end

	init_charset
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := decode_inst.lgetenv (ce_string ("LESSBINFMT"))
					setbinfmt (l_s)
					l_s := decode_inst.lgetenv (ce_string ("LESSCHARSET"))
					if (icharset (l_s)).to_boolean then
						js.return
					end
					if not js.return_called then
						l_s := decode_inst.lgetenv (ce_string ("LESSCHARDEF"))
						if not l_s.is_void then
							if (l_s[0]).to_integer_32 /= 0 then
								ichardef (l_s)
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_s := decode_inst.lgetenv (ce_string ("LC_ALL"))
						if l_s.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						l_s := decode_inst.lgetenv (ce_string ("LC_CTYPE"))
						if l_s.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						l_s := decode_inst.lgetenv (ce_string ("LANG"))
						if l_s.is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if: | _L___0:
						if (strstr (l_s, ce_string ("UTF-8"))).is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if (strstr (l_s, ce_string ("utf-8"))).is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (icharset (ce_string ("utf-8"))).to_boolean then
							js.return
						end
				when 13 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							ilocale
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	prchar (a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_c: INTEGER_32
		do
			l_c := a_c
			l_c := (l_c).bit_and ((255))
			if (control_char (l_c)).to_boolean then
				if l_c = 27 then
					sprintf ([buf, ce_string ("ESC")]).do_nothing
				elseif l_c < 128 then
					if (control_char ((l_c).bit_xor (64))).to_boolean then
						sprintf ([buf, binfmt, l_c]).do_nothing
					else
						sprintf ([buf, ce_string ("^%%c"), (l_c).bit_xor (64)]).do_nothing
					end
				else
					sprintf ([buf, binfmt, l_c]).do_nothing
				end
			else
				sprintf ([buf, ce_string ("%%c"), l_c]).do_nothing
			end
			Result := buf
		end

	setbinfmt (a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					if l_s.is_void then
						l_s := ce_string ("*s<%%X>")
					elseif (l_s[0]).to_integer_32 = 0 then
						l_s := ce_string ("*s<%%X>")
					end
					if (l_s[0]).to_integer_32 /= 42 then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						inspect (l_s[1]).to_integer_32 -- switch 1 head
						when 100 then l_pos := -1 + 2
						when 107 then l_pos := -1 + 3
						when 115 then l_pos := -1 + 4
						when 117 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 100
						binattr := 2
						l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 107
						binattr := 3
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 115
						binattr := 5
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 117
						binattr := 1
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						binattr := 0
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_s := l_s + (2)
				when 8 then -- if done
					binfmt := l_s
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
