class
	P_EDIT

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create curr_altfilename.make
			create curr_altpipe.make
			create force_open.make (<<1>>)
		end

feature {ANY} -- attributes

	curr_altfilename: CE_POINTER [INTEGER_8] assign set_curr_altfilename

	set_curr_altfilename (a_curr_altfilename: CE_POINTER [INTEGER_8])
		do
			curr_altfilename := a_curr_altfilename
		end

	curr_altpipe: CE_POINTER [ANY] assign set_curr_altpipe

	set_curr_altpipe (a_curr_altpipe: CE_POINTER [ANY])
		do
			curr_altpipe := a_curr_altpipe
		end

	errmsgs: INTEGER_32 assign set_errmsgs

	set_errmsgs (a_errmsgs: INTEGER_32)
		do
			errmsgs := a_errmsgs
		end

	fd0: INTEGER_32 assign set_fd0

	set_fd0 (a_fd0: INTEGER_32)
		do
			fd0 := a_fd0
		end

	force_open: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	back_textlist (a_tlist: CE_POINTER [PD_TEXTLIST]; a_prev: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			if a_prev.is_void then
				l_s := a_tlist.item.endstring
			elseif (a_prev.c_pointer.to_integer_32).to_natural_32 <= ((a_tlist.item.string).c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			else
				l_s := a_prev - 1
			end
			if not js.return_called then
				from
				until
					(l_s[0]).to_integer_32 /= 0
				loop
					l_s := l_s - 1
				end
				if (l_s.c_pointer.to_integer_32).to_natural_32 <= ((a_tlist.item.string).c_pointer.to_integer_32).to_natural_32 then
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (l_s[-1]).to_integer_32 /= 0 then
						if not ((l_s.c_pointer.to_integer_32).to_natural_32 > ((a_tlist.item.string).c_pointer.to_integer_32).to_natural_32) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_s := l_s - 1
					end
				end
				Result := l_s
			end
		end

	cat_file
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l_c := ch_inst.ch_forw_get
				if l_c = -1 then
					js.break
				end
				if not js.loop_jumped then
					output_inst.putchr (l_c).do_nothing
				end
			end
			output_inst.flush
		end

	close_file
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			js: JUMP_STATE
		do
			create l_scrpos.make (<<1>>)

			if main_inst.curr_ifile.is_void then
				js.return
			end
			if not js.return_called then
				position_inst.get_scrpos (l_scrpos)
				if l_scrpos.item.pos /= -1 then
					ifile_inst.store_pos (main_inst.curr_ifile, l_scrpos)
					mark_inst.lastmark
				end
				ch_inst.ch_close
				if not curr_altfilename.is_void then
					filename_inst.close_altfile (curr_altfilename, (ifile_inst.get_filename (main_inst.curr_ifile)), curr_altpipe)
					free (create {CE_POINTER [ANY]}.make_cast (curr_altfilename))
					curr_altfilename := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
				main_inst.curr_ifile := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			end
		end

	edit (a_filename: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_filename.is_void then
				Result := (edit_ifile (create {CE_POINTER [ANY]}.make_shared (default_pointer)))
				js.return
			end
			if not js.return_called then
				Result := (edit_ifile ((ifile_inst.get_ifile (a_filename, main_inst.curr_ifile))))
			end
		end

	edit_first: INTEGER_32
		do
			main_inst.curr_ifile := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			Result := (edit_next (1))
		end

	edit_ifile (a_ifile: CE_POINTER [ANY]): INTEGER_32
		local
			l_f: CE_ARRAY [INTEGER_32]
			l_answer: INTEGER_32
			l_no_display: INTEGER_32
			l_chflags: INTEGER_32
			l_filename: CE_POINTER [INTEGER_8]
			l_open_filename: CE_POINTER [INTEGER_8]
			l_qopen_filename: CE_POINTER [INTEGER_8]
			l_alt_filename: CE_POINTER [INTEGER_8]
			l_alt_pipe: CE_ARRAY [CE_POINTER [ANY]]
			l_was_curr_ifile: CE_POINTER [ANY]
			l_parg: CE_ARRAY [PD_PARG]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make (<<1>>)
			create l_filename.make
			create l_open_filename.make
			create l_qopen_filename.make
			create l_alt_filename.make
			create l_alt_pipe.make (<<1>>)
			create l_was_curr_ifile.make
			create l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_ifile.is_equal (main_inst.curr_ifile) then
						Result := 0
						js.return
					end
					if not js.return_called then
						ch_inst.end_logfile
						l_was_curr_ifile := save_curr_ifile
						if not main_inst.curr_ifile.is_void then
							l_chflags := ch_inst.ch_getflags
							close_file
							if ((l_chflags).bit_and (8)).to_boolean then
								if (ifile_inst.held_ifile (l_was_curr_ifile)) <= 1 then
									ifile_inst.del_ifile (l_was_curr_ifile)
									l_was_curr_ifile := main_inst.old_ifile
								end
							end
						end
						if a_ifile.is_void then
							unsave_ifile (l_was_curr_ifile)
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_filename := main_inst.save ((ifile_inst.get_filename (a_ifile)))
						l_alt_pipe.item := create {CE_POINTER [ANY]}.make_shared (default_pointer)
						l_alt_filename := filename_inst.open_altfile (l_filename, l_f, l_alt_pipe)
						if not l_alt_filename.is_void then
							l_open_filename := l_alt_filename
						else
							l_open_filename := l_filename
						end
						l_qopen_filename := filename_inst.shell_unquote (l_open_filename)
						l_chflags := 0
						if (l_alt_pipe.item).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_chflags := (l_chflags).bit_or ((4))
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 4 then -- else:
						if (strcmp (l_open_filename, ce_string ("-"))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_f.item := fd0
						l_chflags := (l_chflags).bit_or ((2))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if (strcmp (l_open_filename, ce_string ("@/\less/\help/\file/\@"))) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_f.item := -1
						l_chflags := (l_chflags).bit_or ((8))
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						l_parg.item.p_string := filename_inst.bad_file (l_open_filename)
						if (l_parg.item.p_string).is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if:
						output_inst.error (ce_string ("%%s"), l_parg)
						free (create {CE_POINTER [ANY]}.make_cast (l_parg.item.p_string))
				when 12 then -- err1:
						if not l_alt_filename.is_void then
							filename_inst.close_altfile (l_alt_filename, l_filename, l_alt_pipe.item)
							free (create {CE_POINTER [ANY]}.make_cast (l_alt_filename))
						end
						ifile_inst.del_ifile (a_ifile)
						free (create {CE_POINTER [ANY]}.make_cast (l_qopen_filename))
						free (create {CE_POINTER [ANY]}.make_cast (l_filename))
						reedit_ifile (l_was_curr_ifile)
						Result := 1
						js.return
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_f.item := open ([l_qopen_filename, 0])
						if l_f.item < 0 then
							l_parg.item.p_string := os_inst.errno_message (l_filename)
							output_inst.error (ce_string ("%%s"), l_parg)
							free (create {CE_POINTER [ANY]}.make_cast (l_parg.item.p_string))
							l_pos := -1 + 12 -- goto err1
						else
							l_chflags := (l_chflags).bit_or ((1))
							if not (force_open.item).to_boolean then
								if not (ifile_inst.opened (a_ifile)).to_boolean then
									if (filename_inst.bin_file (l_f.item)).to_boolean then
										l_parg.item.p_string := l_filename
										l_answer := output_inst.query (ce_string ("%"%%s%" may be a binary file.  See it anyway? "), l_parg)
										if l_answer /= 121 then
											if l_answer /= 89 then
												close (l_f.item).do_nothing
												l_pos := -1 + 12 -- goto err1
											end
										end
									end
								end
							end
						end
				when 15 then -- if done | if done | if done | if done
						if not js.return_called then
							free (create {CE_POINTER [ANY]}.make_cast (l_qopen_filename))
							if not l_was_curr_ifile.is_void then
								main_inst.old_ifile := l_was_curr_ifile
								unsave_ifile (l_was_curr_ifile)
							end
							main_inst.curr_ifile := a_ifile
							curr_altfilename := l_alt_filename
							curr_altpipe := l_alt_pipe.item
							ifile_inst.set_open (main_inst.curr_ifile)
							ifile_inst.get_pos (main_inst.curr_ifile, main_inst.initial_scrpos)
							main_inst.new_file := 1
							ch_inst.ch_init (l_f.item, l_chflags)
							if not ((l_chflags).bit_and (8)).to_boolean then
								if not main_inst.namelogfile.is_void then
									if main_inst.is_tty.to_boolean then
										use_logfile (main_inst.namelogfile)
									end
								end
								if not main_inst.every_first_cmd.is_void then
									command_inst.ungetsc (main_inst.every_first_cmd)
								end
							end
							l_no_display := (not main_inst.any_display.to_boolean).to_integer
							output_inst.flush
							main_inst.any_display := 1
							if main_inst.is_tty.to_boolean then
								position_inst.pos_clear
								linenum_inst.clr_linenum
								search_inst.clr_hilite
								cmdbuf_inst.cmd_addhist (create {CE_POINTER [PD_MLIST]}.make_cast (cmdbuf_inst.ml_examine), l_filename)
								if l_no_display.to_boolean then
									if errmsgs > 0 then
										l_parg.item.p_string := l_filename
										output_inst.error (ce_string ("%%s"), l_parg)
									end
								end
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_filename))
							Result := 0
						end
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	edit_index (a_n: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_h.make

			l_h := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			from
			until
				js.loop_done
			loop
				l_h := ifile_inst.next_ifile (l_h)
				if l_h.is_void then
					Result := 1
					js.return
				end
				if not js.return_called then
					if (ifile_inst.get_index (l_h)) = a_n then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (edit_ifile (l_h))
			end
		end

	edit_inext (a_h: CE_POINTER [ANY]; a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep (a_h, a_n, 1))
		end

	edit_iprev (a_h: CE_POINTER [ANY]; a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep (a_h, a_n, -1))
		end

	edit_istep (a_h: CE_POINTER [ANY]; a_n: INTEGER_32; a_dir: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [ANY]
			l_n: INTEGER_32
			l_next: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_h.make
			create l_next.make

			l_h := a_h
			l_n := a_n
			from
			until
				js.loop_done
			loop
				if a_dir > 0 then
					l_next := (ifile_inst.next_ifile (l_h))
				else
					l_next := (ifile_inst.prev_ifile (l_h))
				end
				l_n := l_n - 1
				if l_n < 0 then
					if (edit_ifile (l_h)) = 0 then
						js.break
					end
				end
				if not js.loop_jumped then
					if l_next.is_void then
						Result := 1
						js.return
					end
					if not js.return_called and then (((ch_inst.sigs).bit_and (3)).to_boolean) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_h := l_next
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	edit_last: INTEGER_32
		do
			main_inst.curr_ifile := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			Result := (edit_prev (1))
		end

	edit_list (a_filelist: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_save_ifile: CE_POINTER [ANY]
			l_good_filename: CE_POINTER [INTEGER_8]
			l_filename: CE_POINTER [INTEGER_8]
			l_gfilelist: CE_POINTER [INTEGER_8]
			l_gfilename: CE_POINTER [INTEGER_8]
			l_tl_files: CE_ARRAY [PD_TEXTLIST]
			l_tl_gfiles: CE_ARRAY [PD_TEXTLIST]
			js: JUMP_STATE
		do
			create l_save_ifile.make
			create l_good_filename.make
			create l_filename.make
			create l_gfilelist.make
			create l_gfilename.make
			create l_tl_files.make (<<1>>)
			create l_tl_gfiles.make (<<1>>)

			l_save_ifile := save_curr_ifile
			l_good_filename := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			init_textlist (l_tl_files, a_filelist)
			l_filename := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			from
			until
				js.loop_done
			loop
				l_filename := forw_textlist (l_tl_files, l_filename)
				if l_filename.is_void then
					js.break
				end
				if not js.loop_jumped then
					l_gfilelist := filename_inst.lglob (l_filename)
					init_textlist (l_tl_gfiles, l_gfilelist)
					l_gfilename := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					from
					until
						js.loop_done
					loop
						l_gfilename := forw_textlist (l_tl_gfiles, l_gfilename)
						if l_gfilename.is_void then
							js.break
						end
						if not js.loop_jumped then
							if (edit (l_gfilename)) = 0 then
								if l_good_filename.is_void then
									l_good_filename := ifile_inst.get_filename (main_inst.curr_ifile)
								end
							end
						end
					end
					free (create {CE_POINTER [ANY]}.make_cast (l_gfilelist))
				end
			end
			if l_good_filename.is_void then
				unsave_ifile (l_save_ifile)
				Result := 1
				js.return
			end
			if not js.return_called then
				if (ifile_inst.get_ifile (l_good_filename, main_inst.curr_ifile)).is_equal (main_inst.curr_ifile) then
					unsave_ifile (l_save_ifile)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				reedit_ifile (l_save_ifile)
				Result := (edit (l_good_filename))
			end
		end

	edit_next (a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep (main_inst.curr_ifile, a_n, 1))
		end

	edit_prev (a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep (main_inst.curr_ifile, a_n, -1))
		end

	edit_stdin: INTEGER_32
		do
			if (isatty (fd0)).to_boolean then
				output_inst.error (ce_string ("Missing filename (%"less --help%" for help)"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				main_inst.quit (0)
			end
			Result := (edit (ce_string ("-")))
		end

	forw_textlist (a_tlist: CE_POINTER [PD_TEXTLIST]; a_prev: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			if a_prev.is_void then
				l_s := a_tlist.item.string
			else
				l_s := a_prev + (strlen (a_prev)).to_integer_32
			end
			if (l_s.c_pointer.to_integer_32).to_natural_32 >= ((a_tlist.item.endstring).c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					(l_s[0]).to_integer_32 /= 0
				loop
					l_s := l_s + 1
				end
				if (l_s.c_pointer.to_integer_32).to_natural_32 >= ((a_tlist.item.endstring).c_pointer.to_integer_32).to_natural_32 then
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_s
			end
		end

	init_textlist (a_tlist: CE_POINTER [PD_TEXTLIST]; a_str: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_meta_quoted: INTEGER_32
			l_delim_quoted: INTEGER_32
			l_esc: CE_POINTER [INTEGER_8]
			l_esclen: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_esc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_meta_quoted := 0
					l_delim_quoted := 0
					l_esc := (filename_inst.get_meta_escape)
					l_esclen := (strlen (l_esc)).to_integer_32
					a_tlist.item.string := main_inst.skipsp (a_str)
					a_tlist.item.endstring := a_tlist.item.string + (strlen (a_tlist.item.string)).to_integer_32
					l_s := a_str
				when 1 then -- loop condition:
					if not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((a_tlist.item.endstring).c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_meta_quoted.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_meta_quoted := 0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not (l_esclen > 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((l_s + l_esclen).c_pointer.to_integer_32).to_natural_32 < ((a_tlist.item.endstring).c_pointer.to_integer_32).to_natural_32 then
							if (strncmp (l_s, l_esc, l_esclen.to_natural_32)) = 0 then
								l_meta_quoted := 1
								l_s := l_s + (l_esclen - 1)
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if l_delim_quoted.to_boolean then
							if (l_s[0]).to_integer_32 = cmdbuf_inst.closequote.to_integer_32 then
								l_delim_quoted := 0
							end
						elseif (l_s[0]).to_integer_32 = cmdbuf_inst.openquote.to_integer_32 then
							l_delim_quoted := 1
						elseif (l_s[0]).to_integer_32 = 32 then
							l_s[0] := (('%/0/').code).to_integer_8
						end
				when 9 then -- if done
						l_s := l_s + 1
						l_pos := -1 + 1 -- back to loop condition
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reedit_ifile (a_save_ifile: CE_POINTER [ANY])
		local
			l_next: CE_POINTER [ANY]
			l_prev: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_next.make
			create l_prev.make

			unsave_ifile (a_save_ifile)
			l_next := ifile_inst.next_ifile (a_save_ifile)
			l_prev := ifile_inst.prev_ifile (a_save_ifile)
			if (edit_ifile (a_save_ifile)) = 0 then
				js.return
			end
			if not js.return_called and then (not l_next.is_void) then
				if (edit_inext (l_next, 0)) = 0 then
					js.return
				end
			end
			if not js.return_called and then (not l_prev.is_void) then
				if (edit_iprev (l_prev, 0)) = 0 then
					js.return
				end
			end
			if not js.return_called then
				main_inst.quit (1)
			end
		end

	save_curr_ifile: CE_POINTER [ANY]
		do
			if not main_inst.curr_ifile.is_void then
				ifile_inst.hold_ifile (main_inst.curr_ifile, 1)
			end
			Result := main_inst.curr_ifile
		end

	unsave_ifile (a_save_ifile: CE_POINTER [ANY])
		do
			if not a_save_ifile.is_void then
				ifile_inst.hold_ifile (a_save_ifile, -1)
			end
		end

	use_logfile (a_filename: CE_POINTER [INTEGER_8])
		local
			l_filename: CE_POINTER [INTEGER_8]
			l_exists: INTEGER_32
			l_answer: INTEGER_32
			l_parg: CE_ARRAY [PD_PARG]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_filename.make
			create l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_filename := a_filename
					if (((ch_inst.ch_getflags)).bit_and (1)).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_filename := filename_inst.shell_unquote (l_filename)
						l_exists := open ([l_filename, 0])
						close (l_exists).do_nothing
						l_exists := (l_exists >= 0).to_integer
						if not l_exists.to_boolean then
							l_answer := ('O').code
						elseif main_inst.force_logfile.to_boolean then
							l_answer := ('O').code
						else
							l_parg.item.p_string := l_filename
							l_answer := output_inst.query (ce_string ("Warning: %"%%s%" exists; Overwrite, Append or Don%'t log? "), l_parg)
						end
				when 2 then -- loop:
						inspect l_answer -- switch 1 head
						when 79 then l_pos := -1 + 3
						when 111 then l_pos := -1 + 3
						when 65 then l_pos := -1 + 4
						when 97 then l_pos := -1 + 4
						when 68 then l_pos := -1 + 5
						when 100 then l_pos := -1 + 5
						when 113 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 79 | switch 1, case 111
						main_inst.logfile := creat (l_filename, (420).to_natural_32)
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 65 | switch 1, case 97
						main_inst.logfile := open ([l_filename, 1_025])
						if (lseek (main_inst.logfile, (0).to_integer_32, 2)) = -1 then
							close (main_inst.logfile).do_nothing
							main_inst.logfile := -1
						end
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 68 | switch 1, case 100
						free (create {CE_POINTER [ANY]}.make_cast (l_filename))
						js.return
				when 6 then -- switch 1, case 113
						if not js.return_called then
							main_inst.quit (0)
						end
				when 7 then -- switch 1, default:
						if not js.return_called then
							l_answer := output_inst.query (ce_string ("Overwrite, Append, or Don%'t log? (Type %"O%", %"A%", %"D%" or %"q%") "), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 2 -- goto loop
						end
				when 8 then -- switch 1, done: | if done
						if not js.return_called and then (main_inst.logfile < 0) then
							l_parg.item.p_string := l_filename
							output_inst.error (ce_string ("Cannot write to %"%%s%""), l_parg)
							free (create {CE_POINTER [ANY]}.make_cast (l_filename))
							js.return
						end
						if not js.return_called then
							free (create {CE_POINTER [ANY]}.make_cast (l_filename))
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
