class
	P_LINE

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create attr.make
			create bs_mode.make (<<1>>)
			create ctldisp.make (<<1>>)
			create end_ansi_chars.make
			create linebuf.make
			create linenums.make (<<1>>)
			create status_col.make (<<1>>)
			create tabstops.make (<<32>>)
			create twiddle.make (<<1>>)
		end

feature {ANY} -- attributes

	attr: CE_POINTER [INTEGER_8] assign set_attr

	set_attr (a_attr: CE_POINTER [INTEGER_8])
		do
			attr := a_attr
		end

	bs_mode: CE_ARRAY [INTEGER_32]

	column: INTEGER_32 assign set_column

	set_column (a_column: INTEGER_32)
		do
			column := a_column
		end

	ctldisp: CE_ARRAY [INTEGER_32]

	curr: INTEGER_32 assign set_curr

	set_curr (a_curr: INTEGER_32)
		do
			curr := a_curr
		end

	end_ansi_chars: CE_POINTER [INTEGER_8] assign set_end_ansi_chars

	set_end_ansi_chars (a_end_ansi_chars: CE_POINTER [INTEGER_8])
		do
			end_ansi_chars := a_end_ansi_chars
		end

	hilites: INTEGER_32 assign set_hilites

	set_hilites (a_hilites: INTEGER_32)
		do
			hilites := a_hilites
		end

	is_null_line: INTEGER_32 assign set_is_null_line

	set_is_null_line (a_is_null_line: INTEGER_32)
		do
			is_null_line := a_is_null_line
		end

	last_overstrike: INTEGER_32 assign set_last_overstrike

	set_last_overstrike (a_last_overstrike: INTEGER_32)
		do
			last_overstrike := a_last_overstrike
		end

	linebuf: CE_POINTER [INTEGER_8] assign set_linebuf

	set_linebuf (a_linebuf: CE_POINTER [INTEGER_8])
		do
			linebuf := a_linebuf
		end

	linenums: CE_ARRAY [INTEGER_32]

	lmargin: INTEGER_32 assign set_lmargin

	set_lmargin (a_lmargin: INTEGER_32)
		do
			lmargin := a_lmargin
		end

	ntabstops: INTEGER_32 assign set_ntabstops

	set_ntabstops (a_ntabstops: INTEGER_32)
		do
			ntabstops := a_ntabstops
		end

	overstrike: INTEGER_32 assign set_overstrike

	set_overstrike (a_overstrike: INTEGER_32)
		do
			overstrike := a_overstrike
		end

	pendc: INTEGER_8 assign set_pendc

	set_pendc (a_pendc: INTEGER_8)
		do
			pendc := a_pendc
		end

	pendpos: INTEGER_32 assign set_pendpos

	set_pendpos (a_pendpos: INTEGER_32)
		do
			pendpos := a_pendpos
		end

	size_linebuf: INTEGER_32 assign set_size_linebuf

	set_size_linebuf (a_size_linebuf: INTEGER_32)
		do
			size_linebuf := a_size_linebuf
		end

	status_col: CE_ARRAY [INTEGER_32]

	tabdefault: INTEGER_32 assign set_tabdefault

	set_tabdefault (a_tabdefault: INTEGER_32)
		do
			tabdefault := a_tabdefault
		end

	tabstops: CE_ARRAY [INTEGER_32]

	twiddle: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	attr_ewidth (a_a: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_a -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 2
					Result := screen_inst.bo_e_width
					js.return
				when 2 then -- switch 1, case 1
					if not js.return_called then
						Result := screen_inst.ul_e_width
						js.return
					end
				when 3 then -- switch 1, case 3
					if not js.return_called then
						Result := screen_inst.bl_e_width
						js.return
					end
				when 4 then -- switch 1, case 5
					if not js.return_called then
						Result := screen_inst.so_e_width
						js.return
					end
				when 5 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	attr_swidth (a_a: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_a -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 2
					Result := screen_inst.bo_s_width
					js.return
				when 2 then -- switch 1, case 1
					if not js.return_called then
						Result := screen_inst.ul_s_width
						js.return
					end
				when 3 then -- switch 1, case 3
					if not js.return_called then
						Result := screen_inst.bl_s_width
						js.return
					end
				when 4 then -- switch 1, case 5
					if not js.return_called then
						Result := screen_inst.so_s_width
						js.return
					end
				when 5 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	back_raw_line (a_curr_pos: INTEGER_32; a_linep: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_new_pos: INTEGER_32
			l_old_size_linebuf: INTEGER_32
			l_fm: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_fm.make
			create l_to.make

			if a_curr_pos = -1 then
				Result := (-1).to_integer_32
				js.return
			elseif a_curr_pos <= 0 then
				Result := (-1).to_integer_32
				js.return
			elseif (ch_inst.ch_seek (a_curr_pos - 1)).to_boolean then
				Result := (-1).to_integer_32
				js.return
			end
			if not js.return_called then
				l_n := size_linebuf
				l_n := l_n - 1
				linebuf[l_n] := (('%/0/').code).to_integer_8
				from
				until
					js.loop_done
				loop
					l_c := ch_inst.ch_back_get
					if l_c = 10 then
						l_new_pos := (ch_inst.ch_tell) + 1
						js.break
					end
					if not js.loop_jumped and then (l_c = -1) then
						l_new_pos := (0).to_integer_32
						js.break
					end
					if not js.loop_jumped and then (l_n <= 0) then
						l_old_size_linebuf := size_linebuf
						if (expand_linebuf).to_boolean then
							l_new_pos := (ch_inst.ch_tell) + 1
							js.break
						end
						if not js.loop_jumped then
							l_fm := linebuf + l_old_size_linebuf
							l_to := linebuf + size_linebuf
							from
							until
								not ((l_fm.c_pointer.to_integer_32).to_natural_32 >= (linebuf.c_pointer.to_integer_32).to_natural_32)
							loop
								l_to[0] := l_fm[0]
								l_fm := l_fm - 1
								l_to := l_to - 1
							end
							l_n := size_linebuf - l_old_size_linebuf
						end
					end
					if not js.loop_jumped then
						l_n := l_n - 1
						linebuf[l_n] := l_c.to_integer_8
					end
				end
				if not a_linep.is_void then
					a_linep.item := linebuf + l_n
				end
				Result := l_new_pos
			end
		end

	backc
		do
			curr := curr - 1
			column := column - (pwidth ((linebuf[curr]).to_integer_32, (attr[curr]).to_integer_32))
		end

	do_append (a_c: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_a: INTEGER_32
			l_i: INTEGER_32
			l_tmp___18: NATURAL_32
			l_tmp___19: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c /= 8 then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						inspect bs_mode.item -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 0 then l_pos := -1 + 4
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 1
						from
						until
							js.loop_done
						loop
							if (store_char (a_c, 0, a_pos)).to_boolean then
								Result := 1
								js.return
							else
								curr := curr + 1
							end
							if not js.return_called then
								js.break
							end
						end
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_pos := -1 + 55 -- goto do_control_char
				when 4 then -- switch 1, case 0
						if curr = 0 then
							l_pos := -1 + 6 -- switch 1; break
						end
				when 5 then
						backc
						overstrike := 1
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 67
				when 7 then -- else:
						if not (overstrike.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 8 then -- if:
						overstrike := overstrike - 1
						if not ((charset_inst.utf_mode.item).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if ((a_c).bit_and (248)) = 240 then
							if curr > 2 then
								if (a_c.to_integer_8).to_integer_32 = (linebuf[(curr - 3)]).to_integer_32 then
									backc
									backc
									backc
									from
									until
										js.loop_done
									loop
										if (store_char ((linebuf[curr]).to_integer_32, 2, a_pos)).to_boolean then
											Result := 1
											js.return
										else
											curr := curr + 1
										end
										if not js.return_called then
											js.break
										end
									end
									if not js.return_called then
										overstrike := 3
									end
								else
									l_pos := -1 + 11 -- goto _L___13
								end
							else
								l_pos := -1 + 11 -- goto _L___13
							end
						else
							l_pos := -1 + 11 -- goto _L___13
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 11 then -- else: | _L___13:
						if not ((charset_inst.utf_mode.item).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						if ((a_c).bit_and (240)) /= 224 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L___10
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if overstrike /= 2 then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if:
						if ((a_c).bit_and (192)) /= 128 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___10:
						if curr > 1 then
							if (a_c.to_integer_8).to_integer_32 = (linebuf[(curr - 2)]).to_integer_32 then
								backc
								backc
								from
								until
									js.loop_done
								loop
									if (store_char ((linebuf[curr]).to_integer_32, 2, a_pos)).to_boolean then
										Result := 1
										js.return
									else
										curr := curr + 1
									end
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									overstrike := 2
								end
							else
								l_pos := -1 + 23 -- goto _L___9
							end
						else
							l_pos := -1 + 23 -- goto _L___9
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 23 -- goto _L___9
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 23 -- goto _L___9
				when 22 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 48
				when 23 then -- else: | _L___9:
						if not ((charset_inst.utf_mode.item).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 24 then -- if:
						if not (curr > 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 25 then -- if:
						if ((a_c).bit_and (224)) /= 192 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 30 -- goto _L___5
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 28 then -- else:
						if overstrike /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if ((a_c).bit_and (192)) /= 128 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___5:
						if (a_c.to_integer_8).to_integer_32 = (linebuf[(curr - 1)]).to_integer_32 then
							backc
							from
							until
								js.loop_done
							loop
								if (store_char ((linebuf[curr]).to_integer_32, 2, a_pos)).to_boolean then
									Result := 1
									js.return
								else
									curr := curr + 1
								end
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								overstrike := 1
							end
						else
							l_pos := -1 + 38 -- goto _L___6
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 38 -- goto _L___6
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 38 -- goto _L___6
				when 35 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_pos := -1 + 38 -- goto _L___6
				when 37 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 38 then -- else: | _L___6:
						if not ((charset_inst.utf_mode.item).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if curr > 0 then
							if ((a_c).bit_and (192)) = 128 then
								if (attr[(curr - 1)]).to_integer_32 = 1 then
									if a_c = 9 then
										from
										until
											js.loop_done
										loop
											if (store_tab (1, a_pos)).to_boolean then
												Result := 1
												js.return
											end
											if not js.return_called then
												js.break
											end
										end
									else
										from
										until
											js.loop_done
										loop
											if (store_char (a_c, 1, a_pos)).to_boolean then
												Result := 1
												js.return
											else
												curr := curr + 1
											end
											if not js.return_called then
												js.break
											end
										end
									end
								else
									l_pos := -1 + 41 -- goto _L___2
								end
							else
								l_pos := -1 + 41 -- goto _L___2
							end
						else
							l_pos := -1 + 41 -- goto _L___2
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 41 then -- else: | _L___2:
						if (a_c.to_integer_8).to_integer_32 /= (linebuf[curr]).to_integer_32 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_c /= 95 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if last_overstrike /= 0 then
							if a_c = 9 then
								from
								until
									js.loop_done
								loop
									if (store_tab (last_overstrike, a_pos)).to_boolean then
										Result := 1
										js.return
									end
									if not js.return_called then
										js.break
									end
								end
							else
								from
								until
									js.loop_done
								loop
									if (store_char (a_c, last_overstrike, a_pos)).to_boolean then
										Result := 1
										js.return
									else
										curr := curr + 1
									end
									if not js.return_called then
										js.break
									end
								end
							end
						else
							l_pos := -1 + 45 -- goto _L
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L:
						if a_c = 9 then
							from
							until
								js.loop_done
							loop
								if (store_tab (2, a_pos)).to_boolean then
									Result := 1
									js.return
								end
								if not js.return_called then
									js.break
								end
							end
						else
							from
							until
								js.loop_done
							loop
								if (store_char (a_c, 2, a_pos)).to_boolean then
									Result := 1
									js.return
								else
									curr := curr + 1
								end
								if not js.return_called then
									js.break
								end
							end
						end
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						if a_c = 95 then
							if (charset_inst.utf_mode.item).to_boolean then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < 5))
								loop
									if curr <= l_i then
										js.break
									elseif (((linebuf[(curr - l_i)]).to_integer_32).bit_and (192)) /= 128 then
										js.break
									end
									if not js.loop_jumped then
										attr[((curr - l_i) - 1)] := (1).to_integer_8
										l_i := l_i + 1
									end
								end
							end
							if (linebuf[curr]).to_integer_32 = 9 then
								from
								until
									js.loop_done
								loop
									if (store_tab (1, a_pos)).to_boolean then
										Result := 1
										js.return
									end
									if not js.return_called then
										js.break
									end
								end
							else
								from
								until
									js.loop_done
								loop
									if (store_char ((linebuf[curr]).to_integer_32, 1, a_pos)).to_boolean then
										Result := 1
										js.return
									else
										curr := curr + 1
									end
									if not js.return_called then
										js.break
									end
								end
							end
						elseif (linebuf[curr]).to_integer_32 = 95 then
							if (charset_inst.utf_mode.item).to_boolean then
								if ((a_c).bit_and (224)) = 192 then
									overstrike := 1
								elseif ((a_c).bit_and (240)) = 224 then
									overstrike := 2
								elseif ((a_c).bit_and (248)) = 240 then
									overstrike := 3
								end
							end
							if a_c = 9 then
								from
								until
									js.loop_done
								loop
									if (store_tab (1, a_pos)).to_boolean then
										Result := 1
										js.return
									end
									if not js.return_called then
										js.break
									end
								end
							else
								from
								until
									js.loop_done
								loop
									if (store_char (a_c, 1, a_pos)).to_boolean then
										Result := 1
										js.return
									else
										curr := curr + 1
									end
									if not js.return_called then
										js.break
									end
								end
							end
						elseif (charset_inst.control_char (a_c)).to_boolean then
							l_pos := -1 + 55 -- goto do_control_char
						elseif a_c = 9 then
							from
							until
								js.loop_done
							loop
								if (store_tab (0, a_pos)).to_boolean then
									Result := 1
									js.return
								end
								if not js.return_called then
									js.break
								end
							end
						else
							from
							until
								js.loop_done
							loop
								if (store_char (a_c, 0, a_pos)).to_boolean then
									Result := 1
									js.return
								else
									curr := curr + 1
								end
								if not js.return_called then
									js.break
								end
							end
						end
				when 48 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 67
				when 49 then -- else:
						if a_c /= 9 then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						inspect bs_mode.item -- switch 2 head
						when 2 then l_pos := -1 + 51
						when 1 then l_pos := -1 + 52
						when 0 then l_pos := -1 + 52
						else l_pos := -1 + 53
						end
				when 51 then -- switch 2, case 2
						l_pos := -1 + 55 -- goto do_control_char
				when 52 then -- switch 2, case 1 | switch 2, case 0
						from
						until
							js.loop_done
						loop
							if (store_tab (0, a_pos)).to_boolean then
								Result := 1
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
						l_pos := -1 + 53 -- switch 2; break
				when 53 then -- switch 2, done: | if block done, skip else block:
						l_pos := -1 + 67
				when 54 then -- else:
						if not ((charset_inst.control_char (a_c)).to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 55 then -- if: | do_control_char:
						if ctldisp.item /= 1 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 60 -- goto _L___14
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 58 then -- else:
						if ctldisp.item /= 2 then
							l_pos := -1 + 64 -- skip if block
						end
				when 59 then -- if:
						if a_c /= 27 then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if: | _L___14:
						from
						until
							js.loop_done
						loop
							if (store_char (a_c, 0, a_pos)).to_boolean then
								Result := 1
								js.return
							else
								curr := curr + 1
							end
							if not js.return_called then
								js.break
							end
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 62 then -- else:
						l_pos := -1 + 64 -- goto _L___15
				when 63 then -- if done | if block done, skip else block:
						l_pos := -1 + 65
				when 64 then -- else: | _L___15:
						l_s := charset_inst.prchar (a_c)
						l_a := charset_inst.binattr
						l_tmp___18 := strlen (l_s)
						l_tmp___19 := attr_swidth (l_a)
						if ((column + l_tmp___18.to_integer_32) + l_tmp___19) + (attr_ewidth (l_a)) > screen_inst.sc_width then
							Result := 1
							js.return
						end
						if not js.return_called then
							from
							until
								not (not js.loop_done and then ((l_s[0]).to_integer_32 /= 0))
							loop
								from
								until
									js.loop_done
								loop
									if (store_char ((l_s[0]).to_integer_32, l_a, a_pos)).to_boolean then
										Result := 1
										js.return
									else
										curr := curr + 1
									end
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									l_s := l_s + 1
								end
							end
						end
				when 65 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else:
						if a_c = 9 then
							from
							until
								js.loop_done
							loop
								if (store_tab (0, a_pos)).to_boolean then
									Result := 1
									js.return
								end
								if not js.return_called then
									js.break
								end
							end
						else
							from
							until
								js.loop_done
							loop
								if (store_char (a_c, 0, a_pos)).to_boolean then
									Result := 1
									js.return
								else
									curr := curr + 1
								end
								if not js.return_called then
									js.break
								end
							end
						end
				when 67 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 68 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	expand_linebuf: INTEGER_32
		local
			l_new_size: INTEGER_32
			l_new_buf: CE_POINTER [INTEGER_8]
			l_new_attr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_new_buf.make
			create l_new_attr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_new_size := size_linebuf + 1_024
					l_new_buf := create {CE_POINTER [INTEGER_8]}.make_cast ((calloc (l_new_size.to_natural_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
					l_new_attr := create {CE_POINTER [INTEGER_8]}.make_cast ((calloc (l_new_size.to_natural_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
					if not (l_new_buf.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (l_new_attr.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not l_new_attr.is_void then
							free (create {CE_POINTER [ANY]}.make_cast (l_new_attr))
						end
						if not l_new_buf.is_void then
							free (create {CE_POINTER [ANY]}.make_cast (l_new_buf))
						end
						Result := 1
						js.return
				when 5 then -- if done
						if not js.return_called then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_new_buf), create {CE_POINTER [ANY]}.make_cast (linebuf), size_linebuf.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_new_attr), create {CE_POINTER [ANY]}.make_cast (attr), size_linebuf.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
							free (create {CE_POINTER [ANY]}.make_cast (attr))
							free (create {CE_POINTER [ANY]}.make_cast (linebuf))
							linebuf := l_new_buf
							attr := l_new_attr
							size_linebuf := l_new_size
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	forw_raw_line (a_curr_pos: INTEGER_32; a_linep: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_new_pos: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			if a_curr_pos = -1 then
				Result := (-1).to_integer_32
				js.return
			elseif (ch_inst.ch_seek (a_curr_pos)).to_boolean then
				Result := (-1).to_integer_32
				js.return
			else
				l_c := ch_inst.ch_forw_get
				if l_c = -1 then
					Result := (-1).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				l_n := 0
				from
				until
					js.loop_done
				loop
					if l_c = 10 then
						l_new_pos := ch_inst.ch_tell
						js.break
					elseif l_c = -1 then
						l_new_pos := ch_inst.ch_tell
						js.break
					end
					if not js.loop_jumped and then (l_n >= size_linebuf - 1) then
						if (expand_linebuf).to_boolean then
							l_new_pos := (ch_inst.ch_tell) - 1
							js.break
						end
					end
					if not js.loop_jumped then
						l_tmp___2 := l_n
						l_n := l_n + 1
						linebuf[l_tmp___2] := l_c.to_integer_8
						l_c := ch_inst.ch_forw_get
					end
				end
				linebuf[l_n] := (('%/0/').code).to_integer_8
				if not a_linep.is_void then
					a_linep.item := linebuf
				end
				Result := l_new_pos
			end
		end

	gline (a_i: INTEGER_32; a_ap: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			if is_null_line.to_boolean then
				a_ap.item := 2
				if (twiddle.item).to_boolean then
					l_s := ce_string ("~%N")
				else
					l_s := ce_string ("%N")
				end
				Result := (l_s[a_i]).to_integer_32
				js.return
			end
			if not js.return_called then
				a_ap.item := (attr[a_i]).to_integer_32
				Result := (((linebuf[a_i]).to_integer_32).bit_and (255))
			end
		end

	in_ansi_esc_seq: INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := curr - 1
			from
			until
				not (not js.loop_done and then (l_i >= 0))
			loop
				if (linebuf[l_i]).to_integer_32 = 27 then
					Result := 1
					js.return
				end
				if not js.return_called then
					if (is_ansi_end (((linebuf[l_i]).to_integer_32).to_integer_8)).to_boolean then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i - 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	init_line
		do
			end_ansi_chars := decode_inst.lgetenv (ce_string ("LESSANSIENDCHARS"))
			if end_ansi_chars.is_void then
				end_ansi_chars := ce_string ("m")
			elseif (end_ansi_chars[0]).to_integer_32 = 0 then
				end_ansi_chars := ce_string ("m")
			end
			linebuf := create {CE_POINTER [INTEGER_8]}.make_cast ((main_inst.ecalloc (1_024, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			attr := create {CE_POINTER [INTEGER_8]}.make_cast ((main_inst.ecalloc (1_024, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			size_linebuf := 1_024
		end

	is_ansi_end (a_c: INTEGER_8): INTEGER_32
		do
			Result := (not (strchr (end_ansi_chars, a_c.to_integer_32)).is_void).to_integer
		end

	null_line
		do
			is_null_line := 1
			forwback_inst.cshift := 0
		end

	pappend (a_c: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			if pendc.to_boolean then
				if (do_append (pendc.to_integer_32, pendpos)).to_boolean then
					Result := 1
					js.return
				end
				if not js.return_called then
					pendc := (('%/0/').code).to_integer_8
				end
			end
			if not js.return_called and then (a_c = 13) then
				if bs_mode.item = 0 then
					pendc := a_c.to_integer_8
					pendpos := a_pos
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_r := do_append (a_c, a_pos)
				if forwback_inst.cshift < command_inst.hshift then
					if column > screen_inst.sc_width // 2 then
						linebuf[curr] := (('%/0/').code).to_integer_8
						pshift (command_inst.hshift - forwback_inst.cshift)
					end
				end
				Result := l_r
			end
		end

	pdone (a_endline: INTEGER_32)
		do
			if pendc.to_boolean then
				if pendc.to_integer_32 /= 13 then
					do_append (pendc.to_integer_32, pendpos).do_nothing
				elseif not a_endline.to_boolean then
					do_append (pendc.to_integer_32, pendpos).do_nothing
				end
			end
			if forwback_inst.cshift < command_inst.hshift then
				pshift (command_inst.hshift - forwback_inst.cshift)
			end
			if column < screen_inst.sc_width then
				linebuf[curr] := (('%N').code).to_integer_8
				attr[curr] := (0).to_integer_8
				curr := curr + 1
			elseif not screen_inst.auto_wrap.to_boolean then
				linebuf[curr] := (('%N').code).to_integer_8
				attr[curr] := (0).to_integer_8
				curr := curr + 1
			elseif screen_inst.ignaw.to_boolean then
				linebuf[curr] := (('%N').code).to_integer_8
				attr[curr] := (0).to_integer_8
				curr := curr + 1
			elseif ctldisp.item = 1 then
				linebuf[curr] := (('%N').code).to_integer_8
				attr[curr] := (0).to_integer_8
				curr := curr + 1
			end
			linebuf[curr] := (('%/0/').code).to_integer_8
			attr[curr] := (0).to_integer_8
			if (status_col.item).to_boolean then
				if hilites > 0 then
					linebuf[0] := (('*').code).to_integer_8
					attr[0] := (5).to_integer_8
				end
			end
			if a_endline.to_boolean then
				forwback_inst.cshift := 0
			end
		end

	plinenum (a_pos: INTEGER_32)
		local
			l_linenum: INTEGER_32
			l_i: INTEGER_32
			l_buf___1: CE_ARRAY [INTEGER_8]
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create l_buf___1.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			l_linenum := (0).to_integer_32
			if linenums.item = 2 then
				l_linenum := linenum_inst.find_linenum (a_pos)
			end
			if (status_col.item).to_boolean then
				linebuf[curr] := ((' ').code).to_integer_8
				if main_inst.start_attnpos /= -1 then
					if a_pos >= main_inst.start_attnpos then
						if a_pos < main_inst.end_attnpos then
							attr[curr] := (5).to_integer_8
						else
							attr[curr] := (0).to_integer_8
						end
					else
						attr[curr] := (0).to_integer_8
					end
				else
					attr[curr] := (0).to_integer_8
				end
				curr := curr + 1
				column := column + 1
			end
			if linenums.item = 2 then
				output_inst.linenumtoa (l_linenum, l_buf___1)
				l_n := (strlen (l_buf___1)).to_integer_32
				if l_n < 7 then
					l_n := 7
				end
				sprintf ([(linebuf + curr), ce_string ("%%*s "), l_n, l_buf___1]).do_nothing
				l_n := l_n + 1
				l_i := 0
				from
				until
					not (l_i < l_n)
				loop
					attr[(curr + l_i)] := (0).to_integer_8
					l_i := l_i + 1
				end
				curr := curr + l_n
				column := column + l_n
				lmargin := lmargin + l_n
			end
			from
			until
				not (column < lmargin)
			loop
				linebuf[curr] := ((' ').code).to_integer_8
				l_tmp___0 := curr
				curr := curr + 1
				attr[l_tmp___0] := (0).to_integer_8
				column := column + 1
			end
		end

	prewind
		do
			curr := 0
			column := 0
			overstrike := 0
			is_null_line := 0
			pendc := (('%/0/').code).to_integer_8
			lmargin := 0
			if (status_col.item).to_boolean then
				lmargin := lmargin + 1
			end
			hilites := 0
		end

	pshift (a_shift: INTEGER_32)
		local
			l_shift: INTEGER_32
			l_i: INTEGER_32
			l_nchars: INTEGER_32
		do
			l_shift := a_shift
			if l_shift > column - lmargin then
				l_shift := column - lmargin
			end
			if l_shift > curr - lmargin then
				l_shift := curr - lmargin
			end
			if (charset_inst.utf_mode.item).to_boolean then
				l_nchars := utf_shift_chars (linebuf + lmargin, l_shift)
			else
				l_nchars := shift_chars (linebuf + lmargin, l_shift)
			end
			if l_nchars > curr then
				l_nchars := curr
			end
			l_i := 0
			from
			until
				not (l_i < curr - l_nchars)
			loop
				linebuf[(lmargin + l_i)] := linebuf[((lmargin + l_i) + l_nchars)]
				attr[(lmargin + l_i)] := attr[((lmargin + l_i) + l_nchars)]
				l_i := l_i + 1
			end
			curr := curr - l_nchars
			column := column - l_shift
			forwback_inst.cshift := forwback_inst.cshift + l_shift
		end

	pwidth (a_c: INTEGER_32; a_a: INTEGER_32): INTEGER_32
		local
			l_w: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if (charset_inst.utf_mode.item).to_boolean then
				if ((a_c).bit_and (192)) = 128 then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (a_c = 8) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (charset_inst.control_char (a_c)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_w := 1
				if curr > 0 then
					if (attr[(curr - 1)]).to_integer_32 /= a_a then
						l_w := l_w + (attr_ewidth ((attr[(curr - 1)]).to_integer_32))
					end
				end
				if a_a.to_boolean then
					if curr = 0 then
						l_tmp___1 := attr_swidth (a_a)
						l_w := l_w + l_tmp___1
					elseif (attr[(curr - 1)]).to_integer_32 /= a_a then
						l_tmp___1 := attr_swidth (a_a)
						l_w := l_w + l_tmp___1
					end
				end
				Result := l_w
			end
		end

	shift_chars (a_s: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make
			create l_tmp.make
			create l_tmp___1.make

			l_len := a_len
			l_p := a_s
			from
			until
				js.loop_done
			loop
				if (l_p[0]).to_integer_32 /= 0 then
					if not (l_len > 0) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp___1 := l_p
					l_p := l_p + 1
					if (l_tmp___1[0]).to_integer_32 /= 27 then
						l_len := l_len - 1
					else
						from
						until
							not (not js.loop_done and then ((l_p[0]).to_integer_32 /= 0))
						loop
							l_tmp := l_p
							l_p := l_p + 1
							if (is_ansi_end (((l_tmp[0]).to_integer_32).to_integer_8)).to_boolean then
								js.break
							end
						end
					end
				end
			end
			Result := (l_p.distance (a_s))
		end

	store_char (a_c: INTEGER_32; a_a: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_a: INTEGER_32
			l_w: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					if l_a /= 0 then
						last_overstrike := l_a
					end
					if (search_inst.is_hilited (a_pos, a_pos + 1, 0)).to_boolean then
						l_a := 5
						hilites := hilites + 1
					end
					if ctldisp.item = 2 then
						if (in_ansi_esc_seq).to_boolean then
							l_w := 0
						else
							l_w := pwidth (a_c, l_a)
						end
					else
						l_w := pwidth (a_c, l_a)
					end
					if ctldisp.item /= 1 then
						if (column + l_w) + (attr_ewidth (l_a)) > screen_inst.sc_width then
							Result := 1
							js.return
						end
					end
					if not js.return_called and then (curr >= size_linebuf - 2) then
						if (expand_linebuf).to_boolean then
							Result := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (curr > 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_a /= 0 then
							if (linebuf[(curr - 1)]).to_integer_32 = 32 then
								if (attr[(curr - 1)]).to_integer_32 = 0 then
									if (attr_swidth (l_a)) > 0 then
										attr[(curr - 1)] := (4).to_integer_8
										column := column - 1
									else
										l_pos := -1 + 4 -- goto _L___2
									end
								else
									l_pos := -1 + 4 -- goto _L___2
								end
							else
								l_pos := -1 + 4 -- goto _L___2
							end
						else
							l_pos := -1 + 4 -- goto _L___2
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___2:
						if curr > 0 then
							if (attr[(curr - 1)]).to_integer_32 /= 0 then
								if (attr[(curr - 1)]).to_integer_32 /= 4 then
									if a_c = 32 then
										if l_a = 0 then
											if (attr_ewidth ((attr[(curr - 1)]).to_integer_32)) > 0 then
												l_a := 4
												column := column - 1
											end
										end
									end
								end
							end
						end
				when 5 then
						linebuf[curr] := a_c.to_integer_8
						attr[curr] := l_a.to_integer_8
						column := column + l_w
						Result := 0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	store_tab (a_attr___0: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_to_tab: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_to_tab := (column + forwback_inst.cshift) - lmargin
			if ntabstops < 2 then
				l_to_tab := tabdefault - (l_to_tab - tabstops[ntabstops - 1]) \\ tabdefault
			elseif l_to_tab >= tabstops[ntabstops - 1] then
				l_to_tab := tabdefault - (l_to_tab - tabstops[ntabstops - 1]) \\ tabdefault
			else
				l_i := ntabstops - 2
				from
				until
					not (not js.loop_done and then (l_i >= 0))
				loop
					if l_to_tab >= tabstops[l_i] then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i - 1
					end
				end
				l_to_tab := tabstops[l_i + 1] - l_to_tab
			end
			from
			until
				js.loop_done
			loop
				from
				until
					js.loop_done
				loop
					if (store_char ((' ').code, a_attr___0, a_pos)).to_boolean then
						Result := 1
						js.return
					else
						curr := curr + 1
					end
					if not js.return_called then
						js.break
					end
				end
				if not js.return_called then
					l_to_tab := l_to_tab - 1
					if not (l_to_tab > 0) then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	utf_shift_chars (a_s: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_ulen: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_s
			l_len := a_len
			l_ulen := 0
			from
			until
				js.loop_done
			loop
				if (l_s[0]).to_integer_32 /= 0 then
					if not (l_len > 0) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (((l_s[0]).to_integer_32).bit_and (192)) /= 128 then
						l_len := l_len - 1
					end
					l_s := l_s + 1
					l_ulen := l_ulen + 1
				end
			end
			from
			until
				(((l_s[0]).to_integer_32).bit_and (192)) /= 128
			loop
				l_s := l_s + 1
				l_ulen := l_ulen + 1
			end
			Result := l_ulen
		end

end
