class
	P_OS

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	consecutive_nulls: INTEGER_32 assign set_consecutive_nulls

	set_consecutive_nulls (a_consecutive_nulls: INTEGER_32)
		do
			consecutive_nulls := a_consecutive_nulls
		end

	read_label: CE_EXCEPTION assign set_read_label

	set_read_label (a_read_label: CE_EXCEPTION)
		do
			read_label := a_read_label
		end

	reading: INTEGER_32 assign set_reading

	set_reading (a_reading: INTEGER_32)
		do
			reading := a_reading
		end

feature {ANY} -- routines

	errno_message (a_filename: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p: CE_POINTER [INTEGER_8]
			l_m: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
		do
			create l_p.make
			create l_m.make

			l_p := strerror ((errno_location).item)
			l_tmp___0 := strlen (a_filename)
			l_m := create {CE_POINTER [INTEGER_8]}.make_cast ((main_inst.ecalloc (((l_tmp___0 + (strlen (l_p))) + {NATURAL_32} 3).to_integer_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			sprintf ([l_m, ce_string ("%%s: %%s"), a_filename, l_p]).do_nothing
			Result := l_m
		end

	get_time: INTEGER_32
		local
			l_t: CE_ARRAY [INTEGER_32]
		do
			create l_t.make (<<1>>)

			time (l_t).do_nothing
			Result := (l_t.item)
		end

	intread
		do
			read_label.raise (1)
		end

	iread (a_fd: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					read_label := create {CE_EXCEPTION}.make ($iread, l_pos, $l_tmp)
				when 1 then -- continue here on raising read_label:
					if l_tmp.to_boolean then
						reading := 0
						sigsetmask (0).do_nothing
						Result := (-2)
						js.return
					end
					if not js.return_called then
						output_inst.flush
						reading := 1
						l_n := read (a_fd, create {CE_POINTER [ANY]}.make_cast (a_buf___1), a_len)
						if not ch_inst.ignore_eoi.to_boolean then
							if l_n = 0 then
								consecutive_nulls := consecutive_nulls + 1
							else
								consecutive_nulls := 0
							end
							if consecutive_nulls > 20 then
								main_inst.quit (1)
							end
						end
						reading := 0
						if l_n < 0 then
							Result := (-1)
							js.return
						end
					end
					if not js.return_called then
						Result := l_n
					end
				when 2 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $iread then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	percent_pos (a_pos: INTEGER_32; a_percent: INTEGER_32): INTEGER_32
		local
			l_result100: INTEGER_32
		do
			if a_percent = 0 then
				Result := (0).to_integer_32
			else
				l_result100 := a_pos * a_percent.to_integer_32
				if l_result100 // a_percent.to_integer_32 = a_pos then
					Result := (l_result100 // 100)
				else
					Result := (a_percent.to_integer_32 * (a_pos // 100))
				end
			end
		end

	percentage (a_num: INTEGER_32; a_den: INTEGER_32): INTEGER_32
		local
			l_num100: INTEGER_32
		do
			l_num100 := a_num * 100
			if l_num100 // 100 = a_num then
				Result := (l_num100 // a_den).to_integer_32
			else
				Result := (a_num // (a_den // 100)).to_integer_32
			end
		end

end
