class
	P_POSITION

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create table.make
		end

feature {ANY} -- attributes

	table: CE_POINTER [INTEGER_32] assign set_table

	set_table (a_table: CE_POINTER [INTEGER_32])
		do
			table := a_table
		end

	table_size: INTEGER_32 assign set_table_size

	set_table_size (a_table_size: INTEGER_32)
		do
			table_size := a_table_size
		end

feature {ANY} -- routines

	add_back_pos (a_pos: INTEGER_32)
		local
			l_i: INTEGER_32
		do
			l_i := screen_inst.sc_height - 1
			from
			until
				not (l_i > 0)
			loop
				table[l_i] := table[(l_i - 1)]
				l_i := l_i - 1
			end
			table[0] := a_pos
		end

	add_forw_pos (a_pos: INTEGER_32)
		local
			l_i: INTEGER_32
		do
			l_i := 1
			from
			until
				not (l_i < screen_inst.sc_height)
			loop
				table[(l_i - 1)] := table[l_i]
				l_i := l_i + 1
			end
			table[(screen_inst.sc_height - 1)] := a_pos
		end

	adjsline (a_sline: INTEGER_32): INTEGER_32
		local
			l_sline: INTEGER_32
		do
			l_sline := a_sline
			if l_sline < 0 then
				l_sline := l_sline + screen_inst.sc_height
			end
			if l_sline <= 0 then
				l_sline := 1
			end
			if l_sline >= screen_inst.sc_height then
				l_sline := screen_inst.sc_height - 1
			end
			Result := (l_sline - 1)
		end

	empty_lines (a_s: INTEGER_32; a_e: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := a_s
			from
			until
				not (not js.loop_done and then (l_i <= a_e))
			loop
				if table[l_i] /= -1 then
					Result := 0
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	empty_screen: INTEGER_32
		do
			Result := (empty_lines (0, screen_inst.sc_height - 1))
		end

	get_scrpos (a_scrpos: CE_POINTER [PD_SCRPOS])
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < screen_inst.sc_height))
			loop
				if table[l_i] /= -1 then
					a_scrpos.item.ln := l_i + 1
					a_scrpos.item.pos := table[l_i]
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				a_scrpos.item.pos := (-1).to_integer_32
			end
		end

	onscreen (a_pos: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			if a_pos < table[0] then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_i := 1
				from
				until
					not (not js.loop_done and then (l_i < screen_inst.sc_height))
				loop
					if a_pos < table[l_i] then
						Result := (l_i - 1)
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	pos_clear
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < screen_inst.sc_height)
			loop
				table[l_i] := (-1).to_integer_32
				l_i := l_i + 1
			end
		end

	pos_init
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			js: JUMP_STATE
		do
			create l_scrpos.make (<<1>>)

			if screen_inst.sc_height <= table_size then
				js.return
			end
			if not js.return_called then
				if not table.is_void then
					get_scrpos (l_scrpos)
					free (create {CE_POINTER [ANY]}.make_cast (table))
				else
					l_scrpos.item.pos := (-1).to_integer_32
				end
				table := create {CE_POINTER [INTEGER_32]}.make_cast ((main_inst.ecalloc (screen_inst.sc_height, {PLATFORM}.Integer_32_bytes.to_natural_32)))
				table_size := screen_inst.sc_height
				pos_clear
				if l_scrpos.item.pos /= -1 then
					table[(l_scrpos.item.ln - 1)] := l_scrpos.item.pos
				end
			end
		end

	position (a_where: INTEGER_32): INTEGER_32
		local
			l_where: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_where := a_where
					inspect l_where -- switch 1 head
					when -1 then l_pos := -1 + 1 -- -1
					when -2 then l_pos := -1 + 2 -- -2
					when -3 then l_pos := -1 + 3 -- -3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case -1
					l_where := screen_inst.sc_height - 2
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case -2
					l_where := screen_inst.sc_height - 1
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case -3
					l_where := (screen_inst.sc_height - 1) // 2
				when 4 then -- switch 1, done:
					Result := (table[l_where])
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
