class
	P_SIGNAL

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {ANY} -- routines

	init_signals (a_on: INTEGER_32)
		do
			if a_on.to_boolean then
				signal (2, u_interrupt_address).do_nothing
				signal (20, stop_address).do_nothing
				signal (28, winch_address).do_nothing
			else
				signal (2, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				signal (20, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				signal (28, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
				signal (3, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			end
		end

	psignals
		local
			l_tsignals: INTEGER_32
			l_old_width: INTEGER_32
			l_old_height: INTEGER_32
			js: JUMP_STATE
		do
			l_tsignals := ch_inst.sigs
			if l_tsignals = 0 then
				js.return
			end
			if not js.return_called then
				ch_inst.sigs := 0
				if ((l_tsignals).bit_and (2)).to_boolean then
					signal (22, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
					screen_inst.clear_bot
					screen_inst.deinit
					output_inst.flush
					screen_inst.raw_mode (0)
					signal (22, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
					signal (20, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
					kill ((getpid), 20).do_nothing
					signal (20, stop_address).do_nothing
					screen_inst.raw_mode (1)
					screen_inst.init
					command_inst.screen_trashed := 1
					l_tsignals := (l_tsignals).bit_or ((4))
				end
				if ((l_tsignals).bit_and (4)).to_boolean then
					l_old_width := screen_inst.sc_width
					l_old_height := screen_inst.sc_height
					screen_inst.get_term
					if screen_inst.sc_width /= l_old_width then
						main_inst.wscroll := (screen_inst.sc_height + 1) // 2
						command_inst.screen_trashed := 1
					elseif screen_inst.sc_height /= l_old_height then
						main_inst.wscroll := (screen_inst.sc_height + 1) // 2
						command_inst.screen_trashed := 1
					end
				end
				if ((l_tsignals).bit_and (1)).to_boolean then
					screen_inst.bell
					if linenum_inst.lnloop.to_boolean then
						linenum_inst.lnloop := 0
						if line_inst.linenums.item = 2 then
							command_inst.screen_trashed := 1
						end
						line_inst.linenums.item := 0
						output_inst.error (ce_string ("Line numbers turned off"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
					end
				end
			end
		end

	stop (a_type: INTEGER_32)
		do
			signal (20, stop_address).do_nothing
			ch_inst.sigs := (ch_inst.sigs).bit_or ((2))
			if os_inst.reading.to_boolean then
				os_inst.intread
			end
		end

	stop_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent stop)
		end

	u_interrupt (a_type: INTEGER_32)
		do
			signal (2, u_interrupt_address).do_nothing
			ch_inst.sigs := (ch_inst.sigs).bit_or ((1))
			if os_inst.reading.to_boolean then
				os_inst.intread
			end
		end

	u_interrupt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent u_interrupt)
		end

	winch (a_type: INTEGER_32)
		do
			signal (28, winch_address).do_nothing
			ch_inst.sigs := (ch_inst.sigs).bit_or ((4))
			if os_inst.reading.to_boolean then
				os_inst.intread
			end
		end

	winch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent winch)
		end

end
