class
	PD_ADDRESS_LIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create addresses.make
		end

feature {ANY} -- fields

	count: INTEGER_32 assign set_count

	addresses: CE_POINTER [PD_IP_ADDRESS] assign set_addresses

	faulty: INTEGER_32 assign set_faulty

	connected: BOOLEAN assign set_connected

	refcount: INTEGER_32 assign set_refcount

feature {ANY} -- setters

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_addresses (a_addresses: CE_POINTER [PD_IP_ADDRESS])
		do
			addresses := a_addresses
			update_memory_field ("addresses")
		end

	set_faulty (a_faulty: INTEGER_32)
		do
			faulty := a_faulty
			update_memory_field ("faulty")
		end

	set_connected (a_connected: BOOLEAN)
		do
			connected := a_connected
			update_memory_field ("connected")
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			refcount := a_refcount
			update_memory_field ("refcount")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			count := a_other.count
			addresses := a_other.addresses
			faulty := a_other.faulty
			connected := a_other.connected
			refcount := a_other.refcount
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				count = a_other.count and
				addresses.is_equal (a_other.addresses) and
				faulty = a_other.faulty and
				connected = a_other.connected and
				refcount = a_other.refcount
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("addresses"),
					create {CE_STRUCTURE_FIELD}.make ("faulty"),
					create {CE_STRUCTURE_FIELD}.make ("connected"),
					create {CE_STRUCTURE_FIELD}.make ("refcount")
				>>)
			init_structure_info
		end

end
