class
	PD_CMDLINE_OPTION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create long_name.make
			create data.make
		end

feature {ANY} -- fields

	long_name: CE_POINTER [INTEGER_8] assign set_long_name

	short_name: INTEGER_8 assign set_short_name

	type: NATURAL_32 assign set_type

	data: CE_POINTER [ANY] assign set_data

	argtype: INTEGER_32 assign set_argtype

feature {ANY} -- setters

	set_long_name (a_long_name: CE_POINTER [INTEGER_8])
		do
			long_name := a_long_name
			update_memory_field ("long_name")
		end

	set_short_name (a_short_name: INTEGER_8)
		do
			short_name := a_short_name
			update_memory_field ("short_name")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_argtype (a_argtype: INTEGER_32)
		do
			argtype := a_argtype
			update_memory_field ("argtype")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			long_name := a_other.long_name
			short_name := a_other.short_name
			type := a_other.type
			data := a_other.data
			argtype := a_other.argtype
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				long_name.is_equal (a_other.long_name) and
				short_name = a_other.short_name and
				type = a_other.type and
				data.is_equal (a_other.data) and
				argtype = a_other.argtype
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("long_name"),
					create {CE_STRUCTURE_FIELD}.make ("short_name"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("argtype")
				>>)
			init_structure_info
		end

end
