class
	PD_DOT_PROGRESS

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	initial_length: INTEGER_64 assign set_initial_length

	total_length: INTEGER_64 assign set_total_length

	accumulated: INTEGER_32 assign set_accumulated

	rows: INTEGER_32 assign set_rows

	dots: INTEGER_32 assign set_dots

	last_timer_value: REAL_64 assign set_last_timer_value

feature {ANY} -- setters

	set_initial_length (a_initial_length: INTEGER_64)
		do
			initial_length := a_initial_length
			update_memory_field ("initial_length")
		end

	set_total_length (a_total_length: INTEGER_64)
		do
			total_length := a_total_length
			update_memory_field ("total_length")
		end

	set_accumulated (a_accumulated: INTEGER_32)
		do
			accumulated := a_accumulated
			update_memory_field ("accumulated")
		end

	set_rows (a_rows: INTEGER_32)
		do
			rows := a_rows
			update_memory_field ("rows")
		end

	set_dots (a_dots: INTEGER_32)
		do
			dots := a_dots
			update_memory_field ("dots")
		end

	set_last_timer_value (a_last_timer_value: REAL_64)
		do
			last_timer_value := a_last_timer_value
			update_memory_field ("last_timer_value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			initial_length := a_other.initial_length
			total_length := a_other.total_length
			accumulated := a_other.accumulated
			rows := a_other.rows
			dots := a_other.dots
			last_timer_value := a_other.last_timer_value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				initial_length = a_other.initial_length and
				total_length = a_other.total_length and
				accumulated = a_other.accumulated and
				rows = a_other.rows and
				dots = a_other.dots and
				last_timer_value = a_other.last_timer_value
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("initial_length"),
					create {CE_STRUCTURE_FIELD}.make ("total_length"),
					create {CE_STRUCTURE_FIELD}.make ("accumulated"),
					create {CE_STRUCTURE_FIELD}.make ("rows"),
					create {CE_STRUCTURE_FIELD}.make ("dots"),
					create {CE_STRUCTURE_FIELD}.make ("last_timer_value")
				>>)
			init_structure_info
		end

end
