class
	PD_IP_ADDRESS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
		end

feature {ANY} -- fields

	family: INTEGER_32 assign set_family

	data: PD_DATA assign set_data

	ipv6_scope: INTEGER_32 assign set_ipv6_scope

feature {ANY} -- setters

	set_family (a_family: INTEGER_32)
		do
			family := a_family
			update_memory_field ("family")
		end

	set_data (a_data: PD_DATA)
		do
			data := a_data
			update_memory_field ("data")
		end

	set_ipv6_scope (a_ipv6_scope: INTEGER_32)
		do
			ipv6_scope := a_ipv6_scope
			update_memory_field ("ipv6_scope")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			family := a_other.family
			data := a_other.data.twin
			ipv6_scope := a_other.ipv6_scope
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				family = a_other.family and
				data.is_equal (a_other.data) and
				ipv6_scope = a_other.ipv6_scope
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("family"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("ipv6_scope")
				>>)
			init_structure_info
		end

end
