class
	PD_IRI

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create uri_encoding.make
			create content_encoding.make
			create orig_url.make
		end

feature {ANY} -- fields

	uri_encoding: CE_POINTER [INTEGER_8] assign set_uri_encoding

	content_encoding: CE_POINTER [INTEGER_8] assign set_content_encoding

	orig_url: CE_POINTER [INTEGER_8] assign set_orig_url

	utf8_encode: BOOLEAN assign set_utf8_encode

feature {ANY} -- setters

	set_uri_encoding (a_uri_encoding: CE_POINTER [INTEGER_8])
		do
			uri_encoding := a_uri_encoding
			update_memory_field ("uri_encoding")
		end

	set_content_encoding (a_content_encoding: CE_POINTER [INTEGER_8])
		do
			content_encoding := a_content_encoding
			update_memory_field ("content_encoding")
		end

	set_orig_url (a_orig_url: CE_POINTER [INTEGER_8])
		do
			orig_url := a_orig_url
			update_memory_field ("orig_url")
		end

	set_utf8_encode (a_utf8_encode: BOOLEAN)
		do
			utf8_encode := a_utf8_encode
			update_memory_field ("utf8_encode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			uri_encoding := a_other.uri_encoding
			content_encoding := a_other.content_encoding
			orig_url := a_other.orig_url
			utf8_encode := a_other.utf8_encode
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				uri_encoding.is_equal (a_other.uri_encoding) and
				content_encoding.is_equal (a_other.content_encoding) and
				orig_url.is_equal (a_other.orig_url) and
				utf8_encode = a_other.utf8_encode
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("uri_encoding"),
					create {CE_STRUCTURE_FIELD}.make ("content_encoding"),
					create {CE_STRUCTURE_FIELD}.make ("orig_url"),
					create {CE_STRUCTURE_FIELD}.make ("utf8_encode")
				>>)
			init_structure_info
		end

end
