class
	PD_KNOWN_TAG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create handler.make
		end

feature {ANY} -- fields

	tagid: INTEGER_32 assign set_tagid

	name: CE_POINTER [INTEGER_8] assign set_name

	handler: CE_ROUTINE assign set_handler

feature {ANY} -- setters

	set_tagid (a_tagid: INTEGER_32)
		do
			tagid := a_tagid
			update_memory_field ("tagid")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_handler (a_handler: CE_ROUTINE)
		do
			handler := a_handler
			update_memory_field ("handler")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tagid := a_other.tagid
			name := a_other.name
			handler := a_other.handler
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tagid = a_other.tagid and
				name.is_equal (a_other.name) and
				handler.is_equal (a_other.handler)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tagid"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("handler")
				>>)
			init_structure_info
		end

end
