class
	PD_RESPONSE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create headers.make
		end

feature {ANY} -- fields

	data: CE_POINTER [INTEGER_8] assign set_data

	headers: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_headers

feature {ANY} -- setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_headers (a_headers: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			headers := a_headers
			update_memory_field ("headers")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			headers := a_other.headers
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				headers.is_equal (a_other.headers)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("headers")
				>>)
			init_structure_info
		end

end
