class
	PD_URL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create url.make
			create host.make
			create path.make
			create params.make
			create query.make
			create fragment.make
			create dir.make
			create file.make
			create user.make
			create passwd.make
		end

feature {ANY} -- fields

	url: CE_POINTER [INTEGER_8] assign set_url

	scheme: NATURAL_32 assign set_scheme

	host: CE_POINTER [INTEGER_8] assign set_host

	port: INTEGER_32 assign set_port

	path: CE_POINTER [INTEGER_8] assign set_path

	params: CE_POINTER [INTEGER_8] assign set_params

	query: CE_POINTER [INTEGER_8] assign set_query

	fragment: CE_POINTER [INTEGER_8] assign set_fragment

	dir: CE_POINTER [INTEGER_8] assign set_dir

	file: CE_POINTER [INTEGER_8] assign set_file

	user: CE_POINTER [INTEGER_8] assign set_user

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

feature {ANY} -- setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_scheme (a_scheme: NATURAL_32)
		do
			scheme := a_scheme
			update_memory_field ("scheme")
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_params (a_params: CE_POINTER [INTEGER_8])
		do
			params := a_params
			update_memory_field ("params")
		end

	set_query (a_query: CE_POINTER [INTEGER_8])
		do
			query := a_query
			update_memory_field ("query")
		end

	set_fragment (a_fragment: CE_POINTER [INTEGER_8])
		do
			fragment := a_fragment
			update_memory_field ("fragment")
		end

	set_dir (a_dir: CE_POINTER [INTEGER_8])
		do
			dir := a_dir
			update_memory_field ("dir")
		end

	set_file (a_file: CE_POINTER [INTEGER_8])
		do
			file := a_file
			update_memory_field ("file")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			url := a_other.url
			scheme := a_other.scheme
			host := a_other.host
			port := a_other.port
			path := a_other.path
			params := a_other.params
			query := a_other.query
			fragment := a_other.fragment
			dir := a_other.dir
			file := a_other.file
			user := a_other.user
			passwd := a_other.passwd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				url.is_equal (a_other.url) and
				scheme = a_other.scheme and
				host.is_equal (a_other.host) and
				port = a_other.port and
				path.is_equal (a_other.path) and
				params.is_equal (a_other.params) and
				query.is_equal (a_other.query) and
				fragment.is_equal (a_other.fragment) and
				dir.is_equal (a_other.dir) and
				file.is_equal (a_other.file) and
				user.is_equal (a_other.user) and
				passwd.is_equal (a_other.passwd)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("scheme"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("params"),
					create {CE_STRUCTURE_FIELD}.make ("query"),
					create {CE_STRUCTURE_FIELD}.make ("fragment"),
					create {CE_STRUCTURE_FIELD}.make ("dir"),
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("passwd")
				>>)
			init_structure_info
		end

end
