class
	P_MD5

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create fillbuf.make (<<64>>)
		end

feature {ANY} -- attributes

	fillbuf: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	md5_buffer (a_buffer___0: CE_POINTER [INTEGER_8]; a_len: NATURAL_32; a_resblock: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_ctx: CE_ARRAY [PD_MD5_CTX]
		do
			create l_ctx.make (<<1>>)

			md5_init_ctx (l_ctx)
			md5_process_bytes (create {CE_POINTER [ANY]}.make_cast (a_buffer___0), a_len, l_ctx)
			Result := (md5_finish_ctx (l_ctx, a_resblock))
		end

	md5_finish_ctx (a_ctx: CE_POINTER [PD_MD5_CTX]; a_resbuf: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_bytes: NATURAL_32
			l_size: NATURAL_32
			l_tmp: INTEGER_32
		do
			l_bytes := a_ctx.item.buflen
			if l_bytes < {NATURAL_32} 56 then
				l_tmp := 16
			else
				l_tmp := 32
			end
			l_size := l_tmp.to_natural_32
			a_ctx.item.total[0] := a_ctx.item.total[0] + l_bytes
			if a_ctx.item.total[0] < l_bytes then
				a_ctx.item.total[1] := (a_ctx.item.total[1]) + 1
			end
			a_ctx.item.buffer[(l_size - {NATURAL_32} 2).to_integer_32] := (a_ctx.item.total[0]).bit_shift_left (3)
			a_ctx.item.buffer[(l_size - {NATURAL_32} 1).to_integer_32] := (((a_ctx.item.total[1]).bit_shift_left (3))).bit_or (((a_ctx.item.total[0]).bit_shift_right (29)))
			memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast ((a_ctx.item.buffer)) + l_bytes.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (fillbuf), (l_size - {NATURAL_32} 2) * {NATURAL_32} 4 - l_bytes).do_nothing
			md5_process_block (create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer)), l_size * {NATURAL_32} 4, a_ctx)
			Result := (md5_read_ctx (a_ctx, a_resbuf))
		end

	md5_init_ctx (a_ctx: CE_POINTER [PD_MD5_CTX])
		local
			l_tmp: NATURAL_32
		do
			a_ctx.item.A := (1_732_584_193).to_natural_32
			a_ctx.item.B := {NATURAL_32} 4_023_233_417
			a_ctx.item.C := {NATURAL_32} 2_562_383_102
			a_ctx.item.D := (271_733_878).to_natural_32
			l_tmp := (0).to_natural_32
			a_ctx.item.total[1] := l_tmp
			a_ctx.item.total[0] := l_tmp
			a_ctx.item.buflen := (0).to_natural_32
		end

	md5_process_block (a_buffer___0: CE_POINTER [ANY]; a_len: NATURAL_32; a_ctx: CE_POINTER [PD_MD5_CTX])
		local
			l_correct_words: CE_ARRAY [NATURAL_32]
			l_words: CE_POINTER [NATURAL_32]
			l_nwords: NATURAL_32
			l_endp: CE_POINTER [NATURAL_32]
			l_A: NATURAL_32
			l_B: NATURAL_32
			l_C: NATURAL_32
			l_D: NATURAL_32
			l_cwp: CE_POINTER [NATURAL_32]
			l_A_save: NATURAL_32
			l_B_save: NATURAL_32
			l_C_save: NATURAL_32
			l_D_save: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_tmp___4: NATURAL_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [NATURAL_32]
			l_tmp___8: NATURAL_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			l_tmp___10: NATURAL_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___12: NATURAL_32
			l_tmp___13: CE_POINTER [NATURAL_32]
			l_tmp___14: NATURAL_32
			l_tmp___15: CE_POINTER [NATURAL_32]
			l_tmp___16: NATURAL_32
			l_tmp___17: CE_POINTER [NATURAL_32]
			l_tmp___18: NATURAL_32
			l_tmp___19: CE_POINTER [NATURAL_32]
			l_tmp___20: NATURAL_32
			l_tmp___21: CE_POINTER [NATURAL_32]
			l_tmp___22: NATURAL_32
			l_tmp___23: CE_POINTER [NATURAL_32]
			l_tmp___24: NATURAL_32
			l_tmp___25: CE_POINTER [NATURAL_32]
			l_tmp___26: NATURAL_32
			l_tmp___27: CE_POINTER [NATURAL_32]
			l_tmp___28: NATURAL_32
			l_tmp___29: CE_POINTER [NATURAL_32]
			l_tmp___30: NATURAL_32
			js: JUMP_STATE
		do
			create l_correct_words.make (<<16>>)
			create l_words.make
			create l_endp.make
			create l_cwp.make
			create l_tmp.make
			create l_tmp___1.make
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___7.make
			create l_tmp___9.make
			create l_tmp___11.make
			create l_tmp___13.make
			create l_tmp___15.make
			create l_tmp___17.make
			create l_tmp___19.make
			create l_tmp___21.make
			create l_tmp___23.make
			create l_tmp___25.make
			create l_tmp___27.make
			create l_tmp___29.make

			l_words := create {CE_POINTER [NATURAL_32]}.make_cast (a_buffer___0)
			l_nwords := a_len // {PLATFORM}.Natural_32_bytes.to_natural_32
			l_endp := l_words + l_nwords.to_integer_32
			l_A := a_ctx.item.A
			l_B := a_ctx.item.B
			l_C := a_ctx.item.C
			l_D := a_ctx.item.D
			a_ctx.item.total[0] := a_ctx.item.total[0] + a_len
			if a_ctx.item.total[0] < a_len then
				a_ctx.item.total[1] := (a_ctx.item.total[1]) + 1
			end
			from
			until
				not (not js.loop_done and then ((l_words.c_pointer.to_integer_32).to_natural_32 < (l_endp.c_pointer.to_integer_32).to_natural_32))
			loop
				l_cwp := l_correct_words
				l_A_save := l_A
				l_B_save := l_B
				l_C_save := l_C
				l_D_save := l_D
				from
				until
					js.loop_done
				loop
					l_tmp := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___0 := l_words.item
					l_tmp.item := l_tmp___0
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___0) + {NATURAL_32} 3_614_090_360)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___1 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___2 := l_words.item
					l_tmp___1.item := l_tmp___2
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___2) + {NATURAL_32} 3_905_402_710)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___3 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___4 := l_words.item
					l_tmp___3.item := l_tmp___4
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___4) + {NATURAL_32} 606_105_819)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___5 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___6 := l_words.item
					l_tmp___5.item := l_tmp___6
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___6) + {NATURAL_32} 3_250_441_966)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___7 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___8 := l_words.item
					l_tmp___7.item := l_tmp___8
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___8) + {NATURAL_32} 4_118_548_399)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___9 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___10 := l_words.item
					l_tmp___9.item := l_tmp___10
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___10) + {NATURAL_32} 1_200_080_426)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___11 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___12 := l_words.item
					l_tmp___11.item := l_tmp___12
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___12) + {NATURAL_32} 2_821_735_955)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___13 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___14 := l_words.item
					l_tmp___13.item := l_tmp___14
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___14) + {NATURAL_32} 4_249_261_313)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___15 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___16 := l_words.item
					l_tmp___15.item := l_tmp___16
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___16) + {NATURAL_32} 1_770_035_416)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___17 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___18 := l_words.item
					l_tmp___17.item := l_tmp___18
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___18) + {NATURAL_32} 2_336_552_879)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___19 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___20 := l_words.item
					l_tmp___19.item := l_tmp___20
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___20) + {NATURAL_32} 4_294_925_233)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___21 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___22 := l_words.item
					l_tmp___21.item := l_tmp___22
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___22) + {NATURAL_32} 2_304_563_134)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___23 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___24 := l_words.item
					l_tmp___23.item := l_tmp___24
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___24) + {NATURAL_32} 1_804_603_682)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___25 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___26 := l_words.item
					l_tmp___25.item := l_tmp___26
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___26) + {NATURAL_32} 4_254_626_195)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___27 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___28 := l_words.item
					l_tmp___27.item := l_tmp___28
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___28) + {NATURAL_32} 2_792_965_006)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_tmp___29 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___30 := l_words.item
					l_tmp___29.item := l_tmp___30
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___30) + {NATURAL_32} 1_236_535_329)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[1]) + {NATURAL_32} 4_129_170_786)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[6]) + {NATURAL_32} 3_225_465_664)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[11]) + {NATURAL_32} 643_717_713)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[0]) + {NATURAL_32} 3_921_069_994)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[5]) + {NATURAL_32} 3_593_408_605)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[10]) + {NATURAL_32} 38_016_083)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[15]) + {NATURAL_32} 3_634_488_961)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[4]) + {NATURAL_32} 3_889_429_448)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[9]) + {NATURAL_32} 568_446_438)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[14]) + {NATURAL_32} 3_275_163_606)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[3]) + {NATURAL_32} 4_107_603_335)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[8]) + {NATURAL_32} 1_163_531_501)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[13]) + {NATURAL_32} 2_850_285_829)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[2]) + {NATURAL_32} 4_243_563_512)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[7]) + {NATURAL_32} 1_735_328_473)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[12]) + {NATURAL_32} 2_368_359_562)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[5]) + {NATURAL_32} 4_294_588_738)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[8]) + {NATURAL_32} 2_272_392_833)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[11]) + {NATURAL_32} 1_839_030_562)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[14]) + {NATURAL_32} 4_259_657_740)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[1]) + {NATURAL_32} 2_763_975_236)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[4]) + {NATURAL_32} 1_272_893_353)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[7]) + {NATURAL_32} 4_139_469_664)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[10]) + {NATURAL_32} 3_200_236_656)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[13]) + {NATURAL_32} 681_279_174)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[0]) + {NATURAL_32} 3_936_430_074)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[3]) + {NATURAL_32} 3_572_445_317)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[6]) + {NATURAL_32} 76_029_189)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[9]) + {NATURAL_32} 3_654_602_809)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[12]) + {NATURAL_32} 3_873_151_461)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[15]) + {NATURAL_32} 530_742_520)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[2]) + {NATURAL_32} 3_299_628_645)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[0]) + {NATURAL_32} 4_096_336_452)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[7]) + {NATURAL_32} 1_126_891_415)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[14]) + {NATURAL_32} 2_878_612_391)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[5]) + {NATURAL_32} 4_237_533_241)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[12]) + {NATURAL_32} 1_700_485_571)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[3]) + {NATURAL_32} 2_399_980_690)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[10]) + {NATURAL_32} 4_293_915_773)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[1]) + {NATURAL_32} 2_240_044_497)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[8]) + {NATURAL_32} 1_873_313_359)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[15]) + {NATURAL_32} 4_264_355_552)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[6]) + {NATURAL_32} 2_734_768_916)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[13]) + {NATURAL_32} 1_309_151_649)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[4]) + {NATURAL_32} 4_149_444_226)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[11]) + {NATURAL_32} 3_174_756_917)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[2]) + {NATURAL_32} 718_787_259)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[9]) + {NATURAL_32} 3_951_481_745)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					js.break
				end
				l_A := l_A + l_A_save
				l_B := l_B + l_B_save
				l_C := l_C + l_C_save
				l_D := l_D + l_D_save
			end
			a_ctx.item.A := l_A
			a_ctx.item.B := l_B
			a_ctx.item.C := l_C
			a_ctx.item.D := l_D
		end

	md5_process_bytes (a_buffer___0: CE_POINTER [ANY]; a_len: NATURAL_32; a_ctx: CE_POINTER [PD_MD5_CTX])
		local
			l_buffer___0: CE_POINTER [ANY]
			l_len: NATURAL_32
			l_left_over: NATURAL_32
			l_add: NATURAL_32
			l_tmp: NATURAL_32
			l_left_over___0: NATURAL_32
		do
			create l_buffer___0.make

			l_buffer___0 := a_buffer___0
			l_len := a_len
			if a_ctx.item.buflen /= {NATURAL_32} 0 then
				l_left_over := a_ctx.item.buflen
				if {NATURAL_32} 128 - l_left_over > l_len then
					l_tmp := l_len
				else
					l_tmp := {NATURAL_32} 128 - l_left_over
				end
				l_add := l_tmp
				memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast ((a_ctx.item.buffer)) + l_left_over.to_integer_32)), l_buffer___0, l_add).do_nothing
				a_ctx.item.buflen := a_ctx.item.buflen + l_add
				if a_ctx.item.buflen > {NATURAL_32} 64 then
					md5_process_block (create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer)), (a_ctx.item.buflen).bit_and ({NATURAL_32} 4_294_967_232), a_ctx)
					a_ctx.item.buflen := (a_ctx.item.buflen).bit_and (({NATURAL_32} 63))
					memcpy (create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast ((a_ctx.item.buffer)) + (((l_left_over + l_add)).bit_and ({NATURAL_32} 4_294_967_232)).to_integer_32)), a_ctx.item.buflen).do_nothing
				end
				l_buffer___0 := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer___0) + l_add.to_integer_32))
				l_len := l_len - l_add
			end
			if l_len >= {NATURAL_32} 64 then
				if (l_buffer___0.c_pointer.to_integer_32).to_natural_32 \\ ((create {CE_POINTER [NATURAL_32]}.make_shared ((create {CE_POINTER [PD_ANONYMOUS]}.make_shared (default_pointer)).c_pointer + (create {PD_ANONYMOUS}.make).offset_of ("x"))).c_pointer.to_integer_32).to_natural_32 /= {NATURAL_32} 0 then
					from
					until
						not (l_len > {NATURAL_32} 64)
					loop
						md5_process_block ((memcpy (create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer)), l_buffer___0, (64).to_natural_32)), (64).to_natural_32, a_ctx)
						l_buffer___0 := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer___0) + 64))
						l_len := l_len - ({NATURAL_32} 64)
					end
				else
					md5_process_block (l_buffer___0, (l_len).bit_and ({NATURAL_32} 4_294_967_232), a_ctx)
					l_buffer___0 := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer___0) + ((l_len).bit_and ({NATURAL_32} 4_294_967_232)).to_integer_32))
					l_len := (l_len).bit_and (({NATURAL_32} 63))
				end
			end
			if l_len > {NATURAL_32} 0 then
				l_left_over___0 := a_ctx.item.buflen
				memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast ((a_ctx.item.buffer)) + l_left_over___0.to_integer_32)), l_buffer___0, l_len).do_nothing
				l_left_over___0 := l_left_over___0 + l_len
				if l_left_over___0 >= {NATURAL_32} 64 then
					md5_process_block (create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer)), (64).to_natural_32, a_ctx)
					l_left_over___0 := l_left_over___0 - ({NATURAL_32} 64)
					memcpy (create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer)), create {CE_POINTER [ANY]}.make_cast ((a_ctx.item.buffer + 16)), l_left_over___0).do_nothing
				end
				a_ctx.item.buflen := l_left_over___0
			end
		end

	md5_read_ctx (a_ctx: CE_POINTER [PD_MD5_CTX]; a_resbuf: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_r: CE_POINTER [INTEGER_8]
		do
			create l_r.make

			l_r := create {CE_POINTER [INTEGER_8]}.make_cast (a_resbuf)
			set_uint32 (l_r + ({NATURAL_32} 0).to_integer_32, a_ctx.item.A)
			set_uint32 (l_r + ({PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, a_ctx.item.B)
			set_uint32 (l_r + ({NATURAL_32} 2 * {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, a_ctx.item.C)
			set_uint32 (l_r + ({NATURAL_32} 3 * {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, a_ctx.item.D)
			Result := a_resbuf
		end

	md5_stream (a_stream: CE_POINTER [SD_IO_FILE]; a_resblock: CE_POINTER [ANY]): INTEGER_32
		local
			l_ctx: CE_ARRAY [PD_MD5_CTX]
			l_buffer___0: CE_ARRAY [INTEGER_8]
			l_sum: NATURAL_32
			l_n: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ctx.make (<<1>>)
			create l_buffer___0.make (<<4_168>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					md5_init_ctx (l_ctx)
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_sum := (0).to_natural_32
				when 3 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 8 -- skip loop
						end
				when 4 then -- loop body:
						l_n := fread (create {CE_POINTER [ANY]}.make_cast ((l_buffer___0 + l_sum.to_integer_32)), (1).to_natural_32, {NATURAL_32} 4_096 - l_sum, a_stream)
						l_sum := l_sum + l_n
						if l_sum = {NATURAL_32} 4_096 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_n = {NATURAL_32} 0 then
							if (ferror (a_stream)).to_boolean then
								Result := 1
								js.return
							end
							if not js.return_called then
								l_pos := -1 + 10 -- goto process_partial_block
							end
						end
				when 6 then
						if not js.return_called then
							if (feof (a_stream)).to_boolean then
								l_pos := -1 + 10 -- goto process_partial_block
							end
						end
				when 7 then
						l_pos := -1 + 3 -- back to loop condition
				when 8 then -- loop done
						if not js.return_called then
							md5_process_block (create {CE_POINTER [ANY]}.make_cast (l_buffer___0), (4_096).to_natural_32, l_ctx)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 10 then -- if: | process_partial_block:
						if l_sum > {NATURAL_32} 0 then
							md5_process_bytes (create {CE_POINTER [ANY]}.make_cast (l_buffer___0), l_sum, l_ctx)
						end
						md5_finish_ctx (l_ctx, a_resblock).do_nothing
						Result := 0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_uint32 (a_cp: CE_POINTER [INTEGER_8]; a_v: NATURAL_32)
		local
			l_v: CE_ARRAY [NATURAL_32]
		do
			create l_v.make (<<1>>)

			l_v.item := a_v
			memcpy (create {CE_POINTER [ANY]}.make_cast (a_cp), create {CE_POINTER [ANY]}.make_cast (l_v), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
		end

end
