class
	P_NETRC

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create netrc_list.make
		end

feature {ANY} -- attributes

	netrc_list: CE_POINTER [PD_ACC_T] assign set_netrc_list

	set_netrc_list (a_netrc_list: CE_POINTER [PD_ACC_T])
		do
			netrc_list := a_netrc_list
		end

	processed_netrc: INTEGER_32 assign set_processed_netrc

	set_processed_netrc (a_processed_netrc: INTEGER_32)
		do
			processed_netrc := a_processed_netrc
		end

feature {ANY} -- routines

	free_netrc (a_l: CE_POINTER [PD_ACC_T])
		local
			l_l: CE_POINTER [PD_ACC_T]
			l_t: CE_POINTER [PD_ACC_T]
		do
			create l_l.make
			create l_t.make

			l_l := a_l
			from
			until
				l_l.is_void
			loop
				l_t := l_l.item.next
				if (not (l_l.item.acc).is_void) then
					free (create {CE_POINTER [ANY]}.make_cast (l_l.item.acc))
				end
				if (not (l_l.item.passwd).is_void) then
					free (create {CE_POINTER [ANY]}.make_cast (l_l.item.passwd))
				end
				if (not (l_l.item.host).is_void) then
					free (create {CE_POINTER [ANY]}.make_cast (l_l.item.host))
				end
				free (create {CE_POINTER [ANY]}.make_cast (l_l))
				l_l := l_t
			end
		end

	maybe_add_to_list (a_newentry: CE_POINTER [CE_POINTER [PD_ACC_T]]; a_list: CE_POINTER [CE_POINTER [PD_ACC_T]])
		local
			l_a: CE_POINTER [PD_ACC_T]
			l_l: CE_POINTER [PD_ACC_T]
			l_pos: INTEGER_32
		do
			create l_a.make
			create l_l.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_newentry.item
					l_l := a_list.item
					if l_a.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_a.item.acc).is_void then
							if (not (l_a.item.host).is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_a.item.host))
							end
							if (not (l_a.item.acc).is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_a.item.acc))
							end
							if (not (l_a.item.passwd).is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_a.item.passwd))
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (not l_a.is_void) then
							l_a.item.next := l_l
							l_l := l_a
						end
						l_a := create {CE_POINTER [PD_ACC_T]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_ACC_T}.make).structure_size.to_natural_32)))
				when 4 then
					memset (create {CE_POINTER [ANY]}.make_cast (l_a), 0, (create {PD_ACC_T}.make).structure_size.to_natural_32).do_nothing
					a_newentry.item := l_a
					a_list.item := l_l
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_netrc (a_path: CE_POINTER [INTEGER_8]): CE_POINTER [PD_ACC_T]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_line: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_premature_token: CE_POINTER [INTEGER_8]
			l_current: CE_ARRAY [CE_POINTER [PD_ACC_T]]
			l_retval: CE_ARRAY [CE_POINTER [PD_ACC_T]]
			l_ln: INTEGER_32
			l_qmark: INTEGER_32
			l_last_token: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_saved_reference: CE_POINTER [PD_ACC_T]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_line.make
			create l_p___0.make
			create l_tok.make
			create l_premature_token.make
			create l_current.make (<<1>>)
			create l_retval.make (<<1>>)
			create l_tmp___0.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_saved_reference.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_last_token := {PC_LAST_TOKEN}.tok_nothing
					l_retval.item := create {CE_POINTER [PD_ACC_T]}.make_shared (default_pointer)
					l_current.item := l_retval.item
					l_fp := fopen (a_path, ce_string ("r"))
					if l_fp.is_void then
						l_tmp___0 := strerror ((errno_location).item)
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Cannot read %%s (%%s).%N"))), wget_inst.exec_name, a_path, l_tmp___0]).do_nothing
						Result := (l_retval.item)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_ln := 0
						l_premature_token := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						l_line := utils_inst.read_whole_line (l_fp)
						if l_line.is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						l_ln := l_ln + 1
						l_p___0 := l_line
						l_qmark := 0
						from
						until
							js.loop_done
						loop
							if (l_p___0[0]).to_boolean then
								if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						if l_last_token = {NATURAL_32} 3 then
							if not (l_p___0[0]).to_boolean then
								l_last_token := {PC_LAST_TOKEN}.tok_nothing
							end
						end
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 16 -- skip loop
						end
				when 6 then -- loop body:
						if (l_p___0[0]).to_boolean then
							if l_last_token = {NATURAL_32} 3 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							from
							until
								js.loop_done
							loop
								if (l_p___0[0]).to_boolean then
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							if (l_p___0[0]).to_integer_32 = 35 then
								js.break
							elseif not (l_p___0[0]).to_boolean then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[0]).to_integer_32 = 34 then
							l_qmark := 1
							shift_left (l_p___0)
						end
						l_tok := l_p___0
						from
						until
							js.loop_done
						loop
							if (l_p___0[0]).to_boolean then
								if l_qmark.to_boolean then
									l_tmp___6 := ((l_p___0[0]).to_integer_32 /= 34).to_integer
								else
									if (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_tmp___5 := 0
									else
										l_tmp___5 := 1
									end
									l_tmp___6 := l_tmp___5
								end
								if not l_tmp___6.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_p___0[0]).to_integer_32 = 92 then
									shift_left (l_p___0)
								end
								l_p___0 := l_p___0 + 1
							end
						end
						if l_qmark.to_boolean then
							shift_left (l_p___0)
							l_qmark := 0
						end
						if (l_p___0[0]).to_boolean then
							l_tmp___7 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___7[0] := (('%/0/').code).to_integer_8
						end
						inspect l_last_token.to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						when 5 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						when 0 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 8 then -- switch 1, case 2
						if (not (l_current.item).is_void) then
							l_current.item.item.acc := xmalloc_inst.xstrdup (l_tok)
						else
							l_premature_token := ce_string ("login")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 9 then -- switch 1, case 4
						maybe_add_to_list (l_current, l_retval)
						l_current.item.item.host := xmalloc_inst.xstrdup (l_tok)
						l_pos := -1 + 14 -- switch 1; break
				when 10 then -- switch 1, case 5
						if (not (l_current.item).is_void) then
							l_current.item.item.passwd := xmalloc_inst.xstrdup (l_tok)
						else
							l_premature_token := ce_string ("password")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 11 then -- switch 1, case 3
						if (l_current.item).is_void then
							l_premature_token := ce_string ("macdef")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 1
						if (l_current.item).is_void then
							l_premature_token := ce_string ("account")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, case 0
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done:
						if (not l_premature_token.is_void) then
							l_tmp___8 := quote_inst.quote (l_premature_token)
							fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s:%%d: warning: %%s token appears before any machine name%N"))), wget_inst.exec_name, a_path, l_ln, l_tmp___8]).do_nothing
							l_premature_token := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						if l_last_token /= {NATURAL_32} 0 then
							l_last_token := {PC_LAST_TOKEN}.tok_nothing
						elseif (strcmp (l_tok, ce_string ("account"))).to_boolean then
							if (strcmp (l_tok, ce_string ("default"))).to_boolean then
								if (strcmp (l_tok, ce_string ("login"))).to_boolean then
									if (strcmp (l_tok, ce_string ("macdef"))).to_boolean then
										if (strcmp (l_tok, ce_string ("machine"))).to_boolean then
											if (strcmp (l_tok, ce_string ("password"))).to_boolean then
												fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s:%%d: unknown token %"%%s%"%N"))), wget_inst.exec_name, a_path, l_ln, l_tok]).do_nothing
											else
												l_last_token := {PC_LAST_TOKEN}.tok_password
											end
										else
											l_last_token := {PC_LAST_TOKEN}.tok_machine
										end
									else
										l_last_token := {PC_LAST_TOKEN}.tok_macdef
									end
								else
									l_last_token := {PC_LAST_TOKEN}.tok_login
								end
							else
								maybe_add_to_list (l_current, l_retval)
							end
						else
							l_last_token := {PC_LAST_TOKEN}.tok_account
						end
				when 15 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 16 then -- loop done
						free (create {CE_POINTER [ANY]}.make_cast (l_line))
				when 17 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						fclose (l_fp).do_nothing
						maybe_add_to_list (l_current, l_retval)
						free (create {CE_POINTER [ANY]}.make_cast (l_current.item))
						l_current.item := l_retval.item
						l_retval.item := create {CE_POINTER [PD_ACC_T]}.make_shared (default_pointer)
						from
						until
							(l_current.item).is_void
						loop
							l_saved_reference := l_current.item.item.next
							l_current.item.item.next := l_retval.item
							l_retval.item := l_current.item
							l_current.item := l_saved_reference
						end
						Result := (l_retval.item)
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	search_netrc (a_host: CE_POINTER [INTEGER_8]; a_acc: CE_POINTER [CE_POINTER [INTEGER_8]]; a_passwd: CE_POINTER [CE_POINTER [INTEGER_8]]; a_slack_default: INTEGER_32)
		local
			l_l: CE_POINTER [PD_ACC_T]
			l_home___0: CE_POINTER [INTEGER_8]
			l_err: INTEGER_32
			l_buf___6: CE_ARRAY [SD_STAT]
			l_path: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_l.make
			create l_home___0.make
			create l_buf___6.make (<<1>>)
			create l_path.make

			if not options_inst.opt.item.netrc then
				js.return
			end
			if not js.return_called then
				if not processed_netrc.to_boolean then
					l_home___0 := (init_inst.home_dir)
					netrc_list := create {CE_POINTER [PD_ACC_T]}.make_shared (default_pointer)
					processed_netrc := 1
					if (not l_home___0.is_void) then
						l_tmp___0 := strlen (l_home___0)
						l_path := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (((l_tmp___0 + {NATURAL_32} 1) + (strlen (ce_string (".netrc")))) + {NATURAL_32} 1)))
						sprintf ([l_path, ce_string ("%%s/%%s"), l_home___0, ce_string (".netrc")]).do_nothing
						free (create {CE_POINTER [ANY]}.make_cast (l_home___0))
						l_err := stat (l_path, l_buf___6)
						if l_err = 0 then
							netrc_list := parse_netrc (l_path)
						end
					end
				end
				if netrc_list.is_void then
					js.return
				end
			end
			if not js.return_called and then (not (a_acc.item).is_void) then
				if (not (a_passwd.item).is_void) then
					js.return
				end
			end
			if not js.return_called then
				l_l := netrc_list
				from
				until
					not (not js.loop_done and then (not l_l.is_void))
				loop
					if (not (l_l.item.host).is_void) then
						if not (strcasecmp (l_l.item.host, a_host)).to_boolean then
							js.break
						end
					end
					if js.loop_increment then
						l_l := l_l.item.next
					end
				end
				if (not l_l.is_void) then
					if (not (a_acc.item).is_void) then
						if (strcmp (l_l.item.acc, a_acc.item)).to_boolean then
							a_passwd.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						else
							a_passwd.item := l_l.item.passwd
						end
					else
						a_acc.item := l_l.item.acc
						if (not (l_l.item.passwd).is_void) then
							a_passwd.item := l_l.item.passwd
						end
					end
				else
					if not a_slack_default.to_boolean then
						js.return
					end
					if not js.return_called and then (not (a_acc.item).is_void) then
						js.return
					end
					if not js.return_called then
						l_l := netrc_list
						from
						until
							not (not js.loop_done and then (not l_l.is_void))
						loop
							if (l_l.item.host).is_void then
								js.break
							end
							if not js.loop_jumped then
								l_l := l_l.item.next
							end
						end
						if l_l.is_void then
							js.return
						end
					end
					if not js.return_called then
						a_acc.item := l_l.item.acc
						if (a_passwd.item).is_void then
							a_passwd.item := l_l.item.passwd
						end
					end
				end
			end
		end

	shift_left (a_string: CE_POINTER [INTEGER_8])
		local
			l_p___0: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make

			l_p___0 := a_string
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				l_p___0[0] := l_p___0[1]
				l_p___0 := l_p___0 + 1
			end
		end

end
