class
	PD_C2_DOMAIN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create domain.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_C2_DOMAIN] assign set_next

	prev: CE_POINTER [PD_C2_DOMAIN] assign set_prev

	domain: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_C2_DOMAIN])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_C2_DOMAIN])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			domain := a_other.domain.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				domain.is_equal (a_other.domain)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("domain", <<1>>)
				>>)
			init_structure_info
		end

end
