class
	PD_CACHE_ENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create url.make
			create head.make
			create redirect.make
			create last_modified.make
			create frag.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CACHE_ENTRY] assign set_next

	prev: CE_POINTER [PD_CACHE_ENTRY] assign set_prev

	url: CE_POINTER [NATURAL_8] assign set_url

	head: CE_POINTER [NATURAL_8] assign set_head

	redirect: CE_POINTER [NATURAL_8] assign set_redirect

	redirect_get: INTEGER_32 assign set_redirect_get

	length: INTEGER_32 assign set_length

	incomplete: INTEGER_32 assign set_incomplete

	tgc: INTEGER_32 assign set_tgc

	last_modified: CE_POINTER [NATURAL_8] assign set_last_modified

	data_size: INTEGER_32 assign set_data_size

	frag: PD_LIST_HEAD assign set_frag

	count: NATURAL_32 assign set_count

	refcount: INTEGER_32 assign set_refcount

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_CACHE_ENTRY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CACHE_ENTRY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_head (a_head: CE_POINTER [NATURAL_8])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_redirect (a_redirect: CE_POINTER [NATURAL_8])
		do
			redirect := a_redirect
			update_memory_field ("redirect")
		end

	set_redirect_get (a_redirect_get: INTEGER_32)
		do
			redirect_get := a_redirect_get
			update_memory_field ("redirect_get")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_incomplete (a_incomplete: INTEGER_32)
		do
			incomplete := a_incomplete
			update_memory_field ("incomplete")
		end

	set_tgc (a_tgc: INTEGER_32)
		do
			tgc := a_tgc
			update_memory_field ("tgc")
		end

	set_last_modified (a_last_modified: CE_POINTER [NATURAL_8])
		do
			last_modified := a_last_modified
			update_memory_field ("last_modified")
		end

	set_data_size (a_data_size: INTEGER_32)
		do
			data_size := a_data_size
			update_memory_field ("data_size")
		end

	set_frag (a_frag: PD_LIST_HEAD)
		do
			frag := a_frag
			update_memory_field ("frag")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			refcount := a_refcount
			update_memory_field ("refcount")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			url := a_other.url
			head := a_other.head
			redirect := a_other.redirect
			redirect_get := a_other.redirect_get
			length := a_other.length
			incomplete := a_other.incomplete
			tgc := a_other.tgc
			last_modified := a_other.last_modified
			data_size := a_other.data_size
			frag := a_other.frag.twin
			count := a_other.count
			refcount := a_other.refcount
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				url.is_equal (a_other.url) and
				head.is_equal (a_other.head) and
				redirect.is_equal (a_other.redirect) and
				redirect_get = a_other.redirect_get and
				length = a_other.length and
				incomplete = a_other.incomplete and
				tgc = a_other.tgc and
				last_modified.is_equal (a_other.last_modified) and
				data_size = a_other.data_size and
				frag.is_equal (a_other.frag) and
				count = a_other.count and
				refcount = a_other.refcount
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("redirect"),
					create {CE_STRUCTURE_FIELD}.make ("redirect_get"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("incomplete"),
					create {CE_STRUCTURE_FIELD}.make ("tgc"),
					create {CE_STRUCTURE_FIELD}.make ("last_modified"),
					create {CE_STRUCTURE_FIELD}.make ("data_size"),
					create {CE_STRUCTURE_FIELD}.make ("frag"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("refcount")
				>>)
			init_structure_info
		end

end
