class
	PD_CONN_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create func.make
			create sa.make
			create sock.make
		end

feature {ANY} -- fields

	func: CE_ROUTINE assign set_func

	sa: SD_SOCKADDR_IN assign set_sa

	addr: NATURAL_32 assign set_addr

	port: INTEGER_32 assign set_port

	sock: CE_POINTER [INTEGER_32] assign set_sock

feature {ANY} -- setters

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

	set_sa (a_sa: SD_SOCKADDR_IN)
		do
			sa := a_sa
			update_memory_field ("sa")
		end

	set_addr (a_addr: NATURAL_32)
		do
			addr := a_addr
			update_memory_field ("addr")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_sock (a_sock: CE_POINTER [INTEGER_32])
		do
			sock := a_sock
			update_memory_field ("sock")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			func := a_other.func
			sa := a_other.sa.twin
			addr := a_other.addr
			port := a_other.port
			sock := a_other.sock
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				func.is_equal (a_other.func) and
				sa.is_equal (a_other.sa) and
				addr = a_other.addr and
				port = a_other.port and
				sock.is_equal (a_other.sock)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("sa"),
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("sock")
				>>)
			init_structure_info
		end

end
