class
	PD_CONNECTION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create url.make
			create pri.make (<<6>>)
			create dnsquery.make
			create statuss.make
			create info.make
			create buffer.make
			create conn_func.make
			create cache.make
			create prg.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CONNECTION] assign set_next

	prev: CE_POINTER [PD_CONNECTION] assign set_prev

	count: NATURAL_32 assign set_count

	url: CE_POINTER [NATURAL_8] assign set_url

	running: INTEGER_32 assign set_running

	state: INTEGER_32 assign set_state

	prev_error: INTEGER_32 assign set_prev_error

	from2: INTEGER_32 assign set_from2

	pri: CE_ARRAY [INTEGER_32]

	no_cache: INTEGER_32 assign set_no_cache

	sock1: INTEGER_32 assign set_sock1

	sock2: INTEGER_32 assign set_sock2

	dnsquery: CE_POINTER [ANY] assign set_dnsquery

	pid: INTEGER_32 assign set_pid

	tries: INTEGER_32 assign set_tries

	statuss: PD_LIST_HEAD assign set_statuss

	info: CE_POINTER [ANY] assign set_info

	buffer: CE_POINTER [ANY] assign set_buffer

	conn_func: CE_ROUTINE assign set_conn_func

	cache: CE_POINTER [PD_CACHE_ENTRY] assign set_cache

	received: INTEGER_32 assign set_received

	est_length: INTEGER_32 assign set_est_length

	unrestartable: INTEGER_32 assign set_unrestartable

	prg: PD_REMAINING_INFO assign set_prg

	timer: INTEGER_32 assign set_timer

	detached: INTEGER_32 assign set_detached

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_CONNECTION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CONNECTION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_running (a_running: INTEGER_32)
		do
			running := a_running
			update_memory_field ("running")
		end

	set_state (a_state: INTEGER_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_prev_error (a_prev_error: INTEGER_32)
		do
			prev_error := a_prev_error
			update_memory_field ("prev_error")
		end

	set_from2 (a_from2: INTEGER_32)
		do
			from2 := a_from2
			update_memory_field ("from2")
		end

	set_no_cache (a_no_cache: INTEGER_32)
		do
			no_cache := a_no_cache
			update_memory_field ("no_cache")
		end

	set_sock1 (a_sock1: INTEGER_32)
		do
			sock1 := a_sock1
			update_memory_field ("sock1")
		end

	set_sock2 (a_sock2: INTEGER_32)
		do
			sock2 := a_sock2
			update_memory_field ("sock2")
		end

	set_dnsquery (a_dnsquery: CE_POINTER [ANY])
		do
			dnsquery := a_dnsquery
			update_memory_field ("dnsquery")
		end

	set_pid (a_pid: INTEGER_32)
		do
			pid := a_pid
			update_memory_field ("pid")
		end

	set_tries (a_tries: INTEGER_32)
		do
			tries := a_tries
			update_memory_field ("tries")
		end

	set_statuss (a_statuss: PD_LIST_HEAD)
		do
			statuss := a_statuss
			update_memory_field ("statuss")
		end

	set_info (a_info: CE_POINTER [ANY])
		do
			info := a_info
			update_memory_field ("info")
		end

	set_buffer (a_buffer: CE_POINTER [ANY])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_conn_func (a_conn_func: CE_ROUTINE)
		do
			conn_func := a_conn_func
			update_memory_field ("conn_func")
		end

	set_cache (a_cache: CE_POINTER [PD_CACHE_ENTRY])
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_received (a_received: INTEGER_32)
		do
			received := a_received
			update_memory_field ("received")
		end

	set_est_length (a_est_length: INTEGER_32)
		do
			est_length := a_est_length
			update_memory_field ("est_length")
		end

	set_unrestartable (a_unrestartable: INTEGER_32)
		do
			unrestartable := a_unrestartable
			update_memory_field ("unrestartable")
		end

	set_prg (a_prg: PD_REMAINING_INFO)
		do
			prg := a_prg
			update_memory_field ("prg")
		end

	set_timer (a_timer: INTEGER_32)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

	set_detached (a_detached: INTEGER_32)
		do
			detached := a_detached
			update_memory_field ("detached")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			count := a_other.count
			url := a_other.url
			running := a_other.running
			state := a_other.state
			prev_error := a_other.prev_error
			from2 := a_other.from2
			pri := a_other.pri.twin
			no_cache := a_other.no_cache
			sock1 := a_other.sock1
			sock2 := a_other.sock2
			dnsquery := a_other.dnsquery
			pid := a_other.pid
			tries := a_other.tries
			statuss := a_other.statuss.twin
			info := a_other.info
			buffer := a_other.buffer
			conn_func := a_other.conn_func
			cache := a_other.cache
			received := a_other.received
			est_length := a_other.est_length
			unrestartable := a_other.unrestartable
			prg := a_other.prg.twin
			timer := a_other.timer
			detached := a_other.detached
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				count = a_other.count and
				url.is_equal (a_other.url) and
				running = a_other.running and
				state = a_other.state and
				prev_error = a_other.prev_error and
				from2 = a_other.from2 and
				pri.is_equal (a_other.pri) and
				no_cache = a_other.no_cache and
				sock1 = a_other.sock1 and
				sock2 = a_other.sock2 and
				dnsquery.is_equal (a_other.dnsquery) and
				pid = a_other.pid and
				tries = a_other.tries and
				statuss.is_equal (a_other.statuss) and
				info.is_equal (a_other.info) and
				buffer.is_equal (a_other.buffer) and
				conn_func.is_equal (a_other.conn_func) and
				cache.is_equal (a_other.cache) and
				received = a_other.received and
				est_length = a_other.est_length and
				unrestartable = a_other.unrestartable and
				prg.is_equal (a_other.prg) and
				timer = a_other.timer and
				detached = a_other.detached
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("running"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("prev_error"),
					create {CE_STRUCTURE_FIELD}.make ("from2"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pri", <<6>>),
					create {CE_STRUCTURE_FIELD}.make ("no_cache"),
					create {CE_STRUCTURE_FIELD}.make ("sock1"),
					create {CE_STRUCTURE_FIELD}.make ("sock2"),
					create {CE_STRUCTURE_FIELD}.make ("dnsquery"),
					create {CE_STRUCTURE_FIELD}.make ("pid"),
					create {CE_STRUCTURE_FIELD}.make ("tries"),
					create {CE_STRUCTURE_FIELD}.make ("statuss"),
					create {CE_STRUCTURE_FIELD}.make ("info"),
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("conn_func"),
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("received"),
					create {CE_STRUCTURE_FIELD}.make ("est_length"),
					create {CE_STRUCTURE_FIELD}.make ("unrestartable"),
					create {CE_STRUCTURE_FIELD}.make ("prg"),
					create {CE_STRUCTURE_FIELD}.make ("timer"),
					create {CE_STRUCTURE_FIELD}.make ("detached")
				>>)
			init_structure_info
		end

end
