class
	PD_DIALOG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create title.make
			create fn.make
			create handle_event.make
			create abort.make
			create udata.make
			create udata2.make
			create refresh.make
			create refresh_data.make
			create items.make (<<1>>)
		end

feature {ANY} -- fields

	title: CE_POINTER [NATURAL_8] assign set_title

	fn: CE_ROUTINE assign set_fn

	handle_event: CE_ROUTINE assign set_handle_event

	abort: CE_ROUTINE assign set_abort

	udata: CE_POINTER [ANY] assign set_udata

	udata2: CE_POINTER [ANY] assign set_udata2

	align: INTEGER_32 assign set_align

	refresh: CE_ROUTINE assign set_refresh

	refresh_data: CE_POINTER [ANY] assign set_refresh_data

	items: CE_ARRAY [PD_DIALOG_ITEM]

feature {ANY} -- setters

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			title := a_title
			update_memory_field ("title")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_handle_event (a_handle_event: CE_ROUTINE)
		do
			handle_event := a_handle_event
			update_memory_field ("handle_event")
		end

	set_abort (a_abort: CE_ROUTINE)
		do
			abort := a_abort
			update_memory_field ("abort")
		end

	set_udata (a_udata: CE_POINTER [ANY])
		do
			udata := a_udata
			update_memory_field ("udata")
		end

	set_udata2 (a_udata2: CE_POINTER [ANY])
		do
			udata2 := a_udata2
			update_memory_field ("udata2")
		end

	set_align (a_align: INTEGER_32)
		do
			align := a_align
			update_memory_field ("align")
		end

	set_refresh (a_refresh: CE_ROUTINE)
		do
			refresh := a_refresh
			update_memory_field ("refresh")
		end

	set_refresh_data (a_refresh_data: CE_POINTER [ANY])
		do
			refresh_data := a_refresh_data
			update_memory_field ("refresh_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			title := a_other.title
			fn := a_other.fn
			handle_event := a_other.handle_event
			abort := a_other.abort
			udata := a_other.udata
			udata2 := a_other.udata2
			align := a_other.align
			refresh := a_other.refresh
			refresh_data := a_other.refresh_data
			items := a_other.items.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				title.is_equal (a_other.title) and
				fn.is_equal (a_other.fn) and
				handle_event.is_equal (a_other.handle_event) and
				abort.is_equal (a_other.abort) and
				udata.is_equal (a_other.udata) and
				udata2.is_equal (a_other.udata2) and
				align = a_other.align and
				refresh.is_equal (a_other.refresh) and
				refresh_data.is_equal (a_other.refresh_data) and
				items.is_equal (a_other.items)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("title"),
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("handle_event"),
					create {CE_STRUCTURE_FIELD}.make ("abort"),
					create {CE_STRUCTURE_FIELD}.make ("udata"),
					create {CE_STRUCTURE_FIELD}.make ("udata2"),
					create {CE_STRUCTURE_FIELD}.make ("align"),
					create {CE_STRUCTURE_FIELD}.make ("refresh"),
					create {CE_STRUCTURE_FIELD}.make ("refresh_data"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("items", <<1>>)
				>>)
			init_structure_info
		end

end
