class
	PD_DIALOG_ITEM_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create item.make
			create history.make
			create cur_hist.make
			create cdata.make
		end

feature {ANY} -- fields

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	l: INTEGER_32 assign set_l

	vpos: INTEGER_32 assign set_vpos

	cpos: INTEGER_32 assign set_cpos

	checked: INTEGER_32 assign set_checked

	item: CE_POINTER [PD_DIALOG_ITEM] assign set_item

	history: PD_LIST_HEAD assign set_history

	cur_hist: CE_POINTER [PD_HISTORY_ITEM] assign set_cur_hist

	cdata: CE_POINTER [NATURAL_8] assign set_cdata

feature {ANY} -- setters

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_l (a_l: INTEGER_32)
		do
			l := a_l
			update_memory_field ("l")
		end

	set_vpos (a_vpos: INTEGER_32)
		do
			vpos := a_vpos
			update_memory_field ("vpos")
		end

	set_cpos (a_cpos: INTEGER_32)
		do
			cpos := a_cpos
			update_memory_field ("cpos")
		end

	set_checked (a_checked: INTEGER_32)
		do
			checked := a_checked
			update_memory_field ("checked")
		end

	set_item (a_item: CE_POINTER [PD_DIALOG_ITEM])
		do
			item := a_item
			update_memory_field ("item")
		end

	set_history (a_history: PD_LIST_HEAD)
		do
			history := a_history
			update_memory_field ("history")
		end

	set_cur_hist (a_cur_hist: CE_POINTER [PD_HISTORY_ITEM])
		do
			cur_hist := a_cur_hist
			update_memory_field ("cur_hist")
		end

	set_cdata (a_cdata: CE_POINTER [NATURAL_8])
		do
			cdata := a_cdata
			update_memory_field ("cdata")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
			l := a_other.l
			vpos := a_other.vpos
			cpos := a_other.cpos
			checked := a_other.checked
			item := a_other.item
			history := a_other.history.twin
			cur_hist := a_other.cur_hist
			cdata := a_other.cdata
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y and
				l = a_other.l and
				vpos = a_other.vpos and
				cpos = a_other.cpos and
				checked = a_other.checked and
				item.is_equal (a_other.item) and
				history.is_equal (a_other.history) and
				cur_hist.is_equal (a_other.cur_hist) and
				cdata.is_equal (a_other.cdata)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("l"),
					create {CE_STRUCTURE_FIELD}.make ("vpos"),
					create {CE_STRUCTURE_FIELD}.make ("cpos"),
					create {CE_STRUCTURE_FIELD}.make ("checked"),
					create {CE_STRUCTURE_FIELD}.make ("item"),
					create {CE_STRUCTURE_FIELD}.make ("history"),
					create {CE_STRUCTURE_FIELD}.make ("cur_hist"),
					create {CE_STRUCTURE_FIELD}.make ("cdata")
				>>)
			init_structure_info
		end

end
