class
	PD_DNSQUERY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fn.make
			create data.make
			create xfn.make
			create s.make
			create addr.make
			create name.make (<<1>>)
		end

feature {ANY} -- fields

	fn: CE_ROUTINE assign set_fn

	data: CE_POINTER [ANY] assign set_data

	xfn: CE_ROUTINE assign set_xfn

	h: INTEGER_32 assign set_h

	s: CE_POINTER [CE_POINTER [PD_DNSQUERY]] assign set_s

	addr: CE_POINTER [NATURAL_32] assign set_addr

	name: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_xfn (a_xfn: CE_ROUTINE)
		do
			xfn := a_xfn
			update_memory_field ("xfn")
		end

	set_h (a_h: INTEGER_32)
		do
			h := a_h
			update_memory_field ("h")
		end

	set_s (a_s: CE_POINTER [CE_POINTER [PD_DNSQUERY]])
		do
			s := a_s
			update_memory_field ("s")
		end

	set_addr (a_addr: CE_POINTER [NATURAL_32])
		do
			addr := a_addr
			update_memory_field ("addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fn := a_other.fn
			data := a_other.data
			xfn := a_other.xfn
			h := a_other.h
			s := a_other.s
			addr := a_other.addr
			name := a_other.name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fn.is_equal (a_other.fn) and
				data.is_equal (a_other.data) and
				xfn.is_equal (a_other.xfn) and
				h = a_other.h and
				s.is_equal (a_other.s) and
				addr.is_equal (a_other.addr) and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("xfn"),
					create {CE_STRUCTURE_FIELD}.make ("h"),
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<1>>)
				>>)
			init_structure_info
		end

end
