class
	PD_DOCUMENT_SETUP

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	assume_cp: INTEGER_32 assign set_assume_cp

	hard_assume: INTEGER_32 assign set_hard_assume

	tables: INTEGER_32 assign set_tables

	frames: INTEGER_32 assign set_frames

	images: INTEGER_32 assign set_images

	margin: INTEGER_32 assign set_margin

	num_links: INTEGER_32 assign set_num_links

	table_order: INTEGER_32 assign set_table_order

feature {ANY} -- setters

	set_assume_cp (a_assume_cp: INTEGER_32)
		do
			assume_cp := a_assume_cp
			update_memory_field ("assume_cp")
		end

	set_hard_assume (a_hard_assume: INTEGER_32)
		do
			hard_assume := a_hard_assume
			update_memory_field ("hard_assume")
		end

	set_tables (a_tables: INTEGER_32)
		do
			tables := a_tables
			update_memory_field ("tables")
		end

	set_frames (a_frames: INTEGER_32)
		do
			frames := a_frames
			update_memory_field ("frames")
		end

	set_images (a_images: INTEGER_32)
		do
			images := a_images
			update_memory_field ("images")
		end

	set_margin (a_margin: INTEGER_32)
		do
			margin := a_margin
			update_memory_field ("margin")
		end

	set_num_links (a_num_links: INTEGER_32)
		do
			num_links := a_num_links
			update_memory_field ("num_links")
		end

	set_table_order (a_table_order: INTEGER_32)
		do
			table_order := a_table_order
			update_memory_field ("table_order")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			assume_cp := a_other.assume_cp
			hard_assume := a_other.hard_assume
			tables := a_other.tables
			frames := a_other.frames
			images := a_other.images
			margin := a_other.margin
			num_links := a_other.num_links
			table_order := a_other.table_order
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				assume_cp = a_other.assume_cp and
				hard_assume = a_other.hard_assume and
				tables = a_other.tables and
				frames = a_other.frames and
				images = a_other.images and
				margin = a_other.margin and
				num_links = a_other.num_links and
				table_order = a_other.table_order
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("assume_cp"),
					create {CE_STRUCTURE_FIELD}.make ("hard_assume"),
					create {CE_STRUCTURE_FIELD}.make ("tables"),
					create {CE_STRUCTURE_FIELD}.make ("frames"),
					create {CE_STRUCTURE_FIELD}.make ("images"),
					create {CE_STRUCTURE_FIELD}.make ("margin"),
					create {CE_STRUCTURE_FIELD}.make ("num_links"),
					create {CE_STRUCTURE_FIELD}.make ("table_order")
				>>)
			init_structure_info
		end

end
