class
	PD_ELEMENT_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create func.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	func: CE_ROUTINE assign set_func

	linebreak: INTEGER_32 assign set_linebreak

	nopair: INTEGER_32 assign set_nopair

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

	set_linebreak (a_linebreak: INTEGER_32)
		do
			linebreak := a_linebreak
			update_memory_field ("linebreak")
		end

	set_nopair (a_nopair: INTEGER_32)
		do
			nopair := a_nopair
			update_memory_field ("nopair")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			func := a_other.func
			linebreak := a_other.linebreak
			nopair := a_other.nopair
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				func.is_equal (a_other.func) and
				linebreak = a_other.linebreak and
				nopair = a_other.nopair
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("linebreak"),
					create {CE_STRUCTURE_FIELD}.make ("nopair")
				>>)
			init_structure_info
		end

end
