class
	PD_EXTENSION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create ext.make
			create ct.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_EXTENSION] assign set_next

	prev: CE_POINTER [PD_EXTENSION] assign set_prev

	cnt: NATURAL_32 assign set_cnt

	ext: CE_POINTER [NATURAL_8] assign set_ext

	ct: CE_POINTER [NATURAL_8] assign set_ct

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_EXTENSION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_EXTENSION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_cnt (a_cnt: NATURAL_32)
		do
			cnt := a_cnt
			update_memory_field ("cnt")
		end

	set_ext (a_ext: CE_POINTER [NATURAL_8])
		do
			ext := a_ext
			update_memory_field ("ext")
		end

	set_ct (a_ct: CE_POINTER [NATURAL_8])
		do
			ct := a_ct
			update_memory_field ("ct")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			cnt := a_other.cnt
			ext := a_other.ext
			ct := a_other.ct
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				cnt = a_other.cnt and
				ext.is_equal (a_other.ext) and
				ct.is_equal (a_other.ct)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("cnt"),
					create {CE_STRUCTURE_FIELD}.make ("ext"),
					create {CE_STRUCTURE_FIELD}.make ("ct")
				>>)
			init_structure_info
		end

end
