class
	PD_F_DATA_C

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create name.make
			create f_data.make
			create link_bg.make
			create search_word.make
			create vs.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_F_DATA_C] assign set_next

	prev: CE_POINTER [PD_F_DATA_C] assign set_prev

	used: INTEGER_32 assign set_used

	name: CE_POINTER [NATURAL_8] assign set_name

	f_data: CE_POINTER [PD_F_DATA] assign set_f_data

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	xl: INTEGER_32 assign set_xl

	yl: INTEGER_32 assign set_yl

	link_bg: CE_POINTER [PD_LINK_BG] assign set_link_bg

	link_bg_n: INTEGER_32 assign set_link_bg_n

	search_word: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_search_word

	vs: CE_POINTER [PD_VIEW_STATE] assign set_vs

	depth: INTEGER_32 assign set_depth

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_F_DATA_C])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_F_DATA_C])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_used (a_used: INTEGER_32)
		do
			used := a_used
			update_memory_field ("used")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_f_data (a_f_data: CE_POINTER [PD_F_DATA])
		do
			f_data := a_f_data
			update_memory_field ("f_data")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_xl (a_xl: INTEGER_32)
		do
			xl := a_xl
			update_memory_field ("xl")
		end

	set_yl (a_yl: INTEGER_32)
		do
			yl := a_yl
			update_memory_field ("yl")
		end

	set_link_bg (a_link_bg: CE_POINTER [PD_LINK_BG])
		do
			link_bg := a_link_bg
			update_memory_field ("link_bg")
		end

	set_link_bg_n (a_link_bg_n: INTEGER_32)
		do
			link_bg_n := a_link_bg_n
			update_memory_field ("link_bg_n")
		end

	set_search_word (a_search_word: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			search_word := a_search_word
			update_memory_field ("search_word")
		end

	set_vs (a_vs: CE_POINTER [PD_VIEW_STATE])
		do
			vs := a_vs
			update_memory_field ("vs")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			used := a_other.used
			name := a_other.name
			f_data := a_other.f_data
			xw := a_other.xw
			yw := a_other.yw
			xp := a_other.xp
			yp := a_other.yp
			xl := a_other.xl
			yl := a_other.yl
			link_bg := a_other.link_bg
			link_bg_n := a_other.link_bg_n
			search_word := a_other.search_word
			vs := a_other.vs
			depth := a_other.depth
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				used = a_other.used and
				name.is_equal (a_other.name) and
				f_data.is_equal (a_other.f_data) and
				xw = a_other.xw and
				yw = a_other.yw and
				xp = a_other.xp and
				yp = a_other.yp and
				xl = a_other.xl and
				yl = a_other.yl and
				link_bg.is_equal (a_other.link_bg) and
				link_bg_n = a_other.link_bg_n and
				search_word.is_equal (a_other.search_word) and
				vs.is_equal (a_other.vs) and
				depth = a_other.depth
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("used"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("f_data"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("xl"),
					create {CE_STRUCTURE_FIELD}.make ("yl"),
					create {CE_STRUCTURE_FIELD}.make ("link_bg"),
					create {CE_STRUCTURE_FIELD}.make ("link_bg_n"),
					create {CE_STRUCTURE_FIELD}.make ("search_word"),
					create {CE_STRUCTURE_FIELD}.make ("vs"),
					create {CE_STRUCTURE_FIELD}.make ("depth")
				>>)
			init_structure_info
		end

end
