class
	PD_FILE_TO_LOAD

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create ses.make
			create ce.make
			create url.make
			create stat.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_FILE_TO_LOAD] assign set_next

	prev: CE_POINTER [PD_FILE_TO_LOAD] assign set_prev

	ses: CE_POINTER [PD_SESSION] assign set_ses

	req_sent: INTEGER_32 assign set_req_sent

	pri: INTEGER_32 assign set_pri

	ce: CE_POINTER [PD_CACHE_ENTRY] assign set_ce

	url: CE_POINTER [NATURAL_8] assign set_url

	stat: PD_STATUS assign set_stat

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_FILE_TO_LOAD])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_FILE_TO_LOAD])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			ses := a_ses
			update_memory_field ("ses")
		end

	set_req_sent (a_req_sent: INTEGER_32)
		do
			req_sent := a_req_sent
			update_memory_field ("req_sent")
		end

	set_pri (a_pri: INTEGER_32)
		do
			pri := a_pri
			update_memory_field ("pri")
		end

	set_ce (a_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			ce := a_ce
			update_memory_field ("ce")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat := a_stat
			update_memory_field ("stat")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			ses := a_other.ses
			req_sent := a_other.req_sent
			pri := a_other.pri
			ce := a_other.ce
			url := a_other.url
			stat := a_other.stat.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				ses.is_equal (a_other.ses) and
				req_sent = a_other.req_sent and
				pri = a_other.pri and
				ce.is_equal (a_other.ce) and
				url.is_equal (a_other.url) and
				stat.is_equal (a_other.stat)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("ses"),
					create {CE_STRUCTURE_FIELD}.make ("req_sent"),
					create {CE_STRUCTURE_FIELD}.make ("pri"),
					create {CE_STRUCTURE_FIELD}.make ("ce"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("stat")
				>>)
			init_structure_info
		end

end
