class
	PD_FRAGMENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create data.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_FRAGMENT] assign set_next

	prev: CE_POINTER [PD_FRAGMENT] assign set_prev

	offset: INTEGER_32 assign set_offset

	length: INTEGER_32 assign set_length

	real_length: INTEGER_32 assign set_real_length

	data: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_FRAGMENT])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_FRAGMENT])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_offset (a_offset: INTEGER_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_real_length (a_real_length: INTEGER_32)
		do
			real_length := a_real_length
			update_memory_field ("real_length")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			offset := a_other.offset
			length := a_other.length
			real_length := a_other.real_length
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				offset = a_other.offset and
				length = a_other.length and
				real_length = a_other.real_length and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("offset"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("real_length"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("data", <<1>>)
				>>)
			init_structure_info
		end

end
