class
	PD_FRAME_PARAM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent.make
			create name.make
			create url.make
		end

feature {ANY} -- fields

	parent: CE_POINTER [PD_FRAMESET_DESC] assign set_parent

	name: CE_POINTER [NATURAL_8] assign set_name

	url: CE_POINTER [NATURAL_8] assign set_url

feature {ANY} -- setters

	set_parent (a_parent: CE_POINTER [PD_FRAMESET_DESC])
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent := a_other.parent
			name := a_other.name
			url := a_other.url
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent.is_equal (a_other.parent) and
				name.is_equal (a_other.name) and
				url.is_equal (a_other.url)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("url")
				>>)
			init_structure_info
		end

end
