class
	PD_FTP_CONNECTION_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ftp_buffer.make (<<16_384>>)
			create cmdbuf.make (<<1>>)
		end

feature {ANY} -- fields

	pending_commands: INTEGER_32 assign set_pending_commands

	opc: INTEGER_32 assign set_opc

	pasv: INTEGER_32 assign set_pasv

	dir: INTEGER_32 assign set_dir

	rest_sent: INTEGER_32 assign set_rest_sent

	conn_st: INTEGER_32 assign set_conn_st

	d: INTEGER_32 assign set_d

	dpos: INTEGER_32 assign set_dpos

	buf_pos: INTEGER_32 assign set_buf_pos

	ftp_buffer: CE_ARRAY [NATURAL_8]

	cmdbuf: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_pending_commands (a_pending_commands: INTEGER_32)
		do
			pending_commands := a_pending_commands
			update_memory_field ("pending_commands")
		end

	set_opc (a_opc: INTEGER_32)
		do
			opc := a_opc
			update_memory_field ("opc")
		end

	set_pasv (a_pasv: INTEGER_32)
		do
			pasv := a_pasv
			update_memory_field ("pasv")
		end

	set_dir (a_dir: INTEGER_32)
		do
			dir := a_dir
			update_memory_field ("dir")
		end

	set_rest_sent (a_rest_sent: INTEGER_32)
		do
			rest_sent := a_rest_sent
			update_memory_field ("rest_sent")
		end

	set_conn_st (a_conn_st: INTEGER_32)
		do
			conn_st := a_conn_st
			update_memory_field ("conn_st")
		end

	set_d (a_d: INTEGER_32)
		do
			d := a_d
			update_memory_field ("d")
		end

	set_dpos (a_dpos: INTEGER_32)
		do
			dpos := a_dpos
			update_memory_field ("dpos")
		end

	set_buf_pos (a_buf_pos: INTEGER_32)
		do
			buf_pos := a_buf_pos
			update_memory_field ("buf_pos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pending_commands := a_other.pending_commands
			opc := a_other.opc
			pasv := a_other.pasv
			dir := a_other.dir
			rest_sent := a_other.rest_sent
			conn_st := a_other.conn_st
			d := a_other.d
			dpos := a_other.dpos
			buf_pos := a_other.buf_pos
			ftp_buffer := a_other.ftp_buffer.twin
			cmdbuf := a_other.cmdbuf.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pending_commands = a_other.pending_commands and
				opc = a_other.opc and
				pasv = a_other.pasv and
				dir = a_other.dir and
				rest_sent = a_other.rest_sent and
				conn_st = a_other.conn_st and
				d = a_other.d and
				dpos = a_other.dpos and
				buf_pos = a_other.buf_pos and
				ftp_buffer.is_equal (a_other.ftp_buffer) and
				cmdbuf.is_equal (a_other.cmdbuf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pending_commands"),
					create {CE_STRUCTURE_FIELD}.make ("opc"),
					create {CE_STRUCTURE_FIELD}.make ("pasv"),
					create {CE_STRUCTURE_FIELD}.make ("dir"),
					create {CE_STRUCTURE_FIELD}.make ("rest_sent"),
					create {CE_STRUCTURE_FIELD}.make ("conn_st"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("dpos"),
					create {CE_STRUCTURE_FIELD}.make ("buf_pos"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ftp_buffer", <<16_384>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cmdbuf", <<1>>)
				>>)
			init_structure_info
		end

end
