class
	PD_HISTORY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create items.make
		end

feature {ANY} -- fields

	n: INTEGER_32 assign set_n

	items: PD_LIST_HEAD assign set_items

feature {ANY} -- setters

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_items (a_items: PD_LIST_HEAD)
		do
			items := a_items
			update_memory_field ("items")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			items := a_other.items.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				items.is_equal (a_other.items)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("items")
				>>)
			init_structure_info
		end

end
