class
	PD_HTML_ELEMENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create attr.make
			create parattr.make
			create name.make
			create options.make
			create frameset.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_HTML_ELEMENT] assign set_next

	prev: CE_POINTER [PD_HTML_ELEMENT] assign set_prev

	attr: PD_TEXT_ATTRIB assign set_attr

	parattr: PD_PAR_ATTRIB assign set_parattr

	invisible: INTEGER_32 assign set_invisible

	name: CE_POINTER [NATURAL_8] assign set_name

	namelen: INTEGER_32 assign set_namelen

	options: CE_POINTER [NATURAL_8] assign set_options

	linebreak: INTEGER_32 assign set_linebreak

	dontkill: INTEGER_32 assign set_dontkill

	frameset: CE_POINTER [PD_FRAMESET_DESC] assign set_frameset

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_HTML_ELEMENT])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_HTML_ELEMENT])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_attr (a_attr: PD_TEXT_ATTRIB)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_parattr (a_parattr: PD_PAR_ATTRIB)
		do
			parattr := a_parattr
			update_memory_field ("parattr")
		end

	set_invisible (a_invisible: INTEGER_32)
		do
			invisible := a_invisible
			update_memory_field ("invisible")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_namelen (a_namelen: INTEGER_32)
		do
			namelen := a_namelen
			update_memory_field ("namelen")
		end

	set_options (a_options: CE_POINTER [NATURAL_8])
		do
			options := a_options
			update_memory_field ("options")
		end

	set_linebreak (a_linebreak: INTEGER_32)
		do
			linebreak := a_linebreak
			update_memory_field ("linebreak")
		end

	set_dontkill (a_dontkill: INTEGER_32)
		do
			dontkill := a_dontkill
			update_memory_field ("dontkill")
		end

	set_frameset (a_frameset: CE_POINTER [PD_FRAMESET_DESC])
		do
			frameset := a_frameset
			update_memory_field ("frameset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			attr := a_other.attr.twin
			parattr := a_other.parattr.twin
			invisible := a_other.invisible
			name := a_other.name
			namelen := a_other.namelen
			options := a_other.options
			linebreak := a_other.linebreak
			dontkill := a_other.dontkill
			frameset := a_other.frameset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				attr.is_equal (a_other.attr) and
				parattr.is_equal (a_other.parattr) and
				invisible = a_other.invisible and
				name.is_equal (a_other.name) and
				namelen = a_other.namelen and
				options.is_equal (a_other.options) and
				linebreak = a_other.linebreak and
				dontkill = a_other.dontkill and
				frameset.is_equal (a_other.frameset)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("parattr"),
					create {CE_STRUCTURE_FIELD}.make ("invisible"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("namelen"),
					create {CE_STRUCTURE_FIELD}.make ("options"),
					create {CE_STRUCTURE_FIELD}.make ("linebreak"),
					create {CE_STRUCTURE_FIELD}.make ("dontkill"),
					create {CE_STRUCTURE_FIELD}.make ("frameset")
				>>)
			init_structure_info
		end

end
