class
	PD_ITRM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create t.make
			create kqueue.make (<<16>>)
			create ev_queue.make
			create mouse_h.make
			create orig_title.make
		end

feature {ANY} -- fields

	std_in: INTEGER_32 assign set_std_in

	std_out: INTEGER_32 assign set_std_out

	sock_in: INTEGER_32 assign set_sock_in

	sock_out: INTEGER_32 assign set_sock_out

	ctl_in: INTEGER_32 assign set_ctl_in

	blocked: INTEGER_32 assign set_blocked

	t: SD_TERMIOS assign set_t

	flags: INTEGER_32 assign set_flags

	kqueue: CE_ARRAY [NATURAL_8]

	qlen: INTEGER_32 assign set_qlen

	tm: INTEGER_32 assign set_tm

	ev_queue: CE_POINTER [NATURAL_8] assign set_ev_queue

	eqlen: INTEGER_32 assign set_eqlen

	mouse_h: CE_POINTER [ANY] assign set_mouse_h

	orig_title: CE_POINTER [NATURAL_8] assign set_orig_title

feature {ANY} -- setters

	set_std_in (a_std_in: INTEGER_32)
		do
			std_in := a_std_in
			update_memory_field ("std_in")
		end

	set_std_out (a_std_out: INTEGER_32)
		do
			std_out := a_std_out
			update_memory_field ("std_out")
		end

	set_sock_in (a_sock_in: INTEGER_32)
		do
			sock_in := a_sock_in
			update_memory_field ("sock_in")
		end

	set_sock_out (a_sock_out: INTEGER_32)
		do
			sock_out := a_sock_out
			update_memory_field ("sock_out")
		end

	set_ctl_in (a_ctl_in: INTEGER_32)
		do
			ctl_in := a_ctl_in
			update_memory_field ("ctl_in")
		end

	set_blocked (a_blocked: INTEGER_32)
		do
			blocked := a_blocked
			update_memory_field ("blocked")
		end

	set_t (a_t: SD_TERMIOS)
		do
			t := a_t
			update_memory_field ("t")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			qlen := a_qlen
			update_memory_field ("qlen")
		end

	set_tm (a_tm: INTEGER_32)
		do
			tm := a_tm
			update_memory_field ("tm")
		end

	set_ev_queue (a_ev_queue: CE_POINTER [NATURAL_8])
		do
			ev_queue := a_ev_queue
			update_memory_field ("ev_queue")
		end

	set_eqlen (a_eqlen: INTEGER_32)
		do
			eqlen := a_eqlen
			update_memory_field ("eqlen")
		end

	set_mouse_h (a_mouse_h: CE_POINTER [ANY])
		do
			mouse_h := a_mouse_h
			update_memory_field ("mouse_h")
		end

	set_orig_title (a_orig_title: CE_POINTER [NATURAL_8])
		do
			orig_title := a_orig_title
			update_memory_field ("orig_title")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			std_in := a_other.std_in
			std_out := a_other.std_out
			sock_in := a_other.sock_in
			sock_out := a_other.sock_out
			ctl_in := a_other.ctl_in
			blocked := a_other.blocked
			t := a_other.t.twin
			flags := a_other.flags
			kqueue := a_other.kqueue.twin
			qlen := a_other.qlen
			tm := a_other.tm
			ev_queue := a_other.ev_queue
			eqlen := a_other.eqlen
			mouse_h := a_other.mouse_h
			orig_title := a_other.orig_title
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				std_in = a_other.std_in and
				std_out = a_other.std_out and
				sock_in = a_other.sock_in and
				sock_out = a_other.sock_out and
				ctl_in = a_other.ctl_in and
				blocked = a_other.blocked and
				t.is_equal (a_other.t) and
				flags = a_other.flags and
				kqueue.is_equal (a_other.kqueue) and
				qlen = a_other.qlen and
				tm = a_other.tm and
				ev_queue.is_equal (a_other.ev_queue) and
				eqlen = a_other.eqlen and
				mouse_h.is_equal (a_other.mouse_h) and
				orig_title.is_equal (a_other.orig_title)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("std_in"),
					create {CE_STRUCTURE_FIELD}.make ("std_out"),
					create {CE_STRUCTURE_FIELD}.make ("sock_in"),
					create {CE_STRUCTURE_FIELD}.make ("sock_out"),
					create {CE_STRUCTURE_FIELD}.make ("ctl_in"),
					create {CE_STRUCTURE_FIELD}.make ("blocked"),
					create {CE_STRUCTURE_FIELD}.make ("t"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("kqueue", <<16>>),
					create {CE_STRUCTURE_FIELD}.make ("qlen"),
					create {CE_STRUCTURE_FIELD}.make ("tm"),
					create {CE_STRUCTURE_FIELD}.make ("ev_queue"),
					create {CE_STRUCTURE_FIELD}.make ("eqlen"),
					create {CE_STRUCTURE_FIELD}.make ("mouse_h"),
					create {CE_STRUCTURE_FIELD}.make ("orig_title")
				>>)
			init_structure_info
		end

end
