class
	PD_LINE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create d.make
		end

feature {ANY} -- fields

	l: INTEGER_32 assign set_l

	c: NATURAL_16 assign set_c

	d: CE_POINTER [NATURAL_16] assign set_d

feature {ANY} -- setters

	set_l (a_l: INTEGER_32)
		do
			l := a_l
			update_memory_field ("l")
		end

	set_c (a_c: NATURAL_16)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_d (a_d: CE_POINTER [NATURAL_16])
		do
			d := a_d
			update_memory_field ("d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			l := a_other.l
			c := a_other.c
			d := a_other.d
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				l = a_other.l and
				c = a_other.c and
				d.is_equal (a_other.d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("l"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("d")
				>>)
			init_structure_info
		end

end
