class
	PD_LOCATION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create frames.make
			create stat.make
			create vs.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_LOCATION] assign set_next

	prev: CE_POINTER [PD_LOCATION] assign set_prev

	frames: PD_LIST_HEAD assign set_frames

	stat: PD_STATUS assign set_stat

	vs: PD_VIEW_STATE assign set_vs

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_LOCATION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_LOCATION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_frames (a_frames: PD_LIST_HEAD)
		do
			frames := a_frames
			update_memory_field ("frames")
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat := a_stat
			update_memory_field ("stat")
		end

	set_vs (a_vs: PD_VIEW_STATE)
		do
			vs := a_vs
			update_memory_field ("vs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			frames := a_other.frames.twin
			stat := a_other.stat.twin
			vs := a_other.vs.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				frames.is_equal (a_other.frames) and
				stat.is_equal (a_other.stat) and
				vs.is_equal (a_other.vs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("frames"),
					create {CE_STRUCTURE_FIELD}.make ("stat"),
					create {CE_STRUCTURE_FIELD}.make ("vs")
				>>)
			init_structure_info
		end

end
