class
	PD_MAINMENU

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create win.make
			create items.make
		end

feature {ANY} -- fields

	selected: INTEGER_32 assign set_selected

	sp: INTEGER_32 assign set_sp

	ni: INTEGER_32 assign set_ni

	data: CE_POINTER [ANY] assign set_data

	win: CE_POINTER [PD_WINDOW] assign set_win

	items: CE_POINTER [PD_MENU_ITEM] assign set_items

feature {ANY} -- setters

	set_selected (a_selected: INTEGER_32)
		do
			selected := a_selected
			update_memory_field ("selected")
		end

	set_sp (a_sp: INTEGER_32)
		do
			sp := a_sp
			update_memory_field ("sp")
		end

	set_ni (a_ni: INTEGER_32)
		do
			ni := a_ni
			update_memory_field ("ni")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_items (a_items: CE_POINTER [PD_MENU_ITEM])
		do
			items := a_items
			update_memory_field ("items")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			selected := a_other.selected
			sp := a_other.sp
			ni := a_other.ni
			data := a_other.data
			win := a_other.win
			items := a_other.items
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				selected = a_other.selected and
				sp = a_other.sp and
				ni = a_other.ni and
				data.is_equal (a_other.data) and
				win.is_equal (a_other.win) and
				items.is_equal (a_other.items)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("selected"),
					create {CE_STRUCTURE_FIELD}.make ("sp"),
					create {CE_STRUCTURE_FIELD}.make ("ni"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("items")
				>>)
			init_structure_info
		end

end
