class
	PD_MENU_ITEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create text.make
			create rtext.make
			create hotkey.make
			create func.make
			create data.make
		end

feature {ANY} -- fields

	text: CE_POINTER [NATURAL_8] assign set_text

	rtext: CE_POINTER [NATURAL_8] assign set_rtext

	hotkey: CE_POINTER [NATURAL_8] assign set_hotkey

	func: CE_ROUTINE assign set_func

	data: CE_POINTER [ANY] assign set_data

	in_m: INTEGER_32 assign set_in_m

	free_i: INTEGER_32 assign set_free_i

feature {ANY} -- setters

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_rtext (a_rtext: CE_POINTER [NATURAL_8])
		do
			rtext := a_rtext
			update_memory_field ("rtext")
		end

	set_hotkey (a_hotkey: CE_POINTER [NATURAL_8])
		do
			hotkey := a_hotkey
			update_memory_field ("hotkey")
		end

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_in_m (a_in_m: INTEGER_32)
		do
			in_m := a_in_m
			update_memory_field ("in_m")
		end

	set_free_i (a_free_i: INTEGER_32)
		do
			free_i := a_free_i
			update_memory_field ("free_i")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			text := a_other.text
			rtext := a_other.rtext
			hotkey := a_other.hotkey
			func := a_other.func
			data := a_other.data
			in_m := a_other.in_m
			free_i := a_other.free_i
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				text.is_equal (a_other.text) and
				rtext.is_equal (a_other.rtext) and
				hotkey.is_equal (a_other.hotkey) and
				func.is_equal (a_other.func) and
				data.is_equal (a_other.data) and
				in_m = a_other.in_m and
				free_i = a_other.free_i
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("rtext"),
					create {CE_STRUCTURE_FIELD}.make ("hotkey"),
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("in_m"),
					create {CE_STRUCTURE_FIELD}.make ("free_i")
				>>)
			init_structure_info
		end

end
