class
	PD_OINW

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fn.make
			create text.make
			create hk.make
		end

feature {ANY} -- fields

	env: INTEGER_32 assign set_env

	fn: CE_ROUTINE assign set_fn

	text: CE_POINTER [NATURAL_8] assign set_text

	hk: CE_POINTER [NATURAL_8] assign set_hk

feature {ANY} -- setters

	set_env (a_env: INTEGER_32)
		do
			env := a_env
			update_memory_field ("env")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_hk (a_hk: CE_POINTER [NATURAL_8])
		do
			hk := a_hk
			update_memory_field ("hk")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			env := a_other.env
			fn := a_other.fn
			text := a_other.text
			hk := a_other.hk
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				env = a_other.env and
				fn.is_equal (a_other.fn) and
				text.is_equal (a_other.text) and
				hk.is_equal (a_other.hk)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("env"),
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("hk")
				>>)
			init_structure_info
		end

end
