class
	PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create rd_cmd.make
			create rd_cfg.make
			create wr_cfg.make
			create ptr.make
			create cfg_name.make
			create cmd_name.make
		end

feature {ANY} -- fields

	p: INTEGER_32 assign set_p

	rd_cmd: CE_ROUTINE assign set_rd_cmd

	rd_cfg: CE_ROUTINE assign set_rd_cfg

	wr_cfg: CE_ROUTINE assign set_wr_cfg

	min: INTEGER_32 assign set_min

	max: INTEGER_32 assign set_max

	ptr: CE_POINTER [ANY] assign set_ptr

	cfg_name: CE_POINTER [NATURAL_8] assign set_cfg_name

	cmd_name: CE_POINTER [NATURAL_8] assign set_cmd_name

feature {ANY} -- setters

	set_p (a_p: INTEGER_32)
		do
			p := a_p
			update_memory_field ("p")
		end

	set_rd_cmd (a_rd_cmd: CE_ROUTINE)
		do
			rd_cmd := a_rd_cmd
			update_memory_field ("rd_cmd")
		end

	set_rd_cfg (a_rd_cfg: CE_ROUTINE)
		do
			rd_cfg := a_rd_cfg
			update_memory_field ("rd_cfg")
		end

	set_wr_cfg (a_wr_cfg: CE_ROUTINE)
		do
			wr_cfg := a_wr_cfg
			update_memory_field ("wr_cfg")
		end

	set_min (a_min: INTEGER_32)
		do
			min := a_min
			update_memory_field ("min")
		end

	set_max (a_max: INTEGER_32)
		do
			max := a_max
			update_memory_field ("max")
		end

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_cfg_name (a_cfg_name: CE_POINTER [NATURAL_8])
		do
			cfg_name := a_cfg_name
			update_memory_field ("cfg_name")
		end

	set_cmd_name (a_cmd_name: CE_POINTER [NATURAL_8])
		do
			cmd_name := a_cmd_name
			update_memory_field ("cmd_name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p := a_other.p
			rd_cmd := a_other.rd_cmd
			rd_cfg := a_other.rd_cfg
			wr_cfg := a_other.wr_cfg
			min := a_other.min
			max := a_other.max
			ptr := a_other.ptr
			cfg_name := a_other.cfg_name
			cmd_name := a_other.cmd_name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p = a_other.p and
				rd_cmd.is_equal (a_other.rd_cmd) and
				rd_cfg.is_equal (a_other.rd_cfg) and
				wr_cfg.is_equal (a_other.wr_cfg) and
				min = a_other.min and
				max = a_other.max and
				ptr.is_equal (a_other.ptr) and
				cfg_name.is_equal (a_other.cfg_name) and
				cmd_name.is_equal (a_other.cmd_name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("rd_cmd"),
					create {CE_STRUCTURE_FIELD}.make ("rd_cfg"),
					create {CE_STRUCTURE_FIELD}.make ("wr_cfg"),
					create {CE_STRUCTURE_FIELD}.make ("min"),
					create {CE_STRUCTURE_FIELD}.make ("max"),
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("cfg_name"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_name")
				>>)
			init_structure_info
		end

end
