class
	PD_PART

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create spaces.make
			create uf.make
		end

feature {ANY} -- fields

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	xmax: INTEGER_32 assign set_xmax

	xa: INTEGER_32 assign set_xa

	cx: INTEGER_32 assign set_cx

	cy: INTEGER_32 assign set_cy

	data: CE_POINTER [PD_F_DATA] assign set_data

	bgcolor: INTEGER_32 assign set_bgcolor

	spaces: CE_POINTER [NATURAL_8] assign set_spaces

	spl: INTEGER_32 assign set_spl

	link_num: INTEGER_32 assign set_link_num

	uf: PD_LIST_HEAD assign set_uf

feature {ANY} -- setters

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_xmax (a_xmax: INTEGER_32)
		do
			xmax := a_xmax
			update_memory_field ("xmax")
		end

	set_xa (a_xa: INTEGER_32)
		do
			xa := a_xa
			update_memory_field ("xa")
		end

	set_cx (a_cx: INTEGER_32)
		do
			cx := a_cx
			update_memory_field ("cx")
		end

	set_cy (a_cy: INTEGER_32)
		do
			cy := a_cy
			update_memory_field ("cy")
		end

	set_data (a_data: CE_POINTER [PD_F_DATA])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_bgcolor (a_bgcolor: INTEGER_32)
		do
			bgcolor := a_bgcolor
			update_memory_field ("bgcolor")
		end

	set_spaces (a_spaces: CE_POINTER [NATURAL_8])
		do
			spaces := a_spaces
			update_memory_field ("spaces")
		end

	set_spl (a_spl: INTEGER_32)
		do
			spl := a_spl
			update_memory_field ("spl")
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			link_num := a_link_num
			update_memory_field ("link_num")
		end

	set_uf (a_uf: PD_LIST_HEAD)
		do
			uf := a_uf
			update_memory_field ("uf")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
			xp := a_other.xp
			yp := a_other.yp
			xmax := a_other.xmax
			xa := a_other.xa
			cx := a_other.cx
			cy := a_other.cy
			data := a_other.data
			bgcolor := a_other.bgcolor
			spaces := a_other.spaces
			spl := a_other.spl
			link_num := a_other.link_num
			uf := a_other.uf.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y and
				xp = a_other.xp and
				yp = a_other.yp and
				xmax = a_other.xmax and
				xa = a_other.xa and
				cx = a_other.cx and
				cy = a_other.cy and
				data.is_equal (a_other.data) and
				bgcolor = a_other.bgcolor and
				spaces.is_equal (a_other.spaces) and
				spl = a_other.spl and
				link_num = a_other.link_num and
				uf.is_equal (a_other.uf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("xmax"),
					create {CE_STRUCTURE_FIELD}.make ("xa"),
					create {CE_STRUCTURE_FIELD}.make ("cx"),
					create {CE_STRUCTURE_FIELD}.make ("cy"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("bgcolor"),
					create {CE_STRUCTURE_FIELD}.make ("spaces"),
					create {CE_STRUCTURE_FIELD}.make ("spl"),
					create {CE_STRUCTURE_FIELD}.make ("link_num"),
					create {CE_STRUCTURE_FIELD}.make ("uf")
				>>)
			init_structure_info
		end

end
