class
	PD_READ_BUFFER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create done.make
			create data.make (<<1>>)
		end

feature {ANY} -- fields

	sock: INTEGER_32 assign set_sock

	len: INTEGER_32 assign set_len

	close: INTEGER_32 assign set_close

	done: CE_ROUTINE assign set_done

	data: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_sock (a_sock: INTEGER_32)
		do
			sock := a_sock
			update_memory_field ("sock")
		end

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_close (a_close: INTEGER_32)
		do
			close := a_close
			update_memory_field ("close")
		end

	set_done (a_done: CE_ROUTINE)
		do
			done := a_done
			update_memory_field ("done")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sock := a_other.sock
			len := a_other.len
			close := a_other.close
			done := a_other.done
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sock = a_other.sock and
				len = a_other.len and
				close = a_other.close and
				done.is_equal (a_other.done) and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sock"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("close"),
					create {CE_STRUCTURE_FIELD}.make ("done"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("data", <<1>>)
				>>)
			init_structure_info
		end

end
