class
	PD_REFRESH

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create term.make
			create win.make
			create ses.make
			create fn.make
			create data.make
		end

feature {ANY} -- fields

	term: CE_POINTER [PD_TERMINAL] assign set_term

	win: CE_POINTER [PD_WINDOW] assign set_win

	ses: CE_POINTER [PD_SESSION] assign set_ses

	fn: CE_ROUTINE assign set_fn

	data: CE_POINTER [ANY] assign set_data

	timer: INTEGER_32 assign set_timer

feature {ANY} -- setters

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			term := a_term
			update_memory_field ("term")
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			ses := a_ses
			update_memory_field ("ses")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_timer (a_timer: INTEGER_32)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			term := a_other.term
			win := a_other.win
			ses := a_other.ses
			fn := a_other.fn
			data := a_other.data
			timer := a_other.timer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				term.is_equal (a_other.term) and
				win.is_equal (a_other.win) and
				ses.is_equal (a_other.ses) and
				fn.is_equal (a_other.fn) and
				data.is_equal (a_other.data) and
				timer = a_other.timer
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("term"),
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("ses"),
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("timer")
				>>)
			init_structure_info
		end

end
