class
	PD_RGB_CACHE_ENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create rgb.make
		end

feature {ANY} -- fields

	color: INTEGER_32 assign set_color

	l: INTEGER_32 assign set_l

	rgb: PD_RGB assign set_rgb

feature {ANY} -- setters

	set_color (a_color: INTEGER_32)
		do
			color := a_color
			update_memory_field ("color")
		end

	set_l (a_l: INTEGER_32)
		do
			l := a_l
			update_memory_field ("l")
		end

	set_rgb (a_rgb: PD_RGB)
		do
			rgb := a_rgb
			update_memory_field ("rgb")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			color := a_other.color
			l := a_other.l
			rgb := a_other.rgb.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				color = a_other.color and
				l = a_other.l and
				rgb.is_equal (a_other.rgb)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("color"),
					create {CE_STRUCTURE_FIELD}.make ("l"),
					create {CE_STRUCTURE_FIELD}.make ("rgb")
				>>)
			init_structure_info
		end

end
