class
	PD_SEARCH

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	c: NATURAL_8 assign set_c

	n: INTEGER_32 assign set_n

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

feature {ANY} -- setters

	set_c (a_c: NATURAL_8)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c := a_other.c
			n := a_other.n
			x := a_other.x
			y := a_other.y
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c = a_other.c and
				n = a_other.n and
				x = a_other.x and
				y = a_other.y
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("n"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct search {
					unsigned char c;
					int n : 24;
					int x;
					int y;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct search);
					if(strcmp(field_name, "x") == 0) return offsetof(struct search, x);
				} else {
					struct search *p = (struct search *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "n") == 0) p->n = (int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "n") == 0) return p->n;
					}
				}
			]"
		end

end
