class
	PD_SESSION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create history.make
			create term.make
			create win.make
			create screen.make
			create scrn_frames.make
			create loading.make
			create wtd_target.make
			create loading_url.make
			create more_files.make
			create goto_position.make
			create imgmap_href_base.make
			create imgmap_target_base.make
			create ds.make
			create kbdprefix.make
			create tq.make
			create tq_url.make
			create tq_ce.make
			create tq_goto_position.make
			create tq_prog.make
			create dn_url.make
			create search_word.make
			create last_search_word.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_SESSION] assign set_next

	prev: CE_POINTER [PD_SESSION] assign set_prev

	history: PD_LIST_HEAD assign set_history

	term: CE_POINTER [PD_TERMINAL] assign set_term

	win: CE_POINTER [PD_WINDOW] assign set_win

	id: INTEGER_32 assign set_id

	screen: CE_POINTER [PD_F_DATA_C] assign set_screen

	scrn_frames: PD_LIST_HEAD assign set_scrn_frames

	loading: PD_STATUS assign set_loading

	wtd: INTEGER_32 assign set_wtd

	wtd_target: CE_POINTER [NATURAL_8] assign set_wtd_target

	loading_url: CE_POINTER [NATURAL_8] assign set_loading_url

	display_timer: INTEGER_32 assign set_display_timer

	more_files: PD_LIST_HEAD assign set_more_files

	goto_position: CE_POINTER [NATURAL_8] assign set_goto_position

	imgmap_href_base: CE_POINTER [NATURAL_8] assign set_imgmap_href_base

	imgmap_target_base: CE_POINTER [NATURAL_8] assign set_imgmap_target_base

	ds: PD_DOCUMENT_SETUP assign set_ds

	kbdprefix: PD_KBDPREFIX assign set_kbdprefix

	reloadlevel: INTEGER_32 assign set_reloadlevel

	redirect_cnt: INTEGER_32 assign set_redirect_cnt

	tq: PD_STATUS assign set_tq

	tq_url: CE_POINTER [NATURAL_8] assign set_tq_url

	tq_ce: CE_POINTER [PD_CACHE_ENTRY] assign set_tq_ce

	tq_goto_position: CE_POINTER [NATURAL_8] assign set_tq_goto_position

	tq_prog: CE_POINTER [NATURAL_8] assign set_tq_prog

	tq_prog_flags: INTEGER_32 assign set_tq_prog_flags

	dn_url: CE_POINTER [NATURAL_8] assign set_dn_url

	search_word: CE_POINTER [NATURAL_8] assign set_search_word

	last_search_word: CE_POINTER [NATURAL_8] assign set_last_search_word

	search_direction: INTEGER_32 assign set_search_direction

	exit_query: INTEGER_32 assign set_exit_query

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_SESSION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_SESSION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_history (a_history: PD_LIST_HEAD)
		do
			history := a_history
			update_memory_field ("history")
		end

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			term := a_term
			update_memory_field ("term")
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_screen (a_screen: CE_POINTER [PD_F_DATA_C])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

	set_scrn_frames (a_scrn_frames: PD_LIST_HEAD)
		do
			scrn_frames := a_scrn_frames
			update_memory_field ("scrn_frames")
		end

	set_loading (a_loading: PD_STATUS)
		do
			loading := a_loading
			update_memory_field ("loading")
		end

	set_wtd (a_wtd: INTEGER_32)
		do
			wtd := a_wtd
			update_memory_field ("wtd")
		end

	set_wtd_target (a_wtd_target: CE_POINTER [NATURAL_8])
		do
			wtd_target := a_wtd_target
			update_memory_field ("wtd_target")
		end

	set_loading_url (a_loading_url: CE_POINTER [NATURAL_8])
		do
			loading_url := a_loading_url
			update_memory_field ("loading_url")
		end

	set_display_timer (a_display_timer: INTEGER_32)
		do
			display_timer := a_display_timer
			update_memory_field ("display_timer")
		end

	set_more_files (a_more_files: PD_LIST_HEAD)
		do
			more_files := a_more_files
			update_memory_field ("more_files")
		end

	set_goto_position (a_goto_position: CE_POINTER [NATURAL_8])
		do
			goto_position := a_goto_position
			update_memory_field ("goto_position")
		end

	set_imgmap_href_base (a_imgmap_href_base: CE_POINTER [NATURAL_8])
		do
			imgmap_href_base := a_imgmap_href_base
			update_memory_field ("imgmap_href_base")
		end

	set_imgmap_target_base (a_imgmap_target_base: CE_POINTER [NATURAL_8])
		do
			imgmap_target_base := a_imgmap_target_base
			update_memory_field ("imgmap_target_base")
		end

	set_ds (a_ds: PD_DOCUMENT_SETUP)
		do
			ds := a_ds
			update_memory_field ("ds")
		end

	set_kbdprefix (a_kbdprefix: PD_KBDPREFIX)
		do
			kbdprefix := a_kbdprefix
			update_memory_field ("kbdprefix")
		end

	set_reloadlevel (a_reloadlevel: INTEGER_32)
		do
			reloadlevel := a_reloadlevel
			update_memory_field ("reloadlevel")
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			redirect_cnt := a_redirect_cnt
			update_memory_field ("redirect_cnt")
		end

	set_tq (a_tq: PD_STATUS)
		do
			tq := a_tq
			update_memory_field ("tq")
		end

	set_tq_url (a_tq_url: CE_POINTER [NATURAL_8])
		do
			tq_url := a_tq_url
			update_memory_field ("tq_url")
		end

	set_tq_ce (a_tq_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			tq_ce := a_tq_ce
			update_memory_field ("tq_ce")
		end

	set_tq_goto_position (a_tq_goto_position: CE_POINTER [NATURAL_8])
		do
			tq_goto_position := a_tq_goto_position
			update_memory_field ("tq_goto_position")
		end

	set_tq_prog (a_tq_prog: CE_POINTER [NATURAL_8])
		do
			tq_prog := a_tq_prog
			update_memory_field ("tq_prog")
		end

	set_tq_prog_flags (a_tq_prog_flags: INTEGER_32)
		do
			tq_prog_flags := a_tq_prog_flags
			update_memory_field ("tq_prog_flags")
		end

	set_dn_url (a_dn_url: CE_POINTER [NATURAL_8])
		do
			dn_url := a_dn_url
			update_memory_field ("dn_url")
		end

	set_search_word (a_search_word: CE_POINTER [NATURAL_8])
		do
			search_word := a_search_word
			update_memory_field ("search_word")
		end

	set_last_search_word (a_last_search_word: CE_POINTER [NATURAL_8])
		do
			last_search_word := a_last_search_word
			update_memory_field ("last_search_word")
		end

	set_search_direction (a_search_direction: INTEGER_32)
		do
			search_direction := a_search_direction
			update_memory_field ("search_direction")
		end

	set_exit_query (a_exit_query: INTEGER_32)
		do
			exit_query := a_exit_query
			update_memory_field ("exit_query")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			history := a_other.history.twin
			term := a_other.term
			win := a_other.win
			id := a_other.id
			screen := a_other.screen
			scrn_frames := a_other.scrn_frames.twin
			loading := a_other.loading.twin
			wtd := a_other.wtd
			wtd_target := a_other.wtd_target
			loading_url := a_other.loading_url
			display_timer := a_other.display_timer
			more_files := a_other.more_files.twin
			goto_position := a_other.goto_position
			imgmap_href_base := a_other.imgmap_href_base
			imgmap_target_base := a_other.imgmap_target_base
			ds := a_other.ds.twin
			kbdprefix := a_other.kbdprefix.twin
			reloadlevel := a_other.reloadlevel
			redirect_cnt := a_other.redirect_cnt
			tq := a_other.tq.twin
			tq_url := a_other.tq_url
			tq_ce := a_other.tq_ce
			tq_goto_position := a_other.tq_goto_position
			tq_prog := a_other.tq_prog
			tq_prog_flags := a_other.tq_prog_flags
			dn_url := a_other.dn_url
			search_word := a_other.search_word
			last_search_word := a_other.last_search_word
			search_direction := a_other.search_direction
			exit_query := a_other.exit_query
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				history.is_equal (a_other.history) and
				term.is_equal (a_other.term) and
				win.is_equal (a_other.win) and
				id = a_other.id and
				screen.is_equal (a_other.screen) and
				scrn_frames.is_equal (a_other.scrn_frames) and
				loading.is_equal (a_other.loading) and
				wtd = a_other.wtd and
				wtd_target.is_equal (a_other.wtd_target) and
				loading_url.is_equal (a_other.loading_url) and
				display_timer = a_other.display_timer and
				more_files.is_equal (a_other.more_files) and
				goto_position.is_equal (a_other.goto_position) and
				imgmap_href_base.is_equal (a_other.imgmap_href_base) and
				imgmap_target_base.is_equal (a_other.imgmap_target_base) and
				ds.is_equal (a_other.ds) and
				kbdprefix.is_equal (a_other.kbdprefix) and
				reloadlevel = a_other.reloadlevel and
				redirect_cnt = a_other.redirect_cnt and
				tq.is_equal (a_other.tq) and
				tq_url.is_equal (a_other.tq_url) and
				tq_ce.is_equal (a_other.tq_ce) and
				tq_goto_position.is_equal (a_other.tq_goto_position) and
				tq_prog.is_equal (a_other.tq_prog) and
				tq_prog_flags = a_other.tq_prog_flags and
				dn_url.is_equal (a_other.dn_url) and
				search_word.is_equal (a_other.search_word) and
				last_search_word.is_equal (a_other.last_search_word) and
				search_direction = a_other.search_direction and
				exit_query = a_other.exit_query
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("history"),
					create {CE_STRUCTURE_FIELD}.make ("term"),
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("screen"),
					create {CE_STRUCTURE_FIELD}.make ("scrn_frames"),
					create {CE_STRUCTURE_FIELD}.make ("loading"),
					create {CE_STRUCTURE_FIELD}.make ("wtd"),
					create {CE_STRUCTURE_FIELD}.make ("wtd_target"),
					create {CE_STRUCTURE_FIELD}.make ("loading_url"),
					create {CE_STRUCTURE_FIELD}.make ("display_timer"),
					create {CE_STRUCTURE_FIELD}.make ("more_files"),
					create {CE_STRUCTURE_FIELD}.make ("goto_position"),
					create {CE_STRUCTURE_FIELD}.make ("imgmap_href_base"),
					create {CE_STRUCTURE_FIELD}.make ("imgmap_target_base"),
					create {CE_STRUCTURE_FIELD}.make ("ds"),
					create {CE_STRUCTURE_FIELD}.make ("kbdprefix"),
					create {CE_STRUCTURE_FIELD}.make ("reloadlevel"),
					create {CE_STRUCTURE_FIELD}.make ("redirect_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("tq"),
					create {CE_STRUCTURE_FIELD}.make ("tq_url"),
					create {CE_STRUCTURE_FIELD}.make ("tq_ce"),
					create {CE_STRUCTURE_FIELD}.make ("tq_goto_position"),
					create {CE_STRUCTURE_FIELD}.make ("tq_prog"),
					create {CE_STRUCTURE_FIELD}.make ("tq_prog_flags"),
					create {CE_STRUCTURE_FIELD}.make ("dn_url"),
					create {CE_STRUCTURE_FIELD}.make ("search_word"),
					create {CE_STRUCTURE_FIELD}.make ("last_search_word"),
					create {CE_STRUCTURE_FIELD}.make ("search_direction"),
					create {CE_STRUCTURE_FIELD}.make ("exit_query")
				>>)
			init_structure_info
		end

end
