class
	PD_STATUS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create c.make
			create ce.make
			create end2.make
			create data.make
			create prg.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_STATUS] assign set_next

	prev: CE_POINTER [PD_STATUS] assign set_prev

	c: CE_POINTER [PD_CONNECTION] assign set_c

	ce: CE_POINTER [PD_CACHE_ENTRY] assign set_ce

	state: INTEGER_32 assign set_state

	prev_error: INTEGER_32 assign set_prev_error

	pri: INTEGER_32 assign set_pri

	end2: CE_ROUTINE assign set_end2

	data: CE_POINTER [ANY] assign set_data

	prg: CE_POINTER [PD_REMAINING_INFO] assign set_prg

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_STATUS])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_STATUS])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_c (a_c: CE_POINTER [PD_CONNECTION])
		do
			c := a_c
			update_memory_field ("c")
		end

	set_ce (a_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			ce := a_ce
			update_memory_field ("ce")
		end

	set_state (a_state: INTEGER_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_prev_error (a_prev_error: INTEGER_32)
		do
			prev_error := a_prev_error
			update_memory_field ("prev_error")
		end

	set_pri (a_pri: INTEGER_32)
		do
			pri := a_pri
			update_memory_field ("pri")
		end

	set_end2 (a_end2: CE_ROUTINE)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_prg (a_prg: CE_POINTER [PD_REMAINING_INFO])
		do
			prg := a_prg
			update_memory_field ("prg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			c := a_other.c
			ce := a_other.ce
			state := a_other.state
			prev_error := a_other.prev_error
			pri := a_other.pri
			end2 := a_other.end2
			data := a_other.data
			prg := a_other.prg
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				c.is_equal (a_other.c) and
				ce.is_equal (a_other.ce) and
				state = a_other.state and
				prev_error = a_other.prev_error and
				pri = a_other.pri and
				end2.is_equal (a_other.end2) and
				data.is_equal (a_other.data) and
				prg.is_equal (a_other.prg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("ce"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("prev_error"),
					create {CE_STRUCTURE_FIELD}.make ("pri"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("prg")
				>>)
			init_structure_info
		end

end
