class
	PD_TABLE_CELL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create start.make
			create end2.make
			create bgcolor.make
		end

feature {ANY} -- fields

	used: INTEGER_32 assign set_used

	spanned: INTEGER_32 assign set_spanned

	mx: INTEGER_32 assign set_mx

	my: INTEGER_32 assign set_my

	start: CE_POINTER [NATURAL_8] assign set_start

	end2: CE_POINTER [NATURAL_8] assign set_end2

	align: INTEGER_32 assign set_align

	valign: INTEGER_32 assign set_valign

	b: INTEGER_32 assign set_b

	bgcolor: PD_RGB assign set_bgcolor

	group: INTEGER_32 assign set_group

	colspan: INTEGER_32 assign set_colspan

	rowspan: INTEGER_32 assign set_rowspan

	min_width: INTEGER_32 assign set_min_width

	max_width: INTEGER_32 assign set_max_width

	x_width: INTEGER_32 assign set_x_width

	height: INTEGER_32 assign set_height

	xpos: INTEGER_32 assign set_xpos

	ypos: INTEGER_32 assign set_ypos

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	link_num: INTEGER_32 assign set_link_num

feature {ANY} -- setters

	set_used (a_used: INTEGER_32)
		do
			used := a_used
			update_memory_field ("used")
		end

	set_spanned (a_spanned: INTEGER_32)
		do
			spanned := a_spanned
			update_memory_field ("spanned")
		end

	set_mx (a_mx: INTEGER_32)
		do
			mx := a_mx
			update_memory_field ("mx")
		end

	set_my (a_my: INTEGER_32)
		do
			my := a_my
			update_memory_field ("my")
		end

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: CE_POINTER [NATURAL_8])
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_align (a_align: INTEGER_32)
		do
			align := a_align
			update_memory_field ("align")
		end

	set_valign (a_valign: INTEGER_32)
		do
			valign := a_valign
			update_memory_field ("valign")
		end

	set_b (a_b: INTEGER_32)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_bgcolor (a_bgcolor: PD_RGB)
		do
			bgcolor := a_bgcolor
			update_memory_field ("bgcolor")
		end

	set_group (a_group: INTEGER_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_colspan (a_colspan: INTEGER_32)
		do
			colspan := a_colspan
			update_memory_field ("colspan")
		end

	set_rowspan (a_rowspan: INTEGER_32)
		do
			rowspan := a_rowspan
			update_memory_field ("rowspan")
		end

	set_min_width (a_min_width: INTEGER_32)
		do
			min_width := a_min_width
			update_memory_field ("min_width")
		end

	set_max_width (a_max_width: INTEGER_32)
		do
			max_width := a_max_width
			update_memory_field ("max_width")
		end

	set_x_width (a_x_width: INTEGER_32)
		do
			x_width := a_x_width
			update_memory_field ("x_width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_xpos (a_xpos: INTEGER_32)
		do
			xpos := a_xpos
			update_memory_field ("xpos")
		end

	set_ypos (a_ypos: INTEGER_32)
		do
			ypos := a_ypos
			update_memory_field ("ypos")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			link_num := a_link_num
			update_memory_field ("link_num")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			used := a_other.used
			spanned := a_other.spanned
			mx := a_other.mx
			my := a_other.my
			start := a_other.start
			end2 := a_other.end2
			align := a_other.align
			valign := a_other.valign
			b := a_other.b
			bgcolor := a_other.bgcolor.twin
			group := a_other.group
			colspan := a_other.colspan
			rowspan := a_other.rowspan
			min_width := a_other.min_width
			max_width := a_other.max_width
			x_width := a_other.x_width
			height := a_other.height
			xpos := a_other.xpos
			ypos := a_other.ypos
			xw := a_other.xw
			yw := a_other.yw
			link_num := a_other.link_num
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				used = a_other.used and
				spanned = a_other.spanned and
				mx = a_other.mx and
				my = a_other.my and
				start.is_equal (a_other.start) and
				end2.is_equal (a_other.end2) and
				align = a_other.align and
				valign = a_other.valign and
				b = a_other.b and
				bgcolor.is_equal (a_other.bgcolor) and
				group = a_other.group and
				colspan = a_other.colspan and
				rowspan = a_other.rowspan and
				min_width = a_other.min_width and
				max_width = a_other.max_width and
				x_width = a_other.x_width and
				height = a_other.height and
				xpos = a_other.xpos and
				ypos = a_other.ypos and
				xw = a_other.xw and
				yw = a_other.yw and
				link_num = a_other.link_num
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("used"),
					create {CE_STRUCTURE_FIELD}.make ("spanned"),
					create {CE_STRUCTURE_FIELD}.make ("mx"),
					create {CE_STRUCTURE_FIELD}.make ("my"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("align"),
					create {CE_STRUCTURE_FIELD}.make ("valign"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("bgcolor"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("colspan"),
					create {CE_STRUCTURE_FIELD}.make ("rowspan"),
					create {CE_STRUCTURE_FIELD}.make ("min_width"),
					create {CE_STRUCTURE_FIELD}.make ("max_width"),
					create {CE_STRUCTURE_FIELD}.make ("x_width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("xpos"),
					create {CE_STRUCTURE_FIELD}.make ("ypos"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("link_num")
				>>)
			init_structure_info
		end

end
