class
	PD_WINDOW

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create handler.make
			create data.make
			create term.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_WINDOW] assign set_next

	prev: CE_POINTER [PD_WINDOW] assign set_prev

	handler: CE_ROUTINE assign set_handler

	data: CE_POINTER [ANY] assign set_data

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	term: CE_POINTER [PD_TERMINAL] assign set_term

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_WINDOW])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_WINDOW])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_handler (a_handler: CE_ROUTINE)
		do
			handler := a_handler
			update_memory_field ("handler")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			term := a_term
			update_memory_field ("term")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			handler := a_other.handler
			data := a_other.data
			xp := a_other.xp
			yp := a_other.yp
			term := a_other.term
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				handler.is_equal (a_other.handler) and
				data.is_equal (a_other.data) and
				xp = a_other.xp and
				yp = a_other.yp and
				term.is_equal (a_other.term)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("handler"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("term")
				>>)
			init_structure_info
		end

end
