class
	P_CACHE

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create cache.make (<<1>>)
		end

feature {ANY} -- attributes

	cache: CE_ARRAY [PD_LIST_HEAD]

	cache_count: INTEGER_32 assign set_cache_count

	set_cache_count (a_cache_count: INTEGER_32)
		do
			cache_count := a_cache_count
		end

	cache_size: INTEGER_32 assign set_cache_size

	set_cache_size (a_cache_size: INTEGER_32)
		do
			cache_size := a_cache_size
		end

	page_size: INTEGER_32 assign set_page_size

	set_page_size (a_page_size: INTEGER_32)
		do
			page_size := a_page_size
		end

feature {ANY} -- routines

	add_fragment (a_e: CE_POINTER [PD_CACHE_ENTRY]; a_offset: INTEGER_32; a_data: CE_POINTER [NATURAL_8]; a_length: INTEGER_32): INTEGER_32
		local
			l_f: CE_POINTER [PD_FRAGMENT]
			l_nf: CE_POINTER [PD_FRAGMENT]
			l_a: INTEGER_32
			l_trunc: INTEGER_32
			l_ca: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_nf.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := 0
					l_trunc := 0
					if not a_length.to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if not (a_offset + a_length < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_offset + a_length < a_offset) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 89])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
				when 6 then -- if done
						if not (a_offset.to_natural_32 + ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or ((page_size - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64) < {NATURAL_32} 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (a_offset.to_natural_32 + ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or ((page_size - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64) < a_offset.to_natural_32) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 90])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
				when 11 then -- if done
						if a_e.item.length < a_offset + a_length then
							a_e.item.length := a_offset + a_length
						end
						l_tmp := cache_count
						cache_count := cache_count + 1
						a_e.item.count := l_tmp.to_natural_32
						l_f := create {CE_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
				when 12 then -- loop condition:
						if not (not js.loop_done and then (not l_f.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))) then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						if l_f.item.offset > a_offset then
							js.break
						end
						if not js.loop_jumped and then (l_f.item.offset <= a_offset) then
							if l_f.item.offset + l_f.item.length >= a_offset then
								if a_offset + a_length > l_f.item.offset + l_f.item.length then
									if (memcmp (create {CE_POINTER [ANY]}.make_cast (((l_f.item.data + a_offset) - l_f.item.offset)), create {CE_POINTER [ANY]}.make_cast (a_data), ((l_f.item.offset + l_f.item.length) - a_offset).to_natural_32)).to_boolean then
										l_trunc := 1
									end
									l_a := 1
									if (a_offset - l_f.item.offset) + a_length <= l_f.item.real_length then
										a_e.item.data_size := a_e.item.data_size + ((a_offset + a_length) - (l_f.item.offset + l_f.item.length))
										cache_size := cache_size + ((a_offset + a_length) - (l_f.item.offset + l_f.item.length))
										l_f.item.length := (a_offset - l_f.item.offset) + a_length
									else
										a_e.item.data_size := a_e.item.data_size + (-((l_f.item.offset + l_f.item.length) - a_offset))
										cache_size := cache_size + (-((l_f.item.offset + l_f.item.length) - a_offset))
										l_f.item.length := a_offset - l_f.item.offset
										l_f := l_f.item.next
										js.break
									end
								elseif (memcmp (create {CE_POINTER [ANY]}.make_cast (((l_f.item.data + a_offset) - l_f.item.offset)), create {CE_POINTER [ANY]}.make_cast (a_data), a_length.to_natural_32)).to_boolean then
									l_trunc := 1
								end
								if not js.loop_jumped then
									memcpy (create {CE_POINTER [ANY]}.make_cast (((l_f.item.data + a_offset) - l_f.item.offset)), create {CE_POINTER [ANY]}.make_cast (a_data), a_length.to_natural_32).do_nothing
									l_pos := -1 + 21 -- goto ch_o
								end
							end
						end
				when 14 then
						if not js.loop_jumped then
							l_f := l_f.item.next
						end
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						l_ca := ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or ((page_size - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64).to_integer_32
						if not (l_ca.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not (l_ca < 0) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___1:
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 119])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
				when 20 then -- if done
						l_nf := create {CE_POINTER [PD_FRAGMENT]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 120, (((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + l_ca.to_natural_32).to_natural_32)))
						l_a := 1
						a_e.item.data_size := a_e.item.data_size + a_length
						cache_size := cache_size + a_length
						l_nf.item.offset := a_offset
						l_nf.item.length := a_length
						l_nf.item.real_length := ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or ((page_size - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64).to_integer_32
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_nf.item.data)), create {CE_POINTER [ANY]}.make_cast (a_data), a_length.to_natural_32).do_nothing
						from
						until
							js.loop_done
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_f.item.prev))
							l_nf.item.next := (l_f.item.prev).item.next
							l_nf.item.prev := l_f.item.prev;
							(l_f.item.prev).item.next := l_nf;
							(l_nf.item.next).item.prev := l_nf
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_f.item.prev))
							js.break
						end
						l_f := l_nf
				when 21 then -- ch_o:
						from
						until
							js.loop_done
						loop
							if not (l_f.item.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
								if not (l_f.item.offset + l_f.item.length > (l_f.item.next).item.offset) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_f.item.offset + l_f.item.length < (l_f.item.next).item.offset + (l_f.item.next).item.length then
									l_nf := create {CE_POINTER [PD_FRAGMENT]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 132, create {CE_POINTER [ANY]}.make_cast (l_f), (((((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + ((l_f.item.next).item.offset).to_natural_32) - (l_f.item.offset).to_natural_32) + ((l_f.item.next).item.length).to_natural_32).to_natural_32)));
									(l_nf.item.prev).item.next := l_nf;
									(l_nf.item.next).item.prev := l_nf
									l_f := l_nf
									if (memcmp (create {CE_POINTER [ANY]}.make_cast (((l_f.item.data + (l_f.item.next).item.offset) - l_f.item.offset)), create {CE_POINTER [ANY]}.make_cast (((l_f.item.next).item.data)), ((l_f.item.offset + l_f.item.length) - (l_f.item.next).item.offset).to_natural_32)).to_boolean then
										l_trunc := 1
									end
									memcpy (create {CE_POINTER [ANY]}.make_cast ((l_f.item.data + l_f.item.length)), create {CE_POINTER [ANY]}.make_cast (((((l_f.item.next).item.data + l_f.item.offset) + l_f.item.length) - (l_f.item.next).item.offset)), ((((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset) - l_f.item.length).to_natural_32).do_nothing
									a_e.item.data_size := a_e.item.data_size + ((((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset) - l_f.item.length)
									cache_size := cache_size + ((((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset) - l_f.item.length)
									l_tmp___5 := ((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset
									l_f.item.real_length := l_tmp___5
									l_f.item.length := l_tmp___5
								elseif (memcmp (create {CE_POINTER [ANY]}.make_cast (((l_f.item.data + (l_f.item.next).item.offset) - l_f.item.offset)), create {CE_POINTER [ANY]}.make_cast (((l_f.item.next).item.data)), ((l_f.item.next).item.length).to_natural_32)).to_boolean then
									l_trunc := 1
								end
								l_nf := l_f.item.next
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_nf));
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_nf.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_nf.item.prev);
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_nf.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_nf.item.next)
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_nf))
								a_e.item.data_size := a_e.item.data_size + (-l_nf.item.length)
								cache_size := cache_size + (-l_nf.item.length)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 146, create {CE_POINTER [ANY]}.make_cast (l_nf))
							end
						end
						if l_trunc.to_boolean then
							truncate_entry (a_e, a_offset + a_length, 0)
						end
						Result := l_a
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cache_info (a_type: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
					inspect a_type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 9 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 1
					Result := cache_size
					js.return
				when 2 then -- switch 1, case 2
					if not js.return_called then
						l_ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.next)
						from
						until
							l_ce.is_equal (cache)
						loop
							l_i := l_i + 1
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						js.return
					end
				when 3 then -- switch 1, case 3
					if not js.return_called then
						l_ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.next)
						from
						until
							l_ce.is_equal (cache)
						loop
							l_i := l_i + ((l_ce.item.refcount).to_boolean).to_integer
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						js.return
					end
				when 4 then -- switch 1, case 4
					if not js.return_called then
						l_ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.next)
						from
						until
							l_ce.is_equal (cache)
						loop
							l_i := l_i + (sched_inst.is_entry_used (l_ce))
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						js.return
					end
				when 5 then -- switch 1, case 9
					if not js.return_called then
						Result := (cache.c_pointer.to_integer_32).to_integer_32
						js.return
					end
				when 6 then -- switch 1, default:
					if not js.return_called then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
							links_inst.errline := 28
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache_info: bad request"))])
						end
					end
				when 7 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	defrag_entry (a_e: CE_POINTER [PD_CACHE_ENTRY])
		local
			l_f: CE_POINTER [PD_FRAGMENT]
			l_g: CE_POINTER [PD_FRAGMENT]
			l_h: CE_POINTER [PD_FRAGMENT]
			l_n: CE_POINTER [PD_FRAGMENT]
			l_x: CE_POINTER [PD_FRAGMENT]
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_g.make
			create l_h.make
			create l_n.make
			create l_x.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_e.item.frag.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
						js.return
					end
					if not js.return_called then
						l_f := create {CE_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
						if (l_f.item.offset).to_boolean then
							js.return
						end
					end
					if not js.return_called then
						l_g := l_f.item.next
						from
						until
							js.loop_done
						loop
							if not l_g.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
								if not (l_g.item.offset <= (l_g.item.prev).item.offset + (l_g.item.prev).item.length) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_g.item.offset < (l_g.item.prev).item.offset + (l_g.item.prev).item.length then
									from
									until
										False
									loop
										links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
										links_inst.errline := 164
										error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fragments overlay"))])
									end
									js.return
								end
								if not js.return_called then
									l_g := l_g.item.next
								end
							end
						end
					end
					if not js.return_called and then (l_g.is_equal (l_f.item.next)) then
						if l_f.item.length = l_f.item.real_length then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_l := (0).to_integer_32
						l_h := l_f
						from
						until
							l_h.is_equal (l_g)
						loop
							l_l := l_l + (l_h.item.length)
							l_h := l_h.item.next
						end
						if not (l_l.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (l_l < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 169])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
				when 6 then -- if done
						l_n := create {CE_POINTER [PD_FRAGMENT]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 170, (((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + l_l.to_natural_32).to_natural_32)))
						l_n.item.offset := (0).to_integer_32
						l_n.item.length := l_l
						l_n.item.real_length := l_l
						l_l := (0).to_integer_32
						l_h := l_f
						from
						until
							l_h.is_equal (l_g)
						loop
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_n.item.data + l_l)), create {CE_POINTER [ANY]}.make_cast ((l_h.item.data)), (l_h.item.length).to_natural_32).do_nothing
							l_l := l_l + (l_h.item.length)
							l_x := l_h
							l_h := l_h.item.prev
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_x));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_x.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_x.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_x.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_x.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_x))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 185, create {CE_POINTER [ANY]}.make_cast (l_x))
							l_h := l_h.item.next
						end
						from
						until
							js.loop_done
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
							l_n.item.next := (create {CE_POINTER [PD_FRAGMENT]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))).item.next
							l_n.item.prev := create {CE_POINTER [PD_FRAGMENT]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))));
							(create {CE_POINTER [PD_FRAGMENT]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))).item.next := l_n;
							(l_n.item.next).item.prev := l_n
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
							js.break
						end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	delete_cache_entry (a_e: CE_POINTER [PD_CACHE_ENTRY])
		do
			if (a_e.item.refcount).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
					links_inst.errline := 270
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("deleteing locked cache entry"))])
				end
			end
			if (sched_inst.is_entry_used (a_e)).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
					links_inst.errline := 272
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("deleting loading cache entry"))])
				end
			end
			delete_entry_content (a_e)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_e));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_e.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_e.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_e.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_e.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_e))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 276, create {CE_POINTER [ANY]}.make_cast (a_e.item.url))
			if (not (a_e.item.head).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 277, create {CE_POINTER [ANY]}.make_cast (a_e.item.head))
			end
			if (not (a_e.item.last_modified).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 278, create {CE_POINTER [ANY]}.make_cast (a_e.item.last_modified))
			end
			if (not (a_e.item.redirect).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 279, create {CE_POINTER [ANY]}.make_cast (a_e.item.redirect))
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 283, create {CE_POINTER [ANY]}.make_cast (a_e))
		end

	delete_entry_content (a_e: CE_POINTER [PD_CACHE_ENTRY])
		local
			l_tmp: INTEGER_32
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a__.make

			l_tmp := cache_count
			cache_count := cache_count + 1
			a_e.item.count := l_tmp.to_natural_32
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_e.item.frag.next)
			from
			until
				l_a__.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_e.item.frag.prev)
			from
			until
				l_a__.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(a_e.item.frag.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
			loop
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_e.item.frag.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 254, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
			a_e.item.length := (0).to_integer_32
			a_e.item.incomplete := 1
			cache_size := cache_size - (a_e.item.data_size)
			if cache_size < 0 then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
					links_inst.errline := 258
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache_size underflow: %%ld")), cache_size])
				end
				cache_size := 0
			end
			a_e.item.data_size := (0).to_integer_32
			if (not (a_e.item.last_modified).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 263, create {CE_POINTER [ANY]}.make_cast (a_e.item.last_modified))
				a_e.item.last_modified := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	extract_proxy (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_a: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_a.make

			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url))) < {NATURAL_32} 8 then
				Result := a_url
				js.return
			elseif (links_inst.casecmp (a_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("proxy://")), (8).to_natural_32)).to_boolean then
				Result := a_url
				js.return
			end
			if not js.return_called then
				l_a := strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((a_url + 8)), ('/').code)
				if l_a.is_void then
					Result := a_url
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((l_a + 1)))
			end
		end

	find_in_cache (a_url: CE_POINTER [NATURAL_8]; a_f: CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]): INTEGER_32
		local
			l_url: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			js: JUMP_STATE
		do
			create l_url.make
			create l_e.make

			l_url := a_url
			l_url := extract_proxy (l_url)
			l_e := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.next)
			from
			until
				not (not js.loop_done and then (not l_e.is_equal (cache)))
			loop
				if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_e.item.url), create {CE_POINTER [INTEGER_8]}.make_cast (l_url))).to_boolean then
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e));
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_e.item.prev);
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_e.item.next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e))
					from
					until
						js.loop_done
					loop
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (cache))
						l_e.item.next := (create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache)).item.next
						l_e.item.prev := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache);
						(create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache)).item.next := l_e;
						(l_e.item.next).item.prev := l_e
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (cache))
						js.break
					end
					a_f.item := l_e
					Result := 0
					js.return
				end
				if not js.return_called then
					l_e := l_e.item.next
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	free_entry_to (a_e: CE_POINTER [PD_CACHE_ENTRY]; a_off: INTEGER_32)
		local
			l_f: CE_POINTER [PD_FRAGMENT]
			l_g: CE_POINTER [PD_FRAGMENT]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_f.make
			create l_g.make

			l_f := create {CE_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
			from
			until
				not (not js.loop_done and then (not l_f.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
			loop
				if l_f.item.offset + l_f.item.length <= a_off then
					a_e.item.data_size := a_e.item.data_size + (-l_f.item.length)
					cache_size := cache_size + (-l_f.item.length)
					l_g := l_f
					l_f := l_f.item.prev
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_g));
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_g.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_g.item.prev);
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_g.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_g.item.next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_g))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 242, create {CE_POINTER [ANY]}.make_cast (l_g))
				elseif l_f.item.offset < a_off then
					a_e.item.data_size := a_e.item.data_size + (l_f.item.offset - a_off)
					cache_size := cache_size + (l_f.item.offset - a_off)
					l_tmp := l_f.item.length - (a_off - l_f.item.offset)
					l_f.item.length := l_tmp
					memmove (create {CE_POINTER [ANY]}.make_cast ((l_f.item.data)), create {CE_POINTER [ANY]}.make_cast ((l_f.item.data + (a_off - l_f.item.offset))), l_tmp.to_natural_32).do_nothing
					l_f.item.offset := a_off
				else
					js.break
				end
				if not js.loop_jumped then
					l_f := l_f.item.next
				end
			end
		end

	garbage_collection (a_u: INTEGER_32)
		local
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_f: CE_POINTER [PD_CACHE_ENTRY]
			l_ncs: INTEGER_32
			l_ccs: INTEGER_32
			l_no: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_f.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ncs := cache_size
					l_ccs := 0
					l_no := 0
					if not a_u.to_boolean then
						if cache_size <= default_inst.memory_cache_size.item then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_e := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.next)
				when 2 then -- loop condition:
						if not (not js.loop_done and then (not l_e.is_equal (cache))) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						if not ((l_e.item.refcount).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not ((sched_inst.is_entry_used (l_e)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_ncs := l_ncs - (l_e.item.data_size)
						if l_ncs < 0 then
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
								links_inst.errline := 295
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache_size underflow: %%ld")), l_ncs])
							end
							l_ncs := 0
						end
				when 8 then -- if done
						l_ccs := l_ccs + (l_e.item.data_size)
						l_e := l_e.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						if l_ccs /= cache_size then
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
								links_inst.errline := 300
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache size badly computed: %%ld != %%ld")), cache_size, l_ccs])
								cache_size := l_ccs
							end
						end
						if not a_u.to_boolean then
							if l_ncs <= default_inst.memory_cache_size.item then
								js.return
							end
						end
				when 10 then -- if done
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 11 then -- if:
						l_e := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.prev)
				when 12 then -- loop condition:
						if not (not js.loop_done and then (not l_e.is_equal (cache))) then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						if not a_u.to_boolean then
							if l_ncs <= (default_inst.memory_cache_size.item * 9) // 10 then
								l_pos := -1 + 16 -- goto g
							end
						end
				when 14 then
						if (l_e.item.refcount).to_boolean then
							l_no := 1
							l_e.item.tgc := 0
							js.continue
						elseif (sched_inst.is_entry_used (l_e)).to_boolean then
							l_no := 1
							l_e.item.tgc := 0
							js.continue
						end
						if not js.loop_jumped then
							l_e.item.tgc := 1
							l_ncs := l_ncs - (l_e.item.data_size)
							if l_ncs < 0 then
								from
								until
									False
								loop
									links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
									links_inst.errline := 311
									error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache_size underflow: %%ld")), l_ncs])
								end
								l_ncs := 0
							end
						end
						if js.loop_increment then
							l_e := l_e.item.prev
						end
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						if l_ncs.to_boolean then
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c"))
								links_inst.errline := 315
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache_size(%%ld) is larger than size of all objects(%%ld)")), cache_size, cache_size - l_ncs])
							end
						end
				when 16 then -- g:
						l_e := l_e.item.next
						if l_e.is_equal (cache) then
							js.return
						end
				when 17 then -- if done
					if not js.return_called then
						if not a_u.to_boolean then
							l_f := l_e
							from
							until
								l_f.is_equal (cache)
							loop
								if l_ncs + l_f.item.data_size <= (default_inst.memory_cache_size.item * 9) // 10 then
									l_ncs := l_ncs + (l_f.item.data_size)
									l_f.item.tgc := 0
								end
								l_f := l_f.item.next
							end
						end
						l_f := l_e
						from
						until
							l_f.is_equal (cache)
						loop
							l_f := l_f.item.next
							if ((l_f.item.prev).item.tgc).to_boolean then
								delete_cache_entry (l_f.item.prev)
							end
						end
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cache_entry (a_url: CE_POINTER [NATURAL_8]; a_f: CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]): INTEGER_32
		local
			l_url: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_url.make
			create l_e.make

			l_url := a_url
			if not (find_in_cache (l_url, a_f)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				main_inst.shrink_memory (0)
				l_url := extract_proxy (l_url)
				l_e := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 60, (create {PD_CACHE_ENTRY}.make).structure_size.to_natural_32)))
				memset (create {CE_POINTER [ANY]}.make_cast (l_e), 0, (create {PD_CACHE_ENTRY}.make).structure_size.to_natural_32).do_nothing
				l_e.item.url := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 62, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_url))) + {NATURAL_32} 1)))
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_e.item.url), create {CE_POINTER [INTEGER_8]}.make_cast (l_url)).do_nothing
				l_e.item.length := (0).to_integer_32
				l_e.item.incomplete := 1
				l_e.item.data_size := (0).to_integer_32
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
				l_e.item.frag.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))
				l_e.item.frag.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
				l_tmp___3 := cache_count
				cache_count := cache_count + 1
				l_e.item.count := l_tmp___3.to_natural_32
				l_e.item.refcount := 0
				from
				until
					js.loop_done
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (cache))
					l_e.item.next := (create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache)).item.next
					l_e.item.prev := create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache);
					(create {CE_POINTER [PD_CACHE_ENTRY]}.make_cast (cache)).item.next := l_e;
					(l_e.item.next).item.prev := l_e
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (cache))
					js.break
				end
				a_f.item := l_e
				Result := 0
			end
		end

	init_cache
		local
			l_tmp___1: INTEGER_32
		do
			if (getpagesize).to_boolean then
				if (getpagesize) < 65_536 then
					l_tmp___1 := getpagesize
					if not ((l_tmp___1).bit_and (((getpagesize) - 1))).to_boolean then
						page_size := getpagesize
					end
				end
			end
		end

	truncate_entry (a_e: CE_POINTER [PD_CACHE_ENTRY]; a_off: INTEGER_32; a_final: INTEGER_32)
		local
			l_modified: INTEGER_32
			l_f: CE_POINTER [PD_FRAGMENT]
			l_g: CE_POINTER [PD_FRAGMENT]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_g.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_modified := 0
					if a_e.item.length > a_off then
						a_e.item.length := a_off
						a_e.item.incomplete := 1
					end
					l_f := create {CE_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not l_f.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_f.item.offset >= a_off) then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | del:
						from
						until
							l_f.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
						loop
							l_modified := 1
							a_e.item.data_size := a_e.item.data_size + (-l_f.item.length)
							cache_size := cache_size + (-l_f.item.length)
							l_g := l_f.item.next
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_f));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_f.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_f.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_f.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_f.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_f))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 207, create {CE_POINTER [ANY]}.make_cast (l_f))
							l_f := l_g
						end
						l_pos := -1 + 6 -- goto ret
				when 4 then
						if l_f.item.offset + l_f.item.length > a_off then
							l_modified := 1
							a_e.item.data_size := a_e.item.data_size + (-((l_f.item.offset + l_f.item.length) - a_off))
							cache_size := cache_size + (-((l_f.item.offset + l_f.item.length) - a_off))
							l_f.item.length := a_off - l_f.item.offset
							if a_final.to_boolean then
								l_g := create {CE_POINTER [PD_FRAGMENT]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache.c")), 217, create {CE_POINTER [ANY]}.make_cast (l_f), (((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + (l_f.item.length).to_natural_32).to_natural_32)));
								(l_g.item.next).item.prev := l_g;
								(l_g.item.prev).item.next := l_g
								l_f := l_g
								l_f.item.real_length := l_f.item.length
							end
							l_f := l_f.item.next
							l_pos := -1 + 3 -- goto del
						end
				when 5 then
						l_f := l_f.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- ret:
					if l_modified.to_boolean then
						l_tmp___0 := cache_count
						cache_count := cache_count + 1
						a_e.item.count := l_tmp___0.to_natural_32
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
