class
	P_CHARSETS

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create no_str.make
			create strange_chars.make (<<32>>)
			create strings.make (<<256, 2>>)
			create table_dirty_workaround_for_name_clash_with_libraries_on_macos.make (<<256>>)
			create utf_buffer.make (<<7>>)
			create utf_table.make (<<256>>)
		end

feature {ANY} -- attributes

	first: INTEGER_32 assign set_first

	set_first (a_first: INTEGER_32)
		do
			first := a_first
		end

	lfr: INTEGER_32 assign set_lfr

	set_lfr (a_lfr: INTEGER_32)
		do
			lfr := a_lfr
		end

	lfr___0: INTEGER_32 assign set_lfr___0

	set_lfr___0 (a_lfr___0: INTEGER_32)
		do
			lfr___0 := a_lfr___0
		end

	lto: INTEGER_32 assign set_lto

	set_lto (a_lto: INTEGER_32)
		do
			lto := a_lto
		end

	no_str: CE_POINTER [NATURAL_8] assign set_no_str

	set_no_str (a_no_str: CE_POINTER [NATURAL_8])
		do
			no_str := a_no_str
		end

	strange_chars: CE_ARRAY [INTEGER_32]

	strings: CE_ARRAY [CE_ARRAY [INTEGER_8]]

	table_dirty_workaround_for_name_clash_with_libraries_on_macos: CE_ARRAY [PD_CONV_TABLE]

	utf_buffer: CE_ARRAY [NATURAL_8]

	utf_table: CE_ARRAY [PD_CONV_TABLE]

	utf_table_init: INTEGER_32 assign set_utf_table_init

	set_utf_table_init (a_utf_table_init: INTEGER_32)
		do
			utf_table_init := a_utf_table_init
		end

feature {ANY} -- routines

	add_utf_8 (a_ct: CE_POINTER [PD_CONV_TABLE]; a_u: INTEGER_32; a_str: CE_POINTER [NATURAL_8])
		local
			l_ct: CE_POINTER [PD_CONV_TABLE]
			l_p: CE_POINTER [NATURAL_8]
			l_nct: CE_POINTER [PD_CONV_TABLE]
			js: JUMP_STATE
		do
			create l_ct.make
			create l_p.make
			create l_nct.make

			l_ct := a_ct
			l_p := (encode_utf_8 (a_u))
			from
			until
				not (not js.loop_done and then ((l_p[1]).to_boolean))
			loop
				if ((l_ct + (l_p.item).to_integer_32).item.t).to_boolean then
					l_ct := (l_ct + (l_p.item).to_integer_32).item.u.tbl
				else
					if not ((l_ct + (l_p.item).to_integer_32).item.u.str).is_equal (no_str) then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c"))
							links_inst.errline := 162
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad utf encoding #1"))])
						end
						js.return
					end
					if not js.return_called then
						l_nct := create {CE_POINTER [PD_CONV_TABLE]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 165, (create {PD_CONV_TABLE}.make).structure_size.to_natural_32 * {NATURAL_32} 256)))
						memset (create {CE_POINTER [ANY]}.make_cast (l_nct), 0, (create {PD_CONV_TABLE}.make).structure_size.to_natural_32 * {NATURAL_32} 256).do_nothing
						new_translation_table (l_nct);
						(l_ct + (l_p.item).to_integer_32).item.t := 1;
						(l_ct + (l_p.item).to_integer_32).item.u.tbl := l_nct
						l_ct := l_nct
					end
				end
				if not js.return_called then
					l_p := l_p + 1
				end
			end
			if not js.return_called and then (((l_ct + (l_p.item).to_integer_32).item.t).to_boolean) then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c"))
					links_inst.errline := 175
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad utf encoding #2"))])
				end
				js.return
			end
			if not js.return_called and then (((l_ct + (l_p.item).to_integer_32).item.u.str).is_equal (no_str)) then
				(l_ct + (l_p.item).to_integer_32).item.u.str := a_str
			end
		end

	charset_upcase (a_ch: NATURAL_8; a_cp: INTEGER_32): NATURAL_8
		local
			l_u: INTEGER_32
			l_res: INTEGER_32
			l_str: CE_POINTER [NATURAL_8]
			l__s: INTEGER_32
			l__e: INTEGER_32
			l__m: INTEGER_32
			js: JUMP_STATE
		do
			create l_str.make

			if a_ch.to_integer_32 < 128 then
				Result := (links_inst.upcase (a_ch))
				js.return
			end
			if not js.return_called then
				l_u := cp2u (a_ch, a_cp)
				l__s := 0
				l__e := (((create {PD_UNICODE_UPCASE}.make).structure_size.to_natural_32 * (674).to_natural_32) // (create {PD_UNICODE_UPCASE}.make).structure_size.to_natural_32 - {NATURAL_32} 1).to_integer_32
				from
				until
					js.loop_done
				loop
					if not (l__s <= l__e) then
						l_res := -1
						if l_res.to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l__m := (l__s + l__e) // 2
						if upcase_inst.unicode_upcase[l__m].lo = l_u then
							l_res := l__m
							js.break
						end
					end
					if not js.loop_jumped then
						if upcase_inst.unicode_upcase[l__m].lo > l_u then
							l__e := l__m - 1
						end
						if upcase_inst.unicode_upcase[l__m].lo < l_u then
							l__s := l__m + 1
						end
					end
				end
				if l_res = -1 then
					Result := a_ch
					js.return
				end
			end
			if not js.return_called then
				l_str := u2cp (upcase_inst.unicode_upcase[l_res].up, a_cp, 0)
				if l_str.is_void then
					Result := a_ch
					js.return
				elseif not (l_str[0]).to_boolean then
					Result := a_ch
					js.return
				elseif (l_str[1]).to_boolean then
					Result := a_ch
					js.return
				end
			end
			if not js.return_called then
				Result := (l_str[0])
			end
		end

	charset_upcase_string (a_chp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_cp: INTEGER_32)
		local
			l_ch: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
		do
			create l_ch.make

			l_ch := a_chp.item
			l_i := 0
			from
			until
				not ((l_ch[l_i]).to_boolean)
			loop
				l_ch[l_i] := charset_upcase (l_ch[l_i], a_cp)
				l_i := l_i + 1
			end
		end

	convert_string (a_ct: CE_POINTER [PD_CONV_TABLE]; a_c: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_buffer___0: CE_POINTER [NATURAL_8]
			l_bp: INTEGER_32
			l_pp: INTEGER_32
			l_i: INTEGER_32
			l_e: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_t: CE_POINTER [PD_CONV_TABLE]
			l_i___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_i___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buffer___0.make
			create l_e.make
			create l_t.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bp := 0
					l_pp := 0
					if (not a_ct.is_void) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_i := 0
				when 2 then -- loop condition:
						if not (l_i < a_l) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if (a_c[l_i]).to_integer_32 = 38 then
							l_pos := -1 + 6 -- goto xx
						end
				when 4 then
						l_i := l_i + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 326, a_c, a_l))
						js.return
						if js.return_called then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | xx:
						
				when 7 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 30 -- skip if block
						end
				when 8 then -- if:
							l_buffer___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 329, (64).to_natural_32)))
				when 9 then -- loop condition:
							if not (not js.loop_done and then (l_pp < a_l)) then
								l_pos := -1 + 29 -- skip loop
							end
				when 10 then -- loop body:
							if not ((a_c[l_pp]).to_integer_32 < 128) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if (a_c[l_pp]).to_integer_32 = 38 then
								l_pos := -1 + 13 -- skip if block
							end
				when 12 then -- if: | putc:
							l_tmp___1 := l_bp
							l_bp := l_bp + 1
							l_tmp___2 := l_pp
							l_pp := l_pp + 1
							l_buffer___0[l_tmp___1] := a_c[l_tmp___2]
							if not ((l_bp).bit_and (63)).to_boolean then
								if l_bp.to_natural_32 > {NATURAL_32} 2_147_483_583 then
									from
									until
										False
									loop
										error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("charsets.c"), 336])
										kbd_inst.fatal_tty_exit
										exit (4)
									end
								end
								l_buffer___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 337, create {CE_POINTER [ANY]}.make_cast (l_buffer___0), (l_bp + 64).to_natural_32)))
							end
							js.continue
				when 13 then -- if done | if done
							if js.loop_jumped then
								l_pos := -1 + 28 -- skip if block
							end
				when 14 then -- if:
							if (a_c[l_pp]).to_integer_32 = 38 then
								l_pos := -1 + 24 -- skip if block
							end
				when 15 then -- if:
							if a_ct.is_void then
								l_pos := -1 + 12 -- goto putc
							end
				when 16 then
							l_t := a_ct
							l_i___0 := l_pp
				when 17 then -- decode:
							if ((l_t + (a_c[l_i___0]).to_integer_32).item.t).to_boolean then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_e := (l_t + (a_c[l_i___0]).to_integer_32).item.u.str
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 20 then -- else:
							l_tmp___4 := l_i___0
							l_i___0 := l_i___0 + 1
							l_t := (l_t + (a_c[l_tmp___4]).to_integer_32).item.u.tbl
							if l_i___0 >= a_l then
								l_pos := -1 + 12 -- goto putc
							end
				when 21 then
							l_pos := -1 + 17 -- goto decode
				when 22 then
							l_pp := l_i___0 + 1
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 24 then -- else:
							l_i___1 := l_pp + 1
							if (links_inst.d_opt.item.plain).to_boolean then
								l_pos := -1 + 12 -- goto putc
							end
				when 25 then
							from
							until
								js.loop_done
							loop
								if l_i___1 < a_l then
									if (a_c[l_i___1]).to_integer_32 /= 59 then
										if (a_c[l_i___1]).to_integer_32 /= 38 then
											if not ((a_c[l_i___1]).to_integer_32 > 32) then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_i___1 := l_i___1 + 1
								end
							end
							l_e := get_entity_string (a_c + (l_pp + 1), (l_i___1 - l_pp) - 1, links_inst.d_opt.item.cp)
							if l_e.is_void then
								l_pos := -1 + 12 -- goto putc
							end
				when 26 then
							if l_i___1 < a_l then
								if (a_c[l_i___1]).to_integer_32 = 59 then
									l_tmp___5 := 1
								else
									l_tmp___5 := 0
								end
							else
								l_tmp___5 := 0
							end
							l_pp := l_i___1 + l_tmp___5
				when 27 then -- if done
							if not (l_e[0]).to_boolean then
								js.continue
							end
				when 28 then -- if done
							if not js.loop_jumped and then (not (l_e[1]).to_boolean) then
								l_tmp___6 := l_bp
								l_bp := l_bp + 1
								l_buffer___0[l_tmp___6] := l_e[0]
								if not ((l_bp).bit_and (63)).to_boolean then
									if l_bp.to_natural_32 > {NATURAL_32} 2_147_483_583 then
										from
										until
											False
										loop
											error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("charsets.c"), 367])
											kbd_inst.fatal_tty_exit
											exit (4)
										end
									end
									l_buffer___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 368, create {CE_POINTER [ANY]}.make_cast (l_buffer___0), (l_bp + 64).to_natural_32)))
								end
								js.continue
							end
							if not js.loop_jumped then
								from
								until
									not (not js.loop_done and then ((l_e.item).to_boolean))
								loop
									l_tmp___8 := l_bp
									l_bp := l_bp + 1
									l_tmp___9 := l_e
									l_e := l_e + 1
									l_buffer___0[l_tmp___8] := l_tmp___9.item
									if not ((l_bp).bit_and (63)).to_boolean then
										if l_bp.to_natural_32 > {NATURAL_32} 2_147_483_583 then
											from
											until
												False
											loop
												error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("charsets.c"), 375])
												kbd_inst.fatal_tty_exit
												exit (4)
											end
										end
										l_buffer___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 376, create {CE_POINTER [ANY]}.make_cast (l_buffer___0), (l_bp + 64).to_natural_32)))
									end
								end
							end
							l_pos := -1 + 9 -- back to loop condition
				when 29 then -- loop done
							l_buffer___0[l_bp] := (0).to_natural_8
							Result := l_buffer___0
				when 30 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cp2u (a_ch: NATURAL_8; a_from: INTEGER_32): INTEGER_32
		local
			l_e: CE_POINTER [PD_TABLE_ENTRY]
			js: JUMP_STATE
		do
			create l_e.make

			if a_from < 0 then
				Result := a_ch.to_integer_32
				js.return
			elseif a_ch.to_integer_32 < 128 then
				Result := a_ch.to_integer_32
				js.return
			end
			if not js.return_called then
				l_e := codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos
				from
				until
					not (not js.loop_done and then ((l_e.item.c).to_boolean))
				loop
					if (l_e.item.c).to_integer_32 = a_ch.to_integer_32 then
						Result := (l_e.item.u)
						js.return
					end
					if not js.return_called then
						l_e := l_e + 1
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	encode_utf_8 (a_u: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			memset (create {CE_POINTER [ANY]}.make_cast (utf_buffer), 0, (7).to_natural_32).do_nothing
			if a_u < 128 then
				utf_buffer[0] := a_u.to_natural_8
			elseif a_u < 2_048 then
				utf_buffer[0] := ((192).bit_or (((((a_u).bit_shift_right (6))).bit_and (31)))).to_natural_8
				utf_buffer[1] := ((128).bit_or (((a_u).bit_and (63)))).to_natural_8
			elseif a_u < 65_536 then
				utf_buffer[0] := ((224).bit_or (((((a_u).bit_shift_right (12))).bit_and (15)))).to_natural_8
				utf_buffer[1] := ((128).bit_or (((((a_u).bit_shift_right (6))).bit_and (63)))).to_natural_8
				utf_buffer[2] := ((128).bit_or (((a_u).bit_and (63)))).to_natural_8
			elseif a_u < 2_097_152 then
				utf_buffer[0] := ((240).bit_or (((((a_u).bit_shift_right (18))).bit_and (15)))).to_natural_8
				utf_buffer[1] := ((128).bit_or (((((a_u).bit_shift_right (12))).bit_and (63)))).to_natural_8
				utf_buffer[2] := ((128).bit_or (((((a_u).bit_shift_right (6))).bit_and (63)))).to_natural_8
				utf_buffer[3] := ((128).bit_or (((a_u).bit_and (63)))).to_natural_8
			elseif a_u < 67_108_864 then
				utf_buffer[0] := ((248).bit_or (((((a_u).bit_shift_right (24))).bit_and (15)))).to_natural_8
				utf_buffer[1] := ((128).bit_or (((((a_u).bit_shift_right (18))).bit_and (63)))).to_natural_8
				utf_buffer[2] := ((128).bit_or (((((a_u).bit_shift_right (12))).bit_and (63)))).to_natural_8
				utf_buffer[3] := ((128).bit_or (((((a_u).bit_shift_right (6))).bit_and (63)))).to_natural_8
				utf_buffer[4] := ((128).bit_or (((a_u).bit_and (63)))).to_natural_8
			else
				utf_buffer[0] := ((252).bit_or (((((a_u).bit_shift_right (30))).bit_and (1)))).to_natural_8
				utf_buffer[1] := ((128).bit_or (((((a_u).bit_shift_right (24))).bit_and (63)))).to_natural_8
				utf_buffer[2] := ((128).bit_or (((((a_u).bit_shift_right (18))).bit_and (63)))).to_natural_8
				utf_buffer[3] := ((128).bit_or (((((a_u).bit_shift_right (12))).bit_and (63)))).to_natural_8
				utf_buffer[4] := ((128).bit_or (((((a_u).bit_shift_right (6))).bit_and (63)))).to_natural_8
				utf_buffer[5] := ((128).bit_or (((a_u).bit_and (63)))).to_natural_8
			end
			Result := utf_buffer
		end

	free_conv_table
		do
			if not utf_table_init.to_boolean then
				free_utf_table
			end
			if first.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast (table_dirty_workaround_for_name_clash_with_libraries_on_macos), 0, (create {PD_CONV_TABLE}.make).structure_size.to_natural_32 * {NATURAL_32} 256).do_nothing
				first := 0
			end
			new_translation_table (table_dirty_workaround_for_name_clash_with_libraries_on_macos)
			if (not no_str.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 222, create {CE_POINTER [ANY]}.make_cast (no_str))
				no_str := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	free_translation_table (a_p: CE_POINTER [PD_CONV_TABLE])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 256)
			loop
				if ((a_p + l_i).item.t).to_boolean then
					free_translation_table ((a_p + l_i).item.u.tbl)
				end
				l_i := l_i + 1
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 58, create {CE_POINTER [ANY]}.make_cast (a_p))
		end

	free_utf_table
		local
			l_i: INTEGER_32
		do
			l_i := 128
			from
			until
				not (l_i < 256)
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 187, create {CE_POINTER [ANY]}.make_cast (utf_table[l_i].u.str))
				l_i := l_i + 1
			end
		end

	get_cp_index (a_n: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i: INTEGER_32
			l_a: INTEGER_32
			l_p: INTEGER_32
			l_q: INTEGER_32
			l_ii: INTEGER_32
			l_ll: INTEGER_32
			l_tmp: NATURAL_8
			l_tmp___3: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ii := -1
					l_ll := 0
					l_i := 0
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not (codepage_inst.codepages[l_i].name).is_void)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_a := 0
				when 3 then -- loop condition:
						if not (not js.loop_done and then (not (codepage_inst.codepages[l_i].aliases[l_a]).is_void)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_p := 0
				when 5 then -- loop condition:
						if not (not js.loop_done and then ((a_n[l_p]).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_tmp___3 := links_inst.upcase (a_n[l_p])
						if l_tmp___3.to_integer_32 /= (links_inst.upcase ((codepage_inst.codepages[l_i].aliases[l_a])[0])).to_integer_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						l_q := 1
				when 8 then -- loop condition:
						if not (((codepage_inst.codepages[l_i].aliases[l_a])[l_q]).to_boolean) then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						l_tmp := links_inst.upcase (a_n[(l_p + l_q)])
						if l_tmp.to_integer_32 /= (links_inst.upcase ((codepage_inst.codepages[l_i].aliases[l_a])[l_q])).to_integer_32 then
							l_pos := -1 + 12 -- goto fail
						end
				when 10 then
						l_q := l_q + 1
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (codepage_inst.codepages[l_i].aliases[l_a]))) > l_ll.to_natural_32 then
							l_ll := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (codepage_inst.codepages[l_i].aliases[l_a]))).to_integer_32
							l_ii := l_i
						end
				when 12 then -- fail:
						l_p := l_p + 1
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						l_a := l_a + 1
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					Result := l_ii
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cp_mime_name (a_index___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_index___0 < 0 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("none")))
				js.return
			end
			if not js.return_called and then ((codepage_inst.codepages[a_index___0].aliases).is_void) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (codepage_inst.codepages[a_index___0].aliases[0])
			end
		end

	get_cp_name (a_index___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_index___0 < 0 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("none")))
				js.return
			end
			if not js.return_called then
				Result := (codepage_inst.codepages[a_index___0].name)
			end
		end

	get_entity_number (a_st: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_st: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_n: INTEGER_32
			l_c: INTEGER_8
			l_tmp: CE_POINTER [NATURAL_8]
			l_c___0: INTEGER_8
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_st.make
			create l_tmp.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_st := a_st
					l_l := a_l
					l_n := 0
					if (links_inst.upcase (l_st[0])).to_integer_32 /= 88 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_st := l_st + 1
						l_l := l_l - 1
						if not l_l.to_boolean then
							Result := (-1)
							js.return
						elseif l_l > 4 then
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						l_tmp := l_st
						l_st := l_st + 1
						l_c := (links_inst.upcase (l_tmp.item)).to_integer_8
						if not (l_c.to_integer_32 >= 48) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_c.to_integer_32 <= 57 then
							l_n := (l_n * 16 + l_c.to_integer_32) - 48
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_c.to_integer_32 >= 65 then
							if l_c.to_integer_32 <= 70 then
								l_n := ((l_n * 16 + l_c.to_integer_32) - 65) + 10
							else
								Result := (-1)
								js.return
							end
						else
							Result := (-1)
							js.return
						end
				when 7 then
						if not js.return_called and then (l_n >= 65_536) then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_l := l_l - 1
							if not l_l.to_boolean then
								js.break
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if not l_l.to_boolean then
							Result := (-1)
							js.return
						elseif l_l > 5 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								l_tmp___1 := l_st
								l_st := l_st + 1
								l_c___0 := (l_tmp___1.item).to_integer_8
								if l_c___0.to_integer_32 >= 48 then
									if l_c___0.to_integer_32 <= 57 then
										l_n := (l_n * 10 + l_c___0.to_integer_32) - 48
									else
										Result := (-1)
										js.return
									end
								else
									Result := (-1)
									js.return
								end
								if not js.return_called and then (l_n >= 65_536) then
									Result := (-1)
									js.return
								end
								if not js.return_called then
									l_l := l_l - 1
									if not l_l.to_boolean then
										js.break
									end
								end
							end
						end
				when 10 then -- if done
					if not js.return_called then
						Result := l_n
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_entity_string (a_st: CE_POINTER [NATURAL_8]; a_l: INTEGER_32; a_encoding: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_e: INTEGER_32
			l_c: INTEGER_32
			l_m: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_l <= 0 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (a_st[0]).to_integer_32 /= 35 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_l = 1 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_n := get_entity_number (a_st + 1, a_l - 1)
							if l_n = -1 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
						end
						if not js.return_called and then (l_n < 32) then
							l_n := 32
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 4 then -- else:
						l_s := 0
						l_e := 1_001
				when 5 then -- loop condition:
						if not (l_s <= l_e) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_m := (l_s + l_e) // 2
						l_c := xxstrcmp (create {CE_POINTER [NATURAL_8]}.make_cast (entity_inst.entities[l_m].s), a_st, a_l)
						if not l_c.to_boolean then
							l_n := entity_inst.entities[l_m].c
							l_pos := -1 + 9 -- goto f
						end
				when 7 then
						if l_c > 0 then
							l_e := l_m - 1
						else
							l_s := l_m + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | f:
						
				when 10 then -- if done | if done | if done
						if not js.return_called then
							Result := (u2cp (l_n, a_encoding, 1))
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_translation_table (a_from: INTEGER_32; a_to: INTEGER_32): CE_POINTER [PD_CONV_TABLE]
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_j___0: INTEGER_32
			l_u: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp___0.make
			create l_tmp___1.make
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if no_str.is_void then
						no_str := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 230, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*")))
					end
					if first.to_boolean then
						memset (create {CE_POINTER [ANY]}.make_cast (table_dirty_workaround_for_name_clash_with_libraries_on_macos), 0, (create {PD_CONV_TABLE}.make).structure_size.to_natural_32 * {NATURAL_32} 256).do_nothing
						first := 0
					end
					if a_from = -1 then
						Result := (create {CE_POINTER [PD_CONV_TABLE]}.make_shared (default_pointer))
						js.return
					elseif a_to = -1 then
						Result := (create {CE_POINTER [PD_CONV_TABLE]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called and then ((codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos).is_equal (codepage_inst.table_utf_8)) then
						Result := (get_translation_table_to_utf_8 (a_from))
						js.return
					end
					if not js.return_called and then (a_from = lfr___0) then
						if a_to = lto then
							Result := table_dirty_workaround_for_name_clash_with_libraries_on_macos
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						lfr___0 := a_from
						lto := a_to
						new_translation_table (table_dirty_workaround_for_name_clash_with_libraries_on_macos)
						if not ((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos).is_equal (codepage_inst.table_utf_8)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_j := 0
						from
						until
							not (((codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.c).to_boolean)
						loop
							if (codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.u = 160 then
								l_tmp___1 := ce_string ("%/1/")
							else
								if (codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.u = 173 then
									l_tmp___0 := ce_string ("")
								else
									l_tmp___0 := (strings[((codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.c).to_integer_32])
								end
								l_tmp___1 := l_tmp___0
							end
							add_utf_8 (table_dirty_workaround_for_name_clash_with_libraries_on_macos, (codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.u, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1))
							l_j := l_j + 1
						end
						l_i := 0
						from
						until
							uni_7b_inst.unicode_7b[l_i].x = -1
						loop
							if uni_7b_inst.unicode_7b[l_i].x >= 128 then
								add_utf_8 (table_dirty_workaround_for_name_clash_with_libraries_on_macos, uni_7b_inst.unicode_7b[l_i].x, uni_7b_inst.unicode_7b[l_i].s)
							end
							l_i := l_i + 1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						l_i := 128
				when 5 then -- loop condition:
						if not (not js.loop_done and then (l_i < 256)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_j___0 := 0
				when 7 then -- loop condition:
						if not (((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j___0).item.c).to_boolean) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if ((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j___0).item.c).to_integer_32 = l_i then
							l_pos := -1 + 11 -- goto f
						end
				when 9 then
						l_j___0 := l_j___0 + 1
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						js.continue
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | f:
						l_u := create {CE_POINTER [INTEGER_8]}.make_cast ((u2cp ((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j___0).item.u, a_to, 1)))
						if (not l_u.is_void) then
							table_dirty_workaround_for_name_clash_with_libraries_on_macos[l_i].u.str := create {CE_POINTER [NATURAL_8]}.make_cast (l_u)
						end
				when 12 then -- if done
						if js.loop_increment then
							l_i := l_i + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done | if done
						Result := table_dirty_workaround_for_name_clash_with_libraries_on_macos
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_translation_table_to_utf_8 (a_from: INTEGER_32): CE_POINTER [PD_CONV_TABLE]
		local
			l_i: INTEGER_32
			l_u: INTEGER_32
			js: JUMP_STATE
		do
			if a_from = -1 then
				Result := (create {CE_POINTER [PD_CONV_TABLE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called and then (a_from = lfr) then
				Result := utf_table
				js.return
			end
			if not js.return_called then
				if utf_table_init.to_boolean then
					memset (create {CE_POINTER [ANY]}.make_cast (utf_table), 0, (create {PD_CONV_TABLE}.make).structure_size.to_natural_32 * {NATURAL_32} 256).do_nothing
					utf_table_init := 0
				else
					free_utf_table
				end
				l_i := 0
				from
				until
					not (l_i < 128)
				loop
					utf_table[l_i].u.str := create {CE_POINTER [NATURAL_8]}.make_cast ((strings[l_i]))
					l_i := l_i + 1
				end
				if (codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos).is_equal (codepage_inst.table_utf_8) then
					l_i := 128
					from
					until
						not (l_i < 256)
					loop
						utf_table[l_i].u.str := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 200, create {CE_POINTER [NATURAL_8]}.make_cast ((strings[l_i])))
						l_i := l_i + 1
					end
					Result := utf_table
					js.return
				end
			end
			if not js.return_called then
				l_i := 128
				from
				until
					not (l_i < 256)
				loop
					utf_table[l_i].u.str := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_i := l_i + 1
				end
				l_i := 0
				from
				until
					not (((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_i).item.c).to_boolean)
				loop
					l_u := (codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_i).item.u
					if (utf_table[((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_i).item.c).to_integer_32].u.str).is_void then
						utf_table[((codepage_inst.codepages[a_from].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_i).item.c).to_integer_32].u.str := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 207, (encode_utf_8 (l_u)))
					end
					l_i := l_i + 1
				end
				l_i := 128
				from
				until
					not (l_i < 256)
				loop
					if (utf_table[l_i].u.str).is_void then
						utf_table[l_i].u.str := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charsets.c")), 210, no_str)
					end
					l_i := l_i + 1
				end
				Result := utf_table
			end
		end

	is_cp_special (a_index___0: INTEGER_32): INTEGER_32
		do
			Result := ((codepage_inst.codepages[a_index___0].table_dirty_workaround_for_name_clash_with_libraries_on_macos).is_equal (codepage_inst.table_utf_8)).to_integer
		end

	new_translation_table (a_p: CE_POINTER [PD_CONV_TABLE])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 256)
			loop
				if ((a_p + l_i).item.t).to_boolean then
					free_translation_table ((a_p + l_i).item.u.tbl)
				end
				l_i := l_i + 1
			end
			l_i := 0
			from
			until
				not (l_i < 128)
			loop
				(a_p + l_i).item.t := 0;
				(a_p + l_i).item.u.str := create {CE_POINTER [NATURAL_8]}.make_cast ((strings[l_i]))
				l_i := l_i + 1
			end
			from
			until
				not (l_i < 256)
			loop
				(a_p + l_i).item.t := 0;
				(a_p + l_i).item.u.str := no_str
				l_i := l_i + 1
			end
		end

	u2cp (a_u: INTEGER_32; a_to: INTEGER_32; a_fallback: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_u: INTEGER_32
			l_j: INTEGER_32
			l_s: INTEGER_32
			l__s: INTEGER_32
			l__e: INTEGER_32
			l__m: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := a_u
				when 1 then -- again:
					if l_u < 128 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((strings[l_u])))
						js.return
					end
					if not js.return_called and then (l_u = 160) then
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/1/")))
						js.return
					end
					if not js.return_called and then (l_u = 173) then
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						js.return
					end
					if not js.return_called and then (l_u < 160) then
						l_u := strange_chars[l_u - 128]
						if not l_u.to_boolean then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_pos := -1 + 1 -- goto again
						end
					end
				when 2 then
					if not js.return_called then
						l_j := 0
						from
						until
							not (not js.loop_done and then (((codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.c).to_boolean))
						loop
							if (codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.u = l_u then
								Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((strings[((codepage_inst.codepages[a_to].table_dirty_workaround_for_name_clash_with_libraries_on_macos + l_j).item.c).to_integer_32])))
								js.return
							end
							if not js.return_called then
								l_j := l_j + 1
							end
						end
					end
					if not js.return_called and then (not a_fallback.to_boolean) then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l__s := 0
						l__e := 2_315
						from
						until
							js.loop_done
						loop
							if not (l__s <= l__e) then
								l_s := -1
								if l_s.to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								l__m := (l__s + l__e) // 2
								if uni_7b_inst.unicode_7b[l__m].x = l_u then
									l_s := l__m
									js.break
								end
							end
							if not js.loop_jumped then
								if uni_7b_inst.unicode_7b[l__m].x > l_u then
									l__e := l__m - 1
								end
								if uni_7b_inst.unicode_7b[l__m].x < l_u then
									l__s := l__m + 1
								end
							end
						end
						if l_s /= -1 then
							Result := (uni_7b_inst.unicode_7b[l_s].s)
							js.return
						end
					end
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	xxstrcmp (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]; a_l2: INTEGER_32): INTEGER_32
		local
			l_s1: CE_POINTER [NATURAL_8]
			l_s2: CE_POINTER [NATURAL_8]
			l_l2: INTEGER_32
			js: JUMP_STATE
		do
			create l_s1.make
			create l_s2.make

			l_s1 := a_s1
			l_s2 := a_s2
			l_l2 := a_l2
			from
			until
				not (not js.loop_done and then (l_l2.to_boolean))
			loop
				if (l_s1.item).to_integer_32 > (l_s2.item).to_integer_32 then
					Result := 1
					js.return
				end
				if not js.return_called then
					if not (l_s1.item).to_boolean then
						Result := (-1)
						js.return
					elseif (l_s1.item).to_integer_32 < (l_s2.item).to_integer_32 then
						Result := (-1)
						js.return
					end
				end
				if not js.return_called then
					l_s1 := l_s1 + 1
					l_s2 := l_s2 + 1
					l_l2 := l_l2 - 1
				end
			end
			if not js.return_called then
				Result := ((l_s1.item).to_boolean).to_integer
			end
		end

end
