class
	P_FILE

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create last_group.make (<<64>>)
			create last_user.make (<<64>>)
		end

feature {ANY} -- attributes

	last_gid: INTEGER_32 assign set_last_gid

	set_last_gid (a_last_gid: INTEGER_32)
		do
			last_gid := a_last_gid
		end

	last_group: CE_ARRAY [INTEGER_8]

	last_uid: INTEGER_32 assign set_last_uid

	set_last_uid (a_last_uid: INTEGER_32)
		do
			last_uid := a_last_uid
		end

	last_user: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	comp_de (a_d1: CE_POINTER [PD_DIRS]; a_d2: CE_POINTER [PD_DIRS]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_d1.item.f[0]).to_integer_32 = 46 then
				if (a_d1.item.f[1]).to_integer_32 = 46 then
					if not (a_d1.item.f[2]).to_boolean then
						Result := (-1)
						js.return
					end
				end
			end
			if not js.return_called and then ((a_d2.item.f[0]).to_integer_32 = 46) then
				if (a_d2.item.f[1]).to_integer_32 = 46 then
					if not (a_d2.item.f[2]).to_boolean then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called and then ((a_d1.item.s[0]).to_integer_32 = 100) then
				if (a_d2.item.s[0]).to_integer_32 /= 100 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called and then ((a_d1.item.s[0]).to_integer_32 /= 100) then
				if (a_d2.item.s[0]).to_integer_32 = 100 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_d1.item.f), create {CE_POINTER [INTEGER_8]}.make_cast (a_d2.item.f)))
			end
		end

	comp_de_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent comp_de)
		end

	file_func (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_e: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_file: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_name: CE_POINTER [NATURAL_8]
			l_head___0: CE_POINTER [NATURAL_8]
			l_fl: CE_ARRAY [INTEGER_32]
			l_d: CE_POINTER [ANY]
			l_h: INTEGER_32
			l_r: INTEGER_32
			l_stt: CE_ARRAY [SD_STAT]
			l_er___0: INTEGER_32
			l_dir: CE_POINTER [PD_DIRS]
			l_dirl: INTEGER_32
			l_i: INTEGER_32
			l_de: CE_POINTER [SD_DIRENT]
			l_stt___0: CE_ARRAY [SD_STAT]
			l_stp: CE_POINTER [SD_STAT]
			l_p: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___10: INTEGER_32
			l_lnk: CE_POINTER [NATURAL_8]
			l_buf___0: CE_POINTER [NATURAL_8]
			l_size: INTEGER_32
			l_r___0: INTEGER_32
			l_n___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_st: CE_ARRAY [SD_STAT]
			l_n___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___20: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make (<<1>>)
			create l_file.make (<<1>>)
			create l_name.make
			create l_head___0.make
			create l_fl.make (<<1>>)
			create l_d.make
			create l_stt.make (<<1>>)
			create l_dir.make
			create l_de.make
			create l_stt___0.make (<<1>>)
			create l_stp.make
			create l_p.make
			create l_l.make (<<1>>)
			create l_n.make (<<1>>)
			create l_lnk.make
			create l_buf___0.make
			create l_n___0.make (<<1>>)
			create l_st.make (<<1>>)
			create l_n___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if default_inst.anonymous.to_boolean then
						sched_inst.setcstate (a_c, -1_009)
						sched_inst.abort_connection (a_c)
						js.return
					end
					if not js.return_called then
						l_name := get_filename (a_c.item.url)
						if l_name.is_void then
							sched_inst.setcstate (a_c, -1_004)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if not js.return_called then
						if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), l_stt)).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 231, create {CE_POINTER [ANY]}.make_cast (l_name))
							sched_inst.setcstate (a_c, -(errno_location).item)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if not js.return_called and then (((l_stt.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 16_384) then
						if ((l_stt.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 32_768 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 235, create {CE_POINTER [ANY]}.make_cast (l_name))
							sched_inst.setcstate (a_c, -1_200)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_h := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_name), 256])
						if l_h /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_er___0 := (errno_location).item
						l_d := opendir (create {CE_POINTER [INTEGER_8]}.make_cast (l_name))
						if (not l_d.is_void) then
							l_pos := -1 + 7 -- goto dir
						end
				when 3 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 241, create {CE_POINTER [ANY]}.make_cast (l_name))
						sched_inst.setcstate (a_c, -l_er___0)
						sched_inst.abort_connection (a_c)
						js.return
				when 4 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 5 then -- if:
							os_dep_inst.set_bin (l_h)
							if ((l_stt.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 16_384 then
								l_pos := -1 + 19 -- skip if block
							end
				when 6 then -- if:
							l_d := opendir (create {CE_POINTER [INTEGER_8]}.make_cast (l_name))
							close (l_h).do_nothing
							if l_d.is_void then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 253, create {CE_POINTER [ANY]}.make_cast (l_name))
								sched_inst.setcstate (a_c, -(errno_location).item)
								sched_inst.abort_connection (a_c)
								js.return
							end
							if js.return_called then
								l_pos := -1 + 8 -- skip if block
							end
				when 7 then -- if: | dir:
							l_dir := create {CE_POINTER [PD_DIRS]}.make_shared (default_pointer + -1)
							l_dirl := 0
							if (l_name[0]).to_boolean then
								if not (os_dep_inst.dir_sep ((l_name[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_name))) - {NATURAL_32} 1).to_integer_32]).to_integer_8)).to_boolean then
									if (cache_inst.get_cache_entry (a_c.item.url, l_e)).to_boolean then
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 260, create {CE_POINTER [ANY]}.make_cast (l_name))
										closedir (l_d).do_nothing
										sched_inst.setcstate (a_c, -1_004)
										sched_inst.abort_connection (a_c)
										js.return
									end
									if not js.return_called then
										a_c.item.cache := l_e.item
										if (not (l_e.item.item.redirect).is_void) then
											error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 265, create {CE_POINTER [ANY]}.make_cast (l_e.item.item.redirect))
										end
										l_e.item.item.redirect := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 266, a_c.item.url)
										l_e.item.item.redirect_get := 1
										links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_e.item.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 269, create {CE_POINTER [ANY]}.make_cast (l_name))
										closedir (l_d).do_nothing
										l_pos := -1 + 22 -- goto end
									end
								end
							end
				when 8 then
							if js.return_called then
								l_pos := -1 + 18 -- skip if block
							end
				when 9 then -- if:
							last_uid := -1
							last_gid := -1
							l_file.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 275)
							l_fl.item := 0
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<html><head><title>")))
							url_inst.add_conv_str (l_file, l_fl, l_name, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_name))).to_integer_32, -1)
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</title></head><body><h2>Directory ")))
							url_inst.add_conv_str (l_file, l_fl, l_name, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_name))).to_integer_32, -1)
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</h2><pre>")))
							from
							until
								js.loop_done
							loop
								l_de := readdir (l_d)
								if l_de.is_void then
									js.break
								end
								if not js.loop_jumped then
									if not (strcmp ((l_de.item.d_name), ce_string ("."))).to_boolean then
										js.continue
									end
								end
								if not js.loop_jumped then
									if l_dirl.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_DIRS}.make).structure_size.to_natural_32 - {NATURAL_32} 1 then
										from
										until
											False
										loop
											error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("file.c"), 288])
											kbd_inst.fatal_tty_exit
											exit (4)
										end
									end
									l_dir := create {CE_POINTER [PD_DIRS]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 289, create {CE_POINTER [ANY]}.make_cast (l_dir), (l_dirl + 1).to_natural_32 * (create {PD_DIRS}.make).structure_size.to_natural_32)));
									(l_dir + l_dirl).item.f := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 290, create {CE_POINTER [NATURAL_8]}.make_cast ((l_de.item.d_name)))
									l_tmp___10 := l_dirl
									l_dirl := l_dirl + 1
									l_p := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared ((l_dir + l_tmp___10).c_pointer + (create {PD_DIRS}.make).offset_of ("s"))
									l_p.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 291)
									l_l.item := 0
									l_n.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 293, l_name)
									links_inst.add_to_strn (l_n, create {CE_POINTER [NATURAL_8]}.make_cast ((l_de.item.d_name)))
									if (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (l_n.item), l_stt___0)).to_boolean then
										l_stp := create {CE_POINTER [SD_STAT]}.make_shared (default_pointer)
									else
										l_stp := l_stt___0
									end
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 302, create {CE_POINTER [ANY]}.make_cast (l_n.item))
									stat_mode (l_p, l_l, l_stp)
									stat_links (l_p, l_l, l_stp)
									stat_user (l_p, l_l, l_stp, 0)
									stat_user (l_p, l_l, l_stp, 1)
									stat_size (l_p, l_l, l_stp)
									stat_date (l_p, l_l, l_stp)
								end
							end
							closedir (l_d).do_nothing
							if l_dirl.to_boolean then
								qsort (create {CE_POINTER [ANY]}.make_cast (l_dir), l_dirl.to_natural_32, (create {PD_DIRS}.make).structure_size.to_natural_32, (comp_de_address))
							end
							l_i := 0
				when 10 then -- loop condition:
							if not (not js.loop_done and then (l_i < l_dirl)) then
								l_pos := -1 + 17 -- skip loop
							end
				when 11 then -- loop body:
							l_lnk := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							if ((l_dir + l_i).item.s[0]).to_integer_32 /= 108 then
								l_pos := -1 + 16 -- skip if block
							end
				when 12 then -- if:
							l_buf___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_size := 0
							l_n___0.item := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 319, l_name))
							links_inst.add_to_strn (l_n___0, (l_dir + l_i).item.f)
							from
							until
								js.loop_done
							loop
								if (not l_buf___0.is_void) then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 322, create {CE_POINTER [ANY]}.make_cast (l_buf___0))
								end
								l_size := l_size + (64)
								if l_size.to_natural_32 > {NATURAL_32} 2_147_483_647 then
									from
									until
										False
									loop
										error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("file.c"), 324])
										kbd_inst.fatal_tty_exit
										exit (4)
									end
								end
								l_buf___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 325, l_size.to_natural_32)))
								l_r___0 := readlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_n___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___0), l_size.to_natural_32)
								if l_r___0 /= l_size then
									js.break
								end
							end
							if l_r___0 = -1 then
								l_pos := -1 + 14 -- goto yyy
							end
				when 13 then
							l_buf___0[l_r___0] := (0).to_natural_8
							l_lnk := l_buf___0
							l_pos := -1 + 15 -- goto xxx
				when 14 then -- yyy:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 333, create {CE_POINTER [ANY]}.make_cast (l_buf___0))
				when 15 then -- xxx:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 335, create {CE_POINTER [ANY]}.make_cast (l_n___0.item))
				when 16 then -- if done
							links_inst.add_to_str (l_file, l_fl, (l_dir + l_i).item.s)
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<a href=%"./")))
							url_inst.add_conv_str (l_file, l_fl, (l_dir + l_i).item.f, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_dir + l_i).item.f))).to_integer_32, 1)
							if ((l_dir + l_i).item.s[0]).to_integer_32 = 100 then
								links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							elseif (not l_lnk.is_void) then
								l_n___1.item := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 345, l_name))
								links_inst.add_to_strn (l_n___1, (l_dir + l_i).item.f)
								if not (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_n___1.item), l_st)).to_boolean then
									if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
										links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
									end
								end
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 348, create {CE_POINTER [ANY]}.make_cast (l_n___1.item))
							end
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%">")))
							url_inst.add_conv_str (l_file, l_fl, (l_dir + l_i).item.f, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_dir + l_i).item.f))).to_integer_32, 0)
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</a>")))
							if (not l_lnk.is_void) then
								links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" -> ")))
								links_inst.add_to_str (l_file, l_fl, l_lnk)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 358, create {CE_POINTER [ANY]}.make_cast (l_lnk))
							end
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							l_i := l_i + 1
							l_pos := -1 + 10 -- back to loop condition
				when 17 then -- loop done
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 362, create {CE_POINTER [ANY]}.make_cast (l_name))
							l_i := 0
							from
							until
								not (l_i < l_dirl)
							loop
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 363, create {CE_POINTER [ANY]}.make_cast ((l_dir + l_i).item.s))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 363, create {CE_POINTER [ANY]}.make_cast ((l_dir + l_i).item.f))
								l_i := l_i + 1
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 364, create {CE_POINTER [ANY]}.make_cast (l_dir))
							links_inst.add_to_str (l_file, l_fl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</pre></body></html>%N")))
							l_head___0 := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 366, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%NContent-Type: text/html%R%N")))
				when 18 then -- if done | if block done, skip else block:
							l_pos := -1 + 20
				when 19 then -- else:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 368, create {CE_POINTER [ANY]}.make_cast (l_name))
							if l_stt.item.st_size > 2_147_483_647 then
								close (l_h).do_nothing
								sched_inst.setcstate (a_c, -1_014)
								sched_inst.abort_connection (a_c)
								js.return
							end
							if not js.return_called then
								l_file.item := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 376, (l_stt.item.st_size + (not (l_stt.item.st_size).to_boolean).to_integer).to_natural_32)))
								l_r := read (l_h, create {CE_POINTER [ANY]}.make_cast (l_file.item), (l_stt.item.st_size).to_natural_32)
								if l_r.to_integer_32 /= l_stt.item.st_size then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 378, create {CE_POINTER [ANY]}.make_cast (l_file.item))
									close (l_h).do_nothing
									if l_r = -1 then
										l_tmp___20 := -(errno_location).item
									else
										l_tmp___20 := -1_201
									end
									sched_inst.setcstate (a_c, l_tmp___20)
									sched_inst.abort_connection (a_c)
									js.return
								end
							end
							if not js.return_called then
								close (l_h).do_nothing
								l_fl.item := (l_stt.item.st_size).to_integer_32
								l_head___0 := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 384, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							end
				when 20 then -- if done | if done
							if not js.return_called then
								if (cache_inst.get_cache_entry (a_c.item.url, l_e)).to_boolean then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 387, create {CE_POINTER [ANY]}.make_cast (l_file.item))
									sched_inst.setcstate (a_c, -1_004)
									sched_inst.abort_connection (a_c)
									js.return
								end
							end
							if js.return_called then
								l_pos := -1 + 23 -- skip if block
							end
				when 21 then -- if:
								if (not (l_e.item.item.head).is_void) then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 390, create {CE_POINTER [ANY]}.make_cast (l_e.item.item.head))
								end
								l_e.item.item.head := l_head___0
								a_c.item.cache := l_e.item
								cache_inst.add_fragment (l_e.item, (0).to_integer_32, l_file.item, (l_fl.item).to_integer_32).do_nothing
								cache_inst.truncate_entry (l_e.item, (l_fl.item).to_integer_32, 1)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 395, create {CE_POINTER [ANY]}.make_cast (l_file.item))
				when 22 then; -- end:
								(a_c.item.cache).item.incomplete := 0
								sched_inst.setcstate (a_c, -1_000)
								sched_inst.abort_connection (a_c)
				when 23 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	file_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent file_func)
		end

	get_filename (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p: CE_POINTER [NATURAL_8]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ml: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_p.make
			create l_m.make (<<1>>)
			create l_ml.make (<<1>>)

			l_p := a_url + 7
			from
			until
				js.loop_done
			loop
				if (l_p.item).to_boolean then
					if (l_p.item).to_integer_32 = 1 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p := l_p + 1
				end
			end
			l_m.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file.c")), 193)
			l_ml.item := 0
			url_inst.add_conv_str (l_m, l_ml, a_url + 7, (l_p.distance (a_url)) - 7, -2)
			Result := (l_m.item)
		end

	setrwx (a_m: INTEGER_32; a_p: CE_POINTER [NATURAL_8])
		do
			if ((a_m).bit_and (256)).to_boolean then
				a_p[0] := (('r').code).to_natural_8
			end
			if ((a_m).bit_and (128)).to_boolean then
				a_p[1] := (('w').code).to_natural_8
			end
			if ((a_m).bit_and (64)).to_boolean then
				a_p[2] := (('x').code).to_natural_8
			end
		end

	setst (a_m: INTEGER_32; a_p: CE_POINTER [NATURAL_8])
		do
			if ((a_m).bit_and (2_048)).to_boolean then
				a_p[2] := (('S').code).to_natural_8
				if ((a_m).bit_and (64)).to_boolean then
					a_p[2] := (('s').code).to_natural_8
				end
			end
			if ((a_m).bit_and (1_024)).to_boolean then
				a_p[5] := (('S').code).to_natural_8
				if ((a_m).bit_and (((64).bit_shift_right (3)))).to_boolean then
					a_p[5] := (('s').code).to_natural_8
				end
			end
			if ((a_m).bit_and (512)).to_boolean then
				a_p[8] := (('T').code).to_natural_8
				if ((a_m).bit_and (((((64).bit_shift_right (3))).bit_shift_right (3)))).to_boolean then
					a_p[8] := (('t').code).to_natural_8
				end
			end
		end

	stat_date (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		local
			l_current_time: INTEGER_32
			l_when: CE_ARRAY [INTEGER_32]
			l_when_local: CE_POINTER [SD_TM]
			l_fmt: CE_POINTER [NATURAL_8]
			l_str: CE_ARRAY [NATURAL_8]
			l_wr: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_when.make (<<1>>)
			create l_when_local.make
			create l_fmt.make
			create l_str.make (<<13>>)

			l_current_time := (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			if a_stp.is_void then
				links_inst.add_to_str (a_p, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("             ")))
				js.return
			end
			if not js.return_called then
				l_when.item := a_stp.item.st_mtim.tv_sec
				l_when_local := localtime (l_when)
				if l_current_time > l_when.item + 15_552_000 then
					l_fmt := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%b %%e  %%Y"))
				elseif l_current_time < l_when.item - 3_600 then
					l_fmt := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%b %%e  %%Y"))
				else
					l_fmt := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%b %%e %%H:%%M"))
				end
				l_wr := (strftime (create {CE_POINTER [INTEGER_8]}.make_cast (l_str), (13).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (l_fmt), l_when_local)).to_integer_32
				from
				until
					not (l_wr < 12)
				loop
					l_tmp___1 := l_wr
					l_wr := l_wr + 1
					l_str[l_tmp___1] := ((' ').code).to_natural_8
				end
				l_str[12] := (0).to_natural_8
				links_inst.add_to_str (a_p, a_l, l_str)
				links_inst.add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
			end
		end

	stat_links (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		local
			l_lnk: CE_ARRAY [NATURAL_8]
		do
			create l_lnk.make (<<64>>)

			if a_stp.is_void then
				links_inst.add_to_str (a_p, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("    ")))
			else
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_lnk), ce_string ("%%3d "), (a_stp.item.st_nlink).to_integer_32]).do_nothing
				links_inst.add_to_str (a_p, a_l, l_lnk)
			end
		end

	stat_mode (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		local
			l_c: NATURAL_8
			l_rwx: CE_ARRAY [NATURAL_8]
			l_mode: INTEGER_32
		do
			create l_rwx.make (<<10>>)

			l_c := (('?').code).to_natural_8
			if (not a_stp.is_void) then
				if ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 24_576 then
					l_c := (('b').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 8_192 then
					l_c := (('c').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
					l_c := (('d').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
					l_c := (('-').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 4_096 then
					l_c := (('p').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 40_960 then
					l_c := (('l').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 49_152 then
					l_c := (('s').code).to_natural_8
				end
			end
			links_inst.add_chr_to_str (a_p, a_l, l_c)
			l_rwx[0] := (('-').code).to_natural_8
			l_rwx[1] := (('-').code).to_natural_8
			l_rwx[2] := (('-').code).to_natural_8
			l_rwx[3] := (('-').code).to_natural_8
			l_rwx[4] := (('-').code).to_natural_8
			l_rwx[5] := (('-').code).to_natural_8
			l_rwx[6] := (('-').code).to_natural_8
			l_rwx[7] := (('-').code).to_natural_8
			l_rwx[8] := (('-').code).to_natural_8
			l_rwx[9] := (('%/0/').code).to_natural_8
			if (not a_stp.is_void) then
				l_mode := (a_stp.item.st_mode).to_integer_32
				setrwx (l_mode, l_rwx + 0)
				setrwx ((l_mode).bit_shift_left (3), l_rwx + 3)
				setrwx ((l_mode).bit_shift_left (6), l_rwx + 6)
				setst (l_mode, l_rwx)
			end
			links_inst.add_to_str (a_p, a_l, l_rwx)
			links_inst.add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
		end

	stat_size (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		local
			l_size: CE_ARRAY [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_size.make (<<64>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_stp.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | z:
						links_inst.add_to_str (a_p, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("         ")))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else:
						if ((a_stp.item.st_size).to_natural_32).to_integer_32 = a_stp.item.st_size then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_size), ce_string ("%%8lu "), (a_stp.item.st_size).to_natural_32]).do_nothing
							links_inst.add_to_str (a_p, a_l, l_size)
						else
							l_pos := -1 + 1 -- goto z
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	stat_user (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT]; a_g: INTEGER_32)
		local
			l_pwd: CE_POINTER [SD_PASSWD]
			l_grp: CE_POINTER [SD_GROUP]
			l_id: INTEGER_32
			l_pp: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pwd.make
			create l_grp.make
			create l_pp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_stp.is_void then
						links_inst.add_to_str (a_p, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("         ")))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not a_g.to_boolean then
							l_id := (a_stp.item.st_uid).to_integer_32
						else
							l_id := (a_stp.item.st_gid).to_integer_32
						end
						if not a_g.to_boolean then
							l_pp := create {CE_POINTER [NATURAL_8]}.make_cast (last_user)
						else
							l_pp := create {CE_POINTER [NATURAL_8]}.make_cast (last_group)
						end
						if not a_g.to_boolean then
							if l_id = last_uid then
								if last_uid /= -1 then
									l_pos := -1 + 4 -- goto a
								end
							end
						end
				when 2 then
						if a_g.to_boolean then
							if l_id = last_gid then
								if last_gid /= -1 then
									l_pos := -1 + 4 -- goto a
								end
							end
						end
				when 3 then
						if not a_g.to_boolean then
							l_pwd := getpwuid (l_id.to_natural_32)
							if (not l_pwd.is_void) then
								if (l_pwd.item.pw_name).is_void then
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
								else
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pp), ce_string ("%%.8s"), l_pwd.item.pw_name]).do_nothing
								end
							else
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
							end
							last_uid := l_id
						else
							l_grp := getgrgid (l_id.to_natural_32)
							if (not l_grp.is_void) then
								if (l_grp.item.gr_name).is_void then
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
								else
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pp), ce_string ("%%.8s"), l_grp.item.gr_name]).do_nothing
								end
							else
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
							end
							last_gid := l_id
						end
				when 4 then -- a:
						links_inst.add_to_str (a_p, a_l, l_pp)
						l_i := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pp))).to_integer_32
						from
						until
							not (l_i < 8)
						loop
							links_inst.add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
							l_i := l_i + 1
						end
						links_inst.add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
