class
	P_KBD

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create buf.make (<<16_384>>)
			create ditrm.make
			create init_seq.make (<<6>>)
			create init_seq_tw_mouse.make (<<6>>)
			create init_seq_x_mouse.make (<<9>>)
			create os2xtd.make (<<256>>)
			create term_seq.make (<<10>>)
			create term_seq_tw_mouse.make (<<6>>)
			create term_seq_x_mouse.make (<<18>>)
		end

feature {ANY} -- attributes

	buf: CE_ARRAY [NATURAL_8]

	ditrm: CE_POINTER [PD_ITRM] assign set_ditrm

	set_ditrm (a_ditrm: CE_POINTER [PD_ITRM])
		do
			ditrm := a_ditrm
		end

	init_seq: CE_ARRAY [NATURAL_8]

	init_seq_tw_mouse: CE_ARRAY [NATURAL_8]

	init_seq_x_mouse: CE_ARRAY [NATURAL_8]

	os2xtd: CE_ARRAY [PD_KEY]

	term_seq: CE_ARRAY [NATURAL_8]

	term_seq_tw_mouse: CE_ARRAY [NATURAL_8]

	term_seq_x_mouse: CE_ARRAY [NATURAL_8]

	xterm_button: INTEGER_32 assign set_xterm_button

	set_xterm_button (a_xterm_button: INTEGER_32)
		do
			xterm_button := a_xterm_button
		end

feature {ANY} -- routines

	block_itrm (a_fd: INTEGER_32)
		local
			l_itrm: CE_POINTER [PD_ITRM]
			js: JUMP_STATE
		do
			create l_itrm.make

			l_itrm := ditrm
			if l_itrm.is_void then
				js.return
			end
			if not js.return_called and then ((l_itrm.item.blocked).to_boolean) then
				js.return
			end
			if not js.return_called then
				l_itrm.item.blocked := a_fd + 1
				os_dep_inst.block_stdin
				os_dep_inst.unhandle_terminal_resize (l_itrm.item.ctl_in)
				send_term_sequence (l_itrm.item.std_out, l_itrm.item.flags)
				ttcsetattr (l_itrm.item.ctl_in, 0, create {CE_POINTER [SD_TERMIOS]}.make_shared (l_itrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
				select_inst.set_handlers (l_itrm.item.std_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (l_itrm))
			end
		end

	dispatch_special (a_text: CE_POINTER [NATURAL_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_text[0]).to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					os_dep_inst.set_window_title (a_text + 1)
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 2
					resize_terminal_x (a_text + 1)
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	fatal_tty_exit
		do
			if (not ditrm.is_void) then
				ttcsetattr (ditrm.item.ctl_in, 0, create {CE_POINTER [SD_TERMIOS]}.make_shared (ditrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
			end
		end

	free_all_itrms
		do
			if (not ditrm.is_void) then
				free_trm (ditrm)
			end
		end

	free_trm (a_itrm: CE_POINTER [PD_ITRM])
		local
			js: JUMP_STATE
		do
			if a_itrm.is_void then
				js.return
			end
			if not js.return_called then
				os_dep_inst.set_window_title (a_itrm.item.orig_title)
				if (not (a_itrm.item.orig_title).is_void) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 295, create {CE_POINTER [ANY]}.make_cast (a_itrm.item.orig_title))
					a_itrm.item.orig_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				os_dep_inst.unhandle_terminal_resize (a_itrm.item.ctl_in)
				send_term_sequence (a_itrm.item.std_out, a_itrm.item.flags)
				ttcsetattr (a_itrm.item.ctl_in, 0, create {CE_POINTER [SD_TERMIOS]}.make_shared (a_itrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
				if (not (a_itrm.item.mouse_h).is_void) then
					os_dep_inst.unhandle_mouse (a_itrm.item.mouse_h)
				end
				select_inst.set_handlers (a_itrm.item.std_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				select_inst.set_handlers (a_itrm.item.sock_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				select_inst.set_handlers (a_itrm.item.std_out, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				select_inst.set_handlers (a_itrm.item.sock_out, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				if a_itrm.item.tm /= -1 then
					select_inst.kill_timer (a_itrm.item.tm)
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 305, create {CE_POINTER [ANY]}.make_cast (a_itrm.item.ev_queue))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 306, create {CE_POINTER [ANY]}.make_cast (a_itrm))
				if a_itrm.is_equal (ditrm) then
					ditrm := create {CE_POINTER [PD_ITRM]}.make_shared (default_pointer)
				end
			end
		end

	free_trm_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent free_trm)
		end

	get_esc_code (a_str: CE_POINTER [INTEGER_8]; a_len: INTEGER_32; a_code: CE_POINTER [INTEGER_8]; a_num: CE_POINTER [INTEGER_32]; a_el: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_pos___0: INTEGER_32
			js: JUMP_STATE
		do
			a_num.item := 0
			l_pos___0 := 2
			from
			until
				not (not js.loop_done and then (l_pos___0 < a_len))
			loop
				if (a_str[l_pos___0]).to_integer_32 < 48 then
					a_el.item := l_pos___0 + 1
					a_code[0] := a_str[l_pos___0]
					Result := 0
					js.return
				elseif (a_str[l_pos___0]).to_integer_32 > 57 then
					a_el.item := l_pos___0 + 1
					a_code[0] := a_str[l_pos___0]
					Result := 0
					js.return
				elseif l_pos___0 > 7 then
					a_el.item := l_pos___0 + 1
					a_code[0] := a_str[l_pos___0]
					Result := 0
					js.return
				end
				if not js.return_called then
					a_num.item := (a_num.item * 10 + (a_str[l_pos___0]).to_integer_32) - 48
					l_pos___0 := l_pos___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	handle_trm (a_std_in: INTEGER_32; a_std_out: INTEGER_32; a_sock_in: INTEGER_32; a_sock_out: INTEGER_32; a_ctl_in: INTEGER_32; a_init_string: CE_POINTER [ANY]; a_init_len: INTEGER_32)
		local
			l_init_len: CE_ARRAY [INTEGER_32]
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_itrm: CE_POINTER [PD_ITRM]
			l_ev: CE_ARRAY [PD_EVENT]
			l_ts: CE_POINTER [NATURAL_8]
			l_xwin: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_mm: CE_POINTER [NATURAL_8]
			l_ll: INTEGER_32
			l_mm___0: CE_POINTER [NATURAL_8]
			l_ll___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_init_len.make (<<1>>)
			create l_x.make (<<1>>)
			create l_y.make (<<1>>)
			create l_itrm.make
			create l_ev.make (<<1>>)
			create l_ts.make
			create l_xwin.make (<<1>>)
			create l_mm.make
			create l_mm___0.make

			l_init_len.item := a_init_len
			l_ev.item.ev := 0
			l_ev.item.x := 80
			l_ev.item.y := 24
			l_ev.item.b := 0
			if (os_dep_inst.get_terminal_size (a_ctl_in, l_x, l_y)).to_boolean then
				error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: could not get terminal size"))])
				js.return
			end
			if not js.return_called then
				l_itrm := create {CE_POINTER [PD_ITRM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 202, (create {PD_ITRM}.make).structure_size.to_natural_32)))
				ditrm := l_itrm
				l_itrm.item.std_in := a_std_in
				l_itrm.item.std_out := a_std_out
				l_itrm.item.sock_in := a_sock_in
				l_itrm.item.sock_out := a_sock_out
				l_itrm.item.ctl_in := a_ctl_in
				l_itrm.item.blocked := 0
				l_itrm.item.qlen := 0
				l_itrm.item.tm := -1
				l_itrm.item.ev_queue := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
				l_itrm.item.eqlen := 0
				if a_ctl_in >= 0 then
					setraw (a_ctl_in, create {CE_POINTER [SD_TERMIOS]}.make_shared (l_itrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
				end
				select_inst.set_handlers (a_std_in, (in_kbd_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (l_itrm))
				if a_sock_in /= a_std_out then
					select_inst.set_handlers (a_sock_in, (in_sock_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (l_itrm))
				end
				l_ev.item.x := (l_x.item).to_integer_32
				l_ev.item.y := (l_y.item).to_integer_32
				os_dep_inst.handle_terminal_resize (a_ctl_in, resize_terminal_address)
				queue_event (l_itrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
				l_tmp___1 := os_dep_inst.is_xterm
				l_tmp___2 := os_dep_inst.can_twterm
				if (not (getenv (ce_string ("STY"))).is_void) then
					l_tmp___4 := 1
				else
					l_tmp___4 := 0
				end
				l_xwin.item := ((l_tmp___1 + l_tmp___2 * 16) + l_tmp___4 * 2) + (os_dep_inst.get_system_env)
				l_itrm.item.flags := 0
				l_ts := create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("TERM"))))
				if l_ts.is_void then
					l_ts := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
				end
				if ((l_xwin.item).bit_and (16)).to_boolean then
					if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts), ce_string ("linux"))).to_boolean then
						l_itrm.item.flags := (l_itrm.item.flags).bit_or ((1))
					end
				end
				if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts))) >= {NATURAL_32} 32 then
					queue_event (l_itrm, l_ts, 32)
				else
					l_ll := ({NATURAL_32} 32 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts)))).to_integer_32
					queue_event (l_itrm, l_ts, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts))).to_integer_32)
					l_mm := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 230, l_ll.to_natural_32)))
					memset (create {CE_POINTER [ANY]}.make_cast (l_mm), 0, l_ll.to_natural_32).do_nothing
					queue_event (l_itrm, l_mm, l_ll)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 233, create {CE_POINTER [ANY]}.make_cast (l_mm))
				end
				l_ts := terminal_inst.get_cwd
				if l_ts.is_void then
					l_ts := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 235, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				end
				if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts))) >= {NATURAL_32} 256 then
					queue_event (l_itrm, l_ts, 256)
				else
					l_ll___0 := ({NATURAL_32} 256 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts)))).to_integer_32
					queue_event (l_itrm, l_ts, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ts))).to_integer_32)
					l_mm___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 241, l_ll___0.to_natural_32)))
					memset (create {CE_POINTER [ANY]}.make_cast (l_mm___0), 0, l_ll___0.to_natural_32).do_nothing
					queue_event (l_itrm, l_mm___0, l_ll___0)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 244, create {CE_POINTER [ANY]}.make_cast (l_mm___0))
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 246, create {CE_POINTER [ANY]}.make_cast (l_ts))
				queue_event (l_itrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_xwin), ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)
				queue_event (l_itrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_init_len), ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)
				queue_event (l_itrm, create {CE_POINTER [NATURAL_8]}.make_cast (a_init_string), l_init_len.item)
				l_itrm.item.mouse_h := os_dep_inst.handle_mouse (0, (mouse_queue_event_address), create {CE_POINTER [ANY]}.make_cast (l_itrm))
				l_itrm.item.orig_title := os_dep_inst.get_window_title
				os_dep_inst.set_window_title (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Links")))
				send_init_sequence (a_std_out, l_itrm.item.flags)
			end
		end

	in_kbd (a_itrm: CE_POINTER [PD_ITRM])
		local
			l_r: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if not (links_inst.can_read (a_itrm.item.std_in)).to_boolean then
				js.return
			end
			if not js.return_called then
				if a_itrm.item.tm /= -1 then
					select_inst.kill_timer (a_itrm.item.tm)
					a_itrm.item.tm := -1
				end
				if a_itrm.item.qlen >= 16 then
					select_inst.set_handlers (a_itrm.item.std_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (a_itrm))
					from
					until
						js.loop_done
					loop
						if not (process_queue (a_itrm)).to_boolean then
							js.break
						end
					end
					js.return
				end
			end
			if not js.return_called then
				l_r := read (a_itrm.item.std_in, create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue + a_itrm.item.qlen)), (16 - a_itrm.item.qlen).to_natural_32)
				if l_r <= 0 then
					free_trm (a_itrm)
					js.return
				end
			end
			if not js.return_called then
				l_tmp___1 := a_itrm.item.qlen + l_r
				a_itrm.item.qlen := l_tmp___1
				if l_tmp___1 > 16 then
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: too many bytes read"))])
					a_itrm.item.qlen := 16
				end
				from
				until
					js.loop_done
				loop
					if not (process_queue (a_itrm)).to_boolean then
						js.break
					end
				end
			end
		end

	in_kbd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent in_kbd)
		end

	in_sock (a_itrm: CE_POINTER [PD_ITRM])
		local
			l_path: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_delete: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pl: CE_ARRAY [INTEGER_32]
			l_dl: CE_ARRAY [INTEGER_32]
			l_ch: INTEGER_8
			l_fg: INTEGER_32
			l_c: INTEGER_32
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_cc: CE_ARRAY [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_cc___0: CE_ARRAY [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_cc___1: CE_ARRAY [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_blockh: INTEGER_32
			l_param: CE_POINTER [NATURAL_8]
			l_tmp___8: NATURAL_32
			l_tmp___12: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_path.make (<<1>>)
			create l_delete.make (<<1>>)
			create l_pl.make (<<1>>)
			create l_dl.make (<<1>>)
			create l_cc.make (<<1>>)
			create l_cc___0.make (<<1>>)
			create l_cc___1.make (<<1>>)
			create l_param.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := read (a_itrm.item.sock_in, create {CE_POINTER [ANY]}.make_cast (buf), (16_384).to_natural_32)
					if not (l_c <= 0) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | fr:
						free_trm (a_itrm)
						select_inst.terminate := 1
						js.return
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 3 then -- if: | qwerty:
						l_i := 0
				when 4 then -- loop condition:
						if not (l_i < l_c) then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						if not (buf[l_i]).to_boolean then
							l_pos := -1 + 9 -- goto ex
						end
				when 6 then
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						if not (is_blocked).to_boolean then
							os_dep_inst.want_draw
							terminal_inst.hard_write (a_itrm.item.std_out, buf, l_c).do_nothing
							os_dep_inst.done_draw
						end
						js.return
				when 8 then -- if done
					if js.return_called then
						l_pos := -1 + 24 -- skip if block
					end
				when 9 then -- if: | ex:
						if not (is_blocked).to_boolean then
							os_dep_inst.want_draw
							terminal_inst.hard_write (a_itrm.item.std_out, buf, l_i).do_nothing
							os_dep_inst.done_draw
						end
						l_i := l_i + 1
						memmove (create {CE_POINTER [ANY]}.make_cast (buf), create {CE_POINTER [ANY]}.make_cast ((buf + l_i)), (16_384 - l_i).to_natural_32).do_nothing
						l_c := l_c - l_i
						l_p := 0
						if l_p < l_c then
							l_tmp___1 := l_p
							l_p := l_p + 1
							l_cc.item := buf[l_tmp___1]
						elseif (terminal_inst.hard_read (a_itrm.item.sock_in, l_cc, 1)) <= 0 then
							l_pos := -1 + 1 -- goto fr
						end
				when 10 then
						l_fg := (l_cc.item).to_integer_32
						l_path.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 378)
						l_delete.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 379)
						l_dl.item := 0
						l_pl.item := l_dl.item
				when 11 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 14 -- skip loop
						end
				when 12 then -- loop body:
						if l_p < l_c then
							l_tmp___3 := l_p
							l_p := l_p + 1
							l_cc___0.item := buf[l_tmp___3]
						elseif (terminal_inst.hard_read (a_itrm.item.sock_in, l_cc___0, 1)) <= 0 then
							l_pos := -1 + 1 -- goto fr
						end
				when 13 then
						l_ch := (l_cc___0.item).to_integer_8
						if not l_ch.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							links_inst.add_chr_to_str (l_path, l_pl, l_ch.to_natural_8)
						end
						l_pos := -1 + 11 -- back to loop condition
				when 14 then -- loop done
						if js.loop_done then
							l_pos := -1 + 17 -- skip loop
						end
				when 15 then -- loop body:
						if l_p < l_c then
							l_tmp___5 := l_p
							l_p := l_p + 1
							l_cc___1.item := buf[l_tmp___5]
						elseif (terminal_inst.hard_read (a_itrm.item.sock_in, l_cc___1, 1)) <= 0 then
							l_pos := -1 + 1 -- goto fr
						end
				when 16 then
						l_ch := (l_cc___1.item).to_integer_8
						if not l_ch.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							links_inst.add_chr_to_str (l_delete, l_dl, l_ch.to_natural_8)
						end
						l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
						if (l_path.item.item).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						dispatch_special (l_delete.item)
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 20 then -- else:
						if (is_blocked).to_boolean then
							if l_fg.to_boolean then
								if (l_delete.item.item).to_boolean then
									unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_delete.item)).do_nothing
								end
								l_pos := -1 + 23 -- goto to_je_ale_hnus
							end
						end
				when 21 then
						l_tmp___8 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path.item))
						l_param := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 400, (l_tmp___8 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_delete.item)))) + {NATURAL_32} 3)))
						l_param[0] := l_fg.to_natural_8
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_param + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_path.item)).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((((l_param + 1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path.item))).to_integer_32) + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_delete.item)).do_nothing
						if l_fg = 1 then
							block_itrm (0)
						end
						l_tmp___12 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path.item))
						l_blockh := os_dep_inst.start_thread ((terminal_inst.exec_thread_address), create {CE_POINTER [ANY]}.make_cast (l_param), ((l_tmp___12 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_delete.item)))) + {NATURAL_32} 3).to_integer_32)
						if l_blockh = -1 then
							if l_fg = 1 then
								unblock_itrm (0).do_nothing
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 407, create {CE_POINTER [ANY]}.make_cast (l_param))
							l_pos := -1 + 23 -- goto to_je_ale_hnus
						end
				when 22 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 410, create {CE_POINTER [ANY]}.make_cast (l_param))
						if l_fg = 1 then
							select_inst.set_handlers (l_blockh, unblock_itrm_x_address, create {CE_ROUTINE}.make_shared (default_pointer), unblock_itrm_x_address, create {CE_POINTER [ANY]}.make_shared (default_pointer + l_blockh))
						else
							select_inst.set_handlers (l_blockh, terminal_inst.close_handle_address, create {CE_ROUTINE}.make_shared (default_pointer), terminal_inst.close_handle_address, create {CE_POINTER [ANY]}.make_shared (default_pointer + l_blockh))
						end
				when 23 then -- to_je_ale_hnus:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 418, create {CE_POINTER [ANY]}.make_cast (l_path.item))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 419, create {CE_POINTER [ANY]}.make_cast (l_delete.item))
						memmove (create {CE_POINTER [ANY]}.make_cast (buf), create {CE_POINTER [ANY]}.make_cast ((buf + l_p)), (16_384 - l_p).to_natural_32).do_nothing
						l_c := l_c - l_p
						l_pos := -1 + 3 -- goto qwerty
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	in_sock_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent in_sock)
		end

	is_blocked: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (not ditrm.is_void) then
				if (ditrm.item.blocked).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	kbd_ctrl_c
		local
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create l_ev.make (<<1>>)

			l_ev.item.ev := 1
			l_ev.item.x := 512
			l_ev.item.y := 0
			l_ev.item.b := 0
			if (not ditrm.is_void) then
				queue_event (ditrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
			end
		end

	kbd_timeout (a_itrm: CE_POINTER [PD_ITRM])
		local
			l_ev: CE_ARRAY [PD_EVENT]
			js: JUMP_STATE
		do
			create l_ev.make (<<1>>)

			l_ev.item.ev := 1
			l_ev.item.x := 259
			l_ev.item.y := 0
			l_ev.item.b := 0
			a_itrm.item.tm := -1
			if (links_inst.can_read (a_itrm.item.std_in)).to_boolean then
				in_kbd (a_itrm)
				js.return
			end
			if not js.return_called and then (not (a_itrm.item.qlen).to_boolean) then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c"))
					links_inst.errline := 436
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("timeout on empty queue"))])
				end
				js.return
			end
			if not js.return_called then
				queue_event (a_itrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
				a_itrm.item.qlen := (a_itrm.item.qlen) - 1
				if (a_itrm.item.qlen).to_boolean then
					memmove (create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue)), create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue + 1)), (a_itrm.item.qlen).to_natural_32).do_nothing
				end
				from
				until
					js.loop_done
				loop
					if not (process_queue (a_itrm)).to_boolean then
						js.break
					end
				end
			end
		end

	kbd_timeout_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent kbd_timeout)
		end

	mouse_queue_event (a_itrm: CE_POINTER [PD_ITRM]; a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if (a_itrm.item.blocked).to_boolean then
				js.return
			end
			if not js.return_called then
				queue_event (a_itrm, a_data, a_len)
			end
		end

	mouse_queue_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mouse_queue_event)
		end

	process_queue (a_itrm: CE_POINTER [PD_ITRM]): INTEGER_32
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_el: CE_ARRAY [INTEGER_32]
			l_c: CE_ARRAY [INTEGER_8]
			l_v: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ev.make (<<1>>)
			create l_el.make (<<1>>)
			create l_c.make (<<1>>)
			create l_v.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ev.item.ev := 1
					l_ev.item.x := -1
					l_ev.item.y := 0
					l_ev.item.b := 0
					l_el.item := 0
					if not (a_itrm.item.qlen).to_boolean then
						l_pos := -1 + 84 -- goto end
					end
				when 1 then
					if (a_itrm.item.kqueue[0]).to_integer_32 /= 27 then
						l_pos := -1 + 78 -- skip if block
					end
				when 2 then -- if:
						if a_itrm.item.qlen < 2 then
							l_pos := -1 + 85 -- goto ret
						end
				when 3 then
						if (a_itrm.item.kqueue[1]).to_integer_32 /= 91 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 6 then -- else:
						if (a_itrm.item.kqueue[1]).to_integer_32 /= 79 then
							l_pos := -1 + 73 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if not (a_itrm.item.qlen >= 4) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if (a_itrm.item.kqueue[2]).to_integer_32 /= 91 then
							l_pos := -1 + 12 -- skip if block
						end
				when 9 then -- if:
						if (a_itrm.item.kqueue[3]).to_integer_32 < 65 then
							l_pos := -1 + 85 -- goto ret
						elseif (a_itrm.item.kqueue[3]).to_integer_32 > 76 then
							l_pos := -1 + 85 -- goto ret
						end
				when 10 then
						l_ev.item.x := (288 - ((a_itrm.item.kqueue[3]).to_integer_32 - 65)).to_integer_32
						l_el.item := 4
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 72
				when 14 then -- else: | _L:
						if not ((get_esc_code (create {CE_POINTER [INTEGER_8]}.make_cast ((a_itrm.item.kqueue)), a_itrm.item.qlen, l_c, l_v, l_el)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 85 -- goto ret
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 17 then -- else:
						inspect (l_c.item).to_integer_32 -- switch 1 head
						when 64 then l_pos := -1 + 18
						when 65 then l_pos := -1 + 19
						when 66 then l_pos := -1 + 20
						when 67 then l_pos := -1 + 21
						when 68 then l_pos := -1 + 22
						when 70 then l_pos := -1 + 23
						when 75 then l_pos := -1 + 23
						when 101 then l_pos := -1 + 23
						when 72 then l_pos := -1 + 24
						when 0 then l_pos := -1 + 24
						when 86 then l_pos := -1 + 25
						when 73 then l_pos := -1 + 25
						when 85 then l_pos := -1 + 26
						when 71 then l_pos := -1 + 26
						when 80 then l_pos := -1 + 27
						when 81 then l_pos := -1 + 28
						when 83 then l_pos := -1 + 29
						when 84 then l_pos := -1 + 30
						when 87 then l_pos := -1 + 31
						when 88 then l_pos := -1 + 32
						when 89 then l_pos := -1 + 33
						when 122 then l_pos := -1 + 34
						when 126 then l_pos := -1 + 42
						when 82 then l_pos := -1 + 59
						when 77 then l_pos := -1 + 60
						else l_pos := -1 + 72
						end
				when 18 then -- switch 1, case 64
						l_ev.item.x := 264
						l_pos := -1 + 72 -- switch 1; break
				when 19 then -- switch 1, case 65
						l_ev.item.x := 262
						l_pos := -1 + 72 -- switch 1; break
				when 20 then -- switch 1, case 66
						l_ev.item.x := 263
						l_pos := -1 + 72 -- switch 1; break
				when 21 then -- switch 1, case 67
						l_ev.item.x := 261
						l_pos := -1 + 72 -- switch 1; break
				when 22 then -- switch 1, case 68
						l_ev.item.x := 260
						l_pos := -1 + 72 -- switch 1; break
				when 23 then -- switch 1, case 70 | switch 1, case 75 | switch 1, case 101
						l_ev.item.x := 267
						l_pos := -1 + 72 -- switch 1; break
				when 24 then -- switch 1, case 72 | switch 1, case 0
						l_ev.item.x := 266
						l_pos := -1 + 72 -- switch 1; break
				when 25 then -- switch 1, case 86 | switch 1, case 73
						l_ev.item.x := 268
						l_pos := -1 + 72 -- switch 1; break
				when 26 then -- switch 1, case 85 | switch 1, case 71
						l_ev.item.x := 269
						l_pos := -1 + 72 -- switch 1; break
				when 27 then -- switch 1, case 80
						l_ev.item.x := 288
						l_pos := -1 + 72 -- switch 1; break
				when 28 then -- switch 1, case 81
						l_ev.item.x := 289
						l_pos := -1 + 72 -- switch 1; break
				when 29 then -- switch 1, case 83
						l_ev.item.x := 291
						l_pos := -1 + 72 -- switch 1; break
				when 30 then -- switch 1, case 84
						l_ev.item.x := 292
						l_pos := -1 + 72 -- switch 1; break
				when 31 then -- switch 1, case 87
						l_ev.item.x := 295
						l_pos := -1 + 72 -- switch 1; break
				when 32 then -- switch 1, case 88
						l_ev.item.x := 296
						l_pos := -1 + 72 -- switch 1; break
				when 33 then -- switch 1, case 89
						l_ev.item.x := 298
						l_pos := -1 + 72 -- switch 1; break
				when 34 then -- switch 1, case 122
						inspect l_v.item -- switch 2 head
						when 247 then l_pos := -1 + 35
						when 214 then l_pos := -1 + 36
						when 220 then l_pos := -1 + 37
						when 216 then l_pos := -1 + 38
						when 222 then l_pos := -1 + 39
						when 249 then l_pos := -1 + 40
						else l_pos := -1 + 41
						end
				when 35 then -- switch 2, case 247
						l_ev.item.x := 264
						l_pos := -1 + 41 -- switch 2; break
				when 36 then -- switch 2, case 214
						l_ev.item.x := 266
						l_pos := -1 + 41 -- switch 2; break
				when 37 then -- switch 2, case 220
						l_ev.item.x := 267
						l_pos := -1 + 41 -- switch 2; break
				when 38 then -- switch 2, case 216
						l_ev.item.x := 268
						l_pos := -1 + 41 -- switch 2; break
				when 39 then -- switch 2, case 222
						l_ev.item.x := 269
						l_pos := -1 + 41 -- switch 2; break
				when 40 then -- switch 2, case 249
						l_ev.item.x := 265
						l_pos := -1 + 41 -- switch 2; break
				when 41 then -- switch 2, done:
						l_pos := -1 + 72 -- switch 1; break
				when 42 then -- switch 1, case 126
						inspect l_v.item -- switch 3 head
						when 1 then l_pos := -1 + 43
						when 2 then l_pos := -1 + 44
						when 3 then l_pos := -1 + 45
						when 4 then l_pos := -1 + 46
						when 5 then l_pos := -1 + 47
						when 6 then l_pos := -1 + 48
						when 7 then l_pos := -1 + 49
						when 8 then l_pos := -1 + 50
						when 17 then l_pos := -1 + 51
						when 18 then l_pos := -1 + 52
						when 19 then l_pos := -1 + 53
						when 20 then l_pos := -1 + 54
						when 21 then l_pos := -1 + 55
						when 23 then l_pos := -1 + 56
						when 24 then l_pos := -1 + 57
						else l_pos := -1 + 58
						end
				when 43 then -- switch 3, case 1
						l_ev.item.x := 266
						l_pos := -1 + 58 -- switch 3; break
				when 44 then -- switch 3, case 2
						l_ev.item.x := 264
						l_pos := -1 + 58 -- switch 3; break
				when 45 then -- switch 3, case 3
						l_ev.item.x := 265
						l_pos := -1 + 58 -- switch 3; break
				when 46 then -- switch 3, case 4
						l_ev.item.x := 267
						l_pos := -1 + 58 -- switch 3; break
				when 47 then -- switch 3, case 5
						l_ev.item.x := 268
						l_pos := -1 + 58 -- switch 3; break
				when 48 then -- switch 3, case 6
						l_ev.item.x := 269
						l_pos := -1 + 58 -- switch 3; break
				when 49 then -- switch 3, case 7
						l_ev.item.x := 266
						l_pos := -1 + 58 -- switch 3; break
				when 50 then -- switch 3, case 8
						l_ev.item.x := 267
						l_pos := -1 + 58 -- switch 3; break
				when 51 then -- switch 3, case 17
						l_ev.item.x := 293
						l_pos := -1 + 58 -- switch 3; break
				when 52 then -- switch 3, case 18
						l_ev.item.x := 294
						l_pos := -1 + 58 -- switch 3; break
				when 53 then -- switch 3, case 19
						l_ev.item.x := 295
						l_pos := -1 + 58 -- switch 3; break
				when 54 then -- switch 3, case 20
						l_ev.item.x := 296
						l_pos := -1 + 58 -- switch 3; break
				when 55 then -- switch 3, case 21
						l_ev.item.x := 297
						l_pos := -1 + 58 -- switch 3; break
				when 56 then -- switch 3, case 23
						l_ev.item.x := 298
						l_pos := -1 + 58 -- switch 3; break
				when 57 then -- switch 3, case 24
						l_ev.item.x := 299
						l_pos := -1 + 58 -- switch 3; break
				when 58 then -- switch 3, done:
						l_pos := -1 + 72 -- switch 1; break
				when 59 then -- switch 1, case 82
						resize_terminal
						l_pos := -1 + 72 -- switch 1; break
				when 60 then -- switch 1, case 77
						if a_itrm.item.qlen - l_el.item < 3 then
							l_pos := -1 + 85 -- goto ret
						end
				when 61 then
						if l_v.item /= 5 then
							l_pos := -1 + 70 -- skip if block
						end
				when 62 then -- if:
						if xterm_button = -1 then
							xterm_button := 0
						end
						if a_itrm.item.qlen - l_el.item < 5 then
							l_pos := -1 + 85 -- goto ret
						end
				when 63 then
						l_ev.item.x := ((((a_itrm.item.kqueue[l_el.item + 1]).to_integer_32 - 32) - 1) + (((((a_itrm.item.kqueue[l_el.item + 2]).to_integer_32 - 32) - 1)).bit_shift_left (7))).to_integer_32
						if ((l_ev.item.x).bit_and (((1).bit_shift_left (13)).to_integer_32)).to_boolean then
							l_ev.item.x := 0
						end
						l_ev.item.y := ((((a_itrm.item.kqueue[l_el.item + 3]).to_integer_32 - 32) - 1) + (((((a_itrm.item.kqueue[l_el.item + 4]).to_integer_32 - 32) - 1)).bit_shift_left (7))).to_integer_32
						if ((l_ev.item.y).bit_and (((1).bit_shift_left (13)).to_integer_32)).to_boolean then
							l_ev.item.y := 0
						end
						inspect (((a_itrm.item.kqueue[l_el.item]).to_integer_32 - 32)).bit_xor (xterm_button) -- switch 4 head
						when 1 then l_pos := -1 + 64
						when 2 then l_pos := -1 + 65
						when 4 then l_pos := -1 + 66
						when 0 then l_pos := -1 + 67
						else l_pos := -1 + 68
						end
				when 64 then -- switch 4, case 1
						if ((xterm_button).bit_and (1)).to_boolean then
							l_tmp := 4
						else
							l_tmp := 0
						end
						l_ev.item.b := l_tmp.to_integer_32
						l_pos := -1 + 68 -- switch 4; break
				when 65 then -- switch 4, case 2
						if ((xterm_button).bit_and (2)).to_boolean then
							l_tmp___0 := 4
						else
							l_tmp___0 := 0
						end
						l_ev.item.b := ((1).bit_or (l_tmp___0)).to_integer_32
						l_pos := -1 + 68 -- switch 4; break
				when 66 then -- switch 4, case 4
						if ((xterm_button).bit_and (4)).to_boolean then
							l_tmp___1 := 4
						else
							l_tmp___1 := 0
						end
						l_ev.item.b := ((2).bit_or (l_tmp___1)).to_integer_32
						l_pos := -1 + 68 -- switch 4; break
				when 67 then -- switch 4, case 0
						l_ev.item.b := 8
				when 68 then -- switch 4, done:
						xterm_button := (a_itrm.item.kqueue[l_el.item]).to_integer_32 - 32
						l_el.item := l_el.item + (5)
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:
						l_ev.item.x := (((a_itrm.item.kqueue[l_el.item + 1]).to_integer_32 - 32) - 1).to_integer_32
						l_ev.item.y := (((a_itrm.item.kqueue[l_el.item + 2]).to_integer_32 - 32) - 1).to_integer_32
						l_ev.item.b := 0
						if (((a_itrm.item.kqueue[l_el.item]).to_integer_32).bit_and (4)).to_boolean then
							l_ev.item.b := 8
						end
						l_ev.item.b := (l_ev.item.b).bit_or ((((a_itrm.item.kqueue[l_el.item]).to_integer_32).bit_and (3)).to_integer_32)
						if l_ev.item.b = 3 then
							l_ev.item.b := 4
							if xterm_button /= -1 then
								l_ev.item.b := (l_ev.item.b).bit_or (xterm_button.to_integer_32)
							end
						end
						xterm_button := -1
						if ((l_ev.item.b).bit_and (12)) = 0 then
							xterm_button := ((l_ev.item.b).bit_and (3)).to_integer_32
						end
						l_el.item := l_el.item + (3)
				when 71 then -- if done
						l_ev.item.ev := 2
						l_pos := -1 + 72 -- switch 1; break
				when 72 then -- switch 1, done: | if done | if done | if block done, skip else block:
						l_pos := -1 + 76
				when 73 then -- else:
						l_el.item := 2
						if (a_itrm.item.kqueue[1]).to_integer_32 >= 32 then
							l_ev.item.x := (a_itrm.item.kqueue[1]).to_integer_32
							l_ev.item.y := 4
							l_pos := -1 + 82 -- goto l2
						end
				when 74 then
						if (a_itrm.item.kqueue[1]).to_integer_32 = 127 then
							l_ev.item.x := 265
							l_ev.item.y := 0
							l_pos := -1 + 82 -- goto l2
						end
				when 75 then
						if (a_itrm.item.kqueue[1]).to_integer_32 = 27 then
							if a_itrm.item.qlen >= 3 then
								if (a_itrm.item.kqueue[2]).to_integer_32 = 91 then
									l_el.item := 1
								elseif (a_itrm.item.kqueue[2]).to_integer_32 = 79 then
									l_el.item := 1
								end
							end
							l_ev.item.x := 259
							l_pos := -1 + 82 -- goto l2
						end
				when 76 then -- if done
						l_pos := -1 + 83 -- goto l1
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 78 then -- else:
						if (a_itrm.item.kqueue[0]).to_integer_32 /= 0 then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						if a_itrm.item.qlen < 2 then
							l_pos := -1 + 85 -- goto ret
						end
				when 80 then
						l_ev.item.x := (os2xtd[(a_itrm.item.kqueue[1]).to_integer_32].x).to_integer_32
						if not (l_ev.item.x).to_boolean then
							l_ev.item.x := -1
						end
						l_ev.item.y := (os2xtd[(a_itrm.item.kqueue[1]).to_integer_32].y).to_integer_32
						l_el.item := 2
						l_pos := -1 + 83 -- goto l1
				when 81 then -- if done
						l_el.item := 1
						l_ev.item.x := (a_itrm.item.kqueue[0]).to_integer_32
				when 82 then -- l2:
						if l_ev.item.x = 8 then
							l_ev.item.x := 257
						end
						if l_ev.item.x = 9 then
							l_ev.item.x := 258
						end
						if l_ev.item.x = 10 then
							l_ev.item.x := 256
							l_ev.item.y := 2
						end
						if l_ev.item.x = 13 then
							l_ev.item.x := 256
						end
						if l_ev.item.x = 127 then
							l_ev.item.x := 257
						end
						if l_ev.item.x < 32 then
							l_ev.item.x := l_ev.item.x + (64)
							l_ev.item.y := 2
						end
				when 83 then -- l1:
						if a_itrm.item.qlen < l_el.item then
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c"))
								links_inst.errline := 666
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("event queue underflow"))])
							end
							a_itrm.item.qlen := l_el.item
						end
						if l_ev.item.x /= -1 then
							queue_event (a_itrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
							l_tmp___3 := a_itrm.item.qlen - l_el.item
							a_itrm.item.qlen := l_tmp___3
							memmove (create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue)), create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue + l_el.item)), l_tmp___3.to_natural_32).do_nothing
						else
							l_tmp___4 := a_itrm.item.qlen - l_el.item
							a_itrm.item.qlen := l_tmp___4
							memmove (create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue)), create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.kqueue + l_el.item)), l_tmp___4.to_natural_32).do_nothing
						end
				when 84 then -- end:
						if a_itrm.item.qlen < 16 then
							select_inst.set_handlers (a_itrm.item.std_in, (in_kbd_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (a_itrm))
						end
						Result := (l_el.item)
						js.return
						if js.return_called then
							l_pos := -1 + 86 -- skip if block
						end
				when 85 then -- if: | ret:
							a_itrm.item.tm := select_inst.install_timer ((200).to_integer_32, (kbd_timeout_address), create {CE_POINTER [ANY]}.make_cast (a_itrm))
							Result := 0
				when 86 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	queue_event (a_itrm: CE_POINTER [PD_ITRM]; a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_w: INTEGER_32
			js: JUMP_STATE
		do
			l_w := 0
			if not a_len.to_boolean then
				js.return
			end
			if not js.return_called and then (not (a_itrm.item.eqlen).to_boolean) then
				if (links_inst.can_write (a_itrm.item.sock_out)).to_boolean then
					l_w := write (a_itrm.item.sock_out, create {CE_POINTER [ANY]}.make_cast (a_data), a_len.to_natural_32)
					if l_w <= 0 then
						select_inst.register_bottom_half ((free_trm_address), create {CE_POINTER [ANY]}.make_cast (a_itrm)).do_nothing
						js.return
					end
				end
			end
			if not js.return_called and then (l_w < a_len) then
				if (a_itrm.item.eqlen).to_natural_32 + (a_len - l_w).to_natural_32 > {NATURAL_32} 2_147_483_647 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("kbd.c"), 75])
						fatal_tty_exit
						exit (4)
					end
				end
				a_itrm.item.ev_queue := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c")), 76, create {CE_POINTER [ANY]}.make_cast (a_itrm.item.ev_queue), ((a_itrm.item.eqlen + a_len) - l_w).to_natural_32)))
				memcpy (create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.ev_queue + a_itrm.item.eqlen)), create {CE_POINTER [ANY]}.make_cast ((a_data + l_w)), (a_len - l_w).to_natural_32).do_nothing
				a_itrm.item.eqlen := a_itrm.item.eqlen + (a_len - l_w)
				select_inst.set_handlers (a_itrm.item.sock_out, create {CE_ROUTINE}.make_cast ((select_inst.get_handler (a_itrm.item.sock_out, 0))), (write_ev_queue_address), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (a_itrm))
			end
		end

	resize_terminal
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_ev.make (<<1>>)
			create l_x.make (<<1>>)
			create l_y.make (<<1>>)

			l_ev.item.ev := 4
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			if (os_dep_inst.get_terminal_size (ditrm.item.std_out, l_x, l_y)).to_boolean then
				js.return
			end
			if not js.return_called then
				l_ev.item.x := (l_x.item).to_integer_32
				l_ev.item.y := (l_y.item).to_integer_32
				queue_event (ditrm, create {CE_POINTER [NATURAL_8]}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
			end
		end

	resize_terminal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent resize_terminal)
		end

	resize_terminal_x (a_text: CE_POINTER [NATURAL_8])
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_p: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p.make
			create l_tmp___0.make

			l_p := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_text), (',').code)))
			if l_p.is_void then
				js.return
			end
			if not js.return_called then
				l_tmp___0 := l_p
				l_p := l_p + 1
				l_tmp___0.item := (0).to_natural_8
				l_x := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (a_text))
				l_y := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_p))
				os_dep_inst.resize_window (l_x, l_y).do_nothing
				resize_terminal
			end
		end

	send_init_sequence (a_h: INTEGER_32; a_flags: INTEGER_32)
		do
			os_dep_inst.want_draw
			terminal_inst.hard_write (a_h, init_seq, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (init_seq))).to_integer_32).do_nothing
			if ((a_flags).bit_and (1)).to_boolean then
				terminal_inst.hard_write (a_h, init_seq_tw_mouse, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (init_seq_tw_mouse))).to_integer_32).do_nothing
			else
				terminal_inst.hard_write (a_h, init_seq_x_mouse, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (init_seq_x_mouse))).to_integer_32).do_nothing
			end
			os_dep_inst.done_draw
		end

	send_term_sequence (a_h: INTEGER_32; a_flags: INTEGER_32)
		do
			os_dep_inst.want_draw
			terminal_inst.hard_write (a_h, term_seq, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (term_seq))).to_integer_32).do_nothing
			if ((a_flags).bit_and (1)).to_boolean then
				terminal_inst.hard_write (a_h, term_seq_tw_mouse, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (term_seq_tw_mouse))).to_integer_32).do_nothing
			else
				terminal_inst.hard_write (a_h, term_seq_x_mouse, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (term_seq_x_mouse))).to_integer_32).do_nothing
			end
			os_dep_inst.done_draw
		end

	setraw (a_fd: INTEGER_32; a_p: CE_POINTER [SD_TERMIOS]): INTEGER_32
		local
			l_t: CE_ARRAY [SD_TERMIOS]
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			memset (create {CE_POINTER [ANY]}.make_cast (l_t), 0, (create {SD_TERMIOS}.make).structure_size.to_natural_32).do_nothing
			if (ttcgetattr (a_fd, l_t)).to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (not a_p.is_void) then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_p), create {CE_POINTER [ANY]}.make_cast (l_t), (create {SD_TERMIOS}.make).structure_size.to_natural_32).do_nothing
				end
				os_dep_inst.os_cfmakeraw (l_t)
				l_t.item.c2_lflag := (l_t.item.c2_lflag).bit_or (({NATURAL_32} 1))
				l_t.item.c2_lflag := (l_t.item.c2_lflag).bit_or (({NATURAL_32} 256))
				l_t.item.c2_oflag := (l_t.item.c2_oflag).bit_or (({NATURAL_32} 1))
				if (ttcsetattr (a_fd, 0, l_t)).to_boolean then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	ttcgetattr (a_fd: INTEGER_32; a_t: CE_POINTER [SD_TERMIOS]): INTEGER_32
		local
			l_r: INTEGER_32
		do
			select_inst.interruptible_signal (22, 1)
			select_inst.interruptible_signal (21, 1)
			l_r := tcgetattr (a_fd, a_t)
			select_inst.interruptible_signal (22, 0)
			select_inst.interruptible_signal (21, 0)
			Result := l_r
		end

	ttcsetattr (a_fd: INTEGER_32; a_a: INTEGER_32; a_t: CE_POINTER [SD_TERMIOS]): INTEGER_32
		local
			l_r: INTEGER_32
		do
			select_inst.interruptible_signal (22, 1)
			select_inst.interruptible_signal (21, 1)
			l_r := tcsetattr (a_fd, a_a, a_t)
			select_inst.interruptible_signal (22, 0)
			select_inst.interruptible_signal (21, 0)
			Result := l_r
		end

	unblock_itrm (a_fd: INTEGER_32): INTEGER_32
		local
			l_itrm: CE_POINTER [PD_ITRM]
			js: JUMP_STATE
		do
			create l_itrm.make

			l_itrm := ditrm
			if l_itrm.is_void then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (l_itrm.item.ctl_in >= 0) then
				if (setraw (l_itrm.item.ctl_in, create {CE_POINTER [SD_TERMIOS]}.make_shared (default_pointer))).to_boolean then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called and then (l_itrm.item.blocked /= a_fd + 1) then
				Result := (-2)
				js.return
			end
			if not js.return_called then
				l_itrm.item.blocked := 0
				send_init_sequence (l_itrm.item.std_out, l_itrm.item.flags)
				select_inst.set_handlers (l_itrm.item.std_in, (in_kbd_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_POINTER [ANY]}.make_cast (l_itrm))
				os_dep_inst.handle_terminal_resize (l_itrm.item.ctl_in, resize_terminal_address)
				os_dep_inst.unblock_stdin
				resize_terminal
				Result := 0
			end
		end

	unblock_itrm_x (a_h: CE_POINTER [ANY])
		local
			js: JUMP_STATE
		do
			terminal_inst.close_handle (a_h)
			if ditrm.is_void then
				js.return
			end
			if not js.return_called then
				unblock_itrm (0).do_nothing
			end
		end

	unblock_itrm_x_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent unblock_itrm_x)
		end

	write_ev_queue (a_itrm: CE_POINTER [PD_ITRM])
		local
			l_l: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_tmp___1.make
			create l_tmp___2.make

			if not (a_itrm.item.eqlen).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbd.c"))
					links_inst.errline := 48
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("event queue empty"))])
				end
			end
			if a_itrm.item.eqlen > 128 then
				l_tmp := 128
			else
				l_tmp := a_itrm.item.eqlen
			end
			l_l := write (a_itrm.item.sock_out, create {CE_POINTER [ANY]}.make_cast (a_itrm.item.ev_queue), l_tmp.to_natural_32)
			if l_l = -1 then
				free_trm (a_itrm)
				js.return
			end
			if not js.return_called then
				l_tmp___0 := a_itrm.item.eqlen - l_l
				a_itrm.item.eqlen := l_tmp___0
				memmove (create {CE_POINTER [ANY]}.make_cast (a_itrm.item.ev_queue), create {CE_POINTER [ANY]}.make_cast ((a_itrm.item.ev_queue + l_l)), l_tmp___0.to_natural_32).do_nothing
				if not (a_itrm.item.eqlen).to_boolean then
					l_tmp___1 := select_inst.get_handler (a_itrm.item.sock_out, 3)
					l_tmp___2 := select_inst.get_handler (a_itrm.item.sock_out, 2)
					select_inst.set_handlers (a_itrm.item.sock_out, create {CE_ROUTINE}.make_cast ((select_inst.get_handler (a_itrm.item.sock_out, 0))), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_cast (l_tmp___2), l_tmp___1)
				end
			end
		end

	write_ev_queue_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent write_ev_queue)
		end

end
