class
	P_MAILTO

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {ANY} -- routines

	mailto_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		local
			l_user: CE_POINTER [NATURAL_8]
			l_host: CE_POINTER [NATURAL_8]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_f: INTEGER_32
			l_tmp: NATURAL_32
			l_pos: INTEGER_32
		do
			create l_user.make
			create l_host.make
			create l_m.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := 1
					l_user := url_inst.get_user_name (a_url)
					if l_user.is_void then
						l_pos := -1 + 4 -- goto fail
					end
				when 1 then
					l_host := url_inst.get_host_name (a_url)
					if l_host.is_void then
						l_pos := -1 + 3 -- goto fail1
					end
				when 2 then
					l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_user))
					l_m.item := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 22, (l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_host)))) + {NATURAL_32} 2)))
					l_f := 0
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_m.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_user)).do_nothing
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_m.item), ce_string ("@")).do_nothing
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_m.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_host)).do_nothing
					os_dep_inst.check_shell_security (l_m)
					prog_func (a_ses.item.term, types_inst.mailto_prog, l_m.item, links_inst.dummyarray + 297)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 29, create {CE_POINTER [ANY]}.make_cast (l_m.item))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 30, create {CE_POINTER [ANY]}.make_cast (l_host))
				when 3 then -- fail1:
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 32, create {CE_POINTER [ANY]}.make_cast (l_user))
				when 4 then -- fail:
					if l_f.to_boolean then
						bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 138, 1, links_inst.dummyarray + 301, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mailto_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mailto_func)
		end

	mms_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		local
			js: JUMP_STATE
		do
			if (os_dep_inst.check_shell_url (a_url)).to_boolean then
				bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 304, 1, links_inst.dummyarray + 300, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				js.return
			end
			if not js.return_called then
				prog_func (a_ses.item.term, types_inst.mms_prog, a_url, links_inst.dummyarray + 300)
			end
		end

	mms_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mms_func)
		end

	prog_func (a_term: CE_POINTER [PD_TERMINAL]; a_list: CE_POINTER [PD_LIST_HEAD]; a_param: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8])
		local
			l_prog: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_prog.make
			create l_cmd.make

			l_prog := types_inst.get_prog (a_list)
			if (not l_prog.is_void) then
				if not (l_prog.item).to_boolean then
					bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 295, 129, links_inst.dummyarray + 296, ce_string (" "), a_name, ce_string ("."), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					js.return
				end
			else
				bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 295, 129, links_inst.dummyarray + 296, ce_string (" "), a_name, ce_string ("."), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				js.return
			end
			if not js.return_called then
				l_cmd := session_inst.subst_file (l_prog, a_param)
				if (not l_cmd.is_void) then
					terminal_inst.exec_on_terminal (a_term, l_cmd, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 12, create {CE_POINTER [ANY]}.make_cast (l_cmd))
				end
			end
		end

	telnet_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		do
			tn_func (a_ses, a_url, types_inst.telnet_prog, links_inst.dummyarray + 298, links_inst.dummyarray + 302)
		end

	telnet_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent telnet_func)
		end

	tn3270_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		do
			tn_func (a_ses, a_url, types_inst.tn3270_prog, links_inst.dummyarray + 299, links_inst.dummyarray + 303)
		end

	tn3270_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tn3270_func)
		end

	tn_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_prog: CE_POINTER [PD_LIST_HEAD]; a_t1: CE_POINTER [NATURAL_8]; a_t2: CE_POINTER [NATURAL_8])
		local
			l_m: CE_POINTER [NATURAL_8]
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_pl: CE_ARRAY [INTEGER_32]
			l_hh: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_f: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_pos: INTEGER_32
		do
			create l_m.make
			create l_h.make (<<1>>)
			create l_p.make (<<1>>)
			create l_hl.make (<<1>>)
			create l_pl.make (<<1>>)
			create l_hh.make (<<1>>)
			create l_pp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := 1
					if (url_inst.parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, l_p, l_pl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
						l_pos := -1 + 2 -- goto fail
					elseif not (l_hl.item).to_boolean then
						l_pos := -1 + 2 -- goto fail
					end
				when 1 then
					l_hh.item := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 45, l_h.item, l_hl.item)
					if (l_pl.item).to_boolean then
						l_pp.item := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 46, l_p.item, l_pl.item)
					end
					os_dep_inst.check_shell_security (l_hh)
					if (l_pl.item).to_boolean then
						os_dep_inst.check_shell_security (l_pp)
					end
					l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_hh.item))
					if (l_pl.item).to_boolean then
						l_tmp___2 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pp.item)))
					else
						l_tmp___2 := (0).to_natural_32
					end
					l_m := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 49, (l_tmp___0 + l_tmp___2) + {NATURAL_32} 2)))
					l_f := 0
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_m), create {CE_POINTER [INTEGER_8]}.make_cast (l_hh.item)).do_nothing
					if (l_pl.item).to_boolean then
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_m), ce_string (" ")).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_m), create {CE_POINTER [INTEGER_8]}.make_cast (l_pp.item)).do_nothing
						l_m[((l_hl.item + 1) + l_pl.item)] := (0).to_natural_8
					end
					prog_func (a_ses.item.term, a_prog, l_m, a_t1)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 58, create {CE_POINTER [ANY]}.make_cast (l_m))
					if (l_pl.item).to_boolean then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 59, create {CE_POINTER [ANY]}.make_cast (l_pp.item))
					end
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto.c")), 60, create {CE_POINTER [ANY]}.make_cast (l_hh.item))
				when 2 then -- fail:
					if l_f.to_boolean then
						bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 138, 1, a_t2, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
