class
	P_TERMINAL

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create dumb_term.make (<<1>>)
			create frame_dumb.make (<<48>>)
			create frame_freebsd.make (<<48>>)
			create frame_koi.make (<<48>>)
			create frame_restrict.make (<<48>>)
			create frame_vt100.make (<<48>>)
			create p1.make (<<6>>)
			create p2.make (<<6>>)
			create term_specs.make (<<1>>)
			create terminals.make (<<1>>)
		end

feature {ANY} -- attributes

	dumb_term: CE_ARRAY [PD_TERM_SPEC]

	frame_dumb: CE_ARRAY [NATURAL_8]

	frame_freebsd: CE_ARRAY [NATURAL_8]

	frame_koi: CE_ARRAY [NATURAL_8]

	frame_restrict: CE_ARRAY [NATURAL_8]

	frame_vt100: CE_ARRAY [NATURAL_8]

	p1: CE_ARRAY [INTEGER_32]

	p2: CE_ARRAY [INTEGER_32]

	term_specs: CE_ARRAY [PD_LIST_HEAD]

	terminals: CE_ARRAY [PD_LIST_HEAD]

feature {ANY} -- routines

	add_empty_window (a_term: CE_POINTER [PD_TERMINAL]; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY])
		local
			l_ewd: CE_POINTER [PD_EWD]
		do
			create l_ewd.make

			l_ewd := create {CE_POINTER [PD_EWD]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 260, (create {PD_EWD}.make).structure_size.to_natural_32)))
			l_ewd.item.fn := a_fn
			l_ewd.item.data := a_data
			l_ewd.item.b := 0
			add_window (a_term, empty_window_handler_address, create {CE_POINTER [ANY]}.make_cast (l_ewd))
		end

	add_window (a_term: CE_POINTER [PD_TERMINAL]; a_handler: CE_ROUTINE; a_data: CE_POINTER [ANY])
		do
			add_window_at_pos (a_term, a_handler, a_data, create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
		end

	add_window_at_pos (a_term: CE_POINTER [PD_TERMINAL]; a_handler: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_at: CE_POINTER [PD_WINDOW])
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_win: CE_POINTER [PD_WINDOW]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ev.make (<<1>>)
			create l_win.make

			l_ev.item.ev := 0
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_ev.item.x := (a_term.item.x).to_integer_32
			l_ev.item.y := (a_term.item.y).to_integer_32
			l_win := create {CE_POINTER [PD_WINDOW]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 168, (create {PD_WINDOW}.make).structure_size.to_natural_32)))
			l_win.item.handler := a_handler
			l_win.item.data := a_data
			l_win.item.term := a_term
			l_tmp___0 := 0
			l_win.item.yp := l_tmp___0
			l_win.item.xp := l_tmp___0
			from
			until
				js.loop_done
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_at))
				l_win.item.next := a_at.item.next
				l_win.item.prev := a_at
				a_at.item.next := l_win;
				(l_win.item.next).item.prev := l_win
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_at))
				js.break
			end
			(l_win.item.handler).call ([l_win, l_ev, 0])
		end

	alloc_term_screen (a_term: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_32]
			l_t: CE_POINTER [NATURAL_32]
		do
			create l_s.make
			create l_t.make

			if a_x.to_boolean then
				if (a_x.to_natural_32 * a_y.to_natural_32) // a_x.to_natural_32 /= a_y.to_natural_32 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 62])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
			end
			if a_x.to_natural_32 * a_y.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Natural_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 63])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_s := create {CE_POINTER [NATURAL_32]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 64, create {CE_POINTER [ANY]}.make_cast (a_term.item.screen), (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)))
			l_t := create {CE_POINTER [NATURAL_32]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 65, create {CE_POINTER [ANY]}.make_cast (a_term.item.last_screen), (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_t), -1, (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			a_term.item.x := a_x
			a_term.item.y := a_y
			a_term.item.last_screen := l_t
			memset (create {CE_POINTER [ANY]}.make_cast (l_s), 0, (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			a_term.item.screen := l_s
			a_term.item.dirty := 1
		end

	check_if_no_terminal
		local
			js: JUMP_STATE
		do
			if not ((terminals.item.next).is_equal (terminals)) then
				js.return
			end
			if not js.return_called then
				select_inst.terminate := 1
			end
		end

	clear_terminal (a_term: CE_POINTER [PD_TERMINAL])
		do
			fill_area (a_term, 0, 0, a_term.item.x, a_term.item.y, ((' ').code).to_natural_32)
			set_cursor (a_term, 0, 0, 0, 0)
		end

	close_handle (a_p: CE_POINTER [ANY])
		local
			l_h: INTEGER_32
		do
			l_h := (a_p.c_pointer.to_integer_32).to_integer_32
			close (l_h).do_nothing
			select_inst.set_handlers (l_h, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
		end

	close_handle_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent close_handle)
		end

	cls_redraw_all_terminals
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_term := create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals.item.next)
			from
			until
				l_term.is_equal (terminals)
			loop
				redraw_terminal_cls (l_term)
				l_term := l_term.item.next
			end
		end

	delete_window (a_win: CE_POINTER [PD_WINDOW])
		local
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create l_ev.make (<<1>>)

			l_ev.item.ev := 5
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0;
			(a_win.item.handler).call ([a_win, l_ev, 1])
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_win));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_win.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_win.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_win.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_win.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_win))
			if (not (a_win.item.data).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 187, a_win.item.data)
			end
			redraw_terminal (a_win.item.term)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 189, create {CE_POINTER [ANY]}.make_cast (a_win))
		end

	delete_window_ev (a_win: CE_POINTER [PD_WINDOW]; a_ev: CE_POINTER [PD_EVENT])
		local
			l_w: CE_POINTER [PD_WINDOW]
		do
			create l_w.make

			l_w := a_win.item.next
			if l_w.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_win.item.term).c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
				l_w := create {CE_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			end
			delete_window (a_win)
			if (not a_ev.is_void) then
				if (not l_w.is_void) then
					if not (l_w.item.next).is_equal (l_w) then
						(l_w.item.handler).call ([l_w, a_ev, 1])
					end
				end
			end
		end

	destroy_all_terminals
		local
			l_term: CE_POINTER [PD_TERMINAL]
			js: JUMP_STATE
		do
			create l_term.make

			from
			until
				js.loop_done
			loop
				l_term := create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals.item.next)
				if l_term.is_equal (terminals) then
					js.break
				end
				if not js.loop_jumped then
					destroy_terminal (l_term)
				end
			end
		end

	destroy_terminal (a_term: CE_POINTER [PD_TERMINAL])
		do
			from
			until
				(a_term.item.windows.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))
			loop
				delete_window (create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next))
			end
			if (not (a_term.item.title).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 556, create {CE_POINTER [ANY]}.make_cast (a_term.item.title))
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 557, create {CE_POINTER [ANY]}.make_cast (a_term.item.screen))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 558, create {CE_POINTER [ANY]}.make_cast (a_term.item.last_screen))
			select_inst.set_handlers (a_term.item.fdin, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 560, create {CE_POINTER [ANY]}.make_cast (a_term.item.input_queue))
			if a_term.item.blocked /= -1 then
				close (a_term.item.blocked).do_nothing
				select_inst.set_handlers (a_term.item.blocked, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_term));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_term.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_term.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_term.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_term.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_term))
			close (a_term.item.fdin).do_nothing
			if a_term.item.fdout /= 1 then
				if a_term.item.fdout /= a_term.item.fdin then
					close (a_term.item.fdout).do_nothing
				end
			else
				main_inst.unhandle_terminal_signals (a_term)
				kbd_inst.free_all_itrms
				if not ((terminals.item.next).is_equal (terminals)) then
					if (fork) > 0 then
						exit2 (0)
					end
				end
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 578, create {CE_POINTER [ANY]}.make_cast (a_term))
			check_if_no_terminal
		end

	destroy_terminal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent destroy_terminal)
		end

	do_terminal_function (a_term: CE_POINTER [PD_TERMINAL]; a_code: NATURAL_8; a_data: CE_POINTER [NATURAL_8])
		local
			l_x_data: CE_POINTER [NATURAL_8]
		do
			create l_x_data.make

			l_x_data := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 763, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_data))) + {NATURAL_32} 2)))
			l_x_data[0] := a_code
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_x_data + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (a_data)).do_nothing
			exec_on_terminal (a_term, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_x_data, 0)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 767, create {CE_POINTER [ANY]}.make_cast (l_x_data))
		end

	draw_frame (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_xw: INTEGER_32; a_yw: INTEGER_32; a_c: NATURAL_32; a_w: INTEGER_32)
		local
			l_c: NATURAL_32
			l_p: CE_POINTER [INTEGER_32]
			l_tmp: CE_POINTER [INTEGER_32]
		do
			create l_p.make
			create l_tmp.make

			l_c := a_c
			if a_w > 1 then
				l_tmp := p2
			else
				l_tmp := p1
			end
			l_p := l_tmp
			l_c := (l_c).bit_or (({NATURAL_32} 32_768))
			set_char (a_t, a_x, a_y, l_c + (l_p[0]).to_natural_32)
			set_char (a_t, (a_x + a_xw) - 1, a_y, l_c + (l_p[1]).to_natural_32)
			set_char (a_t, a_x, (a_y + a_yw) - 1, l_c + (l_p[2]).to_natural_32)
			set_char (a_t, (a_x + a_xw) - 1, (a_y + a_yw) - 1, l_c + (l_p[3]).to_natural_32)
			fill_area (a_t, a_x, a_y + 1, 1, a_yw - 2, l_c + (l_p[4]).to_natural_32)
			fill_area (a_t, (a_x + a_xw) - 1, a_y + 1, 1, a_yw - 2, l_c + (l_p[4]).to_natural_32)
			fill_area (a_t, a_x + 1, a_y, a_xw - 2, 1, l_c + (l_p[5]).to_natural_32)
			fill_area (a_t, a_x + 1, (a_y + a_yw) - 1, a_xw - 2, 1, l_c + (l_p[5]).to_natural_32)
		end

	empty_window_handler (a_win: CE_POINTER [PD_WINDOW]; a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		local
			l_n: CE_POINTER [PD_WINDOW]
			l_ewd: CE_POINTER [PD_EWD]
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_n.make
			create l_ewd.make
			create l_x.make (<<1>>)
			create l_y.make (<<1>>)
			create l_fn.make
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ewd := create {CE_POINTER [PD_EWD]}.make_cast (a_win.item.data)
					l_fn := l_ewd.item.fn
					l_data := l_ewd.item.data
					if (l_ewd.item.b).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 2
						when 3 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3
						get_parent_ptr (a_win, l_x, l_y)
						set_window_ptr (a_win, l_x.item, l_y.item)
						js.return
				when 3 then -- switch 1, case 5
						if not js.return_called then
							l_fn.call ([l_data])
							js.return
						end
				when 4 then -- switch 1, done: | if done
						if not js.return_called then
							l_ewd.item.b := 1
							l_n := a_win.item.next
							delete_window (a_win)
							l_fn.call ([l_data])
							if not (l_n.item.next).is_equal (l_n) then
								(l_n.item.handler).call ([l_n, a_ev, a_fwd])
							end
						end
				when 5 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	empty_window_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent empty_window_handler)
		end

	erase_screen (a_term: CE_POINTER [PD_TERMINAL])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_term.item.master).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (kbd_inst.is_blocked).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (a_term.item.master).to_boolean then
							os_dep_inst.want_draw
						end
						hard_write (a_term.item.fdout, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[2J%/27/[1;1H")), 10).do_nothing
						if (a_term.item.master).to_boolean then
							os_dep_inst.done_draw
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	exec_on_terminal (a_term: CE_POINTER [PD_TERMINAL]; a_path: CE_POINTER [NATURAL_8]; a_delete: CE_POINTER [NATURAL_8]; a_fg: INTEGER_32)
		local
			l_path: CE_POINTER [NATURAL_8]
			l_blockh: INTEGER_32
			l_param: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___4: NATURAL_32
			l_data: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___10: NATURAL_32
			js: JUMP_STATE
		do
			create l_path.make
			create l_param.make
			create l_data.make

			l_path := a_path
			if (not l_path.is_void) then
				if not (l_path.item).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if l_path.is_void then
					l_path := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
				end
				if (a_term.item.master).to_boolean then
					if not (l_path.item).to_boolean then
						kbd_inst.dispatch_special (a_delete)
					else
						if (kbd_inst.is_blocked).to_boolean then
							if a_fg.to_boolean then
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)).do_nothing
								js.return
							end
						end
						if not js.return_called then
							l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))
							l_param := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 722, (l_tmp___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)))) + {NATURAL_32} 3)))
							l_param[0] := a_fg.to_natural_8
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_param + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_path)).do_nothing
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((((l_param + 1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))).to_integer_32) + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)).do_nothing
							if a_fg = 1 then
								kbd_inst.block_itrm (a_term.item.fdin)
							end
							l_tmp___4 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))
							l_blockh := os_dep_inst.start_thread ((exec_thread_address), create {CE_POINTER [ANY]}.make_cast (l_param), ((l_tmp___4 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)))) + {NATURAL_32} 3).to_integer_32)
							if l_blockh = -1 then
								if a_fg = 1 then
									kbd_inst.unblock_itrm (a_term.item.fdin).do_nothing
								end
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 729, create {CE_POINTER [ANY]}.make_cast (l_param))
								js.return
							end
						end
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 732, create {CE_POINTER [ANY]}.make_cast (l_param))
							if a_fg = 1 then
								a_term.item.blocked := l_blockh
								select_inst.set_handlers (l_blockh, (unblock_terminal_address), create {CE_ROUTINE}.make_shared (default_pointer), (unblock_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_term))
								select_inst.set_handlers (a_term.item.fdin, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), (destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_term))
							else
								select_inst.set_handlers (l_blockh, close_handle_address, create {CE_ROUTINE}.make_shared (default_pointer), close_handle_address, create {CE_POINTER [ANY]}.make_shared (default_pointer + l_blockh))
							end
						end
					end
				else
					l_tmp___6 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))
					l_data := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 744, (l_tmp___6 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)))) + {NATURAL_32} 4)))
					l_data[0] := (0).to_natural_8
					l_data[1] := a_fg.to_natural_8
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_data + 2)), create {CE_POINTER [INTEGER_8]}.make_cast (l_path)).do_nothing
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_data + 3) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))).to_integer_32)), create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)).do_nothing
					l_tmp___10 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))
					hard_write (a_term.item.fdout, l_data, ((l_tmp___10 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_delete)))) + {NATURAL_32} 4).to_integer_32).do_nothing
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 750, create {CE_POINTER [ANY]}.make_cast (l_data))
				end
			end
			if not js.return_called then
			end
		end

	exec_thread (a_path: CE_POINTER [NATURAL_8]; a_p: INTEGER_32)
		do
			if (a_path[0]).to_integer_32 = 2 then
				setpgid (0, 0).do_nothing
			end
			os_dep_inst.exe (create {CE_POINTER [INTEGER_8]}.make_cast ((a_path + 1))).do_nothing
			if (a_path[(({NATURAL_32} 1 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_path + 1))))) + {NATURAL_32} 1).to_integer_32]).to_boolean then
				unlink (create {CE_POINTER [INTEGER_8]}.make_cast ((((a_path + 1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_path + 1)))).to_integer_32) + 1))).do_nothing
			end
		end

	exec_thread_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent exec_thread)
		end

	fill_area (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_xw: INTEGER_32; a_yw: INTEGER_32; a_c: NATURAL_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			a_t.item.dirty := 1
			if a_y >= 0 then
				l_j := 0
			else
				l_j := -a_y
			end
			from
			until
				js.loop_done
			loop
				if l_j < a_yw then
					if not (a_y + l_j < a_t.item.y) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if a_x >= 0 then
						l_i := 0
					else
						l_i := -a_x
					end
					from
					until
						js.loop_done
					loop
						if l_i < a_xw then
							if not (a_x + l_i < a_t.item.x) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							a_t.item.screen[((a_x + l_i) + a_t.item.x * (a_y + l_j))] := a_c
							l_i := l_i + 1
						end
					end
					l_j := l_j + 1
				end
			end
		end

	free_term_specs
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a__.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (term_specs))
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (term_specs.item.next)
			from
			until
				l_a__.is_equal (term_specs)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (term_specs.item.prev)
			from
			until
				l_a__.is_equal (term_specs)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(term_specs.item.next).is_equal (term_specs)
			loop
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (term_specs.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 269, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (term_specs))
		end

	get_char (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32): NATURAL_32
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
		do
			l_x := a_x
			l_y := a_y
			if l_x >= a_t.item.x then
				l_x := a_t.item.x - 1
			end
			if l_x < 0 then
				l_x := 0
			end
			if l_y >= a_t.item.y then
				l_y := a_t.item.y - 1
			end
			if l_y < 0 then
				l_y := 0
			end
			Result := (a_t.item.screen[(l_x + a_t.item.x * l_y)])
		end

	get_cwd: CE_POINTER [NATURAL_8]
		local
			l_bufsize: INTEGER_32
			l_buf___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___0.make

			l_bufsize := 128
			from
			until
				js.loop_done
			loop
				l_buf___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 41, l_bufsize.to_natural_32)))
				if (not (getcwd (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___0), l_bufsize.to_natural_32)).is_void) then
					Result := l_buf___0
					js.return
				end
				if not js.return_called then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 43, create {CE_POINTER [ANY]}.make_cast (l_buf___0))
					if (errno_location).item = 4 then
						js.continue
					end
					if not js.loop_jumped then
						if (errno_location).item /= 34 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							if l_bufsize.to_natural_32 > {NATURAL_32} 2_147_483_519 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 46])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_bufsize := l_bufsize + (128)
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	get_parent_ptr (a_win: CE_POINTER [PD_WINDOW]; a_x: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32])
		local
			l_tmp: INTEGER_32
		do
			if not (a_win.item.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_win.item.term).c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
				a_x.item := (a_win.item.next).item.xp
				a_y.item := (a_win.item.next).item.yp
			else
				l_tmp := 0
				a_y.item := l_tmp
				a_x.item := l_tmp
			end
		end

	get_root_window (a_term: CE_POINTER [PD_TERMINAL]): CE_POINTER [PD_WINDOW]
		local
			js: JUMP_STATE
		do
			if (a_term.item.windows.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c"))
					links_inst.errline := 219
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal has no windows"))])
				end
				Result := (create {CE_POINTER [PD_WINDOW]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.prev))
			end
		end

	get_term_spec (a_term: CE_POINTER [NATURAL_8]): CE_POINTER [PD_TERM_SPEC]
		local
			l_t: CE_POINTER [PD_TERM_SPEC]
			js: JUMP_STATE
		do
			create l_t.make

			l_t := create {CE_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item.next)
			from
			until
				not (not js.loop_done and then (not l_t.is_equal (term_specs)))
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_t.item.term)), create {CE_POINTER [INTEGER_8]}.make_cast (a_term))).to_boolean then
					Result := l_t
					js.return
				end
				if not js.return_called then
					l_t := l_t.item.next
				end
			end
			if not js.return_called then
				Result := dumb_term
			end
		end

	getcompcode (a_c: INTEGER_32): INTEGER_32
		do
			Result := ((((((a_c).bit_shift_left (1))).bit_or (((((a_c).bit_and (4))).bit_shift_right (2))))).bit_and (7))
		end

	hard_read (a_fd: INTEGER_32; a_p: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_r: INTEGER_32
			l_t: INTEGER_32
			js: JUMP_STATE
		do
			create l_p.make

			l_p := a_p
			l_l := a_l
			l_r := 1
			l_t := 0
			from
			until
				js.loop_done
			loop
				if l_l > 0 then
					if not l_r.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_r := read (a_fd, create {CE_POINTER [ANY]}.make_cast (l_p), l_l.to_natural_32)
					if l_r < 0 then
						if (errno_location).item = 4 then
							js.continue
						end
						if not js.loop_jumped then
							Result := (-1)
							js.return
						end
					end
				end
				if not js.loop_jumped then
					l_t := l_t + l_r
					l_p := l_p + l_r
					l_l := l_l - l_r
				end
			end
			if not js.return_called then
				Result := l_t
			end
		end

	hard_write (a_fd: INTEGER_32; a_p: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_w: INTEGER_32
			l_t: INTEGER_32
			js: JUMP_STATE
		do
			create l_p.make

			l_p := a_p
			l_l := a_l
			l_w := 1
			l_t := 0
			from
			until
				js.loop_done
			loop
				if l_l > 0 then
					if not l_w.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_w := write (a_fd, create {CE_POINTER [ANY]}.make_cast (l_p), l_l.to_natural_32)
					if l_w < 0 then
						if (errno_location).item = 4 then
							js.continue
						end
						if not js.loop_jumped then
							Result := (-1)
							js.return
						end
					end
				end
				if not js.loop_jumped then
					l_t := l_t + l_w
					l_p := l_p + l_w
					l_l := l_l - l_w
				end
			end
			if not js.return_called then
				Result := l_t
			end
		end

	in_term (a_term: CE_POINTER [PD_TERMINAL])
		local
			l_ev: CE_POINTER [PD_EVENT]
			l_r: INTEGER_32
			l_iq: CE_POINTER [NATURAL_8]
			l_init_len: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ev.make
			create l_iq.make
			create l_win.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_term.item.qlen).to_natural_32 + {NATURAL_32} 64 > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 344])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_iq := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 345, create {CE_POINTER [ANY]}.make_cast (a_term.item.input_queue), (a_term.item.qlen + 64).to_natural_32)))
					a_term.item.input_queue := l_iq
					l_r := read (a_term.item.fdin, create {CE_POINTER [ANY]}.make_cast ((l_iq + a_term.item.qlen)), (64).to_natural_32)
					if l_r <= 0 then
						if l_r = -1 then
							if (errno_location).item /= 104 then
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: error %%d on terminal: could not read event")), (errno_location).item])
							end
						end
						destroy_terminal (a_term)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_term.item.qlen := a_term.item.qlen + l_r
				when 2 then -- test_queue:
						if (a_term.item.qlen).to_natural_32 < (create {PD_EVENT}.make).structure_size.to_natural_32 then
							js.return
						end
				when 3 then -- if done
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_ev := create {CE_POINTER [PD_EVENT]}.make_cast (l_iq)
						l_r := ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32
						if l_ev.item.ev /= 0 then
							if l_ev.item.ev /= 4 then
								if l_ev.item.ev /= 3 then
									if l_ev.item.ev /= 1 then
										if l_ev.item.ev /= 2 then
											if l_ev.item.ev /= 5 then
												error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: error on terminal: bad event %%d")), l_ev.item.ev])
												l_pos := -1 + 26 -- goto mm
											end
										end
									end
								end
							end
						end
				when 5 then
						if l_ev.item.ev = 0 then
							if (a_term.item.qlen).to_natural_32 < (((create {PD_EVENT}.make).structure_size.to_natural_32 + {NATURAL_32} 32) + {NATURAL_32} 256) + {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32 then
								js.return
							end
							if not js.return_called then
								l_init_len := (create {CE_POINTER [INTEGER_32]}.make_cast (((((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32) + 256) + ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32))).item
								if (a_term.item.qlen).to_natural_32 < ((((create {PD_EVENT}.make).structure_size.to_natural_32 + {NATURAL_32} 32) + {NATURAL_32} 256) + {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32) + l_init_len.to_natural_32 then
									js.return
								end
							end
							if not js.return_called then
								memcpy (create {CE_POINTER [ANY]}.make_cast ((a_term.item.term)), create {CE_POINTER [ANY]}.make_cast ((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)), (32).to_natural_32).do_nothing
								a_term.item.term[31] := (0).to_natural_8
								memcpy (create {CE_POINTER [ANY]}.make_cast ((a_term.item.cwd)), create {CE_POINTER [ANY]}.make_cast (((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32)), (256).to_natural_32).do_nothing
								a_term.item.cwd[255] := (0).to_natural_8
								a_term.item.environment := (create {CE_POINTER [INTEGER_32]}.make_cast ((((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32) + 256))).item
								l_ev.item.b := (((((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32) + 256) + ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32).c_pointer.to_integer_32).to_integer_32
								l_r := (((((create {PD_EVENT}.make).structure_size.to_natural_32 + {NATURAL_32} 32) + {NATURAL_32} 256) + {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32) + l_init_len.to_natural_32).to_integer_32
								sync_term_specs
							end
						end
				when 6 then -- if done
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 7 then -- if:
						if l_ev.item.ev /= 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto send_redraw
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 10 then -- else:
						if l_ev.item.ev /= 4 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto send_redraw
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if l_ev.item.ev /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | send_redraw:
						if l_ev.item.x < 0 then
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: bad terminal size: %%d, %%d")), (l_ev.item.x).to_integer_32, (l_ev.item.y).to_integer_32])
							l_pos := -1 + 26 -- goto mm
						elseif l_ev.item.y < 0 then
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: bad terminal size: %%d, %%d")), (l_ev.item.x).to_integer_32, (l_ev.item.y).to_integer_32])
							l_pos := -1 + 26 -- goto mm
						end
				when 15 then
						alloc_term_screen (a_term, (l_ev.item.x).to_integer_32, (l_ev.item.y).to_integer_32)
						clear_terminal (a_term)
						erase_screen (a_term)
						a_term.item.redrawing := 1
						l_win := create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.prev)
						from
						until
							l_win.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))
						loop
							(l_win.item.handler).call ([l_win, l_ev, 0])
							l_win := l_win.item.prev
						end
						a_term.item.redrawing := 0
				when 16 then -- if done | if done
						if l_ev.item.ev /= 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___2
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 19 then -- else:
						if l_ev.item.ev /= 2 then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if: | _L___2:
						if l_ev.item.ev /= 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (links_inst.upcase ((l_ev.item.x).to_natural_8)).to_integer_32 = 76 then
							if l_ev.item.y = 2 then
								l_ev.item.ev := 3
								l_ev.item.x := (a_term.item.x).to_integer_32
								l_ev.item.y := (a_term.item.y).to_integer_32
								l_pos := -1 + 14 -- goto send_redraw
							else
								l_pos := -1 + 23 -- goto _L___1
							end
						else
							l_pos := -1 + 23 -- goto _L___1
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L___1:
						if l_ev.item.ev = 1 then
							if l_ev.item.x = 512 then
								(((create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.prev).item.handler).call ([create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.prev), l_ev, 0])
							else
								(((create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next).item.handler).call ([create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next), l_ev, 0])
							end
						else
							(((create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next).item.handler).call ([create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next), l_ev, 0])
						end
				when 24 then -- if done | if done
						if l_ev.item.ev = 5 then
							destroy_terminal (a_term)
							js.return
						end
				when 25 then -- if done
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 26 then -- if: | mm:
						if a_term.item.qlen = l_r then
							a_term.item.qlen := 0
						else
							l_tmp___3 := a_term.item.qlen - l_r
							a_term.item.qlen := l_tmp___3
							memmove (create {CE_POINTER [ANY]}.make_cast (l_iq), create {CE_POINTER [ANY]}.make_cast ((l_iq + l_r)), l_tmp___3.to_natural_32).do_nothing
						end
						l_pos := -1 + 2 -- goto test_queue
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	in_term_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent in_term)
		end

	init_term (a_fdin: INTEGER_32; a_fdout: INTEGER_32; a_root_window: CE_ROUTINE): CE_POINTER [PD_TERMINAL]
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_win: CE_POINTER [PD_WINDOW]
			js: JUMP_STATE
		do
			create l_term.make
			create l_win.make

			l_term := create {CE_POINTER [PD_TERMINAL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 306, (create {PD_TERMINAL}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_term), 0, (create {PD_TERMINAL}.make).structure_size.to_natural_32).do_nothing
			l_term.item.fdin := a_fdin
			l_term.item.fdout := a_fdout
			l_term.item.master := (l_term.item.fdout = (os_dep_inst.get_output_handle)).to_integer
			l_term.item.lcx := -1
			l_term.item.lcy := -1
			l_term.item.dirty := 1
			l_term.item.redrawing := 0
			l_term.item.blocked := -1
			l_term.item.screen := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer + -1)
			l_term.item.last_screen := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer + -1)
			l_term.item.spec := dumb_term
			l_term.item.term[0] := (0).to_natural_8
			l_term.item.cwd[0] := (0).to_natural_8
			l_term.item.input_queue := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			l_term.item.qlen := 0
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
			l_term.item.windows.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))
			l_term.item.windows.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
			l_win := create {CE_POINTER [PD_WINDOW]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 328, (create {PD_WINDOW}.make).structure_size.to_natural_32)))
			l_win.item.handler := a_root_window
			l_win.item.data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			l_win.item.term := l_term
			from
			until
				js.loop_done
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
				l_win.item.next := (create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next
				l_win.item.prev := create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))));
				(create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next := l_win;
				(l_win.item.next).item.prev := l_win
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
				js.break
			end
			from
			until
				js.loop_done
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (terminals))
				l_term.item.next := (create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals)).item.next
				l_term.item.prev := create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals);
				(create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals)).item.next := l_term;
				(l_term.item.next).item.prev := l_term
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (terminals))
				js.break
			end
			select_inst.set_handlers (a_fdin, (in_term_address), create {CE_ROUTINE}.make_shared (default_pointer), (destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (l_term))
			Result := l_term
		end

	new_term_spec (a_term: CE_POINTER [NATURAL_8]): CE_POINTER [PD_TERM_SPEC]
		local
			l_t: CE_POINTER [PD_TERM_SPEC]
			js: JUMP_STATE
		do
			create l_t.make

			l_t := create {CE_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item.next)
			from
			until
				not (not js.loop_done and then (not l_t.is_equal (term_specs)))
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_t.item.term)), create {CE_POINTER [INTEGER_8]}.make_cast (a_term))).to_boolean then
					Result := l_t
					js.return
				end
				if not js.return_called then
					l_t := l_t.item.next
				end
			end
			if not js.return_called then
				l_t := create {CE_POINTER [PD_TERM_SPEC]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 287, (create {PD_TERM_SPEC}.make).structure_size.to_natural_32)))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_t), create {CE_POINTER [ANY]}.make_cast (dumb_term), (create {PD_TERM_SPEC}.make).structure_size.to_natural_32).do_nothing
				if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_term))) < {NATURAL_32} 32 then
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_t.item.term)), create {CE_POINTER [INTEGER_8]}.make_cast (a_term)).do_nothing
				else
					memcpy (create {CE_POINTER [ANY]}.make_cast ((l_t.item.term)), create {CE_POINTER [ANY]}.make_cast (a_term), (31).to_natural_32).do_nothing
					l_t.item.term[31] := (0).to_natural_8
				end
				from
				until
					js.loop_done
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (term_specs))
					l_t.item.next := (create {CE_POINTER [PD_TERM_SPEC]}.make_cast (term_specs)).item.next
					l_t.item.prev := create {CE_POINTER [PD_TERM_SPEC]}.make_cast (term_specs);
					(create {CE_POINTER [PD_TERM_SPEC]}.make_cast (term_specs)).item.next := l_t;
					(l_t.item.next).item.prev := l_t
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (term_specs))
					js.break
				end
				sync_term_specs
				Result := l_t
			end
		end

	print_text (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_l: INTEGER_32; a_text: CE_POINTER [NATURAL_8]; a_c: NATURAL_32)
		local
			l_x: INTEGER_32
			l_l: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_text.make

			l_x := a_x
			l_l := a_l
			l_text := a_text
			from
			until
				js.loop_done
			loop
				l_tmp := l_l
				l_l := l_l - 1
				if l_tmp.to_boolean then
					if not (l_text.item).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					set_char (a_t, l_x, a_y, (l_text.item).to_natural_32 + a_c)
					l_text := l_text + 1
					l_x := l_x + 1
				end
			end
		end

	redraw_all_terminals
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_term := create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals.item.next)
			from
			until
				l_term.is_equal (terminals)
			loop
				redraw_screen (l_term)
				l_term := l_term.item.next
			end
		end

	redraw_below_window (a_win: CE_POINTER [PD_WINDOW])
		local
			l_win: CE_POINTER [PD_WINDOW]
			l_tr: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
			l_end: CE_POINTER [PD_WINDOW]
			l_ev: CE_ARRAY [PD_EVENT]
			js: JUMP_STATE
		do
			create l_win.make
			create l_term.make
			create l_end.make
			create l_ev.make (<<1>>)

			l_win := a_win
			l_term := l_win.item.term
			l_end := l_win
			l_ev.item.ev := 3
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_ev.item.x := (l_term.item.x).to_integer_32
			l_ev.item.y := (l_term.item.y).to_integer_32
			if l_term.item.redrawing >= 2 then
				js.return
			end
			if not js.return_called then
				l_tr := l_term.item.redrawing;
				(l_win.item.term).item.redrawing := 2
				l_win := create {CE_POINTER [PD_WINDOW]}.make_cast (l_term.item.windows.prev)
				from
				until
					l_win.is_equal (l_end)
				loop
					(l_win.item.handler).call ([l_win, l_ev, 0])
					l_win := l_win.item.prev
				end
				l_term.item.redrawing := l_tr
			end
		end

	redraw_from_window (a_win: CE_POINTER [PD_WINDOW])
		local
			l_win: CE_POINTER [PD_WINDOW]
			l_term: CE_POINTER [PD_TERMINAL]
			l_end: CE_POINTER [PD_WINDOW]
			l_ev: CE_ARRAY [PD_EVENT]
			js: JUMP_STATE
		do
			create l_win.make
			create l_term.make
			create l_end.make
			create l_ev.make (<<1>>)

			l_win := a_win
			l_term := l_win.item.term
			l_end := create {CE_POINTER [PD_WINDOW]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))
			l_ev.item.ev := 3
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_ev.item.x := (l_term.item.x).to_integer_32
			l_ev.item.y := (l_term.item.y).to_integer_32
			if (l_term.item.redrawing).to_boolean then
				js.return
			end
			if not js.return_called then
				l_term.item.redrawing := 1
				l_win := l_win.item.prev
				from
				until
					l_win.is_equal (l_end)
				loop
					(l_win.item.handler).call ([l_win, l_ev, 0])
					l_win := l_win.item.prev
				end
				l_term.item.redrawing := 0
			end
		end

	redraw_screen (a_term: CE_POINTER [PD_TERMINAL])
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_p: INTEGER_32
			l_cx: INTEGER_32
			l_cy: INTEGER_32
			l_a: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_attrib: INTEGER_32
			l_mode: INTEGER_32
			l_l: CE_ARRAY [INTEGER_32]
			l_s: CE_POINTER [PD_TERM_SPEC]
			l_i: INTEGER_32
			l_ch: NATURAL_32
			l_c: NATURAL_8
			l_A2: NATURAL_8
			l_m: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_ch___0: NATURAL_32
			l_c___0: NATURAL_8
			l_A___0: NATURAL_8
			l_m___0: CE_ARRAY [NATURAL_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a.make (<<1>>)
			create l_l.make (<<1>>)
			create l_s.make
			create l_m.make (<<4>>)
			create l_m___0.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := 0
					l_cx := a_term.item.lcx
					l_cy := a_term.item.lcy
					l_attrib := -1
					l_mode := -1
					l_l.item := 0
					if not (a_term.item.dirty).to_boolean then
						js.return
					elseif (a_term.item.master).to_boolean then
						if (kbd_inst.is_blocked).to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 80 -- skip if block
					end
				when 1 then -- if:
						l_a.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 505)
						l_s := a_term.item.spec
						l_y := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_y < a_term.item.y)) then
							l_pos := -1 + 74 -- skip loop
						end
				when 3 then -- loop body:
						l_x := 0
				when 4 then -- loop condition:
						if not (not js.loop_done and then (l_x < a_term.item.x)) then
							l_pos := -1 + 73 -- skip loop
						end
				when 5 then -- loop body:
						if l_y = a_term.item.y - 1 then
							if l_x = a_term.item.x - 1 then
								js.break
							end
						end
						if not js.loop_jumped and then (a_term.item.screen[l_p] = a_term.item.last_screen[l_p]) then
							js.continue
						end
						if not (not js.loop_jumped and then (((a_term.item.screen[l_p]).bit_and ({NATURAL_32} 14_336)) = ((a_term.item.last_screen[l_p]).bit_and ({NATURAL_32} 14_336)))) then
							l_pos := -1 + 21 -- skip if block
						end
				when 6 then -- if:
						if ((a_term.item.screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else:
						if ((a_term.item.screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 12 then -- else:
						if ((a_term.item.screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if: | _L___0:
						if ((a_term.item.last_screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 16 then -- else:
						if ((a_term.item.last_screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if ((a_term.item.last_screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L:
						if l_x /= a_term.item.cx then
							js.continue
						elseif l_y /= a_term.item.cy then
							js.continue
						end
				when 21 then -- if done | if done | if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 72 -- skip if block
						end
				when 22 then -- if:
						a_term.item.last_screen[l_p] := a_term.item.screen[l_p]
						if l_cx /= l_x then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if l_cy = l_y then
							l_pos := -1 + 54 -- goto pc
						else
							l_pos := -1 + 25 -- goto _L___17
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 25 then -- else: | _L___17:
						if l_cy /= l_y then
							l_pos := -1 + 53 -- skip if block
						end
				when 26 then -- if:
						if not (l_x - l_cx < 10) then
							l_pos := -1 + 51 -- skip if block
						end
				when 27 then -- if:
						if not (l_x - l_cx > 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 28 then -- if:
						l_i := l_x - l_cx
				when 29 then -- loop condition:
						if not (l_i >= 0) then
							l_pos := -1 + 48 -- skip loop
						end
				when 30 then -- loop body:
						l_ch := a_term.item.screen[(l_p - l_i)]
						l_c := ((l_ch).bit_and ({NATURAL_32} 255)).to_natural_8
						l_A2 := ((((l_ch).bit_shift_right (8))).bit_and ({NATURAL_32} 127)).to_natural_8
						if l_s.item.mode /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (l_s.item.m11_hack).to_boolean then
							if ((l_ch).bit_shift_right (15)).to_integer_32 /= l_mode then
								l_mode := ((l_ch).bit_shift_right (15)).to_integer_32
								if l_mode.to_boolean then
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[11m")))
								else
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[10m")))
								end
							end
						end
						if (l_s.item.restrict_852).to_boolean then
							if ((l_ch).bit_shift_right (15)).to_boolean then
								if l_c.to_integer_32 >= 176 then
									if l_c.to_integer_32 < 224 then
										if (frame_restrict[l_c.to_integer_32 - 176]).to_boolean then
											l_c := frame_restrict[l_c.to_integer_32 - 176]
										end
									end
								end
							end
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 33 then -- else:
						if l_s.item.mode /= 1 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if ((l_ch).bit_shift_right (15)).to_integer_32 /= l_mode then
							l_mode := ((l_ch).bit_shift_right (15)).to_integer_32
							if l_mode.to_boolean then
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/14/")))
							else
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/15/")))
							end
						end
						if l_mode.to_boolean then
							if l_c.to_integer_32 >= 176 then
								if l_c.to_integer_32 < 224 then
									l_c := frame_vt100[l_c.to_integer_32 - 176]
								end
							end
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 36 then -- else:
						if l_s.item.mode /= 3 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if ((l_ch).bit_shift_right (15)).to_boolean then
							if l_c.to_integer_32 >= 176 then
								if l_c.to_integer_32 < 224 then
									l_c := frame_koi[l_c.to_integer_32 - 176]
								else
									l_pos := -1 + 39 -- goto _L___6
								end
							else
								l_pos := -1 + 39 -- goto _L___6
							end
						else
							l_pos := -1 + 39 -- goto _L___6
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 39 then -- else: | _L___6:
						if l_s.item.mode /= 4 then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						if ((l_ch).bit_shift_right (15)).to_boolean then
							if l_c.to_integer_32 >= 176 then
								if l_c.to_integer_32 < 224 then
									l_c := frame_freebsd[l_c.to_integer_32 - 176]
								else
									l_pos := -1 + 42 -- goto _L___3
								end
							else
								l_pos := -1 + 42 -- goto _L___3
							end
						else
							l_pos := -1 + 42 -- goto _L___3
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else: | _L___3:
						if l_s.item.mode = 0 then
							if ((l_ch).bit_shift_right (15)).to_boolean then
								if l_c.to_integer_32 >= 176 then
									if l_c.to_integer_32 < 224 then
										l_c := frame_dumb[l_c.to_integer_32 - 176]
									end
								end
							end
						end
				when 43 then -- if done | if done | if done
						if not ((l_A2.to_integer_32).bit_and (64)).to_boolean then
							if (l_A2.to_integer_32).bit_shift_right (3) = ((l_A2.to_integer_32).bit_and (7)) then
								l_A2 := ((((l_A2.to_integer_32).bit_and (56))).bit_or (7 * (not ((l_A2.to_integer_32).bit_and (16)).to_boolean).to_integer)).to_natural_8
							end
						end
						if l_A2.to_integer_32 /= l_attrib then
							l_attrib := l_A2.to_integer_32
							links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[0")))
							if (l_s.item.col).to_boolean then
								l_m[0] := ((';').code).to_natural_8
								l_m[1] := (('3').code).to_natural_8
								l_m[3] := (0).to_natural_8
								l_m[2] := (((l_attrib).bit_and (7)) + 48).to_natural_8
								links_inst.add_to_str (l_a, l_l, l_m)
								l_m[1] := (('4').code).to_natural_8
								l_m[2] := (((((l_attrib).bit_shift_right (3))).bit_and (7)) + 48).to_natural_8
								links_inst.add_to_str (l_a, l_l, l_m)
							else
								l_tmp___0 := getcompcode ((l_attrib).bit_and (7))
								if l_tmp___0 < (getcompcode ((((l_attrib).bit_shift_right (3))).bit_and (7))) then
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";7")))
								end
							end
							if ((l_attrib).bit_and (64)).to_boolean then
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";1")))
							end
							links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("m")))
						end
						if not (l_c.to_integer_32 >= 32) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if l_c.to_integer_32 /= 127 then
							links_inst.add_chr_to_str (l_a, l_l, l_c)
						else
							l_pos := -1 + 46 -- goto _L___7
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L___7:
						if not l_c.to_boolean then
							links_inst.add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
						elseif l_c.to_integer_32 = 1 then
							links_inst.add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
						else
							links_inst.add_chr_to_str (l_a, l_l, (('.').code).to_natural_8)
						end
				when 47 then
						l_cx := l_cx + 1
						l_i := l_i - 1
						l_pos := -1 + 29 -- back to loop condition
				when 48 then -- loop done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						l_pos := -1 + 53 -- goto _L___16
				when 50 then -- if done | if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else:
						l_pos := -1 + 53 -- goto _L___16
				when 52 then -- if done | if block done, skip else block:
						l_pos := -1 + 72
				when 53 then -- else: | _L___16:
						links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[")))
						links_inst.add_num_to_str (l_a, l_l, (l_y + 1).to_integer_32)
						links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";")))
						links_inst.add_num_to_str (l_a, l_l, (l_x + 1).to_integer_32)
						links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H")))
						l_cx := l_x
						l_cy := l_y
				when 54 then -- pc:
						l_ch___0 := a_term.item.screen[l_p]
						l_c___0 := ((l_ch___0).bit_and ({NATURAL_32} 255)).to_natural_8
						l_A___0 := ((((l_ch___0).bit_shift_right (8))).bit_and ({NATURAL_32} 127)).to_natural_8
						if l_s.item.mode /= 2 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if (l_s.item.m11_hack).to_boolean then
							if ((l_ch___0).bit_shift_right (15)).to_integer_32 /= l_mode then
								l_mode := ((l_ch___0).bit_shift_right (15)).to_integer_32
								if l_mode.to_boolean then
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[11m")))
								else
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[10m")))
								end
							end
						end
						if (l_s.item.restrict_852).to_boolean then
							if ((l_ch___0).bit_shift_right (15)).to_boolean then
								if l_c___0.to_integer_32 >= 176 then
									if l_c___0.to_integer_32 < 224 then
										if (frame_restrict[l_c___0.to_integer_32 - 176]).to_boolean then
											l_c___0 := frame_restrict[l_c___0.to_integer_32 - 176]
										end
									end
								end
							end
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 57 then -- else:
						if l_s.item.mode /= 1 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if ((l_ch___0).bit_shift_right (15)).to_integer_32 /= l_mode then
							l_mode := ((l_ch___0).bit_shift_right (15)).to_integer_32
							if l_mode.to_boolean then
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/14/")))
							else
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/15/")))
							end
						end
						if l_mode.to_boolean then
							if l_c___0.to_integer_32 >= 176 then
								if l_c___0.to_integer_32 < 224 then
									l_c___0 := frame_vt100[l_c___0.to_integer_32 - 176]
								end
							end
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 60 then -- else:
						if l_s.item.mode /= 3 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if ((l_ch___0).bit_shift_right (15)).to_boolean then
							if l_c___0.to_integer_32 >= 176 then
								if l_c___0.to_integer_32 < 224 then
									l_c___0 := frame_koi[l_c___0.to_integer_32 - 176]
								else
									l_pos := -1 + 63 -- goto _L___13
								end
							else
								l_pos := -1 + 63 -- goto _L___13
							end
						else
							l_pos := -1 + 63 -- goto _L___13
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 63 then -- else: | _L___13:
						if l_s.item.mode /= 4 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if ((l_ch___0).bit_shift_right (15)).to_boolean then
							if l_c___0.to_integer_32 >= 176 then
								if l_c___0.to_integer_32 < 224 then
									l_c___0 := frame_freebsd[l_c___0.to_integer_32 - 176]
								else
									l_pos := -1 + 66 -- goto _L___10
								end
							else
								l_pos := -1 + 66 -- goto _L___10
							end
						else
							l_pos := -1 + 66 -- goto _L___10
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else: | _L___10:
						if l_s.item.mode = 0 then
							if ((l_ch___0).bit_shift_right (15)).to_boolean then
								if l_c___0.to_integer_32 >= 176 then
									if l_c___0.to_integer_32 < 224 then
										l_c___0 := frame_dumb[l_c___0.to_integer_32 - 176]
									end
								end
							end
						end
				when 67 then -- if done | if done | if done
						if not ((l_A___0.to_integer_32).bit_and (64)).to_boolean then
							if (l_A___0.to_integer_32).bit_shift_right (3) = ((l_A___0.to_integer_32).bit_and (7)) then
								l_A___0 := ((((l_A___0.to_integer_32).bit_and (56))).bit_or (7 * (not ((l_A___0.to_integer_32).bit_and (16)).to_boolean).to_integer)).to_natural_8
							end
						end
						if l_A___0.to_integer_32 /= l_attrib then
							l_attrib := l_A___0.to_integer_32
							links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[0")))
							if (l_s.item.col).to_boolean then
								l_m___0[0] := ((';').code).to_natural_8
								l_m___0[1] := (('3').code).to_natural_8
								l_m___0[3] := (0).to_natural_8
								l_m___0[2] := (((l_attrib).bit_and (7)) + 48).to_natural_8
								links_inst.add_to_str (l_a, l_l, l_m___0)
								l_m___0[1] := (('4').code).to_natural_8
								l_m___0[2] := (((((l_attrib).bit_shift_right (3))).bit_and (7)) + 48).to_natural_8
								links_inst.add_to_str (l_a, l_l, l_m___0)
							else
								l_tmp___2 := getcompcode ((l_attrib).bit_and (7))
								if l_tmp___2 < (getcompcode ((((l_attrib).bit_shift_right (3))).bit_and (7))) then
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";7")))
								end
							end
							if ((l_attrib).bit_and (64)).to_boolean then
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";1")))
							end
							links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("m")))
						end
						if not (l_c___0.to_integer_32 >= 32) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if l_c___0.to_integer_32 /= 127 then
							links_inst.add_chr_to_str (l_a, l_l, l_c___0)
						else
							l_pos := -1 + 70 -- goto _L___14
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else: | _L___14:
						if not l_c___0.to_boolean then
							links_inst.add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
						elseif l_c___0.to_integer_32 = 1 then
							links_inst.add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
						else
							links_inst.add_chr_to_str (l_a, l_l, (('.').code).to_natural_8)
						end
				when 71 then
						l_cx := l_cx + 1
				when 72 then -- if done | if done
						if js.loop_increment then
							l_x := l_x + 1
							l_p := l_p + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 73 then -- loop done
						l_y := l_y + 1
						l_pos := -1 + 2 -- back to loop condition
				when 74 then -- loop done
						if (l_l.item).to_boolean then
							if (l_s.item.col).to_boolean then
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[37;40m")))
							end
							links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[0m")))
							if l_s.item.mode = 2 then
								if (l_s.item.m11_hack).to_boolean then
									links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[10m")))
								end
							end
							if l_s.item.mode = 1 then
								links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/15/")))
							end
						end
						a_term.item.lcx := l_cx
						a_term.item.lcy := l_cy
						if a_term.item.cx = a_term.item.lcx then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_pos := -1 + 78 -- goto _L___18
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 77 then -- else:
						if a_term.item.cy = a_term.item.lcy then
							l_pos := -1 + 79 -- skip if block
						end
				when 78 then -- if: | _L___18:
						a_term.item.lcx := a_term.item.cx
						a_term.item.lcy := a_term.item.cy
						links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/27/[")))
						links_inst.add_num_to_str (l_a, l_l, (a_term.item.cy + 1).to_integer_32)
						links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";")))
						links_inst.add_num_to_str (l_a, l_l, (a_term.item.cx + 1).to_integer_32)
						links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H")))
				when 79 then -- if done
						if (l_l.item).to_boolean then
							if (a_term.item.master).to_boolean then
								os_dep_inst.want_draw
							end
						end
						hard_write (a_term.item.fdout, l_a.item, l_l.item).do_nothing
						if (l_l.item).to_boolean then
							if (a_term.item.master).to_boolean then
								os_dep_inst.done_draw
							end
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 548, create {CE_POINTER [ANY]}.make_cast (l_a.item))
						a_term.item.dirty := 0
				when 80 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_terminal (a_term: CE_POINTER [PD_TERMINAL])
		do
			redraw_terminal_ev (a_term, 3)
		end

	redraw_terminal_all (a_term: CE_POINTER [PD_TERMINAL])
		do
			redraw_terminal_ev (a_term, 4)
		end

	redraw_terminal_cls (a_term: CE_POINTER [PD_TERMINAL])
		do
			erase_screen (a_term)
			alloc_term_screen (a_term, a_term.item.x, a_term.item.y)
			redraw_terminal_all (a_term)
		end

	redraw_terminal_ev (a_term: CE_POINTER [PD_TERMINAL]; a_e: INTEGER_32)
		local
			l_win: CE_POINTER [PD_WINDOW]
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create l_win.make
			create l_ev.make (<<1>>)

			l_ev.item.ev := 0
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_ev.item.ev := a_e.to_integer_32
			l_ev.item.x := (a_term.item.x).to_integer_32
			l_ev.item.y := (a_term.item.y).to_integer_32
			clear_terminal (a_term)
			a_term.item.redrawing := 2
			l_win := create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.prev)
			from
			until
				l_win.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))
			loop
				(l_win.item.handler).call ([l_win, l_ev, 0])
				l_win := l_win.item.prev
			end
			a_term.item.redrawing := 0
		end

	set_char (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_c: NATURAL_32)
		do
			a_t.item.dirty := 1
			if a_x >= 0 then
				if a_x < a_t.item.x then
					if a_y >= 0 then
						if a_y < a_t.item.y then
							a_t.item.screen[(a_x + a_t.item.x * a_y)] := a_c
						end
					end
				end
			end
		end

	set_color (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_c: NATURAL_32)
		do
			a_t.item.dirty := 1
			if a_x >= 0 then
				if a_x < a_t.item.x then
					if a_y >= 0 then
						if a_y < a_t.item.y then
							a_t.item.screen[(a_x + a_t.item.x * a_y)] := (((a_t.item.screen[(a_x + a_t.item.x * a_y)]).bit_and ({NATURAL_32} 33_023))).bit_or (((a_c).bit_and ({NATURAL_32} 4_294_934_272)))
						end
					end
				end
			end
		end

	set_cursor (a_term: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_altx: INTEGER_32; a_alty: INTEGER_32)
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
		do
			l_x := a_x
			l_y := a_y
			a_term.item.dirty := 1
			if ((a_term.item.spec).item.block_cursor).to_boolean then
				l_x := a_altx
				l_y := a_alty
			end
			if l_x >= a_term.item.x then
				l_x := a_term.item.x - 1
			end
			if l_y >= a_term.item.y then
				l_y := a_term.item.y - 1
			end
			if l_x < 0 then
				l_x := 0
			end
			if l_y < 0 then
				l_y := 0
			end
			a_term.item.cx := l_x
			a_term.item.cy := l_y
		end

	set_cwd (a_path: CE_POINTER [NATURAL_8])
		local
			js: JUMP_STATE
		do
			if (not a_path.is_void) then
				from
				until
					js.loop_done
				loop
					if (chdir (create {CE_POINTER [INTEGER_8]}.make_cast (a_path))).to_boolean then
						if (errno_location).item /= 4 then
							js.break
						end
					else
						js.break
					end
				end
			end
		end

	set_line (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_l: INTEGER_32; a_line: CE_POINTER [NATURAL_16])
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			a_t.item.dirty := 1
			if a_x >= 0 then
				l_i := 0
			else
				l_i := -a_x
			end
			from
			until
				js.loop_done
			loop
				if a_x + a_l <= a_t.item.x then
					l_tmp := a_l
				else
					l_tmp := a_t.item.x - a_x
				end
				if not (l_i < l_tmp) then
					js.break
				end
				if not js.loop_jumped then
					a_t.item.screen[((a_x + l_i) + a_t.item.x * a_y)] := (a_line[l_i]).to_natural_32
					l_i := l_i + 1
				end
			end
		end

	set_line_color (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_l: INTEGER_32; a_c: NATURAL_32)
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			a_t.item.dirty := 1
			if a_x >= 0 then
				l_i := 0
			else
				l_i := -a_x
			end
			from
			until
				js.loop_done
			loop
				if a_x + a_l <= a_t.item.x then
					l_tmp := a_l
				else
					l_tmp := a_t.item.x - a_x
				end
				if not (l_i < l_tmp) then
					js.break
				end
				if not js.loop_jumped then
					a_t.item.screen[((a_x + l_i) + a_t.item.x * a_y)] := (((a_t.item.screen[((a_x + l_i) + a_t.item.x * a_y)]).bit_and ({NATURAL_32} 33_023))).bit_or (((a_c).bit_and ({NATURAL_32} 4_294_934_272)))
					l_i := l_i + 1
				end
			end
		end

	set_only_char (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_c: NATURAL_32)
		do
			a_t.item.dirty := 1
			if a_x >= 0 then
				if a_x < a_t.item.x then
					if a_y >= 0 then
						if a_y < a_t.item.y then
							a_t.item.screen[(a_x + a_t.item.x * a_y)] := (((a_t.item.screen[(a_x + a_t.item.x * a_y)]).bit_and ({NATURAL_32} 4_294_934_272))).bit_or (((a_c).bit_and ({NATURAL_32} 33_023)))
						end
					end
				end
			end
		end

	set_terminal_title (a_term: CE_POINTER [PD_TERMINAL]; a_title: CE_POINTER [NATURAL_8])
		local
			l_i: INTEGER_32
			l_a: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_a.make
			create l_b.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < 10_000) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if not (a_title[l_i]).to_boolean then
							l_pos := -1 + 5 -- goto s
						end
				when 3 then
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					a_title[10_000] := (0).to_natural_8
				when 5 then -- s:
					if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_title), 1)).is_void) then
						l_a := a_title
						l_b := a_title
						from
						until
							not ((l_a.item).to_boolean)
						loop
							if (l_a.item).to_integer_32 /= 1 then
								l_tmp := l_b
								l_b := l_b + 1
								l_tmp.item := l_a.item
							end
							l_a := l_a + 1
						end
						l_b.item := (0).to_natural_8
					end
					if (not (a_term.item.title).is_void) then
						if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_title), create {CE_POINTER [INTEGER_8]}.make_cast (a_term.item.title))).to_boolean then
							l_pos := -1 + 7 -- goto ret
						end
					end
				when 6 then
					if (not (a_term.item.title).is_void) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 782, create {CE_POINTER [ANY]}.make_cast (a_term.item.title))
					end
					a_term.item.title := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 783, a_title)
					do_terminal_function (a_term, (1).to_natural_8, a_title)
				when 7 then -- ret:
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal.c")), 794, create {CE_POINTER [ANY]}.make_cast (a_title))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_window_ptr (a_win: CE_POINTER [PD_WINDOW]; a_x: INTEGER_32; a_y: INTEGER_32)
		do
			a_win.item.xp := a_x
			a_win.item.yp := a_y
		end

	sync_term_specs
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_term := create {CE_POINTER [PD_TERMINAL]}.make_cast (terminals.item.next)
			from
			until
				l_term.is_equal (terminals)
			loop
				l_term.item.spec := get_term_spec (l_term.item.term)
				l_term := l_term.item.next
			end
		end

	unblock_terminal (a_term: CE_POINTER [PD_TERMINAL])
		do
			close_handle (create {CE_POINTER [ANY]}.make_shared (default_pointer + a_term.item.blocked))
			a_term.item.blocked := -1
			select_inst.set_handlers (a_term.item.fdin, (in_term_address), create {CE_ROUTINE}.make_shared (default_pointer), (destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_term))
			kbd_inst.unblock_itrm (a_term.item.fdin).do_nothing
			redraw_terminal_cls (a_term)
		end

	unblock_terminal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent unblock_terminal)
		end

end
