class
	SD_HOSTENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create h_name.make
			create h_aliases.make
			create h_addr_list.make
		end

feature {ANY} -- fields

	h_name: CE_POINTER [INTEGER_8] assign set_h_name

	h_aliases: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_h_aliases

	h_addrtype: INTEGER_32 assign set_h_addrtype

	h_length: INTEGER_32 assign set_h_length

	h_addr_list: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_h_addr_list

feature {ANY} -- setters

	set_h_name (a_h_name: CE_POINTER [INTEGER_8])
		do
			h_name := a_h_name
			update_memory_field ("h_name")
		end

	set_h_aliases (a_h_aliases: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			h_aliases := a_h_aliases
			update_memory_field ("h_aliases")
		end

	set_h_addrtype (a_h_addrtype: INTEGER_32)
		do
			h_addrtype := a_h_addrtype
			update_memory_field ("h_addrtype")
		end

	set_h_length (a_h_length: INTEGER_32)
		do
			h_length := a_h_length
			update_memory_field ("h_length")
		end

	set_h_addr_list (a_h_addr_list: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			h_addr_list := a_h_addr_list
			update_memory_field ("h_addr_list")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			h_name := a_other.h_name
			h_aliases := a_other.h_aliases
			h_addrtype := a_other.h_addrtype
			h_length := a_other.h_length
			h_addr_list := a_other.h_addr_list
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				h_name.is_equal (a_other.h_name) and
				h_aliases.is_equal (a_other.h_aliases) and
				h_addrtype = a_other.h_addrtype and
				h_length = a_other.h_length and
				h_addr_list.is_equal (a_other.h_addr_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("h_name"),
					create {CE_STRUCTURE_FIELD}.make ("h_aliases"),
					create {CE_STRUCTURE_FIELD}.make ("h_addrtype"),
					create {CE_STRUCTURE_FIELD}.make ("h_length"),
					create {CE_STRUCTURE_FIELD}.make ("h_addr_list")
				>>)
			init_structure_info
		end

end
