class
	SD_PASSWD

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pw_name.make
			create pw_passwd.make
			create pw_gecos.make
			create pw_dir.make
			create pw_shell.make
		end

feature {ANY} -- fields

	pw_name: CE_POINTER [INTEGER_8] assign set_pw_name

	pw_passwd: CE_POINTER [INTEGER_8] assign set_pw_passwd

	pw_uid: NATURAL_32 assign set_pw_uid

	pw_gid: NATURAL_32 assign set_pw_gid

	pw_gecos: CE_POINTER [INTEGER_8] assign set_pw_gecos

	pw_dir: CE_POINTER [INTEGER_8] assign set_pw_dir

	pw_shell: CE_POINTER [INTEGER_8] assign set_pw_shell

feature {ANY} -- setters

	set_pw_name (a_pw_name: CE_POINTER [INTEGER_8])
		do
			pw_name := a_pw_name
			update_memory_field ("pw_name")
		end

	set_pw_passwd (a_pw_passwd: CE_POINTER [INTEGER_8])
		do
			pw_passwd := a_pw_passwd
			update_memory_field ("pw_passwd")
		end

	set_pw_uid (a_pw_uid: NATURAL_32)
		do
			pw_uid := a_pw_uid
			update_memory_field ("pw_uid")
		end

	set_pw_gid (a_pw_gid: NATURAL_32)
		do
			pw_gid := a_pw_gid
			update_memory_field ("pw_gid")
		end

	set_pw_gecos (a_pw_gecos: CE_POINTER [INTEGER_8])
		do
			pw_gecos := a_pw_gecos
			update_memory_field ("pw_gecos")
		end

	set_pw_dir (a_pw_dir: CE_POINTER [INTEGER_8])
		do
			pw_dir := a_pw_dir
			update_memory_field ("pw_dir")
		end

	set_pw_shell (a_pw_shell: CE_POINTER [INTEGER_8])
		do
			pw_shell := a_pw_shell
			update_memory_field ("pw_shell")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pw_name := a_other.pw_name
			pw_passwd := a_other.pw_passwd
			pw_uid := a_other.pw_uid
			pw_gid := a_other.pw_gid
			pw_gecos := a_other.pw_gecos
			pw_dir := a_other.pw_dir
			pw_shell := a_other.pw_shell
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pw_name.is_equal (a_other.pw_name) and
				pw_passwd.is_equal (a_other.pw_passwd) and
				pw_uid = a_other.pw_uid and
				pw_gid = a_other.pw_gid and
				pw_gecos.is_equal (a_other.pw_gecos) and
				pw_dir.is_equal (a_other.pw_dir) and
				pw_shell.is_equal (a_other.pw_shell)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pw_name"),
					create {CE_STRUCTURE_FIELD}.make ("pw_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("pw_uid"),
					create {CE_STRUCTURE_FIELD}.make ("pw_gid"),
					create {CE_STRUCTURE_FIELD}.make ("pw_gecos"),
					create {CE_STRUCTURE_FIELD}.make ("pw_dir"),
					create {CE_STRUCTURE_FIELD}.make ("pw_shell")
				>>)
			init_structure_info
		end

end
