class
	SD_SOCKADDR_UN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sun_path.make (<<108>>)
		end

feature {ANY} -- fields

	sun_family: NATURAL_16 assign set_sun_family

	sun_path: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_sun_family (a_sun_family: NATURAL_16)
		do
			sun_family := a_sun_family
			update_memory_field ("sun_family")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sun_family := a_other.sun_family
			sun_path := a_other.sun_path.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sun_family = a_other.sun_family and
				sun_path.is_equal (a_other.sun_path)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sun_family"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sun_path", <<108>>)
				>>)
			init_structure_info
		end

end
