class
	SD_TERMIOS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create c2_cc.make (<<32>>)
		end

feature {ANY} -- fields

	c2_iflag: NATURAL_32 assign set_c2_iflag

	c2_oflag: NATURAL_32 assign set_c2_oflag

	c2_cflag: NATURAL_32 assign set_c2_cflag

	c2_lflag: NATURAL_32 assign set_c2_lflag

	c2_line: NATURAL_8 assign set_c2_line

	c2_cc: CE_ARRAY [NATURAL_8]

	c2_ispeed: NATURAL_32 assign set_c2_ispeed

	c2_ospeed: NATURAL_32 assign set_c2_ospeed

feature {ANY} -- setters

	set_c2_iflag (a_c2_iflag: NATURAL_32)
		do
			c2_iflag := a_c2_iflag
			update_memory_field ("c2_iflag")
		end

	set_c2_oflag (a_c2_oflag: NATURAL_32)
		do
			c2_oflag := a_c2_oflag
			update_memory_field ("c2_oflag")
		end

	set_c2_cflag (a_c2_cflag: NATURAL_32)
		do
			c2_cflag := a_c2_cflag
			update_memory_field ("c2_cflag")
		end

	set_c2_lflag (a_c2_lflag: NATURAL_32)
		do
			c2_lflag := a_c2_lflag
			update_memory_field ("c2_lflag")
		end

	set_c2_line (a_c2_line: NATURAL_8)
		do
			c2_line := a_c2_line
			update_memory_field ("c2_line")
		end

	set_c2_ispeed (a_c2_ispeed: NATURAL_32)
		do
			c2_ispeed := a_c2_ispeed
			update_memory_field ("c2_ispeed")
		end

	set_c2_ospeed (a_c2_ospeed: NATURAL_32)
		do
			c2_ospeed := a_c2_ospeed
			update_memory_field ("c2_ospeed")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c2_iflag := a_other.c2_iflag
			c2_oflag := a_other.c2_oflag
			c2_cflag := a_other.c2_cflag
			c2_lflag := a_other.c2_lflag
			c2_line := a_other.c2_line
			c2_cc := a_other.c2_cc.twin
			c2_ispeed := a_other.c2_ispeed
			c2_ospeed := a_other.c2_ospeed
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c2_iflag = a_other.c2_iflag and
				c2_oflag = a_other.c2_oflag and
				c2_cflag = a_other.c2_cflag and
				c2_lflag = a_other.c2_lflag and
				c2_line = a_other.c2_line and
				c2_cc.is_equal (a_other.c2_cc) and
				c2_ispeed = a_other.c2_ispeed and
				c2_ospeed = a_other.c2_ospeed
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c2_iflag"),
					create {CE_STRUCTURE_FIELD}.make ("c2_oflag"),
					create {CE_STRUCTURE_FIELD}.make ("c2_cflag"),
					create {CE_STRUCTURE_FIELD}.make ("c2_lflag"),
					create {CE_STRUCTURE_FIELD}.make ("c2_line"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("c2_cc", <<32>>),
					create {CE_STRUCTURE_FIELD}.make ("c2_ispeed"),
					create {CE_STRUCTURE_FIELD}.make ("c2_ospeed")
				>>)
			init_structure_info
		end

end
