class
	PD_ACO_SAVE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create save_curbuf.make
			create save_curwin.make
			create new_curwin.make
			create new_curbuf.make
			create globaldir.make
		end

feature {ANY} -- fields

	save_curbuf: CE_POINTER [PD_FILE_BUFFER] assign set_save_curbuf

	use_aucmd_win: INTEGER_32 assign set_use_aucmd_win

	save_curwin: CE_POINTER [PD_WINDOW_S] assign set_save_curwin

	new_curwin: CE_POINTER [PD_WINDOW_S] assign set_new_curwin

	new_curbuf: CE_POINTER [PD_FILE_BUFFER] assign set_new_curbuf

	globaldir: CE_POINTER [NATURAL_8] assign set_globaldir

feature {ANY} -- setters

	set_save_curbuf (a_save_curbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			save_curbuf := a_save_curbuf
			update_memory_field ("save_curbuf")
		end

	set_use_aucmd_win (a_use_aucmd_win: INTEGER_32)
		do
			use_aucmd_win := a_use_aucmd_win
			update_memory_field ("use_aucmd_win")
		end

	set_save_curwin (a_save_curwin: CE_POINTER [PD_WINDOW_S])
		do
			save_curwin := a_save_curwin
			update_memory_field ("save_curwin")
		end

	set_new_curwin (a_new_curwin: CE_POINTER [PD_WINDOW_S])
		do
			new_curwin := a_new_curwin
			update_memory_field ("new_curwin")
		end

	set_new_curbuf (a_new_curbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			new_curbuf := a_new_curbuf
			update_memory_field ("new_curbuf")
		end

	set_globaldir (a_globaldir: CE_POINTER [NATURAL_8])
		do
			globaldir := a_globaldir
			update_memory_field ("globaldir")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			save_curbuf := a_other.save_curbuf
			use_aucmd_win := a_other.use_aucmd_win
			save_curwin := a_other.save_curwin
			new_curwin := a_other.new_curwin
			new_curbuf := a_other.new_curbuf
			globaldir := a_other.globaldir
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				save_curbuf.is_equal (a_other.save_curbuf) and
				use_aucmd_win = a_other.use_aucmd_win and
				save_curwin.is_equal (a_other.save_curwin) and
				new_curwin.is_equal (a_other.new_curwin) and
				new_curbuf.is_equal (a_other.new_curbuf) and
				globaldir.is_equal (a_other.globaldir)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("save_curbuf"),
					create {CE_STRUCTURE_FIELD}.make ("use_aucmd_win"),
					create {CE_STRUCTURE_FIELD}.make ("save_curwin"),
					create {CE_STRUCTURE_FIELD}.make ("new_curwin"),
					create {CE_STRUCTURE_FIELD}.make ("new_curbuf"),
					create {CE_STRUCTURE_FIELD}.make ("globaldir")
				>>)
			init_structure_info
		end

end
