class
	PD_AFFENTRY_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ae_next.make
			create ae_chop.make
			create ae_add.make
			create ae_flags.make
			create ae_cond.make
			create ae_prog.make
		end

feature {ANY} -- fields

	ae_next: CE_POINTER [PD_AFFENTRY_S] assign set_ae_next

	ae_chop: CE_POINTER [NATURAL_8] assign set_ae_chop

	ae_add: CE_POINTER [NATURAL_8] assign set_ae_add

	ae_flags: CE_POINTER [NATURAL_8] assign set_ae_flags

	ae_cond: CE_POINTER [NATURAL_8] assign set_ae_cond

	ae_prog: CE_POINTER [PD_REGPROG_T] assign set_ae_prog

	ae_compforbid: INTEGER_8 assign set_ae_compforbid

	ae_comppermit: INTEGER_8 assign set_ae_comppermit

feature {ANY} -- setters

	set_ae_next (a_ae_next: CE_POINTER [PD_AFFENTRY_S])
		do
			ae_next := a_ae_next
			update_memory_field ("ae_next")
		end

	set_ae_chop (a_ae_chop: CE_POINTER [NATURAL_8])
		do
			ae_chop := a_ae_chop
			update_memory_field ("ae_chop")
		end

	set_ae_add (a_ae_add: CE_POINTER [NATURAL_8])
		do
			ae_add := a_ae_add
			update_memory_field ("ae_add")
		end

	set_ae_flags (a_ae_flags: CE_POINTER [NATURAL_8])
		do
			ae_flags := a_ae_flags
			update_memory_field ("ae_flags")
		end

	set_ae_cond (a_ae_cond: CE_POINTER [NATURAL_8])
		do
			ae_cond := a_ae_cond
			update_memory_field ("ae_cond")
		end

	set_ae_prog (a_ae_prog: CE_POINTER [PD_REGPROG_T])
		do
			ae_prog := a_ae_prog
			update_memory_field ("ae_prog")
		end

	set_ae_compforbid (a_ae_compforbid: INTEGER_8)
		do
			ae_compforbid := a_ae_compforbid
			update_memory_field ("ae_compforbid")
		end

	set_ae_comppermit (a_ae_comppermit: INTEGER_8)
		do
			ae_comppermit := a_ae_comppermit
			update_memory_field ("ae_comppermit")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ae_next := a_other.ae_next
			ae_chop := a_other.ae_chop
			ae_add := a_other.ae_add
			ae_flags := a_other.ae_flags
			ae_cond := a_other.ae_cond
			ae_prog := a_other.ae_prog
			ae_compforbid := a_other.ae_compforbid
			ae_comppermit := a_other.ae_comppermit
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ae_next.is_equal (a_other.ae_next) and
				ae_chop.is_equal (a_other.ae_chop) and
				ae_add.is_equal (a_other.ae_add) and
				ae_flags.is_equal (a_other.ae_flags) and
				ae_cond.is_equal (a_other.ae_cond) and
				ae_prog.is_equal (a_other.ae_prog) and
				ae_compforbid = a_other.ae_compforbid and
				ae_comppermit = a_other.ae_comppermit
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ae_next"),
					create {CE_STRUCTURE_FIELD}.make ("ae_chop"),
					create {CE_STRUCTURE_FIELD}.make ("ae_add"),
					create {CE_STRUCTURE_FIELD}.make ("ae_flags"),
					create {CE_STRUCTURE_FIELD}.make ("ae_cond"),
					create {CE_STRUCTURE_FIELD}.make ("ae_prog"),
					create {CE_STRUCTURE_FIELD}.make ("ae_compforbid"),
					create {CE_STRUCTURE_FIELD}.make ("ae_comppermit")
				>>)
			init_structure_info
		end

end
