class
	PD_ANONYMOUS3

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	in: INTEGER_32 assign set_in

	i: INTEGER_32 assign set_i

feature {ANY} -- setters

	set_in (a_in: INTEGER_32)
		do
			in := a_in
			update_memory_field ("in")
		end

	set_i (a_i: INTEGER_32)
		do
			i := a_i
			update_memory_field ("i")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			in := a_other.in
			i := a_other.i
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				in = a_other.in and
				i = a_other.i
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("in"),
					create {CE_STRUCTURE_FIELD}.make ("i")
				>>)
			init_structure_info
		end

end
