class
	PD_ARGLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create al_ga.make
		end

feature {ANY} -- fields

	al_ga: PD_GROWARRAY assign set_al_ga

	al_refcount: INTEGER_32 assign set_al_refcount

feature {ANY} -- setters

	set_al_ga (a_al_ga: PD_GROWARRAY)
		do
			al_ga := a_al_ga
			update_memory_field ("al_ga")
		end

	set_al_refcount (a_al_refcount: INTEGER_32)
		do
			al_refcount := a_al_refcount
			update_memory_field ("al_refcount")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			al_ga := a_other.al_ga.twin
			al_refcount := a_other.al_refcount
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				al_ga.is_equal (a_other.al_ga) and
				al_refcount = a_other.al_refcount
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("al_ga"),
					create {CE_STRUCTURE_FIELD}.make ("al_refcount")
				>>)
			init_structure_info
		end

end
