class
	PD_AUTOPATCMD

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create curpat.make
			create nextcmd.make
			create fname.make
			create sfname.make
			create tail.make
			create next.make
		end

feature {ANY} -- fields

	curpat: CE_POINTER [PD_AUTOPAT] assign set_curpat

	nextcmd: CE_POINTER [PD_AUTOCMD] assign set_nextcmd

	group: INTEGER_32 assign set_group

	fname: CE_POINTER [NATURAL_8] assign set_fname

	sfname: CE_POINTER [NATURAL_8] assign set_sfname

	tail: CE_POINTER [NATURAL_8] assign set_tail

	event: NATURAL_32 assign set_event

	arg_bufnr: INTEGER_32 assign set_arg_bufnr

	next: CE_POINTER [PD_AUTOPATCMD] assign set_next

feature {ANY} -- setters

	set_curpat (a_curpat: CE_POINTER [PD_AUTOPAT])
		do
			curpat := a_curpat
			update_memory_field ("curpat")
		end

	set_nextcmd (a_nextcmd: CE_POINTER [PD_AUTOCMD])
		do
			nextcmd := a_nextcmd
			update_memory_field ("nextcmd")
		end

	set_group (a_group: INTEGER_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

	set_sfname (a_sfname: CE_POINTER [NATURAL_8])
		do
			sfname := a_sfname
			update_memory_field ("sfname")
		end

	set_tail (a_tail: CE_POINTER [NATURAL_8])
		do
			tail := a_tail
			update_memory_field ("tail")
		end

	set_event (a_event: NATURAL_32)
		do
			event := a_event
			update_memory_field ("event")
		end

	set_arg_bufnr (a_arg_bufnr: INTEGER_32)
		do
			arg_bufnr := a_arg_bufnr
			update_memory_field ("arg_bufnr")
		end

	set_next (a_next: CE_POINTER [PD_AUTOPATCMD])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			curpat := a_other.curpat
			nextcmd := a_other.nextcmd
			group := a_other.group
			fname := a_other.fname
			sfname := a_other.sfname
			tail := a_other.tail
			event := a_other.event
			arg_bufnr := a_other.arg_bufnr
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				curpat.is_equal (a_other.curpat) and
				nextcmd.is_equal (a_other.nextcmd) and
				group = a_other.group and
				fname.is_equal (a_other.fname) and
				sfname.is_equal (a_other.sfname) and
				tail.is_equal (a_other.tail) and
				event = a_other.event and
				arg_bufnr = a_other.arg_bufnr and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("curpat"),
					create {CE_STRUCTURE_FIELD}.make ("nextcmd"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("fname"),
					create {CE_STRUCTURE_FIELD}.make ("sfname"),
					create {CE_STRUCTURE_FIELD}.make ("tail"),
					create {CE_STRUCTURE_FIELD}.make ("event"),
					create {CE_STRUCTURE_FIELD}.make ("arg_bufnr"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
