class
	PD_BUFFHEADER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create bh_first.make
			create bh_curr.make
		end

feature {ANY} -- fields

	bh_first: PD_BUFFBLOCK assign set_bh_first

	bh_curr: CE_POINTER [PD_BUFFBLOCK] assign set_bh_curr

	bh_index: INTEGER_32 assign set_bh_index

	bh_space: INTEGER_32 assign set_bh_space

feature {ANY} -- setters

	set_bh_first (a_bh_first: PD_BUFFBLOCK)
		do
			bh_first := a_bh_first
			update_memory_field ("bh_first")
		end

	set_bh_curr (a_bh_curr: CE_POINTER [PD_BUFFBLOCK])
		do
			bh_curr := a_bh_curr
			update_memory_field ("bh_curr")
		end

	set_bh_index (a_bh_index: INTEGER_32)
		do
			bh_index := a_bh_index
			update_memory_field ("bh_index")
		end

	set_bh_space (a_bh_space: INTEGER_32)
		do
			bh_space := a_bh_space
			update_memory_field ("bh_space")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bh_first := a_other.bh_first.twin
			bh_curr := a_other.bh_curr
			bh_index := a_other.bh_index
			bh_space := a_other.bh_space
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bh_first.is_equal (a_other.bh_first) and
				bh_curr.is_equal (a_other.bh_curr) and
				bh_index = a_other.bh_index and
				bh_space = a_other.bh_space
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bh_first"),
					create {CE_STRUCTURE_FIELD}.make ("bh_curr"),
					create {CE_STRUCTURE_FIELD}.make ("bh_index"),
					create {CE_STRUCTURE_FIELD}.make ("bh_space")
				>>)
			init_structure_info
		end

end
