class
	PD_BW_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create bw_buf.make
			create bw_rest.make (<<30>>)
			create bw_conv_buf.make
			create bw_iconv_fd.make
		end

feature {ANY} -- fields

	bw_fd: INTEGER_32 assign set_bw_fd

	bw_buf: CE_POINTER [NATURAL_8] assign set_bw_buf

	bw_len: INTEGER_32 assign set_bw_len

	bw_flags: INTEGER_32 assign set_bw_flags

	bw_rest: CE_ARRAY [NATURAL_8]

	bw_restlen: INTEGER_32 assign set_bw_restlen

	bw_first: INTEGER_32 assign set_bw_first

	bw_conv_buf: CE_POINTER [NATURAL_8] assign set_bw_conv_buf

	bw_conv_buflen: INTEGER_32 assign set_bw_conv_buflen

	bw_conv_error: INTEGER_32 assign set_bw_conv_error

	bw_conv_error_lnum: INTEGER_32 assign set_bw_conv_error_lnum

	bw_start_lnum: INTEGER_32 assign set_bw_start_lnum

	bw_iconv_fd: CE_POINTER [ANY] assign set_bw_iconv_fd

feature {ANY} -- setters

	set_bw_fd (a_bw_fd: INTEGER_32)
		do
			bw_fd := a_bw_fd
			update_memory_field ("bw_fd")
		end

	set_bw_buf (a_bw_buf: CE_POINTER [NATURAL_8])
		do
			bw_buf := a_bw_buf
			update_memory_field ("bw_buf")
		end

	set_bw_len (a_bw_len: INTEGER_32)
		do
			bw_len := a_bw_len
			update_memory_field ("bw_len")
		end

	set_bw_flags (a_bw_flags: INTEGER_32)
		do
			bw_flags := a_bw_flags
			update_memory_field ("bw_flags")
		end

	set_bw_restlen (a_bw_restlen: INTEGER_32)
		do
			bw_restlen := a_bw_restlen
			update_memory_field ("bw_restlen")
		end

	set_bw_first (a_bw_first: INTEGER_32)
		do
			bw_first := a_bw_first
			update_memory_field ("bw_first")
		end

	set_bw_conv_buf (a_bw_conv_buf: CE_POINTER [NATURAL_8])
		do
			bw_conv_buf := a_bw_conv_buf
			update_memory_field ("bw_conv_buf")
		end

	set_bw_conv_buflen (a_bw_conv_buflen: INTEGER_32)
		do
			bw_conv_buflen := a_bw_conv_buflen
			update_memory_field ("bw_conv_buflen")
		end

	set_bw_conv_error (a_bw_conv_error: INTEGER_32)
		do
			bw_conv_error := a_bw_conv_error
			update_memory_field ("bw_conv_error")
		end

	set_bw_conv_error_lnum (a_bw_conv_error_lnum: INTEGER_32)
		do
			bw_conv_error_lnum := a_bw_conv_error_lnum
			update_memory_field ("bw_conv_error_lnum")
		end

	set_bw_start_lnum (a_bw_start_lnum: INTEGER_32)
		do
			bw_start_lnum := a_bw_start_lnum
			update_memory_field ("bw_start_lnum")
		end

	set_bw_iconv_fd (a_bw_iconv_fd: CE_POINTER [ANY])
		do
			bw_iconv_fd := a_bw_iconv_fd
			update_memory_field ("bw_iconv_fd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bw_fd := a_other.bw_fd
			bw_buf := a_other.bw_buf
			bw_len := a_other.bw_len
			bw_flags := a_other.bw_flags
			bw_rest := a_other.bw_rest.twin
			bw_restlen := a_other.bw_restlen
			bw_first := a_other.bw_first
			bw_conv_buf := a_other.bw_conv_buf
			bw_conv_buflen := a_other.bw_conv_buflen
			bw_conv_error := a_other.bw_conv_error
			bw_conv_error_lnum := a_other.bw_conv_error_lnum
			bw_start_lnum := a_other.bw_start_lnum
			bw_iconv_fd := a_other.bw_iconv_fd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bw_fd = a_other.bw_fd and
				bw_buf.is_equal (a_other.bw_buf) and
				bw_len = a_other.bw_len and
				bw_flags = a_other.bw_flags and
				bw_rest.is_equal (a_other.bw_rest) and
				bw_restlen = a_other.bw_restlen and
				bw_first = a_other.bw_first and
				bw_conv_buf.is_equal (a_other.bw_conv_buf) and
				bw_conv_buflen = a_other.bw_conv_buflen and
				bw_conv_error = a_other.bw_conv_error and
				bw_conv_error_lnum = a_other.bw_conv_error_lnum and
				bw_start_lnum = a_other.bw_start_lnum and
				bw_iconv_fd.is_equal (a_other.bw_iconv_fd)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bw_fd"),
					create {CE_STRUCTURE_FIELD}.make ("bw_buf"),
					create {CE_STRUCTURE_FIELD}.make ("bw_len"),
					create {CE_STRUCTURE_FIELD}.make ("bw_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bw_rest", <<30>>),
					create {CE_STRUCTURE_FIELD}.make ("bw_restlen"),
					create {CE_STRUCTURE_FIELD}.make ("bw_first"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_buf"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_buflen"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_error"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_error_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("bw_start_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("bw_iconv_fd")
				>>)
			init_structure_info
		end

end
