class
	PD_CMDLINE_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cmdbuff.make
			create cmdprompt.make
			create xpc.make
			create xp_arg.make
		end

feature {ANY} -- fields

	cmdbuff: CE_POINTER [NATURAL_8] assign set_cmdbuff

	cmdbufflen: INTEGER_32 assign set_cmdbufflen

	cmdlen: INTEGER_32 assign set_cmdlen

	cmdpos: INTEGER_32 assign set_cmdpos

	cmdspos: INTEGER_32 assign set_cmdspos

	cmdfirstc: INTEGER_32 assign set_cmdfirstc

	cmdindent: INTEGER_32 assign set_cmdindent

	cmdprompt: CE_POINTER [NATURAL_8] assign set_cmdprompt

	cmdattr: INTEGER_32 assign set_cmdattr

	overstrike: INTEGER_32 assign set_overstrike

	xpc: CE_POINTER [PD_EXPAND] assign set_xpc

	xp_context: INTEGER_32 assign set_xp_context

	xp_arg: CE_POINTER [NATURAL_8] assign set_xp_arg

	input_fn: INTEGER_32 assign set_input_fn

feature {ANY} -- setters

	set_cmdbuff (a_cmdbuff: CE_POINTER [NATURAL_8])
		do
			cmdbuff := a_cmdbuff
			update_memory_field ("cmdbuff")
		end

	set_cmdbufflen (a_cmdbufflen: INTEGER_32)
		do
			cmdbufflen := a_cmdbufflen
			update_memory_field ("cmdbufflen")
		end

	set_cmdlen (a_cmdlen: INTEGER_32)
		do
			cmdlen := a_cmdlen
			update_memory_field ("cmdlen")
		end

	set_cmdpos (a_cmdpos: INTEGER_32)
		do
			cmdpos := a_cmdpos
			update_memory_field ("cmdpos")
		end

	set_cmdspos (a_cmdspos: INTEGER_32)
		do
			cmdspos := a_cmdspos
			update_memory_field ("cmdspos")
		end

	set_cmdfirstc (a_cmdfirstc: INTEGER_32)
		do
			cmdfirstc := a_cmdfirstc
			update_memory_field ("cmdfirstc")
		end

	set_cmdindent (a_cmdindent: INTEGER_32)
		do
			cmdindent := a_cmdindent
			update_memory_field ("cmdindent")
		end

	set_cmdprompt (a_cmdprompt: CE_POINTER [NATURAL_8])
		do
			cmdprompt := a_cmdprompt
			update_memory_field ("cmdprompt")
		end

	set_cmdattr (a_cmdattr: INTEGER_32)
		do
			cmdattr := a_cmdattr
			update_memory_field ("cmdattr")
		end

	set_overstrike (a_overstrike: INTEGER_32)
		do
			overstrike := a_overstrike
			update_memory_field ("overstrike")
		end

	set_xpc (a_xpc: CE_POINTER [PD_EXPAND])
		do
			xpc := a_xpc
			update_memory_field ("xpc")
		end

	set_xp_context (a_xp_context: INTEGER_32)
		do
			xp_context := a_xp_context
			update_memory_field ("xp_context")
		end

	set_xp_arg (a_xp_arg: CE_POINTER [NATURAL_8])
		do
			xp_arg := a_xp_arg
			update_memory_field ("xp_arg")
		end

	set_input_fn (a_input_fn: INTEGER_32)
		do
			input_fn := a_input_fn
			update_memory_field ("input_fn")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cmdbuff := a_other.cmdbuff
			cmdbufflen := a_other.cmdbufflen
			cmdlen := a_other.cmdlen
			cmdpos := a_other.cmdpos
			cmdspos := a_other.cmdspos
			cmdfirstc := a_other.cmdfirstc
			cmdindent := a_other.cmdindent
			cmdprompt := a_other.cmdprompt
			cmdattr := a_other.cmdattr
			overstrike := a_other.overstrike
			xpc := a_other.xpc
			xp_context := a_other.xp_context
			xp_arg := a_other.xp_arg
			input_fn := a_other.input_fn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cmdbuff.is_equal (a_other.cmdbuff) and
				cmdbufflen = a_other.cmdbufflen and
				cmdlen = a_other.cmdlen and
				cmdpos = a_other.cmdpos and
				cmdspos = a_other.cmdspos and
				cmdfirstc = a_other.cmdfirstc and
				cmdindent = a_other.cmdindent and
				cmdprompt.is_equal (a_other.cmdprompt) and
				cmdattr = a_other.cmdattr and
				overstrike = a_other.overstrike and
				xpc.is_equal (a_other.xpc) and
				xp_context = a_other.xp_context and
				xp_arg.is_equal (a_other.xp_arg) and
				input_fn = a_other.input_fn
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cmdbuff"),
					create {CE_STRUCTURE_FIELD}.make ("cmdbufflen"),
					create {CE_STRUCTURE_FIELD}.make ("cmdlen"),
					create {CE_STRUCTURE_FIELD}.make ("cmdpos"),
					create {CE_STRUCTURE_FIELD}.make ("cmdspos"),
					create {CE_STRUCTURE_FIELD}.make ("cmdfirstc"),
					create {CE_STRUCTURE_FIELD}.make ("cmdindent"),
					create {CE_STRUCTURE_FIELD}.make ("cmdprompt"),
					create {CE_STRUCTURE_FIELD}.make ("cmdattr"),
					create {CE_STRUCTURE_FIELD}.make ("overstrike"),
					create {CE_STRUCTURE_FIELD}.make ("xpc"),
					create {CE_STRUCTURE_FIELD}.make ("xp_context"),
					create {CE_STRUCTURE_FIELD}.make ("xp_arg"),
					create {CE_STRUCTURE_FIELD}.make ("input_fn")
				>>)
			init_structure_info
		end

end
