class
	PD_COMPL_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cp_next.make
			create cp_prev.make
			create cp_str.make
			create cp_text.make (<<4>>)
			create cp_fname.make
		end

feature {ANY} -- fields

	cp_next: CE_POINTER [PD_COMPL_S] assign set_cp_next

	cp_prev: CE_POINTER [PD_COMPL_S] assign set_cp_prev

	cp_str: CE_POINTER [NATURAL_8] assign set_cp_str

	cp_icase: INTEGER_8 assign set_cp_icase

	cp_text: CE_ARRAY [CE_POINTER [NATURAL_8]]

	cp_fname: CE_POINTER [NATURAL_8] assign set_cp_fname

	cp_flags: INTEGER_32 assign set_cp_flags

	cp_number: INTEGER_32 assign set_cp_number

feature {ANY} -- setters

	set_cp_next (a_cp_next: CE_POINTER [PD_COMPL_S])
		do
			cp_next := a_cp_next
			update_memory_field ("cp_next")
		end

	set_cp_prev (a_cp_prev: CE_POINTER [PD_COMPL_S])
		do
			cp_prev := a_cp_prev
			update_memory_field ("cp_prev")
		end

	set_cp_str (a_cp_str: CE_POINTER [NATURAL_8])
		do
			cp_str := a_cp_str
			update_memory_field ("cp_str")
		end

	set_cp_icase (a_cp_icase: INTEGER_8)
		do
			cp_icase := a_cp_icase
			update_memory_field ("cp_icase")
		end

	set_cp_fname (a_cp_fname: CE_POINTER [NATURAL_8])
		do
			cp_fname := a_cp_fname
			update_memory_field ("cp_fname")
		end

	set_cp_flags (a_cp_flags: INTEGER_32)
		do
			cp_flags := a_cp_flags
			update_memory_field ("cp_flags")
		end

	set_cp_number (a_cp_number: INTEGER_32)
		do
			cp_number := a_cp_number
			update_memory_field ("cp_number")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cp_next := a_other.cp_next
			cp_prev := a_other.cp_prev
			cp_str := a_other.cp_str
			cp_icase := a_other.cp_icase
			cp_text := a_other.cp_text.twin
			cp_fname := a_other.cp_fname
			cp_flags := a_other.cp_flags
			cp_number := a_other.cp_number
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cp_next.is_equal (a_other.cp_next) and
				cp_prev.is_equal (a_other.cp_prev) and
				cp_str.is_equal (a_other.cp_str) and
				cp_icase = a_other.cp_icase and
				cp_text.is_equal (a_other.cp_text) and
				cp_fname.is_equal (a_other.cp_fname) and
				cp_flags = a_other.cp_flags and
				cp_number = a_other.cp_number
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cp_next"),
					create {CE_STRUCTURE_FIELD}.make ("cp_prev"),
					create {CE_STRUCTURE_FIELD}.make ("cp_str"),
					create {CE_STRUCTURE_FIELD}.make ("cp_icase"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cp_text", <<4>>),
					create {CE_STRUCTURE_FIELD}.make ("cp_fname"),
					create {CE_STRUCTURE_FIELD}.make ("cp_flags"),
					create {CE_STRUCTURE_FIELD}.make ("cp_number")
				>>)
			init_structure_info
		end

end
