class
	PD_CONDSTACK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cs_flags.make (<<50>>)
			create cs_pending.make (<<50>>)
			create cs_pend.make
			create cs_forinfo.make (<<50>>)
			create cs_line.make (<<50>>)
			create cs_emsg_silent_list.make
		end

feature {ANY} -- fields

	cs_flags: CE_ARRAY [INTEGER_16]

	cs_pending: CE_ARRAY [INTEGER_8]

	cs_pend: PD_CS_PEND assign set_cs_pend

	cs_forinfo: CE_ARRAY [CE_POINTER [ANY]]

	cs_line: CE_ARRAY [INTEGER_32]

	cs_idx: INTEGER_32 assign set_cs_idx

	cs_looplevel: INTEGER_32 assign set_cs_looplevel

	cs_trylevel: INTEGER_32 assign set_cs_trylevel

	cs_emsg_silent_list: CE_POINTER [PD_ESLIST_ELEM] assign set_cs_emsg_silent_list

	cs_lflags: INTEGER_8 assign set_cs_lflags

feature {ANY} -- setters

	set_cs_pend (a_cs_pend: PD_CS_PEND)
		do
			cs_pend := a_cs_pend
			update_memory_field ("cs_pend")
		end

	set_cs_idx (a_cs_idx: INTEGER_32)
		do
			cs_idx := a_cs_idx
			update_memory_field ("cs_idx")
		end

	set_cs_looplevel (a_cs_looplevel: INTEGER_32)
		do
			cs_looplevel := a_cs_looplevel
			update_memory_field ("cs_looplevel")
		end

	set_cs_trylevel (a_cs_trylevel: INTEGER_32)
		do
			cs_trylevel := a_cs_trylevel
			update_memory_field ("cs_trylevel")
		end

	set_cs_emsg_silent_list (a_cs_emsg_silent_list: CE_POINTER [PD_ESLIST_ELEM])
		do
			cs_emsg_silent_list := a_cs_emsg_silent_list
			update_memory_field ("cs_emsg_silent_list")
		end

	set_cs_lflags (a_cs_lflags: INTEGER_8)
		do
			cs_lflags := a_cs_lflags
			update_memory_field ("cs_lflags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cs_flags := a_other.cs_flags.twin
			cs_pending := a_other.cs_pending.twin
			cs_pend := a_other.cs_pend.twin
			cs_forinfo := a_other.cs_forinfo.twin
			cs_line := a_other.cs_line.twin
			cs_idx := a_other.cs_idx
			cs_looplevel := a_other.cs_looplevel
			cs_trylevel := a_other.cs_trylevel
			cs_emsg_silent_list := a_other.cs_emsg_silent_list
			cs_lflags := a_other.cs_lflags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cs_flags.is_equal (a_other.cs_flags) and
				cs_pending.is_equal (a_other.cs_pending) and
				cs_pend.is_equal (a_other.cs_pend) and
				cs_forinfo.is_equal (a_other.cs_forinfo) and
				cs_line.is_equal (a_other.cs_line) and
				cs_idx = a_other.cs_idx and
				cs_looplevel = a_other.cs_looplevel and
				cs_trylevel = a_other.cs_trylevel and
				cs_emsg_silent_list.is_equal (a_other.cs_emsg_silent_list) and
				cs_lflags = a_other.cs_lflags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_flags", <<50>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_pending", <<50>>),
					create {CE_STRUCTURE_FIELD}.make ("cs_pend"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_forinfo", <<50>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_line", <<50>>),
					create {CE_STRUCTURE_FIELD}.make ("cs_idx"),
					create {CE_STRUCTURE_FIELD}.make ("cs_looplevel"),
					create {CE_STRUCTURE_FIELD}.make ("cs_trylevel"),
					create {CE_STRUCTURE_FIELD}.make ("cs_emsg_silent_list"),
					create {CE_STRUCTURE_FIELD}.make ("cs_lflags")
				>>)
			init_structure_info
		end

end
