class
	PD_DBG_STUFF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create caught_stack.make
			create vv_exception.make
			create vv_throwpoint.make
			create current_exception.make
		end

feature {ANY} -- fields

	trylevel: INTEGER_32 assign set_trylevel

	force_abort: INTEGER_32 assign set_force_abort

	caught_stack: CE_POINTER [PD_VIM_EXCEPTION] assign set_caught_stack

	vv_exception: CE_POINTER [NATURAL_8] assign set_vv_exception

	vv_throwpoint: CE_POINTER [NATURAL_8] assign set_vv_throwpoint

	did_emsg: INTEGER_32 assign set_did_emsg

	got_int: INTEGER_32 assign set_got_int

	did_throw: INTEGER_32 assign set_did_throw

	need_rethrow: INTEGER_32 assign set_need_rethrow

	check_cstack: INTEGER_32 assign set_check_cstack

	current_exception: CE_POINTER [PD_VIM_EXCEPTION] assign set_current_exception

feature {ANY} -- setters

	set_trylevel (a_trylevel: INTEGER_32)
		do
			trylevel := a_trylevel
			update_memory_field ("trylevel")
		end

	set_force_abort (a_force_abort: INTEGER_32)
		do
			force_abort := a_force_abort
			update_memory_field ("force_abort")
		end

	set_caught_stack (a_caught_stack: CE_POINTER [PD_VIM_EXCEPTION])
		do
			caught_stack := a_caught_stack
			update_memory_field ("caught_stack")
		end

	set_vv_exception (a_vv_exception: CE_POINTER [NATURAL_8])
		do
			vv_exception := a_vv_exception
			update_memory_field ("vv_exception")
		end

	set_vv_throwpoint (a_vv_throwpoint: CE_POINTER [NATURAL_8])
		do
			vv_throwpoint := a_vv_throwpoint
			update_memory_field ("vv_throwpoint")
		end

	set_did_emsg (a_did_emsg: INTEGER_32)
		do
			did_emsg := a_did_emsg
			update_memory_field ("did_emsg")
		end

	set_got_int (a_got_int: INTEGER_32)
		do
			got_int := a_got_int
			update_memory_field ("got_int")
		end

	set_did_throw (a_did_throw: INTEGER_32)
		do
			did_throw := a_did_throw
			update_memory_field ("did_throw")
		end

	set_need_rethrow (a_need_rethrow: INTEGER_32)
		do
			need_rethrow := a_need_rethrow
			update_memory_field ("need_rethrow")
		end

	set_check_cstack (a_check_cstack: INTEGER_32)
		do
			check_cstack := a_check_cstack
			update_memory_field ("check_cstack")
		end

	set_current_exception (a_current_exception: CE_POINTER [PD_VIM_EXCEPTION])
		do
			current_exception := a_current_exception
			update_memory_field ("current_exception")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			trylevel := a_other.trylevel
			force_abort := a_other.force_abort
			caught_stack := a_other.caught_stack
			vv_exception := a_other.vv_exception
			vv_throwpoint := a_other.vv_throwpoint
			did_emsg := a_other.did_emsg
			got_int := a_other.got_int
			did_throw := a_other.did_throw
			need_rethrow := a_other.need_rethrow
			check_cstack := a_other.check_cstack
			current_exception := a_other.current_exception
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				trylevel = a_other.trylevel and
				force_abort = a_other.force_abort and
				caught_stack.is_equal (a_other.caught_stack) and
				vv_exception.is_equal (a_other.vv_exception) and
				vv_throwpoint.is_equal (a_other.vv_throwpoint) and
				did_emsg = a_other.did_emsg and
				got_int = a_other.got_int and
				did_throw = a_other.did_throw and
				need_rethrow = a_other.need_rethrow and
				check_cstack = a_other.check_cstack and
				current_exception.is_equal (a_other.current_exception)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("trylevel"),
					create {CE_STRUCTURE_FIELD}.make ("force_abort"),
					create {CE_STRUCTURE_FIELD}.make ("caught_stack"),
					create {CE_STRUCTURE_FIELD}.make ("vv_exception"),
					create {CE_STRUCTURE_FIELD}.make ("vv_throwpoint"),
					create {CE_STRUCTURE_FIELD}.make ("did_emsg"),
					create {CE_STRUCTURE_FIELD}.make ("got_int"),
					create {CE_STRUCTURE_FIELD}.make ("did_throw"),
					create {CE_STRUCTURE_FIELD}.make ("need_rethrow"),
					create {CE_STRUCTURE_FIELD}.make ("check_cstack"),
					create {CE_STRUCTURE_FIELD}.make ("current_exception")
				>>)
			init_structure_info
		end

end
