class
	PD_DICTITEM_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create di_tv.make
			create di_key.make (<<1>>)
		end

feature {ANY} -- fields

	di_tv: PD_TYPVAL_T assign set_di_tv

	di_flags: NATURAL_8 assign set_di_flags

	di_key: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_di_tv (a_di_tv: PD_TYPVAL_T)
		do
			di_tv := a_di_tv
			update_memory_field ("di_tv")
		end

	set_di_flags (a_di_flags: NATURAL_8)
		do
			di_flags := a_di_flags
			update_memory_field ("di_flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			di_tv := a_other.di_tv.twin
			di_flags := a_other.di_flags
			di_key := a_other.di_key.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				di_tv.is_equal (a_other.di_tv) and
				di_flags = a_other.di_flags and
				di_key.is_equal (a_other.di_key)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("di_tv"),
					create {CE_STRUCTURE_FIELD}.make ("di_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("di_key", <<1>>)
				>>)
			init_structure_info
		end

end
