class
	PD_DIFFBLOCK_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create df_next.make
			create df_lnum.make (<<4>>)
			create df_count.make (<<4>>)
		end

feature {ANY} -- fields

	df_next: CE_POINTER [PD_DIFFBLOCK_S] assign set_df_next

	df_lnum: CE_ARRAY [INTEGER_32]

	df_count: CE_ARRAY [INTEGER_32]

feature {ANY} -- setters

	set_df_next (a_df_next: CE_POINTER [PD_DIFFBLOCK_S])
		do
			df_next := a_df_next
			update_memory_field ("df_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			df_next := a_other.df_next
			df_lnum := a_other.df_lnum.twin
			df_count := a_other.df_count.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				df_next.is_equal (a_other.df_next) and
				df_lnum.is_equal (a_other.df_lnum) and
				df_count.is_equal (a_other.df_count)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("df_next"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("df_lnum", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("df_count", <<4>>)
				>>)
			init_structure_info
		end

end
