class
	PD_EXPGEN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create func.make
		end

feature {ANY} -- fields

	context: INTEGER_32 assign set_context

	func: CE_ROUTINE assign set_func

	ic: INTEGER_32 assign set_ic

feature {ANY} -- setters

	set_context (a_context: INTEGER_32)
		do
			context := a_context
			update_memory_field ("context")
		end

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

	set_ic (a_ic: INTEGER_32)
		do
			ic := a_ic
			update_memory_field ("ic")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			context := a_other.context
			func := a_other.func
			ic := a_other.ic
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				context = a_other.context and
				func.is_equal (a_other.func) and
				ic = a_other.ic
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("context"),
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("ic")
				>>)
			init_structure_info
		end

end
