class
	PD_FF_SEARCH_CTX_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ffsc_stack_ptr.make
			create ffsc_visited_list.make
			create ffsc_dir_visited_list.make
			create ffsc_visited_lists_list.make
			create ffsc_dir_visited_lists_list.make
			create ffsc_file_to_search.make
			create ffsc_start_dir.make
			create ffsc_fix_path.make
			create ffsc_wc_path.make
			create ffsc_stopdirs_v.make
		end

feature {ANY} -- fields

	ffsc_stack_ptr: CE_POINTER [PD_FF_STACK] assign set_ffsc_stack_ptr

	ffsc_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_visited_list

	ffsc_dir_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_dir_visited_list

	ffsc_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_visited_lists_list

	ffsc_dir_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_dir_visited_lists_list

	ffsc_file_to_search: CE_POINTER [NATURAL_8] assign set_ffsc_file_to_search

	ffsc_start_dir: CE_POINTER [NATURAL_8] assign set_ffsc_start_dir

	ffsc_fix_path: CE_POINTER [NATURAL_8] assign set_ffsc_fix_path

	ffsc_wc_path: CE_POINTER [NATURAL_8] assign set_ffsc_wc_path

	ffsc_level: INTEGER_32 assign set_ffsc_level

	ffsc_stopdirs_v: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_ffsc_stopdirs_v

	ffsc_find_what: INTEGER_32 assign set_ffsc_find_what

	ffsc_tagfile: INTEGER_32 assign set_ffsc_tagfile

feature {ANY} -- setters

	set_ffsc_stack_ptr (a_ffsc_stack_ptr: CE_POINTER [PD_FF_STACK])
		do
			ffsc_stack_ptr := a_ffsc_stack_ptr
			update_memory_field ("ffsc_stack_ptr")
		end

	set_ffsc_visited_list (a_ffsc_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			ffsc_visited_list := a_ffsc_visited_list
			update_memory_field ("ffsc_visited_list")
		end

	set_ffsc_dir_visited_list (a_ffsc_dir_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			ffsc_dir_visited_list := a_ffsc_dir_visited_list
			update_memory_field ("ffsc_dir_visited_list")
		end

	set_ffsc_visited_lists_list (a_ffsc_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			ffsc_visited_lists_list := a_ffsc_visited_lists_list
			update_memory_field ("ffsc_visited_lists_list")
		end

	set_ffsc_dir_visited_lists_list (a_ffsc_dir_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			ffsc_dir_visited_lists_list := a_ffsc_dir_visited_lists_list
			update_memory_field ("ffsc_dir_visited_lists_list")
		end

	set_ffsc_file_to_search (a_ffsc_file_to_search: CE_POINTER [NATURAL_8])
		do
			ffsc_file_to_search := a_ffsc_file_to_search
			update_memory_field ("ffsc_file_to_search")
		end

	set_ffsc_start_dir (a_ffsc_start_dir: CE_POINTER [NATURAL_8])
		do
			ffsc_start_dir := a_ffsc_start_dir
			update_memory_field ("ffsc_start_dir")
		end

	set_ffsc_fix_path (a_ffsc_fix_path: CE_POINTER [NATURAL_8])
		do
			ffsc_fix_path := a_ffsc_fix_path
			update_memory_field ("ffsc_fix_path")
		end

	set_ffsc_wc_path (a_ffsc_wc_path: CE_POINTER [NATURAL_8])
		do
			ffsc_wc_path := a_ffsc_wc_path
			update_memory_field ("ffsc_wc_path")
		end

	set_ffsc_level (a_ffsc_level: INTEGER_32)
		do
			ffsc_level := a_ffsc_level
			update_memory_field ("ffsc_level")
		end

	set_ffsc_stopdirs_v (a_ffsc_stopdirs_v: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			ffsc_stopdirs_v := a_ffsc_stopdirs_v
			update_memory_field ("ffsc_stopdirs_v")
		end

	set_ffsc_find_what (a_ffsc_find_what: INTEGER_32)
		do
			ffsc_find_what := a_ffsc_find_what
			update_memory_field ("ffsc_find_what")
		end

	set_ffsc_tagfile (a_ffsc_tagfile: INTEGER_32)
		do
			ffsc_tagfile := a_ffsc_tagfile
			update_memory_field ("ffsc_tagfile")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ffsc_stack_ptr := a_other.ffsc_stack_ptr
			ffsc_visited_list := a_other.ffsc_visited_list
			ffsc_dir_visited_list := a_other.ffsc_dir_visited_list
			ffsc_visited_lists_list := a_other.ffsc_visited_lists_list
			ffsc_dir_visited_lists_list := a_other.ffsc_dir_visited_lists_list
			ffsc_file_to_search := a_other.ffsc_file_to_search
			ffsc_start_dir := a_other.ffsc_start_dir
			ffsc_fix_path := a_other.ffsc_fix_path
			ffsc_wc_path := a_other.ffsc_wc_path
			ffsc_level := a_other.ffsc_level
			ffsc_stopdirs_v := a_other.ffsc_stopdirs_v
			ffsc_find_what := a_other.ffsc_find_what
			ffsc_tagfile := a_other.ffsc_tagfile
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ffsc_stack_ptr.is_equal (a_other.ffsc_stack_ptr) and
				ffsc_visited_list.is_equal (a_other.ffsc_visited_list) and
				ffsc_dir_visited_list.is_equal (a_other.ffsc_dir_visited_list) and
				ffsc_visited_lists_list.is_equal (a_other.ffsc_visited_lists_list) and
				ffsc_dir_visited_lists_list.is_equal (a_other.ffsc_dir_visited_lists_list) and
				ffsc_file_to_search.is_equal (a_other.ffsc_file_to_search) and
				ffsc_start_dir.is_equal (a_other.ffsc_start_dir) and
				ffsc_fix_path.is_equal (a_other.ffsc_fix_path) and
				ffsc_wc_path.is_equal (a_other.ffsc_wc_path) and
				ffsc_level = a_other.ffsc_level and
				ffsc_stopdirs_v.is_equal (a_other.ffsc_stopdirs_v) and
				ffsc_find_what = a_other.ffsc_find_what and
				ffsc_tagfile = a_other.ffsc_tagfile
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ffsc_stack_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_visited_list"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_dir_visited_list"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_visited_lists_list"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_dir_visited_lists_list"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_file_to_search"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_start_dir"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_fix_path"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_wc_path"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_level"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_stopdirs_v"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_find_what"),
					create {CE_STRUCTURE_FIELD}.make ("ffsc_tagfile")
				>>)
			init_structure_info
		end

end
