class
	PD_FF_VISITED

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ffv_next.make
			create ffv_wc_path.make
			create ffv_fname.make (<<1>>)
		end

feature {ANY} -- fields

	ffv_next: CE_POINTER [PD_FF_VISITED] assign set_ffv_next

	ffv_wc_path: CE_POINTER [NATURAL_8] assign set_ffv_wc_path

	ffv_dev_valid: INTEGER_32 assign set_ffv_dev_valid

	ffv_dev: NATURAL_64 assign set_ffv_dev

	ffv_ino: NATURAL_32 assign set_ffv_ino

	ffv_fname: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_ffv_next (a_ffv_next: CE_POINTER [PD_FF_VISITED])
		do
			ffv_next := a_ffv_next
			update_memory_field ("ffv_next")
		end

	set_ffv_wc_path (a_ffv_wc_path: CE_POINTER [NATURAL_8])
		do
			ffv_wc_path := a_ffv_wc_path
			update_memory_field ("ffv_wc_path")
		end

	set_ffv_dev_valid (a_ffv_dev_valid: INTEGER_32)
		do
			ffv_dev_valid := a_ffv_dev_valid
			update_memory_field ("ffv_dev_valid")
		end

	set_ffv_dev (a_ffv_dev: NATURAL_64)
		do
			ffv_dev := a_ffv_dev
			update_memory_field ("ffv_dev")
		end

	set_ffv_ino (a_ffv_ino: NATURAL_32)
		do
			ffv_ino := a_ffv_ino
			update_memory_field ("ffv_ino")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ffv_next := a_other.ffv_next
			ffv_wc_path := a_other.ffv_wc_path
			ffv_dev_valid := a_other.ffv_dev_valid
			ffv_dev := a_other.ffv_dev
			ffv_ino := a_other.ffv_ino
			ffv_fname := a_other.ffv_fname.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ffv_next.is_equal (a_other.ffv_next) and
				ffv_wc_path.is_equal (a_other.ffv_wc_path) and
				ffv_dev_valid = a_other.ffv_dev_valid and
				ffv_dev = a_other.ffv_dev and
				ffv_ino = a_other.ffv_ino and
				ffv_fname.is_equal (a_other.ffv_fname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ffv_next"),
					create {CE_STRUCTURE_FIELD}.make ("ffv_wc_path"),
					create {CE_STRUCTURE_FIELD}.make ("ffv_dev_valid"),
					create {CE_STRUCTURE_FIELD}.make ("ffv_dev"),
					create {CE_STRUCTURE_FIELD}.make ("ffv_ino"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ffv_fname", <<1>>)
				>>)
			init_structure_info
		end

end
