class
	PD_FRAME_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fr_parent.make
			create fr_next.make
			create fr_prev.make
			create fr_child.make
			create fr_win.make
		end

feature {ANY} -- fields

	fr_layout: INTEGER_8 assign set_fr_layout

	fr_width: INTEGER_32 assign set_fr_width

	fr_newwidth: INTEGER_32 assign set_fr_newwidth

	fr_height: INTEGER_32 assign set_fr_height

	fr_newheight: INTEGER_32 assign set_fr_newheight

	fr_parent: CE_POINTER [PD_FRAME_S] assign set_fr_parent

	fr_next: CE_POINTER [PD_FRAME_S] assign set_fr_next

	fr_prev: CE_POINTER [PD_FRAME_S] assign set_fr_prev

	fr_child: CE_POINTER [PD_FRAME_S] assign set_fr_child

	fr_win: CE_POINTER [PD_WINDOW_S] assign set_fr_win

feature {ANY} -- setters

	set_fr_layout (a_fr_layout: INTEGER_8)
		do
			fr_layout := a_fr_layout
			update_memory_field ("fr_layout")
		end

	set_fr_width (a_fr_width: INTEGER_32)
		do
			fr_width := a_fr_width
			update_memory_field ("fr_width")
		end

	set_fr_newwidth (a_fr_newwidth: INTEGER_32)
		do
			fr_newwidth := a_fr_newwidth
			update_memory_field ("fr_newwidth")
		end

	set_fr_height (a_fr_height: INTEGER_32)
		do
			fr_height := a_fr_height
			update_memory_field ("fr_height")
		end

	set_fr_newheight (a_fr_newheight: INTEGER_32)
		do
			fr_newheight := a_fr_newheight
			update_memory_field ("fr_newheight")
		end

	set_fr_parent (a_fr_parent: CE_POINTER [PD_FRAME_S])
		do
			fr_parent := a_fr_parent
			update_memory_field ("fr_parent")
		end

	set_fr_next (a_fr_next: CE_POINTER [PD_FRAME_S])
		do
			fr_next := a_fr_next
			update_memory_field ("fr_next")
		end

	set_fr_prev (a_fr_prev: CE_POINTER [PD_FRAME_S])
		do
			fr_prev := a_fr_prev
			update_memory_field ("fr_prev")
		end

	set_fr_child (a_fr_child: CE_POINTER [PD_FRAME_S])
		do
			fr_child := a_fr_child
			update_memory_field ("fr_child")
		end

	set_fr_win (a_fr_win: CE_POINTER [PD_WINDOW_S])
		do
			fr_win := a_fr_win
			update_memory_field ("fr_win")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fr_layout := a_other.fr_layout
			fr_width := a_other.fr_width
			fr_newwidth := a_other.fr_newwidth
			fr_height := a_other.fr_height
			fr_newheight := a_other.fr_newheight
			fr_parent := a_other.fr_parent
			fr_next := a_other.fr_next
			fr_prev := a_other.fr_prev
			fr_child := a_other.fr_child
			fr_win := a_other.fr_win
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fr_layout = a_other.fr_layout and
				fr_width = a_other.fr_width and
				fr_newwidth = a_other.fr_newwidth and
				fr_height = a_other.fr_height and
				fr_newheight = a_other.fr_newheight and
				fr_parent.is_equal (a_other.fr_parent) and
				fr_next.is_equal (a_other.fr_next) and
				fr_prev.is_equal (a_other.fr_prev) and
				fr_child.is_equal (a_other.fr_child) and
				fr_win.is_equal (a_other.fr_win)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fr_layout"),
					create {CE_STRUCTURE_FIELD}.make ("fr_width"),
					create {CE_STRUCTURE_FIELD}.make ("fr_newwidth"),
					create {CE_STRUCTURE_FIELD}.make ("fr_height"),
					create {CE_STRUCTURE_FIELD}.make ("fr_newheight"),
					create {CE_STRUCTURE_FIELD}.make ("fr_parent"),
					create {CE_STRUCTURE_FIELD}.make ("fr_next"),
					create {CE_STRUCTURE_FIELD}.make ("fr_prev"),
					create {CE_STRUCTURE_FIELD}.make ("fr_child"),
					create {CE_STRUCTURE_FIELD}.make ("fr_win")
				>>)
			init_structure_info
		end

end
