class
	PD_GTKFORMCHILD

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create widget.make
			create window.make
		end

feature {ANY} -- fields

	widget: CE_POINTER [SD_GTKWIDGET] assign set_widget

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	mapped: INTEGER_32 assign set_mapped

feature {ANY} -- setters

	set_widget (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			widget := a_widget
			update_memory_field ("widget")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_mapped (a_mapped: INTEGER_32)
		do
			mapped := a_mapped
			update_memory_field ("mapped")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			widget := a_other.widget
			window := a_other.window
			x := a_other.x
			y := a_other.y
			mapped := a_other.mapped
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				widget.is_equal (a_other.widget) and
				window.is_equal (a_other.window) and
				x = a_other.x and
				y = a_other.y and
				mapped = a_other.mapped
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("widget"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("mapped")
				>>)
			init_structure_info
		end

end
