class
	PD_GUI

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dragged_wp.make
			create bottom_sbar.make
			create which_scrollbars.make (<<3>>)
			create norm_font.make
			create wide_font.make
			create blank_pointer.make
			create geom.make
			create mainwin.make
			create formwin.make
			create drawarea.make
			create menubar.make
			create toolbar.make
			create fgcolor.make
			create bgcolor.make
			create spcolor.make
			create text_gc.make
			create text_context.make
			create ascii_font.make
			create ascii_glyphs.make
			create tabline.make
			create accel_group.make
			create filedlg.make
			create browse_fname.make
			create rsrc_input_method.make
			create rsrc_preedit_type_name.make
		end

feature {ANY} -- fields

	in_focus: INTEGER_32 assign set_in_focus

	in_use: INTEGER_32 assign set_in_use

	starting: INTEGER_32 assign set_starting

	shell_created: INTEGER_32 assign set_shell_created

	dying: INTEGER_32 assign set_dying

	dofork: INTEGER_32 assign set_dofork

	dragged_sb: INTEGER_32 assign set_dragged_sb

	dragged_wp: CE_POINTER [PD_WINDOW_S] assign set_dragged_wp

	pointer_hidden: INTEGER_32 assign set_pointer_hidden

	col: INTEGER_32 assign set_col

	row: INTEGER_32 assign set_row

	cursor_col: INTEGER_32 assign set_cursor_col

	cursor_row: INTEGER_32 assign set_cursor_row

	cursor_is_valid: INTEGER_8 assign set_cursor_is_valid

	num_cols: INTEGER_32 assign set_num_cols

	num_rows: INTEGER_32 assign set_num_rows

	scroll_region_top: INTEGER_32 assign set_scroll_region_top

	scroll_region_bot: INTEGER_32 assign set_scroll_region_bot

	scroll_region_left: INTEGER_32 assign set_scroll_region_left

	scroll_region_right: INTEGER_32 assign set_scroll_region_right

	highlight_mask: INTEGER_32 assign set_highlight_mask

	scrollbar_width: INTEGER_32 assign set_scrollbar_width

	scrollbar_height: INTEGER_32 assign set_scrollbar_height

	left_sbar_x: INTEGER_32 assign set_left_sbar_x

	right_sbar_x: INTEGER_32 assign set_right_sbar_x

	menu_is_active: INTEGER_8 assign set_menu_is_active

	bottom_sbar: PD_GUISCROLLBAR assign set_bottom_sbar

	which_scrollbars: CE_ARRAY [INTEGER_32]

	prev_wrap: INTEGER_32 assign set_prev_wrap

	char_width: INTEGER_32 assign set_char_width

	char_height: INTEGER_32 assign set_char_height

	char_ascent: INTEGER_32 assign set_char_ascent

	border_width: INTEGER_32 assign set_border_width

	border_offset: INTEGER_32 assign set_border_offset

	norm_font: CE_POINTER [ANY] assign set_norm_font

	font_can_bold: INTEGER_32 assign set_font_can_bold

	wide_font: CE_POINTER [ANY] assign set_wide_font

	back_pixel: INTEGER_32 assign set_back_pixel

	norm_pixel: INTEGER_32 assign set_norm_pixel

	def_back_pixel: INTEGER_32 assign set_def_back_pixel

	def_norm_pixel: INTEGER_32 assign set_def_norm_pixel

	visibility: INTEGER_32 assign set_visibility

	blank_pointer: CE_POINTER [SD_GDKCURSOR] assign set_blank_pointer

	geom: CE_POINTER [NATURAL_8] assign set_geom

	mainwin: CE_POINTER [SD_GTKWIDGET] assign set_mainwin

	formwin: CE_POINTER [SD_GTKWIDGET] assign set_formwin

	drawarea: CE_POINTER [SD_GTKWIDGET] assign set_drawarea

	menubar: CE_POINTER [SD_GTKWIDGET] assign set_menubar

	toolbar: CE_POINTER [SD_GTKWIDGET] assign set_toolbar

	fgcolor: CE_POINTER [SD_GDKCOLOR] assign set_fgcolor

	bgcolor: CE_POINTER [SD_GDKCOLOR] assign set_bgcolor

	spcolor: CE_POINTER [SD_GDKCOLOR] assign set_spcolor

	text_gc: CE_POINTER [SD_GDKGC] assign set_text_gc

	text_context: CE_POINTER [ANY] assign set_text_context

	ascii_font: CE_POINTER [ANY] assign set_ascii_font

	ascii_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING] assign set_ascii_glyphs

	tabline: CE_POINTER [SD_GTKWIDGET] assign set_tabline

	accel_group: CE_POINTER [SD_GTKACCELGROUP] assign set_accel_group

	filedlg: CE_POINTER [SD_GTKWIDGET] assign set_filedlg

	browse_fname: CE_POINTER [NATURAL_8] assign set_browse_fname

	rsrc_input_method: CE_POINTER [INTEGER_8] assign set_rsrc_input_method

	rsrc_preedit_type_name: CE_POINTER [INTEGER_8] assign set_rsrc_preedit_type_name

feature {ANY} -- setters

	set_in_focus (a_in_focus: INTEGER_32)
		do
			in_focus := a_in_focus
			update_memory_field ("in_focus")
		end

	set_in_use (a_in_use: INTEGER_32)
		do
			in_use := a_in_use
			update_memory_field ("in_use")
		end

	set_starting (a_starting: INTEGER_32)
		do
			starting := a_starting
			update_memory_field ("starting")
		end

	set_shell_created (a_shell_created: INTEGER_32)
		do
			shell_created := a_shell_created
			update_memory_field ("shell_created")
		end

	set_dying (a_dying: INTEGER_32)
		do
			dying := a_dying
			update_memory_field ("dying")
		end

	set_dofork (a_dofork: INTEGER_32)
		do
			dofork := a_dofork
			update_memory_field ("dofork")
		end

	set_dragged_sb (a_dragged_sb: INTEGER_32)
		do
			dragged_sb := a_dragged_sb
			update_memory_field ("dragged_sb")
		end

	set_dragged_wp (a_dragged_wp: CE_POINTER [PD_WINDOW_S])
		do
			dragged_wp := a_dragged_wp
			update_memory_field ("dragged_wp")
		end

	set_pointer_hidden (a_pointer_hidden: INTEGER_32)
		do
			pointer_hidden := a_pointer_hidden
			update_memory_field ("pointer_hidden")
		end

	set_col (a_col: INTEGER_32)
		do
			col := a_col
			update_memory_field ("col")
		end

	set_row (a_row: INTEGER_32)
		do
			row := a_row
			update_memory_field ("row")
		end

	set_cursor_col (a_cursor_col: INTEGER_32)
		do
			cursor_col := a_cursor_col
			update_memory_field ("cursor_col")
		end

	set_cursor_row (a_cursor_row: INTEGER_32)
		do
			cursor_row := a_cursor_row
			update_memory_field ("cursor_row")
		end

	set_cursor_is_valid (a_cursor_is_valid: INTEGER_8)
		do
			cursor_is_valid := a_cursor_is_valid
			update_memory_field ("cursor_is_valid")
		end

	set_num_cols (a_num_cols: INTEGER_32)
		do
			num_cols := a_num_cols
			update_memory_field ("num_cols")
		end

	set_num_rows (a_num_rows: INTEGER_32)
		do
			num_rows := a_num_rows
			update_memory_field ("num_rows")
		end

	set_scroll_region_top (a_scroll_region_top: INTEGER_32)
		do
			scroll_region_top := a_scroll_region_top
			update_memory_field ("scroll_region_top")
		end

	set_scroll_region_bot (a_scroll_region_bot: INTEGER_32)
		do
			scroll_region_bot := a_scroll_region_bot
			update_memory_field ("scroll_region_bot")
		end

	set_scroll_region_left (a_scroll_region_left: INTEGER_32)
		do
			scroll_region_left := a_scroll_region_left
			update_memory_field ("scroll_region_left")
		end

	set_scroll_region_right (a_scroll_region_right: INTEGER_32)
		do
			scroll_region_right := a_scroll_region_right
			update_memory_field ("scroll_region_right")
		end

	set_highlight_mask (a_highlight_mask: INTEGER_32)
		do
			highlight_mask := a_highlight_mask
			update_memory_field ("highlight_mask")
		end

	set_scrollbar_width (a_scrollbar_width: INTEGER_32)
		do
			scrollbar_width := a_scrollbar_width
			update_memory_field ("scrollbar_width")
		end

	set_scrollbar_height (a_scrollbar_height: INTEGER_32)
		do
			scrollbar_height := a_scrollbar_height
			update_memory_field ("scrollbar_height")
		end

	set_left_sbar_x (a_left_sbar_x: INTEGER_32)
		do
			left_sbar_x := a_left_sbar_x
			update_memory_field ("left_sbar_x")
		end

	set_right_sbar_x (a_right_sbar_x: INTEGER_32)
		do
			right_sbar_x := a_right_sbar_x
			update_memory_field ("right_sbar_x")
		end

	set_menu_is_active (a_menu_is_active: INTEGER_8)
		do
			menu_is_active := a_menu_is_active
			update_memory_field ("menu_is_active")
		end

	set_bottom_sbar (a_bottom_sbar: PD_GUISCROLLBAR)
		do
			bottom_sbar := a_bottom_sbar
			update_memory_field ("bottom_sbar")
		end

	set_prev_wrap (a_prev_wrap: INTEGER_32)
		do
			prev_wrap := a_prev_wrap
			update_memory_field ("prev_wrap")
		end

	set_char_width (a_char_width: INTEGER_32)
		do
			char_width := a_char_width
			update_memory_field ("char_width")
		end

	set_char_height (a_char_height: INTEGER_32)
		do
			char_height := a_char_height
			update_memory_field ("char_height")
		end

	set_char_ascent (a_char_ascent: INTEGER_32)
		do
			char_ascent := a_char_ascent
			update_memory_field ("char_ascent")
		end

	set_border_width (a_border_width: INTEGER_32)
		do
			border_width := a_border_width
			update_memory_field ("border_width")
		end

	set_border_offset (a_border_offset: INTEGER_32)
		do
			border_offset := a_border_offset
			update_memory_field ("border_offset")
		end

	set_norm_font (a_norm_font: CE_POINTER [ANY])
		do
			norm_font := a_norm_font
			update_memory_field ("norm_font")
		end

	set_font_can_bold (a_font_can_bold: INTEGER_32)
		do
			font_can_bold := a_font_can_bold
			update_memory_field ("font_can_bold")
		end

	set_wide_font (a_wide_font: CE_POINTER [ANY])
		do
			wide_font := a_wide_font
			update_memory_field ("wide_font")
		end

	set_back_pixel (a_back_pixel: INTEGER_32)
		do
			back_pixel := a_back_pixel
			update_memory_field ("back_pixel")
		end

	set_norm_pixel (a_norm_pixel: INTEGER_32)
		do
			norm_pixel := a_norm_pixel
			update_memory_field ("norm_pixel")
		end

	set_def_back_pixel (a_def_back_pixel: INTEGER_32)
		do
			def_back_pixel := a_def_back_pixel
			update_memory_field ("def_back_pixel")
		end

	set_def_norm_pixel (a_def_norm_pixel: INTEGER_32)
		do
			def_norm_pixel := a_def_norm_pixel
			update_memory_field ("def_norm_pixel")
		end

	set_visibility (a_visibility: INTEGER_32)
		do
			visibility := a_visibility
			update_memory_field ("visibility")
		end

	set_blank_pointer (a_blank_pointer: CE_POINTER [SD_GDKCURSOR])
		do
			blank_pointer := a_blank_pointer
			update_memory_field ("blank_pointer")
		end

	set_geom (a_geom: CE_POINTER [NATURAL_8])
		do
			geom := a_geom
			update_memory_field ("geom")
		end

	set_mainwin (a_mainwin: CE_POINTER [SD_GTKWIDGET])
		do
			mainwin := a_mainwin
			update_memory_field ("mainwin")
		end

	set_formwin (a_formwin: CE_POINTER [SD_GTKWIDGET])
		do
			formwin := a_formwin
			update_memory_field ("formwin")
		end

	set_drawarea (a_drawarea: CE_POINTER [SD_GTKWIDGET])
		do
			drawarea := a_drawarea
			update_memory_field ("drawarea")
		end

	set_menubar (a_menubar: CE_POINTER [SD_GTKWIDGET])
		do
			menubar := a_menubar
			update_memory_field ("menubar")
		end

	set_toolbar (a_toolbar: CE_POINTER [SD_GTKWIDGET])
		do
			toolbar := a_toolbar
			update_memory_field ("toolbar")
		end

	set_fgcolor (a_fgcolor: CE_POINTER [SD_GDKCOLOR])
		do
			fgcolor := a_fgcolor
			update_memory_field ("fgcolor")
		end

	set_bgcolor (a_bgcolor: CE_POINTER [SD_GDKCOLOR])
		do
			bgcolor := a_bgcolor
			update_memory_field ("bgcolor")
		end

	set_spcolor (a_spcolor: CE_POINTER [SD_GDKCOLOR])
		do
			spcolor := a_spcolor
			update_memory_field ("spcolor")
		end

	set_text_gc (a_text_gc: CE_POINTER [SD_GDKGC])
		do
			text_gc := a_text_gc
			update_memory_field ("text_gc")
		end

	set_text_context (a_text_context: CE_POINTER [ANY])
		do
			text_context := a_text_context
			update_memory_field ("text_context")
		end

	set_ascii_font (a_ascii_font: CE_POINTER [ANY])
		do
			ascii_font := a_ascii_font
			update_memory_field ("ascii_font")
		end

	set_ascii_glyphs (a_ascii_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING])
		do
			ascii_glyphs := a_ascii_glyphs
			update_memory_field ("ascii_glyphs")
		end

	set_tabline (a_tabline: CE_POINTER [SD_GTKWIDGET])
		do
			tabline := a_tabline
			update_memory_field ("tabline")
		end

	set_accel_group (a_accel_group: CE_POINTER [SD_GTKACCELGROUP])
		do
			accel_group := a_accel_group
			update_memory_field ("accel_group")
		end

	set_filedlg (a_filedlg: CE_POINTER [SD_GTKWIDGET])
		do
			filedlg := a_filedlg
			update_memory_field ("filedlg")
		end

	set_browse_fname (a_browse_fname: CE_POINTER [NATURAL_8])
		do
			browse_fname := a_browse_fname
			update_memory_field ("browse_fname")
		end

	set_rsrc_input_method (a_rsrc_input_method: CE_POINTER [INTEGER_8])
		do
			rsrc_input_method := a_rsrc_input_method
			update_memory_field ("rsrc_input_method")
		end

	set_rsrc_preedit_type_name (a_rsrc_preedit_type_name: CE_POINTER [INTEGER_8])
		do
			rsrc_preedit_type_name := a_rsrc_preedit_type_name
			update_memory_field ("rsrc_preedit_type_name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			in_focus := a_other.in_focus
			in_use := a_other.in_use
			starting := a_other.starting
			shell_created := a_other.shell_created
			dying := a_other.dying
			dofork := a_other.dofork
			dragged_sb := a_other.dragged_sb
			dragged_wp := a_other.dragged_wp
			pointer_hidden := a_other.pointer_hidden
			col := a_other.col
			row := a_other.row
			cursor_col := a_other.cursor_col
			cursor_row := a_other.cursor_row
			cursor_is_valid := a_other.cursor_is_valid
			num_cols := a_other.num_cols
			num_rows := a_other.num_rows
			scroll_region_top := a_other.scroll_region_top
			scroll_region_bot := a_other.scroll_region_bot
			scroll_region_left := a_other.scroll_region_left
			scroll_region_right := a_other.scroll_region_right
			highlight_mask := a_other.highlight_mask
			scrollbar_width := a_other.scrollbar_width
			scrollbar_height := a_other.scrollbar_height
			left_sbar_x := a_other.left_sbar_x
			right_sbar_x := a_other.right_sbar_x
			menu_is_active := a_other.menu_is_active
			bottom_sbar := a_other.bottom_sbar.twin
			which_scrollbars := a_other.which_scrollbars.twin
			prev_wrap := a_other.prev_wrap
			char_width := a_other.char_width
			char_height := a_other.char_height
			char_ascent := a_other.char_ascent
			border_width := a_other.border_width
			border_offset := a_other.border_offset
			norm_font := a_other.norm_font
			font_can_bold := a_other.font_can_bold
			wide_font := a_other.wide_font
			back_pixel := a_other.back_pixel
			norm_pixel := a_other.norm_pixel
			def_back_pixel := a_other.def_back_pixel
			def_norm_pixel := a_other.def_norm_pixel
			visibility := a_other.visibility
			blank_pointer := a_other.blank_pointer
			geom := a_other.geom
			mainwin := a_other.mainwin
			formwin := a_other.formwin
			drawarea := a_other.drawarea
			menubar := a_other.menubar
			toolbar := a_other.toolbar
			fgcolor := a_other.fgcolor
			bgcolor := a_other.bgcolor
			spcolor := a_other.spcolor
			text_gc := a_other.text_gc
			text_context := a_other.text_context
			ascii_font := a_other.ascii_font
			ascii_glyphs := a_other.ascii_glyphs
			tabline := a_other.tabline
			accel_group := a_other.accel_group
			filedlg := a_other.filedlg
			browse_fname := a_other.browse_fname
			rsrc_input_method := a_other.rsrc_input_method
			rsrc_preedit_type_name := a_other.rsrc_preedit_type_name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				in_focus = a_other.in_focus and
				in_use = a_other.in_use and
				starting = a_other.starting and
				shell_created = a_other.shell_created and
				dying = a_other.dying and
				dofork = a_other.dofork and
				dragged_sb = a_other.dragged_sb and
				dragged_wp.is_equal (a_other.dragged_wp) and
				pointer_hidden = a_other.pointer_hidden and
				col = a_other.col and
				row = a_other.row and
				cursor_col = a_other.cursor_col and
				cursor_row = a_other.cursor_row and
				cursor_is_valid = a_other.cursor_is_valid and
				num_cols = a_other.num_cols and
				num_rows = a_other.num_rows and
				scroll_region_top = a_other.scroll_region_top and
				scroll_region_bot = a_other.scroll_region_bot and
				scroll_region_left = a_other.scroll_region_left and
				scroll_region_right = a_other.scroll_region_right and
				highlight_mask = a_other.highlight_mask and
				scrollbar_width = a_other.scrollbar_width and
				scrollbar_height = a_other.scrollbar_height and
				left_sbar_x = a_other.left_sbar_x and
				right_sbar_x = a_other.right_sbar_x and
				menu_is_active = a_other.menu_is_active and
				bottom_sbar.is_equal (a_other.bottom_sbar) and
				which_scrollbars.is_equal (a_other.which_scrollbars) and
				prev_wrap = a_other.prev_wrap and
				char_width = a_other.char_width and
				char_height = a_other.char_height and
				char_ascent = a_other.char_ascent and
				border_width = a_other.border_width and
				border_offset = a_other.border_offset and
				norm_font.is_equal (a_other.norm_font) and
				font_can_bold = a_other.font_can_bold and
				wide_font.is_equal (a_other.wide_font) and
				back_pixel = a_other.back_pixel and
				norm_pixel = a_other.norm_pixel and
				def_back_pixel = a_other.def_back_pixel and
				def_norm_pixel = a_other.def_norm_pixel and
				visibility = a_other.visibility and
				blank_pointer.is_equal (a_other.blank_pointer) and
				geom.is_equal (a_other.geom) and
				mainwin.is_equal (a_other.mainwin) and
				formwin.is_equal (a_other.formwin) and
				drawarea.is_equal (a_other.drawarea) and
				menubar.is_equal (a_other.menubar) and
				toolbar.is_equal (a_other.toolbar) and
				fgcolor.is_equal (a_other.fgcolor) and
				bgcolor.is_equal (a_other.bgcolor) and
				spcolor.is_equal (a_other.spcolor) and
				text_gc.is_equal (a_other.text_gc) and
				text_context.is_equal (a_other.text_context) and
				ascii_font.is_equal (a_other.ascii_font) and
				ascii_glyphs.is_equal (a_other.ascii_glyphs) and
				tabline.is_equal (a_other.tabline) and
				accel_group.is_equal (a_other.accel_group) and
				filedlg.is_equal (a_other.filedlg) and
				browse_fname.is_equal (a_other.browse_fname) and
				rsrc_input_method.is_equal (a_other.rsrc_input_method) and
				rsrc_preedit_type_name.is_equal (a_other.rsrc_preedit_type_name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("in_focus"),
					create {CE_STRUCTURE_FIELD}.make ("in_use"),
					create {CE_STRUCTURE_FIELD}.make ("starting"),
					create {CE_STRUCTURE_FIELD}.make ("shell_created"),
					create {CE_STRUCTURE_FIELD}.make ("dying"),
					create {CE_STRUCTURE_FIELD}.make ("dofork"),
					create {CE_STRUCTURE_FIELD}.make ("dragged_sb"),
					create {CE_STRUCTURE_FIELD}.make ("dragged_wp"),
					create {CE_STRUCTURE_FIELD}.make ("pointer_hidden"),
					create {CE_STRUCTURE_FIELD}.make ("col"),
					create {CE_STRUCTURE_FIELD}.make ("row"),
					create {CE_STRUCTURE_FIELD}.make ("cursor_col"),
					create {CE_STRUCTURE_FIELD}.make ("cursor_row"),
					create {CE_STRUCTURE_FIELD}.make ("cursor_is_valid"),
					create {CE_STRUCTURE_FIELD}.make ("num_cols"),
					create {CE_STRUCTURE_FIELD}.make ("num_rows"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_region_top"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_region_bot"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_region_left"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_region_right"),
					create {CE_STRUCTURE_FIELD}.make ("highlight_mask"),
					create {CE_STRUCTURE_FIELD}.make ("scrollbar_width"),
					create {CE_STRUCTURE_FIELD}.make ("scrollbar_height"),
					create {CE_STRUCTURE_FIELD}.make ("left_sbar_x"),
					create {CE_STRUCTURE_FIELD}.make ("right_sbar_x"),
					create {CE_STRUCTURE_FIELD}.make ("menu_is_active"),
					create {CE_STRUCTURE_FIELD}.make ("bottom_sbar"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("which_scrollbars", <<3>>),
					create {CE_STRUCTURE_FIELD}.make ("prev_wrap"),
					create {CE_STRUCTURE_FIELD}.make ("char_width"),
					create {CE_STRUCTURE_FIELD}.make ("char_height"),
					create {CE_STRUCTURE_FIELD}.make ("char_ascent"),
					create {CE_STRUCTURE_FIELD}.make ("border_width"),
					create {CE_STRUCTURE_FIELD}.make ("border_offset"),
					create {CE_STRUCTURE_FIELD}.make ("norm_font"),
					create {CE_STRUCTURE_FIELD}.make ("font_can_bold"),
					create {CE_STRUCTURE_FIELD}.make ("wide_font"),
					create {CE_STRUCTURE_FIELD}.make ("back_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("norm_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("def_back_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("def_norm_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("visibility"),
					create {CE_STRUCTURE_FIELD}.make ("blank_pointer"),
					create {CE_STRUCTURE_FIELD}.make ("geom"),
					create {CE_STRUCTURE_FIELD}.make ("mainwin"),
					create {CE_STRUCTURE_FIELD}.make ("formwin"),
					create {CE_STRUCTURE_FIELD}.make ("drawarea"),
					create {CE_STRUCTURE_FIELD}.make ("menubar"),
					create {CE_STRUCTURE_FIELD}.make ("toolbar"),
					create {CE_STRUCTURE_FIELD}.make ("fgcolor"),
					create {CE_STRUCTURE_FIELD}.make ("bgcolor"),
					create {CE_STRUCTURE_FIELD}.make ("spcolor"),
					create {CE_STRUCTURE_FIELD}.make ("text_gc"),
					create {CE_STRUCTURE_FIELD}.make ("text_context"),
					create {CE_STRUCTURE_FIELD}.make ("ascii_font"),
					create {CE_STRUCTURE_FIELD}.make ("ascii_glyphs"),
					create {CE_STRUCTURE_FIELD}.make ("tabline"),
					create {CE_STRUCTURE_FIELD}.make ("accel_group"),
					create {CE_STRUCTURE_FIELD}.make ("filedlg"),
					create {CE_STRUCTURE_FIELD}.make ("browse_fname"),
					create {CE_STRUCTURE_FIELD}.make ("rsrc_input_method"),
					create {CE_STRUCTURE_FIELD}.make ("rsrc_preedit_type_name")
				>>)
			init_structure_info
		end

end
