class
	PD_GUISCROLLBAR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create wp.make
			create id.make
		end

feature {ANY} -- fields

	ident: INTEGER_32 assign set_ident

	wp: CE_POINTER [PD_WINDOW_S] assign set_wp

	type: INTEGER_32 assign set_type

	value: INTEGER_32 assign set_value

	size: INTEGER_32 assign set_size

	max: INTEGER_32 assign set_max

	top: INTEGER_32 assign set_top

	height: INTEGER_32 assign set_height

	width: INTEGER_32 assign set_width

	status_height: INTEGER_32 assign set_status_height

	id: CE_POINTER [SD_GTKWIDGET] assign set_id

	handler_id: NATURAL_32 assign set_handler_id

feature {ANY} -- setters

	set_ident (a_ident: INTEGER_32)
		do
			ident := a_ident
			update_memory_field ("ident")
		end

	set_wp (a_wp: CE_POINTER [PD_WINDOW_S])
		do
			wp := a_wp
			update_memory_field ("wp")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_value (a_value: INTEGER_32)
		do
			value := a_value
			update_memory_field ("value")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_max (a_max: INTEGER_32)
		do
			max := a_max
			update_memory_field ("max")
		end

	set_top (a_top: INTEGER_32)
		do
			top := a_top
			update_memory_field ("top")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_status_height (a_status_height: INTEGER_32)
		do
			status_height := a_status_height
			update_memory_field ("status_height")
		end

	set_id (a_id: CE_POINTER [SD_GTKWIDGET])
		do
			id := a_id
			update_memory_field ("id")
		end

	set_handler_id (a_handler_id: NATURAL_32)
		do
			handler_id := a_handler_id
			update_memory_field ("handler_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ident := a_other.ident
			wp := a_other.wp
			type := a_other.type
			value := a_other.value
			size := a_other.size
			max := a_other.max
			top := a_other.top
			height := a_other.height
			width := a_other.width
			status_height := a_other.status_height
			id := a_other.id
			handler_id := a_other.handler_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ident = a_other.ident and
				wp.is_equal (a_other.wp) and
				type = a_other.type and
				value = a_other.value and
				size = a_other.size and
				max = a_other.max and
				top = a_other.top and
				height = a_other.height and
				width = a_other.width and
				status_height = a_other.status_height and
				id.is_equal (a_other.id) and
				handler_id = a_other.handler_id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ident"),
					create {CE_STRUCTURE_FIELD}.make ("wp"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("max"),
					create {CE_STRUCTURE_FIELD}.make ("top"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("status_height"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("handler_id")
				>>)
			init_structure_info
		end

end
