class
	PD_LANGP_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create lp_slang.make
			create lp_sallang.make
			create lp_replang.make
		end

feature {ANY} -- fields

	lp_slang: CE_POINTER [PD_SLANG_S] assign set_lp_slang

	lp_sallang: CE_POINTER [PD_SLANG_S] assign set_lp_sallang

	lp_replang: CE_POINTER [PD_SLANG_S] assign set_lp_replang

	lp_region: INTEGER_32 assign set_lp_region

feature {ANY} -- setters

	set_lp_slang (a_lp_slang: CE_POINTER [PD_SLANG_S])
		do
			lp_slang := a_lp_slang
			update_memory_field ("lp_slang")
		end

	set_lp_sallang (a_lp_sallang: CE_POINTER [PD_SLANG_S])
		do
			lp_sallang := a_lp_sallang
			update_memory_field ("lp_sallang")
		end

	set_lp_replang (a_lp_replang: CE_POINTER [PD_SLANG_S])
		do
			lp_replang := a_lp_replang
			update_memory_field ("lp_replang")
		end

	set_lp_region (a_lp_region: INTEGER_32)
		do
			lp_region := a_lp_region
			update_memory_field ("lp_region")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lp_slang := a_other.lp_slang
			lp_sallang := a_other.lp_sallang
			lp_replang := a_other.lp_replang
			lp_region := a_other.lp_region
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lp_slang.is_equal (a_other.lp_slang) and
				lp_sallang.is_equal (a_other.lp_sallang) and
				lp_replang.is_equal (a_other.lp_replang) and
				lp_region = a_other.lp_region
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lp_slang"),
					create {CE_STRUCTURE_FIELD}.make ("lp_sallang"),
					create {CE_STRUCTURE_FIELD}.make ("lp_replang"),
					create {CE_STRUCTURE_FIELD}.make ("lp_region")
				>>)
			init_structure_info
		end

end
