class
	PD_LINEOFF_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	lnum: INTEGER_32 assign set_lnum

	fill: INTEGER_32 assign set_fill

	height: INTEGER_32 assign set_height

feature {ANY} -- setters

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_fill (a_fill: INTEGER_32)
		do
			fill := a_fill
			update_memory_field ("fill")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lnum := a_other.lnum
			fill := a_other.fill
			height := a_other.height
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lnum = a_other.lnum and
				fill = a_other.fill and
				height = a_other.height
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("fill"),
					create {CE_STRUCTURE_FIELD}.make ("height")
				>>)
			init_structure_info
		end

end
