class
	PD_LISTVAR_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create lv_first.make
			create lv_last.make
			create lv_watch.make
			create lv_idx_item.make
			create lv_copylist.make
			create lv_used_next.make
			create lv_used_prev.make
		end

feature {ANY} -- fields

	lv_first: CE_POINTER [PD_LISTITEM_S] assign set_lv_first

	lv_last: CE_POINTER [PD_LISTITEM_S] assign set_lv_last

	lv_refcount: INTEGER_32 assign set_lv_refcount

	lv_len: INTEGER_32 assign set_lv_len

	lv_watch: CE_POINTER [PD_LISTWATCH_S] assign set_lv_watch

	lv_idx: INTEGER_32 assign set_lv_idx

	lv_idx_item: CE_POINTER [PD_LISTITEM_S] assign set_lv_idx_item

	lv_copyID: INTEGER_32 assign set_lv_copyID

	lv_copylist: CE_POINTER [PD_LISTVAR_S] assign set_lv_copylist

	lv_lock: INTEGER_8 assign set_lv_lock

	lv_used_next: CE_POINTER [PD_LISTVAR_S] assign set_lv_used_next

	lv_used_prev: CE_POINTER [PD_LISTVAR_S] assign set_lv_used_prev

feature {ANY} -- setters

	set_lv_first (a_lv_first: CE_POINTER [PD_LISTITEM_S])
		do
			lv_first := a_lv_first
			update_memory_field ("lv_first")
		end

	set_lv_last (a_lv_last: CE_POINTER [PD_LISTITEM_S])
		do
			lv_last := a_lv_last
			update_memory_field ("lv_last")
		end

	set_lv_refcount (a_lv_refcount: INTEGER_32)
		do
			lv_refcount := a_lv_refcount
			update_memory_field ("lv_refcount")
		end

	set_lv_len (a_lv_len: INTEGER_32)
		do
			lv_len := a_lv_len
			update_memory_field ("lv_len")
		end

	set_lv_watch (a_lv_watch: CE_POINTER [PD_LISTWATCH_S])
		do
			lv_watch := a_lv_watch
			update_memory_field ("lv_watch")
		end

	set_lv_idx (a_lv_idx: INTEGER_32)
		do
			lv_idx := a_lv_idx
			update_memory_field ("lv_idx")
		end

	set_lv_idx_item (a_lv_idx_item: CE_POINTER [PD_LISTITEM_S])
		do
			lv_idx_item := a_lv_idx_item
			update_memory_field ("lv_idx_item")
		end

	set_lv_copyID (a_lv_copyID: INTEGER_32)
		do
			lv_copyID := a_lv_copyID
			update_memory_field ("lv_copyID")
		end

	set_lv_copylist (a_lv_copylist: CE_POINTER [PD_LISTVAR_S])
		do
			lv_copylist := a_lv_copylist
			update_memory_field ("lv_copylist")
		end

	set_lv_lock (a_lv_lock: INTEGER_8)
		do
			lv_lock := a_lv_lock
			update_memory_field ("lv_lock")
		end

	set_lv_used_next (a_lv_used_next: CE_POINTER [PD_LISTVAR_S])
		do
			lv_used_next := a_lv_used_next
			update_memory_field ("lv_used_next")
		end

	set_lv_used_prev (a_lv_used_prev: CE_POINTER [PD_LISTVAR_S])
		do
			lv_used_prev := a_lv_used_prev
			update_memory_field ("lv_used_prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lv_first := a_other.lv_first
			lv_last := a_other.lv_last
			lv_refcount := a_other.lv_refcount
			lv_len := a_other.lv_len
			lv_watch := a_other.lv_watch
			lv_idx := a_other.lv_idx
			lv_idx_item := a_other.lv_idx_item
			lv_copyID := a_other.lv_copyID
			lv_copylist := a_other.lv_copylist
			lv_lock := a_other.lv_lock
			lv_used_next := a_other.lv_used_next
			lv_used_prev := a_other.lv_used_prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lv_first.is_equal (a_other.lv_first) and
				lv_last.is_equal (a_other.lv_last) and
				lv_refcount = a_other.lv_refcount and
				lv_len = a_other.lv_len and
				lv_watch.is_equal (a_other.lv_watch) and
				lv_idx = a_other.lv_idx and
				lv_idx_item.is_equal (a_other.lv_idx_item) and
				lv_copyID = a_other.lv_copyID and
				lv_copylist.is_equal (a_other.lv_copylist) and
				lv_lock = a_other.lv_lock and
				lv_used_next.is_equal (a_other.lv_used_next) and
				lv_used_prev.is_equal (a_other.lv_used_prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lv_first"),
					create {CE_STRUCTURE_FIELD}.make ("lv_last"),
					create {CE_STRUCTURE_FIELD}.make ("lv_refcount"),
					create {CE_STRUCTURE_FIELD}.make ("lv_len"),
					create {CE_STRUCTURE_FIELD}.make ("lv_watch"),
					create {CE_STRUCTURE_FIELD}.make ("lv_idx"),
					create {CE_STRUCTURE_FIELD}.make ("lv_idx_item"),
					create {CE_STRUCTURE_FIELD}.make ("lv_copyID"),
					create {CE_STRUCTURE_FIELD}.make ("lv_copylist"),
					create {CE_STRUCTURE_FIELD}.make ("lv_lock"),
					create {CE_STRUCTURE_FIELD}.make ("lv_used_next"),
					create {CE_STRUCTURE_FIELD}.make ("lv_used_prev")
				>>)
			init_structure_info
		end

end
