class
	PD_MAPBLOCK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create m_next.make
			create m_keys.make
			create m_str.make
		end

feature {ANY} -- fields

	m_next: CE_POINTER [PD_MAPBLOCK] assign set_m_next

	m_keys: CE_POINTER [NATURAL_8] assign set_m_keys

	m_keylen: INTEGER_32 assign set_m_keylen

	m_str: CE_POINTER [NATURAL_8] assign set_m_str

	m_mode: INTEGER_32 assign set_m_mode

	m_noremap: INTEGER_32 assign set_m_noremap

	m_silent: INTEGER_8 assign set_m_silent

	m_expr: INTEGER_8 assign set_m_expr

	m_script_ID: INTEGER_32 assign set_m_script_ID

feature {ANY} -- setters

	set_m_next (a_m_next: CE_POINTER [PD_MAPBLOCK])
		do
			m_next := a_m_next
			update_memory_field ("m_next")
		end

	set_m_keys (a_m_keys: CE_POINTER [NATURAL_8])
		do
			m_keys := a_m_keys
			update_memory_field ("m_keys")
		end

	set_m_keylen (a_m_keylen: INTEGER_32)
		do
			m_keylen := a_m_keylen
			update_memory_field ("m_keylen")
		end

	set_m_str (a_m_str: CE_POINTER [NATURAL_8])
		do
			m_str := a_m_str
			update_memory_field ("m_str")
		end

	set_m_mode (a_m_mode: INTEGER_32)
		do
			m_mode := a_m_mode
			update_memory_field ("m_mode")
		end

	set_m_noremap (a_m_noremap: INTEGER_32)
		do
			m_noremap := a_m_noremap
			update_memory_field ("m_noremap")
		end

	set_m_silent (a_m_silent: INTEGER_8)
		do
			m_silent := a_m_silent
			update_memory_field ("m_silent")
		end

	set_m_expr (a_m_expr: INTEGER_8)
		do
			m_expr := a_m_expr
			update_memory_field ("m_expr")
		end

	set_m_script_ID (a_m_script_ID: INTEGER_32)
		do
			m_script_ID := a_m_script_ID
			update_memory_field ("m_script_ID")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			m_next := a_other.m_next
			m_keys := a_other.m_keys
			m_keylen := a_other.m_keylen
			m_str := a_other.m_str
			m_mode := a_other.m_mode
			m_noremap := a_other.m_noremap
			m_silent := a_other.m_silent
			m_expr := a_other.m_expr
			m_script_ID := a_other.m_script_ID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				m_next.is_equal (a_other.m_next) and
				m_keys.is_equal (a_other.m_keys) and
				m_keylen = a_other.m_keylen and
				m_str.is_equal (a_other.m_str) and
				m_mode = a_other.m_mode and
				m_noremap = a_other.m_noremap and
				m_silent = a_other.m_silent and
				m_expr = a_other.m_expr and
				m_script_ID = a_other.m_script_ID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("m_next"),
					create {CE_STRUCTURE_FIELD}.make ("m_keys"),
					create {CE_STRUCTURE_FIELD}.make ("m_keylen"),
					create {CE_STRUCTURE_FIELD}.make ("m_str"),
					create {CE_STRUCTURE_FIELD}.make ("m_mode"),
					create {CE_STRUCTURE_FIELD}.make ("m_noremap"),
					create {CE_STRUCTURE_FIELD}.make ("m_silent"),
					create {CE_STRUCTURE_FIELD}.make ("m_expr"),
					create {CE_STRUCTURE_FIELD}.make ("m_script_ID")
				>>)
			init_structure_info
		end

end
