class
	PD_MATCHINF_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mi_lp.make
			create mi_word.make
			create mi_end.make
			create mi_fend.make
			create mi_cend.make
			create mi_fword.make (<<251>>)
			create mi_compflags.make (<<250>>)
			create mi_win.make
			create mi_end2.make
		end

feature {ANY} -- fields

	mi_lp: CE_POINTER [PD_LANGP_S] assign set_mi_lp

	mi_word: CE_POINTER [NATURAL_8] assign set_mi_word

	mi_end: CE_POINTER [NATURAL_8] assign set_mi_end

	mi_fend: CE_POINTER [NATURAL_8] assign set_mi_fend

	mi_cend: CE_POINTER [NATURAL_8] assign set_mi_cend

	mi_fword: CE_ARRAY [NATURAL_8]

	mi_fwordlen: INTEGER_32 assign set_mi_fwordlen

	mi_prefarridx: INTEGER_32 assign set_mi_prefarridx

	mi_prefcnt: INTEGER_32 assign set_mi_prefcnt

	mi_prefixlen: INTEGER_32 assign set_mi_prefixlen

	mi_cprefixlen: INTEGER_32 assign set_mi_cprefixlen

	mi_compoff: INTEGER_32 assign set_mi_compoff

	mi_compflags: CE_ARRAY [NATURAL_8]

	mi_complen: INTEGER_32 assign set_mi_complen

	mi_compextra: INTEGER_32 assign set_mi_compextra

	mi_result: INTEGER_32 assign set_mi_result

	mi_capflags: INTEGER_32 assign set_mi_capflags

	mi_win: CE_POINTER [PD_WINDOW_S] assign set_mi_win

	mi_result2: INTEGER_32 assign set_mi_result2

	mi_end2: CE_POINTER [NATURAL_8] assign set_mi_end2

feature {ANY} -- setters

	set_mi_lp (a_mi_lp: CE_POINTER [PD_LANGP_S])
		do
			mi_lp := a_mi_lp
			update_memory_field ("mi_lp")
		end

	set_mi_word (a_mi_word: CE_POINTER [NATURAL_8])
		do
			mi_word := a_mi_word
			update_memory_field ("mi_word")
		end

	set_mi_end (a_mi_end: CE_POINTER [NATURAL_8])
		do
			mi_end := a_mi_end
			update_memory_field ("mi_end")
		end

	set_mi_fend (a_mi_fend: CE_POINTER [NATURAL_8])
		do
			mi_fend := a_mi_fend
			update_memory_field ("mi_fend")
		end

	set_mi_cend (a_mi_cend: CE_POINTER [NATURAL_8])
		do
			mi_cend := a_mi_cend
			update_memory_field ("mi_cend")
		end

	set_mi_fwordlen (a_mi_fwordlen: INTEGER_32)
		do
			mi_fwordlen := a_mi_fwordlen
			update_memory_field ("mi_fwordlen")
		end

	set_mi_prefarridx (a_mi_prefarridx: INTEGER_32)
		do
			mi_prefarridx := a_mi_prefarridx
			update_memory_field ("mi_prefarridx")
		end

	set_mi_prefcnt (a_mi_prefcnt: INTEGER_32)
		do
			mi_prefcnt := a_mi_prefcnt
			update_memory_field ("mi_prefcnt")
		end

	set_mi_prefixlen (a_mi_prefixlen: INTEGER_32)
		do
			mi_prefixlen := a_mi_prefixlen
			update_memory_field ("mi_prefixlen")
		end

	set_mi_cprefixlen (a_mi_cprefixlen: INTEGER_32)
		do
			mi_cprefixlen := a_mi_cprefixlen
			update_memory_field ("mi_cprefixlen")
		end

	set_mi_compoff (a_mi_compoff: INTEGER_32)
		do
			mi_compoff := a_mi_compoff
			update_memory_field ("mi_compoff")
		end

	set_mi_complen (a_mi_complen: INTEGER_32)
		do
			mi_complen := a_mi_complen
			update_memory_field ("mi_complen")
		end

	set_mi_compextra (a_mi_compextra: INTEGER_32)
		do
			mi_compextra := a_mi_compextra
			update_memory_field ("mi_compextra")
		end

	set_mi_result (a_mi_result: INTEGER_32)
		do
			mi_result := a_mi_result
			update_memory_field ("mi_result")
		end

	set_mi_capflags (a_mi_capflags: INTEGER_32)
		do
			mi_capflags := a_mi_capflags
			update_memory_field ("mi_capflags")
		end

	set_mi_win (a_mi_win: CE_POINTER [PD_WINDOW_S])
		do
			mi_win := a_mi_win
			update_memory_field ("mi_win")
		end

	set_mi_result2 (a_mi_result2: INTEGER_32)
		do
			mi_result2 := a_mi_result2
			update_memory_field ("mi_result2")
		end

	set_mi_end2 (a_mi_end2: CE_POINTER [NATURAL_8])
		do
			mi_end2 := a_mi_end2
			update_memory_field ("mi_end2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mi_lp := a_other.mi_lp
			mi_word := a_other.mi_word
			mi_end := a_other.mi_end
			mi_fend := a_other.mi_fend
			mi_cend := a_other.mi_cend
			mi_fword := a_other.mi_fword.twin
			mi_fwordlen := a_other.mi_fwordlen
			mi_prefarridx := a_other.mi_prefarridx
			mi_prefcnt := a_other.mi_prefcnt
			mi_prefixlen := a_other.mi_prefixlen
			mi_cprefixlen := a_other.mi_cprefixlen
			mi_compoff := a_other.mi_compoff
			mi_compflags := a_other.mi_compflags.twin
			mi_complen := a_other.mi_complen
			mi_compextra := a_other.mi_compextra
			mi_result := a_other.mi_result
			mi_capflags := a_other.mi_capflags
			mi_win := a_other.mi_win
			mi_result2 := a_other.mi_result2
			mi_end2 := a_other.mi_end2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mi_lp.is_equal (a_other.mi_lp) and
				mi_word.is_equal (a_other.mi_word) and
				mi_end.is_equal (a_other.mi_end) and
				mi_fend.is_equal (a_other.mi_fend) and
				mi_cend.is_equal (a_other.mi_cend) and
				mi_fword.is_equal (a_other.mi_fword) and
				mi_fwordlen = a_other.mi_fwordlen and
				mi_prefarridx = a_other.mi_prefarridx and
				mi_prefcnt = a_other.mi_prefcnt and
				mi_prefixlen = a_other.mi_prefixlen and
				mi_cprefixlen = a_other.mi_cprefixlen and
				mi_compoff = a_other.mi_compoff and
				mi_compflags.is_equal (a_other.mi_compflags) and
				mi_complen = a_other.mi_complen and
				mi_compextra = a_other.mi_compextra and
				mi_result = a_other.mi_result and
				mi_capflags = a_other.mi_capflags and
				mi_win.is_equal (a_other.mi_win) and
				mi_result2 = a_other.mi_result2 and
				mi_end2.is_equal (a_other.mi_end2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mi_lp"),
					create {CE_STRUCTURE_FIELD}.make ("mi_word"),
					create {CE_STRUCTURE_FIELD}.make ("mi_end"),
					create {CE_STRUCTURE_FIELD}.make ("mi_fend"),
					create {CE_STRUCTURE_FIELD}.make ("mi_cend"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mi_fword", <<251>>),
					create {CE_STRUCTURE_FIELD}.make ("mi_fwordlen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_prefarridx"),
					create {CE_STRUCTURE_FIELD}.make ("mi_prefcnt"),
					create {CE_STRUCTURE_FIELD}.make ("mi_prefixlen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_cprefixlen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_compoff"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mi_compflags", <<250>>),
					create {CE_STRUCTURE_FIELD}.make ("mi_complen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_compextra"),
					create {CE_STRUCTURE_FIELD}.make ("mi_result"),
					create {CE_STRUCTURE_FIELD}.make ("mi_capflags"),
					create {CE_STRUCTURE_FIELD}.make ("mi_win"),
					create {CE_STRUCTURE_FIELD}.make ("mi_result2"),
					create {CE_STRUCTURE_FIELD}.make ("mi_end2")
				>>)
			init_structure_info
		end

end
