class
	PD_MEMFILE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mf_fname.make
			create mf_ffname.make
			create mf_free_first.make
			create mf_used_first.make
			create mf_used_last.make
			create mf_hash.make (<<64>>)
			create mf_trans.make (<<64>>)
			create mf_buffer.make
			create mf_seed.make (<<8>>)
			create mf_old_key.make
			create mf_old_seed.make (<<8>>)
		end

feature {ANY} -- fields

	mf_fname: CE_POINTER [NATURAL_8] assign set_mf_fname

	mf_ffname: CE_POINTER [NATURAL_8] assign set_mf_ffname

	mf_fd: INTEGER_32 assign set_mf_fd

	mf_free_first: CE_POINTER [PD_BLOCK_HDR] assign set_mf_free_first

	mf_used_first: CE_POINTER [PD_BLOCK_HDR] assign set_mf_used_first

	mf_used_last: CE_POINTER [PD_BLOCK_HDR] assign set_mf_used_last

	mf_used_count: NATURAL_32 assign set_mf_used_count

	mf_used_count_max: NATURAL_32 assign set_mf_used_count_max

	mf_hash: CE_ARRAY [CE_POINTER [PD_BLOCK_HDR]]

	mf_trans: CE_ARRAY [CE_POINTER [PD_NR_TRANS]]

	mf_blocknr_max: INTEGER_32 assign set_mf_blocknr_max

	mf_blocknr_min: INTEGER_32 assign set_mf_blocknr_min

	mf_neg_count: INTEGER_32 assign set_mf_neg_count

	mf_infile_count: INTEGER_32 assign set_mf_infile_count

	mf_page_size: NATURAL_32 assign set_mf_page_size

	mf_dirty: INTEGER_32 assign set_mf_dirty

	mf_buffer: CE_POINTER [PD_FILE_BUFFER] assign set_mf_buffer

	mf_seed: CE_ARRAY [NATURAL_8]

	mf_old_key: CE_POINTER [NATURAL_8] assign set_mf_old_key

	mf_old_cm: INTEGER_32 assign set_mf_old_cm

	mf_old_seed: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_mf_fname (a_mf_fname: CE_POINTER [NATURAL_8])
		do
			mf_fname := a_mf_fname
			update_memory_field ("mf_fname")
		end

	set_mf_ffname (a_mf_ffname: CE_POINTER [NATURAL_8])
		do
			mf_ffname := a_mf_ffname
			update_memory_field ("mf_ffname")
		end

	set_mf_fd (a_mf_fd: INTEGER_32)
		do
			mf_fd := a_mf_fd
			update_memory_field ("mf_fd")
		end

	set_mf_free_first (a_mf_free_first: CE_POINTER [PD_BLOCK_HDR])
		do
			mf_free_first := a_mf_free_first
			update_memory_field ("mf_free_first")
		end

	set_mf_used_first (a_mf_used_first: CE_POINTER [PD_BLOCK_HDR])
		do
			mf_used_first := a_mf_used_first
			update_memory_field ("mf_used_first")
		end

	set_mf_used_last (a_mf_used_last: CE_POINTER [PD_BLOCK_HDR])
		do
			mf_used_last := a_mf_used_last
			update_memory_field ("mf_used_last")
		end

	set_mf_used_count (a_mf_used_count: NATURAL_32)
		do
			mf_used_count := a_mf_used_count
			update_memory_field ("mf_used_count")
		end

	set_mf_used_count_max (a_mf_used_count_max: NATURAL_32)
		do
			mf_used_count_max := a_mf_used_count_max
			update_memory_field ("mf_used_count_max")
		end

	set_mf_blocknr_max (a_mf_blocknr_max: INTEGER_32)
		do
			mf_blocknr_max := a_mf_blocknr_max
			update_memory_field ("mf_blocknr_max")
		end

	set_mf_blocknr_min (a_mf_blocknr_min: INTEGER_32)
		do
			mf_blocknr_min := a_mf_blocknr_min
			update_memory_field ("mf_blocknr_min")
		end

	set_mf_neg_count (a_mf_neg_count: INTEGER_32)
		do
			mf_neg_count := a_mf_neg_count
			update_memory_field ("mf_neg_count")
		end

	set_mf_infile_count (a_mf_infile_count: INTEGER_32)
		do
			mf_infile_count := a_mf_infile_count
			update_memory_field ("mf_infile_count")
		end

	set_mf_page_size (a_mf_page_size: NATURAL_32)
		do
			mf_page_size := a_mf_page_size
			update_memory_field ("mf_page_size")
		end

	set_mf_dirty (a_mf_dirty: INTEGER_32)
		do
			mf_dirty := a_mf_dirty
			update_memory_field ("mf_dirty")
		end

	set_mf_buffer (a_mf_buffer: CE_POINTER [PD_FILE_BUFFER])
		do
			mf_buffer := a_mf_buffer
			update_memory_field ("mf_buffer")
		end

	set_mf_old_key (a_mf_old_key: CE_POINTER [NATURAL_8])
		do
			mf_old_key := a_mf_old_key
			update_memory_field ("mf_old_key")
		end

	set_mf_old_cm (a_mf_old_cm: INTEGER_32)
		do
			mf_old_cm := a_mf_old_cm
			update_memory_field ("mf_old_cm")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mf_fname := a_other.mf_fname
			mf_ffname := a_other.mf_ffname
			mf_fd := a_other.mf_fd
			mf_free_first := a_other.mf_free_first
			mf_used_first := a_other.mf_used_first
			mf_used_last := a_other.mf_used_last
			mf_used_count := a_other.mf_used_count
			mf_used_count_max := a_other.mf_used_count_max
			mf_hash := a_other.mf_hash.twin
			mf_trans := a_other.mf_trans.twin
			mf_blocknr_max := a_other.mf_blocknr_max
			mf_blocknr_min := a_other.mf_blocknr_min
			mf_neg_count := a_other.mf_neg_count
			mf_infile_count := a_other.mf_infile_count
			mf_page_size := a_other.mf_page_size
			mf_dirty := a_other.mf_dirty
			mf_buffer := a_other.mf_buffer
			mf_seed := a_other.mf_seed.twin
			mf_old_key := a_other.mf_old_key
			mf_old_cm := a_other.mf_old_cm
			mf_old_seed := a_other.mf_old_seed.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mf_fname.is_equal (a_other.mf_fname) and
				mf_ffname.is_equal (a_other.mf_ffname) and
				mf_fd = a_other.mf_fd and
				mf_free_first.is_equal (a_other.mf_free_first) and
				mf_used_first.is_equal (a_other.mf_used_first) and
				mf_used_last.is_equal (a_other.mf_used_last) and
				mf_used_count = a_other.mf_used_count and
				mf_used_count_max = a_other.mf_used_count_max and
				mf_hash.is_equal (a_other.mf_hash) and
				mf_trans.is_equal (a_other.mf_trans) and
				mf_blocknr_max = a_other.mf_blocknr_max and
				mf_blocknr_min = a_other.mf_blocknr_min and
				mf_neg_count = a_other.mf_neg_count and
				mf_infile_count = a_other.mf_infile_count and
				mf_page_size = a_other.mf_page_size and
				mf_dirty = a_other.mf_dirty and
				mf_buffer.is_equal (a_other.mf_buffer) and
				mf_seed.is_equal (a_other.mf_seed) and
				mf_old_key.is_equal (a_other.mf_old_key) and
				mf_old_cm = a_other.mf_old_cm and
				mf_old_seed.is_equal (a_other.mf_old_seed)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mf_fname"),
					create {CE_STRUCTURE_FIELD}.make ("mf_ffname"),
					create {CE_STRUCTURE_FIELD}.make ("mf_fd"),
					create {CE_STRUCTURE_FIELD}.make ("mf_free_first"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_first"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_last"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_count"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_count_max"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_hash", <<64>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_trans", <<64>>),
					create {CE_STRUCTURE_FIELD}.make ("mf_blocknr_max"),
					create {CE_STRUCTURE_FIELD}.make ("mf_blocknr_min"),
					create {CE_STRUCTURE_FIELD}.make ("mf_neg_count"),
					create {CE_STRUCTURE_FIELD}.make ("mf_infile_count"),
					create {CE_STRUCTURE_FIELD}.make ("mf_page_size"),
					create {CE_STRUCTURE_FIELD}.make ("mf_dirty"),
					create {CE_STRUCTURE_FIELD}.make ("mf_buffer"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_seed", <<8>>),
					create {CE_STRUCTURE_FIELD}.make ("mf_old_key"),
					create {CE_STRUCTURE_FIELD}.make ("mf_old_cm"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_old_seed", <<8>>)
				>>)
			init_structure_info
		end

end
