class
	PD_MPARM_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create argv.make
			create use_vimrc.make
			create commands.make (<<10>>)
			create cmds_tofree.make (<<10>>)
			create pre_commands.make (<<10>>)
			create tagname.make
			create use_ef.make
			create term.make
			create serverName_arg.make
			create serverStr.make
			create serverStrEnc.make
			create servername.make
		end

feature {ANY} -- fields

	argc: INTEGER_32 assign set_argc

	argv: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_argv

	evim_mode: INTEGER_32 assign set_evim_mode

	use_vimrc: CE_POINTER [NATURAL_8] assign set_use_vimrc

	n_commands: INTEGER_32 assign set_n_commands

	commands: CE_ARRAY [CE_POINTER [NATURAL_8]]

	cmds_tofree: CE_ARRAY [NATURAL_8]

	n_pre_commands: INTEGER_32 assign set_n_pre_commands

	pre_commands: CE_ARRAY [CE_POINTER [NATURAL_8]]

	edit_type: INTEGER_32 assign set_edit_type

	tagname: CE_POINTER [NATURAL_8] assign set_tagname

	use_ef: CE_POINTER [NATURAL_8] assign set_use_ef

	want_full_screen: INTEGER_32 assign set_want_full_screen

	stdout_isatty: INTEGER_32 assign set_stdout_isatty

	term: CE_POINTER [NATURAL_8] assign set_term

	ask_for_key: INTEGER_32 assign set_ask_for_key

	no_swap_file: INTEGER_32 assign set_no_swap_file

	use_debug_break_level: INTEGER_32 assign set_use_debug_break_level

	window_count: INTEGER_32 assign set_window_count

	window_layout: INTEGER_32 assign set_window_layout

	serverArg: INTEGER_32 assign set_serverArg

	serverName_arg: CE_POINTER [NATURAL_8] assign set_serverName_arg

	serverStr: CE_POINTER [NATURAL_8] assign set_serverStr

	serverStrEnc: CE_POINTER [NATURAL_8] assign set_serverStrEnc

	servername: CE_POINTER [NATURAL_8] assign set_servername

	diff_mode: INTEGER_32 assign set_diff_mode

feature {ANY} -- setters

	set_argc (a_argc: INTEGER_32)
		do
			argc := a_argc
			update_memory_field ("argc")
		end

	set_argv (a_argv: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			argv := a_argv
			update_memory_field ("argv")
		end

	set_evim_mode (a_evim_mode: INTEGER_32)
		do
			evim_mode := a_evim_mode
			update_memory_field ("evim_mode")
		end

	set_use_vimrc (a_use_vimrc: CE_POINTER [NATURAL_8])
		do
			use_vimrc := a_use_vimrc
			update_memory_field ("use_vimrc")
		end

	set_n_commands (a_n_commands: INTEGER_32)
		do
			n_commands := a_n_commands
			update_memory_field ("n_commands")
		end

	set_n_pre_commands (a_n_pre_commands: INTEGER_32)
		do
			n_pre_commands := a_n_pre_commands
			update_memory_field ("n_pre_commands")
		end

	set_edit_type (a_edit_type: INTEGER_32)
		do
			edit_type := a_edit_type
			update_memory_field ("edit_type")
		end

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			tagname := a_tagname
			update_memory_field ("tagname")
		end

	set_use_ef (a_use_ef: CE_POINTER [NATURAL_8])
		do
			use_ef := a_use_ef
			update_memory_field ("use_ef")
		end

	set_want_full_screen (a_want_full_screen: INTEGER_32)
		do
			want_full_screen := a_want_full_screen
			update_memory_field ("want_full_screen")
		end

	set_stdout_isatty (a_stdout_isatty: INTEGER_32)
		do
			stdout_isatty := a_stdout_isatty
			update_memory_field ("stdout_isatty")
		end

	set_term (a_term: CE_POINTER [NATURAL_8])
		do
			term := a_term
			update_memory_field ("term")
		end

	set_ask_for_key (a_ask_for_key: INTEGER_32)
		do
			ask_for_key := a_ask_for_key
			update_memory_field ("ask_for_key")
		end

	set_no_swap_file (a_no_swap_file: INTEGER_32)
		do
			no_swap_file := a_no_swap_file
			update_memory_field ("no_swap_file")
		end

	set_use_debug_break_level (a_use_debug_break_level: INTEGER_32)
		do
			use_debug_break_level := a_use_debug_break_level
			update_memory_field ("use_debug_break_level")
		end

	set_window_count (a_window_count: INTEGER_32)
		do
			window_count := a_window_count
			update_memory_field ("window_count")
		end

	set_window_layout (a_window_layout: INTEGER_32)
		do
			window_layout := a_window_layout
			update_memory_field ("window_layout")
		end

	set_serverArg (a_serverArg: INTEGER_32)
		do
			serverArg := a_serverArg
			update_memory_field ("serverArg")
		end

	set_serverName_arg (a_serverName_arg: CE_POINTER [NATURAL_8])
		do
			serverName_arg := a_serverName_arg
			update_memory_field ("serverName_arg")
		end

	set_serverStr (a_serverStr: CE_POINTER [NATURAL_8])
		do
			serverStr := a_serverStr
			update_memory_field ("serverStr")
		end

	set_serverStrEnc (a_serverStrEnc: CE_POINTER [NATURAL_8])
		do
			serverStrEnc := a_serverStrEnc
			update_memory_field ("serverStrEnc")
		end

	set_servername (a_servername: CE_POINTER [NATURAL_8])
		do
			servername := a_servername
			update_memory_field ("servername")
		end

	set_diff_mode (a_diff_mode: INTEGER_32)
		do
			diff_mode := a_diff_mode
			update_memory_field ("diff_mode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			argc := a_other.argc
			argv := a_other.argv
			evim_mode := a_other.evim_mode
			use_vimrc := a_other.use_vimrc
			n_commands := a_other.n_commands
			commands := a_other.commands.twin
			cmds_tofree := a_other.cmds_tofree.twin
			n_pre_commands := a_other.n_pre_commands
			pre_commands := a_other.pre_commands.twin
			edit_type := a_other.edit_type
			tagname := a_other.tagname
			use_ef := a_other.use_ef
			want_full_screen := a_other.want_full_screen
			stdout_isatty := a_other.stdout_isatty
			term := a_other.term
			ask_for_key := a_other.ask_for_key
			no_swap_file := a_other.no_swap_file
			use_debug_break_level := a_other.use_debug_break_level
			window_count := a_other.window_count
			window_layout := a_other.window_layout
			serverArg := a_other.serverArg
			serverName_arg := a_other.serverName_arg
			serverStr := a_other.serverStr
			serverStrEnc := a_other.serverStrEnc
			servername := a_other.servername
			diff_mode := a_other.diff_mode
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				argc = a_other.argc and
				argv.is_equal (a_other.argv) and
				evim_mode = a_other.evim_mode and
				use_vimrc.is_equal (a_other.use_vimrc) and
				n_commands = a_other.n_commands and
				commands.is_equal (a_other.commands) and
				cmds_tofree.is_equal (a_other.cmds_tofree) and
				n_pre_commands = a_other.n_pre_commands and
				pre_commands.is_equal (a_other.pre_commands) and
				edit_type = a_other.edit_type and
				tagname.is_equal (a_other.tagname) and
				use_ef.is_equal (a_other.use_ef) and
				want_full_screen = a_other.want_full_screen and
				stdout_isatty = a_other.stdout_isatty and
				term.is_equal (a_other.term) and
				ask_for_key = a_other.ask_for_key and
				no_swap_file = a_other.no_swap_file and
				use_debug_break_level = a_other.use_debug_break_level and
				window_count = a_other.window_count and
				window_layout = a_other.window_layout and
				serverArg = a_other.serverArg and
				serverName_arg.is_equal (a_other.serverName_arg) and
				serverStr.is_equal (a_other.serverStr) and
				serverStrEnc.is_equal (a_other.serverStrEnc) and
				servername.is_equal (a_other.servername) and
				diff_mode = a_other.diff_mode
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("argc"),
					create {CE_STRUCTURE_FIELD}.make ("argv"),
					create {CE_STRUCTURE_FIELD}.make ("evim_mode"),
					create {CE_STRUCTURE_FIELD}.make ("use_vimrc"),
					create {CE_STRUCTURE_FIELD}.make ("n_commands"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("commands", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cmds_tofree", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("n_pre_commands"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pre_commands", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("edit_type"),
					create {CE_STRUCTURE_FIELD}.make ("tagname"),
					create {CE_STRUCTURE_FIELD}.make ("use_ef"),
					create {CE_STRUCTURE_FIELD}.make ("want_full_screen"),
					create {CE_STRUCTURE_FIELD}.make ("stdout_isatty"),
					create {CE_STRUCTURE_FIELD}.make ("term"),
					create {CE_STRUCTURE_FIELD}.make ("ask_for_key"),
					create {CE_STRUCTURE_FIELD}.make ("no_swap_file"),
					create {CE_STRUCTURE_FIELD}.make ("use_debug_break_level"),
					create {CE_STRUCTURE_FIELD}.make ("window_count"),
					create {CE_STRUCTURE_FIELD}.make ("window_layout"),
					create {CE_STRUCTURE_FIELD}.make ("serverArg"),
					create {CE_STRUCTURE_FIELD}.make ("serverName_arg"),
					create {CE_STRUCTURE_FIELD}.make ("serverStr"),
					create {CE_STRUCTURE_FIELD}.make ("serverStrEnc"),
					create {CE_STRUCTURE_FIELD}.make ("servername"),
					create {CE_STRUCTURE_FIELD}.make ("diff_mode")
				>>)
			init_structure_info
		end

end
