class
	PD_MSGCHUNK_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sb_next.make
			create sb_prev.make
			create sb_text.make (<<1>>)
		end

feature {ANY} -- fields

	sb_next: CE_POINTER [PD_MSGCHUNK_S] assign set_sb_next

	sb_prev: CE_POINTER [PD_MSGCHUNK_S] assign set_sb_prev

	sb_eol: INTEGER_8 assign set_sb_eol

	sb_msg_col: INTEGER_32 assign set_sb_msg_col

	sb_attr: INTEGER_32 assign set_sb_attr

	sb_text: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_sb_next (a_sb_next: CE_POINTER [PD_MSGCHUNK_S])
		do
			sb_next := a_sb_next
			update_memory_field ("sb_next")
		end

	set_sb_prev (a_sb_prev: CE_POINTER [PD_MSGCHUNK_S])
		do
			sb_prev := a_sb_prev
			update_memory_field ("sb_prev")
		end

	set_sb_eol (a_sb_eol: INTEGER_8)
		do
			sb_eol := a_sb_eol
			update_memory_field ("sb_eol")
		end

	set_sb_msg_col (a_sb_msg_col: INTEGER_32)
		do
			sb_msg_col := a_sb_msg_col
			update_memory_field ("sb_msg_col")
		end

	set_sb_attr (a_sb_attr: INTEGER_32)
		do
			sb_attr := a_sb_attr
			update_memory_field ("sb_attr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sb_next := a_other.sb_next
			sb_prev := a_other.sb_prev
			sb_eol := a_other.sb_eol
			sb_msg_col := a_other.sb_msg_col
			sb_attr := a_other.sb_attr
			sb_text := a_other.sb_text.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sb_next.is_equal (a_other.sb_next) and
				sb_prev.is_equal (a_other.sb_prev) and
				sb_eol = a_other.sb_eol and
				sb_msg_col = a_other.sb_msg_col and
				sb_attr = a_other.sb_attr and
				sb_text.is_equal (a_other.sb_text)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sb_next"),
					create {CE_STRUCTURE_FIELD}.make ("sb_prev"),
					create {CE_STRUCTURE_FIELD}.make ("sb_eol"),
					create {CE_STRUCTURE_FIELD}.make ("sb_msg_col"),
					create {CE_STRUCTURE_FIELD}.make ("sb_attr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sb_text", <<1>>)
				>>)
			init_structure_info
		end

end
