class
	PD_POINTER_ENTRY

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	pe_bnum: INTEGER_32 assign set_pe_bnum

	pe_line_count: INTEGER_32 assign set_pe_line_count

	pe_old_lnum: INTEGER_32 assign set_pe_old_lnum

	pe_page_count: INTEGER_32 assign set_pe_page_count

feature {ANY} -- setters

	set_pe_bnum (a_pe_bnum: INTEGER_32)
		do
			pe_bnum := a_pe_bnum
			update_memory_field ("pe_bnum")
		end

	set_pe_line_count (a_pe_line_count: INTEGER_32)
		do
			pe_line_count := a_pe_line_count
			update_memory_field ("pe_line_count")
		end

	set_pe_old_lnum (a_pe_old_lnum: INTEGER_32)
		do
			pe_old_lnum := a_pe_old_lnum
			update_memory_field ("pe_old_lnum")
		end

	set_pe_page_count (a_pe_page_count: INTEGER_32)
		do
			pe_page_count := a_pe_page_count
			update_memory_field ("pe_page_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pe_bnum := a_other.pe_bnum
			pe_line_count := a_other.pe_line_count
			pe_old_lnum := a_other.pe_old_lnum
			pe_page_count := a_other.pe_page_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pe_bnum = a_other.pe_bnum and
				pe_line_count = a_other.pe_line_count and
				pe_old_lnum = a_other.pe_old_lnum and
				pe_page_count = a_other.pe_page_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pe_bnum"),
					create {CE_STRUCTURE_FIELD}.make ("pe_line_count"),
					create {CE_STRUCTURE_FIELD}.make ("pe_old_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("pe_page_count")
				>>)
			init_structure_info
		end

end
