class
	PD_PRT_PS_ENCODING_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create encoding.make
			create cmap_encoding.make
		end

feature {ANY} -- fields

	encoding: CE_POINTER [INTEGER_8] assign set_encoding

	cmap_encoding: CE_POINTER [INTEGER_8] assign set_cmap_encoding

	needs_charset: INTEGER_32 assign set_needs_charset

feature {ANY} -- setters

	set_encoding (a_encoding: CE_POINTER [INTEGER_8])
		do
			encoding := a_encoding
			update_memory_field ("encoding")
		end

	set_cmap_encoding (a_cmap_encoding: CE_POINTER [INTEGER_8])
		do
			cmap_encoding := a_cmap_encoding
			update_memory_field ("cmap_encoding")
		end

	set_needs_charset (a_needs_charset: INTEGER_32)
		do
			needs_charset := a_needs_charset
			update_memory_field ("needs_charset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			encoding := a_other.encoding
			cmap_encoding := a_other.cmap_encoding
			needs_charset := a_other.needs_charset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				encoding.is_equal (a_other.encoding) and
				cmap_encoding.is_equal (a_other.cmap_encoding) and
				needs_charset = a_other.needs_charset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("encoding"),
					create {CE_STRUCTURE_FIELD}.make ("cmap_encoding"),
					create {CE_STRUCTURE_FIELD}.make ("needs_charset")
				>>)
			init_structure_info
		end

end
