class
	PD_PRT_PS_FONT_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ps_fontname.make (<<4>>)
		end

feature {ANY} -- fields

	wx: INTEGER_32 assign set_wx

	uline_offset: INTEGER_32 assign set_uline_offset

	uline_width: INTEGER_32 assign set_uline_width

	bbox_min_y: INTEGER_32 assign set_bbox_min_y

	bbox_max_y: INTEGER_32 assign set_bbox_max_y

	ps_fontname: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- setters

	set_wx (a_wx: INTEGER_32)
		do
			wx := a_wx
			update_memory_field ("wx")
		end

	set_uline_offset (a_uline_offset: INTEGER_32)
		do
			uline_offset := a_uline_offset
			update_memory_field ("uline_offset")
		end

	set_uline_width (a_uline_width: INTEGER_32)
		do
			uline_width := a_uline_width
			update_memory_field ("uline_width")
		end

	set_bbox_min_y (a_bbox_min_y: INTEGER_32)
		do
			bbox_min_y := a_bbox_min_y
			update_memory_field ("bbox_min_y")
		end

	set_bbox_max_y (a_bbox_max_y: INTEGER_32)
		do
			bbox_max_y := a_bbox_max_y
			update_memory_field ("bbox_max_y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wx := a_other.wx
			uline_offset := a_other.uline_offset
			uline_width := a_other.uline_width
			bbox_min_y := a_other.bbox_min_y
			bbox_max_y := a_other.bbox_max_y
			ps_fontname := a_other.ps_fontname.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wx = a_other.wx and
				uline_offset = a_other.uline_offset and
				uline_width = a_other.uline_width and
				bbox_min_y = a_other.bbox_min_y and
				bbox_max_y = a_other.bbox_max_y and
				ps_fontname.is_equal (a_other.ps_fontname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wx"),
					create {CE_STRUCTURE_FIELD}.make ("uline_offset"),
					create {CE_STRUCTURE_FIELD}.make ("uline_width"),
					create {CE_STRUCTURE_FIELD}.make ("bbox_min_y"),
					create {CE_STRUCTURE_FIELD}.make ("bbox_max_y"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ps_fontname", <<4>>)
				>>)
			init_structure_info
		end

end
