class
	PD_PRT_RESFILE_BUFFER_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buffer.make (<<2_048>>)
		end

feature {ANY} -- fields

	buffer: CE_ARRAY [NATURAL_8]

	len: INTEGER_32 assign set_len

	line_start: INTEGER_32 assign set_line_start

	line_end: INTEGER_32 assign set_line_end

feature {ANY} -- setters

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_line_start (a_line_start: INTEGER_32)
		do
			line_start := a_line_start
			update_memory_field ("line_start")
		end

	set_line_end (a_line_end: INTEGER_32)
		do
			line_end := a_line_end
			update_memory_field ("line_end")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer.twin
			len := a_other.len
			line_start := a_other.line_start
			line_end := a_other.line_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				len = a_other.len and
				line_start = a_other.line_start and
				line_end = a_other.line_end
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<2_048>>),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("line_start"),
					create {CE_STRUCTURE_FIELD}.make ("line_end")
				>>)
			init_structure_info
		end

end
