class
	PD_PRT_TEXT_ATTR_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	fg_color: NATURAL_32 assign set_fg_color

	bg_color: NATURAL_32 assign set_bg_color

	bold: INTEGER_32 assign set_bold

	italic: INTEGER_32 assign set_italic

	underline: INTEGER_32 assign set_underline

	undercurl: INTEGER_32 assign set_undercurl

feature {ANY} -- setters

	set_fg_color (a_fg_color: NATURAL_32)
		do
			fg_color := a_fg_color
			update_memory_field ("fg_color")
		end

	set_bg_color (a_bg_color: NATURAL_32)
		do
			bg_color := a_bg_color
			update_memory_field ("bg_color")
		end

	set_bold (a_bold: INTEGER_32)
		do
			bold := a_bold
			update_memory_field ("bold")
		end

	set_italic (a_italic: INTEGER_32)
		do
			italic := a_italic
			update_memory_field ("italic")
		end

	set_underline (a_underline: INTEGER_32)
		do
			underline := a_underline
			update_memory_field ("underline")
		end

	set_undercurl (a_undercurl: INTEGER_32)
		do
			undercurl := a_undercurl
			update_memory_field ("undercurl")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fg_color := a_other.fg_color
			bg_color := a_other.bg_color
			bold := a_other.bold
			italic := a_other.italic
			underline := a_other.underline
			undercurl := a_other.undercurl
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fg_color = a_other.fg_color and
				bg_color = a_other.bg_color and
				bold = a_other.bold and
				italic = a_other.italic and
				underline = a_other.underline and
				undercurl = a_other.undercurl
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fg_color"),
					create {CE_STRUCTURE_FIELD}.make ("bg_color"),
					create {CE_STRUCTURE_FIELD}.make ("bold"),
					create {CE_STRUCTURE_FIELD}.make ("italic"),
					create {CE_STRUCTURE_FIELD}.make ("underline"),
					create {CE_STRUCTURE_FIELD}.make ("undercurl")
				>>)
			init_structure_info
		end

end
