class
	PD_PUMITEM_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pum_text.make
			create pum_kind.make
			create pum_extra.make
			create pum_info.make
		end

feature {ANY} -- fields

	pum_text: CE_POINTER [NATURAL_8] assign set_pum_text

	pum_kind: CE_POINTER [NATURAL_8] assign set_pum_kind

	pum_extra: CE_POINTER [NATURAL_8] assign set_pum_extra

	pum_info: CE_POINTER [NATURAL_8] assign set_pum_info

feature {ANY} -- setters

	set_pum_text (a_pum_text: CE_POINTER [NATURAL_8])
		do
			pum_text := a_pum_text
			update_memory_field ("pum_text")
		end

	set_pum_kind (a_pum_kind: CE_POINTER [NATURAL_8])
		do
			pum_kind := a_pum_kind
			update_memory_field ("pum_kind")
		end

	set_pum_extra (a_pum_extra: CE_POINTER [NATURAL_8])
		do
			pum_extra := a_pum_extra
			update_memory_field ("pum_extra")
		end

	set_pum_info (a_pum_info: CE_POINTER [NATURAL_8])
		do
			pum_info := a_pum_info
			update_memory_field ("pum_info")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pum_text := a_other.pum_text
			pum_kind := a_other.pum_kind
			pum_extra := a_other.pum_extra
			pum_info := a_other.pum_info
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pum_text.is_equal (a_other.pum_text) and
				pum_kind.is_equal (a_other.pum_kind) and
				pum_extra.is_equal (a_other.pum_extra) and
				pum_info.is_equal (a_other.pum_info)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pum_text"),
					create {CE_STRUCTURE_FIELD}.make ("pum_kind"),
					create {CE_STRUCTURE_FIELD}.make ("pum_extra"),
					create {CE_STRUCTURE_FIELD}.make ("pum_info")
				>>)
			init_structure_info
		end

end
