class
	PD_QF_INFO_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create qf_lists.make (<<10>>)
		end

feature {ANY} -- fields

	qf_refcount: INTEGER_32 assign set_qf_refcount

	qf_listcount: INTEGER_32 assign set_qf_listcount

	qf_curlist: INTEGER_32 assign set_qf_curlist

	qf_lists: CE_ARRAY [PD_QF_LIST_S]

feature {ANY} -- setters

	set_qf_refcount (a_qf_refcount: INTEGER_32)
		do
			qf_refcount := a_qf_refcount
			update_memory_field ("qf_refcount")
		end

	set_qf_listcount (a_qf_listcount: INTEGER_32)
		do
			qf_listcount := a_qf_listcount
			update_memory_field ("qf_listcount")
		end

	set_qf_curlist (a_qf_curlist: INTEGER_32)
		do
			qf_curlist := a_qf_curlist
			update_memory_field ("qf_curlist")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			qf_refcount := a_other.qf_refcount
			qf_listcount := a_other.qf_listcount
			qf_curlist := a_other.qf_curlist
			qf_lists := a_other.qf_lists.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				qf_refcount = a_other.qf_refcount and
				qf_listcount = a_other.qf_listcount and
				qf_curlist = a_other.qf_curlist and
				qf_lists.is_equal (a_other.qf_lists)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("qf_refcount"),
					create {CE_STRUCTURE_FIELD}.make ("qf_listcount"),
					create {CE_STRUCTURE_FIELD}.make ("qf_curlist"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("qf_lists", <<10>>)
				>>)
			init_structure_info
		end

end
