class
	PD_REGBEHIND_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create save_after.make
			create save_behind.make
			create save_start.make (<<10>>)
			create save_end.make (<<10>>)
		end

feature {ANY} -- fields

	save_after: PD_REGSAVE_T assign set_save_after

	save_behind: PD_REGSAVE_T assign set_save_behind

	save_need_clear_subexpr: INTEGER_32 assign set_save_need_clear_subexpr

	save_start: CE_ARRAY [PD_SAVE_SE_T]

	save_end: CE_ARRAY [PD_SAVE_SE_T]

feature {ANY} -- setters

	set_save_after (a_save_after: PD_REGSAVE_T)
		do
			save_after := a_save_after
			update_memory_field ("save_after")
		end

	set_save_behind (a_save_behind: PD_REGSAVE_T)
		do
			save_behind := a_save_behind
			update_memory_field ("save_behind")
		end

	set_save_need_clear_subexpr (a_save_need_clear_subexpr: INTEGER_32)
		do
			save_need_clear_subexpr := a_save_need_clear_subexpr
			update_memory_field ("save_need_clear_subexpr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			save_after := a_other.save_after.twin
			save_behind := a_other.save_behind.twin
			save_need_clear_subexpr := a_other.save_need_clear_subexpr
			save_start := a_other.save_start.twin
			save_end := a_other.save_end.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				save_after.is_equal (a_other.save_after) and
				save_behind.is_equal (a_other.save_behind) and
				save_need_clear_subexpr = a_other.save_need_clear_subexpr and
				save_start.is_equal (a_other.save_start) and
				save_end.is_equal (a_other.save_end)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("save_after"),
					create {CE_STRUCTURE_FIELD}.make ("save_behind"),
					create {CE_STRUCTURE_FIELD}.make ("save_need_clear_subexpr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("save_start", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("save_end", <<10>>)
				>>)
			init_structure_info
		end

end
