class
	PD_REGMATCH_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create regprog.make
			create startp.make (<<10>>)
			create endp.make (<<10>>)
		end

feature {ANY} -- fields

	regprog: CE_POINTER [PD_REGPROG_T] assign set_regprog

	startp: CE_ARRAY [CE_POINTER [NATURAL_8]]

	endp: CE_ARRAY [CE_POINTER [NATURAL_8]]

	rm_ic: INTEGER_32 assign set_rm_ic

feature {ANY} -- setters

	set_regprog (a_regprog: CE_POINTER [PD_REGPROG_T])
		do
			regprog := a_regprog
			update_memory_field ("regprog")
		end

	set_rm_ic (a_rm_ic: INTEGER_32)
		do
			rm_ic := a_rm_ic
			update_memory_field ("rm_ic")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			regprog := a_other.regprog
			startp := a_other.startp.twin
			endp := a_other.endp.twin
			rm_ic := a_other.rm_ic
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				regprog.is_equal (a_other.regprog) and
				startp.is_equal (a_other.startp) and
				endp.is_equal (a_other.endp) and
				rm_ic = a_other.rm_ic
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("regprog"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("startp", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("endp", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("rm_ic")
				>>)
			init_structure_info
		end

end
