class
	PD_REGPROG_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create regmust.make
			create program.make (<<1>>)
		end

feature {ANY} -- fields

	regstart: INTEGER_32 assign set_regstart

	reganch: NATURAL_8 assign set_reganch

	regmust: CE_POINTER [NATURAL_8] assign set_regmust

	regmlen: INTEGER_32 assign set_regmlen

	regflags: NATURAL_32 assign set_regflags

	reghasz: NATURAL_8 assign set_reghasz

	program: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_regstart (a_regstart: INTEGER_32)
		do
			regstart := a_regstart
			update_memory_field ("regstart")
		end

	set_reganch (a_reganch: NATURAL_8)
		do
			reganch := a_reganch
			update_memory_field ("reganch")
		end

	set_regmust (a_regmust: CE_POINTER [NATURAL_8])
		do
			regmust := a_regmust
			update_memory_field ("regmust")
		end

	set_regmlen (a_regmlen: INTEGER_32)
		do
			regmlen := a_regmlen
			update_memory_field ("regmlen")
		end

	set_regflags (a_regflags: NATURAL_32)
		do
			regflags := a_regflags
			update_memory_field ("regflags")
		end

	set_reghasz (a_reghasz: NATURAL_8)
		do
			reghasz := a_reghasz
			update_memory_field ("reghasz")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			regstart := a_other.regstart
			reganch := a_other.reganch
			regmust := a_other.regmust
			regmlen := a_other.regmlen
			regflags := a_other.regflags
			reghasz := a_other.reghasz
			program := a_other.program.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				regstart = a_other.regstart and
				reganch = a_other.reganch and
				regmust.is_equal (a_other.regmust) and
				regmlen = a_other.regmlen and
				regflags = a_other.regflags and
				reghasz = a_other.reghasz and
				program.is_equal (a_other.program)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("regstart"),
					create {CE_STRUCTURE_FIELD}.make ("reganch"),
					create {CE_STRUCTURE_FIELD}.make ("regmust"),
					create {CE_STRUCTURE_FIELD}.make ("regmlen"),
					create {CE_STRUCTURE_FIELD}.make ("regflags"),
					create {CE_STRUCTURE_FIELD}.make ("reghasz"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("program", <<1>>)
				>>)
			init_structure_info
		end

end
