class
	PD_SCRIPTVAR_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sv_var.make
			create sv_dict.make
		end

feature {ANY} -- fields

	sv_var: PD_DICTITEM_S assign set_sv_var

	sv_dict: PD_DICTVAR_S assign set_sv_dict

feature {ANY} -- setters

	set_sv_var (a_sv_var: PD_DICTITEM_S)
		do
			sv_var := a_sv_var
			update_memory_field ("sv_var")
		end

	set_sv_dict (a_sv_dict: PD_DICTVAR_S)
		do
			sv_dict := a_sv_dict
			update_memory_field ("sv_dict")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sv_var := a_other.sv_var.twin
			sv_dict := a_other.sv_dict.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sv_var.is_equal (a_other.sv_var) and
				sv_dict.is_equal (a_other.sv_dict)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sv_var"),
					create {CE_STRUCTURE_FIELD}.make ("sv_dict")
				>>)
			init_structure_info
		end

end
