class
	PD_SE_U

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	ptr: CE_POINTER [NATURAL_8] assign set_ptr

	pos: PD_LPOS_T assign set_pos

feature {ANY} -- setters

	set_ptr (a_ptr: CE_POINTER [NATURAL_8])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_pos (a_pos: PD_LPOS_T)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ptr := a_other.ptr
			pos := a_other.pos.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ptr.is_equal (a_other.ptr) and
				pos.is_equal (a_other.pos)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("pos")
				>>)
			init_structure_info
		end

end
