class
	PD_SIGNLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
		end

feature {ANY} -- fields

	id: INTEGER_32 assign set_id

	lnum: INTEGER_32 assign set_lnum

	typenr: INTEGER_32 assign set_typenr

	next: CE_POINTER [PD_SIGNLIST] assign set_next

	prev: CE_POINTER [PD_SIGNLIST] assign set_prev

feature {ANY} -- setters

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_typenr (a_typenr: INTEGER_32)
		do
			typenr := a_typenr
			update_memory_field ("typenr")
		end

	set_next (a_next: CE_POINTER [PD_SIGNLIST])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_SIGNLIST])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			id := a_other.id
			lnum := a_other.lnum
			typenr := a_other.typenr
			next := a_other.next
			prev := a_other.prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				id = a_other.id and
				lnum = a_other.lnum and
				typenr = a_other.typenr and
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("typenr"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev")
				>>)
			init_structure_info
		end

end
