class
	PD_SPELLINFO_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create si_foldroot.make
			create si_keeproot.make
			create si_prefroot.make
			create si_blocks.make
			create si_first_free.make
			create si_spellbuf.make
			create si_conv.make
			create si_info.make
			create si_region_name.make (<<16>>)
			create si_rep.make
			create si_repsal.make
			create si_sal.make
			create si_sofofr.make
			create si_sofoto.make
			create si_commonwords.make
			create si_map.make
			create si_midword.make
			create si_comppat.make
			create si_compflags.make
			create si_syllable.make
			create si_prefcond.make
		end

feature {ANY} -- fields

	si_foldroot: CE_POINTER [PD_WORDNODE_S] assign set_si_foldroot

	si_foldwcount: INTEGER_32 assign set_si_foldwcount

	si_keeproot: CE_POINTER [PD_WORDNODE_S] assign set_si_keeproot

	si_keepwcount: INTEGER_32 assign set_si_keepwcount

	si_prefroot: CE_POINTER [PD_WORDNODE_S] assign set_si_prefroot

	si_sugtree: INTEGER_32 assign set_si_sugtree

	si_blocks: CE_POINTER [PD_SBLOCK_S] assign set_si_blocks

	si_blocks_cnt: INTEGER_32 assign set_si_blocks_cnt

	si_compress_cnt: INTEGER_32 assign set_si_compress_cnt

	si_first_free: CE_POINTER [PD_WORDNODE_S] assign set_si_first_free

	si_free_count: INTEGER_32 assign set_si_free_count

	si_spellbuf: CE_POINTER [PD_FILE_BUFFER] assign set_si_spellbuf

	si_ascii: INTEGER_32 assign set_si_ascii

	si_add: INTEGER_32 assign set_si_add

	si_clear_chartab: INTEGER_32 assign set_si_clear_chartab

	si_region: INTEGER_32 assign set_si_region

	si_conv: PD_VIMCONV_T assign set_si_conv

	si_memtot: INTEGER_32 assign set_si_memtot

	si_verbose: INTEGER_32 assign set_si_verbose

	si_msg_count: INTEGER_32 assign set_si_msg_count

	si_info: CE_POINTER [NATURAL_8] assign set_si_info

	si_region_count: INTEGER_32 assign set_si_region_count

	si_region_name: CE_ARRAY [NATURAL_8]

	si_rep: PD_GROWARRAY assign set_si_rep

	si_repsal: PD_GROWARRAY assign set_si_repsal

	si_sal: PD_GROWARRAY assign set_si_sal

	si_sofofr: CE_POINTER [NATURAL_8] assign set_si_sofofr

	si_sofoto: CE_POINTER [NATURAL_8] assign set_si_sofoto

	si_nosugfile: INTEGER_32 assign set_si_nosugfile

	si_nosplitsugs: INTEGER_32 assign set_si_nosplitsugs

	si_followup: INTEGER_32 assign set_si_followup

	si_collapse: INTEGER_32 assign set_si_collapse

	si_commonwords: PD_HASHTABLE_S assign set_si_commonwords

	si_sugtime: INTEGER_32 assign set_si_sugtime

	si_rem_accents: INTEGER_32 assign set_si_rem_accents

	si_map: PD_GROWARRAY assign set_si_map

	si_midword: CE_POINTER [NATURAL_8] assign set_si_midword

	si_compmax: INTEGER_32 assign set_si_compmax

	si_compminlen: INTEGER_32 assign set_si_compminlen

	si_compsylmax: INTEGER_32 assign set_si_compsylmax

	si_compoptions: INTEGER_32 assign set_si_compoptions

	si_comppat: PD_GROWARRAY assign set_si_comppat

	si_compflags: CE_POINTER [NATURAL_8] assign set_si_compflags

	si_nobreak: NATURAL_8 assign set_si_nobreak

	si_syllable: CE_POINTER [NATURAL_8] assign set_si_syllable

	si_prefcond: PD_GROWARRAY assign set_si_prefcond

	si_newprefID: INTEGER_32 assign set_si_newprefID

	si_newcompID: INTEGER_32 assign set_si_newcompID

feature {ANY} -- setters

	set_si_foldroot (a_si_foldroot: CE_POINTER [PD_WORDNODE_S])
		do
			si_foldroot := a_si_foldroot
			update_memory_field ("si_foldroot")
		end

	set_si_foldwcount (a_si_foldwcount: INTEGER_32)
		do
			si_foldwcount := a_si_foldwcount
			update_memory_field ("si_foldwcount")
		end

	set_si_keeproot (a_si_keeproot: CE_POINTER [PD_WORDNODE_S])
		do
			si_keeproot := a_si_keeproot
			update_memory_field ("si_keeproot")
		end

	set_si_keepwcount (a_si_keepwcount: INTEGER_32)
		do
			si_keepwcount := a_si_keepwcount
			update_memory_field ("si_keepwcount")
		end

	set_si_prefroot (a_si_prefroot: CE_POINTER [PD_WORDNODE_S])
		do
			si_prefroot := a_si_prefroot
			update_memory_field ("si_prefroot")
		end

	set_si_sugtree (a_si_sugtree: INTEGER_32)
		do
			si_sugtree := a_si_sugtree
			update_memory_field ("si_sugtree")
		end

	set_si_blocks (a_si_blocks: CE_POINTER [PD_SBLOCK_S])
		do
			si_blocks := a_si_blocks
			update_memory_field ("si_blocks")
		end

	set_si_blocks_cnt (a_si_blocks_cnt: INTEGER_32)
		do
			si_blocks_cnt := a_si_blocks_cnt
			update_memory_field ("si_blocks_cnt")
		end

	set_si_compress_cnt (a_si_compress_cnt: INTEGER_32)
		do
			si_compress_cnt := a_si_compress_cnt
			update_memory_field ("si_compress_cnt")
		end

	set_si_first_free (a_si_first_free: CE_POINTER [PD_WORDNODE_S])
		do
			si_first_free := a_si_first_free
			update_memory_field ("si_first_free")
		end

	set_si_free_count (a_si_free_count: INTEGER_32)
		do
			si_free_count := a_si_free_count
			update_memory_field ("si_free_count")
		end

	set_si_spellbuf (a_si_spellbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			si_spellbuf := a_si_spellbuf
			update_memory_field ("si_spellbuf")
		end

	set_si_ascii (a_si_ascii: INTEGER_32)
		do
			si_ascii := a_si_ascii
			update_memory_field ("si_ascii")
		end

	set_si_add (a_si_add: INTEGER_32)
		do
			si_add := a_si_add
			update_memory_field ("si_add")
		end

	set_si_clear_chartab (a_si_clear_chartab: INTEGER_32)
		do
			si_clear_chartab := a_si_clear_chartab
			update_memory_field ("si_clear_chartab")
		end

	set_si_region (a_si_region: INTEGER_32)
		do
			si_region := a_si_region
			update_memory_field ("si_region")
		end

	set_si_conv (a_si_conv: PD_VIMCONV_T)
		do
			si_conv := a_si_conv
			update_memory_field ("si_conv")
		end

	set_si_memtot (a_si_memtot: INTEGER_32)
		do
			si_memtot := a_si_memtot
			update_memory_field ("si_memtot")
		end

	set_si_verbose (a_si_verbose: INTEGER_32)
		do
			si_verbose := a_si_verbose
			update_memory_field ("si_verbose")
		end

	set_si_msg_count (a_si_msg_count: INTEGER_32)
		do
			si_msg_count := a_si_msg_count
			update_memory_field ("si_msg_count")
		end

	set_si_info (a_si_info: CE_POINTER [NATURAL_8])
		do
			si_info := a_si_info
			update_memory_field ("si_info")
		end

	set_si_region_count (a_si_region_count: INTEGER_32)
		do
			si_region_count := a_si_region_count
			update_memory_field ("si_region_count")
		end

	set_si_rep (a_si_rep: PD_GROWARRAY)
		do
			si_rep := a_si_rep
			update_memory_field ("si_rep")
		end

	set_si_repsal (a_si_repsal: PD_GROWARRAY)
		do
			si_repsal := a_si_repsal
			update_memory_field ("si_repsal")
		end

	set_si_sal (a_si_sal: PD_GROWARRAY)
		do
			si_sal := a_si_sal
			update_memory_field ("si_sal")
		end

	set_si_sofofr (a_si_sofofr: CE_POINTER [NATURAL_8])
		do
			si_sofofr := a_si_sofofr
			update_memory_field ("si_sofofr")
		end

	set_si_sofoto (a_si_sofoto: CE_POINTER [NATURAL_8])
		do
			si_sofoto := a_si_sofoto
			update_memory_field ("si_sofoto")
		end

	set_si_nosugfile (a_si_nosugfile: INTEGER_32)
		do
			si_nosugfile := a_si_nosugfile
			update_memory_field ("si_nosugfile")
		end

	set_si_nosplitsugs (a_si_nosplitsugs: INTEGER_32)
		do
			si_nosplitsugs := a_si_nosplitsugs
			update_memory_field ("si_nosplitsugs")
		end

	set_si_followup (a_si_followup: INTEGER_32)
		do
			si_followup := a_si_followup
			update_memory_field ("si_followup")
		end

	set_si_collapse (a_si_collapse: INTEGER_32)
		do
			si_collapse := a_si_collapse
			update_memory_field ("si_collapse")
		end

	set_si_commonwords (a_si_commonwords: PD_HASHTABLE_S)
		do
			si_commonwords := a_si_commonwords
			update_memory_field ("si_commonwords")
		end

	set_si_sugtime (a_si_sugtime: INTEGER_32)
		do
			si_sugtime := a_si_sugtime
			update_memory_field ("si_sugtime")
		end

	set_si_rem_accents (a_si_rem_accents: INTEGER_32)
		do
			si_rem_accents := a_si_rem_accents
			update_memory_field ("si_rem_accents")
		end

	set_si_map (a_si_map: PD_GROWARRAY)
		do
			si_map := a_si_map
			update_memory_field ("si_map")
		end

	set_si_midword (a_si_midword: CE_POINTER [NATURAL_8])
		do
			si_midword := a_si_midword
			update_memory_field ("si_midword")
		end

	set_si_compmax (a_si_compmax: INTEGER_32)
		do
			si_compmax := a_si_compmax
			update_memory_field ("si_compmax")
		end

	set_si_compminlen (a_si_compminlen: INTEGER_32)
		do
			si_compminlen := a_si_compminlen
			update_memory_field ("si_compminlen")
		end

	set_si_compsylmax (a_si_compsylmax: INTEGER_32)
		do
			si_compsylmax := a_si_compsylmax
			update_memory_field ("si_compsylmax")
		end

	set_si_compoptions (a_si_compoptions: INTEGER_32)
		do
			si_compoptions := a_si_compoptions
			update_memory_field ("si_compoptions")
		end

	set_si_comppat (a_si_comppat: PD_GROWARRAY)
		do
			si_comppat := a_si_comppat
			update_memory_field ("si_comppat")
		end

	set_si_compflags (a_si_compflags: CE_POINTER [NATURAL_8])
		do
			si_compflags := a_si_compflags
			update_memory_field ("si_compflags")
		end

	set_si_nobreak (a_si_nobreak: NATURAL_8)
		do
			si_nobreak := a_si_nobreak
			update_memory_field ("si_nobreak")
		end

	set_si_syllable (a_si_syllable: CE_POINTER [NATURAL_8])
		do
			si_syllable := a_si_syllable
			update_memory_field ("si_syllable")
		end

	set_si_prefcond (a_si_prefcond: PD_GROWARRAY)
		do
			si_prefcond := a_si_prefcond
			update_memory_field ("si_prefcond")
		end

	set_si_newprefID (a_si_newprefID: INTEGER_32)
		do
			si_newprefID := a_si_newprefID
			update_memory_field ("si_newprefID")
		end

	set_si_newcompID (a_si_newcompID: INTEGER_32)
		do
			si_newcompID := a_si_newcompID
			update_memory_field ("si_newcompID")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_foldroot := a_other.si_foldroot
			si_foldwcount := a_other.si_foldwcount
			si_keeproot := a_other.si_keeproot
			si_keepwcount := a_other.si_keepwcount
			si_prefroot := a_other.si_prefroot
			si_sugtree := a_other.si_sugtree
			si_blocks := a_other.si_blocks
			si_blocks_cnt := a_other.si_blocks_cnt
			si_compress_cnt := a_other.si_compress_cnt
			si_first_free := a_other.si_first_free
			si_free_count := a_other.si_free_count
			si_spellbuf := a_other.si_spellbuf
			si_ascii := a_other.si_ascii
			si_add := a_other.si_add
			si_clear_chartab := a_other.si_clear_chartab
			si_region := a_other.si_region
			si_conv := a_other.si_conv.twin
			si_memtot := a_other.si_memtot
			si_verbose := a_other.si_verbose
			si_msg_count := a_other.si_msg_count
			si_info := a_other.si_info
			si_region_count := a_other.si_region_count
			si_region_name := a_other.si_region_name.twin
			si_rep := a_other.si_rep.twin
			si_repsal := a_other.si_repsal.twin
			si_sal := a_other.si_sal.twin
			si_sofofr := a_other.si_sofofr
			si_sofoto := a_other.si_sofoto
			si_nosugfile := a_other.si_nosugfile
			si_nosplitsugs := a_other.si_nosplitsugs
			si_followup := a_other.si_followup
			si_collapse := a_other.si_collapse
			si_commonwords := a_other.si_commonwords.twin
			si_sugtime := a_other.si_sugtime
			si_rem_accents := a_other.si_rem_accents
			si_map := a_other.si_map.twin
			si_midword := a_other.si_midword
			si_compmax := a_other.si_compmax
			si_compminlen := a_other.si_compminlen
			si_compsylmax := a_other.si_compsylmax
			si_compoptions := a_other.si_compoptions
			si_comppat := a_other.si_comppat.twin
			si_compflags := a_other.si_compflags
			si_nobreak := a_other.si_nobreak
			si_syllable := a_other.si_syllable
			si_prefcond := a_other.si_prefcond.twin
			si_newprefID := a_other.si_newprefID
			si_newcompID := a_other.si_newcompID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_foldroot.is_equal (a_other.si_foldroot) and
				si_foldwcount = a_other.si_foldwcount and
				si_keeproot.is_equal (a_other.si_keeproot) and
				si_keepwcount = a_other.si_keepwcount and
				si_prefroot.is_equal (a_other.si_prefroot) and
				si_sugtree = a_other.si_sugtree and
				si_blocks.is_equal (a_other.si_blocks) and
				si_blocks_cnt = a_other.si_blocks_cnt and
				si_compress_cnt = a_other.si_compress_cnt and
				si_first_free.is_equal (a_other.si_first_free) and
				si_free_count = a_other.si_free_count and
				si_spellbuf.is_equal (a_other.si_spellbuf) and
				si_ascii = a_other.si_ascii and
				si_add = a_other.si_add and
				si_clear_chartab = a_other.si_clear_chartab and
				si_region = a_other.si_region and
				si_conv.is_equal (a_other.si_conv) and
				si_memtot = a_other.si_memtot and
				si_verbose = a_other.si_verbose and
				si_msg_count = a_other.si_msg_count and
				si_info.is_equal (a_other.si_info) and
				si_region_count = a_other.si_region_count and
				si_region_name.is_equal (a_other.si_region_name) and
				si_rep.is_equal (a_other.si_rep) and
				si_repsal.is_equal (a_other.si_repsal) and
				si_sal.is_equal (a_other.si_sal) and
				si_sofofr.is_equal (a_other.si_sofofr) and
				si_sofoto.is_equal (a_other.si_sofoto) and
				si_nosugfile = a_other.si_nosugfile and
				si_nosplitsugs = a_other.si_nosplitsugs and
				si_followup = a_other.si_followup and
				si_collapse = a_other.si_collapse and
				si_commonwords.is_equal (a_other.si_commonwords) and
				si_sugtime = a_other.si_sugtime and
				si_rem_accents = a_other.si_rem_accents and
				si_map.is_equal (a_other.si_map) and
				si_midword.is_equal (a_other.si_midword) and
				si_compmax = a_other.si_compmax and
				si_compminlen = a_other.si_compminlen and
				si_compsylmax = a_other.si_compsylmax and
				si_compoptions = a_other.si_compoptions and
				si_comppat.is_equal (a_other.si_comppat) and
				si_compflags.is_equal (a_other.si_compflags) and
				si_nobreak = a_other.si_nobreak and
				si_syllable.is_equal (a_other.si_syllable) and
				si_prefcond.is_equal (a_other.si_prefcond) and
				si_newprefID = a_other.si_newprefID and
				si_newcompID = a_other.si_newcompID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_foldroot"),
					create {CE_STRUCTURE_FIELD}.make ("si_foldwcount"),
					create {CE_STRUCTURE_FIELD}.make ("si_keeproot"),
					create {CE_STRUCTURE_FIELD}.make ("si_keepwcount"),
					create {CE_STRUCTURE_FIELD}.make ("si_prefroot"),
					create {CE_STRUCTURE_FIELD}.make ("si_sugtree"),
					create {CE_STRUCTURE_FIELD}.make ("si_blocks"),
					create {CE_STRUCTURE_FIELD}.make ("si_blocks_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("si_compress_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("si_first_free"),
					create {CE_STRUCTURE_FIELD}.make ("si_free_count"),
					create {CE_STRUCTURE_FIELD}.make ("si_spellbuf"),
					create {CE_STRUCTURE_FIELD}.make ("si_ascii"),
					create {CE_STRUCTURE_FIELD}.make ("si_add"),
					create {CE_STRUCTURE_FIELD}.make ("si_clear_chartab"),
					create {CE_STRUCTURE_FIELD}.make ("si_region"),
					create {CE_STRUCTURE_FIELD}.make ("si_conv"),
					create {CE_STRUCTURE_FIELD}.make ("si_memtot"),
					create {CE_STRUCTURE_FIELD}.make ("si_verbose"),
					create {CE_STRUCTURE_FIELD}.make ("si_msg_count"),
					create {CE_STRUCTURE_FIELD}.make ("si_info"),
					create {CE_STRUCTURE_FIELD}.make ("si_region_count"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("si_region_name", <<16>>),
					create {CE_STRUCTURE_FIELD}.make ("si_rep"),
					create {CE_STRUCTURE_FIELD}.make ("si_repsal"),
					create {CE_STRUCTURE_FIELD}.make ("si_sal"),
					create {CE_STRUCTURE_FIELD}.make ("si_sofofr"),
					create {CE_STRUCTURE_FIELD}.make ("si_sofoto"),
					create {CE_STRUCTURE_FIELD}.make ("si_nosugfile"),
					create {CE_STRUCTURE_FIELD}.make ("si_nosplitsugs"),
					create {CE_STRUCTURE_FIELD}.make ("si_followup"),
					create {CE_STRUCTURE_FIELD}.make ("si_collapse"),
					create {CE_STRUCTURE_FIELD}.make ("si_commonwords"),
					create {CE_STRUCTURE_FIELD}.make ("si_sugtime"),
					create {CE_STRUCTURE_FIELD}.make ("si_rem_accents"),
					create {CE_STRUCTURE_FIELD}.make ("si_map"),
					create {CE_STRUCTURE_FIELD}.make ("si_midword"),
					create {CE_STRUCTURE_FIELD}.make ("si_compmax"),
					create {CE_STRUCTURE_FIELD}.make ("si_compminlen"),
					create {CE_STRUCTURE_FIELD}.make ("si_compsylmax"),
					create {CE_STRUCTURE_FIELD}.make ("si_compoptions"),
					create {CE_STRUCTURE_FIELD}.make ("si_comppat"),
					create {CE_STRUCTURE_FIELD}.make ("si_compflags"),
					create {CE_STRUCTURE_FIELD}.make ("si_nobreak"),
					create {CE_STRUCTURE_FIELD}.make ("si_syllable"),
					create {CE_STRUCTURE_FIELD}.make ("si_prefcond"),
					create {CE_STRUCTURE_FIELD}.make ("si_newprefID"),
					create {CE_STRUCTURE_FIELD}.make ("si_newcompID")
				>>)
			init_structure_info
		end

end
