class
	PD_SST_UNION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	sst_stack: CE_ARRAY [PD_BUF_STATE]

	sst_ga: PD_GROWARRAY assign set_sst_ga

feature {ANY} -- setters

	set_sst_ga (a_sst_ga: PD_GROWARRAY)
		do
			sst_ga := a_sst_ga
			update_memory_field ("sst_ga")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sst_stack := a_other.sst_stack.twin
			sst_ga := a_other.sst_ga.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sst_stack.is_equal (a_other.sst_stack) and
				sst_ga.is_equal (a_other.sst_ga)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sst_stack", <<7>>),
					create {CE_STRUCTURE_FIELD}.make ("sst_ga")
				>>)
			init_structure_info
		end

end
