class
	PD_SUGGEST_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create st_word.make
			create st_slang.make
		end

feature {ANY} -- fields

	st_word: CE_POINTER [NATURAL_8] assign set_st_word

	st_wordlen: INTEGER_32 assign set_st_wordlen

	st_orglen: INTEGER_32 assign set_st_orglen

	st_score: INTEGER_32 assign set_st_score

	st_altscore: INTEGER_32 assign set_st_altscore

	st_salscore: INTEGER_32 assign set_st_salscore

	st_had_bonus: INTEGER_32 assign set_st_had_bonus

	st_slang: CE_POINTER [PD_SLANG_S] assign set_st_slang

feature {ANY} -- setters

	set_st_word (a_st_word: CE_POINTER [NATURAL_8])
		do
			st_word := a_st_word
			update_memory_field ("st_word")
		end

	set_st_wordlen (a_st_wordlen: INTEGER_32)
		do
			st_wordlen := a_st_wordlen
			update_memory_field ("st_wordlen")
		end

	set_st_orglen (a_st_orglen: INTEGER_32)
		do
			st_orglen := a_st_orglen
			update_memory_field ("st_orglen")
		end

	set_st_score (a_st_score: INTEGER_32)
		do
			st_score := a_st_score
			update_memory_field ("st_score")
		end

	set_st_altscore (a_st_altscore: INTEGER_32)
		do
			st_altscore := a_st_altscore
			update_memory_field ("st_altscore")
		end

	set_st_salscore (a_st_salscore: INTEGER_32)
		do
			st_salscore := a_st_salscore
			update_memory_field ("st_salscore")
		end

	set_st_had_bonus (a_st_had_bonus: INTEGER_32)
		do
			st_had_bonus := a_st_had_bonus
			update_memory_field ("st_had_bonus")
		end

	set_st_slang (a_st_slang: CE_POINTER [PD_SLANG_S])
		do
			st_slang := a_st_slang
			update_memory_field ("st_slang")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			st_word := a_other.st_word
			st_wordlen := a_other.st_wordlen
			st_orglen := a_other.st_orglen
			st_score := a_other.st_score
			st_altscore := a_other.st_altscore
			st_salscore := a_other.st_salscore
			st_had_bonus := a_other.st_had_bonus
			st_slang := a_other.st_slang
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				st_word.is_equal (a_other.st_word) and
				st_wordlen = a_other.st_wordlen and
				st_orglen = a_other.st_orglen and
				st_score = a_other.st_score and
				st_altscore = a_other.st_altscore and
				st_salscore = a_other.st_salscore and
				st_had_bonus = a_other.st_had_bonus and
				st_slang.is_equal (a_other.st_slang)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("st_word"),
					create {CE_STRUCTURE_FIELD}.make ("st_wordlen"),
					create {CE_STRUCTURE_FIELD}.make ("st_orglen"),
					create {CE_STRUCTURE_FIELD}.make ("st_score"),
					create {CE_STRUCTURE_FIELD}.make ("st_altscore"),
					create {CE_STRUCTURE_FIELD}.make ("st_salscore"),
					create {CE_STRUCTURE_FIELD}.make ("st_had_bonus"),
					create {CE_STRUCTURE_FIELD}.make ("st_slang")
				>>)
			init_structure_info
		end

end
