class
	PD_SUGINFO_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create su_ga.make
			create su_sga.make
			create su_badptr.make
			create su_badword.make (<<250>>)
			create su_fbadword.make (<<250>>)
			create su_sal_badword.make (<<250>>)
			create su_banned.make
			create su_sallang.make
		end

feature {ANY} -- fields

	su_ga: PD_GROWARRAY assign set_su_ga

	su_maxcount: INTEGER_32 assign set_su_maxcount

	su_maxscore: INTEGER_32 assign set_su_maxscore

	su_sfmaxscore: INTEGER_32 assign set_su_sfmaxscore

	su_sga: PD_GROWARRAY assign set_su_sga

	su_badptr: CE_POINTER [NATURAL_8] assign set_su_badptr

	su_badlen: INTEGER_32 assign set_su_badlen

	su_badflags: INTEGER_32 assign set_su_badflags

	su_badword: CE_ARRAY [NATURAL_8]

	su_fbadword: CE_ARRAY [NATURAL_8]

	su_sal_badword: CE_ARRAY [NATURAL_8]

	su_banned: PD_HASHTABLE_S assign set_su_banned

	su_sallang: CE_POINTER [PD_SLANG_S] assign set_su_sallang

feature {ANY} -- setters

	set_su_ga (a_su_ga: PD_GROWARRAY)
		do
			su_ga := a_su_ga
			update_memory_field ("su_ga")
		end

	set_su_maxcount (a_su_maxcount: INTEGER_32)
		do
			su_maxcount := a_su_maxcount
			update_memory_field ("su_maxcount")
		end

	set_su_maxscore (a_su_maxscore: INTEGER_32)
		do
			su_maxscore := a_su_maxscore
			update_memory_field ("su_maxscore")
		end

	set_su_sfmaxscore (a_su_sfmaxscore: INTEGER_32)
		do
			su_sfmaxscore := a_su_sfmaxscore
			update_memory_field ("su_sfmaxscore")
		end

	set_su_sga (a_su_sga: PD_GROWARRAY)
		do
			su_sga := a_su_sga
			update_memory_field ("su_sga")
		end

	set_su_badptr (a_su_badptr: CE_POINTER [NATURAL_8])
		do
			su_badptr := a_su_badptr
			update_memory_field ("su_badptr")
		end

	set_su_badlen (a_su_badlen: INTEGER_32)
		do
			su_badlen := a_su_badlen
			update_memory_field ("su_badlen")
		end

	set_su_badflags (a_su_badflags: INTEGER_32)
		do
			su_badflags := a_su_badflags
			update_memory_field ("su_badflags")
		end

	set_su_banned (a_su_banned: PD_HASHTABLE_S)
		do
			su_banned := a_su_banned
			update_memory_field ("su_banned")
		end

	set_su_sallang (a_su_sallang: CE_POINTER [PD_SLANG_S])
		do
			su_sallang := a_su_sallang
			update_memory_field ("su_sallang")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			su_ga := a_other.su_ga.twin
			su_maxcount := a_other.su_maxcount
			su_maxscore := a_other.su_maxscore
			su_sfmaxscore := a_other.su_sfmaxscore
			su_sga := a_other.su_sga.twin
			su_badptr := a_other.su_badptr
			su_badlen := a_other.su_badlen
			su_badflags := a_other.su_badflags
			su_badword := a_other.su_badword.twin
			su_fbadword := a_other.su_fbadword.twin
			su_sal_badword := a_other.su_sal_badword.twin
			su_banned := a_other.su_banned.twin
			su_sallang := a_other.su_sallang
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				su_ga.is_equal (a_other.su_ga) and
				su_maxcount = a_other.su_maxcount and
				su_maxscore = a_other.su_maxscore and
				su_sfmaxscore = a_other.su_sfmaxscore and
				su_sga.is_equal (a_other.su_sga) and
				su_badptr.is_equal (a_other.su_badptr) and
				su_badlen = a_other.su_badlen and
				su_badflags = a_other.su_badflags and
				su_badword.is_equal (a_other.su_badword) and
				su_fbadword.is_equal (a_other.su_fbadword) and
				su_sal_badword.is_equal (a_other.su_sal_badword) and
				su_banned.is_equal (a_other.su_banned) and
				su_sallang.is_equal (a_other.su_sallang)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("su_ga"),
					create {CE_STRUCTURE_FIELD}.make ("su_maxcount"),
					create {CE_STRUCTURE_FIELD}.make ("su_maxscore"),
					create {CE_STRUCTURE_FIELD}.make ("su_sfmaxscore"),
					create {CE_STRUCTURE_FIELD}.make ("su_sga"),
					create {CE_STRUCTURE_FIELD}.make ("su_badptr"),
					create {CE_STRUCTURE_FIELD}.make ("su_badlen"),
					create {CE_STRUCTURE_FIELD}.make ("su_badflags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("su_badword", <<250>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("su_fbadword", <<250>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("su_sal_badword", <<250>>),
					create {CE_STRUCTURE_FIELD}.make ("su_banned"),
					create {CE_STRUCTURE_FIELD}.make ("su_sallang")
				>>)
			init_structure_info
		end

end
