class
	PD_TABPAGE_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create tp_next.make
			create tp_topframe.make
			create tp_curwin.make
			create tp_prevwin.make
			create tp_firstwin.make
			create tp_lastwin.make
			create tp_prev_which_scrollbars.make (<<3>>)
			create tp_first_diff.make
			create tp_diffbuf.make (<<4>>)
			create tp_snapshot.make (<<2>>)
			create tp_winvar.make
			create tp_vars.make
		end

feature {ANY} -- fields

	tp_next: CE_POINTER [PD_TABPAGE_S] assign set_tp_next

	tp_topframe: CE_POINTER [PD_FRAME_S] assign set_tp_topframe

	tp_curwin: CE_POINTER [PD_WINDOW_S] assign set_tp_curwin

	tp_prevwin: CE_POINTER [PD_WINDOW_S] assign set_tp_prevwin

	tp_firstwin: CE_POINTER [PD_WINDOW_S] assign set_tp_firstwin

	tp_lastwin: CE_POINTER [PD_WINDOW_S] assign set_tp_lastwin

	tp_old_Rows: INTEGER_32 assign set_tp_old_Rows

	tp_old_Columns: INTEGER_32 assign set_tp_old_Columns

	tp_ch_used: INTEGER_32 assign set_tp_ch_used

	tp_prev_which_scrollbars: CE_ARRAY [INTEGER_32]

	tp_first_diff: CE_POINTER [PD_DIFFBLOCK_S] assign set_tp_first_diff

	tp_diffbuf: CE_ARRAY [CE_POINTER [PD_FILE_BUFFER]]

	tp_diff_invalid: INTEGER_32 assign set_tp_diff_invalid

	tp_snapshot: CE_ARRAY [CE_POINTER [PD_FRAME_S]]

	tp_winvar: PD_DICTITEM_S assign set_tp_winvar

	tp_vars: PD_DICTVAR_S assign set_tp_vars

feature {ANY} -- setters

	set_tp_next (a_tp_next: CE_POINTER [PD_TABPAGE_S])
		do
			tp_next := a_tp_next
			update_memory_field ("tp_next")
		end

	set_tp_topframe (a_tp_topframe: CE_POINTER [PD_FRAME_S])
		do
			tp_topframe := a_tp_topframe
			update_memory_field ("tp_topframe")
		end

	set_tp_curwin (a_tp_curwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_curwin := a_tp_curwin
			update_memory_field ("tp_curwin")
		end

	set_tp_prevwin (a_tp_prevwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_prevwin := a_tp_prevwin
			update_memory_field ("tp_prevwin")
		end

	set_tp_firstwin (a_tp_firstwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_firstwin := a_tp_firstwin
			update_memory_field ("tp_firstwin")
		end

	set_tp_lastwin (a_tp_lastwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_lastwin := a_tp_lastwin
			update_memory_field ("tp_lastwin")
		end

	set_tp_old_Rows (a_tp_old_Rows: INTEGER_32)
		do
			tp_old_Rows := a_tp_old_Rows
			update_memory_field ("tp_old_Rows")
		end

	set_tp_old_Columns (a_tp_old_Columns: INTEGER_32)
		do
			tp_old_Columns := a_tp_old_Columns
			update_memory_field ("tp_old_Columns")
		end

	set_tp_ch_used (a_tp_ch_used: INTEGER_32)
		do
			tp_ch_used := a_tp_ch_used
			update_memory_field ("tp_ch_used")
		end

	set_tp_first_diff (a_tp_first_diff: CE_POINTER [PD_DIFFBLOCK_S])
		do
			tp_first_diff := a_tp_first_diff
			update_memory_field ("tp_first_diff")
		end

	set_tp_diff_invalid (a_tp_diff_invalid: INTEGER_32)
		do
			tp_diff_invalid := a_tp_diff_invalid
			update_memory_field ("tp_diff_invalid")
		end

	set_tp_winvar (a_tp_winvar: PD_DICTITEM_S)
		do
			tp_winvar := a_tp_winvar
			update_memory_field ("tp_winvar")
		end

	set_tp_vars (a_tp_vars: PD_DICTVAR_S)
		do
			tp_vars := a_tp_vars
			update_memory_field ("tp_vars")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tp_next := a_other.tp_next
			tp_topframe := a_other.tp_topframe
			tp_curwin := a_other.tp_curwin
			tp_prevwin := a_other.tp_prevwin
			tp_firstwin := a_other.tp_firstwin
			tp_lastwin := a_other.tp_lastwin
			tp_old_Rows := a_other.tp_old_Rows
			tp_old_Columns := a_other.tp_old_Columns
			tp_ch_used := a_other.tp_ch_used
			tp_prev_which_scrollbars := a_other.tp_prev_which_scrollbars.twin
			tp_first_diff := a_other.tp_first_diff
			tp_diffbuf := a_other.tp_diffbuf.twin
			tp_diff_invalid := a_other.tp_diff_invalid
			tp_snapshot := a_other.tp_snapshot.twin
			tp_winvar := a_other.tp_winvar.twin
			tp_vars := a_other.tp_vars.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tp_next.is_equal (a_other.tp_next) and
				tp_topframe.is_equal (a_other.tp_topframe) and
				tp_curwin.is_equal (a_other.tp_curwin) and
				tp_prevwin.is_equal (a_other.tp_prevwin) and
				tp_firstwin.is_equal (a_other.tp_firstwin) and
				tp_lastwin.is_equal (a_other.tp_lastwin) and
				tp_old_Rows = a_other.tp_old_Rows and
				tp_old_Columns = a_other.tp_old_Columns and
				tp_ch_used = a_other.tp_ch_used and
				tp_prev_which_scrollbars.is_equal (a_other.tp_prev_which_scrollbars) and
				tp_first_diff.is_equal (a_other.tp_first_diff) and
				tp_diffbuf.is_equal (a_other.tp_diffbuf) and
				tp_diff_invalid = a_other.tp_diff_invalid and
				tp_snapshot.is_equal (a_other.tp_snapshot) and
				tp_winvar.is_equal (a_other.tp_winvar) and
				tp_vars.is_equal (a_other.tp_vars)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tp_next"),
					create {CE_STRUCTURE_FIELD}.make ("tp_topframe"),
					create {CE_STRUCTURE_FIELD}.make ("tp_curwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_prevwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_firstwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_lastwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_old_Rows"),
					create {CE_STRUCTURE_FIELD}.make ("tp_old_Columns"),
					create {CE_STRUCTURE_FIELD}.make ("tp_ch_used"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("tp_prev_which_scrollbars", <<3>>),
					create {CE_STRUCTURE_FIELD}.make ("tp_first_diff"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("tp_diffbuf", <<4>>),
					create {CE_STRUCTURE_FIELD}.make ("tp_diff_invalid"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("tp_snapshot", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("tp_winvar"),
					create {CE_STRUCTURE_FIELD}.make ("tp_vars")
				>>)
			init_structure_info
		end

end
