class
	PD_TAGNAME_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create tn_tags.make
			create tn_np.make
			create tn_search_ctx.make
		end

feature {ANY} -- fields

	tn_tags: CE_POINTER [NATURAL_8] assign set_tn_tags

	tn_np: CE_POINTER [NATURAL_8] assign set_tn_np

	tn_did_filefind_init: INTEGER_32 assign set_tn_did_filefind_init

	tn_hf_idx: INTEGER_32 assign set_tn_hf_idx

	tn_search_ctx: CE_POINTER [ANY] assign set_tn_search_ctx

feature {ANY} -- setters

	set_tn_tags (a_tn_tags: CE_POINTER [NATURAL_8])
		do
			tn_tags := a_tn_tags
			update_memory_field ("tn_tags")
		end

	set_tn_np (a_tn_np: CE_POINTER [NATURAL_8])
		do
			tn_np := a_tn_np
			update_memory_field ("tn_np")
		end

	set_tn_did_filefind_init (a_tn_did_filefind_init: INTEGER_32)
		do
			tn_did_filefind_init := a_tn_did_filefind_init
			update_memory_field ("tn_did_filefind_init")
		end

	set_tn_hf_idx (a_tn_hf_idx: INTEGER_32)
		do
			tn_hf_idx := a_tn_hf_idx
			update_memory_field ("tn_hf_idx")
		end

	set_tn_search_ctx (a_tn_search_ctx: CE_POINTER [ANY])
		do
			tn_search_ctx := a_tn_search_ctx
			update_memory_field ("tn_search_ctx")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tn_tags := a_other.tn_tags
			tn_np := a_other.tn_np
			tn_did_filefind_init := a_other.tn_did_filefind_init
			tn_hf_idx := a_other.tn_hf_idx
			tn_search_ctx := a_other.tn_search_ctx
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tn_tags.is_equal (a_other.tn_tags) and
				tn_np.is_equal (a_other.tn_np) and
				tn_did_filefind_init = a_other.tn_did_filefind_init and
				tn_hf_idx = a_other.tn_hf_idx and
				tn_search_ctx.is_equal (a_other.tn_search_ctx)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tn_tags"),
					create {CE_STRUCTURE_FIELD}.make ("tn_np"),
					create {CE_STRUCTURE_FIELD}.make ("tn_did_filefind_init"),
					create {CE_STRUCTURE_FIELD}.make ("tn_hf_idx"),
					create {CE_STRUCTURE_FIELD}.make ("tn_search_ctx")
				>>)
			init_structure_info
		end

end
