class
	PD_TASAVE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create save_typebuf.make
			create save_stuffbuff.make
			create save_inputbuf.make
		end

feature {ANY} -- fields

	save_typebuf: PD_TYPEBUF_T assign set_save_typebuf

	typebuf_valid: INTEGER_32 assign set_typebuf_valid

	old_char: INTEGER_32 assign set_old_char

	old_mod_mask: INTEGER_32 assign set_old_mod_mask

	save_stuffbuff: PD_BUFFHEADER assign set_save_stuffbuff

	save_inputbuf: CE_POINTER [NATURAL_8] assign set_save_inputbuf

feature {ANY} -- setters

	set_save_typebuf (a_save_typebuf: PD_TYPEBUF_T)
		do
			save_typebuf := a_save_typebuf
			update_memory_field ("save_typebuf")
		end

	set_typebuf_valid (a_typebuf_valid: INTEGER_32)
		do
			typebuf_valid := a_typebuf_valid
			update_memory_field ("typebuf_valid")
		end

	set_old_char (a_old_char: INTEGER_32)
		do
			old_char := a_old_char
			update_memory_field ("old_char")
		end

	set_old_mod_mask (a_old_mod_mask: INTEGER_32)
		do
			old_mod_mask := a_old_mod_mask
			update_memory_field ("old_mod_mask")
		end

	set_save_stuffbuff (a_save_stuffbuff: PD_BUFFHEADER)
		do
			save_stuffbuff := a_save_stuffbuff
			update_memory_field ("save_stuffbuff")
		end

	set_save_inputbuf (a_save_inputbuf: CE_POINTER [NATURAL_8])
		do
			save_inputbuf := a_save_inputbuf
			update_memory_field ("save_inputbuf")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			save_typebuf := a_other.save_typebuf.twin
			typebuf_valid := a_other.typebuf_valid
			old_char := a_other.old_char
			old_mod_mask := a_other.old_mod_mask
			save_stuffbuff := a_other.save_stuffbuff.twin
			save_inputbuf := a_other.save_inputbuf
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				save_typebuf.is_equal (a_other.save_typebuf) and
				typebuf_valid = a_other.typebuf_valid and
				old_char = a_other.old_char and
				old_mod_mask = a_other.old_mod_mask and
				save_stuffbuff.is_equal (a_other.save_stuffbuff) and
				save_inputbuf.is_equal (a_other.save_inputbuf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("save_typebuf"),
					create {CE_STRUCTURE_FIELD}.make ("typebuf_valid"),
					create {CE_STRUCTURE_FIELD}.make ("old_char"),
					create {CE_STRUCTURE_FIELD}.make ("old_mod_mask"),
					create {CE_STRUCTURE_FIELD}.make ("save_stuffbuff"),
					create {CE_STRUCTURE_FIELD}.make ("save_inputbuf")
				>>)
			init_structure_info
		end

end
