class
	PD_TYPVAL_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create vval.make
		end

feature {ANY} -- fields

	v_type: INTEGER_8 assign set_v_type

	v_lock: INTEGER_8 assign set_v_lock

	vval: PD_VVAL assign set_vval

feature {ANY} -- setters

	set_v_type (a_v_type: INTEGER_8)
		do
			v_type := a_v_type
			update_memory_field ("v_type")
		end

	set_v_lock (a_v_lock: INTEGER_8)
		do
			v_lock := a_v_lock
			update_memory_field ("v_lock")
		end

	set_vval (a_vval: PD_VVAL)
		do
			vval := a_vval
			update_memory_field ("vval")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			v_type := a_other.v_type
			v_lock := a_other.v_lock
			vval := a_other.vval.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				v_type = a_other.v_type and
				v_lock = a_other.v_lock and
				vval.is_equal (a_other.vval)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("v_type"),
					create {CE_STRUCTURE_FIELD}.make ("v_lock"),
					create {CE_STRUCTURE_FIELD}.make ("vval")
				>>)
			init_structure_info
		end

end
