class
	PD_UH_ALT_PREV

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	ptr: CE_POINTER [PD_U_HEADER] assign set_ptr

	seq: INTEGER_32 assign set_seq

feature {ANY} -- setters

	set_ptr (a_ptr: CE_POINTER [PD_U_HEADER])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_seq (a_seq: INTEGER_32)
		do
			seq := a_seq
			update_memory_field ("seq")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ptr := a_other.ptr
			seq := a_other.seq
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ptr.is_equal (a_other.ptr) and
				seq = a_other.seq
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("seq")
				>>)
			init_structure_info
		end

end
