class
	PD_VIMMENU

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create dname.make
			create en_name.make
			create en_dname.make
			create actext.make
			create cb.make
			create iconfile.make
			create strings.make (<<7>>)
			create noremap.make (<<7>>)
			create silent.make (<<7>>)
			create children.make
			create parent.make
			create next.make
			create id.make
			create submenu_id.make
			create tearoff_handle.make
			create label.make
		end

feature {ANY} -- fields

	modes: INTEGER_32 assign set_modes

	enabled: INTEGER_32 assign set_enabled

	name: CE_POINTER [NATURAL_8] assign set_name

	dname: CE_POINTER [NATURAL_8] assign set_dname

	en_name: CE_POINTER [NATURAL_8] assign set_en_name

	en_dname: CE_POINTER [NATURAL_8] assign set_en_dname

	mnemonic: INTEGER_32 assign set_mnemonic

	actext: CE_POINTER [NATURAL_8] assign set_actext

	priority: INTEGER_32 assign set_priority

	cb: CE_ROUTINE assign set_cb

	iconfile: CE_POINTER [NATURAL_8] assign set_iconfile

	iconidx: INTEGER_32 assign set_iconidx

	icon_builtin: INTEGER_32 assign set_icon_builtin

	strings: CE_ARRAY [CE_POINTER [NATURAL_8]]

	noremap: CE_ARRAY [INTEGER_32]

	silent: CE_ARRAY [INTEGER_8]

	children: CE_POINTER [PD_VIMMENU] assign set_children

	parent: CE_POINTER [PD_VIMMENU] assign set_parent

	next: CE_POINTER [PD_VIMMENU] assign set_next

	id: CE_POINTER [SD_GTKWIDGET] assign set_id

	submenu_id: CE_POINTER [SD_GTKWIDGET] assign set_submenu_id

	tearoff_handle: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_handle

	label: CE_POINTER [SD_GTKWIDGET] assign set_label

feature {ANY} -- setters

	set_modes (a_modes: INTEGER_32)
		do
			modes := a_modes
			update_memory_field ("modes")
		end

	set_enabled (a_enabled: INTEGER_32)
		do
			enabled := a_enabled
			update_memory_field ("enabled")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_dname (a_dname: CE_POINTER [NATURAL_8])
		do
			dname := a_dname
			update_memory_field ("dname")
		end

	set_en_name (a_en_name: CE_POINTER [NATURAL_8])
		do
			en_name := a_en_name
			update_memory_field ("en_name")
		end

	set_en_dname (a_en_dname: CE_POINTER [NATURAL_8])
		do
			en_dname := a_en_dname
			update_memory_field ("en_dname")
		end

	set_mnemonic (a_mnemonic: INTEGER_32)
		do
			mnemonic := a_mnemonic
			update_memory_field ("mnemonic")
		end

	set_actext (a_actext: CE_POINTER [NATURAL_8])
		do
			actext := a_actext
			update_memory_field ("actext")
		end

	set_priority (a_priority: INTEGER_32)
		do
			priority := a_priority
			update_memory_field ("priority")
		end

	set_cb (a_cb: CE_ROUTINE)
		do
			cb := a_cb
			update_memory_field ("cb")
		end

	set_iconfile (a_iconfile: CE_POINTER [NATURAL_8])
		do
			iconfile := a_iconfile
			update_memory_field ("iconfile")
		end

	set_iconidx (a_iconidx: INTEGER_32)
		do
			iconidx := a_iconidx
			update_memory_field ("iconidx")
		end

	set_icon_builtin (a_icon_builtin: INTEGER_32)
		do
			icon_builtin := a_icon_builtin
			update_memory_field ("icon_builtin")
		end

	set_children (a_children: CE_POINTER [PD_VIMMENU])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_parent (a_parent: CE_POINTER [PD_VIMMENU])
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_next (a_next: CE_POINTER [PD_VIMMENU])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_id (a_id: CE_POINTER [SD_GTKWIDGET])
		do
			id := a_id
			update_memory_field ("id")
		end

	set_submenu_id (a_submenu_id: CE_POINTER [SD_GTKWIDGET])
		do
			submenu_id := a_submenu_id
			update_memory_field ("submenu_id")
		end

	set_tearoff_handle (a_tearoff_handle: CE_POINTER [SD_GTKWIDGET])
		do
			tearoff_handle := a_tearoff_handle
			update_memory_field ("tearoff_handle")
		end

	set_label (a_label: CE_POINTER [SD_GTKWIDGET])
		do
			label := a_label
			update_memory_field ("label")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			modes := a_other.modes
			enabled := a_other.enabled
			name := a_other.name
			dname := a_other.dname
			en_name := a_other.en_name
			en_dname := a_other.en_dname
			mnemonic := a_other.mnemonic
			actext := a_other.actext
			priority := a_other.priority
			cb := a_other.cb
			iconfile := a_other.iconfile
			iconidx := a_other.iconidx
			icon_builtin := a_other.icon_builtin
			strings := a_other.strings.twin
			noremap := a_other.noremap.twin
			silent := a_other.silent.twin
			children := a_other.children
			parent := a_other.parent
			next := a_other.next
			id := a_other.id
			submenu_id := a_other.submenu_id
			tearoff_handle := a_other.tearoff_handle
			label := a_other.label
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				modes = a_other.modes and
				enabled = a_other.enabled and
				name.is_equal (a_other.name) and
				dname.is_equal (a_other.dname) and
				en_name.is_equal (a_other.en_name) and
				en_dname.is_equal (a_other.en_dname) and
				mnemonic = a_other.mnemonic and
				actext.is_equal (a_other.actext) and
				priority = a_other.priority and
				cb.is_equal (a_other.cb) and
				iconfile.is_equal (a_other.iconfile) and
				iconidx = a_other.iconidx and
				icon_builtin = a_other.icon_builtin and
				strings.is_equal (a_other.strings) and
				noremap.is_equal (a_other.noremap) and
				silent.is_equal (a_other.silent) and
				children.is_equal (a_other.children) and
				parent.is_equal (a_other.parent) and
				next.is_equal (a_other.next) and
				id.is_equal (a_other.id) and
				submenu_id.is_equal (a_other.submenu_id) and
				tearoff_handle.is_equal (a_other.tearoff_handle) and
				label.is_equal (a_other.label)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("modes"),
					create {CE_STRUCTURE_FIELD}.make ("enabled"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("dname"),
					create {CE_STRUCTURE_FIELD}.make ("en_name"),
					create {CE_STRUCTURE_FIELD}.make ("en_dname"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic"),
					create {CE_STRUCTURE_FIELD}.make ("actext"),
					create {CE_STRUCTURE_FIELD}.make ("priority"),
					create {CE_STRUCTURE_FIELD}.make ("cb"),
					create {CE_STRUCTURE_FIELD}.make ("iconfile"),
					create {CE_STRUCTURE_FIELD}.make ("iconidx"),
					create {CE_STRUCTURE_FIELD}.make ("icon_builtin"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("strings", <<7>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("noremap", <<7>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("silent", <<7>>),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("submenu_id"),
					create {CE_STRUCTURE_FIELD}.make ("tearoff_handle"),
					create {CE_STRUCTURE_FIELD}.make ("label")
				>>)
			init_structure_info
		end

end
