class
	PD_W_LINE

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	wl_lnum: INTEGER_32 assign set_wl_lnum

	wl_size: NATURAL_16 assign set_wl_size

	wl_valid: INTEGER_8 assign set_wl_valid

	wl_folded: INTEGER_8 assign set_wl_folded

	wl_lastlnum: INTEGER_32 assign set_wl_lastlnum

feature {ANY} -- setters

	set_wl_lnum (a_wl_lnum: INTEGER_32)
		do
			wl_lnum := a_wl_lnum
			update_memory_field ("wl_lnum")
		end

	set_wl_size (a_wl_size: NATURAL_16)
		do
			wl_size := a_wl_size
			update_memory_field ("wl_size")
		end

	set_wl_valid (a_wl_valid: INTEGER_8)
		do
			wl_valid := a_wl_valid
			update_memory_field ("wl_valid")
		end

	set_wl_folded (a_wl_folded: INTEGER_8)
		do
			wl_folded := a_wl_folded
			update_memory_field ("wl_folded")
		end

	set_wl_lastlnum (a_wl_lastlnum: INTEGER_32)
		do
			wl_lastlnum := a_wl_lastlnum
			update_memory_field ("wl_lastlnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wl_lnum := a_other.wl_lnum
			wl_size := a_other.wl_size
			wl_valid := a_other.wl_valid
			wl_folded := a_other.wl_folded
			wl_lastlnum := a_other.wl_lastlnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wl_lnum = a_other.wl_lnum and
				wl_size = a_other.wl_size and
				wl_valid = a_other.wl_valid and
				wl_folded = a_other.wl_folded and
				wl_lastlnum = a_other.wl_lastlnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wl_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("wl_size"),
					create {CE_STRUCTURE_FIELD}.make ("wl_valid"),
					create {CE_STRUCTURE_FIELD}.make ("wl_folded"),
					create {CE_STRUCTURE_FIELD}.make ("wl_lastlnum")
				>>)
			init_structure_info
		end

end
