class
	PD_WCMD_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create line.make
		end

feature {ANY} -- fields

	line: CE_POINTER [NATURAL_8] assign set_line

	lnum: INTEGER_32 assign set_lnum

feature {ANY} -- setters

	set_line (a_line: CE_POINTER [NATURAL_8])
		do
			line := a_line
			update_memory_field ("line")
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			line := a_other.line
			lnum := a_other.lnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				line.is_equal (a_other.line) and
				lnum = a_other.lnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("line"),
					create {CE_STRUCTURE_FIELD}.make ("lnum")
				>>)
			init_structure_info
		end

end
