class
	PD_YANKREG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create y_array.make
		end

feature {ANY} -- fields

	y_array: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_y_array

	y_size: INTEGER_32 assign set_y_size

	y_type: NATURAL_8 assign set_y_type

	y_width: INTEGER_32 assign set_y_width

feature {ANY} -- setters

	set_y_array (a_y_array: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			y_array := a_y_array
			update_memory_field ("y_array")
		end

	set_y_size (a_y_size: INTEGER_32)
		do
			y_size := a_y_size
			update_memory_field ("y_size")
		end

	set_y_type (a_y_type: NATURAL_8)
		do
			y_type := a_y_type
			update_memory_field ("y_type")
		end

	set_y_width (a_y_width: INTEGER_32)
		do
			y_width := a_y_width
			update_memory_field ("y_width")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			y_array := a_other.y_array
			y_size := a_other.y_size
			y_type := a_other.y_type
			y_width := a_other.y_width
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				y_array.is_equal (a_other.y_array) and
				y_size = a_other.y_size and
				y_type = a_other.y_type and
				y_width = a_other.y_width
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("y_array"),
					create {CE_STRUCTURE_FIELD}.make ("y_size"),
					create {CE_STRUCTURE_FIELD}.make ("y_type"),
					create {CE_STRUCTURE_FIELD}.make ("y_width")
				>>)
			init_structure_info
		end

end
