class
	P_DIFF

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	diff_a_works: INTEGER_32 assign set_diff_a_works

	set_diff_a_works (a_diff_a_works: INTEGER_32)
		do
			diff_a_works := a_diff_a_works
		end

	diff_busy: INTEGER_32 assign set_diff_busy

	set_diff_busy (a_diff_busy: INTEGER_32)
		do
			diff_busy := a_diff_busy
		end

	diff_flags: INTEGER_32 assign set_diff_flags

	set_diff_flags (a_diff_flags: INTEGER_32)
		do
			diff_flags := a_diff_flags
		end

feature {ANY} -- routines

	diff_alloc_new (a_tp: CE_POINTER [PD_TABPAGE_S]; a_dprev: CE_POINTER [PD_DIFFBLOCK_S]; a_dp: CE_POINTER [PD_DIFFBLOCK_S]): CE_POINTER [PD_DIFFBLOCK_S]
		local
			l_dnew: CE_POINTER [PD_DIFFBLOCK_S]
		do
			create l_dnew.make

			l_dnew := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_cast ((misc2_inst.alloc ((create {PD_DIFFBLOCK_S}.make).structure_size.to_natural_32)))
			if not l_dnew.is_void then
				l_dnew.item.df_next := a_dp
				if a_dprev.is_void then
					a_tp.item.tp_first_diff := l_dnew
				else
					a_dprev.item.df_next := l_dnew
				end
			end
			Result := l_dnew
		end

	diff_buf_add (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if (diff_buf_idx (a_buf___6)) /= 4 then
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < 4))
				loop
					if (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
						globals_inst.curtab.item.tp_diffbuf[l_i___0] := a_buf___6
						globals_inst.curtab.item.tp_diff_invalid := 1
						diff_redraw (1)
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E96: Can not diff more than %%ld buffers")))), 4).do_nothing
			end
		end

	diff_buf_adjust (a_win: CE_POINTER [PD_WINDOW_S])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp___0.make

			if not (a_win.item.w_onebuf_opt.wo_diff).to_boolean then
				l_wp___0 := globals_inst.firstwin
				from
				until
					not (not js.loop_done and then (not l_wp___0.is_void))
				loop
					if (l_wp___0.item.w_buffer).is_equal (a_win.item.w_buffer) then
						if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l_wp___0 := l_wp___0.item.w_next
					end
				end
				if l_wp___0.is_void then
					l_i___0 := diff_buf_idx (a_win.item.w_buffer)
					if l_i___0 /= 4 then
						globals_inst.curtab.item.tp_diffbuf[l_i___0] := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						globals_inst.curtab.item.tp_diff_invalid := 1
						diff_redraw (1)
					end
				end
			else
				diff_buf_add (a_win.item.w_buffer)
			end
		end

	diff_buf_delete (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_i___0: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
		do
			create l_tp.make

			l_tp := globals_inst.first_tabpage
			from
			until
				l_tp.is_void
			loop
				l_i___0 := diff_buf_idx_tp (a_buf___6, l_tp)
				if l_i___0 /= 4 then
					l_tp.item.tp_diffbuf[l_i___0] := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_tp.item.tp_diff_invalid := 1
					if l_tp.is_equal (globals_inst.curtab) then
						diff_redraw (1)
					end
				end
				l_tp := l_tp.item.tp_next
			end
		end

	diff_buf_idx (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := 0
			from
			until
				not (not js.loop_done and then (l_idx < 4))
			loop
				if (globals_inst.curtab.item.tp_diffbuf[l_idx]).is_equal (a_buf___6) then
					js.break
				end
				if not js.loop_jumped then
					l_idx := l_idx + 1
				end
			end
			Result := l_idx
		end

	diff_buf_idx_tp (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_tp: CE_POINTER [PD_TABPAGE_S]): INTEGER_32
		local
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := 0
			from
			until
				not (not js.loop_done and then (l_idx < 4))
			loop
				if (a_tp.item.tp_diffbuf[l_idx]).is_equal (a_buf___6) then
					js.break
				end
				if not js.loop_jumped then
					l_idx := l_idx + 1
				end
			end
			Result := l_idx
		end

	diff_check (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_maxcount: INTEGER_32
			l_i___0: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_cmp: INTEGER_32
			l_zero: INTEGER_32
			js: JUMP_STATE
		do
			create l_dp.make
			create l_buf___6.make

			l_buf___6 := a_wp___0.item.w_buffer
			if (globals_inst.curtab.item.tp_diff_invalid).to_boolean then
				ex_diffupdate (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
			end
			if (globals_inst.curtab.item.tp_first_diff).is_void then
				Result := 0
				js.return
			elseif not (a_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_lnum < 1 then
					Result := 0
					js.return
				elseif a_lnum > l_buf___6.item.b_ml.ml_line_count + 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_idx := diff_buf_idx (l_buf___6)
				if l_idx = 4 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (fold_inst.hasFoldingWin (a_wp___0, a_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_dp := globals_inst.curtab.item.tp_first_diff
				from
				until
					not (not js.loop_done and then (not l_dp.is_void))
				loop
					if a_lnum <= l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx] then
						js.break
					end
					if not js.loop_jumped then
						l_dp := l_dp.item.df_next
					end
				end
				if l_dp.is_void then
					Result := 0
					js.return
				elseif a_lnum < l_dp.item.df_lnum[l_idx] then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (a_lnum < l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx]) then
				l_zero := 0
				l_cmp := 0
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < 4))
				loop
					if l_i___0 /= l_idx then
						if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
							if l_dp.item.df_count[l_i___0] = 0 then
								l_zero := 1
							else
								if l_dp.item.df_count[l_i___0] /= l_dp.item.df_count[l_idx] then
									Result := (-1)
									js.return
								end
								if not js.return_called then
									l_cmp := 1
								end
							end
						end
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
				if not js.return_called and then (l_cmp.to_boolean) then
					l_i___0 := 0
					from
					until
						not (not js.loop_done and then (l_i___0 < 4))
					loop
						if l_i___0 /= l_idx then
							if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
								if l_dp.item.df_count[l_i___0] /= 0 then
									if not (diff_equal_entry (l_dp, l_idx, l_i___0)).to_boolean then
										Result := (-1)
										js.return
									end
								end
							end
						end
						if not js.return_called then
							l_i___0 := l_i___0 + 1
						end
					end
				end
				if not js.return_called and then (l_zero = 0) then
					Result := 0
					js.return
				end
				if not js.return_called then
					Result := (-2)
					js.return
				end
			end
			if not js.return_called and then (not ((diff_flags).bit_and (1)).to_boolean) then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_maxcount := 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < 4)
				loop
					if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
						if l_dp.item.df_count[l_i___0] > l_maxcount.to_integer_32 then
							l_maxcount := (l_dp.item.df_count[l_i___0]).to_integer_32
						end
					end
					l_i___0 := l_i___0 + 1
				end
				Result := (l_maxcount.to_integer_32 - l_dp.item.df_count[l_idx]).to_integer_32
			end
		end

	diff_check_fill (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			if not ((diff_flags).bit_and (1)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_n := diff_check (a_wp___0, a_lnum)
				if l_n <= 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := l_n
			end
		end

	diff_check_sanity (a_tp: CE_POINTER [PD_TABPAGE_S]; a_dp: CE_POINTER [PD_DIFFBLOCK_S]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 < 4))
			loop
				if not (a_tp.item.tp_diffbuf[l_i___0]).is_void then
					if (a_dp.item.df_lnum[l_i___0] + a_dp.item.df_count[l_i___0]) - 1 > (a_tp.item.tp_diffbuf[l_i___0]).item.b_ml.ml_line_count then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	diff_check_unchanged (a_tp: CE_POINTER [PD_TABPAGE_S]; a_dp: CE_POINTER [PD_DIFFBLOCK_S])
		local
			l_i_org: INTEGER_32
			l_i_new: INTEGER_32
			l_off_org: INTEGER_32
			l_off_new: INTEGER_32
			l_line_org: CE_POINTER [NATURAL_8]
			l_dir___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_line_org.make

			l_dir___0 := 1
			l_i_org := 0
			from
			until
				not (not js.loop_done and then (l_i_org < 4))
			loop
				if not (a_tp.item.tp_diffbuf[l_i_org]).is_void then
					js.break
				end
				if not js.loop_jumped then
					l_i_org := l_i_org + 1
				end
			end
			if l_i_org = 4 then
				js.return
			end
			if not js.return_called then
				if (diff_check_sanity (a_tp, a_dp)) = 0 then
					js.return
				end
			end
			if not js.return_called then
				l_off_org := 0
				l_off_new := 0
				from
				until
					js.loop_done
				loop
					from
					until
						not (not js.loop_done and then (a_dp.item.df_count[l_i_org] > 0))
					loop
						if l_dir___0 = -1 then
							l_off_org := (a_dp.item.df_count[l_i_org] - 1).to_integer_32
						end
						l_line_org := misc2_inst.vim_strsave ((memline_inst.ml_get_buf (a_tp.item.tp_diffbuf[l_i_org], a_dp.item.df_lnum[l_i_org] + l_off_org.to_integer_32, 0)))
						if l_line_org.is_void then
							js.return
						end
						if not js.return_called then
							l_i_new := l_i_org + 1
							from
							until
								not (not js.loop_done and then (l_i_new < 4))
							loop
								if (a_tp.item.tp_diffbuf[l_i_new]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									if l_dir___0 = -1 then
										l_off_new := (a_dp.item.df_count[l_i_new] - 1).to_integer_32
									end
									if l_off_new < 0 then
										js.break
									elseif l_off_new.to_integer_32 >= a_dp.item.df_count[l_i_new] then
										js.break
									end
								end
								if not js.loop_jumped then
									if (diff_cmp (l_line_org, (memline_inst.ml_get_buf (a_tp.item.tp_diffbuf[l_i_new], a_dp.item.df_lnum[l_i_new] + l_off_new.to_integer_32, 0)))) /= 0 then
										js.break
									end
								end
								if js.loop_increment then
									l_i_new := l_i_new + 1
								end
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_org))
							if l_i_new /= 4 then
								js.break
							end
							if not js.loop_jumped then
								l_i_new := l_i_org
								from
								until
									not (l_i_new < 4)
								loop
									if not (a_tp.item.tp_diffbuf[l_i_new]).is_void then
										if l_dir___0 = 1 then
											a_dp.item.df_lnum[l_i_new] := (a_dp.item.df_lnum[l_i_new]) + 1
										end
										a_dp.item.df_count[l_i_new] := (a_dp.item.df_count[l_i_new]) - 1
									end
									l_i_new := l_i_new + 1
								end
							end
						end
					end
					if not js.return_called then
						if l_dir___0 = -1 then
							js.break
						end
						if not js.loop_jumped then
							l_dir___0 := -1
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	diff_clear (a_tp: CE_POINTER [PD_TABPAGE_S])
		local
			l_p___0: CE_POINTER [PD_DIFFBLOCK_S]
			l_next_p: CE_POINTER [PD_DIFFBLOCK_S]
		do
			create l_p___0.make
			create l_next_p.make

			l_p___0 := a_tp.item.tp_first_diff
			from
			until
				l_p___0.is_void
			loop
				l_next_p := l_p___0.item.df_next
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				l_p___0 := l_next_p
			end
			a_tp.item.tp_first_diff := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
		end

	diff_cmp (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p1.make
			create l_p2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((diff_flags).bit_and (6)) = 0 then
						Result := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s1), create {CE_POINTER [INTEGER_8]}.make_cast (a_s2)))
						js.return
					end
					if not js.return_called and then (((diff_flags).bit_and (2)).to_boolean) then
						if not ((diff_flags).bit_and (4)).to_boolean then
							Result := (mbyte_inst.mb_strnicmp (a_s1, a_s2, (2_147_483_647).to_natural_32))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_p1 := a_s1
						l_p2 := a_s2
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						if (l_p1.item).to_integer_32 /= 0 then
							if (l_p2.item).to_integer_32 = 0 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if (l_p1.item).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_p1.item).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___0:
						if (l_p2.item).to_integer_32 = 32 then
							l_p1 := charset_inst.skipwhite (l_p1)
							l_p2 := charset_inst.skipwhite (l_p2)
						elseif (l_p2.item).to_integer_32 = 9 then
							l_p1 := charset_inst.skipwhite (l_p1)
							l_p2 := charset_inst.skipwhite (l_p2)
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p1])
						if l_l /= (globals_inst.mb_ptr2len.integer_32_item ([l_p2])) then
							js.break
						end
						if not js.loop_jumped then
							if l_l > 1 then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p1), create {CE_POINTER [INTEGER_8]}.make_cast (l_p2), l_l.to_natural_32)) /= 0 then
									if not globals_inst.enc_utf8.to_boolean then
										js.break
									elseif not ((diff_flags).bit_and (2)).to_boolean then
										js.break
									else
										l_tmp___4 := mbyte_inst.utf_fold ((mbyte_inst.utf_ptr2char (l_p1)))
										if l_tmp___4 /= (mbyte_inst.utf_fold ((mbyte_inst.utf_ptr2char (l_p2)))) then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									l_p1 := l_p1 + l_l
									l_p2 := l_p2 + l_l
								end
							else
								if (l_p1.item).to_integer_32 /= (l_p2.item).to_integer_32 then
									if not ((diff_flags).bit_and (2)).to_boolean then
										js.break
									else
										l_tmp___7 := tolower ((l_p1.item).to_integer_32)
										if l_tmp___7 /= (tolower ((l_p2.item).to_integer_32)) then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									l_p1 := l_p1 + 1
									l_p2 := l_p2 + 1
								end
							end
						end
				when 11 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						l_p1 := charset_inst.skipwhite (l_p1)
						l_p2 := charset_inst.skipwhite (l_p2)
						if (l_p1.item).to_integer_32 /= 0 then
							Result := 1
							js.return
						elseif (l_p2.item).to_integer_32 /= 0 then
							Result := 1
							js.return
						end
				when 13 then -- if done
					if not js.return_called then
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_copy_entry (a_dprev: CE_POINTER [PD_DIFFBLOCK_S]; a_dp: CE_POINTER [PD_DIFFBLOCK_S]; a_idx_orig: INTEGER_32; a_idx_new: INTEGER_32)
		local
			l_off___0: INTEGER_32
		do
			if a_dprev.is_void then
				l_off___0 := 0
			else
				l_off___0 := (a_dprev.item.df_lnum[a_idx_orig] + a_dprev.item.df_count[a_idx_orig]) - (a_dprev.item.df_lnum[a_idx_new] + a_dprev.item.df_count[a_idx_new])
			end
			a_dp.item.df_lnum[a_idx_new] := a_dp.item.df_lnum[a_idx_orig] - l_off___0
			a_dp.item.df_count[a_idx_new] := a_dp.item.df_count[a_idx_orig]
		end

	diff_equal_entry (a_dp: CE_POINTER [PD_DIFFBLOCK_S]; a_idx1: INTEGER_32; a_idx2: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_cmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make

			if a_dp.item.df_count[a_idx1] /= a_dp.item.df_count[a_idx2] then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (diff_check_sanity (globals_inst.curtab, a_dp)) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0.to_integer_32 < a_dp.item.df_count[a_idx1]))
				loop
					l_line := misc2_inst.vim_strsave ((memline_inst.ml_get_buf (globals_inst.curtab.item.tp_diffbuf[a_idx1], a_dp.item.df_lnum[a_idx1] + l_i___0.to_integer_32, 0)))
					if l_line.is_void then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_cmp := diff_cmp (l_line, (memline_inst.ml_get_buf (globals_inst.curtab.item.tp_diffbuf[a_idx2], a_dp.item.df_lnum[a_idx2] + l_i___0.to_integer_32, 0)))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line))
						if l_cmp /= 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	diff_file (a_tmp_orig: CE_POINTER [NATURAL_8]; a_tmp_new: CE_POINTER [NATURAL_8]; a_tmp_diff: CE_POINTER [NATURAL_8])
		local
			l_cmd: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
		do
			create l_cmd.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			if (option_inst.p_dex.item.item).to_integer_32 /= 0 then
				eval_inst.eval_diff (a_tmp_orig, a_tmp_new, a_tmp_diff)
			else
				l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_tmp_orig))
				l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_tmp_new))
				l_tmp___1 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_tmp_diff))
				l_len := (((l_tmp + l_tmp___0) + l_tmp___1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_srr.item)))) + {NATURAL_32} 27
				l_cmd := misc2_inst.alloc (l_len)
				if not l_cmd.is_void then
					if (not (getenv (ce_string ("DIFF_OPTIONS"))).is_void) then
						misc1_inst.vim_setenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("DIFF_OPTIONS")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					end
					if ((diff_flags).bit_and (2)).to_boolean then
						l_tmp___4 := ce_string ("-i ")
					else
						l_tmp___4 := ce_string ("")
					end
					if ((diff_flags).bit_and (4)).to_boolean then
						l_tmp___5 := ce_string ("-b ")
					else
						l_tmp___5 := ce_string ("")
					end
					if diff_a_works = 0 then
						l_tmp___6 := ce_string ("")
					else
						l_tmp___6 := ce_string ("-a ")
					end
					message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), l_len, ce_string ("diff %%s%%s%%s%%s%%s %%s"), l_tmp___6, ce_string (""), l_tmp___5, l_tmp___4, a_tmp_orig, a_tmp_new]).do_nothing
					ex_cmds_inst.append_redir (l_cmd, l_len.to_integer_32, option_inst.p_srr.item, a_tmp_diff)
					fileio_inst.block_autocmds
					misc2_inst.call_shell (l_cmd, 25).do_nothing
					fileio_inst.unblock_autocmds
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd))
				end
			end
		end

	diff_find_change (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_startp: CE_POINTER [INTEGER_32]; a_endp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line_org: CE_POINTER [NATURAL_8]
			l_line_new: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_si_org: INTEGER_32
			l_si_new: INTEGER_32
			l_ei_org: INTEGER_32
			l_ei_new: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_idx: INTEGER_32
			l_off___0: INTEGER_32
			l_added: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line_org.make
			create l_line_new.make
			create l_dp.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_added := 1
					l_line_org := misc2_inst.vim_strsave ((memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0)))
					if l_line_org.is_void then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_idx := diff_buf_idx (a_wp___0.item.w_buffer)
						if l_idx = 4 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_org))
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_dp := globals_inst.curtab.item.tp_first_diff
						from
						until
							not (not js.loop_done and then (not l_dp.is_void))
						loop
							if a_lnum <= l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx] then
								js.break
							end
							if not js.loop_jumped then
								l_dp := l_dp.item.df_next
							end
						end
						if l_dp.is_void then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_org))
							Result := 0
							js.return
						elseif (diff_check_sanity (globals_inst.curtab, l_dp)) = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_org))
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if:
						l_off___0 := (a_lnum - l_dp.item.df_lnum[l_idx]).to_integer_32
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 < 4)) then
							l_pos := -1 + 45 -- skip loop
						end
				when 3 then -- loop body:
						if (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
							l_pos := -1 + 44 -- skip if block
						end
				when 4 then -- if:
						if l_i___0 = l_idx then
							l_pos := -1 + 44 -- skip if block
						end
				when 5 then -- if:
						if l_off___0.to_integer_32 >= l_dp.item.df_count[l_i___0] then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 44 -- skip if block
						end
				when 6 then -- if:
						l_added := 0
						l_line_new := memline_inst.ml_get_buf (globals_inst.curtab.item.tp_diffbuf[l_i___0], l_dp.item.df_lnum[l_i___0] + l_off___0.to_integer_32, 0)
						l_si_new := 0
						l_si_org := l_si_new
				when 7 then -- loop condition:
						if not (not js.loop_done and then ((l_line_org[l_si_org]).to_integer_32 /= 0)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 8 then -- loop body:
						if not (((diff_flags).bit_and (4)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						if (l_line_org[l_si_org]).to_integer_32 /= 32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if (l_line_org[l_si_org]).to_integer_32 /= 9 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L___1:
						if (l_line_new[l_si_new]).to_integer_32 = 32 then
							l_tmp___1 := charset_inst.skipwhite (l_line_org + l_si_org)
							l_si_org := l_tmp___1.distance (l_line_org)
							l_tmp___2 := charset_inst.skipwhite (l_line_new + l_si_new)
							l_si_new := l_tmp___2.distance (l_line_new)
						elseif (l_line_new[l_si_new]).to_integer_32 = 9 then
							l_tmp___1 := charset_inst.skipwhite (l_line_org + l_si_org)
							l_si_org := l_tmp___1.distance (l_line_org)
							l_tmp___2 := charset_inst.skipwhite (l_line_new + l_si_new)
							l_si_new := l_tmp___2.distance (l_line_new)
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___0
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if (l_line_org[l_si_org]).to_integer_32 /= (l_line_new[l_si_new]).to_integer_32 then
							js.break
						end
						if not js.loop_jumped then
							l_si_org := l_si_org + 1
							l_si_new := l_si_new + 1
						end
				when 18 then
						l_pos := -1 + 7 -- back to loop condition
				when 19 then -- loop done
						if globals_inst.has_mbyte.to_boolean then
							l_si_org := l_si_org - (globals_inst.mb_head_off.integer_32_item ([l_line_org, l_line_org + l_si_org]))
							l_si_new := l_si_new - (globals_inst.mb_head_off.integer_32_item ([l_line_new, l_line_new + l_si_new]))
						end
						if a_startp.item > l_si_org then
							a_startp.item := l_si_org
						end
						if (l_line_org[l_si_org]).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___6
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 22 then -- else:
						if (l_line_new[l_si_new]).to_integer_32 = 0 then
							l_pos := -1 + 44 -- skip if block
						end
				when 23 then -- if: | _L___6:
						l_ei_org := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line_org))).to_integer_32
						l_ei_new := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line_new))).to_integer_32
				when 24 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 43 -- skip loop
						end
				when 25 then -- loop body:
						if l_ei_org >= a_startp.item then
							if l_ei_new >= l_si_new then
								if l_ei_org >= 0 then
									if not (l_ei_new >= 0) then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 42 -- skip if block
						end
				when 26 then -- if:
						if not (((diff_flags).bit_and (4)).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 27 then -- if:
						if (l_line_org[l_ei_org]).to_integer_32 /= 32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___5
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 30 then -- else:
						if (l_line_org[l_ei_org]).to_integer_32 /= 9 then
							l_pos := -1 + 39 -- skip if block
						end
				when 31 then -- if: | _L___5:
						if (l_line_new[l_ei_new]).to_integer_32 /= 32 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 34 then -- else:
						if (l_line_new[l_ei_new]).to_integer_32 /= 9 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if: | _L___3:
						from
						until
							js.loop_done
						loop
							if l_ei_org >= a_startp.item then
								if (l_line_org[l_ei_org]).to_integer_32 /= 32 then
									if (l_line_org[l_ei_org]).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_ei_org := l_ei_org - 1
							end
						end
						from
						until
							js.loop_done
						loop
							if l_ei_new >= l_si_new then
								if (l_line_new[l_ei_new]).to_integer_32 /= 32 then
									if (l_line_new[l_ei_new]).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_ei_new := l_ei_new - 1
							end
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						l_pos := -1 + 41 -- goto _L___4
				when 38 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						l_pos := -1 + 41 -- goto _L___4
				when 40 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___4:
						if (l_line_org[l_ei_org]).to_integer_32 /= (l_line_new[l_ei_new]).to_integer_32 then
							js.break
						end
						if not js.loop_jumped then
							l_ei_org := l_ei_org - 1
							l_ei_new := l_ei_new - 1
						end
				when 42 then -- if done
						l_pos := -1 + 24 -- back to loop condition
				when 43 then -- loop done
						if a_endp.item < l_ei_org then
							a_endp.item := l_ei_org
						end
				when 44 then -- if done | if done | if done | if done
						if js.loop_increment then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 45 then -- loop done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_org))
						Result := l_added
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_fold_update (a_dp: CE_POINTER [PD_DIFFBLOCK_S]; a_skip_idx: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				not (not js.loop_done and then (not l_wp___0.is_void))
			loop
				l_i___0 := 0
				from
				until
					not (l_i___0 < 4)
				loop
					if (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_equal (l_wp___0.item.w_buffer) then
						if l_i___0 /= a_skip_idx then
							fold_inst.foldUpdate (l_wp___0, a_dp.item.df_lnum[l_i___0], a_dp.item.df_lnum[l_i___0] + a_dp.item.df_count[l_i___0])
						end
					end
					l_i___0 := l_i___0 + 1
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	diff_get_corresponding_line (a_buf1: CE_POINTER [PD_FILE_BUFFER]; a_lnum1: INTEGER_32; a_buf2: CE_POINTER [PD_FILE_BUFFER]; a_lnum3: INTEGER_32): INTEGER_32
		local
			l_idx1: INTEGER_32
			l_idx2: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_baseline: INTEGER_32
			l_lnum2: INTEGER_32
			js: JUMP_STATE
		do
			create l_dp.make

			l_baseline := 0
			l_idx1 := diff_buf_idx (a_buf1)
			l_idx2 := diff_buf_idx (a_buf2)
			if l_idx1 = 4 then
				Result := a_lnum1
				js.return
			elseif l_idx2 = 4 then
				Result := a_lnum1
				js.return
			elseif (globals_inst.curtab.item.tp_first_diff).is_void then
				Result := a_lnum1
				js.return
			end
			if not js.return_called then
				if (globals_inst.curtab.item.tp_diff_invalid).to_boolean then
					ex_diffupdate (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				if (globals_inst.curtab.item.tp_first_diff).is_void then
					Result := a_lnum1
					js.return
				end
			end
			if not js.return_called then
				l_dp := globals_inst.curtab.item.tp_first_diff
				from
				until
					not (not js.loop_done and then (not l_dp.is_void))
				loop
					if l_dp.item.df_lnum[l_idx1] > a_lnum1 then
						l_lnum2 := a_lnum1 - l_baseline.to_integer_32
						if l_lnum2 > a_buf2.item.b_ml.ml_line_count then
							l_lnum2 := a_buf2.item.b_ml.ml_line_count
						end
						Result := l_lnum2
						js.return
					elseif l_dp.item.df_lnum[l_idx1] + l_dp.item.df_count[l_idx1] > a_lnum1 then
						l_baseline := (a_lnum1 - l_dp.item.df_lnum[l_idx1]).to_integer_32
						if l_baseline.to_integer_32 > l_dp.item.df_count[l_idx2] then
							l_baseline := (l_dp.item.df_count[l_idx2]).to_integer_32
						end
						Result := (l_dp.item.df_lnum[l_idx2] + l_baseline.to_integer_32)
						js.return
					elseif l_dp.item.df_lnum[l_idx1] = a_lnum1 then
						if l_dp.item.df_count[l_idx1] = 0 then
							if l_dp.item.df_lnum[l_idx2] <= a_lnum3 then
								if l_dp.item.df_lnum[l_idx2] + l_dp.item.df_count[l_idx2] > a_lnum3 then
									Result := a_lnum3
									js.return
								end
							end
						end
					end
					if not js.return_called then
						l_baseline := ((l_dp.item.df_lnum[l_idx1] + l_dp.item.df_count[l_idx1]) - (l_dp.item.df_lnum[l_idx2] + l_dp.item.df_count[l_idx2])).to_integer_32
						l_dp := l_dp.item.df_next
					end
				end
			end
			if not js.return_called then
				l_lnum2 := a_lnum1 - l_baseline.to_integer_32
				if l_lnum2 > a_buf2.item.b_ml.ml_line_count then
					l_lnum2 := a_buf2.item.b_ml.ml_line_count
				end
				Result := l_lnum2
			end
		end

	diff_infold (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_other: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			js: JUMP_STATE
		do
			create l_dp.make

			l_idx := -1
			l_other := 0
			if not (a_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < 4)
				loop
					if (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_equal (a_wp___0.item.w_buffer) then
						l_idx := l_i___0
					elseif not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
						l_other := 1
					end
					l_i___0 := l_i___0 + 1
				end
				if l_idx = -1 then
					Result := 0
					js.return
				elseif not l_other.to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (globals_inst.curtab.item.tp_diff_invalid).to_boolean then
					ex_diffupdate (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				if (globals_inst.curtab.item.tp_first_diff).is_void then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_dp := globals_inst.curtab.item.tp_first_diff
				from
				until
					not (not js.loop_done and then (not l_dp.is_void))
				loop
					if l_dp.item.df_lnum[l_idx] - globals_inst.diff_context.to_integer_32 > a_lnum then
						js.break
					end
					if not js.loop_jumped then
						if (l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx]) + globals_inst.diff_context.to_integer_32 > a_lnum then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_dp := l_dp.item.df_next
						end
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	diff_invalidate (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_i___0: INTEGER_32
		do
			create l_tp.make

			l_tp := globals_inst.first_tabpage
			from
			until
				l_tp.is_void
			loop
				l_i___0 := diff_buf_idx_tp (a_buf___6, l_tp)
				if l_i___0 /= 4 then
					l_tp.item.tp_diff_invalid := 1
					if l_tp.is_equal (globals_inst.curtab) then
						diff_redraw (1)
					end
				end
				l_tp := l_tp.item.tp_next
			end
		end

	diff_lnum_win (a_lnum: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_dp.make

			l_idx := diff_buf_idx (globals_inst.curbuf)
			if l_idx = 4 then
				Result := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				if (globals_inst.curtab.item.tp_diff_invalid).to_boolean then
					ex_diffupdate (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				l_dp := globals_inst.curtab.item.tp_first_diff
				from
				until
					not (not js.loop_done and then (not l_dp.is_void))
				loop
					if a_lnum <= l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx] then
						js.break
					end
					if not js.loop_jumped then
						l_dp := l_dp.item.df_next
					end
				end
				if l_dp.is_void then
					Result := ((a_wp___0.item.w_buffer).item.b_ml.ml_line_count - (globals_inst.curbuf.item.b_ml.ml_line_count - a_lnum))
					js.return
				end
			end
			if not js.return_called then
				l_i___0 := diff_buf_idx (a_wp___0.item.w_buffer)
				if l_i___0 = 4 then
					Result := (0).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				l_n := a_lnum + (l_dp.item.df_lnum[l_i___0] - l_dp.item.df_lnum[l_idx])
				if l_n > l_dp.item.df_lnum[l_i___0] + l_dp.item.df_count[l_i___0] then
					l_n := l_dp.item.df_lnum[l_i___0] + l_dp.item.df_count[l_i___0]
				end
				Result := l_n
			end
		end

	diff_mark_adjust (a_line1: INTEGER_32; a_line2: INTEGER_32; a_amount: INTEGER_32; a_amount_after: INTEGER_32)
		local
			l_idx: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
		do
			create l_tp.make

			l_tp := globals_inst.first_tabpage
			from
			until
				l_tp.is_void
			loop
				l_idx := diff_buf_idx_tp (globals_inst.curbuf, l_tp)
				if l_idx /= 4 then
					diff_mark_adjust_tp (l_tp, l_idx, a_line1, a_line2, a_amount, a_amount_after)
				end
				l_tp := l_tp.item.tp_next
			end
		end

	diff_mark_adjust_tp (a_tp: CE_POINTER [PD_TABPAGE_S]; a_idx: INTEGER_32; a_line1: INTEGER_32; a_line2: INTEGER_32; a_amount: INTEGER_32; a_amount_after: INTEGER_32)
		local
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_dprev: CE_POINTER [PD_DIFFBLOCK_S]
			l_dnext: CE_POINTER [PD_DIFFBLOCK_S]
			l_i___0: INTEGER_32
			l_inserted: INTEGER_32
			l_deleted: INTEGER_32
			l_n: INTEGER_32
			l_off___0: INTEGER_32
			l_last: INTEGER_32
			l_lnum_deleted: INTEGER_32
			l_check_unchanged: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dp.make
			create l_dprev.make
			create l_dnext.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum_deleted := a_line1
					if a_line2 = 2_147_483_647 then
						l_inserted := a_amount.to_integer_32
						l_deleted := 0
					elseif a_amount_after > 0 then
						l_inserted := a_amount_after.to_integer_32
						l_deleted := 0
					else
						l_inserted := 0
						l_deleted := (-a_amount_after).to_integer_32
					end
					l_dprev := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
					l_dp := a_tp.item.tp_first_diff
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_dp.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 5 then -- else:
						if not (l_dp.item.df_lnum[a_idx] - 1 > a_line2) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 8 then -- else:
						if a_line2 /= 2_147_483_647 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if not (l_dp.item.df_lnum[a_idx] > a_line1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if not (l_dprev.is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (l_dprev.item.df_lnum[a_idx] + l_dprev.item.df_count[a_idx] < a_line1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if not diff_busy.to_boolean then
							l_dnext := diff_alloc_new (a_tp, l_dprev, l_dp)
							if l_dnext.is_void then
								js.return
							end
							if not js.return_called then
								l_dnext.item.df_lnum[a_idx] := a_line1
								l_dnext.item.df_count[a_idx] := l_inserted.to_integer_32
								l_i___0 := 0
								from
								until
									not (l_i___0 < 4)
								loop
									if not (a_tp.item.tp_diffbuf[l_i___0]).is_void then
										if l_i___0 /= a_idx then
											if l_dprev.is_void then
												l_dnext.item.df_lnum[l_i___0] := a_line1
											else
												l_dnext.item.df_lnum[l_i___0] := (a_line1 + (l_dprev.item.df_lnum[l_i___0] + l_dprev.item.df_count[l_i___0])) - (l_dprev.item.df_lnum[a_idx] + l_dprev.item.df_count[a_idx])
											end
											l_dnext.item.df_count[l_i___0] := l_deleted.to_integer_32
										end
									end
									l_i___0 := l_i___0 + 1
								end
							end
						end
				when 15 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							if l_dp.is_void then
								js.break
							end
							if not js.loop_jumped then
								l_last := (l_dp.item.df_lnum[a_idx] + l_dp.item.df_count[a_idx]) - 1
								if l_last >= a_line1 - 1 then
									if l_dp.item.df_lnum[a_idx] - (l_deleted + l_inserted /= 0).to_integer > a_line2 then
										if a_amount_after = 0 then
											js.break
										end
										if not js.loop_jumped then
											l_dp.item.df_lnum[a_idx] := l_dp.item.df_lnum[a_idx] + a_amount_after
										end
									else
										l_check_unchanged := 0
										if l_deleted > 0 then
											if l_dp.item.df_lnum[a_idx] >= a_line1 then
												l_off___0 := (l_dp.item.df_lnum[a_idx] - l_lnum_deleted).to_integer_32
												if l_last <= a_line2 then
													if not (l_dp.item.df_next).is_void then
														if (l_dp.item.df_next).item.df_lnum[a_idx] - 1 <= a_line2 then
															l_n := ((l_dp.item.df_next).item.df_lnum[a_idx] - l_lnum_deleted).to_integer_32
															l_deleted := l_deleted - l_n
															l_n := (l_n.to_integer_32 - l_dp.item.df_count[a_idx]).to_integer_32
															l_lnum_deleted := (l_dp.item.df_next).item.df_lnum[a_idx]
														else
															l_n := (l_deleted.to_integer_32 - l_dp.item.df_count[a_idx]).to_integer_32
														end
													else
														l_n := (l_deleted.to_integer_32 - l_dp.item.df_count[a_idx]).to_integer_32
													end
													l_dp.item.df_count[a_idx] := (0).to_integer_32
												else
													l_n := l_off___0
													l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] - ((a_line2 - l_dp.item.df_lnum[a_idx]) + 1)
													l_check_unchanged := 1
												end
												l_dp.item.df_lnum[a_idx] := a_line1
											else
												l_off___0 := 0
												if l_last < a_line2 then
													l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] - ((l_last - l_lnum_deleted) + 1)
													if not (l_dp.item.df_next).is_void then
														if (l_dp.item.df_next).item.df_lnum[a_idx] - 1 <= a_line2 then
															l_n := (((l_dp.item.df_next).item.df_lnum[a_idx] - 1) - l_last).to_integer_32
															l_deleted := (l_deleted.to_integer_32 - ((l_dp.item.df_next).item.df_lnum[a_idx] - l_lnum_deleted)).to_integer_32
															l_lnum_deleted := (l_dp.item.df_next).item.df_lnum[a_idx]
														else
															l_n := (a_line2 - l_last).to_integer_32
														end
													else
														l_n := (a_line2 - l_last).to_integer_32
													end
													l_check_unchanged := 1
												else
													l_n := 0
													l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] - l_deleted.to_integer_32
												end
											end
											l_i___0 := 0
											from
											until
												not (l_i___0 < 4)
											loop
												if not (a_tp.item.tp_diffbuf[l_i___0]).is_void then
													if l_i___0 /= a_idx then
														l_dp.item.df_lnum[l_i___0] := l_dp.item.df_lnum[l_i___0] - l_off___0.to_integer_32
														l_dp.item.df_count[l_i___0] := l_dp.item.df_count[l_i___0] + l_n.to_integer_32
													end
												end
												l_i___0 := l_i___0 + 1
											end
										elseif l_dp.item.df_lnum[a_idx] <= a_line1 then
											l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] + l_inserted.to_integer_32
											l_check_unchanged := 1
										else
											l_dp.item.df_lnum[a_idx] := l_dp.item.df_lnum[a_idx] + l_inserted.to_integer_32
										end
										if l_check_unchanged.to_boolean then
											diff_check_unchanged (a_tp, l_dp)
										end
									end
								end
							end
							if not js.loop_jumped then
								if not l_dprev.is_void then
									if l_dprev.item.df_lnum[a_idx] + l_dprev.item.df_count[a_idx] = l_dp.item.df_lnum[a_idx] then
										l_i___0 := 0
										from
										until
											not (l_i___0 < 4)
										loop
											if not (a_tp.item.tp_diffbuf[l_i___0]).is_void then
												l_dprev.item.df_count[l_i___0] := l_dprev.item.df_count[l_i___0] + (l_dp.item.df_count[l_i___0])
											end
											l_i___0 := l_i___0 + 1
										end
										l_dprev.item.df_next := l_dp.item.df_next
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dp))
										l_dp := l_dprev.item.df_next
									else
										l_dprev := l_dp
										l_dp := l_dp.item.df_next
									end
								else
									l_dprev := l_dp
									l_dp := l_dp.item.df_next
								end
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not js.return_called then
						l_dprev := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
						l_dp := a_tp.item.tp_first_diff
						from
						until
							not (not js.loop_done and then (not l_dp.is_void))
						loop
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then (l_i___0 < 4))
							loop
								if not (a_tp.item.tp_diffbuf[l_i___0]).is_void then
									if l_dp.item.df_count[l_i___0] /= 0 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							if l_i___0 = 4 then
								l_dnext := l_dp.item.df_next
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dp))
								l_dp := l_dnext
								if l_dprev.is_void then
									a_tp.item.tp_first_diff := l_dnext
								else
									l_dprev.item.df_next := l_dnext
								end
							else
								l_dprev := l_dp
								l_dp := l_dp.item.df_next
							end
						end
						if a_tp.is_equal (globals_inst.curtab) then
							diff_redraw (1)
							globals_inst.diff_need_scrollbind := 1
						end
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_mode_buf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
		do
			create l_tp.make

			l_tp := globals_inst.first_tabpage
			from
			until
				not (not js.loop_done and then (not l_tp.is_void))
			loop
				if (diff_buf_idx_tp (a_buf___6, l_tp)) /= 4 then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_tp := l_tp.item.tp_next
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	diff_move_to (a_dir___0: INTEGER_32; a_count___2: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_idx: INTEGER_32
			l_lnum: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_lnum := globals_inst.curwin.item.w_cursor.lnum
					l_idx := diff_buf_idx (globals_inst.curbuf)
					if l_idx = 4 then
						Result := 0
						js.return
					elseif (globals_inst.curtab.item.tp_first_diff).is_void then
						Result := 0
						js.return
					end
					if not js.return_called then
						if (globals_inst.curtab.item.tp_diff_invalid).to_boolean then
							ex_diffupdate (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
						end
						if (globals_inst.curtab.item.tp_first_diff).is_void then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 11 -- skip loop
						end
				when 2 then -- loop body:
						l_count___2 := l_count___2 - 1
						if not (l_count___2 >= 0) then
							js.break
						end
						if not js.loop_jumped and then (a_dir___0 = -1) then
							if l_lnum <= (globals_inst.curtab.item.tp_first_diff).item.df_lnum[l_idx] then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_dp := globals_inst.curtab.item.tp_first_diff
				when 4 then -- loop condition:
						if not (not js.loop_done and then (not (l_dp.is_void))) then
							l_pos := -1 + 10 -- skip loop
						end
				when 5 then -- loop body:
						if a_dir___0 /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_lnum < l_dp.item.df_lnum[l_idx] then
							l_lnum := l_dp.item.df_lnum[l_idx]
							js.break
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if a_dir___0 = -1 then
							if (l_dp.item.df_next).is_void then
								l_lnum := l_dp.item.df_lnum[l_idx]
								js.break
							elseif l_lnum <= (l_dp.item.df_next).item.df_lnum[l_idx] then
								l_lnum := l_dp.item.df_lnum[l_idx]
								js.break
							end
						end
				when 9 then
						if not js.loop_jumped then
							l_dp := l_dp.item.df_next
						end
						l_pos := -1 + 4 -- back to loop condition
				when 10 then -- loop done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
						if l_lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
							l_lnum := globals_inst.curbuf.item.b_ml.ml_line_count
						end
						if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
							Result := 0
							js.return
						end
				when 12 then -- if done
					if not js.return_called then
						mark_inst.setpcmark
						globals_inst.curwin.item.w_cursor.lnum := l_lnum
						globals_inst.curwin.item.w_cursor.col := 0
						Result := 1
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_read (a_idx_orig: INTEGER_32; a_idx_new: INTEGER_32; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_dprev: CE_POINTER [PD_DIFFBLOCK_S]
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_dn: CE_POINTER [PD_DIFFBLOCK_S]
			l_dpl: CE_POINTER [PD_DIFFBLOCK_S]
			l_f1: INTEGER_32
			l_l1: INTEGER_32
			l_f2: INTEGER_32
			l_l2: INTEGER_32
			l_linebuf: CE_ARRAY [NATURAL_8]
			l_difftype: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_off___0: INTEGER_32
			l_i___0: INTEGER_32
			l_lnum_orig: INTEGER_32
			l_lnum_new: INTEGER_32
			l_count_orig: INTEGER_32
			l_count_new: INTEGER_32
			l_notset: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_dprev.make
			create l_dp.make
			create l_dn.make
			create l_dpl.make
			create l_linebuf.make (<<50>>)
			create l_p___0.make (<<1>>)
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dprev := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
					l_dp := globals_inst.curtab.item.tp_first_diff
					l_notset := 1
					l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E98: Cannot read diff output"))))).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 2 then -- loop body:
						if (fileio_inst.vim_fgets (l_linebuf, 50, l_fd)).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if not ((((ctype_b_loc).item[(l_linebuf[0]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								js.continue
							end
						end
						if not js.loop_jumped then
							l_p___0.item := l_linebuf
							l_f1 := charset_inst.getdigits (l_p___0)
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
								l_l1 := charset_inst.getdigits (l_p___0)
							else
								l_l1 := l_f1
							end
							if (l_p___0.item.item).to_integer_32 /= 97 then
								if (l_p___0.item.item).to_integer_32 /= 99 then
									if (l_p___0.item.item).to_integer_32 /= 100 then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							l_tmp___2 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_difftype := (l_tmp___2.item).to_integer_32
							l_f2 := charset_inst.getdigits (l_p___0)
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
								l_l2 := charset_inst.getdigits (l_p___0)
							else
								l_l2 := l_f2
							end
							if l_l1 < l_f1 then
								js.continue
							elseif l_l2 < l_f2 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if l_difftype = 97 then
							l_lnum_orig := l_f1 + 1
							l_count_orig := 0
						else
							l_lnum_orig := l_f1
							l_count_orig := (l_l1 - l_f1) + 1
						end
						if l_difftype = 100 then
							l_lnum_new := l_f2 + 1
							l_count_new := 0
						else
							l_lnum_new := l_f2
							l_count_new := (l_l2 - l_f2) + 1
						end
						from
						until
							js.loop_done
						loop
							if not l_dp.is_void then
								if not (l_lnum_orig > l_dp.item.df_lnum[a_idx_orig] + l_dp.item.df_count[a_idx_orig]) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_notset.to_boolean then
									diff_copy_entry (l_dprev, l_dp, a_idx_orig, a_idx_new)
								end
								l_dprev := l_dp
								l_dp := l_dp.item.df_next
								l_notset := 1
							end
						end
						if l_dp.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_lnum_orig <= l_dp.item.df_lnum[a_idx_orig] + l_dp.item.df_count[a_idx_orig] then
							if l_lnum_orig + l_count_orig >= l_dp.item.df_lnum[a_idx_orig] then
								l_dpl := l_dp
								from
								until
									not (not js.loop_done and then (not (l_dpl.item.df_next).is_void))
								loop
									if l_lnum_orig + l_count_orig < (l_dpl.item.df_next).item.df_lnum[a_idx_orig] then
										js.break
									end
									if not js.loop_jumped then
										l_dpl := l_dpl.item.df_next
									end
								end
								l_off___0 := l_dp.item.df_lnum[a_idx_orig] - l_lnum_orig
								if l_off___0 > 0 then
									l_i___0 := a_idx_orig
									from
									until
										not (l_i___0 < a_idx_new)
									loop
										if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
											l_dp.item.df_lnum[l_i___0] := l_dp.item.df_lnum[l_i___0] - l_off___0
										end
										l_i___0 := l_i___0 + 1
									end
									l_dp.item.df_lnum[a_idx_new] := l_lnum_new
									l_dp.item.df_count[a_idx_new] := l_count_new
								elseif l_notset.to_boolean then
									l_dp.item.df_lnum[a_idx_new] := l_lnum_new + l_off___0
									l_dp.item.df_count[a_idx_new] := l_count_new - l_off___0
								else
									l_dp.item.df_count[a_idx_new] := l_dp.item.df_count[a_idx_new] + ((((l_count_new - l_count_orig) + l_dpl.item.df_lnum[a_idx_orig]) + l_dpl.item.df_count[a_idx_orig]) - (l_dp.item.df_lnum[a_idx_orig] + l_dp.item.df_count[a_idx_orig]))
								end
								l_off___0 := (l_lnum_orig + l_count_orig) - (l_dpl.item.df_lnum[a_idx_orig] + l_dpl.item.df_count[a_idx_orig])
								if l_off___0 < 0 then
									if l_notset.to_boolean then
										l_dp.item.df_count[a_idx_new] := l_dp.item.df_count[a_idx_new] + (-l_off___0)
									end
									l_off___0 := 0
								end
								l_i___0 := a_idx_orig
								from
								until
									not (l_i___0 < a_idx_new)
								loop
									if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
										l_dp.item.df_count[l_i___0] := ((l_dpl.item.df_lnum[l_i___0] + l_dpl.item.df_count[l_i___0]) - l_dp.item.df_lnum[l_i___0]) + l_off___0
									end
									l_i___0 := l_i___0 + 1
								end
								l_dn := l_dp.item.df_next
								l_dp.item.df_next := l_dpl.item.df_next
								from
								until
									l_dn.is_equal (l_dp.item.df_next)
								loop
									l_dpl := l_dn.item.df_next
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dn))
									l_dn := l_dpl
								end
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else: | _L___0:
						l_dp := diff_alloc_new (globals_inst.curtab, l_dprev, l_dp)
						if l_dp.is_void then
							l_pos := -1 + 11 -- goto done
						end
				when 7 then
						l_dp.item.df_lnum[a_idx_orig] := l_lnum_orig
						l_dp.item.df_count[a_idx_orig] := l_count_orig
						l_dp.item.df_lnum[a_idx_new] := l_lnum_new
						l_dp.item.df_count[a_idx_new] := l_count_new
						l_i___0 := a_idx_orig + 1
						from
						until
							not (l_i___0 < a_idx_new)
						loop
							if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
								diff_copy_entry (l_dprev, l_dp, a_idx_orig, l_i___0)
							end
							l_i___0 := l_i___0 + 1
						end
				when 8 then
						l_notset := 0
				when 9 then -- if done
						if js.loop_increment then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
						from
						until
							l_dp.is_void
						loop
							if l_notset.to_boolean then
								diff_copy_entry (l_dprev, l_dp, a_idx_orig, a_idx_new)
							end
							l_dprev := l_dp
							l_dp := l_dp.item.df_next
							l_notset := 1
						end
				when 11 then -- done:
						fclose (l_fd).do_nothing
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_redraw (a_dofold: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_n: INTEGER_32
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
					screen_inst.redraw_win_later (l_wp___0, 35)
					if a_dofold.to_boolean then
						if (fold_inst.foldmethodIsDiff (l_wp___0)).to_boolean then
							fold_inst.foldUpdateAll (l_wp___0)
						end
					end
					if not l_wp___0.is_equal (globals_inst.curwin) then
						if l_wp___0.item.w_topfill > 0 then
							l_n := diff_check (l_wp___0, l_wp___0.item.w_topline)
							if l_wp___0.item.w_topfill > l_n then
								if l_n < 0 then
									l_wp___0.item.w_topfill := 0
								else
									l_wp___0.item.w_topfill := l_n
								end
							end
						end
					end
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	diff_set_topline (a_fromwin: CE_POINTER [PD_WINDOW_S]; a_towin: CE_POINTER [PD_WINDOW_S])
		local
			l_frombuf: CE_POINTER [PD_FILE_BUFFER]
			l_lnum: INTEGER_32
			l_fromidx: INTEGER_32
			l_toidx: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_max_count: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_frombuf.make
			create l_dp.make

			l_frombuf := a_fromwin.item.w_buffer
			l_lnum := a_fromwin.item.w_topline
			l_fromidx := diff_buf_idx (l_frombuf)
			if l_fromidx = 4 then
				js.return
			end
			if not js.return_called then
				if (globals_inst.curtab.item.tp_diff_invalid).to_boolean then
					ex_diffupdate (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				a_towin.item.w_topfill := 0
				l_dp := globals_inst.curtab.item.tp_first_diff
				from
				until
					not (not js.loop_done and then (not l_dp.is_void))
				loop
					if l_lnum <= l_dp.item.df_lnum[l_fromidx] + l_dp.item.df_count[l_fromidx] then
						js.break
					end
					if not js.loop_jumped then
						l_dp := l_dp.item.df_next
					end
				end
				if l_dp.is_void then
					a_towin.item.w_topline := (a_towin.item.w_buffer).item.b_ml.ml_line_count - (l_frombuf.item.b_ml.ml_line_count - l_lnum)
				else
					l_toidx := diff_buf_idx (a_towin.item.w_buffer)
					if l_toidx = 4 then
						js.return
					end
					if not js.return_called then
						a_towin.item.w_topline := l_lnum + (l_dp.item.df_lnum[l_toidx] - l_dp.item.df_lnum[l_fromidx])
						if l_lnum >= l_dp.item.df_lnum[l_fromidx] then
							l_max_count := 0
							l_i___0 := 0
							from
							until
								not (l_i___0 < 4)
							loop
								if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
									if l_max_count.to_integer_32 < l_dp.item.df_count[l_i___0] then
										l_max_count := (l_dp.item.df_count[l_i___0]).to_integer_32
									end
								end
								l_i___0 := l_i___0 + 1
							end
							if l_dp.item.df_count[l_toidx] = l_dp.item.df_count[l_fromidx] then
								a_towin.item.w_topfill := a_fromwin.item.w_topfill
							elseif l_dp.item.df_count[l_toidx] > l_dp.item.df_count[l_fromidx] then
								if l_lnum = l_dp.item.df_lnum[l_fromidx] + l_dp.item.df_count[l_fromidx] then
									if (l_max_count - a_fromwin.item.w_topfill).to_integer_32 >= l_dp.item.df_count[l_toidx] then
										a_towin.item.w_topline := l_dp.item.df_lnum[l_toidx] + l_dp.item.df_count[l_toidx]
										a_towin.item.w_topfill := a_fromwin.item.w_topfill
									else
										a_towin.item.w_topline := (l_dp.item.df_lnum[l_toidx] + l_max_count.to_integer_32) - (a_fromwin.item.w_topfill).to_integer_32
									end
								end
							elseif a_towin.item.w_topline >= l_dp.item.df_lnum[l_toidx] + l_dp.item.df_count[l_toidx] then
								a_towin.item.w_topline := l_dp.item.df_lnum[l_toidx] + l_dp.item.df_count[l_toidx]
								if ((diff_flags).bit_and (1)).to_boolean then
									if l_lnum = l_dp.item.df_lnum[l_fromidx] + l_dp.item.df_count[l_fromidx] then
										a_towin.item.w_topfill := a_fromwin.item.w_topfill
									else
										a_towin.item.w_topfill := ((l_dp.item.df_lnum[l_fromidx] + l_max_count.to_integer_32) - l_lnum).to_integer_32
									end
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				a_towin.item.w_botfill := 0
				if a_towin.item.w_topline > (a_towin.item.w_buffer).item.b_ml.ml_line_count then
					a_towin.item.w_topline := (a_towin.item.w_buffer).item.b_ml.ml_line_count
					a_towin.item.w_botfill := 1
				end
				if a_towin.item.w_topline < 1 then
					a_towin.item.w_topline := (1).to_integer_32
					a_towin.item.w_topfill := 0
				end
				move_inst.invalidate_botline_win (a_towin)
				move_inst.changed_line_abv_curs_win (a_towin)
				move_inst.check_topfill (a_towin, 0)
				fold_inst.hasFoldingWin (a_towin, a_towin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (a_towin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
			end
		end

	diff_win_options (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_addbuf: INTEGER_32)
		local
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
		do
			create l_old_curwin___1.make

			l_old_curwin___1 := globals_inst.curwin
			globals_inst.curwin := a_wp___0
			fold_inst.newFoldLevel
			globals_inst.curwin := l_old_curwin___1
			a_wp___0.item.w_onebuf_opt.wo_diff := 1
			a_wp___0.item.w_onebuf_opt.wo_crb := 1
			a_wp___0.item.w_onebuf_opt.wo_scb := 1
			a_wp___0.item.w_onebuf_opt.wo_wrap := 0
			globals_inst.curwin := a_wp___0
			globals_inst.curbuf := globals_inst.curwin.item.w_buffer
			option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fdm")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diff")), 5, 0)
			globals_inst.curwin := l_old_curwin___1
			globals_inst.curbuf := globals_inst.curwin.item.w_buffer
			a_wp___0.item.w_onebuf_opt.wo_fdc := globals_inst.diff_foldcolumn.to_integer_32
			a_wp___0.item.w_onebuf_opt.wo_fen := 1
			a_wp___0.item.w_onebuf_opt.wo_fdl := 0
			fold_inst.foldUpdateAll (a_wp___0)
			move_inst.changed_window_setting_win (a_wp___0)
			if (misc2_inst.vim_strchr (option_inst.p_sbo.item, ('h').code)).is_void then
				ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("set sbo+=hor"))).do_nothing
			end
			if a_addbuf.to_boolean then
				diff_buf_add (a_wp___0.item.w_buffer)
			end
			screen_inst.redraw_win_later (a_wp___0, 40)
		end

	diff_write (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_r: INTEGER_32
			l_save_ff: CE_POINTER [NATURAL_8]
		do
			create l_save_ff.make

			l_save_ff := a_buf___6.item.b_p_ff
			a_buf___6.item.b_p_ff := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("unix")))
			l_r := fileio_inst.buf_write (a_buf___6, a_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (1).to_integer_32, a_buf___6.item.b_ml.ml_line_count, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), 0, 0, 0, 1)
			option_inst.free_string_option (a_buf___6.item.b_p_ff)
			a_buf___6.item.b_p_ff := l_save_ff
			Result := l_r
		end

	diffopt_changed: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_diff_context_new: INTEGER_32
			l_diff_flags_new: INTEGER_32
			l_diff_foldcolumn_new: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_tp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_diff_context_new := 6
					l_diff_flags_new := 0
					l_diff_foldcolumn_new := 2
					l_p___0.item := option_inst.p_dip.item
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_p___0.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("filler"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_p___0.item := l_p___0.item + (6)
						l_diff_flags_new := (l_diff_flags_new).bit_or ((1))
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("context:"), (8).to_natural_32)) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0.item[8]).to_integer_32 >= 48 then
							if (l_p___0.item[8]).to_integer_32 <= 57 then
								l_p___0.item := l_p___0.item + (8)
								l_diff_context_new := (charset_inst.getdigits (l_p___0)).to_integer_32
							else
								l_pos := -1 + 8 -- goto _L
							end
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("icase"), (5).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (5)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((2))
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("iwhite"), (6).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (6)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((4))
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("horizontal"), (10).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (10)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((8))
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("vertical"), (8).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (8)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((16))
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("foldcolumn:"), (11).to_natural_32)) = 0 then
							if (l_p___0.item[11]).to_integer_32 >= 48 then
								if (l_p___0.item[11]).to_integer_32 <= 57 then
									l_p___0.item := l_p___0.item + (11)
									l_diff_foldcolumn_new := (charset_inst.getdigits (l_p___0)).to_integer_32
								end
							end
						end
				when 9 then -- if done
						if (l_p___0.item.item).to_integer_32 /= 44 then
							if (l_p___0.item.item).to_integer_32 /= 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called and then ((l_p___0.item.item).to_integer_32 = 44) then
							l_p___0.item := l_p___0.item + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if not js.return_called and then (((l_diff_flags_new).bit_and (8)).to_boolean) then
						if ((l_diff_flags_new).bit_and (16)).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if diff_flags /= l_diff_flags_new then
							l_tp := globals_inst.first_tabpage
							from
							until
								l_tp.is_void
							loop
								l_tp.item.tp_diff_invalid := 1
								l_tp := l_tp.item.tp_next
							end
						end
						diff_flags := l_diff_flags_new
						globals_inst.diff_context := l_diff_context_new
						globals_inst.diff_foldcolumn := l_diff_foldcolumn_new
						diff_redraw (1)
						normal_inst.check_scrollbind ((0).to_integer_32, 0)
						Result := 1
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diffopt_horizontal: INTEGER_32
		do
			Result := (((diff_flags).bit_and (8)) /= 0).to_integer
		end

	ex_diffgetput (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_count___2: INTEGER_32
			l_off___0: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_dprev: CE_POINTER [PD_DIFFBLOCK_S]
			l_dfree: CE_POINTER [PD_DIFFBLOCK_S]
			l_idx_cur: INTEGER_32
			l_idx_other: INTEGER_32
			l_idx_from: INTEGER_32
			l_idx_to: INTEGER_32
			l_i___0: INTEGER_32
			l_added: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_start_skip: INTEGER_32
			l_end_skip: INTEGER_32
			l_new_count: INTEGER_32
			l_buf_empty: INTEGER_32
			l_found_not_ma: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_nr: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dp.make
			create l_dprev.make
			create l_dfree.make
			create l_p___0.make
			create l_aco.make (<<1>>)
			create l_buf___6.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_off___0 := (0).to_integer_32
					l_found_not_ma := 0
					l_idx_cur := diff_buf_idx (globals_inst.curbuf)
					if l_idx_cur = 4 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E99: Current buffer is not in diff mode"))))).do_nothing
						js.return
					end
					if not js.return_called then
						if ((a_eap.item.arg).item).to_integer_32 = 0 then
							l_idx_other := 0
							from
							until
								not (not js.loop_done and then (l_idx_other < 4))
							loop
								if not (globals_inst.curtab.item.tp_diffbuf[l_idx_other]).is_equal (globals_inst.curbuf) then
									if not (globals_inst.curtab.item.tp_diffbuf[l_idx_other]).is_void then
										if a_eap.item.cmdidx /= 109 then
											js.break
										elseif ((globals_inst.curtab.item.tp_diffbuf[l_idx_other]).item.b_p_ma).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_found_not_ma := 1
										end
									end
								end
								if not js.loop_jumped then
									l_idx_other := l_idx_other + 1
								end
							end
							if l_idx_other = 4 then
								if l_found_not_ma.to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E793: No other buffer in diff mode is modifiable"))))).do_nothing
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E100: No other buffer in diff mode"))))).do_nothing
								end
								js.return
							end
							if not js.return_called then
								l_i___0 := l_idx_other + 1
								from
								until
									not (not js.loop_done and then (l_i___0 < 4))
								loop
									if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_equal (globals_inst.curbuf) then
										if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
											if a_eap.item.cmdidx /= 109 then
												l_tmp___2 := gettext (ce_string ("E101: More than two buffers in diff mode, don%'t know which one to use"))
												message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
												js.return
											elseif ((globals_inst.curtab.item.tp_diffbuf[l_i___0]).item.b_p_ma).to_boolean then
												l_tmp___2 := gettext (ce_string ("E101: More than two buffers in diff mode, don%'t know which one to use"))
												message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
												js.return
											end
										end
									end
									if not js.return_called then
										l_i___0 := l_i___0 + 1
									end
								end
							end
						else
							l_p___0 := a_eap.item.arg + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32
							from
							until
								js.loop_done
							loop
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > ((a_eap.item.arg).c_pointer.to_integer_32).to_natural_32 then
									if (l_p___0[-1]).to_integer_32 /= 32 then
										if (l_p___0[-1]).to_integer_32 /= 9 then
											js.break
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 - 1
								end
							end
							l_i___0 := 0
							from
							until
								js.loop_done
							loop
								if (charset_inst.vim_isdigit ((a_eap.item.arg[l_i___0]).to_integer_32)).to_boolean then
									if not (((a_eap.item.arg + l_i___0).c_pointer.to_integer_32).to_natural_32 < (l_p___0.c_pointer.to_integer_32).to_natural_32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							if (a_eap.item.arg + l_i___0).is_equal (l_p___0) then
								l_i___0 := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32
							else
								l_i___0 := buffer_inst.buflist_findpat (a_eap.item.arg, l_p___0, 0, 1)
								if l_i___0 < 0 then
									js.return
								end
							end
							if not js.return_called then
								l_buf___6 := buffer_inst.buflist_findnr (l_i___0)
								if l_buf___6.is_void then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E102: Can%'t find buffer %"%%s%"")))), a_eap.item.arg).do_nothing
									js.return
								end
							end
							if not js.return_called and then (l_buf___6.is_equal (globals_inst.curbuf)) then
								js.return
							end
							if not js.return_called then
								l_idx_other := diff_buf_idx (l_buf___6)
								if l_idx_other = 4 then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E103: Buffer %"%%s%" is not in diff mode")))), a_eap.item.arg).do_nothing
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						diff_busy := 1
						if a_eap.item.addr_count /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if a_eap.item.cmdidx /= 106 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_eap.item.line1 = globals_inst.curbuf.item.b_ml.ml_line_count then
							if (diff_check (globals_inst.curwin, a_eap.item.line1)) = 0 then
								if a_eap.item.line1 = 1 then
									a_eap.item.line2 := (a_eap.item.line2) + 1
								elseif (diff_check (globals_inst.curwin, a_eap.item.line1 - 1)) = 0 then
									a_eap.item.line2 := (a_eap.item.line2) + 1
								else
									l_pos := -1 + 5 -- goto _L___1
								end
							else
								l_pos := -1 + 5 -- goto _L___1
							end
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___1:
						if a_eap.item.line1 > 0 then
							a_eap.item.line1 := (a_eap.item.line1) - 1
						end
				when 6 then -- if done
						if a_eap.item.cmdidx = 106 then
							l_idx_from := l_idx_other
							l_idx_to := l_idx_cur
						else
							l_idx_from := l_idx_cur
							l_idx_to := l_idx_other
							fileio_inst.aucmd_prepbuf (l_aco, globals_inst.curtab.item.tp_diffbuf[l_idx_other])
						end
						if not (globals_inst.curbuf.item.b_changed).to_boolean then
							misc1_inst.change_warning (0)
							if (diff_buf_idx (globals_inst.curbuf)) /= l_idx_to then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E787: Buffer changed unexpectedly"))))).do_nothing
								js.return
							end
						end
				when 7 then -- if done
					if not js.return_called then
						l_dprev := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
						l_dp := globals_inst.curtab.item.tp_first_diff
						from
						until
							not (not js.loop_done and then (not l_dp.is_void))
						loop
							if l_dp.item.df_lnum[l_idx_cur] > a_eap.item.line2 + l_off___0 then
								js.break
							end
							if not js.loop_jumped then
								l_dfree := create {CE_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
								l_lnum := l_dp.item.df_lnum[l_idx_to]
								l_count___2 := (l_dp.item.df_count[l_idx_to]).to_integer_32
								if l_dp.item.df_lnum[l_idx_cur] + l_dp.item.df_count[l_idx_cur] > a_eap.item.line1 + l_off___0 then
									if (undo_inst.u_save (l_lnum - 1, l_lnum + l_count___2.to_integer_32)) /= 0 then
										l_start_skip := 0
										l_end_skip := 0
										if a_eap.item.addr_count > 0 then
											l_start_skip := ((a_eap.item.line1 + l_off___0) - l_dp.item.df_lnum[l_idx_cur]).to_integer_32
											if l_start_skip > 0 then
												if l_start_skip > l_count___2 then
													l_lnum := l_lnum + l_count___2.to_integer_32
													l_count___2 := 0
												else
													l_count___2 := l_count___2 - l_start_skip
													l_lnum := l_lnum + l_start_skip.to_integer_32
												end
											else
												l_start_skip := 0
											end
											l_end_skip := (((l_dp.item.df_lnum[l_idx_cur] + l_dp.item.df_count[l_idx_cur]) - 1) - (a_eap.item.line2 + l_off___0)).to_integer_32
											if l_end_skip > 0 then
												if l_idx_cur = l_idx_from then
													l_i___0 := ((l_dp.item.df_count[l_idx_cur] - l_start_skip.to_integer_32) - l_end_skip.to_integer_32).to_integer_32
													if l_count___2 > l_i___0 then
														l_count___2 := l_i___0
													end
												else
													l_count___2 := l_count___2 - l_end_skip
													l_end_skip := ((l_dp.item.df_count[l_idx_from] - l_start_skip.to_integer_32) - l_count___2.to_integer_32).to_integer_32
													if l_end_skip < 0 then
														l_end_skip := 0
													end
												end
											else
												l_end_skip := 0
											end
										end
										l_buf_empty := 0
										l_added := 0
										l_i___0 := 0
										from
										until
											not (l_i___0 < l_count___2)
										loop
											l_buf_empty := (globals_inst.curbuf.item.b_ml.ml_line_count = 1).to_integer
											memline_inst.ml_delete (l_lnum, 0).do_nothing
											l_added := l_added - 1
											l_i___0 := l_i___0 + 1
										end
										l_i___0 := 0
										from
										until
											not (not js.loop_done and then (l_i___0.to_integer_32 < (l_dp.item.df_count[l_idx_from] - l_start_skip.to_integer_32) - l_end_skip.to_integer_32))
										loop
											l_nr := (l_dp.item.df_lnum[l_idx_from] + l_start_skip.to_integer_32) + l_i___0.to_integer_32
											if l_nr > (globals_inst.curtab.item.tp_diffbuf[l_idx_from]).item.b_ml.ml_line_count then
												js.break
											end
											if not js.loop_jumped then
												l_p___0 := misc2_inst.vim_strsave ((memline_inst.ml_get_buf (globals_inst.curtab.item.tp_diffbuf[l_idx_from], l_nr, 0)))
												if not l_p___0.is_void then
													memline_inst.ml_append ((l_lnum + l_i___0.to_integer_32) - 1, l_p___0, 0, 0).do_nothing
													misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
													l_added := l_added + 1
													if l_buf_empty.to_boolean then
														if globals_inst.curbuf.item.b_ml.ml_line_count = 2 then
															l_buf_empty := 0
															memline_inst.ml_delete ((2).to_integer_32, 0).do_nothing
														end
													end
												end
												l_i___0 := l_i___0 + 1
											end
										end
										l_new_count := (l_dp.item.df_count[l_idx_to] + l_added.to_integer_32).to_integer_32
										l_dp.item.df_count[l_idx_to] := l_new_count.to_integer_32
										if l_start_skip = 0 then
											if l_end_skip = 0 then
												l_i___0 := 0
												from
												until
													not (not js.loop_done and then (l_i___0 < 4))
												loop
													if not (globals_inst.curtab.item.tp_diffbuf[l_i___0]).is_void then
														if l_i___0 /= l_idx_from then
															if l_i___0 /= l_idx_to then
																if not (diff_equal_entry (l_dp, l_idx_from, l_i___0)).to_boolean then
																	js.break
																end
															end
														end
													end
													if not js.loop_jumped then
														l_i___0 := l_i___0 + 1
													end
												end
												if l_i___0 = 4 then
													l_dfree := l_dp
													l_dp := l_dp.item.df_next
													if l_dprev.is_void then
														globals_inst.curtab.item.tp_first_diff := l_dp
													else
														l_dprev.item.df_next := l_dp
													end
												end
											end
										end
										if l_added /= 0 then
											mark_inst.mark_adjust (l_lnum, (l_lnum + l_count___2.to_integer_32) - 1, 2_147_483_647, l_added.to_integer_32)
											if globals_inst.curwin.item.w_cursor.lnum >= l_lnum then
												if globals_inst.curwin.item.w_cursor.lnum >= l_lnum + l_count___2.to_integer_32 then
													globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_cursor.lnum + l_added.to_integer_32
												elseif l_added < 0 then
													globals_inst.curwin.item.w_cursor.lnum := l_lnum
												end
											end
										end
										misc1_inst.changed_lines (l_lnum, 0, l_lnum + l_count___2.to_integer_32, l_added.to_integer_32)
										if not l_dfree.is_void then
											diff_fold_update (l_dfree, l_idx_to)
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dfree))
										else
											l_dp.item.df_count[l_idx_to] := l_new_count.to_integer_32
										end
										if l_idx_cur = l_idx_to then
											l_off___0 := l_off___0 + l_added.to_integer_32
										end
									end
								end
								if l_dfree.is_void then
									l_dprev := l_dp
									l_dp := l_dp.item.df_next
								end
							end
						end
						if a_eap.item.cmdidx /= 106 then
							if globals_inst.KeyTyped.to_boolean then
								undo_inst.u_sync (0)
							end
							fileio_inst.aucmd_restbuf (l_aco)
						end
						diff_busy := 0
						misc2_inst.check_cursor
						move_inst.changed_line_abv_curs
						diff_redraw (0)
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_diffgetput_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_diffgetput)
		end

	ex_diffoff (a_eap: CE_POINTER [PD_EXARG])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_diffwin: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_old_curwin___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curwin___1 := globals_inst.curwin
					l_diffwin := 0
					l_wp___0 := globals_inst.firstwin
				when 1 then -- loop condition:
					if l_wp___0.is_void then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_wp___0.is_equal (globals_inst.curwin)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if not ((a_eap.item.forceit).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not ((l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_wp___0.item.w_onebuf_opt.wo_diff := 0
						l_wp___0.item.w_onebuf_opt.wo_crb := 0
						l_wp___0.item.w_onebuf_opt.wo_scb := 0
						l_wp___0.item.w_onebuf_opt.wo_wrap := 1
						globals_inst.curwin := l_wp___0
						globals_inst.curbuf := globals_inst.curwin.item.w_buffer
						option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fdm")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("manual")), 5, 0)
						globals_inst.curwin := l_old_curwin___1
						globals_inst.curbuf := globals_inst.curwin.item.w_buffer
						l_wp___0.item.w_onebuf_opt.wo_fdc := 0
						l_wp___0.item.w_onebuf_opt.wo_fen := 0
						l_wp___0.item.w_onebuf_opt.wo_fdl := 0
						fold_inst.foldUpdateAll (l_wp___0)
						move_inst.changed_window_setting_win (l_wp___0)
						diff_buf_adjust (l_wp___0)
				when 8 then -- if done | if done
						l_diffwin := (l_diffwin).bit_or ((l_wp___0.item.w_onebuf_opt.wo_diff))
						l_wp___0 := l_wp___0.item.w_next
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if not l_diffwin.to_boolean then
						if not (misc2_inst.vim_strchr (option_inst.p_sbo.item, ('h').code)).is_void then
							ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("set sbo-=hor"))).do_nothing
						end
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_diffoff_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_diffoff)
		end

	ex_diffpatch (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp_orig: CE_POINTER [NATURAL_8]
			l_tmp_new: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_buflen: NATURAL_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_newname: CE_POINTER [NATURAL_8]
			l_dirbuf: CE_ARRAY [NATURAL_8]
			l_fullname: CE_POINTER [NATURAL_8]
			l_browseFile: CE_POINTER [NATURAL_8]
			l_browse_flag: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___1: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___16: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp_orig.make
			create l_tmp_new.make
			create l_buf___6.make
			create l_old_curwin___1.make
			create l_newname.make
			create l_dirbuf.make (<<4_096>>)
			create l_fullname.make
			create l_browseFile.make
			create l_st.make (<<1>>)
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___12.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_old_curwin___1 := globals_inst.curwin
					l_newname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_fullname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_browseFile := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_browse_flag := globals_inst.cmdmod.item.browse
					if (globals_inst.cmdmod.item.browse).to_boolean then
						l_browseFile := message_inst.do_browse (0, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Patch file")))), a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("All Files (*)%T*%N")), create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
						if l_browseFile.is_void then
							js.return
						end
						if not js.return_called then
							a_eap.item.arg := l_browseFile
							globals_inst.cmdmod.item.browse := 0
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp_orig := fileio_inst.vim_tempname (('o').code)
						l_tmp_new := fileio_inst.vim_tempname (('n').code)
						if l_tmp_orig.is_void then
							l_pos := -1 + 5 -- goto theend
						elseif l_tmp_new.is_void then
							l_pos := -1 + 5 -- goto theend
						end
				when 2 then
						if (fileio_inst.buf_write (globals_inst.curbuf, l_tmp_orig, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (1).to_integer_32, globals_inst.curbuf.item.b_ml.ml_line_count, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), 0, 0, 0, 1)) = 0 then
							l_pos := -1 + 5 -- goto theend
						end
				when 3 then
						l_fullname := misc1_inst.FullName_save (a_eap.item.arg, 0)
						l_tmp___1 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_orig))
						if not l_fullname.is_void then
							l_tmp___4 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fullname)))
						else
							l_tmp___4 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg)))
						end
						l_buflen := ((l_tmp___1 + l_tmp___4) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new)))) + {NATURAL_32} 16
						l_buf___6 := misc2_inst.alloc (l_buflen)
						if l_buf___6.is_void then
							l_pos := -1 + 5 -- goto theend
						end
				when 4 then
						if (os_unix_inst.mch_dirname (l_dirbuf, 4_096)) /= 1 then
							l_dirbuf[0] := (('%/0/').code).to_natural_8
						elseif (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirbuf))) /= 0 then
							l_dirbuf[0] := (('%/0/').code).to_natural_8
						else
							if not globals_inst.vim_tempdir.is_void then
								globals_inst.ignored := os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.vim_tempdir))
							else
								globals_inst.ignored := os_unix_inst.mch_chdir (ce_string ("/tmp"))
							end
							fileio_inst.shorten_fnames (1)
						end
						if (option_inst.p_pex.item.item).to_integer_32 /= 0 then
							if not l_fullname.is_void then
								l_tmp___8 := l_fullname
							else
								l_tmp___8 := a_eap.item.arg
							end
							eval_inst.eval_patch (l_tmp_orig, l_tmp___8, l_tmp_new)
						else
							if not l_fullname.is_void then
								l_tmp___9 := l_fullname
							else
								l_tmp___9 := a_eap.item.arg
							end
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), l_buflen, ce_string ("patch -o %%s %%s < %"%%s%""), l_tmp_new, l_tmp_orig, l_tmp___9]).do_nothing
							fileio_inst.block_autocmds
							misc2_inst.call_shell (l_buf___6, 5).do_nothing
							fileio_inst.unblock_autocmds
						end
						if (l_dirbuf[0]).to_integer_32 /= 0 then
							if (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirbuf))) /= 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_prev_dir))))).do_nothing
							end
							fileio_inst.shorten_fnames (1)
						end
						screen_inst.redraw_later (50)
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new)).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string (".orig")).do_nothing
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6)).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new)).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string (".rej")).do_nothing
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6)).do_nothing
						if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new), l_st)) < 0 then
							l_tmp___12 := gettext (ce_string ("E816: Cannot read patch output"))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12)).do_nothing
						elseif l_st.item.st_size = 0 then
							l_tmp___12 := gettext (ce_string ("E816: Cannot read patch output"))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12)).do_nothing
						else
							if not (globals_inst.curbuf.item.b_fname).is_void then
								l_newname := misc2_inst.vim_strnsave (globals_inst.curbuf.item.b_fname, ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_fname))) + {NATURAL_32} 4).to_integer_32)
								if not l_newname.is_void then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newname), ce_string (".new")).do_nothing
								end
							end
							globals_inst.need_mouse_correct := 1
							globals_inst.cmdmod.item.tab := 0
							if ((diff_flags).bit_and (16)).to_boolean then
								l_tmp___16 := 2
							else
								l_tmp___16 := 0
							end
							if (window_inst.win_split (0, l_tmp___16)) /= 0 then
								a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_split
								a_eap.item.arg := l_tmp_new
								ex_docmd_inst.do_exedit (a_eap, l_old_curwin___1)
								if not globals_inst.curwin.is_equal (l_old_curwin___1) then
									if (window_inst.win_valid (l_old_curwin___1)).to_boolean then
										diff_win_options (globals_inst.curwin, 1)
										diff_win_options (l_old_curwin___1, 1)
										if not l_newname.is_void then
											a_eap.item.arg := l_newname
											ex_cmds_inst.ex_file (a_eap)
											if (fileio_inst.au_has_group (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetypedetect")))).to_boolean then
												ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":doau filetypedetect BufRead"))).do_nothing
											end
										end
									end
								end
							end
						end
				when 5 then -- theend:
						if not l_tmp_orig.is_void then
							unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_orig)).do_nothing
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp_orig))
						if not l_tmp_new.is_void then
							unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new)).do_nothing
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp_new))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newname))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fullname))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_browseFile))
						globals_inst.cmdmod.item.browse := l_browse_flag
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_diffpatch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_diffpatch)
		end

	ex_diffsplit (a_eap: CE_POINTER [PD_EXARG])
		local
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
		do
			create l_old_curwin___1.make

			l_old_curwin___1 := globals_inst.curwin
			globals_inst.need_mouse_correct := 1
			globals_inst.cmdmod.item.tab := 0
			if ((diff_flags).bit_and (16)).to_boolean then
				l_tmp := 2
			else
				l_tmp := 0
			end
			if (window_inst.win_split (0, l_tmp)) /= 0 then
				a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_split
				globals_inst.curwin.item.w_onebuf_opt.wo_diff := 1
				ex_docmd_inst.do_exedit (a_eap, l_old_curwin___1)
				if not globals_inst.curwin.is_equal (l_old_curwin___1) then
					diff_win_options (globals_inst.curwin, 1)
					diff_win_options (l_old_curwin___1, 1)
				end
			end
		end

	ex_diffsplit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_diffsplit)
		end

	ex_diffthis (a_eap: CE_POINTER [PD_EXARG])
		do
			diff_win_options (globals_inst.curwin, 1)
		end

	ex_diffthis_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_diffthis)
		end

	ex_diffupdate (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_idx_orig: INTEGER_32
			l_idx_new: INTEGER_32
			l_tmp_orig: CE_POINTER [NATURAL_8]
			l_tmp_new: CE_POINTER [NATURAL_8]
			l_tmp_diff: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_ok: INTEGER_32
			l_io_error: INTEGER_32
			l_linebuf: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_tmp_orig.make
			create l_tmp_new.make
			create l_tmp_diff.make
			create l_fd.make
			create l_linebuf.make (<<50>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_io_error := 0
					diff_clear (globals_inst.curtab)
					globals_inst.curtab.item.tp_diff_invalid := 0
					l_idx_orig := 0
					from
					until
						not (not js.loop_done and then (l_idx_orig < 4))
					loop
						if not (globals_inst.curtab.item.tp_diffbuf[l_idx_orig]).is_void then
							js.break
						end
						if not js.loop_jumped then
							l_idx_orig := l_idx_orig + 1
						end
					end
					if l_idx_orig = 4 then
						js.return
					end
					if not js.return_called then
						l_idx_new := l_idx_orig + 1
						from
						until
							not (not js.loop_done and then (l_idx_new < 4))
						loop
							if not (globals_inst.curtab.item.tp_diffbuf[l_idx_new]).is_void then
								js.break
							end
							if not js.loop_jumped then
								l_idx_new := l_idx_new + 1
							end
						end
						if l_idx_new = 4 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp_orig := fileio_inst.vim_tempname (('o').code)
						l_tmp_new := fileio_inst.vim_tempname (('n').code)
						l_tmp_diff := fileio_inst.vim_tempname (('d').code)
						if l_tmp_orig.is_void then
							l_pos := -1 + 5 -- goto theend
						elseif l_tmp_new.is_void then
							l_pos := -1 + 5 -- goto theend
						elseif l_tmp_diff.is_void then
							l_pos := -1 + 5 -- goto theend
						end
				when 2 then
						from
						until
							js.loop_done
						loop
							l_ok := 0
							l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_orig), ce_string ("w"))
							if l_fd.is_void then
								l_io_error := 1
							else
								if (fwrite (create {CE_POINTER [ANY]}.make_cast (ce_string ("line1%N")), (6).to_natural_32, (1).to_natural_32, l_fd)) /= {NATURAL_32} 1 then
									l_io_error := 1
								end
								fclose (l_fd).do_nothing
								l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new), ce_string ("w"))
								if l_fd.is_void then
									l_io_error := 1
								else
									if (fwrite (create {CE_POINTER [ANY]}.make_cast (ce_string ("line2%N")), (6).to_natural_32, (1).to_natural_32, l_fd)) /= {NATURAL_32} 1 then
										l_io_error := 1
									end
									fclose (l_fd).do_nothing
									diff_file (l_tmp_orig, l_tmp_new, l_tmp_diff)
									l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_diff), ce_string ("r"))
									if l_fd.is_void then
										l_io_error := 1
									else
										from
										until
											js.loop_done
										loop
											if (fileio_inst.vim_fgets (l_linebuf, 50, l_fd)).to_boolean then
												js.break
											end
											if not js.loop_jumped then
												if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_linebuf), ce_string ("1c1"), (3).to_natural_32)) = 0 then
													l_ok := 1
												end
											end
										end
										fclose (l_fd).do_nothing
									end
									unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_diff)).do_nothing
									unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new)).do_nothing
								end
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_orig)).do_nothing
							end
							if (option_inst.p_dex.item.item).to_integer_32 /= 0 then
								js.break
							end
							if not js.loop_jumped and then (diff_a_works /= 2) then
								js.break
							end
							if not js.loop_jumped then
								diff_a_works := l_ok
								if l_ok.to_boolean then
									js.break
								end
							end
						end
						if not l_ok.to_boolean then
							if l_io_error.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E810: Cannot read or write temp files"))))).do_nothing
							end
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E97: Cannot create diffs"))))).do_nothing
							diff_a_works := 2
							l_pos := -1 + 5 -- goto theend
						end
				when 3 then
						l_buf___6 := globals_inst.curtab.item.tp_diffbuf[l_idx_orig]
						if (diff_write (l_buf___6, l_tmp_orig)) = 0 then
							l_pos := -1 + 5 -- goto theend
						end
				when 4 then
						l_idx_new := l_idx_orig + 1
						from
						until
							not (l_idx_new < 4)
						loop
							l_buf___6 := globals_inst.curtab.item.tp_diffbuf[l_idx_new]
							if l_buf___6.is_void then
								js.continue
							end
							if not js.loop_jumped then
								if (diff_write (l_buf___6, l_tmp_new)) = 0 then
									js.continue
								end
							end
							if not js.loop_jumped then
								diff_file (l_tmp_orig, l_tmp_new, l_tmp_diff)
								diff_read (l_idx_orig, l_idx_new, l_tmp_diff)
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_diff)).do_nothing
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_new)).do_nothing
							end
							l_idx_new := l_idx_new + 1
						end
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_orig)).do_nothing
						globals_inst.curwin.item.w_valid_cursor.lnum := (0).to_integer_32
						diff_redraw (1)
				when 5 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp_orig))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp_new))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp_diff))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_diffupdate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_diffupdate)
		end

	nv_diffgetput (a_put: INTEGER_32)
		local
			l_ea: CE_ARRAY [PD_EXARG]
		do
			create l_ea.make (<<1>>)

			l_ea.item.arg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			if a_put.to_boolean then
				l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_diffput
			else
				l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_diffget
			end
			l_ea.item.addr_count := 0
			l_ea.item.line1 := globals_inst.curwin.item.w_cursor.lnum
			l_ea.item.line2 := globals_inst.curwin.item.w_cursor.lnum
			ex_diffgetput (l_ea)
		end

end
