class
	P_GUI_GTK

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create find_widgets.make (<<1>>)
			create menu_stock_ids.make (<<32>>)
			create repl_widgets.make (<<1>>)
			create suffixes.make (<<3, 4>>)
		end

feature {ANY} -- attributes

	find_widgets: CE_ARRAY [PD_SHAREDFINDREPLACE]

	menu_stock_ids: CE_ARRAY [CE_POINTER [INTEGER_8]]

	popup_mouse_pos: INTEGER_32 assign set_popup_mouse_pos

	set_popup_mouse_pos (a_popup_mouse_pos: INTEGER_32)
		do
			popup_mouse_pos := a_popup_mouse_pos
		end

	repl_widgets: CE_ARRAY [PD_SHAREDFINDREPLACE]

	suffixes: CE_ARRAY [CE_ARRAY [INTEGER_8]]

feature {ANY} -- routines

	add_stock_icon (a_factory: CE_POINTER [SD_GTKICONFACTORY]; a_stock_id: CE_POINTER [INTEGER_8]; a_inline_data: CE_POINTER [NATURAL_8]; a_data_length: INTEGER_32)
		local
			l_pixbuf: CE_POINTER [ANY]
			l_icon_set: CE_POINTER [ANY]
		do
			create l_pixbuf.make
			create l_icon_set.make

			l_pixbuf := gdk_pixbuf_new_from_inline (a_data_length, a_inline_data, 0, create {CE_POINTER [CE_POINTER [SD_GERROR]]}.make_shared (default_pointer))
			l_icon_set := gtk_icon_set_new_from_pixbuf (l_pixbuf)
			gtk_icon_factory_add (a_factory, a_stock_id, l_icon_set)
			gtk_icon_set_unref (l_icon_set)
			g_object_unref (l_pixbuf)
		end

	adjustment_value_changed (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT]; a_data: CE_POINTER [ANY])
		local
			l_sb: CE_POINTER [PD_GUISCROLLBAR]
			l_value: INTEGER_32
			l_dragging: INTEGER_32
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_state: CE_ARRAY [NATURAL_32]
			l_width: CE_ARRAY [INTEGER_32]
			l_height: CE_ARRAY [INTEGER_32]
		do
			create l_sb.make
			create l_x___0.make (<<1>>)
			create l_y.make (<<1>>)
			create l_state.make (<<1>>)
			create l_width.make (<<1>>)
			create l_height.make (<<1>>)

			l_dragging := 0
			if (mbyte_inst.im_is_preediting).to_boolean then
				mbyte_inst.xim_reset
			end
			l_sb := gui_inst.gui_find_scrollbar ((a_data.c_pointer.to_integer_32).to_integer_32)
			l_value := (a_adjustment.item.value).truncated_to_integer
			if not l_sb.is_void then
				l_dragging := 1
				if not (l_sb.item.wp).is_void then
					gdk_window_get_pointer ((l_sb.item.id).item.window, l_x___0, l_y, l_state).do_nothing
					gdk_drawable_get_size ((l_sb.item.id).item.window, l_width, l_height)
					if l_x___0.item >= 0 then
						if l_x___0.item < l_width.item then
							if l_y.item >= 0 then
								if l_y.item < l_height.item then
									if l_y.item < l_width.item then
										l_dragging := 0
										l_value := (l_sb.item.wp).item.w_topline - 2
									elseif l_y.item > l_height.item - l_width.item then
										l_dragging := 0
										l_value := (l_sb.item.wp).item.w_topline
									end
								end
							end
						end
					end
				end
			end
			gui_inst.gui_drag_scrollbar (l_sb, l_value, l_dragging)
		end

	adjustment_value_changed_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent adjustment_value_changed)
		end

	button_equal (a_a: CE_POINTER [INTEGER_8]; a_b: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_a: CE_POINTER [INTEGER_8]
			l_b: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_a.make
			create l_b.make

			l_a := a_a
			l_b := a_b
			from
			until
				js.loop_done
			loop
				if (l_a[0]).to_integer_32 /= 0 then
					if (l_b[0]).to_integer_32 = 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped and then ((l_a[0]).to_integer_32 = 95) then
					l_a := l_a + 1
					if (l_a[0]).to_integer_32 = 0 then
						js.break
					end
				end
				if not js.loop_jumped and then ((l_b[0]).to_integer_32 = 95) then
					l_b := l_b + 1
					if (l_b[0]).to_integer_32 = 0 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_tmp___0 := g_unichar_tolower ((g_utf8_get_char (l_a)))
					if l_tmp___0 /= (g_unichar_tolower ((g_utf8_get_char (l_b)))) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_a := (l_a + (g_utf8_skip[((create {CE_POINTER [NATURAL_8]}.make_cast (l_a)).item).to_integer_32]).to_integer_32)
						l_b := (l_b + (g_utf8_skip[((create {CE_POINTER [NATURAL_8]}.make_cast (l_b)).item).to_integer_32]).to_integer_32)
					end
				end
			end
			if not js.return_called then
				if (l_a[0]).to_integer_32 = 0 then
					if (l_b[0]).to_integer_32 = 0 then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
				else
					l_tmp___3 := 0
				end
				Result := l_tmp___3
			end
		end

	convert_localized_message (a_buffer: CE_POINTER [CE_POINTER [NATURAL_8]]; a_message: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
		do
			if globals_inst.output_conv.item.vc_type = 0 then
				Result := a_message
				js.return
			end
			if not js.return_called then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_buffer.item))
				a_buffer.item := mbyte_inst.string_convert (globals_inst.output_conv, create {CE_POINTER [NATURAL_8]}.make_cast (a_message), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				Result := (create {CE_POINTER [INTEGER_8]}.make_cast (a_buffer.item))
			end
		end

	create_image_button (a_stock_id: CE_POINTER [INTEGER_8]; a_label: CE_POINTER [INTEGER_8]): CE_POINTER [SD_GTKWIDGET]
		local
			l_text: CE_POINTER [NATURAL_8]
			l_box: CE_POINTER [SD_GTKWIDGET]
			l_alignment: CE_POINTER [SD_GTKWIDGET]
			l_button: CE_POINTER [SD_GTKWIDGET]
			l_tmp___0: CE_POINTER [SD_GTKWIDGET]
			l_tmp___3: CE_POINTER [SD_GTKWIDGET]
		do
			create l_text.make
			create l_box.make
			create l_alignment.make
			create l_button.make
			create l_tmp___0.make
			create l_tmp___3.make

			if globals_inst.output_conv.item.vc_type = 0 then
				l_text := create {CE_POINTER [NATURAL_8]}.make_cast (a_label)
			elseif a_label.is_void then
				l_text := create {CE_POINTER [NATURAL_8]}.make_cast (a_label)
			else
				l_text := (mbyte_inst.string_convert (globals_inst.output_conv, create {CE_POINTER [NATURAL_8]}.make_cast (a_label), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
			l_box := gtk_hbox_new (0, 3)
			l_tmp___0 := gtk_image_new_from_stock (a_stock_id, {SC_GTKICONSIZE}.GTK_ICON_SIZE_BUTTON)
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), (gtk_box_get_type)))), l_tmp___0, 0, 0, (0).to_natural_32)
			l_tmp___3 := gtk_label_new (create {CE_POINTER [INTEGER_8]}.make_cast (l_text))
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), (gtk_box_get_type)))), l_tmp___3, 0, 0, (0).to_natural_32)
			if globals_inst.output_conv.item.vc_type = 0 then
				l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
				l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			l_alignment := gtk_alignment_new ((0.5).truncated_to_real, (0.5).truncated_to_real, (0.0).truncated_to_real, (0.0).truncated_to_real)
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_alignment), (gtk_container_get_type)))), l_box)
			gtk_widget_show_all (l_alignment)
			l_button := gtk_button_new
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_button), (gtk_container_get_type)))), l_alignment)
			Result := l_button
		end

	create_menu_icon (a_menu___1: CE_POINTER [PD_VIMMENU]; a_icon_size: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		local
			l_image: CE_POINTER [SD_GTKWIDGET]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_stock_id: CE_POINTER [INTEGER_8]
			l_n_ids: INTEGER_32
		do
			create l_image.make
			create l_buf___6.make (<<4_096>>)
			create l_stock_id.make

			l_image := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			if not (a_menu___1.item.iconfile).is_void then
				if (lookup_menu_iconfile (a_menu___1.item.iconfile, l_buf___6)).to_boolean then
					l_image := load_menu_iconfile (l_buf___6, a_icon_size)
				end
			end
			if l_image.is_void then
				if not (a_menu___1.item.icon_builtin).to_boolean then
					if (lookup_menu_iconfile (a_menu___1.item.name, l_buf___6)).to_boolean then
						l_image := load_menu_iconfile (l_buf___6, a_icon_size)
					end
				end
			end
			if l_image.is_void then
				l_n_ids := (({PLATFORM}.Pointer_bytes.to_natural_32 * (32).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
				if a_menu___1.item.iconidx >= 0 then
					if a_menu___1.item.iconidx < l_n_ids then
						l_stock_id := menu_stock_ids[a_menu___1.item.iconidx]
					else
						l_stock_id := ce_string ("gtk-missing-image")
					end
				else
					l_stock_id := ce_string ("gtk-missing-image")
				end
				l_image := gtk_image_new_from_stock (l_stock_id, a_icon_size)
			end
			Result := l_image
		end

	create_message_dialog (a_type: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_message: CE_POINTER [NATURAL_8]): CE_POINTER [SD_GTKWIDGET]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_message: CE_POINTER [NATURAL_8]
			l_dialog: CE_POINTER [SD_GTKWIDGET]
			l_message_type: NATURAL_32
			l_pos: INTEGER_32
		do
			create l_title.make
			create l_message.make
			create l_dialog.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_title := a_title
					l_message := a_message
					inspect a_type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_ERROR
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_WARNING
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 4
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_QUESTION
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					l_message_type := {SC_GTKMESSAGETYPE}.GTK_MESSAGE_INFO
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					if globals_inst.output_conv.item.vc_type = 0 then
						l_message := l_message
					elseif l_message.is_void then
						l_message := l_message
					else
						l_message := (mbyte_inst.string_convert (globals_inst.output_conv, l_message, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					l_dialog := gtk_message_dialog_new ([create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.mainwin), (gtk_window_get_type)))), {SC_GTKDIALOGFLAGS}.GTK_DIALOG_DESTROY_WITH_PARENT, l_message_type, {SC_GTKBUTTONSTYPE}.GTK_BUTTONS_NONE, ce_string ("%%s"), create {CE_POINTER [INTEGER_8]}.make_cast (l_message)])
					if globals_inst.output_conv.item.vc_type = 0 then
						l_message := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_message))
						l_message := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if not l_title.is_void then
						if globals_inst.output_conv.item.vc_type = 0 then
							l_title := l_title
						elseif l_title.is_void then
							l_title := l_title
						else
							l_title := (mbyte_inst.string_convert (globals_inst.output_conv, l_title, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						end
						gtk_window_set_title (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_window_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_title))
						if globals_inst.output_conv.item.vc_type = 0 then
							l_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						else
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_title))
							l_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
					elseif a_type = 0 then
						gtk_window_set_title (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_window_get_type)))), ce_string ("VIM"))
					end
					Result := l_dialog
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dialog_add_buttons (a_dialog: CE_POINTER [SD_GTKDIALOG]; a_button_string: CE_POINTER [NATURAL_8])
		local
			l_button_string: CE_POINTER [NATURAL_8]
			l_ok: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_ync: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_buttons: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_n_buttons: CE_ARRAY [INTEGER_32]
			l_idx: INTEGER_32
			l_vbutton_box: CE_POINTER [SD_GTKWIDGET]
			l_tmp: NATURAL_32
			l_label: CE_POINTER [INTEGER_8]
			l_label8: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_button_string.make
			create l_ok.make
			create l_ync.make
			create l_buttons.make
			create l_n_buttons.make (<<1>>)
			create l_vbutton_box.make
			create l_label.make
			create l_label8.make

			l_button_string := a_button_string
			l_n_buttons.item := 0
			l_button_string := misc2_inst.vim_strsave (l_button_string)
			if l_button_string.is_void then
				js.return
			end
			if not js.return_called then
				if not (misc2_inst.vim_strchr (option_inst.p_go.item, ('v').code)).is_void then
					l_vbutton_box := gtk_vbutton_box_new
					gtk_widget_show (l_vbutton_box)
					l_tmp := gtk_box_get_type
					gtk_box_pack_end (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_dialog), (gtk_dialog_get_type))))).item.vbox), l_tmp))), l_vbutton_box, 1, 0, (0).to_natural_32);
					(create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_dialog), (gtk_dialog_get_type))))).item.action_area := l_vbutton_box
				end
				l_ok := split_button_translation (ce_string ("&Ok"))
				l_ync := split_button_translation (ce_string ("&Yes%N&No%N&Cancel"))
				l_buttons := split_button_string (l_button_string, l_n_buttons)
				l_idx := 1
				from
				until
					not (l_idx <= l_n_buttons.item)
				loop
					l_label := l_buttons[(l_idx - 1)]
					if not l_ok.is_void then
						if not l_ync.is_void then
							if (button_equal (l_label, l_ok[0])).to_boolean then
								l_label := ce_string ("gtk-ok")
							elseif (button_equal (l_label, l_ync[0])).to_boolean then
								l_label := ce_string ("gtk-yes")
							elseif (button_equal (l_label, l_ync[1])).to_boolean then
								l_label := ce_string ("gtk-no")
							elseif (button_equal (l_label, l_ync[2])).to_boolean then
								l_label := ce_string ("gtk-cancel")
							elseif (button_equal (l_label, ce_string ("Ok"))).to_boolean then
								l_label := ce_string ("gtk-ok")
							elseif (button_equal (l_label, ce_string ("Yes"))).to_boolean then
								l_label := ce_string ("gtk-yes")
							elseif (button_equal (l_label, ce_string ("No"))).to_boolean then
								l_label := ce_string ("gtk-no")
							elseif (button_equal (l_label, ce_string ("Cancel"))).to_boolean then
								l_label := ce_string ("gtk-cancel")
							end
						end
					end
					if globals_inst.output_conv.item.vc_type = 0 then
						l_label8 := create {CE_POINTER [NATURAL_8]}.make_cast (l_label)
					elseif l_label.is_void then
						l_label8 := create {CE_POINTER [NATURAL_8]}.make_cast (l_label)
					else
						l_label8 := (mbyte_inst.string_convert (globals_inst.output_conv, create {CE_POINTER [NATURAL_8]}.make_cast (l_label), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					gtk_dialog_add_button (a_dialog, create {CE_POINTER [INTEGER_8]}.make_cast (l_label8), l_idx).do_nothing
					if globals_inst.output_conv.item.vc_type = 0 then
						l_label8 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_label8))
						l_label8 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					l_idx := l_idx + 1
				end
				if not l_ok.is_void then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ok.item))
				end
				if not l_ync.is_void then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ync.item))
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ok))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ync))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buttons))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_button_string))
			end
		end

	dialog_key_press_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTKEY]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_di: CE_POINTER [PD_DIALOGINFO]
			l_tmp___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_di.make

			l_di := create {CE_POINTER [PD_DIALOGINFO]}.make_cast (a_data)
			if (l_di.item.ignore_enter).to_boolean then
				if a_event.item.keyval = {NATURAL_32} 65_293 then
					Result := 1
					js.return
				elseif a_event.item.keyval = {NATURAL_32} 32 then
					Result := 1
					js.return
				else
					l_di.item.ignore_enter := 0
				end
			else
				l_di.item.ignore_enter := 0
			end
			if not js.return_called and then (a_event.item.keyval = {NATURAL_32} 65_307) then
				gtk_dialog_response (l_di.item.dialog, -2)
				Result := 1
				js.return
			end
			if not js.return_called and then ((l_di.item.noalt).to_boolean) then
				if ((a_event.item.state).bit_and ((gtk_accelerator_get_default_mod_mask))) = {NATURAL_32} 0 then
					l_tmp___1 := gtk_window_get_mnemonic_modifier (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_window_get_type)))))
					Result := (gtk_window_mnemonic_activate (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_window_get_type)))), a_event.item.keyval, l_tmp___1))
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	dialog_key_press_event_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dialog_key_press_event_cb)
		end

	entry_activate_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		do
			gtk_widget_grab_focus (create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_data), (gtk_widget_get_type)))))
		end

	entry_activate_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent entry_activate_cb)
		end

	entry_changed_cb (a_entry: CE_POINTER [SD_GTKWIDGET]; a_dialog: CE_POINTER [SD_GTKWIDGET])
		local
			l_entry_text: CE_POINTER [INTEGER_8]
			l_nonempty: INTEGER_32
			js: JUMP_STATE
		do
			create l_entry_text.make

			l_entry_text := gtk_entry_get_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_entry), (gtk_entry_get_type)))))
			if l_entry_text.is_void then
				js.return
			end
			if not js.return_called then
				l_nonempty := ((l_entry_text[0]).to_integer_32 /= 0).to_integer
				if a_dialog.is_equal (find_widgets.item.dialog) then
					gtk_widget_set_sensitive (find_widgets.item.find, l_nonempty)
				end
				if a_dialog.is_equal (repl_widgets.item.dialog) then
					gtk_widget_set_sensitive (repl_widgets.item.find, l_nonempty)
					gtk_widget_set_sensitive (repl_widgets.item.replace, l_nonempty)
					gtk_widget_set_sensitive (repl_widgets.item.all2, l_nonempty)
				end
			end
		end

	entry_changed_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent entry_changed_cb)
		end

	ex_helpfind (a_eap: CE_POINTER [PD_EXARG])
		do
			ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("emenu ToolBar.FindHelp"))).do_nothing
		end

	ex_helpfind_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_helpfind)
		end

	find_key_press_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTKEY]; a_frdp: CE_POINTER [PD_SHAREDFINDREPLACE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((a_event.item.state).bit_and ({NATURAL_32} 5)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_event.item.keyval = {NATURAL_32} 65_307) then
				gtk_widget_hide (a_frdp.item.dialog)
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	find_key_press_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent find_key_press_event)
		end

	find_replace_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		local
			l_flags___0: INTEGER_32
			l_find_text: CE_POINTER [NATURAL_8]
			l_repl_text: CE_POINTER [NATURAL_8]
			l_direction_down: INTEGER_32
			l_sfr: CE_POINTER [PD_SHAREDFINDREPLACE]
			l_rc: INTEGER_32
		do
			create l_find_text.make
			create l_repl_text.make
			create l_sfr.make

			l_flags___0 := ((a_data.c_pointer.to_integer_32).to_integer_32).to_integer_32
			if l_flags___0 = 1 then
				l_repl_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_sfr := find_widgets
			else
				l_repl_text := create {CE_POINTER [NATURAL_8]}.make_cast ((gtk_entry_get_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (repl_widgets.item.with), (gtk_entry_get_type)))))))
				l_sfr := repl_widgets
			end
			l_find_text := create {CE_POINTER [NATURAL_8]}.make_cast ((gtk_entry_get_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.what), (gtk_entry_get_type)))))))
			l_direction_down := ((create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.down), (gtk_toggle_button_get_type))))).item.active).to_integer_32
			if ((create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.wword), (gtk_toggle_button_get_type))))).item.active).to_boolean then
				l_flags___0 := (l_flags___0).bit_or ((8))
			end
			if ((create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sfr.item.mcase), (gtk_toggle_button_get_type))))).item.active).to_boolean then
				l_flags___0 := (l_flags___0).bit_or ((16))
			end
			if globals_inst.input_conv.item.vc_type = 0 then
				l_repl_text := l_repl_text
			elseif l_repl_text.is_void then
				l_repl_text := l_repl_text
			else
				l_repl_text := (mbyte_inst.string_convert (globals_inst.input_conv, l_repl_text, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
			if globals_inst.input_conv.item.vc_type = 0 then
				l_find_text := l_find_text
			elseif l_find_text.is_void then
				l_find_text := l_find_text
			else
				l_find_text := (mbyte_inst.string_convert (globals_inst.input_conv, l_find_text, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
			l_rc := gui_inst.gui_do_findrepl (l_flags___0, l_find_text, l_repl_text, l_direction_down)
			if globals_inst.input_conv.item.vc_type = 0 then
				l_repl_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl_text))
				l_repl_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			if globals_inst.input_conv.item.vc_type = 0 then
				l_find_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_find_text))
				l_find_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	find_replace_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent find_replace_cb)
		end

	find_replace_dialog_create (a_arg: CE_POINTER [NATURAL_8]; a_do_replace: INTEGER_32)
		local
			l_hbox: CE_POINTER [SD_GTKWIDGET]
			l_actionarea: CE_POINTER [SD_GTKWIDGET]
			l_table: CE_POINTER [SD_GTKWIDGET]
			l_tmp: CE_POINTER [SD_GTKWIDGET]
			l_vbox: CE_POINTER [SD_GTKWIDGET]
			l_sensitive: INTEGER_32
			l_frdp: CE_POINTER [PD_SHAREDFINDREPLACE]
			l_entry_text: CE_POINTER [NATURAL_8]
			l_wword: CE_ARRAY [INTEGER_32]
			l_mcase: CE_ARRAY [INTEGER_32]
			l_conv_buffer: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_old_text: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___26: NATURAL_32
			l_tmp___40: INTEGER_32
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___111: CE_POINTER [ANY]
			l_tmp___115: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___120: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___127: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___133: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___137: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___141: CE_POINTER [SD_GTYPEINSTANCE]
			js: JUMP_STATE
		do
			create l_hbox.make
			create l_actionarea.make
			create l_table.make
			create l_tmp.make
			create l_vbox.make
			create l_frdp.make
			create l_entry_text.make
			create l_wword.make (<<1>>)
			create l_mcase.make (<<1>>)
			create l_conv_buffer.make (<<1>>)
			create l_old_text.make
			create l_tmp___11.make
			create l_tmp___17.make
			create l_tmp___21.make
			create l_tmp___96.make
			create l_tmp___111.make
			create l_tmp___115.make
			create l_tmp___120.make
			create l_tmp___127.make
			create l_tmp___133.make
			create l_tmp___137.make
			create l_tmp___141.make

			l_wword.item := 0
			l_mcase.item := (not (option_inst.p_ic.item).to_boolean).to_integer
			l_conv_buffer.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if a_do_replace.to_boolean then
				l_frdp := repl_widgets
			else
				l_frdp := find_widgets
			end
			l_entry_text := gui_inst.get_find_dialog_text (a_arg, l_wword, l_mcase)
			if not l_entry_text.is_void then
				if globals_inst.output_conv.item.vc_type /= 0 then
					l_old_text := l_entry_text
					l_entry_text := mbyte_inst.string_convert (globals_inst.output_conv, l_entry_text, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_old_text))
				end
			end
			if (not (l_frdp.item.dialog).is_void) then
				if not l_entry_text.is_void then
					gtk_entry_set_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_entry_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_entry_text))
					gtk_toggle_button_set_active (create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.wword), (gtk_toggle_button_get_type)))), l_wword.item)
					gtk_toggle_button_set_active (create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.mcase), (gtk_toggle_button_get_type)))), l_mcase.item)
				end
				gtk_window_present (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_entry_text))
				js.return
			end
			if not js.return_called then
				l_frdp.item.dialog := gtk_dialog_new
				gtk_dialog_set_has_separator (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_dialog_get_type)))), 0)
				l_tmp___11 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.mainwin), (gtk_window_get_type))
				gtk_window_set_transient_for (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), create {CE_POINTER [SD_GTKWINDOW]}.make_cast (l_tmp___11))
				gtk_window_set_destroy_with_parent (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), 1)
				if a_do_replace.to_boolean then
					l_tmp___17 := convert_localized_message (l_conv_buffer, (gettext (ce_string ("VIM - Search and Replace..."))))
					gtk_window_set_title (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), l_tmp___17)
				else
					l_tmp___21 := convert_localized_message (l_conv_buffer, (gettext (ce_string ("VIM - Search..."))))
					gtk_window_set_title (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_window_get_type)))), l_tmp___21)
				end
				l_hbox := gtk_hbox_new (0, 0)
				gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_container_get_type)))), (10).to_natural_32)
				l_tmp___26 := gtk_container_get_type
				gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_dialog_get_type))))).item.vbox), l_tmp___26))), l_hbox)
				if a_do_replace.to_boolean then
					l_table := gtk_table_new ((1_024).to_natural_32, (4).to_natural_32, 0)
				else
					l_table := gtk_table_new ((1_024).to_natural_32, (3).to_natural_32, 0)
				end
				gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_box_get_type)))), l_table, 1, 1, (0).to_natural_32)
				gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_container_get_type)))), (4).to_natural_32)
				l_tmp := gtk_label_new ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Find what:"))))))
				gtk_misc_set_alignment (create {CE_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_misc_get_type)))), (0.0).truncated_to_real, (0.5).truncated_to_real)
				gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (0).to_natural_32, (1).to_natural_32, (0).to_natural_32, (1).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				l_frdp.item.what := gtk_entry_new
				if not l_entry_text.is_void then
					if (l_entry_text[0]).to_integer_32 /= 0 then
						l_tmp___40 := 1
					else
						l_tmp___40 := 0
					end
				else
					l_tmp___40 := 0
				end
				l_sensitive := l_tmp___40
				if not l_entry_text.is_void then
					gtk_entry_set_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_entry_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_entry_text))
				end
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("changed"), (entry_changed_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_frdp.item.dialog), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("key_press_event"), (find_key_press_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_frdp), create {CE_ROUTINE}.make_shared (default_pointer), 0, 1).do_nothing
				gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.what, (1).to_natural_32, (1_024).to_natural_32, (0).to_natural_32, (1).to_natural_32, (5).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				if a_do_replace.to_boolean then
					l_tmp := gtk_label_new ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Replace with:"))))))
					gtk_misc_set_alignment (create {CE_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_misc_get_type)))), (0.0).truncated_to_real, (0.5).truncated_to_real)
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (0).to_natural_32, (1).to_natural_32, (1).to_natural_32, (2).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
					l_frdp.item.with := gtk_entry_new
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.with), (gtk_object_get_type)))), ce_string ("activate"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer + 2), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.with), (gtk_object_get_type)))), ce_string ("key_press_event"), (find_key_press_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_frdp), create {CE_ROUTINE}.make_shared (default_pointer), 0, 1).do_nothing
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.with, (1).to_natural_32, (1_024).to_natural_32, (1).to_natural_32, (2).to_natural_32, (5).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("activate"), (entry_activate_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_frdp.item.with), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				else
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.what), (gtk_object_get_type)))), ce_string ("activate"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer + 1), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				end
				l_frdp.item.wword := gtk_check_button_new_with_label ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Match whole word only"))))))
				gtk_toggle_button_set_active (create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.wword), (gtk_toggle_button_get_type)))), l_wword.item)
				if a_do_replace.to_boolean then
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.wword, (0).to_natural_32, (1_023).to_natural_32, (2).to_natural_32, (3).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				else
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.wword, (0).to_natural_32, (1_023).to_natural_32, (1).to_natural_32, (2).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				end
				l_frdp.item.mcase := gtk_check_button_new_with_label ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Match case"))))))
				gtk_toggle_button_set_active (create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.mcase), (gtk_toggle_button_get_type)))), l_mcase.item)
				if a_do_replace.to_boolean then
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.mcase, (0).to_natural_32, (1_023).to_natural_32, (3).to_natural_32, (4).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				else
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_frdp.item.mcase, (0).to_natural_32, (1_023).to_natural_32, (2).to_natural_32, (3).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_EXPAND, (2).to_natural_32, (2).to_natural_32)
				end
				l_tmp := gtk_frame_new ((convert_localized_message (l_conv_buffer, (gettext (ce_string ("Direction"))))))
				if a_do_replace.to_boolean then
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (1_023).to_natural_32, (1_024).to_natural_32, (2).to_natural_32, (4).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_FILL, (2).to_natural_32, (2).to_natural_32)
				else
					gtk_table_attach (create {CE_POINTER [SD_GTKTABLE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_table), (gtk_table_get_type)))), l_tmp, (1_023).to_natural_32, (1_024).to_natural_32, (1).to_natural_32, (3).to_natural_32, {SC_GTKATTACHOPTIONS}.GTK_FILL, {SC_GTKATTACHOPTIONS}.GTK_FILL, (2).to_natural_32, (2).to_natural_32)
				end
				l_vbox := gtk_vbox_new (0, 0)
				gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_container_get_type)))), (0).to_natural_32)
				gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_container_get_type)))), l_vbox)
				l_frdp.item.up := gtk_radio_button_new_with_label (create {CE_POINTER [SD_GSLIST]}.make_shared (default_pointer), (convert_localized_message (l_conv_buffer, (gettext (ce_string ("Up"))))))
				gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), l_frdp.item.up, 1, 1, (0).to_natural_32)
				l_tmp___96 := convert_localized_message (l_conv_buffer, (gettext (ce_string ("Down"))))
				l_frdp.item.down := gtk_radio_button_new_with_label ((gtk_radio_button_get_group (create {CE_POINTER [SD_GTKRADIOBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.up), (gtk_radio_button_get_type)))))), l_tmp___96)
				gtk_toggle_button_set_active (create {CE_POINTER [SD_GTKTOGGLEBUTTON]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.down), (gtk_toggle_button_get_type)))), 1)
				gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_container_get_type)))), (2).to_natural_32)
				gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), l_frdp.item.down, 1, 1, (0).to_natural_32)
				l_actionarea := gtk_vbutton_box_new
				gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_container_get_type)))), (2).to_natural_32)
				gtk_box_pack_end (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_box_get_type)))), l_actionarea, 0, 0, (0).to_natural_32)
				l_frdp.item.find := create_image_button (ce_string ("gtk-find"), (gettext (ce_string ("Find Next"))))
				gtk_widget_set_sensitive (l_frdp.item.find, l_sensitive)
				if a_do_replace.to_boolean then
					l_tmp___111 := create {CE_POINTER [ANY]}.make_shared (default_pointer + 2)
				else
					l_tmp___111 := create {CE_POINTER [ANY]}.make_shared (default_pointer + 1)
				end
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.find), (gtk_object_get_type)))), ce_string ("clicked"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), l_tmp___111, create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				from
				until
					js.loop_done
				loop
					l_tmp___115 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.find), (gtk_object_get_type));
					(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___115)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___115)).item.flags).bit_or (({NATURAL_32} 8_192))
					js.break
				end
				gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_frdp.item.find, 0, 0, (0).to_natural_32)
				gtk_widget_grab_default (l_frdp.item.find)
				if a_do_replace.to_boolean then
					l_frdp.item.replace := create_image_button (ce_string ("gtk-convert"), (gettext (ce_string ("Replace"))))
					gtk_widget_set_sensitive (l_frdp.item.replace, l_sensitive)
					from
					until
						js.loop_done
					loop
						l_tmp___120 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.replace), (gtk_object_get_type));
						(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___120)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___120)).item.flags).bit_or (({NATURAL_32} 8_192))
						js.break
					end
					gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_frdp.item.replace, 0, 0, (0).to_natural_32)
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.replace), (gtk_object_get_type)))), ce_string ("clicked"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer + 3), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					l_frdp.item.all2 := create_image_button (ce_string ("gtk-convert"), (gettext (ce_string ("Replace All"))))
					gtk_widget_set_sensitive (l_frdp.item.all2, l_sensitive)
					from
					until
						js.loop_done
					loop
						l_tmp___127 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.all2), (gtk_object_get_type));
						(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___127)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___127)).item.flags).bit_or (({NATURAL_32} 8_192))
						js.break
					end
					gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_frdp.item.all2, 0, 0, (0).to_natural_32)
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.all2), (gtk_object_get_type)))), ce_string ("clicked"), (find_replace_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer + 4), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				end
				l_tmp := gtk_button_new_from_stock (ce_string ("gtk-close"))
				from
				until
					js.loop_done
				loop
					l_tmp___133 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_object_get_type));
					(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___133)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___133)).item.flags).bit_or (({NATURAL_32} 8_192))
					js.break
				end
				gtk_box_pack_end (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_actionarea), (gtk_box_get_type)))), l_tmp, 0, 0, (0).to_natural_32)
				l_tmp___137 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_object_get_type))
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tmp), (gtk_object_get_type)))), ce_string ("clicked"), (gtk_widget_hide_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_tmp___137), create {CE_ROUTINE}.make_shared (default_pointer), 1, 0).do_nothing
				l_tmp___141 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_object_get_type))
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_object_get_type)))), ce_string ("delete_event"), (gtk_widget_hide_on_delete_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_tmp___141), create {CE_ROUTINE}.make_shared (default_pointer), 1, 0).do_nothing
				l_tmp := gtk_vseparator_new
				gtk_box_pack_end (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_hbox), (gtk_box_get_type)))), l_tmp, 0, 0, (10).to_natural_32)
				gtk_widget_hide ((create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_frdp.item.dialog), (gtk_dialog_get_type))))).item.action_area)
				gtk_widget_show_all (l_hbox)
				gtk_widget_show (l_frdp.item.dialog)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_entry_text))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_conv_buffer.item))
			end
		end

	get_menu_position (a_menu___1: CE_POINTER [PD_VIMMENU]): INTEGER_32
		local
			l_node: CE_POINTER [PD_VIMMENU]
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			create l_node.make

			l_idx := 0
			l_node := (a_menu___1.item.parent).item.children
			from
			until
				not (not js.loop_done and then (not l_node.is_equal (a_menu___1)))
			loop
				from
				until
					js.loop_done
				loop
					if l_node.is_void then
						g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("get_menu_position"), ce_string ("node != NULL"))
						Result := (-1)
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				if not js.return_called then
					l_idx := l_idx + 1
					l_node := l_node.item.next
				end
			end
			if not js.return_called then
				Result := l_idx
			end
		end

	gui_gtk_register_stock_icons
		local
			l_factory: CE_POINTER [SD_GTKICONFACTORY]
		do
			create l_factory.make

			l_factory := gtk_icon_factory_new
			add_stock_icon (l_factory, ce_string ("vim-build-tags"), pixmaps_stock_icons_inst.stock_vim_build_tags, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-find-help"), pixmaps_stock_icons_inst.stock_vim_find_help, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-save-all"), pixmaps_stock_icons_inst.stock_vim_save_all, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-session-load"), pixmaps_stock_icons_inst.stock_vim_session_load, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-session-new"), pixmaps_stock_icons_inst.stock_vim_session_new, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-session-save"), pixmaps_stock_icons_inst.stock_vim_session_save, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-shell"), pixmaps_stock_icons_inst.stock_vim_shell, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (9_241).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-maximize"), pixmaps_stock_icons_inst.stock_vim_window_maximize, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-maximize-width"), pixmaps_stock_icons_inst.stock_vim_window_maximize_width, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-minimize"), pixmaps_stock_icons_inst.stock_vim_window_minimize, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-minimize-width"), pixmaps_stock_icons_inst.stock_vim_window_minimize_width, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-split"), pixmaps_stock_icons_inst.stock_vim_window_split, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			add_stock_icon (l_factory, ce_string ("vim-window-split-vertical"), pixmaps_stock_icons_inst.stock_vim_window_split_vertical, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_329).to_natural_32).to_integer_32)
			gtk_icon_factory_add_default (l_factory)
			g_object_unref (create {CE_POINTER [ANY]}.make_cast (l_factory))
		end

	gui_gtk_set_mnemonics (a_enable: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_name___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_menu___1.make
			create l_name___1.make

			l_menu___1 := globals_inst.root_menu.item
			from
			until
				l_menu___1.is_void
			loop
				if (l_menu___1.item.id).is_void then
					js.continue
				end
				if not js.loop_jumped then
					l_name___1 := translate_mnemonic_tag (l_menu___1.item.name, a_enable)
					gtk_label_set_text_with_mnemonic (create {CE_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_menu___1.item.label), (gtk_label_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
				end
				l_menu___1 := l_menu___1.item.next
			end
		end

	gui_make_popup (a_path_name: CE_POINTER [NATURAL_8]; a_mouse_pos: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
		do
			create l_menu___1.make

			popup_mouse_pos := a_mouse_pos
			l_menu___1 := menu_inst.gui_find_menu (a_path_name)
			if not l_menu___1.is_void then
				if not (l_menu___1.item.submenu_id).is_void then
					gtk_menu_popup (create {CE_POINTER [SD_GTKMENU]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_menu___1.item.submenu_id), (gtk_menu_get_type)))), create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), popup_menu_position_func_address, create {CE_POINTER [ANY]}.make_shared (default_pointer), {NATURAL_32} 0, (0).to_natural_32)
				end
			end
		end

	gui_mch_add_menu (a_menu___1: CE_POINTER [PD_VIMMENU]; a_idx: INTEGER_32)
		local
			l_idx: INTEGER_32
			l_parent: CE_POINTER [PD_VIMMENU]
			l_parent_widget: CE_POINTER [SD_GTKWIDGET]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_parent.make
			create l_parent_widget.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := a_idx
					if (a_menu___1.item.name[0]).to_integer_32 = 93 then
						a_menu___1.item.submenu_id := gtk_menu_new
						js.return
					elseif (menu_inst.menu_is_popup (a_menu___1.item.name)).to_boolean then
						a_menu___1.item.submenu_id := gtk_menu_new
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_parent := a_menu___1.item.parent
						if l_parent.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_parent.item.submenu_id).is_void then
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not (menu_inst.menu_is_menubar (a_menu___1.item.name)).to_boolean then
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							if not l_parent.is_void then
								l_parent_widget := l_parent.item.submenu_id
							else
								l_parent_widget := gui_inst.gui.item.menubar
							end
							menu_item_new (a_menu___1, l_parent_widget)
							if not l_parent.is_void then
								if not (menu_inst.menu_is_popup (l_parent.item.name)).to_boolean then
									l_idx := l_idx + 1
								end
							end
							gtk_menu_shell_insert (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_parent_widget), (gtk_menu_shell_get_type)))), a_menu___1.item.id, l_idx)
							a_menu___1.item.submenu_id := gtk_menu_new
							gtk_menu_set_accel_group (create {CE_POINTER [SD_GTKMENU]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), (gtk_menu_get_type)))), gui_inst.gui.item.accel_group)
							gtk_menu_item_set_submenu (create {CE_POINTER [SD_GTKMENUITEM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_menu_item_get_type)))), a_menu___1.item.submenu_id)
							a_menu___1.item.tearoff_handle := gtk_tearoff_menu_item_new
							if not (misc2_inst.vim_strchr (option_inst.p_go.item, ('t').code)).is_void then
								gtk_widget_show (a_menu___1.item.tearoff_handle)
							end
							gtk_menu_shell_prepend (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), (gtk_menu_get_type)))), a_menu___1.item.tearoff_handle)
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gui_mch_add_menu_item (a_menu___1: CE_POINTER [PD_VIMMENU]; a_idx: INTEGER_32)
		local
			l_idx: INTEGER_32
			l_parent: CE_POINTER [PD_VIMMENU]
			l_toolbar: CE_POINTER [SD_GTKTOOLBAR]
			l_text: CE_POINTER [NATURAL_8]
			l_tooltip: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_parent.make
			create l_toolbar.make
			create l_text.make
			create l_tooltip.make

			l_idx := a_idx
			l_parent := a_menu___1.item.parent
			if (menu_inst.menu_is_toolbar (l_parent.item.name)).to_boolean then
				l_toolbar := create {CE_POINTER [SD_GTKTOOLBAR]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.toolbar), (gtk_toolbar_get_type))))
				a_menu___1.item.submenu_id := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
				if (menu_inst.menu_is_separator (a_menu___1.item.name)).to_boolean then
					gtk_toolbar_insert_space (l_toolbar, l_idx)
					a_menu___1.item.id := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
				else
					if globals_inst.output_conv.item.vc_type = 0 then
						l_text := a_menu___1.item.dname
					elseif (a_menu___1.item.dname).is_void then
						l_text := a_menu___1.item.dname
					else
						l_text := (mbyte_inst.string_convert (globals_inst.output_conv, a_menu___1.item.dname, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					if globals_inst.output_conv.item.vc_type = 0 then
						l_tooltip := a_menu___1.item.strings[6]
					elseif (a_menu___1.item.strings[6]).is_void then
						l_tooltip := a_menu___1.item.strings[6]
					else
						l_tooltip := (mbyte_inst.string_convert (globals_inst.output_conv, a_menu___1.item.strings[6], create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					if not l_tooltip.is_void then
						if not (mbyte_inst.utf_valid_string (l_tooltip, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							if globals_inst.output_conv.item.vc_type = 0 then
								l_tooltip := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tooltip))
								l_tooltip := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
						end
					end
					a_menu___1.item.id := gtk_toolbar_insert_item (l_toolbar, create {CE_POINTER [INTEGER_8]}.make_cast (l_text), create {CE_POINTER [INTEGER_8]}.make_cast (l_tooltip), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), (create_menu_icon (a_menu___1, (gtk_toolbar_get_icon_size (l_toolbar)))), (menu_item_activate_address), create {CE_POINTER [ANY]}.make_cast (a_menu___1), l_idx)
					if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
						gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_object_get_type)))), ce_string ("focus_in_event"), (toolbar_button_focus_in_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					end
					if globals_inst.output_conv.item.vc_type = 0 then
						l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
						l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if globals_inst.output_conv.item.vc_type = 0 then
						l_tooltip := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tooltip))
						l_tooltip := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				end
			else
				if l_parent.is_void then
					js.return
				elseif (l_parent.item.submenu_id).is_void then
					js.return
				end
				if not js.return_called then
					if not (menu_inst.menu_is_popup (l_parent.item.name)).to_boolean then
						l_idx := l_idx + 1
					end
					if (menu_inst.menu_is_separator (a_menu___1.item.name)).to_boolean then
						a_menu___1.item.id := gtk_menu_item_new
						gtk_widget_set_sensitive (a_menu___1.item.id, 0)
						gtk_widget_show (a_menu___1.item.id)
						gtk_menu_shell_insert (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_parent.item.submenu_id), (gtk_menu_get_type)))), a_menu___1.item.id, l_idx)
						js.return
					end
				end
				if not js.return_called then
					menu_item_new (a_menu___1, l_parent.item.submenu_id)
					gtk_widget_show (a_menu___1.item.id)
					gtk_menu_shell_insert (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_parent.item.submenu_id), (gtk_menu_get_type)))), a_menu___1.item.id, l_idx)
					if not (a_menu___1.item.id).is_void then
						gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_object_get_type)))), ce_string ("activate"), (menu_item_activate_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_menu___1), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					end
				end
			end
			if not js.return_called then
			end
		end

	gui_mch_browse (a_saving: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_dflt: CE_POINTER [NATURAL_8]; a_ext: CE_POINTER [NATURAL_8]; a_initdir: CE_POINTER [NATURAL_8]; a_filter: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_fc: CE_POINTER [SD_GTKWIDGET]
			l_dirbuf: CE_ARRAY [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_filename: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_title.make
			create l_fc.make
			create l_dirbuf.make (<<4_096>>)
			create l_tmp___1.make
			create l_filename.make

			l_title := a_title
			if globals_inst.output_conv.item.vc_type = 0 then
				l_title := l_title
			elseif l_title.is_void then
				l_title := l_title
			else
				l_title := (mbyte_inst.string_convert (globals_inst.output_conv, l_title, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
			if a_initdir.is_void then
				os_unix_inst.mch_dirname (l_dirbuf, 4_096).do_nothing
			elseif (a_initdir.item).to_integer_32 = 0 then
				os_unix_inst.mch_dirname (l_dirbuf, 4_096).do_nothing
			elseif (window_inst.vim_FullName (a_initdir, l_dirbuf, 4_094, 0)) = 0 then
				l_dirbuf[0] := (('%/0/').code).to_natural_8
			end
			misc1_inst.add_pathsep (l_dirbuf)
			gui_gtk_x11_inst.gui_mch_mousehide (0)
			if a_saving.to_boolean then
				l_tmp___1 := ce_string ("gtk-save")
			else
				l_tmp___1 := ce_string ("gtk-open")
			end
			if a_saving.to_boolean then
				l_tmp___2 := 1
			else
				l_tmp___2 := 0
			end
			l_fc := gtk_file_chooser_dialog_new ([create {CE_POINTER [INTEGER_8]}.make_cast (l_title), create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.mainwin), (gtk_window_get_type)))), l_tmp___2.to_natural_32, ce_string ("gtk-cancel"), -6, l_tmp___1, -3, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			gtk_file_chooser_set_current_folder (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_file_chooser_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_dirbuf)).do_nothing
			if a_saving.to_boolean then
				if not a_dflt.is_void then
					if (a_dflt.item).to_integer_32 /= 0 then
						gtk_file_chooser_set_current_name (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_file_chooser_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (a_dflt))
					end
				end
			end
			gui_inst.gui.item.browse_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if (gtk_dialog_run (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_dialog_get_type)))))) = -3 then
				l_filename := gtk_file_chooser_get_filename (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_file_chooser_get_type)))))
				gui_inst.gui.item.browse_fname := create {CE_POINTER [NATURAL_8]}.make_cast ((g_strdup (l_filename)))
				g_free (create {CE_POINTER [ANY]}.make_cast (l_filename))
			end
			gtk_widget_destroy (create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_fc), (gtk_widget_get_type)))))
			if globals_inst.output_conv.item.vc_type = 0 then
				l_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_title))
				l_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			if (gui_inst.gui.item.browse_fname).is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (misc2_inst.vim_strsave ((fileio_inst.shorten_fname1 (gui_inst.gui.item.browse_fname))))
			end
		end

	gui_mch_browsedir (a_title: CE_POINTER [NATURAL_8]; a_initdir: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_dirbuf: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_dirdlg: CE_POINTER [SD_GTKWIDGET]
			l_dirname: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_title.make
			create l_dirbuf.make (<<4_096>>)
			create l_p___0.make
			create l_dirdlg.make
			create l_dirname.make

			l_title := a_title
			l_dirname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if globals_inst.output_conv.item.vc_type = 0 then
				l_title := l_title
			elseif l_title.is_void then
				l_title := l_title
			else
				l_title := (mbyte_inst.string_convert (globals_inst.output_conv, l_title, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
			l_dirdlg := gtk_file_chooser_dialog_new ([create {CE_POINTER [INTEGER_8]}.make_cast (l_title), create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.mainwin), (gtk_window_get_type)))), {SC_GTKFILECHOOSERACTION}.GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, ce_string ("gtk-cancel"), -6, ce_string ("gtk-ok"), -3, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			if globals_inst.output_conv.item.vc_type = 0 then
				l_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_title))
				l_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			gui_gtk_x11_inst.gui_mch_mousehide (0)
			if a_initdir.is_void then
				os_unix_inst.mch_dirname (l_dirbuf, 4_086).do_nothing
			elseif (a_initdir.item).to_integer_32 = 0 then
				os_unix_inst.mch_dirname (l_dirbuf, 4_086).do_nothing
			elseif (window_inst.vim_FullName (a_initdir, l_dirbuf, 4_086, 0)) = 0 then
				os_unix_inst.mch_dirname (l_dirbuf, 4_086).do_nothing
			end
			misc1_inst.add_pathsep (l_dirbuf)
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirbuf), ce_string ("@zd(*&1|")).do_nothing
			gtk_file_chooser_set_filename (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dirdlg), (gtk_file_chooser_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_dirbuf)).do_nothing
			if (gtk_dialog_run (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dirdlg), (gtk_dialog_get_type)))))) = -3 then
				l_dirname := create {CE_POINTER [NATURAL_8]}.make_cast ((gtk_file_chooser_get_filename (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dirdlg), (gtk_file_chooser_get_type)))))))
			end
			gtk_widget_destroy (l_dirdlg)
			if l_dirname.is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_p___0 := misc2_inst.vim_strsave ((fileio_inst.shorten_fname1 (l_dirname)))
				g_free (create {CE_POINTER [ANY]}.make_cast (l_dirname))
				Result := l_p___0
			end
		end

	gui_mch_create_scrollbar (a_sb: CE_POINTER [PD_GUISCROLLBAR]; a_orient: INTEGER_32)
		local
			l_adjustment: CE_POINTER [SD_GTKADJUSTMENT]
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			js: JUMP_STATE
		do
			create l_adjustment.make
			create l_tmp___0.make

			if a_orient = 1 then
				a_sb.item.id := gtk_hscrollbar_new (create {CE_POINTER [SD_GTKADJUSTMENT]}.make_shared (default_pointer))
			elseif a_orient = 0 then
				a_sb.item.id := gtk_vscrollbar_new (create {CE_POINTER [SD_GTKADJUSTMENT]}.make_shared (default_pointer))
			end
			if not (a_sb.item.id).is_void then
				from
				until
					js.loop_done
				loop
					l_tmp___0 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_sb.item.id), (gtk_object_get_type));
					(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___0)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___0)).item.flags).bit_and (({NATURAL_32} 4_294_965_247))
					js.break
				end
				gui_gtk_f_inst.gtk_form_put (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.formwin), (gui_gtk_f_inst.gtk_form_get_type)))), a_sb.item.id, 0, 0)
				l_adjustment := gtk_range_get_adjustment (create {CE_POINTER [SD_GTKRANGE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_sb.item.id), (gtk_range_get_type)))))
				a_sb.item.handler_id := gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_adjustment), (gtk_object_get_type)))), ce_string ("value_changed"), (adjustment_value_changed_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer + a_sb.item.ident), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0)
				gui_gtk_x11_inst.gui_mch_update
			end
		end

	gui_mch_destroy_menu (a_menu___1: CE_POINTER [PD_VIMMENU])
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_menu___1.item.parent).is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (menu_inst.menu_is_toolbar ((a_menu___1.item.parent).item.name)).to_boolean then
							if (menu_inst.menu_is_separator (a_menu___1.item.name)).to_boolean then
								l_tmp := get_menu_position (a_menu___1)
								gtk_toolbar_remove_space (create {CE_POINTER [SD_GTKTOOLBAR]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.toolbar), (gtk_toolbar_get_type)))), l_tmp)
							elseif not (a_menu___1.item.id).is_void then
								gtk_widget_destroy (a_menu___1.item.id)
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if not (a_menu___1.item.submenu_id).is_void then
							gtk_widget_destroy (a_menu___1.item.submenu_id)
						end
						if not (a_menu___1.item.id).is_void then
							gtk_widget_destroy (a_menu___1.item.id)
						end
				when 4 then
					a_menu___1.item.submenu_id := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
					a_menu___1.item.id := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_mch_destroy_scrollbar (a_sb: CE_POINTER [PD_GUISCROLLBAR])
		do
			if not (a_sb.item.id).is_void then
				gtk_widget_destroy (a_sb.item.id)
				a_sb.item.id := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			end
			gui_gtk_x11_inst.gui_mch_update
		end

	gui_mch_dialog (a_type: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_message: CE_POINTER [NATURAL_8]; a_buttons: CE_POINTER [NATURAL_8]; a_def_but: INTEGER_32; a_textfield: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dialog: CE_POINTER [SD_GTKWIDGET]
			l_entry: CE_POINTER [SD_GTKWIDGET]
			l_text: CE_POINTER [NATURAL_8]
			l_response: INTEGER_32
			l_dialoginfo: CE_ARRAY [PD_DIALOGINFO]
			l_alignment: CE_POINTER [SD_GTKWIDGET]
			l_tmp___10: NATURAL_32
			l_tmp___23: INTEGER_32
		do
			create l_dialog.make
			create l_entry.make
			create l_text.make
			create l_dialoginfo.make (<<1>>)
			create l_alignment.make

			l_entry := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			l_dialog := create_message_dialog (a_type, a_title, a_message)
			l_dialoginfo.item.dialog := create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type))))
			dialog_add_buttons (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))), a_buttons)
			if not a_textfield.is_void then
				l_entry := gtk_entry_new
				gtk_widget_show (l_entry)
				if globals_inst.output_conv.item.vc_type = 0 then
					l_text := a_textfield
				elseif a_textfield.is_void then
					l_text := a_textfield
				else
					l_text := (mbyte_inst.string_convert (globals_inst.output_conv, a_textfield, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
				end
				gtk_entry_set_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_entry), (gtk_entry_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_text))
				if globals_inst.output_conv.item.vc_type = 0 then
					l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				else
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
					l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				l_alignment := gtk_alignment_new ((0.5).truncated_to_real, (0.5).truncated_to_real, (1.0).truncated_to_real, (1.0).truncated_to_real)
				gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_alignment), (gtk_container_get_type)))), l_entry)
				gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_alignment), (gtk_container_get_type)))), (5).to_natural_32)
				gtk_widget_show (l_alignment)
				l_tmp___10 := gtk_box_get_type
				gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type))))).item.vbox), l_tmp___10))), l_alignment, 1, 0, (0).to_natural_32)
				l_dialoginfo.item.noalt := 0
			else
				l_dialoginfo.item.noalt := 1
			end
			g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("key_press_event"), (dialog_key_press_event_cb_address), create {CE_POINTER [ANY]}.make_cast (l_dialoginfo), create {CE_ROUTINE}.make_shared (default_pointer), (0).to_natural_32).do_nothing
			if a_def_but > 0 then
				gtk_dialog_set_default_response (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))), a_def_but)
				l_dialoginfo.item.ignore_enter := 0
			else
				l_dialoginfo.item.ignore_enter := 1
			end
			gui_gtk_x11_inst.gui_mch_mousehide (0)
			l_response := gtk_dialog_run (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))))
			if l_response /= -1 then
				if l_response = -3 then
					l_response := a_def_but
				end
				if not a_textfield.is_void then
					l_text := create {CE_POINTER [NATURAL_8]}.make_cast ((gtk_entry_get_text (create {CE_POINTER [SD_GTKENTRY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_entry), (gtk_entry_get_type)))))))
					if globals_inst.input_conv.item.vc_type = 0 then
						l_text := l_text
					elseif l_text.is_void then
						l_text := l_text
					else
						l_text := (mbyte_inst.string_convert (globals_inst.input_conv, l_text, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					misc2_inst.vim_strncpy (a_textfield, l_text, (1_024).to_natural_32)
					if globals_inst.input_conv.item.vc_type = 0 then
						l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
						l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				end
				gtk_widget_destroy (l_dialog)
			end
			if l_response > 0 then
				l_tmp___23 := l_response
			else
				l_tmp___23 := 0
			end
			Result := l_tmp___23
		end

	gui_mch_find_dialog (a_eap: CE_POINTER [PD_EXARG])
		do
			if (gui_inst.gui.item.in_use).to_boolean then
				find_replace_dialog_create (a_eap.item.arg, 0)
			end
		end

	gui_mch_find_dialog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gui_mch_find_dialog)
		end

	gui_mch_menu_set_tip (a_menu___1: CE_POINTER [PD_VIMMENU])
		local
			l_tooltip: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [SD_GTYPEINSTANCE]
		do
			create l_tooltip.make
			create l_tmp___1.make

			if not (a_menu___1.item.id).is_void then
				if not (a_menu___1.item.parent).is_void then
					if not (gui_inst.gui.item.toolbar).is_void then
						if (menu_inst.menu_is_toolbar ((a_menu___1.item.parent).item.name)).to_boolean then
							if globals_inst.output_conv.item.vc_type = 0 then
								l_tooltip := a_menu___1.item.strings[6]
							elseif (a_menu___1.item.strings[6]).is_void then
								l_tooltip := a_menu___1.item.strings[6]
							else
								l_tooltip := (mbyte_inst.string_convert (globals_inst.output_conv, a_menu___1.item.strings[6], create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
							end
							if l_tooltip.is_void then
								l_tmp___0 := gtk_toolbar_get_type
								l_tmp___1 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.toolbar), l_tmp___0)
								gtk_tooltips_set_tip ((create {CE_POINTER [SD_GTKTOOLBAR]}.make_cast (l_tmp___1)).item.tooltips, a_menu___1.item.id, create {CE_POINTER [INTEGER_8]}.make_cast (l_tooltip), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif (mbyte_inst.utf_valid_string (l_tooltip, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
								l_tmp___0 := gtk_toolbar_get_type
								l_tmp___1 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.toolbar), l_tmp___0)
								gtk_tooltips_set_tip ((create {CE_POINTER [SD_GTKTOOLBAR]}.make_cast (l_tmp___1)).item.tooltips, a_menu___1.item.id, create {CE_POINTER [INTEGER_8]}.make_cast (l_tooltip), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							end
							if globals_inst.output_conv.item.vc_type = 0 then
								l_tooltip := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tooltip))
								l_tooltip := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
						end
					end
				end
			end
		end

	gui_mch_replace_dialog (a_eap: CE_POINTER [PD_EXARG])
		do
			if (gui_inst.gui.item.in_use).to_boolean then
				find_replace_dialog_create (a_eap.item.arg, 1)
			end
		end

	gui_mch_replace_dialog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gui_mch_replace_dialog)
		end

	gui_mch_set_scrollbar_pos (a_sb: CE_POINTER [PD_GUISCROLLBAR]; a_x___0: INTEGER_32; a_y: INTEGER_32; a_w: INTEGER_32; a_h: INTEGER_32)
		do
			if not (a_sb.item.id).is_void then
				gui_gtk_f_inst.gtk_form_move_resize (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.formwin), (gui_gtk_f_inst.gtk_form_get_type)))), a_sb.item.id, a_x___0, a_y, a_w, a_h)
			end
		end

	gui_mch_set_scrollbar_thumb (a_sb: CE_POINTER [PD_GUISCROLLBAR]; a_val___0: INTEGER_32; a_size: INTEGER_32; a_max: INTEGER_32)
		local
			l_adjustment: CE_POINTER [SD_GTKADJUSTMENT]
		do
			create l_adjustment.make

			if not (a_sb.item.id).is_void then
				l_adjustment := gtk_range_get_adjustment (create {CE_POINTER [SD_GTKRANGE]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_sb.item.id), (gtk_range_get_type)))))
				l_adjustment.item.lower := 0.0
				l_adjustment.item.value := a_val___0.to_double
				l_adjustment.item.upper := (a_max + 1).to_double
				l_adjustment.item.page_size := a_size.to_double
				if a_size < 3 then
					l_adjustment.item.page_increment := (1).to_double
				else
					l_adjustment.item.page_increment := (a_size - 2).to_double
				end
				l_adjustment.item.step_increment := 1.0
				g_signal_handler_block (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_adjustment), (gtk_object_get_type)))), a_sb.item.handler_id)
				gtk_adjustment_changed (l_adjustment)
				g_signal_handler_unblock (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_adjustment), (gtk_object_get_type)))), a_sb.item.handler_id)
			end
		end

	gui_mch_set_text_area_pos (a_x___0: INTEGER_32; a_y: INTEGER_32; a_w: INTEGER_32; a_h: INTEGER_32)
		do
			gui_gtk_f_inst.gtk_form_move_resize (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.item.formwin), (gui_gtk_f_inst.gtk_form_get_type)))), gui_inst.gui.item.drawarea, a_x___0, a_y, a_w, a_h)
		end

	gui_mch_show_popupmenu (a_menu___1: CE_POINTER [PD_VIMMENU])
		local
			l_menuitem: CE_POINTER [SD_GTKWIDGET]
			l_submenu: CE_POINTER [SD_GTKWIDGET]
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [SD_GTYPEINSTANCE]
		do
			create l_menuitem.make
			create l_submenu.make
			create l_name___1.make
			create l_tmp___8.make

			if not globals_inst.xic.is_void then
				if (g_object_get_data (create {CE_POINTER [SD_GOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("vim-has-im-menu"))).is_void then
					l_menuitem := gtk_separator_menu_item_new
					gtk_widget_show (l_menuitem)
					gtk_menu_shell_append (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), (gtk_menu_shell_get_type)))), l_menuitem)
					l_name___1 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Input _Methods"))))
					if globals_inst.output_conv.item.vc_type = 0 then
						l_name___1 := l_name___1
					elseif l_name___1.is_void then
						l_name___1 := l_name___1
					else
						l_name___1 := (mbyte_inst.string_convert (globals_inst.output_conv, l_name___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					l_menuitem := gtk_menu_item_new_with_mnemonic (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1))
					if globals_inst.output_conv.item.vc_type = 0 then
						l_name___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
						l_name___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					gtk_widget_show (l_menuitem)
					l_submenu := gtk_menu_new
					gtk_menu_item_set_submenu (create {CE_POINTER [SD_GTKMENUITEM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_menuitem), (gtk_menu_item_get_type)))), l_submenu)
					gtk_menu_shell_append (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), (gtk_menu_shell_get_type)))), l_menuitem)
					l_tmp___8 := g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_submenu), (gtk_menu_shell_get_type))
					gtk_im_multicontext_append_menuitems (create {CE_POINTER [SD_GTKIMMULTICONTEXT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (globals_inst.xic), (gtk_im_multicontext_get_type)))), create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___8))
					g_object_set_data (create {CE_POINTER [SD_GOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("vim-has-im-menu"), create {CE_POINTER [ANY]}.make_shared (default_pointer + 1))
				end
			end
			gtk_menu_popup (create {CE_POINTER [SD_GTKMENU]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.submenu_id), (gtk_menu_get_type)))), create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), {NATURAL_32} 3, (0).to_natural_32)
		end

	gui_mch_toggle_tearoffs (a_enable: INTEGER_32)
		do
			recurse_tearoffs (globals_inst.root_menu.item, a_enable)
		end

	load_menu_iconfile (a_name___1: CE_POINTER [NATURAL_8]; a_icon_size: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		local
			l_image: CE_POINTER [SD_GTKWIDGET]
			l_icon_set: CE_POINTER [ANY]
			l_icon_source: CE_POINTER [ANY]
		do
			create l_image.make
			create l_icon_set.make
			create l_icon_source.make

			l_image := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			l_icon_set := gtk_icon_set_new
			l_icon_source := gtk_icon_source_new
			gtk_icon_source_set_filename (l_icon_source, create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))
			gtk_icon_set_add_source (l_icon_set, l_icon_source)
			l_image := gtk_image_new_from_icon_set (l_icon_set, a_icon_size)
			gtk_icon_source_free (l_icon_source)
			gtk_icon_set_unref (l_icon_set)
			Result := l_image
		end

	lookup_menu_iconfile (a_iconfile: CE_POINTER [NATURAL_8]; a_dest: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_buf___6.make (<<4_096>>)

			misc1_inst.expand_env (a_iconfile, a_dest, 4_096)
			if (os_unix_inst.mch_isFullName (a_dest)).to_boolean then
				Result := (misc1_inst.vim_fexists (a_dest))
			else
				l_i___0 := {NATURAL_32} 0
				from
				until
					not (not js.loop_done and then (l_i___0 < (({PLATFORM}.Integer_8_bytes.to_natural_32 * (4).to_natural_32) * (3).to_natural_32) // ({PLATFORM}.Integer_8_bytes.to_natural_32 * (4).to_natural_32)))
				loop
					if (gui_inst.gui_find_bitmap (a_dest, l_buf___6, (suffixes[l_i___0.to_integer_32]))) = 1 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_dest), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6)).do_nothing
						Result := 1
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
				if not js.return_called then
					Result := 0
				end
			end
		end

	menu_item_activate (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		do
			gui_inst.gui_menu_cb (create {CE_POINTER [PD_VIMMENU]}.make_cast (a_data))
		end

	menu_item_activate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_item_activate)
		end

	menu_item_new (a_menu___1: CE_POINTER [PD_VIMMENU]; a_parent_widget: CE_POINTER [SD_GTKWIDGET])
		local
			l_box: CE_POINTER [SD_GTKWIDGET]
			l_text: CE_POINTER [NATURAL_8]
			l_use_mnemonic: INTEGER_32
			l___inst: CE_POINTER [SD_GTYPEINSTANCE]
			l___t: NATURAL_32
			l___r: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___4: CE_POINTER [SD_GTKWIDGET]
		do
			create l_box.make
			create l_text.make
			create l___inst.make
			create l_tmp___4.make

			a_menu___1.item.id := gtk_menu_item_new
			l_box := gtk_hbox_new (0, 20)
			if (option_inst.p_wak.item[0]).to_integer_32 /= 110 then
				l_tmp___0 := 1
			else
				l___inst := create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_parent_widget)
				l___t := (gtk_menu_bar_get_type)
				if l___inst.is_void then
					l___r := 0
				elseif (not (l___inst.item.g_class).is_void) then
					if (l___inst.item.g_class).item.g_type = l___t then
						l___r := 1
					else
						l___r := g_type_check_instance_is_a (l___inst, l___t)
					end
				else
					l___r := g_type_check_instance_is_a (l___inst, l___t)
				end
				if l___r.to_boolean then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
			end
			l_use_mnemonic := l_tmp___0
			l_text := translate_mnemonic_tag (a_menu___1.item.name, l_use_mnemonic)
			a_menu___1.item.label := gtk_label_new_with_mnemonic (create {CE_POINTER [INTEGER_8]}.make_cast (l_text))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), (gtk_box_get_type)))), a_menu___1.item.label, 0, 0, (0).to_natural_32)
			if not (a_menu___1.item.actext).is_void then
				if (a_menu___1.item.actext[0]).to_integer_32 /= 0 then
					if globals_inst.output_conv.item.vc_type = 0 then
						l_text := a_menu___1.item.actext
					elseif (a_menu___1.item.actext).is_void then
						l_text := a_menu___1.item.actext
					else
						l_text := (mbyte_inst.string_convert (globals_inst.output_conv, a_menu___1.item.actext, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					end
					l_tmp___4 := gtk_label_new (create {CE_POINTER [INTEGER_8]}.make_cast (l_text))
					gtk_box_pack_end (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), (gtk_box_get_type)))), l_tmp___4, 0, 0, (0).to_natural_32)
					if globals_inst.output_conv.item.vc_type = 0 then
						l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
						l_text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				end
			end
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_container_get_type)))), l_box)
			gtk_widget_show_all (a_menu___1.item.id)
		end

	popup_menu_position_func (a_menu___1: CE_POINTER [SD_GTKMENU]; a_x___0: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32]; a_push_in: CE_POINTER [INTEGER_32]; a_user_data: CE_POINTER [ANY])
		local
			l_mx: CE_ARRAY [INTEGER_32]
			l_my: CE_ARRAY [INTEGER_32]
		do
			create l_mx.make (<<1>>)
			create l_my.make (<<1>>)

			gdk_window_get_origin ((gui_inst.gui.item.drawarea).item.window, a_x___0, a_y).do_nothing
			if popup_mouse_pos.to_boolean then
				gui_gtk_x11_inst.gui_mch_getmouse (l_mx, l_my)
				a_x___0.item := a_x___0.item + (l_mx.item)
				a_y.item := a_y.item + (l_my.item)
			elseif not globals_inst.curwin.is_void then
				if not (gui_inst.gui.item.drawarea).is_void then
					if not ((gui_inst.gui.item.drawarea).item.window).is_void then
						a_x___0.item := a_x___0.item + ((((globals_inst.curwin.item.w_wincol + globals_inst.curwin.item.w_wcol) + 1) * gui_inst.gui.item.char_width + gui_inst.gui.item.border_offset) + 1)
						a_y.item := a_y.item + ((((globals_inst.curwin.item.w_winrow + globals_inst.curwin.item.w_wrow) + 1) * gui_inst.gui.item.char_height + gui_inst.gui.item.border_offset) + 1)
					end
				end
			end
		end

	popup_menu_position_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent popup_menu_position_func)
		end

	recurse_tearoffs (a_menu___1: CE_POINTER [PD_VIMMENU]; a_val___0: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
		do
			create l_menu___1.make

			l_menu___1 := a_menu___1
			from
			until
				l_menu___1.is_void
			loop
				if not (l_menu___1.item.submenu_id).is_void then
					if not (l_menu___1.item.tearoff_handle).is_void then
						if (l_menu___1.item.name[0]).to_integer_32 /= 93 then
							if not (menu_inst.menu_is_popup (l_menu___1.item.name)).to_boolean then
								if a_val___0.to_boolean then
									gtk_widget_show (l_menu___1.item.tearoff_handle)
								else
									gtk_widget_hide (l_menu___1.item.tearoff_handle)
								end
							end
						end
					end
				end
				recurse_tearoffs (l_menu___1.item.children, a_val___0)
				l_menu___1 := l_menu___1.item.next
			end
		end

	split_button_string (a_button_string: CE_POINTER [NATURAL_8]; a_n_buttons: CE_POINTER [INTEGER_32]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_array: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_count___2: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
		do
			create l_array.make
			create l_p___0.make
			create l_tmp___1.make
			create l_tmp___3.make

			l_count___2 := {NATURAL_32} 1
			l_p___0 := a_button_string
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				if (l_p___0.item).to_integer_32 = 10 then
					l_count___2 := l_count___2 + 1
				end
				l_p___0 := l_p___0 + 1
			end
			l_array := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((misc2_inst.alloc ((l_count___2 + {NATURAL_32} 1) * {PLATFORM}.Pointer_bytes.to_natural_32)))
			l_count___2 := {NATURAL_32} 0
			if not l_array.is_void then
				l_tmp___0 := l_count___2
				l_count___2 := l_count___2 + 1
				l_array[l_tmp___0.to_integer_32] := create {CE_POINTER [INTEGER_8]}.make_cast (a_button_string)
				l_p___0 := a_button_string
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					if (l_p___0.item).to_integer_32 = 10 then
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___1.item := (('%/0/').code).to_natural_8
						l_tmp___2 := l_count___2
						l_count___2 := l_count___2 + 1
						l_array[l_tmp___2.to_integer_32] := create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)
					elseif (l_p___0.item).to_integer_32 = 38 then
						l_tmp___3 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___3.item := (('_').code).to_natural_8
					else
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___5 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
						else
							l_tmp___5 := 1
						end
						l_p___0 := l_p___0 + l_tmp___5
					end
				end
				l_array[l_count___2.to_integer_32] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			a_n_buttons.item := l_count___2.to_integer_32
			Result := l_array
		end

	split_button_translation (a_message: CE_POINTER [INTEGER_8]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_buttons: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_str___1: CE_POINTER [NATURAL_8]
			l_n_buttons: CE_ARRAY [INTEGER_32]
			l_n_expected: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_buttons.make
			create l_str___1.make
			create l_n_buttons.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buttons := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
					l_n_buttons.item := 0
					l_n_expected := 1
					l_str___1 := create {CE_POINTER [NATURAL_8]}.make_cast (a_message)
					from
					until
						(l_str___1.item).to_integer_32 = 0
					loop
						if (l_str___1.item).to_integer_32 = 10 then
							l_n_expected := l_n_expected + 1
						end
						l_str___1 := l_str___1 + 1
					end
					l_str___1 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (a_message)))
					if not l_str___1.is_void then
						if globals_inst.output_conv.item.vc_type /= 0 then
							l_str___1 := mbyte_inst.string_convert (globals_inst.output_conv, l_str___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						else
							l_str___1 := misc2_inst.vim_strsave (l_str___1)
						end
						if not l_str___1.is_void then
							l_buttons := split_button_string (l_str___1, l_n_buttons)
						end
					end
					if not (l_buttons.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_n_buttons.item = l_n_expected then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buttons))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
						l_buttons := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
						l_str___1 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (a_message))
						if not l_str___1.is_void then
							l_buttons := split_button_string (l_str___1, l_n_buttons)
						end
						if l_buttons.is_void then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
						end
				when 5 then -- if done
						Result := l_buttons
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	toolbar_button_focus_in_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTFOCUS]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
				gtk_widget_grab_focus (gui_inst.gui.item.drawarea)
			end
			Result := 1
		end

	toolbar_button_focus_in_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent toolbar_button_focus_in_event)
		end

	translate_mnemonic_tag (a_name___1: CE_POINTER [NATURAL_8]; a_use_mnemonic: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_psrc: CE_POINTER [NATURAL_8]
			l_pdest: CE_POINTER [NATURAL_8]
			l_n_underscores: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_name___1.make
			create l_buf___6.make
			create l_psrc.make
			create l_pdest.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make

			l_name___1 := a_name___1
			l_n_underscores := 0
			if globals_inst.output_conv.item.vc_type = 0 then
				l_name___1 := l_name___1
			elseif l_name___1.is_void then
				l_name___1 := l_name___1
			else
				l_name___1 := (mbyte_inst.string_convert (globals_inst.output_conv, l_name___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
			if l_name___1.is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_psrc := l_name___1
				from
				until
					js.loop_done
				loop
					if (l_psrc.item).to_integer_32 /= 0 then
						if (l_psrc.item).to_integer_32 = 9 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (l_psrc.item).to_integer_32 = 95 then
							l_n_underscores := l_n_underscores + 1
						end
						l_psrc := l_psrc + 1
					end
				end
				l_buf___6 := misc2_inst.alloc ((((l_psrc.distance (l_name___1)) + l_n_underscores) + 1).to_natural_32)
				if not l_buf___6.is_void then
					l_pdest := l_buf___6
					l_psrc := l_name___1
					from
					until
						js.loop_done
					loop
						if (l_psrc.item).to_integer_32 /= 0 then
							if (l_psrc.item).to_integer_32 = 9 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if (l_psrc.item).to_integer_32 = 95 then
								l_tmp___0 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___0.item := (('_').code).to_natural_8
								l_tmp___1 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___1.item := (('_').code).to_natural_8
							elseif (l_psrc.item).to_integer_32 /= 38 then
								l_tmp___2 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___2.item := l_psrc.item
							elseif (l_psrc[1]).to_integer_32 = 38 then
								l_tmp___3 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___4 := l_psrc
								l_psrc := l_psrc + 1
								l_tmp___3.item := l_tmp___4.item
							elseif a_use_mnemonic.to_boolean then
								l_tmp___5 := l_pdest
								l_pdest := l_pdest + 1
								l_tmp___5.item := (('_').code).to_natural_8
							end
							l_psrc := l_psrc + 1
						end
					end
					l_pdest.item := (('%/0/').code).to_natural_8
				end
				if globals_inst.output_conv.item.vc_type = 0 then
					l_name___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				else
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
					l_name___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				Result := l_buf___6
			end
		end

end
