class
	P_HASHTAB

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {ANY} -- routines

	hash_add (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_key: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			js: JUMP_STATE
		do
			create l_hi___1.make

			l_hash := (hash_hash (a_key))
			l_hi___1 := hash_lookup (a_ht, a_key, l_hash)
			if not ((l_hi___1.item.hi_key).is_void) then
				if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("hash_add()"))).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (hash_add_item (a_ht, l_hi___1, a_key, l_hash))
			end
		end

	hash_add_item (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_hi___1: CE_POINTER [PD_HASHITEM_S]; a_key: CE_POINTER [NATURAL_8]; a_hash: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_ht.item.ht_error).to_boolean then
				if (hash_may_resize (a_ht, 0)) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_ht.item.ht_used := (a_ht.item.ht_used) + 1
				if (a_hi___1.item.hi_key).is_void then
					a_ht.item.ht_filled := (a_ht.item.ht_filled) + 1
				end
				a_hi___1.item.hi_key := a_key
				a_hi___1.item.hi_hash := a_hash
				Result := (hash_may_resize (a_ht, 0))
			end
		end

	hash_clear (a_ht: CE_POINTER [PD_HASHTABLE_S])
		do
			if not (a_ht.item.ht_array).is_equal (a_ht.item.ht_smallarray) then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_ht.item.ht_array))
			end
		end

	hash_clear_all (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_off___0: INTEGER_32)
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
		do
			create l_hi___1.make

			l_todo := (a_ht.item.ht_used).to_integer_32
			l_hi___1 := a_ht.item.ht_array
			from
			until
				not (l_todo > 0)
			loop
				if not ((l_hi___1.item.hi_key).is_void) then
					if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_hi___1.item.hi_key - a_off___0)))
						l_todo := l_todo - 1
					end
				end
				l_hi___1 := l_hi___1 + 1
			end
			hash_clear (a_ht)
		end

	hash_debug_results
		do
		end

	hash_find (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_key: CE_POINTER [NATURAL_8]): CE_POINTER [PD_HASHITEM_S]
		do
			Result := (hash_lookup (a_ht, a_key, (hash_hash (a_key))))
		end

	hash_hash (a_key: CE_POINTER [NATURAL_8]): NATURAL_32
		local
			l_hash: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_hash := (a_key.item).to_natural_32
			if l_hash = {NATURAL_32} 0 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_p___0 := a_key + 1
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					l_tmp := l_p___0
					l_p___0 := l_p___0 + 1
					l_hash := l_hash * {NATURAL_32} 101 + (l_tmp.item).to_natural_32
				end
				Result := l_hash
			end
		end

	hash_init (a_ht: CE_POINTER [PD_HASHTABLE_S])
		do
			memset (create {CE_POINTER [ANY]}.make_cast (a_ht), 0, (create {PD_HASHTABLE_S}.make).structure_size.to_natural_32).do_nothing
			a_ht.item.ht_array := a_ht.item.ht_smallarray
			a_ht.item.ht_mask := (15).to_natural_32
		end

	hash_lock (a_ht: CE_POINTER [PD_HASHTABLE_S])
		do
			a_ht.item.ht_locked := (a_ht.item.ht_locked) + 1
		end

	hash_lookup (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_key: CE_POINTER [NATURAL_8]; a_hash: NATURAL_32): CE_POINTER [PD_HASHITEM_S]
		local
			l_perturb: NATURAL_32
			l_freeitem: CE_POINTER [PD_HASHITEM_S]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_idx: INTEGER_32
			l_tmp___0: CE_POINTER [PD_HASHITEM_S]
			js: JUMP_STATE
		do
			create l_freeitem.make
			create l_hi___1.make
			create l_tmp___0.make

			l_idx := ((a_hash).bit_and (a_ht.item.ht_mask)).to_integer_32
			l_hi___1 := a_ht.item.ht_array + l_idx
			if (l_hi___1.item.hi_key).is_void then
				Result := l_hi___1
				js.return
			end
			if not js.return_called then
				if (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
					l_freeitem := l_hi___1
				elseif l_hi___1.item.hi_hash = a_hash then
					if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_hi___1.item.hi_key), create {CE_POINTER [INTEGER_8]}.make_cast (a_key))) = 0 then
						Result := l_hi___1
						js.return
					else
						l_freeitem := create {CE_POINTER [PD_HASHITEM_S]}.make_shared (default_pointer)
					end
				else
					l_freeitem := create {CE_POINTER [PD_HASHITEM_S]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				l_perturb := a_hash
				from
				until
					js.loop_done
				loop
					l_idx := (((((l_idx).bit_shift_left (2)) + l_idx).to_natural_32 + l_perturb) + {NATURAL_32} 1).to_integer_32
					l_hi___1 := a_ht.item.ht_array + ((l_idx.to_natural_32).bit_and (a_ht.item.ht_mask)).to_integer_32
					if (l_hi___1.item.hi_key).is_void then
						if l_freeitem.is_void then
							l_tmp___0 := l_hi___1
						else
							l_tmp___0 := l_freeitem
						end
						Result := l_tmp___0
						js.return
					end
					if not js.return_called and then (l_hi___1.item.hi_hash = a_hash) then
						if not (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_hi___1.item.hi_key), create {CE_POINTER [INTEGER_8]}.make_cast (a_key))) = 0 then
								Result := l_hi___1
								js.return
							end
						end
					end
					if not js.return_called then
						if (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
							if l_freeitem.is_void then
								l_freeitem := l_hi___1
							end
						end
						l_perturb := (l_perturb).bit_shift_right ((5))
					end
				end
			end
		end

	hash_may_resize (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_minitems: INTEGER_32): INTEGER_32
		local
			l_minitems: INTEGER_32
			l_temparray: CE_ARRAY [PD_HASHITEM_S]
			l_oldarray: CE_POINTER [PD_HASHITEM_S]
			l_newarray: CE_POINTER [PD_HASHITEM_S]
			l_olditem: CE_POINTER [PD_HASHITEM_S]
			l_newitem: CE_POINTER [PD_HASHITEM_S]
			l_newi: INTEGER_32
			l_todo: INTEGER_32
			l_oldsize: NATURAL_32
			l_newsize: NATURAL_32
			l_minsize: NATURAL_32
			l_newmask: NATURAL_32
			l_perturb: NATURAL_32
			js: JUMP_STATE
		do
			create l_temparray.make (<<16>>)
			create l_oldarray.make
			create l_newarray.make
			create l_olditem.make
			create l_newitem.make

			l_minitems := a_minitems
			if a_ht.item.ht_locked > 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				if l_minitems = 0 then
					if a_ht.item.ht_filled < {NATURAL_32} 15 then
						if (a_ht.item.ht_array).is_equal (a_ht.item.ht_smallarray) then
							Result := 1
							js.return
						end
					end
					if not js.return_called then
						l_oldsize := a_ht.item.ht_mask + {NATURAL_32} 1
						if a_ht.item.ht_filled * {NATURAL_32} 3 < l_oldsize * {NATURAL_32} 2 then
							if a_ht.item.ht_used > l_oldsize // {NATURAL_32} 5 then
								Result := 1
								js.return
							end
						end
					end
					if not js.return_called then
						if a_ht.item.ht_used > {NATURAL_32} 1_000 then
							l_minsize := a_ht.item.ht_used * {NATURAL_32} 2
						else
							l_minsize := a_ht.item.ht_used * {NATURAL_32} 4
						end
					end
				else
					if l_minitems.to_natural_32 < a_ht.item.ht_used then
						l_minitems := (a_ht.item.ht_used).to_integer_32
					end
					l_minsize := ((l_minitems * 3) // 2).to_natural_32
				end
			end
			if not js.return_called then
				l_newsize := (16).to_natural_32
				from
				until
					not (not js.loop_done and then (l_newsize < l_minsize))
				loop
					l_newsize := (l_newsize).bit_shift_left ((1))
					if l_newsize = {NATURAL_32} 0 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				if l_newsize = {NATURAL_32} 16 then
					l_newarray := a_ht.item.ht_smallarray
					if (a_ht.item.ht_array).is_equal (l_newarray) then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_temparray), create {CE_POINTER [ANY]}.make_cast (l_newarray), ((create {PD_HASHITEM_S}.make).structure_size.to_natural_32 * (16).to_natural_32)).do_nothing
						l_oldarray := l_temparray
					else
						l_oldarray := a_ht.item.ht_array
					end
				else
					l_newarray := create {CE_POINTER [PD_HASHITEM_S]}.make_cast ((misc2_inst.alloc ((((create {PD_HASHITEM_S}.make).structure_size.to_natural_32).to_natural_32 * l_newsize).to_natural_32)))
					if l_newarray.is_void then
						if a_ht.item.ht_filled < a_ht.item.ht_mask then
							Result := 1
							js.return
						end
						if not js.return_called then
							a_ht.item.ht_error := 1
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_oldarray := a_ht.item.ht_array
					end
				end
			end
			if not js.return_called then
				memset (create {CE_POINTER [ANY]}.make_cast (l_newarray), 0, (((create {PD_HASHITEM_S}.make).structure_size.to_natural_32).to_natural_32 * l_newsize).to_natural_32).do_nothing
				l_newmask := l_newsize - {NATURAL_32} 1
				l_todo := (a_ht.item.ht_used).to_integer_32
				l_olditem := l_oldarray
				from
				until
					not (not js.loop_done and then (l_todo > 0))
				loop
					if not ((l_olditem.item.hi_key).is_void) then
						if not ((l_olditem.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_newi := ((l_olditem.item.hi_hash).bit_and (l_newmask)).to_integer_32
							l_newitem := l_newarray + l_newi
							if not (l_newitem.item.hi_key).is_void then
								l_perturb := l_olditem.item.hi_hash
								from
								until
									js.loop_done
								loop
									l_newi := (((((l_newi).bit_shift_left (2)) + l_newi).to_natural_32 + l_perturb) + {NATURAL_32} 1).to_integer_32
									l_newitem := l_newarray + ((l_newi.to_natural_32).bit_and (l_newmask)).to_integer_32
									if (l_newitem.item.hi_key).is_void then
										js.break
									end
									if not js.loop_jumped then
										l_perturb := (l_perturb).bit_shift_right ((5))
									end
								end
							end
							l_newitem.item := (l_olditem.item).twin
							l_todo := l_todo - 1
						end
					end
					l_olditem := l_olditem + 1
				end
				if not (a_ht.item.ht_array).is_equal (a_ht.item.ht_smallarray) then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_ht.item.ht_array))
				end
				a_ht.item.ht_array := l_newarray
				a_ht.item.ht_mask := l_newmask
				a_ht.item.ht_filled := a_ht.item.ht_used
				a_ht.item.ht_error := 0
				Result := 1
			end
		end

	hash_remove (a_ht: CE_POINTER [PD_HASHTABLE_S]; a_hi___1: CE_POINTER [PD_HASHITEM_S])
		do
			a_ht.item.ht_used := (a_ht.item.ht_used) - 1
			a_hi___1.item.hi_key := globals_inst.hash_removed
			hash_may_resize (a_ht, 0).do_nothing
		end

	hash_unlock (a_ht: CE_POINTER [PD_HASHTABLE_S])
		do
			a_ht.item.ht_locked := (a_ht.item.ht_locked) - 1
			hash_may_resize (a_ht, 0).do_nothing
		end

end
