class
	P_TAG

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create bottommsg.make
			create matches.make
			create mt_names.make (<<8>>)
			create nofile_fname.make
			create ptag_entry.make
			create tag_fnames.make (<<1>>)
			create tagmatchname.make
			create topmsg.make
		end

feature {ANY} -- attributes

	bottommsg: CE_POINTER [NATURAL_8] assign set_bottommsg

	set_bottommsg (a_bottommsg: CE_POINTER [NATURAL_8])
		do
			bottommsg := a_bottommsg
		end

	flags: INTEGER_32 assign set_flags

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
		end

	matches: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_matches

	set_matches (a_matches: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			matches := a_matches
		end

	max_num_matches: INTEGER_32 assign set_max_num_matches

	set_max_num_matches (a_max_num_matches: INTEGER_32)
		do
			max_num_matches := a_max_num_matches
		end

	mt_names: CE_ARRAY [CE_POINTER [INTEGER_8]]

	nofile_fname: CE_POINTER [NATURAL_8] assign set_nofile_fname

	set_nofile_fname (a_nofile_fname: CE_POINTER [NATURAL_8])
		do
			nofile_fname := a_nofile_fname
		end

	num_matches: INTEGER_32 assign set_num_matches

	set_num_matches (a_num_matches: INTEGER_32)
		do
			num_matches := a_num_matches
		end

	ptag_entry: PD_TAGGY assign set_ptag_entry

	set_ptag_entry (a_ptag_entry: PD_TAGGY)
		do
			ptag_entry := a_ptag_entry
		end

	tag_fnames: CE_ARRAY [PD_GROWARRAY]

	tagmatchname: CE_POINTER [NATURAL_8] assign set_tagmatchname

	set_tagmatchname (a_tagmatchname: CE_POINTER [NATURAL_8])
		do
			tagmatchname := a_tagmatchname
		end

	topmsg: CE_POINTER [NATURAL_8] assign set_topmsg

	set_topmsg (a_topmsg: CE_POINTER [NATURAL_8])
		do
			topmsg := a_topmsg
		end

feature {ANY} -- routines

	add_tag_field (a_dict: CE_POINTER [PD_DICTVAR_S]; a_field_name: CE_POINTER [INTEGER_8]; a_start___1: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_end: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_end.make
			create l_buf___6.make (<<4_096>>)

			l_end := a_end
			l_len := 0
			if not (eval_inst.dict_find (a_dict, create {CE_POINTER [NATURAL_8]}.make_cast (a_field_name), -1)).is_void then
				if option_inst.p_verbose.item > 0 then
					message_inst.verbose_enter
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Duplicate field name: %%s")))), a_field_name]).do_nothing
					message_inst.verbose_leave
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				if not a_start___1.is_void then
					if l_end.is_void then
						l_end := a_start___1 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_start___1))).to_integer_32
						from
						until
							js.loop_done
						loop
							if (l_end.c_pointer.to_integer_32).to_natural_32 > (a_start___1.c_pointer.to_integer_32).to_natural_32 then
								if (l_end[-1]).to_integer_32 /= 13 then
									if (l_end[-1]).to_integer_32 /= 10 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_end := l_end - 1
							end
						end
					end
					l_len := l_end.distance (a_start___1)
					if l_len > ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32).to_integer_32 - 1 then
						l_len := (({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32) - {NATURAL_32} 1).to_integer_32
					end
					misc2_inst.vim_strncpy (l_buf___6, a_start___1, l_len.to_natural_32)
				end
				l_buf___6[l_len] := (('%/0/').code).to_natural_8
				Result := (eval_inst.dict_add_nr_str (a_dict, a_field_name, 0, l_buf___6))
			end
		end

	do_tag (a_tag: CE_POINTER [NATURAL_8]; a_type: INTEGER_32; a_count___2: INTEGER_32; a_forceit: INTEGER_32; a_verbose: INTEGER_32): INTEGER_32
		local
			l_type: INTEGER_32
			l_tagstack: CE_POINTER [PD_TAGGY]
			l_tagstackidx: INTEGER_32
			l_tagstacklen: INTEGER_32
			l_cur_match: INTEGER_32
			l_cur_fnum: INTEGER_32
			l_oldtagstackidx: INTEGER_32
			l_prevtagstackidx: INTEGER_32
			l_prev_num_matches: INTEGER_32
			l_new_tag: INTEGER_32
			l_other_name: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_idx: INTEGER_32
			l_ic: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_no_regexp: INTEGER_32
			l_error_cur_match: INTEGER_32
			l_command_end: CE_POINTER [NATURAL_8]
			l_save_pos: INTEGER_32
			l_saved_fmark: PD_FILEMARK
			l_taglen: INTEGER_32
			l_tagp: CE_ARRAY [PD_TAG_POINTERS]
			l_tagp2: CE_ARRAY [PD_TAG_POINTERS]
			l_new_num_matches: CE_ARRAY [INTEGER_32]
			l_new_matches: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_attr: INTEGER_32
			l_use_tagstack: INTEGER_32
			l_skip_msg: INTEGER_32
			l_buf_ffname: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_old_KeyTyped: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_ask_for_selection: INTEGER_32
			l_tmp___24: INTEGER_32
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_tag_name: CE_ARRAY [NATURAL_8]
			l_fname: CE_ARRAY [NATURAL_8]
			l_cmd: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_cmd_len: INTEGER_32
			l_lnum: INTEGER_32
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_cmd_start: CE_POINTER [NATURAL_8]
			l_cmd_end: CE_POINTER [NATURAL_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tagstack.make
			create l_p___0.make
			create l_name___1.make
			create l_command_end.make
			create l_saved_fmark.make
			create l_tagp.make (<<1>>)
			create l_tagp2.make (<<1>>)
			create l_new_num_matches.make (<<1>>)
			create l_new_matches.make (<<1>>)
			create l_buf_ffname.make
			create l_tmp___0.make
			create l_buf___6.make
			create l_list.make
			create l_tag_name.make (<<129>>)
			create l_fname.make (<<4_097>>)
			create l_cmd.make (<<1_025>>)
			create l_dict.make
			create l_cmd_start.make
			create l_cmd_end.make
			create l_tmp___31.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := a_type
					l_tagstack := globals_inst.curwin.item.w_tagstack
					l_tagstackidx := globals_inst.curwin.item.w_tagstackidx
					l_tagstacklen := globals_inst.curwin.item.w_tagstacklen
					l_cur_match := 0
					l_cur_fnum := globals_inst.curbuf.item.b_fnum
					l_oldtagstackidx := l_tagstackidx
					l_prevtagstackidx := l_tagstackidx
					l_new_tag := 0
					l_no_regexp := 0
					l_error_cur_match := 0
					l_save_pos := 0
					l_skip_msg := 0
					l_buf_ffname := globals_inst.curbuf.item.b_ffname
					if l_type = 8 then
						l_type := 1
						l_no_regexp := 1
					end
					l_prev_num_matches := num_matches
					option_inst.free_string_option (nofile_fname)
					nofile_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_saved_fmark.mark.lnum := (0).to_integer_32
					l_saved_fmark.mark.col := 0
					l_saved_fmark.mark.coladd := 0
					l_saved_fmark.fnum := 0
					if (option_inst.p_tgst.item).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_tag.item).to_integer_32 /= 0 then
							l_use_tagstack := 0
							l_new_tag := 1
						else
							l_pos := -1 + 3 -- goto _L___3
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 3 then -- else: | _L___3:
						if globals_inst.g_do_tagpreview.to_boolean then
							l_use_tagstack := 0
						else
							l_use_tagstack := 1
						end
						if (a_tag.item).to_integer_32 = 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 4 then -- if:
						if l_type /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 14 -- goto _L___2
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 7 then -- else:
						if l_type /= 7 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L___2
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 10 then -- else:
						if l_type /= 9 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___2
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 13 then -- else:
						if l_type /= 11 then
							l_pos := -1 + 24 -- skip if block
						end
				when 14 then -- if: | _L___2:
						if not (globals_inst.g_do_tagpreview.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
						if (ptag_entry.tagname).is_void then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (ptag_entry.tagname), create {CE_POINTER [INTEGER_8]}.make_cast (a_tag))) = 0 then
							l_cur_match := ptag_entry.cur_match
							l_cur_fnum := ptag_entry.cur_fnum
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ptag_entry.tagname))
						ptag_entry.tagname := misc2_inst.vim_strsave (a_tag)
						if (ptag_entry.tagname).is_void then
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						from
						until
							not (l_tagstackidx < l_tagstacklen)
						loop
							l_tagstacklen := l_tagstacklen - 1
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_tagstack + l_tagstacklen).item.tagname))
						end
						l_tagstacklen := l_tagstacklen + 1
						if l_tagstacklen > 20 then
							l_tagstacklen := 20
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_tagstack + 0).item.tagname))
							l_i___0 := 1
							from
							until
								not (l_i___0 < l_tagstacklen)
							loop
								l_tagstack[(l_i___0 - 1)] := (l_tagstack[l_i___0]).twin
								l_i___0 := l_i___0 + 1
							end
							l_tagstackidx := l_tagstackidx - 1
						end
						l_tmp___0 := misc2_inst.vim_strsave (a_tag);
						(l_tagstack + l_tagstackidx).item.tagname := l_tmp___0
						if l_tmp___0.is_void then
							globals_inst.curwin.item.w_tagstacklen := l_tagstacklen - 1
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 21 then
						globals_inst.curwin.item.w_tagstacklen := l_tagstacklen
						l_save_pos := 1
				when 22 then
						l_new_tag := 1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 26 -- goto _L___1
				when 25 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 56
				when 26 then -- else: | _L___1:
						if globals_inst.g_do_tagpreview.to_boolean then
							l_tmp___2 := ((ptag_entry.tagname).is_void).to_integer
						else
							l_tmp___2 := (l_tagstacklen = 0).to_integer
						end
						if l_tmp___2.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_tagstack))))).do_nothing
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 27 then
						if l_type /= 2 then
							l_pos := -1 + 39 -- skip if block
						end
				when 28 then -- if:
						l_old_KeyTyped := globals_inst.KeyTyped
						l_tagstackidx := l_tagstackidx - a_count___2
						if not (l_tagstackidx < 0) then
							l_pos := -1 + 32 -- skip if block
						end
				when 29 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (bottommsg))))).do_nothing
						if l_tagstackidx + a_count___2 = 0 then
							l_tagstackidx := 0
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 30 then
						l_tagstackidx := 0
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						if l_tagstackidx >= l_tagstacklen then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (topmsg))))).do_nothing
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 33 then
						l_saved_fmark := ((l_tagstack + l_tagstackidx).item.fmark).twin
						if l_saved_fmark.fnum = globals_inst.curbuf.item.b_fnum then
							l_pos := -1 + 37 -- skip if block
						end
				when 34 then -- if:
						if (buffer_inst.buflist_getfile (l_saved_fmark.fnum, l_saved_fmark.mark.lnum, 1, a_forceit)) = 0 then
							l_tagstackidx := l_oldtagstackidx
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 35 then
						globals_inst.curwin.item.w_cursor.lnum := l_saved_fmark.mark.lnum
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						mark_inst.setpcmark
						globals_inst.curwin.item.w_cursor.lnum := l_saved_fmark.mark.lnum
				when 38 then -- if done
						globals_inst.curwin.item.w_cursor.col := l_saved_fmark.mark.col
						globals_inst.curwin.item.w_set_curswant := 1
						misc2_inst.check_cursor
						if ((option_inst.fdo_flags.item).bit_and ({NATURAL_32} 128)).to_boolean then
							if l_old_KeyTyped.to_boolean then
								fold_inst.foldOpenCursor
							end
						end
						misc1_inst.FreeWild (num_matches, matches)
						num_matches := 0
						tag_freematch
						l_pos := -1 + 154 -- goto end_do_tag
				when 39 then
						if l_type /= 1 then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___0
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 42 then -- else:
						if l_type /= 11 then
							l_pos := -1 + 50 -- skip if block
						end
				when 43 then -- if: | _L___0:
						if not (globals_inst.g_do_tagpreview.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_cur_match := ptag_entry.cur_match
						l_cur_fnum := ptag_entry.cur_fnum
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 46 then -- else:
						l_save_pos := 1
						l_tagstackidx := l_tagstackidx + (a_count___2 - 1)
						if l_tagstackidx >= l_tagstacklen then
							l_tagstackidx := l_tagstacklen - 1
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (topmsg))))).do_nothing
							l_save_pos := 0
						elseif l_tagstackidx < 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (bottommsg))))).do_nothing
							l_tagstackidx := 0
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 47 then
						l_cur_match := (l_tagstack + l_tagstackidx).item.cur_match
						l_cur_fnum := (l_tagstack + l_tagstackidx).item.cur_fnum
				when 48 then -- if done
						l_new_tag := 1
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 50 then -- else:
						l_prevtagstackidx := l_tagstackidx
						if globals_inst.g_do_tagpreview.to_boolean then
							l_cur_match := ptag_entry.cur_match
							l_cur_fnum := ptag_entry.cur_fnum
						else
							l_tagstackidx := l_tagstackidx - 1
							if l_tagstackidx < 0 then
								l_tagstackidx := 0
							end
							l_cur_match := (l_tagstack + l_tagstackidx).item.cur_match
							l_cur_fnum := (l_tagstack + l_tagstackidx).item.cur_fnum
						end
						inspect l_type -- switch 1 head
						when 5 then l_pos := -1 + 51
						when 7 then l_pos := -1 + 52
						when 9 then l_pos := -1 + 52
						when 6 then l_pos := -1 + 52
						when 3 then l_pos := -1 + 53
						when 4 then l_pos := -1 + 54
						else l_pos := -1 + 55
						end
				when 51 then -- switch 1, case 5
						l_cur_match := a_count___2 - 1
						l_pos := -1 + 55 -- switch 1; break
				when 52 then -- switch 1, case 7 | switch 1, case 9 | switch 1, case 6
						l_cur_match := 2_147_483_646
						l_pos := -1 + 55 -- switch 1; break
				when 53 then -- switch 1, case 3
						l_cur_match := l_cur_match + a_count___2
						l_pos := -1 + 55 -- switch 1; break
				when 54 then -- switch 1, case 4
						l_cur_match := l_cur_match - a_count___2
						l_pos := -1 + 55 -- switch 1; break
				when 55 then -- switch 1, done:
						if l_cur_match.to_integer_32 >= 2_147_483_647 then
							l_cur_match := 2_147_483_646
						elseif l_cur_match < 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E425: Cannot go before first matching tag"))))).do_nothing
							l_skip_msg := 1
							l_cur_match := 0
							l_cur_fnum := globals_inst.curbuf.item.b_fnum
						end
				when 56 then -- if done | if done
						if globals_inst.g_do_tagpreview.to_boolean then
							if l_type /= 7 then
								if l_type /= 9 then
									ptag_entry.cur_match := l_cur_match
									ptag_entry.cur_fnum := l_cur_fnum
								end
							end
						else
							l_saved_fmark := ((l_tagstack + l_tagstackidx).item.fmark).twin
							if l_save_pos.to_boolean then
								(l_tagstack + l_tagstackidx).item.fmark.mark := (globals_inst.curwin.item.w_cursor).twin;
								(l_tagstack + l_tagstackidx).item.fmark.fnum := globals_inst.curbuf.item.b_fnum
							end
							globals_inst.curwin.item.w_tagstackidx := l_tagstackidx
							if l_type /= 7 then
								if l_type /= 9 then
									globals_inst.curwin.item.w_tagstack[l_tagstackidx].cur_match := l_cur_match
									globals_inst.curwin.item.w_tagstack[l_tagstackidx].cur_fnum := l_cur_fnum
								end
							end
						end
				when 57 then
					if l_cur_fnum /= globals_inst.curbuf.item.b_fnum then
						l_buf___6 := (buffer_inst.buflist_findnr (l_cur_fnum))
						if not l_buf___6.is_void then
							l_buf_ffname := l_buf___6.item.b_ffname
						end
					end
				when 58 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 154 -- skip loop
					end
				when 59 then -- loop body:
						if l_use_tagstack.to_boolean then
							l_name___1 := (l_tagstack + l_tagstackidx).item.tagname
						elseif globals_inst.g_do_tagpreview.to_boolean then
							l_name___1 := ptag_entry.tagname
						else
							l_name___1 := a_tag
						end
						if tagmatchname.is_void then
							l_tmp___11 := 1
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (tagmatchname), create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1))) /= 0 then
							l_tmp___11 := 1
						else
							l_tmp___11 := 0
						end
						l_other_name := l_tmp___11
						if not (l_new_tag.to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						l_pos := -1 + 66 -- goto _L___4
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 62 then -- else:
						if not (l_cur_match >= num_matches) then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						if max_num_matches.to_integer_32 /= 2_147_483_647 then
							l_pos := -1 + 66 -- goto _L___4
						else
							l_pos := -1 + 65 -- goto _L___5
						end
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 65 then -- else: | _L___5:
						if not (l_other_name.to_boolean) then
							l_pos := -1 + 67 -- skip if block
						end
				when 66 then -- if: | _L___4:
						if l_other_name.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (tagmatchname))
							tagmatchname := misc2_inst.vim_strsave (l_name___1)
						end
						if l_type = 1 then
							if (a_tag.item).to_integer_32 /= 0 then
								if a_count___2 > 0 then
									l_cur_match := a_count___2 - 1
								end
							end
						end
						if l_type = 7 then
							l_cur_match := 2_147_483_646
						elseif l_type = 9 then
							l_cur_match := 2_147_483_646
						elseif l_type = 11 then
							l_cur_match := 2_147_483_646
						end
						max_num_matches := l_cur_match + 1
						if not l_no_regexp.to_boolean then
							if (l_name___1.item).to_integer_32 = 47 then
								flags := 4
								l_name___1 := l_name___1 + 1
							else
								flags := 8
							end
						else
							flags := 8
						end
						if a_verbose.to_boolean then
							flags := (flags).bit_or ((32))
						end
						if (find_tags (l_name___1, l_new_num_matches, l_new_matches, flags, max_num_matches, l_buf_ffname)) = 1 then
							if l_new_num_matches.item < max_num_matches then
								max_num_matches := 2_147_483_647
							end
						end
						if not l_new_tag.to_boolean then
							if not l_other_name.to_boolean then
								l_idx := 0
								l_j := 0
								from
								until
									not (not js.loop_done and then (l_j < num_matches))
								loop
									parse_match (matches[l_j], l_tagp).do_nothing
									l_i___0 := l_idx
									from
									until
										not (not js.loop_done and then (l_i___0 < l_new_num_matches.item))
									loop
										parse_match (l_new_matches.item[l_i___0], l_tagp2).do_nothing
										if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.tagname), create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp2.item.tagname))) = 0 then
											l_p___0 := l_new_matches.item[l_i___0]
											l_k := l_i___0
											from
											until
												not (l_k > l_idx)
											loop
												l_new_matches.item[l_k] := l_new_matches.item[(l_k - 1)]
												l_k := l_k - 1
											end
											l_tmp___13 := l_idx
											l_idx := l_idx + 1
											l_new_matches.item[l_tmp___13] := l_p___0
											js.break
										end
										if not js.loop_jumped then
											l_i___0 := l_i___0 + 1
										end
									end
									l_j := l_j + 1
								end
							end
						end
						misc1_inst.FreeWild (num_matches, matches)
						num_matches := l_new_num_matches.item
						matches := l_new_matches.item
				when 67 then -- if done | if done
						if not (num_matches <= 0) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if a_verbose.to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E426: tag not found: %%s")))), l_name___1).do_nothing
						end
						globals_inst.g_do_tagpreview := 0
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 70 then -- else:
						l_ask_for_selection := 0
						if l_type /= 7 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 75 -- goto _L___8
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 73 then -- else:
						if l_type /= 9 then
							l_pos := -1 + 98 -- skip if block
						end
				when 74 then -- if:
						if not (num_matches > 1) then
							l_pos := -1 + 96 -- skip if block
						end
				when 75 then -- if: | _L___8:
						parse_match (matches[0], l_tagp).do_nothing
						l_taglen := ((l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))) + 2
						if l_taglen < 18 then
							l_taglen := 18
						end
						if l_taglen.to_integer_32 > globals_inst.Columns.item - 25 then
							l_taglen := 2_147_483_647
						end
						if globals_inst.msg_col = 0 then
							globals_inst.msg_didout := 0
						end
						message_inst.msg_start
						message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("  # pri kind tag")))), globals_inst.highlight_attr[14])
						message_inst.msg_clr_eos
						taglen_advance (l_taglen)
						message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("file%N")))), globals_inst.highlight_attr[14])
						l_i___0 := 0
				when 76 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 94 -- skip loop
						end
				when 77 then -- loop body:
						if l_i___0 < num_matches then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 86 -- skip if block
						end
				when 78 then -- if:
						parse_match (matches[l_i___0], l_tagp).do_nothing
						if l_new_tag.to_boolean then
							l_pos := -1 + 84 -- skip if block
						end
				when 79 then -- if:
						if not (globals_inst.g_do_tagpreview.to_boolean) then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if:
						if l_i___0 = ptag_entry.cur_match then
							globals_inst.IObuff.item := (('>').code).to_natural_8
						else
							l_pos := -1 + 82 -- goto _L___6
						end
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else: | _L___6:
						if l_use_tagstack.to_boolean then
							if l_i___0 = (l_tagstack + l_tagstackidx).item.cur_match then
								globals_inst.IObuff.item := (('>').code).to_natural_8
							else
								globals_inst.IObuff.item := ((' ').code).to_natural_8
							end
						else
							globals_inst.IObuff.item := ((' ').code).to_natural_8
						end
				when 83 then -- if done | if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else:
						globals_inst.IObuff.item := ((' ').code).to_natural_8
				when 85 then
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + 1, (1_024).to_natural_32, ce_string ("%%2d %%s "), l_i___0 + 1, mt_names[(((matches[l_i___0])[0]).to_integer_32).bit_and (7)]]).do_nothing
						message_inst.msg_puts (globals_inst.IObuff)
						if not (l_tagp.item.tagkind).is_void then
							message_inst.msg_outtrans_len (l_tagp.item.tagkind, (l_tagp.item.tagkind_end).distance ((l_tagp.item.tagkind))).do_nothing
						end
						message_inst.msg_advance (13)
						message_inst.msg_outtrans_len_attr (l_tagp.item.tagname, (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname)), globals_inst.highlight_attr[14]).do_nothing
						message_inst.msg_putchar ((' ').code)
						taglen_advance (l_taglen)
						l_p___0 := tag_full_fname (l_tagp)
						if not l_p___0.is_void then
							message_inst.msg_puts_long_attr (l_p___0, globals_inst.highlight_attr[2])
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
						if globals_inst.msg_col > 0 then
							message_inst.msg_putchar (('%N').code)
						end
						if globals_inst.got_int.to_boolean then
							js.break
						end
				when 86 then -- if done
						if not js.loop_jumped then
							message_inst.msg_advance (15)
							l_command_end := l_tagp.item.command_end
							if not l_command_end.is_void then
								l_p___0 := l_command_end + 3
								from
								until
									js.loop_done
								loop
									if (l_p___0.item).to_boolean then
										if (l_p___0.item).to_integer_32 /= 13 then
											if (l_p___0.item).to_integer_32 = 10 then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										from
										until
											(l_p___0.item).to_integer_32 /= 9
										loop
											l_p___0 := l_p___0 + 1
										end
										if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)) = 0 then
											if (misc2_inst.vim_isspace ((l_p___0[5]).to_integer_32)).to_boolean then
												l_p___0 := l_p___0 + (5)
												js.continue
											end
										end
									end
									if not js.loop_jumped then
										if l_p___0.is_equal (l_tagp.item.tagkind) then
											l_p___0 := l_tagp.item.tagkind_end
											js.continue
										elseif (l_p___0 + 5).is_equal (l_tagp.item.tagkind) then
											if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("kind:"), (5).to_natural_32)) = 0 then
												l_p___0 := l_tagp.item.tagkind_end
												js.continue
											end
										end
									end
									if not js.loop_jumped then
										l_attr := globals_inst.highlight_attr[8]
										from
										until
											js.loop_done
										loop
											if (l_p___0.item).to_boolean then
												if (l_p___0.item).to_integer_32 /= 13 then
													if (l_p___0.item).to_integer_32 = 10 then
														js.break
													end
												else
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												if (globals_inst.msg_col + (charset_inst.ptr2cells (l_p___0))).to_integer_32 >= globals_inst.Columns.item then
													message_inst.msg_putchar (('%N').code)
													if globals_inst.got_int.to_boolean then
														js.break
													end
													if not js.loop_jumped then
														message_inst.msg_advance (15)
													end
												end
											end
											if not js.loop_jumped then
												l_p___0 := message_inst.msg_outtrans_one (l_p___0, l_attr)
												if (l_p___0.item).to_integer_32 = 9 then
													message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), l_attr)
													js.break
												end
											end
											if not js.loop_jumped and then ((l_p___0.item).to_integer_32 = 58) then
												l_attr := 0
											end
										end
									end
								end
								if globals_inst.msg_col > 15 then
									message_inst.msg_putchar (('%N').code)
									if globals_inst.got_int.to_boolean then
										js.break
									end
									if not js.loop_jumped then
										message_inst.msg_advance (15)
									end
								end
							else
								l_p___0 := l_tagp.item.command
								from
								until
									js.loop_done
								loop
									if (l_p___0.item).to_boolean then
										if (l_p___0.item).to_integer_32 /= 13 then
											if (l_p___0.item).to_integer_32 = 10 then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0 := l_p___0 + 1
									end
								end
								l_command_end := l_p___0
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 93 -- skip if block
						end
				when 87 then -- if:
						l_p___0 := l_tagp.item.command
						if (l_p___0.item).to_integer_32 /= 47 then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						l_pos := -1 + 91 -- goto _L___7
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 90 then -- else:
						if (l_p___0.item).to_integer_32 /= 63 then
							l_pos := -1 + 92 -- skip if block
						end
				when 91 then -- if: | _L___7:
						l_p___0 := l_p___0 + 1
						if (l_p___0.item).to_integer_32 = 94 then
							l_p___0 := l_p___0 + 1
						end
				when 92 then -- if done
						from
						until
							js.loop_done
						loop
							if not l_p___0.is_equal (l_command_end) then
								if not (misc2_inst.vim_isspace ((l_p___0.item).to_integer_32)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						from
						until
							not (not js.loop_done and then (not l_p___0.is_equal (l_command_end)))
						loop
							if (l_p___0.item).to_integer_32 = 9 then
								l_tmp___24 := 1
							else
								l_tmp___24 := (charset_inst.ptr2cells (l_p___0))
							end
							if (globals_inst.msg_col + l_tmp___24).to_integer_32 > globals_inst.Columns.item then
								message_inst.msg_putchar (('%N').code)
							end
							if globals_inst.got_int.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								message_inst.msg_advance (15)
								if (l_p___0.item).to_integer_32 = 92 then
									if (l_p___0[1]).to_integer_32 = ((l_tagp.item.command).item).to_integer_32 then
										l_p___0 := l_p___0 + 1
									end
								end
								if (l_p___0.item).to_integer_32 = 9 then
									message_inst.msg_putchar ((' ').code)
									l_p___0 := l_p___0 + 1
								else
									l_p___0 := message_inst.msg_outtrans_one (l_p___0, 0)
								end
								if l_p___0.is_equal (l_command_end - 2) then
									if (l_p___0.item).to_integer_32 = 36 then
										if (l_p___0[1]).to_integer_32 = ((l_tagp.item.command).item).to_integer_32 then
											js.break
										end
									end
								end
							end
							if not js.loop_jumped and then (l_p___0.is_equal (l_command_end - 1)) then
								if (l_p___0.item).to_integer_32 = ((l_tagp.item.command).item).to_integer_32 then
									if (l_p___0.item).to_integer_32 = 47 then
										js.break
									elseif (l_p___0.item).to_integer_32 = 63 then
										js.break
									end
								end
							end
						end
						if globals_inst.msg_col.to_boolean then
							message_inst.msg_putchar (('%N').code)
						end
						ui_inst.ui_breakcheck
						l_i___0 := l_i___0 + 1
				when 93 then -- if done
						l_pos := -1 + 76 -- back to loop condition
				when 94 then -- loop done
						if globals_inst.got_int.to_boolean then
							globals_inst.got_int := 0
						end
						l_ask_for_selection := 1
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 96 then -- else:
						l_pos := -1 + 98 -- goto _L___9
				when 97 then -- if done | if block done, skip else block:
						l_pos := -1 + 101
				when 98 then -- else: | _L___9:
						if l_type /= 11 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_list := eval_inst.list_alloc
						if l_list.is_void then
							l_pos := -1 + 154 -- goto end_do_tag
						end
				when 100 then
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < num_matches))
						loop
							parse_match (matches[l_i___0], l_tagp).do_nothing
							l_len := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
							if l_len > 128 then
								l_len := 128
							end
							misc2_inst.vim_strncpy (l_tag_name, l_tagp.item.tagname, l_len.to_natural_32)
							l_tag_name[l_len] := (('%/0/').code).to_natural_8
							l_p___0 := tag_full_fname (l_tagp)
							if l_p___0.is_void then
								js.continue
							end
							if not js.loop_jumped then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								l_lnum := 0
								if ((((ctype_b_loc).item[((l_tagp.item.command).item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
									l_lnum := atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.command))
								else
									l_cmd_start := l_tagp.item.command
									l_cmd_end := l_tagp.item.command_end
									if l_cmd_end.is_void then
										l_p___0 := l_tagp.item.command
										from
										until
											js.loop_done
										loop
											if (l_p___0.item).to_boolean then
												if (l_p___0.item).to_integer_32 /= 13 then
													if (l_p___0.item).to_integer_32 = 10 then
														js.break
													end
												else
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_p___0 := l_p___0 + 1
											end
										end
										l_cmd_end := l_p___0
									end
									l_cmd_end := l_cmd_end - 1
									if (l_cmd_start.item).to_integer_32 = 47 then
										l_cmd_start := l_cmd_start + 1
									elseif (l_cmd_start.item).to_integer_32 = 63 then
										l_cmd_start := l_cmd_start + 1
									end
									if (l_cmd_end.item).to_integer_32 = 47 then
										l_cmd_end := l_cmd_end - 1
									elseif (l_cmd_end.item).to_integer_32 = 63 then
										l_cmd_end := l_cmd_end - 1
									end
									l_len := 0
									l_cmd[0] := (('%/0/').code).to_natural_8
									if (l_cmd_start.item).to_integer_32 = 94 then
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), ce_string ("^")).do_nothing
										l_cmd_start := l_cmd_start + 1
										l_len := l_len + 1
									end
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), ce_string ("\V")).do_nothing
									l_len := l_len + (2)
									l_cmd_len := (l_cmd_end.distance (l_cmd_start)) + 1
									if l_cmd_len > 1_019 then
										l_cmd_len := 1_019
									end
									strncat (create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd_start), l_cmd_len.to_natural_32).do_nothing
									l_len := l_len + l_cmd_len
									if (l_cmd[l_len - 1]).to_integer_32 = 36 then
										l_cmd[l_len - 1] := (('\').code).to_natural_8
										l_cmd[l_len] := (('$').code).to_natural_8
										l_len := l_len + 1
									end
									l_cmd[l_len] := (('%/0/').code).to_natural_8
								end
								l_dict := eval_inst.dict_alloc
								if l_dict.is_void then
									js.continue
								end
							end
							if not js.loop_jumped then
								if (eval_inst.list_append_dict (l_list, l_dict)) = 0 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dict))
									js.continue
								end
							end
							if not js.loop_jumped then
								eval_inst.dict_add_nr_str (l_dict, ce_string ("text"), 0, l_tag_name).do_nothing
								eval_inst.dict_add_nr_str (l_dict, ce_string ("filename"), 0, l_fname).do_nothing
								eval_inst.dict_add_nr_str (l_dict, ce_string ("lnum"), l_lnum, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
								if l_lnum = 0 then
									eval_inst.dict_add_nr_str (l_dict, ce_string ("pattern"), 0, l_cmd).do_nothing
								end
							end
							if js.loop_increment then
								l_i___0 := l_i___0 + 1
							end
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("ltag %%s"), a_tag]).do_nothing
						quickfix_inst.set_errorlist (globals_inst.curwin, l_list, (' ').code, globals_inst.IObuff).do_nothing
						eval_inst.list_free (l_list, 1)
						l_cur_match := 0
				when 101 then -- if done | if done
						if l_ask_for_selection /= 1 then
							l_pos := -1 + 111 -- skip if block
						end
				when 102 then -- if:
						l_i___0 := misc1_inst.prompt_for_number (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						if not (l_i___0 <= 0) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						l_pos := -1 + 109 -- goto _L___10
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 105 then -- else:
						if not (l_i___0 > num_matches) then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						l_pos := -1 + 109 -- goto _L___10
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 108 then -- else:
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 110 -- skip if block
						end
				when 109 then -- if: | _L___10:
						if l_use_tagstack.to_boolean then
							(l_tagstack + l_tagstackidx).item.fmark := l_saved_fmark.twin
							l_tagstackidx := l_prevtagstackidx
						end
						js.break
				when 110 then -- if done | if done
						if not js.loop_jumped then
							l_cur_match := l_i___0 - 1
						end
				when 111 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 153 -- skip if block
						end
				when 112 then -- if:
						if not (l_cur_match >= num_matches) then
							l_pos := -1 + 119 -- skip if block
						end
				when 113 then -- if:
						if l_type /= 3 then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						l_pos := -1 + 117 -- goto _L___11
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 118
				when 116 then -- else:
						if l_type /= 5 then
							l_pos := -1 + 118 -- skip if block
						end
				when 117 then -- if: | _L___11:
						if nofile_fname.is_void then
							if num_matches = 1 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E427: There is only one matching tag"))))).do_nothing
							else
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E428: Cannot go beyond last matching tag"))))).do_nothing
							end
							l_skip_msg := 1
						end
				when 118 then -- if done
						l_cur_match := num_matches - 1
				when 119 then -- if done
						if l_use_tagstack.to_boolean then
							(l_tagstack + l_tagstackidx).item.cur_match := l_cur_match;
							(l_tagstack + l_tagstackidx).item.cur_fnum := l_cur_fnum
							l_tagstackidx := l_tagstackidx + 1
						elseif globals_inst.g_do_tagpreview.to_boolean then
							ptag_entry.cur_match := l_cur_match
							ptag_entry.cur_fnum := l_cur_fnum
						end
						if not nofile_fname.is_void then
							if l_error_cur_match /= l_cur_match then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("File %"%%s%" does not exist")))), nofile_fname]).do_nothing
							end
						end
						l_ic := (((matches[l_cur_match])[0]).to_integer_32).bit_and (4)
						if l_type = 7 then
							l_pos := -1 + 134 -- skip if block
						end
				when 120 then -- if:
						if l_type = 9 then
							l_pos := -1 + 134 -- skip if block
						end
				when 121 then -- if:
						if not (num_matches > 1) then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						l_pos := -1 + 125 -- goto _L___13
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 124 then -- else:
						if not (l_ic.to_boolean) then
							l_pos := -1 + 134 -- skip if block
						end
				when 125 then -- if: | _L___13:
						if l_skip_msg.to_boolean then
							l_pos := -1 + 134 -- skip if block
						end
				when 126 then -- if:
						if max_num_matches.to_integer_32 /= 2_147_483_647 then
							l_tmp___31 := (gettext (ce_string (" or more")))
						else
							l_tmp___31 := ce_string ("")
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("tag %%d of %%d%%s"))), l_cur_match + 1, num_matches, l_tmp___31]).do_nothing
						if l_ic.to_boolean then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("  Using tag with different case!")))).do_nothing
						end
						if not (num_matches > l_prev_num_matches) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						l_pos := -1 + 130 -- goto _L___12
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 129 then -- else:
						if not (l_new_tag.to_boolean) then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if: | _L___12:
						if num_matches > 1 then
							if l_ic.to_boolean then
								message_inst.msg_attr (globals_inst.IObuff, globals_inst.highlight_attr[17]).do_nothing
							else
								message_inst.msg (globals_inst.IObuff).do_nothing
							end
							globals_inst.msg_scroll := 1
						else
							message_inst.give_warning (globals_inst.IObuff, l_ic)
						end
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 132 then -- else:
						message_inst.give_warning (globals_inst.IObuff, l_ic)
				when 133 then -- if done
						if l_ic.to_boolean then
							if not globals_inst.msg_scrolled.to_boolean then
								if globals_inst.msg_silent = 0 then
									term_inst.out_flush
									ui_inst.ui_delay (1_000, 1)
								end
							end
						end
				when 134 then -- if done | if done | if done | if done
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string (":ta %%s%R"), l_name___1]).do_nothing
						eval_inst.set_vim_var_string (47, globals_inst.IObuff, -1)
						l_i___0 := jumpto_tag (matches[l_cur_match], a_forceit, (l_type /= 10).to_integer)
						eval_inst.set_vim_var_string (47, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
						if l_i___0 /= 99 then
							l_pos := -1 + 152 -- skip if block
						end
				when 135 then -- if:
						if l_type /= 4 then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if:
						if l_cur_match > 0 then
							l_pos := -1 + 149 -- goto _L___15
						else
							l_pos := -1 + 138 -- goto _L___17
						end
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 138 then -- else: | _L___17:
						if l_type /= 1 then
							l_pos := -1 + 141 -- skip if block
						end
				when 139 then -- if:
						l_pos := -1 + 145 -- goto _L___16
				when 140 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 141 then -- else:
						if l_type /= 3 then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_pos := -1 + 145 -- goto _L___16
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 144 then -- else:
						if l_type /= 5 then
							l_pos := -1 + 150 -- skip if block
						end
				when 145 then -- if: | _L___16:
						if max_num_matches.to_integer_32 = 2_147_483_647 then
							l_pos := -1 + 148 -- skip if block
						end
				when 146 then -- if:
						l_pos := -1 + 149 -- goto _L___15
				when 147 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 148 then -- else:
						if not (l_cur_match < num_matches - 1) then
							l_pos := -1 + 150 -- skip if block
						end
				when 149 then -- if: | _L___15:
						l_error_cur_match := l_cur_match
						if l_use_tagstack.to_boolean then
							l_tagstackidx := l_tagstackidx - 1
						end
						if l_type = 4 then
							l_cur_match := l_cur_match - 1
						else
							l_type := 3
							l_cur_match := l_cur_match + 1
						end
						js.continue
				when 150 then -- if done | if done | if done | if done | if done
						if not js.loop_jumped then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E429: File %"%%s%" does not exist")))), nofile_fname).do_nothing
						end
				when 151 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 152 then -- else:
						if l_use_tagstack.to_boolean then
							if l_tagstackidx > globals_inst.curwin.item.w_tagstacklen then
								l_tagstackidx := globals_inst.curwin.item.w_tagstackidx
							end
						end
				when 153 then -- if done | if done | if done
						if not js.loop_jumped then
							js.break
						end
						if js.loop_increment then
							
						end
						l_pos := -1 + 58 -- back to loop condition
				when 154 then -- end_do_tag:
					if l_use_tagstack.to_boolean then
						if l_tagstackidx <= globals_inst.curwin.item.w_tagstacklen then
							globals_inst.curwin.item.w_tagstackidx := l_tagstackidx
						end
					end
					globals_inst.postponed_split := 0
					Result := 0
				when 155 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_tags (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tagstack: CE_POINTER [PD_TAGGY]
			l_tagstackidx: INTEGER_32
			l_tagstacklen: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_name___1.make
			create l_tagstack.make

			l_tagstack := globals_inst.curwin.item.w_tagstack
			l_tagstackidx := globals_inst.curwin.item.w_tagstackidx
			l_tagstacklen := globals_inst.curwin.item.w_tagstacklen
			message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N  # TO tag         FROM line  in file/text")))))
			l_i___0 := 0
			from
			until
				not (l_i___0 < l_tagstacklen)
			loop
				if not ((l_tagstack + l_i___0).item.tagname).is_void then
					l_name___1 := mark_inst.fm_getname (create {CE_POINTER [PD_FILEMARK]}.make_shared ((l_tagstack + l_i___0).c_pointer + (create {PD_TAGGY}.make).offset_of ("fmark")), 30)
					if l_name___1.is_void then
						js.continue
					end
					if not js.loop_jumped then
						message_inst.msg_putchar (('%N').code)
						if l_i___0 = l_tagstackidx then
							l_tmp___0 := ('>').code
						else
							l_tmp___0 := (' ').code
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%c%%2d %%2d %%-15s %%5ld  "), l_tmp___0, l_i___0 + 1, (l_tagstack + l_i___0).item.cur_match + 1, (l_tagstack + l_i___0).item.tagname, (l_tagstack + l_i___0).item.fmark.mark.lnum]).do_nothing
						message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
						if (l_tagstack + l_i___0).item.fmark.fnum = globals_inst.curbuf.item.b_fnum then
							l_tmp___1 := globals_inst.highlight_attr[2]
						else
							l_tmp___1 := 0
						end
						message_inst.msg_outtrans_attr (l_name___1, l_tmp___1).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
					end
				end
				if not js.loop_jumped then
					term_inst.out_flush
				end
				l_i___0 := l_i___0 + 1
			end
			if l_tagstackidx = l_tagstacklen then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N>")))
			end
		end

	do_tags_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_tags)
		end

	expand_tag_fname (a_fname: CE_POINTER [NATURAL_8]; a_tag_fname: CE_POINTER [NATURAL_8]; a_expand: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: CE_POINTER [NATURAL_8]
			l_expanded_fname: CE_POINTER [NATURAL_8]
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_p___0.make
			create l_retval.make
			create l_expanded_fname.make
			create l_xpc.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := a_fname
					l_expanded_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if a_expand.to_boolean then
						if (os_unix_inst.mch_has_wildcard (l_fname)).to_boolean then
							ex_getln_inst.ExpandInit (l_xpc)
							l_xpc.item.xp_context := 2
							l_expanded_fname := ex_getln_inst.ExpandOne (l_xpc, l_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 65, 2)
							if not l_expanded_fname.is_void then
								l_fname := l_expanded_fname
							end
						end
					end
					if not ((option_inst.p_tr.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((globals_inst.curbuf.item.b_help).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if (window_inst.vim_isAbsName (l_fname)).to_boolean then
							l_retval := misc2_inst.vim_strsave (l_fname)
						else
							l_p___0 := misc1_inst.gettail (a_tag_fname)
							if not l_p___0.is_equal (a_tag_fname) then
								l_retval := misc2_inst.alloc ({NATURAL_32} 4_096)
								if not l_retval.is_void then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_retval), create {CE_POINTER [INTEGER_8]}.make_cast (a_tag_fname)).do_nothing
									misc2_inst.vim_strncpy (l_retval + (l_p___0.distance (a_tag_fname)), l_fname, ((4_096 - (l_p___0.distance (a_tag_fname))) - 1).to_natural_32)
									simplify_filename (l_retval)
								end
							else
								l_retval := misc2_inst.vim_strsave (l_fname)
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_retval := misc2_inst.vim_strsave (l_fname)
				when 7 then -- if done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_expanded_fname))
						Result := l_retval
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	expand_tags (a_tagnames: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_tagnmflag: INTEGER_32
			l_tagnm: CE_ARRAY [NATURAL_8]
			l_t_p: CE_ARRAY [PD_TAG_POINTERS]
			l_ret: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create l_tagnm.make (<<100>>)
			create l_t_p.make (<<1>>)

			if a_tagnames.to_boolean then
				l_tagnmflag := 2
			else
				l_tagnmflag := 0
			end
			if (a_pat[0]).to_integer_32 = 47 then
				l_ret := find_tags (a_pat + 1, a_num_file, a_file, (((4).bit_or (l_tagnmflag))).bit_or (32), 300, globals_inst.curbuf.item.b_ffname)
			else
				l_ret := find_tags (a_pat, a_num_file, a_file, (((((4).bit_or (l_tagnmflag))).bit_or (32))).bit_or (8), 300, globals_inst.curbuf.item.b_ffname)
			end
			if l_ret = 1 then
				if not a_tagnames.to_boolean then
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_num_file.item)
					loop
						parse_match (a_file.item[l_i___0], l_t_p).do_nothing
						l_c := (l_t_p.item.tagname_end).distance ((l_t_p.item.tagname))
						memmove (create {CE_POINTER [ANY]}.make_cast (l_tagnm), create {CE_POINTER [ANY]}.make_cast (l_t_p.item.tagname), l_c.to_natural_32).do_nothing
						l_tmp := l_c
						l_c := l_c + 1
						l_tagnm[l_tmp] := (0).to_natural_8
						l_tmp___0 := l_c
						l_c := l_c + 1
						if not (l_t_p.item.tagkind).is_void then
							if ((l_t_p.item.tagkind).item).to_boolean then
								l_tagnm[l_tmp___0] := (l_t_p.item.tagkind).item
							else
								l_tagnm[l_tmp___0] := (('f').code).to_natural_8
							end
						else
							l_tagnm[l_tmp___0] := (('f').code).to_natural_8
						end
						l_tmp___1 := l_c
						l_c := l_c + 1
						l_tagnm[l_tmp___1] := (0).to_natural_8
						memmove (create {CE_POINTER [ANY]}.make_cast ((a_file.item[l_i___0] + l_c)), create {CE_POINTER [ANY]}.make_cast (l_t_p.item.fname), ((l_t_p.item.fname_end).distance ((l_t_p.item.fname))).to_natural_32).do_nothing;
						(a_file.item[l_i___0])[(l_c + ((l_t_p.item.fname_end).distance ((l_t_p.item.fname))))] := (0).to_natural_8
						memmove (create {CE_POINTER [ANY]}.make_cast (a_file.item[l_i___0]), create {CE_POINTER [ANY]}.make_cast (l_tagnm), l_c.to_natural_32).do_nothing
						l_i___0 := l_i___0 + 1
					end
				end
			end
			Result := l_ret
		end

	find_extra (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_str___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1 := a_pp.item
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 23 -- skip loop
					end
				when 2 then -- loop body:
						if not ((l_str___1.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1.item).to_integer_32 <= 57 then
							l_str___1 := charset_inst.skipdigits (l_str___1)
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else: | _L___0:
						if (l_str___1.item).to_integer_32 /= 47 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_str___1.item).to_integer_32 /= 63 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_str___1 := regexp_inst.skip_regexp (l_str___1 + 1, (l_str___1.item).to_integer_32, 0, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
						if (l_str___1.item).to_integer_32 /= ((a_pp.item).item).to_integer_32 then
							l_str___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						else
							l_str___1 := l_str___1 + 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_str___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				when 12 then -- if done | if done
						if not (l_str___1.is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						js.break
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if (l_str___1.item).to_integer_32 = 59 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						js.break
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not ((l_str___1[1]).to_integer_32 >= 48) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not ((l_str___1[1]).to_integer_32 <= 57) then
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___1:
						if (l_str___1[1]).to_integer_32 /= 47 then
							if (l_str___1[1]).to_integer_32 /= 63 then
								js.break
							end
						end
				when 22 then -- if done | if done
						if not js.loop_jumped then
							l_str___1 := l_str___1 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 23 then -- loop done
					if not l_str___1.is_void then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), ce_string (";%""), (2).to_natural_32)) = 0 then
							a_pp.item := l_str___1
							Result := 1
							js.return
						end
					end
					if not js.return_called then
						Result := 0
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_tags (a_pat: CE_POINTER [NATURAL_8]; a_num_matches___0: CE_POINTER [INTEGER_32]; a_matchesp: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32; a_mincount: INTEGER_32; a_buf_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_lbuf: CE_POINTER [NATURAL_8]
			l_tag_fname: CE_POINTER [NATURAL_8]
			l_tn: CE_ARRAY [PD_TAGNAME_T]
			l_first_file: INTEGER_32
			l_tagp: CE_ARRAY [PD_TAG_POINTERS]
			l_did_open: INTEGER_32
			l_stop_searching: INTEGER_32
			l_retval: INTEGER_32
			l_is_static: INTEGER_32
			l_is_current: INTEGER_32
			l_eof: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_search_info: CE_ARRAY [PD_TAG_SEARCH_INFO]
			l_filesize: INTEGER_32
			l_tagcmp: INTEGER_32
			l_offset: INTEGER_32
			l_round: INTEGER_32
			l_state: NATURAL_32
			l_cmplen: INTEGER_32
			l_match: INTEGER_32
			l_match_no_ic: INTEGER_32
			l_match_re: INTEGER_32
			l_matchoff: INTEGER_32
			l_mfp: CE_POINTER [PD_MATCH_FOUND]
			l_mfp2: CE_POINTER [PD_MATCH_FOUND]
			l_ga_match: CE_ARRAY [PD_GROWARRAY]
			l_match_count: INTEGER_32
			l_matches___0: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_mtt: INTEGER_32
			l_len: INTEGER_32
			l_help_save: INTEGER_32
			l_help_pri: INTEGER_32
			l_help_lang_find: CE_POINTER [NATURAL_8]
			l_help_lang: CE_ARRAY [NATURAL_8]
			l_saved_pat: CE_POINTER [NATURAL_8]
			l_pats: CE_POINTER [PD_PAT_T]
			l_orgpat: CE_ARRAY [PD_PAT_T]
			l_convpat: CE_ARRAY [PD_PAT_T]
			l_vimconv: CE_ARRAY [PD_VIMCONV_T]
			l_findall: INTEGER_32
			l_tmp: INTEGER_32
			l_sort_error: INTEGER_32
			l_linear: INTEGER_32
			l_sortic: INTEGER_32
			l_line_error: INTEGER_32
			l_has_re: INTEGER_32
			l_help_only: INTEGER_32
			l_name_only: INTEGER_32
			l_noic: INTEGER_32
			l_get_it_again: INTEGER_32
			l_verbose: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___22: INTEGER_32
			l_cc___0: INTEGER_32
			l_conv_line: CE_POINTER [NATURAL_8]
			l_lbuf_line: CE_POINTER [NATURAL_8]
			l_tmp___32: INTEGER_32
			l_temp_end: CE_POINTER [NATURAL_8]
			l_tmp___36: NATURAL_32
			l_tmp___41: INTEGER_32
			l_tmp___44: INTEGER_32
			l_tmp___50: INTEGER_32
			l_tmp___51: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_lbuf.make
			create l_tag_fname.make
			create l_tn.make (<<1>>)
			create l_tagp.make (<<1>>)
			create l_p___0.make
			create l_s.make
			create l_search_info.make (<<1>>)
			create l_mfp.make
			create l_mfp2.make
			create l_ga_match.make (<<16>>)
			create l_matches___0.make
			create l_help_lang_find.make
			create l_help_lang.make (<<3>>)
			create l_saved_pat.make
			create l_pats.make
			create l_orgpat.make (<<1>>)
			create l_convpat.make (<<1>>)
			create l_vimconv.make (<<1>>)
			create l_conv_line.make
			create l_lbuf_line.make
			create l_temp_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_open := 0
					l_stop_searching := 0
					l_retval := 0
					l_eof := 0
					l_match_no_ic := 0
					l_matchoff := 0
					l_match_count := 0
					l_help_pri := 0
					l_help_lang_find := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_saved_pat := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if a_mincount.to_integer_32 = 2_147_483_647 then
						l_tmp := 1
					elseif a_mincount = 300 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_findall := l_tmp
					l_sort_error := 0
					l_sortic := 0
					l_line_error := 0
					l_has_re := (a_flags___0).bit_and (4)
					l_help_only := (a_flags___0).bit_and (1)
					l_name_only := (a_flags___0).bit_and (2)
					l_noic := (a_flags___0).bit_and (8)
					l_get_it_again := 0
					l_verbose := (a_flags___0).bit_and (32)
					l_help_save := globals_inst.curbuf.item.b_help
					l_orgpat.item.pat := a_pat
					l_pats := l_orgpat
					l_vimconv.item.vc_type := 0
					l_lbuf := misc2_inst.alloc ({NATURAL_32} 512)
					l_tag_fname := misc2_inst.alloc ({NATURAL_32} 4_097)
					l_mtt := 0
					from
					until
						not (l_mtt < 16)
					loop
						misc2_inst.ga_init2 (l_ga_match + l_mtt, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 100)
						l_mtt := l_mtt + 1
					end
					if l_lbuf.is_void then
						l_pos := -1 + 63 -- goto findtag_end
					elseif l_tag_fname.is_void then
						l_pos := -1 + 63 -- goto findtag_end
					end
				when 1 then
					if l_help_only.to_boolean then
						globals_inst.curbuf.item.b_help := 1
					end
					l_pats.item.len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))).to_integer_32
					if (globals_inst.curbuf.item.b_help).to_boolean then
						if l_pats.item.len > 3 then
							if (a_pat[(l_pats.item.len - 3)]).to_integer_32 = 64 then
								if (a_pat[(l_pats.item.len - 2)]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(a_pat[(l_pats.item.len - 2)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
										if (a_pat[(l_pats.item.len - 1)]).to_integer_32 < 127 then
											if ((((ctype_b_loc).item[(a_pat[(l_pats.item.len - 1)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
												l_saved_pat := misc2_inst.vim_strnsave (a_pat, l_pats.item.len - 3)
												if not l_saved_pat.is_void then
													l_help_lang_find := a_pat + (l_pats.item.len - 2)
													l_pats.item.pat := l_saved_pat
													l_pats.item.len := l_pats.item.len - (3)
												end
											end
										end
									end
								end
							end
						end
					end
					if option_inst.p_tl.item /= 0 then
						if (l_pats.item.len).to_integer_32 > option_inst.p_tl.item then
							l_pats.item.len := (option_inst.p_tl.item).to_integer_32
						end
					end
					prepare_pats (l_pats, l_has_re)
					memset (create {CE_POINTER [ANY]}.make_cast (l_search_info), 0, (1).to_natural_32).do_nothing
					if not ((option_inst.p_ic.item).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if l_noic.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_findall.to_boolean then
							l_tmp___3 := 1
						elseif l_pats.item.headlen = 0 then
							l_tmp___3 := 1
						elseif not (option_inst.p_tbs.item).to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_tmp___3 := 0
				when 8 then -- if done
						l_pats.item.regmatch.rm_ic := l_tmp___3
						l_round := 1
				when 9 then -- loop condition:
						if not (not js.loop_done and then (l_round <= 2)) then
							l_pos := -1 + 62 -- skip loop
						end
				when 10 then -- loop body:
							if l_pats.item.headlen = 0 then
								l_tmp___4 := 1
							elseif not (option_inst.p_tbs.item).to_boolean then
								l_tmp___4 := 1
							elseif l_round = 2 then
								l_tmp___4 := 1
							else
								l_tmp___4 := 0
							end
							l_linear := l_tmp___4
							l_first_file := 1
				when 11 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 51 -- skip loop
							end
				when 12 then -- loop body:
							if (get_tagfname (l_tn, l_first_file, l_tag_fname)) /= 1 then
								js.break
							end
							if not (not js.loop_jumped and then ((globals_inst.curbuf.item.b_help).to_boolean)) then
								l_pos := -1 + 22 -- skip if block
							end
				when 13 then -- if:
							l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tag_fname))).to_integer_32
							if l_i___0 > 3 then
								if (l_tag_fname[(l_i___0 - 3)]).to_integer_32 = 45 then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), create {CE_POINTER [INTEGER_8]}.make_cast (((l_tag_fname + l_i___0) - 2))).do_nothing
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), ce_string ("en")).do_nothing
								end
							else
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), ce_string ("en")).do_nothing
							end
							if not l_help_lang_find.is_void then
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang_find))) /= 0 then
									js.continue
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 22 -- skip if block
							end
				when 14 then -- if:
							if not (((a_flags___0).bit_and (128)).to_boolean) then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							if l_help_lang_find.is_void then
								if not (globals_inst.curbuf.item.b_fname).is_void then
									l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_fname))).to_integer_32
									if l_i___0 > 4 then
										if (globals_inst.curbuf.item.b_fname[(l_i___0 - 1)]).to_integer_32 = 120 then
											if (globals_inst.curbuf.item.b_fname[(l_i___0 - 4)]).to_integer_32 = 46 then
												if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (((globals_inst.curbuf.item.b_fname + l_i___0) - 3)), create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), (2).to_natural_32)) = 0 then
													l_help_pri := 0
												else
													l_pos := -1 + 17 -- goto _L___6
												end
											else
												l_pos := -1 + 17 -- goto _L___6
											end
										else
											l_pos := -1 + 17 -- goto _L___6
										end
									else
										l_pos := -1 + 17 -- goto _L___6
									end
								else
									l_pos := -1 + 17 -- goto _L___6
								end
							else
								l_pos := -1 + 17 -- goto _L___6
							end
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 17 then -- else: | _L___6:
							l_help_pri := 1
							l_s := option_inst.p_hlg.item
							from
							until
								not (not js.loop_done and then ((l_s.item).to_integer_32 /= 0))
							loop
								if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), (2).to_natural_32)) = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_help_pri := l_help_pri + 1
									l_s := misc2_inst.vim_strchr (l_s, (',').code)
									if l_s.is_void then
										js.break
									end
								end
								if not js.loop_jumped then
									l_s := l_s + 1
								end
							end
							if not (l_s.is_void) then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 20 then -- else:
							if (l_s.item).to_integer_32 /= 0 then
								l_pos := -1 + 22 -- skip if block
							end
				when 21 then -- if: | _L___0:
							l_help_pri := l_help_pri + 1
							if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang), ce_string ("en"))) /= 0 then
								l_help_pri := l_help_pri + 1
							end
				when 22 then -- if done | if done | if done | if done
							if not js.loop_jumped then
								l_fp := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tag_fname), ce_string ("r"))
								if l_fp.is_void then
									js.continue
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 50 -- skip if block
							end
				when 23 then -- if:
							if option_inst.p_verbose.item >= 5 then
								message_inst.verbose_enter
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Searching tags file %%s")))), l_tag_fname]).do_nothing
								message_inst.verbose_leave
							end
							l_did_open := 1
							l_state := {PC_STATE}.TS_START
				when 24 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 49 -- skip loop
							end
				when 25 then -- loop body:
							misc1_inst.line_breakcheck
							if ((a_flags___0).bit_and (64)).to_boolean then
								edit_inst.ins_compl_check_keys (30)
							end
							if globals_inst.got_int.to_boolean then
								l_stop_searching := 1
								js.break
							elseif globals_inst.compl_interrupted.to_boolean then
								l_stop_searching := 1
								js.break
							end
							if not js.loop_jumped and then (a_mincount = 300) then
								if l_match_count >= 300 then
									l_stop_searching := 1
									l_retval := 1
									js.break
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							if l_get_it_again.to_boolean then
								l_pos := -1 + 37 -- goto line_read_in
							end
				when 27 then
							if l_state = {NATURAL_32} 2 then
								l_offset := l_search_info.item.low_offset + (l_search_info.item.high_offset - l_search_info.item.low_offset) // 2
								if l_offset = l_search_info.item.curr_offset then
									js.break
								else
									l_search_info.item.curr_offset := l_offset
								end
							elseif l_state = {NATURAL_32} 3 then
								l_search_info.item.curr_offset := l_search_info.item.curr_offset - (1_024)
								if l_search_info.item.curr_offset < 0 then
									l_search_info.item.curr_offset := (0).to_integer_32
									rewind (l_fp)
									l_state := {PC_STATE}.TS_STEP_FORWARD
								end
							end
				when 28 then -- if done
							if js.loop_jumped then
								l_pos := -1 + 36 -- skip if block
							end
				when 29 then -- if:
							if l_state /= {NATURAL_32} 2 then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___7
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 32 then -- else:
							if l_state /= {NATURAL_32} 3 then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if: | _L___7:
							l_search_info.item.curr_offset_used := l_search_info.item.curr_offset
							fseeko (l_fp, l_search_info.item.curr_offset, 0).do_nothing
							l_eof := fileio_inst.vim_fgets (l_lbuf, 512, l_fp)
							if not l_eof.to_boolean then
								if l_search_info.item.curr_offset /= 0 then
									l_search_info.item.curr_offset := ftello (l_fp)
									if l_search_info.item.curr_offset = l_search_info.item.high_offset then
										fseeko (l_fp, l_search_info.item.low_offset, 0).do_nothing
										l_search_info.item.curr_offset := l_search_info.item.low_offset
									end
									l_eof := fileio_inst.vim_fgets (l_lbuf, 512, l_fp)
								end
							end
							from
							until
								js.loop_done
							loop
								if not l_eof.to_boolean then
									if not (charset_inst.vim_isblankline (l_lbuf)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_search_info.item.curr_offset := ftello (l_fp)
									l_eof := fileio_inst.vim_fgets (l_lbuf, 512, l_fp)
								end
							end
							if l_eof.to_boolean then
								l_state := {PC_STATE}.TS_SKIP_BACK
								l_search_info.item.match_offset := ftello (l_fp)
								l_search_info.item.curr_offset := l_search_info.item.curr_offset_used
								js.continue
							end
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 35 then -- else:
							from
							until
								js.loop_done
							loop
								l_eof := fileio_inst.vim_fgets (l_lbuf, 512, l_fp)
								if not l_eof.to_boolean then
									if not (charset_inst.vim_isblankline (l_lbuf)).to_boolean then
										js.break
									end
								else
									js.break
								end
							end
							if l_eof.to_boolean then
								js.break
							end
				when 36 then -- if done | if done
							if js.loop_jumped then
								l_pos := -1 + 38 -- skip if block
							end
				when 37 then -- if: | line_read_in:
							if l_state = {NATURAL_32} 0 then
								if l_linear.to_boolean then
									l_state := {PC_STATE}.TS_LINEAR
								elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbuf), ce_string ("!_TAG_"), (6).to_natural_32)) > 0 then
									l_state := {PC_STATE}.TS_BINARY
								elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbuf), ce_string ("!_TAG_FILE_SORTED%T"), (18).to_natural_32)) = 0 then
									if (l_lbuf[18]).to_integer_32 = 49 then
										l_state := {PC_STATE}.TS_BINARY
									elseif (l_lbuf[18]).to_integer_32 = 50 then
										l_state := {PC_STATE}.TS_BINARY
										l_sortic := 1
										if (option_inst.p_ic.item).to_boolean then
											l_tmp___14 := 1
										elseif not l_noic.to_boolean then
											l_tmp___14 := 1
										else
											l_tmp___14 := 0
										end
										l_pats.item.regmatch.rm_ic := l_tmp___14
									else
										l_state := {PC_STATE}.TS_LINEAR
									end
								end
								if l_state = {NATURAL_32} 2 then
									if (l_pats.item.regmatch.rm_ic).to_boolean then
										if not l_sortic.to_boolean then
											l_linear := 1
											l_state := {PC_STATE}.TS_LINEAR
										end
									end
								end
								if l_state = {NATURAL_32} 2 then
									l_filesize := lseek ((fileno (l_fp)), 0, 2)
									if l_filesize <= 0 then
										l_state := {PC_STATE}.TS_LINEAR
									else
										lseek ((fileno (l_fp)), 0, 0).do_nothing
										l_search_info.item.low_offset := (0).to_integer_32
										l_search_info.item.low_char := 0
										l_search_info.item.high_offset := l_filesize
										l_search_info.item.curr_offset := (0).to_integer_32
										l_search_info.item.high_char := 255
									end
									js.continue
								end
							end
				when 38 then -- if done
							if not js.loop_jumped and then ((l_lbuf[0]).to_integer_32 = 33) then
								if l_pats.is_equal (l_orgpat) then
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbuf), ce_string ("!_TAG_FILE_ENCODING%T"), (20).to_natural_32)) = 0 then
										l_p___0 := l_lbuf + 20
										from
										until
											js.loop_done
										loop
											if (l_p___0.item).to_integer_32 > 32 then
												if not ((l_p___0.item).to_integer_32 < 127) then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_p___0 := l_p___0 + 1
											end
										end
										l_p___0.item := (('%/0/').code).to_natural_8
										mbyte_inst.convert_setup (l_vimconv, option_inst.p_enc.item, l_lbuf + 20).do_nothing
										if l_vimconv.item.vc_type /= 0 then
											l_convpat.item.pat := mbyte_inst.string_convert (l_vimconv, l_pats.item.pat, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
											if not (l_convpat.item.pat).is_void then
												l_pats := l_convpat
												l_pats.item.len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pats.item.pat))).to_integer_32
												prepare_pats (l_pats, l_has_re)
												l_pats.item.regmatch.rm_ic := l_orgpat.item.regmatch.rm_ic
											end
										end
										mbyte_inst.convert_setup (l_vimconv, l_lbuf + 20, option_inst.p_enc.item).do_nothing
										js.continue
									end
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 48 -- skip if block
							end
				when 39 then -- if:
							if not ((l_pats.item.headlen).to_boolean) then
								l_pos := -1 + 47 -- skip if block
							end
				when 40 then -- if:
							l_tagp.item.tagname := l_lbuf
							l_tagp.item.tagname_end := misc2_inst.vim_strchr (l_lbuf, ('%T').code)
							if (l_tagp.item.tagname_end).is_void then
								l_line_error := 1
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 45 -- skip if block
							end
				when 41 then -- if:
							l_tagp.item.fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_p___0 := l_lbuf
							from
							until
								not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_tagp.item.tagname_end).c_pointer.to_integer_32).to_natural_32))
							loop
								if (l_p___0.item).to_integer_32 = 58 then
									if (l_tagp.item.fname).is_void then
										l_tagp.item.fname := l_tagp.item.tagname_end + 1
									end
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbuf), create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.fname), (l_p___0.distance (l_lbuf)).to_natural_32)) = 0 then
										if (l_tagp.item.fname[(l_p___0.distance (l_lbuf))]).to_integer_32 = 9 then
											l_tagp.item.tagname := l_p___0 + 1
											js.break
										end
									end
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							l_cmplen := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
							if option_inst.p_tl.item /= 0 then
								if l_cmplen.to_integer_32 > option_inst.p_tl.item then
									l_cmplen := (option_inst.p_tl.item).to_integer_32
								end
							end
							if not (l_has_re.to_boolean) then
								l_pos := -1 + 44 -- skip if block
							end
				when 42 then -- if:
							if l_pats.item.headlen < l_cmplen then
								l_cmplen := l_pats.item.headlen
							else
								l_pos := -1 + 44 -- goto _L___8
							end
				when 43 then -- if block done, skip else block:
							l_pos := -1 + 45
				when 44 then -- else: | _L___8:
							if l_state = {NATURAL_32} 1 then
								if l_pats.item.headlen /= l_cmplen then
									js.continue
								end
							end
				when 45 then -- if done
							if not js.loop_jumped then
								if l_state = {NATURAL_32} 2 then
									l_i___0 := (l_tagp.item.tagname[0]).to_integer_32
									if l_sortic.to_boolean then
										if (l_tagp.item.tagname[0]).to_integer_32 < 97 then
											l_tmp___22 := (l_tagp.item.tagname[0]).to_integer_32
										elseif (l_tagp.item.tagname[0]).to_integer_32 > 122 then
											l_tmp___22 := (l_tagp.item.tagname[0]).to_integer_32
										else
											l_tmp___22 := (l_tagp.item.tagname[0]).to_integer_32 - 32
										end
										l_i___0 := l_tmp___22
									end
									if l_i___0 < l_search_info.item.low_char then
										l_sort_error := 1
									elseif l_i___0 > l_search_info.item.high_char then
										l_sort_error := 1
									end
									if l_sortic.to_boolean then
										l_tagcmp := tag_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)
									else
										l_tagcmp := strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.tagname), create {CE_POINTER [INTEGER_8]}.make_cast (l_pats.item.head), l_cmplen.to_natural_32)
									end
									if l_tagcmp = 0 then
										if l_cmplen < l_pats.item.headlen then
											l_tagcmp := -1
										elseif l_cmplen > l_pats.item.headlen then
											l_tagcmp := 1
										end
									end
									if l_tagcmp = 0 then
										l_state := {PC_STATE}.TS_SKIP_BACK
										l_search_info.item.match_offset := l_search_info.item.curr_offset
										js.continue
									end
									if not js.loop_jumped and then (l_tagcmp < 0) then
										l_search_info.item.curr_offset := ftello (l_fp)
										if l_search_info.item.curr_offset < l_search_info.item.high_offset then
											l_search_info.item.low_offset := l_search_info.item.curr_offset
											if l_sortic.to_boolean then
												if (l_tagp.item.tagname[0]).to_integer_32 < 97 then
													l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32
												elseif (l_tagp.item.tagname[0]).to_integer_32 > 122 then
													l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32
												else
													l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32 - 32
												end
											else
												l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32
											end
											js.continue
										end
									end
									if not js.loop_jumped and then (l_tagcmp > 0) then
										if l_search_info.item.curr_offset /= l_search_info.item.high_offset then
											l_search_info.item.high_offset := l_search_info.item.curr_offset
											if l_sortic.to_boolean then
												if (l_tagp.item.tagname[0]).to_integer_32 < 97 then
													l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32
												elseif (l_tagp.item.tagname[0]).to_integer_32 > 122 then
													l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32
												else
													l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32 - 32
												end
											else
												l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32
											end
											js.continue
										end
									end
									if not js.loop_jumped then
										js.break
									end
								elseif l_state = {NATURAL_32} 3 then
									if (mbyte_inst.mb_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)) /= 0 then
										l_state := {PC_STATE}.TS_STEP_FORWARD
									else
										l_search_info.item.curr_offset := l_search_info.item.curr_offset_used
									end
									js.continue
								elseif l_state = {NATURAL_32} 4 then
									if (mbyte_inst.mb_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)) /= 0 then
										if (ftello (l_fp)) > l_search_info.item.match_offset then
											js.break
										else
											js.continue
										end
									end
								elseif (mbyte_inst.mb_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)) /= 0 then
									js.continue
								end
							end
							if not js.loop_jumped then
								if (l_tagp.item.fname).is_void then
									l_tagp.item.fname := l_tagp.item.tagname_end + 1
								end
								l_tagp.item.fname_end := misc2_inst.vim_strchr (l_tagp.item.fname, ('%T').code)
								l_tagp.item.command := l_tagp.item.fname_end + 1
								if (l_tagp.item.fname_end).is_void then
									l_i___0 := 0
								else
									l_i___0 := 1
								end
							end
				when 46 then -- if block done, skip else block:
							l_pos := -1 + 48
				when 47 then -- else:
							l_i___0 := parse_tag_line (l_lbuf, l_tagp)
				when 48 then -- if done | if done
							if not js.loop_jumped and then (l_i___0 = 0) then
								l_line_error := 1
								js.break
							end
							if not js.loop_jumped then
								l_cmplen := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
								if option_inst.p_tl.item /= 0 then
									if l_cmplen.to_integer_32 > option_inst.p_tl.item then
										l_cmplen := (option_inst.p_tl.item).to_integer_32
									end
								end
								if l_pats.item.len /= l_cmplen then
									l_match := 0
								elseif (l_pats.item.regmatch.rm_ic).to_boolean then
									l_match := ((mbyte_inst.mb_strnicmp (l_tagp.item.tagname, l_pats.item.pat, l_cmplen.to_natural_32)) = 0).to_integer
									if l_match.to_boolean then
										l_match_no_ic := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.tagname), create {CE_POINTER [INTEGER_8]}.make_cast (l_pats.item.pat), l_cmplen.to_natural_32)) = 0).to_integer
									end
								else
									l_match := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.tagname), create {CE_POINTER [INTEGER_8]}.make_cast (l_pats.item.pat), l_cmplen.to_natural_32)) = 0).to_integer
								end
								l_match_re := 0
								if not l_match.to_boolean then
									if not (l_pats.item.regmatch.regprog).is_void then
										l_cc___0 := ((l_tagp.item.tagname_end).item).to_integer_32;
										(l_tagp.item.tagname_end).item := (('%/0/').code).to_natural_8
										l_match := regexp_inst.vim_regexec (create {CE_POINTER [PD_REGMATCH_T]}.make_shared (l_pats.c_pointer + (create {PD_PAT_T}.make).offset_of ("regmatch")), l_tagp.item.tagname, 0)
										if l_match.to_boolean then
											l_matchoff := (l_pats.item.regmatch.startp[0]).distance ((l_tagp.item.tagname))
											if (l_pats.item.regmatch.rm_ic).to_boolean then
												l_pats.item.regmatch.rm_ic := 0
												l_match_no_ic := regexp_inst.vim_regexec (create {CE_POINTER [PD_REGMATCH_T]}.make_shared (l_pats.c_pointer + (create {PD_PAT_T}.make).offset_of ("regmatch")), l_tagp.item.tagname, 0)
												l_pats.item.regmatch.rm_ic := 1
											end
										end
										(l_tagp.item.tagname_end).item := l_cc___0.to_natural_8
										l_match_re := 1
									end
								end
								if l_match.to_boolean then
									l_is_current := test_for_current (l_tagp.item.fname, l_tagp.item.fname_end, l_tag_fname, a_buf_ffname)
									if not (l_tagp.item.tagname).is_equal (l_lbuf) then
										l_is_static := 1
									else
										l_is_static := test_for_static (l_tagp)
									end
									if l_is_static.to_boolean then
										if l_is_current.to_boolean then
											l_mtt := 0
										else
											l_mtt := 3
										end
									elseif l_is_current.to_boolean then
										l_mtt := 1
									else
										l_mtt := 2
									end
									if (l_pats.item.regmatch.rm_ic).to_boolean then
										if not l_match_no_ic.to_boolean then
											l_mtt := l_mtt + (4)
										end
									end
									if l_match_re.to_boolean then
										l_mtt := l_mtt + (8)
									end
									if (misc2_inst.ga_grow (l_ga_match + l_mtt, 1)) = 1 then
										l_conv_line := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
										l_lbuf_line := l_lbuf
										if l_vimconv.item.vc_type /= 0 then
											l_conv_line := mbyte_inst.string_convert (l_vimconv, l_lbuf, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
											if not l_conv_line.is_void then
												if (parse_tag_line (l_conv_line, l_tagp)) = 1 then
													l_lbuf_line := l_conv_line
												else
													parse_tag_line (l_lbuf, l_tagp).do_nothing
												end
											end
										end
										if l_help_only.to_boolean then
											(l_tagp.item.tagname_end).item := (('%/0/').code).to_natural_8
											l_len := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
											l_mfp := create {CE_POINTER [PD_MATCH_FOUND]}.make_cast ((misc2_inst.alloc ((((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len) + 10) + 3).to_natural_32)))
											if not l_mfp.is_void then
												l_mfp.item.len := (l_len + 3) + 1
												l_p___0 := l_mfp.item.match
												strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_tagp.item.tagname)).do_nothing
												l_p___0[l_len] := (('@').code).to_natural_8
												strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_p___0 + l_len) + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_help_lang)).do_nothing
												if l_match_re.to_boolean then
													l_tmp___32 := l_matchoff
												else
													l_tmp___32 := 0
												end
												sprintf ([(((create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0) + l_len) + 1) + 3), ce_string ("%%06d"), (ex_cmds_inst.help_heuristic (l_tagp.item.tagname, l_tmp___32, (not l_match_no_ic.to_boolean).to_integer)) + l_help_pri]).do_nothing
											end
											(l_tagp.item.tagname_end).item := (('%T').code).to_natural_8
										elseif l_name_only.to_boolean then
											if l_get_it_again.to_boolean then
												l_temp_end := l_tagp.item.command
												if (l_temp_end.item).to_integer_32 = 47 then
													from
													until
														js.loop_done
													loop
														if (l_temp_end.item).to_boolean then
															if (l_temp_end.item).to_integer_32 /= 13 then
																if (l_temp_end.item).to_integer_32 /= 10 then
																	if (l_temp_end.item).to_integer_32 = 36 then
																		js.break
																	end
																else
																	js.break
																end
															else
																js.break
															end
														else
															js.break
														end
														if not js.loop_jumped then
															l_temp_end := l_temp_end + 1
														end
													end
												end
												if ((l_tagp.item.command + 2).c_pointer.to_integer_32).to_natural_32 < (l_temp_end.c_pointer.to_integer_32).to_natural_32 then
													l_len := (l_temp_end.distance ((l_tagp.item.command))) - 2
													l_mfp := create {CE_POINTER [PD_MATCH_FOUND]}.make_cast ((misc2_inst.alloc ((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len).to_natural_32)))
													if not l_mfp.is_void then
														l_mfp.item.len := l_len + 1
														l_p___0 := l_mfp.item.match
														misc2_inst.vim_strncpy (l_p___0, l_tagp.item.command + 2, l_len.to_natural_32)
													end
												else
													l_mfp := create {CE_POINTER [PD_MATCH_FOUND]}.make_shared (default_pointer)
												end
												l_get_it_again := 0
											else
												l_len := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
												l_mfp := create {CE_POINTER [PD_MATCH_FOUND]}.make_cast ((misc2_inst.alloc ((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len).to_natural_32)))
												if not l_mfp.is_void then
													l_mfp.item.len := l_len + 1
													l_p___0 := l_mfp.item.match
													misc2_inst.vim_strncpy (l_p___0, l_tagp.item.tagname, l_len.to_natural_32)
												end
												if ((globals_inst.State).bit_and (16)).to_boolean then
													l_get_it_again := option_inst.p_sft.item
												end
											end
										else
											l_tmp___36 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tag_fname))
											l_len := (l_tmp___36.to_integer_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbuf_line))).to_integer_32) + 3
											l_mfp := create {CE_POINTER [PD_MATCH_FOUND]}.make_cast ((misc2_inst.alloc ((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len).to_natural_32)))
											if not l_mfp.is_void then
												l_mfp.item.len := l_len
												l_p___0 := l_mfp.item.match
												l_p___0[0] := l_mtt.to_natural_8
												strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_tag_fname)).do_nothing
												l_s := ((l_p___0 + 1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tag_fname))).to_integer_32) + 1
												strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (l_lbuf_line)).do_nothing
											end
										end
										if not l_mfp.is_void then
											l_i___0 := l_ga_match[l_mtt].ga_len
											from
											until
												js.loop_done
											loop
												l_i___0 := l_i___0 - 1
												if l_i___0 >= 0 then
													if globals_inst.got_int.to_boolean then
														js.break
													end
												else
													js.break
												end
												if not js.loop_jumped then
													l_mfp2 := create {CE_POINTER [CE_POINTER [PD_MATCH_FOUND]]}.make_cast (l_ga_match[l_mtt].ga_data)[l_i___0]
													if l_mfp2.item.len = l_mfp.item.len then
														if (memcmp (create {CE_POINTER [ANY]}.make_cast ((l_mfp2.item.match)), create {CE_POINTER [ANY]}.make_cast ((l_mfp.item.match)), (l_mfp.item.len).to_natural_32)) = 0 then
															js.break
														end
													end
												end
												if not js.loop_jumped then
													misc1_inst.line_breakcheck
												end
											end
											if l_i___0 < 0 then
												l_tmp___41 := l_ga_match[l_mtt].ga_len
												l_ga_match[l_mtt].ga_len := (l_ga_match[l_mtt].ga_len) + 1
												create {CE_POINTER [CE_POINTER [PD_MATCH_FOUND]]}.make_cast (l_ga_match[l_mtt].ga_data)[l_tmp___41] := l_mfp
												l_match_count := l_match_count + 1
											else
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mfp))
											end
										end
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_conv_line))
									else
										l_retval := 1
										l_stop_searching := 1
										js.break
									end
								end
							end
							if js.loop_increment then
								
							end
							l_pos := -1 + 24 -- back to loop condition
				when 49 then -- loop done
							if l_line_error.to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E431: Format error in tags file %"%%s%"")))), l_tag_fname).do_nothing
								l_tmp___44 := ftello (l_fp)
								misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Before byte %%ld")))), l_tmp___44).do_nothing
								l_stop_searching := 1
								l_line_error := 0
							end
							fclose (l_fp).do_nothing
							if l_pats.is_equal (l_convpat) then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pats.item.pat))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pats.item.regmatch.regprog))
								l_orgpat.item.regmatch.rm_ic := l_pats.item.regmatch.rm_ic
								l_pats := l_orgpat
							end
							if l_vimconv.item.vc_type /= 0 then
								mbyte_inst.convert_setup (l_vimconv, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
							end
							if l_sort_error.to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E432: Tags file not sorted: %%s")))), l_tag_fname).do_nothing
								l_sort_error := 0
							end
							if l_match_count >= a_mincount then
								l_retval := 1
								l_stop_searching := 1
							end
							if l_stop_searching.to_boolean then
								js.break
							end
				when 50 then -- if done
							if js.loop_increment then
								l_first_file := 0
							end
							l_pos := -1 + 11 -- back to loop condition
				when 51 then -- loop done
							tagname_free (l_tn)
							if not (l_stop_searching.to_boolean) then
								l_pos := -1 + 54 -- skip if block
							end
				when 52 then -- if:
							js.break
				when 53 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 54 then -- else:
							if not (l_linear.to_boolean) then
								l_pos := -1 + 57 -- skip if block
							end
				when 55 then -- if:
							js.break
				when 56 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 57 then -- else:
							if (option_inst.p_ic.item).to_boolean then
								l_pos := -1 + 60 -- skip if block
							end
				when 58 then -- if:
							if l_noic.to_boolean then
								js.break
							else
								l_pos := -1 + 60 -- goto _L___9
							end
				when 59 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 60 then -- else: | _L___9:
							if (l_pats.item.regmatch.rm_ic).to_boolean then
								js.break
							end
				when 61 then -- if done | if done
							if not js.loop_jumped then
								l_pats.item.regmatch.rm_ic := 1
								l_round := l_round + 1
							end
							l_pos := -1 + 9 -- back to loop condition
				when 62 then -- loop done
						if not l_stop_searching.to_boolean then
							if not l_did_open.to_boolean then
								if l_verbose.to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E433: No tags file"))))).do_nothing
								end
							end
							l_retval := 1
						end
				when 63 then -- findtag_end:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_lbuf))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pats.item.regmatch.regprog))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tag_fname))
						if l_retval = 0 then
							l_match_count := 0
						end
						if l_match_count > 0 then
							l_matches___0 := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc ((l_match_count.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32, 1)))
						else
							l_matches___0 := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
						end
						l_match_count := 0
						l_mtt := 0
						from
						until
							not (not js.loop_done and then (l_mtt < 16))
						loop
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_ga_match[l_mtt].ga_len)
							loop
								l_mfp := create {CE_POINTER [CE_POINTER [PD_MATCH_FOUND]]}.make_cast (l_ga_match[l_mtt].ga_data)[l_i___0]
								if l_matches___0.is_void then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mfp))
								else
									if l_help_only.to_boolean then
										l_tmp___50 := 6
									else
										l_tmp___50 := 0
									end
									memmove (create {CE_POINTER [ANY]}.make_cast (l_mfp), create {CE_POINTER [ANY]}.make_cast ((l_mfp.item.match)), (l_mfp.item.len + l_tmp___50).to_natural_32).do_nothing
									l_tmp___51 := l_match_count
									l_match_count := l_match_count + 1
									l_matches___0[l_tmp___51] := create {CE_POINTER [NATURAL_8]}.make_cast (l_mfp)
								end
								l_i___0 := l_i___0 + 1
							end
							misc2_inst.ga_clear (l_ga_match + l_mtt)
							l_mtt := l_mtt + 1
						end
						a_matchesp.item := l_matches___0
						a_num_matches___0.item := l_match_count
						globals_inst.curbuf.item.b_help := l_help_save
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_saved_pat))
						Result := l_retval
				when 64 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	found_tagfile_cb (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_tmp: INTEGER_32
		do
			if (misc2_inst.ga_grow (tag_fnames, 1)) = 1 then
				l_tmp := tag_fnames.item.ga_len
				tag_fnames.item.ga_len := (tag_fnames.item.ga_len) + 1
				create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (tag_fnames.item.ga_data)[l_tmp] := misc2_inst.vim_strsave (a_fname)
			end
		end

	found_tagfile_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent found_tagfile_cb)
		end

	get_tagfname (a_tnp: CE_POINTER [PD_TAGNAME_T]; a_first___0: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_r_ptr: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_filename: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fname.make
			create l_r_ptr.make
			create l_tmp___1.make
			create l_filename.make
			create l_tmp___3.make

			l_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if a_first___0.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast (a_tnp), 0, (create {PD_TAGNAME_T}.make).structure_size.to_natural_32).do_nothing
			end
			if (globals_inst.curbuf.item.b_help).to_boolean then
				if a_first___0.to_boolean then
					misc2_inst.ga_clear_strings (tag_fnames)
					misc2_inst.ga_init2 (tag_fnames, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 10)
					ex_cmds2_inst.do_in_runtimepath (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("doc/tags doc/tags-??")), 1, found_tagfile_cb_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				end
				if a_tnp.item.tn_hf_idx >= tag_fnames.item.ga_len then
					if a_tnp.item.tn_hf_idx > tag_fnames.item.ga_len then
						Result := 0
						js.return
					elseif (option_inst.p_hf.item.item).to_integer_32 = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						a_tnp.item.tn_hf_idx := (a_tnp.item.tn_hf_idx) + 1
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_hf.item)).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (a_buf___6))), ce_string ("tags")).do_nothing
					end
				else
					l_tmp___0 := a_tnp.item.tn_hf_idx
					a_tnp.item.tn_hf_idx := (a_tnp.item.tn_hf_idx) + 1
					misc2_inst.vim_strncpy (a_buf___6, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (tag_fnames.item.ga_data)[l_tmp___0], (4_095).to_natural_32)
				end
				if not js.return_called then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (a_first___0.to_boolean) then
				if ((globals_inst.curbuf.item.b_p_tags).item).to_integer_32 /= 0 then
					l_tmp___1 := globals_inst.curbuf.item.b_p_tags
				else
					l_tmp___1 := option_inst.p_tags.item
				end
				a_tnp.item.tn_tags := misc2_inst.vim_strsave (l_tmp___1)
				if (a_tnp.item.tn_tags).is_void then
					Result := 0
					js.return
				end
				if not js.return_called then
					a_tnp.item.tn_np := a_tnp.item.tn_tags
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (a_tnp.item.tn_did_filefind_init).to_boolean then
						l_fname := misc2_inst.vim_findfile (a_tnp.item.tn_search_ctx)
						if not l_fname.is_void then
							js.break
						end
						if not js.loop_jumped then
							a_tnp.item.tn_did_filefind_init := 0
						end
					else
						l_filename := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						if ((a_tnp.item.tn_np).item).to_integer_32 = 0 then
							misc2_inst.vim_findfile_cleanup (a_tnp.item.tn_search_ctx)
							a_tnp.item.tn_search_ctx := create {CE_POINTER [ANY]}.make_shared (default_pointer)
							Result := 0
							js.return
						end
						if not js.return_called then
							a_buf___6[0] := (('%/0/').code).to_natural_8
							misc2_inst.copy_option_part (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_tnp.c_pointer + (create {PD_TAGNAME_T}.make).offset_of ("tn_np")), a_buf___6, 4_095, ce_string (" ,")).do_nothing
							l_r_ptr := misc2_inst.vim_findfile_stopdir (a_buf___6)
							l_filename := misc1_inst.gettail (a_buf___6)
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_filename + 1)), create {CE_POINTER [ANY]}.make_cast (l_filename), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_filename))) + {NATURAL_32} 1).do_nothing
							l_tmp___3 := l_filename
							l_filename := l_filename + 1
							l_tmp___3.item := (('%/0/').code).to_natural_8
							a_tnp.item.tn_search_ctx := misc2_inst.vim_findfile_init (a_buf___6, l_filename, l_r_ptr, 100, 0, 0, a_tnp.item.tn_search_ctx, 1, globals_inst.curbuf.item.b_ffname)
							if not (a_tnp.item.tn_search_ctx).is_void then
								a_tnp.item.tn_did_filefind_init := 1
							end
						end
					end
				end
			end
			if not js.return_called then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
				Result := 1
			end
		end

	get_tags (a_list: CE_POINTER [PD_LISTVAR_S]; a_pat: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_num_matches___0: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_ret: INTEGER_32
			l_matches___0: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_full_fname: CE_POINTER [NATURAL_8]
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_tp: CE_ARRAY [PD_TAG_POINTERS]
			l_is_static: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_num_matches___0.make (<<1>>)
			create l_matches___0.make (<<1>>)
			create l_p___0.make
			create l_full_fname.make
			create l_dict.make
			create l_tp.make (<<1>>)
			create l_s.make
			create l_n.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := find_tags (a_pat, l_num_matches___0, l_matches___0, 12, 2_147_483_647, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if l_ret /= 1 then
						l_pos := -1 + 29 -- skip if block
					end
				when 1 then -- if:
						if not (l_num_matches___0.item > 0) then
							l_pos := -1 + 29 -- skip if block
						end
				when 2 then -- if:
						l_i___0 := 0
				when 3 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 < l_num_matches___0.item)) then
							l_pos := -1 + 28 -- skip loop
						end
				when 4 then -- loop body:
						parse_match (l_matches___0.item[l_i___0], l_tp).do_nothing
						l_is_static := (test_for_static (l_tp)).to_integer_32
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tp.item.tagname), ce_string ("!_TAG_"), (6).to_natural_32)) = 0 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 27 -- skip if block
						end
				when 5 then -- if:
						l_dict := eval_inst.dict_alloc
						if l_dict.is_void then
							l_ret := 0
						end
						if (eval_inst.list_append_dict (a_list, l_dict)) = 0 then
							l_ret := 0
						end
						l_full_fname := tag_full_fname (l_tp)
						if (add_tag_field (l_dict, ce_string ("name"), l_tp.item.tagname, l_tp.item.tagname_end)) = 0 then
							l_ret := 0
						elseif (add_tag_field (l_dict, ce_string ("filename"), l_full_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
							l_ret := 0
						elseif (add_tag_field (l_dict, ce_string ("cmd"), l_tp.item.command, l_tp.item.command_end)) = 0 then
							l_ret := 0
						elseif (add_tag_field (l_dict, ce_string ("kind"), l_tp.item.tagkind, l_tp.item.tagkind_end)) = 0 then
							l_ret := 0
						elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("static"), l_is_static, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
							l_ret := 0
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_full_fname))
						if (l_tp.item.command_end).is_void then
							l_pos := -1 + 26 -- skip if block
						end
				when 6 then -- if:
						l_p___0 := l_tp.item.command_end + 3
				when 7 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 26 -- skip loop
						end
				when 8 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 /= 10 then
								if (l_p___0.item).to_integer_32 = 13 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 9 then -- if:
						if not (l_p___0.is_equal (l_tp.item.tagkind)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_p___0 := l_tp.item.tagkind_end - 1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if not ((l_p___0 + 5).is_equal (l_tp.item.tagkind)) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("kind:"), (5).to_natural_32)) = 0 then
							l_p___0 := l_tp.item.tagkind_end - 1
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___0:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_p___0 := l_p___0 + (4)
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if ((l_p___0.item).to_integer_32 = 32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if ((l_p___0.item).to_integer_32 = 9) then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						l_n := l_p___0
						from
						until
							js.loop_done
						loop
							if (l_p___0.item).to_integer_32 /= 0 then
								if (l_p___0.item).to_integer_32 >= 32 then
									if (l_p___0.item).to_integer_32 < 127 then
										if (l_p___0.item).to_integer_32 = 58 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						l_len := l_p___0.distance (l_n)
						if (l_p___0.item).to_integer_32 /= 58 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_len > 0 then
							l_p___0 := l_p___0 + 1
							l_s := l_p___0
							from
							until
								js.loop_done
							loop
								if (l_p___0.item).to_integer_32 /= 0 then
									if not ((l_p___0.item).to_integer_32 >= 32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							l_n[l_len] := (('%/0/').code).to_natural_8
							if (add_tag_field (l_dict, create {CE_POINTER [INTEGER_8]}.make_cast (l_n), l_s, l_p___0)) = 0 then
								l_ret := 0
							end
							l_n[l_len] := ((':').code).to_natural_8
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							if (l_p___0.item).to_integer_32 /= 0 then
								if not ((l_p___0.item).to_integer_32 >= 32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
				when 24 then
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
				when 25 then -- if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 26 then -- loop done | if done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_matches___0.item[l_i___0]))
				when 27 then -- if done
						if js.loop_increment then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 28 then -- loop done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_matches___0.item))
				when 29 then -- if done | if done
						Result := l_ret
				when 30 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	jumpto_tag (a_lbuf: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_keep_help: INTEGER_32): INTEGER_32
		local
			l_save_secure: INTEGER_32
			l_save_magic: INTEGER_32
			l_save_p_ws: INTEGER_32
			l_save_p_scs: INTEGER_32
			l_save_p_ic: INTEGER_32
			l_save_lnum: INTEGER_32
			l_csave: INTEGER_32
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pbuf: CE_POINTER [NATURAL_8]
			l_pbuf_end: CE_POINTER [NATURAL_8]
			l_tofree_fname: CE_POINTER [NATURAL_8]
			l_fname: CE_POINTER [NATURAL_8]
			l_tagp: CE_ARRAY [PD_TAG_POINTERS]
			l_retval: INTEGER_32
			l_getfile_result: INTEGER_32
			l_search_options: INTEGER_32
			l_save_no_hlsearch: INTEGER_32
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
			l_full_fname: CE_POINTER [NATURAL_8]
			l_old_KeyTyped: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_found: INTEGER_32
			l_cc___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make (<<1>>)
			create l_pbuf.make
			create l_pbuf_end.make
			create l_tofree_fname.make
			create l_fname.make
			create l_tagp.make (<<1>>)
			create l_curwin_save.make
			create l_full_fname.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_csave := 0
					l_tofree_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_retval := 0
					l_curwin_save := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
					l_full_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_old_KeyTyped := globals_inst.KeyTyped
					l_pbuf := misc2_inst.alloc ({NATURAL_32} 512)
					if l_pbuf.is_void then
						l_tagp.item.fname_end := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_pos := -1 + 28 -- goto erret
					elseif (parse_match (a_lbuf, l_tagp)) = 0 then
						l_tagp.item.fname_end := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_pos := -1 + 28 -- goto erret
					end
				when 1 then
					l_csave := ((l_tagp.item.fname_end).item).to_integer_32;
					(l_tagp.item.fname_end).item := (('%/0/').code).to_natural_8
					l_fname := l_tagp.item.fname
					l_str___1.item := l_tagp.item.command
					l_pbuf_end := l_pbuf
					from
					until
						js.loop_done
					loop
						if (l_str___1.item.item).to_boolean then
							if (l_str___1.item.item).to_integer_32 /= 10 then
								if (l_str___1.item.item).to_integer_32 = 13 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_tmp___0 := l_pbuf_end
							l_pbuf_end := l_pbuf_end + 1
							l_tmp___1 := l_str___1.item
							l_str___1.item := l_str___1.item + 1
							l_tmp___0.item := l_tmp___1.item
						end
					end
					l_pbuf_end.item := (('%/0/').code).to_natural_8
					l_str___1.item := l_pbuf
					if (find_extra (l_str___1)) = 1 then
						l_pbuf_end := l_str___1.item
						l_pbuf_end.item := (('%/0/').code).to_natural_8
					end
					l_fname := expand_tag_fname (l_fname, l_tagp.item.tag_fname, 1)
					if l_fname.is_void then
						l_pos := -1 + 28 -- goto erret
					end
				when 2 then
					l_tofree_fname := l_fname
					if (os_unix_inst.mch_getperm (l_fname)) < 0 then
						if not (fileio_inst.has_autocmd ({PC_AUTO_EVENT}.EVENT_BUFREADCMD, l_fname, create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))).to_boolean then
							l_retval := 99
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (nofile_fname))
							nofile_fname := misc2_inst.vim_strsave (l_fname)
							if nofile_fname.is_void then
								nofile_fname := globals_inst.empty_option
							end
							l_pos := -1 + 28 -- goto erret
						end
					end
				when 3 then
					globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
					globals_inst.need_mouse_correct := 1
					if globals_inst.g_do_tagpreview.to_boolean then
						globals_inst.postponed_split := 0
						l_curwin_save := globals_inst.curwin
						if not (globals_inst.curwin.item.w_onebuf_opt.wo_pvw).to_boolean then
							l_full_fname := misc1_inst.FullName_save (l_fname, 0)
							l_fname := l_full_fname
							ex_cmds_inst.prepare_tagpreview (1).do_nothing
						end
					end
					if not (globals_inst.postponed_split.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if globals_inst.cmdmod.item.tab = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if globals_inst.postponed_split > 0 then
							l_tmp___5 := globals_inst.postponed_split
						else
							l_tmp___5 := 0
						end
						window_inst.win_split (l_tmp___5, globals_inst.postponed_split_flags).do_nothing
						globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
				when 8 then -- if done
						if a_keep_help.to_boolean then
							if globals_inst.g_do_tagpreview.to_boolean then
								globals_inst.keep_help_flag := (l_curwin_save.item.w_buffer).item.b_help
							else
								globals_inst.keep_help_flag := globals_inst.curbuf.item.b_help
							end
						end
						l_getfile_result := ex_cmds_inst.getfile (0, l_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1, (0).to_integer_32, a_forceit)
						globals_inst.keep_help_flag := 0
						if not (l_getfile_result <= 0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 9 then -- if:
							globals_inst.curwin.item.w_set_curswant := 1
							globals_inst.postponed_split := 0
							l_save_secure := globals_inst.secure
							globals_inst.secure := 1
							globals_inst.sandbox := globals_inst.sandbox + 1
							l_save_magic := option_inst.p_magic.item
							option_inst.p_magic.item := 0
							l_save_no_hlsearch := globals_inst.no_hlsearch
							if not (misc2_inst.vim_strchr (option_inst.p_cpo.item, ('t').code)).is_void then
								l_search_options := 0
							else
								l_search_options := 1_024
							end
							l_str___1.item := l_pbuf
							if (l_pbuf[0]).to_integer_32 = 47 then
								l_tmp___7 := regexp_inst.skip_regexp (l_pbuf + 1, (l_pbuf[0]).to_integer_32, 0, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
								l_str___1.item := l_tmp___7 + 1
							elseif (l_pbuf[0]).to_integer_32 = 63 then
								l_tmp___7 := regexp_inst.skip_regexp (l_pbuf + 1, (l_pbuf[0]).to_integer_32, 0, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
								l_str___1.item := l_tmp___7 + 1
							end
							if not (((l_str___1.item).c_pointer.to_integer_32).to_natural_32 > ((l_pbuf_end - 1).c_pointer.to_integer_32).to_natural_32) then
								l_pos := -1 + 24 -- skip if block
							end
				when 10 then -- if:
							l_save_p_ws := option_inst.p_ws.item
							l_save_p_ic := option_inst.p_ic.item
							l_save_p_scs := option_inst.p_scs.item
							option_inst.p_ws.item := 1
							option_inst.p_ic.item := 0
							option_inst.p_scs.item := 0
							l_save_lnum := globals_inst.curwin.item.w_cursor.lnum
							globals_inst.curwin.item.w_cursor.lnum := (0).to_integer_32
							if not ((search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), (l_pbuf[0]).to_integer_32, l_pbuf + 1, 1, l_search_options, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							l_retval := 1
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 13 then -- else:
							l_found := 1
							option_inst.p_ic.item := 1
							if not (search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), (l_pbuf[0]).to_integer_32, l_pbuf + 1, 1, l_search_options, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
								l_found := 2
								test_for_static (l_tagp).do_nothing
								l_cc___0 := ((l_tagp.item.tagname_end).item).to_integer_32;
								(l_tagp.item.tagname_end).item := (('%/0/').code).to_natural_8
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pbuf), ce_string ("^%%s\s\*("), l_tagp.item.tagname]).do_nothing
								if not (search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_pbuf, 1, l_search_options, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pbuf), ce_string ("^\[#a-zA-Z_]\.\*\<%%s\s\*("), l_tagp.item.tagname]).do_nothing
									if not (search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_pbuf, 1, l_search_options, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
										l_found := 0
									end
								end
								(l_tagp.item.tagname_end).item := l_cc___0.to_natural_8
							end
							if l_found /= 0 then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E434: Can%'t find tag pattern"))))).do_nothing
							globals_inst.curwin.item.w_cursor.lnum := l_save_lnum
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 16 then -- else:
							if l_found /= 2 then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 21
				when 19 then -- else:
							if l_save_p_ic.to_boolean then
								l_pos := -1 + 21 -- skip if block
							end
				when 20 then -- if: | _L___0:
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E435: Couldn%'t find tag, just guessing!"))))).do_nothing
							if not globals_inst.msg_scrolled.to_boolean then
								if globals_inst.msg_silent = 0 then
									term_inst.out_flush
									ui_inst.ui_delay (1_000, 1)
								end
							end
				when 21 then -- if done
							l_retval := 1
				when 22 then -- if done | if done
							option_inst.p_ws.item := l_save_p_ws
							option_inst.p_ic.item := l_save_p_ic
							option_inst.p_scs.item := l_save_p_scs
							misc2_inst.check_cursor
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 24 then -- else:
							globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
							ex_docmd_inst.do_cmdline_cmd (l_pbuf).do_nothing
							l_retval := 1
				when 25 then -- if done
							if globals_inst.secure = 2 then
								message_inst.wait_return (1)
							end
							globals_inst.secure := l_save_secure
							option_inst.p_magic.item := l_save_magic
							globals_inst.sandbox := globals_inst.sandbox - 1
							if l_search_options.to_boolean then
								globals_inst.no_hlsearch := l_save_no_hlsearch
							end
							if l_getfile_result = -1 then
								l_retval := 1
							end
							if l_retval = 1 then
								if (globals_inst.curbuf.item.b_help).to_boolean then
									move_inst.set_topline (globals_inst.curwin, globals_inst.curwin.item.w_cursor.lnum)
								end
								if ((option_inst.fdo_flags.item).bit_and ({NATURAL_32} 128)).to_boolean then
									if l_old_KeyTyped.to_boolean then
										fold_inst.foldOpenCursor
									end
								end
							end
							if globals_inst.g_do_tagpreview.to_boolean then
								if not globals_inst.curwin.is_equal (l_curwin_save) then
									if (window_inst.win_valid (l_curwin_save)).to_boolean then
										move_inst.validate_cursor
										screen_inst.redraw_later (10)
										window_inst.win_enter (l_curwin_save, 1)
									end
								end
							end
							globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 28
				when 27 then -- else:
							globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
							if globals_inst.postponed_split.to_boolean then
								window_inst.win_close (globals_inst.curwin, 0)
								globals_inst.postponed_split := 0
							end
				when 28 then -- erret:
						globals_inst.g_do_tagpreview := 0
						if not (l_tagp.item.fname_end).is_void then
							(l_tagp.item.fname_end).item := l_csave.to_natural_8
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pbuf))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree_fname))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_full_fname))
						Result := l_retval
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	parse_match (a_lbuf: CE_POINTER [NATURAL_8]; a_tagp: CE_POINTER [PD_TAG_POINTERS]): INTEGER_32
		local
			l_lbuf: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pc: CE_POINTER [NATURAL_8]
			l_pt: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_lbuf.make
			create l_p___0.make (<<1>>)
			create l_pc.make
			create l_pt.make
			create l_tmp___2.make

			l_lbuf := a_lbuf
			a_tagp.item.tag_fname := l_lbuf + 1
			l_lbuf := l_lbuf + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_tagp.item.tag_fname))) + {NATURAL_32} 2).to_integer_32
			l_retval := parse_tag_line (l_lbuf, a_tagp)
			a_tagp.item.tagkind := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_tagp.item.command_end := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if l_retval = 1 then
				l_p___0.item := a_tagp.item.command
				if (find_extra (l_p___0)) = 1 then
					a_tagp.item.command_end := l_p___0.item
					l_p___0.item := l_p___0.item + (2)
					l_tmp___2 := l_p___0.item
					l_p___0.item := l_p___0.item + 1
					if (l_tmp___2.item).to_integer_32 = 9 then
						from
						until
							js.loop_done
						loop
							if (l_p___0.item.item).to_integer_32 < 127 then
								if not ((((ctype_b_loc).item[(l_p___0.item.item).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("kind:"), (5).to_natural_32)) = 0 then
									a_tagp.item.tagkind := l_p___0.item + 5
									js.break
								end
							end
							if not js.loop_jumped then
								l_pc := misc2_inst.vim_strchr (l_p___0.item, (':').code)
								l_pt := misc2_inst.vim_strchr (l_p___0.item, ('%T').code)
								if l_pc.is_void then
									a_tagp.item.tagkind := l_p___0.item
									js.break
								elseif not l_pt.is_void then
									if (l_pc.c_pointer.to_integer_32).to_natural_32 > (l_pt.c_pointer.to_integer_32).to_natural_32 then
										a_tagp.item.tagkind := l_p___0.item
										js.break
									end
								end
							end
							if not js.loop_jumped and then (l_pt.is_void) then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.item := l_pt + 1
							end
						end
					end
				end
				if not (a_tagp.item.tagkind).is_void then
					l_p___0.item := a_tagp.item.tagkind
					from
					until
						js.loop_done
					loop
						if (l_p___0.item.item).to_boolean then
							if (l_p___0.item.item).to_integer_32 /= 9 then
								if (l_p___0.item.item).to_integer_32 /= 13 then
									if (l_p___0.item.item).to_integer_32 = 10 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.item := l_p___0.item + 1
						end
					end
					a_tagp.item.tagkind_end := l_p___0.item
				end
			end
			Result := l_retval
		end

	parse_tag_line (a_lbuf: CE_POINTER [NATURAL_8]; a_tagp: CE_POINTER [PD_TAG_POINTERS]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			a_tagp.item.tagname := a_lbuf
			l_p___0 := misc2_inst.vim_strchr (a_lbuf, ('%T').code)
			if l_p___0.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_tagp.item.tagname_end := l_p___0
				if (l_p___0.item).to_integer_32 /= 0 then
					l_p___0 := l_p___0 + 1
				end
				a_tagp.item.fname := l_p___0
				l_p___0 := misc2_inst.vim_strchr (l_p___0, ('%T').code)
				if l_p___0.is_void then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_tagp.item.fname_end := l_p___0
				if (l_p___0.item).to_integer_32 /= 0 then
					l_p___0 := l_p___0 + 1
				end
				if (l_p___0.item).to_integer_32 = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_tagp.item.command := l_p___0
				Result := 1
			end
		end

	prepare_pats (a_pats: CE_POINTER [PD_PAT_T]; a_has_re: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make

			a_pats.item.head := a_pats.item.pat
			a_pats.item.headlen := a_pats.item.len
			if a_has_re.to_boolean then
				if (a_pats.item.pat[0]).to_integer_32 = 94 then
					a_pats.item.head := a_pats.item.pat + 1
				elseif (a_pats.item.pat[0]).to_integer_32 = 92 then
					if (a_pats.item.pat[1]).to_integer_32 = 60 then
						a_pats.item.head := a_pats.item.pat + 2
					end
				end
				if (a_pats.item.head).is_equal (a_pats.item.pat) then
					a_pats.item.headlen := 0
				else
					a_pats.item.headlen := 0
					from
					until
						not (not js.loop_done and then ((a_pats.item.head[a_pats.item.headlen]).to_integer_32 /= 0))
					loop
						if (option_inst.p_magic.item).to_boolean then
							l_tmp := ce_string (".[~*\$")
						else
							l_tmp := ce_string ("\$")
						end
						if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), (a_pats.item.head[a_pats.item.headlen]).to_integer_32)).is_void then
							js.break
						end
						if not js.loop_jumped then
							a_pats.item.headlen := (a_pats.item.headlen) + 1
						end
					end
				end
				if option_inst.p_tl.item /= 0 then
					if (a_pats.item.headlen).to_integer_32 > option_inst.p_tl.item then
						a_pats.item.headlen := (option_inst.p_tl.item).to_integer_32
					end
				end
			end
			if a_has_re.to_boolean then
				if (option_inst.p_magic.item).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				a_pats.item.regmatch.regprog := regexp_inst.vim_regcomp (a_pats.item.pat, l_tmp___1)
			else
				a_pats.item.regmatch.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			end
		end

	simplify_filename (a_filename: CE_POINTER [NATURAL_8])
		local
			l_components: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_start___1: CE_POINTER [NATURAL_8]
			l_stripping_disabled: INTEGER_32
			l_relative: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_do_strip: INTEGER_32
			l_saved_char: NATURAL_8
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___11: INTEGER_32
			l_new_st: CE_ARRAY [SD_STAT]
			l_tmp___14: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tail.make
			create l_start___1.make
			create l_st.make (<<1>>)
			create l_new_st.make (<<1>>)
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_components := 0
					l_stripping_disabled := 0
					l_relative := 1
					l_p___0 := a_filename
					if (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
						l_relative := 0
						from
						until
							js.loop_done
						loop
							l_p___0 := l_p___0 + 1
							if not (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
								js.break
							end
						end
					end
					l_start___1 := l_p___0
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 44 -- skip loop
					end
				when 2 then -- loop body:
						if not ((misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 5 then -- else:
						if (l_p___0[0]).to_integer_32 /= 46 then
							l_pos := -1 + 17 -- skip if block
						end
				when 6 then -- if:
						if not ((misc1_inst.vim_ispathsep ((l_p___0[1]).to_integer_32)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___5
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L___5:
						if not (l_p___0.is_equal (l_start___1)) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_relative.to_boolean then
							l_p___0 := l_p___0 + (1 + ((l_p___0[1]).to_integer_32 /= 0).to_integer)
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_tail := l_p___0 + 1
						if (l_p___0[1]).to_integer_32 /= 0 then
							from
							until
								js.loop_done
							loop
								if not (misc1_inst.vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___3 := (globals_inst.mb_ptr2len.integer_32_item ([l_tail]))
									else
										l_tmp___3 := 1
									end
									l_tail := l_tail + l_tmp___3
								end
							end
						elseif (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							l_p___0 := l_p___0 - 1
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_tail), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tail))) + {NATURAL_32} 1).do_nothing
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___4
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 43
				when 17 then -- else: | _L___4:
						if (l_p___0[0]).to_integer_32 /= 46 then
							l_pos := -1 + 42 -- skip if block
						end
				when 18 then -- if:
						if (l_p___0[1]).to_integer_32 /= 46 then
							l_pos := -1 + 40 -- skip if block
						end
				when 19 then -- if:
						if not ((misc1_inst.vim_ispathsep ((l_p___0[2]).to_integer_32)).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___3
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 22 then -- else:
						if (l_p___0[2]).to_integer_32 /= 0 then
							l_pos := -1 + 38 -- skip if block
						end
				when 23 then -- if: | _L___3:
						l_tail := l_p___0 + 2
						from
						until
							js.loop_done
						loop
							if not (misc1_inst.vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___7 := (globals_inst.mb_ptr2len.integer_32_item ([l_tail]))
								else
									l_tmp___7 := 1
								end
								l_tail := l_tail + l_tmp___7
							end
						end
						if not (l_components > 0) then
							l_pos := -1 + 33 -- skip if block
						end
				when 24 then -- if:
						l_do_strip := 0
						if not l_stripping_disabled.to_boolean then
							l_saved_char := l_p___0[-1]
							l_p___0[-1] := (('%/0/').code).to_natural_8
							if (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (a_filename), l_st)) < 0 then
								l_do_strip := 1
							end
							l_p___0[-1] := l_saved_char
							l_p___0 := l_p___0 - 1
							from
							until
								js.loop_done
							loop
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
									if (misc2_inst.after_pathsep (l_start___1, l_p___0)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___11 := (globals_inst.mb_head_off.integer_32_item ([l_start___1, l_p___0 - 1])) + 1
									else
										l_tmp___11 := 1
									end
									l_p___0 := l_p___0 - l_tmp___11
								end
							end
							if not l_do_strip.to_boolean then
								l_saved_char := l_tail.item
								l_tail.item := (('%/0/').code).to_natural_8
								if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_filename), l_st)) >= 0 then
									l_do_strip := 1
								else
									l_stripping_disabled := 1
								end
								l_tail.item := l_saved_char
								if l_do_strip.to_boolean then
									if l_p___0.is_equal (l_start___1) then
										if l_relative.to_boolean then
											stat (ce_string ("."), l_new_st).do_nothing
										else
											l_saved_char := l_p___0.item
											l_p___0.item := (('%/0/').code).to_natural_8
											stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_filename), l_new_st).do_nothing
											l_p___0.item := l_saved_char
										end
									else
										l_saved_char := l_p___0.item
										l_p___0.item := (('%/0/').code).to_natural_8
										stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_filename), l_new_st).do_nothing
										l_p___0.item := l_saved_char
									end
									if l_new_st.item.st_ino /= l_st.item.st_ino then
										l_do_strip := 0
									elseif l_new_st.item.st_dev /= l_st.item.st_dev then
										l_do_strip := 0
									end
								end
							end
						end
						if l_do_strip.to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_p___0 := l_tail
						l_components := 0
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 27 then -- else:
						if not (l_p___0.is_equal (l_start___1)) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_relative.to_boolean then
							if (l_tail[-1]).to_integer_32 = 46 then
								l_tmp___14 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___14.item := (('.').code).to_natural_8
								l_p___0.item := (('%/0/').code).to_natural_8
							else
								l_pos := -1 + 30 -- goto _L___1
							end
						else
							l_pos := -1 + 30 -- goto _L___1
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___1:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							if (l_tail[-1]).to_integer_32 = 46 then
								l_p___0 := l_p___0 - 1
							end
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_tail), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tail))) + {NATURAL_32} 1).do_nothing
				when 31 then
						l_components := l_components - 1
				when 32 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 33 then -- else:
						if not (l_p___0.is_equal (l_start___1)) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if not l_relative.to_boolean then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_tail), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tail))) + {NATURAL_32} 1).do_nothing
						else
							l_pos := -1 + 36 -- goto _L___2
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else: | _L___2:
						if l_p___0.is_equal (l_start___1 + 2) then
							if (l_p___0[-2]).to_integer_32 = 46 then
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 - 2)), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
								l_tail := l_tail - (2)
							end
						end
						l_p___0 := l_tail
				when 37 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_components := l_components + 1
						l_p___0 := misc1_inst.getnextcomp (l_p___0)
				when 39 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						l_components := l_components + 1
						l_p___0 := misc1_inst.getnextcomp (l_p___0)
				when 41 then -- if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						l_components := l_components + 1
						l_p___0 := misc1_inst.getnextcomp (l_p___0)
				when 43 then -- if done | if done
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 44 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tag_freematch
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (tagmatchname))
			tagmatchname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

	tag_full_fname (a_tagp: CE_POINTER [PD_TAG_POINTERS]): CE_POINTER [NATURAL_8]
		local
			l_fullname: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
		do
			create l_fullname.make

			l_c := ((a_tagp.item.fname_end).item).to_integer_32;
			(a_tagp.item.fname_end).item := (('%/0/').code).to_natural_8
			l_fullname := expand_tag_fname (a_tagp.item.fname, a_tagp.item.tag_fname, 0);
			(a_tagp.item.fname_end).item := l_c.to_natural_8
			Result := l_fullname
		end

	tag_strnicmp (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_s1: CE_POINTER [NATURAL_8]
			l_s2: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_s1.make
			create l_s2.make

			l_s1 := a_s1
			l_s2 := a_s2
			l_len := a_len
			from
			until
				not (not js.loop_done and then (l_len > {NATURAL_32} 0))
			loop
				if (l_s1.item).to_integer_32 < 97 then
					l_tmp := (l_s1.item).to_integer_32
				elseif (l_s1.item).to_integer_32 > 122 then
					l_tmp := (l_s1.item).to_integer_32
				else
					l_tmp := (l_s1.item).to_integer_32 - 32
				end
				if (l_s2.item).to_integer_32 < 97 then
					l_tmp___0 := (l_s2.item).to_integer_32
				elseif (l_s2.item).to_integer_32 > 122 then
					l_tmp___0 := (l_s2.item).to_integer_32
				else
					l_tmp___0 := (l_s2.item).to_integer_32 - 32
				end
				l_i___0 := l_tmp - l_tmp___0
				if l_i___0 /= 0 then
					Result := l_i___0
					js.return
				end
				if not js.return_called then
					if (l_s1.item).to_integer_32 = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_s1 := l_s1 + 1
						l_s2 := l_s2 + 1
						l_len := l_len - 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	taglen_advance (a_l: INTEGER_32)
		do
			if a_l.to_integer_32 = 2_147_483_647 then
				message_inst.msg_putchar (('%N').code)
				message_inst.msg_advance (24)
			else
				message_inst.msg_advance (13 + a_l)
			end
		end

	tagname_free (a_tnp: CE_POINTER [PD_TAGNAME_T])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_tnp.item.tn_tags))
			misc2_inst.vim_findfile_cleanup (a_tnp.item.tn_search_ctx)
			a_tnp.item.tn_search_ctx := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			misc2_inst.ga_clear_strings (tag_fnames)
		end

	test_for_current (a_fname: CE_POINTER [NATURAL_8]; a_fname_end: CE_POINTER [NATURAL_8]; a_tag_fname: CE_POINTER [NATURAL_8]; a_buf_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_c: INTEGER_32
			l_retval: INTEGER_32
			l_fullname: CE_POINTER [NATURAL_8]
		do
			create l_fullname.make

			l_retval := 0
			if not a_buf_ffname.is_void then
				l_c := (a_fname_end.item).to_integer_32
				a_fname_end.item := (('%/0/').code).to_natural_8
				l_fullname := expand_tag_fname (a_fname, a_tag_fname, 1)
				if not l_fullname.is_void then
					l_retval := ((misc1_inst.fullpathcmp (l_fullname, a_buf_ffname, 1))).bit_and (1)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fullname))
				end
				a_fname_end.item := l_c.to_natural_8
			end
			Result := l_retval
		end

	test_for_static (a_tagp: CE_POINTER [PD_TAG_POINTERS]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_len := (a_tagp.item.fname_end).distance ((a_tagp.item.fname))
			l_p___0 := a_tagp.item.tagname + l_len
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_tagp.item.tagname_end).c_pointer.to_integer_32).to_natural_32 then
				if (l_p___0.item).to_integer_32 = 58 then
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_tagp.item.tagname), create {CE_POINTER [INTEGER_8]}.make_cast (a_tagp.item.fname), l_len.to_natural_32)) = 0 then
						a_tagp.item.tagname := l_p___0 + 1
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				l_p___0 := a_tagp.item.command
				from
				until
					js.loop_done
				loop
					l_p___0 := misc2_inst.vim_strchr (l_p___0, ('%T').code)
					if l_p___0.is_void then
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)) = 0 then
							Result := 1
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
