class
	SD_ATKRELATIONSET

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent.make
			create relations.make
		end

feature {ANY} -- fields

	parent: SD_GOBJECT assign set_parent

	relations: CE_POINTER [SD_GPTRARRAY] assign set_relations

feature {ANY} -- setters

	set_parent (a_parent: SD_GOBJECT)
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_relations (a_relations: CE_POINTER [SD_GPTRARRAY])
		do
			relations := a_relations
			update_memory_field ("relations")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent := a_other.parent.twin
			relations := a_other.relations
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent.is_equal (a_other.parent) and
				relations.is_equal (a_other.relations)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("relations")
				>>)
			init_structure_info
		end

end
