class
	SD_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	v_int: INTEGER_32 assign set_v_int

	v_uint: NATURAL_32 assign set_v_uint

	v_long: INTEGER_32 assign set_v_long

	v_ulong: NATURAL_32 assign set_v_ulong

	v_int64: INTEGER_64 assign set_v_int64

	v_uint64: NATURAL_64 assign set_v_uint64

	v_float: REAL_32 assign set_v_float

	v_double: REAL_64 assign set_v_double

	v_pointer: CE_POINTER [ANY] assign set_v_pointer

feature {ANY} -- setters

	set_v_int (a_v_int: INTEGER_32)
		do
			v_int := a_v_int
			update_memory_field ("v_int")
		end

	set_v_uint (a_v_uint: NATURAL_32)
		do
			v_uint := a_v_uint
			update_memory_field ("v_uint")
		end

	set_v_long (a_v_long: INTEGER_32)
		do
			v_long := a_v_long
			update_memory_field ("v_long")
		end

	set_v_ulong (a_v_ulong: NATURAL_32)
		do
			v_ulong := a_v_ulong
			update_memory_field ("v_ulong")
		end

	set_v_int64 (a_v_int64: INTEGER_64)
		do
			v_int64 := a_v_int64
			update_memory_field ("v_int64")
		end

	set_v_uint64 (a_v_uint64: NATURAL_64)
		do
			v_uint64 := a_v_uint64
			update_memory_field ("v_uint64")
		end

	set_v_float (a_v_float: REAL_32)
		do
			v_float := a_v_float
			update_memory_field ("v_float")
		end

	set_v_double (a_v_double: REAL_64)
		do
			v_double := a_v_double
			update_memory_field ("v_double")
		end

	set_v_pointer (a_v_pointer: CE_POINTER [ANY])
		do
			v_pointer := a_v_pointer
			update_memory_field ("v_pointer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			v_int := a_other.v_int
			v_uint := a_other.v_uint
			v_long := a_other.v_long
			v_ulong := a_other.v_ulong
			v_int64 := a_other.v_int64
			v_uint64 := a_other.v_uint64
			v_float := a_other.v_float
			v_double := a_other.v_double
			v_pointer := a_other.v_pointer
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				v_int = a_other.v_int and
				v_uint = a_other.v_uint and
				v_long = a_other.v_long and
				v_ulong = a_other.v_ulong and
				v_int64 = a_other.v_int64 and
				v_uint64 = a_other.v_uint64 and
				v_float = a_other.v_float and
				v_double = a_other.v_double and
				v_pointer.is_equal (a_other.v_pointer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("v_int"),
					create {CE_STRUCTURE_FIELD}.make ("v_uint"),
					create {CE_STRUCTURE_FIELD}.make ("v_long"),
					create {CE_STRUCTURE_FIELD}.make ("v_ulong"),
					create {CE_STRUCTURE_FIELD}.make ("v_int64"),
					create {CE_STRUCTURE_FIELD}.make ("v_uint64"),
					create {CE_STRUCTURE_FIELD}.make ("v_float"),
					create {CE_STRUCTURE_FIELD}.make ("v_double"),
					create {CE_STRUCTURE_FIELD}.make ("v_pointer")
				>>)
			init_structure_info
		end

end
