class
	SD_DATA4

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	pixmap: SD_GTKIMAGEPIXMAPDATA assign set_pixmap

	image: SD_GTKIMAGEIMAGEDATA assign set_image

	pixbuf: SD_GTKIMAGEPIXBUFDATA assign set_pixbuf

	stock: SD_GTKIMAGESTOCKDATA assign set_stock

	icon_set: SD_GTKIMAGEICONSETDATA assign set_icon_set

	anim: SD_GTKIMAGEANIMATIONDATA assign set_anim

	name: SD_GTKIMAGEICONNAMEDATA assign set_name

	gicon: SD_GTKIMAGEGICONDATA assign set_gicon

feature {ANY} -- setters

	set_pixmap (a_pixmap: SD_GTKIMAGEPIXMAPDATA)
		do
			pixmap := a_pixmap
			update_memory_field ("pixmap")
		end

	set_image (a_image: SD_GTKIMAGEIMAGEDATA)
		do
			image := a_image
			update_memory_field ("image")
		end

	set_pixbuf (a_pixbuf: SD_GTKIMAGEPIXBUFDATA)
		do
			pixbuf := a_pixbuf
			update_memory_field ("pixbuf")
		end

	set_stock (a_stock: SD_GTKIMAGESTOCKDATA)
		do
			stock := a_stock
			update_memory_field ("stock")
		end

	set_icon_set (a_icon_set: SD_GTKIMAGEICONSETDATA)
		do
			icon_set := a_icon_set
			update_memory_field ("icon_set")
		end

	set_anim (a_anim: SD_GTKIMAGEANIMATIONDATA)
		do
			anim := a_anim
			update_memory_field ("anim")
		end

	set_name (a_name: SD_GTKIMAGEICONNAMEDATA)
		do
			name := a_name
			update_memory_field ("name")
		end

	set_gicon (a_gicon: SD_GTKIMAGEGICONDATA)
		do
			gicon := a_gicon
			update_memory_field ("gicon")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pixmap := a_other.pixmap.twin
			image := a_other.image.twin
			pixbuf := a_other.pixbuf.twin
			stock := a_other.stock.twin
			icon_set := a_other.icon_set.twin
			anim := a_other.anim.twin
			name := a_other.name.twin
			gicon := a_other.gicon.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pixmap.is_equal (a_other.pixmap) and
				image.is_equal (a_other.image) and
				pixbuf.is_equal (a_other.pixbuf) and
				stock.is_equal (a_other.stock) and
				icon_set.is_equal (a_other.icon_set) and
				anim.is_equal (a_other.anim) and
				name.is_equal (a_other.name) and
				gicon.is_equal (a_other.gicon)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("pixmap"),
					create {CE_STRUCTURE_FIELD}.make ("image"),
					create {CE_STRUCTURE_FIELD}.make ("pixbuf"),
					create {CE_STRUCTURE_FIELD}.make ("stock"),
					create {CE_STRUCTURE_FIELD}.make ("icon_set"),
					create {CE_STRUCTURE_FIELD}.make ("anim"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("gicon")
				>>)
			init_structure_info
		end

end
