class
	SD_DEPTH

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create visuals.make
		end

feature {ANY} -- fields

	depth: INTEGER_32 assign set_depth

	nvisuals: INTEGER_32 assign set_nvisuals

	visuals: CE_POINTER [SD_VISUAL] assign set_visuals

feature {ANY} -- setters

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_nvisuals (a_nvisuals: INTEGER_32)
		do
			nvisuals := a_nvisuals
			update_memory_field ("nvisuals")
		end

	set_visuals (a_visuals: CE_POINTER [SD_VISUAL])
		do
			visuals := a_visuals
			update_memory_field ("visuals")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			depth := a_other.depth
			nvisuals := a_other.nvisuals
			visuals := a_other.visuals
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				depth = a_other.depth and
				nvisuals = a_other.nvisuals and
				visuals.is_equal (a_other.visuals)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("nvisuals"),
					create {CE_STRUCTURE_FIELD}.make ("visuals")
				>>)
			init_structure_info
		end

end
