class
	SD_GDKCOLORMAP

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_instance.make
			create colors.make
			create visual.make
			create windowing_data.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	size: INTEGER_32 assign set_size

	colors: CE_POINTER [SD_GDKCOLOR] assign set_colors

	visual: CE_POINTER [SD_GDKVISUAL] assign set_visual

	windowing_data: CE_POINTER [ANY] assign set_windowing_data

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_colors (a_colors: CE_POINTER [SD_GDKCOLOR])
		do
			colors := a_colors
			update_memory_field ("colors")
		end

	set_visual (a_visual: CE_POINTER [SD_GDKVISUAL])
		do
			visual := a_visual
			update_memory_field ("visual")
		end

	set_windowing_data (a_windowing_data: CE_POINTER [ANY])
		do
			windowing_data := a_windowing_data
			update_memory_field ("windowing_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			size := a_other.size
			colors := a_other.colors
			visual := a_other.visual
			windowing_data := a_other.windowing_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				size = a_other.size and
				colors.is_equal (a_other.colors) and
				visual.is_equal (a_other.visual) and
				windowing_data.is_equal (a_other.windowing_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("colors"),
					create {CE_STRUCTURE_FIELD}.make ("visual"),
					create {CE_STRUCTURE_FIELD}.make ("windowing_data")
				>>)
			init_structure_info
		end

end
