class
	SD_GDKDISPLAYPOINTERHOOKS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create get_pointer.make
			create window_get_pointer.make
			create window_at_pointer.make
		end

feature {ANY} -- fields

	get_pointer: CE_ROUTINE assign set_get_pointer

	window_get_pointer: CE_ROUTINE assign set_window_get_pointer

	window_at_pointer: CE_ROUTINE assign set_window_at_pointer

feature {ANY} -- setters

	set_get_pointer (a_get_pointer: CE_ROUTINE)
		do
			get_pointer := a_get_pointer
			update_memory_field ("get_pointer")
		end

	set_window_get_pointer (a_window_get_pointer: CE_ROUTINE)
		do
			window_get_pointer := a_window_get_pointer
			update_memory_field ("window_get_pointer")
		end

	set_window_at_pointer (a_window_at_pointer: CE_ROUTINE)
		do
			window_at_pointer := a_window_at_pointer
			update_memory_field ("window_at_pointer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			get_pointer := a_other.get_pointer
			window_get_pointer := a_other.window_get_pointer
			window_at_pointer := a_other.window_at_pointer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				get_pointer.is_equal (a_other.get_pointer) and
				window_get_pointer.is_equal (a_other.window_get_pointer) and
				window_at_pointer.is_equal (a_other.window_at_pointer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("get_pointer"),
					create {CE_STRUCTURE_FIELD}.make ("window_get_pointer"),
					create {CE_STRUCTURE_FIELD}.make ("window_at_pointer")
				>>)
			init_structure_info
		end

end
