class
	SD_GDKEVENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	any: SD_GDKEVENTANY assign set_any

	expose: SD_GDKEVENTEXPOSE assign set_expose

	no_expose: SD_GDKEVENTNOEXPOSE assign set_no_expose

	visibility: SD_GDKEVENTVISIBILITY assign set_visibility

	motion: SD_GDKEVENTMOTION assign set_motion

	button: SD_GDKEVENTBUTTON assign set_button

	scroll: SD_GDKEVENTSCROLL assign set_scroll

	key: SD_GDKEVENTKEY assign set_key

	crossing: SD_GDKEVENTCROSSING assign set_crossing

	focus_change: SD_GDKEVENTFOCUS assign set_focus_change

	configure: SD_GDKEVENTCONFIGURE assign set_configure

	property: SD_GDKEVENTPROPERTY assign set_property

	selection: SD_GDKEVENTSELECTION assign set_selection

	owner_change: SD_GDKEVENTOWNERCHANGE assign set_owner_change

	proximity: SD_GDKEVENTPROXIMITY assign set_proximity

	client: SD_GDKEVENTCLIENT assign set_client

	dnd: SD_GDKEVENTDND assign set_dnd

	window_state: SD_GDKEVENTWINDOWSTATE assign set_window_state

	setting: SD_GDKEVENTSETTING assign set_setting

	grab_broken: SD_GDKEVENTGRABBROKEN assign set_grab_broken

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_any (a_any: SD_GDKEVENTANY)
		do
			any := a_any
			update_memory_field ("any")
		end

	set_expose (a_expose: SD_GDKEVENTEXPOSE)
		do
			expose := a_expose
			update_memory_field ("expose")
		end

	set_no_expose (a_no_expose: SD_GDKEVENTNOEXPOSE)
		do
			no_expose := a_no_expose
			update_memory_field ("no_expose")
		end

	set_visibility (a_visibility: SD_GDKEVENTVISIBILITY)
		do
			visibility := a_visibility
			update_memory_field ("visibility")
		end

	set_motion (a_motion: SD_GDKEVENTMOTION)
		do
			motion := a_motion
			update_memory_field ("motion")
		end

	set_button (a_button: SD_GDKEVENTBUTTON)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_scroll (a_scroll: SD_GDKEVENTSCROLL)
		do
			scroll := a_scroll
			update_memory_field ("scroll")
		end

	set_key (a_key: SD_GDKEVENTKEY)
		do
			key := a_key
			update_memory_field ("key")
		end

	set_crossing (a_crossing: SD_GDKEVENTCROSSING)
		do
			crossing := a_crossing
			update_memory_field ("crossing")
		end

	set_focus_change (a_focus_change: SD_GDKEVENTFOCUS)
		do
			focus_change := a_focus_change
			update_memory_field ("focus_change")
		end

	set_configure (a_configure: SD_GDKEVENTCONFIGURE)
		do
			configure := a_configure
			update_memory_field ("configure")
		end

	set_property (a_property: SD_GDKEVENTPROPERTY)
		do
			property := a_property
			update_memory_field ("property")
		end

	set_selection (a_selection: SD_GDKEVENTSELECTION)
		do
			selection := a_selection
			update_memory_field ("selection")
		end

	set_owner_change (a_owner_change: SD_GDKEVENTOWNERCHANGE)
		do
			owner_change := a_owner_change
			update_memory_field ("owner_change")
		end

	set_proximity (a_proximity: SD_GDKEVENTPROXIMITY)
		do
			proximity := a_proximity
			update_memory_field ("proximity")
		end

	set_client (a_client: SD_GDKEVENTCLIENT)
		do
			client := a_client
			update_memory_field ("client")
		end

	set_dnd (a_dnd: SD_GDKEVENTDND)
		do
			dnd := a_dnd
			update_memory_field ("dnd")
		end

	set_window_state (a_window_state: SD_GDKEVENTWINDOWSTATE)
		do
			window_state := a_window_state
			update_memory_field ("window_state")
		end

	set_setting (a_setting: SD_GDKEVENTSETTING)
		do
			setting := a_setting
			update_memory_field ("setting")
		end

	set_grab_broken (a_grab_broken: SD_GDKEVENTGRABBROKEN)
		do
			grab_broken := a_grab_broken
			update_memory_field ("grab_broken")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			any := a_other.any.twin
			expose := a_other.expose.twin
			no_expose := a_other.no_expose.twin
			visibility := a_other.visibility.twin
			motion := a_other.motion.twin
			button := a_other.button.twin
			scroll := a_other.scroll.twin
			key := a_other.key.twin
			crossing := a_other.crossing.twin
			focus_change := a_other.focus_change.twin
			configure := a_other.configure.twin
			property := a_other.property.twin
			selection := a_other.selection.twin
			owner_change := a_other.owner_change.twin
			proximity := a_other.proximity.twin
			client := a_other.client.twin
			dnd := a_other.dnd.twin
			window_state := a_other.window_state.twin
			setting := a_other.setting.twin
			grab_broken := a_other.grab_broken.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				any.is_equal (a_other.any) and
				expose.is_equal (a_other.expose) and
				no_expose.is_equal (a_other.no_expose) and
				visibility.is_equal (a_other.visibility) and
				motion.is_equal (a_other.motion) and
				button.is_equal (a_other.button) and
				scroll.is_equal (a_other.scroll) and
				key.is_equal (a_other.key) and
				crossing.is_equal (a_other.crossing) and
				focus_change.is_equal (a_other.focus_change) and
				configure.is_equal (a_other.configure) and
				property.is_equal (a_other.property) and
				selection.is_equal (a_other.selection) and
				owner_change.is_equal (a_other.owner_change) and
				proximity.is_equal (a_other.proximity) and
				client.is_equal (a_other.client) and
				dnd.is_equal (a_other.dnd) and
				window_state.is_equal (a_other.window_state) and
				setting.is_equal (a_other.setting) and
				grab_broken.is_equal (a_other.grab_broken)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("any"),
					create {CE_STRUCTURE_FIELD}.make ("expose"),
					create {CE_STRUCTURE_FIELD}.make ("no_expose"),
					create {CE_STRUCTURE_FIELD}.make ("visibility"),
					create {CE_STRUCTURE_FIELD}.make ("motion"),
					create {CE_STRUCTURE_FIELD}.make ("button"),
					create {CE_STRUCTURE_FIELD}.make ("scroll"),
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("crossing"),
					create {CE_STRUCTURE_FIELD}.make ("focus_change"),
					create {CE_STRUCTURE_FIELD}.make ("configure"),
					create {CE_STRUCTURE_FIELD}.make ("property"),
					create {CE_STRUCTURE_FIELD}.make ("selection"),
					create {CE_STRUCTURE_FIELD}.make ("owner_change"),
					create {CE_STRUCTURE_FIELD}.make ("proximity"),
					create {CE_STRUCTURE_FIELD}.make ("client"),
					create {CE_STRUCTURE_FIELD}.make ("dnd"),
					create {CE_STRUCTURE_FIELD}.make ("window_state"),
					create {CE_STRUCTURE_FIELD}.make ("setting"),
					create {CE_STRUCTURE_FIELD}.make ("grab_broken")
				>>)
			init_structure_info
		end

end
