class
	SD_GDKEVENTCONFIGURE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create window.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	width: INTEGER_32 assign set_width

	height: INTEGER_32 assign set_height

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			x := a_other.x
			y := a_other.y
			width := a_other.width
			height := a_other.height
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				x = a_other.x and
				y = a_other.y and
				width = a_other.width and
				height = a_other.height
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height")
				>>)
			init_structure_info
		end

end
