class
	SD_GDKEVENTWINDOWSTATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create window.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	changed_mask: NATURAL_32 assign set_changed_mask

	new_window_state: NATURAL_32 assign set_new_window_state

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_changed_mask (a_changed_mask: NATURAL_32)
		do
			changed_mask := a_changed_mask
			update_memory_field ("changed_mask")
		end

	set_new_window_state (a_new_window_state: NATURAL_32)
		do
			new_window_state := a_new_window_state
			update_memory_field ("new_window_state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			changed_mask := a_other.changed_mask
			new_window_state := a_other.new_window_state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				changed_mask = a_other.changed_mask and
				new_window_state = a_other.new_window_state
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("changed_mask"),
					create {CE_STRUCTURE_FIELD}.make ("new_window_state")
				>>)
			init_structure_info
		end

end
