class
	SD_GDKSCREEN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	closed: NATURAL_32 assign set_closed

	normal_gcs: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	exposure_gcs: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	subwindow_gcs: CE_ARRAY [CE_POINTER [SD_GDKGC]]

	font_options: CE_POINTER [ANY] assign set_font_options

	resolution: REAL_64 assign set_resolution

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_closed (a_closed: NATURAL_32)
		do
			closed := a_closed
			update_memory_field ("closed")
		end

	set_font_options (a_font_options: CE_POINTER [ANY])
		do
			font_options := a_font_options
			update_memory_field ("font_options")
		end

	set_resolution (a_resolution: REAL_64)
		do
			resolution := a_resolution
			update_memory_field ("resolution")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			closed := a_other.closed
			normal_gcs := a_other.normal_gcs.twin
			exposure_gcs := a_other.exposure_gcs.twin
			subwindow_gcs := a_other.subwindow_gcs.twin
			font_options := a_other.font_options
			resolution := a_other.resolution
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				closed = a_other.closed and
				normal_gcs.is_equal (a_other.normal_gcs) and
				exposure_gcs.is_equal (a_other.exposure_gcs) and
				subwindow_gcs.is_equal (a_other.subwindow_gcs) and
				font_options.is_equal (a_other.font_options) and
				resolution = a_other.resolution
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("closed"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("normal_gcs", <<32>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("exposure_gcs", <<32>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("subwindow_gcs", <<32>>),
					create {CE_STRUCTURE_FIELD}.make ("font_options"),
					create {CE_STRUCTURE_FIELD}.make ("resolution")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gdk/gdk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GdkScreen);
					if(strcmp(field_name, "normal_gcs") == 0) return offsetof(struct _GdkScreen, normal_gcs);
				} else {
					struct _GdkScreen *p = (struct _GdkScreen *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "closed") == 0) p->closed = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "closed") == 0) return p->closed;
					}
				}
			]"
		end

end
