class
	SD_GLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create next.make
			create prev.make
		end

feature {ANY} -- fields

	data: CE_POINTER [ANY] assign set_data

	next: CE_POINTER [SD_GLIST] assign set_next

	prev: CE_POINTER [SD_GLIST] assign set_prev

feature {ANY} -- setters

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_next (a_next: CE_POINTER [SD_GLIST])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [SD_GLIST])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			next := a_other.next
			prev := a_other.prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev")
				>>)
			init_structure_info
		end

end
