class
	SD_GPTRARRAY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pdata.make
		end

feature {ANY} -- fields

	pdata: CE_POINTER [CE_POINTER [ANY]] assign set_pdata

	len: NATURAL_32 assign set_len

feature {ANY} -- setters

	set_pdata (a_pdata: CE_POINTER [CE_POINTER [ANY]])
		do
			pdata := a_pdata
			update_memory_field ("pdata")
		end

	set_len (a_len: NATURAL_32)
		do
			len := a_len
			update_memory_field ("len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pdata := a_other.pdata
			len := a_other.len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pdata.is_equal (a_other.pdata) and
				len = a_other.len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pdata"),
					create {CE_STRUCTURE_FIELD}.make ("len")
				>>)
			init_structure_info
		end

end
