class
	SD_GSOURCE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create callback_data.make
			create callback_funcs.make
			create source_funcs.make
			create context.make
			create poll_fds.make
			create prev.make
			create next.make
			create name.make
			create priv.make
		end

feature {ANY} -- fields

	callback_data: CE_POINTER [ANY] assign set_callback_data

	callback_funcs: CE_POINTER [SD_GSOURCECALLBACKFUNCS] assign set_callback_funcs

	source_funcs: CE_POINTER [SD_GSOURCEFUNCS] assign set_source_funcs

	ref_count: NATURAL_32 assign set_ref_count

	context: CE_POINTER [ANY] assign set_context

	priority: INTEGER_32 assign set_priority

	flags: NATURAL_32 assign set_flags

	source_id: NATURAL_32 assign set_source_id

	poll_fds: CE_POINTER [SD_GSLIST] assign set_poll_fds

	prev: CE_POINTER [SD_GSOURCE] assign set_prev

	next: CE_POINTER [SD_GSOURCE] assign set_next

	name: CE_POINTER [INTEGER_8] assign set_name

	priv: CE_POINTER [ANY] assign set_priv

feature {ANY} -- setters

	set_callback_data (a_callback_data: CE_POINTER [ANY])
		do
			callback_data := a_callback_data
			update_memory_field ("callback_data")
		end

	set_callback_funcs (a_callback_funcs: CE_POINTER [SD_GSOURCECALLBACKFUNCS])
		do
			callback_funcs := a_callback_funcs
			update_memory_field ("callback_funcs")
		end

	set_source_funcs (a_source_funcs: CE_POINTER [SD_GSOURCEFUNCS])
		do
			source_funcs := a_source_funcs
			update_memory_field ("source_funcs")
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			ref_count := a_ref_count
			update_memory_field ("ref_count")
		end

	set_context (a_context: CE_POINTER [ANY])
		do
			context := a_context
			update_memory_field ("context")
		end

	set_priority (a_priority: INTEGER_32)
		do
			priority := a_priority
			update_memory_field ("priority")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_source_id (a_source_id: NATURAL_32)
		do
			source_id := a_source_id
			update_memory_field ("source_id")
		end

	set_poll_fds (a_poll_fds: CE_POINTER [SD_GSLIST])
		do
			poll_fds := a_poll_fds
			update_memory_field ("poll_fds")
		end

	set_prev (a_prev: CE_POINTER [SD_GSOURCE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_next (a_next: CE_POINTER [SD_GSOURCE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_priv (a_priv: CE_POINTER [ANY])
		do
			priv := a_priv
			update_memory_field ("priv")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			callback_data := a_other.callback_data
			callback_funcs := a_other.callback_funcs
			source_funcs := a_other.source_funcs
			ref_count := a_other.ref_count
			context := a_other.context
			priority := a_other.priority
			flags := a_other.flags
			source_id := a_other.source_id
			poll_fds := a_other.poll_fds
			prev := a_other.prev
			next := a_other.next
			name := a_other.name
			priv := a_other.priv
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				callback_data.is_equal (a_other.callback_data) and
				callback_funcs.is_equal (a_other.callback_funcs) and
				source_funcs.is_equal (a_other.source_funcs) and
				ref_count = a_other.ref_count and
				context.is_equal (a_other.context) and
				priority = a_other.priority and
				flags = a_other.flags and
				source_id = a_other.source_id and
				poll_fds.is_equal (a_other.poll_fds) and
				prev.is_equal (a_other.prev) and
				next.is_equal (a_other.next) and
				name.is_equal (a_other.name) and
				priv.is_equal (a_other.priv)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("callback_data"),
					create {CE_STRUCTURE_FIELD}.make ("callback_funcs"),
					create {CE_STRUCTURE_FIELD}.make ("source_funcs"),
					create {CE_STRUCTURE_FIELD}.make ("ref_count"),
					create {CE_STRUCTURE_FIELD}.make ("context"),
					create {CE_STRUCTURE_FIELD}.make ("priority"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("source_id"),
					create {CE_STRUCTURE_FIELD}.make ("poll_fds"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("priv")
				>>)
			init_structure_info
		end

end
