class
	SD_GTKACCELKEY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	accel_key: NATURAL_32 assign set_accel_key

	accel_mods: NATURAL_32 assign set_accel_mods

	accel_flags: NATURAL_32 assign set_accel_flags

feature {ANY} -- setters

	set_accel_key (a_accel_key: NATURAL_32)
		do
			accel_key := a_accel_key
			update_memory_field ("accel_key")
		end

	set_accel_mods (a_accel_mods: NATURAL_32)
		do
			accel_mods := a_accel_mods
			update_memory_field ("accel_mods")
		end

	set_accel_flags (a_accel_flags: NATURAL_32)
		do
			accel_flags := a_accel_flags
			update_memory_field ("accel_flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			accel_key := a_other.accel_key
			accel_mods := a_other.accel_mods
			accel_flags := a_other.accel_flags
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				accel_key = a_other.accel_key and
				accel_mods = a_other.accel_mods and
				accel_flags = a_other.accel_flags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("accel_key"),
					create {CE_STRUCTURE_FIELD}.make ("accel_mods"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("accel_flags")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkAccelKey);
				} else {
					struct _GtkAccelKey *p = (struct _GtkAccelKey *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "accel_flags") == 0) p->accel_flags = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "accel_flags") == 0) return p->accel_flags;
					}
				}
			]"
		end

end
