class
	SD_GTKADJUSTMENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_instance.make
		end

feature {ANY} -- fields

	parent_instance: SD_GTKOBJECT assign set_parent_instance

	lower: REAL_64 assign set_lower

	upper: REAL_64 assign set_upper

	value: REAL_64 assign set_value

	step_increment: REAL_64 assign set_step_increment

	page_increment: REAL_64 assign set_page_increment

	page_size: REAL_64 assign set_page_size

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GTKOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_lower (a_lower: REAL_64)
		do
			lower := a_lower
			update_memory_field ("lower")
		end

	set_upper (a_upper: REAL_64)
		do
			upper := a_upper
			update_memory_field ("upper")
		end

	set_value (a_value: REAL_64)
		do
			value := a_value
			update_memory_field ("value")
		end

	set_step_increment (a_step_increment: REAL_64)
		do
			step_increment := a_step_increment
			update_memory_field ("step_increment")
		end

	set_page_increment (a_page_increment: REAL_64)
		do
			page_increment := a_page_increment
			update_memory_field ("page_increment")
		end

	set_page_size (a_page_size: REAL_64)
		do
			page_size := a_page_size
			update_memory_field ("page_size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			lower := a_other.lower
			upper := a_other.upper
			value := a_other.value
			step_increment := a_other.step_increment
			page_increment := a_other.page_increment
			page_size := a_other.page_size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				lower = a_other.lower and
				upper = a_other.upper and
				value = a_other.value and
				step_increment = a_other.step_increment and
				page_increment = a_other.page_increment and
				page_size = a_other.page_size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("lower"),
					create {CE_STRUCTURE_FIELD}.make ("upper"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("step_increment"),
					create {CE_STRUCTURE_FIELD}.make ("page_increment"),
					create {CE_STRUCTURE_FIELD}.make ("page_size")
				>>)
			init_structure_info
		end

end
