class
	SD_GTKDIALOG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create window.make
			create vbox.make
			create action_area.make
			create separator.make
		end

feature {ANY} -- fields

	window: SD_GTKWINDOW assign set_window

	vbox: CE_POINTER [SD_GTKWIDGET] assign set_vbox

	action_area: CE_POINTER [SD_GTKWIDGET] assign set_action_area

	separator: CE_POINTER [SD_GTKWIDGET] assign set_separator

feature {ANY} -- setters

	set_window (a_window: SD_GTKWINDOW)
		do
			window := a_window
			update_memory_field ("window")
		end

	set_vbox (a_vbox: CE_POINTER [SD_GTKWIDGET])
		do
			vbox := a_vbox
			update_memory_field ("vbox")
		end

	set_action_area (a_action_area: CE_POINTER [SD_GTKWIDGET])
		do
			action_area := a_action_area
			update_memory_field ("action_area")
		end

	set_separator (a_separator: CE_POINTER [SD_GTKWIDGET])
		do
			separator := a_separator
			update_memory_field ("separator")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			window := a_other.window.twin
			vbox := a_other.vbox
			action_area := a_other.action_area
			separator := a_other.separator
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				window.is_equal (a_other.window) and
				vbox.is_equal (a_other.vbox) and
				action_area.is_equal (a_other.action_area) and
				separator.is_equal (a_other.separator)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("vbox"),
					create {CE_STRUCTURE_FIELD}.make ("action_area"),
					create {CE_STRUCTURE_FIELD}.make ("separator")
				>>)
			init_structure_info
		end

end
