class
	SD_GTKSETTINGS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_instance.make
			create queued_settings.make
			create property_values.make
			create rc_context.make
			create screen.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	queued_settings: CE_POINTER [ANY] assign set_queued_settings

	property_values: CE_POINTER [ANY] assign set_property_values

	rc_context: CE_POINTER [ANY] assign set_rc_context

	screen: CE_POINTER [SD_GDKSCREEN] assign set_screen

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_queued_settings (a_queued_settings: CE_POINTER [ANY])
		do
			queued_settings := a_queued_settings
			update_memory_field ("queued_settings")
		end

	set_property_values (a_property_values: CE_POINTER [ANY])
		do
			property_values := a_property_values
			update_memory_field ("property_values")
		end

	set_rc_context (a_rc_context: CE_POINTER [ANY])
		do
			rc_context := a_rc_context
			update_memory_field ("rc_context")
		end

	set_screen (a_screen: CE_POINTER [SD_GDKSCREEN])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			queued_settings := a_other.queued_settings
			property_values := a_other.property_values
			rc_context := a_other.rc_context
			screen := a_other.screen
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				queued_settings.is_equal (a_other.queued_settings) and
				property_values.is_equal (a_other.property_values) and
				rc_context.is_equal (a_other.rc_context) and
				screen.is_equal (a_other.screen)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("queued_settings"),
					create {CE_STRUCTURE_FIELD}.make ("property_values"),
					create {CE_STRUCTURE_FIELD}.make ("rc_context"),
					create {CE_STRUCTURE_FIELD}.make ("screen")
				>>)
			init_structure_info
		end

end
