class
	SD_GTKTABLEROWCOL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	requisition: NATURAL_16 assign set_requisition

	allocation: NATURAL_16 assign set_allocation

	spacing: NATURAL_16 assign set_spacing

	need_expand: NATURAL_32 assign set_need_expand

	need_shrink: NATURAL_32 assign set_need_shrink

	expand: NATURAL_32 assign set_expand

	shrink: NATURAL_32 assign set_shrink

	empty: NATURAL_32 assign set_empty

feature {ANY} -- setters

	set_requisition (a_requisition: NATURAL_16)
		do
			requisition := a_requisition
			update_memory_field ("requisition")
		end

	set_allocation (a_allocation: NATURAL_16)
		do
			allocation := a_allocation
			update_memory_field ("allocation")
		end

	set_spacing (a_spacing: NATURAL_16)
		do
			spacing := a_spacing
			update_memory_field ("spacing")
		end

	set_need_expand (a_need_expand: NATURAL_32)
		do
			need_expand := a_need_expand
			update_memory_field ("need_expand")
		end

	set_need_shrink (a_need_shrink: NATURAL_32)
		do
			need_shrink := a_need_shrink
			update_memory_field ("need_shrink")
		end

	set_expand (a_expand: NATURAL_32)
		do
			expand := a_expand
			update_memory_field ("expand")
		end

	set_shrink (a_shrink: NATURAL_32)
		do
			shrink := a_shrink
			update_memory_field ("shrink")
		end

	set_empty (a_empty: NATURAL_32)
		do
			empty := a_empty
			update_memory_field ("empty")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			requisition := a_other.requisition
			allocation := a_other.allocation
			spacing := a_other.spacing
			need_expand := a_other.need_expand
			need_shrink := a_other.need_shrink
			expand := a_other.expand
			shrink := a_other.shrink
			empty := a_other.empty
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				requisition = a_other.requisition and
				allocation = a_other.allocation and
				spacing = a_other.spacing and
				need_expand = a_other.need_expand and
				need_shrink = a_other.need_shrink and
				expand = a_other.expand and
				shrink = a_other.shrink and
				empty = a_other.empty
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("requisition"),
					create {CE_STRUCTURE_FIELD}.make ("allocation"),
					create {CE_STRUCTURE_FIELD}.make ("spacing"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_expand"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_shrink"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("expand"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("shrink"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("empty")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkTableRowCol);
				} else {
					struct _GtkTableRowCol *p = (struct _GtkTableRowCol *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "need_expand") == 0) p->need_expand = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_shrink") == 0) p->need_shrink = (unsigned int)$a_value;
						else if(strcmp(field_name, "expand") == 0) p->expand = (unsigned int)$a_value;
						else if(strcmp(field_name, "shrink") == 0) p->shrink = (unsigned int)$a_value;
						else if(strcmp(field_name, "empty") == 0) p->empty = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "need_expand") == 0) return p->need_expand;
						if(strcmp(field_name, "need_shrink") == 0) return p->need_shrink;
						if(strcmp(field_name, "expand") == 0) return p->expand;
						if(strcmp(field_name, "shrink") == 0) return p->shrink;
						if(strcmp(field_name, "empty") == 0) return p->empty;
					}
				}
			]"
		end

end
