class
	SD_GTKTARGETENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create target.make
		end

feature {ANY} -- fields

	target: CE_POINTER [INTEGER_8] assign set_target

	flags: NATURAL_32 assign set_flags

	info: NATURAL_32 assign set_info

feature {ANY} -- setters

	set_target (a_target: CE_POINTER [INTEGER_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_info (a_info: NATURAL_32)
		do
			info := a_info
			update_memory_field ("info")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			target := a_other.target
			flags := a_other.flags
			info := a_other.info
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				target.is_equal (a_other.target) and
				flags = a_other.flags and
				info = a_other.info
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("info")
				>>)
			init_structure_info
		end

end
