class
	SD_GTKTOOLTIPSDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create tooltips.make
			create widget.make
			create tip_text.make
			create tip_private.make
		end

feature {ANY} -- fields

	tooltips: CE_POINTER [SD_GTKTOOLTIPS] assign set_tooltips

	widget: CE_POINTER [SD_GTKWIDGET] assign set_widget

	tip_text: CE_POINTER [INTEGER_8] assign set_tip_text

	tip_private: CE_POINTER [INTEGER_8] assign set_tip_private

feature {ANY} -- setters

	set_tooltips (a_tooltips: CE_POINTER [SD_GTKTOOLTIPS])
		do
			tooltips := a_tooltips
			update_memory_field ("tooltips")
		end

	set_widget (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			widget := a_widget
			update_memory_field ("widget")
		end

	set_tip_text (a_tip_text: CE_POINTER [INTEGER_8])
		do
			tip_text := a_tip_text
			update_memory_field ("tip_text")
		end

	set_tip_private (a_tip_private: CE_POINTER [INTEGER_8])
		do
			tip_private := a_tip_private
			update_memory_field ("tip_private")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tooltips := a_other.tooltips
			widget := a_other.widget
			tip_text := a_other.tip_text
			tip_private := a_other.tip_private
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tooltips.is_equal (a_other.tooltips) and
				widget.is_equal (a_other.widget) and
				tip_text.is_equal (a_other.tip_text) and
				tip_private.is_equal (a_other.tip_private)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tooltips"),
					create {CE_STRUCTURE_FIELD}.make ("widget"),
					create {CE_STRUCTURE_FIELD}.make ("tip_text"),
					create {CE_STRUCTURE_FIELD}.make ("tip_private")
				>>)
			init_structure_info
		end

end
