class
	SD_GTKWINDOWGROUP

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_instance.make
			create grabs.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	grabs: CE_POINTER [SD_GSLIST] assign set_grabs

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_grabs (a_grabs: CE_POINTER [SD_GSLIST])
		do
			grabs := a_grabs
			update_memory_field ("grabs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			grabs := a_other.grabs
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				grabs.is_equal (a_other.grabs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("grabs")
				>>)
			init_structure_info
		end

end
