class
	SD_ICEREPLYWAITINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create reply.make
		end

feature {ANY} -- fields

	sequence_of_request: NATURAL_32 assign set_sequence_of_request

	major_opcode_of_request: INTEGER_32 assign set_major_opcode_of_request

	minor_opcode_of_request: INTEGER_32 assign set_minor_opcode_of_request

	reply: CE_POINTER [ANY] assign set_reply

feature {ANY} -- setters

	set_sequence_of_request (a_sequence_of_request: NATURAL_32)
		do
			sequence_of_request := a_sequence_of_request
			update_memory_field ("sequence_of_request")
		end

	set_major_opcode_of_request (a_major_opcode_of_request: INTEGER_32)
		do
			major_opcode_of_request := a_major_opcode_of_request
			update_memory_field ("major_opcode_of_request")
		end

	set_minor_opcode_of_request (a_minor_opcode_of_request: INTEGER_32)
		do
			minor_opcode_of_request := a_minor_opcode_of_request
			update_memory_field ("minor_opcode_of_request")
		end

	set_reply (a_reply: CE_POINTER [ANY])
		do
			reply := a_reply
			update_memory_field ("reply")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sequence_of_request := a_other.sequence_of_request
			major_opcode_of_request := a_other.major_opcode_of_request
			minor_opcode_of_request := a_other.minor_opcode_of_request
			reply := a_other.reply
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sequence_of_request = a_other.sequence_of_request and
				major_opcode_of_request = a_other.major_opcode_of_request and
				minor_opcode_of_request = a_other.minor_opcode_of_request and
				reply.is_equal (a_other.reply)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sequence_of_request"),
					create {CE_STRUCTURE_FIELD}.make ("major_opcode_of_request"),
					create {CE_STRUCTURE_FIELD}.make ("minor_opcode_of_request"),
					create {CE_STRUCTURE_FIELD}.make ("reply")
				>>)
			init_structure_info
		end

end
