class
	SD_PANGOGLYPHINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create geometry.make
			create attr.make
		end

feature {ANY} -- fields

	glyph: NATURAL_32 assign set_glyph

	geometry: SD_PANGOGLYPHGEOMETRY assign set_geometry

	attr: SD_PANGOGLYPHVISATTR assign set_attr

feature {ANY} -- setters

	set_glyph (a_glyph: NATURAL_32)
		do
			glyph := a_glyph
			update_memory_field ("glyph")
		end

	set_geometry (a_geometry: SD_PANGOGLYPHGEOMETRY)
		do
			geometry := a_geometry
			update_memory_field ("geometry")
		end

	set_attr (a_attr: SD_PANGOGLYPHVISATTR)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			glyph := a_other.glyph
			geometry := a_other.geometry.twin
			attr := a_other.attr.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				glyph = a_other.glyph and
				geometry.is_equal (a_other.geometry) and
				attr.is_equal (a_other.attr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("glyph"),
					create {CE_STRUCTURE_FIELD}.make ("geometry"),
					create {CE_STRUCTURE_FIELD}.make ("attr")
				>>)
			init_structure_info
		end

end
