class
	SD_PANGOITEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create analysis.make
		end

feature {ANY} -- fields

	offset: INTEGER_32 assign set_offset

	length: INTEGER_32 assign set_length

	num_chars: INTEGER_32 assign set_num_chars

	analysis: SD_PANGOANALYSIS assign set_analysis

feature {ANY} -- setters

	set_offset (a_offset: INTEGER_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_num_chars (a_num_chars: INTEGER_32)
		do
			num_chars := a_num_chars
			update_memory_field ("num_chars")
		end

	set_analysis (a_analysis: SD_PANGOANALYSIS)
		do
			analysis := a_analysis
			update_memory_field ("analysis")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			offset := a_other.offset
			length := a_other.length
			num_chars := a_other.num_chars
			analysis := a_other.analysis.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				offset = a_other.offset and
				length = a_other.length and
				num_chars = a_other.num_chars and
				analysis.is_equal (a_other.analysis)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("offset"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("num_chars"),
					create {CE_STRUCTURE_FIELD}.make ("analysis")
				>>)
			init_structure_info
		end

end
