class
	SD_SIFIELDS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	pad: CE_ARRAY [INTEGER_32]

	kill: SD_KILL assign set_kill

	timer: SD_TIMER assign set_timer

	rt: SD_RT assign set_rt

	sigchld: SD_SIGCHLD assign set_sigchld

	sigfault: SD_SIGFAULT assign set_sigfault

	sigpoll: SD_SIGPOLL assign set_sigpoll

feature {ANY} -- setters

	set_kill (a_kill: SD_KILL)
		do
			kill := a_kill
			update_memory_field ("kill")
		end

	set_timer (a_timer: SD_TIMER)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

	set_rt (a_rt: SD_RT)
		do
			rt := a_rt
			update_memory_field ("rt")
		end

	set_sigchld (a_sigchld: SD_SIGCHLD)
		do
			sigchld := a_sigchld
			update_memory_field ("sigchld")
		end

	set_sigfault (a_sigfault: SD_SIGFAULT)
		do
			sigfault := a_sigfault
			update_memory_field ("sigfault")
		end

	set_sigpoll (a_sigpoll: SD_SIGPOLL)
		do
			sigpoll := a_sigpoll
			update_memory_field ("sigpoll")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pad := a_other.pad.twin
			kill := a_other.kill.twin
			timer := a_other.timer.twin
			rt := a_other.rt.twin
			sigchld := a_other.sigchld.twin
			sigfault := a_other.sigfault.twin
			sigpoll := a_other.sigpoll.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pad.is_equal (a_other.pad) and
				kill.is_equal (a_other.kill) and
				timer.is_equal (a_other.timer) and
				rt.is_equal (a_other.rt) and
				sigchld.is_equal (a_other.sigchld) and
				sigfault.is_equal (a_other.sigfault) and
				sigpoll.is_equal (a_other.sigpoll)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pad", <<({NATURAL_32} 128 // {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 3).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("kill"),
					create {CE_STRUCTURE_FIELD}.make ("timer"),
					create {CE_STRUCTURE_FIELD}.make ("rt"),
					create {CE_STRUCTURE_FIELD}.make ("sigchld"),
					create {CE_STRUCTURE_FIELD}.make ("sigfault"),
					create {CE_STRUCTURE_FIELD}.make ("sigpoll")
				>>)
			init_structure_info
		end

end
