class
	SD_SMCCALLBACKS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create save_yourself.make
			create die.make
			create save_complete.make
			create shutdown_cancelled.make
		end

feature {ANY} -- fields

	save_yourself: SD_SAVE_YOURSELF assign set_save_yourself

	die: SD_DIE assign set_die

	save_complete: SD_SAVE_COMPLETE assign set_save_complete

	shutdown_cancelled: SD_SHUTDOWN_CANCELLED assign set_shutdown_cancelled

feature {ANY} -- setters

	set_save_yourself (a_save_yourself: SD_SAVE_YOURSELF)
		do
			save_yourself := a_save_yourself
			update_memory_field ("save_yourself")
		end

	set_die (a_die: SD_DIE)
		do
			die := a_die
			update_memory_field ("die")
		end

	set_save_complete (a_save_complete: SD_SAVE_COMPLETE)
		do
			save_complete := a_save_complete
			update_memory_field ("save_complete")
		end

	set_shutdown_cancelled (a_shutdown_cancelled: SD_SHUTDOWN_CANCELLED)
		do
			shutdown_cancelled := a_shutdown_cancelled
			update_memory_field ("shutdown_cancelled")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			save_yourself := a_other.save_yourself.twin
			die := a_other.die.twin
			save_complete := a_other.save_complete.twin
			shutdown_cancelled := a_other.shutdown_cancelled.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				save_yourself.is_equal (a_other.save_yourself) and
				die.is_equal (a_other.die) and
				save_complete.is_equal (a_other.save_complete) and
				shutdown_cancelled.is_equal (a_other.shutdown_cancelled)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("save_yourself"),
					create {CE_STRUCTURE_FIELD}.make ("die"),
					create {CE_STRUCTURE_FIELD}.make ("save_complete"),
					create {CE_STRUCTURE_FIELD}.make ("shutdown_cancelled")
				>>)
			init_structure_info
		end

end
