class
	SD_XGENERICEVENTCOOKIE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create display.make
			create data.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	extension: INTEGER_32 assign set_extension

	evtype: INTEGER_32 assign set_evtype

	cookie: NATURAL_32 assign set_cookie

	data: CE_POINTER [ANY] assign set_data

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_extension (a_extension: INTEGER_32)
		do
			extension := a_extension
			update_memory_field ("extension")
		end

	set_evtype (a_evtype: INTEGER_32)
		do
			evtype := a_evtype
			update_memory_field ("evtype")
		end

	set_cookie (a_cookie: NATURAL_32)
		do
			cookie := a_cookie
			update_memory_field ("cookie")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			extension := a_other.extension
			evtype := a_other.evtype
			cookie := a_other.cookie
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				extension = a_other.extension and
				evtype = a_other.evtype and
				cookie = a_other.cookie and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("extension"),
					create {CE_STRUCTURE_FIELD}.make ("evtype"),
					create {CE_STRUCTURE_FIELD}.make ("cookie"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
