class
	SD_XSIZEHINTS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create min_aspect.make
			create max_aspect.make
		end

feature {ANY} -- fields

	flags: INTEGER_32 assign set_flags

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	width: INTEGER_32 assign set_width

	height: INTEGER_32 assign set_height

	min_width: INTEGER_32 assign set_min_width

	min_height: INTEGER_32 assign set_min_height

	max_width: INTEGER_32 assign set_max_width

	max_height: INTEGER_32 assign set_max_height

	width_inc: INTEGER_32 assign set_width_inc

	height_inc: INTEGER_32 assign set_height_inc

	min_aspect: SD_MIN_ASPECT assign set_min_aspect

	max_aspect: SD_MIN_ASPECT assign set_max_aspect

	base_width: INTEGER_32 assign set_base_width

	base_height: INTEGER_32 assign set_base_height

	win_gravity: INTEGER_32 assign set_win_gravity

feature {ANY} -- setters

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_min_width (a_min_width: INTEGER_32)
		do
			min_width := a_min_width
			update_memory_field ("min_width")
		end

	set_min_height (a_min_height: INTEGER_32)
		do
			min_height := a_min_height
			update_memory_field ("min_height")
		end

	set_max_width (a_max_width: INTEGER_32)
		do
			max_width := a_max_width
			update_memory_field ("max_width")
		end

	set_max_height (a_max_height: INTEGER_32)
		do
			max_height := a_max_height
			update_memory_field ("max_height")
		end

	set_width_inc (a_width_inc: INTEGER_32)
		do
			width_inc := a_width_inc
			update_memory_field ("width_inc")
		end

	set_height_inc (a_height_inc: INTEGER_32)
		do
			height_inc := a_height_inc
			update_memory_field ("height_inc")
		end

	set_min_aspect (a_min_aspect: SD_MIN_ASPECT)
		do
			min_aspect := a_min_aspect
			update_memory_field ("min_aspect")
		end

	set_max_aspect (a_max_aspect: SD_MIN_ASPECT)
		do
			max_aspect := a_max_aspect
			update_memory_field ("max_aspect")
		end

	set_base_width (a_base_width: INTEGER_32)
		do
			base_width := a_base_width
			update_memory_field ("base_width")
		end

	set_base_height (a_base_height: INTEGER_32)
		do
			base_height := a_base_height
			update_memory_field ("base_height")
		end

	set_win_gravity (a_win_gravity: INTEGER_32)
		do
			win_gravity := a_win_gravity
			update_memory_field ("win_gravity")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			flags := a_other.flags
			x := a_other.x
			y := a_other.y
			width := a_other.width
			height := a_other.height
			min_width := a_other.min_width
			min_height := a_other.min_height
			max_width := a_other.max_width
			max_height := a_other.max_height
			width_inc := a_other.width_inc
			height_inc := a_other.height_inc
			min_aspect := a_other.min_aspect.twin
			max_aspect := a_other.max_aspect.twin
			base_width := a_other.base_width
			base_height := a_other.base_height
			win_gravity := a_other.win_gravity
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				flags = a_other.flags and
				x = a_other.x and
				y = a_other.y and
				width = a_other.width and
				height = a_other.height and
				min_width = a_other.min_width and
				min_height = a_other.min_height and
				max_width = a_other.max_width and
				max_height = a_other.max_height and
				width_inc = a_other.width_inc and
				height_inc = a_other.height_inc and
				min_aspect.is_equal (a_other.min_aspect) and
				max_aspect.is_equal (a_other.max_aspect) and
				base_width = a_other.base_width and
				base_height = a_other.base_height and
				win_gravity = a_other.win_gravity
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("min_width"),
					create {CE_STRUCTURE_FIELD}.make ("min_height"),
					create {CE_STRUCTURE_FIELD}.make ("max_width"),
					create {CE_STRUCTURE_FIELD}.make ("max_height"),
					create {CE_STRUCTURE_FIELD}.make ("width_inc"),
					create {CE_STRUCTURE_FIELD}.make ("height_inc"),
					create {CE_STRUCTURE_FIELD}.make ("min_aspect"),
					create {CE_STRUCTURE_FIELD}.make ("max_aspect"),
					create {CE_STRUCTURE_FIELD}.make ("base_width"),
					create {CE_STRUCTURE_FIELD}.make ("base_height"),
					create {CE_STRUCTURE_FIELD}.make ("win_gravity")
				>>)
			init_structure_info
		end

end
