deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	abs (a___x: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return abs($a___x);"
		end

	atoi (a___nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atoi (a___nptr.c_pointer)
		end

	c_atoi (a___nptr: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return atoi($a___nptr);"
		end

	atol (a___nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atol (a___nptr.c_pointer)
		end

	c_atol (a___nptr: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return atol($a___nptr);"
		end

	exit (a___status: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"exit($a___status);"
		end

	free (a___ptr: CE_POINTER [ANY])
		do
			c_free (a___ptr.c_pointer)
		end

	c_free (a___ptr: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"free($a___ptr);"
		end

	getenv (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getenv (a___name.c_pointer))
		end

	c_getenv (a___name: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return getenv($a___name);"
		end

	grantpt (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return grantpt($a___fd);"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	mblen (a___s: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_mblen (a___s.c_pointer, a___n)
		end

	c_mblen (a___s: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return mblen($a___s, $a___n);"
		end

	mkdtemp (a___template: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_mkdtemp (a___template.c_pointer))
		end

	c_mkdtemp (a___template: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return mkdtemp($a___template);"
		end

	ptsname (a___fd: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_ptsname (a___fd))
		end

	c_ptsname (a___fd: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return ptsname($a___fd);"
		end

	qsort (a___base: CE_POINTER [ANY]; a___nmemb: NATURAL_32; a___size: NATURAL_32; a___compar: CE_ROUTINE)
		do
			c_qsort (a___base.c_pointer, a___nmemb, a___size, a___compar.c_pointer)
		end

	c_qsort (a___base: POINTER; a___nmemb: NATURAL_32; a___size: NATURAL_32; a___compar: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"qsort($a___base, $a___nmemb, $a___size, $a___compar);"
		end

	rand: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return rand();"
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	setenv (a___name: CE_POINTER [INTEGER_8]; a___value: CE_POINTER [INTEGER_8]; a___replace: INTEGER_32): INTEGER_32
		do
			Result := c_setenv (a___name.c_pointer, a___value.c_pointer, a___replace)
		end

	c_setenv (a___name: POINTER; a___value: POINTER; a___replace: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return setenv($a___name, $a___value, $a___replace);"
		end

	srand (a___seed: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"srand($a___seed);"
		end

	strtod (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): REAL_64
		do
			Result := c_strtod (a___nptr.c_pointer, a___endptr.c_pointer)
		end

	c_strtod (a___nptr: POINTER; a___endptr: POINTER): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return strtod($a___nptr, $a___endptr);"
		end

	strtol (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a___base: INTEGER_32): INTEGER_32
		do
			Result := c_strtol (a___nptr.c_pointer, a___endptr.c_pointer, a___base)
		end

	c_strtol (a___nptr: POINTER; a___endptr: POINTER; a___base: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return strtol($a___nptr, $a___endptr, $a___base);"
		end

	unlockpt (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return unlockpt($a___fd);"
		end

end
