class
	PD_ADDRENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	ina4: SD_IN_ADDR assign set_ina4

	ina6: SD_IN6_ADDR assign set_ina6

feature {ANY} -- setters

	set_ina4 (a_ina4: SD_IN_ADDR)
		do
			ina4 := a_ina4
			update_memory_field ("ina4")
		end

	set_ina6 (a_ina6: SD_IN6_ADDR)
		do
			ina6 := a_ina6
			update_memory_field ("ina6")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ina4 := a_other.ina4.twin
			ina6 := a_other.ina6.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ina4.is_equal (a_other.ina4) and
				ina6.is_equal (a_other.ina6)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("ina4"),
					create {CE_STRUCTURE_FIELD}.make ("ina6")
				>>)
			init_structure_info
		end

end
