class
	PD_AUTH

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	want: INTEGER_32 assign set_want

	picked: INTEGER_32 assign set_picked

	avail: INTEGER_32 assign set_avail

	done: BOOLEAN assign set_done

	multi: BOOLEAN assign set_multi

	iestyle: BOOLEAN assign set_iestyle

feature {ANY} -- setters

	set_want (a_want: INTEGER_32)
		do
			want := a_want
			update_memory_field ("want")
		end

	set_picked (a_picked: INTEGER_32)
		do
			picked := a_picked
			update_memory_field ("picked")
		end

	set_avail (a_avail: INTEGER_32)
		do
			avail := a_avail
			update_memory_field ("avail")
		end

	set_done (a_done: BOOLEAN)
		do
			done := a_done
			update_memory_field ("done")
		end

	set_multi (a_multi: BOOLEAN)
		do
			multi := a_multi
			update_memory_field ("multi")
		end

	set_iestyle (a_iestyle: BOOLEAN)
		do
			iestyle := a_iestyle
			update_memory_field ("iestyle")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			want := a_other.want
			picked := a_other.picked
			avail := a_other.avail
			done := a_other.done
			multi := a_other.multi
			iestyle := a_other.iestyle
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				want = a_other.want and
				picked = a_other.picked and
				avail = a_other.avail and
				done = a_other.done and
				multi = a_other.multi and
				iestyle = a_other.iestyle
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("want"),
					create {CE_STRUCTURE_FIELD}.make ("picked"),
					create {CE_STRUCTURE_FIELD}.make ("avail"),
					create {CE_STRUCTURE_FIELD}.make ("done"),
					create {CE_STRUCTURE_FIELD}.make ("multi"),
					create {CE_STRUCTURE_FIELD}.make ("iestyle")
				>>)
			init_structure_info
		end

end
