class
	PD_CONNCACHE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create connects.make
		end

feature {ANY} -- fields

	connects: CE_POINTER [CE_POINTER [PD_CONNECTDATA]] assign set_connects

	num: INTEGER_32 assign set_num

	type: NATURAL_32 assign set_type

feature {ANY} -- setters

	set_connects (a_connects: CE_POINTER [CE_POINTER [PD_CONNECTDATA]])
		do
			connects := a_connects
			update_memory_field ("connects")
		end

	set_num (a_num: INTEGER_32)
		do
			num := a_num
			update_memory_field ("num")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			connects := a_other.connects
			num := a_other.num
			type := a_other.type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				connects.is_equal (a_other.connects) and
				num = a_other.num and
				type = a_other.type
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("connects"),
					create {CE_STRUCTURE_FIELD}.make ("num"),
					create {CE_STRUCTURE_FIELD}.make ("type")
				>>)
			init_structure_info
		end

end
