class
	PD_CURL_HANDLER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create scheme.make
			create setup_connection.make
			create do_it.make
			create done.make
			create do_more.make
			create connect_it.make
			create connecting.make
			create doing.make
			create proto_getsock.make
			create doing_getsock.make
			create perform_getsock.make
			create disconnect.make
		end

feature {ANY} -- fields

	scheme: CE_POINTER [INTEGER_8] assign set_scheme

	setup_connection: CE_ROUTINE assign set_setup_connection

	do_it: CE_ROUTINE assign set_do_it

	done: CE_ROUTINE assign set_done

	do_more: CE_ROUTINE assign set_do_more

	connect_it: CE_ROUTINE assign set_connect_it

	connecting: CE_ROUTINE assign set_connecting

	doing: CE_ROUTINE assign set_doing

	proto_getsock: CE_ROUTINE assign set_proto_getsock

	doing_getsock: CE_ROUTINE assign set_doing_getsock

	perform_getsock: CE_ROUTINE assign set_perform_getsock

	disconnect: CE_ROUTINE assign set_disconnect

	defport: INTEGER_32 assign set_defport

	protocol: INTEGER_32 assign set_protocol

feature {ANY} -- setters

	set_scheme (a_scheme: CE_POINTER [INTEGER_8])
		do
			scheme := a_scheme
			update_memory_field ("scheme")
		end

	set_setup_connection (a_setup_connection: CE_ROUTINE)
		do
			setup_connection := a_setup_connection
			update_memory_field ("setup_connection")
		end

	set_do_it (a_do_it: CE_ROUTINE)
		do
			do_it := a_do_it
			update_memory_field ("do_it")
		end

	set_done (a_done: CE_ROUTINE)
		do
			done := a_done
			update_memory_field ("done")
		end

	set_do_more (a_do_more: CE_ROUTINE)
		do
			do_more := a_do_more
			update_memory_field ("do_more")
		end

	set_connect_it (a_connect_it: CE_ROUTINE)
		do
			connect_it := a_connect_it
			update_memory_field ("connect_it")
		end

	set_connecting (a_connecting: CE_ROUTINE)
		do
			connecting := a_connecting
			update_memory_field ("connecting")
		end

	set_doing (a_doing: CE_ROUTINE)
		do
			doing := a_doing
			update_memory_field ("doing")
		end

	set_proto_getsock (a_proto_getsock: CE_ROUTINE)
		do
			proto_getsock := a_proto_getsock
			update_memory_field ("proto_getsock")
		end

	set_doing_getsock (a_doing_getsock: CE_ROUTINE)
		do
			doing_getsock := a_doing_getsock
			update_memory_field ("doing_getsock")
		end

	set_perform_getsock (a_perform_getsock: CE_ROUTINE)
		do
			perform_getsock := a_perform_getsock
			update_memory_field ("perform_getsock")
		end

	set_disconnect (a_disconnect: CE_ROUTINE)
		do
			disconnect := a_disconnect
			update_memory_field ("disconnect")
		end

	set_defport (a_defport: INTEGER_32)
		do
			defport := a_defport
			update_memory_field ("defport")
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			protocol := a_protocol
			update_memory_field ("protocol")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			scheme := a_other.scheme
			setup_connection := a_other.setup_connection
			do_it := a_other.do_it
			done := a_other.done
			do_more := a_other.do_more
			connect_it := a_other.connect_it
			connecting := a_other.connecting
			doing := a_other.doing
			proto_getsock := a_other.proto_getsock
			doing_getsock := a_other.doing_getsock
			perform_getsock := a_other.perform_getsock
			disconnect := a_other.disconnect
			defport := a_other.defport
			protocol := a_other.protocol
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				scheme.is_equal (a_other.scheme) and
				setup_connection.is_equal (a_other.setup_connection) and
				do_it.is_equal (a_other.do_it) and
				done.is_equal (a_other.done) and
				do_more.is_equal (a_other.do_more) and
				connect_it.is_equal (a_other.connect_it) and
				connecting.is_equal (a_other.connecting) and
				doing.is_equal (a_other.doing) and
				proto_getsock.is_equal (a_other.proto_getsock) and
				doing_getsock.is_equal (a_other.doing_getsock) and
				perform_getsock.is_equal (a_other.perform_getsock) and
				disconnect.is_equal (a_other.disconnect) and
				defport = a_other.defport and
				protocol = a_other.protocol
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("scheme"),
					create {CE_STRUCTURE_FIELD}.make ("setup_connection"),
					create {CE_STRUCTURE_FIELD}.make ("do_it"),
					create {CE_STRUCTURE_FIELD}.make ("done"),
					create {CE_STRUCTURE_FIELD}.make ("do_more"),
					create {CE_STRUCTURE_FIELD}.make ("connect_it"),
					create {CE_STRUCTURE_FIELD}.make ("connecting"),
					create {CE_STRUCTURE_FIELD}.make ("doing"),
					create {CE_STRUCTURE_FIELD}.make ("proto_getsock"),
					create {CE_STRUCTURE_FIELD}.make ("doing_getsock"),
					create {CE_STRUCTURE_FIELD}.make ("perform_getsock"),
					create {CE_STRUCTURE_FIELD}.make ("disconnect"),
					create {CE_STRUCTURE_FIELD}.make ("defport"),
					create {CE_STRUCTURE_FIELD}.make ("protocol")
				>>)
			init_structure_info
		end

end
