class
	PD_CURL_HASH

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create table.make
			create hash_func.make
			create comp_func.make
			create dtor.make
		end

feature {ANY} -- fields

	table: CE_POINTER [CE_POINTER [PD_CURL_LLIST]] assign set_table

	hash_func: CE_ROUTINE assign set_hash_func

	comp_func: CE_ROUTINE assign set_comp_func

	dtor: CE_ROUTINE assign set_dtor

	slots: INTEGER_32 assign set_slots

	size: NATURAL_32 assign set_size

feature {ANY} -- setters

	set_table (a_table: CE_POINTER [CE_POINTER [PD_CURL_LLIST]])
		do
			table := a_table
			update_memory_field ("table")
		end

	set_hash_func (a_hash_func: CE_ROUTINE)
		do
			hash_func := a_hash_func
			update_memory_field ("hash_func")
		end

	set_comp_func (a_comp_func: CE_ROUTINE)
		do
			comp_func := a_comp_func
			update_memory_field ("comp_func")
		end

	set_dtor (a_dtor: CE_ROUTINE)
		do
			dtor := a_dtor
			update_memory_field ("dtor")
		end

	set_slots (a_slots: INTEGER_32)
		do
			slots := a_slots
			update_memory_field ("slots")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			table := a_other.table
			hash_func := a_other.hash_func
			comp_func := a_other.comp_func
			dtor := a_other.dtor
			slots := a_other.slots
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				table.is_equal (a_other.table) and
				hash_func.is_equal (a_other.hash_func) and
				comp_func.is_equal (a_other.comp_func) and
				dtor.is_equal (a_other.dtor) and
				slots = a_other.slots and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("table"),
					create {CE_STRUCTURE_FIELD}.make ("hash_func"),
					create {CE_STRUCTURE_FIELD}.make ("comp_func"),
					create {CE_STRUCTURE_FIELD}.make ("dtor"),
					create {CE_STRUCTURE_FIELD}.make ("slots"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
