class
	PD_CURLMSG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create easy_handle.make
			create data.make
		end

feature {ANY} -- fields

	msg: NATURAL_32 assign set_msg

	easy_handle: CE_POINTER [ANY] assign set_easy_handle

	data: PD_DATA2 assign set_data

feature {ANY} -- setters

	set_msg (a_msg: NATURAL_32)
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_easy_handle (a_easy_handle: CE_POINTER [ANY])
		do
			easy_handle := a_easy_handle
			update_memory_field ("easy_handle")
		end

	set_data (a_data: PD_DATA2)
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			msg := a_other.msg
			easy_handle := a_other.easy_handle
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				msg = a_other.msg and
				easy_handle.is_equal (a_other.easy_handle) and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make ("easy_handle"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
