class
	PD_DYNAMICALLY_ALLOCATED_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create proxyuserpwd.make
			create uagent.make
			create accept_encoding.make
			create userpwd.make
			create rangeline.make
			create ref.make
			create host.make
			create cookiehost.make
			create rtsp_transport.make
		end

feature {ANY} -- fields

	proxyuserpwd: CE_POINTER [INTEGER_8] assign set_proxyuserpwd

	uagent: CE_POINTER [INTEGER_8] assign set_uagent

	accept_encoding: CE_POINTER [INTEGER_8] assign set_accept_encoding

	userpwd: CE_POINTER [INTEGER_8] assign set_userpwd

	rangeline: CE_POINTER [INTEGER_8] assign set_rangeline

	ref: CE_POINTER [INTEGER_8] assign set_ref

	host: CE_POINTER [INTEGER_8] assign set_host

	cookiehost: CE_POINTER [INTEGER_8] assign set_cookiehost

	rtsp_transport: CE_POINTER [INTEGER_8] assign set_rtsp_transport

feature {ANY} -- setters

	set_proxyuserpwd (a_proxyuserpwd: CE_POINTER [INTEGER_8])
		do
			proxyuserpwd := a_proxyuserpwd
			update_memory_field ("proxyuserpwd")
		end

	set_uagent (a_uagent: CE_POINTER [INTEGER_8])
		do
			uagent := a_uagent
			update_memory_field ("uagent")
		end

	set_accept_encoding (a_accept_encoding: CE_POINTER [INTEGER_8])
		do
			accept_encoding := a_accept_encoding
			update_memory_field ("accept_encoding")
		end

	set_userpwd (a_userpwd: CE_POINTER [INTEGER_8])
		do
			userpwd := a_userpwd
			update_memory_field ("userpwd")
		end

	set_rangeline (a_rangeline: CE_POINTER [INTEGER_8])
		do
			rangeline := a_rangeline
			update_memory_field ("rangeline")
		end

	set_ref (a_ref: CE_POINTER [INTEGER_8])
		do
			ref := a_ref
			update_memory_field ("ref")
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_cookiehost (a_cookiehost: CE_POINTER [INTEGER_8])
		do
			cookiehost := a_cookiehost
			update_memory_field ("cookiehost")
		end

	set_rtsp_transport (a_rtsp_transport: CE_POINTER [INTEGER_8])
		do
			rtsp_transport := a_rtsp_transport
			update_memory_field ("rtsp_transport")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			proxyuserpwd := a_other.proxyuserpwd
			uagent := a_other.uagent
			accept_encoding := a_other.accept_encoding
			userpwd := a_other.userpwd
			rangeline := a_other.rangeline
			ref := a_other.ref
			host := a_other.host
			cookiehost := a_other.cookiehost
			rtsp_transport := a_other.rtsp_transport
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				proxyuserpwd.is_equal (a_other.proxyuserpwd) and
				uagent.is_equal (a_other.uagent) and
				accept_encoding.is_equal (a_other.accept_encoding) and
				userpwd.is_equal (a_other.userpwd) and
				rangeline.is_equal (a_other.rangeline) and
				ref.is_equal (a_other.ref) and
				host.is_equal (a_other.host) and
				cookiehost.is_equal (a_other.cookiehost) and
				rtsp_transport.is_equal (a_other.rtsp_transport)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("proxyuserpwd"),
					create {CE_STRUCTURE_FIELD}.make ("uagent"),
					create {CE_STRUCTURE_FIELD}.make ("accept_encoding"),
					create {CE_STRUCTURE_FIELD}.make ("userpwd"),
					create {CE_STRUCTURE_FIELD}.make ("rangeline"),
					create {CE_STRUCTURE_FIELD}.make ("ref"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("cookiehost"),
					create {CE_STRUCTURE_FIELD}.make ("rtsp_transport")
				>>)
			init_structure_info
		end

end
