class
	PD_DYNAMICSTATIC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create url.make
			create referer.make
			create cookielist.make
		end

feature {ANY} -- fields

	url: CE_POINTER [INTEGER_8] assign set_url

	url_alloc: BOOLEAN assign set_url_alloc

	referer: CE_POINTER [INTEGER_8] assign set_referer

	referer_alloc: BOOLEAN assign set_referer_alloc

	cookielist: CE_POINTER [PD_CURL_SLIST] assign set_cookielist

feature {ANY} -- setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_url_alloc (a_url_alloc: BOOLEAN)
		do
			url_alloc := a_url_alloc
			update_memory_field ("url_alloc")
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			referer := a_referer
			update_memory_field ("referer")
		end

	set_referer_alloc (a_referer_alloc: BOOLEAN)
		do
			referer_alloc := a_referer_alloc
			update_memory_field ("referer_alloc")
		end

	set_cookielist (a_cookielist: CE_POINTER [PD_CURL_SLIST])
		do
			cookielist := a_cookielist
			update_memory_field ("cookielist")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			url := a_other.url
			url_alloc := a_other.url_alloc
			referer := a_other.referer
			referer_alloc := a_other.referer_alloc
			cookielist := a_other.cookielist
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				url.is_equal (a_other.url) and
				url_alloc = a_other.url_alloc and
				referer.is_equal (a_other.referer) and
				referer_alloc = a_other.referer_alloc and
				cookielist.is_equal (a_other.cookielist)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("url_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("referer"),
					create {CE_STRUCTURE_FIELD}.make ("referer_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("cookielist")
				>>)
			init_structure_info
		end

end
