class
	PD_FORM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create fp.make
			create fread_func.make
		end

feature {ANY} -- fields

	data: CE_POINTER [PD_FORMDATA] assign set_data

	sent: NATURAL_32 assign set_sent

	fp: CE_POINTER [SD_IO_FILE] assign set_fp

	fread_func: CE_ROUTINE assign set_fread_func

feature {ANY} -- setters

	set_data (a_data: CE_POINTER [PD_FORMDATA])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_sent (a_sent: NATURAL_32)
		do
			sent := a_sent
			update_memory_field ("sent")
		end

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			fp := a_fp
			update_memory_field ("fp")
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			fread_func := a_fread_func
			update_memory_field ("fread_func")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			sent := a_other.sent
			fp := a_other.fp
			fread_func := a_other.fread_func
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				sent = a_other.sent and
				fp.is_equal (a_other.fp) and
				fread_func.is_equal (a_other.fread_func)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("sent"),
					create {CE_STRUCTURE_FIELD}.make ("fp"),
					create {CE_STRUCTURE_FIELD}.make ("fread_func")
				>>)
			init_structure_info
		end

end
