class
	PD_FTP_CONN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pp.make
			create entrypath.make
			create dirs.make
			create file.make
			create prevpath.make
			create server_os.make
		end

feature {ANY} -- fields

	pp: PD_PINGPONG assign set_pp

	entrypath: CE_POINTER [INTEGER_8] assign set_entrypath

	dirs: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_dirs

	dirdepth: INTEGER_32 assign set_dirdepth

	diralloc: INTEGER_32 assign set_diralloc

	file: CE_POINTER [INTEGER_8] assign set_file

	dont_check: BOOLEAN assign set_dont_check

	ctl_valid: BOOLEAN assign set_ctl_valid

	cwddone: BOOLEAN assign set_cwddone

	cwdfail: BOOLEAN assign set_cwdfail

	prevpath: CE_POINTER [INTEGER_8] assign set_prevpath

	transfertype: INTEGER_8 assign set_transfertype

	count1: INTEGER_32 assign set_count1

	count2: INTEGER_32 assign set_count2

	count3: INTEGER_32 assign set_count3

	state: NATURAL_32 assign set_state

	server_os: CE_POINTER [INTEGER_8] assign set_server_os

	known_filesize: INTEGER_64 assign set_known_filesize

feature {ANY} -- setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp := a_pp
			update_memory_field ("pp")
		end

	set_entrypath (a_entrypath: CE_POINTER [INTEGER_8])
		do
			entrypath := a_entrypath
			update_memory_field ("entrypath")
		end

	set_dirs (a_dirs: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			dirs := a_dirs
			update_memory_field ("dirs")
		end

	set_dirdepth (a_dirdepth: INTEGER_32)
		do
			dirdepth := a_dirdepth
			update_memory_field ("dirdepth")
		end

	set_diralloc (a_diralloc: INTEGER_32)
		do
			diralloc := a_diralloc
			update_memory_field ("diralloc")
		end

	set_file (a_file: CE_POINTER [INTEGER_8])
		do
			file := a_file
			update_memory_field ("file")
		end

	set_dont_check (a_dont_check: BOOLEAN)
		do
			dont_check := a_dont_check
			update_memory_field ("dont_check")
		end

	set_ctl_valid (a_ctl_valid: BOOLEAN)
		do
			ctl_valid := a_ctl_valid
			update_memory_field ("ctl_valid")
		end

	set_cwddone (a_cwddone: BOOLEAN)
		do
			cwddone := a_cwddone
			update_memory_field ("cwddone")
		end

	set_cwdfail (a_cwdfail: BOOLEAN)
		do
			cwdfail := a_cwdfail
			update_memory_field ("cwdfail")
		end

	set_prevpath (a_prevpath: CE_POINTER [INTEGER_8])
		do
			prevpath := a_prevpath
			update_memory_field ("prevpath")
		end

	set_transfertype (a_transfertype: INTEGER_8)
		do
			transfertype := a_transfertype
			update_memory_field ("transfertype")
		end

	set_count1 (a_count1: INTEGER_32)
		do
			count1 := a_count1
			update_memory_field ("count1")
		end

	set_count2 (a_count2: INTEGER_32)
		do
			count2 := a_count2
			update_memory_field ("count2")
		end

	set_count3 (a_count3: INTEGER_32)
		do
			count3 := a_count3
			update_memory_field ("count3")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_server_os (a_server_os: CE_POINTER [INTEGER_8])
		do
			server_os := a_server_os
			update_memory_field ("server_os")
		end

	set_known_filesize (a_known_filesize: INTEGER_64)
		do
			known_filesize := a_known_filesize
			update_memory_field ("known_filesize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pp := a_other.pp.twin
			entrypath := a_other.entrypath
			dirs := a_other.dirs
			dirdepth := a_other.dirdepth
			diralloc := a_other.diralloc
			file := a_other.file
			dont_check := a_other.dont_check
			ctl_valid := a_other.ctl_valid
			cwddone := a_other.cwddone
			cwdfail := a_other.cwdfail
			prevpath := a_other.prevpath
			transfertype := a_other.transfertype
			count1 := a_other.count1
			count2 := a_other.count2
			count3 := a_other.count3
			state := a_other.state
			server_os := a_other.server_os
			known_filesize := a_other.known_filesize
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pp.is_equal (a_other.pp) and
				entrypath.is_equal (a_other.entrypath) and
				dirs.is_equal (a_other.dirs) and
				dirdepth = a_other.dirdepth and
				diralloc = a_other.diralloc and
				file.is_equal (a_other.file) and
				dont_check = a_other.dont_check and
				ctl_valid = a_other.ctl_valid and
				cwddone = a_other.cwddone and
				cwdfail = a_other.cwdfail and
				prevpath.is_equal (a_other.prevpath) and
				transfertype = a_other.transfertype and
				count1 = a_other.count1 and
				count2 = a_other.count2 and
				count3 = a_other.count3 and
				state = a_other.state and
				server_os.is_equal (a_other.server_os) and
				known_filesize = a_other.known_filesize
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pp"),
					create {CE_STRUCTURE_FIELD}.make ("entrypath"),
					create {CE_STRUCTURE_FIELD}.make ("dirs"),
					create {CE_STRUCTURE_FIELD}.make ("dirdepth"),
					create {CE_STRUCTURE_FIELD}.make ("diralloc"),
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("dont_check"),
					create {CE_STRUCTURE_FIELD}.make ("ctl_valid"),
					create {CE_STRUCTURE_FIELD}.make ("cwddone"),
					create {CE_STRUCTURE_FIELD}.make ("cwdfail"),
					create {CE_STRUCTURE_FIELD}.make ("prevpath"),
					create {CE_STRUCTURE_FIELD}.make ("transfertype"),
					create {CE_STRUCTURE_FIELD}.make ("count1"),
					create {CE_STRUCTURE_FIELD}.make ("count2"),
					create {CE_STRUCTURE_FIELD}.make ("count3"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("server_os"),
					create {CE_STRUCTURE_FIELD}.make ("known_filesize")
				>>)
			init_structure_info
		end

end
