class
	PD_FTP_WC_TMPDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parser.make
			create backup.make
		end

feature {ANY} -- fields

	parser: CE_POINTER [PD_FTP_PARSELIST_DATA] assign set_parser

	backup: PD_BACKUP assign set_backup

feature {ANY} -- setters

	set_parser (a_parser: CE_POINTER [PD_FTP_PARSELIST_DATA])
		do
			parser := a_parser
			update_memory_field ("parser")
		end

	set_backup (a_backup: PD_BACKUP)
		do
			backup := a_backup
			update_memory_field ("backup")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parser := a_other.parser
			backup := a_other.backup.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parser.is_equal (a_other.parser) and
				backup.is_equal (a_other.backup)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parser"),
					create {CE_STRUCTURE_FIELD}.make ("backup")
				>>)
			init_structure_info
		end

end
