class
	PD_HOSTNAME

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create rawalloc.make
			create encalloc.make
			create name.make
			create dispname.make
		end

feature {ANY} -- fields

	rawalloc: CE_POINTER [INTEGER_8] assign set_rawalloc

	encalloc: CE_POINTER [INTEGER_8] assign set_encalloc

	name: CE_POINTER [INTEGER_8] assign set_name

	dispname: CE_POINTER [INTEGER_8] assign set_dispname

feature {ANY} -- setters

	set_rawalloc (a_rawalloc: CE_POINTER [INTEGER_8])
		do
			rawalloc := a_rawalloc
			update_memory_field ("rawalloc")
		end

	set_encalloc (a_encalloc: CE_POINTER [INTEGER_8])
		do
			encalloc := a_encalloc
			update_memory_field ("encalloc")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_dispname (a_dispname: CE_POINTER [INTEGER_8])
		do
			dispname := a_dispname
			update_memory_field ("dispname")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rawalloc := a_other.rawalloc
			encalloc := a_other.encalloc
			name := a_other.name
			dispname := a_other.dispname
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rawalloc.is_equal (a_other.rawalloc) and
				encalloc.is_equal (a_other.encalloc) and
				name.is_equal (a_other.name) and
				dispname.is_equal (a_other.dispname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rawalloc"),
					create {CE_STRUCTURE_FIELD}.make ("encalloc"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("dispname")
				>>)
			init_structure_info
		end

end
