class
	PD_NAMEBUFF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create hostentry.make
			create addrentry.make
			create h_addr_list.make (<<2>>)
		end

feature {ANY} -- fields

	hostentry: SD_HOSTENT assign set_hostentry

	addrentry: PD_ADDRENTRY assign set_addrentry

	h_addr_list: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- setters

	set_hostentry (a_hostentry: SD_HOSTENT)
		do
			hostentry := a_hostentry
			update_memory_field ("hostentry")
		end

	set_addrentry (a_addrentry: PD_ADDRENTRY)
		do
			addrentry := a_addrentry
			update_memory_field ("addrentry")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hostentry := a_other.hostentry.twin
			addrentry := a_other.addrentry.twin
			h_addr_list := a_other.h_addr_list.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hostentry.is_equal (a_other.hostentry) and
				addrentry.is_equal (a_other.addrentry) and
				h_addr_list.is_equal (a_other.h_addr_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hostentry"),
					create {CE_STRUCTURE_FIELD}.make ("addrentry"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("h_addr_list", <<2>>)
				>>)
			init_structure_info
		end

end
