class
	PD_PUREINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create contenttype.make
			create wouldredirect.make
			create ip.make (<<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>)
			create localip.make (<<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>)
			create certs.make
		end

feature {ANY} -- fields

	httpcode: INTEGER_32 assign set_httpcode

	httpproxycode: INTEGER_32 assign set_httpproxycode

	httpversion: INTEGER_32 assign set_httpversion

	filetime: INTEGER_32 assign set_filetime

	timecond: BOOLEAN assign set_timecond

	header_size: INTEGER_32 assign set_header_size

	request_size: INTEGER_32 assign set_request_size

	proxyauthavail: INTEGER_32 assign set_proxyauthavail

	httpauthavail: INTEGER_32 assign set_httpauthavail

	numconnects: INTEGER_32 assign set_numconnects

	contenttype: CE_POINTER [INTEGER_8] assign set_contenttype

	wouldredirect: CE_POINTER [INTEGER_8] assign set_wouldredirect

	ip: CE_ARRAY [INTEGER_8]

	port: INTEGER_32 assign set_port

	localip: CE_ARRAY [INTEGER_8]

	localport: INTEGER_32 assign set_localport

	certs: PD_CURL_CERTINFO assign set_certs

feature {ANY} -- setters

	set_httpcode (a_httpcode: INTEGER_32)
		do
			httpcode := a_httpcode
			update_memory_field ("httpcode")
		end

	set_httpproxycode (a_httpproxycode: INTEGER_32)
		do
			httpproxycode := a_httpproxycode
			update_memory_field ("httpproxycode")
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			httpversion := a_httpversion
			update_memory_field ("httpversion")
		end

	set_filetime (a_filetime: INTEGER_32)
		do
			filetime := a_filetime
			update_memory_field ("filetime")
		end

	set_timecond (a_timecond: BOOLEAN)
		do
			timecond := a_timecond
			update_memory_field ("timecond")
		end

	set_header_size (a_header_size: INTEGER_32)
		do
			header_size := a_header_size
			update_memory_field ("header_size")
		end

	set_request_size (a_request_size: INTEGER_32)
		do
			request_size := a_request_size
			update_memory_field ("request_size")
		end

	set_proxyauthavail (a_proxyauthavail: INTEGER_32)
		do
			proxyauthavail := a_proxyauthavail
			update_memory_field ("proxyauthavail")
		end

	set_httpauthavail (a_httpauthavail: INTEGER_32)
		do
			httpauthavail := a_httpauthavail
			update_memory_field ("httpauthavail")
		end

	set_numconnects (a_numconnects: INTEGER_32)
		do
			numconnects := a_numconnects
			update_memory_field ("numconnects")
		end

	set_contenttype (a_contenttype: CE_POINTER [INTEGER_8])
		do
			contenttype := a_contenttype
			update_memory_field ("contenttype")
		end

	set_wouldredirect (a_wouldredirect: CE_POINTER [INTEGER_8])
		do
			wouldredirect := a_wouldredirect
			update_memory_field ("wouldredirect")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_localport (a_localport: INTEGER_32)
		do
			localport := a_localport
			update_memory_field ("localport")
		end

	set_certs (a_certs: PD_CURL_CERTINFO)
		do
			certs := a_certs
			update_memory_field ("certs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			httpcode := a_other.httpcode
			httpproxycode := a_other.httpproxycode
			httpversion := a_other.httpversion
			filetime := a_other.filetime
			timecond := a_other.timecond
			header_size := a_other.header_size
			request_size := a_other.request_size
			proxyauthavail := a_other.proxyauthavail
			httpauthavail := a_other.httpauthavail
			numconnects := a_other.numconnects
			contenttype := a_other.contenttype
			wouldredirect := a_other.wouldredirect
			ip := a_other.ip.twin
			port := a_other.port
			localip := a_other.localip.twin
			localport := a_other.localport
			certs := a_other.certs.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				httpcode = a_other.httpcode and
				httpproxycode = a_other.httpproxycode and
				httpversion = a_other.httpversion and
				filetime = a_other.filetime and
				timecond = a_other.timecond and
				header_size = a_other.header_size and
				request_size = a_other.request_size and
				proxyauthavail = a_other.proxyauthavail and
				httpauthavail = a_other.httpauthavail and
				numconnects = a_other.numconnects and
				contenttype.is_equal (a_other.contenttype) and
				wouldredirect.is_equal (a_other.wouldredirect) and
				ip.is_equal (a_other.ip) and
				port = a_other.port and
				localip.is_equal (a_other.localip) and
				localport = a_other.localport and
				certs.is_equal (a_other.certs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("httpcode"),
					create {CE_STRUCTURE_FIELD}.make ("httpproxycode"),
					create {CE_STRUCTURE_FIELD}.make ("httpversion"),
					create {CE_STRUCTURE_FIELD}.make ("filetime"),
					create {CE_STRUCTURE_FIELD}.make ("timecond"),
					create {CE_STRUCTURE_FIELD}.make ("header_size"),
					create {CE_STRUCTURE_FIELD}.make ("request_size"),
					create {CE_STRUCTURE_FIELD}.make ("proxyauthavail"),
					create {CE_STRUCTURE_FIELD}.make ("httpauthavail"),
					create {CE_STRUCTURE_FIELD}.make ("numconnects"),
					create {CE_STRUCTURE_FIELD}.make ("contenttype"),
					create {CE_STRUCTURE_FIELD}.make ("wouldredirect"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ip", <<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("localip", <<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("localport"),
					create {CE_STRUCTURE_FIELD}.make ("certs")
				>>)
			init_structure_info
		end

end
