class
	PD_RTSP

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create http_wrapper.make
		end

feature {ANY} -- fields

	http_wrapper: PD_HTTP assign set_http_wrapper

	CSeq_sent: INTEGER_32 assign set_CSeq_sent

	CSeq_recv: INTEGER_32 assign set_CSeq_recv

feature {ANY} -- setters

	set_http_wrapper (a_http_wrapper: PD_HTTP)
		do
			http_wrapper := a_http_wrapper
			update_memory_field ("http_wrapper")
		end

	set_CSeq_sent (a_CSeq_sent: INTEGER_32)
		do
			CSeq_sent := a_CSeq_sent
			update_memory_field ("CSeq_sent")
		end

	set_CSeq_recv (a_CSeq_recv: INTEGER_32)
		do
			CSeq_recv := a_CSeq_recv
			update_memory_field ("CSeq_recv")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			http_wrapper := a_other.http_wrapper.twin
			CSeq_sent := a_other.CSeq_sent
			CSeq_recv := a_other.CSeq_recv
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				http_wrapper.is_equal (a_other.http_wrapper) and
				CSeq_sent = a_other.CSeq_sent and
				CSeq_recv = a_other.CSeq_recv
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("http_wrapper"),
					create {CE_STRUCTURE_FIELD}.make ("CSeq_sent"),
					create {CE_STRUCTURE_FIELD}.make ("CSeq_recv")
				>>)
			init_structure_info
		end

end
