class
	PD_SA_EX_U

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	addr: SD_SOCKADDR assign set_addr

	buff: PD_CURL_SOCKADDR_STORAGE assign set_buff

feature {ANY} -- setters

	set_addr (a_addr: SD_SOCKADDR)
		do
			addr := a_addr
			update_memory_field ("addr")
		end

	set_buff (a_buff: PD_CURL_SOCKADDR_STORAGE)
		do
			buff := a_buff
			update_memory_field ("buff")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			addr := a_other.addr.twin
			buff := a_other.buff.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				addr.is_equal (a_other.addr) and
				buff.is_equal (a_other.buff)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make ("buff")
				>>)
			init_structure_info
		end

end
