class
	PD_STRINGS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create time.make
			create perm.make
			create user.make
			create group.make
			create target.make
		end

feature {ANY} -- fields

	time: CE_POINTER [INTEGER_8] assign set_time

	perm: CE_POINTER [INTEGER_8] assign set_perm

	user: CE_POINTER [INTEGER_8] assign set_user

	group: CE_POINTER [INTEGER_8] assign set_group

	target: CE_POINTER [INTEGER_8] assign set_target

feature {ANY} -- setters

	set_time (a_time: CE_POINTER [INTEGER_8])
		do
			time := a_time
			update_memory_field ("time")
		end

	set_perm (a_perm: CE_POINTER [INTEGER_8])
		do
			perm := a_perm
			update_memory_field ("perm")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_group (a_group: CE_POINTER [INTEGER_8])
		do
			group := a_group
			update_memory_field ("group")
		end

	set_target (a_target: CE_POINTER [INTEGER_8])
		do
			target := a_target
			update_memory_field ("target")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			time := a_other.time
			perm := a_other.perm
			user := a_other.user
			group := a_other.group
			target := a_other.target
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				time.is_equal (a_other.time) and
				perm.is_equal (a_other.perm) and
				user.is_equal (a_other.user) and
				group.is_equal (a_other.group) and
				target.is_equal (a_other.target)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("perm"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("target")
				>>)
			init_structure_info
		end

end
