class
	P_EASY

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_ccalloc.make
			create Curl_cfree.make
			create Curl_cmalloc.make
			create Curl_crealloc.make
			create Curl_cstrdup.make
		end

feature {ANY} -- attributes

	Curl_ccalloc: CE_ROUTINE assign set_Curl_ccalloc

	set_Curl_ccalloc (a_Curl_ccalloc: CE_ROUTINE)
		do
			Curl_ccalloc := a_Curl_ccalloc
		end

	Curl_cfree: CE_ROUTINE assign set_Curl_cfree

	set_Curl_cfree (a_Curl_cfree: CE_ROUTINE)
		do
			Curl_cfree := a_Curl_cfree
		end

	Curl_cmalloc: CE_ROUTINE assign set_Curl_cmalloc

	set_Curl_cmalloc (a_Curl_cmalloc: CE_ROUTINE)
		do
			Curl_cmalloc := a_Curl_cmalloc
		end

	Curl_crealloc: CE_ROUTINE assign set_Curl_crealloc

	set_Curl_crealloc (a_Curl_crealloc: CE_ROUTINE)
		do
			Curl_crealloc := a_Curl_crealloc
		end

	Curl_cstrdup: CE_ROUTINE assign set_Curl_cstrdup

	set_Curl_cstrdup (a_Curl_cstrdup: CE_ROUTINE)
		do
			Curl_cstrdup := a_Curl_cstrdup
		end

	init_flags: INTEGER_32 assign set_init_flags

	set_init_flags (a_init_flags: INTEGER_32)
		do
			init_flags := a_init_flags
		end

	initialized: NATURAL_32 assign set_initialized

	set_initialized (a_initialized: NATURAL_32)
		do
			initialized := a_initialized
		end

feature {ANY} -- routines

	Curl_easy_addmulti (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_multi: CE_POINTER [ANY])
		do
			a_data.item.multi := create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi)
			if a_multi.is_void then
				a_data.item.state.used_interface := {PC_USED_INTERFACE}.Curl_if_none
			end
		end

	Curl_easy_initHandleData (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req")))), 0, (create {PD_SINGLEREQUEST}.make).structure_size.to_natural_32).do_nothing
			a_data.item.req.maxdownload := (-1).to_integer_64
		end

	curl_easy_cleanup (a_curl: CE_POINTER [ANY])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl)
			if l_data.is_void then
				js.return
			end
			if not js.return_called then
				url_inst.Curl_close (l_data).do_nothing
			end
		end

	curl_easy_duphandle (a_incurl: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_fail: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_outcurl: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make
			create l_outcurl.make

			l_fail := (1).to_boolean
			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_incurl)
			l_outcurl := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_SESSIONHANDLE}.make).structure_size.to_natural_32]))))
			if l_outcurl.is_void then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_outcurl.item.state.headerbuff := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (Curl_cmalloc.pointer_item ([(256).to_natural_32]))))
					if (l_outcurl.item.state.headerbuff).is_void then
						js.break
					end
					if not js.loop_jumped then
						l_outcurl.item.state.headersize := (256).to_natural_32
						if (url_inst.Curl_dupset (l_outcurl, l_data)) /= {NATURAL_32} 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_outcurl.item.state.connc := create {CE_POINTER [PD_CONNCACHE]}.make_shared (default_pointer)
						l_outcurl.item.state.lastconnect := -1
						l_outcurl.item.progress.flags := l_data.item.progress.flags
						l_outcurl.item.progress.callback := l_data.item.progress.callback
						if (not (l_data.item.cookies).is_void) then
							l_outcurl.item.cookies := cookie_inst.Curl_cookie_init (l_data, (l_data.item.cookies).item.filename, l_outcurl.item.cookies, l_data.item.set.cookiesession)
							if (l_outcurl.item.cookies).is_void then
								js.break
							end
						end
					end
					if not js.loop_jumped and then (not (l_data.item.change.cookielist).is_void) then
						l_outcurl.item.change.cookielist := slist_inst.Curl_slist_duplicate (l_data.item.change.cookielist)
						if (l_outcurl.item.change.cookielist).is_void then
							js.break
						end
					end
					if not js.loop_jumped and then (not (l_data.item.change.url).is_void) then
						l_outcurl.item.change.url := create {CE_POINTER [INTEGER_8]}.make_cast (Curl_cstrdup.pointer_item ([l_data.item.change.url]))
						if (l_outcurl.item.change.url).is_void then
							js.break
						end
						if not js.loop_jumped then
							l_outcurl.item.change.url_alloc := (1).to_boolean
						end
					end
					if not js.loop_jumped and then (not (l_data.item.change.referer).is_void) then
						l_outcurl.item.change.referer := create {CE_POINTER [INTEGER_8]}.make_cast (Curl_cstrdup.pointer_item ([l_data.item.change.referer]))
						if (l_outcurl.item.change.referer).is_void then
							js.break
						end
						if not js.loop_jumped then
							l_outcurl.item.change.referer_alloc := (1).to_boolean
						end
					end
					if not js.loop_jumped then
						Curl_easy_initHandleData (l_outcurl)
						l_outcurl.item.magic := {NATURAL_32} 3_235_830_701
						l_fail := (0).to_boolean
						js.break
					end
				end
				if l_fail then
					if (not l_outcurl.is_void) then
						if (not (l_outcurl.item.state.connc).is_void) then
							if (l_outcurl.item.state.connc).item.type = {NATURAL_32} 0 then
								url_inst.Curl_rm_connc (l_outcurl.item.state.connc)
							end
						end
						if (not (l_outcurl.item.state.headerbuff).is_void) then
							Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl.item.state.headerbuff)])
						end
						if (not (l_outcurl.item.change.cookielist).is_void) then
							slist_inst.curl_slist_free_all (l_outcurl.item.change.cookielist)
						end
						if (not (l_outcurl.item.change.url).is_void) then
							Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl.item.change.url)])
						end
						if (not (l_outcurl.item.change.referer).is_void) then
							Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl.item.change.referer)])
						end
						url_inst.Curl_freeset (l_outcurl)
						Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl)])
						l_outcurl := create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer)
					end
				end
				Result := (create {CE_POINTER [ANY]}.make_cast (l_outcurl))
			end
		end

	curl_easy_getinfo (a_args: TUPLE [a_curl: CE_POINTER [ANY]; a_info: NATURAL_32]): NATURAL_32
		local
			l_arg: CE_VA_LIST
			l_paramp: CE_POINTER [ANY]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_arg.make_shared (default_pointer)
			create l_paramp.make
			create l_data.make

			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_args.a_curl)
			l_arg := create {CE_VA_LIST}.make (a_args, 3)
			l_paramp := (create {CE_POINTER [ANY]}.make_cast (l_arg.pointer_item))
			Result := (getinfo_inst.Curl_getinfo ([l_data, a_args.a_info, l_paramp]))
		end

	curl_easy_init: CE_POINTER [ANY]
		local
			l_res: NATURAL_32
			l_data: CE_ARRAY [CE_POINTER [PD_SESSIONHANDLE]]
			js: JUMP_STATE
		do
			create l_data.make (<<1>>)

			if not initialized.to_boolean then
				l_res := curl_global_init (((1).bit_or (((1).bit_shift_left (1)))).to_integer_32)
				if l_res.to_boolean then
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_res := url_inst.Curl_open (l_data)
				if l_res /= {NATURAL_32} 0 then
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_data.item))
			end
		end

	curl_easy_pause (a_curl: CE_POINTER [ANY]; a_action: INTEGER_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_result: NATURAL_32
			l_newstate: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tempwrite: CE_POINTER [INTEGER_8]
			l_freewrite: CE_POINTER [INTEGER_8]
			l_tempsize: NATURAL_32
			l_temptype: INTEGER_32
			l_chunklen: NATURAL_32
			l_newptr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_data.make
			create l_k.make
			create l_tempwrite.make
			create l_freewrite.make
			create l_newptr.make

			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl)
			l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_result := {PC_CURLCODE}.CURLE_OK
			l_newstate := (l_k.item.keepon).bit_and ((((((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5))))).bit_not)
			if ((a_action).bit_and (1)).to_boolean then
				l_tmp := (1).bit_shift_left (4)
			else
				l_tmp := 0
			end
			if ((a_action).bit_and (((1).bit_shift_left (2)))).to_boolean then
				l_tmp___0 := (1).bit_shift_left (5)
			else
				l_tmp___0 := 0
			end
			l_newstate := (l_newstate).bit_or (((l_tmp).bit_or (l_tmp___0)))
			l_k.item.keepon := l_newstate
			if not ((l_newstate).bit_and (((1).bit_shift_left (4)))).to_boolean then
				if (not (l_data.item.state.tempwrite).is_void) then
					l_tempwrite := l_data.item.state.tempwrite
					l_freewrite := l_tempwrite
					l_tempsize := l_data.item.state.tempwritesize
					l_temptype := l_data.item.state.tempwritetype
					l_data.item.state.tempwrite := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					from
					until
						js.loop_done
					loop
						if l_tempsize > {NATURAL_32} 16_384 then
							l_chunklen := (16_384).to_natural_32
						else
							l_chunklen := l_tempsize
						end
						l_result := sendf_inst.Curl_client_write (l_data.item.state.current_conn, l_temptype, l_tempwrite, l_chunklen)
						if l_result.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if (not (l_data.item.state.tempwrite).is_void) then
								if (l_tempsize - l_chunklen).to_boolean then
									l_newptr := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.tempwrite), l_tempsize]))))
									if l_newptr.is_void then
										Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.tempwrite)])
										l_data.item.state.tempwrite := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
										l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
										js.break
									end
									if not js.loop_jumped then
										l_data.item.state.tempwrite := l_newptr
										memcpy (create {CE_POINTER [ANY]}.make_cast (l_newptr), create {CE_POINTER [ANY]}.make_cast (l_tempwrite), l_tempsize).do_nothing
										l_data.item.state.tempwritesize := l_tempsize
										js.break
									end
								else
									l_tempsize := l_tempsize - l_chunklen
									l_tempwrite := l_tempwrite + l_chunklen.to_integer_32
								end
							else
								l_tempsize := l_tempsize - l_chunklen
								l_tempwrite := l_tempwrite + l_chunklen.to_integer_32
							end
						end
						if not js.loop_jumped then
							if l_result = {NATURAL_32} 0 then
								if not l_tempsize.to_boolean then
									js.break
								end
							else
								js.break
							end
						end
					end
					Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_freewrite)])
				end
			end
			Result := l_result
		end

	curl_easy_perform (a_curl: CE_POINTER [ANY]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ptr: CE_POINTER [PD_CURL_HASH]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl)
					if l_data.is_void then
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.share).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((l_data.item.share).item.hostcache).is_void then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_data.item.set.global_dns_cache then
							if l_data.item.dns.hostcachetype /= {NATURAL_32} 2 then
								if l_data.item.dns.hostcachetype = {NATURAL_32} 1 then
									hash_inst.Curl_hash_destroy (l_data.item.dns.hostcache)
									l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
									l_data.item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
								end
								l_ptr := hostip_inst.Curl_global_host_cache_init
								if (not l_ptr.is_void) then
									l_data.item.dns.hostcache := l_ptr
									l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_GLOBAL
								end
							end
						end
						if (l_data.item.dns.hostcache).is_void then
							l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_PRIVATE
							l_data.item.dns.hostcache := hostip_inst.Curl_mk_dnscache
							if (l_data.item.dns.hostcache).is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
				when 5 then -- if done
						if not js.return_called and then ((l_data.item.state.connc).is_void) then
							l_data.item.state.connc := url_inst.Curl_mk_connc (0, -1)
							if (l_data.item.state.connc).is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
						if not js.return_called then
							Result := (transfer_inst.Curl_perform (l_data))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	curl_easy_recv (a_curl: CE_POINTER [ANY]; a_buffer: CE_POINTER [ANY]; a_buflen: NATURAL_32; a_n: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_sfd: CE_ARRAY [INTEGER_32]
			l_ret: NATURAL_32
			l_n1: CE_ARRAY [INTEGER_32]
			l_c: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_sfd.make (<<1>>)
			create l_n1.make (<<1>>)
			create l_c.make (<<1>>)
			create l_data.make

			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl)
			l_ret := easy_connection (l_data, l_sfd, l_c)
			if l_ret.to_boolean then
				Result := l_ret
				js.return
			end
			if not js.return_called then
				a_n.item := (0).to_natural_32
				l_ret := sendf_inst.Curl_read (l_c.item, l_sfd.item, create {CE_POINTER [INTEGER_8]}.make_cast (a_buffer), a_buflen, l_n1)
				if l_ret /= {NATURAL_32} 0 then
					Result := l_ret
					js.return
				end
			end
			if not js.return_called then
				a_n.item := (l_n1.item).to_natural_32
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	curl_easy_reset (a_curl: CE_POINTER [ANY])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl)
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_data.item.state.pathbuffer))
			l_data.item.state.pathbuffer := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			url_inst.Curl_safefree (l_data.item.state.proto.generic)
			l_data.item.state.proto.generic := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			url_inst.Curl_freeset (l_data)
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_USERDEFINED]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set")))), 0, (create {PD_USERDEFINED}.make).structure_size.to_natural_32).do_nothing
			url_inst.Curl_init_userdefined (create {CE_POINTER [PD_USERDEFINED]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set"))).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_PROGRESS]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("progress")))), 0, (create {PD_PROGRESS}.make).structure_size.to_natural_32).do_nothing
			Curl_easy_initHandleData (l_data)
			l_data.item.progress.flags := (l_data.item.progress.flags).bit_or (((1).bit_shift_left (4)))
			l_data.item.state.current_speed := (-1).to_integer_64
		end

	curl_easy_send (a_curl: CE_POINTER [ANY]; a_buffer: CE_POINTER [ANY]; a_buflen: NATURAL_32; a_n: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_sfd: CE_ARRAY [INTEGER_32]
			l_ret: NATURAL_32
			l_n1: CE_ARRAY [INTEGER_32]
			l_c: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_sfd.make (<<1>>)
			create l_n1.make (<<1>>)
			create l_c.make (<<1>>)
			create l_data.make

			l_c.item := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl)
			l_ret := easy_connection (l_data, l_sfd, l_c)
			if l_ret.to_boolean then
				Result := l_ret
				js.return
			end
			if not js.return_called then
				a_n.item := (0).to_natural_32
				l_ret := sendf_inst.Curl_write (l_c.item, l_sfd.item, a_buffer, a_buflen, l_n1)
				if l_n1.item = -1 then
					Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
					js.return
				end
			end
			if not js.return_called and then ({NATURAL_32} 0 = l_ret) then
				if 0 = l_n1.item then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					js.return
				end
			end
			if not js.return_called then
				a_n.item := (l_n1.item).to_natural_32
				Result := l_ret
			end
		end

	curl_easy_setopt (a_args: TUPLE [a_curl: CE_POINTER [ANY]; a_tag: NATURAL_32]): NATURAL_32
		local
			l_arg: CE_VA_LIST
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ret: NATURAL_32
			js: JUMP_STATE
		do
			create l_arg.make_shared (default_pointer)
			create l_data.make

			l_data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_args.a_curl)
			if a_args.a_curl.is_void then
				Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
				js.return
			end
			if not js.return_called then
				l_arg := create {CE_VA_LIST}.make (a_args, 3)
				l_ret := url_inst.Curl_setopt (l_data, a_args.a_tag, l_arg.twin)
				Result := l_ret
			end
		end

	curl_global_cleanup
		local
			js: JUMP_STATE
		do
			if not initialized.to_boolean then
				js.return
			end
			if not js.return_called then
				initialized := initialized - 1
				if initialized.to_boolean then
					js.return
				end
			end
			if not js.return_called then
				hostip_inst.Curl_global_host_cache_dtor
				if ((init_flags).bit_and (1)).to_boolean then
				end
				if ((init_flags).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
					win32_cleanup
				end
				init_flags := 0
			end
		end

	curl_global_init (a_flags: INTEGER_32): NATURAL_32
		local
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_tmp := initialized
			initialized := initialized + 1
			if l_tmp.to_boolean then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				Curl_cmalloc := malloc_address
				Curl_cfree := free_address
				Curl_crealloc := realloc_address
				Curl_cstrdup := strdup_address
				Curl_ccalloc := calloc_address
				if ((a_flags).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
					if (win32_init) /= {NATURAL_32} 0 then
						Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
						js.return
					end
				end
			end
			if not js.return_called then
				init_flags := a_flags
				curl_rand_inst.Curl_srand
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	curl_global_init_mem (a_flags: INTEGER_32; a_m: CE_ROUTINE; a_f: CE_ROUTINE; a_r: CE_ROUTINE; a_s: CE_ROUTINE; a_c: CE_ROUTINE): NATURAL_32
		local
			l_code: NATURAL_32
			js: JUMP_STATE
		do
			l_code := {PC_CURLCODE}.CURLE_OK
			if a_m.is_void then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif a_f.is_void then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif a_r.is_void then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif a_s.is_void then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif a_c.is_void then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			end
			if not js.return_called and then (initialized.to_boolean) then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				l_code := curl_global_init (a_flags)
				if l_code = {NATURAL_32} 0 then
					Curl_cmalloc := a_m
					Curl_cfree := a_f
					Curl_cstrdup := a_s
					Curl_crealloc := a_r
					Curl_ccalloc := a_c
				end
				Result := l_code
			end
		end

	easy_connection (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_sfd: CE_POINTER [INTEGER_32]; a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): NATURAL_32
		local
			js: JUMP_STATE
		do
			if a_data.is_void then
				Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
				js.return
			end
			if not js.return_called and then (not a_data.item.set.connect_only) then
				sendf_inst.Curl_failf ([a_data, ce_string ("CONNECT_ONLY is required!")])
				Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
				js.return
			end
			if not js.return_called then
				a_sfd.item := connect_inst.Curl_getconnectinfo (a_data, a_connp)
				if a_sfd.item = -1 then
					sendf_inst.Curl_failf ([a_data, ce_string ("Failed to get recent socket")])
					Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
					js.return
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	win32_cleanup
		do
		end

	win32_init: NATURAL_32
		do
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

end
