class
	P_FILE

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_file.make (<<1>>)
		end

feature {ANY} -- attributes

	Curl_handler_file: CE_ARRAY [PD_CURL_HANDLER]

feature {ANY} -- routines

	file_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_real_path: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [PD_FILEPROTO]
			l_fd: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_real_path.make
			create l_file.make

			l_data := a_conn.item.data
			l_real_path := (escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (l_data), l_data.item.state.path, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			if l_real_path.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				url_inst.Curl_reset_reqproto (a_conn)
				if (l_data.item.state.proto.file).is_void then
					l_file := create {CE_POINTER [PD_FILEPROTO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_FILEPROTO}.make).structure_size.to_natural_32]))))
					if l_file.is_void then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_real_path)])
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if not js.return_called then
						l_data.item.state.proto.file := l_file
					end
				else
					l_file := l_data.item.state.proto.file
					url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_file.item.freepath))
					if l_file.item.fd /= -1 then
						close (l_file.item.fd).do_nothing
					end
					l_file.item.path := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_file.item.freepath := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_file.item.fd := -1
				end
			end
			if not js.return_called then
				l_fd := open ([l_real_path, 0])
				l_file.item.path := l_real_path
				l_file.item.freepath := l_real_path
				l_file.item.fd := l_fd
				if not l_data.item.set.upload then
					if l_fd = -1 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Couldn%'t open file %%s"), l_data.item.state.path])
						file_done (a_conn, {PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE, (0).to_boolean).do_nothing
						Result := ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE)
						js.return
					end
				end
			end
			if not js.return_called then
				a_done.item := (1).to_boolean
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	file_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent file_connect)
		end

	file_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_res: NATURAL_32
			l_statbuf: CE_ARRAY [SD_STAT]
			l_expected_size: INTEGER_64
			l_fstated: BOOLEAN
			l_nread: INTEGER_32
			l_bytestoread: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buf: CE_POINTER [INTEGER_8]
			l_bytecount: INTEGER_64
			l_fd: INTEGER_32
			l_now: SD_TIMEVAL
			l_result: NATURAL_32
			l_tm: CE_POINTER [SD_TM]
			l_filetime: CE_ARRAY [INTEGER_32]
			l_buffer: CE_ARRAY [SD_TM]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_statbuf.make (<<1>>)
			create l_data.make
			create l_buf.make
			create l_now.make
			create l_tm.make
			create l_filetime.make (<<1>>)
			create l_buffer.make (<<1>>)

			l_res := {PC_CURLCODE}.CURLE_OK
			l_expected_size := (0).to_integer_64
			l_fstated := (0).to_boolean
			l_data := a_conn.item.data
			l_buf := l_data.item.state.buffer
			l_bytecount := (0).to_integer_64
			l_now := (timeval_inst.curlx_tvnow).twin
			a_done.item := (1).to_boolean
			getinfo_inst.Curl_initinfo (l_data).do_nothing
			progress_inst.Curl_pgrsStartNow (l_data)
			if l_data.item.set.upload then
				Result := (file_upload (a_conn))
				js.return
			end
			if not js.return_called then
				l_fd := ((a_conn.item.data).item.state.proto.file).item.fd
				if -1 /= (fstat (l_fd, l_statbuf)) then
					l_expected_size := (l_statbuf.item.st_size).to_integer_64
					l_data.item.info.filetime := l_statbuf.item.st_mtim.tv_sec
					l_fstated := (1).to_boolean
				end
				if l_data.item.set.opt_no_body then
					if l_data.item.set.include_header then
						if l_fstated then
							mprintf_inst.curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16_385).to_natural_32), ce_string ("Content-Length: %%lld%R%N"), l_expected_size]).do_nothing
							l_result := sendf_inst.Curl_client_write (a_conn, (1).bit_or (((1).bit_shift_left (1))), l_buf, (0).to_natural_32)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called then
								l_result := sendf_inst.Curl_client_write (a_conn, (1).bit_or (((1).bit_shift_left (1))), ce_string ("Accept-ranges: bytes%R%N"), (0).to_natural_32)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							end
							if not js.return_called then
								if l_fstated then
									l_filetime.item := l_statbuf.item.st_mtim.tv_sec
									l_tm := (gmtime_r (l_filetime, l_buffer))
									if (l_tm.item.tm_wday).to_boolean then
										l_tmp___3 := l_tm.item.tm_wday - 1
									else
										l_tmp___3 := 6
									end
									mprintf_inst.curl_msnprintf ([l_buf, (16_383).to_natural_32, ce_string ("Last-Modified: %%s, %%02d %%s %%4d %%02d:%%02d:%%02d GMT%R%N"), parsedate_inst.Curl_wkday[l_tmp___3], l_tm.item.tm_mday, parsedate_inst.Curl_month[l_tm.item.tm_mon], l_tm.item.tm_year + 1_900, l_tm.item.tm_hour, l_tm.item.tm_min, l_tm.item.tm_sec]).do_nothing
									l_result := sendf_inst.Curl_client_write (a_conn, (1).bit_or (((1).bit_shift_left (1))), l_buf, (0).to_natural_32)
								end
								if l_fstated then
									progress_inst.Curl_pgrsSetDownloadSize (l_data, l_expected_size)
								end
								Result := l_result
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				file_range (a_conn).do_nothing
				if l_data.item.state.resume_from < {INTEGER_64} 0 then
					if not l_fstated then
						sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t get the size of file.")])
						Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
						js.return
					else
						l_data.item.state.resume_from := l_data.item.state.resume_from + (l_statbuf.item.st_size).to_integer_64
					end
				end
			end
			if not js.return_called then
				if l_data.item.state.resume_from <= l_expected_size then
					l_expected_size := l_expected_size - (l_data.item.state.resume_from)
				else
					sendf_inst.Curl_failf ([l_data, ce_string ("failed to resume file:// transfer")])
					Result := ({PC_CURLCODE}.CURLE_BAD_DOWNLOAD_RESUME)
					js.return
				end
			end
			if not js.return_called then
				if l_data.item.req.maxdownload > {INTEGER_64} 0 then
					l_expected_size := l_data.item.req.maxdownload
				end
				if l_fstated then
					if l_expected_size = {INTEGER_64} 0 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					end
				end
			end
			if not js.return_called then
				if l_fstated then
					progress_inst.Curl_pgrsSetDownloadSize (l_data, l_expected_size)
				end
				if (l_data.item.state.resume_from).to_boolean then
					if l_data.item.state.resume_from /= (lseek (l_fd, (l_data.item.state.resume_from).to_integer_32, 0)).to_integer_64 then
						Result := ({PC_CURLCODE}.CURLE_BAD_DOWNLOAD_RESUME)
						js.return
					end
				end
			end
			if not js.return_called then
				progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_STARTTRANSFER)
				from
				until
					not (not js.loop_done and then (l_res = {NATURAL_32} 0))
				loop
					if l_expected_size < {INTEGER_64} 16_383 then
						l_bytestoread := l_expected_size.to_natural_32
					else
						l_bytestoread := (16_383).to_natural_32
					end
					l_nread := read (l_fd, create {CE_POINTER [ANY]}.make_cast (l_buf), l_bytestoread)
					if l_nread > 0 then
						l_buf[l_nread] := (0).to_integer_8
					end
					if l_nread <= 0 then
						js.break
					elseif l_expected_size = {INTEGER_64} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_bytecount := l_bytecount + l_nread.to_integer_64
						l_expected_size := l_expected_size - l_nread.to_integer_64
						l_res := sendf_inst.Curl_client_write (a_conn, 1, l_buf, l_nread.to_natural_32)
						if l_res.to_boolean then
							Result := l_res
							js.return
						end
						if not js.return_called then
							progress_inst.Curl_pgrsSetDownloadCounter (l_data, l_bytecount)
							if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
								l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
							else
								l_res := speedcheck_inst.Curl_speedcheck (l_data, l_now.twin)
							end
						end
					end
				end
			end
			if not js.return_called then
				if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
					l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
				end
				Result := l_res
			end
		end

	file_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent file_do)
		end

	file_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_file: CE_POINTER [PD_FILEPROTO]
		do
			create l_file.make

			l_file := (a_conn.item.data).item.state.proto.file
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_file.item.freepath))
			if l_file.item.fd /= -1 then
				close (l_file.item.fd).do_nothing
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	file_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent file_done)
		end

	file_range (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_from: INTEGER_64
			l_to: INTEGER_64
			l_totalsize: INTEGER_64
			l_ptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ptr2: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make (<<1>>)
			create l_ptr2.make (<<1>>)
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_totalsize := (-1).to_integer_64
					l_data := a_conn.item.data
					if not (l_data.item.state.use_range) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.state.range).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						l_from := strtoll (l_data.item.state.range, l_ptr, 0)
						from
						until
							js.loop_done
						loop
							if (l_ptr.item[0]).to_boolean then
								if not ((((ctype_b_loc).item[(l_ptr.item[0]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
									if (l_ptr.item[0]).to_integer_32 /= 45 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_ptr.item := l_ptr.item + 1
							end
						end
						l_to := strtoll (l_ptr.item, l_ptr2, 0)
						if (l_ptr.item).is_equal (l_ptr2.item) then
							l_to := (-1).to_integer_64
						end
						if -{INTEGER_64} 1 /= l_to then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_from >= {INTEGER_64} 0 then
							l_data.item.state.resume_from := l_from
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_from < {INTEGER_64} 0 then
							l_data.item.req.maxdownload := -l_from
							l_data.item.state.resume_from := l_from
						else
							l_totalsize := l_to - l_from
							l_data.item.req.maxdownload := l_totalsize + {INTEGER_64} 1
							l_data.item.state.resume_from := l_from
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_data.item.req.maxdownload := (-1).to_integer_64
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_data.item.req.maxdownload := (-1).to_integer_64
				when 10 then
					Result := ({PC_CURLCODE}.CURLE_OK)
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	file_upload (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_file: CE_POINTER [PD_FILEPROTO]
			l_dir: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buf: CE_POINTER [INTEGER_8]
			l_nread: NATURAL_32
			l_nwrite: NATURAL_32
			l_bytecount: INTEGER_64
			l_now: SD_TIMEVAL
			l_file_stat: CE_ARRAY [SD_STAT]
			l_buf2: CE_POINTER [INTEGER_8]
			l_fd: INTEGER_32
			l_readcount: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_file.make
			create l_dir.make
			create l_fp.make
			create l_data.make
			create l_buf.make
			create l_now.make
			create l_file_stat.make (<<1>>)
			create l_buf2.make
			create l_readcount.make (<<1>>)

			l_file := (a_conn.item.data).item.state.proto.file
			l_dir := (strchr (l_file.item.path, ('/').code))
			l_res := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_buf := l_data.item.state.buffer
			l_bytecount := (0).to_integer_64
			l_now := (timeval_inst.curlx_tvnow).twin
			a_conn.item.fread_func := l_data.item.set.fread_func
			a_conn.item.fread_in := l_data.item.set.in;
			(a_conn.item.data).item.req.upload_fromhere := l_buf
			if l_dir.is_void then
				Result := ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE)
				js.return
			end
			if not js.return_called and then (not (l_dir[1]).to_boolean) then
				Result := ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE)
				js.return
			end
			if not js.return_called then
				if (l_data.item.state.resume_from).to_boolean then
					l_fp := fopen (l_file.item.path, ce_string ("ab"))
				else
					l_fd := open ([l_file.item.path, 577, (a_conn.item.data).item.set.new_file_perms])
					if l_fd < 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t open %%s for writing"), l_file.item.path])
						Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
						js.return
					end
					if not js.return_called then
						close (l_fd).do_nothing
						l_fp := fopen (l_file.item.path, ce_string ("wb"))
					end
				end
			end
			if not js.return_called and then (l_fp.is_void) then
				sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t open %%s for writing"), l_file.item.path])
				Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
				js.return
			end
			if not js.return_called then
				if -{INTEGER_64} 1 /= l_data.item.set.infilesize then
					progress_inst.Curl_pgrsSetUploadSize (l_data, l_data.item.set.infilesize)
				end
				if l_data.item.state.resume_from < {INTEGER_64} 0 then
					if (fstat ((fileno (l_fp)), l_file_stat)).to_boolean then
						fclose (l_fp).do_nothing
						sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t get the size of %%s"), l_file.item.path])
						Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
						js.return
					else
						l_data.item.state.resume_from := (l_file_stat.item.st_size).to_integer_64
					end
				end
			end
			if not js.return_called then
				from
				until
					not (not js.loop_done and then (l_res = {NATURAL_32} 0))
				loop
					l_res := transfer_inst.Curl_fillreadbuffer (a_conn, 16_384, l_readcount)
					if l_res.to_boolean then
						js.break
					end
					if not js.loop_jumped and then (l_readcount.item <= 0) then
						js.break
					end
					if not js.loop_jumped then
						l_nread := (l_readcount.item).to_natural_32
						if (l_data.item.state.resume_from).to_boolean then
							if l_nread.to_integer_64 <= l_data.item.state.resume_from then
								l_data.item.state.resume_from := l_data.item.state.resume_from - l_nread.to_integer_64
								l_nread := (0).to_natural_32
								l_buf2 := l_buf
							else
								l_buf2 := (l_buf + (l_data.item.state.resume_from).to_integer_32)
								l_nread := l_nread - (l_data.item.state.resume_from).to_natural_32
								l_data.item.state.resume_from := (0).to_integer_64
							end
						else
							l_buf2 := l_buf
						end
						l_nwrite := fwrite (create {CE_POINTER [ANY]}.make_cast (l_buf2), (1).to_natural_32, l_nread, l_fp)
						if l_nwrite /= l_nread then
							l_res := {PC_CURLCODE}.CURLE_SEND_ERROR
							js.break
						end
					end
					if not js.loop_jumped then
						l_bytecount := l_bytecount + l_nread.to_integer_64
						progress_inst.Curl_pgrsSetUploadCounter (l_data, l_bytecount)
						if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
							l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
						else
							l_res := speedcheck_inst.Curl_speedcheck (l_data, l_now.twin)
						end
					end
				end
				if not l_res.to_boolean then
					if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
						l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
					end
				end
				fclose (l_fp).do_nothing
				Result := l_res
			end
		end

end
