class
	P_FORMDATA

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create ctts.make (<<6>>)
			create table16.make (<<17>>)
		end

feature {ANY} -- attributes

	ctts: CE_ARRAY [PD_CONTENTTYPE]

	table16: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	AddFormData (a_formp: CE_POINTER [CE_POINTER [PD_FORMDATA]]; a_type: NATURAL_32; a_line: CE_POINTER [ANY]; a_length: NATURAL_32; a_size: CE_POINTER [INTEGER_64]): NATURAL_32
		local
			l_length: NATURAL_32
			l_newform: CE_POINTER [PD_FORMDATA]
			l_file: CE_ARRAY [SD_STAT]
			js: JUMP_STATE
		do
			create l_newform.make
			create l_file.make (<<1>>)

			l_length := a_length
			l_newform := create {CE_POINTER [PD_FORMDATA]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_FORMDATA}.make).structure_size.to_natural_32]))))
			if l_newform.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				l_newform.item.next := create {CE_POINTER [PD_FORMDATA]}.make_shared (default_pointer)
				if a_type <= {NATURAL_32} 1 then
					if not l_length.to_boolean then
						l_length := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_line))
					end
					l_newform.item.line := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_length + {NATURAL_32} 1]))))
					if (l_newform.item.line).is_void then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newform)])
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if not js.return_called then
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_newform.item.line), a_line, l_length).do_nothing
						l_newform.item.length := l_length
						l_newform.item.line[l_length.to_integer_32] := (0).to_integer_8
					end
				else
					l_newform.item.line := create {CE_POINTER [INTEGER_8]}.make_cast (a_line)
				end
			end
			if not js.return_called then
				l_newform.item.type := a_type
				if (not (a_formp.item).is_void) then
					(a_formp.item).item.next := l_newform
					a_formp.item := l_newform
				else
					a_formp.item := l_newform
				end
				if (not a_size.is_void) then
					if a_type /= {NATURAL_32} 3 then
						a_size.item := a_size.item + l_length.to_integer_64
					elseif not (strequal_inst.curl_strequal (ce_string ("-"), l_newform.item.line)).to_boolean then
						if not (stat (l_newform.item.line, l_file)).to_boolean then
							a_size.item := a_size.item + (l_file.item.st_size).to_integer_64
						end
					end
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	AddFormDataf (a_args: TUPLE [a_formp: CE_POINTER [CE_POINTER [PD_FORMDATA]]; a_size: CE_POINTER [INTEGER_64]; a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_s: CE_ARRAY [INTEGER_8]
			l_ap: CE_VA_LIST
		do
			create l_s.make (<<4_096>>)
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, 4)
			mprintf_inst.curl_mvsnprintf (l_s, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (4_096).to_natural_32), a_args.a_fmt, l_ap.twin).do_nothing
			Result := (AddFormData (a_args.a_formp, {PC_FORMTYPE}.FORM_DATA, create {CE_POINTER [ANY]}.make_cast (l_s), (0).to_natural_32, a_args.a_size))
		end

	AddFormInfo (a_value: CE_POINTER [INTEGER_8]; a_contenttype: CE_POINTER [INTEGER_8]; a_parent_form_info: CE_POINTER [PD_FORMINFO]): CE_POINTER [PD_FORMINFO]
		local
			l_form_info: CE_POINTER [PD_FORMINFO]
			js: JUMP_STATE
		do
			create l_form_info.make

			l_form_info := create {CE_POINTER [PD_FORMINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_FORMINFO}.make).structure_size.to_natural_32]))))
			if (not l_form_info.is_void) then
				if (not a_value.is_void) then
					l_form_info.item.value := a_value
				end
				if (not a_contenttype.is_void) then
					l_form_info.item.contenttype := a_contenttype
				end
				l_form_info.item.flags := 1
			else
				Result := (create {CE_POINTER [PD_FORMINFO]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (not a_parent_form_info.is_void) then
					l_form_info.item.more := a_parent_form_info.item.more
					a_parent_form_info.item.more := l_form_info
				else
					Result := (create {CE_POINTER [PD_FORMINFO]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_form_info
			end
		end

	AddHttpPost (a_name: CE_POINTER [INTEGER_8]; a_namelength: NATURAL_32; a_value: CE_POINTER [INTEGER_8]; a_contentslength: NATURAL_32; a_buffer: CE_POINTER [INTEGER_8]; a_bufferlength: NATURAL_32; a_contenttype: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32; a_contentHeader: CE_POINTER [PD_CURL_SLIST]; a_showfilename: CE_POINTER [INTEGER_8]; a_userp: CE_POINTER [INTEGER_8]; a_parent_post: CE_POINTER [PD_CURL_HTTPPOST]; a_httppost: CE_POINTER [CE_POINTER [PD_CURL_HTTPPOST]]; a_last_post: CE_POINTER [CE_POINTER [PD_CURL_HTTPPOST]]): CE_POINTER [PD_CURL_HTTPPOST]
		local
			l_post: CE_POINTER [PD_CURL_HTTPPOST]
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_post.make

			l_post := create {CE_POINTER [PD_CURL_HTTPPOST]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_CURL_HTTPPOST}.make).structure_size.to_natural_32]))))
			if (not l_post.is_void) then
				l_post.item.name := a_name
				if (not a_name.is_void) then
					if a_namelength.to_boolean then
						l_tmp___1 := a_namelength
					else
						l_tmp___1 := (strlen (a_name))
					end
					l_tmp___2 := l_tmp___1
				else
					l_tmp___2 := (0).to_natural_32
				end
				l_post.item.namelength := l_tmp___2.to_integer_32
				l_post.item.contents := a_value
				l_post.item.contentslength := a_contentslength.to_integer_32
				l_post.item.buffer := a_buffer
				l_post.item.bufferlength := a_bufferlength.to_integer_32
				l_post.item.contenttype := a_contenttype
				l_post.item.contentheader := a_contentHeader
				l_post.item.showfilename := a_showfilename
				l_post.item.userp := create {CE_POINTER [ANY]}.make_cast (a_userp)
				l_post.item.flags := a_flags
			else
				Result := (create {CE_POINTER [PD_CURL_HTTPPOST]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (not a_parent_post.is_void) then
					l_post.item.more := a_parent_post.item.more
					a_parent_post.item.more := l_post
				else
					if (not (a_last_post.item).is_void) then
						(a_last_post.item).item.next := l_post
					else
						a_httppost.item := l_post
					end
					a_last_post.item := l_post
				end
				Result := l_post
			end
		end

	ContentTypeForFilename (a_filename: CE_POINTER [INTEGER_8]; a_prevtype: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_contenttype: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_contenttype.make

			l_contenttype := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not a_prevtype.is_void) then
				l_contenttype := a_prevtype
			else
				l_contenttype := ce_string ("application/octet-stream")
			end
			if (not a_filename.is_void) then
				l_i := {NATURAL_32} 0
				from
				until
					not (not js.loop_done and then (l_i < ((create {PD_CONTENTTYPE}.make).structure_size.to_natural_32 * (6).to_natural_32) // (create {PD_CONTENTTYPE}.make).structure_size.to_natural_32))
				loop
					l_tmp___2 := strlen (a_filename)
					if l_tmp___2 >= (strlen ((ctts[l_i.to_integer_32].extension))) then
						l_tmp := strlen (a_filename)
						if (strequal_inst.curl_strequal ((a_filename + l_tmp.to_integer_32) - (strlen ((ctts[l_i.to_integer_32].extension))).to_integer_32, (ctts[l_i.to_integer_32].extension))).to_boolean then
							l_contenttype := ctts[l_i.to_integer_32].type
							js.break
						end
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_contenttype
		end

	Curl_FormBoundary: CE_POINTER [INTEGER_8]
		local
			l_retstring: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_retstring.make

			l_retstring := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(41).to_natural_32]))))
			if l_retstring.is_void then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				strcpy (l_retstring, ce_string ("----------------------------")).do_nothing
				l_i := strlen (l_retstring)
				from
				until
					not (l_i < {NATURAL_32} 40)
				loop
					l_retstring[l_i.to_integer_32] := table16[((curl_rand_inst.Curl_rand) \\ {NATURAL_32} 16).to_integer_32]
					l_i := l_i + 1
				end
				l_retstring[40] := (0).to_integer_8
				Result := l_retstring
			end
		end

	Curl_FormInit (a_form: CE_POINTER [PD_FORM]; a_formdata: CE_POINTER [PD_FORMDATA]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_formdata.is_void then
				Result := 1
				js.return
			end
			if not js.return_called then
				a_form.item.data := a_formdata
				a_form.item.sent := (0).to_natural_32
				a_form.item.fp := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
				a_form.item.fread_func := create {CE_ROUTINE}.make_shared (default_pointer)
				Result := 0
			end
		end

	Curl_FormReader (a_buffer: CE_POINTER [INTEGER_8]; a_size: NATURAL_32; a_nitems: NATURAL_32; a_mydata: CE_POINTER [SD_IO_FILE]): NATURAL_32
		local
			l_form: CE_POINTER [PD_FORM]
			l_wantedsize: NATURAL_32
			l_gotsize: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_form.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_gotsize := (0).to_natural_32
					l_form := create {CE_POINTER [PD_FORM]}.make_cast (a_mydata)
					l_wantedsize := a_size * a_nitems
					if (l_form.item.data).is_void then
						Result := (0).to_natural_32
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_form.item.data).item.type /= {NATURAL_32} 3 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_form.item.data).item.type /= {NATURAL_32} 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_gotsize := readfromfile (l_form, a_buffer, l_wantedsize)
						if l_gotsize.to_boolean then
							Result := l_gotsize
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								if (l_form.item.data).item.length - l_form.item.sent > l_wantedsize - l_gotsize then
									memcpy (create {CE_POINTER [ANY]}.make_cast ((a_buffer + l_gotsize.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (((l_form.item.data).item.line + (l_form.item.sent).to_integer_32)), l_wantedsize - l_gotsize).do_nothing
									l_form.item.sent := l_form.item.sent + (l_wantedsize - l_gotsize)
									Result := l_wantedsize
									js.return
								end
								if not js.return_called then
									memcpy (create {CE_POINTER [ANY]}.make_cast ((a_buffer + l_gotsize.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (((l_form.item.data).item.line + (l_form.item.sent).to_integer_32)), (l_form.item.data).item.length - l_form.item.sent).do_nothing
									l_gotsize := l_gotsize + ((l_form.item.data).item.length - l_form.item.sent)
									l_form.item.sent := (0).to_natural_32
									l_form.item.data := (l_form.item.data).item.next
									if (not (l_form.item.data).is_void) then
										if not ((l_form.item.data).item.type < {NATURAL_32} 2) then
											js.break
										end
									else
										js.break
									end
								end
							end
						end
						if not js.return_called then
							Result := l_gotsize
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_FormReader_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_FormReader)
		end

	Curl_formclean (a_form_ptr: CE_POINTER [CE_POINTER [PD_FORMDATA]])
		local
			l_next: CE_POINTER [PD_FORMDATA]
			l_form: CE_POINTER [PD_FORMDATA]
			js: JUMP_STATE
		do
			create l_next.make
			create l_form.make

			l_form := a_form_ptr.item
			if l_form.is_void then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_next := l_form.item.next
					if l_form.item.type <= {NATURAL_32} 1 then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.line)])
					end
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form)])
					l_form := l_next
					if l_form.is_void then
						js.break
					end
				end
				a_form_ptr.item := create {CE_POINTER [PD_FORMDATA]}.make_shared (default_pointer)
			end
		end

	Curl_formpostheader (a_formp: CE_POINTER [ANY]; a_len: CE_POINTER [NATURAL_32]): CE_POINTER [INTEGER_8]
		local
			l_header: CE_POINTER [INTEGER_8]
			l_form: CE_POINTER [PD_FORM]
			js: JUMP_STATE
		do
			create l_header.make
			create l_form.make

			l_form := create {CE_POINTER [PD_FORM]}.make_cast (a_formp)
			if (l_form.item.data).is_void then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_header := (l_form.item.data).item.line
				a_len.item := (l_form.item.data).item.length
				l_form.item.data := (l_form.item.data).item.next
				Result := l_header
			end
		end

	Curl_getFormData (a_finalform: CE_POINTER [CE_POINTER [PD_FORMDATA]]; a_post: CE_POINTER [PD_CURL_HTTPPOST]; a_custom_content_type: CE_POINTER [INTEGER_8]; a_sizep: CE_POINTER [INTEGER_64]): NATURAL_32
		local
			l_post: CE_POINTER [PD_CURL_HTTPPOST]
			l_form: CE_ARRAY [CE_POINTER [PD_FORMDATA]]
			l_firstform: CE_ARRAY [CE_POINTER [PD_FORMDATA]]
			l_file: CE_POINTER [PD_CURL_HTTPPOST]
			l_result: NATURAL_32
			l_size: CE_ARRAY [INTEGER_64]
			l_boundary: CE_POINTER [INTEGER_8]
			l_fileboundary: CE_POINTER [INTEGER_8]
			l_curList: CE_POINTER [PD_CURL_SLIST]
			l_tmp: CE_POINTER [INTEGER_8]
			l_filebasename: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_filebasename___0: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_fileread: CE_POINTER [SD_IO_FILE]
			l_nread: NATURAL_32
			l_buffer: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_post.make
			create l_form.make (<<1>>)
			create l_firstform.make (<<1>>)
			create l_file.make
			create l_size.make (<<1>>)
			create l_boundary.make
			create l_fileboundary.make
			create l_curList.make
			create l_tmp.make
			create l_filebasename.make
			create l_tmp___0.make
			create l_filebasename___0.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_fileread.make
			create l_buffer.make (<<512>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_post := a_post
					l_form.item := create {CE_POINTER [PD_FORMDATA]}.make_shared (default_pointer)
					l_result := {PC_CURLCODE}.CURLE_OK
					l_size.item := (0).to_integer_64
					l_fileboundary := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					a_finalform.item := create {CE_POINTER [PD_FORMDATA]}.make_shared (default_pointer)
					if l_post.is_void then
						Result := l_result
						js.return
					end
					if not js.return_called then
						l_boundary := Curl_FormBoundary
						if l_boundary.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						if (not a_custom_content_type.is_void) then
							l_tmp := a_custom_content_type
						else
							l_tmp := ce_string ("Content-Type: multipart/form-data")
						end
						l_result := AddFormDataf ([l_form, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), ce_string ("%%s; boundary=%%s%R%N"), l_tmp, l_boundary])
						if l_result.to_boolean then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
							Result := l_result
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_firstform.item := l_form.item
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 20 -- skip loop
						end
				when 3 then -- loop body:
						if (l_size.item).to_boolean then
							l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%N")])
							if l_result.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_result := AddFormDataf ([l_form, l_size, ce_string ("--%%s%R%N"), l_boundary])
							if l_result.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_result := AddFormDataf ([l_form, l_size, ce_string ("Content-Disposition: form-data; name=%"")])
							if l_result.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_result := AddFormData (l_form, {PC_FORMTYPE}.FORM_DATA, create {CE_POINTER [ANY]}.make_cast (l_post.item.name), (l_post.item.namelength).to_natural_32, l_size)
							if l_result.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_result := AddFormDataf ([l_form, l_size, ce_string ("%"")])
							if l_result.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped and then (not (l_post.item.more).is_void) then
							l_fileboundary := Curl_FormBoundary
							l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%NContent-Type: multipart/mixed, boundary=%%s%R%N"), l_fileboundary])
							if l_result.to_boolean then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 19 -- skip if block
						end
				when 4 then -- if:
						l_file := l_post
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 18 -- skip loop
						end
				when 6 then -- loop body:
						if (not (l_post.item.more).is_void) then
							l_filebasename := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							if (l_file.item.showfilename).is_void then
								l_filebasename := strippath (l_file.item.contents)
								if l_filebasename.is_void then
									Curl_formclean (l_firstform)
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
							end
							if not js.return_called then
								if (not (l_file.item.showfilename).is_void) then
									l_tmp___0 := l_file.item.showfilename
								else
									l_tmp___0 := l_filebasename
								end
								l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%N--%%s%R%NContent-Disposition: attachment; filename=%"%%s%""), l_fileboundary, l_tmp___0])
								if (not l_filebasename.is_void) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_filebasename)])
								end
								if l_result.to_boolean then
									js.break
								end
							end
						elseif ((l_post.item.flags).bit_and (((((1).bit_or (((1).bit_shift_left (4))))).bit_or (((1).bit_shift_left (6)))).to_integer_32)).to_boolean then
							if (l_post.item.showfilename).is_void then
								l_tmp___2 := (strippath (l_post.item.contents))
							else
								l_tmp___2 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
							l_filebasename___0 := l_tmp___2
							if (not (l_post.item.showfilename).is_void) then
								l_tmp___3 := l_post.item.showfilename
							else
								l_tmp___3 := l_filebasename___0
							end
							l_result := AddFormDataf ([l_form, l_size, ce_string ("; filename=%"%%s%""), l_tmp___3])
							if (not l_filebasename___0.is_void) then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_filebasename___0)])
							end
							if l_result.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped and then (not (l_file.item.contenttype).is_void) then
							l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%NContent-Type: %%s"), l_file.item.contenttype])
							if l_result.to_boolean then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						l_curList := l_file.item.contentheader
						from
						until
							not (not js.loop_done and then (not l_curList.is_void))
						loop
							l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%N%%s"), l_curList.item.data])
							if l_result.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_curList := l_curList.item.next
							end
						end
						if l_result.to_boolean then
							Curl_formclean (l_firstform)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
							Result := l_result
							js.return
						end
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%N%R%N")])
						if l_result.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 9 then -- if:
						if not (((l_post.item.flags).bit_and (1)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (((l_post.item.flags).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						if (strequal_inst.curl_strequal (ce_string ("-"), l_file.item.contents)).to_boolean then
							l_fileread := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
						else
							l_fileread := (fopen (l_file.item.contents, ce_string ("rb")))
						end
						if (not l_fileread.is_void) then
							if not l_fileread.is_equal ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))) then
								fclose (l_fileread).do_nothing
								l_result := AddFormData (l_form, {PC_FORMTYPE}.FORM_FILE, create {CE_POINTER [ANY]}.make_cast (l_file.item.contents), (0).to_natural_32, l_size)
							else
								from
								until
									js.loop_done
								loop
									l_nread := fread (create {CE_POINTER [ANY]}.make_cast (l_buffer), (1).to_natural_32, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (512).to_natural_32), l_fileread)
									if l_nread = {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_result := AddFormData (l_form, {PC_FORMTYPE}.FORM_CONTENT, create {CE_POINTER [ANY]}.make_cast (l_buffer), l_nread, l_size)
										if l_result.to_boolean then
											js.break
										end
									end
								end
							end
							if l_result.to_boolean then
								Curl_formclean (l_firstform)
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
								Result := l_result
								js.return
							end
						else
							Curl_formclean (l_firstform)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
							a_finalform.item := create {CE_POINTER [PD_FORMDATA]}.make_shared (default_pointer)
							Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
							js.return
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						if ((l_post.item.flags).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
							l_result := AddFormData (l_form, {PC_FORMTYPE}.FORM_CONTENT, create {CE_POINTER [ANY]}.make_cast (l_post.item.buffer), (l_post.item.bufferlength).to_natural_32, l_size)
							if l_result.to_boolean then
								js.break
							end
						elseif ((l_post.item.flags).bit_and (((1).bit_shift_left (6)).to_integer_32)).to_boolean then
							l_result := AddFormData (l_form, {PC_FORMTYPE}.FORM_CALLBACK, l_post.item.userp, (l_post.item.contentslength).to_natural_32, l_size)
							if l_result.to_boolean then
								js.break
							end
						else
							l_result := AddFormData (l_form, {PC_FORMTYPE}.FORM_CONTENT, create {CE_POINTER [ANY]}.make_cast (l_post.item.contents), (l_post.item.contentslength).to_natural_32, l_size)
							if l_result.to_boolean then
								js.break
							end
						end
				when 16 then -- if done | if done
						if not js.loop_jumped then
							l_file := l_file.item.more
							if l_file.is_void then
								js.break
							end
						end
				when 17 then -- if done | if done
						l_pos := -1 + 5 -- back to loop condition
				when 18 then -- loop done
						if not js.return_called and then (l_result.to_boolean) then
							Curl_formclean (l_firstform)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
							Result := l_result
							js.return
						end
						if not js.return_called then
							if (not (l_post.item.more).is_void) then
								l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%N--%%s--"), l_fileboundary])
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_fileboundary)])
								if l_result.to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								l_post := l_post.item.next
								if l_post.is_void then
									js.break
								end
							end
						end
				when 19 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 20 then -- loop done | if done
						if not js.return_called and then (l_result.to_boolean) then
							Curl_formclean (l_firstform)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
							Result := l_result
							js.return
						end
						if not js.return_called then
							l_result := AddFormDataf ([l_form, l_size, ce_string ("%R%N--%%s--%R%N"), l_boundary])
							if l_result.to_boolean then
								Curl_formclean (l_firstform)
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
								Result := l_result
								js.return
							end
						end
						if not js.return_called then
							a_sizep.item := l_size.item
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_boundary)])
							a_finalform.item := l_firstform.item
							Result := l_result
						end
				when 21 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	FormAdd (a_httppost: CE_POINTER [CE_POINTER [PD_CURL_HTTPPOST]]; a_last_post: CE_POINTER [CE_POINTER [PD_CURL_HTTPPOST]]; a_params: CE_VA_LIST): NATURAL_32
		local
			l_params: CE_VA_LIST
			l_first_form: CE_POINTER [PD_FORMINFO]
			l_current_form: CE_POINTER [PD_FORMINFO]
			l_form: CE_POINTER [PD_FORMINFO]
			l_return_value: NATURAL_32
			l_prevtype: CE_POINTER [INTEGER_8]
			l_post: CE_POINTER [PD_CURL_HTTPPOST]
			l_option: NATURAL_32
			l_forms: CE_POINTER [PD_CURL_FORMS]
			l_array_value: CE_POINTER [INTEGER_8]
			l_array_state: BOOLEAN
			l_name: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_value: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_filename: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_filename___0: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_filename___1: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_buffer: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_userp: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_contenttype: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_list: CE_POINTER [PD_CURL_SLIST]
			l_tmp___23: CE_POINTER [PD_CURL_SLIST]
			l_filename___2: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_delete_form: CE_POINTER [PD_FORMINFO]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_params.make_shared (default_pointer)
			create l_first_form.make
			create l_current_form.make
			create l_form.make
			create l_prevtype.make
			create l_post.make
			create l_forms.make
			create l_array_value.make
			create l_name.make
			create l_tmp___1.make
			create l_value.make
			create l_tmp___4.make
			create l_filename.make
			create l_tmp___7.make
			create l_filename___0.make
			create l_tmp___9.make
			create l_filename___1.make
			create l_tmp___12.make
			create l_buffer.make
			create l_tmp___15.make
			create l_userp.make
			create l_tmp___18.make
			create l_contenttype.make
			create l_tmp___20.make
			create l_list.make
			create l_tmp___23.make
			create l_filename___2.make
			create l_tmp___25.make
			create l_delete_form.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_params := a_params.twin
					l_form := create {CE_POINTER [PD_FORMINFO]}.make_shared (default_pointer)
					l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OK
					l_prevtype := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_post := create {CE_POINTER [PD_CURL_HTTPPOST]}.make_shared (default_pointer)
					l_forms := create {CE_POINTER [PD_CURL_FORMS]}.make_shared (default_pointer)
					l_array_value := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_array_state := (0).to_boolean
					l_first_form := create {CE_POINTER [PD_FORMINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_FORMINFO}.make).structure_size.to_natural_32]))))
					if l_first_form.is_void then
						Result := ({PC_CURLFORMCODE}.CURL_FORMADD_MEMORY)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 56 -- skip if block
					end
				when 1 then -- if:
						l_current_form := l_first_form
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_return_value = {NATURAL_32} 0)) then
							l_pos := -1 + 27 -- skip loop
						end
				when 3 then -- loop body:
						if not l_array_state then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (not l_forms.is_void) then
							l_option := l_forms.item.option
							l_array_value := l_forms.item.value
							l_forms := l_forms + 1
							if {NATURAL_32} 17 = l_option then
								l_array_state := (0).to_boolean
								js.continue
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_option := l_params.natural_32_item
						if {NATURAL_32} 17 = l_option then
							js.break
						end
				when 7 then
						if js.loop_jumped then
							l_pos := -1 + 26 -- skip if block
						end
				when 8 then -- if:
						inspect l_option.to_integer_32 -- switch 1 head
						when 8 then l_pos := -1 + 9
						when 2 then l_pos := -1 + 10
						when 1 then l_pos := -1 + 11
						when 3 then l_pos := -1 + 12
						when 5 then l_pos := -1 + 13
						when 4 then l_pos := -1 + 14
						when 6 then l_pos := -1 + 15
						when 7 then l_pos := -1 + 16
						when 10 then l_pos := -1 + 17
						when 11 then l_pos := -1 + 18
						when 12 then l_pos := -1 + 19
						when 13 then l_pos := -1 + 20
						when 19 then l_pos := -1 + 21
						when 14 then l_pos := -1 + 22
						when 15 then l_pos := -1 + 23
						when 16 then l_pos := -1 + 24
						else l_pos := -1 + 25
						end
				when 9 then -- switch 1, case 8
						if l_array_state then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_ILLEGAL_ARRAY
						else
							l_forms := (create {CE_POINTER [PD_CURL_FORMS]}.make_cast (l_params.pointer_item))
							if (not l_forms.is_void) then
								l_array_state := (1).to_boolean
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 10 then -- switch 1, case 2
						l_current_form.item.flags := (l_current_form.item.flags).bit_or (((1).bit_shift_left (2)).to_integer_32)
				when 11 then -- switch 1, case 1
						if (not (l_current_form.item.name).is_void) then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							if l_array_state then
								l_tmp___1 := l_array_value
							else
								l_tmp___1 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
							end
							l_name := l_tmp___1
							if (not l_name.is_void) then
								l_current_form.item.name := l_name
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 12 then -- switch 1, case 3
						if (l_current_form.item.namelength).to_boolean then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						elseif l_array_state then
							l_current_form.item.namelength := (l_array_value.c_pointer.to_integer_32).to_natural_32
						else
							l_current_form.item.namelength := (l_params.integer_32_item).to_natural_32
						end
						l_pos := -1 + 26 -- switch 1; break
				when 13 then -- switch 1, case 5
						l_current_form.item.flags := (l_current_form.item.flags).bit_or (((1).bit_shift_left (3)).to_integer_32)
				when 14 then -- switch 1, case 4
						if (not (l_current_form.item.value).is_void) then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							if l_array_state then
								l_tmp___4 := l_array_value
							else
								l_tmp___4 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
							end
							l_value := l_tmp___4
							if (not l_value.is_void) then
								l_current_form.item.value := l_value
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 15 then -- switch 1, case 6
						if (l_current_form.item.contentslength).to_boolean then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						elseif l_array_state then
							l_current_form.item.contentslength := (l_array_value.c_pointer.to_integer_32).to_natural_32
						else
							l_current_form.item.contentslength := (l_params.integer_32_item).to_natural_32
						end
						l_pos := -1 + 26 -- switch 1; break
				when 16 then -- switch 1, case 7
						if l_current_form.item.flags /= 0 then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							if l_array_state then
								l_tmp___7 := l_array_value
							else
								l_tmp___7 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
							end
							l_filename := l_tmp___7
							if (not l_filename.is_void) then
								l_current_form.item.value := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_filename]))
								if (l_current_form.item.value).is_void then
									l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
								else
									l_current_form.item.flags := (l_current_form.item.flags).bit_or (((1).bit_shift_left (1)).to_integer_32)
									l_current_form.item.value_alloc := (1).to_boolean
								end
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 17 then -- switch 1, case 10
						if l_array_state then
							l_tmp___9 := l_array_value
						else
							l_tmp___9 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
						end
						l_filename___0 := l_tmp___9
						if (not (l_current_form.item.value).is_void) then
							if ((l_current_form.item.flags).bit_and (1)).to_boolean then
								if (not l_filename___0.is_void) then
									l_current_form := AddFormInfo ((create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_filename___0]))), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_current_form)
									if l_current_form.is_void then
										l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
									end
								else
									l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
								end
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
							end
						elseif (not l_filename___0.is_void) then
							l_current_form.item.value := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_filename___0]))
							if (l_current_form.item.value).is_void then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
							else
								l_current_form.item.flags := (l_current_form.item.flags).bit_or ((1))
								l_current_form.item.value_alloc := (1).to_boolean
							end
						else
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
						end
						l_pos := -1 + 26 -- switch 1; break
				when 18 then -- switch 1, case 11
						if l_array_state then
							l_tmp___12 := l_array_value
						else
							l_tmp___12 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
						end
						l_filename___1 := l_tmp___12
						if (not (l_current_form.item.value).is_void) then
							if ((l_current_form.item.flags).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
								if (not l_filename___1.is_void) then
									l_current_form := AddFormInfo ((create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_filename___1]))), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_current_form)
									if l_current_form.is_void then
										l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
									end
								else
									l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
								end
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
							end
						else
							if (not l_filename___1.is_void) then
								l_current_form.item.value := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_filename___1]))
								if (l_current_form.item.value).is_void then
									l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
								end
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
							l_current_form.item.flags := (l_current_form.item.flags).bit_or (((1).bit_shift_left (4)).to_integer_32)
						end
						l_pos := -1 + 26 -- switch 1; break
				when 19 then -- switch 1, case 12
						l_current_form.item.flags := (l_current_form.item.flags).bit_or (((1).bit_shift_left (5)).to_integer_32)
						if (not (l_current_form.item.buffer).is_void) then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							if l_array_state then
								l_tmp___15 := l_array_value
							else
								l_tmp___15 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
							end
							l_buffer := l_tmp___15
							if (not l_buffer.is_void) then
								l_current_form.item.buffer := l_buffer
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 20 then -- switch 1, case 13
						if (l_current_form.item.bufferlength).to_boolean then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						elseif l_array_state then
							l_current_form.item.bufferlength := (l_array_value.c_pointer.to_integer_32).to_natural_32
						else
							l_current_form.item.bufferlength := (l_params.integer_32_item).to_natural_32
						end
						l_pos := -1 + 26 -- switch 1; break
				when 21 then -- switch 1, case 19
						l_current_form.item.flags := (l_current_form.item.flags).bit_or (((1).bit_shift_left (6)).to_integer_32)
						if (not (l_current_form.item.userp).is_void) then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							if l_array_state then
								l_tmp___18 := l_array_value
							else
								l_tmp___18 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
							end
							l_userp := l_tmp___18
							if (not l_userp.is_void) then
								l_current_form.item.userp := l_userp
								l_current_form.item.value := l_userp
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 22 then -- switch 1, case 14
						if l_array_state then
							l_tmp___20 := l_array_value
						else
							l_tmp___20 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
						end
						l_contenttype := l_tmp___20
						if (not (l_current_form.item.contenttype).is_void) then
							if ((l_current_form.item.flags).bit_and (1)).to_boolean then
								if (not l_contenttype.is_void) then
									l_current_form := AddFormInfo (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_contenttype]))), l_current_form)
									if l_current_form.is_void then
										l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
									end
								else
									l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
								end
							else
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
							end
						elseif (not l_contenttype.is_void) then
							l_current_form.item.contenttype := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_contenttype]))
							if (l_current_form.item.contenttype).is_void then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
							else
								l_current_form.item.contenttype_alloc := (1).to_boolean
							end
						else
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_NULL
						end
						l_pos := -1 + 26 -- switch 1; break
				when 23 then -- switch 1, case 15
						if l_array_state then
							l_tmp___23 := create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_array_value)
						else
							l_tmp___23 := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_params.pointer_item))
						end
						l_list := l_tmp___23
						if (not (l_current_form.item.contentheader).is_void) then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							l_current_form.item.contentheader := l_list
						end
						l_pos := -1 + 26 -- switch 1; break
				when 24 then -- switch 1, case 16
						if l_array_state then
							l_tmp___25 := l_array_value
						else
							l_tmp___25 := (create {CE_POINTER [INTEGER_8]}.make_cast (l_params.pointer_item))
						end
						l_filename___2 := l_tmp___25
						if (not (l_current_form.item.showfilename).is_void) then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_OPTION_TWICE
						else
							l_current_form.item.showfilename := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_filename___2]))
							if (l_current_form.item.showfilename).is_void then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
							else
								l_current_form.item.showfilename_alloc := (1).to_boolean
							end
						end
						l_pos := -1 + 26 -- switch 1; break
				when 25 then -- switch 1, default:
						l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_UNKNOWN_OPTION
				when 26 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 27 then -- loop done
						if {NATURAL_32} 0 /= l_return_value then
							l_pos := -1 + 55 -- skip if block
						end
				when 28 then -- if:
						l_post := create {CE_POINTER [PD_CURL_HTTPPOST]}.make_shared (default_pointer)
						l_form := l_first_form
				when 29 then -- loop condition:
						if not (not js.loop_done and then (not l_form.is_void)) then
							l_pos := -1 + 55 -- skip loop
						end
				when 30 then -- loop body:
						if (not (l_form.item.name).is_void) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___7
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 33 then -- else:
						if (not (l_form.item.value).is_void) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if: | _L___7:
						if l_post.is_void then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_INCOMPLETE
							js.break
						else
							l_pos := -1 + 36 -- goto _L___6
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 36 then -- else: | _L___6:
						if not ((l_form.item.contentslength).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if ((l_form.item.flags).bit_and (1)).to_boolean then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_INCOMPLETE
							js.break
						else
							l_pos := -1 + 39 -- goto _L___5
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 39 then -- else: | _L___5:
						if not (((l_form.item.flags).bit_and (1)).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						if ((l_form.item.flags).bit_and (((1).bit_shift_left (3)).to_integer_32)).to_boolean then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_INCOMPLETE
							js.break
						else
							l_pos := -1 + 42 -- goto _L___4
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 42 then -- else: | _L___4:
						if (not (l_form.item.buffer).is_void) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if ((l_form.item.flags).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
							if ((l_form.item.flags).bit_and (((1).bit_shift_left (5)).to_integer_32)).to_boolean then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_INCOMPLETE
								js.break
							else
								l_pos := -1 + 45 -- goto _L___3
							end
						else
							l_pos := -1 + 45 -- goto _L___3
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 45 then -- else: | _L___3:
						if not (((l_form.item.flags).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if ((l_form.item.flags).bit_and (((1).bit_shift_left (3)).to_integer_32)).to_boolean then
							l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_INCOMPLETE
							js.break
						else
							l_pos := -1 + 48 -- goto _L___1
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 48 then -- else: | _L___1:
						if not (((l_form.item.flags).bit_and (1)).to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___0
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if not (((l_form.item.flags).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L___0:
						if (l_form.item.contenttype).is_void then
							l_form.item.contenttype := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([(ContentTypeForFilename (l_form.item.value, l_prevtype))]))
							if (l_form.item.contenttype).is_void then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
								js.break
							end
							if not js.loop_jumped then
								l_form.item.contenttype_alloc := (1).to_boolean
							end
						end
				when 53 then -- if done
						if not js.loop_jumped and then (not ((l_form.item.flags).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean) then
							if l_form.is_equal (l_first_form) then
								if (not (l_form.item.name).is_void) then
									l_form.item.name := memdup (l_form.item.name, l_form.item.namelength)
								end
								if (l_form.item.name).is_void then
									l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
									js.break
								end
								if not js.loop_jumped then
									l_form.item.name_alloc := (1).to_boolean
								end
							end
						end
						if not js.loop_jumped and then (not ((l_form.item.flags).bit_and (((((((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (3))))).bit_or (((1).bit_shift_left (5))))).bit_or (((1).bit_shift_left (6)))).to_integer_32)).to_boolean) then
							l_form.item.value := memdup (l_form.item.value, l_form.item.contentslength)
							if (l_form.item.value).is_void then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
								js.break
							end
							if not js.loop_jumped then
								l_form.item.value_alloc := (1).to_boolean
							end
						end
						if not js.loop_jumped then
							l_post := AddHttpPost (l_form.item.name, l_form.item.namelength, l_form.item.value, l_form.item.contentslength, l_form.item.buffer, l_form.item.bufferlength, l_form.item.contenttype, l_form.item.flags, l_form.item.contentheader, l_form.item.showfilename, l_form.item.userp, l_post, a_httppost, a_last_post)
							if l_post.is_void then
								l_return_value := {PC_CURLFORMCODE}.CURL_FORMADD_MEMORY
								js.break
							end
						end
						if not js.loop_jumped and then (not (l_form.item.contenttype).is_void) then
							l_prevtype := l_form.item.contenttype
						end
				when 54 then -- if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_form := l_form.item.more
						end
						l_pos := -1 + 29 -- back to loop condition
				when 55 then -- loop done | if done
						if l_return_value.to_boolean then
							if l_form.is_void then
								l_form := l_current_form
							end
							if (not l_form.is_void) then
								if l_form.item.name_alloc then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.name)])
								end
								if l_form.item.value_alloc then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.value)])
								end
								if l_form.item.contenttype_alloc then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.contenttype)])
								end
								if l_form.item.showfilename_alloc then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.showfilename)])
								end
							end
						end
						l_form := l_first_form
						from
						until
							l_form.is_void
						loop
							l_delete_form := l_form
							l_form := l_form.item.more
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_delete_form)])
						end
						Result := l_return_value
				when 56 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_formadd (a_args: TUPLE [a_httppost: CE_POINTER [CE_POINTER [PD_CURL_HTTPPOST]]; a_last_post: CE_POINTER [CE_POINTER [PD_CURL_HTTPPOST]]]): NATURAL_32
		local
			l_arg: CE_VA_LIST
			l_result: NATURAL_32
		do
			create l_arg.make_shared (default_pointer)

			l_arg := create {CE_VA_LIST}.make (a_args, 3)
			l_result := FormAdd (a_args.a_httppost, a_args.a_last_post, l_arg.twin)
			Result := l_result
		end

	curl_formfree (a_form: CE_POINTER [PD_CURL_HTTPPOST])
		local
			l_form: CE_POINTER [PD_CURL_HTTPPOST]
			l_next: CE_POINTER [PD_CURL_HTTPPOST]
			js: JUMP_STATE
		do
			create l_form.make
			create l_next.make

			l_form := a_form
			if l_form.is_void then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_next := l_form.item.next
					if (not (l_form.item.more).is_void) then
						curl_formfree (l_form.item.more)
					end
					if not ((l_form.item.flags).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean then
						if (not (l_form.item.name).is_void) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.name)])
						end
					end
					if not ((l_form.item.flags).bit_and (((((1).bit_shift_left (3))).bit_or (((1).bit_shift_left (6)))).to_integer_32)).to_boolean then
						if (not (l_form.item.contents).is_void) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.contents)])
						end
					end
					if (not (l_form.item.contenttype).is_void) then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.contenttype)])
					end
					if (not (l_form.item.showfilename).is_void) then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form.item.showfilename)])
					end
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_form)])
					l_form := l_next
					if l_form.is_void then
						js.break
					end
				end
			end
		end

	curl_formget (a_form: CE_POINTER [PD_CURL_HTTPPOST]; a_arg: CE_POINTER [ANY]; a_append: CE_ROUTINE): INTEGER_32
		local
			l_rc: NATURAL_32
			l_size: CE_ARRAY [INTEGER_64]
			l_data: CE_ARRAY [CE_POINTER [PD_FORMDATA]]
			l_ptr: CE_POINTER [PD_FORMDATA]
			l_buffer: CE_ARRAY [INTEGER_8]
			l_nread: NATURAL_32
			l_temp: CE_ARRAY [PD_FORM]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_size.make (<<1>>)
			create l_data.make (<<1>>)
			create l_ptr.make
			create l_buffer.make (<<8_192>>)
			create l_temp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rc := Curl_getFormData (l_data, a_form, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_size)
					if l_rc /= {NATURAL_32} 0 then
						Result := l_rc.to_integer_32
						js.return
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_ptr := l_data.item
				when 2 then -- loop condition:
						if not (not js.loop_done and then (not l_ptr.is_void)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 3 then -- loop body:
						if l_ptr.item.type /= {NATURAL_32} 3 then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						Curl_FormInit (l_temp, l_ptr).do_nothing
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 12 -- skip loop
						end
				when 6 then -- loop body:
						l_nread := readfromfile (l_temp, l_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32))
						if l_nread /= {NATURAL_32} 4_294_967_295 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_nread = (a_append.natural_32_item ([a_arg, l_buffer, l_nread])) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (not (l_temp.item.fp).is_void) then
							fclose (l_temp.item.fp).do_nothing
						end
						Curl_formclean (l_data)
						Result := (-1)
						js.return
				when 11 then -- if done
						if not js.return_called and then (l_nread /= ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32)) then
							js.break
						end
						l_pos := -1 + 5 -- back to loop condition
				when 12 then -- loop done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if l_ptr.item.length /= (a_append.natural_32_item ([a_arg, l_ptr.item.line, l_ptr.item.length])) then
							Curl_formclean (l_data)
							Result := (-1)
							js.return
						end
				when 14 then -- if done
						if not js.return_called then
							l_ptr := l_ptr.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 15 then -- loop done | if done
						if not js.return_called then
							Curl_formclean (l_data)
							Result := 0
						end
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	memdup (a_src: CE_POINTER [INTEGER_8]; a_buffer_length: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_length: NATURAL_32
			l_add: BOOLEAN
			l_buffer: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_buffer.make

			l_add := (0).to_boolean
			if a_buffer_length.to_boolean then
				l_length := a_buffer_length
			elseif (not a_src.is_void) then
				l_length := strlen (a_src)
				l_add := (1).to_boolean
			else
				Result := (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("")])))
				js.return
			end
			if not js.return_called then
				l_buffer := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_length + l_add.to_integer.to_natural_32]))))
				if l_buffer.is_void then
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_buffer), create {CE_POINTER [ANY]}.make_cast (a_src), l_length).do_nothing
				if l_add then
					l_buffer[l_length.to_integer_32] := (('%/0/').code).to_integer_8
				end
				Result := l_buffer
			end
		end

	readfromfile (a_form: CE_POINTER [PD_FORM]; a_buffer: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): NATURAL_32
		local
			l_nread: NATURAL_32
			l_callback: BOOLEAN
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_callback := ((a_form.item.data).item.type = {NATURAL_32} 2)
					if l_callback then
						l_nread := (a_form.item.fread_func).natural_32_item ([a_buffer, (1).to_natural_32, a_size, create {CE_POINTER [ANY]}.make_cast ((a_form.item.data).item.line)])
					else
						if (a_form.item.fp).is_void then
							a_form.item.fp := fopen ((a_form.item.data).item.line, ce_string ("rb"))
							if (a_form.item.fp).is_void then
								Result := (-1).to_natural_32
								js.return
							end
						end
						if not js.return_called then
							l_nread := fread (create {CE_POINTER [ANY]}.make_cast (a_buffer), (1).to_natural_32, a_size, a_form.item.fp)
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if l_nread.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (l_nread > a_size) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not l_callback then
							fclose (a_form.item.fp).do_nothing
							a_form.item.fp := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
						end
						a_form.item.data := (a_form.item.data).item.next
				when 6 then -- if done
						Result := l_nread
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strippath (a_fullfile: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_filename: CE_POINTER [INTEGER_8]
			l_base: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_filename.make
			create l_base.make

			l_filename := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_fullfile]))
			if l_filename.is_void then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_base := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([(xpg_basename (l_filename))]))
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_filename)])
				Result := l_base
			end
		end

end
