class
	P_IF2IP

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_if2ip (a_af: INTEGER_32; a_interface: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [INTEGER_8]; a_buf_size: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_iface: CE_POINTER [SD_IFADDRS]
			l_head: CE_ARRAY [CE_POINTER [SD_IFADDRS]]
			l_ip: CE_POINTER [INTEGER_8]
			l_addr: CE_POINTER [ANY]
			l_scope: CE_ARRAY [INTEGER_8]
			l_scopeid: NATURAL_32
			js: JUMP_STATE
		do
			create l_iface.make
			create l_head.make (<<1>>)
			create l_ip.make
			create l_addr.make
			create l_scope.make (<<12>>)

			l_ip := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (getifaddrs (l_head)) >= 0 then
				l_iface := l_head.item
				from
				until
					not (not js.loop_done and then (not l_iface.is_void))
				loop
					if not (l_iface.item.ifa_addr).is_void then
						if ((l_iface.item.ifa_addr).item.sa_family).to_integer_32 = a_af then
							if (strequal_inst.curl_strequal (l_iface.item.ifa_name, a_interface)).to_boolean then
								l_scope[0] := (('%/0/').code).to_integer_8
								l_scope[1] := (0).to_integer_8
								l_scope[2] := (0).to_integer_8
								l_scope[3] := (0).to_integer_8
								l_scope[4] := (0).to_integer_8
								l_scope[5] := (0).to_integer_8
								l_scope[6] := (0).to_integer_8
								l_scope[7] := (0).to_integer_8
								l_scope[8] := (0).to_integer_8
								l_scope[9] := (0).to_integer_8
								l_scope[10] := (0).to_integer_8
								l_scope[11] := (0).to_integer_8
								if a_af = 10 then
									l_scopeid := {NATURAL_32} 0
									l_addr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared ((create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_iface.item.ifa_addr)).c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr"))))
									l_scopeid := (create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_iface.item.ifa_addr)).item.sin6_scope_id
									if l_scopeid.to_boolean then
										mprintf_inst.curl_msnprintf ([l_scope, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (12).to_natural_32), ce_string ("%%%%%%u"), l_scopeid]).do_nothing
									end
								else
									l_addr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IN_ADDR]}.make_shared ((create {CE_POINTER [SD_SOCKADDR_IN]}.make_cast (l_iface.item.ifa_addr)).c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr"))))
								end
								l_ip := (inet_ntop (a_af, l_addr, a_buf, a_buf_size.to_natural_32))
								strequal_inst.Curl_strlcat (a_buf, l_scope, a_buf_size.to_natural_32).do_nothing
								js.break
							end
						end
					end
					if not js.loop_jumped then
						l_iface := l_iface.item.ifa_next
					end
				end
				freeifaddrs (l_head.item)
			end
			Result := l_ip
		end

end
