class
	P_NETRC

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_parsenetrc (a_host: CE_POINTER [INTEGER_8]; a_login: CE_POINTER [INTEGER_8]; a_password: CE_POINTER [INTEGER_8]; a_netrcfile: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_netrcfile: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [SD_IO_FILE]
			l_retcode: INTEGER_32
			l_specific_login: INTEGER_32
			l_home: CE_POINTER [INTEGER_8]
			l_home_alloc: BOOLEAN
			l_netrc_alloc: BOOLEAN
			l_state___3: INTEGER_32
			l_state_login: INTEGER_8
			l_state_password: INTEGER_8
			l_state_our_login: INTEGER_32
			l_pw: CE_POINTER [SD_PASSWD]
			l_tok: CE_POINTER [INTEGER_8]
			l_tok_buf: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_done: BOOLEAN
			l_netrcbuffer: CE_ARRAY [INTEGER_8]
			l_netrcbuffsize: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_netrcfile.make
			create l_file.make
			create l_home.make
			create l_pw.make
			create l_tok.make
			create l_tok_buf.make (<<1>>)
			create l_netrcbuffer.make (<<256>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_netrcfile := a_netrcfile
					l_retcode := 1
					l_specific_login := ((a_login[0]).to_integer_32 /= 0).to_integer
					l_home := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_home_alloc := (0).to_boolean
					l_netrc_alloc := (0).to_boolean
					l_state___3 := 0
					l_state_login := (0).to_integer_8
					l_state_password := (0).to_integer_8
					l_state_our_login := 0
					if l_netrcfile.is_void then
						l_home := getenv_inst.curl_getenv (ce_string ("HOME"))
						if (not l_home.is_void) then
							l_home_alloc := (1).to_boolean
						else
							l_pw := getpwuid ((geteuid))
							if (not l_pw.is_void) then
								l_home := l_pw.item.pw_dir
							end
						end
						if l_home.is_void then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_netrcfile := mprintf_inst.curl_maprintf ([ce_string ("%%s%%s%%s"), l_home, ce_string ("/"), ce_string (".netrc")])
							if l_netrcfile.is_void then
								if l_home_alloc then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_home)])
								end
								Result := (-1)
								js.return
							end
						end
						if not js.return_called then
							l_netrc_alloc := (1).to_boolean
						end
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						l_file := fopen (l_netrcfile, ce_string ("r"))
						if l_file.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						l_done := (0).to_boolean
						l_netrcbuffsize := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32
				when 3 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 15 -- skip loop
						end
				when 4 then -- loop body:
						if not l_done then
							if (fgets (l_netrcbuffer, l_netrcbuffsize, l_file)).is_void then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_tok := strtok_r (l_netrcbuffer, ce_string (" %T%N"), l_tok_buf)
				when 6 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 14 -- skip loop
						end
				when 7 then -- loop body:
						if not l_done then
							if l_tok.is_void then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped and then ((a_login[0]).to_boolean) then
							if (a_password[0]).to_boolean then
								l_done := (1).to_boolean
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						inspect l_state___3 -- switch 1 head
						when 0 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 9 then -- switch 1, case 0
						if (rawstr_inst.Curl_raw_equal (ce_string ("machine"), l_tok)).to_boolean then
							l_state___3 := 1
						end
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 1
						if (rawstr_inst.Curl_raw_equal (a_host, l_tok)).to_boolean then
							l_state___3 := 3
							l_retcode := 0
						else
							l_state___3 := 0
						end
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, case 3
						if l_state_login.to_boolean then
							if l_specific_login.to_boolean then
								l_state_our_login := rawstr_inst.Curl_raw_equal (a_login, l_tok)
							else
								strncpy (a_login, l_tok, (63).to_natural_32).do_nothing
							end
							l_state_login := (0).to_integer_8
						elseif l_state_password.to_boolean then
							if l_state_our_login.to_boolean then
								strncpy (a_password, l_tok, (63).to_natural_32).do_nothing
							elseif not l_specific_login.to_boolean then
								strncpy (a_password, l_tok, (63).to_natural_32).do_nothing
							end
							l_state_password := (0).to_integer_8
						elseif (rawstr_inst.Curl_raw_equal (ce_string ("login"), l_tok)).to_boolean then
							l_state_login := (1).to_integer_8
						elseif (rawstr_inst.Curl_raw_equal (ce_string ("password"), l_tok)).to_boolean then
							l_state_password := (1).to_integer_8
						elseif (rawstr_inst.Curl_raw_equal (ce_string ("machine"), l_tok)).to_boolean then
							l_state___3 := 1
							l_state_our_login := 0
						end
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
						l_tok := strtok_r (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" %T%N"), l_tok_buf)
				when 13 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 14 then -- loop done | if done
						l_pos := -1 + 3 -- back to loop condition
				when 15 then -- loop done
						fclose (l_file).do_nothing
				when 16 then -- if done
						if l_home_alloc then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_home)])
						end
						if l_netrc_alloc then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_netrcfile)])
						end
						Result := l_retcode
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
