class
	P_RTSP

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_rtsp.make (<<1>>)
		end

feature {ANY} -- attributes

	Curl_handler_rtsp: CE_ARRAY [PD_CURL_HANDLER]

feature {ANY} -- routines

	Curl_rtsp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_rtspreq: NATURAL_32
			l_rtsp: CE_POINTER [PD_RTSP]
			l_http: CE_POINTER [PD_HTTP]
			l_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_postsize: INTEGER_64
			l_putsize: INTEGER_64
			l_p_request: CE_POINTER [INTEGER_8]
			l_p_session_id: CE_POINTER [INTEGER_8]
			l_p_accept: CE_POINTER [INTEGER_8]
			l_p_accept_encoding: CE_POINTER [INTEGER_8]
			l_p_range: CE_POINTER [INTEGER_8]
			l_p_referrer: CE_POINTER [INTEGER_8]
			l_p_stream_uri: CE_POINTER [INTEGER_8]
			l_p_transport: CE_POINTER [INTEGER_8]
			l_p_uagent: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___19: INTEGER_64
			l_tmp___20: INTEGER_64
			l_tmp___24: CE_POINTER [INTEGER_64]
			l_tmp___25: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_rtsp.make
			create l_http.make
			create l_req_buffer.make
			create l_p_request.make
			create l_p_session_id.make
			create l_p_accept.make
			create l_p_accept_encoding.make
			create l_p_range.make
			create l_p_referrer.make
			create l_p_stream_uri.make
			create l_p_transport.make
			create l_p_uagent.make
			create l_tmp___0.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___16.make
			create l_tmp___17.make
			create l_tmp___24.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_result := {PC_CURLCODE}.CURLE_OK
					l_rtspreq := l_data.item.set.rtspreq
					l_postsize := (0).to_integer_64
					l_putsize := (0).to_integer_64
					l_p_request := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_session_id := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_accept := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_accept_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_range := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_referrer := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_stream_uri := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_transport := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_p_uagent := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					a_done.item := (1).to_boolean
					url_inst.Curl_reset_reqproto (a_conn)
					if (l_data.item.state.proto.rtsp).is_void then
						l_rtsp := create {CE_POINTER [PD_RTSP]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_RTSP}.make).structure_size.to_natural_32]))))
						if l_rtsp.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_data.item.state.proto.rtsp := l_rtsp
						end
					else
						l_rtsp := l_data.item.state.proto.rtsp
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_http := create {CE_POINTER [PD_HTTP]}.make_shared (l_rtsp.c_pointer + (create {PD_RTSP}.make).offset_of ("http_wrapper"))
						l_rtsp.item.CSeq_sent := l_data.item.state.rtsp_next_client_CSeq
						l_rtsp.item.CSeq_recv := 0
						l_data.item.set.opt_no_body := (1).to_boolean
						inspect l_rtspreq.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 5 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 8
						when 7 then l_pos := -1 + 9
						when 8 then l_pos := -1 + 10
						when 9 then l_pos := -1 + 11
						when 10 then l_pos := -1 + 12
						when 11 then l_pos := -1 + 13
						when 12 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 2 then -- switch 1, case 0
						sendf_inst.Curl_failf ([l_data, ce_string ("Got invalid RTSP request: RTSPREQ_NONE")])
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						js.return
				when 3 then -- switch 1, case 1
						if not js.return_called then
							l_p_request := ce_string ("OPTIONS")
						end
						l_pos := -1 + 15 -- switch 1; break
				when 4 then -- switch 1, case 2
						l_p_request := ce_string ("DESCRIBE")
						l_data.item.set.opt_no_body := (0).to_boolean
						l_pos := -1 + 15 -- switch 1; break
				when 5 then -- switch 1, case 3
						l_p_request := ce_string ("ANNOUNCE")
						l_pos := -1 + 15 -- switch 1; break
				when 6 then -- switch 1, case 4
						l_p_request := ce_string ("SETUP")
						l_pos := -1 + 15 -- switch 1; break
				when 7 then -- switch 1, case 5
						l_p_request := ce_string ("PLAY")
						l_pos := -1 + 15 -- switch 1; break
				when 8 then -- switch 1, case 6
						l_p_request := ce_string ("PAUSE")
						l_pos := -1 + 15 -- switch 1; break
				when 9 then -- switch 1, case 7
						l_p_request := ce_string ("TEARDOWN")
						l_pos := -1 + 15 -- switch 1; break
				when 10 then -- switch 1, case 8
						l_p_request := ce_string ("GET_PARAMETER")
						l_pos := -1 + 15 -- switch 1; break
				when 11 then -- switch 1, case 9
						l_p_request := ce_string ("SET_PARAMETER")
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 10
						l_p_request := ce_string ("RECORD")
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 11
						l_p_request := ce_string ("")
						l_data.item.set.opt_no_body := (0).to_boolean
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, case 12
						sendf_inst.Curl_failf ([l_data, ce_string ("Got invalid RTSP request: RTSPREQ_LAST")])
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						js.return
				when 15 then -- switch 1, done: | if done
						if not js.return_called and then (l_rtspreq = {NATURAL_32} 11) then
							transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
							Result := l_result
							js.return
						end
						if not js.return_called then
							l_p_session_id := l_data.item.set.str[33]
							if l_p_session_id.is_void then
								if ((l_rtspreq).bit_and ({NATURAL_32} 4_294_967_288)).to_boolean then
									if (not l_p_request.is_void) then
										l_tmp___0 := l_p_request
									else
										l_tmp___0 := ce_string ("")
									end
									sendf_inst.Curl_failf ([l_data, ce_string ("Refusing to issue an RTSP request [%%s] without a session ID."), l_tmp___0])
									Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
									js.return
								end
							end
						end
						if not js.return_called then
							if (not (l_data.item.set.str[34]).is_void) then
								l_p_stream_uri := l_data.item.set.str[34]
							else
								l_p_stream_uri := ce_string ("*")
							end
							l_p_transport := (http_inst.Curl_checkheaders (l_data, ce_string ("Transport:")))
							if l_rtspreq = {NATURAL_32} 4 then
								if l_p_transport.is_void then
									if (not (l_data.item.set.str[35]).is_void) then
										url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.rtsp_transport))
										a_conn.item.allocptr.rtsp_transport := mprintf_inst.curl_maprintf ([ce_string ("Transport: %%s%R%N"), l_data.item.set.str[35]])
										if (a_conn.item.allocptr.rtsp_transport).is_void then
											Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
											js.return
										end
									else
										sendf_inst.Curl_failf ([l_data, ce_string ("Refusing to issue an RTSP SETUP without a Transport: header.")])
										Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
										js.return
									end
									if not js.return_called then
										l_p_transport := a_conn.item.allocptr.rtsp_transport
									end
								end
							end
						end
						if not js.return_called and then (l_rtspreq = {NATURAL_32} 2) then
							if (not (http_inst.Curl_checkheaders (l_data, ce_string ("Accept:"))).is_void) then
								l_p_accept := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							else
								l_p_accept := ce_string ("Accept: application/sdp%R%N")
							end
							if (http_inst.Curl_checkheaders (l_data, ce_string ("Accept-Encoding:"))).is_void then
								if (not (l_data.item.set.str[6]).is_void) then
									url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.accept_encoding))
									a_conn.item.allocptr.accept_encoding := mprintf_inst.curl_maprintf ([ce_string ("Accept-Encoding: %%s%R%N"), l_data.item.set.str[6]])
									if (a_conn.item.allocptr.accept_encoding).is_void then
										Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
										js.return
									end
									if not js.return_called then
										l_p_accept_encoding := a_conn.item.allocptr.accept_encoding
									end
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if:
							if (http_inst.Curl_checkheaders (l_data, ce_string ("User-Agent:"))).is_void then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							if (not (a_conn.item.allocptr.uagent).is_void) then
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.uagent))
								a_conn.item.allocptr.uagent := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							else
								l_pos := -1 + 19 -- goto _L
							end
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 19 then -- else: | _L:
							if (http_inst.Curl_checkheaders (l_data, ce_string ("User-Agent:"))).is_void then
								if (not (l_data.item.set.str[25]).is_void) then
									l_p_uagent := a_conn.item.allocptr.uagent
								end
							end
				when 20 then
							url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.ref))
							if (not (l_data.item.change.referer).is_void) then
								if (not (http_inst.Curl_checkheaders (l_data, ce_string ("Referer:"))).is_void) then
									a_conn.item.allocptr.ref := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								else
									a_conn.item.allocptr.ref := mprintf_inst.curl_maprintf ([ce_string ("Referer: %%s%R%N"), l_data.item.change.referer])
								end
							else
								a_conn.item.allocptr.ref := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
							l_p_referrer := a_conn.item.allocptr.ref
							if l_data.item.state.use_range then
								if ((l_rtspreq).bit_and ({NATURAL_32} 15)).to_boolean then
									if (http_inst.Curl_checkheaders (l_data, ce_string ("Range:"))).is_void then
										if (not (l_data.item.state.range).is_void) then
											url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.rangeline))
											a_conn.item.allocptr.rangeline := mprintf_inst.curl_maprintf ([ce_string ("Range: %%s%R%N"), l_data.item.state.range])
											l_p_range := a_conn.item.allocptr.rangeline
										end
									end
								end
							end
							if (not (http_inst.Curl_checkheaders (l_data, ce_string ("CSeq:"))).is_void) then
								sendf_inst.Curl_failf ([l_data, ce_string ("CSeq cannot be set as a custom header.")])
								Result := ({PC_CURLCODE}.CURLE_RTSP_CSEQ_ERROR)
								js.return
							end
				when 21 then -- if done
						if not js.return_called then
							if (not (http_inst.Curl_checkheaders (l_data, ce_string ("Session:"))).is_void) then
								sendf_inst.Curl_failf ([l_data, ce_string ("Session ID cannot be set as a custom header.")])
								Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
								js.return
							end
						end
						if not js.return_called then
							l_req_buffer := http_inst.Curl_add_buffer_init
							if l_req_buffer.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
						if not js.return_called then
							if (not l_p_request.is_void) then
								l_tmp___11 := l_p_request
							else
								l_tmp___11 := ce_string ("")
							end
							l_result := http_inst.Curl_add_bufferf ([l_req_buffer, ce_string ("%%s %%s RTSP/1.0%R%NCSeq: %%ld%R%N"), l_tmp___11, l_p_stream_uri, l_rtsp.item.CSeq_sent])
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						if not js.return_called and then (not l_p_session_id.is_void) then
							l_result := http_inst.Curl_add_bufferf ([l_req_buffer, ce_string ("Session: %%s%R%N"), l_p_session_id])
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						if not js.return_called then
							if (not l_p_uagent.is_void) then
								l_tmp___12 := l_p_uagent
							else
								l_tmp___12 := ce_string ("")
							end
							if (not l_p_referrer.is_void) then
								l_tmp___13 := l_p_referrer
							else
								l_tmp___13 := ce_string ("")
							end
							if (not l_p_range.is_void) then
								l_tmp___14 := l_p_range
							else
								l_tmp___14 := ce_string ("")
							end
							if (not l_p_accept_encoding.is_void) then
								l_tmp___15 := l_p_accept_encoding
							else
								l_tmp___15 := ce_string ("")
							end
							if (not l_p_accept.is_void) then
								l_tmp___16 := l_p_accept
							else
								l_tmp___16 := ce_string ("")
							end
							if (not l_p_transport.is_void) then
								l_tmp___17 := l_p_transport
							else
								l_tmp___17 := ce_string ("")
							end
							l_result := http_inst.Curl_add_bufferf ([l_req_buffer, ce_string ("%%s%%s%%s%%s%%s%%s"), l_tmp___17, l_tmp___16, l_tmp___15, l_tmp___14, l_tmp___13, l_tmp___12])
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 27 -- skip if block
						end
				when 22 then -- if:
							if l_rtspreq /= {NATURAL_32} 4 then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							l_pos := -1 + 26 -- goto _L___0
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 25 then -- else:
							if l_rtspreq /= {NATURAL_32} 2 then
								l_pos := -1 + 27 -- skip if block
							end
				when 26 then -- if: | _L___0:
							l_result := http_inst.Curl_add_timecondition (l_data, l_req_buffer)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
				when 27 then -- if done | if done
							if not js.return_called then
								l_result := http_inst.Curl_add_custom_headers (a_conn, l_req_buffer)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							end
							if js.return_called then
								l_pos := -1 + 48 -- skip if block
							end
				when 28 then -- if:
								if l_rtspreq /= {NATURAL_32} 3 then
									l_pos := -1 + 31 -- skip if block
								end
				when 29 then -- if:
								l_pos := -1 + 35 -- goto _L___3
				when 30 then -- if block done, skip else block:
								l_pos := -1 + 48
				when 31 then -- else:
								if l_rtspreq /= {NATURAL_32} 9 then
									l_pos := -1 + 34 -- skip if block
								end
				when 32 then -- if:
								l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
								l_pos := -1 + 48
				when 34 then -- else:
								if l_rtspreq /= {NATURAL_32} 8 then
									l_pos := -1 + 48 -- skip if block
								end
				when 35 then -- if: | _L___3:
								if l_data.item.set.upload then
									l_putsize := l_data.item.set.infilesize
									l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_PUT
								else
									if l_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
										l_postsize := l_data.item.set.postfieldsize
									else
										if (not (l_data.item.set.postfields).is_void) then
											l_tmp___19 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_data.item.set.postfields))).to_integer_64
										else
											l_tmp___19 := (0).to_integer_64
										end
										l_postsize := l_tmp___19
									end
									l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
								end
								if not (l_putsize > {INTEGER_64} 0) then
									l_pos := -1 + 38 -- skip if block
								end
				when 36 then -- if:
								l_pos := -1 + 39 -- goto _L___2
				when 37 then -- if block done, skip else block:
								l_pos := -1 + 48
				when 38 then -- else:
								if not (l_postsize > {INTEGER_64} 0) then
									l_pos := -1 + 47 -- skip if block
								end
				when 39 then -- if: | _L___2:
								if (http_inst.Curl_checkheaders (l_data, ce_string ("Content-Length:"))).is_void then
									if l_data.item.set.upload then
										l_tmp___20 := l_putsize
									else
										l_tmp___20 := l_postsize
									end
									l_result := http_inst.Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_tmp___20])
									if l_result.to_boolean then
										Result := l_result
										js.return
									end
								end
								if js.return_called then
									l_pos := -1 + 45 -- skip if block
								end
				when 40 then -- if:
								if l_rtspreq /= {NATURAL_32} 9 then
									l_pos := -1 + 43 -- skip if block
								end
				when 41 then -- if:
								l_pos := -1 + 44 -- goto _L___1
				when 42 then -- if block done, skip else block:
								l_pos := -1 + 45
				when 43 then -- else:
								if l_rtspreq /= {NATURAL_32} 8 then
									l_pos := -1 + 45 -- skip if block
								end
				when 44 then -- if: | _L___1:
								if (http_inst.Curl_checkheaders (l_data, ce_string ("Content-Type:"))).is_void then
									l_result := http_inst.Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Type: text/parameters%R%N")])
									if l_result.to_boolean then
										Result := l_result
										js.return
									end
								end
				when 45 then -- if done | if done
								if not js.return_called and then (l_rtspreq = {NATURAL_32} 3) then
									if (http_inst.Curl_checkheaders (l_data, ce_string ("Content-Type:"))).is_void then
										l_result := http_inst.Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Type: application/sdp%R%N")])
										if l_result.to_boolean then
											Result := l_result
											js.return
										end
									end
								end
								if not js.return_called then
									l_data.item.state.expect100header := (0).to_boolean
								end
				when 46 then -- if block done, skip else block:
								l_pos := -1 + 48
				when 47 then -- else:
								if l_rtspreq = {NATURAL_32} 8 then
									l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_HEAD
									l_data.item.set.opt_no_body := (1).to_boolean
								end
				when 48 then -- if done | if done | if done | if done | if done
								if not js.return_called then
									l_data.item.req.forbidchunk := (1).to_boolean
									l_result := http_inst.Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
									if l_result.to_boolean then
										Result := l_result
										js.return
									end
								end
								if not js.return_called and then (l_postsize > {INTEGER_64} 0) then
									l_result := http_inst.Curl_add_buffer (l_req_buffer, l_data.item.set.postfields, l_postsize.to_natural_32)
									if l_result.to_boolean then
										Result := l_result
										js.return
									end
								end
								if not js.return_called then
									l_result := http_inst.Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, 0)
									if l_result.to_boolean then
										sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending RTSP request")])
										Result := l_result
										js.return
									end
								end
								if not js.return_called then
									if l_putsize.to_boolean then
										l_tmp___24 := create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("writebytecount"))
									else
										l_tmp___24 := create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer)
									end
									if l_putsize.to_boolean then
										l_tmp___25 := 0
									else
										l_tmp___25 := -1
									end
									transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), l_tmp___25, l_tmp___24)
									l_data.item.state.rtsp_next_client_CSeq := (l_data.item.state.rtsp_next_client_CSeq) + 1
									if (l_http.item.writebytecount).to_boolean then
										progress_inst.Curl_pgrsSetUploadCounter (l_data, l_http.item.writebytecount)
										if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
											l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
										end
									end
									Result := l_result
								end
				when 49 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	Curl_rtsp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_rtsp)
		end

	Curl_rtsp_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_httpStatus: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_data := a_conn.item.data
			l_httpStatus := http_inst.Curl_http_connect (a_conn, a_done)
			if l_data.item.state.rtsp_next_client_CSeq = 0 then
				l_data.item.state.rtsp_next_client_CSeq := 1
			end
			if l_data.item.state.rtsp_next_server_CSeq = 0 then
				l_data.item.state.rtsp_next_server_CSeq := 1
			end
			a_conn.item.proto.rtspc.rtp_channel := -1
			Result := l_httpStatus
		end

	Curl_rtsp_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_rtsp_connect)
		end

	Curl_rtsp_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		do
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proto.rtspc.rtp_buf))
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_rtsp_disconnect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_rtsp_disconnect)
		end

	Curl_rtsp_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_premature: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_rtsp: CE_POINTER [PD_RTSP]
			l_httpStatus: NATURAL_32
			l_CSeq_sent: INTEGER_32
			l_CSeq_recv: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_rtsp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_premature := a_premature
					l_data := a_conn.item.data
					l_rtsp := l_data.item.state.proto.rtsp
					if l_data.item.set.rtspreq = {NATURAL_32} 11 then
						l_premature := (1).to_boolean
					end
					l_httpStatus := http_inst.Curl_http_done (a_conn, a_status, l_premature)
					if l_rtsp.is_void then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_CSeq_sent := l_rtsp.item.CSeq_sent
						l_CSeq_recv := l_rtsp.item.CSeq_recv
						if l_data.item.set.rtspreq = {NATURAL_32} 11 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_CSeq_sent /= l_CSeq_recv then
							sendf_inst.Curl_failf ([l_data, ce_string ("The CSeq of this request %%ld did not match the response %%ld"), l_CSeq_sent, l_CSeq_recv])
							Result := ({PC_CURLCODE}.CURLE_RTSP_CSEQ_ERROR)
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_data.item.set.rtspreq = {NATURAL_32} 11 then
							if a_conn.item.proto.rtspc.rtp_channel = -1 then
								sendf_inst.Curl_infof ([l_data, ce_string ("Got an RTP Receive with a CSeq of %%ld%N"), l_CSeq_recv])
							end
						end
				when 5 then -- if done
						if not js.return_called then
							Result := l_httpStatus
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_rtsp_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_rtsp_done)
		end

	Curl_rtsp_parseheader (a_conn: CE_POINTER [PD_CONNECTDATA]; a_header: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_CSeq: CE_ARRAY [INTEGER_32]
			l_nc: INTEGER_32
			l_temp: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_data.make
			create l_CSeq.make (<<1>>)
			create l_temp.make
			create l_start.make
			create l_end.make

			l_data := a_conn.item.data
			l_CSeq.item := 0
			if (rawstr_inst.Curl_raw_nequal (ce_string ("CSeq:"), a_header, (strlen (ce_string ("CSeq:"))))).to_boolean then
				l_temp := (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_header])))
				if l_temp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					rawstr_inst.Curl_strntoupper (l_temp, l_temp, {PLATFORM}.Pointer_bytes.to_natural_32)
					l_nc := sscanf ([l_temp, ce_string ("CSEQ: %%ld"), l_CSeq])
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_temp)])
					if l_nc = 1 then
						(l_data.item.state.proto.rtsp).item.CSeq_recv := l_CSeq.item
						l_data.item.state.rtsp_CSeq_recv := l_CSeq.item
					else
						sendf_inst.Curl_failf ([l_data, ce_string ("Unable to read the CSeq header: [%%s]"), a_header])
						Result := ({PC_CURLCODE}.CURLE_RTSP_CSEQ_ERROR)
						js.return
					end
				end
			elseif (rawstr_inst.Curl_raw_nequal (ce_string ("Session:"), a_header, (strlen (ce_string ("Session:"))))).to_boolean then
				l_start := a_header + 9
				from
				until
					js.loop_done
				loop
					if (l_start[0]).to_boolean then
						if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_start := l_start + 1
					end
				end
				if not (l_start[0]).to_boolean then
					sendf_inst.Curl_failf ([l_data, ce_string ("Got a blank Session ID")])
				elseif (not (l_data.item.set.str[33]).is_void) then
					if (strncmp (l_start, l_data.item.set.str[33], (strlen (l_data.item.set.str[33])))) /= 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Got RTSP Session ID Line [%%s], but wanted ID [%%s]"), l_start, l_data.item.set.str[33]])
						Result := ({PC_CURLCODE}.CURLE_RTSP_SESSION_ERROR)
						js.return
					end
				else
					l_end := l_start
					from
					until
						js.loop_done
					loop
						if (l_end[0]).to_boolean then
							if not ((((ctype_b_loc).item[((l_end[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								if (l_end[0]).to_integer_32 /= 45 then
									if (l_end[0]).to_integer_32 /= 95 then
										if (l_end[0]).to_integer_32 /= 46 then
											if (l_end[0]).to_integer_32 /= 43 then
												if (l_end[0]).to_integer_32 = 92 then
													if (l_end[1]).to_boolean then
														if (l_end[1]).to_integer_32 = 36 then
															l_end := l_end + 1
														else
															js.break
														end
													else
														js.break
													end
												else
													js.break
												end
											end
										end
									end
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_end := l_end + 1
						end
					end
					l_data.item.set.str[33] := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([((l_end.distance (l_start)) + 1).to_natural_32]))))
					if (l_data.item.set.str[33]).is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if not js.return_called then
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_data.item.set.str[33]), create {CE_POINTER [ANY]}.make_cast (l_start), (l_end.distance (l_start)).to_natural_32).do_nothing;
						(l_data.item.set.str[33])[(l_end.distance (l_start))] := (('%/0/').code).to_integer_8
					end
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_rtsp_rtp_readwrite (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_nread: CE_POINTER [INTEGER_32]; a_readmore: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_rtspc: CE_POINTER [PD_RTSP_CONN]
			l_rtp: CE_POINTER [INTEGER_8]
			l_rtp_dataleft: INTEGER_32
			l_scratch: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_newptr: CE_POINTER [INTEGER_8]
			l_rtp_length: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_k.make
			create l_rtspc.make
			create l_rtp.make
			create l_scratch.make
			create l_newptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_rtspc := create {CE_POINTER [PD_RTSP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("rtspc"))
					if (not (l_rtspc.item.rtp_buf).is_void) then
						l_newptr := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_rtspc.item.rtp_buf), (l_rtspc.item.rtp_bufsize + a_nread.item).to_natural_32]))))
						if l_newptr.is_void then
							url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_rtspc.item.rtp_buf))
							l_rtspc.item.rtp_buf := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_rtspc.item.rtp_bufsize := 0
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_rtspc.item.rtp_buf := l_newptr
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_rtspc.item.rtp_buf + l_rtspc.item.rtp_bufsize)), create {CE_POINTER [ANY]}.make_cast (l_k.item.str), (a_nread.item).to_natural_32).do_nothing
							l_rtspc.item.rtp_bufsize := l_rtspc.item.rtp_bufsize + (a_nread.item)
							l_rtp := l_rtspc.item.rtp_buf
							l_rtp_dataleft := l_rtspc.item.rtp_bufsize
						end
					else
						l_rtp := l_k.item.str
						l_rtp_dataleft := a_nread.item
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							if l_rtp_dataleft > 0 then
								if (l_rtp[0]).to_integer_32 /= 36 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_rtp_dataleft > 4 then
									l_rtspc.item.rtp_channel := ((l_rtp[1]).to_natural_8).to_integer_32
									l_rtp_length := (((((l_rtp[2]).to_natural_8).to_integer_32).bit_shift_left (8))).bit_or (((l_rtp[3]).to_natural_8).to_integer_32)
									if l_rtp_dataleft < l_rtp_length + 4 then
										a_readmore.item := (1).to_boolean
										js.break
									else
										l_result := rtp_client_write (a_conn, l_rtp + 0, (l_rtp_length + 4).to_natural_32)
										if l_result.to_boolean then
											sendf_inst.Curl_failf ([a_data, ce_string ("Got an error writing an RTP packet")])
											a_readmore.item := (0).to_boolean
											url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_rtspc.item.rtp_buf))
											l_rtspc.item.rtp_buf := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
											l_rtspc.item.rtp_bufsize := 0
											Result := l_result
											js.return
										end
										if not js.return_called then
											l_rtp_dataleft := l_rtp_dataleft - (l_rtp_length + 4)
											l_rtp := l_rtp + (l_rtp_length + 4)
											if a_data.item.set.rtspreq = {NATURAL_32} 11 then
												l_k.item.keepon := (l_k.item.keepon).bit_and ((-2))
											end
										end
									end
								else
									a_readmore.item := (1).to_boolean
									js.break
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if l_rtp_dataleft = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_rtp[0]).to_integer_32 = 36 then
							l_scratch := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_rtp_dataleft.to_natural_32]))))
							if l_scratch.is_void then
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_rtspc.item.rtp_buf))
								l_rtspc.item.rtp_buf := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								l_rtspc.item.rtp_bufsize := 0
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
							if not js.return_called then
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_scratch), create {CE_POINTER [ANY]}.make_cast (l_rtp), l_rtp_dataleft.to_natural_32).do_nothing
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_rtspc.item.rtp_buf))
								l_rtspc.item.rtp_buf := l_scratch
								l_rtspc.item.rtp_bufsize := l_rtp_dataleft
								a_nread.item := 0
								Result := ({PC_CURLCODE}.CURLE_OK)
								js.return
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_k.item.str := l_k.item.str + (a_nread.item - l_rtp_dataleft)
						if l_rtp_dataleft > 0 then
						end
						a_nread.item := l_rtp_dataleft
				when 5 then -- if done
						if not js.return_called then
							url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_rtspc.item.rtp_buf))
							l_rtspc.item.rtp_buf := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_rtspc.item.rtp_bufsize := 0
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	rtp_client_write (a_conn: CE_POINTER [PD_CONNECTDATA]; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_wrote: NATURAL_32
			l_writeit: CE_ROUTINE
			js: JUMP_STATE
		do
			create l_data.make
			create l_writeit.make

			l_data := a_conn.item.data
			if a_len = {NATURAL_32} 0 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Cannot write a 0 size RTP packet.")])
				Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
				js.return
			end
			if not js.return_called then
				if (not (l_data.item.set.fwrite_rtp).is_void) then
					l_writeit := l_data.item.set.fwrite_rtp
				else
					l_writeit := l_data.item.set.fwrite_func
				end
				l_wrote := l_writeit.natural_32_item ([a_ptr, (1).to_natural_32, a_len, l_data.item.set.rtp_out])
				if {NATURAL_32} 268_435_457 = l_wrote then
					sendf_inst.Curl_failf ([l_data, ce_string ("Cannot pause RTP")])
					Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
					js.return
				end
			end
			if not js.return_called and then (l_wrote /= a_len) then
				sendf_inst.Curl_failf ([l_data, ce_string ("Failed writing RTP data")])
				Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	rtsp_getsock_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			a_socks[0] := a_conn.item.sock[0]
			Result := ((1).bit_shift_left (16))
		end

	rtsp_getsock_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rtsp_getsock_do)
		end

end
