class
	P_SENDF

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create s_infotype.make (<<7, 3>>)
		end

feature {ANY} -- attributes

	s_infotype: CE_ARRAY [CE_ARRAY [INTEGER_8]]

feature {ANY} -- routines

	Curl_client_write (a_conn: CE_POINTER [PD_CONNECTDATA]; a_type: INTEGER_32; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): NATURAL_32
		local
			l_len: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_wrote: NATURAL_32
			l_newlen: NATURAL_32
			l_newptr: CE_POINTER [INTEGER_8]
			l_writeit: CE_ROUTINE
			l_tmp___1: CE_ROUTINE
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_newptr.make
			create l_writeit.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_data := a_conn.item.data
					if {NATURAL_32} 0 = l_len then
						l_len := strlen (a_ptr)
					end
					if ((l_data.item.req.keepon).bit_and (((1).bit_shift_left (4)))).to_boolean then
						if a_type /= l_data.item.state.tempwritetype then
							Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
							js.return
						end
						if not js.return_called then
							l_newlen := l_len + l_data.item.state.tempwritesize
							l_newptr := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.tempwrite), l_newlen]))))
							if l_newptr.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
						if not js.return_called then
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_newptr + (l_data.item.state.tempwritesize).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (a_ptr), l_len).do_nothing
							l_data.item.state.tempwrite := l_newptr
							l_data.item.state.tempwritesize := l_newlen
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
					end
					if not js.return_called and then (((a_type).bit_and (1)).to_boolean) then
						if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean then
							if (a_conn.item.proto.ftpc.transfertype).to_integer_32 = 65 then
								l_len := convert_lineends (l_data, a_ptr, l_len)
							end
						end
						if l_len.to_boolean then
							l_wrote := (l_data.item.set.fwrite_func).natural_32_item ([a_ptr, (1).to_natural_32, l_len, l_data.item.set.out2])
						else
							l_wrote := l_len
						end
						if {NATURAL_32} 268_435_457 = l_wrote then
							Result := (pausewrite (l_data, a_type, a_ptr, l_len))
							js.return
						end
						if not js.return_called and then (l_wrote /= l_len) then
							Curl_failf ([l_data, ce_string ("Failed writing body (%%zu != %%zu)"), l_wrote, l_len])
							Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
							js.return
						end
					end
					if not (not js.return_called and then (((a_type).bit_and (((1).bit_shift_left (1)))).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.set.fwrite_header).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_data.item.set.writeheader).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (not (l_data.item.set.fwrite_header).is_void) then
							l_tmp___1 := l_data.item.set.fwrite_header
						else
							l_tmp___1 := l_data.item.set.fwrite_func
						end
						l_writeit := l_tmp___1
						l_wrote := l_writeit.natural_32_item ([a_ptr, (1).to_natural_32, l_len, l_data.item.set.writeheader])
						if {NATURAL_32} 268_435_457 = l_wrote then
							Result := (pausewrite (l_data, (1).bit_shift_left (1), a_ptr, l_len))
							js.return
						end
						if not js.return_called and then (l_wrote /= l_len) then
							Curl_failf ([l_data, ce_string ("Failed writing header")])
							Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_debug (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_type: NATURAL_32; a_ptr: CE_POINTER [INTEGER_8]; a_size: NATURAL_32; a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_rc: INTEGER_32
			l_buffer: CE_ARRAY [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
			l_w: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buffer.make (<<160>>)
			create l_t.make
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_data.item.set.printhost) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if a_conn.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if (a_conn.item.host.dispname).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_t := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_w := ce_string ("Data")
						inspect a_type.to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 4 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 1
						l_w := ce_string ("Header")
				when 5 then -- switch 1, case 3
						l_t := ce_string ("from")
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_w := ce_string ("Header")
				when 7 then -- switch 1, case 4
						l_t := ce_string ("to")
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if (not l_t.is_void) then
							mprintf_inst.curl_msnprintf ([l_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (160).to_natural_32), ce_string ("[%%s %%s %%s]"), l_w, l_t, a_conn.item.host.dispname]).do_nothing
							l_rc := showit (a_data, {PC_CURL_INFOTYPE}.CURLINFO_TEXT, l_buffer, (strlen (l_buffer)))
							if l_rc.to_boolean then
								Result := l_rc
								js.return
							end
						end
				when 10 then -- if done | if done | if done
						if not js.return_called then
							l_rc := showit (a_data, a_type, a_ptr, a_size)
							Result := l_rc
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_failf (a_args: TUPLE [a_data: CE_POINTER [PD_SESSIONHANDLE]; a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_ap: CE_VA_LIST
			l_len: NATURAL_32
		do
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, 3)
			mprintf_inst.curl_mvsnprintf (a_args.a_data.item.state.buffer, (16_384).to_natural_32, a_args.a_fmt, l_ap.twin).do_nothing
			if (not (a_args.a_data.item.set.errorbuffer).is_void) then
				if not a_args.a_data.item.state.errorbuf then
					mprintf_inst.curl_msnprintf ([a_args.a_data.item.set.errorbuffer, (256).to_natural_32, ce_string ("%%s"), a_args.a_data.item.state.buffer]).do_nothing
					a_args.a_data.item.state.errorbuf := (1).to_boolean
				end
			end
			if a_args.a_data.item.set.verbose then
				l_len := strlen ((a_args.a_data.item.state.buffer))
				if l_len < {NATURAL_32} 16_383 then
					a_args.a_data.item.state.buffer[l_len.to_integer_32] := (('%N').code).to_integer_8
					l_len := l_len + 1
					a_args.a_data.item.state.buffer[l_len.to_integer_32] := (('%/0/').code).to_integer_8
				end
				Curl_debug (a_args.a_data, {PC_CURL_INFOTYPE}.CURLINFO_TEXT, a_args.a_data.item.state.buffer, l_len, create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)).do_nothing
			end
		end

	Curl_infof (a_args: TUPLE [a_data: CE_POINTER [PD_SESSIONHANDLE]; a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_ap: CE_VA_LIST
			l_len: NATURAL_32
			l_print_buffer: CE_ARRAY [INTEGER_8]
		do
			create l_ap.make_shared (default_pointer)
			create l_print_buffer.make (<<2_049>>)

			if (not a_args.a_data.is_void) then
				if a_args.a_data.item.set.verbose then
					l_ap := create {CE_VA_LIST}.make (a_args, 3)
					mprintf_inst.curl_mvsnprintf (l_print_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (2_049).to_natural_32), a_args.a_fmt, l_ap.twin).do_nothing
					l_len := strlen (l_print_buffer)
					Curl_debug (a_args.a_data, {PC_CURL_INFOTYPE}.CURLINFO_TEXT, l_print_buffer, l_len, create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)).do_nothing
				end
			end
		end

	Curl_read (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sockfd: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_sizerequested: NATURAL_32; a_n: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_curlcode: CE_ARRAY [NATURAL_32]
			l_nread: INTEGER_32
			l_bytesfromsocket: NATURAL_32
			l_buffertofill: CE_POINTER [INTEGER_8]
			l_pipelining: BOOLEAN
			l_tmp___0: INTEGER_32
			l_num: INTEGER_32
			l_bytestocopy: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_curlcode.make (<<1>>)
			create l_buffertofill.make

			l_curlcode.item := {PC_CURLCODE}.CURLE_RECV_ERROR
			l_nread := 0
			l_bytesfromsocket := (0).to_natural_32
			l_buffertofill := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not ((a_conn.item.data).item.multi).is_void) then
				if (multi_inst.Curl_multi_canPipeline ((a_conn.item.data).item.multi)) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			l_pipelining := l_tmp___0.to_boolean
			l_num := (a_sockfd = a_conn.item.sock[1]).to_integer
			a_n.item := 0
			if l_pipelining then
				if a_conn.item.buf_len - a_conn.item.read_pos < a_sizerequested then
					l_tmp___1 := a_conn.item.buf_len - a_conn.item.read_pos
				else
					l_tmp___1 := a_sizerequested
				end
				l_bytestocopy := l_tmp___1
				if l_bytestocopy > {NATURAL_32} 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_buf), create {CE_POINTER [ANY]}.make_cast ((a_conn.item.master_buffer + (a_conn.item.read_pos).to_integer_32)), l_bytestocopy).do_nothing
					a_conn.item.read_pos := a_conn.item.read_pos + l_bytestocopy
					a_conn.item.bits.stream_was_rewound := (0).to_boolean
					a_n.item := l_bytestocopy.to_integer_32
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
				if not js.return_called then
					if a_sizerequested < {NATURAL_32} 16_384 * {PLATFORM}.Integer_8_bytes.to_natural_32 then
						l_bytesfromsocket := a_sizerequested
					else
						l_bytesfromsocket := {NATURAL_32} 16_384 * {PLATFORM}.Integer_8_bytes.to_natural_32
					end
					l_buffertofill := a_conn.item.master_buffer
				end
			else
				if ((a_conn.item.data).item.set.buffer_size).to_boolean then
					l_tmp___4 := (a_conn.item.data).item.set.buffer_size
				else
					l_tmp___4 := 16_384
				end
				if a_sizerequested.to_integer_32 < l_tmp___4 then
					l_bytesfromsocket := (a_sizerequested.to_integer_32).to_natural_32
				else
					if ((a_conn.item.data).item.set.buffer_size).to_boolean then
						l_tmp___3 := (a_conn.item.data).item.set.buffer_size
					else
						l_tmp___3 := 16_384
					end
					l_bytesfromsocket := l_tmp___3.to_natural_32
				end
				l_buffertofill := a_buf
			end
			if not js.return_called then
				l_nread := (a_conn.item.recv[l_num]).integer_32_item ([a_conn, l_num, l_buffertofill, l_bytesfromsocket, l_curlcode])
				if l_nread < 0 then
					Result := (l_curlcode.item)
					js.return
				end
			end
			if not js.return_called then
				if l_pipelining then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_buf), create {CE_POINTER [ANY]}.make_cast (a_conn.item.master_buffer), l_nread.to_natural_32).do_nothing
					a_conn.item.buf_len := l_nread.to_natural_32
					a_conn.item.read_pos := l_nread.to_natural_32
				end
				a_n.item := a_n.item + l_nread
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_read_plain (a_sockfd: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_bytesfromsocket: NATURAL_32; a_n: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_nread: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
		do
			l_nread := (recv (a_sockfd, create {CE_POINTER [ANY]}.make_cast (a_buf), a_bytesfromsocket, 0))
			if -1 = l_nread then
				l_err := (errno_location).item
				if 11 = l_err then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					js.return
				elseif 11 = l_err then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					js.return
				elseif 4 = l_err then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					js.return
				else
					Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
					js.return
				end
			end
			if not js.return_called then
				a_n.item := l_nread
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_recv_plain (a_conn: CE_POINTER [PD_CONNECTDATA]; a_num: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32; a_code: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_sockfd: INTEGER_32
			l_nread: INTEGER_32
			l_err: INTEGER_32
		do
			l_sockfd := a_conn.item.sock[a_num]
			l_nread := (recv (l_sockfd, create {CE_POINTER [ANY]}.make_cast (a_buf), a_len, 0))
			a_code.item := {PC_CURLCODE}.CURLE_OK
			if -1 = l_nread then
				l_err := (errno_location).item
				if 11 = l_err then
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
				elseif 11 = l_err then
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
				elseif 4 = l_err then
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
				else
					Curl_failf ([a_conn.item.data, ce_string ("Recv failure: %%s"), (strerror_inst.Curl_strerror (a_conn, l_err))])
					a_code.item := {PC_CURLCODE}.CURLE_RECV_ERROR
				end
			end
			Result := l_nread
		end

	Curl_recv_plain_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_recv_plain)
		end

	Curl_send_plain (a_conn: CE_POINTER [PD_CONNECTDATA]; a_num: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_code: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_sockfd: INTEGER_32
			l_bytes_written: INTEGER_32
			l_err: INTEGER_32
		do
			l_sockfd := a_conn.item.sock[a_num]
			l_bytes_written := (send (l_sockfd, a_mem, a_len, 16_384))
			a_code.item := {PC_CURLCODE}.CURLE_OK
			if -1 = l_bytes_written then
				l_err := (errno_location).item
				if 11 = l_err then
					l_bytes_written := 0
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
				elseif 11 = l_err then
					l_bytes_written := 0
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
				elseif 4 = l_err then
					l_bytes_written := 0
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
				else
					Curl_failf ([a_conn.item.data, ce_string ("Send failure: %%s"), (strerror_inst.Curl_strerror (a_conn, l_err))])
					a_code.item := {PC_CURLCODE}.CURLE_SEND_ERROR
				end
			end
			Result := l_bytes_written
		end

	Curl_send_plain_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_send_plain)
		end

	Curl_sendf (a_args: TUPLE [a_sockfd: INTEGER_32; a_conn: CE_POINTER [PD_CONNECTDATA]; a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_write_len: NATURAL_32
			l_res: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_sptr: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			js: JUMP_STATE
		do
			create l_data.make
			create l_bytes_written.make (<<1>>)
			create l_s.make
			create l_sptr.make
			create l_ap.make_shared (default_pointer)

			l_data := a_args.a_conn.item.data
			l_res := {PC_CURLCODE}.CURLE_OK
			l_ap := create {CE_VA_LIST}.make (a_args, 4)
			l_s := mprintf_inst.curl_mvaprintf (a_args.a_fmt, l_ap.twin)
			if l_s.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				l_bytes_written.item := 0
				l_write_len := strlen (l_s)
				l_sptr := l_s
				from
				until
					js.loop_done
				loop
					l_res := Curl_write (a_args.a_conn, a_args.a_sockfd, create {CE_POINTER [ANY]}.make_cast (l_sptr), l_write_len, l_bytes_written)
					if {NATURAL_32} 0 /= l_res then
						js.break
					end
					if not js.loop_jumped then
						if l_data.item.set.verbose then
							Curl_debug (l_data, {PC_CURL_INFOTYPE}.CURLINFO_DATA_OUT, l_sptr, (l_bytes_written.item).to_natural_32, a_args.a_conn).do_nothing
						end
						if (l_bytes_written.item).to_natural_32 /= l_write_len then
							l_write_len := l_write_len - (l_bytes_written.item).to_natural_32
							l_sptr := l_sptr + (l_bytes_written.item)
						else
							js.break
						end
					end
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_s)])
				Result := l_res
			end
		end

	Curl_write (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sockfd: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_written: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_bytes_written: INTEGER_32
			l_curlcode: CE_ARRAY [NATURAL_32]
			l_num: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_curlcode.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_curlcode.item := {PC_CURLCODE}.CURLE_OK
					l_num := (a_sockfd = a_conn.item.sock[1]).to_integer
					l_bytes_written := (a_conn.item.send[l_num]).integer_32_item ([a_conn, l_num, a_mem, a_len, l_curlcode])
					a_written.item := l_bytes_written
					if l_bytes_written >= 0 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect (l_curlcode.item).to_integer_32 -- switch 1 head
						when 81 then l_pos := -1 + 2
						when 0 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 81
						a_written.item := 0
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
				when 3 then -- switch 1, case 0
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
							js.return
						end
				when 4 then -- switch 1, default:
						if not js.return_called then
							Result := (l_curlcode.item)
						end
				when 5 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_write_plain (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sockfd: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_written: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_bytes_written: INTEGER_32
			l_retcode: CE_ARRAY [NATURAL_32]
			l_num: INTEGER_32
		do
			create l_retcode.make (<<1>>)

			l_num := (a_sockfd = a_conn.item.sock[1]).to_integer
			l_bytes_written := Curl_send_plain (a_conn, l_num, a_mem, a_len, l_retcode)
			a_written.item := l_bytes_written
			Result := (l_retcode.item)
		end

	convert_lineends (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_startPtr: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): NATURAL_32
		local
			l_size: NATURAL_32
			l_inPtr: CE_POINTER [INTEGER_8]
			l_outPtr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_inPtr.make
			create l_outPtr.make

			l_size := a_size
			if a_startPtr.is_void then
				Result := l_size
				js.return
			elseif l_size < {NATURAL_32} 1 then
				Result := l_size
				js.return
			end
			if not js.return_called then
				if (a_data.item.state.prev_block_had_trailing_cr).to_integer = 1 then
					if (a_startPtr[0]).to_integer_32 = 10 then
						memmove (create {CE_POINTER [ANY]}.make_cast (a_startPtr), create {CE_POINTER [ANY]}.make_cast ((a_startPtr + 1)), l_size - {NATURAL_32} 1).do_nothing
						l_size := l_size - 1
						a_data.item.state.crlf_conversions := (a_data.item.state.crlf_conversions) + 1
					end
					a_data.item.state.prev_block_had_trailing_cr := (0).to_boolean
				end
				l_outPtr := create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (a_startPtr), ('%R').code, l_size)))
				l_inPtr := l_outPtr
				if (not l_inPtr.is_void) then
					from
					until
						not ((l_inPtr.c_pointer.to_integer_32).to_natural_32 < (((a_startPtr + l_size.to_integer_32) - 1).c_pointer.to_integer_32).to_natural_32)
					loop
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_inPtr), create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)) = 0 then
							l_inPtr := l_inPtr + 1
							l_outPtr[0] := l_inPtr[0]
							a_data.item.state.crlf_conversions := (a_data.item.state.crlf_conversions) + 1
						elseif (l_inPtr[0]).to_integer_32 = 13 then
							l_outPtr[0] := (('%N').code).to_integer_8
						else
							l_outPtr[0] := l_inPtr[0]
						end
						l_outPtr := l_outPtr + 1
						l_inPtr := l_inPtr + 1
					end
					if (l_inPtr.c_pointer.to_integer_32).to_natural_32 < ((a_startPtr + l_size.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
						if (l_inPtr[0]).to_integer_32 = 13 then
							l_outPtr[0] := (('%N').code).to_integer_8
							a_data.item.state.prev_block_had_trailing_cr := (1).to_boolean
						else
							l_outPtr[0] := l_inPtr[0]
						end
						l_outPtr := l_outPtr + 1
					end
					if (l_outPtr.c_pointer.to_integer_32).to_natural_32 < ((a_startPtr + l_size.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
						l_outPtr[0] := (('%/0/').code).to_integer_8
					end
					Result := (l_outPtr.distance (a_startPtr)).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				Result := l_size
			end
		end

	pausewrite (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_type: INTEGER_32; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): NATURAL_32
		local
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_dupl: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_k.make
			create l_dupl.make

			l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_dupl := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([a_len]))))
			if l_dupl.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_dupl), create {CE_POINTER [ANY]}.make_cast (a_ptr), a_len).do_nothing
				a_data.item.state.tempwrite := l_dupl
				a_data.item.state.tempwritesize := a_len
				a_data.item.state.tempwritetype := a_type
				l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (4)))
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	showit (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_type: NATURAL_32; a_ptr: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not (a_data.item.set.fdebug).is_void) then
						Result := ((a_data.item.set.fdebug).integer_32_item ([create {CE_POINTER [ANY]}.make_cast (a_data), a_type, a_ptr, a_size, a_data.item.set.debugdata]))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_type.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 0 | switch 1, case 2 | switch 1, case 1
						fwrite (create {CE_POINTER [ANY]}.make_cast ((s_infotype[a_type.to_integer_32])), (2).to_natural_32, (1).to_natural_32, a_data.item.set.err).do_nothing
						fwrite (create {CE_POINTER [ANY]}.make_cast (a_ptr), a_size, (1).to_natural_32, a_data.item.set.err).do_nothing
						l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
						Result := 0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
