class
	P_SPLAY

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create KEY_NOTUSED.make
			create KEY_NOTUSED___0.make
		end

feature {ANY} -- attributes

	KEY_NOTUSED: SD_TIMEVAL assign set_KEY_NOTUSED

	set_KEY_NOTUSED (a_KEY_NOTUSED: SD_TIMEVAL)
		do
			KEY_NOTUSED := a_KEY_NOTUSED
		end

	KEY_NOTUSED___0: SD_TIMEVAL assign set_KEY_NOTUSED___0

	set_KEY_NOTUSED___0 (a_KEY_NOTUSED___0: SD_TIMEVAL)
		do
			KEY_NOTUSED___0 := a_KEY_NOTUSED___0
		end

feature {ANY} -- routines

	Curl_splay (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_N: CE_ARRAY [PD_CURL_TREE]
			l_l: CE_POINTER [PD_CURL_TREE]
			l_r: CE_POINTER [PD_CURL_TREE]
			l_y: CE_POINTER [PD_CURL_TREE]
			l_comp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_N.make (<<1>>)
			create l_l.make
			create l_r.make
			create l_y.make

			l_t := a_t
			if l_t.is_void then
				Result := l_t
				js.return
			end
			if not js.return_called then
				l_N.item.larger := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				l_N.item.smaller := l_N.item.larger
				l_r := l_N
				l_l := l_r
				from
				until
					js.loop_done
				loop
					if a_i.tv_sec < l_t.item.key.tv_sec then
						l_comp := -1
					else
						if a_i.tv_sec > l_t.item.key.tv_sec then
							l_tmp___1 := 1
						else
							if a_i.tv_usec < l_t.item.key.tv_usec then
								l_tmp___0 := -1
							else
								if a_i.tv_usec > l_t.item.key.tv_usec then
									l_tmp := 1
								else
									l_tmp := 0
								end
								l_tmp___0 := l_tmp
							end
							l_tmp___1 := l_tmp___0
						end
						l_comp := l_tmp___1.to_integer_32
					end
					if l_comp < 0 then
						if (l_t.item.smaller).is_void then
							js.break
						end
						if not js.loop_jumped then
							if a_i.tv_sec < (l_t.item.smaller).item.key.tv_sec then
								l_tmp___5 := -1
							else
								if a_i.tv_sec > (l_t.item.smaller).item.key.tv_sec then
									l_tmp___4 := 1
								else
									if a_i.tv_usec < (l_t.item.smaller).item.key.tv_usec then
										l_tmp___3 := -1
									else
										if a_i.tv_usec > (l_t.item.smaller).item.key.tv_usec then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
										l_tmp___3 := l_tmp___2
									end
									l_tmp___4 := l_tmp___3
								end
								l_tmp___5 := l_tmp___4
							end
							if l_tmp___5 < 0 then
								l_y := l_t.item.smaller
								l_t.item.smaller := l_y.item.larger
								l_y.item.larger := l_t
								l_t := l_y
								if (l_t.item.smaller).is_void then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_r.item.smaller := l_t
							l_r := l_t
							l_t := l_t.item.smaller
						end
					elseif l_comp > 0 then
						if (l_t.item.larger).is_void then
							js.break
						end
						if not js.loop_jumped then
							if a_i.tv_sec < (l_t.item.larger).item.key.tv_sec then
								l_tmp___9 := -1
							else
								if a_i.tv_sec > (l_t.item.larger).item.key.tv_sec then
									l_tmp___8 := 1
								else
									if a_i.tv_usec < (l_t.item.larger).item.key.tv_usec then
										l_tmp___7 := -1
									else
										if a_i.tv_usec > (l_t.item.larger).item.key.tv_usec then
											l_tmp___6 := 1
										else
											l_tmp___6 := 0
										end
										l_tmp___7 := l_tmp___6
									end
									l_tmp___8 := l_tmp___7
								end
								l_tmp___9 := l_tmp___8
							end
							if l_tmp___9 > 0 then
								l_y := l_t.item.larger
								l_t.item.larger := l_y.item.smaller
								l_y.item.smaller := l_t
								l_t := l_y
								if (l_t.item.larger).is_void then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_l.item.larger := l_t
							l_l := l_t
							l_t := l_t.item.larger
						end
					else
						js.break
					end
				end
				l_l.item.larger := l_t.item.smaller
				l_r.item.smaller := l_t.item.larger
				l_t.item.smaller := l_N.item.larger
				l_t.item.larger := l_N.item.smaller
				Result := l_t
			end
		end

	Curl_splaygetbest (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]; a_removed: CE_POINTER [CE_POINTER [PD_CURL_TREE]]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_x: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_x.make

			l_t := a_t
			if l_t.is_void then
				a_removed.item := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				Result := (create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_t := Curl_splay (a_i.twin, l_t)
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 < 0 then
					if (not (l_t.item.smaller).is_void) then
						l_t := Curl_splay (((l_t.item.smaller).item.key).twin, l_t)
					else
						a_removed.item := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
						Result := l_t
						js.return
					end
				end
			end
			if not js.return_called then
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___6 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___5 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___4 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
							l_tmp___4 := l_tmp___3
						end
						l_tmp___5 := l_tmp___4
					end
					l_tmp___6 := l_tmp___5
				end
				if l_tmp___6 >= 0 then
					l_x := l_t.item.same
					if (not l_x.is_void) then
						l_x.item.key := (l_t.item.key).twin
						l_x.item.larger := l_t.item.larger
						l_x.item.smaller := l_t.item.smaller
						a_removed.item := l_t
						Result := l_x
						js.return
					end
					if not js.return_called then
						if (l_t.item.smaller).is_void then
							l_x := l_t.item.larger
						else
							l_x := Curl_splay (a_i.twin, l_t.item.smaller)
							l_x.item.larger := l_t.item.larger
						end
						a_removed.item := l_t
						Result := l_x
					end
				else
					a_removed.item := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					Result := l_t
				end
			end
		end

	Curl_splayinsert (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]; a_node: CE_POINTER [PD_CURL_TREE]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [PD_CURL_TREE]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_tmp___3.make

			l_t := a_t
			if a_node.is_void then
				Result := l_t
				js.return
			end
			if not js.return_called and then (not l_t.is_void) then
				l_t := Curl_splay (a_i.twin, l_t)
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 = 0 then
					a_node.item.same := l_t
					a_node.item.key := a_i.twin
					a_node.item.smaller := l_t.item.smaller
					a_node.item.larger := l_t.item.larger
					l_t.item.smaller := a_node
					l_t.item.key := KEY_NOTUSED.twin
					Result := a_node
					js.return
				end
			end
			if not js.return_called then
				if l_t.is_void then
					l_tmp___3 := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					a_node.item.larger := l_tmp___3
					a_node.item.smaller := l_tmp___3
				else
					if a_i.tv_sec < l_t.item.key.tv_sec then
						l_tmp___7 := -1
					else
						if a_i.tv_sec > l_t.item.key.tv_sec then
							l_tmp___6 := 1
						else
							if a_i.tv_usec < l_t.item.key.tv_usec then
								l_tmp___5 := -1
							else
								if a_i.tv_usec > l_t.item.key.tv_usec then
									l_tmp___4 := 1
								else
									l_tmp___4 := 0
								end
								l_tmp___5 := l_tmp___4
							end
							l_tmp___6 := l_tmp___5
						end
						l_tmp___7 := l_tmp___6
					end
					if l_tmp___7 < 0 then
						a_node.item.smaller := l_t.item.smaller
						a_node.item.larger := l_t
						l_t.item.smaller := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					else
						a_node.item.larger := l_t.item.larger
						a_node.item.smaller := l_t
						l_t.item.larger := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					end
				end
				a_node.item.key := a_i.twin
				a_node.item.same := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				Result := a_node
			end
		end

	Curl_splayremovebyaddr (a_t: CE_POINTER [PD_CURL_TREE]; a_removenode: CE_POINTER [PD_CURL_TREE]; a_newroot: CE_POINTER [CE_POINTER [PD_CURL_TREE]]): INTEGER_32
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_x: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_x.make

			l_t := a_t
			if l_t.is_void then
				Result := 1
				js.return
			elseif a_removenode.is_void then
				Result := 1
				js.return
			end
			if not js.return_called then
				if KEY_NOTUSED___0.tv_sec < a_removenode.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if KEY_NOTUSED___0.tv_sec > a_removenode.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if KEY_NOTUSED___0.tv_usec < a_removenode.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if KEY_NOTUSED___0.tv_usec > a_removenode.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 = 0 then
					if (a_removenode.item.smaller).is_void then
						Result := 3
						js.return
					end
					if not js.return_called then
						(a_removenode.item.smaller).item.same := a_removenode.item.same
						if (not (a_removenode.item.same).is_void) then
							(a_removenode.item.same).item.smaller := a_removenode.item.smaller
						end
						a_removenode.item.smaller := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
						a_newroot.item := l_t
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				l_t := Curl_splay ((a_removenode.item.key).twin, l_t)
				if not l_t.is_equal (a_removenode) then
					Result := 2
					js.return
				end
			end
			if not js.return_called then
				l_x := l_t.item.same
				if (not l_x.is_void) then
					l_x.item.key := (l_t.item.key).twin
					l_x.item.larger := l_t.item.larger
					l_x.item.smaller := l_t.item.smaller
				elseif (l_t.item.smaller).is_void then
					l_x := l_t.item.larger
				else
					l_x := Curl_splay ((a_removenode.item.key).twin, l_t.item.smaller)
					l_x.item.larger := l_t.item.larger
				end
				a_newroot.item := l_x
				Result := 0
			end
		end

end
