class
	P_TFTP

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_tftp.make (<<1>>)
		end

feature {ANY} -- attributes

	Curl_handler_tftp: CE_ARRAY [PD_CURL_HANDLER]

feature {ANY} -- routines

	Curl_strnlen (a_string: CE_POINTER [INTEGER_8]; a_maxlen: NATURAL_32): NATURAL_32
		local
			l_end: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
		do
			create l_end.make

			l_end := create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (a_string), ('%/0/').code, a_maxlen)))
			if (not l_end.is_void) then
				l_tmp___0 := (l_end.distance (a_string)).to_natural_32
			else
				l_tmp___0 := a_maxlen
			end
			Result := l_tmp___0
		end

	getrpacketblock (a_packet: CE_POINTER [PD_TFTP_PACKET]): NATURAL_16
		do
			Result := (((((a_packet.item.data[2]).to_integer_32).bit_shift_left (8))).bit_or ((a_packet.item.data[3]).to_integer_32)).to_natural_16
		end

	getrpacketevent (a_packet: CE_POINTER [PD_TFTP_PACKET]): NATURAL_16
		do
			Result := (((((a_packet.item.data[0]).to_integer_32).bit_shift_left (8))).bit_or ((a_packet.item.data[1]).to_integer_32)).to_natural_16
		end

	setpacketblock (a_packet: CE_POINTER [PD_TFTP_PACKET]; a_num: NATURAL_16)
		do
			a_packet.item.data[2] := ((a_num.to_integer_32).bit_shift_right (8)).to_natural_8
			a_packet.item.data[3] := ((a_num.to_integer_32).bit_and (255)).to_natural_8
		end

	setpacketevent (a_packet: CE_POINTER [PD_TFTP_PACKET]; a_num: NATURAL_16)
		do
			a_packet.item.data[0] := ((a_num.to_integer_32).bit_shift_right (8)).to_natural_8
			a_packet.item.data[1] := ((a_num.to_integer_32).bit_and (255)).to_natural_8
		end

	tftp_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_code: NATURAL_32
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_blksize: INTEGER_32
			l_rc: INTEGER_32
			l_tmp: CE_POINTER [PD_TFTP_STATE_DATA]
			js: JUMP_STATE
		do
			create l_state___3.make
			create l_tmp.make

			l_blksize := 512
			url_inst.Curl_reset_reqproto (a_conn)
			l_tmp := create {CE_POINTER [PD_TFTP_STATE_DATA]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_TFTP_STATE_DATA}.make).structure_size.to_natural_32]))))
			a_conn.item.proto.tftpc := l_tmp
			l_state___3 := l_tmp
			if l_state___3.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called and then (((a_conn.item.data).item.set.tftp_blksize).to_boolean) then
				l_blksize := ((a_conn.item.data).item.set.tftp_blksize).to_integer_32
				if l_blksize > 65_464 then
					Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
					js.return
				elseif l_blksize < 8 then
					Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
					js.return
				end
			end
			if not js.return_called and then ((l_state___3.item.rpacket.data).is_void) then
				l_state___3.item.rpacket.data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, ((l_blksize + 2) + 2).to_natural_32]))))
				if (l_state___3.item.rpacket.data).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called and then ((l_state___3.item.spacket.data).is_void) then
				l_state___3.item.spacket.data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, ((l_blksize + 2) + 2).to_natural_32]))))
				if (l_state___3.item.spacket.data).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				a_conn.item.bits.close := (1).to_boolean
				l_state___3.item.conn := a_conn
				l_state___3.item.sockfd := (l_state___3.item.conn).item.sock[0]
				l_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_START
				l_state___3.item.error := -100
				l_state___3.item.blksize := 512
				l_state___3.item.requested_blksize := l_blksize;
				(create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("local_addr"))))).item.sa_family := ((a_conn.item.ip_addr).item.ai_family).to_natural_16
				tftp_set_timeouts (l_state___3).do_nothing
				if not a_conn.item.bits.bound then
					l_rc := bind (l_state___3.item.sockfd, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("local_addr")))), (a_conn.item.ip_addr).item.ai_addrlen)
					if l_rc.to_boolean then
						sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("bind() failed; %%s"), (strerror_inst.Curl_strerror (a_conn, (errno_location).item))])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					end
					if not js.return_called then
						a_conn.item.bits.bound := (1).to_boolean
					end
				end
			end
			if not js.return_called then
				progress_inst.Curl_pgrsStartNow (a_conn.item.data)
				a_done.item := (1).to_boolean
				l_code := {PC_CURLCODE}.CURLE_OK
				Result := l_code
			end
		end

	tftp_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_connect)
		end

	tftp_connect_for_rx (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		local
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data := (a_state___3.item.conn).item.data
			sendf_inst.Curl_infof ([l_data, ce_string ("%%s%N"), ce_string ("Connected for receive")])
			a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_RX
			l_res := tftp_set_timeouts (a_state___3)
			if l_res /= {NATURAL_32} 0 then
				Result := l_res
				js.return
			end
			if not js.return_called then
				Result := (tftp_rx (a_state___3, a_event))
			end
		end

	tftp_connect_for_tx (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		local
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data := (a_state___3.item.conn).item.data
			sendf_inst.Curl_infof ([l_data, ce_string ("%%s%N"), ce_string ("Connected for transmit")])
			a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_TX
			l_res := tftp_set_timeouts (a_state___3)
			if l_res /= {NATURAL_32} 0 then
				Result := l_res
				js.return
			end
			if not js.return_called then
				Result := (tftp_tx (a_state___3, a_event))
			end
		end

	tftp_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
		do
			create l_state___3.make

			l_state___3 := a_conn.item.proto.tftpc
			if (not l_state___3.is_void) then
				url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_state___3.item.rpacket.data))
				url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_state___3.item.spacket.data))
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_state___3)])
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	tftp_disconnect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_disconnect)
		end

	tftp_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_code: NATURAL_32
			js: JUMP_STATE
		do
			create l_state___3.make

			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			if (a_conn.item.proto.tftpc).is_void then
				l_code := tftp_connect (a_conn, a_done)
				if l_code.to_boolean then
					Result := l_code
					js.return
				end
			end
			if not js.return_called then
				l_state___3 := a_conn.item.proto.tftpc
				l_code := tftp_perform (a_conn, a_done)
				if l_code = {NATURAL_32} 0 then
					l_code := tftp_translate_code (l_state___3.item.error)
				end
				Result := l_code
			end
		end

	tftp_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_do)
		end

	tftp_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := tftp_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
			end
			Result := l_result
		end

	tftp_doing_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_doing)
		end

	tftp_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_code: NATURAL_32
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
		do
			create l_state___3.make

			l_code := {PC_CURLCODE}.CURLE_OK
			l_state___3 := a_conn.item.proto.tftpc
			progress_inst.Curl_pgrsDone (a_conn)
			l_code := tftp_translate_code (l_state___3.item.error)
			Result := l_code
		end

	tftp_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_done)
		end

	tftp_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_rc: INTEGER_32
			l_check_time: INTEGER_32
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_fd_read: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_transaction_start: SD_TIMEVAL
			l_error: INTEGER_32
			l_rtms: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_state___3.make
			create l_k.make
			create l_transaction_start.make

			l_check_time := 0
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_state___3 := a_conn.item.proto.tftpc
			l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_transaction_start := (timeval_inst.curlx_tvnow).twin
			l_k.item.start := l_transaction_start.twin
			l_k.item.now := l_transaction_start.twin
			from
			until
				js.loop_done
			loop
				if l_state___3.item.state /= {NATURAL_32} 3 then
					if l_result /= {NATURAL_32} 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_timeout_ms := (l_state___3.item.retry_time * 1_000).to_integer_32
					if l_data.item.set.upload then
						if (l_data.item.set.max_send_speed).to_boolean then
							if l_data.item.progress.ulspeed > l_data.item.set.max_send_speed then
								l_fd_read := -1
								l_timeout_ms := transfer_inst.Curl_sleep_time (l_data.item.set.max_send_speed, l_data.item.progress.ulspeed, l_state___3.item.blksize)
							else
								l_fd_read := l_state___3.item.sockfd
							end
						else
							l_fd_read := l_state___3.item.sockfd
						end
					elseif (l_data.item.set.max_recv_speed).to_boolean then
						if l_data.item.progress.dlspeed > l_data.item.set.max_recv_speed then
							l_fd_read := -1
							l_timeout_ms := transfer_inst.Curl_sleep_time (l_data.item.set.max_recv_speed, l_data.item.progress.dlspeed, l_state___3.item.blksize)
						else
							l_fd_read := l_state___3.item.sockfd
						end
					else
						l_fd_read := l_state___3.item.sockfd
					end
					if (l_data.item.set.timeout).to_boolean then
						l_timeout_ms := l_data.item.set.timeout - (timeval_inst.curlx_tvdiff ((l_k.item.now).twin, (l_k.item.start).twin))
						if l_timeout_ms > (l_state___3.item.retry_time * 1_000).to_integer_32 then
							l_timeout_ms := (l_state___3.item.retry_time * 1_000).to_integer_32
						elseif l_timeout_ms < 0 then
							l_timeout_ms := 0
						end
					end
					l_rc := select_inst.Curl_socket_ready (l_fd_read, -1, l_timeout_ms.to_integer_32)
					l_k.item.now := (timeval_inst.curlx_tvnow).twin
					if (timeval_inst.curlx_tvdiff ((l_k.item.now).twin, (l_k.item.start).twin)) >= l_data.item.set.timeout then
						if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
							tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR).do_nothing
							Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
							js.return
						end
						if not js.return_called then
							l_k.item.start := (l_k.item.now).twin
						end
					end
					if not js.return_called then
						if l_rc = -1 then
							l_error := (errno_location).item
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_conn, l_error))])
							l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR
						elseif l_rc = 0 then
							l_rtms := (l_state___3.item.retry_time * 1_000).to_integer_32
							if (timeval_inst.curlx_tvdiff ((l_k.item.now).twin, l_transaction_start.twin)) > l_rtms then
								l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_TIMEOUT
								l_check_time := 1
							else
								js.continue
							end
						else
							l_result := tftp_receive_packet (a_conn)
							if l_result = {NATURAL_32} 0 then
								l_transaction_start := (timeval_inst.curlx_tvnow).twin
							end
							if (not (l_k.item.bytecountp).is_void) then
								(l_k.item.bytecountp).item := l_k.item.bytecount
							end
							if (not (l_k.item.writebytecountp).is_void) then
								(l_k.item.writebytecountp).item := l_k.item.writebytecount
							end
						end
						if not js.loop_jumped then
							if l_check_time.to_boolean then
								tftp_state_timeout (a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
								l_check_time := 0
							end
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called then
								l_result := tftp_state_machine (l_state___3, l_state___3.item.event)
							end
						end
					end
				end
				if js.loop_increment then
					
				end
			end
			if not js.return_called then
				transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
				Result := l_result
			end
		end

	tftp_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not a_numsocks.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_socks[0] := a_conn.item.sock[0]
				Result := 1
			end
		end

	tftp_getsock_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_getsock)
		end

	tftp_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_rc: INTEGER_32
			l_event: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_timeout_ms: INTEGER_32
			l_error: INTEGER_32
			js: JUMP_STATE
		do
			create l_event.make (<<1>>)
			create l_data.make
			create l_state___3.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_state___3 := a_conn.item.proto.tftpc
			l_timeout_ms := (tftp_state_timeout (a_conn, l_event))
			a_done.item := (0).to_boolean
			if l_timeout_ms <= 0 then
				sendf_inst.Curl_failf ([l_data, ce_string ("TFTP response timeout")])
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				js.return
			elseif l_event.item /= -1 then
				l_result := tftp_state_machine (l_state___3, l_event.item)
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					js.return
				end
				if not js.return_called then
					a_done.item := (l_state___3.item.state = {NATURAL_32} 3)
					if a_done.item then
						transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
					end
				end
			else
				l_rc := select_inst.Curl_socket_ready (l_state___3.item.sockfd, -1, 0)
				if l_rc = -1 then
					l_error := (errno_location).item
					sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_conn, l_error))])
					l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR
				elseif l_rc /= 0 then
					l_result := tftp_receive_packet (a_conn)
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						js.return
					end
					if not js.return_called then
						l_result := tftp_state_machine (l_state___3, l_state___3.item.event)
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called then
						a_done.item := (l_state___3.item.state = {NATURAL_32} 3)
						if a_done.item then
							transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
						end
					end
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	tftp_multi_statemach_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_multi_statemach)
		end

	tftp_option_add (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_csize: NATURAL_32; a_buf: CE_POINTER [INTEGER_8]; a_option: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			js: JUMP_STATE
		do
			if ((strlen (a_option)) + a_csize) + {NATURAL_32} 1 > (a_state___3.item.blksize).to_natural_32 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				strcpy (a_buf, a_option).do_nothing
				Result := ((strlen (a_option)) + {NATURAL_32} 1)
			end
		end

	tftp_option_get (a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32; a_option: CE_POINTER [CE_POINTER [INTEGER_8]]; a_value: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_loc: NATURAL_32
			js: JUMP_STATE
		do
			l_loc := Curl_strnlen (a_buf, a_len)
			l_loc := l_loc + 1
			if l_loc >= a_len then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				a_option.item := a_buf
				l_loc := l_loc + (Curl_strnlen (a_buf + l_loc.to_integer_32, a_len - l_loc))
				l_loc := l_loc + 1
				if l_loc > a_len then
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				a_value.item := a_buf + ((strlen (a_option.item)) + {NATURAL_32} 1).to_integer_32
				Result := (a_buf + l_loc.to_integer_32)
			end
		end

	tftp_parse_option_ack (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_ptr: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): NATURAL_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_option: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_value: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_blksize: INTEGER_32
			l_tsize: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make
			create l_data.make
			create l_option.make (<<1>>)
			create l_value.make (<<1>>)

			l_tmp := a_ptr
			l_data := (a_state___3.item.conn).item.data
			a_state___3.item.blksize := 512
			from
			until
				not (not js.loop_done and then ((l_tmp.c_pointer.to_integer_32).to_natural_32 < ((a_ptr + a_len).c_pointer.to_integer_32).to_natural_32))
			loop
				l_tmp := tftp_option_get (l_tmp, ((a_ptr + a_len).distance (l_tmp)).to_natural_32, l_option, l_value)
				if l_tmp.is_void then
					sendf_inst.Curl_failf ([l_data, ce_string ("Malformed ACK packet, rejecting")])
					Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
					js.return
				end
				if not js.return_called then
					sendf_inst.Curl_infof ([l_data, ce_string ("got option=(%%s) value=(%%s)%N"), l_option.item, l_value.item])
					if (rawstr_inst.Curl_raw_nequal (l_option.item, ce_string ("blksize"), (strlen (l_option.item)))).to_boolean then
						l_blksize := strtol (l_value.item, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
						if not l_blksize.to_boolean then
							sendf_inst.Curl_failf ([l_data, ce_string ("invalid blocksize value in OACK packet")])
							Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
							js.return
						elseif l_blksize > 65_464 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s (%%d)"), ce_string ("blksize is larger than max supported"), 65_464])
							Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
							js.return
						elseif l_blksize < 8 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s (%%d)"), ce_string ("blksize is smaller than min supported"), 8])
							Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
							js.return
						elseif l_blksize > (a_state___3.item.requested_blksize).to_integer_32 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s (%%ld)"), ce_string ("server requested blksize larger than allocated"), l_blksize])
							Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
							js.return
						end
						if not js.return_called then
							a_state___3.item.blksize := l_blksize.to_integer_32
							sendf_inst.Curl_infof ([l_data, ce_string ("%%s (%%d) %%s (%%d)%N"), ce_string ("blksize parsed from OACK"), a_state___3.item.blksize, ce_string ("requested"), a_state___3.item.requested_blksize])
						end
					elseif (rawstr_inst.Curl_raw_nequal (l_option.item, ce_string ("tsize"), (strlen (l_option.item)))).to_boolean then
						l_tsize := 0
						l_tsize := strtol (l_value.item, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
						sendf_inst.Curl_infof ([l_data, ce_string ("%%s (%%ld)%N"), ce_string ("tsize parsed from OACK"), l_tsize])
						if not l_data.item.set.upload then
							if not l_tsize.to_boolean then
								sendf_inst.Curl_failf ([l_data, ce_string ("invalid tsize -:%%s:- value in OACK packet"), l_value.item])
								Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
								js.return
							end
							if not js.return_called then
								progress_inst.Curl_pgrsSetDownloadSize (l_data, l_tsize.to_integer_64)
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	tftp_perform (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			js: JUMP_STATE
		do
			create l_state___3.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_state___3 := a_conn.item.proto.tftpc
			a_dophase_done.item := (0).to_boolean
			l_result := tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_INIT)
			if l_state___3.item.state = {NATURAL_32} 3 then
				Result := l_result
				js.return
			elseif l_result /= {NATURAL_32} 0 then
				Result := l_result
				js.return
			end
			if not js.return_called then
				if (a_conn.item.data).item.state.used_interface = {NATURAL_32} 2 then
					tftp_multi_statemach (a_conn, a_dophase_done).do_nothing
				else
					l_result := tftp_easy_statemach (a_conn)
					a_dophase_done.item := (1).to_boolean
				end
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	tftp_receive_packet (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_fromaddr: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_fromlen: CE_ARRAY [NATURAL_32]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fromaddr.make (<<1>>)
			create l_fromlen.make (<<1>>)
			create l_data.make
			create l_state___3.make
			create l_k.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := a_conn.item.data
					l_state___3 := a_conn.item.proto.tftpc
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_fromlen.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
					l_state___3.item.rbytes := (recvfrom (l_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (l_state___3.item.rpacket.data), (l_state___3.item.blksize + 4).to_natural_32, 0, create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_fromaddr), l_fromlen))
					if l_state___3.item.remote_addrlen = {NATURAL_32} 0 then
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), create {CE_POINTER [ANY]}.make_cast (l_fromaddr), l_fromlen.item).do_nothing
						l_state___3.item.remote_addrlen := l_fromlen.item
					end
					if not (l_state___3.item.rbytes < 4) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						sendf_inst.Curl_failf ([l_data, ce_string ("Received too short packet")])
						l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_TIMEOUT
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						l_state___3.item.event := (getrpacketevent ((create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))))).to_integer_32
						inspect l_state___3.item.event -- switch 1 head
						when 3 then l_pos := -1 + 4
						when 5 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 3
						if l_state___3.item.rbytes > 4 then
							if ((((l_state___3.item.block).to_integer_32 + 1)).bit_and (65_535)) = (getrpacketblock ((create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))))).to_integer_32 then
								l_result := sendf_inst.Curl_client_write (a_conn, 1, create {CE_POINTER [INTEGER_8]}.make_cast (l_state___3.item.rpacket.data) + 4, (l_state___3.item.rbytes - 4).to_natural_32)
								if l_result.to_boolean then
									tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR).do_nothing
									Result := l_result
									js.return
								end
								if not js.return_called then
									l_k.item.bytecount := l_k.item.bytecount + (l_state___3.item.rbytes - 4).to_integer_64
									progress_inst.Curl_pgrsSetDownloadCounter (l_data, l_k.item.bytecount)
								end
							end
						end
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 5
						l_state___3.item.error := (getrpacketblock ((create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))))).to_integer_32
						sendf_inst.Curl_infof ([l_data, ce_string ("%%s%N"), create {CE_POINTER [INTEGER_8]}.make_cast (l_state___3.item.rpacket.data) + 4])
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 4
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_result := tftp_parse_option_ack (l_state___3, create {CE_POINTER [INTEGER_8]}.make_cast (l_state___3.item.rpacket.data) + 2, l_state___3.item.rbytes - 2)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), ce_string ("Internal error: Unexpected packet")])
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if not js.return_called then
							if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
								tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR).do_nothing
								Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
								js.return
							end
						end
				when 10 then -- if done
					if not js.return_called then
						Result := l_result
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_rx (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		local
			l_sbytes: INTEGER_32
			l_rblock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := (a_state___3.item.conn).item.data
					inspect a_event -- switch 1 head
					when 3 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 3
					when 7 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 3
					l_rblock := (getrpacketblock ((create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))))).to_integer_32
					if ((((a_state___3.item.block).to_integer_32 + 1)).bit_and (65_535)) /= l_rblock then
						sendf_inst.Curl_infof ([l_data, ce_string ("Received unexpected DATA packet block %%d%N"), l_rblock])
						a_state___3.item.retries := (a_state___3.item.retries) + 1
						if a_state___3.item.retries > a_state___3.item.retry_max then
							sendf_inst.Curl_failf ([l_data, ce_string ("tftp_rx: giving up waiting for block %%d"), (((a_state___3.item.block).to_integer_32 + 1)).bit_and (65_535)])
							Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
					end
				when 2 then
					if not js.return_called then
						a_state___3.item.block := l_rblock.to_natural_16
						a_state___3.item.retries := 0
						setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (4).to_natural_16)
						setpacketblock (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), a_state___3.item.block)
						l_sbytes := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen)
						if l_sbytes < 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
							Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
							js.return
						end
					end
					if not js.return_called then
						if a_state___3.item.rbytes < a_state___3.item.blksize + 4 then
							a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
						else
							a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_RX
						end
						time (create {CE_POINTER [INTEGER_32]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rx_time"))).do_nothing
					end
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 6
					a_state___3.item.block := (0).to_natural_16
					a_state___3.item.retries := 0
					setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (4).to_natural_16)
					setpacketblock (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), a_state___3.item.block)
					l_sbytes := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen)
					if l_sbytes < 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
						Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
						js.return
					end
					if not js.return_called then
						a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_RX
						time (create {CE_POINTER [INTEGER_32]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rx_time"))).do_nothing
					end
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 7
					a_state___3.item.retries := (a_state___3.item.retries) + 1
					sendf_inst.Curl_infof ([l_data, ce_string ("Timeout waiting for block %%d ACK.  Retries = %%d%N"), (((a_state___3.item.block).to_integer_32 + 1)).bit_and (65_535), a_state___3.item.retries])
					if a_state___3.item.retries > a_state___3.item.retry_max then
						a_state___3.item.error := -99
						a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
					else
						l_sbytes := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen)
						if l_sbytes < 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
							Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
							js.return
						end
					end
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 5
					setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (5).to_natural_16)
					setpacketblock (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), a_state___3.item.block)
					sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen).do_nothing
					a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), ce_string ("tftp_rx: internal error")])
					Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
					js.return
				when 7 then -- switch 1, done:
					if not js.return_called then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_send_first (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		local
			l_sbytes: NATURAL_32
			l_senddata: INTEGER_32
			l_mode___1: CE_POINTER [INTEGER_8]
			l_filename: CE_POINTER [INTEGER_8]
			l_buf: CE_ARRAY [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_res: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mode___1.make
			create l_filename.make
			create l_buf.make (<<64>>)
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mode___1 := ce_string ("octet")
					l_data := (a_state___3.item.conn).item.data
					l_res := {PC_CURLCODE}.CURLE_OK
					if l_data.item.set.prefer_ascii then
						l_mode___1 := ce_string ("netascii")
					end
					inspect a_event -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 7 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 0 | switch 1, case 7
					a_state___3.item.retries := (a_state___3.item.retries) + 1
					if a_state___3.item.retries > a_state___3.item.retry_max then
						a_state___3.item.error := -98
						a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
						Result := l_res
						js.return
					end
					if not js.return_called then
						if l_data.item.set.upload then
							setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (2).to_natural_16);
							((a_state___3.item.conn).item.data).item.req.upload_fromhere := create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + 4
							if l_data.item.set.infilesize /= -{INTEGER_64} 1 then
								progress_inst.Curl_pgrsSetUploadSize (l_data, l_data.item.set.infilesize)
							end
						else
							setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (1).to_natural_16)
						end
						l_filename := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (l_data), (((a_state___3.item.conn).item.data).item.state.path + 1), 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						if l_filename.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + 2, (a_state___3.item.blksize).to_natural_32, ce_string ("%%s%%c%%s%%c"), l_filename, ('%/0/').code, l_mode___1, ('%/0/').code]).do_nothing
						l_tmp := strlen (l_filename)
						l_sbytes := ({NATURAL_32} 4 + l_tmp) + (strlen (l_mode___1))
						if l_data.item.set.upload then
							if l_data.item.set.infilesize /= -{INTEGER_64} 1 then
								mprintf_inst.curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32), ce_string ("%%lld"), l_data.item.set.infilesize]).do_nothing
							else
								strcpy (l_buf, ce_string ("0")).do_nothing
							end
						else
							strcpy (l_buf, ce_string ("0")).do_nothing
						end
						l_sbytes := l_sbytes + (tftp_option_add (a_state___3, l_sbytes, create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + l_sbytes.to_integer_32, ce_string ("tsize")))
						l_sbytes := l_sbytes + (tftp_option_add (a_state___3, l_sbytes, create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + l_sbytes.to_integer_32, l_buf))
						mprintf_inst.curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32), ce_string ("%%d"), a_state___3.item.requested_blksize]).do_nothing
						l_sbytes := l_sbytes + (tftp_option_add (a_state___3, l_sbytes, create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + l_sbytes.to_integer_32, ce_string ("blksize")))
						l_sbytes := l_sbytes + (tftp_option_add (a_state___3, l_sbytes, create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + l_sbytes.to_integer_32, l_buf))
						mprintf_inst.curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32), ce_string ("%%d"), a_state___3.item.retry_time]).do_nothing
						l_sbytes := l_sbytes + (tftp_option_add (a_state___3, l_sbytes, create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + l_sbytes.to_integer_32, ce_string ("timeout")))
						l_sbytes := l_sbytes + (tftp_option_add (a_state___3, l_sbytes, create {CE_POINTER [INTEGER_8]}.make_cast (a_state___3.item.spacket.data) + l_sbytes.to_integer_32, l_buf))
						l_senddata := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), l_sbytes, 0, ((a_state___3.item.conn).item.ip_addr).item.ai_addr, ((a_state___3.item.conn).item.ip_addr).item.ai_addrlen)
						if l_senddata /= l_sbytes.to_integer_32 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
						end
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_filename))
					end
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 6
					if l_data.item.set.upload then
						l_res := tftp_connect_for_tx (a_state___3, a_event)
					else
						l_res := tftp_connect_for_rx (a_state___3, a_event)
					end
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 4
					l_res := tftp_connect_for_tx (a_state___3, a_event)
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 3
					l_res := tftp_connect_for_rx (a_state___3, a_event)
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 5
					a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					sendf_inst.Curl_failf ([(a_state___3.item.conn).item.data, ce_string ("tftp_send_first: internal error")])
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					if not js.return_called then
						Result := l_res
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_set_timeouts (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]): NATURAL_32
		local
			l_maxtime: INTEGER_32
			l_timeout: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_start: BOOLEAN
			js: JUMP_STATE
		do
			l_start := (a_state___3.item.state = {NATURAL_32} 0)
			time (create {CE_POINTER [INTEGER_32]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("start_time"))).do_nothing
			l_timeout_ms := connect_inst.Curl_timeleft (a_state___3.item.conn, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), l_start)
			if l_timeout_ms < 0 then
				sendf_inst.Curl_failf ([(a_state___3.item.conn).item.data, ce_string ("Connection time-out")])
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				js.return
			end
			if not js.return_called then
				if l_start then
					l_maxtime := (l_timeout_ms + 500) // 1_000
					a_state___3.item.max_time := a_state___3.item.start_time + l_maxtime
					l_timeout := l_maxtime
					a_state___3.item.retry_max := l_timeout.to_integer_32 // 5
					if a_state___3.item.retry_max < 1 then
						a_state___3.item.retry_max := 1
					end
					a_state___3.item.retry_time := l_timeout.to_integer_32 // a_state___3.item.retry_max
					if a_state___3.item.retry_time < 1 then
						a_state___3.item.retry_time := 1
					end
				else
					if l_timeout_ms > 0 then
						l_maxtime := (l_timeout_ms + 500) // 1_000
					else
						l_maxtime := (3_600).to_integer_32
					end
					a_state___3.item.max_time := a_state___3.item.start_time + l_maxtime
					l_timeout := l_maxtime // 10
					a_state___3.item.retry_max := l_timeout.to_integer_32 // 15
				end
				if a_state___3.item.retry_max < 3 then
					a_state___3.item.retry_max := 3
				end
				if a_state___3.item.retry_max > 50 then
					a_state___3.item.retry_max := 50
				end
				a_state___3.item.retry_time := (l_timeout // (a_state___3.item.retry_max).to_integer_32).to_integer_32
				if a_state___3.item.retry_time < 1 then
					a_state___3.item.retry_time := 1
				end
				sendf_inst.Curl_infof ([(a_state___3.item.conn).item.data, ce_string ("set timeouts for state %%d; Total %%ld, retry %%d maxtry %%d%N"), (a_state___3.item.state).to_integer_32, a_state___3.item.max_time - a_state___3.item.start_time, a_state___3.item.retry_time, a_state___3.item.retry_max])
				time (create {CE_POINTER [INTEGER_32]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rx_time"))).do_nothing
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	tftp_setup_connection (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_type: CE_POINTER [INTEGER_8]
			l_command: INTEGER_8
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_type.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					a_conn.item.socktype := 2
					l_type := strstr (l_data.item.state.path, ce_string (";mode="))
					if l_type.is_void then
						l_type := strstr (a_conn.item.host.rawalloc, ce_string (";mode="))
					end
					if l_type.is_void then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_type[0] := (0).to_integer_8
						l_command := rawstr_inst.Curl_raw_toupper (l_type[6])
						inspect l_command.to_integer_32 -- switch 1 head
						when 65 then l_pos := -1 + 2
						when 78 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 65 | switch 1, case 78
						l_data.item.set.prefer_ascii := (1).to_boolean
						l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
						l_data.item.set.prefer_ascii := (0).to_boolean
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done: | if done
						Result := ({PC_CURLCODE}.CURLE_OK)
				when 5 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	tftp_setup_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tftp_setup_connection)
		end

	tftp_state_machine (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		local
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_res := {PC_CURLCODE}.CURLE_OK
					l_data := (a_state___3.item.conn).item.data
					inspect (a_state___3.item.state).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					l_res := tftp_send_first (a_state___3, a_event)
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_res := tftp_rx (a_state___3, a_event)
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					l_res := tftp_tx (a_state___3, a_event)
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3
					sendf_inst.Curl_infof ([l_data, ce_string ("%%s%N"), ce_string ("TFTP finished")])
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), ce_string ("Internal state machine error")])
					l_res := {PC_CURLCODE}.CURLE_TFTP_ILLEGAL
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					Result := l_res
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_state_timeout (a_conn: CE_POINTER [PD_CONNECTDATA]; a_event: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_current: CE_ARRAY [INTEGER_32]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			js: JUMP_STATE
		do
			create l_current.make (<<1>>)
			create l_state___3.make

			l_state___3 := a_conn.item.proto.tftpc
			if (not a_event.is_void) then
				a_event.item := -1
			end
			time (l_current).do_nothing
			if l_current.item > l_state___3.item.max_time then
				l_state___3.item.error := -99
				l_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
				Result := 0
				js.return
			elseif l_current.item > l_state___3.item.rx_time + (l_state___3.item.retry_time).to_integer_32 then
				if (not a_event.is_void) then
					a_event.item := {PC_TFTP_EVENT_T}.TFTP_EVENT_TIMEOUT
				end
				time (create {CE_POINTER [INTEGER_32]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rx_time"))).do_nothing
			end
			if not js.return_called then
				Result := (l_state___3.item.max_time - l_current.item)
			end
		end

	tftp_translate_code (a_error: INTEGER_32): NATURAL_32
		local
			l_code: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_code := {PC_CURLCODE}.CURLE_OK
					if a_error = -100 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						inspect a_error -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 5
						when 5 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						when 7 then l_pos := -1 + 8
						when -99 then l_pos := -1 + 9 -- -99
						when -98 then l_pos := -1 + 10 -- -98
						else l_pos := -1 + 11
						end
				when 2 then -- switch 1, case 1
						l_code := {PC_CURLCODE}.CURLE_TFTP_NOTFOUND
						l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_code := {PC_CURLCODE}.CURLE_TFTP_PERM
						l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_code := {PC_CURLCODE}.CURLE_REMOTE_DISK_FULL
						l_pos := -1 + 12 -- switch 1; break
				when 5 then -- switch 1, case 0 | switch 1, case 4
						l_code := {PC_CURLCODE}.CURLE_TFTP_ILLEGAL
						l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 5
						l_code := {PC_CURLCODE}.CURLE_TFTP_UNKNOWNID
						l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_code := {PC_CURLCODE}.CURLE_REMOTE_FILE_EXISTS
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 7
						l_code := {PC_CURLCODE}.CURLE_TFTP_NOSUCHUSER
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case -99
						l_code := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case -98
						l_code := {PC_CURLCODE}.CURLE_COULDNT_CONNECT
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						l_code := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_code := {PC_CURLCODE}.CURLE_OK
				when 14 then -- if done
					Result := l_code
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_tx (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sbytes: INTEGER_32
			l_rblock: INTEGER_32
			l_res: NATURAL_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_k.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := (a_state___3.item.conn).item.data
					l_res := {PC_CURLCODE}.CURLE_OK
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					inspect a_event -- switch 1 head
					when 4 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 1
					when 7 then l_pos := -1 + 11
					when 5 then l_pos := -1 + 12
					else l_pos := -1 + 13
					end
				when 1 then -- switch 1, case 4 | switch 1, case 6
					if a_event /= 4 then
						l_pos := -1 + 9 -- skip if block
					end
				when 2 then -- if:
						l_rblock := (getrpacketblock ((create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))))).to_integer_32
						if l_rblock = (a_state___3.item.block).to_integer_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if (a_state___3.item.block).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_rblock /= 65_535 then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						sendf_inst.Curl_infof ([l_data, ce_string ("Received ACK for block %%d, expecting %%d%N"), l_rblock, (a_state___3.item.block).to_integer_32])
						a_state___3.item.retries := (a_state___3.item.retries) + 1
						if a_state___3.item.retries > a_state___3.item.retry_max then
							sendf_inst.Curl_failf ([l_data, ce_string ("tftp_tx: giving up waiting for block %%d ack"), (a_state___3.item.block).to_integer_32])
							l_res := {PC_CURLCODE}.CURLE_SEND_ERROR
						else
							l_sbytes := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")))), (4 + a_state___3.item.sbytes).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen)
							if l_sbytes < 0 then
								sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
								l_res := {PC_CURLCODE}.CURLE_SEND_ERROR
							end
						end
						Result := l_res
						js.return
				when 7 then -- if done
						if not js.return_called then
							time (create {CE_POINTER [INTEGER_32]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rx_time"))).do_nothing
							a_state___3.item.block := ((a_state___3.item.block).to_integer_32 + 1).to_natural_16
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						a_state___3.item.block := (1).to_natural_16
				when 10 then -- if done
					if not js.return_called then
						a_state___3.item.retries := 0
						setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (3).to_natural_16)
						setpacketblock (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), a_state___3.item.block)
						if (a_state___3.item.block).to_integer_32 > 1 then
							if a_state___3.item.sbytes < a_state___3.item.blksize then
								a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
								Result := ({PC_CURLCODE}.CURLE_OK)
								js.return
							end
						end
					end
					if not js.return_called then
						l_res := transfer_inst.Curl_fillreadbuffer (a_state___3.item.conn, a_state___3.item.blksize, create {CE_POINTER [INTEGER_32]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("sbytes")))
						if l_res.to_boolean then
							Result := l_res
							js.return
						end
					end
					if not js.return_called then
						l_sbytes := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4 + a_state___3.item.sbytes).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen)
						if l_sbytes < 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
							Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
							js.return
						end
					end
					if not js.return_called then
						l_k.item.writebytecount := l_k.item.writebytecount + (a_state___3.item.sbytes).to_integer_64
						progress_inst.Curl_pgrsSetUploadCounter (l_data, l_k.item.writebytecount)
					end
					l_pos := -1 + 14 -- switch 1; break
				when 11 then -- switch 1, case 7
					a_state___3.item.retries := (a_state___3.item.retries) + 1
					sendf_inst.Curl_infof ([l_data, ce_string ("Timeout waiting for block %%d ACK.  Retries = %%d%N"), (((a_state___3.item.block).to_integer_32 + 1)).bit_and (65_535), a_state___3.item.retries])
					if a_state___3.item.retries > a_state___3.item.retry_max then
						a_state___3.item.error := -99
						a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
					else
						l_sbytes := sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4 + a_state___3.item.sbytes).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen)
						if l_sbytes < 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("%%s"), (strerror_inst.Curl_strerror (a_state___3.item.conn, (errno_location).item))])
							Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
							js.return
						end
						if not js.return_called then
							progress_inst.Curl_pgrsSetUploadCounter (l_data, l_k.item.writebytecount)
						end
					end
					l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 5
					a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
					setpacketevent (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), (5).to_natural_16)
					setpacketblock (create {CE_POINTER [PD_TFTP_PACKET]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("spacket")), a_state___3.item.block)
					sendto (a_state___3.item.sockfd, create {CE_POINTER [ANY]}.make_cast (a_state___3.item.spacket.data), (4).to_natural_32, 16_384, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (a_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), a_state___3.item.remote_addrlen).do_nothing
					a_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
					l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:
					sendf_inst.Curl_failf ([l_data, ce_string ("tftp_tx: internal error, event: %%i"), a_event])
					l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done:
					if not js.return_called then
						Result := l_res
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
