class
	P_TIMEVAL

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_tvlong (a_t1: SD_TIMEVAL): INTEGER_32
		do
			Result := (a_t1.tv_sec)
		end

	curlx_tvdiff (a_newer: SD_TIMEVAL; a_older: SD_TIMEVAL): INTEGER_32
		do
			Result := ((a_newer.tv_sec - a_older.tv_sec) * 1_000 + (a_newer.tv_usec - a_older.tv_usec) // 1_000)
		end

	curlx_tvdiff_secs (a_newer: SD_TIMEVAL; a_older: SD_TIMEVAL): REAL_64
		do
			Result := ((a_newer.tv_sec - a_older.tv_sec).to_double + (a_newer.tv_usec - a_older.tv_usec).to_double / 1000000.0)
		end

	curlx_tvnow: SD_TIMEVAL
		local
			l_now: CE_ARRAY [SD_TIMEVAL]
			l_tsnow: CE_ARRAY [SD_TIMESPEC]
		do
			create l_now.make (<<1>>)
			create l_tsnow.make (<<1>>)

			if 0 = (clock_gettime (1, l_tsnow)) then
				l_now.item.tv_sec := l_tsnow.item.tv_sec
				l_now.item.tv_usec := l_tsnow.item.tv_nsec // 1_000
			else
				gettimeofday (l_now, create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
			end
			Result := (l_now.item).twin
		end

end
