class
	P_TRANSFER

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_do_perform (a_data: CE_POINTER [PD_SESSIONHANDLE]): NATURAL_32
		local
			l_res: NATURAL_32
			l_res2: NATURAL_32
			l_conn: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_newurl: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_follow: NATURAL_32
			l_do_done: CE_ARRAY [BOOLEAN]
			l_retry: BOOLEAN
			l_rc: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_conn.make (<<1>>)
			create l_newurl.make (<<1>>)
			create l_do_done.make (<<1>>)
			create l_str.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_conn.item := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
					l_newurl.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_follow := {PC_FOLLOWTYPE}.FOLLOW_NONE
					a_data.item.state.used_interface := {PC_USED_INTERFACE}.Curl_if_easy
					l_res := Curl_pretransfer (a_data)
					if l_res.to_boolean then
						Result := l_res
						js.return
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 16 -- skip loop
						end
				when 2 then -- loop body:
						l_res := connect_host (a_data, l_conn)
						if l_res /= {NATURAL_32} 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						if a_data.item.set.connect_only then
							l_conn.item.item.bits.close := (0).to_boolean
							l_res := url_inst.Curl_done (l_conn, {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						l_res := url_inst.Curl_do (l_conn, l_do_done)
						if l_res /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if (l_conn.item.item.data).item.set.wildcardmatch then
							if (l_conn.item.item.data).item.wildcard.state = {NATURAL_32} 6 then
								l_conn.item.item.bits.close := (0).to_boolean
								l_res := url_inst.Curl_done (l_conn, {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
								js.break
							elseif (l_conn.item.item.data).item.wildcard.state = {NATURAL_32} 4 then
								l_conn.item.item.bits.close := (0).to_boolean
								l_res := url_inst.Curl_done (l_conn, {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						l_res := Transfer (l_conn.item)
						if l_res /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_res /= {NATURAL_32} 56 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_retry := (0).to_boolean
						l_rc := (Curl_retry_request (l_conn.item, l_newurl))
						if l_rc.to_boolean then
							l_res := l_rc
						elseif (not (l_newurl.item).is_void) then
							l_retry := (1).to_boolean
						else
							l_retry := (0).to_boolean
						end
						if l_retry then
							l_res := {PC_CURLCODE}.CURLE_OK
							l_follow := {PC_FOLLOWTYPE}.FOLLOW_RETRY
						elseif l_res = {NATURAL_32} 0 then
							if (not (a_data.item.req.newurl).is_void) then
								l_follow := {PC_FOLLOWTYPE}.FOLLOW_REDIR
								l_newurl.item := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_data.item.req.newurl]))
								if (l_newurl.item).is_void then
									l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								end
							elseif (not (a_data.item.req.location).is_void) then
								l_follow := {PC_FOLLOWTYPE}.FOLLOW_FAKE
								l_newurl.item := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_data.item.req.location]))
								if (l_newurl.item).is_void then
									l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								end
							end
						end
				when 11 then -- if done
						if l_res /= {NATURAL_32} 0 then
							l_conn.item.item.bits.close := (1).to_boolean
							if -1 /= l_conn.item.item.sock[1] then
								close (l_conn.item.item.sock[1]).do_nothing
								l_conn.item.item.sock[1] := -1
							end
						end
						l_res2 := url_inst.Curl_done (l_conn, l_res, (0).to_boolean)
						if {NATURAL_32} 0 = l_res then
							l_res := l_res2
						end
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if (not (l_conn.item).is_void) then
							url_inst.Curl_done (l_conn, l_res, (0).to_boolean).do_nothing
						end
				when 14 then -- if done | if done
						if not js.loop_jumped and then (l_res = {NATURAL_32} 0) then
							if l_follow.to_boolean then
								l_res := Curl_follow (a_data, l_newurl.item, l_follow)
								if {NATURAL_32} 0 = l_res then
									l_newurl.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
									if l_follow >= {NATURAL_32} 2 then
										l_follow := {PC_FOLLOWTYPE}.FOLLOW_NONE
										js.continue
									end
								end
							end
						end
				when 15 then -- if done
						if not js.loop_jumped then
							js.break
						end
						if js.loop_increment then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
						if (not (l_newurl.item).is_void) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl.item)])
						end
						if l_res.to_boolean then
							if not a_data.item.state.errorbuf then
								l_str := (strerror_inst.curl_easy_strerror (l_res))
								if l_str.is_void then
									sendf_inst.Curl_failf ([a_data, ce_string ("unspecified error %%d"), l_res.to_integer_32])
								else
									sendf_inst.Curl_failf ([a_data, ce_string ("%%s"), l_str])
								end
							end
						end
						l_res2 := Curl_posttransfer (a_data)
						if not l_res.to_boolean then
							if l_res2.to_boolean then
								l_res := l_res2
							end
						end
						Result := l_res
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_fillreadbuffer (a_conn: CE_POINTER [PD_CONNECTDATA]; a_bytes: INTEGER_32; a_nreadp: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buffersize: NATURAL_32
			l_nread: INTEGER_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_hexbuffer: CE_ARRAY [INTEGER_8]
			l_endofline_native: CE_POINTER [INTEGER_8]
			l_endofline_network: CE_POINTER [INTEGER_8]
			l_hexlen: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_k.make
			create l_hexbuffer.make (<<11>>)
			create l_endofline_native.make
			create l_endofline_network.make

			l_data := a_conn.item.data
			l_buffersize := a_bytes.to_natural_32
			if l_data.item.req.upload_chunky then
				l_buffersize := l_buffersize - ({NATURAL_32} 12)
				l_data.item.req.upload_fromhere := l_data.item.req.upload_fromhere + (10)
			end
			l_nread := ((a_conn.item.fread_func).natural_32_item ([l_data.item.req.upload_fromhere, (1).to_natural_32, l_buffersize, a_conn.item.fread_in])).to_integer_32
			if l_nread = 268_435_456 then
				sendf_inst.Curl_failf ([l_data, ce_string ("operation aborted by callback")])
				a_nreadp.item := 0
				Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
				js.return
			elseif l_nread = 268_435_457 then
				l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
				l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (5)))
				if l_data.item.req.upload_chunky then
					l_data.item.req.upload_fromhere := l_data.item.req.upload_fromhere - (10)
				end
				a_nreadp.item := 0
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			elseif l_nread.to_natural_32 > l_buffersize then
				a_nreadp.item := 0
				sendf_inst.Curl_failf ([l_data, ce_string ("read function returned funny value")])
				Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
				js.return
			end
			if not js.return_called then
				if not l_data.item.req.forbidchunk then
					if l_data.item.req.upload_chunky then
						if l_data.item.set.crlf then
							l_endofline_native := ce_string ("%N")
							l_endofline_network := ce_string ("%N")
						elseif l_data.item.set.prefer_ascii then
							l_endofline_native := ce_string ("%N")
							l_endofline_network := ce_string ("%N")
						else
							l_endofline_native := ce_string ("%R%N")
							l_endofline_network := ce_string ("%R%N")
						end
						l_hexlen := mprintf_inst.curl_msnprintf ([l_hexbuffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (11).to_natural_32), ce_string ("%%x%%s"), l_nread, l_endofline_native])
						l_data.item.req.upload_fromhere := l_data.item.req.upload_fromhere - l_hexlen
						l_nread := l_nread + l_hexlen
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_data.item.req.upload_fromhere), create {CE_POINTER [ANY]}.make_cast (l_hexbuffer), l_hexlen.to_natural_32).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_data.item.req.upload_fromhere + l_nread)), create {CE_POINTER [ANY]}.make_cast (l_endofline_network), (strlen (l_endofline_network))).do_nothing
						if l_nread - l_hexlen = 0 then
							l_data.item.req.upload_done := (1).to_boolean
						end
						l_nread := l_nread + (strlen (l_endofline_native)).to_integer_32
					end
				end
				a_nreadp.item := l_nread
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_follow (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_newurl: CE_POINTER [INTEGER_8]; a_type: NATURAL_32): NATURAL_32
		local
			l_newurl: CE_POINTER [INTEGER_8]
			l_disallowport: BOOLEAN
			l_absolute: CE_POINTER [INTEGER_8]
			l_newest: CE_POINTER [INTEGER_8]
			l_newlen: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newurl.make
			create l_absolute.make
			create l_newest.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newurl := a_newurl
					l_disallowport := (0).to_boolean
					if a_type = {NATURAL_32} 3 then
						if a_data.item.set.maxredirs /= -1 then
							if a_data.item.set.followlocation >= a_data.item.set.maxredirs then
								sendf_inst.Curl_failf ([a_data, ce_string ("Maximum (%%ld) redirects followed"), a_data.item.set.maxredirs])
								Result := ({PC_CURLCODE}.CURLE_TOO_MANY_REDIRECTS)
								js.return
							end
						end
						if not js.return_called then
							a_data.item.state.this_is_a_follow := (1).to_boolean
							a_data.item.set.followlocation := (a_data.item.set.followlocation) + 1
							if a_data.item.set.http_auto_referer then
								if a_data.item.change.referer_alloc then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.referer)])
								end
								a_data.item.change.referer := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_data.item.change.url]))
								if (a_data.item.change.referer).is_void then
									a_data.item.change.referer_alloc := (0).to_boolean
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
								if not js.return_called then
									a_data.item.change.referer_alloc := (1).to_boolean
								end
							end
						end
					end
					if not js.return_called then
						if (is_absolute_url (l_newurl)) then
							l_disallowport := (1).to_boolean
							if (not (strchr (l_newurl, (' ').code)).is_void) then
								l_newlen := (strlen_url (l_newurl))
								l_newest := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_newlen + {NATURAL_32} 1]))))
								if l_newest.is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
								if not js.return_called then
									strcpy_url (l_newest, l_newurl)
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl)])
									l_newurl := l_newest
								end
							end
						else
							l_absolute := (concat_url (a_data.item.change.url, l_newurl))
							if l_absolute.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
							if not js.return_called then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl)])
								l_newurl := l_absolute
							end
						end
					end
					if not js.return_called and then (a_type = {NATURAL_32} 1) then
						a_data.item.info.wouldredirect := l_newurl
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if l_disallowport then
							a_data.item.state.allow_port := (0).to_boolean
						end
						if a_data.item.change.url_alloc then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.url)])
						else
							a_data.item.change.url_alloc := (1).to_boolean
						end
						a_data.item.change.url := l_newurl
						l_newurl := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						sendf_inst.Curl_infof ([a_data, ce_string ("Issue another request to this URL: %'%%s%'%N"), a_data.item.change.url])
						inspect a_data.item.info.httpcode -- switch 1 head
						when 301 then l_pos := -1 + 3
						when 302 then l_pos := -1 + 9
						when 303 then l_pos := -1 + 15
						when 304 then l_pos := -1 + 16
						when 305 then l_pos := -1 + 17
						else l_pos := -1 + 2
						end
				when 2 then -- switch 1, default:
						l_pos := -1 + 18 -- switch 1; break
				when 3 then -- switch 1, case 301
						if a_data.item.set.httpreq /= {NATURAL_32} 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_data.item.set.httpreq /= {NATURAL_32} 3 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if not a_data.item.set.post301 then
							sendf_inst.Curl_infof ([a_data, ce_string ("Violate RFC 2616/10.3.2 and switch from POST to GET%N")])
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
						end
				when 8 then -- if done
						l_pos := -1 + 18 -- switch 1; break
				when 9 then -- switch 1, case 302
						if a_data.item.set.httpreq /= {NATURAL_32} 2 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if a_data.item.set.httpreq /= {NATURAL_32} 3 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L___0:
						if not a_data.item.set.post302 then
							sendf_inst.Curl_infof ([a_data, ce_string ("Violate RFC 2616/10.3.3 and switch from POST to GET%N")])
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
						end
				when 14 then -- if done
						l_pos := -1 + 18 -- switch 1; break
				when 15 then -- switch 1, case 303
						if a_data.item.set.httpreq /= {NATURAL_32} 1 then
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
							if a_data.item.set.opt_no_body then
								l_tmp___4 := ce_string ("HEAD")
							else
								l_tmp___4 := ce_string ("GET")
							end
							sendf_inst.Curl_infof ([a_data, ce_string ("Disables POST, goes with %%s%N"), l_tmp___4])
						end
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 304
						l_pos := -1 + 18 -- switch 1; break
				when 17 then -- switch 1, case 305
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done:
						progress_inst.Curl_pgrsTime (a_data, {PC_TIMERID}.TIMER_REDIRECT)
						progress_inst.Curl_pgrsResetTimes (a_data)
						Result := ({PC_CURLCODE}.CURLE_OK)
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_perform (a_data: CE_POINTER [PD_SESSIONHANDLE]): NATURAL_32
		local
			l_res: NATURAL_32
			js: JUMP_STATE
		do
			if not a_data.item.set.wildcardmatch then
				Result := (Curl_do_perform (a_data))
				js.return
			end
			if not js.return_called then
				l_res := wildcard_inst.Curl_wildcard_init (create {CE_POINTER [PD_WILDCARDDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard")))
				if l_res.to_boolean then
					Result := l_res
					js.return
				end
			end
			if not js.return_called then
				l_res := Curl_do_perform (a_data)
				if l_res.to_boolean then
					wildcard_inst.Curl_wildcard_dtor (create {CE_POINTER [PD_WILDCARDDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard")))
					Result := l_res
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if not l_res.to_boolean then
						if a_data.item.wildcard.state = {NATURAL_32} 6 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_res := Curl_do_perform (a_data)
					end
				end
				wildcard_inst.Curl_wildcard_dtor (create {CE_POINTER [PD_WILDCARDDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard")))
				a_data.item.wildcard.state := {PC_CURL_WILDCARD_STATES}.CURLWC_INIT
				Result := l_res
			end
		end

	Curl_posttransfer (a_data: CE_POINTER [PD_SESSIONHANDLE]): NATURAL_32
		do
			if not ((a_data.item.progress.flags).bit_and (((1).bit_shift_left (4)))).to_boolean then
				if not a_data.item.progress.callback then
					mprintf_inst.curl_mfprintf ([a_data.item.set.err, ce_string ("%N")]).do_nothing
				end
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_pretransfer (a_data: CE_POINTER [PD_SESSIONHANDLE]): NATURAL_32
		local
			l_res: NATURAL_32
			js: JUMP_STATE
		do
			if (a_data.item.change.url).is_void then
				sendf_inst.Curl_failf ([a_data, ce_string ("No URL set!")])
				Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
				js.return
			end
			if not js.return_called then
				l_res := {PC_CURLCODE}.CURLE_OK
				if l_res.to_boolean then
					Result := l_res
					js.return
				end
			end
			if not js.return_called then
				a_data.item.set.followlocation := 0
				a_data.item.state.this_is_a_follow := (0).to_boolean
				a_data.item.state.errorbuf := (0).to_boolean
				a_data.item.state.httpversion := 0
				a_data.item.state.ssl_connect_retry := (0).to_boolean
				a_data.item.state.authproblem := (0).to_boolean
				a_data.item.state.authhost.want := a_data.item.set.httpauth
				a_data.item.state.authproxy.want := a_data.item.set.proxyauth
				url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.info.wouldredirect))
				a_data.item.info.wouldredirect := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				if (not (a_data.item.change.cookielist).is_void) then
					cookie_inst.Curl_cookie_loadfiles (a_data)
				end
				a_data.item.state.allow_port := (1).to_boolean
				getinfo_inst.Curl_initinfo (a_data).do_nothing
				progress_inst.Curl_pgrsStartNow (a_data)
				if (a_data.item.set.timeout).to_boolean then
					multi_inst.Curl_expire (a_data, a_data.item.set.timeout)
				end
				if (a_data.item.set.connecttimeout).to_boolean then
					multi_inst.Curl_expire (a_data, a_data.item.set.connecttimeout)
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_readrewind (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_err: INTEGER_32
			l_err___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_conn.item.data
			a_conn.item.bits.rewindaftersend := (0).to_boolean
			l_data.item.req.keepon := (l_data.item.req.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
			if (l_data.item.set.postfields).is_void then
				if l_data.item.set.httpreq /= {NATURAL_32} 3 then
					if (not (l_data.item.set.seek_func).is_void) then
						l_err := (l_data.item.set.seek_func).integer_32_item ([l_data.item.set.seek_client, (0).to_integer_64, 0])
						if l_err.to_boolean then
							sendf_inst.Curl_failf ([l_data, ce_string ("seek callback returned error %%d"), l_err])
							Result := ({PC_CURLCODE}.CURLE_SEND_FAIL_REWIND)
							js.return
						end
					elseif (not (l_data.item.set.ioctl_func).is_void) then
						l_err___0 := (l_data.item.set.ioctl_func).natural_32_item ([create {CE_POINTER [ANY]}.make_cast (l_data), 1, l_data.item.set.ioctl_client])
						sendf_inst.Curl_infof ([l_data, ce_string ("the ioctl callback returned %%d%N"), l_err___0.to_integer_32])
						if l_err___0.to_boolean then
							sendf_inst.Curl_failf ([l_data, ce_string ("ioctl callback returned error %%d"), l_err___0.to_integer_32])
							Result := ({PC_CURLCODE}.CURLE_SEND_FAIL_REWIND)
							js.return
						end
					else
						if (l_data.item.set.fread_func).is_equal (fread_address) then
							if -1 /= (fseek (create {CE_POINTER [SD_IO_FILE]}.make_cast (l_data.item.set.in), 0, 0)) then
								Result := ({PC_CURLCODE}.CURLE_OK)
								js.return
							end
						end
						if not js.return_called then
							sendf_inst.Curl_failf ([l_data, ce_string ("necessary data rewind wasn%'t possible")])
							Result := ({PC_CURLCODE}.CURLE_SEND_FAIL_REWIND)
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_readwrite (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_result: NATURAL_32
			l_didwhat: CE_ARRAY [INTEGER_32]
			l_fd_read: INTEGER_32
			l_fd_write: INTEGER_32
			l_select_res: INTEGER_32
			l_ms: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_k.make
			create l_didwhat.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_didwhat.item := 0
					l_select_res := a_conn.item.cselect_bits
					a_conn.item.cselect_bits := 0
					if ((l_k.item.keepon).bit_and (((((1).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (4)))))) = 1 then
						l_fd_read := a_conn.item.sockfd
					else
						l_fd_read := -1
					end
					if ((l_k.item.keepon).bit_and (((((((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (3))))).bit_or (((1).bit_shift_left (5)))))) = (1).bit_shift_left (1) then
						l_fd_write := a_conn.item.writesockfd
					else
						l_fd_write := -1
					end
					if not l_select_res.to_boolean then
						l_select_res := select_inst.Curl_socket_ready (l_fd_read, l_fd_write, 0)
					end
					if l_select_res = 4 then
						sendf_inst.Curl_failf ([l_data, ce_string ("select/poll returned error")])
						Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
						js.return
					end
					if not (not js.return_called and then (((l_k.item.keepon).bit_and (1)).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (((l_select_res).bit_and (1)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_conn.item.bits.stream_was_rewound) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_result := readwrite_data (l_data, a_conn, l_k, l_didwhat, a_done)
						if l_result.to_boolean then
							Result := l_result
							js.return
						elseif a_done.item then
							Result := l_result
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called and then (((l_k.item.keepon).bit_and (((1).bit_shift_left (1)))).to_boolean) then
							if ((l_select_res).bit_and (2)).to_boolean then
								l_result := readwrite_upload (l_data, a_conn, l_k, l_didwhat)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							end
						end
						if not js.return_called then
							l_k.item.now := (timeval_inst.curlx_tvnow).twin
							if (l_didwhat.item).to_boolean then
								if (not (l_k.item.bytecountp).is_void) then
									(l_k.item.bytecountp).item := l_k.item.bytecount
								end
								if (not (l_k.item.writebytecountp).is_void) then
									(l_k.item.writebytecountp).item := l_k.item.writebytecount
								end
							elseif l_k.item.exp100 = {NATURAL_32} 1 then
								l_ms := (timeval_inst.curlx_tvdiff ((l_k.item.now).twin, (l_k.item.start100).twin))
								if l_ms > 1_000 then
									l_k.item.exp100 := {PC_EXPECT100}.EXP100_SEND_DATA
									l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
									sendf_inst.Curl_infof ([l_data, ce_string ("Done waiting for 100-continue%N")])
								end
							end
							if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
								l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
							else
								l_result := speedcheck_inst.Curl_speedcheck (l_data, (l_k.item.now).twin)
							end
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
							if not ((l_k.item.keepon).to_boolean) then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							if 0 > (connect_inst.Curl_timeleft (a_conn, create {CE_POINTER [SD_TIMEVAL]}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("now")), (0).to_boolean)) then
								if l_k.item.size /= -{INTEGER_64} 1 then
									sendf_inst.Curl_failf ([l_data, ce_string ("Operation timed out after %%ld milliseconds with %%lld out of %%lld bytes received"), (timeval_inst.curlx_tvdiff ((l_k.item.now).twin, (l_data.item.progress.t_startsingle).twin)), l_k.item.bytecount, l_k.item.size])
								else
									sendf_inst.Curl_failf ([l_data, ce_string ("Operation timed out after %%ld milliseconds with %%lld bytes received"), (timeval_inst.curlx_tvdiff ((l_k.item.now).twin, (l_data.item.progress.t_startsingle).twin)), l_k.item.bytecount])
								end
								Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
								js.return
							end
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 10 then -- else:
							if l_data.item.set.opt_no_body then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if l_k.item.size /= -{INTEGER_64} 1 then
								if l_k.item.bytecount /= l_k.item.size then
									if l_k.item.bytecount /= l_k.item.size + l_data.item.state.crlf_conversions then
										if (l_data.item.req.newurl).is_void then
											sendf_inst.Curl_failf ([l_data, ce_string ("transfer closed with %%lld bytes remaining to read"), l_k.item.size - l_k.item.bytecount])
											Result := ({PC_CURLCODE}.CURLE_PARTIAL_FILE)
											js.return
										else
											l_pos := -1 + 13 -- goto _L___3
										end
									else
										l_pos := -1 + 13 -- goto _L___3
									end
								else
									l_pos := -1 + 13 -- goto _L___3
								end
							else
								l_pos := -1 + 13 -- goto _L___3
							end
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 13 then -- else: | _L___3:
							if not l_data.item.set.opt_no_body then
								if l_k.item.chunk then
									if a_conn.item.chunk.state /= {NATURAL_32} 8 then
										sendf_inst.Curl_failf ([l_data, ce_string ("transfer closed with outstanding read data remaining")])
										Result := ({PC_CURLCODE}.CURLE_PARTIAL_FILE)
										js.return
									end
								end
							end
				when 14 then
							if not js.return_called then
								if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
									Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
									js.return
								end
							end
				when 15 then -- if done | if done
							if not js.return_called then
								a_done.item := (0 = ((l_k.item.keepon).bit_and (((((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (4))))).bit_or (((1).bit_shift_left (5)))))))
								Result := ({PC_CURLCODE}.CURLE_OK)
							end
				when 16 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	Curl_reconnect_request (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): NATURAL_32
		local
			l_result: NATURAL_32
			l_conn: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_async: CE_ARRAY [BOOLEAN]
			l_protocol_done: CE_ARRAY [BOOLEAN]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_conn.make (<<1>>)
			create l_data.make
			create l_async.make (<<1>>)
			create l_protocol_done.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_conn.item := a_connp.item
					l_data := l_conn.item.item.data
					sendf_inst.Curl_infof ([l_data, ce_string ("Re-used connection seems dead, get a new one%N")])
					l_conn.item.item.bits.close := (1).to_boolean
					l_result := url_inst.Curl_done (l_conn, l_result, (0).to_boolean)
					if {NATURAL_32} 0 /= l_result then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if {NATURAL_32} 55 /= l_result then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_protocol_done.item := (1).to_boolean
						l_result := url_inst.Curl_connect (l_data, a_connp, l_async, l_protocol_done)
						if {NATURAL_32} 0 = l_result then
							l_conn.item := a_connp.item
							if l_async.item then
								l_result := hostsyn_inst.Curl_wait_for_resolv (l_conn.item, create {CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]}.make_shared (default_pointer))
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
								if not js.return_called then
									l_result := url_inst.Curl_async_resolved (l_conn.item, l_protocol_done)
									if l_result.to_boolean then
										Result := l_result
										js.return
									end
								end
							end
						end
				when 5 then -- if done
						if not js.return_called then
							Result := l_result
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_retry_request (a_conn: CE_POINTER [PD_CONNECTDATA]; a_url: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					a_url.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					if l_data.item.set.upload then
						if not ((a_conn.item.protocol).bit_and (((1).bit_or (((1).bit_shift_left (18)))).to_integer_32)).to_boolean then
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_data.item.state.ssl_connect_retry) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_data.item.req.bytecount + (l_data.item.req.headerbytecount).to_integer_64 /= {INTEGER_64} 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if not (a_conn.item.bits.reuse) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if l_data.item.set.opt_no_body then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_data.item.set.rtspreq = {NATURAL_32} 11 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("Connection died, retrying a fresh connect%N")])
						a_url.item := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([(a_conn.item.data).item.change.url]))
						if (a_url.item).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							a_conn.item.bits.close := (1).to_boolean
							a_conn.item.bits.retry2 := (1).to_boolean
						end
				when 9 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_setup_transfer (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sockindex: INTEGER_32; a_size: INTEGER_64; a_getheader: BOOLEAN; a_bytecountp: CE_POINTER [INTEGER_64]; a_writesockindex: INTEGER_32; a_writecountp: CE_POINTER [INTEGER_64])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_k.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					if a_sockindex = -1 then
						a_conn.item.sockfd := -1
					else
						a_conn.item.sockfd := a_conn.item.sock[a_sockindex]
					end
					if a_writesockindex = -1 then
						a_conn.item.writesockfd := -1
					else
						a_conn.item.writesockfd := a_conn.item.sock[a_writesockindex]
					end
					l_k.item.getheader := a_getheader
					l_k.item.size := a_size
					l_k.item.bytecountp := a_bytecountp
					l_k.item.writebytecountp := a_writecountp
					if not l_k.item.getheader then
						l_k.item.header := (0).to_boolean
						if a_size > {INTEGER_64} 0 then
							progress_inst.Curl_pgrsSetDownloadSize (l_data, a_size)
						end
					end
					if not (l_k.item.getheader) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if l_data.item.set.opt_no_body then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if a_conn.item.sockfd /= -1 then
							l_k.item.keepon := (l_k.item.keepon).bit_or ((1))
						end
						if a_conn.item.writesockfd = -1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if not (l_data.item.state.expect100header) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_data.item.state.proto.http).item.sending = {NATURAL_32} 2 then
							l_k.item.exp100 := {PC_EXPECT100}.EXP100_AWAITING_CONTINUE
							l_k.item.start100 := (l_k.item.start).twin
							multi_inst.Curl_expire (l_data, 1_000)
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_data.item.state.expect100header then
							l_k.item.exp100 := {PC_EXPECT100}.EXP100_SENDING_REQUEST
						end
						l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
				when 9 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_single_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_bitmap: INTEGER_32
			l_sockindex: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_bitmap := 0
					l_sockindex := {NATURAL_32} 0
					if (not ((a_conn.item.handler).item.perform_getsock).is_void) then
						Result := (((a_conn.item.handler).item.perform_getsock).integer_32_item ([a_conn, a_sock, a_numsocks]))
						js.return
					end
					if not js.return_called and then (a_numsocks < 2) then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if ((l_data.item.req.keepon).bit_and (((((1).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (4)))))) = 1 then
							l_bitmap := (l_bitmap).bit_or (((1).bit_shift_left (l_sockindex.to_integer_32)))
							a_sock[l_sockindex.to_integer_32] := a_conn.item.sockfd
						end
						if ((l_data.item.req.keepon).bit_and (((((((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (3))))).bit_or (((1).bit_shift_left (5)))))) /= ((1).bit_shift_left (1)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if a_conn.item.sockfd = a_conn.item.writesockfd then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if ((l_data.item.req.keepon).bit_and (1)).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if ((l_data.item.req.keepon).bit_and (1)).to_boolean then
							l_sockindex := l_sockindex + 1
						end
						a_sock[l_sockindex.to_integer_32] := a_conn.item.writesockfd
				when 7 then -- if done
						l_bitmap := (l_bitmap).bit_or (((1).bit_shift_left (({NATURAL_32} 16 + l_sockindex).to_integer_32)))
				when 8 then -- if done
						Result := l_bitmap
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_sleep_time (a_rate_bps: INTEGER_64; a_cur_rate_bps: INTEGER_64; a_pkt_size: INTEGER_32): INTEGER_32
		local
			l_rate_bps: INTEGER_64
			l_min_sleep: INTEGER_64
			l_rv: INTEGER_64
			js: JUMP_STATE
		do
			l_rate_bps := a_rate_bps
			l_min_sleep := (0).to_integer_64
			l_rv := (0).to_integer_64
			if l_rate_bps = {INTEGER_64} 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_cur_rate_bps > l_rate_bps + ((l_rate_bps).bit_shift_right (10)) then
					l_rate_bps := l_rate_bps - ((l_rate_bps).bit_shift_right (6))
					l_min_sleep := (1).to_integer_64
				elseif a_cur_rate_bps < l_rate_bps - ((l_rate_bps).bit_shift_right (10)) then
					l_rate_bps := l_rate_bps + ((l_rate_bps).bit_shift_right (6))
				end
				l_rv := ((a_pkt_size * 8) * 1_000).to_integer_64 // l_rate_bps
				if l_rv < l_min_sleep then
					l_rv := l_min_sleep
				end
				if l_rv > {INTEGER_64} 2_147_483_647 then
					l_rv := (2_147_483_647).to_integer_64
				end
				Result := l_rv.to_integer_32
			end
		end

	Transfer (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_done: CE_ARRAY [BOOLEAN]
			l_first: BOOLEAN
			l_timeout_ms: INTEGER_32
			l_buffersize: INTEGER_32
			l_totmp: INTEGER_32
			l_fd_read: INTEGER_32
			l_fd_write: INTEGER_32
			l_keepon: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_k.make
			create l_done.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_done.item := (0).to_boolean
					l_first := (1).to_boolean
					if a_conn.item.sockfd = -1 then
						if a_conn.item.writesockfd = -1 then
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
					end
					if not js.return_called and then (not l_k.item.getheader) then
						if l_data.item.set.opt_no_body then
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_done and then (not l_done.item)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 2 then -- loop body:
						l_fd_read := a_conn.item.sockfd
						l_fd_write := a_conn.item.writesockfd
						l_keepon := l_k.item.keepon
						l_timeout_ms := 1_000
						if (a_conn.item.waitfor).to_boolean then
							l_keepon := (l_keepon).bit_and (((((1).bit_or (((1).bit_shift_left (1))))).bit_not))
							l_keepon := (l_keepon).bit_or (((a_conn.item.waitfor).bit_and (((1).bit_or (((1).bit_shift_left (1)))))))
						end
						if not (((l_keepon).bit_and (((1).bit_shift_left (1)))).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not (l_data.item.set.max_send_speed).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (3))).bit_not))
						elseif l_data.item.progress.ulspeed < l_data.item.set.max_send_speed then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (3))).bit_not))
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_data.item.set.upload then
							if (l_data.item.set.max_send_speed).to_boolean then
								if l_data.item.progress.ulspeed > l_data.item.set.max_send_speed then
									if (l_data.item.set.buffer_size).to_boolean then
										l_tmp := l_data.item.set.buffer_size
									else
										l_tmp := 16_384
									end
									l_buffersize := l_tmp.to_integer_32
									l_totmp := (Curl_sleep_time (l_data.item.set.max_send_speed, l_data.item.progress.ulspeed, l_buffersize)).to_integer_32
									if l_totmp < l_timeout_ms then
										l_timeout_ms := l_totmp
									end
								end
							end
						end
						l_fd_write := -1
						if ((l_keepon).bit_and (((1).bit_shift_left (1)))).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (3)))
						end
				when 6 then
						if not (((l_keepon).bit_and (1)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not (l_data.item.set.max_recv_speed).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (2))).bit_not))
						elseif l_data.item.progress.dlspeed < l_data.item.set.max_recv_speed then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (2))).bit_not))
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if not l_data.item.set.upload then
							if (l_data.item.set.max_recv_speed).to_boolean then
								if l_data.item.progress.dlspeed > l_data.item.set.max_recv_speed then
									if (l_data.item.set.buffer_size).to_boolean then
										l_tmp___1 := l_data.item.set.buffer_size
									else
										l_tmp___1 := 16_384
									end
									l_buffersize := l_tmp___1.to_integer_32
									l_totmp := (Curl_sleep_time (l_data.item.set.max_recv_speed, l_data.item.progress.dlspeed, l_buffersize)).to_integer_32
									if l_totmp < l_timeout_ms then
										l_timeout_ms := l_totmp
									end
								end
							end
						end
						l_fd_read := -1
						if ((l_keepon).bit_and (1)).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (2)))
						end
				when 10 then
						if ((l_k.item.keepon).bit_and (((1).bit_shift_left (4)))).to_boolean then
							l_fd_read := -1
						end
						if ((l_k.item.keepon).bit_and (((1).bit_shift_left (5)))).to_boolean then
							l_fd_write := -1
						end
						if not l_first then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_fd_read /= -1 then
							l_timeout_ms := 0
						elseif l_fd_write /= -1 then
							l_timeout_ms := 0
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						l_totmp := (connect_inst.Curl_timeleft (a_conn, create {CE_POINTER [SD_TIMEVAL]}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("now")), (0).to_boolean)).to_integer_32
						if l_totmp < 0 then
							Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
							js.return
						elseif not l_totmp.to_boolean then
							l_totmp := 1_000
						end
						if not js.return_called and then (l_totmp < l_timeout_ms) then
							l_timeout_ms := l_totmp
						end
				when 14 then
						if js.return_called then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						inspect (select_inst.Curl_socket_ready (l_fd_read, l_fd_write, l_timeout_ms)) -- switch 1 head
						when -1 then l_pos := -1 + 16 -- -1
						else l_pos := -1 + 17
						end
				when 16 then -- switch 1, case -1
						if (errno_location).item = 4 then
							js.continue
						end
						if not js.loop_jumped then
							Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
							js.return
						end
				when 17 then -- switch 1, default:
						if not js.loop_jumped then
							l_result := Curl_readwrite (a_conn, l_done)
						end
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done:
						if not js.loop_jumped then
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called then
								l_first := (0).to_boolean
							end
						end
				when 19 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 20 then -- loop done | if done
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 21 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	concat_url (a_base: CE_POINTER [INTEGER_8]; a_relurl: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_newest: CE_POINTER [INTEGER_8]
			l_protsep: CE_POINTER [INTEGER_8]
			l_pathsep: CE_POINTER [INTEGER_8]
			l_newlen: NATURAL_32
			l_useurl: CE_POINTER [INTEGER_8]
			l_urllen: NATURAL_32
			l_url_clone: CE_POINTER [INTEGER_8]
			l_level: INTEGER_32
			l_tmp___0: INTEGER_32
			l_sep: CE_POINTER [INTEGER_8]
			l_tmp___3: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newest.make
			create l_protsep.make
			create l_pathsep.make
			create l_useurl.make
			create l_url_clone.make
			create l_sep.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_useurl := a_relurl
					l_url_clone := (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_base])))
					if l_url_clone.is_void then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_protsep := strstr (l_url_clone, ce_string ("//"))
						if l_protsep.is_void then
							l_protsep := l_url_clone
						else
							l_protsep := l_protsep + (2)
						end
						if 47 /= (a_relurl[0]).to_integer_32 then
							l_level := 0
							l_pathsep := strchr (l_protsep, ('?').code)
							if (not l_pathsep.is_void) then
								l_pathsep[0] := (0).to_integer_8
							end
							if (l_useurl[0]).to_integer_32 /= 63 then
								l_pathsep := strrchr (l_protsep, ('/').code)
								if (not l_pathsep.is_void) then
									l_pathsep[0] := (0).to_integer_8
								end
							end
							l_pathsep := strchr (l_protsep, ('/').code)
							if (not l_pathsep.is_void) then
								l_protsep := l_pathsep + 1
							else
								l_protsep := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
							if (l_useurl[0]).to_integer_32 = 46 then
								if (l_useurl[1]).to_integer_32 = 47 then
									l_useurl := l_useurl + (2)
								end
							end
							from
							until
								js.loop_done
							loop
								if (l_useurl[0]).to_integer_32 = 46 then
									if (l_useurl[1]).to_integer_32 = 46 then
										if (l_useurl[2]).to_integer_32 /= 47 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_level := l_level + 1
									l_useurl := l_useurl + (3)
								end
							end
							if (not l_protsep.is_void) then
								from
								until
									js.loop_done
								loop
									l_tmp___0 := l_level
									l_level := l_level - 1
									if not l_tmp___0.to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_pathsep := strrchr (l_protsep, ('/').code)
										if (not l_pathsep.is_void) then
											l_pathsep[0] := (0).to_integer_8
										else
											l_protsep[0] := (0).to_integer_8
											js.break
										end
									end
								end
							end
						else
							l_pathsep := strchr (l_protsep, ('/').code)
							if (not l_pathsep.is_void) then
								l_sep := (strchr (l_protsep, ('?').code))
								if (not l_sep.is_void) then
									if (l_sep.c_pointer.to_integer_32).to_natural_32 < (l_pathsep.c_pointer.to_integer_32).to_natural_32 then
										l_pathsep := l_sep
									end
								end
								l_pathsep[0] := (0).to_integer_8
							else
								l_pathsep := strchr (l_protsep, ('?').code)
								if (not l_pathsep.is_void) then
									l_pathsep[0] := (0).to_integer_8
								end
							end
						end
						l_newlen := strlen_url (l_useurl)
						l_urllen := strlen (l_url_clone)
						l_newest := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([((l_urllen + {NATURAL_32} 1) + l_newlen) + {NATURAL_32} 1]))))
						if l_newest.is_void then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_url_clone)])
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_newest), create {CE_POINTER [ANY]}.make_cast (l_url_clone), l_urllen).do_nothing
						if (47 = (l_useurl[0]).to_integer_32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if l_protsep.is_void then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_protsep[0]).to_boolean then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if 63 /= (l_useurl[0]).to_integer_32 then
							l_tmp___3 := l_urllen
							l_urllen := l_urllen + 1
							l_newest[l_tmp___3.to_integer_32] := (('/').code).to_integer_8
						end
				when 6 then -- if done
						strcpy_url (l_newest + l_urllen.to_integer_32, l_useurl)
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_url_clone)])
						Result := l_newest
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	connect_host (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): NATURAL_32
		local
			l_res: NATURAL_32
			l_async: CE_ARRAY [BOOLEAN]
			l_protocol_done: CE_ARRAY [BOOLEAN]
		do
			create l_async.make (<<1>>)
			create l_protocol_done.make (<<1>>)

			l_res := {PC_CURLCODE}.CURLE_OK
			l_protocol_done.item := (1).to_boolean
			progress_inst.Curl_pgrsTime (a_data, {PC_TIMERID}.TIMER_STARTSINGLE)
			l_res := url_inst.Curl_connect (a_data, a_conn, l_async, l_protocol_done)
			if {NATURAL_32} 0 = l_res then
				if l_async.item then
					l_res := hostsyn_inst.Curl_wait_for_resolv (a_conn.item, create {CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]}.make_shared (default_pointer))
					if {NATURAL_32} 0 = l_res then
						l_res := url_inst.Curl_async_resolved (a_conn.item, l_protocol_done)
					else
						url_inst.Curl_disconnect (a_conn.item).do_nothing
					end
				end
			end
			Result := l_res
		end

	data_pending (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if ((a_conn.item.protocol).bit_and (((((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5)))).to_integer_32)).to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	is_absolute_url (a_url: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_prot: CE_ARRAY [INTEGER_8]
			l_letter: CE_ARRAY [INTEGER_8]
		do
			create l_prot.make (<<16>>)
			create l_letter.make (<<1>>)

			Result := (2 = (sscanf ([a_url, ce_string ("%%15[^?&/:]://%%c"), l_prot, l_letter])))
		end

	read_rewind (a_conn: CE_POINTER [PD_CONNECTDATA]; a_thismuch: NATURAL_32)
		do
			a_conn.item.read_pos := a_conn.item.read_pos - a_thismuch
			a_conn.item.bits.stream_was_rewound := (1).to_boolean
		end

	readwrite_data (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_k: CE_POINTER [PD_SINGLEREQUEST]; a_didwhat: CE_POINTER [INTEGER_32]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_nread: CE_ARRAY [INTEGER_32]
			l_excess: NATURAL_32
			l_is_empty_data: BOOLEAN
			l_readmore: CE_ARRAY [BOOLEAN]
			l_buffersize: NATURAL_32
			l_tmp: INTEGER_32
			l_bytestoread: NATURAL_32
			l_totalleft: INTEGER_64
			l_tmp___0: INTEGER_32
			l_stop_reading: CE_ARRAY [BOOLEAN]
			l_res: INTEGER_32
			l_dataleft: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_nread.make (<<1>>)
			create l_readmore.make (<<1>>)
			create l_stop_reading.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_excess := (0).to_natural_32
					l_is_empty_data := (0).to_boolean
					l_readmore.item := (0).to_boolean
					a_done.item := (0).to_boolean
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 31 -- skip loop
					end
				when 2 then -- loop body:
						if (a_data.item.set.buffer_size).to_boolean then
							l_tmp := a_data.item.set.buffer_size
						else
							l_tmp := 16_384
						end
						l_buffersize := l_tmp.to_natural_32
						l_bytestoread := l_buffersize
						if a_k.item.size /= -{INTEGER_64} 1 then
							if not a_k.item.header then
								l_totalleft := a_k.item.size - a_k.item.bytecount
								if l_totalleft < l_bytestoread.to_integer_64 then
									l_bytestoread := l_totalleft.to_natural_32
								end
							end
						end
						if l_bytestoread.to_boolean then
							l_result := sendf_inst.Curl_read (a_conn, a_conn.item.sockfd, a_k.item.buf, l_bytestoread, l_nread)
							if {NATURAL_32} 81 = l_result then
								js.break
							end
							if not js.loop_jumped and then (l_result > {NATURAL_32} 0) then
								Result := l_result
								js.return
							end
						else
							l_nread.item := 0
						end
						if not js.loop_jumped then
							if a_k.item.bytecount = {INTEGER_64} 0 then
								if a_k.item.writebytecount = {INTEGER_64} 0 then
									progress_inst.Curl_pgrsTime (a_data, {PC_TIMERID}.TIMER_STARTTRANSFER)
									if a_k.item.exp100 > {NATURAL_32} 0 then
										a_k.item.start100 := (timeval_inst.curlx_tvnow).twin
									end
								end
							end
							a_didwhat.item := (a_didwhat.item).bit_or ((1))
							if l_nread.item = 0 then
								if a_k.item.bodywrites = 0 then
									l_tmp___0 := 1
								else
									l_tmp___0 := 0
								end
							else
								l_tmp___0 := 0
							end
							l_is_empty_data := l_tmp___0.to_boolean
							if 0 < l_nread.item then
								a_k.item.buf[l_nread.item] := (0).to_integer_8
							elseif l_is_empty_data then
								a_k.item.buf[l_nread.item] := (0).to_integer_8
							elseif 0 >= l_nread.item then
								a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
								js.break
							end
						end
						if not js.loop_jumped then
							a_k.item.str := a_k.item.buf
							if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
								l_result := rtsp_inst.Curl_rtsp_rtp_readwrite (a_data, a_conn, l_nread, l_readmore)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
								if not js.return_called and then (l_readmore.item) then
									js.break
								end
							end
						end
						if not js.loop_jumped and then (a_k.item.header) then
							l_stop_reading.item := (0).to_boolean
							l_result := http_inst.Curl_http_readwrite_headers (a_data, a_conn, l_nread, l_stop_reading)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called then
								if a_k.item.maxdownload <= {INTEGER_64} 0 then
									if l_nread.item > 0 then
										if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
											l_result := rtsp_inst.Curl_rtsp_rtp_readwrite (a_data, a_conn, l_nread, l_readmore)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
											if not js.return_called and then (l_readmore.item) then
												js.break
											end
										end
									end
								end
								if not js.loop_jumped and then (l_stop_reading.item) then
									js.break
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 30 -- skip if block
						end
				when 3 then -- if:
						if (a_k.item.str).is_void then
							l_pos := -1 + 29 -- skip if block
						end
				when 4 then -- if:
						if a_k.item.header then
							l_pos := -1 + 29 -- skip if block
						end
				when 5 then -- if:
						if not (l_nread.item > 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 8 then -- else:
						if not l_is_empty_data then
							l_pos := -1 + 29 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if 0 /= a_k.item.bodywrites then
							l_pos := -1 + 19 -- skip if block
						end
				when 10 then -- if:
						if l_is_empty_data then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						if not (((a_conn.item.protocol).bit_and (((1).bit_or (((1).bit_shift_left (18)))).to_integer_32)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if (not (a_data.item.req.newurl).is_void) then
							if a_conn.item.bits.close then
								a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
								a_done.item := (1).to_boolean
								Result := ({PC_CURLCODE}.CURLE_OK)
								js.return
							end
							if not js.return_called then
								a_k.item.ignorebody := (1).to_boolean
								sendf_inst.Curl_infof ([a_data, ce_string ("Ignoring the response-body%N")])
							end
						end
						if not js.return_called and then ((a_data.item.state.resume_from).to_boolean) then
							if not a_k.item.content_range then
								if a_data.item.set.httpreq = {NATURAL_32} 1 then
									if not a_k.item.ignorebody then
										sendf_inst.Curl_failf ([a_data, ce_string ("HTTP server doesn%'t seem to support byte ranges. Cannot resume.")])
										Result := ({PC_CURLCODE}.CURLE_RANGE_ERROR)
										js.return
									end
								end
							end
						end
						if not (not js.return_called and then ((a_data.item.set.timecondition).to_boolean)) then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if (not (a_data.item.state.range).is_void) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if not (a_k.item.timeofdoc > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if not (a_data.item.set.timevalue > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 16 then -- if:
						inspect (a_data.item.set.timecondition).to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 18
						else l_pos := -1 + 17
						end
				when 17 then -- switch 1, default:
						if a_k.item.timeofdoc < a_data.item.set.timevalue then
							sendf_inst.Curl_infof ([a_data, ce_string ("The requested document is not new enough%N")])
							a_done.item := (1).to_boolean
							a_data.item.info.timecond := (1).to_boolean
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, case 2
						if a_k.item.timeofdoc > a_data.item.set.timevalue then
							sendf_inst.Curl_infof ([a_data, ce_string ("The requested document is not old enough%N")])
							a_done.item := (1).to_boolean
							a_data.item.info.timecond := (1).to_boolean
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
						l_pos := -1 + 19 -- switch 1; break
				when 19 then -- switch 1, done: | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							a_k.item.bodywrites := (a_k.item.bodywrites) + 1
							if a_data.item.set.verbose then
								if (a_k.item.badheader).to_boolean then
									sendf_inst.Curl_debug (a_data, {PC_CURL_INFOTYPE}.CURLINFO_DATA_IN, a_data.item.state.headerbuff, a_k.item.hbuflen, a_conn).do_nothing
									if a_k.item.badheader = {NATURAL_32} 1 then
										sendf_inst.Curl_debug (a_data, {PC_CURL_INFOTYPE}.CURLINFO_DATA_IN, a_k.item.str, (l_nread.item).to_natural_32, a_conn).do_nothing
									end
								else
									sendf_inst.Curl_debug (a_data, {PC_CURL_INFOTYPE}.CURLINFO_DATA_IN, a_k.item.str, (l_nread.item).to_natural_32, a_conn).do_nothing
								end
							end
							if a_k.item.chunk then
								l_res := (http_chunks_inst.Curl_httpchunk_read (a_conn, a_k.item.str, l_nread.item, l_nread))
								if 0 < l_res then
									if 4 = l_res then
										sendf_inst.Curl_failf ([a_data, ce_string ("Failed writing data")])
										Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
										js.return
									end
									if not js.return_called then
										sendf_inst.Curl_failf ([a_data, ce_string ("Received problem %%d in the chunky parser"), l_res])
										Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
										js.return
									end
								elseif -1 = l_res then
									a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
									l_dataleft := a_conn.item.chunk.dataleft
									if l_dataleft /= {NATURAL_32} 0 then
										sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("Leftovers after chunking: %%zu bytes"), l_dataleft])
										if (not ((a_conn.item.data).item.multi).is_void) then
											if (multi_inst.Curl_multi_canPipeline ((a_conn.item.data).item.multi)) then
												sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("Rewinding %%zu bytes%N"), l_dataleft])
												read_rewind (a_conn, l_dataleft)
											end
										end
									end
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 29 -- skip if block
						end
				when 20 then -- if:
						if (a_k.item.badheader).to_boolean then
							if not a_k.item.ignorebody then
								a_k.item.bytecount := a_k.item.bytecount + (a_k.item.hbuflen).to_integer_64
							end
						end
						if -{INTEGER_64} 1 /= a_k.item.maxdownload then
							if a_k.item.bytecount + (l_nread.item).to_integer_64 >= a_k.item.maxdownload then
								l_excess := ((a_k.item.bytecount + (l_nread.item).to_integer_64) - a_k.item.maxdownload).to_natural_32
								if l_excess > {NATURAL_32} 0 then
									if not a_k.item.ignorebody then
										if (not ((a_conn.item.data).item.multi).is_void) then
											if (multi_inst.Curl_multi_canPipeline ((a_conn.item.data).item.multi)) then
												sendf_inst.Curl_infof ([a_data, ce_string ("Rewinding stream by : %%zu bytes on url %%s (size = %%lld, maxdownload = %%lld, bytecount = %%lld, nread = %%zd)%N"), l_excess, a_data.item.state.path, a_k.item.size, a_k.item.maxdownload, a_k.item.bytecount, l_nread.item])
												read_rewind (a_conn, l_excess)
											else
												sendf_inst.Curl_infof ([a_data, ce_string ("Excess found in a non pipelined read: excess = %%zu, size = %%lld, maxdownload = %%lld, bytecount = %%lld%N"), l_excess, a_k.item.size, a_k.item.maxdownload, a_k.item.bytecount])
											end
										else
											sendf_inst.Curl_infof ([a_data, ce_string ("Excess found in a non pipelined read: excess = %%zu, size = %%lld, maxdownload = %%lld, bytecount = %%lld%N"), l_excess, a_k.item.size, a_k.item.maxdownload, a_k.item.bytecount])
										end
									end
								end
								l_nread.item := (a_k.item.maxdownload - a_k.item.bytecount).to_integer_32
								if l_nread.item < 0 then
									l_nread.item := 0
								end
								a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
							end
						end
						a_k.item.bytecount := a_k.item.bytecount + (l_nread.item).to_integer_64
						progress_inst.Curl_pgrsSetDownloadCounter (a_data, a_k.item.bytecount)
						if a_k.item.chunk then
							l_pos := -1 + 29 -- skip if block
						end
				when 21 then -- if:
						if not ((l_nread.item).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 24 then -- else:
						if not ((a_k.item.badheader).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if not l_is_empty_data then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L:
						if (a_k.item.badheader).to_boolean then
							if not a_k.item.ignorebody then
								if a_k.item.maxdownload = -{INTEGER_64} 1 then
									l_result := sendf_inst.Curl_client_write (a_conn, 1, a_data.item.state.headerbuff, a_k.item.hbuflen)
								elseif (a_k.item.hbuflen).to_integer_64 <= a_k.item.maxdownload then
									l_result := sendf_inst.Curl_client_write (a_conn, 1, a_data.item.state.headerbuff, a_k.item.hbuflen)
								else
									l_result := sendf_inst.Curl_client_write (a_conn, 1, a_data.item.state.headerbuff, (a_k.item.maxdownload).to_natural_32)
								end
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							end
						end
						if not js.return_called then
							if a_k.item.badheader < {NATURAL_32} 2 then
								if not a_k.item.ignorebody then
									if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (14)).to_integer_32)).to_boolean then
										l_result := pop3_inst.Curl_pop3_write (a_conn, a_k.item.str, (l_nread.item).to_natural_32)
									else
										l_result := sendf_inst.Curl_client_write (a_conn, 1, a_k.item.str, (l_nread.item).to_natural_32)
									end
								end
							end
							a_k.item.badheader := {PC_BADHEADER}.HEADER_NORMAL
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
				when 29 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							if l_excess > {NATURAL_32} 0 then
								if not a_conn.item.bits.stream_was_rewound then
									if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
										a_k.item.str := a_k.item.str + (l_nread.item)
										l_nread.item := l_excess.to_integer_32
										l_result := rtsp_inst.Curl_rtsp_rtp_readwrite (a_data, a_conn, l_nread, l_readmore)
										if l_result.to_boolean then
											Result := l_result
											js.return
										end
										if not js.return_called then
											if l_readmore.item then
												a_k.item.keepon := (a_k.item.keepon).bit_or ((1))
											end
											js.break
										end
									end
								end
							end
							if not js.loop_jumped then
								if l_is_empty_data then
									a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
								end
								if not (data_pending (a_conn)).to_boolean then
									js.break
								end
							end
						end
				when 30 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 31 then -- loop done
					if not js.return_called then
						if ((a_k.item.keepon).bit_and (((1).bit_or (((1).bit_shift_left (1)))))) = (1).bit_shift_left (1) then
							if a_conn.item.bits.close then
								sendf_inst.Curl_infof ([a_data, ce_string ("we are done reading and this is set to close, stop send%N")])
								a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
							end
						end
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	readwrite_upload (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_k: CE_POINTER [PD_SINGLEREQUEST]; a_didwhat: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_i: INTEGER_32
			l_si: INTEGER_32
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_nread: INTEGER_32
			l_sending_http_headers: BOOLEAN
			l_fillcount: CE_ARRAY [INTEGER_32]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bytes_written.make (<<1>>)
			create l_fillcount.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sending_http_headers := (0).to_boolean
					if a_k.item.bytecount = {INTEGER_64} 0 then
						if a_k.item.writebytecount = {INTEGER_64} 0 then
							progress_inst.Curl_pgrsTime (a_data, {PC_TIMERID}.TIMER_STARTTRANSFER)
						end
					end
					a_didwhat.item := (a_didwhat.item).bit_or (((1).bit_shift_left (1)))
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 19 -- skip loop
					end
				when 2 then -- loop body:
						if 0 /= a_data.item.req.upload_present then
							l_pos := -1 + 18 -- skip if block
						end
				when 3 then -- if:
						a_data.item.req.upload_fromhere := a_k.item.uploadbuf
						if not a_k.item.upload_done then
							if a_k.item.exp100 = {NATURAL_32} 2 then
								if (a_data.item.state.proto.http).item.sending = {NATURAL_32} 2 then
									a_k.item.exp100 := {PC_EXPECT100}.EXP100_AWAITING_CONTINUE
									a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
									a_k.item.start100 := (timeval_inst.curlx_tvnow).twin
									a_didwhat.item := (a_didwhat.item).bit_and (((((1).bit_shift_left (1))).bit_not))
									multi_inst.Curl_expire (a_data, 1_000)
									js.break
								end
							end
							if not js.loop_jumped then
								if ((a_conn.item.protocol).bit_and (((1).bit_or (((1).bit_shift_left (18)))).to_integer_32)).to_boolean then
									if (a_data.item.state.proto.http).item.sending = {NATURAL_32} 1 then
										l_sending_http_headers := (1).to_boolean
									else
										l_sending_http_headers := (0).to_boolean
									end
								end
								l_result := Curl_fillreadbuffer (a_conn, 16_384, l_fillcount)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
								if not js.return_called then
									l_nread := l_fillcount.item
								end
							end
						else
							l_nread := 0
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_nread.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((a_k.item.keepon).bit_and (((1).bit_shift_left (5)))).to_boolean then
							js.break
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_nread <= 0 then
							a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
							if a_conn.item.bits.rewindaftersend then
								l_result := Curl_readrewind (a_conn)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 18 -- skip if block
						end
				when 9 then -- if:
						a_data.item.req.upload_present := l_nread
						if not (((a_conn.item.protocol).bit_and (((1).bit_shift_left (16)).to_integer_32)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_result := smtp_inst.Curl_smtp_escape_eob (a_conn, l_nread)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 12 then -- else:
						if l_sending_http_headers then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (a_data.item.set.crlf) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (a_data.item.set.prefer_ascii) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if (a_data.item.state.scratch).is_void then
							a_data.item.state.scratch := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(32_768).to_natural_32]))))
						end
						if (a_data.item.state.scratch).is_void then
							sendf_inst.Curl_failf ([a_data, ce_string ("Failed to alloc scratch buffer!")])
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_i := 0
							l_si := 0
							from
							until
								not (l_i < l_nread)
							loop
								if (a_data.item.req.upload_fromhere[l_i]).to_integer_32 = 10 then
									l_tmp___0 := l_si
									l_si := l_si + 1
									a_data.item.state.scratch[l_tmp___0] := (13).to_integer_8
									a_data.item.state.scratch[l_si] := (10).to_integer_8
									if not a_data.item.set.crlf then
										a_data.item.set.infilesize := (a_data.item.set.infilesize) + 1
									end
								else
									a_data.item.state.scratch[l_si] := a_data.item.req.upload_fromhere[l_i]
								end
								l_i := l_i + 1
								l_si := l_si + 1
							end
							if l_si /= l_nread then
								l_nread := l_si
								a_data.item.req.upload_fromhere := a_data.item.state.scratch
								a_data.item.req.upload_present := l_nread
							end
						end
				when 18 then -- if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_result := sendf_inst.Curl_write (a_conn, a_conn.item.writesockfd, create {CE_POINTER [ANY]}.make_cast (a_data.item.req.upload_fromhere), (a_data.item.req.upload_present).to_natural_32, l_bytes_written)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called then
								if a_data.item.set.verbose then
									sendf_inst.Curl_debug (a_data, {PC_CURL_INFOTYPE}.CURLINFO_DATA_OUT, a_data.item.req.upload_fromhere, (l_bytes_written.item).to_natural_32, a_conn).do_nothing
								end
								if a_data.item.req.upload_present /= l_bytes_written.item then
									a_data.item.req.upload_present := a_data.item.req.upload_present - (l_bytes_written.item)
									a_data.item.req.upload_fromhere := a_data.item.req.upload_fromhere + (l_bytes_written.item)
								else
									a_data.item.req.upload_fromhere := a_k.item.uploadbuf
									a_data.item.req.upload_present := 0
									if a_k.item.upload_done then
										a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
									end
								end
								a_k.item.writebytecount := a_k.item.writebytecount + (l_bytes_written.item).to_integer_64
								progress_inst.Curl_pgrsSetUploadCounter (a_data, a_k.item.writebytecount)
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 19 then -- loop done
					if not js.return_called then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strcpy_url (a_output: CE_POINTER [INTEGER_8]; a_url: CE_POINTER [INTEGER_8])
		local
			l_left: BOOLEAN
			l_iptr: CE_POINTER [INTEGER_8]
			l_optr: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_iptr.make
			create l_optr.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_left := (1).to_boolean
					l_optr := a_output
					l_iptr := a_url
				when 1 then -- loop condition:
					if not ((l_iptr[0]).to_boolean) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_iptr[0]).to_integer_32 -- switch 1 head
						when 63 then l_pos := -1 + 3
						when 32 then l_pos := -1 + 5
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 63
						l_left := (0).to_boolean
				when 4 then -- switch 1, default:
						l_tmp := l_optr
						l_optr := l_optr + 1
						l_tmp[0] := l_iptr[0]
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 32
						if l_left then
							l_tmp___0 := l_optr
							l_optr := l_optr + 1
							l_tmp___0[0] := (('%%').code).to_integer_8
							l_tmp___1 := l_optr
							l_optr := l_optr + 1
							l_tmp___1[0] := (('2').code).to_integer_8
							l_tmp___2 := l_optr
							l_optr := l_optr + 1
							l_tmp___2[0] := (('0').code).to_integer_8
						else
							l_tmp___3 := l_optr
							l_optr := l_optr + 1
							l_tmp___3[0] := (('+').code).to_integer_8
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						l_iptr := l_iptr + 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_optr[0] := (0).to_integer_8
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strlen_url (a_url: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_newlen: NATURAL_32
			l_left: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newlen := (0).to_natural_32
					l_left := (1).to_boolean
					l_ptr := a_url
				when 1 then -- loop condition:
					if not ((l_ptr[0]).to_boolean) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_ptr[0]).to_integer_32 -- switch 1 head
						when 63 then l_pos := -1 + 3
						when 32 then l_pos := -1 + 5
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 63
						l_left := (0).to_boolean
				when 4 then -- switch 1, default:
						l_newlen := l_newlen + 1
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 32
						if l_left then
							l_newlen := l_newlen + ({NATURAL_32} 3)
						else
							l_newlen := l_newlen + 1
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						l_ptr := l_ptr + 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					Result := l_newlen
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
