class
	P_WILDCARD

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_wildcard_dtor (a_wc: CE_POINTER [PD_WILDCARDDATA])
		local
			js: JUMP_STATE
		do
			if a_wc.is_void then
				js.return
			end
			if not js.return_called then
				if (not (a_wc.item.tmp_dtor).is_void) then
					(a_wc.item.tmp_dtor).call ([a_wc.item.tmp])
					a_wc.item.tmp_dtor := create {CE_ROUTINE}.make_shared (default_pointer)
					a_wc.item.tmp := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				end
				if (not (a_wc.item.filelist).is_void) then
					llist_inst.Curl_llist_destroy (a_wc.item.filelist, create {CE_POINTER [ANY]}.make_shared (default_pointer))
					a_wc.item.filelist := create {CE_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
				end
				if (not (a_wc.item.path).is_void) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_wc.item.path)])
					a_wc.item.path := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
				if (not (a_wc.item.pattern).is_void) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_wc.item.pattern)])
					a_wc.item.pattern := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
				a_wc.item.customptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				a_wc.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_INIT
			end
		end

	Curl_wildcard_init (a_wc: CE_POINTER [PD_WILDCARDDATA]): NATURAL_32
		local
			js: JUMP_STATE
		do
			a_wc.item.filelist := llist_inst.Curl_llist_alloc (fileinfo_inst.Curl_fileinfo_dtor_address)
			if (a_wc.item.filelist).is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

end
