class
	SD_RT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create si_sigval.make
		end

feature {ANY} -- fields

	si_pid: INTEGER_32 assign set_si_pid

	si_uid: NATURAL_32 assign set_si_uid

	si_sigval: SD_SIGVAL assign set_si_sigval

feature {ANY} -- setters

	set_si_pid (a_si_pid: INTEGER_32)
		do
			si_pid := a_si_pid
			update_memory_field ("si_pid")
		end

	set_si_uid (a_si_uid: NATURAL_32)
		do
			si_uid := a_si_uid
			update_memory_field ("si_uid")
		end

	set_si_sigval (a_si_sigval: SD_SIGVAL)
		do
			si_sigval := a_si_sigval
			update_memory_field ("si_sigval")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_pid := a_other.si_pid
			si_uid := a_other.si_uid
			si_sigval := a_other.si_sigval.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_pid = a_other.si_pid and
				si_uid = a_other.si_uid and
				si_sigval.is_equal (a_other.si_sigval)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_pid"),
					create {CE_STRUCTURE_FIELD}.make ("si_uid"),
					create {CE_STRUCTURE_FIELD}.make ("si_sigval")
				>>)
			init_structure_info
		end

end
