class
	PD_DOPRNT_PARAMS_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create expfmt.make
		end

feature {ANY} -- fields

	base: INTEGER_32 assign set_base

	conv: INTEGER_32 assign set_conv

	expfmt: CE_POINTER [INTEGER_8] assign set_expfmt

	exptimes4: INTEGER_32 assign set_exptimes4

	fill: INTEGER_8 assign set_fill

	justify: INTEGER_32 assign set_justify

	prec: INTEGER_32 assign set_prec

	showbase: INTEGER_32 assign set_showbase

	showpoint: INTEGER_32 assign set_showpoint

	showtrailing: INTEGER_32 assign set_showtrailing

	sign: INTEGER_8 assign set_sign

	width: INTEGER_32 assign set_width

feature {ANY} -- setters

	set_base (a_base: INTEGER_32)
		do
			base := a_base
			update_memory_field ("base")
		end

	set_conv (a_conv: INTEGER_32)
		do
			conv := a_conv
			update_memory_field ("conv")
		end

	set_expfmt (a_expfmt: CE_POINTER [INTEGER_8])
		do
			expfmt := a_expfmt
			update_memory_field ("expfmt")
		end

	set_exptimes4 (a_exptimes4: INTEGER_32)
		do
			exptimes4 := a_exptimes4
			update_memory_field ("exptimes4")
		end

	set_fill (a_fill: INTEGER_8)
		do
			fill := a_fill
			update_memory_field ("fill")
		end

	set_justify (a_justify: INTEGER_32)
		do
			justify := a_justify
			update_memory_field ("justify")
		end

	set_prec (a_prec: INTEGER_32)
		do
			prec := a_prec
			update_memory_field ("prec")
		end

	set_showbase (a_showbase: INTEGER_32)
		do
			showbase := a_showbase
			update_memory_field ("showbase")
		end

	set_showpoint (a_showpoint: INTEGER_32)
		do
			showpoint := a_showpoint
			update_memory_field ("showpoint")
		end

	set_showtrailing (a_showtrailing: INTEGER_32)
		do
			showtrailing := a_showtrailing
			update_memory_field ("showtrailing")
		end

	set_sign (a_sign: INTEGER_8)
		do
			sign := a_sign
			update_memory_field ("sign")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			base := a_other.base
			conv := a_other.conv
			expfmt := a_other.expfmt
			exptimes4 := a_other.exptimes4
			fill := a_other.fill
			justify := a_other.justify
			prec := a_other.prec
			showbase := a_other.showbase
			showpoint := a_other.showpoint
			showtrailing := a_other.showtrailing
			sign := a_other.sign
			width := a_other.width
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				base = a_other.base and
				conv = a_other.conv and
				expfmt.is_equal (a_other.expfmt) and
				exptimes4 = a_other.exptimes4 and
				fill = a_other.fill and
				justify = a_other.justify and
				prec = a_other.prec and
				showbase = a_other.showbase and
				showpoint = a_other.showpoint and
				showtrailing = a_other.showtrailing and
				sign = a_other.sign and
				width = a_other.width
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("base"),
					create {CE_STRUCTURE_FIELD}.make ("conv"),
					create {CE_STRUCTURE_FIELD}.make ("expfmt"),
					create {CE_STRUCTURE_FIELD}.make ("exptimes4"),
					create {CE_STRUCTURE_FIELD}.make ("fill"),
					create {CE_STRUCTURE_FIELD}.make ("justify"),
					create {CE_STRUCTURE_FIELD}.make ("prec"),
					create {CE_STRUCTURE_FIELD}.make ("showbase"),
					create {CE_STRUCTURE_FIELD}.make ("showpoint"),
					create {CE_STRUCTURE_FIELD}.make ("showtrailing"),
					create {CE_STRUCTURE_FIELD}.make ("sign"),
					create {CE_STRUCTURE_FIELD}.make ("width")
				>>)
			init_structure_info
		end

end
