class
	PD_GMP_DOSCAN_FUNS_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create scan.make
			create step.make
			create get.make
			create unget.make
		end

feature {ANY} -- fields

	scan: CE_ROUTINE assign set_scan

	step: CE_ROUTINE assign set_step

	get: CE_ROUTINE assign set_get

	unget: CE_ROUTINE assign set_unget

feature {ANY} -- setters

	set_scan (a_scan: CE_ROUTINE)
		do
			scan := a_scan
			update_memory_field ("scan")
		end

	set_step (a_step: CE_ROUTINE)
		do
			step := a_step
			update_memory_field ("step")
		end

	set_get (a_get: CE_ROUTINE)
		do
			get := a_get
			update_memory_field ("get")
		end

	set_unget (a_unget: CE_ROUTINE)
		do
			unget := a_unget
			update_memory_field ("unget")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			scan := a_other.scan
			step := a_other.step
			get := a_other.get
			unget := a_other.unget
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				scan.is_equal (a_other.scan) and
				step.is_equal (a_other.step) and
				get.is_equal (a_other.get) and
				unget.is_equal (a_other.unget)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("scan"),
					create {CE_STRUCTURE_FIELD}.make ("step"),
					create {CE_STRUCTURE_FIELD}.make ("get"),
					create {CE_STRUCTURE_FIELD}.make ("unget")
				>>)
			init_structure_info
		end

end
