class
	PD_GMP_PRIMESIEVE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create s.make (<<513>>)
		end

feature {ANY} -- fields

	d: NATURAL_32 assign set_d

	s0: NATURAL_32 assign set_s0

	sqrt_s0: NATURAL_32 assign set_sqrt_s0

	s: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_d (a_d: NATURAL_32)
		do
			d := a_d
			update_memory_field ("d")
		end

	set_s0 (a_s0: NATURAL_32)
		do
			s0 := a_s0
			update_memory_field ("s0")
		end

	set_sqrt_s0 (a_sqrt_s0: NATURAL_32)
		do
			sqrt_s0 := a_sqrt_s0
			update_memory_field ("sqrt_s0")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			s0 := a_other.s0
			sqrt_s0 := a_other.sqrt_s0
			s := a_other.s.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d = a_other.d and
				s0 = a_other.s0 and
				sqrt_s0 = a_other.sqrt_s0 and
				s.is_equal (a_other.s)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("s0"),
					create {CE_STRUCTURE_FIELD}.make ("sqrt_s0"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("s", <<513>>)
				>>)
			init_structure_info
		end

end
