class
	PD_GMP_RANDSTATE_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mp_seed.make (<<1>>)
			create mp_algdata.make
		end

feature {ANY} -- fields

	mp_seed: CE_ARRAY [PD_MPZ_STRUCT]

	mp_alg: NATURAL_32 assign set_mp_alg

	mp_algdata: PD_MP_ALGDATA assign set_mp_algdata

feature {ANY} -- setters

	set_mp_alg (a_mp_alg: NATURAL_32)
		do
			mp_alg := a_mp_alg
			update_memory_field ("mp_alg")
		end

	set_mp_algdata (a_mp_algdata: PD_MP_ALGDATA)
		do
			mp_algdata := a_mp_algdata
			update_memory_field ("mp_algdata")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_seed := a_other.mp_seed.twin
			mp_alg := a_other.mp_alg
			mp_algdata := a_other.mp_algdata.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_seed.is_equal (a_other.mp_seed) and
				mp_alg = a_other.mp_alg and
				mp_algdata.is_equal (a_other.mp_algdata)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mp_seed", <<1>>),
					create {CE_STRUCTURE_FIELD}.make ("mp_alg"),
					create {CE_STRUCTURE_FIELD}.make ("mp_algdata")
				>>)
			init_structure_info
		end

end
