class
	PD_IEEE_DOUBLE_EXTRACT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	s: PD_S assign set_s

	d: REAL_64 assign set_d

feature {ANY} -- setters

	set_s (a_s: PD_S)
		do
			s := a_s
			update_memory_field ("s")
		end

	set_d (a_d: REAL_64)
		do
			d := a_d
			update_memory_field ("d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s := a_other.s.twin
			d := a_other.d
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s.is_equal (a_other.s) and
				d = a_other.d
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("d")
				>>)
			init_structure_info
		end

end
