class
	PD_MPF_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mp_d.make
		end

feature {ANY} -- fields

	mp_prec: INTEGER_32 assign set_mp_prec

	mp_size: INTEGER_32 assign set_mp_size

	mp_exp: INTEGER_32 assign set_mp_exp

	mp_d: CE_POINTER [NATURAL_32] assign set_mp_d

feature {ANY} -- setters

	set_mp_prec (a_mp_prec: INTEGER_32)
		do
			mp_prec := a_mp_prec
			update_memory_field ("mp_prec")
		end

	set_mp_size (a_mp_size: INTEGER_32)
		do
			mp_size := a_mp_size
			update_memory_field ("mp_size")
		end

	set_mp_exp (a_mp_exp: INTEGER_32)
		do
			mp_exp := a_mp_exp
			update_memory_field ("mp_exp")
		end

	set_mp_d (a_mp_d: CE_POINTER [NATURAL_32])
		do
			mp_d := a_mp_d
			update_memory_field ("mp_d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_prec := a_other.mp_prec
			mp_size := a_other.mp_size
			mp_exp := a_other.mp_exp
			mp_d := a_other.mp_d
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_prec = a_other.mp_prec and
				mp_size = a_other.mp_size and
				mp_exp = a_other.mp_exp and
				mp_d.is_equal (a_other.mp_d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_prec"),
					create {CE_STRUCTURE_FIELD}.make ("mp_size"),
					create {CE_STRUCTURE_FIELD}.make ("mp_exp"),
					create {CE_STRUCTURE_FIELD}.make ("mp_d")
				>>)
			init_structure_info
		end

end
