class
	PD_MPQ_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mp_num.make
			create mp_den.make
		end

feature {ANY} -- fields

	mp_num: PD_MPZ_STRUCT assign set_mp_num

	mp_den: PD_MPZ_STRUCT assign set_mp_den

feature {ANY} -- setters

	set_mp_num (a_mp_num: PD_MPZ_STRUCT)
		do
			mp_num := a_mp_num
			update_memory_field ("mp_num")
		end

	set_mp_den (a_mp_den: PD_MPZ_STRUCT)
		do
			mp_den := a_mp_den
			update_memory_field ("mp_den")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_num := a_other.mp_num.twin
			mp_den := a_other.mp_den.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_num.is_equal (a_other.mp_num) and
				mp_den.is_equal (a_other.mp_den)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_num"),
					create {CE_STRUCTURE_FIELD}.make ("mp_den")
				>>)
			init_structure_info
		end

end
