class
	PD_POWERS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create p.make
		end

feature {ANY} -- fields

	p: CE_POINTER [NATURAL_32] assign set_p

	n: INTEGER_32 assign set_n

	shift: INTEGER_32 assign set_shift

	digits_in_base: NATURAL_32 assign set_digits_in_base

	base: INTEGER_32 assign set_base

feature {ANY} -- setters

	set_p (a_p: CE_POINTER [NATURAL_32])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_shift (a_shift: INTEGER_32)
		do
			shift := a_shift
			update_memory_field ("shift")
		end

	set_digits_in_base (a_digits_in_base: NATURAL_32)
		do
			digits_in_base := a_digits_in_base
			update_memory_field ("digits_in_base")
		end

	set_base (a_base: INTEGER_32)
		do
			base := a_base
			update_memory_field ("base")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p := a_other.p
			n := a_other.n
			shift := a_other.shift
			digits_in_base := a_other.digits_in_base
			base := a_other.base
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p.is_equal (a_other.p) and
				n = a_other.n and
				shift = a_other.shift and
				digits_in_base = a_other.digits_in_base and
				base = a_other.base
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("shift"),
					create {CE_STRUCTURE_FIELD}.make ("digits_in_base"),
					create {CE_STRUCTURE_FIELD}.make ("base")
				>>)
			init_structure_info
		end

end
