class
	P_CFDIV_R_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cdiv_r_2exp (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		do
			gmpz_cfdiv_r_2exp (1, a_w, a_u, a_cnt)
		end

	gmpz_cfdiv_r_2exp (a_dir: INTEGER_32; a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_i: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_high: NATURAL_32
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_up.make
			create l_wp.make (<<1>>)
			create l___d.make
			create l___s.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l___ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cnt := a_cnt
					l_usize := (a_u.item.mp_size).to_integer_32
					if l_usize = 0 then
						a_w.item.mp_size := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
						l_cnt := l_cnt \\ ({NATURAL_32} 32)
						if l_usize >= 0 then
							l_abs_usize := l_usize
						else
							l_abs_usize := -l_usize
						end
						l_up := a_u.item.mp_d
						if not (((l_usize).bit_xor (a_dir.to_integer_32)) < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_w.is_equal (a_u) then
							if l_abs_usize <= l_limb_cnt then
								js.return
							end
							if not js.return_called then
								l_wp.item := a_w.item.mp_d
							end
						else
							if l_abs_usize < l_limb_cnt + 1 then
								l_i := l_abs_usize
							else
								l_i := l_limb_cnt + 1
							end
							if (builtin_expect ((l_i > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								realloc_inst.gmpz_realloc (a_w, l_i).do_nothing
							end
							l_wp.item := a_w.item.mp_d
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_wp.item, l_up, l_i)
									js.break
								end
								js.break
							end
							if l_abs_usize <= l_limb_cnt then
								a_w.item.mp_size := l_usize.to_integer_32
								js.return
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if l_abs_usize <= l_limb_cnt then
							l_pos := -1 + 11 -- goto negate
						end
				when 5 then
						l_i := (0).to_integer_32
				when 6 then -- loop condition:
						if not (l_i < l_limb_cnt) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						if l_up[l_i] /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- goto negate
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						if ((l_up[l_limb_cnt]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt.to_integer_32)) - {NATURAL_32} 1))) /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- goto negate
						end
				when 10 then
						a_w.item.mp_size := 0
						js.return
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | negate:
						if (builtin_expect ((l_limb_cnt + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_w, l_limb_cnt + 1).do_nothing
						end
						l_up := a_u.item.mp_d
						l_wp.item := a_w.item.mp_d
						if l_abs_usize < l_limb_cnt + 1 then
							l_i := l_abs_usize
						else
							l_i := l_limb_cnt + 1
						end
						from
						until
							js.loop_done
						loop
							l___d := l_wp.item
							l___s := l_up
							l___n := l_i
							from
							until
								js.loop_done
							loop
								l_tmp___1 := l___d
								l___d := l___d + 1
								l_tmp___2 := l___s
								l___s := l___s + 1
								l_tmp___1.item := (((l_tmp___2.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
							js.break
						end
						from
						until
							not (l_i <= l_limb_cnt)
						loop
							l_wp.item[l_i] := {NATURAL_32} 4_294_967_295
							l_i := l_i + 1
						end
						from
						until
							js.loop_done
						loop
							asm9 (l___ptr_dummy, l_wp)
							js.break
						end
						l_usize := -l_usize
				when 12 then -- if done | if done | if done
						if not js.return_called then
							l_high := l_wp.item[l_limb_cnt]
							l_high := (l_high).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt.to_integer_32)) - {NATURAL_32} 1))
							l_wp.item[l_limb_cnt] := l_high
							from
							until
								not (not js.loop_done and then (l_high = {NATURAL_32} 0))
							loop
								l_limb_cnt := l_limb_cnt - 1
								if l_limb_cnt < 0 then
									a_w.item.mp_size := 0
									js.return
								end
								if not js.return_called then
									l_high := l_wp.item[l_limb_cnt]
								end
							end
						end
						if not js.return_called then
							l_limb_cnt := l_limb_cnt + 1
							if l_usize >= 0 then
								a_w.item.mp_size := l_limb_cnt.to_integer_32
							else
								a_w.item.mp_size := (-l_limb_cnt).to_integer_32
							end
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpz_fdiv_r_2exp (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		do
			gmpz_cfdiv_r_2exp (-1, a_w, a_u, a_cnt)
		end

end
