class
	P_CMP_SI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_cmp_si (a_u: CE_POINTER [PD_MPF_STRUCT]; a_vval: INTEGER_32): INTEGER_32
		local
			l_vval: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_uexp: INTEGER_32
			l_ulimb: NATURAL_32
			l_usign: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make

			l_vval := a_vval
			l_uexp := a_u.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			if (l_usize < 0) = (l_vval < 0) then
				if l_usize = 0 then
					Result := (-(l_vval /= 0).to_integer).to_integer
					js.return
				end
				if not js.return_called and then (l_vval = 0) then
					Result := (l_usize /= 0).to_integer
					js.return
				end
			else
				if l_usize >= 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_usign := 1
				else
					l_usign := -1
				end
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if l_vval >= 0 then
					l_vval := l_vval
				else
					l_vval := -l_vval
				end
				if l_uexp > 1 then
					Result := l_usign
					js.return
				end
			end
			if not js.return_called and then (l_uexp < 1) then
				Result := (-l_usign)
				js.return
			end
			if not js.return_called then
				l_up := a_u.item.mp_d
				l_ulimb := l_up[(l_usize - 1)]
				l_usize := l_usize - 1
				if l_ulimb > l_vval.to_natural_32 then
					Result := l_usign
					js.return
				elseif l_ulimb < l_vval.to_natural_32 then
					Result := (-l_usign)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
					l_usize := l_usize - 1
				end
				if l_usize > 0 then
					Result := l_usign
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gmpq_cmp_si (a_q: CE_POINTER [PD_MPQ_STRUCT]; a_n: INTEGER_32; a_d: NATURAL_32): INTEGER_32
		local
			l_qabs: CE_ARRAY [PD_MPQ_STRUCT]
		do
			create l_qabs.make (<<1>>)

			if a_q.item.mp_num.mp_size >= 0 then
				if a_n >= 0 then
					Result := (cmp_ui_inst.gmpq_cmp_ui (a_q, a_n.to_natural_32, a_d))
				else
					Result := 1
				end
			elseif a_n >= 0 then
				Result := (-1)
			else
				if a_q.item.mp_num.mp_size >= 0 then
					l_qabs[0].mp_num.mp_size := a_q.item.mp_num.mp_size
				else
					l_qabs[0].mp_num.mp_size := (-a_q.item.mp_num.mp_size)
				end
				l_qabs[0].mp_num.mp_d := a_q.item.mp_num.mp_d
				l_qabs[0].mp_den.mp_size := a_q.item.mp_den.mp_size
				l_qabs[0].mp_den.mp_d := a_q.item.mp_den.mp_d
				Result := (-(cmp_ui_inst.gmpq_cmp_ui (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_qabs), (-a_n).to_natural_32, a_d)))
			end
		end

	gmpz_cmp_si (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v_digit: INTEGER_32): INTEGER_32
		local
			l_v_digit: INTEGER_32
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_u_digit: NATURAL_32
			js: JUMP_STATE
		do
			l_v_digit := a_v_digit
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (0).to_integer_32
			if l_v_digit > 0 then
				l_vsize := (1).to_integer_32
			elseif l_v_digit < 0 then
				l_vsize := (-1).to_integer_32
				l_v_digit := -l_v_digit
			end
			if l_usize /= l_vsize then
				Result := (l_usize - l_vsize).to_integer_32
				js.return
			end
			if not js.return_called and then (l_usize = 0) then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_u_digit := a_u.item.mp_d[0]
				if l_u_digit = l_v_digit.to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_u_digit > l_v_digit.to_natural_32 then
					Result := l_usize.to_integer_32
				else
					Result := (-l_usize).to_integer_32
				end
			end
		end

end
