class
	P_DIVE_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_divexact_ui (a_dst: CE_POINTER [PD_MPZ_STRUCT]; a_src: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32)
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_dst_ptr: CE_POINTER [NATURAL_32]
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			js: JUMP_STATE
		do
			create l_dst_ptr.make
			create l_dlimbs.make (<<2>>)
			create l_dz.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			if a_divisor > {NATURAL_32} 4_294_967_295 then
				l_dz[0].mp_alloc := 2
				l_dz[0].mp_d := l_dlimbs
				set_ui_inst.gmpz_set_ui (l_dz, a_divisor)
				divexact_inst.gmpz_divexact (a_dst, a_src, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz))
				js.return
			end
			if not js.return_called then
				l_size := (a_src.item.mp_size).to_integer_32
				if l_size = 0 then
					a_dst.item.mp_size := 0
					js.return
				end
			end
			if not js.return_called then
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				if (builtin_expect ((l_abs_size > (a_dst.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_dst, l_abs_size).do_nothing
				end
				l_dst_ptr := a_dst.item.mp_d
				from
				until
					js.loop_done
				loop
					gmp_impl_inst.gmpn_divexact_1 (l_dst_ptr, a_src.item.mp_d, l_abs_size, a_divisor)
					js.break
				end
				l_abs_size := l_abs_size - (l_dst_ptr[(l_abs_size - 1)] = {NATURAL_32} 0).to_integer
				if l_size >= 0 then
					a_dst.item.mp_size := l_abs_size.to_integer_32
				else
					a_dst.item.mp_size := (-l_abs_size).to_integer_32
				end
			end
		end

end
