class
	P_EQ

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_eq (a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: CE_POINTER [PD_MPF_STRUCT]; a_n_bits: NATURAL_32): INTEGER_32
		local
			l_n_bits: NATURAL_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_p: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_minsize: INTEGER_32
			l_maxsize: INTEGER_32
			l_n_limbs: INTEGER_32
			l_i: INTEGER_32
			l_size: INTEGER_32
			l_uexp: INTEGER_32
			l_vexp: INTEGER_32
			l_diff: NATURAL_32
			l_cnt: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_vp.make
			create l_p.make

			l_n_bits := a_n_bits
			l_uexp := a_u.item.mp_exp
			l_vexp := a_v.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			if ((l_usize).bit_xor (l_vsize)) >= 0 then
				if l_usize = 0 then
					Result := (l_vsize = 0).to_integer
					js.return
				end
				if not js.return_called and then (l_vsize = 0) then
					Result := 0
					js.return
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called and then (l_uexp /= l_vexp) then
				Result := 0
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if l_vsize >= 0 then
					l_vsize := l_vsize
				else
					l_vsize := -l_vsize
				end
				l_up := a_u.item.mp_d
				l_vp := a_v.item.mp_d
				l_up := l_up + l_usize
				l_vp := l_vp + l_vsize
				from
				until
					js.loop_done
				loop
					l_cnt := builtin_clzl (l_up[-1])
					js.break
				end
				if (l_vp[-1]).bit_shift_right ((31 - l_cnt)) /= {NATURAL_32} 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_n_bits := l_n_bits + l_cnt.to_natural_32
				l_n_limbs := (((l_n_bits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
				if l_usize < l_n_limbs then
					l_usize := l_usize
				else
					l_usize := l_n_limbs
				end
				if l_vsize < l_n_limbs then
					l_vsize := l_vsize
				else
					l_vsize := l_n_limbs
				end
				if l_usize < l_vsize then
					l_minsize := l_usize
				else
					l_minsize := l_vsize
				end
				l_maxsize := (l_usize + l_vsize) - l_minsize
				l_up := l_up - l_minsize
				l_vp := l_vp - l_minsize
				l_i := l_minsize - 1
				from
				until
					not (not js.loop_done and then (l_i > 0))
				loop
					if l_up[l_i] /= l_vp[l_i] then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i := l_i - 1
					end
				end
			end
			if not js.return_called then
				l_n_bits := l_n_bits - ((l_maxsize - 1) * 32).to_natural_32
				l_size := l_maxsize - l_minsize
				if l_size /= 0 then
					if l_up[0] /= l_vp[0] then
						Result := 0
						js.return
					end
					if not js.return_called then
						if l_usize > l_vsize then
							l_p := l_up - l_size
						else
							l_p := l_vp - l_size
						end
						l_i := l_size - 1
						from
						until
							not (not js.loop_done and then (l_i > 0))
						loop
							if l_p[l_i] /= {NATURAL_32} 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								l_i := l_i - 1
							end
						end
					end
					if not js.return_called then
						l_diff := l_p[0]
					end
				else
					l_diff := ((l_up[0]).bit_xor (l_vp[0]))
				end
			end
			if not js.return_called then
				if l_n_bits < {NATURAL_32} 32 then
					l_diff := (l_diff).bit_shift_right (({NATURAL_32} 32 - l_n_bits).to_integer_32)
				end
				Result := (l_diff = {NATURAL_32} 0).to_integer
			end
		end

end
