class
	P_EQUAL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_equal (a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT]): INTEGER_32
		local
			l_num1_size: INTEGER_32
			l_num2_size: INTEGER_32
			l_den1_size: INTEGER_32
			l_den2_size: INTEGER_32
			l_i: INTEGER_32
			l_num1_ptr: CE_POINTER [NATURAL_32]
			l_num2_ptr: CE_POINTER [NATURAL_32]
			l_den1_ptr: CE_POINTER [NATURAL_32]
			l_den2_ptr: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_num1_ptr.make
			create l_num2_ptr.make
			create l_den1_ptr.make
			create l_den2_ptr.make

			l_num1_size := (a_op1.item.mp_num.mp_size).to_integer_32
			l_num2_size := (a_op2.item.mp_num.mp_size).to_integer_32
			if l_num1_size /= l_num2_size then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_num1_ptr := a_op1.item.mp_num.mp_d
				l_num2_ptr := a_op2.item.mp_num.mp_d
				if l_num1_size >= 0 then
					l_num1_size := l_num1_size
				else
					l_num1_size := -l_num1_size
				end
				l_i := (0).to_integer_32
				from
				until
					not (not js.loop_done and then (l_i < l_num1_size))
				loop
					if l_num1_ptr[l_i] /= l_num2_ptr[l_i] then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_den1_size := (a_op1.item.mp_den.mp_size).to_integer_32
				l_den2_size := (a_op2.item.mp_den.mp_size).to_integer_32
				if l_den1_size /= l_den2_size then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_den1_ptr := a_op1.item.mp_den.mp_d
				l_den2_ptr := a_op2.item.mp_den.mp_d
				l_i := (0).to_integer_32
				from
				until
					not (not js.loop_done and then (l_i < l_den1_size))
				loop
					if l_den1_ptr[l_i] /= l_den2_ptr[l_i] then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

end
