class
	P_GCD_LEHMER

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gcd_2 (a_gp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_vp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_u0: NATURAL_32
			l_u1: NATURAL_32
			l_v0: NATURAL_32
			l_v1: NATURAL_32
			l_gn: INTEGER_32
			l_r: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			l_u0 := a_up[0]
			l_u1 := a_up[1]
			l_v0 := a_vp[0]
			l_v1 := a_vp[1]
			from
			until
				js.loop_done
			loop
				if l_u1 /= l_v1 then
					if l_u0 = l_v0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if l_u1 > l_v1 then
						l_u1 := l_u1 - (l_v1 + (l_u0 < l_v0).to_integer.to_natural_32)
						l_u0 := ((l_u0 - l_v0)).bit_and ({NATURAL_32} 4_294_967_295)
						from
						until
							js.loop_done
						loop
							l_r := (builtin_ctzl (l_u0)).to_natural_32
							js.break
						end
						l_u0 := (((((l_u1).bit_shift_left (({NATURAL_32} 32 - l_r).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_u0).bit_shift_right (l_r.to_integer_32)))
						l_u1 := (l_u1).bit_shift_right (l_r.to_integer_32)
					else
						l_v1 := l_v1 - (l_u1 + (l_v0 < l_u0).to_integer.to_natural_32)
						l_v0 := ((l_v0 - l_u0)).bit_and ({NATURAL_32} 4_294_967_295)
						from
						until
							js.loop_done
						loop
							l_r := (builtin_ctzl (l_v0)).to_natural_32
							js.break
						end
						l_v0 := (((((l_v1).bit_shift_left (({NATURAL_32} 32 - l_r).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_v0).bit_shift_right (l_r.to_integer_32)))
						l_v1 := (l_v1).bit_shift_right (l_r.to_integer_32)
					end
				end
			end
			a_gp[0] := l_u0
			a_gp[1] := l_u1
			l_gn := (1 + (l_u1 /= {NATURAL_32} 0).to_integer).to_integer_32
			if l_u1 = l_v1 then
				if l_u0 = l_v0 then
					Result := l_gn
					js.return
				end
			end
			if not js.return_called then
				if l_u0 = l_v0 then
					if l_u1 > l_v1 then
						l_tmp___1 := l_u1 - l_v1
					else
						l_tmp___1 := l_v1 - l_u1
					end
					l_v0 := l_tmp___1
				else
					if l_u0 > l_v0 then
						l_tmp___2 := l_u0 - l_v0
					else
						l_tmp___2 := l_v0 - l_u0
					end
					l_v0 := l_tmp___2
				end
				a_gp[0] := gcd_1_inst.gmpn_gcd_1 (a_gp, l_gn, l_v0)
				Result := (1).to_integer_32
			end
		end

	gmpn_gcd_lehmer_n (a_gp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_M: CE_ARRAY [PD_HGCD_MATRIX1]
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_mask: NATURAL_32
			l_shift: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_gn: CE_ARRAY [INTEGER_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_ap.make
			create l_bp.make
			create l_tp.make
			create l_M.make (<<1>>)
			create l___mp_ptr_swap__tmp.make
			create l_gn.make (<<1>>)
			create l___mp_ptr_swap__tmp___0.make

			l_ap := a_ap
			l_bp := a_bp
			l_n := a_n
			l_tp := a_tp
			from
			until
				not (not js.loop_done and then (l_n > 2))
			loop
				l_mask := (l_ap[(l_n - 1)]).bit_or (l_bp[(l_n - 1)])
				if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
					l_ah := l_ap[(l_n - 1)]
					l_al := l_ap[(l_n - 2)]
					l_bh := l_bp[(l_n - 1)]
					l_bl := l_bp[(l_n - 2)]
				else
					from
					until
						js.loop_done
					loop
						l_shift := builtin_clzl (l_mask)
						js.break
					end
					l_ah := (((((l_ap[(l_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 2)]).bit_shift_right ((32 - l_shift))))
					l_al := (((((l_ap[(l_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 3)]).bit_shift_right ((32 - l_shift))))
					l_bh := (((((l_bp[(l_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[(l_n - 2)]).bit_shift_right ((32 - l_shift))))
					l_bl := (((((l_bp[(l_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[(l_n - 3)]).bit_shift_right ((32 - l_shift))))
				end
				if (hgcd2_inst.gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M)).to_boolean then
					l_n := hgcd2_inst.gmpn_hgcd_mul_matrix1_inverse_vector (l_M, l_tp, l_ap, l_bp, l_n)
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp := l_ap
						l_ap := l_tp
						l_tp := l___mp_ptr_swap__tmp
						js.break
					end
				else
					l_n := gcd_subdiv_step_inst.gmpn_gcd_subdiv_step (a_gp, l_gn, l_ap, l_bp, l_n, l_tp)
					if l_n = 0 then
						Result := (l_gn.item)
						js.return
					end
				end
			end
			if not js.return_called and then (l_n = 1) then
				a_gp.item := gcd_1_inst.gmpn_gcd_1 (l_ap, (1).to_integer_32, l_bp[0])
				Result := (1).to_integer_32
				js.return
			end
			if not js.return_called then
				if not ((l_ap[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp___0 := l_ap
						l_ap := l_bp
						l_bp := l___mp_ptr_swap__tmp___0
						js.break
					end
				end
				if l_bp[0] = {NATURAL_32} 0 then
					a_gp.item := gcd_1_inst.gmpn_gcd_1 (l_ap, (2).to_integer_32, l_bp[1])
					Result := (1).to_integer_32
					js.return
				elseif not ((l_bp[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					from
					until
						js.loop_done
					loop
						l_r := builtin_ctzl (l_bp[0])
						js.break
					end
					l_bp[0] := (((((l_bp[1]).bit_shift_left ((32 - l_r)))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[0]).bit_shift_right (l_r)))
					l_bp[1] := (l_bp[1]).bit_shift_right (l_r)
				end
			end
			if not js.return_called then
				Result := (gcd_2 (a_gp, l_ap, l_bp))
			end
		end

end
