class
	P_GCDEXT_LEHMER

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcdext_lehmer_n (a_gp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_usize: CE_POINTER [INTEGER_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_ualloc: INTEGER_32
			l_un: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_u2: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_M: CE_ARRAY [PD_HGCD_MATRIX1]
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_mask: NATURAL_32
			l_shift: INTEGER_32
			l_shift___0: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_gn: CE_ARRAY [INTEGER_32]
			l_updated_un: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_uh: NATURAL_32
			l_vh: NATURAL_32
			l_u: CE_ARRAY [INTEGER_32]
			l_v: CE_ARRAY [INTEGER_32]
			l_negate: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_ap.make
			create l_tp.make
			create l_u0.make
			create l_u1.make
			create l_u2.make
			create l___dst.make
			create l_tmp.make
			create l_M.make (<<1>>)
			create l___mp_ptr_swap__tmp.make
			create l___mp_ptr_swap__tmp___0.make
			create l_gn.make (<<1>>)
			create l_updated_un.make (<<1>>)
			create l_u.make (<<1>>)
			create l_v.make (<<1>>)

			l_ap := a_ap
			l_n := a_n
			l_tp := a_tp
			l_ualloc := l_n + 1
			from
			until
				js.loop_done
			loop
				if 3 * l_ualloc /= 0 then
					l___dst := l_tp
					l___n := 3 * l_ualloc
					from
					until
						js.loop_done
					loop
						l_tmp := l___dst
						l___dst := l___dst + 1
						l_tmp.item := (0).to_natural_32
						l___n := l___n - 1
						if not l___n.to_boolean then
							js.break
						end
					end
				end
				js.break
			end
			l_u0 := l_tp
			l_tp := l_tp + l_ualloc
			l_u1 := l_tp
			l_tp := l_tp + l_ualloc
			l_u2 := l_tp
			l_tp := l_tp + l_ualloc
			l_u1[0] := (1).to_natural_32
			l_un := (1).to_integer_32
			from
			until
				not (not js.loop_done and then (l_n >= 2))
			loop
				l_mask := (l_ap[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])
				if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
					l_ah := l_ap[(l_n - 1)]
					l_al := l_ap[(l_n - 2)]
					l_bh := a_bp[(l_n - 1)]
					l_bl := a_bp[(l_n - 2)]
				elseif l_n = 2 then
					from
					until
						js.loop_done
					loop
						l_shift := builtin_clzl (l_mask)
						js.break
					end
					l_ah := (((((l_ap[1]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[0]).bit_shift_right ((32 - l_shift))))
					l_al := (l_ap[0]).bit_shift_left (l_shift)
					l_bh := (((((a_bp[1]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((a_bp[0]).bit_shift_right ((32 - l_shift))))
					l_bl := (a_bp[0]).bit_shift_left (l_shift)
				else
					from
					until
						js.loop_done
					loop
						l_shift___0 := builtin_clzl (l_mask)
						js.break
					end
					l_ah := (((((l_ap[(l_n - 1)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 2)]).bit_shift_right ((32 - l_shift___0))))
					l_al := (((((l_ap[(l_n - 2)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 3)]).bit_shift_right ((32 - l_shift___0))))
					l_bh := (((((a_bp[(l_n - 1)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((a_bp[(l_n - 2)]).bit_shift_right ((32 - l_shift___0))))
					l_bl := (((((a_bp[(l_n - 2)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((a_bp[(l_n - 3)]).bit_shift_right ((32 - l_shift___0))))
				end
				if (hgcd2_inst.gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M)).to_boolean then
					l_n := hgcd2_inst.gmpn_hgcd_mul_matrix1_inverse_vector (l_M, l_tp, l_ap, a_bp, l_n)
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp := l_ap
						l_ap := l_tp
						l_tp := l___mp_ptr_swap__tmp
						js.break
					end
					l_un := hgcd2_inst.gmpn_hgcd_mul_matrix1_vector (l_M, l_u2, l_u0, l_u1, l_un)
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp___0 := l_u0
						l_u0 := l_u2
						l_u2 := l___mp_ptr_swap__tmp___0
						js.break
					end
				else
					l_updated_un.item := l_un
					l_n := gcdext_subdiv_step_inst.gmpn_gcdext_subdiv_step (a_gp, l_gn, a_up, a_usize, l_ap, a_bp, l_n, l_u0, l_u1, l_updated_un, l_tp, l_u2)
					if l_n = 0 then
						Result := (l_gn.item)
						js.return
					end
					if not js.return_called then
						l_un := l_updated_un.item
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if not (l_ap[0] > {NATURAL_32} 0) then
						assert_inst.gmp_assert_fail (ce_string ("gcdext_lehmer.c"), 122, ce_string ("ap[0] > 0"))
					end
					js.break
				end
				from
				until
					js.loop_done
				loop
					if not (a_bp[0] > {NATURAL_32} 0) then
						assert_inst.gmp_assert_fail (ce_string ("gcdext_lehmer.c"), 123, ce_string ("bp[0] > 0"))
					end
					js.break
				end
				if l_ap[0] = a_bp[0] then
					a_gp[0] := l_ap[0]
					from
					until
						js.loop_done
					loop
						l_c := 0
						l___gmp_i := l_un
						from
						until
							js.loop_done
						loop
							l___gmp_i := l___gmp_i - 1
							if not (l___gmp_i >= 0) then
								js.break
							end
							if not js.loop_jumped then
								l___gmp_x := l_u0[l___gmp_i]
								l___gmp_y := l_u1[l___gmp_i]
								if l___gmp_x /= l___gmp_y then
									if l___gmp_x > l___gmp_y then
										l_c := 1
									else
										l_c := -1
									end
									js.break
								end
							end
						end
						js.break
					end
					if l_c < 0 then
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_un > 0))
							loop
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
								js.break
							end
							js.break
						end
						a_usize.item := -l_un
					else
						from
						until
							js.loop_done
						loop
							from
							until
								(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
							loop
								l_un := l_un - 1
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
								js.break
							end
							js.break
						end
						a_usize.item := l_un
					end
					Result := (1).to_integer_32
				else
					a_gp[0] := gcdext_1_inst.gmpn_gcdext_1 (l_u, l_v, l_ap[0], a_bp[0])
					if l_u.item = 0 then
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_un > 0))
							loop
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
								js.break
							end
							js.break
						end
						a_usize.item := -l_un
						Result := (1).to_integer_32
						js.return
					elseif l_v.item = 0 then
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_un > 0))
							loop
								if l_u1[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
								js.break
							end
							js.break
						end
						a_usize.item := l_un
						Result := (1).to_integer_32
						js.return
					elseif l_u.item > 0 then
						l_negate := 0
						l_v.item := -l_v.item
					else
						l_negate := 1
						l_u.item := -l_u.item
					end
					if not js.return_called then
						l_uh := gmp_inst.gmpn_mul_1 (a_up, l_u1, l_un, (l_u.item).to_natural_32)
						l_vh := gmp_inst.gmpn_addmul_1 (a_up, l_u0, l_un, (l_v.item).to_natural_32)
						if ((l_uh).bit_or (l_vh)) > {NATURAL_32} 0 then
							l_uh := l_uh + l_vh
							l_tmp___1 := l_un
							l_un := l_un + 1
							a_up[l_tmp___1] := l_uh
							if l_uh < l_vh then
								l_tmp___2 := l_un
								l_un := l_un + 1
								a_up[l_tmp___2] := (1).to_natural_32
							end
						end
						from
						until
							js.loop_done
						loop
							from
							until
								(a_up[(l_un - 1)] /= {NATURAL_32} 0)
							loop
								l_un := l_un - 1
							end
							js.break
						end
						if l_negate.to_boolean then
							a_usize.item := -l_un
						else
							a_usize.item := l_un
						end
						Result := (1).to_integer_32
					end
				end
			end
		end

end
