class
	P_GET_D

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_get_d (a_src: CE_POINTER [PD_MPF_STRUCT]): REAL_64
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_exp: INTEGER_32
			js: JUMP_STATE
		do
			l_size := (a_src.item.mp_size).to_integer_32
			if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				l_exp := ((a_src.item.mp_exp - l_abs_size) * 32)
				Result := (gmpn_get_d (a_src.item.mp_d, l_abs_size, l_size, l_exp))
			end
		end

	gmpn_get_d (a_up: CE_POINTER [NATURAL_32]; a_size: INTEGER_32; a_sign: INTEGER_32; a_exp: INTEGER_32): REAL_64
		local
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_lshift: INTEGER_32
			l_nbits: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_x___2: NATURAL_32
			l_mhi: NATURAL_32
			l_mlo: NATURAL_32
			l_rshift: INTEGER_32
			l_tmp___1: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_up.make
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_up := a_up
					l_size := a_size
					l_exp := a_exp
					if l_size = 0 then
						Result := (0.0)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not ((builtin_expect (((32 * l_size).to_natural_32 > (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) - l_exp).to_natural_32).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 9 -- goto ieee_infinity
				when 3 then
						l_exp := -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else:
						l_exp := l_exp + (32 * l_size)
				when 6 then -- if done
						l_up := l_up + l_size
						l_up := l_up - 1
						l_x___2 := l_up.item
						l_size := l_size - 1
						from
						until
							js.loop_done
						loop
							l_lshift := builtin_clzl (l_x___2)
							js.break
						end
						l_exp := l_exp - (l_lshift + 1).to_integer_32
						l_x___2 := (l_x___2).bit_shift_left (l_lshift)
						l_mhi := (l_x___2).bit_shift_right (11)
						if l_lshift < 11 then
							l_mlo := (l_x___2).bit_shift_left (21)
							l_nbits := (32 - l_lshift) - 21
						elseif l_size /= 0 then
							l_nbits := 32 - l_lshift
							l_up := l_up - 1
							l_x___2 := l_up.item
							l_size := l_size - 1
							l_x___2 := l_x___2
							l_mhi := (l_mhi).bit_or (((((l_x___2).bit_shift_right (l_nbits))).bit_shift_right (11)))
							l_mlo := (l_x___2).bit_shift_left (((32 - l_nbits) - 11))
							l_nbits := l_nbits + (11)
						else
							l_mlo := (0).to_natural_32
							l_pos := -1 + 8 -- goto done
						end
				when 7 then
						if l_nbits < 32 then
							if l_size /= 0 then
								l_up := l_up - 1
								l_x___2 := l_up.item
								l_size := l_size - 1
								l_x___2 := l_x___2
								l_x___2 := (l_x___2).bit_shift_right (l_nbits)
								l_mlo := (l_mlo).bit_or (l_x___2)
								l_nbits := l_nbits + (32)
								if l_nbits < 32 then
									if l_size /= 0 then
										l_up := l_up - 1
										l_x___2 := l_up.item
										l_size := l_size - 1
										l_x___2 := l_x___2
										l_x___2 := (l_x___2).bit_shift_right (l_nbits)
										l_mlo := (l_mlo).bit_or (l_x___2)
										l_nbits := l_nbits + (32)
									end
								end
							end
						end
				when 8 then -- done:
						if not ((builtin_expect ((l_exp >= 1_024).to_integer, 0)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | ieee_infinity:
						l_mhi := (0).to_natural_32
						l_mlo := (0).to_natural_32
						l_exp := 1_024
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (builtin_expect ((l_exp <= -1_023).to_integer, 0)).to_boolean then
							if (builtin_expect ((l_exp <= -1_075).to_integer, 1)).to_boolean then
								Result := (0.0)
								js.return
							end
							if not js.return_called then
								l_rshift := (-1_022 - l_exp).to_integer_32
								if l_rshift >= 32 then
									l_mlo := l_mhi
									l_mhi := (0).to_natural_32
									l_rshift := l_rshift - (32)
								end
								l_lshift := 32 - l_rshift
								if l_rshift = 0 then
									l_tmp___1 := (0).to_natural_32
								else
									l_tmp___1 := (l_mhi).bit_shift_left (l_lshift)
								end
								l_mlo := (((l_mlo).bit_shift_right (l_rshift))).bit_or (l_tmp___1)
								l_mhi := (l_mhi).bit_shift_right (l_rshift)
								l_exp := -1_023
							end
						end
				when 12 then -- if done | if done
						if not js.return_called then
							l_u.s.manh := l_mhi.to_natural_32
							l_u.update_class_fields -- synchronize union
							l_u.s.manl := l_mlo.to_natural_32
							l_u.update_class_fields -- synchronize union
							l_u.s.exp := (l_exp + 1_023).to_natural_32
							l_u.update_class_fields -- synchronize union
							l_u.s.sig := (a_sign < 0).to_integer.to_natural_32
							l_u.update_class_fields -- synchronize union
							Result := (l_u.d)
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpq_get_d (a_src: CE_POINTER [PD_MPQ_STRUCT]): REAL_64
		local
			l_res: REAL_64
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_nsize: INTEGER_32
			l_dsize: INTEGER_32
			l_qsize: INTEGER_32
			l_prospective_qsize: INTEGER_32
			l_zeros: INTEGER_32
			l_chop: INTEGER_32
			l_tsize: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_exp: INTEGER_32
			l_qarr: CE_ARRAY [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___12: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___16: CE_POINTER [ANY]
			l_tmp___17: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___19: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_remp.make
			create l_tp.make
			create l_qarr.make (<<(({NATURAL_32} 1 + (({PLATFORM}.Real_64_bytes.to_natural_32 + {NATURAL_32} 4) - {NATURAL_32} 1) // {NATURAL_32} 4) + {NATURAL_32} 1).to_integer_32>>)
			create l_qp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___16.make
			create l___dst.make
			create l_tmp___19.make

			l_nsize := (a_src.item.mp_num.mp_size).to_integer_32
			l_dsize := (a_src.item.mp_den.mp_size).to_integer_32
			l_sign_quotient := l_nsize
			l_qp := l_qarr
			if (builtin_expect ((l_nsize = 0).to_integer, 0)).to_boolean then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if l_nsize >= 0 then
					l_nsize := l_nsize
				else
					l_nsize := -l_nsize
				end
				if l_dsize >= 0 then
					l_dsize := l_dsize
				else
					l_dsize := -l_dsize
				end
				l_np := a_src.item.mp_num.mp_d
				l_dp := a_src.item.mp_den.mp_d
				l_prospective_qsize := (l_nsize - l_dsize) + 1
				l_qsize := (({NATURAL_32} 1 + (({PLATFORM}.Real_64_bytes.to_natural_32 + {NATURAL_32} 4) - {NATURAL_32} 1) // {NATURAL_32} 4) + {NATURAL_32} 1).to_integer_32
				l_zeros := l_qsize - l_prospective_qsize
				l_exp := -l_zeros * 32
				if -l_zeros > 0 then
					l_chop := -l_zeros
				else
					l_chop := (0).to_integer_32
				end
				l_np := l_np + l_chop
				l_nsize := l_nsize - l_chop
				l_zeros := l_zeros + l_chop
				l_tsize := l_nsize + l_zeros
				if l_zeros > 0 then
					l_tmp___17 := l_tsize
				else
					l_tmp___17 := (0).to_integer_32
				end
				if (builtin_expect (((l_dsize + l_tmp___17).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					if l_zeros > 0 then
						l_tmp___12 := l_tsize
					else
						l_tmp___12 := (0).to_integer_32
					end
					l_tmp___16 := (l_aaf.new (((l_dsize + l_tmp___12).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					if l_zeros > 0 then
						l_tmp___14 := l_tsize
					else
						l_tmp___14 := (0).to_integer_32
					end
					l_tmp___16 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_dsize + l_tmp___14).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_remp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___16)
				l_tp := l_remp + l_dsize
				if l_zeros > 0 then
					from
					until
						js.loop_done
					loop
						if l_zeros /= 0 then
							l___dst := l_tp
							l___n := l_zeros
							from
							until
								js.loop_done
							loop
								l_tmp___19 := l___dst
								l___dst := l___dst + 1
								l_tmp___19.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_tp + l_zeros, l_np, l_nsize)
							js.break
						end
						js.break
					end
					l_np := l_tp
					l_nsize := l_tsize
				end
				tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_remp, (0).to_integer_32, l_np, l_nsize, l_dp, l_dsize)
				l_qsize := l_qsize - (l_qp[(l_qsize - 1)] = {NATURAL_32} 0).to_integer
				l_res := gmpn_get_d (l_qp, l_qsize, l_sign_quotient, l_exp)
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				Result := l_res
			end
		end

	gmpz_get_d (a_z: CE_POINTER [PD_MPZ_STRUCT]): REAL_64
		local
			l_size: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_size := (a_z.item.mp_size).to_integer_32
			if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_size >= 0 then
					l_tmp___0 := l_size
				else
					l_tmp___0 := -l_size
				end
				Result := (gmpn_get_d (a_z.item.mp_d, l_tmp___0, l_size, 0))
			end
		end

end
