class
	P_HAMDIST

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_hamdist (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_count: NATURAL_32
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_ulimb: NATURAL_32
			l_vlimb: NATURAL_32
			l_old_vsize: INTEGER_32
			l_step___1: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [NATURAL_32]
			l___mp_srcptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l___x: NATURAL_32
			l_twoscount: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l_tmp___4: CE_POINTER [NATURAL_32]
			l___x___0: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_up.make
			create l_vp.make
			create l___mp_srcptr_swap__tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l___mp_srcptr_swap__tmp___0.make
			create l_tmp___2.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_usize := (a_u.item.mp_size).to_integer_32
					l_vsize := (a_v.item.mp_size).to_integer_32
					l_up := a_u.item.mp_d
					l_vp := a_v.item.mp_d
					if not (l_usize >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_vsize < 0 then
							Result := (((0).to_natural_32).bit_not)
							js.return
						end
						if not js.return_called then
							if l_usize < l_vsize then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										l___mp_srcptr_swap__tmp := l_up
										l_up := l_vp
										l_vp := l___mp_srcptr_swap__tmp
										js.break
									end
									from
									until
										js.loop_done
									loop
										l___mp_size_t_swap__tmp := l_usize
										l_usize := l_vsize
										l_vsize := l___mp_size_t_swap__tmp
										js.break
									end
									js.break
								end
							end
							l_count := (0).to_natural_32
							if l_vsize /= 0 then
								l_count := gmp_inst.gmpn_hamdist (l_up, l_vp, l_vsize)
							end
							l_usize := l_usize - l_vsize
							if l_usize /= 0 then
								l_count := l_count + (gmp_inst.gmpn_popcount (l_up + l_vsize, l_usize))
							end
							Result := l_count
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if l_vsize >= 0 then
							Result := (((0).to_natural_32).bit_not)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_usize := -l_usize
						l_vsize := -l_vsize
						from
						until
							js.loop_done
						loop
							l_usize := l_usize - 1
							l_vsize := l_vsize - 1
							l_tmp___0 := l_up
							l_up := l_up + 1
							l_ulimb := l_tmp___0.item
							l_tmp___1 := l_vp
							l_vp := l_vp + 1
							l_vlimb := l_tmp___1.item
							if l_ulimb /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped and then (l_vlimb /= {NATURAL_32} 0) then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										l___mp_srcptr_swap__tmp___0 := l_up
										l_up := l_vp
										l_vp := l___mp_srcptr_swap__tmp___0
										js.break
									end
									from
									until
										js.loop_done
									loop
										l___mp_size_t_swap__tmp___0 := l_usize
										l_usize := l_vsize
										l_vsize := l___mp_size_t_swap__tmp___0
										js.break
									end
									js.break
								end
								l_ulimb := l_vlimb
								l_vlimb := (0).to_natural_32
								js.break
							end
						end
						l_ulimb := (-l_ulimb.to_integer_32).to_natural_32
						l_vlimb := (-l_vlimb.to_integer_32).to_natural_32
						from
						until
							js.loop_done
						loop
							l___x := (((l_ulimb).bit_xor (l_vlimb))).bit_and ({NATURAL_32} 4_294_967_295)
							l___x := l___x - ((((l___x).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
							l___x := ((((l___x).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l___x).bit_and ({NATURAL_32} 858_993_459))
							l___x := ((((l___x).bit_shift_right (4)) + l___x)).bit_and ({NATURAL_32} 252_645_135)
							l___x := ((l___x).bit_shift_right (8)) + l___x
							l___x := ((l___x).bit_shift_right (16)) + l___x
							l_count := (l___x).bit_and ({NATURAL_32} 255)
							js.break
						end
						if l_vlimb = {NATURAL_32} 0 then
							l_old_vsize := l_vsize
							from
							until
								js.loop_done
							loop
								l_vsize := l_vsize - 1
								l_tmp___2 := l_vp
								l_vp := l_vp + 1
								l_vlimb := l_tmp___2.item
								if l_vlimb /= {NATURAL_32} 0 then
									js.break
								end
							end
							l_step___1 := (l_old_vsize - l_vsize) - 1
							l_count := l_count + (l_step___1 * 32).to_natural_32
							if l_step___1 < l_usize then
								l_step___1 := l_step___1
							else
								l_step___1 := l_usize
							end
							if l_step___1 /= 0 then
								l_count := l_count - (gmp_inst.gmpn_popcount (l_up, l_step___1))
								l_usize := l_usize - l_step___1
								l_up := l_up + l_step___1
							end
							l_vlimb := l_vlimb - 1
							if l_usize /= 0 then
								l_usize := l_usize - 1
								l_tmp___4 := l_up
								l_up := l_up + 1
								l_vlimb := (l_vlimb).bit_xor ((l_tmp___4.item))
							end
							from
							until
								js.loop_done
							loop
								l___x___0 := l_vlimb
								l___x___0 := l___x___0 - ((((l___x___0).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
								l___x___0 := ((((l___x___0).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l___x___0).bit_and ({NATURAL_32} 858_993_459))
								l___x___0 := ((((l___x___0).bit_shift_right (4)) + l___x___0)).bit_and ({NATURAL_32} 252_645_135)
								l___x___0 := ((l___x___0).bit_shift_right (8)) + l___x___0
								l___x___0 := ((l___x___0).bit_shift_right (16)) + l___x___0
								l_twoscount := (l___x___0).bit_and ({NATURAL_32} 255)
								js.break
							end
							l_count := l_count + l_twoscount
						end
						if l_usize < l_vsize then
							l_step___1 := l_usize
						else
							l_step___1 := l_vsize
						end
						if l_step___1 /= 0 then
							l_count := l_count + (gmp_inst.gmpn_hamdist (l_up, l_vp, l_step___1))
							l_usize := l_usize - l_step___1
							l_vsize := l_vsize - l_step___1
							l_up := l_up + l_step___1
							l_vp := l_vp + l_step___1
						end
						if l_usize = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | remaining:
						l_count := l_count + (gmp_inst.gmpn_popcount (l_up, l_usize))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if l_vsize /= 0 then
							l_up := l_vp
							l_usize := l_vsize
							l_pos := -1 + 5 -- goto remaining
						end
				when 8 then
						Result := l_count
				when 9 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
