class
	P_LCM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_lcm (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_g: CE_ARRAY [PD_MPZ_STRUCT]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_vl: NATURAL_32
			l_gl: NATURAL_32
			l_c: NATURAL_32
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___3: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_u.make
			create l_v.make
			create l_g.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l_up.make
			create l_rp.make
			create l___mpz_srcptr_swap__tmp.make
			create l___x.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := a_u
					l_v := a_v
					l_usize := (l_u.item.mp_size).to_integer_32
					l_vsize := (l_v.item.mp_size).to_integer_32
					if l_usize = 0 then
						a_r.item.mp_size := 0
						js.return
					elseif l_vsize = 0 then
						a_r.item.mp_size := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_usize >= 0 then
							l_usize := l_usize
						else
							l_usize := -l_usize
						end
						if l_vsize >= 0 then
							l_vsize := l_vsize
						else
							l_vsize := -l_vsize
						end
						if l_vsize /= 1 then
							l_pos := -1 + 3 -- skip if block
						end
				when 2 then -- if: | one:
						if (builtin_expect ((l_usize + 1 > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_r, l_usize + 1).do_nothing
						end
						l_up := l_u.item.mp_d
						l_vl := l_v.item.mp_d[0]
						l_gl := gcd_1_inst.gmpn_gcd_1 (l_up, l_usize, l_vl)
						l_vl := l_vl // l_gl
						l_rp := a_r.item.mp_d
						l_c := gmp_inst.gmpn_mul_1 (l_rp, l_up, l_usize, l_vl)
						l_rp[l_usize] := l_c
						l_usize := l_usize + (l_c /= {NATURAL_32} 0).to_integer
						a_r.item.mp_size := l_usize.to_integer_32
						js.return
				when 3 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
							if l_usize = 1 then
								l_usize := l_vsize
								from
								until
									js.loop_done
								loop
									l___mpz_srcptr_swap__tmp := l_u
									l_u := l_v
									l_v := l___mpz_srcptr_swap__tmp
									js.break
								end
								l_pos := -1 + 2 -- goto one
							end
				when 5 then
							l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
							if l_usize > l_vsize then
								l_size := l_usize
							else
								l_size := l_vsize
							end
							from
							until
								js.loop_done
							loop
								l___x := l_g
								l___x.item.mp_alloc := l_size.to_integer_32
								if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp___3 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l___x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
								js.break
							end
							gcd_inst.gmpz_gcd (l_g, l_u, l_v)
							divexact_inst.gmpz_divexact (l_g, l_u, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_g))
							mul_inst.gmpz_mul (a_r, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_g), l_v)
							if a_r.item.mp_size >= 0 then
								a_r.item.mp_size := a_r.item.mp_size
							else
								a_r.item.mp_size := -a_r.item.mp_size
							end
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								js.break
							end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
