class
	P_MP_SET_FNS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_set_memory_functions (a_alloc_func: CE_ROUTINE; a_realloc_func: CE_ROUTINE; a_free_func: CE_ROUTINE)
		local
			l_alloc_func: CE_ROUTINE
			l_realloc_func: CE_ROUTINE
			l_free_func: CE_ROUTINE
		do
			create l_alloc_func.make
			create l_realloc_func.make
			create l_free_func.make

			l_alloc_func := a_alloc_func
			l_realloc_func := a_realloc_func
			l_free_func := a_free_func
			if l_alloc_func.is_void then
				l_alloc_func := memory_inst.gmp_default_allocate_address
			end
			if l_realloc_func.is_void then
				l_realloc_func := memory_inst.gmp_default_reallocate_address
			end
			if l_free_func.is_void then
				l_free_func := memory_inst.gmp_default_free_address
			end
			memory_inst.gmp_allocate_func := l_alloc_func
			memory_inst.gmp_reallocate_func := l_realloc_func
			memory_inst.gmp_free_func := l_free_func
		end

end
