class
	P_MU_DIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mu_div_qr (a_qp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_qn: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
		do
			l_qn := a_nn - a_dn
			if l_qn + 100 < a_dn then
				l_qh := mpn_mu_div_qr2 (a_qp, (a_rp + a_nn) - (2 * l_qn + 1), (a_np + a_nn) - (2 * l_qn + 1), 2 * l_qn + 1, (a_dp + a_dn) - (l_qn + 1), l_qn + 1, a_scratch)
				if a_dn - (l_qn + 1) > l_qn then
					mul_inst.gmpn_mul (a_scratch, a_dp, a_dn - (l_qn + 1), a_qp, l_qn).do_nothing
				else
					mul_inst.gmpn_mul (a_scratch, a_qp, l_qn, a_dp, a_dn - (l_qn + 1)).do_nothing
				end
				if l_qh.to_boolean then
					l_cy := gmp_inst.gmpn_add_n (a_scratch + l_qn, (a_scratch + l_qn), a_dp, a_dn - (l_qn + 1))
				else
					l_cy := (0).to_natural_32
				end
				a_scratch[(a_dn - 1)] := l_cy
				l_cy := gmp_inst.gmpn_sub_n (a_rp, a_np, a_scratch, a_nn - (2 * l_qn + 1))
				l_cy := gmp_impl_inst.gmpn_sub_nc ((a_rp + a_nn) - (2 * l_qn + 1), ((a_rp + a_nn) - (2 * l_qn + 1)), ((a_scratch + a_nn) - (2 * l_qn + 1)), l_qn + 1, l_cy)
				if l_cy.to_boolean then
					l_qh := l_qh - (gmp_inst.gmpn_sub_1 (a_qp, a_qp, l_qn, (1).to_natural_32))
					gmp_inst.gmpn_add_n (a_rp, a_rp, a_dp, a_dn).do_nothing
				end
			else
				l_qh := mpn_mu_div_qr2 (a_qp, a_rp, a_np, a_nn, a_dp, a_dn, a_scratch)
			end
			Result := l_qh
		end

	gmpn_mu_div_qr_choose_in (a_qn: INTEGER_32; a_dn: INTEGER_32; a_k: INTEGER_32): INTEGER_32
		local
			l_in: INTEGER_32
			l_b: INTEGER_32
			l_xn: INTEGER_32
		do
			if a_k = 0 then
				if a_qn > a_dn then
					l_b := (a_qn - 1) // a_dn + 1
					l_in := (a_qn - 1) // l_b + 1
				elseif 3 * a_qn > a_dn then
					l_in := (a_qn - 1) // 2 + 1
				else
					l_in := (a_qn - 1) + 1
				end
			else
				if a_dn < a_qn then
					l_xn := a_dn
				else
					l_xn := a_qn
				end
				l_in := (l_xn - 1) // a_k.to_integer_32 + 1
			end
			Result := l_in
		end

	gmpn_mu_div_qr_itch (a_nn: INTEGER_32; a_dn: INTEGER_32; a_mua_k: INTEGER_32): INTEGER_32
		local
			l_itch_local: INTEGER_32
			l_in: INTEGER_32
			l_itch_out: INTEGER_32
		do
			l_itch_local := (mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn + 1))
			l_in := (gmpn_mu_div_qr_choose_in (a_nn - a_dn, a_dn, a_mua_k))
			l_itch_out := (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_itch_local, a_dn, l_in))
			Result := ((l_in + l_itch_local) + l_itch_out)
		end

	gmpn_preinv_mu_div_qr (a_qp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_ip: CE_POINTER [NATURAL_32]; a_in: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_scratch: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_np: CE_POINTER [NATURAL_32]
			l_ip: CE_POINTER [NATURAL_32]
			l_in: INTEGER_32
			l_qn: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_cx: CE_ARRAY [NATURAL_32]
			l_qh: NATURAL_32
			l_r: NATURAL_32
			l_tn: INTEGER_32
			l_wn: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_scratch.make (<<1>>)
			create l_qp.make (<<1>>)
			create l_np.make
			create l_ip.make
			create l_cy.make (<<1>>)
			create l_cx.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)
			create l___ptr_dummy___1.make (<<1>>)

			l_scratch.item := a_scratch
			l_qp.item := a_qp
			l_np := a_np
			l_ip := a_ip
			l_in := a_in
			l_qn := a_nn - a_dn
			l_np := l_np + l_qn
			l_qp.item := l_qp.item + l_qn
			l_qh := ((gmp_inst.gmpn_cmp (l_np, a_dp, a_dn)) >= 0).to_integer.to_natural_32
			if l_qh /= {NATURAL_32} 0 then
				gmp_inst.gmpn_sub_n (a_rp, l_np, a_dp, a_dn).do_nothing
			else
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (a_rp, l_np, a_dn)
						js.break
					end
					js.break
				end
			end
			if l_qn = 0 then
				Result := l_qh
				js.return
			end
			if not js.return_called then
				from
				until
					not (not js.loop_done and then (l_qn > 0))
				loop
					if l_qn < l_in then
						l_ip := l_ip + (l_in - l_qn)
						l_in := l_qn
					end
					l_np := l_np - l_in
					l_qp.item := l_qp.item - l_in
					mul_n_inst.gmpn_mul_n (l_scratch.item, ((a_rp + a_dn) - l_in), l_ip, l_in)
					l_cy.item := gmp_inst.gmpn_add_n (l_qp.item, (l_scratch.item + l_in), ((a_rp + a_dn) - l_in), l_in)
					from
					until
						js.loop_done
					loop
						if l_cy.item /= {NATURAL_32} 0 then
							assert_inst.gmp_assert_fail (ce_string ("mu_div_qr.c"), 269, ce_string ("cy == 0"))
						end
						js.break
					end
					l_qn := l_qn - l_in
					if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_in >= 58 then
							l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn + 1)
							mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_scratch.item, l_tn, a_dp, a_dn, l_qp.item, l_in, l_scratch.item + l_tn)
							l_wn := (a_dn + l_in) - l_tn
							if l_wn > 0 then
								l_cy.item := gmp_inst.gmpn_sub_n (l_scratch.item, l_scratch.item, ((a_rp + a_dn) - l_wn), l_wn)
								l_cy.item := gmp_inst.gmpn_sub_1 (l_scratch.item + l_wn, (l_scratch.item + l_wn), l_tn - l_wn, l_cy.item)
								l_cx.item := ((gmp_inst.gmpn_cmp (((a_rp + a_dn) - l_in), (l_scratch.item + a_dn), l_tn - a_dn)) < 0).to_integer.to_natural_32
								from
								until
									js.loop_done
								loop
									if not (l_cx.item >= l_cy.item) then
										assert_inst.gmp_assert_fail (ce_string ("mu_div_qr.c"), 289, ce_string ("cx >= cy"))
									end
									js.break
								end
								from
								until
									js.loop_done
								loop
									asm314 (l___ptr_dummy, l_scratch, l_cx, l_cy)
									js.break
								end
							end
						else
							mul_inst.gmpn_mul (l_scratch.item, a_dp, a_dn, l_qp.item, l_in).do_nothing
						end
					else
						mul_inst.gmpn_mul (l_scratch.item, a_dp, a_dn, l_qp.item, l_in).do_nothing
					end
					l_r := a_rp[(a_dn - l_in)] - l_scratch.item[a_dn]
					if a_dn /= l_in then
						l_cy.item := gmp_inst.gmpn_sub_n (l_scratch.item, l_np, l_scratch.item, l_in)
						l_cy.item := gmp_impl_inst.gmpn_sub_nc (l_scratch.item + l_in, a_rp, (l_scratch.item + l_in), a_dn - l_in, l_cy.item)
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_rp, l_scratch.item, a_dn)
								js.break
							end
							js.break
						end
					else
						l_cy.item := gmp_inst.gmpn_sub_n (a_rp, l_np, l_scratch.item, l_in)
					end
					l_r := l_r - (l_cy.item)
					from
					until
						not (not js.loop_done and then (l_r /= {NATURAL_32} 0))
					loop
						from
						until
							js.loop_done
						loop
							asm315 (l___ptr_dummy___0, l_qp)
							js.break
						end
						l_cy.item := gmp_inst.gmpn_sub_n (a_rp, a_rp, a_dp, a_dn)
						l_r := l_r - (l_cy.item)
					end
					if (gmp_inst.gmpn_cmp (a_rp, a_dp, a_dn)) >= 0 then
						from
						until
							js.loop_done
						loop
							asm316 (l___ptr_dummy___1, l_qp)
							js.break
						end
						l_cy.item := gmp_inst.gmpn_sub_n (a_rp, a_rp, a_dp, a_dn)
					end
				end
				Result := l_qh
			end
		end

	mpn_mu_div_qr2 (a_qp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l_ip: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_ip.make
			create l_tp.make
			create l___dst.make
			create l_tmp.make

			l_qn := a_nn - a_dn
			l_in := gmpn_mu_div_qr_choose_in (l_qn, a_dn, 0)
			l_ip := a_scratch
			l_tp := (a_scratch + l_in) + 1
			if a_dn = l_in then
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_tp + 1, a_dp, l_in)
						js.break
					end
					js.break
				end
				l_tp[0] := (1).to_natural_32
				invertappr_inst.gmpn_invertappr (l_ip, l_tp, l_in + 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)).do_nothing
				from
				until
					js.loop_done
				loop
					gmp_inst.gmpn_copyi (l_ip, (l_ip + 1), l_in)
					js.break
				end
			else
				l_cy := gmp_inst.gmpn_add_1 (l_tp, (a_dp + a_dn) - (l_in + 1), l_in + 1, (1).to_natural_32)
				if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					from
					until
						js.loop_done
					loop
						if l_in /= 0 then
							l___dst := l_ip
							l___n := l_in
							from
							until
								js.loop_done
							loop
								l_tmp := l___dst
								l___dst := l___dst + 1
								l_tmp.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
				else
					invertappr_inst.gmpn_invertappr (l_ip, l_tp, l_in + 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)).do_nothing
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_ip, (l_ip + 1), l_in)
						js.break
					end
				end
			end
			l_qh := gmpn_preinv_mu_div_qr (a_qp, a_rp, a_np, a_nn, a_dp, a_dn, l_ip, l_in, a_scratch + l_in)
			Result := l_qh
		end

end
