class
	P_NEXTPRIME

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create addtab.make (<<48>>)
			create primegap.make (<<167>>)
		end

feature {ANY} -- attributes

	addtab: CE_ARRAY [NATURAL_8]

	primegap: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	gmp_init_primesieve (a_ps: CE_POINTER [PD_GMP_PRIMESIEVE_T])
		do
			a_ps.item.s0 := {NATURAL_32} 0
			a_ps.item.sqrt_s0 := {NATURAL_32} 0
			a_ps.item.d := {NATURAL_32} 512
			a_ps.item.s[512] := (0).to_natural_8
		end

	gmp_nextprime (a_ps: CE_POINTER [PD_GMP_PRIMESIEVE_T]): NATURAL_32
		local
			l_p: NATURAL_32
			l_d: NATURAL_32
			l_pi: NATURAL_32
			l_sp: CE_POINTER [NATURAL_8]
			l_addp: CE_POINTER [NATURAL_8]
			l_ai: NATURAL_32
			js: JUMP_STATE
		do
			create l_sp.make
			create l_addp.make

			l_addp := addtab
			l_d := a_ps.item.d
			l_sp := a_ps.item.s + l_d.to_integer_32
			from
			until
				(l_sp.item).to_integer_32 = 0
			loop
				l_sp := l_sp + 1
			end
			if not l_sp.is_equal (a_ps.item.s + 512) then
				l_d := (l_sp.distance ((a_ps.item.s))).to_natural_32
				a_ps.item.d := l_d + {NATURAL_32} 1
				Result := (a_ps.item.s0 + {NATURAL_32} 2 * l_d)
				js.return
			end
			if not js.return_called and then (a_ps.item.s0 < {NATURAL_32} 3) then
				a_ps.item.s0 := {NATURAL_32} 4_294_966_275
				Result := {NATURAL_32} 2
				js.return
			end
			if not js.return_called then
				memset (create {CE_POINTER [ANY]}.make_cast ((a_ps.item.s)), 0, (512).to_natural_32).do_nothing
				a_ps.item.s0 := a_ps.item.s0 + ({NATURAL_32} 1_024)
				from
				until
					not ((a_ps.item.sqrt_s0 + {NATURAL_32} 1) * (a_ps.item.sqrt_s0 + {NATURAL_32} 1) <= (a_ps.item.s0 + {NATURAL_32} 1_024) - {NATURAL_32} 1)
				loop
					a_ps.item.sqrt_s0 := (a_ps.item.sqrt_s0) + 1
				end
				l_pi := ((a_ps.item.s0 + {NATURAL_32} 3) // {NATURAL_32} 2) \\ {NATURAL_32} 3
				if l_pi > {NATURAL_32} 0 then
					l_pi := {NATURAL_32} 3 - l_pi
				end
				if a_ps.item.s0 + {NATURAL_32} 2 * l_pi <= {NATURAL_32} 3 then
					l_pi := l_pi + ({NATURAL_32} 3)
				end
				l_sp := a_ps.item.s + l_pi.to_integer_32
				from
				until
					not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((a_ps.item.s + 512).c_pointer.to_integer_32).to_natural_32)
				loop
					l_sp.item := (1).to_natural_8
					l_sp := l_sp + (3)
				end
				l_pi := ((a_ps.item.s0 + {NATURAL_32} 5) // {NATURAL_32} 2) \\ {NATURAL_32} 5
				if l_pi > {NATURAL_32} 0 then
					l_pi := {NATURAL_32} 5 - l_pi
				end
				if a_ps.item.s0 + {NATURAL_32} 2 * l_pi <= {NATURAL_32} 5 then
					l_pi := l_pi + ({NATURAL_32} 5)
				end
				l_sp := a_ps.item.s + l_pi.to_integer_32
				from
				until
					not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((a_ps.item.s + 512).c_pointer.to_integer_32).to_natural_32)
				loop
					l_sp.item := (1).to_natural_8
					l_sp := l_sp + (5)
				end
				l_pi := ((a_ps.item.s0 + {NATURAL_32} 7) // {NATURAL_32} 2) \\ {NATURAL_32} 7
				if l_pi > {NATURAL_32} 0 then
					l_pi := {NATURAL_32} 7 - l_pi
				end
				if a_ps.item.s0 + {NATURAL_32} 2 * l_pi <= {NATURAL_32} 7 then
					l_pi := l_pi + ({NATURAL_32} 7)
				end
				l_sp := a_ps.item.s + l_pi.to_integer_32
				from
				until
					not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((a_ps.item.s + 512).c_pointer.to_integer_32).to_natural_32)
				loop
					l_sp.item := (1).to_natural_8
					l_sp := l_sp + (7)
				end
				l_p := {NATURAL_32} 11
				l_ai := {NATURAL_32} 0
				from
				until
					not (not js.loop_done and then (l_p <= a_ps.item.sqrt_s0))
				loop
					l_pi := ((a_ps.item.s0 + l_p) // {NATURAL_32} 2) \\ l_p
					if l_pi > {NATURAL_32} 0 then
						l_pi := l_p - l_pi
					end
					if a_ps.item.s0 + {NATURAL_32} 2 * l_pi <= l_p then
						l_pi := l_pi + l_p
					end
					l_sp := a_ps.item.s + l_pi.to_integer_32
					from
					until
						not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((a_ps.item.s + 512).c_pointer.to_integer_32).to_natural_32)
					loop
						l_sp.item := (1).to_natural_8
						l_sp := l_sp + l_p.to_integer_32
					end
					l_p := l_p + (l_addp[l_ai.to_integer_32]).to_natural_32
					l_ai := (l_ai + {NATURAL_32} 1) \\ {NATURAL_32} 48
				end
				a_ps.item.d := {NATURAL_32} 0
				Result := (gmp_nextprime (a_ps))
			end
		end

	gmpz_nextprime (a_p: CE_POINTER [PD_MPZ_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_moduli: CE_POINTER [NATURAL_16]
			l_difference: NATURAL_32
			l_i: INTEGER_32
			l_prime_limit: NATURAL_32
			l_prime: NATURAL_32
			l_cnt: INTEGER_32
			l_pn: INTEGER_32
			l_nbits: NATURAL_32
			l_incr: NATURAL_32
			l_r: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_moduli.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (cmp_ui_inst.gmpz_cmp_ui (a_n, {NATURAL_32} 2)) < 0 then
						set_ui_inst.gmpz_set_ui (a_p, {NATURAL_32} 2)
						js.return
					end
					if not js.return_called then
						aors_ui_inst.gmpz_add_ui (a_p, a_n, {NATURAL_32} 1)
						setbit_inst.gmpz_setbit (a_p, (0).to_natural_32)
						if (cmp_ui_inst.gmpz_cmp_ui (a_p, {NATURAL_32} 7)) <= 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_pn := (a_p.item.mp_size).to_integer_32
						from
						until
							js.loop_done
						loop
							l_cnt := builtin_clzl (a_p.item.mp_d[(l_pn - 1)])
							js.break
						end
						l_nbits := (l_pn * 32 - l_cnt.to_integer_32).to_natural_32
						if l_nbits // {NATURAL_32} 2 >= {NATURAL_32} 167 then
							l_prime_limit := {NATURAL_32} 166
						else
							l_prime_limit := (l_nbits // {NATURAL_32} 2).to_natural_32
						end
						l_moduli := create {CE_POINTER [NATURAL_16]}.make_cast ((l_aaf.new ((l_prime_limit * {PLATFORM}.Natural_16_bytes.to_natural_32) * {PLATFORM}.Natural_16_bytes.to_natural_32)))
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_prime := {NATURAL_32} 3
						l_i := 0
						from
						until
							not (l_i.to_natural_32 < l_prime_limit)
						loop
							l_moduli[l_i] := (fdiv_ui_inst.gmpz_fdiv_ui (a_p, l_prime)).to_natural_16
							l_prime := l_prime + (primegap[l_i]).to_natural_32
							l_i := l_i + 1
						end
						l_incr := {NATURAL_32} 0
						l_difference := l_incr.to_natural_32
				when 4 then -- loop condition:
						if not (not js.loop_done and then (l_incr < {NATURAL_32} 65_536)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 5 then -- loop body:
						l_prime := {NATURAL_32} 3
						l_i := 0
				when 6 then -- loop condition:
						if not (l_i.to_natural_32 < l_prime_limit) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						l_r := (((l_moduli[l_i]).to_natural_32 + l_incr).to_natural_32 \\ l_prime).to_natural_32
						l_prime := l_prime + (primegap[l_i]).to_natural_32
						if l_r = {NATURAL_32} 0 then
							l_pos := -1 + 10 -- goto next
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						aors_ui_inst.gmpz_add_ui (a_p, a_p, l_difference)
						l_difference := {NATURAL_32} 0
						if (millerrabin_inst.gmpz_millerrabin (a_p, 10)).to_boolean then
							l_pos := -1 + 12 -- goto done
						end
				when 10 then -- next:
						l_incr := l_incr + ({NATURAL_32} 2)
						l_difference := l_difference + ({NATURAL_32} 2)
						l_pos := -1 + 4 -- back to loop condition
				when 11 then -- loop done
						aors_ui_inst.gmpz_add_ui (a_p, a_p, l_difference)
						l_difference := {NATURAL_32} 0
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- done:
						
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
