class
	P_POWM_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_powm_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_b: CE_POINTER [PD_MPZ_STRUCT]; a_el: NATURAL_32; a_m: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_xp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_xn: INTEGER_32
			l_tn: INTEGER_32
			l_mn: INTEGER_32
			l_bn: INTEGER_32
			l_m_zero_cnt: INTEGER_32
			l_c: INTEGER_32
			l_e: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_new_mp: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_new_bp: CE_POINTER [NATURAL_32]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_cy: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_xp.make
			create l_tp.make
			create l_qp.make
			create l_mp.make
			create l_bp.make
			create l___tmp_marker.make (<<1>>)
			create l_new_mp.make
			create l_tmp___2.make
			create l_new_bp.make
			create l_tmp___7.make
			create l_tmp___13.make
			create l_tmp___18.make
			create l_tmp___23.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mp := a_m.item.mp_d
					if a_m.item.mp_size >= 0 then
						l_mn := (a_m.item.mp_size).to_integer_32
					else
						l_mn := (-a_m.item.mp_size).to_integer_32
					end
					if l_mn = 0 then
						errno_inst.gmp_divide_by_zero
					end
					if a_el = {NATURAL_32} 0 then
						if l_mn = 1 then
							if l_mp[0] = {NATURAL_32} 1 then
								a_r.item.mp_size := 0
							else
								a_r.item.mp_size := 1
							end
						else
							a_r.item.mp_size := 1
						end
						a_r.item.mp_d[0] := (1).to_natural_32
						js.return
					end
					if not js.return_called then
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							js.loop_done
						loop
							l_m_zero_cnt := builtin_clzl (l_mp[(l_mn - 1)])
							js.break
						end
						l_m_zero_cnt := l_m_zero_cnt
						if l_m_zero_cnt /= 0 then
							if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___2 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_mp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
							gmp_inst.gmpn_lshift (l_new_mp, l_mp, l_mn, l_m_zero_cnt.to_natural_32).do_nothing
							l_mp := l_new_mp
						end
						if a_b.item.mp_size >= 0 then
							l_bn := (a_b.item.mp_size).to_integer_32
						else
							l_bn := (-a_b.item.mp_size).to_integer_32
						end
						l_bp := a_b.item.mp_d
						if l_bn > l_mn then
							if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___7 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___7 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_bp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
							reduce (l_new_bp, l_bp, l_bn, l_mp, l_mn)
							l_bp := l_new_bp
							l_bn := l_mn
							from
							until
								js.loop_done
							loop
								from
								until
									not (not js.loop_done and then (l_bn > 0))
								loop
									if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_bn := l_bn - 1
									end
								end
								js.break
							end
						end
						if l_bn = 0 then
							a_r.item.mp_size := 0
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								js.break
							end
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if (builtin_expect (((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___13 := (l_aaf.new (((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___13 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13)
						if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___18 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___18 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_xp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___18)
						if (builtin_expect (((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___23 := (l_aaf.new (((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___23 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_qp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___23)
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (l_xp, l_bp, l_bn)
								js.break
							end
							js.break
						end
						l_xn := l_bn
						l_e := a_el
						from
						until
							js.loop_done
						loop
							l_c := builtin_clzl (l_e)
							js.break
						end
						l_e := (((l_e).bit_shift_left (l_c))).bit_shift_left (1)
						l_c := 31 - l_c
						if l_c = 0 then
							if l_xn = l_mn then
								if (gmp_inst.gmpn_cmp (l_xp, l_mp, l_mn)) >= 0 then
									gmp_inst.gmpn_sub_n (l_xp, l_xp, l_mp, l_mn).do_nothing
								end
							end
							l_pos := -1 + 3 -- goto finishup
						end
				when 2 then
						from
						until
							not (not js.loop_done and then (l_c /= 0))
						loop
							sqr_inst.gmpn_sqr (l_tp, l_xp, l_xn)
							l_tn := 2 * l_xn
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							if l_tn < l_mn then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_xp, l_tp, l_tn)
										js.break
									end
									js.break
								end
								l_xn := l_tn
							else
								tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_tn, l_mp, l_mn)
								l_xn := l_mn
							end
							if l_e.to_integer_32 < 0 then
								mul_inst.gmpn_mul (l_tp, l_xp, l_xn, l_bp, l_bn).do_nothing
								l_tn := l_xn + l_bn
								l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
								if l_tn < l_mn then
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											gmp_inst.gmpn_copyi (l_xp, l_tp, l_tn)
											js.break
										end
										js.break
									end
									l_xn := l_tn
								else
									tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_tn, l_mp, l_mn)
									l_xn := l_mn
								end
							end
							l_e := (l_e).bit_shift_left ((1))
							l_c := l_c - 1
						end
				when 3 then -- finishup:
						if l_m_zero_cnt /= 0 then
							l_cy := gmp_inst.gmpn_lshift (l_tp, l_xp, l_xn, l_m_zero_cnt.to_natural_32)
							l_tp[l_xn] := l_cy
							l_xn := l_xn + (l_cy /= {NATURAL_32} 0).to_integer
							if l_xn < l_mn then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_xp, l_tp, l_xn)
										js.break
									end
									js.break
								end
							else
								tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_xn, l_mp, l_mn)
								l_xn := l_mn
							end
							gmp_inst.gmpn_rshift (l_xp, l_xp, l_xn, l_m_zero_cnt.to_natural_32).do_nothing
						end
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_xn > 0))
							loop
								if l_xp[(l_xn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_xn := l_xn - 1
								end
							end
							js.break
						end
						if ((a_el).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							if a_b.item.mp_size < 0 then
								if l_xn /= 0 then
									l_mp := a_m.item.mp_d
									gmp_inst.gmpn_sub (l_xp, l_mp, l_mn, l_xp, l_xn).do_nothing
									l_xn := l_mn
									from
									until
										js.loop_done
									loop
										from
										until
											not (not js.loop_done and then (l_xn > 0))
										loop
											if l_xp[(l_xn - 1)] /= {NATURAL_32} 0 then
												js.break
											end
											if not js.loop_jumped then
												l_xn := l_xn - 1
											end
										end
										js.break
									end
								end
							end
						end
						if (builtin_expect ((l_xn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_r, l_xn).do_nothing
						end
						a_r.item.mp_size := l_xn.to_integer_32
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_r.item.mp_d, l_xp, l_xn)
								js.break
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reduce (a_tp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32)
		local
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_qp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make

			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___2 := (l_aaf.new ((((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
			tdiv_qr_inst.gmpn_tdiv_qr (l_qp, a_tp, 0, a_ap, a_an, a_mp, a_mn)
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
		end

end
