class
	P_SET_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_q (a_r: CE_POINTER [PD_MPF_STRUCT]; a_q: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l_nsize: INTEGER_32
			l_dsize: INTEGER_32
			l_qsize: INTEGER_32
			l_prospective_qsize: INTEGER_32
			l_tsize: INTEGER_32
			l_zeros: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_high_zero: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_size: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___14: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_qp.make
			create l_tp.make
			create l_remp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___14.make
			create l___dst.make
			create l_tmp___16.make

			l_nsize := (a_q.item.mp_num.mp_size).to_integer_32
			l_dsize := (a_q.item.mp_den.mp_size).to_integer_32
			if (builtin_expect ((l_nsize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_qp := a_r.item.mp_d
				l_sign_quotient := l_nsize
				if l_nsize >= 0 then
					l_nsize := l_nsize
				else
					l_nsize := -l_nsize
				end
				l_np := a_q.item.mp_num.mp_d
				l_dp := a_q.item.mp_den.mp_d
				l_prospective_qsize := (l_nsize - l_dsize) + 1
				l_exp := l_prospective_qsize
				l_qsize := l_prec + 1
				l_zeros := l_qsize - l_prospective_qsize
				l_tsize := l_nsize + l_zeros
				if l_zeros > 0 then
					l_tmp___10 := l_tsize
				else
					l_tmp___10 := (0).to_integer_32
				end
				l_size := l_dsize + l_tmp___10
				if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___14 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___14 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_remp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14)
				l_tp := l_remp + l_dsize
				if l_zeros > 0 then
					from
					until
						js.loop_done
					loop
						if l_zeros /= 0 then
							l___dst := l_tp
							l___n := l_zeros
							from
							until
								js.loop_done
							loop
								l_tmp___16 := l___dst
								l___dst := l___dst + 1
								l_tmp___16.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_tp + l_zeros, l_np, l_nsize)
							js.break
						end
						js.break
					end
					l_np := l_tp
					l_nsize := l_tsize
				else
					l_nsize := l_nsize + l_zeros
					l_np := l_np - l_zeros
				end
				tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_remp, (0).to_integer_32, l_np, l_nsize, l_dp, l_dsize)
				l_high_zero := (l_qp[(l_qsize - 1)] = {NATURAL_32} 0).to_integer
				l_qsize := l_qsize - l_high_zero
				l_exp := l_exp - l_high_zero
				a_r.item.mp_exp := l_exp
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_qsize.to_integer_32
				else
					a_r.item.mp_size := (-l_qsize).to_integer_32
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
