class
	P_SET_SI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_si (a_dest: CE_POINTER [PD_MPF_STRUCT]; a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: INTEGER_32
		do
			if a_val >= 0 then
				l_tmp := a_val
			else
				l_tmp := -a_val
			end
			l_vl := l_tmp.to_natural_32
			a_dest.item.mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			a_dest.item.mp_exp := l_size
			if a_val >= 0 then
				a_dest.item.mp_size := l_size.to_integer_32
			else
				a_dest.item.mp_size := (-l_size).to_integer_32
			end
		end

	gmpq_set_si (a_dest: CE_POINTER [PD_MPQ_STRUCT]; a_num: INTEGER_32; a_den: NATURAL_32)
		local
			l_den: NATURAL_32
			l_abs_num: NATURAL_32
		do
			l_den := a_den
			if a_num >= 0 then
				l_abs_num := a_num.to_natural_32
			else
				l_abs_num := (-a_num).to_natural_32
			end
			if a_num = 0 then
				l_den := {NATURAL_32} 1
				a_dest.item.mp_num.mp_size := 0
			else
				a_dest.item.mp_num.mp_d[0] := l_abs_num
				if a_num > 0 then
					a_dest.item.mp_num.mp_size := 1
				else
					a_dest.item.mp_num.mp_size := -1
				end
			end
			a_dest.item.mp_den.mp_d[0] := l_den
			a_dest.item.mp_den.mp_size := (l_den /= {NATURAL_32} 0).to_integer
		end

	gmpz_set_si (a_dest: CE_POINTER [PD_MPZ_STRUCT]; a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: INTEGER_32
		do
			if a_val >= 0 then
				l_tmp := a_val
			else
				l_tmp := -a_val
			end
			l_vl := l_tmp.to_natural_32
			a_dest.item.mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			if a_val >= 0 then
				a_dest.item.mp_size := l_size.to_integer_32
			else
				a_dest.item.mp_size := (-l_size).to_integer_32
			end
		end

end
