class
	P_SWAP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_swap (a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_uprec: INTEGER_32
			l_vprec: INTEGER_32
			l_uexp: INTEGER_32
			l_vexp: INTEGER_32
		do
			create l_up.make
			create l_vp.make

			l_uprec := (a_u.item.mp_prec).to_integer_32
			l_vprec := (a_v.item.mp_prec).to_integer_32
			a_v.item.mp_prec := l_uprec.to_integer_32
			a_u.item.mp_prec := l_vprec.to_integer_32
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			a_v.item.mp_size := l_usize.to_integer_32
			a_u.item.mp_size := l_vsize.to_integer_32
			l_uexp := a_u.item.mp_exp
			l_vexp := a_v.item.mp_exp
			a_v.item.mp_exp := l_uexp
			a_u.item.mp_exp := l_vexp
			l_up := a_u.item.mp_d
			l_vp := a_v.item.mp_d
			a_v.item.mp_d := l_up
			a_u.item.mp_d := l_vp
		end

	gmpq_swap (a_u: CE_POINTER [PD_MPQ_STRUCT]; a_v: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ualloc: INTEGER_32
			l_valloc: INTEGER_32
		do
			create l_up.make
			create l_vp.make

			l_ualloc := (a_u.item.mp_num.mp_alloc).to_integer_32
			l_valloc := (a_v.item.mp_num.mp_alloc).to_integer_32
			a_v.item.mp_num.mp_alloc := l_ualloc.to_integer_32
			a_u.item.mp_num.mp_alloc := l_valloc.to_integer_32
			l_usize := (a_u.item.mp_num.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_num.mp_size).to_integer_32
			a_v.item.mp_num.mp_size := l_usize.to_integer_32
			a_u.item.mp_num.mp_size := l_vsize.to_integer_32
			l_up := a_u.item.mp_num.mp_d
			l_vp := a_v.item.mp_num.mp_d
			a_v.item.mp_num.mp_d := l_up
			a_u.item.mp_num.mp_d := l_vp
			l_ualloc := (a_u.item.mp_den.mp_alloc).to_integer_32
			l_valloc := (a_v.item.mp_den.mp_alloc).to_integer_32
			a_v.item.mp_den.mp_alloc := l_ualloc.to_integer_32
			a_u.item.mp_den.mp_alloc := l_valloc.to_integer_32
			l_usize := (a_u.item.mp_den.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_den.mp_size).to_integer_32
			a_v.item.mp_den.mp_size := l_usize.to_integer_32
			a_u.item.mp_den.mp_size := l_vsize.to_integer_32
			l_up := a_u.item.mp_den.mp_d
			l_vp := a_v.item.mp_den.mp_d
			a_v.item.mp_den.mp_d := l_up
			a_u.item.mp_den.mp_d := l_vp
		end

	gmpz_swap (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ualloc: INTEGER_32
			l_valloc: INTEGER_32
		do
			create l_up.make
			create l_vp.make

			l_ualloc := (a_u.item.mp_alloc).to_integer_32
			l_valloc := (a_v.item.mp_alloc).to_integer_32
			a_v.item.mp_alloc := l_ualloc.to_integer_32
			a_u.item.mp_alloc := l_valloc.to_integer_32
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			a_v.item.mp_size := l_usize.to_integer_32
			a_u.item.mp_size := l_vsize.to_integer_32
			l_up := a_u.item.mp_d
			l_vp := a_v.item.mp_d
			a_v.item.mp_d := l_up
			a_u.item.mp_d := l_vp
		end

end
