class
	P_TDIV_Q_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_tdiv_q_2exp (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_wsize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_tmp: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_wp.make
			create l_up.make

			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
			if l_usize >= 0 then
				l_tmp := l_usize
			else
				l_tmp := -l_usize
			end
			l_wsize := l_tmp - l_limb_cnt
			if l_wsize <= 0 then
				a_w.item.mp_size := 0
			else
				if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
					realloc_inst.gmpz_realloc (a_w, l_wsize).do_nothing
				end
				l_wp := a_w.item.mp_d
				l_up := a_u.item.mp_d
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					gmp_inst.gmpn_rshift (l_wp, l_up + l_limb_cnt, l_wsize, l_cnt.to_natural_32).do_nothing
					l_wsize := l_wsize - (l_wp[(l_wsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_wp, l_up + l_limb_cnt, l_wsize)
						js.break
					end
				end
				if l_usize >= 0 then
					a_w.item.mp_size := l_wsize.to_integer_32
				else
					a_w.item.mp_size := (-l_wsize).to_integer_32
				end
			end
		end

end
