class
	P_TRUNC

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_trunc (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			l_exp: INTEGER_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_up.make

			l_exp := a_u.item.mp_exp
			l_size := (a_u.item.mp_size).to_integer_32
			if l_size = 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			elseif l_exp <= 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_up := a_u.item.mp_d
				a_r.item.mp_exp := l_exp
				if l_size >= 0 then
					l_asize := l_size
				else
					l_asize := -l_size
				end
				l_up := l_up + l_asize
				if l_asize < l_exp then
					l_asize := l_asize
				else
					l_asize := l_exp
				end
				l_prec := (a_r.item.mp_prec + 1).to_integer_32
				if l_asize < l_prec then
					l_asize := l_asize
				else
					l_asize := l_prec
				end
				l_up := l_up - l_asize
				l_rp := a_r.item.mp_d
				if l_size >= 0 then
					a_r.item.mp_size := l_asize.to_integer_32
				else
					a_r.item.mp_size := (-l_asize).to_integer_32
				end
				if not l_rp.is_equal (l_up) then
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_rp, l_up, l_asize)
						js.break
					end
				end
			end
		end

end
