class
	P_TSTBIT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_tstbit (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_bit_index: NATURAL_32): INTEGER_32
		local
			l_u_ptr: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_abs_size: NATURAL_32
			l_tmp: INTEGER_32
			l_limb_index: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			js: JUMP_STATE
		do
			create l_u_ptr.make
			create l_p.make

			l_u_ptr := a_u.item.mp_d
			l_size := (a_u.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_tmp := l_size
			else
				l_tmp := -l_size
			end
			l_abs_size := l_tmp.to_natural_32
			l_limb_index := (a_bit_index // {NATURAL_32} 32).to_integer_32
			l_p := l_u_ptr + l_limb_index
			if l_limb_index.to_natural_32 >= l_abs_size.to_natural_32 then
				Result := (l_size < 0).to_integer
				js.return
			end
			if not js.return_called then
				l_limb := l_p.item
				if l_size < 0 then
					l_limb := (-l_limb.to_integer_32).to_natural_32
					from
					until
						not (not js.loop_done and then (not l_p.is_equal (l_u_ptr)))
					loop
						l_p := l_p - 1
						if l_p.item /= {NATURAL_32} 0 then
							l_limb := l_limb - 1
							js.break
						end
					end
				end
				Result := ((((l_limb).bit_shift_right ((a_bit_index \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)).to_integer_32
			end
		end

end
