class
	P_URANDOMB

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_urandomb (a_rop: CE_POINTER [PD_MPF_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_nbits: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_nlimbs: INTEGER_32
			l_exp: INTEGER_32
			l_prec: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			js: JUMP_STATE
		do
			create l_rp.make
			create l___rstate.make

			l_nbits := a_nbits
			l_rp := a_rop.item.mp_d
			l_nlimbs := ((l_nbits + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			l_prec := (a_rop.item.mp_prec).to_integer_32
			if l_nlimbs > l_prec + 1 then
				l_nlimbs := l_prec + 1
				l_nbits := (l_nlimbs * 32).to_natural_32
			elseif l_nlimbs = 0 then
				l_nlimbs := l_prec + 1
				l_nbits := (l_nlimbs * 32).to_natural_32
			end
			from
			until
				js.loop_done
			loop
				l___rstate := a_rstate;
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_rp, l_nbits])
				js.break
			end
			if l_nbits \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
				gmp_inst.gmpn_lshift (l_rp, l_rp, l_nlimbs, ({NATURAL_32} 32 - l_nbits \\ {NATURAL_32} 32).to_natural_32).do_nothing
			end
			l_exp := (0).to_integer_32
			from
			until
				js.loop_done
			loop
				if l_nlimbs /= 0 then
					if l_rp[(l_nlimbs - 1)] /= {NATURAL_32} 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_nlimbs := l_nlimbs - 1
					l_exp := l_exp - 1
				end
			end
			a_rop.item.mp_exp := l_exp
			a_rop.item.mp_size := l_nlimbs.to_integer_32
		end

	gmpz_urandomb (a_rop: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			js: JUMP_STATE
		do
			create l_rp.make
			create l___rstate.make

			l_size := ((a_nbits + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			if (builtin_expect ((l_size > (a_rop.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				l_rp := create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_rop, l_size)))
			else
				l_rp := a_rop.item.mp_d
			end
			from
			until
				js.loop_done
			loop
				l___rstate := a_rstate;
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_rp, a_nbits])
				js.break
			end
			from
			until
				js.loop_done
			loop
				from
				until
					not (not js.loop_done and then (l_size > 0))
				loop
					if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_size := l_size - 1
					end
				end
				js.break
			end
			a_rop.item.mp_size := l_size.to_integer_32
		end

end
