class
	P_URANDOMM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_urandomm (a_rop: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_nlast: CE_POINTER [NATURAL_32]
			l_nbits: INTEGER_32
			l_size: INTEGER_32
			l_count: INTEGER_32
			l_pow2: INTEGER_32
			l_cmp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rp.make
			create l_np.make
			create l_nlast.make
			create l___tmp_marker.make (<<1>>)
			create l_tp.make
			create l_tmp___2.make
			create l___rstate.make

			if a_n.item.mp_size >= 0 then
				l_size := (a_n.item.mp_size).to_integer_32
			else
				l_size := (-a_n.item.mp_size).to_integer_32
			end
			if l_size = 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_nlast := a_n.item.mp_d + (l_size - 1)
			l_pow2 := (((l_nlast.item).bit_and ((l_nlast.item - {NATURAL_32} 1))) = {NATURAL_32} 0).to_integer
			if l_pow2 /= 0 then
				l_np := a_n.item.mp_d
				from
				until
					not (not js.loop_done and then ((l_np.c_pointer.to_integer_32).to_natural_32 < (l_nlast.c_pointer.to_integer_32).to_natural_32))
				loop
					if l_np.item /= {NATURAL_32} 0 then
						l_pow2 := 0
						js.break
					end
					if not js.loop_jumped then
						l_np := l_np + 1
					end
				end
			end
			from
			until
				js.loop_done
			loop
				l_count := builtin_clzl (l_nlast.item)
				js.break
			end
			l_nbits := (l_size * 32 - l_count.to_integer_32) - l_pow2.to_integer_32
			if l_nbits = 0 then
				a_rop.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_np := a_n.item.mp_d
				if a_rop.is_equal (a_n) then
					if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___2 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_tp, l_np, l_size)
							js.break
						end
						js.break
					end
					l_np := l_tp
				end
				if (builtin_expect ((l_size > (a_rop.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_rp := create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_rop, l_size)))
				else
					l_rp := a_rop.item.mp_d
				end
				l_rp[(l_size - 1)] := (0).to_natural_32
				l_count := 80
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						l___rstate := a_rstate;
						((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_rp, l_nbits.to_natural_32])
						js.break
					end
					from
					until
						js.loop_done
					loop
						l_cmp := 0
						l___gmp_i := l_size
						from
						until
							js.loop_done
						loop
							l___gmp_i := l___gmp_i - 1
							if not (l___gmp_i >= 0) then
								js.break
							end
							if not js.loop_jumped then
								l___gmp_x := l_rp[l___gmp_i]
								l___gmp_y := l_np[l___gmp_i]
								if l___gmp_x /= l___gmp_y then
									if l___gmp_x > l___gmp_y then
										l_cmp := 1
									else
										l_cmp := -1
									end
									js.break
								end
							end
						end
						js.break
					end
					if l_cmp >= 0 then
						l_count := l_count - 1
						if l_count = 0 then
							js.break
						end
					else
						js.break
					end
				end
				if l_count = 0 then
					gmp_inst.gmpn_sub_n (l_rp, l_rp, l_np, l_size).do_nothing
				end
				from
				until
					js.loop_done
				loop
					from
					until
						not (not js.loop_done and then (l_size > 0))
					loop
						if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_size := l_size - 1
						end
					end
					js.break
				end
				a_rop.item.mp_size := l_size.to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
