class
	SD_OBSTACK_CHUNK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create limit.make
			create prev.make
			create contents.make (<<4>>)
		end

feature {ANY} -- fields

	limit: CE_POINTER [INTEGER_8] assign set_limit

	prev: CE_POINTER [SD_OBSTACK_CHUNK] assign set_prev

	contents: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_limit (a_limit: CE_POINTER [INTEGER_8])
		do
			limit := a_limit
			update_memory_field ("limit")
		end

	set_prev (a_prev: CE_POINTER [SD_OBSTACK_CHUNK])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			limit := a_other.limit
			prev := a_other.prev
			contents := a_other.contents.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				limit.is_equal (a_other.limit) and
				prev.is_equal (a_other.prev) and
				contents.is_equal (a_other.contents)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("limit"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("contents", <<4>>)
				>>)
			init_structure_info
		end

end
