class
	PD_AKIMA_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create b.make
			create c.make
			create d.make
			create m.make
		end

feature {ANY} -- fields

	b: CE_POINTER [REAL_64] assign set_b

	c: CE_POINTER [REAL_64] assign set_c

	d: CE_POINTER [REAL_64] assign set_d

	m: CE_POINTER [REAL_64] assign set_m

feature {ANY} -- setters

	set_b (a_b: CE_POINTER [REAL_64])
		do
			b := a_b
			update_memory_field ("b")
		end

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c := a_c
			update_memory_field ("c")
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_m (a_m: CE_POINTER [REAL_64])
		do
			m := a_m
			update_memory_field ("m")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b := a_other.b
			c := a_other.c
			d := a_other.d
			m := a_other.m
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b.is_equal (a_other.b) and
				c.is_equal (a_other.c) and
				d.is_equal (a_other.d) and
				m.is_equal (a_other.m)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("m")
				>>)
			init_structure_info
		end

end
