class
	PD_BRENT_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	d: REAL_64 assign set_d

	e: REAL_64 assign set_e

	v: REAL_64 assign set_v

	w: REAL_64 assign set_w

	f_v: REAL_64 assign set_f_v

	f_w: REAL_64 assign set_f_w

feature {ANY} -- setters

	set_d (a_d: REAL_64)
		do
			d := a_d
			update_memory_field ("d")
		end

	set_e (a_e: REAL_64)
		do
			e := a_e
			update_memory_field ("e")
		end

	set_v (a_v: REAL_64)
		do
			v := a_v
			update_memory_field ("v")
		end

	set_w (a_w: REAL_64)
		do
			w := a_w
			update_memory_field ("w")
		end

	set_f_v (a_f_v: REAL_64)
		do
			f_v := a_f_v
			update_memory_field ("f_v")
		end

	set_f_w (a_f_w: REAL_64)
		do
			f_w := a_f_w
			update_memory_field ("f_w")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			e := a_other.e
			v := a_other.v
			w := a_other.w
			f_v := a_other.f_v
			f_w := a_other.f_w
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d = a_other.d and
				e = a_other.e and
				v = a_other.v and
				w = a_other.w and
				f_v = a_other.f_v and
				f_w = a_other.f_w
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("e"),
					create {CE_STRUCTURE_FIELD}.make ("v"),
					create {CE_STRUCTURE_FIELD}.make ("w"),
					create {CE_STRUCTURE_FIELD}.make ("f_v"),
					create {CE_STRUCTURE_FIELD}.make ("f_w")
				>>)
			init_structure_info
		end

end
