class
	PD_CHEB_SERIES_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create c.make
		end

feature {ANY} -- fields

	c: CE_POINTER [REAL_64] assign set_c

	order: INTEGER_32 assign set_order

	a: REAL_64 assign set_a

	b: REAL_64 assign set_b

	order_sp: INTEGER_32 assign set_order_sp

feature {ANY} -- setters

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c := a_c
			update_memory_field ("c")
		end

	set_order (a_order: INTEGER_32)
		do
			order := a_order
			update_memory_field ("order")
		end

	set_a (a_a: REAL_64)
		do
			a := a_a
			update_memory_field ("a")
		end

	set_b (a_b: REAL_64)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_order_sp (a_order_sp: INTEGER_32)
		do
			order_sp := a_order_sp
			update_memory_field ("order_sp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c := a_other.c
			order := a_other.order
			a := a_other.a
			b := a_other.b
			order_sp := a_other.order_sp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c.is_equal (a_other.c) and
				order = a_other.order and
				a = a_other.a and
				b = a_other.b and
				order_sp = a_other.order_sp
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("order"),
					create {CE_STRUCTURE_FIELD}.make ("a"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("order_sp")
				>>)
			init_structure_info
		end

end
