class
	PD_CSPLINE_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create c.make
			create g.make
			create diag.make
			create offdiag.make
		end

feature {ANY} -- fields

	c: CE_POINTER [REAL_64] assign set_c

	g: CE_POINTER [REAL_64] assign set_g

	diag: CE_POINTER [REAL_64] assign set_diag

	offdiag: CE_POINTER [REAL_64] assign set_offdiag

feature {ANY} -- setters

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c := a_c
			update_memory_field ("c")
		end

	set_g (a_g: CE_POINTER [REAL_64])
		do
			g := a_g
			update_memory_field ("g")
		end

	set_diag (a_diag: CE_POINTER [REAL_64])
		do
			diag := a_diag
			update_memory_field ("diag")
		end

	set_offdiag (a_offdiag: CE_POINTER [REAL_64])
		do
			offdiag := a_offdiag
			update_memory_field ("offdiag")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c := a_other.c
			g := a_other.g
			diag := a_other.diag
			offdiag := a_other.offdiag
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c.is_equal (a_other.c) and
				g.is_equal (a_other.g) and
				diag.is_equal (a_other.diag) and
				offdiag.is_equal (a_other.offdiag)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("g"),
					create {CE_STRUCTURE_FIELD}.make ("diag"),
					create {CE_STRUCTURE_FIELD}.make ("offdiag")
				>>)
			init_structure_info
		end

end
