class
	PD_FACT_TABLE

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	n: INTEGER_32 assign set_n

	f: REAL_64 assign set_f

	i: INTEGER_32 assign set_i

feature {ANY} -- setters

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_f (a_f: REAL_64)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_i (a_i: INTEGER_32)
		do
			i := a_i
			update_memory_field ("i")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			f := a_other.f
			i := a_other.i
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				f = a_other.f and
				i = a_other.i
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("i")
				>>)
			init_structure_info
		end

end
