class
	PD_GEAR2_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create primer.make
			create yim1.make
			create k.make
			create y0.make
			create y0_orig.make
			create y_onestep.make
		end

feature {ANY} -- fields

	primed: INTEGER_32 assign set_primed

	t_primed: REAL_64 assign set_t_primed

	last_h: REAL_64 assign set_last_h

	primer: CE_POINTER [PD_GSL_ODEIV_STEP] assign set_primer

	yim1: CE_POINTER [REAL_64] assign set_yim1

	k: CE_POINTER [REAL_64] assign set_k

	y0: CE_POINTER [REAL_64] assign set_y0

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep

	stutter: INTEGER_32 assign set_stutter

feature {ANY} -- setters

	set_primed (a_primed: INTEGER_32)
		do
			primed := a_primed
			update_memory_field ("primed")
		end

	set_t_primed (a_t_primed: REAL_64)
		do
			t_primed := a_t_primed
			update_memory_field ("t_primed")
		end

	set_last_h (a_last_h: REAL_64)
		do
			last_h := a_last_h
			update_memory_field ("last_h")
		end

	set_primer (a_primer: CE_POINTER [PD_GSL_ODEIV_STEP])
		do
			primer := a_primer
			update_memory_field ("primer")
		end

	set_yim1 (a_yim1: CE_POINTER [REAL_64])
		do
			yim1 := a_yim1
			update_memory_field ("yim1")
		end

	set_k (a_k: CE_POINTER [REAL_64])
		do
			k := a_k
			update_memory_field ("k")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			y0_orig := a_y0_orig
			update_memory_field ("y0_orig")
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			y_onestep := a_y_onestep
			update_memory_field ("y_onestep")
		end

	set_stutter (a_stutter: INTEGER_32)
		do
			stutter := a_stutter
			update_memory_field ("stutter")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			primed := a_other.primed
			t_primed := a_other.t_primed
			last_h := a_other.last_h
			primer := a_other.primer
			yim1 := a_other.yim1
			k := a_other.k
			y0 := a_other.y0
			y0_orig := a_other.y0_orig
			y_onestep := a_other.y_onestep
			stutter := a_other.stutter
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				primed = a_other.primed and
				t_primed = a_other.t_primed and
				last_h = a_other.last_h and
				primer.is_equal (a_other.primer) and
				yim1.is_equal (a_other.yim1) and
				k.is_equal (a_other.k) and
				y0.is_equal (a_other.y0) and
				y0_orig.is_equal (a_other.y0_orig) and
				y_onestep.is_equal (a_other.y_onestep) and
				stutter = a_other.stutter
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("primed"),
					create {CE_STRUCTURE_FIELD}.make ("t_primed"),
					create {CE_STRUCTURE_FIELD}.make ("last_h"),
					create {CE_STRUCTURE_FIELD}.make ("primer"),
					create {CE_STRUCTURE_FIELD}.make ("yim1"),
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("y0_orig"),
					create {CE_STRUCTURE_FIELD}.make ("y_onestep"),
					create {CE_STRUCTURE_FIELD}.make ("stutter")
				>>)
			init_structure_info
		end

end
