class
	PD_GNEWTON_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x_trial.make
			create d.make
			create lu.make
			create permutation.make
		end

feature {ANY} -- fields

	phi: REAL_64 assign set_phi

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial

	d: CE_POINTER [PD_GSL_VECTOR] assign set_d

	lu: CE_POINTER [PD_GSL_MATRIX] assign set_lu

	permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_permutation

feature {ANY} -- setters

	set_phi (a_phi: REAL_64)
		do
			phi := a_phi
			update_memory_field ("phi")
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			x_trial := a_x_trial
			update_memory_field ("x_trial")
		end

	set_d (a_d: CE_POINTER [PD_GSL_VECTOR])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_lu (a_lu: CE_POINTER [PD_GSL_MATRIX])
		do
			lu := a_lu
			update_memory_field ("lu")
		end

	set_permutation (a_permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			permutation := a_permutation
			update_memory_field ("permutation")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			phi := a_other.phi
			x_trial := a_other.x_trial
			d := a_other.d
			lu := a_other.lu
			permutation := a_other.permutation
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				phi = a_other.phi and
				x_trial.is_equal (a_other.x_trial) and
				d.is_equal (a_other.d) and
				lu.is_equal (a_other.lu) and
				permutation.is_equal (a_other.permutation)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("phi"),
					create {CE_STRUCTURE_FIELD}.make ("x_trial"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("lu"),
					create {CE_STRUCTURE_FIELD}.make ("permutation")
				>>)
			init_structure_info
		end

end
