class
	PD_GSL_BSPLINE_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create knots.make
			create deltal.make
			create deltar.make
			create B.make
		end

feature {ANY} -- fields

	k: NATURAL_32 assign set_k

	km1: NATURAL_32 assign set_km1

	l: NATURAL_32 assign set_l

	nbreak: NATURAL_32 assign set_nbreak

	n: NATURAL_32 assign set_n

	knots: CE_POINTER [PD_GSL_VECTOR] assign set_knots

	deltal: CE_POINTER [PD_GSL_VECTOR] assign set_deltal

	deltar: CE_POINTER [PD_GSL_VECTOR] assign set_deltar

	B: CE_POINTER [PD_GSL_VECTOR] assign set_B

feature {ANY} -- setters

	set_k (a_k: NATURAL_32)
		do
			k := a_k
			update_memory_field ("k")
		end

	set_km1 (a_km1: NATURAL_32)
		do
			km1 := a_km1
			update_memory_field ("km1")
		end

	set_l (a_l: NATURAL_32)
		do
			l := a_l
			update_memory_field ("l")
		end

	set_nbreak (a_nbreak: NATURAL_32)
		do
			nbreak := a_nbreak
			update_memory_field ("nbreak")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_knots (a_knots: CE_POINTER [PD_GSL_VECTOR])
		do
			knots := a_knots
			update_memory_field ("knots")
		end

	set_deltal (a_deltal: CE_POINTER [PD_GSL_VECTOR])
		do
			deltal := a_deltal
			update_memory_field ("deltal")
		end

	set_deltar (a_deltar: CE_POINTER [PD_GSL_VECTOR])
		do
			deltar := a_deltar
			update_memory_field ("deltar")
		end

	set_B (a_B: CE_POINTER [PD_GSL_VECTOR])
		do
			B := a_B
			update_memory_field ("B")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k := a_other.k
			km1 := a_other.km1
			l := a_other.l
			nbreak := a_other.nbreak
			n := a_other.n
			knots := a_other.knots
			deltal := a_other.deltal
			deltar := a_other.deltar
			B := a_other.B
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k = a_other.k and
				km1 = a_other.km1 and
				l = a_other.l and
				nbreak = a_other.nbreak and
				n = a_other.n and
				knots.is_equal (a_other.knots) and
				deltal.is_equal (a_other.deltal) and
				deltar.is_equal (a_other.deltar) and
				B.is_equal (a_other.B)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("km1"),
					create {CE_STRUCTURE_FIELD}.make ("l"),
					create {CE_STRUCTURE_FIELD}.make ("nbreak"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("knots"),
					create {CE_STRUCTURE_FIELD}.make ("deltal"),
					create {CE_STRUCTURE_FIELD}.make ("deltar"),
					create {CE_STRUCTURE_FIELD}.make ("B")
				>>)
			init_structure_info
		end

end
