class
	PD_GSL_EIGEN_GENHERM_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create herm_workspace_p.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	herm_workspace_p: CE_POINTER [PD_GSL_EIGEN_HERM_WORKSPACE] assign set_herm_workspace_p

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_herm_workspace_p (a_herm_workspace_p: CE_POINTER [PD_GSL_EIGEN_HERM_WORKSPACE])
		do
			herm_workspace_p := a_herm_workspace_p
			update_memory_field ("herm_workspace_p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			herm_workspace_p := a_other.herm_workspace_p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				herm_workspace_p.is_equal (a_other.herm_workspace_p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("herm_workspace_p")
				>>)
			init_structure_info
		end

end
