class
	PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create factor.make (<<64>>)
			create twiddle.make (<<64>>)
			create trig.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	nf: NATURAL_32 assign set_nf

	factor: CE_ARRAY [NATURAL_32]

	twiddle: CE_ARRAY [CE_POINTER [PD_GSL_COMPLEX_FLOAT]]

	trig: CE_POINTER [PD_GSL_COMPLEX_FLOAT] assign set_trig

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_nf (a_nf: NATURAL_32)
		do
			nf := a_nf
			update_memory_field ("nf")
		end

	set_trig (a_trig: CE_POINTER [PD_GSL_COMPLEX_FLOAT])
		do
			trig := a_trig
			update_memory_field ("trig")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			nf := a_other.nf
			factor := a_other.factor.twin
			twiddle := a_other.twiddle.twin
			trig := a_other.trig
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				nf = a_other.nf and
				factor.is_equal (a_other.factor) and
				twiddle.is_equal (a_other.twiddle) and
				trig.is_equal (a_other.trig)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("nf"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("factor", <<64>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("twiddle", <<64>>),
					create {CE_STRUCTURE_FIELD}.make ("trig")
				>>)
			init_structure_info
		end

end
