class
	PD_GSL_FFT_REAL_WORKSPACE_FLOAT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create scratch.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	scratch: CE_POINTER [REAL_32] assign set_scratch

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_scratch (a_scratch: CE_POINTER [REAL_32])
		do
			scratch := a_scratch
			update_memory_field ("scratch")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			scratch := a_other.scratch
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				scratch.is_equal (a_other.scratch)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("scratch")
				>>)
			init_structure_info
		end

end
