class
	PD_GSL_FUNCTION_FDF_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create f.make
			create df.make
			create fdf.make
			create params.make
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	df: CE_ROUTINE assign set_df

	fdf: CE_ROUTINE assign set_fdf

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_df (a_df: CE_ROUTINE)
		do
			df := a_df
			update_memory_field ("df")
		end

	set_fdf (a_fdf: CE_ROUTINE)
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			df := a_other.df
			fdf := a_other.fdf
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				df.is_equal (a_other.df) and
				fdf.is_equal (a_other.fdf) and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
