class
	PD_GSL_IEEE_FLOAT_REP

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mantissa.make (<<24>>)
		end

feature {ANY} -- fields

	sign: INTEGER_32 assign set_sign

	mantissa: CE_ARRAY [INTEGER_8]

	exponent: INTEGER_32 assign set_exponent

	type: INTEGER_32 assign set_type

feature {ANY} -- setters

	set_sign (a_sign: INTEGER_32)
		do
			sign := a_sign
			update_memory_field ("sign")
		end

	set_exponent (a_exponent: INTEGER_32)
		do
			exponent := a_exponent
			update_memory_field ("exponent")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sign := a_other.sign
			mantissa := a_other.mantissa.twin
			exponent := a_other.exponent
			type := a_other.type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sign = a_other.sign and
				mantissa.is_equal (a_other.mantissa) and
				exponent = a_other.exponent and
				type = a_other.type
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sign"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mantissa", <<24>>),
					create {CE_STRUCTURE_FIELD}.make ("exponent"),
					create {CE_STRUCTURE_FIELD}.make ("type")
				>>)
			init_structure_info
		end

end
