class
	PD_GSL_INTEGRATION_GLFIXED_TABLE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x.make
			create w.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	x: CE_POINTER [REAL_64] assign set_x

	w: CE_POINTER [REAL_64] assign set_w

	precomputed: INTEGER_32 assign set_precomputed

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_w (a_w: CE_POINTER [REAL_64])
		do
			w := a_w
			update_memory_field ("w")
		end

	set_precomputed (a_precomputed: INTEGER_32)
		do
			precomputed := a_precomputed
			update_memory_field ("precomputed")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			x := a_other.x
			w := a_other.w
			precomputed := a_other.precomputed
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				x.is_equal (a_other.x) and
				w.is_equal (a_other.w) and
				precomputed = a_other.precomputed
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("w"),
					create {CE_STRUCTURE_FIELD}.make ("precomputed")
				>>)
			init_structure_info
		end

end
