class
	PD_GSL_INTEGRATION_QAWO_TABLE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create chebmo.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	omega: REAL_64 assign set_omega

	L: REAL_64 assign set_L

	par: REAL_64 assign set_par

	sine: NATURAL_32 assign set_sine

	chebmo: CE_POINTER [REAL_64] assign set_chebmo

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_omega (a_omega: REAL_64)
		do
			omega := a_omega
			update_memory_field ("omega")
		end

	set_L (a_L: REAL_64)
		do
			L := a_L
			update_memory_field ("L")
		end

	set_par (a_par: REAL_64)
		do
			par := a_par
			update_memory_field ("par")
		end

	set_sine (a_sine: NATURAL_32)
		do
			sine := a_sine
			update_memory_field ("sine")
		end

	set_chebmo (a_chebmo: CE_POINTER [REAL_64])
		do
			chebmo := a_chebmo
			update_memory_field ("chebmo")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			omega := a_other.omega
			L := a_other.L
			par := a_other.par
			sine := a_other.sine
			chebmo := a_other.chebmo
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				omega = a_other.omega and
				L = a_other.L and
				par = a_other.par and
				sine = a_other.sine and
				chebmo.is_equal (a_other.chebmo)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("omega"),
					create {CE_STRUCTURE_FIELD}.make ("L"),
					create {CE_STRUCTURE_FIELD}.make ("par"),
					create {CE_STRUCTURE_FIELD}.make ("sine"),
					create {CE_STRUCTURE_FIELD}.make ("chebmo")
				>>)
			init_structure_info
		end

end
