class
	PD_GSL_INTERP_TYPE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create alloc.make
			create init.make
			create eval.make
			create eval_deriv.make
			create eval_deriv2.make
			create eval_integ.make
			create free.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	min_size: NATURAL_32 assign set_min_size

	alloc: CE_ROUTINE assign set_alloc

	init: CE_ROUTINE assign set_init

	eval: CE_ROUTINE assign set_eval

	eval_deriv: CE_ROUTINE assign set_eval_deriv

	eval_deriv2: CE_ROUTINE assign set_eval_deriv2

	eval_integ: CE_ROUTINE assign set_eval_integ

	free: CE_ROUTINE assign set_free

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_min_size (a_min_size: NATURAL_32)
		do
			min_size := a_min_size
			update_memory_field ("min_size")
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_init (a_init: CE_ROUTINE)
		do
			init := a_init
			update_memory_field ("init")
		end

	set_eval (a_eval: CE_ROUTINE)
		do
			eval := a_eval
			update_memory_field ("eval")
		end

	set_eval_deriv (a_eval_deriv: CE_ROUTINE)
		do
			eval_deriv := a_eval_deriv
			update_memory_field ("eval_deriv")
		end

	set_eval_deriv2 (a_eval_deriv2: CE_ROUTINE)
		do
			eval_deriv2 := a_eval_deriv2
			update_memory_field ("eval_deriv2")
		end

	set_eval_integ (a_eval_integ: CE_ROUTINE)
		do
			eval_integ := a_eval_integ
			update_memory_field ("eval_integ")
		end

	set_free (a_free: CE_ROUTINE)
		do
			free := a_free
			update_memory_field ("free")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			min_size := a_other.min_size
			alloc := a_other.alloc
			init := a_other.init
			eval := a_other.eval
			eval_deriv := a_other.eval_deriv
			eval_deriv2 := a_other.eval_deriv2
			eval_integ := a_other.eval_integ
			free := a_other.free
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				min_size = a_other.min_size and
				alloc.is_equal (a_other.alloc) and
				init.is_equal (a_other.init) and
				eval.is_equal (a_other.eval) and
				eval_deriv.is_equal (a_other.eval_deriv) and
				eval_deriv2.is_equal (a_other.eval_deriv2) and
				eval_integ.is_equal (a_other.eval_integ) and
				free.is_equal (a_other.free)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("min_size"),
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("init"),
					create {CE_STRUCTURE_FIELD}.make ("eval"),
					create {CE_STRUCTURE_FIELD}.make ("eval_deriv"),
					create {CE_STRUCTURE_FIELD}.make ("eval_deriv2"),
					create {CE_STRUCTURE_FIELD}.make ("eval_integ"),
					create {CE_STRUCTURE_FIELD}.make ("free")
				>>)
			init_structure_info
		end

end
