class
	PD_GSL_MIN_FMINIMIZER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create function.make
			create state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE] assign set_type

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function

	x_minimum: REAL_64 assign set_x_minimum

	x_lower: REAL_64 assign set_x_lower

	x_upper: REAL_64 assign set_x_upper

	f_minimum: REAL_64 assign set_f_minimum

	f_lower: REAL_64 assign set_f_lower

	f_upper: REAL_64 assign set_f_upper

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_x_minimum (a_x_minimum: REAL_64)
		do
			x_minimum := a_x_minimum
			update_memory_field ("x_minimum")
		end

	set_x_lower (a_x_lower: REAL_64)
		do
			x_lower := a_x_lower
			update_memory_field ("x_lower")
		end

	set_x_upper (a_x_upper: REAL_64)
		do
			x_upper := a_x_upper
			update_memory_field ("x_upper")
		end

	set_f_minimum (a_f_minimum: REAL_64)
		do
			f_minimum := a_f_minimum
			update_memory_field ("f_minimum")
		end

	set_f_lower (a_f_lower: REAL_64)
		do
			f_lower := a_f_lower
			update_memory_field ("f_lower")
		end

	set_f_upper (a_f_upper: REAL_64)
		do
			f_upper := a_f_upper
			update_memory_field ("f_upper")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			function := a_other.function
			x_minimum := a_other.x_minimum
			x_lower := a_other.x_lower
			x_upper := a_other.x_upper
			f_minimum := a_other.f_minimum
			f_lower := a_other.f_lower
			f_upper := a_other.f_upper
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				function.is_equal (a_other.function) and
				x_minimum = a_other.x_minimum and
				x_lower = a_other.x_lower and
				x_upper = a_other.x_upper and
				f_minimum = a_other.f_minimum and
				f_lower = a_other.f_lower and
				f_upper = a_other.f_upper and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("x_minimum"),
					create {CE_STRUCTURE_FIELD}.make ("x_lower"),
					create {CE_STRUCTURE_FIELD}.make ("x_upper"),
					create {CE_STRUCTURE_FIELD}.make ("f_minimum"),
					create {CE_STRUCTURE_FIELD}.make ("f_lower"),
					create {CE_STRUCTURE_FIELD}.make ("f_upper"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
