class
	PD_GSL_MONTE_MISER_STATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x.make
			create xmid.make
			create sigma_l.make
			create sigma_r.make
			create fmax_l.make
			create fmax_r.make
			create fmin_l.make
			create fmin_r.make
			create fsum_l.make
			create fsum_r.make
			create fsum2_l.make
			create fsum2_r.make
			create hits_l.make
			create hits_r.make
		end

feature {ANY} -- fields

	min_calls: NATURAL_32 assign set_min_calls

	min_calls_per_bisection: NATURAL_32 assign set_min_calls_per_bisection

	dither: REAL_64 assign set_dither

	estimate_frac: REAL_64 assign set_estimate_frac

	alpha: REAL_64 assign set_alpha

	dim: NATURAL_32 assign set_dim

	estimate_style: INTEGER_32 assign set_estimate_style

	depth: INTEGER_32 assign set_depth

	verbose: INTEGER_32 assign set_verbose

	x: CE_POINTER [REAL_64] assign set_x

	xmid: CE_POINTER [REAL_64] assign set_xmid

	sigma_l: CE_POINTER [REAL_64] assign set_sigma_l

	sigma_r: CE_POINTER [REAL_64] assign set_sigma_r

	fmax_l: CE_POINTER [REAL_64] assign set_fmax_l

	fmax_r: CE_POINTER [REAL_64] assign set_fmax_r

	fmin_l: CE_POINTER [REAL_64] assign set_fmin_l

	fmin_r: CE_POINTER [REAL_64] assign set_fmin_r

	fsum_l: CE_POINTER [REAL_64] assign set_fsum_l

	fsum_r: CE_POINTER [REAL_64] assign set_fsum_r

	fsum2_l: CE_POINTER [REAL_64] assign set_fsum2_l

	fsum2_r: CE_POINTER [REAL_64] assign set_fsum2_r

	hits_l: CE_POINTER [NATURAL_32] assign set_hits_l

	hits_r: CE_POINTER [NATURAL_32] assign set_hits_r

feature {ANY} -- setters

	set_min_calls (a_min_calls: NATURAL_32)
		do
			min_calls := a_min_calls
			update_memory_field ("min_calls")
		end

	set_min_calls_per_bisection (a_min_calls_per_bisection: NATURAL_32)
		do
			min_calls_per_bisection := a_min_calls_per_bisection
			update_memory_field ("min_calls_per_bisection")
		end

	set_dither (a_dither: REAL_64)
		do
			dither := a_dither
			update_memory_field ("dither")
		end

	set_estimate_frac (a_estimate_frac: REAL_64)
		do
			estimate_frac := a_estimate_frac
			update_memory_field ("estimate_frac")
		end

	set_alpha (a_alpha: REAL_64)
		do
			alpha := a_alpha
			update_memory_field ("alpha")
		end

	set_dim (a_dim: NATURAL_32)
		do
			dim := a_dim
			update_memory_field ("dim")
		end

	set_estimate_style (a_estimate_style: INTEGER_32)
		do
			estimate_style := a_estimate_style
			update_memory_field ("estimate_style")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			verbose := a_verbose
			update_memory_field ("verbose")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_xmid (a_xmid: CE_POINTER [REAL_64])
		do
			xmid := a_xmid
			update_memory_field ("xmid")
		end

	set_sigma_l (a_sigma_l: CE_POINTER [REAL_64])
		do
			sigma_l := a_sigma_l
			update_memory_field ("sigma_l")
		end

	set_sigma_r (a_sigma_r: CE_POINTER [REAL_64])
		do
			sigma_r := a_sigma_r
			update_memory_field ("sigma_r")
		end

	set_fmax_l (a_fmax_l: CE_POINTER [REAL_64])
		do
			fmax_l := a_fmax_l
			update_memory_field ("fmax_l")
		end

	set_fmax_r (a_fmax_r: CE_POINTER [REAL_64])
		do
			fmax_r := a_fmax_r
			update_memory_field ("fmax_r")
		end

	set_fmin_l (a_fmin_l: CE_POINTER [REAL_64])
		do
			fmin_l := a_fmin_l
			update_memory_field ("fmin_l")
		end

	set_fmin_r (a_fmin_r: CE_POINTER [REAL_64])
		do
			fmin_r := a_fmin_r
			update_memory_field ("fmin_r")
		end

	set_fsum_l (a_fsum_l: CE_POINTER [REAL_64])
		do
			fsum_l := a_fsum_l
			update_memory_field ("fsum_l")
		end

	set_fsum_r (a_fsum_r: CE_POINTER [REAL_64])
		do
			fsum_r := a_fsum_r
			update_memory_field ("fsum_r")
		end

	set_fsum2_l (a_fsum2_l: CE_POINTER [REAL_64])
		do
			fsum2_l := a_fsum2_l
			update_memory_field ("fsum2_l")
		end

	set_fsum2_r (a_fsum2_r: CE_POINTER [REAL_64])
		do
			fsum2_r := a_fsum2_r
			update_memory_field ("fsum2_r")
		end

	set_hits_l (a_hits_l: CE_POINTER [NATURAL_32])
		do
			hits_l := a_hits_l
			update_memory_field ("hits_l")
		end

	set_hits_r (a_hits_r: CE_POINTER [NATURAL_32])
		do
			hits_r := a_hits_r
			update_memory_field ("hits_r")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			min_calls := a_other.min_calls
			min_calls_per_bisection := a_other.min_calls_per_bisection
			dither := a_other.dither
			estimate_frac := a_other.estimate_frac
			alpha := a_other.alpha
			dim := a_other.dim
			estimate_style := a_other.estimate_style
			depth := a_other.depth
			verbose := a_other.verbose
			x := a_other.x
			xmid := a_other.xmid
			sigma_l := a_other.sigma_l
			sigma_r := a_other.sigma_r
			fmax_l := a_other.fmax_l
			fmax_r := a_other.fmax_r
			fmin_l := a_other.fmin_l
			fmin_r := a_other.fmin_r
			fsum_l := a_other.fsum_l
			fsum_r := a_other.fsum_r
			fsum2_l := a_other.fsum2_l
			fsum2_r := a_other.fsum2_r
			hits_l := a_other.hits_l
			hits_r := a_other.hits_r
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				min_calls = a_other.min_calls and
				min_calls_per_bisection = a_other.min_calls_per_bisection and
				dither = a_other.dither and
				estimate_frac = a_other.estimate_frac and
				alpha = a_other.alpha and
				dim = a_other.dim and
				estimate_style = a_other.estimate_style and
				depth = a_other.depth and
				verbose = a_other.verbose and
				x.is_equal (a_other.x) and
				xmid.is_equal (a_other.xmid) and
				sigma_l.is_equal (a_other.sigma_l) and
				sigma_r.is_equal (a_other.sigma_r) and
				fmax_l.is_equal (a_other.fmax_l) and
				fmax_r.is_equal (a_other.fmax_r) and
				fmin_l.is_equal (a_other.fmin_l) and
				fmin_r.is_equal (a_other.fmin_r) and
				fsum_l.is_equal (a_other.fsum_l) and
				fsum_r.is_equal (a_other.fsum_r) and
				fsum2_l.is_equal (a_other.fsum2_l) and
				fsum2_r.is_equal (a_other.fsum2_r) and
				hits_l.is_equal (a_other.hits_l) and
				hits_r.is_equal (a_other.hits_r)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("min_calls"),
					create {CE_STRUCTURE_FIELD}.make ("min_calls_per_bisection"),
					create {CE_STRUCTURE_FIELD}.make ("dither"),
					create {CE_STRUCTURE_FIELD}.make ("estimate_frac"),
					create {CE_STRUCTURE_FIELD}.make ("alpha"),
					create {CE_STRUCTURE_FIELD}.make ("dim"),
					create {CE_STRUCTURE_FIELD}.make ("estimate_style"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("verbose"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("xmid"),
					create {CE_STRUCTURE_FIELD}.make ("sigma_l"),
					create {CE_STRUCTURE_FIELD}.make ("sigma_r"),
					create {CE_STRUCTURE_FIELD}.make ("fmax_l"),
					create {CE_STRUCTURE_FIELD}.make ("fmax_r"),
					create {CE_STRUCTURE_FIELD}.make ("fmin_l"),
					create {CE_STRUCTURE_FIELD}.make ("fmin_r"),
					create {CE_STRUCTURE_FIELD}.make ("fsum_l"),
					create {CE_STRUCTURE_FIELD}.make ("fsum_r"),
					create {CE_STRUCTURE_FIELD}.make ("fsum2_l"),
					create {CE_STRUCTURE_FIELD}.make ("fsum2_r"),
					create {CE_STRUCTURE_FIELD}.make ("hits_l"),
					create {CE_STRUCTURE_FIELD}.make ("hits_r")
				>>)
			init_structure_info
		end

end
