class
	PD_GSL_MONTE_VEGAS_STATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create xi.make
			create xin.make
			create delx.make
			create weight.make
			create x.make
			create bin.make
			create box.make
			create d.make
			create ostream.make
		end

feature {ANY} -- fields

	dim: NATURAL_32 assign set_dim

	bins_max: NATURAL_32 assign set_bins_max

	bins: NATURAL_32 assign set_bins

	boxes: NATURAL_32 assign set_boxes

	xi: CE_POINTER [REAL_64] assign set_xi

	xin: CE_POINTER [REAL_64] assign set_xin

	delx: CE_POINTER [REAL_64] assign set_delx

	weight: CE_POINTER [REAL_64] assign set_weight

	vol: REAL_64 assign set_vol

	x: CE_POINTER [REAL_64] assign set_x

	bin: CE_POINTER [INTEGER_32] assign set_bin

	box: CE_POINTER [INTEGER_32] assign set_box

	d: CE_POINTER [REAL_64] assign set_d

	alpha: REAL_64 assign set_alpha

	mode: INTEGER_32 assign set_mode

	verbose: INTEGER_32 assign set_verbose

	iterations: NATURAL_32 assign set_iterations

	stage: INTEGER_32 assign set_stage

	jac: REAL_64 assign set_jac

	wtd_int_sum: REAL_64 assign set_wtd_int_sum

	sum_wgts: REAL_64 assign set_sum_wgts

	chi_sum: REAL_64 assign set_chi_sum

	chisq: REAL_64 assign set_chisq

	result2: REAL_64 assign set_result2

	sigma: REAL_64 assign set_sigma

	it_start: NATURAL_32 assign set_it_start

	it_num: NATURAL_32 assign set_it_num

	samples: NATURAL_32 assign set_samples

	calls_per_box: NATURAL_32 assign set_calls_per_box

	ostream: CE_POINTER [SD_IO_FILE] assign set_ostream

feature {ANY} -- setters

	set_dim (a_dim: NATURAL_32)
		do
			dim := a_dim
			update_memory_field ("dim")
		end

	set_bins_max (a_bins_max: NATURAL_32)
		do
			bins_max := a_bins_max
			update_memory_field ("bins_max")
		end

	set_bins (a_bins: NATURAL_32)
		do
			bins := a_bins
			update_memory_field ("bins")
		end

	set_boxes (a_boxes: NATURAL_32)
		do
			boxes := a_boxes
			update_memory_field ("boxes")
		end

	set_xi (a_xi: CE_POINTER [REAL_64])
		do
			xi := a_xi
			update_memory_field ("xi")
		end

	set_xin (a_xin: CE_POINTER [REAL_64])
		do
			xin := a_xin
			update_memory_field ("xin")
		end

	set_delx (a_delx: CE_POINTER [REAL_64])
		do
			delx := a_delx
			update_memory_field ("delx")
		end

	set_weight (a_weight: CE_POINTER [REAL_64])
		do
			weight := a_weight
			update_memory_field ("weight")
		end

	set_vol (a_vol: REAL_64)
		do
			vol := a_vol
			update_memory_field ("vol")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_bin (a_bin: CE_POINTER [INTEGER_32])
		do
			bin := a_bin
			update_memory_field ("bin")
		end

	set_box (a_box: CE_POINTER [INTEGER_32])
		do
			box := a_box
			update_memory_field ("box")
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_alpha (a_alpha: REAL_64)
		do
			alpha := a_alpha
			update_memory_field ("alpha")
		end

	set_mode (a_mode: INTEGER_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			verbose := a_verbose
			update_memory_field ("verbose")
		end

	set_iterations (a_iterations: NATURAL_32)
		do
			iterations := a_iterations
			update_memory_field ("iterations")
		end

	set_stage (a_stage: INTEGER_32)
		do
			stage := a_stage
			update_memory_field ("stage")
		end

	set_jac (a_jac: REAL_64)
		do
			jac := a_jac
			update_memory_field ("jac")
		end

	set_wtd_int_sum (a_wtd_int_sum: REAL_64)
		do
			wtd_int_sum := a_wtd_int_sum
			update_memory_field ("wtd_int_sum")
		end

	set_sum_wgts (a_sum_wgts: REAL_64)
		do
			sum_wgts := a_sum_wgts
			update_memory_field ("sum_wgts")
		end

	set_chi_sum (a_chi_sum: REAL_64)
		do
			chi_sum := a_chi_sum
			update_memory_field ("chi_sum")
		end

	set_chisq (a_chisq: REAL_64)
		do
			chisq := a_chisq
			update_memory_field ("chisq")
		end

	set_result2 (a_result2: REAL_64)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_sigma (a_sigma: REAL_64)
		do
			sigma := a_sigma
			update_memory_field ("sigma")
		end

	set_it_start (a_it_start: NATURAL_32)
		do
			it_start := a_it_start
			update_memory_field ("it_start")
		end

	set_it_num (a_it_num: NATURAL_32)
		do
			it_num := a_it_num
			update_memory_field ("it_num")
		end

	set_samples (a_samples: NATURAL_32)
		do
			samples := a_samples
			update_memory_field ("samples")
		end

	set_calls_per_box (a_calls_per_box: NATURAL_32)
		do
			calls_per_box := a_calls_per_box
			update_memory_field ("calls_per_box")
		end

	set_ostream (a_ostream: CE_POINTER [SD_IO_FILE])
		do
			ostream := a_ostream
			update_memory_field ("ostream")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dim := a_other.dim
			bins_max := a_other.bins_max
			bins := a_other.bins
			boxes := a_other.boxes
			xi := a_other.xi
			xin := a_other.xin
			delx := a_other.delx
			weight := a_other.weight
			vol := a_other.vol
			x := a_other.x
			bin := a_other.bin
			box := a_other.box
			d := a_other.d
			alpha := a_other.alpha
			mode := a_other.mode
			verbose := a_other.verbose
			iterations := a_other.iterations
			stage := a_other.stage
			jac := a_other.jac
			wtd_int_sum := a_other.wtd_int_sum
			sum_wgts := a_other.sum_wgts
			chi_sum := a_other.chi_sum
			chisq := a_other.chisq
			result2 := a_other.result2
			sigma := a_other.sigma
			it_start := a_other.it_start
			it_num := a_other.it_num
			samples := a_other.samples
			calls_per_box := a_other.calls_per_box
			ostream := a_other.ostream
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dim = a_other.dim and
				bins_max = a_other.bins_max and
				bins = a_other.bins and
				boxes = a_other.boxes and
				xi.is_equal (a_other.xi) and
				xin.is_equal (a_other.xin) and
				delx.is_equal (a_other.delx) and
				weight.is_equal (a_other.weight) and
				vol = a_other.vol and
				x.is_equal (a_other.x) and
				bin.is_equal (a_other.bin) and
				box.is_equal (a_other.box) and
				d.is_equal (a_other.d) and
				alpha = a_other.alpha and
				mode = a_other.mode and
				verbose = a_other.verbose and
				iterations = a_other.iterations and
				stage = a_other.stage and
				jac = a_other.jac and
				wtd_int_sum = a_other.wtd_int_sum and
				sum_wgts = a_other.sum_wgts and
				chi_sum = a_other.chi_sum and
				chisq = a_other.chisq and
				result2 = a_other.result2 and
				sigma = a_other.sigma and
				it_start = a_other.it_start and
				it_num = a_other.it_num and
				samples = a_other.samples and
				calls_per_box = a_other.calls_per_box and
				ostream.is_equal (a_other.ostream)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dim"),
					create {CE_STRUCTURE_FIELD}.make ("bins_max"),
					create {CE_STRUCTURE_FIELD}.make ("bins"),
					create {CE_STRUCTURE_FIELD}.make ("boxes"),
					create {CE_STRUCTURE_FIELD}.make ("xi"),
					create {CE_STRUCTURE_FIELD}.make ("xin"),
					create {CE_STRUCTURE_FIELD}.make ("delx"),
					create {CE_STRUCTURE_FIELD}.make ("weight"),
					create {CE_STRUCTURE_FIELD}.make ("vol"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("bin"),
					create {CE_STRUCTURE_FIELD}.make ("box"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("alpha"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("verbose"),
					create {CE_STRUCTURE_FIELD}.make ("iterations"),
					create {CE_STRUCTURE_FIELD}.make ("stage"),
					create {CE_STRUCTURE_FIELD}.make ("jac"),
					create {CE_STRUCTURE_FIELD}.make ("wtd_int_sum"),
					create {CE_STRUCTURE_FIELD}.make ("sum_wgts"),
					create {CE_STRUCTURE_FIELD}.make ("chi_sum"),
					create {CE_STRUCTURE_FIELD}.make ("chisq"),
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("sigma"),
					create {CE_STRUCTURE_FIELD}.make ("it_start"),
					create {CE_STRUCTURE_FIELD}.make ("it_num"),
					create {CE_STRUCTURE_FIELD}.make ("samples"),
					create {CE_STRUCTURE_FIELD}.make ("calls_per_box"),
					create {CE_STRUCTURE_FIELD}.make ("ostream")
				>>)
			init_structure_info
		end

end
