class
	PD_GSL_MULTIFIT_LINEAR_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create A.make
			create Q.make
			create QSI.make
			create S.make
			create t.make
			create xt.make
			create D.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	p: NATURAL_32 assign set_p

	A: CE_POINTER [PD_GSL_MATRIX] assign set_A

	Q: CE_POINTER [PD_GSL_MATRIX] assign set_Q

	QSI: CE_POINTER [PD_GSL_MATRIX] assign set_QSI

	S: CE_POINTER [PD_GSL_VECTOR] assign set_S

	t: CE_POINTER [PD_GSL_VECTOR] assign set_t

	xt: CE_POINTER [PD_GSL_VECTOR] assign set_xt

	D: CE_POINTER [PD_GSL_VECTOR] assign set_D

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_p (a_p: NATURAL_32)
		do
			p := a_p
			update_memory_field ("p")
		end

	set_A (a_A: CE_POINTER [PD_GSL_MATRIX])
		do
			A := a_A
			update_memory_field ("A")
		end

	set_Q (a_Q: CE_POINTER [PD_GSL_MATRIX])
		do
			Q := a_Q
			update_memory_field ("Q")
		end

	set_QSI (a_QSI: CE_POINTER [PD_GSL_MATRIX])
		do
			QSI := a_QSI
			update_memory_field ("QSI")
		end

	set_S (a_S: CE_POINTER [PD_GSL_VECTOR])
		do
			S := a_S
			update_memory_field ("S")
		end

	set_t (a_t: CE_POINTER [PD_GSL_VECTOR])
		do
			t := a_t
			update_memory_field ("t")
		end

	set_xt (a_xt: CE_POINTER [PD_GSL_VECTOR])
		do
			xt := a_xt
			update_memory_field ("xt")
		end

	set_D (a_D: CE_POINTER [PD_GSL_VECTOR])
		do
			D := a_D
			update_memory_field ("D")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			p := a_other.p
			A := a_other.A
			Q := a_other.Q
			QSI := a_other.QSI
			S := a_other.S
			t := a_other.t
			xt := a_other.xt
			D := a_other.D
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				p = a_other.p and
				A.is_equal (a_other.A) and
				Q.is_equal (a_other.Q) and
				QSI.is_equal (a_other.QSI) and
				S.is_equal (a_other.S) and
				t.is_equal (a_other.t) and
				xt.is_equal (a_other.xt) and
				D.is_equal (a_other.D)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("A"),
					create {CE_STRUCTURE_FIELD}.make ("Q"),
					create {CE_STRUCTURE_FIELD}.make ("QSI"),
					create {CE_STRUCTURE_FIELD}.make ("S"),
					create {CE_STRUCTURE_FIELD}.make ("t"),
					create {CE_STRUCTURE_FIELD}.make ("xt"),
					create {CE_STRUCTURE_FIELD}.make ("D")
				>>)
			init_structure_info
		end

end
