class
	PD_GSL_MULTIMIN_FMINIMIZER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create f.make
			create x.make
			create state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE] assign set_type

	f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT] assign set_f

	fval: REAL_64 assign set_fval

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x

	size: REAL_64 assign set_size

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_f (a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT])
		do
			f := a_f
			update_memory_field ("f")
		end

	set_fval (a_fval: REAL_64)
		do
			fval := a_fval
			update_memory_field ("fval")
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_size (a_size: REAL_64)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			f := a_other.f
			fval := a_other.fval
			x := a_other.x
			size := a_other.size
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				f.is_equal (a_other.f) and
				fval = a_other.fval and
				x.is_equal (a_other.x) and
				size = a_other.size and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("fval"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
