class
	PD_GSL_MULTIMIN_FMINIMIZER_TYPE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create alloc.make
			create set.make
			create iterate.make
			create free.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	size: NATURAL_32 assign set_size

	alloc: CE_ROUTINE assign set_alloc

	set: CE_ROUTINE assign set_set

	iterate: CE_ROUTINE assign set_iterate

	free: CE_ROUTINE assign set_free

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_set (a_set: CE_ROUTINE)
		do
			set := a_set
			update_memory_field ("set")
		end

	set_iterate (a_iterate: CE_ROUTINE)
		do
			iterate := a_iterate
			update_memory_field ("iterate")
		end

	set_free (a_free: CE_ROUTINE)
		do
			free := a_free
			update_memory_field ("free")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			size := a_other.size
			alloc := a_other.alloc
			set := a_other.set
			iterate := a_other.iterate
			free := a_other.free
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				size = a_other.size and
				alloc.is_equal (a_other.alloc) and
				set.is_equal (a_other.set) and
				iterate.is_equal (a_other.iterate) and
				free.is_equal (a_other.free)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("set"),
					create {CE_STRUCTURE_FIELD}.make ("iterate"),
					create {CE_STRUCTURE_FIELD}.make ("free")
				>>)
			init_structure_info
		end

end
