class
	PD_GSL_ODEIV_STEP_TYPE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create alloc.make
			create apply.make
			create reset.make
			create order.make
			create free.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	can_use_dydt_in: INTEGER_32 assign set_can_use_dydt_in

	gives_exact_dydt_out: INTEGER_32 assign set_gives_exact_dydt_out

	alloc: CE_ROUTINE assign set_alloc

	apply: CE_ROUTINE assign set_apply

	reset: CE_ROUTINE assign set_reset

	order: CE_ROUTINE assign set_order

	free: CE_ROUTINE assign set_free

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_can_use_dydt_in (a_can_use_dydt_in: INTEGER_32)
		do
			can_use_dydt_in := a_can_use_dydt_in
			update_memory_field ("can_use_dydt_in")
		end

	set_gives_exact_dydt_out (a_gives_exact_dydt_out: INTEGER_32)
		do
			gives_exact_dydt_out := a_gives_exact_dydt_out
			update_memory_field ("gives_exact_dydt_out")
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_apply (a_apply: CE_ROUTINE)
		do
			apply := a_apply
			update_memory_field ("apply")
		end

	set_reset (a_reset: CE_ROUTINE)
		do
			reset := a_reset
			update_memory_field ("reset")
		end

	set_order (a_order: CE_ROUTINE)
		do
			order := a_order
			update_memory_field ("order")
		end

	set_free (a_free: CE_ROUTINE)
		do
			free := a_free
			update_memory_field ("free")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			can_use_dydt_in := a_other.can_use_dydt_in
			gives_exact_dydt_out := a_other.gives_exact_dydt_out
			alloc := a_other.alloc
			apply := a_other.apply
			reset := a_other.reset
			order := a_other.order
			free := a_other.free
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				can_use_dydt_in = a_other.can_use_dydt_in and
				gives_exact_dydt_out = a_other.gives_exact_dydt_out and
				alloc.is_equal (a_other.alloc) and
				apply.is_equal (a_other.apply) and
				reset.is_equal (a_other.reset) and
				order.is_equal (a_other.order) and
				free.is_equal (a_other.free)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("can_use_dydt_in"),
					create {CE_STRUCTURE_FIELD}.make ("gives_exact_dydt_out"),
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("apply"),
					create {CE_STRUCTURE_FIELD}.make ("reset"),
					create {CE_STRUCTURE_FIELD}.make ("order"),
					create {CE_STRUCTURE_FIELD}.make ("free")
				>>)
			init_structure_info
		end

end
