class
	PD_GSL_QRNG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_QRNG_TYPE] assign set_type

	dimension: NATURAL_32 assign set_dimension

	state_size: NATURAL_32 assign set_state_size

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_QRNG_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_dimension (a_dimension: NATURAL_32)
		do
			dimension := a_dimension
			update_memory_field ("dimension")
		end

	set_state_size (a_state_size: NATURAL_32)
		do
			state_size := a_state_size
			update_memory_field ("state_size")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			dimension := a_other.dimension
			state_size := a_other.state_size
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				dimension = a_other.dimension and
				state_size = a_other.state_size and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("dimension"),
					create {CE_STRUCTURE_FIELD}.make ("state_size"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
