class
	PD_GSL_QRNG_TYPE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create state_size.make
			create init_state.make
			create get.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	max_dimension: NATURAL_32 assign set_max_dimension

	state_size: CE_ROUTINE assign set_state_size

	init_state: CE_ROUTINE assign set_init_state

	get: CE_ROUTINE assign set_get

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_max_dimension (a_max_dimension: NATURAL_32)
		do
			max_dimension := a_max_dimension
			update_memory_field ("max_dimension")
		end

	set_state_size (a_state_size: CE_ROUTINE)
		do
			state_size := a_state_size
			update_memory_field ("state_size")
		end

	set_init_state (a_init_state: CE_ROUTINE)
		do
			init_state := a_init_state
			update_memory_field ("init_state")
		end

	set_get (a_get: CE_ROUTINE)
		do
			get := a_get
			update_memory_field ("get")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			max_dimension := a_other.max_dimension
			state_size := a_other.state_size
			init_state := a_other.init_state
			get := a_other.get
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				max_dimension = a_other.max_dimension and
				state_size.is_equal (a_other.state_size) and
				init_state.is_equal (a_other.init_state) and
				get.is_equal (a_other.get)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("max_dimension"),
					create {CE_STRUCTURE_FIELD}.make ("state_size"),
					create {CE_STRUCTURE_FIELD}.make ("init_state"),
					create {CE_STRUCTURE_FIELD}.make ("get")
				>>)
			init_structure_info
		end

end
