class
	PD_GSL_RNG_TYPE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create set.make
			create get.make
			create get_double.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	max: NATURAL_32 assign set_max

	min: NATURAL_32 assign set_min

	size: NATURAL_32 assign set_size

	set: CE_ROUTINE assign set_set

	get: CE_ROUTINE assign set_get

	get_double: CE_ROUTINE assign set_get_double

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_max (a_max: NATURAL_32)
		do
			max := a_max
			update_memory_field ("max")
		end

	set_min (a_min: NATURAL_32)
		do
			min := a_min
			update_memory_field ("min")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_set (a_set: CE_ROUTINE)
		do
			set := a_set
			update_memory_field ("set")
		end

	set_get (a_get: CE_ROUTINE)
		do
			get := a_get
			update_memory_field ("get")
		end

	set_get_double (a_get_double: CE_ROUTINE)
		do
			get_double := a_get_double
			update_memory_field ("get_double")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			max := a_other.max
			min := a_other.min
			size := a_other.size
			set := a_other.set
			get := a_other.get
			get_double := a_other.get_double
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				max = a_other.max and
				min = a_other.min and
				size = a_other.size and
				set.is_equal (a_other.set) and
				get.is_equal (a_other.get) and
				get_double.is_equal (a_other.get_double)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("max"),
					create {CE_STRUCTURE_FIELD}.make ("min"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("set"),
					create {CE_STRUCTURE_FIELD}.make ("get"),
					create {CE_STRUCTURE_FIELD}.make ("get_double")
				>>)
			init_structure_info
		end

end
