class
	PD_GSL_SIMAN_PARAMS_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	n_tries: INTEGER_32 assign set_n_tries

	iters_fixed_T: INTEGER_32 assign set_iters_fixed_T

	step_size: REAL_64 assign set_step_size

	k: REAL_64 assign set_k

	t_initial: REAL_64 assign set_t_initial

	mu_t: REAL_64 assign set_mu_t

	t_min: REAL_64 assign set_t_min

feature {ANY} -- setters

	set_n_tries (a_n_tries: INTEGER_32)
		do
			n_tries := a_n_tries
			update_memory_field ("n_tries")
		end

	set_iters_fixed_T (a_iters_fixed_T: INTEGER_32)
		do
			iters_fixed_T := a_iters_fixed_T
			update_memory_field ("iters_fixed_T")
		end

	set_step_size (a_step_size: REAL_64)
		do
			step_size := a_step_size
			update_memory_field ("step_size")
		end

	set_k (a_k: REAL_64)
		do
			k := a_k
			update_memory_field ("k")
		end

	set_t_initial (a_t_initial: REAL_64)
		do
			t_initial := a_t_initial
			update_memory_field ("t_initial")
		end

	set_mu_t (a_mu_t: REAL_64)
		do
			mu_t := a_mu_t
			update_memory_field ("mu_t")
		end

	set_t_min (a_t_min: REAL_64)
		do
			t_min := a_t_min
			update_memory_field ("t_min")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n_tries := a_other.n_tries
			iters_fixed_T := a_other.iters_fixed_T
			step_size := a_other.step_size
			k := a_other.k
			t_initial := a_other.t_initial
			mu_t := a_other.mu_t
			t_min := a_other.t_min
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n_tries = a_other.n_tries and
				iters_fixed_T = a_other.iters_fixed_T and
				step_size = a_other.step_size and
				k = a_other.k and
				t_initial = a_other.t_initial and
				mu_t = a_other.mu_t and
				t_min = a_other.t_min
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n_tries"),
					create {CE_STRUCTURE_FIELD}.make ("iters_fixed_T"),
					create {CE_STRUCTURE_FIELD}.make ("step_size"),
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("t_initial"),
					create {CE_STRUCTURE_FIELD}.make ("mu_t"),
					create {CE_STRUCTURE_FIELD}.make ("t_min")
				>>)
			init_structure_info
		end

end
