class
	PD_GSL_SPLINE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create interp.make
			create x.make
			create y.make
		end

feature {ANY} -- fields

	interp: CE_POINTER [PD_GSL_INTERP] assign set_interp

	x: CE_POINTER [REAL_64] assign set_x

	y: CE_POINTER [REAL_64] assign set_y

	size: NATURAL_32 assign set_size

feature {ANY} -- setters

	set_interp (a_interp: CE_POINTER [PD_GSL_INTERP])
		do
			interp := a_interp
			update_memory_field ("interp")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: CE_POINTER [REAL_64])
		do
			y := a_y
			update_memory_field ("y")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			interp := a_other.interp
			x := a_other.x
			y := a_other.y
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				interp.is_equal (a_other.interp) and
				x.is_equal (a_other.x) and
				y.is_equal (a_other.y) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("interp"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
