class
	PD_POLYNOMIAL_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create d.make
			create coeff.make
			create work.make
		end

feature {ANY} -- fields

	d: CE_POINTER [REAL_64] assign set_d

	coeff: CE_POINTER [REAL_64] assign set_coeff

	work: CE_POINTER [REAL_64] assign set_work

feature {ANY} -- setters

	set_d (a_d: CE_POINTER [REAL_64])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_coeff (a_coeff: CE_POINTER [REAL_64])
		do
			coeff := a_coeff
			update_memory_field ("coeff")
		end

	set_work (a_work: CE_POINTER [REAL_64])
		do
			work := a_work
			update_memory_field ("work")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			coeff := a_other.coeff
			work := a_other.work
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d.is_equal (a_other.d) and
				coeff.is_equal (a_other.coeff) and
				work.is_equal (a_other.work)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("coeff"),
					create {CE_STRUCTURE_FIELD}.make ("work")
				>>)
			init_structure_info
		end

end
