class
	PD_RAN3_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buffer.make (<<56>>)
		end

feature {ANY} -- fields

	x: NATURAL_32 assign set_x

	y: NATURAL_32 assign set_y

	buffer: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_x (a_x: NATURAL_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: NATURAL_32)
		do
			y := a_y
			update_memory_field ("y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
			buffer := a_other.buffer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y and
				buffer.is_equal (a_other.buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<56>>)
				>>)
			init_structure_info
		end

end
