class
	PD_RK2SIMP_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create Y1.make
			create y0.make
			create y0_orig.make
			create ytmp.make
			create dfdy.make
			create dfdt.make
			create y_onestep.make
			create p.make
		end

feature {ANY} -- fields

	Y1: CE_POINTER [REAL_64] assign set_Y1

	y0: CE_POINTER [REAL_64] assign set_y0

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

	dfdy: CE_POINTER [REAL_64] assign set_dfdy

	dfdt: CE_POINTER [REAL_64] assign set_dfdt

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep

	p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_p

feature {ANY} -- setters

	set_Y1 (a_Y1: CE_POINTER [REAL_64])
		do
			Y1 := a_Y1
			update_memory_field ("Y1")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			y0_orig := a_y0_orig
			update_memory_field ("y0_orig")
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

	set_dfdy (a_dfdy: CE_POINTER [REAL_64])
		do
			dfdy := a_dfdy
			update_memory_field ("dfdy")
		end

	set_dfdt (a_dfdt: CE_POINTER [REAL_64])
		do
			dfdt := a_dfdt
			update_memory_field ("dfdt")
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			y_onestep := a_y_onestep
			update_memory_field ("y_onestep")
		end

	set_p (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			p := a_p
			update_memory_field ("p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Y1 := a_other.Y1
			y0 := a_other.y0
			y0_orig := a_other.y0_orig
			ytmp := a_other.ytmp
			dfdy := a_other.dfdy
			dfdt := a_other.dfdt
			y_onestep := a_other.y_onestep
			p := a_other.p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Y1.is_equal (a_other.Y1) and
				y0.is_equal (a_other.y0) and
				y0_orig.is_equal (a_other.y0_orig) and
				ytmp.is_equal (a_other.ytmp) and
				dfdy.is_equal (a_other.dfdy) and
				dfdt.is_equal (a_other.dfdt) and
				y_onestep.is_equal (a_other.y_onestep) and
				p.is_equal (a_other.p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("Y1"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("y0_orig"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp"),
					create {CE_STRUCTURE_FIELD}.make ("dfdy"),
					create {CE_STRUCTURE_FIELD}.make ("dfdt"),
					create {CE_STRUCTURE_FIELD}.make ("y_onestep"),
					create {CE_STRUCTURE_FIELD}.make ("p")
				>>)
			init_structure_info
		end

end
