class
	PD_RK4IMP_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create k1nu.make
			create k2nu.make
			create ytmp1.make
			create ytmp2.make
			create y0.make
			create y0_orig.make
			create y_onestep.make
		end

feature {ANY} -- fields

	k1nu: CE_POINTER [REAL_64] assign set_k1nu

	k2nu: CE_POINTER [REAL_64] assign set_k2nu

	ytmp1: CE_POINTER [REAL_64] assign set_ytmp1

	ytmp2: CE_POINTER [REAL_64] assign set_ytmp2

	y0: CE_POINTER [REAL_64] assign set_y0

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep

feature {ANY} -- setters

	set_k1nu (a_k1nu: CE_POINTER [REAL_64])
		do
			k1nu := a_k1nu
			update_memory_field ("k1nu")
		end

	set_k2nu (a_k2nu: CE_POINTER [REAL_64])
		do
			k2nu := a_k2nu
			update_memory_field ("k2nu")
		end

	set_ytmp1 (a_ytmp1: CE_POINTER [REAL_64])
		do
			ytmp1 := a_ytmp1
			update_memory_field ("ytmp1")
		end

	set_ytmp2 (a_ytmp2: CE_POINTER [REAL_64])
		do
			ytmp2 := a_ytmp2
			update_memory_field ("ytmp2")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			y0_orig := a_y0_orig
			update_memory_field ("y0_orig")
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			y_onestep := a_y_onestep
			update_memory_field ("y_onestep")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k1nu := a_other.k1nu
			k2nu := a_other.k2nu
			ytmp1 := a_other.ytmp1
			ytmp2 := a_other.ytmp2
			y0 := a_other.y0
			y0_orig := a_other.y0_orig
			y_onestep := a_other.y_onestep
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k1nu.is_equal (a_other.k1nu) and
				k2nu.is_equal (a_other.k2nu) and
				ytmp1.is_equal (a_other.ytmp1) and
				ytmp2.is_equal (a_other.ytmp2) and
				y0.is_equal (a_other.y0) and
				y0_orig.is_equal (a_other.y0_orig) and
				y_onestep.is_equal (a_other.y_onestep)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k1nu"),
					create {CE_STRUCTURE_FIELD}.make ("k2nu"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp1"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp2"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("y0_orig"),
					create {CE_STRUCTURE_FIELD}.make ("y_onestep")
				>>)
			init_structure_info
		end

end
