class
	PD_U3

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	d: REAL_64 assign set_d

	b: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_d (a_d: REAL_64)
		do
			d := a_d
			update_memory_field ("d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			b := a_other.b.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d = a_other.d and
				b.is_equal (a_other.b)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b", <<8>>)
				>>)
			init_structure_info
		end

end
