class
	PD_VECTOR_BFGS2_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x0.make
			create g0.make
			create p.make
			create dx0.make
			create dg0.make
			create x_alpha.make
			create g_alpha.make
			create wrap.make
		end

feature {ANY} -- fields

	iter: INTEGER_32 assign set_iter

	step: REAL_64 assign set_step

	g0norm: REAL_64 assign set_g0norm

	pnorm: REAL_64 assign set_pnorm

	delta_f: REAL_64 assign set_delta_f

	fp0: REAL_64 assign set_fp0

	x0: CE_POINTER [PD_GSL_VECTOR] assign set_x0

	g0: CE_POINTER [PD_GSL_VECTOR] assign set_g0

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p

	dx0: CE_POINTER [PD_GSL_VECTOR] assign set_dx0

	dg0: CE_POINTER [PD_GSL_VECTOR] assign set_dg0

	x_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_x_alpha

	g_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_g_alpha

	wrap: PD_WRAPPER_T assign set_wrap

	rho: REAL_64 assign set_rho

	sigma: REAL_64 assign set_sigma

	tau1: REAL_64 assign set_tau1

	tau2: REAL_64 assign set_tau2

	tau3: REAL_64 assign set_tau3

	order: INTEGER_32 assign set_order

feature {ANY} -- setters

	set_iter (a_iter: INTEGER_32)
		do
			iter := a_iter
			update_memory_field ("iter")
		end

	set_step (a_step: REAL_64)
		do
			step := a_step
			update_memory_field ("step")
		end

	set_g0norm (a_g0norm: REAL_64)
		do
			g0norm := a_g0norm
			update_memory_field ("g0norm")
		end

	set_pnorm (a_pnorm: REAL_64)
		do
			pnorm := a_pnorm
			update_memory_field ("pnorm")
		end

	set_delta_f (a_delta_f: REAL_64)
		do
			delta_f := a_delta_f
			update_memory_field ("delta_f")
		end

	set_fp0 (a_fp0: REAL_64)
		do
			fp0 := a_fp0
			update_memory_field ("fp0")
		end

	set_x0 (a_x0: CE_POINTER [PD_GSL_VECTOR])
		do
			x0 := a_x0
			update_memory_field ("x0")
		end

	set_g0 (a_g0: CE_POINTER [PD_GSL_VECTOR])
		do
			g0 := a_g0
			update_memory_field ("g0")
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_dx0 (a_dx0: CE_POINTER [PD_GSL_VECTOR])
		do
			dx0 := a_dx0
			update_memory_field ("dx0")
		end

	set_dg0 (a_dg0: CE_POINTER [PD_GSL_VECTOR])
		do
			dg0 := a_dg0
			update_memory_field ("dg0")
		end

	set_x_alpha (a_x_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			x_alpha := a_x_alpha
			update_memory_field ("x_alpha")
		end

	set_g_alpha (a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			g_alpha := a_g_alpha
			update_memory_field ("g_alpha")
		end

	set_wrap (a_wrap: PD_WRAPPER_T)
		do
			wrap := a_wrap
			update_memory_field ("wrap")
		end

	set_rho (a_rho: REAL_64)
		do
			rho := a_rho
			update_memory_field ("rho")
		end

	set_sigma (a_sigma: REAL_64)
		do
			sigma := a_sigma
			update_memory_field ("sigma")
		end

	set_tau1 (a_tau1: REAL_64)
		do
			tau1 := a_tau1
			update_memory_field ("tau1")
		end

	set_tau2 (a_tau2: REAL_64)
		do
			tau2 := a_tau2
			update_memory_field ("tau2")
		end

	set_tau3 (a_tau3: REAL_64)
		do
			tau3 := a_tau3
			update_memory_field ("tau3")
		end

	set_order (a_order: INTEGER_32)
		do
			order := a_order
			update_memory_field ("order")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			iter := a_other.iter
			step := a_other.step
			g0norm := a_other.g0norm
			pnorm := a_other.pnorm
			delta_f := a_other.delta_f
			fp0 := a_other.fp0
			x0 := a_other.x0
			g0 := a_other.g0
			p := a_other.p
			dx0 := a_other.dx0
			dg0 := a_other.dg0
			x_alpha := a_other.x_alpha
			g_alpha := a_other.g_alpha
			wrap := a_other.wrap.twin
			rho := a_other.rho
			sigma := a_other.sigma
			tau1 := a_other.tau1
			tau2 := a_other.tau2
			tau3 := a_other.tau3
			order := a_other.order
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				iter = a_other.iter and
				step = a_other.step and
				g0norm = a_other.g0norm and
				pnorm = a_other.pnorm and
				delta_f = a_other.delta_f and
				fp0 = a_other.fp0 and
				x0.is_equal (a_other.x0) and
				g0.is_equal (a_other.g0) and
				p.is_equal (a_other.p) and
				dx0.is_equal (a_other.dx0) and
				dg0.is_equal (a_other.dg0) and
				x_alpha.is_equal (a_other.x_alpha) and
				g_alpha.is_equal (a_other.g_alpha) and
				wrap.is_equal (a_other.wrap) and
				rho = a_other.rho and
				sigma = a_other.sigma and
				tau1 = a_other.tau1 and
				tau2 = a_other.tau2 and
				tau3 = a_other.tau3 and
				order = a_other.order
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("iter"),
					create {CE_STRUCTURE_FIELD}.make ("step"),
					create {CE_STRUCTURE_FIELD}.make ("g0norm"),
					create {CE_STRUCTURE_FIELD}.make ("pnorm"),
					create {CE_STRUCTURE_FIELD}.make ("delta_f"),
					create {CE_STRUCTURE_FIELD}.make ("fp0"),
					create {CE_STRUCTURE_FIELD}.make ("x0"),
					create {CE_STRUCTURE_FIELD}.make ("g0"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("dx0"),
					create {CE_STRUCTURE_FIELD}.make ("dg0"),
					create {CE_STRUCTURE_FIELD}.make ("x_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("g_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("wrap"),
					create {CE_STRUCTURE_FIELD}.make ("rho"),
					create {CE_STRUCTURE_FIELD}.make ("sigma"),
					create {CE_STRUCTURE_FIELD}.make ("tau1"),
					create {CE_STRUCTURE_FIELD}.make ("tau2"),
					create {CE_STRUCTURE_FIELD}.make ("tau3"),
					create {CE_STRUCTURE_FIELD}.make ("order")
				>>)
			init_structure_info
		end

end
