class
	P_BALANCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	balance_companion_matrix (a_m___4: CE_POINTER [REAL_64]; a_nc: NATURAL_32)
		local
			l_not_converged: INTEGER_32
			l_row_norm: REAL_64
			l_col_norm: REAL_64
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_g: REAL_64
			l_f: REAL_64
			l_s: REAL_64
			l_tmp___0: REAL_64
			js: JUMP_STATE
		do
			l_not_converged := 1
			l_row_norm := (0).to_double
			l_col_norm := (0).to_double
			from
			until
				not (not js.loop_done and then (l_not_converged.to_boolean))
			loop
				l_not_converged := 0
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_nc))
				loop
					if l_i /= a_nc - {NATURAL_32} 1 then
						l_col_norm := fabs (a_m___4[((l_i + {NATURAL_32} 1) * a_nc + l_i).to_integer_32])
					else
						l_col_norm := (0).to_double
						l_j := (0).to_natural_32
						from
						until
							not (l_j < a_nc - {NATURAL_32} 1)
						loop
							l_col_norm := l_col_norm + (fabs (a_m___4[(l_j * a_nc + (a_nc - {NATURAL_32} 1)).to_integer_32]))
							l_j := l_j + 1
						end
					end
					if l_i = {NATURAL_32} 0 then
						l_row_norm := fabs (a_m___4[(a_nc - {NATURAL_32} 1).to_integer_32])
					elseif l_i = a_nc - {NATURAL_32} 1 then
						l_row_norm := fabs (a_m___4[(l_i * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32])
					else
						l_tmp___0 := fabs (a_m___4[(l_i * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32])
						l_row_norm := l_tmp___0 + (fabs (a_m___4[(l_i * a_nc + (a_nc - {NATURAL_32} 1)).to_integer_32]))
					end
					if l_col_norm = (0).to_double then
						js.continue
					elseif l_row_norm = (0).to_double then
						js.continue
					end
					if not js.loop_jumped then
						l_g := l_row_norm / (2).to_double
						l_f := (1).to_double
						l_s := l_col_norm + l_row_norm
						from
						until
							not (l_col_norm < l_g)
						loop
							l_f := l_f * (2).to_double
							l_col_norm := l_col_norm * (4).to_double
						end
						l_g := l_row_norm * (2).to_double
						from
						until
							not (l_col_norm > l_g)
						loop
							l_f := l_f / (2).to_double
							l_col_norm := l_col_norm / (4).to_double
						end
						if l_row_norm + l_col_norm < (0.95 * l_s) * l_f then
							l_not_converged := 1
							l_g := (1).to_double / l_f
							if l_i = {NATURAL_32} 0 then
								a_m___4[(a_nc - {NATURAL_32} 1).to_integer_32] := a_m___4[(a_nc - {NATURAL_32} 1).to_integer_32] * l_g
							else
								a_m___4[(l_i * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32] := a_m___4[(l_i * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32] * l_g
								a_m___4[(l_i * a_nc + (a_nc - {NATURAL_32} 1)).to_integer_32] := a_m___4[(l_i * a_nc + (a_nc - {NATURAL_32} 1)).to_integer_32] * l_g
							end
							if l_i = a_nc - {NATURAL_32} 1 then
								l_j := (0).to_natural_32
								from
								until
									not (l_j < a_nc)
								loop
									a_m___4[(l_j * a_nc + l_i).to_integer_32] := a_m___4[(l_j * a_nc + l_i).to_integer_32] * l_f
									l_j := l_j + 1
								end
							else
								a_m___4[((l_i + {NATURAL_32} 1) * a_nc + l_i).to_integer_32] := a_m___4[((l_i + {NATURAL_32} 1) * a_nc + l_i).to_integer_32] * l_f
							end
						end
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
			end
		end

	gsl_linalg_balance_columns (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_D: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_j: NATURAL_32
			l_A_j: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_s: REAL_64
			l_f: REAL_64
			js: JUMP_STATE
		do
			create l_A_j.make (<<1>>)

			l_N := a_A___0.item.size2
			if a_D.item.size /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of D must match second dimension of A"), ce_string ("balance.c"), 44, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				init_source_inst.gsl_vector_set_all (a_D, 1.0)
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_N))
				loop
					l_A_j.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_j)).twin
					l_s := (blas_inst.gsl_blas_dasum ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_A_j.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))))
					l_f := 1.0
					if l_s = 0.0 then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_D, l_j, l_f)
						js.continue
					elseif not (infnan_inst.gsl_finite (l_s)).to_boolean then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_D, l_j, l_f)
						js.continue
					end
					if not js.loop_jumped then
						from
						until
							not (l_s > 1.0)
						loop
							l_s := l_s / (2.0)
							l_f := l_f * (2.0)
						end
						from
						until
							not (l_s < 0.5)
						loop
							l_s := l_s * (2.0)
							l_f := l_f / (2.0)
						end
						gsl_gsl_vector_double_inst.gsl_vector_set (a_D, l_j, l_f)
						if l_f /= 1.0 then
							blas_inst.gsl_blas_dscal (1.0 / l_f, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_A_j.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
						end
					end
					if js.loop_increment then
						l_j := l_j + 1
					end
				end
				Result := 0
			end
		end

end
