class
	P_BERNOULLI

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_bernoulli (a_r___3: CE_POINTER [PD_GSL_RNG]; a_p: REAL_64): NATURAL_32
		local
			l_u: REAL_64
		do
			l_u := (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
			if l_u < a_p then
				Result := {NATURAL_32} 1
			else
				Result := {NATURAL_32} 0
			end
		end

	gsl_ran_bernoulli_pdf (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		do
			if a_k = {NATURAL_32} 0 then
				Result := ((1).to_double - a_p)
			elseif a_k = {NATURAL_32} 1 then
				Result := a_p
			else
				Result := (0).to_double
			end
		end

end
