class
	P_BESSEL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	debye_u1 (a_tpow: CE_POINTER [REAL_64]): REAL_64
		do
			Result := ((3.0 * a_tpow[1] - 5.0 * a_tpow[3]) / 24.0)
		end

	debye_u2 (a_tpow: CE_POINTER [REAL_64]): REAL_64
		do
			Result := (((81.0 * a_tpow[2] - 462.0 * a_tpow[4]) + 385.0 * a_tpow[6]) / 1152.0)
		end

	debye_u3 (a_tpow: CE_POINTER [REAL_64]): REAL_64
		do
			Result := ((((30375.0 * a_tpow[3] - 369603.0 * a_tpow[5]) + 765765.0 * a_tpow[7]) - 425425.0 * a_tpow[9]) / 414720.0)
		end

	debye_u4 (a_tpow: CE_POINTER [REAL_64]): REAL_64
		do
			Result := (((((4465125.0 * a_tpow[4] - 94121676.0 * a_tpow[6]) + 349922430.0 * a_tpow[8]) - 446185740.0 * a_tpow[10]) + 185910725.0 * a_tpow[12]) / 39813120.0)
		end

	debye_u5 (a_tpow: CE_POINTER [REAL_64]): REAL_64
		do
			Result := ((((((1519035525.0 * a_tpow[5] - 49286948607.0 * a_tpow[7]) + 284499769554.0 * a_tpow[9]) - 614135872350.0 * a_tpow[11]) + 566098157625.0 * a_tpow[13]) - 188699385875.0 * a_tpow[15]) / 6688604160.0)
		end

	gsl_sf_bessel_IJ_taylor_e (a_nu: REAL_64; a_x: REAL_64; a_sign: INTEGER_32; a_kmax___0: INTEGER_32; a_threshold: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_prefactor: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sum: PD_GSL_SF_RESULT_STRUCT
			l_stat_pre: INTEGER_32
			l_stat_sum: INTEGER_32
			l_stat_mul: INTEGER_32
			l_N: INTEGER_32
			l_f: REAL_64
			l_poch_factor: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tc_factor: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_poch: INTEGER_32
			l_stat_tc: INTEGER_32
			l_p: REAL_64
			l_tmp___7: INTEGER_32
			l_lg: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_lg: INTEGER_32
			l_term1: REAL_64
			l_term2: REAL_64
			l_ln_pre: REAL_64
			l_ln_pre_err: REAL_64
			l_tmp___10: REAL_64
			l_stat_ex: INTEGER_32
			l_tmp___13: INTEGER_32
			l_y: REAL_64
			l_sumk: REAL_64
			l_term: REAL_64
			l_k: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_prefactor.make (<<1>>)
			create l_sum.make
			create l_poch_factor.make (<<1>>)
			create l_tc_factor.make (<<1>>)
			create l_lg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nu < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel.c"), 102, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							if a_nu = 0.0 then
								a_result.item.val := 1.0
								a_result.item.err := 0.0
							else
								a_result.item.val := 0.0
								a_result.item.err := 0.0
							end
							Result := 0
							js.return
						else
							if a_nu = 0.0 then
								l_prefactor.item.val := 1.0
								l_prefactor.item.err := 0.0
								l_stat_pre := 0
							elseif a_nu < (2_147_483_646).to_double then
								l_N := (floor (a_nu + 0.5)).truncated_to_integer
								l_f := a_nu - l_N.to_double
								l_stat_poch := (poch_inst.gsl_sf_poch_e (l_N.to_double + 1.0, l_f, l_poch_factor))
								l_stat_tc := (gamma_inst.gsl_sf_taylorcoeff_e (l_N, 0.5 * a_x, l_tc_factor))
								l_p := (pow (0.5 * a_x, l_f))
								l_prefactor.item.val := (l_tc_factor.item.val * l_p) / l_poch_factor.item.val
								l_prefactor.item.err := (l_tc_factor.item.err * l_p) / l_poch_factor.item.val
								l_prefactor.item.err := l_prefactor.item.err + (((fabs (l_prefactor.item.val)) / l_poch_factor.item.val) * l_poch_factor.item.err)
								l_prefactor.item.err := l_prefactor.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_prefactor.item.val)))
								if l_stat_tc /= 0 then
									l_stat_pre := l_stat_tc
								else
									if l_stat_poch /= 0 then
										l_tmp___7 := l_stat_poch
									else
										l_tmp___7 := 0
									end
									l_stat_pre := l_tmp___7
								end
							else
								l_stat_lg := (gamma_inst.gsl_sf_lngamma_e (a_nu + 1.0, l_lg))
								l_term1 := a_nu * (log (0.5 * a_x))
								l_term2 := l_lg.item.val
								l_ln_pre := l_term1 - l_term2
								l_tmp___10 := fabs (l_term1)
								l_ln_pre_err := 2.2204460492503131e-16 * (l_tmp___10 + (fabs (l_term2))) + l_lg.item.err
								l_stat_ex := (exp_inst.gsl_sf_exp_err_e (l_ln_pre, l_ln_pre_err, l_prefactor))
								if l_stat_ex /= 0 then
									l_stat_pre := l_stat_ex
								else
									if l_stat_lg /= 0 then
										l_tmp___13 := l_stat_lg
									else
										l_tmp___13 := 0
									end
									l_stat_pre := l_tmp___13
								end
							end
							l_y := ((a_sign.to_double * 0.25) * a_x) * a_x
							l_sumk := 1.0
							l_term := 1.0
							l_k := 1
							from
							until
								not (not js.loop_done and then (l_k <= a_kmax___0))
							loop
								l_term := l_term * (l_y / ((a_nu + l_k.to_double) * l_k.to_double))
								l_sumk := l_sumk + l_term
								if (fabs (l_term / l_sumk)) < a_threshold then
									js.break
								end
								if not js.loop_jumped then
									l_k := l_k + 1
								end
							end
							l_sum.val := l_sumk
							l_sum.err := a_threshold * (fabs (l_sumk))
							if l_k >= a_kmax___0 then
								l_stat_sum := 11
							else
								l_stat_sum := 0
							end
							l_stat_mul := elementary_inst.gsl_sf_multiply_err_e (l_prefactor.item.val, l_prefactor.item.err, l_sum.val, l_sum.err, a_result)
							if l_stat_mul /= 0 then
								l_tmp___18 := l_stat_mul
							else
								if l_stat_pre /= 0 then
									l_tmp___17 := l_stat_pre
								else
									if l_stat_sum /= 0 then
										l_tmp___16 := l_stat_sum
									else
										l_tmp___16 := 0
									end
									l_tmp___17 := l_tmp___16
								end
								l_tmp___18 := l_tmp___17
							end
							Result := l_tmp___18
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_I_CF1_ser (a_nu: REAL_64; a_x: REAL_64; a_ratio: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_maxk: INTEGER_32
			l_tk: REAL_64
			l_sum: REAL_64
			l_rhok: REAL_64
			l_k: INTEGER_32
			l_ak: REAL_64
			js: JUMP_STATE
		do
			l_maxk := 20_000
			l_tk := 1.0
			l_sum := 1.0
			l_rhok := 0.0
			l_k := 1
			from
			until
				not (not js.loop_done and then (l_k < l_maxk))
			loop
				l_ak := ((0.25 * (a_x / (a_nu + l_k.to_double))) * a_x) / ((a_nu + l_k.to_double) + 1.0)
				l_rhok := (-l_ak * (1.0 + l_rhok)) / (1.0 + l_ak * (1.0 + l_rhok))
				l_tk := l_tk * l_rhok
				l_sum := l_sum + l_tk
				if (fabs (l_tk / l_sum)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_k := l_k + 1
				end
			end
			a_ratio.item := (a_x / (2.0 * (a_nu + 1.0))) * l_sum
			if l_k = l_maxk then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("bessel.c"), 656, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_Inu_scaled_asymp_unif_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_i: INTEGER_32
			l_z: REAL_64
			l_root_term: REAL_64
			l_pre: REAL_64
			l_eta: REAL_64
			l_ex_arg: REAL_64
			l_tmp___2: REAL_64
			l_ex_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_ex: INTEGER_32
			l_t: REAL_64
			l_sum: REAL_64
			l_tpow: CE_ARRAY [REAL_64]
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___7: REAL_64
		do
			create l_ex_result.make (<<1>>)
			create l_tpow.make (<<16>>)

			l_z := a_x / a_nu
			l_root_term := (hypot (1.0, l_z))
			l_pre := 1.0 / (sqrt (((2.0 * 3.14159265358979323846) * a_nu) * l_root_term))
			l_eta := l_root_term + (log (l_z / (1.0 + l_root_term)))
			if l_z < 1.0 / 6.0554544523933429e-06 then
				l_tmp___2 := a_nu * (-l_z + l_eta)
			else
				l_tmp___2 := ((-0.5 * a_nu) / l_z) * (1.0 - 1.0 / ((12.0 * l_z) * l_z))
			end
			l_ex_arg := l_tmp___2
			l_stat_ex := (exp_inst.gsl_sf_exp_e (l_ex_arg, l_ex_result))
			if l_stat_ex = 0 then
				l_t := 1.0 / l_root_term
				l_tpow[0] := 1.0
				l_i := 1
				from
				until
					not (l_i < 16)
				loop
					l_tpow[l_i] := l_t * l_tpow[l_i - 1]
					l_i := l_i + 1
				end
				l_tmp___4 := debye_u1 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_tmp___5 := debye_u2 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_tmp___6 := debye_u3 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_tmp___7 := debye_u4 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_sum := ((((1.0 + l_tmp___4 / a_nu) + l_tmp___5 / (a_nu * a_nu)) + l_tmp___6 / ((a_nu * a_nu) * a_nu)) + l_tmp___7 / (((a_nu * a_nu) * a_nu) * a_nu)) + (debye_u5 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))) / ((((a_nu * a_nu) * a_nu) * a_nu) * a_nu)
				a_result.item.val := (l_pre * l_ex_result.item.val) * l_sum
				a_result.item.err := (l_pre * l_ex_result.item.val) / (((((a_nu * a_nu) * a_nu) * a_nu) * a_nu) * a_nu)
				a_result.item.err := a_result.item.err + ((l_pre * l_ex_result.item.err) * (fabs (l_sum)))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			else
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := l_stat_ex
			end
		end

	gsl_sf_bessel_Inu_scaled_asympx_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mu: REAL_64
			l_mum1: REAL_64
			l_mum9: REAL_64
			l_pre: REAL_64
			l_r___3: REAL_64
			l_tmp___0: REAL_64
		do
			l_mu := (4.0 * a_nu) * a_nu
			l_mum1 := l_mu - 1.0
			l_mum9 := l_mu - 9.0
			l_pre := 1.0 / (sqrt ((2.0 * 3.14159265358979323846) * a_x))
			l_r___3 := l_mu / a_x
			a_result.item.val := l_pre * ((1.0 - l_mum1 / (8.0 * a_x)) + (l_mum1 * l_mum9) / ((128.0 * a_x) * a_x))
			l_tmp___0 := fabs (a_result.item.val)
			a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_tmp___0 + l_pre * (fabs (((0.1 * l_r___3) * l_r___3) * l_r___3))
			Result := 0
		end

	gsl_sf_bessel_JY_mu_restricted (a_mu: REAL_64; a_x: REAL_64; a_Jmu: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_Jmup1: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_Ymu: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_Ymup1: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_stat_Y: INTEGER_32
			l_stat_J: INTEGER_32
			l_Jmup2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_J1: INTEGER_32
			l_stat_J2: INTEGER_32
			l_c___1: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_P___2: CE_ARRAY [REAL_64]
			l_Q___1: CE_ARRAY [REAL_64]
			l_J_ratio: CE_ARRAY [REAL_64]
			l_J_sgn: CE_ARRAY [REAL_64]
			l_stat_CF1: INTEGER_32
			l_stat_CF2: INTEGER_32
			l_Jprime_J_ratio: REAL_64
			l_gamma___0: REAL_64
			l_tmp___11: REAL_64
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_stat_J0: INTEGER_32
			l_stat_J1___0: INTEGER_32
			l_stat_Y0: INTEGER_32
			l_stat_Y1: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Jmup2.make (<<1>>)
			create l_P___2.make (<<1>>)
			create l_Q___1.make (<<1>>)
			create l_J_ratio.make (<<1>>)
			create l_J_sgn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((fabs (a_mu)) > 0.5) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						a_Jmu.item.val := 0.0
						a_Jmu.item.err := 0.0
						a_Jmup1.item.val := 0.0
						a_Jmup1.item.err := 0.0
						a_Ymu.item.val := 0.0
						a_Ymu.item.err := 0.0
						a_Ymup1.item.val := 0.0
						a_Ymup1.item.err := 0.0
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("error"), ce_string ("bessel.c"), 447, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							if a_mu = 0.0 then
								a_Jmu.item.val := 1.0
								a_Jmu.item.err := 0.0
							else
								a_Jmu.item.val := 0.0
								a_Jmu.item.err := 0.0
							end
							a_Jmup1.item.val := 0.0
							a_Jmup1.item.err := 0.0
							a_Ymu.item.val := 0.0
							a_Ymu.item.err := 0.0
							a_Ymup1.item.val := 0.0
							a_Ymup1.item.err := 0.0
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("error"), ce_string ("bessel.c"), 464, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
						elseif a_x < 2.0 then
							l_stat_J1 := (gsl_sf_bessel_IJ_taylor_e (a_mu + 1.0, a_x, -1, 100, 2.2204460492503131e-16, a_Jmup1))
							l_stat_J2 := (gsl_sf_bessel_IJ_taylor_e (a_mu + 2.0, a_x, -1, 100, 2.2204460492503131e-16, l_Jmup2))
							l_c___1 := (2.0 * (a_mu + 1.0)) / a_x
							a_Jmu.item.val := l_c___1 * a_Jmup1.item.val - l_Jmup2.item.val
							a_Jmu.item.err := l_c___1 * a_Jmup1.item.err + l_Jmup2.item.err
							a_Jmu.item.err := a_Jmu.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_Jmu.item.val)))
							if l_stat_J1 /= 0 then
								l_stat_J := l_stat_J1
							else
								if l_stat_J2 /= 0 then
									l_tmp___2 := l_stat_J2
								else
									l_tmp___2 := 0
								end
								l_stat_J := l_tmp___2
							end
							l_stat_Y := bessel_temme_inst.gsl_sf_bessel_Y_temme (a_mu, a_x, a_Ymu, a_Ymup1)
							if l_stat_J /= 0 then
								l_tmp___4 := l_stat_J
							else
								if l_stat_Y /= 0 then
									l_tmp___3 := l_stat_Y
								else
									l_tmp___3 := 0
								end
								l_tmp___4 := l_tmp___3
							end
							Result := l_tmp___4
							js.return
						elseif a_x < 1000.0 then
							l_stat_CF1 := (gsl_sf_bessel_J_CF1 (a_mu, a_x, l_J_ratio, l_J_sgn))
							l_stat_CF2 := (gsl_sf_bessel_JY_steed_CF2 (a_mu, a_x, l_P___2, l_Q___1))
							l_Jprime_J_ratio := a_mu / a_x - l_J_ratio.item
							l_gamma___0 := (l_P___2.item - l_Jprime_J_ratio) / l_Q___1.item
							a_Jmu.item.val := l_J_sgn.item * (sqrt ((2.0 / (3.14159265358979323846 * a_x)) / (l_Q___1.item + l_gamma___0 * (l_P___2.item - l_Jprime_J_ratio))))
							a_Jmu.item.err := (4.0 * 2.2204460492503131e-16) * (fabs (a_Jmu.item.val))
							a_Jmup1.item.val := l_J_ratio.item * a_Jmu.item.val
							a_Jmup1.item.err := (fabs (l_J_ratio.item)) * a_Jmu.item.err
							a_Ymu.item.val := l_gamma___0 * a_Jmu.item.val
							a_Ymu.item.err := (fabs (l_gamma___0)) * a_Jmu.item.err
							a_Ymup1.item.val := a_Ymu.item.val * ((a_mu / a_x - l_P___2.item) - l_Q___1.item / l_gamma___0)
							l_tmp___11 := fabs ((a_mu / a_x - l_P___2.item) - l_Q___1.item / l_gamma___0)
							a_Ymup1.item.err := a_Ymu.item.err * l_tmp___11 + (4.0 * 2.2204460492503131e-16) * (fabs (a_Ymup1.item.val))
							if l_stat_CF1 /= 0 then
								l_tmp___14 := l_stat_CF1
							else
								if l_stat_CF2 /= 0 then
									l_tmp___13 := l_stat_CF2
								else
									l_tmp___13 := 0
								end
								l_tmp___14 := l_tmp___13
							end
							Result := l_tmp___14
							js.return
						else
							l_stat_J0 := (gsl_sf_bessel_Jnu_asympx_e (a_mu, a_x, a_Jmu))
							l_stat_J1___0 := (gsl_sf_bessel_Jnu_asympx_e (a_mu + 1.0, a_x, a_Jmup1))
							l_stat_Y0 := (gsl_sf_bessel_Ynu_asympx_e (a_mu, a_x, a_Ymu))
							l_stat_Y1 := (gsl_sf_bessel_Ynu_asympx_e (a_mu + 1.0, a_x, a_Ymup1))
							if l_stat_J0 /= 0 then
								l_stat_J := l_stat_J0
							else
								if l_stat_J1___0 /= 0 then
									l_tmp___19 := l_stat_J1___0
								else
									l_tmp___19 := 0
								end
								l_stat_J := l_tmp___19
							end
							if l_stat_Y0 /= 0 then
								l_stat_Y := l_stat_Y0
							else
								if l_stat_Y1 /= 0 then
									l_tmp___20 := l_stat_Y1
								else
									l_tmp___20 := 0
								end
								l_stat_Y := l_tmp___20
							end
							if l_stat_J /= 0 then
								l_tmp___22 := l_stat_J
							else
								if l_stat_Y /= 0 then
									l_tmp___21 := l_stat_Y
								else
									l_tmp___21 := 0
								end
								l_tmp___22 := l_tmp___21
							end
							Result := l_tmp___22
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_JY_steed_CF2 (a_nu: REAL_64; a_x: REAL_64; a_P___2: CE_POINTER [REAL_64]; a_Q___1: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_max_iter: INTEGER_32
			l_SMALL: REAL_64
			l_i: INTEGER_32
			l_x_inv: REAL_64
			l_a___5: REAL_64
			l_p: REAL_64
			l_q___3: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			l_fact: REAL_64
			l_cr: REAL_64
			l_ci: REAL_64
			l_den: REAL_64
			l_dr: REAL_64
			l_di: REAL_64
			l_dlr: REAL_64
			l_dli: REAL_64
			l_temp: REAL_64
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
		do
			l_max_iter := 10_000
			l_SMALL := 1.0e-100
			l_i := 1
			l_x_inv := 1.0 / a_x
			l_a___5 := 0.25 - a_nu * a_nu
			l_p := -0.5 * l_x_inv
			l_q___3 := 1.0
			l_br := 2.0 * a_x
			l_bi := 2.0
			l_fact := (l_a___5 * l_x_inv) / (l_p * l_p + l_q___3 * l_q___3)
			l_cr := l_br + l_q___3 * l_fact
			l_ci := l_bi + l_p * l_fact
			l_den := l_br * l_br + l_bi * l_bi
			l_dr := l_br / l_den
			l_di := -l_bi / l_den
			l_dlr := l_cr * l_dr - l_ci * l_di
			l_dli := l_cr * l_di + l_ci * l_dr
			l_temp := l_p * l_dlr - l_q___3 * l_dli
			l_q___3 := l_p * l_dli + l_q___3 * l_dlr
			l_p := l_temp
			l_i := 2
			from
			until
				not (not js.loop_done and then (l_i <= l_max_iter))
			loop
				l_a___5 := l_a___5 + (2 * (l_i - 1)).to_double
				l_bi := l_bi + (2.0)
				l_dr := l_a___5 * l_dr + l_br
				l_di := l_a___5 * l_di + l_bi
				l_tmp := fabs (l_dr)
				if l_tmp + (fabs (l_di)) < l_SMALL then
					l_dr := l_SMALL
				end
				l_fact := l_a___5 / (l_cr * l_cr + l_ci * l_ci)
				l_cr := l_br + l_cr * l_fact
				l_ci := l_bi - l_ci * l_fact
				l_tmp___1 := fabs (l_cr)
				if l_tmp___1 + (fabs (l_ci)) < l_SMALL then
					l_cr := l_SMALL
				end
				l_den := l_dr * l_dr + l_di * l_di
				l_dr := l_dr / l_den
				l_di := l_di / (-l_den)
				l_dlr := l_cr * l_dr - l_ci * l_di
				l_dli := l_cr * l_di + l_ci * l_dr
				l_temp := l_p * l_dlr - l_q___3 * l_dli
				l_q___3 := l_p * l_dli + l_q___3 * l_dlr
				l_p := l_temp
				l_tmp___3 := fabs (l_dlr - 1.0)
				if l_tmp___3 + (fabs (l_dli)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			a_P___2.item := l_p
			a_Q___1.item := l_q___3
			if l_i = l_max_iter then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("bessel.c"), 713, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_J_CF1 (a_nu: REAL_64; a_x: REAL_64; a_ratio: CE_POINTER [REAL_64]; a_sgn: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_RECUR_BIG: REAL_64
			l_RECUR_SMALL: REAL_64
			l_maxiter: INTEGER_32
			l_n: INTEGER_32
			l_Anm2: REAL_64
			l_Bnm2: REAL_64
			l_Anm1: REAL_64
			l_Bnm1: REAL_64
			l_a1___4: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_an2: REAL_64
			l_fn: REAL_64
			l_dn: REAL_64
			l_s: REAL_64
			l_old_fn: REAL_64
			l_del: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.3407807929942596e+154
					l_RECUR_SMALL := 1.4916681462400413e-154
					l_maxiter := 10_000
					l_n := 1
					l_Anm2 := 1.0
					l_Bnm2 := 0.0
					l_Anm1 := 0.0
					l_Bnm1 := 1.0
					l_a1___4 := a_x / (2.0 * (a_nu + 1.0))
					l_An := l_Anm1 + l_a1___4 * l_Anm2
					l_Bn := l_Bnm1 + l_a1___4 * l_Bnm2
					l_fn := l_An / l_Bn
					l_dn := l_a1___4
					l_s := 1.0
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_n < l_maxiter)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						l_n := l_n + 1
						l_Anm2 := l_Anm1
						l_Bnm2 := l_Bnm1
						l_Anm1 := l_An
						l_Bnm1 := l_Bn
						l_an2 := (-a_x * a_x) / ((4.0 * ((a_nu + l_n.to_double) - 1.0)) * (a_nu + l_n.to_double))
						l_An := l_Anm1 + l_an2 * l_Anm2
						l_Bn := l_Bnm1 + l_an2 * l_Bnm2
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if not ((fabs (l_An)) < l_RECUR_SMALL) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not ((fabs (l_Bn)) < l_RECUR_SMALL) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_An := l_An / l_RECUR_SMALL
						l_Bn := l_Bn / l_RECUR_SMALL
						l_Anm1 := l_Anm1 / l_RECUR_SMALL
						l_Bnm1 := l_Bnm1 / l_RECUR_SMALL
						l_Anm2 := l_Anm2 / l_RECUR_SMALL
						l_Bnm2 := l_Bnm2 / l_RECUR_SMALL
				when 13 then -- if done | if done | if done
						l_old_fn := l_fn
						l_fn := l_An / l_Bn
						l_del := l_old_fn / l_fn
						l_dn := 1.0 / ((2.0 * (a_nu + l_n.to_double)) / a_x - l_dn)
						if l_dn < 0.0 then
							l_s := -l_s
						end
						if (fabs (l_del - 1.0)) < 2.0 * 2.2204460492503131e-16 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					a_ratio.item := l_fn
					a_sgn.item := l_s
					if l_n >= l_maxiter then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("error"), ce_string ("bessel.c"), 584, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
					else
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_bessel_Jnu_asympx_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mu: REAL_64
			l_chi: REAL_64
			l_P___2: REAL_64
			l_Q___1: REAL_64
			l_k: REAL_64
			l_t: REAL_64
			l_convP: INTEGER_32
			l_convQ: INTEGER_32
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___2: REAL_64
			l_pre: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			js: JUMP_STATE
		do
			l_mu := (4.0 * a_nu) * a_nu
			l_chi := a_x - (0.5 * a_nu + 0.25) * 3.14159265358979323846
			l_P___2 := 0.0
			l_Q___1 := 0.0
			l_k := (0).to_double
			l_t := (1).to_double
			from
			until
				js.loop_done
			loop
				if l_k = (0).to_double then
					l_tmp := (1).to_double
				else
					l_tmp := -(l_mu - ((2).to_double * l_k - (1).to_double) * ((2).to_double * l_k - (1).to_double)) / (l_k * ((8).to_double * a_x))
				end
				l_t := l_t * l_tmp
				l_tmp___0 := fabs (l_t)
				l_convP := (l_tmp___0 < 2.2204460492503131e-16 * (fabs (l_P___2))).to_integer
				l_P___2 := l_P___2 + l_t
				l_k := l_k + (1).to_double
				l_t := l_t * ((l_mu - ((2).to_double * l_k - (1).to_double) * ((2).to_double * l_k - (1).to_double)) / (l_k * ((8).to_double * a_x)))
				l_tmp___2 := fabs (l_t)
				l_convQ := (l_tmp___2 < 2.2204460492503131e-16 * (fabs (l_Q___1))).to_integer
				l_Q___1 := l_Q___1 + l_t
				if l_convP.to_boolean then
					if l_convQ.to_boolean then
						if l_k > a_nu / (2).to_double then
							js.break
						end
					end
				end
				if not js.loop_jumped then
					l_k := l_k + (1).to_double
					if not (l_k < (1_000).to_double) then
						js.break
					end
				end
			end
			l_pre := (sqrt (2.0 / (3.14159265358979323846 * a_x)))
			l_c___1 := (cos (l_chi))
			l_s := (sin (l_chi))
			a_result.item.val := l_pre * (l_c___1 * l_P___2 - l_s * l_Q___1)
			l_tmp___7 := fabs (l_c___1 * l_P___2)
			l_tmp___8 := fabs (l_s * l_Q___1)
			l_tmp___9 := fabs (l_t)
			a_result.item.err := ((l_pre * 2.2204460492503131e-16) * ((l_tmp___7 + l_tmp___8) + l_tmp___9)) * ((1).to_double + (fabs (a_x)))
			Result := 0
		end

	gsl_sf_bessel_K_scaled_steed_temme_CF2 (a_nu: REAL_64; a_x: REAL_64; a_K_nu: CE_POINTER [REAL_64]; a_K_nup1: CE_POINTER [REAL_64]; a_Kp_nu: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_maxiter: INTEGER_32
			l_i: INTEGER_32
			l_bi: REAL_64
			l_di: REAL_64
			l_delhi: REAL_64
			l_hi: REAL_64
			l_qi: REAL_64
			l_qip1: REAL_64
			l_ai: REAL_64
			l_a1___4: REAL_64
			l_ci: REAL_64
			l_Qi2: REAL_64
			l_s: REAL_64
			l_dels: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_maxiter := 10_000
			l_i := 1
			l_bi := 2.0 * (1.0 + a_x)
			l_di := 1.0 / l_bi
			l_delhi := l_di
			l_hi := l_di
			l_qi := 0.0
			l_qip1 := 1.0
			l_ai := -(0.25 - a_nu * a_nu)
			l_a1___4 := l_ai
			l_ci := -l_ai
			l_Qi2 := -l_ai
			l_s := 1.0 + l_Qi2 * l_delhi
			l_i := 2
			from
			until
				not (not js.loop_done and then (l_i <= l_maxiter))
			loop
				l_ai := l_ai - (2.0 * (l_i - 1).to_double)
				l_ci := (-l_ai * l_ci) / l_i.to_double
				l_tmp := (l_qi - l_bi * l_qip1) / l_ai
				l_qi := l_qip1
				l_qip1 := l_tmp
				l_Qi2 := l_Qi2 + (l_ci * l_qip1)
				l_bi := l_bi + (2.0)
				l_di := 1.0 / (l_bi + l_ai * l_di)
				l_delhi := (l_bi * l_di - 1.0) * l_delhi
				l_hi := l_hi + l_delhi
				l_dels := l_Qi2 * l_delhi
				l_s := l_s + l_dels
				if (fabs (l_dels / l_s)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			l_hi := l_hi * (-l_a1___4)
			a_K_nu.item := (sqrt (3.14159265358979323846 / (2.0 * a_x))) / l_s
			a_K_nup1.item := (a_K_nu.item * (((a_nu + a_x) + 0.5) - l_hi)) / a_x
			a_Kp_nu.item := -a_K_nup1.item + (a_nu / a_x) * a_K_nu.item
			if l_i = l_maxiter then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("bessel.c"), 772, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_Knu_scaled_asymp_unif_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_i: INTEGER_32
			l_z: REAL_64
			l_root_term: REAL_64
			l_pre: REAL_64
			l_eta: REAL_64
			l_ex_arg: REAL_64
			l_tmp___2: REAL_64
			l_ex_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_ex: INTEGER_32
			l_t: REAL_64
			l_sum: REAL_64
			l_tpow: CE_ARRAY [REAL_64]
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___7: REAL_64
		do
			create l_ex_result.make (<<1>>)
			create l_tpow.make (<<16>>)

			l_z := a_x / a_nu
			l_root_term := (hypot (1.0, l_z))
			l_pre := (sqrt (3.14159265358979323846 / ((2.0 * a_nu) * l_root_term)))
			l_eta := l_root_term + (log (l_z / (1.0 + l_root_term)))
			if l_z < 1.0 / 6.0554544523933429e-06 then
				l_tmp___2 := a_nu * (l_z - l_eta)
			else
				l_tmp___2 := ((0.5 * a_nu) / l_z) * (1.0 + 1.0 / ((12.0 * l_z) * l_z))
			end
			l_ex_arg := l_tmp___2
			l_stat_ex := (exp_inst.gsl_sf_exp_e (l_ex_arg, l_ex_result))
			if l_stat_ex = 0 then
				l_t := 1.0 / l_root_term
				l_tpow[0] := 1.0
				l_i := 1
				from
				until
					not (l_i < 16)
				loop
					l_tpow[l_i] := l_t * l_tpow[l_i - 1]
					l_i := l_i + 1
				end
				l_tmp___4 := debye_u1 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_tmp___5 := debye_u2 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_tmp___6 := debye_u3 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_tmp___7 := debye_u4 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))
				l_sum := ((((1.0 - l_tmp___4 / a_nu) + l_tmp___5 / (a_nu * a_nu)) - l_tmp___6 / ((a_nu * a_nu) * a_nu)) + l_tmp___7 / (((a_nu * a_nu) * a_nu) * a_nu)) - (debye_u5 (create {CE_POINTER [REAL_64]}.make_cast (l_tpow))) / ((((a_nu * a_nu) * a_nu) * a_nu) * a_nu)
				a_result.item.val := (l_pre * l_ex_result.item.val) * l_sum
				a_result.item.err := (l_pre * l_ex_result.item.err) * (fabs (l_sum))
				a_result.item.err := a_result.item.err + ((l_pre * l_ex_result.item.val) / (((((a_nu * a_nu) * a_nu) * a_nu) * a_nu) * a_nu))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			else
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := l_stat_ex
			end
		end

	gsl_sf_bessel_Knu_scaled_asympx_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mu: REAL_64
			l_mum1: REAL_64
			l_mum9: REAL_64
			l_pre: REAL_64
			l_r___3: REAL_64
			l_tmp___0: REAL_64
		do
			l_mu := (4.0 * a_nu) * a_nu
			l_mum1 := l_mu - 1.0
			l_mum9 := l_mu - 9.0
			l_pre := (sqrt (3.14159265358979323846 / (2.0 * a_x)))
			l_r___3 := a_nu / a_x
			a_result.item.val := l_pre * ((1.0 + l_mum1 / (8.0 * a_x)) + (l_mum1 * l_mum9) / ((128.0 * a_x) * a_x))
			l_tmp___0 := fabs (a_result.item.val)
			a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_tmp___0 + l_pre * (fabs (((0.1 * l_r___3) * l_r___3) * l_r___3))
			Result := 0
		end

	gsl_sf_bessel_Ynu_asympx_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ampl: CE_ARRAY [REAL_64]
			l_theta: CE_ARRAY [REAL_64]
			l_alpha: REAL_64
			l_beta: REAL_64
			l_stat_a: INTEGER_32
			l_stat_t: INTEGER_32
			l_sin_alpha: REAL_64
			l_cos_alpha: REAL_64
			l_sin_chi: REAL_64
			l_cos_chi: REAL_64
			l_sin_term: REAL_64
			l_sin_term_mag: REAL_64
			l_tmp___5: REAL_64
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
		do
			create l_ampl.make (<<1>>)
			create l_theta.make (<<1>>)

			l_alpha := a_x
			l_beta := (-0.5 * a_nu) * 3.14159265358979323846
			l_stat_a := (bessel_amp_phase_inst.gsl_sf_bessel_asymp_Mnu_e (a_nu, a_x, l_ampl))
			l_stat_t := (bessel_amp_phase_inst.gsl_sf_bessel_asymp_thetanu_corr_e (a_nu, a_x, l_theta))
			l_sin_alpha := (sin (l_alpha))
			l_cos_alpha := (cos (l_alpha))
			l_sin_chi := (sin (l_beta + l_theta.item))
			l_cos_chi := (cos (l_beta + l_theta.item))
			l_sin_term := l_sin_alpha * l_cos_chi + l_sin_chi * l_cos_alpha
			l_tmp___5 := fabs (l_sin_alpha * l_cos_chi)
			l_sin_term_mag := l_tmp___5 + (fabs (l_sin_chi * l_cos_alpha))
			a_result.item.val := l_ampl.item * l_sin_term
			a_result.item.err := ((fabs (l_ampl.item)) * 2.2204460492503131e-16) * l_sin_term_mag
			a_result.item.err := a_result.item.err + (((fabs (a_result.item.val)) * 2.0) * 2.2204460492503131e-16)
			if (fabs (l_alpha)) > 1.0 / 2.2204460492503131e-16 then
				a_result.item.err := a_result.item.err * (0.5 * (fabs (l_alpha)))
			elseif (fabs (l_alpha)) > 1.0 / 1.4901161193847656e-08 then
				a_result.item.err := a_result.item.err * ((256.0 * (fabs (l_alpha))) * 1.4901161193847656e-08)
			end
			if l_stat_t /= 0 then
				l_tmp___14 := l_stat_t
			else
				if l_stat_a /= 0 then
					l_tmp___13 := l_stat_a
				else
					l_tmp___13 := 0
				end
				l_tmp___14 := l_tmp___13
			end
			Result := l_tmp___14
		end

	gsl_sf_bessel_cos_pi4_e (a_y: REAL_64; a_eps: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sy: REAL_64
			l_cy: REAL_64
			l_s: REAL_64
			l_d: REAL_64
			l_abs_sum: REAL_64
			l_tmp___1: REAL_64
			l_seps: REAL_64
			l_ceps: REAL_64
			l_e2: REAL_64
			l_tmp___4: REAL_64
		do
			l_sy := (sin (a_y))
			l_cy := (cos (a_y))
			l_s := l_sy + l_cy
			l_d := l_sy - l_cy
			l_tmp___1 := fabs (l_cy)
			l_abs_sum := l_tmp___1 + (fabs (l_sy))
			if (fabs (a_eps)) < 7.4009597974140505e-04 then
				l_e2 := a_eps * a_eps
				l_seps := a_eps * (1.0 - (l_e2 / 6.0) * (1.0 - l_e2 / 20.0))
				l_ceps := 1.0 - (l_e2 / 2.0) * (1.0 - l_e2 / 12.0)
			else
				l_seps := sin (a_eps)
				l_ceps := cos (a_eps)
			end
			a_result.item.val := (l_ceps * l_s - l_seps * l_d) / 1.41421356237309504880
			l_tmp___4 := fabs (l_ceps)
			a_result.item.err := (((2.0 * 2.2204460492503131e-16) * (l_tmp___4 + (fabs (l_seps)))) * l_abs_sum) / 1.41421356237309504880
			if a_y > 1.0 / 2.2204460492503131e-16 then
				a_result.item.err := a_result.item.err * (0.5 * a_y)
			elseif a_y > 1.0 / 1.4901161193847656e-08 then
				a_result.item.err := a_result.item.err * ((256.0 * a_y) * 1.4901161193847656e-08)
			end
			Result := 0
		end

	gsl_sf_bessel_sin_pi4_e (a_y: REAL_64; a_eps: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sy: REAL_64
			l_cy: REAL_64
			l_s: REAL_64
			l_d: REAL_64
			l_abs_sum: REAL_64
			l_tmp___1: REAL_64
			l_seps: REAL_64
			l_ceps: REAL_64
			l_e2: REAL_64
			l_tmp___4: REAL_64
		do
			l_sy := (sin (a_y))
			l_cy := (cos (a_y))
			l_s := l_sy + l_cy
			l_d := l_sy - l_cy
			l_tmp___1 := fabs (l_cy)
			l_abs_sum := l_tmp___1 + (fabs (l_sy))
			if (fabs (a_eps)) < 7.4009597974140505e-04 then
				l_e2 := a_eps * a_eps
				l_seps := a_eps * (1.0 - (l_e2 / 6.0) * (1.0 - l_e2 / 20.0))
				l_ceps := 1.0 - (l_e2 / 2.0) * (1.0 - l_e2 / 12.0)
			else
				l_seps := sin (a_eps)
				l_ceps := cos (a_eps)
			end
			a_result.item.val := (l_ceps * l_d + l_seps * l_s) / 1.41421356237309504880
			l_tmp___4 := fabs (l_ceps)
			a_result.item.err := (((2.0 * 2.2204460492503131e-16) * (l_tmp___4 + (fabs (l_seps)))) * l_abs_sum) / 1.41421356237309504880
			if a_y > 1.0 / 2.2204460492503131e-16 then
				a_result.item.err := a_result.item.err * (0.5 * a_y)
			elseif a_y > 1.0 / 1.4901161193847656e-08 then
				a_result.item.err := a_result.item.err * ((256.0 * a_y) * 1.4901161193847656e-08)
			end
			Result := 0
		end

end
