class
	P_BESSEL_AMP_PHASE

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create bm0_data.make (<<21>>)
			create bm1_data.make (<<21>>)
			create bth0_data.make (<<24>>)
			create bth1_data.make (<<24>>)
			create gsl_sf_bessel_amp_phase_bm0_cs.make (<<1>>)
			create gsl_sf_bessel_amp_phase_bm1_cs.make (<<1>>)
			create gsl_sf_bessel_amp_phase_bth0_cs.make (<<1>>)
			create gsl_sf_bessel_amp_phase_bth1_cs.make (<<1>>)
		end

feature {ANY} -- attributes

	bm0_data: CE_ARRAY [REAL_64]

	bm1_data: CE_ARRAY [REAL_64]

	bth0_data: CE_ARRAY [REAL_64]

	bth1_data: CE_ARRAY [REAL_64]

	gsl_sf_bessel_amp_phase_bm0_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	gsl_sf_bessel_amp_phase_bm1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	gsl_sf_bessel_amp_phase_bth0_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	gsl_sf_bessel_amp_phase_bth1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

feature {ANY} -- routines

	gsl_sf_bessel_asymp_Mnu_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_r___3: REAL_64
			l_r2___0: REAL_64
			l_x2___1: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_Mnu2_c: REAL_64
			l_tmp: REAL_64
		do
			l_r___3 := (2.0 * a_nu) / a_x
			l_r2___0 := l_r___3 * l_r___3
			l_x2___1 := a_x * a_x
			l_term1 := (l_r2___0 - 1.0 / l_x2___1) / 8.0
			l_term2 := (((l_r2___0 - 1.0 / l_x2___1) * (l_r2___0 - 9.0 / l_x2___1)) * 3.0) / 128.0
			l_Mnu2_c := (2.0 / 3.14159265358979323846) * ((1.0 + l_term1) + l_term2)
			l_tmp := sqrt (l_Mnu2_c)
			a_result.item := l_tmp / (sqrt (a_x))
			Result := 0
		end

	gsl_sf_bessel_asymp_thetanu_corr_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_r___3: REAL_64
			l_r2___0: REAL_64
			l_x2___1: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
		do
			l_r___3 := (2.0 * a_nu) / a_x
			l_r2___0 := l_r___3 * l_r___3
			l_x2___1 := a_x * a_x
			l_term1 := (a_x * (l_r2___0 - 1.0 / l_x2___1)) / 8.0
			l_term2 := ((a_x * (l_r2___0 - 1.0 / l_x2___1)) * (l_r2___0 - 25.0 / l_x2___1)) / 384.0
			a_result.item := (-0.25 * 3.14159265358979323846 + l_term1) + l_term2
			Result := 0
		end

end
