class
	P_BESSEL_OLVER

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create A3_gt1_cs.make (<<1>>)
			create A3_gt1_data.make (<<31>>)
			create A3_lt1_cs.make (<<1>>)
			create A3_lt1_data.make (<<40>>)
			create A4_gt1_cs.make (<<1>>)
			create A4_gt1_data.make (<<30>>)
			create A4_lt1_cs.make (<<1>>)
			create A4_lt1_data.make (<<30>>)
			create B2_gt1_cs.make (<<1>>)
			create B2_gt1_data.make (<<40>>)
			create B2_lt1_cs.make (<<1>>)
			create B2_lt1_data.make (<<40>>)
			create B3_gt1_cs.make (<<1>>)
			create B3_gt1_data.make (<<30>>)
			create B3_lt1_cs.make (<<1>>)
			create B3_lt1_data.make (<<40>>)
			create zofmzeta_a_cs.make (<<1>>)
			create zofmzeta_a_data.make (<<20>>)
			create zofmzeta_b_cs.make (<<1>>)
			create zofmzeta_b_data.make (<<30>>)
			create zofmzeta_c_cs.make (<<1>>)
			create zofmzeta_c_data.make (<<11>>)
		end

feature {ANY} -- attributes

	A3_gt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	A3_gt1_data: CE_ARRAY [REAL_64]

	A3_lt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	A3_lt1_data: CE_ARRAY [REAL_64]

	A4_gt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	A4_gt1_data: CE_ARRAY [REAL_64]

	A4_lt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	A4_lt1_data: CE_ARRAY [REAL_64]

	B2_gt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	B2_gt1_data: CE_ARRAY [REAL_64]

	B2_lt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	B2_lt1_data: CE_ARRAY [REAL_64]

	B3_gt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	B3_gt1_data: CE_ARRAY [REAL_64]

	B3_lt1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	B3_lt1_data: CE_ARRAY [REAL_64]

	zofmzeta_a_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	zofmzeta_a_data: CE_ARRAY [REAL_64]

	zofmzeta_b_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	zofmzeta_b_data: CE_ARRAY [REAL_64]

	zofmzeta_c_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	zofmzeta_c_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_sf_bessel_Jnu_asymp_Olver_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_zeta: REAL_64
			l_abs_zeta: REAL_64
			l_arg: REAL_64
			l_pre: REAL_64
			l_asum: REAL_64
			l_bsum: REAL_64
			l_asum_err: CE_ARRAY [REAL_64]
			l_ai: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_aip: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_z: REAL_64
			l_crnu: REAL_64
			l_nu3: REAL_64
			l_nu11: REAL_64
			l_stat_a: INTEGER_32
			l_stat_ap: INTEGER_32
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_rt: REAL_64
			l_rt___0: REAL_64
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_asum_err.make (<<1>>)
			create l_ai.make (<<1>>)
			create l_aip.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_nu <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_olver.c"), 847, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_z := a_x / a_nu
						l_crnu := (pow (a_nu, 1.0 / 3.0))
						l_nu3 := (a_nu * a_nu) * a_nu
						l_nu11 := (((l_nu3 * l_nu3) * l_nu3) * a_nu) * a_nu
						if (fabs (1.0 - l_z)) < 0.02 then
							l_a___5 := 1.0 - l_z
							l_c0___0 := 1.25992104989487316476721060728
							l_c1___2 := 0.37797631496846194943016318218
							l_c2___0 := 0.230385563409348235843147082474
							l_c3___3 := 0.165909603649648694839821892031
							l_c4___2 := 0.12931387086451008907
							l_c5___1 := 0.10568046188858133991
							l_c6___2 := 0.08916997952268186978
							l_c7___0 := 0.07700014900618802456
							l_pre := l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * l_c7___0))))))
							l_zeta := l_a___5 * l_pre
							l_pre := sqrt (2.0 * (sqrt (l_pre / (1.0 + l_z))))
							l_abs_zeta := fabs (l_zeta)
						elseif l_z < 1.0 then
							l_rt := (sqrt (1.0 - l_z * l_z))
							l_abs_zeta := pow (1.5 * ((log ((1.0 + l_rt) / l_z)) - l_rt), 2.0 / 3.0)
							l_zeta := l_abs_zeta
							l_pre := sqrt (2.0 * (sqrt (l_abs_zeta / (l_rt * l_rt))))
						else
							l_rt___0 := l_z * (sqrt (1.0 - 1.0 / (l_z * l_z)))
							l_abs_zeta := pow (1.5 * (l_rt___0 - (acos (1.0 / l_z))), 2.0 / 3.0)
							l_zeta := -l_abs_zeta
							l_pre := sqrt (2.0 * (sqrt (l_abs_zeta / (l_rt___0 * l_rt___0))))
						end
						l_asum := olver_Asum (a_nu, l_z, l_abs_zeta, l_asum_err)
						l_bsum := olver_Bsum (a_nu, l_z, l_abs_zeta)
						l_arg := (l_crnu * l_crnu) * l_zeta
						l_stat_a := airy_inst.gsl_sf_airy_Ai_e (l_arg, (0).to_natural_32, l_ai)
						l_stat_ap := airy_der_inst.gsl_sf_airy_Ai_deriv_e (l_arg, (0).to_natural_32, l_aip)
						a_result.item.val := l_pre * ((l_ai.item.val * l_asum) / l_crnu + (l_aip.item.val * l_bsum) / ((a_nu * l_crnu) * l_crnu))
						a_result.item.err := l_pre * (l_ai.item.err * (fabs (l_asum / l_crnu)))
						a_result.item.err := a_result.item.err + (((l_pre * (fabs (l_ai.item.val))) * l_asum_err.item) / l_crnu)
						a_result.item.err := a_result.item.err + ((l_pre * (fabs (l_ai.item.val * l_asum))) / (l_crnu * l_nu11))
						a_result.item.err := a_result.item.err + ((8.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if l_stat_a /= 0 then
							l_tmp___15 := l_stat_a
						else
							if l_stat_ap /= 0 then
								l_tmp___14 := l_stat_ap
							else
								l_tmp___14 := 0
							end
							l_tmp___15 := l_tmp___14
						end
						Result := l_tmp___15
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_Olver_zofmzeta (a_minus_zeta: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_x___0: REAL_64
			l_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_TEN_32: REAL_64
			l_p: REAL_64
			l_x___1: REAL_64
			l_c___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_c___1.make (<<1>>)
			create l_c___2.make (<<1>>)
			create l_c___3.make (<<1>>)

			if a_minus_zeta < 1.0 then
				l_x := 2.0 * a_minus_zeta - 1.0
				cheb_eval_inst.cheb_eval_e (zofmzeta_a_cs, l_x, l_c___1).do_nothing
				Result := (l_c___1.item.val)
			elseif a_minus_zeta < 10.0 then
				l_x___0 := (2.0 * a_minus_zeta - 11.0) / 9.0
				cheb_eval_inst.cheb_eval_e (zofmzeta_b_cs, l_x___0, l_c___2).do_nothing
				Result := (l_c___2.item.val)
			else
				l_TEN_32 := 31.62277660168379332
				l_p := (pow (a_minus_zeta, 3.0 / 2.0))
				l_x___1 := (2.0 * l_TEN_32) / l_p - 1.0
				cheb_eval_inst.cheb_eval_e (zofmzeta_c_cs, l_x___1, l_c___3).do_nothing
				Result := (l_c___3.item.val * l_p)
			end
		end

	gsl_sf_bessel_Ynu_asymp_Olver_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_zeta: REAL_64
			l_abs_zeta: REAL_64
			l_arg: REAL_64
			l_pre: REAL_64
			l_asum: REAL_64
			l_bsum: REAL_64
			l_asum_err: CE_ARRAY [REAL_64]
			l_bi: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_bip: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_z: REAL_64
			l_crnu: REAL_64
			l_nu3: REAL_64
			l_nu11: REAL_64
			l_stat_b: INTEGER_32
			l_stat_d: INTEGER_32
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_rt: REAL_64
			l_rt___0: REAL_64
			l_ac: REAL_64
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_asum_err.make (<<1>>)
			create l_bi.make (<<1>>)
			create l_bip.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_nu <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_olver.c"), 922, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_z := a_x / a_nu
						l_crnu := (pow (a_nu, 1.0 / 3.0))
						l_nu3 := (a_nu * a_nu) * a_nu
						l_nu11 := (((l_nu3 * l_nu3) * l_nu3) * a_nu) * a_nu
						if (fabs (1.0 - l_z)) < 0.02 then
							l_a___5 := 1.0 - l_z
							l_c0___0 := 1.25992104989487316476721060728
							l_c1___2 := 0.37797631496846194943016318218
							l_c2___0 := 0.230385563409348235843147082474
							l_c3___3 := 0.165909603649648694839821892031
							l_c4___2 := 0.12931387086451008907
							l_c5___1 := 0.10568046188858133991
							l_c6___2 := 0.08916997952268186978
							l_c7___0 := 0.07700014900618802456
							l_pre := l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * l_c7___0))))))
							l_zeta := l_a___5 * l_pre
							l_pre := sqrt (2.0 * (sqrt (l_pre / (1.0 + l_z))))
							l_abs_zeta := fabs (l_zeta)
						elseif l_z < 1.0 then
							l_rt := (sqrt (1.0 - l_z * l_z))
							l_abs_zeta := pow (1.5 * ((log ((1.0 + l_rt) / l_z)) - l_rt), 2.0 / 3.0)
							l_zeta := l_abs_zeta
							l_pre := sqrt (2.0 * (sqrt (l_abs_zeta / (l_rt * l_rt))))
						else
							l_rt___0 := l_z * (sqrt (1.0 - 1.0 / (l_z * l_z)))
							l_ac := (acos (1.0 / l_z))
							l_abs_zeta := pow (1.5 * (l_rt___0 - l_ac), 2.0 / 3.0)
							l_zeta := -l_abs_zeta
							l_pre := sqrt ((2.0 * (sqrt (l_abs_zeta))) / l_rt___0)
						end
						l_asum := olver_Asum (a_nu, l_z, l_abs_zeta, l_asum_err)
						l_bsum := olver_Bsum (a_nu, l_z, l_abs_zeta)
						l_arg := (l_crnu * l_crnu) * l_zeta
						l_stat_b := airy_inst.gsl_sf_airy_Bi_e (l_arg, (0).to_natural_32, l_bi)
						l_stat_d := airy_der_inst.gsl_sf_airy_Bi_deriv_e (l_arg, (0).to_natural_32, l_bip)
						a_result.item.val := -l_pre * ((l_bi.item.val * l_asum) / l_crnu + (l_bip.item.val * l_bsum) / ((a_nu * l_crnu) * l_crnu))
						a_result.item.err := l_pre * (l_bi.item.err * (fabs (l_asum / l_crnu)))
						a_result.item.err := a_result.item.err + (((l_pre * (fabs (l_bi.item.val))) * l_asum_err.item) / l_crnu)
						a_result.item.err := a_result.item.err + ((l_pre * (fabs (l_bi.item.val * l_asum))) / (l_crnu * l_nu11))
						a_result.item.err := a_result.item.err + ((8.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if l_stat_b /= 0 then
							l_tmp___15 := l_stat_b
						else
							if l_stat_d /= 0 then
								l_tmp___14 := l_stat_d
							else
								l_tmp___14 := 0
							end
							l_tmp___15 := l_tmp___14
						end
						Result := l_tmp___15
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	olver_A1 (a_z: REAL_64; a_abs_zeta: REAL_64; a_err: CE_POINTER [REAL_64]): REAL_64
		local
			l_t: REAL_64
			l_rz: REAL_64
			l_t2: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_term3: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_sum: REAL_64
			l_t___0: REAL_64
			l_rz___0: REAL_64
			l_t2___0: REAL_64
			l_term1___0: REAL_64
			l_term2___0: REAL_64
			l_term3___0: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
		do
			if a_z < 0.98 then
				l_t := 1.0 / (sqrt (1.0 - a_z * a_z))
				l_rz := (sqrt (a_abs_zeta))
				l_t2 := l_t * l_t
				l_term1 := (l_t2 * ((81.0 - 462.0 * l_t2) + (385.0 * l_t2) * l_t2)) / 1152.0
				l_term2 := -455.0 / (((4608.0 * a_abs_zeta) * a_abs_zeta) * a_abs_zeta)
				l_term3 := ((7.0 * l_t) * (-3.0 + 5.0 * l_t2)) / (((1152.0 * l_rz) * l_rz) * l_rz)
				l_tmp___1 := fabs (l_term1)
				l_tmp___2 := fabs (l_term2)
				a_err.item := (2.0 * 2.2204460492503131e-16) * ((l_tmp___1 + l_tmp___2) + (fabs (l_term3)))
				Result := ((l_term1 + l_term2) + l_term3)
			elseif a_z < 1.02 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := -0.00444444444444444444444444444444
				l_c1___2 := -0.00184415584415584415584415584416
				l_c2___0 := 0.00056812076812076812076812076812
				l_c3___3 := 0.00168137865661675185484709294233
				l_c4___2 := 0.00186744042139000122193399504324
				l_c5___1 := 0.00161330105833747826430066790326
				l_c6___2 := 0.00123177312220625816558607537838
				l_c7___0 := 0.00087334711007377573881689318421
				l_c8___0 := 0.00059004942455353250141217015410
				l_sum := l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * (l_c7___0 + l_a___5 * l_c8___0)))))))
				a_err.item := (2.0 * 2.2204460492503131e-16) * (fabs (l_sum))
				Result := l_sum
			else
				l_t___0 := 1.0 / (a_z * (sqrt (1.0 - 1.0 / (a_z * a_z))))
				l_rz___0 := (sqrt (a_abs_zeta))
				l_t2___0 := l_t___0 * l_t___0
				l_term1___0 := (-l_t2___0 * ((81.0 + 462.0 * l_t2___0) + (385.0 * l_t2___0) * l_t2___0)) / 1152.0
				l_term2___0 := 455.0 / (((4608.0 * a_abs_zeta) * a_abs_zeta) * a_abs_zeta)
				l_term3___0 := ((-7.0 * l_t___0) * (3.0 + 5.0 * l_t2___0)) / (((1152.0 * l_rz___0) * l_rz___0) * l_rz___0)
				l_tmp___7 := fabs (l_term1___0)
				l_tmp___8 := fabs (l_term2___0)
				a_err.item := (2.0 * 2.2204460492503131e-16) * ((l_tmp___7 + l_tmp___8) + (fabs (l_term3___0)))
				Result := ((l_term1___0 + l_term2___0) + l_term3___0)
			end
		end

	olver_A2 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_t: REAL_64
			l_t2: REAL_64
			l_t4: REAL_64
			l_t6: REAL_64
			l_t8: REAL_64
			l_rz: REAL_64
			l_z3: REAL_64
			l_z32: REAL_64
			l_z92: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_term3: REAL_64
			l_term4: REAL_64
			l_term5: REAL_64
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_c10: REAL_64
			l_t___0: REAL_64
			l_t2___0: REAL_64
			l_t4___0: REAL_64
			l_t6___0: REAL_64
			l_t8___0: REAL_64
			l_rz___0: REAL_64
			l_z3___0: REAL_64
			l_z32___0: REAL_64
			l_z92___0: REAL_64
			l_term1___0: REAL_64
			l_term2___0: REAL_64
			l_term3___0: REAL_64
			l_term4___0: REAL_64
			l_term5___0: REAL_64
		do
			if a_z < 0.88 then
				l_t := 1.0 / (sqrt (1.0 - a_z * a_z))
				l_t2 := l_t * l_t
				l_t4 := l_t2 * l_t2
				l_t6 := l_t4 * l_t2
				l_t8 := l_t4 * l_t4
				l_rz := (sqrt (a_abs_zeta))
				l_z3 := (a_abs_zeta * a_abs_zeta) * a_abs_zeta
				l_z32 := (l_rz * l_rz) * l_rz
				l_z92 := l_z3 * l_z32
				l_term1 := (l_t4 * ((((4465125.0 - 94121676.0 * l_t2) + 349922430.0 * l_t4) - 446185740.0 * l_t6) + 185910725.0 * l_t8)) / 39813120.0
				l_term2 := -40415375.0 / ((127401984.0 * l_z3) * l_z3)
				l_term3 := (((-95095.0 / 15925248.0) * l_t) * (3.0 - 5.0 * l_t2)) / l_z92
				l_term4 := (((-455.0 / 5308416.0) * l_t2) * ((81.0 - 462.0 * l_t2) + 385.0 * l_t4)) / l_z3
				l_term5 := ((((-7.0 / 19906560.0) * l_t) * l_t2) * (((30375.0 - 369603.0 * l_t2) + 765765.0 * l_t4) - 425425.0 * l_t6)) / l_z32
				Result := ((((l_term1 + l_term2) + l_term3) + l_term4) + l_term5)
			elseif a_z < 1.12 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := 0.000693735541354588973636592684210
				l_c1___2 := 0.000464483490365843307019777608010
				l_c2___0 := -0.000289036254605598132482570468291
				l_c3___3 := -0.000874764943953712638574497548110
				l_c4___2 := -0.001029716376139865629968584679350
				l_c5___1 := -0.000836857329713810600584714031650
				l_c6___2 := -0.000488910893527218954998270124540
				l_c7___0 := -0.000144236747940817220502256810151
				l_c8___0 := 0.000114363800986163478038576460325
				l_c9 := 0.000266806881492777536223944807117
				l_c10 := -0.011975517576151069627471048587000
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * (l_c7___0 + l_a___5 * (l_c8___0 + l_a___5 * (l_c9 + l_a___5 * l_c10))))))))))
			else
				l_t___0 := 1.0 / (a_z * (sqrt (1.0 - 1.0 / (a_z * a_z))))
				l_t2___0 := l_t___0 * l_t___0
				l_t4___0 := l_t2___0 * l_t2___0
				l_t6___0 := l_t4___0 * l_t2___0
				l_t8___0 := l_t4___0 * l_t4___0
				l_rz___0 := (sqrt (a_abs_zeta))
				l_z3___0 := (a_abs_zeta * a_abs_zeta) * a_abs_zeta
				l_z32___0 := (l_rz___0 * l_rz___0) * l_rz___0
				l_z92___0 := l_z3___0 * l_z32___0
				l_term1___0 := (l_t4___0 * ((((4465125.0 + 94121676.0 * l_t2___0) + 349922430.0 * l_t4___0) + 446185740.0 * l_t6___0) + 185910725.0 * l_t8___0)) / 39813120.0
				l_term2___0 := -40415375.0 / ((127401984.0 * l_z3___0) * l_z3___0)
				l_term3___0 := (((95095.0 / 15925248.0) * l_t___0) * (3.0 + 5.0 * l_t2___0)) / l_z92___0
				l_term4___0 := (((-455.0 / 5308416.0) * l_t2___0) * ((81.0 + 462.0 * l_t2___0) + 385.0 * l_t4___0)) / l_z3___0
				l_term5___0 := ((((7.0 / 19906560.0) * l_t___0) * l_t2___0) * (((30375.0 + 369603.0 * l_t2___0) + 765765.0 * l_t4___0) + 425425.0 * l_t6___0)) / l_z32___0
				Result := ((((l_term1___0 + l_term2___0) + l_term3___0) + l_term4___0) + l_term5___0)
			end
		end

	olver_A3 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_x___0: REAL_64
			l_zi2: REAL_64
			l_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_c___1.make (<<1>>)
			create l_c___2.make (<<1>>)

			if a_z < 0.9 then
				l_x := (20.0 * a_z) / 9.0 - 1.0
				cheb_eval_inst.cheb_eval_e (A3_lt1_cs, l_x, l_c___1).do_nothing
				Result := (l_c___1.item.val)
			elseif a_z < 1.1 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := -0.000354211971457743840771125759200
				l_c1___2 := -0.000312322527890318832782774881353
				l_c2___0 := 0.000277947465383133980329617631915
				l_c3___3 := 0.000919803044747966977054155192400
				l_c4___2 := 0.001147600388275977640983696906320
				l_c5___1 := 0.000869239326123625742931772044544
				l_c6___2 := 0.000287392257282507334785281718027
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * l_c6___2))))))
			else
				l_x___0 := 11.0 / (5.0 * a_z) - 1.0
				l_zi2 := 1.0 / (a_z * a_z)
				cheb_eval_inst.cheb_eval_e (A3_gt1_cs, l_x___0, l_c___2).do_nothing
				Result := (((l_c___2.item.val * l_zi2) * l_zi2) * l_zi2)
			end
		end

	olver_A4 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_x___0: REAL_64
			l_zi2: REAL_64
			l_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_c___1.make (<<1>>)
			create l_c___2.make (<<1>>)

			if a_z < 0.8 then
				l_x := (5.0 * a_z) / 2.0 - 1.0
				cheb_eval_inst.cheb_eval_e (A4_lt1_cs, l_x, l_c___1).do_nothing
				Result := (l_c___1.item.val)
			elseif a_z < 1.2 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := 0.00037819419920177291402661228437
				l_c1___2 := 0.00040494390552363233477213857527
				l_c2___0 := -0.00045764735528936113047289344569
				l_c3___3 := -0.00165361044229650225813161341879
				l_c4___2 := -0.00217527517983360049717137015539
				l_c5___1 := -0.00152003287866490735107772795537
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * l_c5___1)))))
			else
				l_x___0 := 12.0 / (5.0 * a_z) - 1.0
				l_zi2 := 1.0 / (a_z * a_z)
				cheb_eval_inst.cheb_eval_e (A4_gt1_cs, l_x___0, l_c___2).do_nothing
				Result := ((((l_c___2.item.val * l_zi2) * l_zi2) * l_zi2) * l_zi2)
			end
		end

	olver_Asum (a_nu: REAL_64; a_z: REAL_64; a_abs_zeta: REAL_64; a_err: CE_POINTER [REAL_64]): REAL_64
		local
			l_nu2: REAL_64
			l_A1_err: CE_ARRAY [REAL_64]
			l_A1___0: REAL_64
			l_A2___0: REAL_64
			l_A3: REAL_64
			l_A4: REAL_64
		do
			create l_A1_err.make (<<1>>)

			l_nu2 := a_nu * a_nu
			l_A1___0 := (olver_A1 (a_z, a_abs_zeta, l_A1_err))
			l_A2___0 := (olver_A2 (a_z, a_abs_zeta))
			l_A3 := (olver_A3 (a_z, a_abs_zeta))
			l_A4 := (olver_A4 (a_z, a_abs_zeta))
			a_err.item := l_A1_err.item / l_nu2 + 2.2204460492503131e-16
			Result := ((((1.0 + l_A1___0 / l_nu2) + l_A2___0 / (l_nu2 * l_nu2)) + l_A3 / ((l_nu2 * l_nu2) * l_nu2)) + l_A4 / (((l_nu2 * l_nu2) * l_nu2) * l_nu2))
		end

	olver_B02 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_t: REAL_64
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_t___0: REAL_64
		do
			if a_z < 0.98 then
				l_t := 1.0 / (sqrt (1.0 - a_z * a_z))
				Result := (-5.0 / ((48.0 * a_abs_zeta) * a_abs_zeta) + (l_t * (-3.0 + (5.0 * l_t) * l_t)) / (24.0 * (sqrt (a_abs_zeta))))
			elseif a_z < 1.02 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := 0.0179988721413553309252458658183
				l_c1___2 := 0.0111992982212877614645974276203
				l_c2___0 := 0.0059404069786014304317781160605
				l_c3___3 := 0.0028676724516390040844556450173
				l_c4___2 := 0.0012339189052567271708525111185
				l_c5___1 := 0.0004169250674535178764734660248
				l_c6___2 := 0.0000330173385085949806952777365
				l_c7___0 := -0.0001318076238578203009990106425
				l_c8___0 := -0.0001906870370050847239813945647
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * (l_c7___0 + l_a___5 * l_c8___0))))))))
			else
				l_t___0 := 1.0 / (a_z * (sqrt (1.0 - 1.0 / (a_z * a_z))))
				Result := (-5.0 / ((48.0 * a_abs_zeta) * a_abs_zeta) + (l_t___0 * (3.0 + (5.0 * l_t___0) * l_t___0)) / (24.0 * (sqrt (a_abs_zeta))))
			end
		end

	olver_B1 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_t: REAL_64
			l_t2: REAL_64
			l_rz: REAL_64
			l_z32: REAL_64
			l_z92: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_term3: REAL_64
			l_term4: REAL_64
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_c10: REAL_64
			l_t___0: REAL_64
			l_t2___0: REAL_64
			l_rz___0: REAL_64
			l_z32___0: REAL_64
			l_z92___0: REAL_64
			l_term1___0: REAL_64
			l_term2___0: REAL_64
			l_term3___0: REAL_64
			l_term4___0: REAL_64
		do
			if a_z < 0.88 then
				l_t := 1.0 / (sqrt (1.0 - a_z * a_z))
				l_t2 := l_t * l_t
				l_rz := (sqrt (a_abs_zeta))
				l_z32 := (l_rz * l_rz) * l_rz
				l_z92 := (l_z32 * l_z32) * l_z32
				l_term1 := (((l_t * l_t) * l_t) * (((30375.0 - 369603.0 * l_t2) + (765765.0 * l_t2) * l_t2) - ((425425.0 * l_t2) * l_t2) * l_t2)) / 414720.0
				l_term2 := 85085.0 / (663552.0 * l_z92)
				l_term3 := (((385.0 / 110592.) * l_t) * (3.0 - 5.0 * l_t2)) / ((a_abs_zeta * a_abs_zeta) * a_abs_zeta)
				l_term4 := (((5.0 / 55296.0) * l_t2) * ((81.0 - 462.0 * l_t2) + (385.0 * l_t2) * l_t2)) / l_z32
				Result := (-(((l_term1 + l_term2) + l_term3) + l_term4) / l_rz)
			elseif a_z < 1.12 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := -0.00149282953213429172050073403334
				l_c1___2 := -0.00175640941909277865678308358128
				l_c2___0 := -0.00113346148874174912576929663517
				l_c3___3 := -0.00034691090981382974689396961817
				l_c4___2 := 0.00022752516104839243675693256916
				l_c5___1 := 0.00051764145724244846447294636552
				l_c6___2 := 0.00058906174858194233998714243010
				l_c7___0 := 0.00053485514521888073087240392846
				l_c8___0 := 0.00042891792986220150647633418796
				l_c9 := 0.00031639765900613633260381972850
				l_c10 := 0.00021908147678699592975840749194
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * (l_c7___0 + l_a___5 * (l_c8___0 + l_a___5 * (l_c9 + l_a___5 * l_c10))))))))))
			else
				l_t___0 := 1.0 / (a_z * (sqrt (1.0 - 1.0 / (a_z * a_z))))
				l_t2___0 := l_t___0 * l_t___0
				l_rz___0 := (sqrt (a_abs_zeta))
				l_z32___0 := (l_rz___0 * l_rz___0) * l_rz___0
				l_z92___0 := (l_z32___0 * l_z32___0) * l_z32___0
				l_term1___0 := ((-l_t2___0 * l_t___0) * (((30375.0 + 369603.0 * l_t2___0) + (765765.0 * l_t2___0) * l_t2___0) + ((425425.0 * l_t2___0) * l_t2___0) * l_t2___0)) / 414720.0
				l_term2___0 := 85085.0 / (663552.0 * l_z92___0)
				l_term3___0 := (((-385.0 / 110592.0) * l_t___0) * (3.0 + 5.0 * l_t2___0)) / ((a_abs_zeta * a_abs_zeta) * a_abs_zeta)
				l_term4___0 := (((5.0 / 55296.0) * l_t2___0) * ((81.0 + 462.0 * l_t2___0) + (385.0 * l_t2___0) * l_t2___0)) / l_z32___0
				Result := ((((l_term1___0 + l_term2___0) + l_term3___0) + l_term4___0) / l_rz___0)
			end
		end

	olver_B2 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_zi: REAL_64
			l_x___0: REAL_64
			l_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_c___1.make (<<1>>)
			create l_c___2.make (<<1>>)

			if a_z < 0.8 then
				l_x := (5.0 * a_z) / 2.0 - 1.0
				cheb_eval_inst.cheb_eval_e (B2_lt1_cs, l_x, l_c___1).do_nothing
				Result := (l_c___1.item.val / a_z)
			elseif a_z <= 1.2 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := 0.00055221307672129279005986982501
				l_c1___2 := 0.00089586516310476929281129228969
				l_c2___0 := 0.00067015003441569770883539158863
				l_c3___3 := 0.00010166263361949045682945811828
				l_c4___2 := -0.00044086345133806887291336488582
				l_c5___1 := -0.00073963081508788743392883072523
				l_c6___2 := -0.00076745494377839561259903887331
				l_c7___0 := -0.00060829038106040362291568012663
				l_c8___0 := -0.00037128707528893496121336168683
				l_c9 := -0.00014116325105702609866850307176
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * (l_c7___0 + l_a___5 * (l_c8___0 + l_a___5 * l_c9)))))))))
			else
				l_zi := 1.0 / a_z
				l_x___0 := (12.0 / 5.0) * l_zi - 1.0
				cheb_eval_inst.cheb_eval_e (B2_gt1_cs, l_x___0, l_c___2).do_nothing
				Result := (((l_c___2.item.val * l_zi) * l_zi) * l_zi)
			end
		end

	olver_B3 (a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_x___0: REAL_64
			l_zi2: REAL_64
			l_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_c___1.make (<<1>>)
			create l_c___2.make (<<1>>)

			if a_z < 0.8 then
				l_x := (5.0 * a_z) / 2.0 - 1.0
				cheb_eval_inst.cheb_eval_e (B3_lt1_cs, l_x, l_c___1).do_nothing
				Result := (l_c___1.item.val)
			elseif a_z < 1.2 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := -0.00047461779655995980754441833105
				l_c1___2 := -0.00095572913429464297452176811898
				l_c2___0 := -0.00080369634512082892655558133973
				l_c3___3 := -0.00000727921669154784138080600339
				l_c4___2 := 0.00093162500331581345235746518994
				l_c5___1 := 0.00149848796913751497227188612403
				l_c6___2 := 0.00148406039675949727870390426462
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * l_c6___2))))))
			else
				l_x___0 := 12.0 / (5.0 * a_z) - 1.0
				l_zi2 := 1.0 / (a_z * a_z)
				cheb_eval_inst.cheb_eval_e (B3_gt1_cs, l_x___0, l_c___2).do_nothing
				Result := (((l_c___2.item.val * l_zi2) * l_zi2) * l_zi2)
			end
		end

	olver_Bsum (a_nu: REAL_64; a_z: REAL_64; a_abs_zeta: REAL_64): REAL_64
		local
			l_nu2: REAL_64
			l_B0: REAL_64
			l_B1: REAL_64
			l_B2: REAL_64
			l_B3: REAL_64
		do
			l_nu2 := a_nu * a_nu
			l_B0 := (olver_B02 (a_z, a_abs_zeta))
			l_B1 := (olver_B1 (a_z, a_abs_zeta))
			l_B2 := (olver_B2 (a_z, a_abs_zeta))
			l_B3 := (olver_B3 (a_z, a_abs_zeta))
			Result := (((l_B0 + l_B1 / l_nu2) + l_B2 / (l_nu2 * l_nu2)) + l_B3 / (((l_nu2 * l_nu2) * l_nu2) * l_nu2))
		end

end
