class
	P_BESSEL_Y

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	bessel_yl_small_x (a_l: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_num_fact: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_den: REAL_64
			l_stat_df: INTEGER_32
			l_lmax: INTEGER_32
			l_t: REAL_64
			l_sum: REAL_64
			l_t_coeff: REAL_64
			l_t_power: REAL_64
			l_delta___0: REAL_64
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_num_fact.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_den := (pow_int_inst.gsl_sf_pow_int (a_x, a_l + 1))
					l_stat_df := (gamma_inst.gsl_sf_doublefact_e ((2 * a_l - 1).to_natural_32, l_num_fact))
					if l_stat_df = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_den /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_inff).to_double
							a_result.item.err := (builtin_inff).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_y.c"), 49, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_lmax := 200
						l_t := (-0.5 * a_x) * a_x
						l_sum := 1.0
						l_t_coeff := 1.0
						l_t_power := 1.0
						l_i := 1
						from
						until
							not (not js.loop_done and then (l_i <= l_lmax))
						loop
							l_t_coeff := l_t_coeff / (l_i * (2 * (l_i - a_l) - 1)).to_double
							l_t_power := l_t_power * l_t
							l_delta___0 := l_t_power * l_t_coeff
							l_sum := l_sum + l_delta___0
							if (fabs (l_delta___0 / l_sum)) < 0.5 * 2.2204460492503131e-16 then
								js.break
							end
							if not js.loop_jumped then
								l_i := l_i + 1
							end
						end
						a_result.item.val := (-l_num_fact.item.val / l_den) * l_sum
						a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_y02 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_y0_e2 (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_y0_e(x, &result)"), ce_string ("bessel_y.c"), 274, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_y0_e2 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cos_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cos_result.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_y.c"), 82, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (1.0 / 1.7976931348623157e+308 > 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x < 1.0 / 1.7976931348623157e+308 then
							from
							until
								js.loop_done
							loop
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_y.c"), 85, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_stat := (trig_inst.gsl_sf_cos_e (a_x, l_cos_result))
						a_result.item.val := -l_cos_result.item.val / a_x
						a_result.item.err := fabs (l_cos_result.item.err / a_x)
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := l_stat
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_y12 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_y1_e2 (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_y1_e(x, &result)"), ce_string ("bessel_y.c"), 279, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_y1_e2 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_sum: REAL_64
			l_cos_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sin_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_cos: INTEGER_32
			l_stat_sin: INTEGER_32
			l_cx: REAL_64
			l_sx: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: REAL_64
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_cos_result.make (<<1>>)
			create l_sin_result.make (<<1>>)

			if a_x <= 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_y.c"), 103, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 1.0 / 1.3407807929942596e+154 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_y.c"), 106, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 0.25 then
				l_y := a_x * a_x
				l_c1___2 := 1.0 / 2.0
				l_c2___0 := -1.0 / 8.0
				l_c3___3 := 1.0 / 144.0
				l_c4___2 := -1.0 / 5760.0
				l_c5___1 := 1.0 / 403200.0
				l_c6___2 := -1.0 / 43545600.0
				l_sum := 1.0 + l_y * (l_c1___2 + l_y * (l_c2___0 + l_y * (l_c3___3 + l_y * (l_c4___2 + l_y * (l_c5___1 + l_y * l_c6___2)))))
				a_result.item.val := -l_sum / l_y
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_stat_cos := (trig_inst.gsl_sf_cos_e (a_x, l_cos_result))
				l_stat_sin := (trig_inst.gsl_sf_sin_e (a_x, l_sin_result))
				l_cx := l_cos_result.item.val
				l_sx := l_sin_result.item.val
				a_result.item.val := -(l_cx / a_x + l_sx) / a_x
				l_tmp___6 := fabs (l_cos_result.item.err / a_x)
				a_result.item.err := (l_tmp___6 + l_sin_result.item.err) / (fabs (a_x))
				l_tmp___8 := fabs (l_sx / a_x)
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (l_tmp___8 + (fabs (l_cx / (a_x * a_x)))))
				if l_stat_cos /= 0 then
					l_tmp___11 := l_stat_cos
				else
					if l_stat_sin /= 0 then
						l_tmp___10 := l_stat_sin
					else
						l_tmp___10 := 0
					end
					l_tmp___11 := l_tmp___10
				end
				Result := l_tmp___11
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_y2 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_y2_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_y2_e(x, &result)"), ce_string ("bessel_y.c"), 284, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_y2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_sum: REAL_64
			l_cos_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sin_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_cos: INTEGER_32
			l_stat_sin: INTEGER_32
			l_sx: REAL_64
			l_cx: REAL_64
			l_a___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: REAL_64
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_cos_result.make (<<1>>)
			create l_sin_result.make (<<1>>)

			if a_x <= 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_y.c"), 141, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 1.0 / 5.6438030941222897e+102 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_y.c"), 144, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 0.5 then
				l_y := a_x * a_x
				l_c1___2 := 1.0 / 6.0
				l_c2___0 := 1.0 / 24.0
				l_c3___3 := -1.0 / 144.0
				l_c4___2 := 1.0 / 3456.0
				l_c5___1 := -1.0 / 172800.0
				l_c6___2 := 1.0 / 14515200.0
				l_c7___0 := -1.0 / 1828915200.0
				l_sum := 1.0 + l_y * (l_c1___2 + l_y * (l_c2___0 + l_y * (l_c3___3 + l_y * (l_c4___2 + l_y * (l_c5___1 + l_y * (l_c6___2 + l_y * l_c7___0))))))
				a_result.item.val := (-3.0 / ((a_x * a_x) * a_x)) * l_sum
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_stat_cos := (trig_inst.gsl_sf_cos_e (a_x, l_cos_result))
				l_stat_sin := (trig_inst.gsl_sf_sin_e (a_x, l_sin_result))
				l_sx := l_sin_result.item.val
				l_cx := l_cos_result.item.val
				l_a___5 := 3.0 / (a_x * a_x)
				a_result.item.val := ((1.0 - l_a___5) / a_x) * l_cx - l_a___5 * l_sx
				l_tmp___6 := fabs ((1.0 - l_a___5) / a_x)
				a_result.item.err := l_cos_result.item.err * l_tmp___6 + l_sin_result.item.err * (fabs (l_a___5))
				l_tmp___8 := fabs (l_cx / a_x)
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (l_tmp___8 + (fabs (l_sx / (a_x * a_x)))))
				if l_stat_cos /= 0 then
					l_tmp___11 := l_stat_cos
				else
					if l_stat_sin /= 0 then
						l_tmp___10 := l_stat_sin
					else
						l_tmp___10 := 0
					end
					l_tmp___11 := l_tmp___10
				end
				Result := l_tmp___11
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_yl (a_l: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_yl_e (a_l, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_yl_e(l, x, &result)"), ce_string ("bessel_y.c"), 289, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_yl_array (a_lmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
			l_r_yell: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_yellm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_1: INTEGER_32
			l_stat_0: INTEGER_32
			l_yellp1: REAL_64
			l_yell: REAL_64
			l_yellm1: REAL_64
			l_ell: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result.make (<<1>>)
			create l_r_yell.make (<<1>>)
			create l_r_yellm1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lmax < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("error"), ce_string ("bessel_y.c"), 237, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_lmax = 0 then
							l_stat := (gsl_sf_bessel_y0_e2 (a_x, l_result))
							a_result_array[0] := l_result.item.val
							Result := l_stat
							js.return
						else
							l_stat_1 := (gsl_sf_bessel_y1_e2 (a_x, l_r_yell))
							l_stat_0 := (gsl_sf_bessel_y0_e2 (a_x, l_r_yellm1))
							l_yell := l_r_yell.item.val
							l_yellm1 := l_r_yellm1.item.val
							a_result_array[0] := l_yellm1
							a_result_array[1] := l_yell
							l_ell := 1
							from
							until
								not (l_ell < a_lmax)
							loop
								l_yellp1 := ((2 * l_ell + 1).to_double / a_x) * l_yell - l_yellm1
								a_result_array[(l_ell + 1)] := l_yellp1
								l_yellm1 := l_yell
								l_yell := l_yellp1
								l_ell := l_ell + 1
							end
							if l_stat_0 /= 0 then
								l_tmp___3 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___2 := l_stat_1
								else
									l_tmp___2 := 0
								end
								l_tmp___3 := l_tmp___2
							end
							Result := l_tmp___3
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_yl_e (a_l: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_pre: REAL_64
			l_status___0: INTEGER_32
			l_pre___0: REAL_64
			l_r_by: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_bym: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_1: INTEGER_32
			l_stat_0: INTEGER_32
			l_bym: REAL_64
			l_by: REAL_64
			l_byp: REAL_64
			l_j: INTEGER_32
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r_by.make (<<1>>)
			create l_r_bym.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_l < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_y.c"), 181, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_l = 0 then
							Result := (gsl_sf_bessel_y0_e2 (a_x, a_result))
							js.return
						elseif a_l = 1 then
							Result := (gsl_sf_bessel_y1_e2 (a_x, a_result))
							js.return
						elseif a_l = 2 then
							Result := (gsl_sf_bessel_y2_e (a_x, a_result))
							js.return
						elseif a_x < 3.0 then
							Result := (bessel_yl_small_x (a_l, a_x, a_result))
							js.return
						elseif 6.0554544523933429e-06 * a_x > (a_l * a_l + a_l).to_double + 1.0 then
							l_status := (bessel_inst.gsl_sf_bessel_Ynu_asympx_e (a_l.to_double + 0.5, a_x, a_result))
							l_pre := (sqrt ((0.5 * 3.14159265358979323846) / a_x))
							a_result.item.val := a_result.item.val * l_pre
							a_result.item.err := a_result.item.err * l_pre
							Result := l_status
							js.return
						elseif a_l > 40 then
							l_status___0 := (bessel_olver_inst.gsl_sf_bessel_Ynu_asymp_Olver_e (a_l.to_double + 0.5, a_x, a_result))
							l_pre___0 := (sqrt ((0.5 * 3.14159265358979323846) / a_x))
							a_result.item.val := a_result.item.val * l_pre___0
							a_result.item.err := a_result.item.err * l_pre___0
							Result := l_status___0
							js.return
						else
							l_stat_1 := (gsl_sf_bessel_y1_e2 (a_x, l_r_by))
							l_stat_0 := (gsl_sf_bessel_y0_e2 (a_x, l_r_bym))
							l_bym := l_r_bym.item.val
							l_by := l_r_by.item.val
							l_j := 1
							from
							until
								not (l_j < a_l)
							loop
								l_byp := ((2 * l_j + 1).to_double / a_x) * l_by - l_bym
								l_bym := l_by
								l_by := l_byp
								l_j := l_j + 1
							end
							a_result.item.val := l_by
							l_tmp___11 := fabs (a_result.item.val)
							l_tmp___12 := fabs (l_r_by.item.err / l_r_by.item.val)
							a_result.item.err := l_tmp___11 * ((2.2204460492503131e-16 + l_tmp___12) + (fabs (l_r_bym.item.err / l_r_bym.item.val)))
							if l_stat_1 /= 0 then
								l_tmp___15 := l_stat_1
							else
								if l_stat_0 /= 0 then
									l_tmp___14 := l_stat_0
								else
									l_tmp___14 := 0
								end
								l_tmp___15 := l_tmp___14
							end
							Result := l_tmp___15
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
