class
	P_BITREVERSE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	fft_complex_bitreverse_order (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			js: JUMP_STATE
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp_real := a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32]
					l_tmp_imag := a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32] := l_tmp_real
					a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32] := l_tmp_imag
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

	fft_complex_float_bitreverse_order (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp_real: REAL_32
			l_tmp_imag: REAL_32
			js: JUMP_STATE
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp_real := a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32]
					l_tmp_imag := a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32] := l_tmp_real
					a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32] := l_tmp_imag
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

	fft_real_bitreverse_order (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp := a_data[(a_stride * l_i).to_integer_32]
					a_data[(a_stride * l_i).to_integer_32] := a_data[(a_stride * l_j).to_integer_32]
					a_data[(a_stride * l_j).to_integer_32] := l_tmp
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

	fft_real_float_bitreverse_order (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp := a_data[(a_stride * l_i).to_integer_32]
					a_data[(a_stride * l_i).to_integer_32] := a_data[(a_stride * l_j).to_integer_32]
					a_data[(a_stride * l_j).to_integer_32] := l_tmp
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

end
