class
	P_C_PASS_N

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	fft_complex_float_pass_n (a_in: CE_POINTER [REAL_32]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_32]; a_ostride: NATURAL_32; a_sign: INTEGER_32; a_factor: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle: CE_POINTER [PD_GSL_COMPLEX_FLOAT]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_p_1: NATURAL_32
			l_jump: NATURAL_32
			l_e: NATURAL_32
			l_e1: NATURAL_32
			l_idx: NATURAL_32
			l_idxc: NATURAL_32
			l_idx___0: NATURAL_32
			l_idx_step: NATURAL_32
			l_w_real: REAL_32
			l_w_imag: REAL_32
			l_em: NATURAL_32
			l_ecm: NATURAL_32
			l_xp_real: REAL_32
			l_xp_imag: REAL_32
			l_xm_real: REAL_32
			l_xm_imag: REAL_32
			l_ap: REAL_32
			l_am: REAL_32
			l_sum_real: REAL_32
			l_sumc_real: REAL_32
			l_bp: REAL_32
			l_bm: REAL_32
			l_sum_imag: REAL_32
			l_sumc_imag: REAL_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_w_real___0: REAL_32
			l_w_imag___0: REAL_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_m___4 := a_n // a_factor
			l_q___3 := a_n // a_product
			l_p_1 := a_product // a_factor
			l_jump := (a_factor - {NATURAL_32} 1) * l_p_1
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_m___4)
			loop
				a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32]
				a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32]
				l_i := l_i + 1
			end
			l_e := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
			loop
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_m___4)
				loop
					l_idx := l_i + l_e * l_m___4
					l_idxc := l_i + (a_factor - l_e) * l_m___4
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idx).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx).to_integer_32] + a_in[(({NATURAL_32} 2 * a_istride) * l_idxc).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idx + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx + {NATURAL_32} 1).to_integer_32] + a_in[(({NATURAL_32} 2 * a_istride) * l_idxc + {NATURAL_32} 1).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idxc).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx).to_integer_32] - a_in[(({NATURAL_32} 2 * a_istride) * l_idxc).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idxc + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx + {NATURAL_32} 1).to_integer_32] - a_in[(({NATURAL_32} 2 * a_istride) * l_idxc + {NATURAL_32} 1).to_integer_32]
					l_i := l_i + 1
				end
				l_e := l_e + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_m___4)
			loop
				a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32]
				a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32]
				l_i := l_i + 1
			end
			l_e1 := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e1 < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
			loop
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_m___4)
				loop
					a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32] + (a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4)).to_integer_32])
					a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32] + (a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				l_e1 := l_e1 + 1
			end
			l_e := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
			loop
				l_idx___0 := l_e * l_q___3
				l_idx_step := l_e * l_q___3
				l_em := l_e * l_m___4
				l_ecm := (a_factor - l_e) * l_m___4
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_m___4)
				loop
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em)).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32]
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em) + {NATURAL_32} 1).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32]
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm)).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32]
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm) + {NATURAL_32} 1).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32]
					l_i := l_i + 1
				end
				l_e1 := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_e1 < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
				loop
					if l_idx___0 = {NATURAL_32} 0 then
						l_w_real := (1).to_real
						l_w_imag := (0).to_real
					elseif a_sign = -1 then
						l_w_real := (a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[0]
						l_w_imag := (a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[1]
					else
						l_w_real := (a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[0]
						l_w_imag := -(a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[1]
					end
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_m___4)
					loop
						l_xp_real := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4)).to_integer_32]
						l_xp_imag := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32]
						l_xm_real := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + (a_factor - l_e1) * l_m___4)).to_integer_32]
						l_xm_imag := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + (a_factor - l_e1) * l_m___4) + {NATURAL_32} 1).to_integer_32]
						l_ap := l_w_real * l_xp_real
						l_am := l_w_imag * l_xm_imag
						l_sum_real := l_ap - l_am
						l_sumc_real := l_ap + l_am
						l_bp := l_w_real * l_xp_imag
						l_bm := l_w_imag * l_xm_real
						l_sum_imag := l_bp + l_bm
						l_sumc_imag := l_bp - l_bm
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em)).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em)).to_integer_32] + l_sum_real
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em) + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em) + {NATURAL_32} 1).to_integer_32] + l_sum_imag
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm)).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm)).to_integer_32] + l_sumc_real
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm) + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm) + {NATURAL_32} 1).to_integer_32] + l_sumc_imag
						l_i := l_i + 1
					end
					l_idx___0 := l_idx___0 + l_idx_step
					l_idx___0 := l_idx___0 \\ (a_factor * l_q___3)
					l_e1 := l_e1 + 1
				end
				l_e := l_e + 1
			end
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_k1 := (0).to_natural_32
			from
			until
				not (l_k1 < l_p_1)
			loop
				a_out[(({NATURAL_32} 2 * a_ostride) * l_k1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_k1).to_integer_32]
				a_out[(({NATURAL_32} 2 * a_ostride) * l_k1 + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_k1 + {NATURAL_32} 1).to_integer_32]
				l_k1 := l_k1 + 1
			end
			l_e1 := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e1 < a_factor))
			loop
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_p_1)
				loop
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_k1 + l_e1 * l_p_1)).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_k1 + l_e1 * l_m___4)).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_k1 + l_e1 * l_p_1) + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_k1 + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_k1 := l_k1 + 1
				end
				l_e1 := l_e1 + 1
			end
			l_i := l_p_1
			l_j := a_product
			l_k := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_k < l_q___3))
			loop
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_p_1)
				loop
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32]
					l_i := l_i + 1
					l_j := l_j + 1
					l_k1 := l_k1 + 1
				end
				l_j := l_j + l_jump
				l_k := l_k + 1
			end
			l_i := l_p_1
			l_j := a_product
			l_k := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_k < l_q___3))
			loop
				l_k1 := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k1 < l_p_1))
				loop
					l_e1 := (1).to_natural_32
					from
					until
						not (l_e1 < a_factor)
					loop
						l_x_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_e1 * l_m___4)).to_integer_32]
						l_x_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32]
						if a_sign = -1 then
							l_w_real___0 := (a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[0]
							l_w_imag___0 := (a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[1]
						else
							l_w_real___0 := (a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[0]
							l_w_imag___0 := -(a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[1]
						end
						a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_e1 * l_p_1)).to_integer_32] := l_w_real___0 * l_x_real - l_w_imag___0 * l_x_imag
						a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_e1 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w_real___0 * l_x_imag + l_w_imag___0 * l_x_real
						l_e1 := l_e1 + 1
					end
					l_i := l_i + 1
					l_j := l_j + 1
					l_k1 := l_k1 + 1
				end
				l_j := l_j + l_jump
				l_k := l_k + 1
			end
			Result := 0
		end

	fft_complex_pass_n (a_in: CE_POINTER [REAL_64]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_64]; a_ostride: NATURAL_32; a_sign: INTEGER_32; a_factor: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_p_1: NATURAL_32
			l_jump: NATURAL_32
			l_e: NATURAL_32
			l_e1: NATURAL_32
			l_idx: NATURAL_32
			l_idxc: NATURAL_32
			l_idx___0: NATURAL_32
			l_idx_step: NATURAL_32
			l_w_real: REAL_64
			l_w_imag: REAL_64
			l_em: NATURAL_32
			l_ecm: NATURAL_32
			l_xp_real: REAL_64
			l_xp_imag: REAL_64
			l_xm_real: REAL_64
			l_xm_imag: REAL_64
			l_ap: REAL_64
			l_am: REAL_64
			l_sum_real: REAL_64
			l_sumc_real: REAL_64
			l_bp: REAL_64
			l_bm: REAL_64
			l_sum_imag: REAL_64
			l_sumc_imag: REAL_64
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_w_real___0: REAL_64
			l_w_imag___0: REAL_64
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_m___4 := a_n // a_factor
			l_q___3 := a_n // a_product
			l_p_1 := a_product // a_factor
			l_jump := (a_factor - {NATURAL_32} 1) * l_p_1
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_m___4)
			loop
				a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32]
				a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32]
				l_i := l_i + 1
			end
			l_e := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
			loop
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_m___4)
				loop
					l_idx := l_i + l_e * l_m___4
					l_idxc := l_i + (a_factor - l_e) * l_m___4
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idx).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx).to_integer_32] + a_in[(({NATURAL_32} 2 * a_istride) * l_idxc).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idx + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx + {NATURAL_32} 1).to_integer_32] + a_in[(({NATURAL_32} 2 * a_istride) * l_idxc + {NATURAL_32} 1).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idxc).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx).to_integer_32] - a_in[(({NATURAL_32} 2 * a_istride) * l_idxc).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_idxc + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_idx + {NATURAL_32} 1).to_integer_32] - a_in[(({NATURAL_32} 2 * a_istride) * l_idxc + {NATURAL_32} 1).to_integer_32]
					l_i := l_i + 1
				end
				l_e := l_e + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_m___4)
			loop
				a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32]
				a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32]
				l_i := l_i + 1
			end
			l_e1 := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e1 < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
			loop
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_m___4)
				loop
					a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32] + (a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4)).to_integer_32])
					a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32] + (a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				l_e1 := l_e1 + 1
			end
			l_e := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
			loop
				l_idx___0 := l_e * l_q___3
				l_idx_step := l_e * l_q___3
				l_em := l_e * l_m___4
				l_ecm := (a_factor - l_e) * l_m___4
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_m___4)
				loop
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em)).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32]
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em) + {NATURAL_32} 1).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32]
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm)).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i).to_integer_32]
					a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm) + {NATURAL_32} 1).to_integer_32] := a_out[(({NATURAL_32} 2 * a_ostride) * l_i + {NATURAL_32} 1).to_integer_32]
					l_i := l_i + 1
				end
				l_e1 := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_e1 < (a_factor - {NATURAL_32} 1) // {NATURAL_32} 2 + {NATURAL_32} 1))
				loop
					if l_idx___0 = {NATURAL_32} 0 then
						l_w_real := (1).to_double
						l_w_imag := (0).to_double
					elseif a_sign = -1 then
						l_w_real := (a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[0]
						l_w_imag := (a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[1]
					else
						l_w_real := (a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[0]
						l_w_imag := -(a_twiddle + (l_idx___0 - {NATURAL_32} 1).to_integer_32).item.dat[1]
					end
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_m___4)
					loop
						l_xp_real := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4)).to_integer_32]
						l_xp_imag := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32]
						l_xm_real := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + (a_factor - l_e1) * l_m___4)).to_integer_32]
						l_xm_imag := a_out[(({NATURAL_32} 2 * a_ostride) * (l_i + (a_factor - l_e1) * l_m___4) + {NATURAL_32} 1).to_integer_32]
						l_ap := l_w_real * l_xp_real
						l_am := l_w_imag * l_xm_imag
						l_sum_real := l_ap - l_am
						l_sumc_real := l_ap + l_am
						l_bp := l_w_real * l_xp_imag
						l_bm := l_w_imag * l_xm_real
						l_sum_imag := l_bp + l_bm
						l_sumc_imag := l_bp - l_bm
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em)).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em)).to_integer_32] + l_sum_real
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em) + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_em) + {NATURAL_32} 1).to_integer_32] + l_sum_imag
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm)).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm)).to_integer_32] + l_sumc_real
						a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm) + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_ecm) + {NATURAL_32} 1).to_integer_32] + l_sumc_imag
						l_i := l_i + 1
					end
					l_idx___0 := l_idx___0 + l_idx_step
					l_idx___0 := l_idx___0 \\ (a_factor * l_q___3)
					l_e1 := l_e1 + 1
				end
				l_e := l_e + 1
			end
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_k1 := (0).to_natural_32
			from
			until
				not (l_k1 < l_p_1)
			loop
				a_out[(({NATURAL_32} 2 * a_ostride) * l_k1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_k1).to_integer_32]
				a_out[(({NATURAL_32} 2 * a_ostride) * l_k1 + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_k1 + {NATURAL_32} 1).to_integer_32]
				l_k1 := l_k1 + 1
			end
			l_e1 := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_e1 < a_factor))
			loop
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_p_1)
				loop
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_k1 + l_e1 * l_p_1)).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_k1 + l_e1 * l_m___4)).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_k1 + l_e1 * l_p_1) + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * (l_k1 + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_k1 := l_k1 + 1
				end
				l_e1 := l_e1 + 1
			end
			l_i := l_p_1
			l_j := a_product
			l_k := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_k < l_q___3))
			loop
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_p_1)
				loop
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32]
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j + {NATURAL_32} 1).to_integer_32] := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32]
					l_i := l_i + 1
					l_j := l_j + 1
					l_k1 := l_k1 + 1
				end
				l_j := l_j + l_jump
				l_k := l_k + 1
			end
			l_i := l_p_1
			l_j := a_product
			l_k := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_k < l_q___3))
			loop
				l_k1 := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k1 < l_p_1))
				loop
					l_e1 := (1).to_natural_32
					from
					until
						not (l_e1 < a_factor)
					loop
						l_x_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_e1 * l_m___4)).to_integer_32]
						l_x_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_e1 * l_m___4) + {NATURAL_32} 1).to_integer_32]
						if a_sign = -1 then
							l_w_real___0 := (a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[0]
							l_w_imag___0 := (a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[1]
						else
							l_w_real___0 := (a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[0]
							l_w_imag___0 := -(a_twiddle + (((l_e1 - {NATURAL_32} 1) * l_q___3 + l_k) - {NATURAL_32} 1).to_integer_32).item.dat[1]
						end
						a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_e1 * l_p_1)).to_integer_32] := l_w_real___0 * l_x_real - l_w_imag___0 * l_x_imag
						a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_e1 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w_real___0 * l_x_imag + l_w_imag___0 * l_x_real
						l_e1 := l_e1 + 1
					end
					l_i := l_i + 1
					l_j := l_j + 1
					l_k1 := l_k1 + 1
				end
				l_j := l_j + l_jump
				l_k := l_k + 1
			end
			Result := 0
		end

end
