class
	P_CDOTC_SUB

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_cdotc_sub (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_result: CE_POINTER [ANY])
		local
			l_r_real: REAL_32
			l_r_imag: REAL_32
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_y_real: REAL_32
			l_y_imag: REAL_32
		do
			l_r_real := (0.0).truncated_to_real
			l_r_imag := (0.0).truncated_to_real
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_i := 0
			from
			until
				not (l_i < a_N)
			loop
				l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
				l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
				l_y_real := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy]
				l_y_imag := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy + 1)]
				l_r_real := (l_r_real.to_double + ((l_x_real * l_y_real).to_double - (-1.0 * l_x_imag.to_double) * l_y_imag.to_double)).truncated_to_real
				l_r_imag := (l_r_imag.to_double + ((l_x_real * l_y_imag).to_double + (-1.0 * l_x_imag.to_double) * l_y_real.to_double)).truncated_to_real
				l_ix := l_ix + a_incX
				l_iy := l_iy + a_incY
				l_i := l_i + 1
			end
			create {CE_POINTER [REAL_32]}.make_cast (a_result)[0] := l_r_real
			create {CE_POINTER [REAL_32]}.make_cast (a_result)[1] := l_r_imag
		end

end
