class
	P_CGEMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_cgemm (a_Order: NATURAL_32; a_TransA: NATURAL_32; a_TransB: NATURAL_32; a_M: INTEGER_32; a_N: INTEGER_32; a_K: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta: CE_POINTER [ANY]; a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_ldf: INTEGER_32
			l_ldg: INTEGER_32
			l_conjF: INTEGER_32
			l_conjG: INTEGER_32
			l_TransF: INTEGER_32
			l_TransG: INTEGER_32
			l_F___0: CE_POINTER [REAL_32]
			l_G: CE_POINTER [REAL_32]
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Fik_real: REAL_32
			l_Fik_imag: REAL_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Gkj_real: REAL_32
			l_Gkj_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Fik_real___0: REAL_32
			l_Fik_imag___0: REAL_32
			l_Gjk_real: REAL_32
			l_Gjk_imag: REAL_32
			l_Fki_real: REAL_32
			l_Fki_imag: REAL_32
			l_temp_real___1: REAL_32
			l_temp_imag___1: REAL_32
			l_Gkj_real___0: REAL_32
			l_Gkj_imag___0: REAL_32
			l_temp_real___2: REAL_32
			l_temp_imag___2: REAL_32
			l_Fki_real___0: REAL_32
			l_Fki_imag___0: REAL_32
			l_Gjk_real___0: REAL_32
			l_Gjk_imag___0: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_F___0.make
			create l_G.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_F___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)
							l_ldf := a_lda
							if a_TransA = {NATURAL_32} 113 then
								l_conjF := -1
							else
								l_conjF := 1
							end
							if a_TransA = {NATURAL_32} 111 then
								l_TransF := 111
							else
								l_TransF := 112
							end
							l_G := create {CE_POINTER [REAL_32]}.make_cast (a_B)
							l_ldg := a_ldb
							if a_TransB = {NATURAL_32} 113 then
								l_conjG := -1
							else
								l_conjG := 1
							end
							if a_TransB = {NATURAL_32} 111 then
								l_TransG := 111
							else
								l_TransG := 112
							end
						else
							l_n1 := a_N
							l_n2 := a_M
							l_F___0 := create {CE_POINTER [REAL_32]}.make_cast (a_B)
							l_ldf := a_ldb
							if a_TransB = {NATURAL_32} 113 then
								l_conjF := -1
							else
								l_conjF := 1
							end
							if a_TransB = {NATURAL_32} 111 then
								l_TransF := 111
							else
								l_TransF := 112
							end
							l_G := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)
							l_ldg := a_lda
							if a_TransA = {NATURAL_32} 113 then
								l_conjG := -1
							else
								l_conjG := 1
							end
							if a_TransA = {NATURAL_32} 111 then
								l_TransG := 111
							else
								l_TransG := 112
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							l_i := 0
							from
							until
								not (not js.loop_done and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Cij_real := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
								l_Cij_imag := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
								create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 44 -- skip if block
					end
				when 10 then -- if:
						if l_TransF /= 111 then
							l_pos := -1 + 25 -- skip if block
						end
				when 11 then -- if:
						if l_TransG /= 111 then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						l_k := 0
				when 13 then -- loop condition:
						if not (not js.loop_done and then (l_k < a_K)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 14 then -- loop body:
						l_i := 0
				when 15 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_n1)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 16 then -- loop body:
						l_Fik_real := l_F___0[2 * (l_ldf * l_i + l_k)]
						l_Fik_imag := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_i + l_k) + 1)])
						l_temp_real := l_alpha_real * l_Fik_real - l_alpha_imag * l_Fik_imag
						l_temp_imag := l_alpha_real * l_Fik_imag + l_alpha_imag * l_Fik_real
						if l_temp_real.to_double /= 0.0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_temp_imag.to_double /= 0.0 then
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						l_j := 0
						from
						until
							not (l_j < l_n2)
						loop
							l_Gkj_real := l_G[2 * (l_ldg * l_k + l_j)]
							l_Gkj_imag := (l_conjG.to_real * l_G[(2 * (l_ldg * l_k + l_j) + 1)])
							create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_temp_real * l_Gkj_real - l_temp_imag * l_Gkj_imag)
							create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_temp_real * l_Gkj_imag + l_temp_imag * l_Gkj_real)
							l_j := l_j + 1
						end
				when 20 then
						l_i := l_i + 1
						l_pos := -1 + 15 -- back to loop condition
				when 21 then -- loop done
						l_k := l_k + 1
						l_pos := -1 + 13 -- back to loop condition
				when 22 then -- loop done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___5
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 25 then -- else: | _L___5:
						if l_TransF /= 111 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_TransG = 112 then
							l_i := 0
							from
							until
								not (not js.loop_done and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_done and then (l_j < l_n2))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Fik_real___0 := l_F___0[2 * (l_ldf * l_i + l_k)]
										l_Fik_imag___0 := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_i + l_k) + 1)])
										l_Gjk_real := l_G[2 * (l_ldg * l_j + l_k)]
										l_Gjk_imag := (l_conjG.to_real * l_G[(2 * (l_ldg * l_j + l_k) + 1)])
										l_temp_real___0 := l_temp_real___0 + (l_Fik_real___0 * l_Gjk_real - l_Fik_imag___0 * l_Gjk_imag)
										l_temp_imag___0 := l_temp_imag___0 + (l_Fik_real___0 * l_Gjk_imag + l_Fik_imag___0 * l_Gjk_real)
										l_k := l_k + 1
									end
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0)
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 28 -- goto _L___4
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 28 then -- else: | _L___4:
						if l_TransF /= 112 then
							l_pos := -1 + 43 -- skip if block
						end
				when 29 then -- if:
						if l_TransG /= 111 then
							l_pos := -1 + 41 -- skip if block
						end
				when 30 then -- if:
						l_k := 0
				when 31 then -- loop condition:
						if not (not js.loop_done and then (l_k < a_K)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 32 then -- loop body:
						l_i := 0
				when 33 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_n1)) then
							l_pos := -1 + 39 -- skip loop
						end
				when 34 then -- loop body:
						l_Fki_real := l_F___0[2 * (l_ldf * l_k + l_i)]
						l_Fki_imag := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_k + l_i) + 1)])
						l_temp_real___1 := l_alpha_real * l_Fki_real - l_alpha_imag * l_Fki_imag
						l_temp_imag___1 := l_alpha_real * l_Fki_imag + l_alpha_imag * l_Fki_real
						if l_temp_real___1.to_double /= 0.0 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_temp_imag___1.to_double /= 0.0 then
							l_pos := -1 + 37 -- goto _L___2
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___2:
						l_j := 0
						from
						until
							not (l_j < l_n2)
						loop
							l_Gkj_real___0 := l_G[2 * (l_ldg * l_k + l_j)]
							l_Gkj_imag___0 := (l_conjG.to_real * l_G[(2 * (l_ldg * l_k + l_j) + 1)])
							create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_temp_real___1 * l_Gkj_real___0 - l_temp_imag___1 * l_Gkj_imag___0)
							create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_temp_real___1 * l_Gkj_imag___0 + l_temp_imag___1 * l_Gkj_real___0)
							l_j := l_j + 1
						end
				when 38 then
						l_i := l_i + 1
						l_pos := -1 + 33 -- back to loop condition
				when 39 then -- loop done
						l_k := l_k + 1
						l_pos := -1 + 31 -- back to loop condition
				when 40 then -- loop done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 43 -- goto _L___3
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___3:
						if l_TransF = 112 then
							if l_TransG = 112 then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_done and then (l_j < l_n2))
									loop
										l_temp_real___2 := (0.0).truncated_to_real
										l_temp_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < a_K)
										loop
											l_Fki_real___0 := l_F___0[2 * (l_ldf * l_k + l_i)]
											l_Fki_imag___0 := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_k + l_i) + 1)])
											l_Gjk_real___0 := l_G[2 * (l_ldg * l_j + l_k)]
											l_Gjk_imag___0 := (l_conjG.to_real * l_G[(2 * (l_ldg * l_j + l_k) + 1)])
											l_temp_real___2 := l_temp_real___2 + (l_Fki_real___0 * l_Gjk_real___0 - l_Fki_imag___0 * l_Gjk_imag___0)
											l_temp_imag___2 := l_temp_imag___2 + (l_Fki_real___0 * l_Gjk_imag___0 + l_Fki_imag___0 * l_Gjk_real___0)
											l_k := l_k + 1
										end
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_alpha_real * l_temp_real___2 - l_alpha_imag * l_temp_imag___2)
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_alpha_real * l_temp_imag___2 + l_alpha_imag * l_temp_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_gemm_c.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_gemm_c.h"), ce_string ("unrecognized operation")])
						end
				when 44 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
