class
	P_CHEB_EVAL_MODE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cheb_eval_mode_e (a_cs: CE_POINTER [PD_CHEB_SERIES_STRUCT]; a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_j: INTEGER_32
			l_d: REAL_64
			l_dd: REAL_64
			l_y: REAL_64
			l_y2: REAL_64
			l_eval_order: INTEGER_32
			l_temp: REAL_64
			l_tmp___0: REAL_64
		do
			l_d := 0.0
			l_dd := 0.0
			l_y := ((2. * a_x - a_cs.item.a) - a_cs.item.b) / (a_cs.item.b - a_cs.item.a)
			l_y2 := 2.0 * l_y
			if (gsl_gsl_mode_inst.GSL_MODE_PREC (a_mode)) = {NATURAL_32} 0 then
				l_eval_order := a_cs.item.order
			else
				l_eval_order := a_cs.item.order_sp
			end
			l_j := l_eval_order
			from
			until
				not (l_j >= 1)
			loop
				l_temp := l_d
				l_d := (l_y2 * l_d - l_dd) + a_cs.item.c[l_j]
				l_dd := l_temp
				l_j := l_j - 1
			end
			a_result.item.val := (l_y * l_d - l_dd) + 0.5 * a_cs.item.c[0]
			l_tmp___0 := fabs (a_result.item.val)
			a_result.item.err := 2.2204460492503131e-16 * l_tmp___0 + (fabs (a_cs.item.c[l_eval_order]))
			Result := 0
		end

end
