class
	P_CHISQ

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_chisq_P (a_x: REAL_64; a_nu: REAL_64): REAL_64
		do
			Result := (gamma_inst.gsl_cdf_gamma_P (a_x, a_nu / (2).to_double, 2.0))
		end

	gsl_cdf_chisq_Q (a_x: REAL_64; a_nu: REAL_64): REAL_64
		do
			Result := (gamma_inst.gsl_cdf_gamma_Q (a_x, a_nu / (2).to_double, 2.0))
		end

	gsl_ran_chisq (a_r___3: CE_POINTER [PD_GSL_RNG]; a_nu: REAL_64): REAL_64
		local
			l_chisq: REAL_64
		do
			l_chisq := (2).to_double * (gamma_inst.gsl_ran_gamma (a_r___3, a_nu / (2).to_double, 1.0))
			Result := l_chisq
		end

	gsl_ran_chisq_pdf (a_x: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lngamma: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_lngamma := (gamma_inst.gsl_sf_lngamma (a_nu / (2).to_double))
				l_p := (exp (((a_nu / (2).to_double - (1).to_double) * (log (a_x / (2).to_double)) - a_x / (2).to_double) - l_lngamma)) / (2).to_double
				Result := l_p
			end
		end

end
