class
	P_CHOLESKYC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cholesky_complex_conj_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX])
		local
			l_i: NATURAL_32
			l_z: PD_GSL_COMPLEX
		do
			create l_z.make

			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_v.item.size)
			loop
				l_z := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_i)).twin
				gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_v, l_i, (math_inst.gsl_complex_conjugate (l_z.twin)).twin)
				l_i := l_i + 1
			end
		end

	gsl_linalg_complex_cholesky_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_z: CE_ARRAY [PD_GSL_COMPLEX]
			l_ajj: REAL_64
			l_aj: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]
			l_av: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_aj___0: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_am: CE_ARRAY [PD_GSL_MATRIX_COMPLEX_VIEW]
			l_tmp___3: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_z.make (<<1>>)
			create l_aj.make (<<1>>)
			create l_av.make (<<1>>)
			create l_aj___0.make (<<1>>)
			create l_am.make (<<1>>)
			create l_tmp___3.make

			l_N := a_A___0.item.size1
			if l_N /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("cholesky decomposition requires square matrix"), ce_string ("choleskyc.c"), 57, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_N))
				loop
					l_z.item := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_j, l_j)).twin
					l_ajj := l_z.item.dat[0]
					if l_j > {NATURAL_32} 0 then
						l_aj.item := (rowcol_source_inst.gsl_matrix_complex_const_subrow (a_A___0, l_j, (0).to_natural_32, l_j)).twin
						blas_inst.gsl_blas_zdotc ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_aj.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_aj.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), l_z).do_nothing
						l_ajj := l_ajj - (l_z.item.dat[0])
					end
					if l_ajj <= 0.0 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrix is not positive definite"), ce_string ("choleskyc.c"), 81, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_ajj := sqrt (l_ajj)
						from
						until
							js.loop_done
						loop
							l_z.item.dat[0] := l_ajj
							l_z.item.dat[1] := 0.0
							js.break
						end
						gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_j, l_j, (l_z.item).twin)
						if l_j < l_N - {NATURAL_32} 1 then
							l_av.item := (rowcol_source_inst.gsl_matrix_complex_subcolumn (a_A___0, l_j, l_j + {NATURAL_32} 1, (l_N - l_j) - {NATURAL_32} 1)).twin
							if l_j > {NATURAL_32} 0 then
								l_aj___0.item := (rowcol_source_inst.gsl_matrix_complex_subrow (a_A___0, l_j, (0).to_natural_32, l_j)).twin
								l_am.item := (submatrix_source_inst.gsl_matrix_complex_submatrix (a_A___0, l_j + {NATURAL_32} 1, (0).to_natural_32, (l_N - l_j) - {NATURAL_32} 1, l_j)).twin
								cholesky_complex_conj_vector (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_aj___0.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))
								l_tmp___3 := (gsl_gsl_complex_math_inst.gsl_complex_rect (1.0, 0.0)).twin
								blas_inst.gsl_blas_zgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, (gsl_gsl_complex_math_inst.gsl_complex_rect (-1.0, 0.0)).twin, (create {CE_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (l_am.item.c_pointer + (create {PD_GSL_MATRIX_COMPLEX_VIEW}.make).offset_of ("matrix"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_aj___0.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), l_tmp___3.twin, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_av.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
								cholesky_complex_conj_vector (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_aj___0.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))
							end
							blas_inst.gsl_blas_zdscal (1.0 / l_ajj, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_av.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))
						end
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := (1).to_natural_32
					from
					until
						not (not js.loop_done and then (l_i < l_N))
					loop
						l_j := (0).to_natural_32
						from
						until
							not (l_j < l_i)
						loop
							l_z.item := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)).twin
							gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_j, l_i, (math_inst.gsl_complex_conjugate ((l_z.item).twin)).twin)
							l_j := l_j + 1
						end
						l_i := l_i + 1
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_complex_cholesky_solve (a_cholesky: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_x: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_cholesky.item.size1 /= a_cholesky.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("cholesky matrix must be square"), ce_string ("choleskyc.c"), 142, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_cholesky.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("choleskyc.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_cholesky.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("choleskyc.c"), 150, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				copy_source_inst.gsl_vector_complex_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_cholesky, a_x).do_nothing
				blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasConjTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_cholesky, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_complex_cholesky_svx (a_cholesky: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_x: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_cholesky.item.size1 /= a_cholesky.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("cholesky matrix must be square"), ce_string ("choleskyc.c"), 179, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_cholesky.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("choleskyc.c"), 183, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_cholesky, a_x).do_nothing
				blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasConjTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_cholesky, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
