class
	P_DEBYE

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create adeb1_cs.make (<<1>>)
			create adeb1_data.make (<<17>>)
			create adeb2_cs.make (<<1>>)
			create adeb2_data.make (<<18>>)
			create adeb3_cs.make (<<1>>)
			create adeb3_data.make (<<17>>)
			create adeb4_cs.make (<<1>>)
			create adeb4_data.make (<<17>>)
			create adeb5_cs.make (<<1>>)
			create adeb5_data.make (<<17>>)
			create adeb6_cs.make (<<1>>)
			create adeb6_data.make (<<17>>)
		end

feature {ANY} -- attributes

	adeb1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	adeb1_data: CE_ARRAY [REAL_64]

	adeb2_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	adeb2_data: CE_ARRAY [REAL_64]

	adeb3_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	adeb3_data: CE_ARRAY [REAL_64]

	adeb4_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	adeb4_data: CE_ARRAY [REAL_64]

	adeb5_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	adeb5_data: CE_ARRAY [REAL_64]

	adeb6_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	adeb6_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_sf_debye_1 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_debye_1_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_debye_1_e(x, &result)"), ce_string ("debye.c"), 540, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_debye_1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_xcut: REAL_64
			l_t: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_nexp: INTEGER_32
			l_ex: REAL_64
			l_sum: REAL_64
			l_xk: REAL_64
			l_rk: REAL_64
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			l_val_infinity := 1.64493406684822644
			l_xcut := -(-7.0839641853226408e+02)
			if a_x < 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("debye.c"), 202, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 2.0 * 1.4901161193847656e-08 then
				a_result.item.val := (1.0 - 0.25 * a_x) + (a_x * a_x) / 36.0
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e (adeb1_cs, l_t, l_c___1).do_nothing
				a_result.item.val := l_c___1.item.val - 0.25 * a_x
				a_result.item.err := l_c___1.item.err + (0.25 * a_x) * 2.2204460492503131e-16
				Result := 0
				js.return
			elseif a_x < -(0.69314718055994530942 + -3.6043653389117154e+01) then
				l_nexp := (floor (l_xcut / a_x)).truncated_to_integer
				l_ex := (exp (-a_x))
				l_sum := 0.0
				l_xk := l_nexp.to_double * a_x
				l_rk := l_nexp.to_double
				l_i := l_nexp
				from
				until
					not (l_i >= 1)
				loop
					l_sum := l_sum * l_ex
					l_sum := l_sum + ((1.0 + 1.0 / l_xk) / l_rk)
					l_rk := l_rk - (1.0)
					l_xk := l_xk - a_x
					l_i := l_i - 1
				end
				a_result.item.val := l_val_infinity / a_x - l_sum * l_ex
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < l_xcut then
				a_result.item.val := (l_val_infinity - (exp (-a_x)) * (a_x + 1.0)) / a_x
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				a_result.item.val := l_val_infinity / a_x
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_debye_2 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_debye_2_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_debye_2_e(x, &result)"), ce_string ("debye.c"), 545, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_debye_2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_xcut: REAL_64
			l_t: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_nexp: INTEGER_32
			l_ex: REAL_64
			l_xk: REAL_64
			l_rk: REAL_64
			l_sum: REAL_64
			l_i: INTEGER_32
			l_x2___1: REAL_64
			l_sum___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			l_val_infinity := 4.80822761263837714
			l_xcut := -(-7.0839641853226408e+02)
			if a_x < 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("debye.c"), 255, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				a_result.item.val := (1.0 - a_x / 3.0) + (a_x * a_x) / 24.0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e (adeb2_cs, l_t, l_c___1).do_nothing
				a_result.item.val := l_c___1.item.val - a_x / 3.0
				a_result.item.err := l_c___1.item.err + (2.2204460492503131e-16 * a_x) / 3.0
				Result := 0
				js.return
			elseif a_x < -(0.69314718055994530942 + -3.6043653389117154e+01) then
				l_nexp := (floor (l_xcut / a_x)).truncated_to_integer
				l_ex := (exp (-a_x))
				l_xk := l_nexp.to_double * a_x
				l_rk := l_nexp.to_double
				l_sum := 0.0
				l_i := l_nexp
				from
				until
					not (l_i >= 1)
				loop
					l_sum := l_sum * l_ex
					l_sum := l_sum + (((1.0 + 2.0 / l_xk) + 2.0 / (l_xk * l_xk)) / l_rk)
					l_rk := l_rk - (1.0)
					l_xk := l_xk - a_x
					l_i := l_i - 1
				end
				a_result.item.val := l_val_infinity / (a_x * a_x) - (2.0 * l_sum) * l_ex
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < l_xcut then
				l_x2___1 := a_x * a_x
				l_sum___0 := (2.0 + 2.0 * a_x) + l_x2___1
				a_result.item.val := (l_val_infinity - (2.0 * l_sum___0) * (exp (-a_x))) / l_x2___1
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				a_result.item.val := (l_val_infinity / a_x) / a_x
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("debye.c"), 297, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_debye_3 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_debye_3_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_debye_3_e(x, &result)"), ce_string ("debye.c"), 550, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_debye_3_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_xcut: REAL_64
			l_t: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_nexp: INTEGER_32
			l_ex: REAL_64
			l_xk: REAL_64
			l_rk: REAL_64
			l_sum: REAL_64
			l_i: INTEGER_32
			l_xk_inv: REAL_64
			l_x3___1: REAL_64
			l_sum___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			l_val_infinity := 19.4818182068004875
			l_xcut := -(-7.0839641853226408e+02)
			if a_x < 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("debye.c"), 311, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				a_result.item.val := (1.0 - (3.0 * a_x) / 8.0) + (a_x * a_x) / 20.0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e (adeb3_cs, l_t, l_c___1).do_nothing
				a_result.item.val := l_c___1.item.val - 0.375 * a_x
				a_result.item.err := l_c___1.item.err + (2.2204460492503131e-16 * 0.375) * a_x
				Result := 0
				js.return
			elseif a_x < -(0.69314718055994530942 + -3.6043653389117154e+01) then
				l_nexp := (floor (l_xcut / a_x)).truncated_to_integer
				l_ex := (exp (-a_x))
				l_xk := l_nexp.to_double * a_x
				l_rk := l_nexp.to_double
				l_sum := 0.0
				l_i := l_nexp
				from
				until
					not (l_i >= 1)
				loop
					l_xk_inv := 1.0 / l_xk
					l_sum := l_sum * l_ex
					l_sum := l_sum + ((((6.0 * l_xk_inv + 6.0) * l_xk_inv + 3.0) * l_xk_inv + 1.0) / l_rk)
					l_rk := l_rk - (1.0)
					l_xk := l_xk - a_x
					l_i := l_i - 1
				end
				a_result.item.val := l_val_infinity / ((a_x * a_x) * a_x) - (3.0 * l_sum) * l_ex
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x < l_xcut then
				l_x3___1 := (a_x * a_x) * a_x
				l_sum___0 := ((6.0 + 6.0 * a_x) + (3.0 * a_x) * a_x) + l_x3___1
				a_result.item.val := (l_val_infinity - (3.0 * l_sum___0) * (exp (-a_x))) / l_x3___1
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			else
				a_result.item.val := ((l_val_infinity / a_x) / a_x) / a_x
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("debye.c"), 354, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_debye_4 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_debye_4_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_debye_4_e(x, &result)"), ce_string ("debye.c"), 555, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_debye_4_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_xcut: REAL_64
			l_t: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_nexp: INTEGER_32
			l_ex: REAL_64
			l_xk: REAL_64
			l_rk: REAL_64
			l_sum: REAL_64
			l_i: INTEGER_32
			l_xk_inv: REAL_64
			l_x2___1: REAL_64
			l_x4___1: REAL_64
			l_sum___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			l_val_infinity := 99.5450644937635129
			l_xcut := -(-7.0839641853226408e+02)
			if a_x < 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("debye.c"), 368, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				a_result.item.val := (1.0 - (2.0 * a_x) / 5.0) + (a_x * a_x) / 18.0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e (adeb4_cs, l_t, l_c___1).do_nothing
				a_result.item.val := l_c___1.item.val - (2.0 * a_x) / 5.0
				a_result.item.err := l_c___1.item.err + ((2.2204460492503131e-16 * 2.0) * a_x) / 5.0
				Result := 0
				js.return
			elseif a_x < -(0.69314718055994530942 + -3.6043653389117154e+01) then
				l_nexp := (floor (l_xcut / a_x)).truncated_to_integer
				l_ex := (exp (-a_x))
				l_xk := l_nexp.to_double * a_x
				l_rk := l_nexp.to_double
				l_sum := 0.0
				l_i := l_nexp
				from
				until
					not (l_i >= 1)
				loop
					l_xk_inv := 1.0 / l_xk
					l_sum := l_sum * l_ex
					l_sum := l_sum + (((((24.0 * l_xk_inv + 24.0) * l_xk_inv + 12.0) * l_xk_inv + 4.0) * l_xk_inv + 1.0) / l_rk)
					l_rk := l_rk - (1.0)
					l_xk := l_xk - a_x
					l_i := l_i - 1
				end
				a_result.item.val := l_val_infinity / (((a_x * a_x) * a_x) * a_x) - (4.0 * l_sum) * l_ex
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x < l_xcut then
				l_x2___1 := a_x * a_x
				l_x4___1 := l_x2___1 * l_x2___1
				l_sum___0 := (((24.0 + 24.0 * a_x) + 12.0 * l_x2___1) + (4.0 * l_x2___1) * a_x) + l_x4___1
				a_result.item.val := (l_val_infinity - (4.0 * l_sum___0) * (exp (-a_x))) / l_x4___1
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			else
				a_result.item.val := (((l_val_infinity / a_x) / a_x) / a_x) / a_x
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("debye.c"), 412, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_debye_5 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_debye_5_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_debye_5_e(x, &result)"), ce_string ("debye.c"), 560, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_debye_5_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_xcut: REAL_64
			l_t: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_nexp: INTEGER_32
			l_ex: REAL_64
			l_xk: REAL_64
			l_rk: REAL_64
			l_sum: REAL_64
			l_i: INTEGER_32
			l_xk_inv: REAL_64
			l_x2___1: REAL_64
			l_x4___1: REAL_64
			l_x5___0: REAL_64
			l_sum___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			l_val_infinity := 610.405837190669483828710757875
			l_xcut := -(-7.0839641853226408e+02)
			if a_x < 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("debye.c"), 425, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				a_result.item.val := (1.0 - (5.0 * a_x) / 12.0) + ((5.0 * a_x) * a_x) / 84.0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e (adeb5_cs, l_t, l_c___1).do_nothing
				a_result.item.val := l_c___1.item.val - (5.0 * a_x) / 12.0
				a_result.item.err := l_c___1.item.err + ((2.2204460492503131e-16 * 5.0) * a_x) / 12.0
				Result := 0
				js.return
			elseif a_x < -(0.69314718055994530942 + -3.6043653389117154e+01) then
				l_nexp := (floor (l_xcut / a_x)).truncated_to_integer
				l_ex := (exp (-a_x))
				l_xk := l_nexp.to_double * a_x
				l_rk := l_nexp.to_double
				l_sum := 0.0
				l_i := l_nexp
				from
				until
					not (l_i >= 1)
				loop
					l_xk_inv := 1.0 / l_xk
					l_sum := l_sum * l_ex
					l_sum := l_sum + ((((((120.0 * l_xk_inv + 120.0) * l_xk_inv + 60.0) * l_xk_inv + 20.0) * l_xk_inv + 5.0) * l_xk_inv + 1.0) / l_rk)
					l_rk := l_rk - (1.0)
					l_xk := l_xk - a_x
					l_i := l_i - 1
				end
				a_result.item.val := l_val_infinity / ((((a_x * a_x) * a_x) * a_x) * a_x) - (5.0 * l_sum) * l_ex
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x < l_xcut then
				l_x2___1 := a_x * a_x
				l_x4___1 := l_x2___1 * l_x2___1
				l_x5___0 := l_x4___1 * a_x
				l_sum___0 := ((((120.0 + 120.0 * a_x) + 60.0 * l_x2___1) + (20.0 * l_x2___1) * a_x) + 5.0 * l_x4___1) + l_x5___0
				a_result.item.val := (l_val_infinity - (5.0 * l_sum___0) * (exp (-a_x))) / l_x5___0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			else
				a_result.item.val := ((((l_val_infinity / a_x) / a_x) / a_x) / a_x) / a_x
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("debye.c"), 470, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_debye_6 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_debye_6_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_debye_6_e(x, &result)"), ce_string ("debye.c"), 565, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_debye_6_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_xcut: REAL_64
			l_t: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_nexp: INTEGER_32
			l_ex: REAL_64
			l_xk: REAL_64
			l_rk: REAL_64
			l_sum: REAL_64
			l_i: INTEGER_32
			l_xk_inv: REAL_64
			l_x2___1: REAL_64
			l_x4___1: REAL_64
			l_x6___0: REAL_64
			l_sum___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			l_val_infinity := 4356.06887828990661194792541535
			l_xcut := -(-7.0839641853226408e+02)
			if a_x < 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("debye.c"), 483, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				a_result.item.val := (1.0 - (3.0 * a_x) / 7.0) + (a_x * a_x) / 16.0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e (adeb6_cs, l_t, l_c___1).do_nothing
				a_result.item.val := l_c___1.item.val - (3.0 * a_x) / 7.0
				a_result.item.err := l_c___1.item.err + ((2.2204460492503131e-16 * 3.0) * a_x) / 7.0
				Result := 0
				js.return
			elseif a_x < -(0.69314718055994530942 + -3.6043653389117154e+01) then
				l_nexp := (floor (l_xcut / a_x)).truncated_to_integer
				l_ex := (exp (-a_x))
				l_xk := l_nexp.to_double * a_x
				l_rk := l_nexp.to_double
				l_sum := 0.0
				l_i := l_nexp
				from
				until
					not (l_i >= 1)
				loop
					l_xk_inv := 1.0 / l_xk
					l_sum := l_sum * l_ex
					l_sum := l_sum + (((((((720.0 * l_xk_inv + 720.0) * l_xk_inv + 360.0) * l_xk_inv + 120.0) * l_xk_inv + 30.0) * l_xk_inv + 6.0) * l_xk_inv + 1.0) / l_rk)
					l_rk := l_rk - (1.0)
					l_xk := l_xk - a_x
					l_i := l_i - 1
				end
				a_result.item.val := l_val_infinity / (((((a_x * a_x) * a_x) * a_x) * a_x) * a_x) - (6.0 * l_sum) * l_ex
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x < l_xcut then
				l_x2___1 := a_x * a_x
				l_x4___1 := l_x2___1 * l_x2___1
				l_x6___0 := l_x4___1 * l_x2___1
				l_sum___0 := (((((720.0 + 720.0 * a_x) + 360.0 * l_x2___1) + (120.0 * l_x2___1) * a_x) + 30.0 * l_x4___1) + (6.0 * l_x4___1) * a_x) + l_x6___0
				a_result.item.val := (l_val_infinity - (6.0 * l_sum___0) * (exp (-a_x))) / l_x6___0
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			else
				a_result.item.val := (((((l_val_infinity / a_x) / a_x) / a_x) / a_x) / a_x) / a_x
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("debye.c"), 528, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
