class
	P_DERIV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	central_deriv (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_h: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr_round: CE_POINTER [REAL_64]; a_abserr_trunc: CE_POINTER [REAL_64])
		local
			l_fm1: REAL_64
			l_fp1: REAL_64
			l_fmh: REAL_64
			l_fph: REAL_64
			l_r3: REAL_64
			l_r5___0: REAL_64
			l_e3: REAL_64
			l_tmp___3: REAL_64
			l_e5: REAL_64
			l_tmp___5: REAL_64
			l_dy: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
		do
			l_fm1 := ((a_f.item.function).real_64_item ([a_x - a_h, a_f.item.params]))
			l_fp1 := ((a_f.item.function).real_64_item ([a_x + a_h, a_f.item.params]))
			l_fmh := ((a_f.item.function).real_64_item ([a_x - a_h / (2).to_double, a_f.item.params]))
			l_fph := ((a_f.item.function).real_64_item ([a_x + a_h / (2).to_double, a_f.item.params]))
			l_r3 := 0.5 * (l_fp1 - l_fm1)
			l_r5___0 := (4.0 / 3.0) * (l_fph - l_fmh) - (1.0 / 3.0) * l_r3
			l_tmp___3 := fabs (l_fp1)
			l_e3 := (l_tmp___3 + (fabs (l_fm1))) * 2.2204460492503131e-16
			l_tmp___5 := fabs (l_fph)
			l_e5 := (2.0 * (l_tmp___5 + (fabs (l_fmh)))) * 2.2204460492503131e-16 + l_e3
			l_tmp___12 := fabs (l_r3 / a_h)
			if l_tmp___12 > (fabs (l_r5___0 / a_h)) then
				l_tmp___11 := (fabs (l_r3 / a_h))
			else
				l_tmp___11 := (fabs (l_r5___0 / a_h))
			end
			l_dy := (l_tmp___11 * ((fabs (a_x)) / a_h)) * 2.2204460492503131e-16
			a_result.item := l_r5___0 / a_h
			a_abserr_trunc.item := fabs ((l_r5___0 - l_r3) / a_h)
			a_abserr_round.item := (fabs (l_e5 / a_h)) + l_dy
		end

	forward_deriv (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_h: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr_round: CE_POINTER [REAL_64]; a_abserr_trunc: CE_POINTER [REAL_64])
		local
			l_f1: REAL_64
			l_f2: REAL_64
			l_f3: REAL_64
			l_f4: REAL_64
			l_r2___0: REAL_64
			l_r4: REAL_64
			l_e4: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_dy: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
		do
			l_f1 := ((a_f.item.function).real_64_item ([a_x + a_h / 4.0, a_f.item.params]))
			l_f2 := ((a_f.item.function).real_64_item ([a_x + a_h / 2.0, a_f.item.params]))
			l_f3 := ((a_f.item.function).real_64_item ([a_x + (3.0 / 4.0) * a_h, a_f.item.params]))
			l_f4 := ((a_f.item.function).real_64_item ([a_x + a_h, a_f.item.params]))
			l_r2___0 := 2.0 * (l_f4 - l_f2)
			l_r4 := ((22.0 / 3.0) * (l_f4 - l_f3) - (62.0 / 3.0) * (l_f3 - l_f2)) + (52.0 / 3.0) * (l_f2 - l_f1)
			l_tmp___3 := fabs (l_f4)
			l_tmp___4 := fabs (l_f3)
			l_tmp___5 := fabs (l_f2)
			l_e4 := (((2).to_double * 20.67) * (((l_tmp___3 + l_tmp___4) + l_tmp___5) + (fabs (l_f1)))) * 2.2204460492503131e-16
			l_tmp___12 := fabs (l_r2___0 / a_h)
			if l_tmp___12 > (fabs (l_r4 / a_h)) then
				l_tmp___11 := (fabs (l_r2___0 / a_h))
			else
				l_tmp___11 := (fabs (l_r4 / a_h))
			end
			l_dy := (l_tmp___11 * (fabs (a_x / a_h))) * 2.2204460492503131e-16
			a_result.item := l_r4 / a_h
			a_abserr_trunc.item := fabs ((l_r4 - l_r2___0) / a_h)
			a_abserr_round.item := (fabs (l_e4 / a_h)) + l_dy
		end

	gsl_cheb_calc_deriv (a_deriv: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]; a_f: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_con: REAL_64
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_n := (a_f.item.order + {NATURAL_32} 1)
			l_con := 2.0 / (a_f.item.b - a_f.item.a)
			if a_deriv.item.order /= a_f.item.order then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("order of chebyshev series must be equal"), ce_string ("deriv.c"), 34, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_deriv.item.a := a_f.item.a
				a_deriv.item.b := a_f.item.b
				a_deriv.item.c[(l_n - {NATURAL_32} 1).to_integer_32] := 0.0
				if l_n > {NATURAL_32} 1 then
					a_deriv.item.c[(l_n - {NATURAL_32} 2).to_integer_32] := (2.0 * (l_n.to_real_64 - 1.0)) * a_f.item.c[(l_n - {NATURAL_32} 1).to_integer_32]
					l_i := l_n - {NATURAL_32} 3
					from
					until
						not (l_i > {NATURAL_32} 0)
					loop
						a_deriv.item.c[l_i.to_integer_32] := a_deriv.item.c[(l_i + {NATURAL_32} 2).to_integer_32] + (2.0 * (l_i.to_real_64 + 1.0)) * a_f.item.c[(l_i + {NATURAL_32} 1).to_integer_32]
						l_i := l_i - 1
					end
					a_deriv.item.c[0] := a_deriv.item.c[2] + 2.0 * a_f.item.c[1]
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_n)
					loop
						a_deriv.item.c[l_i.to_integer_32] := a_deriv.item.c[l_i.to_integer_32] * l_con
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_deriv_backward (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_h: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		do
			Result := (gsl_deriv_forward (a_f, a_x, -a_h, a_result, a_abserr))
		end

	gsl_deriv_central (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_h: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_r_0: CE_ARRAY [REAL_64]
			l_round___0: CE_ARRAY [REAL_64]
			l_trunc___0: CE_ARRAY [REAL_64]
			l_error: REAL_64
			l_r_opt: CE_ARRAY [REAL_64]
			l_round_opt: CE_ARRAY [REAL_64]
			l_trunc_opt: CE_ARRAY [REAL_64]
			l_error_opt: REAL_64
			l_h_opt: REAL_64
		do
			create l_r_0.make (<<1>>)
			create l_round___0.make (<<1>>)
			create l_trunc___0.make (<<1>>)
			create l_r_opt.make (<<1>>)
			create l_round_opt.make (<<1>>)
			create l_trunc_opt.make (<<1>>)

			central_deriv (a_f, a_x, a_h, l_r_0, l_round___0, l_trunc___0)
			l_error := l_round___0.item + l_trunc___0.item
			if l_round___0.item < l_trunc___0.item then
				if l_round___0.item > (0).to_double then
					if l_trunc___0.item > (0).to_double then
						l_h_opt := a_h * (pow (l_round___0.item / (2.0 * l_trunc___0.item), 1.0 / 3.0))
						central_deriv (a_f, a_x, l_h_opt, l_r_opt, l_round_opt, l_trunc_opt)
						l_error_opt := l_round_opt.item + l_trunc_opt.item
						if l_error_opt < l_error then
							if (fabs (l_r_opt.item - l_r_0.item)) < 4.0 * l_error then
								l_r_0.item := l_r_opt.item
								l_error := l_error_opt
							end
						end
					end
				end
			end
			a_result.item := l_r_0.item
			a_abserr.item := l_error
			Result := 0
		end

	gsl_deriv_forward (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_h: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_r_0: CE_ARRAY [REAL_64]
			l_round___0: CE_ARRAY [REAL_64]
			l_trunc___0: CE_ARRAY [REAL_64]
			l_error: REAL_64
			l_r_opt: CE_ARRAY [REAL_64]
			l_round_opt: CE_ARRAY [REAL_64]
			l_trunc_opt: CE_ARRAY [REAL_64]
			l_error_opt: REAL_64
			l_h_opt: REAL_64
		do
			create l_r_0.make (<<1>>)
			create l_round___0.make (<<1>>)
			create l_trunc___0.make (<<1>>)
			create l_r_opt.make (<<1>>)
			create l_round_opt.make (<<1>>)
			create l_trunc_opt.make (<<1>>)

			forward_deriv (a_f, a_x, a_h, l_r_0, l_round___0, l_trunc___0)
			l_error := l_round___0.item + l_trunc___0.item
			if l_round___0.item < l_trunc___0.item then
				if l_round___0.item > (0).to_double then
					if l_trunc___0.item > (0).to_double then
						l_h_opt := a_h * (pow (l_round___0.item / l_trunc___0.item, 1.0 / 2.0))
						forward_deriv (a_f, a_x, l_h_opt, l_r_opt, l_round_opt, l_trunc_opt)
						l_error_opt := l_round_opt.item + l_trunc_opt.item
						if l_error_opt < l_error then
							if (fabs (l_r_opt.item - l_r_0.item)) < 4.0 * l_error then
								l_r_0.item := l_r_opt.item
								l_error := l_error_opt
							end
						end
					end
				end
			end
			a_result.item := l_r_0.item
			a_abserr.item := l_error
			Result := 0
		end

	gsl_poly_eval_derivs (a_c___1: CE_POINTER [REAL_64]; a_lenc: NATURAL_32; a_x: REAL_64; a_res: CE_POINTER [REAL_64]; a_lenres: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_nmax: NATURAL_32
			l_k: NATURAL_32
			l_l: NATURAL_32
			l_lmax: NATURAL_32
			l_f: REAL_64
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_n := (0).to_natural_32
			l_nmax := (0).to_natural_32
			from
			until
				not (l_i < a_lenres)
			loop
				if l_n < a_lenc then
					a_res[l_i.to_integer_32] := a_c___1[(a_lenc - {NATURAL_32} 1).to_integer_32]
					l_nmax := l_n
					l_n := l_n + 1
				else
					a_res[l_i.to_integer_32] := 0.0
				end
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_lenc - {NATURAL_32} 1))
			loop
				l_k := (a_lenc - {NATURAL_32} 1) - l_i
				a_res[0] := a_x * a_res[0] + a_c___1[(l_k - {NATURAL_32} 1).to_integer_32]
				if l_nmax < l_k then
					l_lmax := l_nmax
				else
					l_lmax := l_k - {NATURAL_32} 1
				end
				l_l := (1).to_natural_32
				from
				until
					not (l_l <= l_lmax)
				loop
					a_res[l_l.to_integer_32] := a_x * a_res[l_l.to_integer_32] + a_res[(l_l - {NATURAL_32} 1).to_integer_32]
					l_l := l_l + 1
				end
				l_i := l_i + 1
			end
			l_f := 1.0
			l_i := (2).to_natural_32
			from
			until
				not (l_i <= l_nmax)
			loop
				l_f := l_f * l_i.to_real_64
				a_res[l_i.to_integer_32] := a_res[l_i.to_integer_32] * l_f
				l_i := l_i + 1
			end
			Result := 0
		end

end
