class
	P_DISCRETE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	free_stack (a_s: CE_POINTER [PD_GSL_STACK_T])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_s.item.v))
			free (create {CE_POINTER [ANY]}.make_cast (a_s))
		end

	gsl_ran_discrete (a_r___3: CE_POINTER [PD_GSL_RNG]; a_g: CE_POINTER [PD_GSL_RAN_DISCRETE_T]): NATURAL_32
		local
			l_c___1: NATURAL_32
			l_u: REAL_64
			l_f: REAL_64
			js: JUMP_STATE
		do
			l_c___1 := (0).to_natural_32
			l_u := gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)
			l_c___1 := (l_u * (a_g.item.K).to_real_64).truncated_to_integer_64.to_natural_32
			l_f := a_g.item.F[l_c___1.to_integer_32]
			if l_f = 1.0 then
				Result := l_c___1
				js.return
			end
			if not js.return_called then
				if l_u < l_f then
					Result := l_c___1
				else
					Result := (a_g.item.A[l_c___1.to_integer_32])
				end
			end
		end

	gsl_ran_discrete_free (a_g: CE_POINTER [PD_GSL_RAN_DISCRETE_T])
		local
			js: JUMP_STATE
		do
			if a_g.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_g.item.A))
				free (create {CE_POINTER [ANY]}.make_cast (a_g.item.F))
				free (create {CE_POINTER [ANY]}.make_cast (a_g))
			end
		end

	gsl_ran_discrete_pdf (a_k: NATURAL_32; a_g: CE_POINTER [PD_GSL_RAN_DISCRETE_T]): REAL_64
		local
			l_i: NATURAL_32
			l_K: NATURAL_32
			l_f: REAL_64
			l_p: REAL_64
			js: JUMP_STATE
		do
			l_p := (0).to_double
			l_K := a_g.item.K
			if a_k > l_K then
				Result := (0).to_double
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_K)
				loop
					l_f := a_g.item.F[l_i.to_integer_32]
					l_f := l_K.to_real_64 * l_f - l_i.to_real_64
					if l_i = a_k then
						l_p := l_p + l_f
					elseif a_k = a_g.item.A[l_i.to_integer_32] then
						l_p := l_p + (1.0 - l_f)
					end
					l_i := l_i + 1
				end
				Result := (l_p / l_K.to_real_64)
			end
		end

	gsl_ran_discrete_preproc (a_Kevents: NATURAL_32; a_ProbArray: CE_POINTER [REAL_64]): CE_POINTER [PD_GSL_RAN_DISCRETE_T]
		local
			l_k: NATURAL_32
			l_b___0: NATURAL_32
			l_s: NATURAL_32
			l_g: CE_POINTER [PD_GSL_RAN_DISCRETE_T]
			l_nBigs: NATURAL_32
			l_nSmalls: NATURAL_32
			l_Bigs: CE_POINTER [PD_GSL_STACK_T]
			l_Smalls: CE_POINTER [PD_GSL_STACK_T]
			l_E: CE_POINTER [REAL_64]
			l_pTotal: REAL_64
			l_mean: REAL_64
			l_d: REAL_64
			l_which: CE_POINTER [NATURAL_32]
			l_Dest: CE_POINTER [PD_GSL_STACK_T]
			l_tmp___3: CE_POINTER [PD_GSL_STACK_T]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_g.make
			create l_Bigs.make
			create l_Smalls.make
			create l_E.make
			create l_which.make
			create l_Dest.make
			create l_tmp___3.make

			l_pTotal := 0.0
			if a_Kevents < {NATURAL_32} 1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("number of events must be a positive integer"), ce_string ("discrete.c"), 228, 4)
					Result := (create {CE_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < a_Kevents))
				loop
					if a_ProbArray[l_k.to_integer_32] < (0).to_double then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("probabilities must be non-negative"), ce_string ("discrete.c"), 238, 4)
							Result := (create {CE_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_pTotal := l_pTotal + (a_ProbArray[l_k.to_integer_32])
						l_k := l_k + 1
					end
				end
			end
			if not js.return_called then
				l_g := create {CE_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_cast ((malloc ((create {PD_GSL_RAN_DISCRETE_T}.make).structure_size.to_natural_32)))
				l_g.item.K := a_Kevents
				l_g.item.F := create {CE_POINTER [REAL_64]}.make_cast ((malloc ({PLATFORM}.Real_64_bytes.to_natural_32 * a_Kevents)))
				l_g.item.A := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc ({PLATFORM}.Natural_32_bytes.to_natural_32 * a_Kevents)))
				l_E := create {CE_POINTER [REAL_64]}.make_cast ((malloc ({PLATFORM}.Real_64_bytes.to_natural_32 * a_Kevents)))
				if l_E.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("Cannot allocate memory for randevent"), ce_string ("discrete.c"), 252, 8)
						Result := (create {CE_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_Kevents)
				loop
					l_E[l_k.to_integer_32] := (a_ProbArray[l_k.to_integer_32] / l_pTotal)
					l_k := l_k + 1
				end
				l_mean := 1.0 / a_Kevents.to_real_64
				l_nBigs := (0).to_natural_32
				l_nSmalls := l_nBigs
				l_which := l_g.item.A
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_Kevents)
				loop
					if l_E[l_k.to_integer_32] < l_mean then
						l_nSmalls := l_nSmalls + 1
						l_which[l_k.to_integer_32] := (0).to_natural_32
					else
						l_nBigs := l_nBigs + 1
						l_which[l_k.to_integer_32] := (1).to_natural_32
					end
					l_k := l_k + 1
				end
				l_Bigs := new_stack (l_nBigs)
				l_Smalls := new_stack (l_nSmalls)
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < a_Kevents))
				loop
					if (l_which[l_k.to_integer_32]).to_boolean then
						l_tmp___3 := l_Bigs
					else
						l_tmp___3 := l_Smalls
					end
					l_Dest := l_tmp___3
					l_status := (push_stack (l_Dest, l_k))
					if l_status.to_boolean then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("failed to build stacks"), ce_string ("discrete.c"), 280, 5)
							Result := (create {CE_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if not ((size_stack (l_Smalls)) > {NATURAL_32} 0) then
						js.break
					end
					if not js.loop_jumped then
						l_s := pop_stack (l_Smalls)
						if (size_stack (l_Bigs)) = {NATURAL_32} 0 then
							l_g.item.A[l_s.to_integer_32] := l_s
							l_g.item.F[l_s.to_integer_32] := 1.0
							js.continue
						end
					end
					if not js.loop_jumped then
						l_b___0 := pop_stack (l_Bigs)
						l_g.item.A[l_s.to_integer_32] := l_b___0
						l_g.item.F[l_s.to_integer_32] := a_Kevents.to_real_64 * l_E[l_s.to_integer_32]
						l_d := l_mean - l_E[l_s.to_integer_32]
						l_E[l_s.to_integer_32] := l_E[l_s.to_integer_32] + l_d
						l_E[l_b___0.to_integer_32] := l_E[l_b___0.to_integer_32] - l_d
						if l_E[l_b___0.to_integer_32] < l_mean then
							push_stack (l_Smalls, l_b___0).do_nothing
						elseif l_E[l_b___0.to_integer_32] > l_mean then
							push_stack (l_Bigs, l_b___0).do_nothing
						else
							l_g.item.A[l_b___0.to_integer_32] := l_b___0
							l_g.item.F[l_b___0.to_integer_32] := 1.0
						end
					end
				end
				from
				until
					js.loop_done
				loop
					if not ((size_stack (l_Bigs)) > {NATURAL_32} 0) then
						js.break
					end
					if not js.loop_jumped then
						l_b___0 := pop_stack (l_Bigs)
						l_g.item.A[l_b___0.to_integer_32] := l_b___0
						l_g.item.F[l_b___0.to_integer_32] := 1.0
					end
				end
				if (size_stack (l_Smalls)) /= {NATURAL_32} 0 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("Smalls stack has not been emptied"), ce_string ("discrete.c"), 322, 7)
						Result := (create {CE_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_Kevents)
				loop
					l_g.item.F[l_k.to_integer_32] := l_g.item.F[l_k.to_integer_32] + l_k.to_real_64
					l_g.item.F[l_k.to_integer_32] := l_g.item.F[l_k.to_integer_32] / a_Kevents.to_real_64
					l_k := l_k + 1
				end
				free_stack (l_Bigs)
				free_stack (l_Smalls)
				free (create {CE_POINTER [ANY]}.make_cast (l_E))
				Result := l_g
			end
		end

	new_stack (a_N: NATURAL_32): CE_POINTER [PD_GSL_STACK_T]
		local
			l_s: CE_POINTER [PD_GSL_STACK_T]
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_STACK_T]}.make_cast ((malloc ((create {PD_GSL_STACK_T}.make).structure_size.to_natural_32)))
			l_s.item.N := a_N
			l_s.item.i := (0).to_natural_32
			l_s.item.v := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc ({PLATFORM}.Natural_32_bytes.to_natural_32 * a_N)))
			Result := l_s
		end

	pop_stack (a_s: CE_POINTER [PD_GSL_STACK_T]): NATURAL_32
		local
			js: JUMP_STATE
		do
			if a_s.item.i = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("internal error - stack exhausted"), ce_string ("discrete.c"), 191, 7)
					Result := (7).to_natural_32
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_s.item.i := (a_s.item.i) - 1
				Result := (a_s.item.v[(a_s.item.i).to_integer_32])
			end
		end

	push_stack (a_s: CE_POINTER [PD_GSL_STACK_T]; a_v: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_s.item.i >= a_s.item.N then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				a_s.item.v[(a_s.item.i).to_integer_32] := a_v
				a_s.item.i := (a_s.item.i) + 1
				Result := 0
			end
		end

	size_stack (a_s: CE_POINTER [PD_GSL_STACK_T]): NATURAL_32
		do
			Result := (a_s.item.i)
		end

end
