class
	P_DNEWTON

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create dnewton_type.make (<<1>>)
			create gsl_multiroot_fsolver_dnewton.make
		end

feature {ANY} -- attributes

	dnewton_type: CE_ARRAY [PD_GSL_MULTIROOT_FSOLVER_TYPE]

	gsl_multiroot_fsolver_dnewton: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE] assign set_gsl_multiroot_fsolver_dnewton

	set_gsl_multiroot_fsolver_dnewton (a_gsl_multiroot_fsolver_dnewton: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE])
		do
			gsl_multiroot_fsolver_dnewton := a_gsl_multiroot_fsolver_dnewton
		end

feature {ANY} -- routines

	dnewton_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_DNEWTON_STATE_T]
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_J: CE_POINTER [PD_GSL_MATRIX]
			js: JUMP_STATE
		do
			create l_state.make
			create l_p.make
			create l_m___4.make
			create l_J.make

			l_state := create {CE_POINTER [PD_DNEWTON_STATE_T]}.make_cast (a_vstate)
			l_m___4 := init_source_inst.gsl_matrix_calloc (a_n, a_n)
			if l_m___4.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("dnewton.c"), 64, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.lu := l_m___4
				l_p := init_inst.gsl_permutation_calloc (a_n)
				if l_p.is_void then
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("dnewton.c"), 75, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.permutation := l_p
				l_J := init_source_inst.gsl_matrix_calloc (a_n, a_n)
				if l_J.is_void then
					init_inst.gsl_permutation_free (l_p)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for d"), ce_string ("dnewton.c"), 87, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.J := l_J
				Result := 0
			end
		end

	dnewton_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dnewton_alloc)
		end

	dnewton_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_DNEWTON_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_DNEWTON_STATE_T]}.make_cast (a_vstate)
			init_source_inst.gsl_matrix_free (l_state.item.J)
			init_source_inst.gsl_matrix_free (l_state.item.lu)
			init_inst.gsl_permutation_free (l_state.item.permutation)
		end

	dnewton_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dnewton_free)
		end

	dnewton_iterate (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_DNEWTON_STATE_T]
			l_signum: CE_ARRAY [INTEGER_32]
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_status: INTEGER_32
			l_status___0: INTEGER_32
			l_e: REAL_64
			l_y: REAL_64
			l_status___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_signum.make (<<1>>)

			l_state := create {CE_POINTER [PD_DNEWTON_STATE_T]}.make_cast (a_vstate)
			l_n := a_function.item.n
			copy_source_inst.gsl_matrix_memcpy (l_state.item.lu, l_state.item.J).do_nothing
			l_status := (lu_inst.gsl_linalg_LU_decomp (l_state.item.lu, l_state.item.permutation, l_signum))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status___0 := (lu_inst.gsl_linalg_LU_solve (l_state.item.lu, l_state.item.permutation, a_f, a_dx))
				if l_status___0.to_boolean then
					Result := l_status___0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_e := (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_i))
					l_y := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, -l_e)
					gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_i, l_y - l_e)
					l_i := l_i + 1
				end
				l_status___1 := ((a_function.item.f).integer_32_item ([a_x, a_function.item.params, a_f]))
				if l_status___1 /= 0 then
					Result := 9
					js.return
				end
			end
			if not js.return_called then
				fdjac_inst.gsl_multiroot_fdjacobian (a_function, a_x, a_f, 1.4901161193847656e-08, l_state.item.J).do_nothing
				Result := 0
			end
		end

	dnewton_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dnewton_iterate)
		end

	dnewton_set (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_DNEWTON_STATE_T]
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_DNEWTON_STATE_T]}.make_cast (a_vstate)
			l_n := a_function.item.n
			l_status := (a_function.item.f).integer_32_item ([a_x, a_function.item.params, a_f])
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := fdjac_inst.gsl_multiroot_fdjacobian (a_function, a_x, a_f, 1.4901161193847656e-08, l_state.item.J)
				if l_status.to_boolean then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, 0.0)
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	dnewton_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dnewton_set)
		end

end
