class
	P_DOGLEG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	compute_Rg (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_Rg: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sum: REAL_64
			l_gj: REAL_64
			l_rij: REAL_64
			js: JUMP_STATE
		do
			l_N := a_r___3.item.size2
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_N))
			loop
				l_sum := (0).to_double
				l_j := l_i
				from
				until
					not (l_j < l_N)
				loop
					l_gj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_gradient, l_j))
					l_rij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j))
					l_sum := l_sum + (l_rij * l_gj)
					l_j := l_j + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_Rg, l_i, l_sum)
				l_i := l_i + 1
			end
		end

	compute_Rg___0 (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_Rg: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sum: REAL_64
			l_gj: REAL_64
			l_rij: REAL_64
			js: JUMP_STATE
		do
			l_N := a_r___3.item.size2
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_N))
			loop
				l_sum := (0).to_double
				l_j := l_i
				from
				until
					not (l_j < l_N)
				loop
					l_gj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_gradient, l_j))
					l_rij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j))
					l_sum := l_sum + (l_rij * l_gj)
					l_j := l_j + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_Rg, l_i, l_sum)
				l_i := l_i + 1
			end
		end

	compute_actual_reduction___0 (a_fnorm: REAL_64; a_fnorm1: REAL_64): REAL_64
		local
			l_actred: REAL_64
			l_u: REAL_64
		do
			if a_fnorm1 < a_fnorm then
				l_u := a_fnorm1 / a_fnorm
				l_actred := (1).to_double - l_u * l_u
			else
				l_actred := (-1).to_double
			end
			Result := l_actred
		end

	compute_actual_reduction___1 (a_fnorm: REAL_64; a_fnorm1: REAL_64): REAL_64
		local
			l_actred: REAL_64
			l_u: REAL_64
		do
			if a_fnorm1 < a_fnorm then
				l_u := a_fnorm1 / a_fnorm
				l_actred := (1).to_double - l_u * l_u
			else
				l_actred := (-1).to_double
			end
			Result := l_actred
		end

	compute_delta___0 (a_diag: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_Dx: REAL_64
			l_factor: REAL_64
			l_tmp___0: REAL_64
		do
			l_Dx := (scaled_enorm___0 (a_diag, a_x))
			l_factor := (100).to_double
			if l_Dx > (0).to_double then
				l_tmp___0 := l_factor * l_Dx
			else
				l_tmp___0 := l_factor
			end
			Result := l_tmp___0
		end

	compute_delta___1 (a_diag: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_Dx: REAL_64
			l_factor: REAL_64
			l_tmp___0: REAL_64
		do
			l_Dx := (scaled_enorm___1 (a_diag, a_x))
			l_factor := (100).to_double
			if l_Dx > (0).to_double then
				l_tmp___0 := l_factor * l_Dx
			else
				l_tmp___0 := l_factor
			end
			Result := l_tmp___0
		end

	compute_df (a_f_trial: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_df: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_dfi: REAL_64
			l_tmp: REAL_64
		do
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_tmp := gsl_gsl_vector_double_inst.gsl_vector_get (a_f_trial, l_i)
				l_dfi := l_tmp - (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_df, l_i, l_dfi)
				l_i := l_i + 1
			end
		end

	compute_df___0 (a_f_trial: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_df: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_dfi: REAL_64
			l_tmp: REAL_64
		do
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_tmp := gsl_gsl_vector_double_inst.gsl_vector_get (a_f_trial, l_i)
				l_dfi := l_tmp - (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_df, l_i, l_dfi)
				l_i := l_i + 1
			end
		end

	compute_diag___0 (a_J: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_sum: REAL_64
			l_Jij: REAL_64
			js: JUMP_STATE
		do
			l_n := a_diag.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_Jij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_J, l_i, l_j))
					l_sum := l_sum + (l_Jij * l_Jij)
					l_i := l_i + 1
				end
				if l_sum = (0).to_double then
					l_sum := 1.0
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_j, (sqrt (l_sum)))
				l_j := l_j + 1
			end
		end

	compute_diag___1 (a_J: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_sum: REAL_64
			l_Jij: REAL_64
			js: JUMP_STATE
		do
			l_n := a_diag.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_Jij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_J, l_i, l_j))
					l_sum := l_sum + (l_Jij * l_Jij)
					l_i := l_i + 1
				end
				if l_sum = (0).to_double then
					l_sum := 1.0
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_j, (sqrt (l_sum)))
				l_j := l_j + 1
			end
		end

	compute_predicted_reduction (a_fnorm: REAL_64; a_fnorm1: REAL_64): REAL_64
		local
			l_prered: REAL_64
			l_u: REAL_64
		do
			if a_fnorm1 < a_fnorm then
				l_u := a_fnorm1 / a_fnorm
				l_prered := (1).to_double - l_u * l_u
			else
				l_prered := (0).to_double
			end
			Result := l_prered
		end

	compute_predicted_reduction___0 (a_fnorm: REAL_64; a_fnorm1: REAL_64): REAL_64
		local
			l_prered: REAL_64
			l_u: REAL_64
		do
			if a_fnorm1 < a_fnorm then
				l_u := a_fnorm1 / a_fnorm
				l_prered := (1).to_double - l_u * l_u
			else
				l_prered := (0).to_double
			end
			Result := l_prered
		end

	compute_qtf (a_q___3: CE_POINTER [PD_GSL_MATRIX]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_qtf: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_N: NATURAL_32
			l_sum: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_N := a_f.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_N))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_q___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i)))
					l_i := l_i + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_qtf, l_j, l_sum)
				l_j := l_j + 1
			end
		end

	compute_qtf___0 (a_q___3: CE_POINTER [PD_GSL_MATRIX]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_qtf: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_N: NATURAL_32
			l_sum: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_N := a_f.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_N))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_q___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i)))
					l_i := l_i + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_qtf, l_j, l_sum)
				l_j := l_j + 1
			end
		end

	compute_rdx (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_rdx: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_N: NATURAL_32
			l_sum: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_N := a_dx.item.size
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_N))
			loop
				l_sum := (0).to_double
				l_j := l_i
				from
				until
					not (l_j < l_N)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_j)))
					l_j := l_j + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_rdx, l_i, l_sum)
				l_i := l_i + 1
			end
		end

	compute_rdx___0 (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_rdx: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_N: NATURAL_32
			l_sum: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_N := a_dx.item.size
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_N))
			loop
				l_sum := (0).to_double
				l_j := l_i
				from
				until
					not (l_j < l_N)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_j)))
					l_j := l_j + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_rdx, l_i, l_sum)
				l_i := l_i + 1
			end
		end

	compute_trial_step___0 (a_x: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_N: NATURAL_32
			l_pi: REAL_64
			l_xi: REAL_64
		do
			l_N := a_x.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_pi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_i))
				l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x_trial, l_i, l_xi + l_pi)
				l_i := l_i + 1
			end
		end

	compute_trial_step___1 (a_x: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_N: NATURAL_32
			l_pi: REAL_64
			l_xi: REAL_64
		do
			l_N := a_x.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_pi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_i))
				l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x_trial, l_i, l_xi + l_pi)
				l_i := l_i + 1
			end
		end

	compute_wv (a_qtdf: CE_POINTER [PD_GSL_VECTOR]; a_rdx: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_pnorm: REAL_64; a_w: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_qtdfi: REAL_64
			l_rdxi: REAL_64
			l_dxi: REAL_64
			l_diagi: REAL_64
		do
			l_n := a_qtdf.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_qtdfi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtdf, l_i))
				l_rdxi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_rdx, l_i))
				l_dxi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_i))
				l_diagi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_i, (l_qtdfi - l_rdxi) / a_pnorm)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_v, l_i, ((l_diagi * l_diagi) * l_dxi) / a_pnorm)
				l_i := l_i + 1
			end
		end

	compute_wv___0 (a_qtdf: CE_POINTER [PD_GSL_VECTOR]; a_rdx: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_pnorm: REAL_64; a_w: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_qtdfi: REAL_64
			l_rdxi: REAL_64
			l_dxi: REAL_64
			l_diagi: REAL_64
		do
			l_n := a_qtdf.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_qtdfi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtdf, l_i))
				l_rdxi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_rdx, l_i))
				l_dxi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_i))
				l_diagi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_i, (l_qtdfi - l_rdxi) / a_pnorm)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_v, l_i, ((l_diagi * l_diagi) * l_dxi) / a_pnorm)
				l_i := l_i + 1
			end
		end

	dogleg (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_delta___0: REAL_64; a_newton: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_qnorm: REAL_64
			l_gnorm: REAL_64
			l_sgnorm: REAL_64
			l_bnorm: REAL_64
			l_temp: REAL_64
			l_alpha: REAL_64
			l_beta: REAL_64
			l_alpha___0: REAL_64
			l_beta___0: REAL_64
			l_bg: REAL_64
			l_bq: REAL_64
			l_dq: REAL_64
			l_dq2: REAL_64
			l_sd: REAL_64
			l_sd2: REAL_64
			l_t1: REAL_64
			l_u: REAL_64
			l_t2: REAL_64
			l_alpha___1: REAL_64
			l_beta___1: REAL_64
			js: JUMP_STATE
		do
			newton_direction (a_r___3, a_qtf, a_newton).do_nothing
			l_qnorm := scaled_enorm___0 (a_diag, a_newton)
			if l_qnorm <= a_delta___0 then
				copy_source_inst.gsl_vector_memcpy (a_p, a_newton).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				gradient_direction (a_r___3, a_qtf, a_diag, a_gradient)
				l_gnorm := enorm_inst.enorm___1 (a_gradient)
				if l_gnorm = (0).to_double then
					l_alpha := a_delta___0 / l_qnorm
					l_beta := (0).to_double
					scaled_addition (l_alpha, a_newton, l_beta, a_gradient, a_p)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				minimum_step (l_gnorm, a_diag, a_gradient)
				compute_Rg (a_r___3, a_gradient, a_p)
				l_temp := enorm_inst.enorm___1 (a_p)
				l_sgnorm := (l_gnorm / l_temp) / l_temp
				if l_sgnorm > a_delta___0 then
					l_alpha___0 := (0).to_double
					l_beta___0 := a_delta___0
					scaled_addition (l_alpha___0, a_newton, l_beta___0, a_gradient, a_p)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_bnorm := enorm_inst.enorm___1 (a_qtf)
				l_bg := l_bnorm / l_gnorm
				l_bq := l_bnorm / l_qnorm
				l_dq := a_delta___0 / l_qnorm
				l_dq2 := l_dq * l_dq
				l_sd := l_sgnorm / a_delta___0
				l_sd2 := l_sd * l_sd
				l_t1 := (l_bg * l_bq) * l_sd
				l_u := l_t1 - l_dq
				l_t2 := (l_t1 - l_dq * l_sd2) + (sqrt (l_u * l_u + ((1).to_double - l_dq2) * ((1).to_double - l_sd2)))
				l_alpha___1 := (l_dq * ((1).to_double - l_sd2)) / l_t2
				l_beta___1 := ((1).to_double - l_alpha___1) * l_sgnorm
				scaled_addition (l_alpha___1, a_newton, l_beta___1, a_gradient, a_p)
				Result := 0
			end
		end

	dogleg___0 (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_delta___0: REAL_64; a_newton: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_qnorm: REAL_64
			l_gnorm: REAL_64
			l_sgnorm: REAL_64
			l_bnorm: REAL_64
			l_temp: REAL_64
			l_alpha: REAL_64
			l_beta: REAL_64
			l_alpha___0: REAL_64
			l_beta___0: REAL_64
			l_bg: REAL_64
			l_bq: REAL_64
			l_dq: REAL_64
			l_dq2: REAL_64
			l_sd: REAL_64
			l_sd2: REAL_64
			l_t1: REAL_64
			l_u: REAL_64
			l_t2: REAL_64
			l_alpha___1: REAL_64
			l_beta___1: REAL_64
			js: JUMP_STATE
		do
			newton_direction___0 (a_r___3, a_qtf, a_newton).do_nothing
			l_qnorm := scaled_enorm___1 (a_diag, a_newton)
			if l_qnorm <= a_delta___0 then
				copy_source_inst.gsl_vector_memcpy (a_p, a_newton).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				gradient_direction___0 (a_r___3, a_qtf, a_diag, a_gradient)
				l_gnorm := enorm_inst.enorm___2 (a_gradient)
				if l_gnorm = (0).to_double then
					l_alpha := a_delta___0 / l_qnorm
					l_beta := (0).to_double
					scaled_addition___0 (l_alpha, a_newton, l_beta, a_gradient, a_p)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				minimum_step___0 (l_gnorm, a_diag, a_gradient)
				compute_Rg___0 (a_r___3, a_gradient, a_p)
				l_temp := enorm_inst.enorm___2 (a_p)
				l_sgnorm := (l_gnorm / l_temp) / l_temp
				if l_sgnorm > a_delta___0 then
					l_alpha___0 := (0).to_double
					l_beta___0 := a_delta___0
					scaled_addition___0 (l_alpha___0, a_newton, l_beta___0, a_gradient, a_p)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_bnorm := enorm_inst.enorm___2 (a_qtf)
				l_bg := l_bnorm / l_gnorm
				l_bq := l_bnorm / l_qnorm
				l_dq := a_delta___0 / l_qnorm
				l_dq2 := l_dq * l_dq
				l_sd := l_sgnorm / a_delta___0
				l_sd2 := l_sd * l_sd
				l_t1 := (l_bg * l_bq) * l_sd
				l_u := l_t1 - l_dq
				l_t2 := (l_t1 - l_dq * l_sd2) + (sqrt (l_u * l_u + ((1).to_double - l_dq2) * ((1).to_double - l_sd2)))
				l_alpha___1 := (l_dq * ((1).to_double - l_sd2)) / l_t2
				l_beta___1 := ((1).to_double - l_alpha___1) * l_sgnorm
				scaled_addition___0 (l_alpha___1, a_newton, l_beta___1, a_gradient, a_p)
				Result := 0
			end
		end

	enorm_sum (a_a___5: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_ai: REAL_64
			l_bi: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_a___5.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_ai := (gsl_gsl_vector_double_inst.gsl_vector_get (a_a___5, l_i))
				l_bi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_b___0, l_i))
				l_u := l_ai + l_bi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	enorm_sum___0 (a_a___5: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_ai: REAL_64
			l_bi: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_a___5.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_ai := (gsl_gsl_vector_double_inst.gsl_vector_get (a_a___5, l_i))
				l_bi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_b___0, l_i))
				l_u := l_ai + l_bi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	gradient_direction (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR])
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sum: REAL_64
			l_dj: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_M := a_r___3.item.size1
			l_N := a_r___3.item.size2
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_M))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtf, l_i)))
					l_i := l_i + 1
				end
				l_dj := gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_j)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_g, l_j, -l_sum / l_dj)
				l_j := l_j + 1
			end
		end

	gradient_direction___0 (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR])
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sum: REAL_64
			l_dj: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_M := a_r___3.item.size1
			l_N := a_r___3.item.size2
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_M))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtf, l_i)))
					l_i := l_i + 1
				end
				l_dj := gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_j)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_g, l_j, -l_sum / l_dj)
				l_j := l_j + 1
			end
		end

	minimum_step (a_gnorm: REAL_64; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_gi: REAL_64
			l_di: REAL_64
		do
			l_N := a_g.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_gi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_g, l_i))
				l_di := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_g, l_i, (l_gi / a_gnorm) / l_di)
				l_i := l_i + 1
			end
		end

	minimum_step___0 (a_gnorm: REAL_64; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_gi: REAL_64
			l_di: REAL_64
		do
			l_N := a_g.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_gi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_g, l_i))
				l_di := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_g, l_i, (l_gi / a_gnorm) / l_di)
				l_i := l_i + 1
			end
		end

	newton_direction (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_status: INTEGER_32
			l_pi: REAL_64
		do
			l_N := a_r___3.item.size2
			l_status := qr_inst.gsl_linalg_R_solve (a_r___3, a_qtf, a_p)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_pi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_p, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_p, l_i, -l_pi)
				l_i := l_i + 1
			end
			Result := l_status
		end

	newton_direction___0 (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_status: INTEGER_32
			l_pi: REAL_64
		do
			l_N := a_r___3.item.size2
			l_status := qr_inst.gsl_linalg_R_solve (a_r___3, a_qtf, a_p)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_pi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_p, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_p, l_i, -l_pi)
				l_i := l_i + 1
			end
			Result := l_status
		end

	scaled_addition (a_alpha: REAL_64; a_newton: CE_POINTER [PD_GSL_VECTOR]; a_beta: REAL_64; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_ni: REAL_64
			l_gi: REAL_64
		do
			l_N := a_p.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ni := (gsl_gsl_vector_double_inst.gsl_vector_get (a_newton, l_i))
				l_gi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_gradient, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_p, l_i, a_alpha * l_ni + a_beta * l_gi)
				l_i := l_i + 1
			end
		end

	scaled_addition___0 (a_alpha: REAL_64; a_newton: CE_POINTER [PD_GSL_VECTOR]; a_beta: REAL_64; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_ni: REAL_64
			l_gi: REAL_64
		do
			l_N := a_p.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ni := (gsl_gsl_vector_double_inst.gsl_vector_get (a_newton, l_i))
				l_gi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_gradient, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_p, l_i, a_alpha * l_ni + a_beta * l_gi)
				l_i := l_i + 1
			end
		end

	scaled_enorm___0 (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
			l_di: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_di := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_i))
				l_u := l_di * l_fi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	scaled_enorm___1 (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
			l_di: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_di := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_i))
				l_u := l_di * l_fi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	update_diag___0 (a_J: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_cnorm: REAL_64
			l_diagj: REAL_64
			l_sum: REAL_64
			l_Jij: REAL_64
			js: JUMP_STATE
		do
			l_n := a_diag.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_Jij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_J, l_i, l_j))
					l_sum := l_sum + (l_Jij * l_Jij)
					l_i := l_i + 1
				end
				if l_sum = (0).to_double then
					l_sum := 1.0
				end
				l_cnorm := sqrt (l_sum)
				l_diagj := gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_j)
				if l_cnorm > l_diagj then
					gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_j, l_cnorm)
				end
				l_j := l_j + 1
			end
		end

	update_diag___1 (a_J: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_cnorm: REAL_64
			l_diagj: REAL_64
			l_sum: REAL_64
			l_Jij: REAL_64
			js: JUMP_STATE
		do
			l_n := a_diag.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_Jij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_J, l_i, l_j))
					l_sum := l_sum + (l_Jij * l_Jij)
					l_i := l_i + 1
				end
				if l_sum = (0).to_double then
					l_sum := 1.0
				end
				l_cnorm := sqrt (l_sum)
				l_diagj := gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_j)
				if l_cnorm > l_diagj then
					gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_j, l_cnorm)
				end
				l_j := l_j + 1
			end
		end

end
