class
	P_DROTMG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_drotmg (a_d1: CE_POINTER [REAL_64]; a_d2: CE_POINTER [REAL_64]; a_b1___0: CE_POINTER [REAL_64]; a_b2: REAL_64; a_P___2: CE_POINTER [REAL_64])
		local
			l_G: REAL_64
			l_G2: REAL_64
			l_D1: REAL_64
			l_D2: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_h11: REAL_64
			l_h12: REAL_64
			l_h21: REAL_64
			l_h22: REAL_64
			l_u: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_G := 4096.0
			l_G2 := l_G * l_G
			l_D1 := a_d1.item
			l_D2 := a_d2.item
			l_x := a_b1___0.item
			l_y := a_b2
			if l_D1 < 0.0 then
				a_P___2[0] := (-1).to_double
				a_P___2[1] := (0).to_double
				a_P___2[2] := (0).to_double
				a_P___2[3] := (0).to_double
				a_P___2[4] := (0).to_double
				a_d1.item := (0).to_double
				a_d2.item := (0).to_double
				a_b1___0.item := (0).to_double
				js.return
			end
			if not js.return_called and then (l_D2 * l_y = 0.0) then
				a_P___2[0] := (-2).to_double
				js.return
			end
			if not js.return_called then
				l_c___1 := fabs ((l_D1 * l_x) * l_x)
				l_s := fabs ((l_D2 * l_y) * l_y)
				if l_c___1 > l_s then
					a_P___2[0] := 0.0
					l_h11 := (1).to_double
					l_h12 := (l_D2 * l_y) / (l_D1 * l_x)
					l_h21 := -l_y / l_x
					l_h22 := (1).to_double
					l_u := (1).to_double - l_h21 * l_h12
					if l_u <= 0.0 then
						a_P___2[0] := (-1).to_double
						a_P___2[1] := (0).to_double
						a_P___2[2] := (0).to_double
						a_P___2[3] := (0).to_double
						a_P___2[4] := (0).to_double
						a_d1.item := (0).to_double
						a_d2.item := (0).to_double
						a_b1___0.item := (0).to_double
						js.return
					end
					if not js.return_called then
						l_D1 := l_D1 / l_u
						l_D2 := l_D2 / l_u
						l_x := l_x * l_u
					end
				else
					if (l_D2 * l_y) * l_y < 0.0 then
						a_P___2[0] := (-1).to_double
						a_P___2[1] := (0).to_double
						a_P___2[2] := (0).to_double
						a_P___2[3] := (0).to_double
						a_P___2[4] := (0).to_double
						a_d1.item := (0).to_double
						a_d2.item := (0).to_double
						a_b1___0.item := (0).to_double
						js.return
					end
					if not js.return_called then
						a_P___2[0] := (1).to_double
						l_h11 := (l_D1 * l_x) / (l_D2 * l_y)
						l_h12 := (1).to_double
						l_h21 := (-1).to_double
						l_h22 := l_x / l_y
						l_u := (1).to_double + l_h11 * l_h22
						l_D1 := l_D1 / l_u
						l_D2 := l_D2 / l_u
						l_tmp := l_D2
						l_D2 := l_D1
						l_D1 := l_tmp
						l_x := l_y * l_u
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if l_D1 <= 1.0 / l_G2 then
						if l_D1 = 0.0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						a_P___2[0] := (-1).to_double
						l_D1 := l_D1 * l_G2
						l_x := l_x / l_G
						l_h11 := l_h11 / l_G
						l_h12 := l_h12 / l_G
					end
				end
				from
				until
					not (l_D1 >= l_G2)
				loop
					a_P___2[0] := (-1).to_double
					l_D1 := l_D1 / l_G2
					l_x := l_x * l_G
					l_h11 := l_h11 * l_G
					l_h12 := l_h12 * l_G
				end
				from
				until
					js.loop_done
				loop
					if (fabs (l_D2)) <= 1.0 / l_G2 then
						if l_D2 = 0.0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						a_P___2[0] := (-1).to_double
						l_D2 := l_D2 * l_G2
						l_h21 := l_h21 / l_G
						l_h22 := l_h22 / l_G
					end
				end
				from
				until
					js.loop_done
				loop
					if not ((fabs (l_D2)) >= l_G2) then
						js.break
					end
					if not js.loop_jumped then
						a_P___2[0] := (-1).to_double
						l_D2 := l_D2 / l_G2
						l_h21 := l_h21 * l_G
						l_h22 := l_h22 * l_G
					end
				end
				a_d1.item := l_D1
				a_d2.item := l_D2
				a_b1___0.item := l_x
				if a_P___2[0] = -1.0 then
					a_P___2[1] := l_h11
					a_P___2[2] := l_h21
					a_P___2[3] := l_h12
					a_P___2[4] := l_h22
				elseif a_P___2[0] = 0.0 then
					a_P___2[2] := l_h21
					a_P___2[3] := l_h12
				elseif a_P___2[0] = 1.0 then
					a_P___2[1] := l_h11
					a_P___2[4] := l_h22
				end
			end
		end

end
