class
	P_ENV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ieee_env_setup
		local
			l_p: CE_POINTER [INTEGER_8]
			l_precision: CE_ARRAY [INTEGER_32]
			l_rounding: CE_ARRAY [INTEGER_32]
			l_exception_mask: CE_ARRAY [INTEGER_32]
			l_comma: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make
			create l_precision.make (<<1>>)
			create l_rounding.make (<<1>>)
			create l_exception_mask.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := (getenv (ce_string ("GSL_IEEE_MODE")))
					l_precision.item := 0
					l_rounding.item := 0
					l_exception_mask.item := 0
					l_comma := 0
					if l_p.is_void then
						js.return
					end
					if not js.return_called and then ((l_p[0]).to_integer_32 = 0) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						read_inst.gsl_ieee_read_mode_string (l_p, l_precision, l_rounding, l_exception_mask).do_nothing
						fp_gnux86_inst.gsl_ieee_set_mode (l_precision.item, l_rounding.item, l_exception_mask.item).do_nothing
						Io.error.put_string ("GSL_IEEE_MODE=%"")
						inspect l_precision.item -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 1
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("single-precision")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("double-precision")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 3
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("extended-precision")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						inspect l_rounding.item -- switch 2 head
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 6 then -- switch 2, case 1
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-to-nearest")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 10 -- switch 2; break
				when 7 then -- switch 2, case 2
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-down")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 10 -- switch 2; break
				when 8 then -- switch 2, case 3
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-up")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 10 -- switch 2; break
				when 9 then -- switch 2, case 4
						from
						until
							js.loop_done
						loop
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-to-zero")
							l_comma := l_comma + 1
							js.break
						end
						l_pos := -1 + 10 -- switch 2; break
				when 10 then -- switch 2, done:
						if ((l_exception_mask.item).bit_and (31)) = 31 then
							from
							until
								js.loop_done
							loop
								if l_comma.to_boolean then
									Io.error.put_string (",")
								end
								Io.error.put_string ("mask-all")
								l_comma := l_comma + 1
								js.break
							end
						elseif ((l_exception_mask.item).bit_and (31)) = 0 then
							from
							until
								js.loop_done
							loop
								if l_comma.to_boolean then
									Io.error.put_string (",")
								end
								Io.error.put_string ("trap-common")
								l_comma := l_comma + 1
								js.break
							end
						else
							if ((l_exception_mask.item).bit_and (1)).to_boolean then
								from
								until
									js.loop_done
								loop
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-invalid")
									l_comma := l_comma + 1
									js.break
								end
							end
							if ((l_exception_mask.item).bit_and (2)).to_boolean then
								from
								until
									js.loop_done
								loop
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-denormalized")
									l_comma := l_comma + 1
									js.break
								end
							end
							if ((l_exception_mask.item).bit_and (4)).to_boolean then
								from
								until
									js.loop_done
								loop
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-division-by-zero")
									l_comma := l_comma + 1
									js.break
								end
							end
							if ((l_exception_mask.item).bit_and (8)).to_boolean then
								from
								until
									js.loop_done
								loop
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-overflow")
									l_comma := l_comma + 1
									js.break
								end
							end
							if ((l_exception_mask.item).bit_and (16)).to_boolean then
								from
								until
									js.loop_done
								loop
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-underflow")
									l_comma := l_comma + 1
									js.break
								end
							end
						end
						if ((l_exception_mask.item).bit_and (32)).to_boolean then
							from
							until
								js.loop_done
							loop
								if l_comma.to_boolean then
									Io.error.put_string (",")
								end
								Io.error.put_string ("trap-inexact")
								l_comma := l_comma + 1
								js.break
							end
						end
						Io.error.put_string ("%"%N")
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
