class
	P_EXPINT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create AE11_cs.make (<<1>>)
			create AE11_data.make (<<39>>)
			create AE12_cs.make (<<1>>)
			create AE12_data.make (<<25>>)
			create AE13_cs.make (<<1>>)
			create AE13_data.make (<<25>>)
			create AE14_cs.make (<<1>>)
			create AE14_data.make (<<26>>)
			create E11_cs.make (<<1>>)
			create E11_data.make (<<19>>)
			create E12_cs.make (<<1>>)
			create E12_data.make (<<16>>)
		end

feature {ANY} -- attributes

	AE11_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	AE11_data: CE_ARRAY [REAL_64]

	AE12_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	AE12_data: CE_ARRAY [REAL_64]

	AE13_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	AE13_data: CE_ARRAY [REAL_64]

	AE14_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	AE14_data: CE_ARRAY [REAL_64]

	E11_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	E11_data: CE_ARRAY [REAL_64]

	E12_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	E12_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	expint_E1_impl (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_scale: INTEGER_32): INTEGER_32
		local
			l_xmaxt: REAL_64
			l_xmax: REAL_64
			l_s: REAL_64
			l_tmp___3: REAL_64
			l_result_c: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___4: REAL_64
			l_s___0: REAL_64
			l_tmp___7: REAL_64
			l_result_c___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ln_term: REAL_64
			l_scale_factor: REAL_64
			l_tmp___12: REAL_64
			l_result_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ln_term___0: REAL_64
			l_scale_factor___0: REAL_64
			l_tmp___20: REAL_64
			l_result_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s___1: REAL_64
			l_tmp___24: REAL_64
			l_result_c___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s___2: REAL_64
			l_tmp___27: REAL_64
			l_result_c___4: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result_c.make (<<1>>)
			create l_result_c___0.make (<<1>>)
			create l_result_c___1.make (<<1>>)
			create l_result_c___2.make (<<1>>)
			create l_result_c___3.make (<<1>>)
			create l_result_c___4.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xmaxt := -(-7.0839641853226408e+02)
					l_xmax := l_xmaxt - (log (l_xmaxt))
					if not (a_x < -l_xmax) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_scale.to_boolean then
							from
							until
								js.loop_done
							loop
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("expint.c"), 298, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else: | _L___0:
						if not (a_x <= -10.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_scale.to_boolean then
							l_tmp___3 := 1.0
						else
							l_tmp___3 := (exp (-a_x))
						end
						l_s := (1.0 / a_x) * l_tmp___3
						cheb_eval_inst.cheb_eval_e (AE11_cs, 20.0 / a_x + 1.0, l_result_c).do_nothing
						a_result.item.val := l_s * (1.0 + l_result_c.item.val)
						a_result.item.err := l_s * l_result_c.item.err
						l_tmp___4 := fabs (a_x)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___4 + 1.0)) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if not (a_x <= -4.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_scale.to_boolean then
							l_tmp___7 := 1.0
						else
							l_tmp___7 := (exp (-a_x))
						end
						l_s___0 := (1.0 / a_x) * l_tmp___7
						cheb_eval_inst.cheb_eval_e (AE12_cs, (40.0 / a_x + 7.0) / 3.0, l_result_c___0).do_nothing
						a_result.item.val := l_s___0 * (1.0 + l_result_c___0.item.val)
						a_result.item.err := l_s___0 * l_result_c___0.item.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else:
						if not (a_x <= -1.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_ln_term := -(log ((fabs (a_x))))
						if a_scale.to_boolean then
							l_tmp___12 := (exp (a_x))
						else
							l_tmp___12 := 1.0
						end
						l_scale_factor := l_tmp___12
						cheb_eval_inst.cheb_eval_e (E11_cs, (2.0 * a_x + 5.0) / 3.0, l_result_c___1).do_nothing
						a_result.item.val := l_scale_factor * (l_ln_term + l_result_c___1.item.val)
						a_result.item.err := l_scale_factor * (l_result_c___1.item.err + 2.2204460492503131e-16 * (fabs (l_ln_term)))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("expint.c"), 329, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else:
						if not (a_x <= 1.0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_ln_term___0 := -(log ((fabs (a_x))))
						if a_scale.to_boolean then
							l_tmp___20 := (exp (a_x))
						else
							l_tmp___20 := 1.0
						end
						l_scale_factor___0 := l_tmp___20
						cheb_eval_inst.cheb_eval_e (E12_cs, a_x, l_result_c___2).do_nothing
						a_result.item.val := l_scale_factor___0 * (((l_ln_term___0 - 0.6875) + a_x) + l_result_c___2.item.val)
						a_result.item.err := l_scale_factor___0 * (l_result_c___2.item.err + 2.2204460492503131e-16 * (fabs (l_ln_term___0)))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else:
						if not (a_x <= 4.0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_scale.to_boolean then
							l_tmp___24 := 1.0
						else
							l_tmp___24 := (exp (-a_x))
						end
						l_s___1 := (1.0 / a_x) * l_tmp___24
						cheb_eval_inst.cheb_eval_e (AE13_cs, (8.0 / a_x - 5.0) / 3.0, l_result_c___3).do_nothing
						a_result.item.val := l_s___1 * (1.0 + l_result_c___3.item.val)
						a_result.item.err := l_s___1 * l_result_c___3.item.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 21 then -- else:
						if not (a_x <= l_xmax) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else:
						if not (a_scale.to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L:
						if a_scale.to_boolean then
							l_tmp___27 := 1.0
						else
							l_tmp___27 := (exp (-a_x))
						end
						l_s___2 := (1.0 / a_x) * l_tmp___27
						cheb_eval_inst.cheb_eval_e (AE14_cs, 8.0 / a_x - 1.0, l_result_c___4).do_nothing
						a_result.item.val := l_s___2 * (1.0 + l_result_c___4.item.val)
						a_result.item.err := l_s___2 * (2.2204460492503131e-16 + l_result_c___4.item.err)
						a_result.item.err := a_result.item.err + (((2.0 * (a_x + 1.0)) * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if a_result.item.val = 0.0 then
							from
							until
								js.loop_done
							loop
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 358, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							Result := 0
							js.return
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						from
						until
							js.loop_done
						loop
							a_result.item.val := 0.0
							a_result.item.err := 2.2250738585072014e-308
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 363, 15)
								Result := 15
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 28 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	expint_E2_impl (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_scale: INTEGER_32): INTEGER_32
		local
			l_xmaxt: REAL_64
			l_xmax: REAL_64
			l_ex: REAL_64
			l_tmp___3: REAL_64
			l_result_E1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_E1: INTEGER_32
			l_s: REAL_64
			l_tmp___8: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_c10: REAL_64
			l_c11: REAL_64
			l_c12: REAL_64
			l_c13: REAL_64
			l_y: REAL_64
			l_sum6: REAL_64
			l_sum: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result_E1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xmaxt := -(-7.0839641853226408e+02)
					l_xmax := l_xmaxt - (log (l_xmaxt))
					if not (a_x < -l_xmax) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_scale.to_boolean then
							from
							until
								js.loop_done
							loop
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("expint.c"), 377, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else: | _L___0:
						if a_x /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_scale.to_boolean then
							a_result.item.val := 1.0
						else
							a_result.item.val := 1.0
						end
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if not (a_x < 100.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_scale.to_boolean then
							l_tmp___3 := 1.0
						else
							l_tmp___3 := (exp (-a_x))
						end
						l_ex := l_tmp___3
						l_stat_E1 := (expint_E1_impl (a_x, l_result_E1, a_scale))
						a_result.item.val := l_ex - a_x * l_result_E1.item.val
						a_result.item.err := 2.2204460492503131e-16 * l_ex + (fabs (a_x)) * l_result_E1.item.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := l_stat_E1
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if not (a_x < l_xmax) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (a_scale.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						if a_scale.to_boolean then
							l_tmp___8 := 1.0
						else
							l_tmp___8 := (exp (-a_x))
						end
						l_s := l_tmp___8
						l_c1___2 := -2.0
						l_c2___0 := 6.0
						l_c3___3 := -24.0
						l_c4___2 := 120.0
						l_c5___1 := -720.0
						l_c6___2 := 5040.0
						l_c7___0 := -40320.0
						l_c8___0 := 362880.0
						l_c9 := -3628800.0
						l_c10 := 39916800.0
						l_c11 := -479001600.0
						l_c12 := 6227020800.0
						l_c13 := -87178291200.0
						l_y := 1.0 / a_x
						l_sum6 := l_c6___2 + l_y * (l_c7___0 + l_y * (l_c8___0 + l_y * (l_c9 + l_y * (l_c10 + l_y * (l_c11 + l_y * (l_c12 + l_y * l_c13))))))
						l_sum := l_y * (l_c1___2 + l_y * (l_c2___0 + l_y * (l_c3___3 + l_y * (l_c4___2 + l_y * (l_c5___1 + l_y * l_sum6)))))
						a_result.item.val := (l_s * (1.0 + l_sum)) / a_x
						a_result.item.err := ((2.0 * (a_x + 1.0)) * 2.2204460492503131e-16) * a_result.item.val
						if a_result.item.val = 0.0 then
							from
							until
								js.loop_done
							loop
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 413, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							Result := 0
							js.return
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						from
						until
							js.loop_done
						loop
							a_result.item.val := 0.0
							a_result.item.err := 2.2250738585072014e-308
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 418, 15)
								Result := 15
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	expint_En_impl (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_scale: INTEGER_32): INTEGER_32
		local
			l_tmp___4: REAL_64
			l_tmp___12: REAL_64
			l_result_g: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_prefactor: REAL_64
			l_status: INTEGER_32
			l_scale_factor: REAL_64
			l_tmp___18: REAL_64
			js: JUMP_STATE
		do
			create l_result_g.make (<<1>>)

			if a_n < 0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("expint.c"), 426, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_n = 0 then
				if a_x = (0).to_double then
					from
					until
						js.loop_done
					loop
						a_result.item.val := (builtin_nanf (ce_string (""))).to_double
						a_result.item.err := (builtin_nanf (ce_string (""))).to_double
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("expint.c"), 429, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						if not js.return_called then
							js.break
						end
					end
				else
					if a_scale.to_boolean then
						l_tmp___4 := 1.0
					else
						l_tmp___4 := (exp (-a_x))
					end
					a_result.item.val := l_tmp___4 / a_x
					a_result.item.err := ((2).to_double * 2.2204460492503131e-16) * (fabs (a_result.item.val))
					if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 433, 15)
							Result := 15
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						Result := 0
						js.return
					end
				end
			elseif a_n = 1 then
				Result := (expint_E1_impl (a_x, a_result, a_scale))
				js.return
			elseif a_n = 2 then
				Result := (expint_E2_impl (a_x, a_result, a_scale))
				js.return
			else
				if a_x < (0).to_double then
					from
					until
						js.loop_done
					loop
						a_result.item.val := (builtin_nanf (ce_string (""))).to_double
						a_result.item.err := (builtin_nanf (ce_string (""))).to_double
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("expint.c"), 442, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					if a_x = (0).to_double then
						if a_scale.to_boolean then
							l_tmp___12 := (exp (a_x))
						else
							l_tmp___12 := (1).to_double
						end
						a_result.item.val := l_tmp___12 * ((1).to_double / (a_n.to_double - 1.0))
						a_result.item.err := ((2).to_double * 2.2204460492503131e-16) * (fabs (a_result.item.val))
						if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 447, 15)
								Result := 15
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
						if not js.return_called then
							Result := 0
							js.return
						end
					else
						l_prefactor := (pow (a_x, (a_n - 1).to_double))
						l_status := (gamma_inc_inst.gsl_sf_gamma_inc_e ((1 - a_n).to_double, a_x, l_result_g))
						if a_scale.to_boolean then
							l_tmp___18 := (exp (a_x))
						else
							l_tmp___18 := 1.0
						end
						l_scale_factor := l_tmp___18
						a_result.item.val := (l_scale_factor * l_prefactor) * l_result_g.item.val
						a_result.item.err := ((2).to_double * 2.2204460492503131e-16) * (fabs (a_result.item.val))
						a_result.item.err := a_result.item.err + ((2).to_double * (fabs ((l_scale_factor * l_prefactor) * l_result_g.item.err)))
						if l_status = 0 then
							if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("expint.c"), 457, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
						end
						if not js.return_called then
							Result := l_status
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_expint_E1 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_E1_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_E1_e(x, &result)"), ce_string ("expint.c"), 545, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_E1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (expint_E1_impl (a_x, a_result, 0))
		end

	gsl_sf_expint_E1_scaled (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_E1_scaled_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_E1_scaled_e(x, &result)"), ce_string ("expint.c"), 550, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_E1_scaled_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (expint_E1_impl (a_x, a_result, 1))
		end

	gsl_sf_expint_E2 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_E2_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_E2_e(x, &result)"), ce_string ("expint.c"), 555, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_E2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (expint_E2_impl (a_x, a_result, 0))
		end

	gsl_sf_expint_E2_scaled (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_E2_scaled_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_E2_scaled_e(x, &result)"), ce_string ("expint.c"), 560, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_E2_scaled_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (expint_E2_impl (a_x, a_result, 1))
		end

	gsl_sf_expint_Ei (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_Ei_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_Ei_e(x, &result)"), ce_string ("expint.c"), 575, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_Ei_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (gsl_sf_expint_E1_e (-a_x, a_result))
			a_result.item.val := -a_result.item.val
			Result := l_status
		end

	gsl_sf_expint_Ei_scaled (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_Ei_scaled_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_Ei_scaled_e(x, &result)"), ce_string ("expint.c"), 580, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_Ei_scaled_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (gsl_sf_expint_E1_scaled_e (-a_x, a_result))
			a_result.item.val := -a_result.item.val
			Result := l_status
		end

	gsl_sf_expint_En (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_En_e (a_n, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_En_e(n, x, &result)"), ce_string ("expint.c"), 565, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_En_e (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (expint_En_impl (a_n, a_x, a_result, 0))
		end

	gsl_sf_expint_En_scaled (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_expint_En_scaled_e (a_n, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_expint_En_scaled_e(n, x, &result)"), ce_string ("expint.c"), 570, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_expint_En_scaled_e (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (expint_En_impl (a_n, a_x, a_result, 1))
		end

end
