class
	P_FDFSOLVER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multifit_fdfsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]; a_n: NATURAL_32; a_p: NATURAL_32): CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]
			js: JUMP_STATE
		do
			create l_s.make

			if a_n < a_p then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("insufficient data points, n < p"), ce_string ("fdfsolver.c"), 36, 4)
					Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s := create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIFIT_FDFSOLVER}.make).structure_size.to_natural_32)))
				if l_s.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for multifit solver struct"), ce_string ("fdfsolver.c"), 44, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.x := init_source_inst.gsl_vector_calloc (a_p)
				if (l_s.item.x).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fdfsolver.c"), 52, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.f := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fdfsolver.c"), 61, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.J := init_source_inst.gsl_matrix_calloc (a_n, a_p)
				if (l_s.item.J).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for g"), ce_string ("fdfsolver.c"), 71, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.dx := init_source_inst.gsl_vector_calloc (a_p)
				if (l_s.item.dx).is_void then
					init_source_inst.gsl_matrix_free (l_s.item.J)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fdfsolver.c"), 82, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					init_source_inst.gsl_matrix_free (l_s.item.J)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for multifit solver state"), ce_string ("fdfsolver.c"), 96, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n, a_p])
				if l_status /= 0 then
					free (l_s.item.state)
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					init_source_inst.gsl_matrix_free (l_s.item.J)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to set solver"), ce_string ("fdfsolver.c"), 112, l_status)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.fdf := create {CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multifit_fdfsolver_free (a_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state)
				init_source_inst.gsl_vector_free (a_s.item.dx)
				init_source_inst.gsl_vector_free (a_s.item.x)
				init_source_inst.gsl_vector_free (a_s.item.f)
				init_source_inst.gsl_matrix_free (a_s.item.J)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_multifit_fdfsolver_iterate (a_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.fdf, a_s.item.x, a_s.item.f, a_s.item.J, a_s.item.dx]))
		end

	gsl_multifit_fdfsolver_name (a_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_multifit_fdfsolver_position (a_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.x)
		end

	gsl_multifit_fdfsolver_set (a_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]; a_f: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_s.item.f).item.size /= a_f.item.n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("function size does not match solver"), ce_string ("fdfsolver.c"), 127, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then ((a_s.item.x).item.size /= a_x.item.size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector length does not match solver"), ce_string ("fdfsolver.c"), 132, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_s.item.fdf := a_f
				copy_source_inst.gsl_vector_memcpy (a_s.item.x, a_x).do_nothing
				Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.fdf, a_s.item.x, a_s.item.f, a_s.item.J, a_s.item.dx]))
			end
		end

	gsl_multiroot_fdfsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIROOT_FDFSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for multiroot solver struct"), ce_string ("fdfsolver.c"), 39, 8)
					Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.x := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.x).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fdfsolver.c"), 47, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.f := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fdfsolver.c"), 56, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.J := init_source_inst.gsl_matrix_calloc (a_n, a_n)
				if (l_s.item.J).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for g"), ce_string ("fdfsolver.c"), 66, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.dx := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.dx).is_void then
					init_source_inst.gsl_matrix_free (l_s.item.J)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fdfsolver.c"), 77, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					init_source_inst.gsl_matrix_free (l_s.item.J)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for multiroot solver state"), ce_string ("fdfsolver.c"), 91, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					free (l_s.item.state)
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					init_source_inst.gsl_matrix_free (l_s.item.J)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to set solver"), ce_string ("fdfsolver.c"), 107, l_status)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.fdf := create {CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multiroot_fdfsolver_dx (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.dx)
		end

	gsl_multiroot_fdfsolver_f (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.f)
		end

	gsl_multiroot_fdfsolver_free (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state)
				init_source_inst.gsl_vector_free (a_s.item.dx)
				init_source_inst.gsl_vector_free (a_s.item.x)
				init_source_inst.gsl_vector_free (a_s.item.f)
				init_source_inst.gsl_matrix_free (a_s.item.J)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_multiroot_fdfsolver_iterate (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.fdf, a_s.item.x, a_s.item.f, a_s.item.J, a_s.item.dx]))
		end

	gsl_multiroot_fdfsolver_name (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_multiroot_fdfsolver_root (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.x)
		end

	gsl_multiroot_fdfsolver_set (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]; a_f: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_s.item.x).item.size /= a_f.item.n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("function incompatible with solver size"), ce_string ("fdfsolver.c"), 122, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_x.item.size /= a_f.item.n) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector length not compatible with function"), ce_string ("fdfsolver.c"), 127, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_s.item.fdf := a_f
				copy_source_inst.gsl_vector_memcpy (a_s.item.x, a_x).do_nothing
				Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.fdf, a_s.item.x, a_s.item.f, a_s.item.J, a_s.item.dx]))
			end
		end

	gsl_root_fdfsolver_alloc (a_T: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE]): CE_POINTER [PD_GSL_ROOT_FDFSOLVER]
		local
			l_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_ROOT_FDFSOLVER]}.make_cast ((malloc ((create {PD_GSL_ROOT_FDFSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for root solver struct"), ce_string ("fdfsolver.c"), 35, 8)
					Result := (create {CE_POINTER [PD_GSL_ROOT_FDFSOLVER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for root solver state"), ce_string ("fdfsolver.c"), 45, 8)
						Result := (create {CE_POINTER [PD_GSL_ROOT_FDFSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_s.item.fdf := create {CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_root_fdfsolver_free (a_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				free (a_s.item.state)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_root_fdfsolver_iterate (a_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.fdf, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_ROOT_FDFSOLVER}.make).offset_of ("root"))]))
		end

	gsl_root_fdfsolver_name (a_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_root_fdfsolver_root (a_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER]): REAL_64
		do
			Result := (a_s.item.root)
		end

	gsl_root_fdfsolver_set (a_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER]; a_f: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: REAL_64): INTEGER_32
		do
			a_s.item.fdf := a_f
			a_s.item.root := a_root
			Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.fdf, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_ROOT_FDFSOLVER}.make).offset_of ("root"))]))
		end

end
