class
	P_FDJAC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multiroot_fdjacobian (a_F___0: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_epsrel: REAL_64; a_jacobian: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_n: NATURAL_32
			l_m___4: NATURAL_32
			l_n1: NATURAL_32
			l_n2: NATURAL_32
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x1___0: CE_POINTER [PD_GSL_VECTOR]
			l_f1: CE_POINTER [PD_GSL_VECTOR]
			l_xj: REAL_64
			l_dx: REAL_64
			l_f_stat: INTEGER_32
			l_g1: REAL_64
			l_g0: REAL_64
			l_col: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_null_col: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_x1___0.make
			create l_f1.make
			create l_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_x.item.size
					l_m___4 := a_f.item.size
					l_n1 := a_jacobian.item.size1
					l_n2 := a_jacobian.item.size2
					l_status := 0
					if l_m___4 = l_n1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_n = l_n2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("function and jacobian are not conformant"), ce_string ("fdjac.c"), 36, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_x1___0 := init_source_inst.gsl_vector_alloc (l_n)
							if l_x1___0.is_void then
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("failed to allocate space for x1 workspace"), ce_string ("fdjac.c"), 47, 8)
									Result := 8
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
						end
						if not js.return_called then
							l_f1 := init_source_inst.gsl_vector_alloc (l_m___4)
							if l_f1.is_void then
								init_source_inst.gsl_vector_free (l_x1___0)
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("failed to allocate space for f1 workspace"), ce_string ("fdjac.c"), 56, 8)
									Result := 8
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
						end
						if not js.return_called then
							copy_source_inst.gsl_vector_memcpy (l_x1___0, a_x).do_nothing
							l_j := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_j < l_n))
							loop
								l_xj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_j))
								l_dx := a_epsrel * (fabs (l_xj))
								if l_dx = (0).to_double then
									l_dx := a_epsrel
								end
								gsl_gsl_vector_double_inst.gsl_vector_set (l_x1___0, l_j, l_xj + l_dx)
								l_f_stat := ((a_F___0.item.f).integer_32_item ([l_x1___0, a_F___0.item.params, l_f1]))
								if l_f_stat /= 0 then
									l_status := 9
									js.break
								end
								if not js.loop_jumped then
									gsl_gsl_vector_double_inst.gsl_vector_set (l_x1___0, l_j, l_xj)
									l_i := (0).to_natural_32
									from
									until
										not (l_i < l_m___4)
									loop
										l_g1 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_f1, l_i))
										l_g0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_jacobian, l_i, l_j, (l_g1 - l_g0) / l_dx)
										l_i := l_i + 1
									end
									l_col.item := (rowcol_source_inst.gsl_matrix_column (a_jacobian, l_j)).twin
									l_null_col := (prop_source_inst.gsl_vector_isnull ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_col.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))))
									if l_null_col.to_boolean then
										l_status := 21
									end
									l_j := l_j + 1
								end
							end
							init_source_inst.gsl_vector_free (l_x1___0)
							init_source_inst.gsl_vector_free (l_f1)
							if l_status.to_boolean then
								Result := l_status
							else
								Result := 0
							end
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
