class
	P_FSOLVER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	compute_f_values (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum: REAL_64; a_f_minimum: CE_POINTER [REAL_64]; a_x_lower: REAL_64; a_f_lower: CE_POINTER [REAL_64]; a_x_upper: REAL_64; a_f_upper: CE_POINTER [REAL_64]): INTEGER_32
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				a_f_lower.item := (a_f.item.function).real_64_item ([a_x_lower, a_f.item.params])
				if not (infnan_inst.gsl_finite (a_f_lower.item)).to_boolean then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("fsolver.c"), 39, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					js.break
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					a_f_upper.item := (a_f.item.function).real_64_item ([a_x_upper, a_f.item.params])
					if not (infnan_inst.gsl_finite (a_f_upper.item)).to_boolean then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("fsolver.c"), 40, 9)
							Result := 9
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					a_f_minimum.item := (a_f.item.function).real_64_item ([a_x_minimum, a_f.item.params])
					if not (infnan_inst.gsl_finite (a_f_minimum.item)).to_boolean then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("fsolver.c"), 41, 9)
							Result := 9
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_min_fminimizer_alloc (a_T: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE]): CE_POINTER [PD_GSL_MIN_FMINIMIZER]
		local
			l_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_MIN_FMINIMIZER]}.make_cast ((malloc ((create {PD_GSL_MIN_FMINIMIZER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for minimizer struct"), ce_string ("fsolver.c"), 79, 8)
					Result := (create {CE_POINTER [PD_GSL_MIN_FMINIMIZER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for minimizer state"), ce_string ("fsolver.c"), 89, 8)
						Result := (create {CE_POINTER [PD_GSL_MIN_FMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_s.item.function := create {CE_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_min_fminimizer_f_lower (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.f_lower)
		end

	gsl_min_fminimizer_f_minimum (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.f_minimum)
		end

	gsl_min_fminimizer_f_upper (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.f_upper)
		end

	gsl_min_fminimizer_free (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				free (a_s.item.state)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_min_fminimizer_iterate (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.function, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("x_minimum")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("f_minimum")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("x_lower")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("f_lower")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("x_upper")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("f_upper"))]))
		end

	gsl_min_fminimizer_minimum (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.x_minimum)
		end

	gsl_min_fminimizer_name (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_min_fminimizer_set (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum: REAL_64; a_x_lower: REAL_64; a_x_upper: REAL_64): INTEGER_32
		local
			l_status: INTEGER_32
			l_f_minimum: CE_ARRAY [REAL_64]
			l_f_lower: CE_ARRAY [REAL_64]
			l_f_upper: CE_ARRAY [REAL_64]
			js: JUMP_STATE
		do
			create l_f_minimum.make (<<1>>)
			create l_f_lower.make (<<1>>)
			create l_f_upper.make (<<1>>)

			l_status := compute_f_values (a_f, a_x_minimum, l_f_minimum, a_x_lower, l_f_lower, a_x_upper, l_f_upper)
			if l_status /= 0 then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := gsl_min_fminimizer_set_with_values (a_s, a_f, a_x_minimum, l_f_minimum.item, a_x_lower, l_f_lower.item, a_x_upper, l_f_upper.item)
				Result := l_status
			end
		end

	gsl_min_fminimizer_set_with_values (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum: REAL_64; a_f_minimum: REAL_64; a_x_lower: REAL_64; a_f_lower: REAL_64; a_x_upper: REAL_64; a_f_upper: REAL_64): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_s.item.function := a_f
					a_s.item.x_minimum := a_x_minimum
					a_s.item.x_lower := a_x_lower
					a_s.item.x_upper := a_x_upper
					if a_x_lower > a_x_upper then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("invalid interval (lower > upper)"), ce_string ("fsolver.c"), 111, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_x_minimum >= a_x_upper) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x_minimum <= a_x_lower) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("x_minimum must lie inside interval (lower < x < upper)"), ce_string ("fsolver.c"), 117, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
							a_s.item.f_lower := a_f_lower
							a_s.item.f_upper := a_f_upper
							a_s.item.f_minimum := a_f_minimum
							if not (a_f_minimum >= a_f_lower) then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 10 then -- else:
							if not (a_f_minimum >= a_f_upper) then
								l_pos := -1 + 12 -- skip if block
							end
				when 11 then -- if: | _L___0:
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("endpoints do not enclose a minimum"), ce_string ("fsolver.c"), 126, 4)
								Result := 4
								js.return
								if not js.return_called then
									js.break
								end
							end
				when 12 then -- if done | if done
							if not js.return_called then
								Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.function, a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper]))
							end
				when 13 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	gsl_min_fminimizer_x_lower (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.x_lower)
		end

	gsl_min_fminimizer_x_minimum (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.x_minimum)
		end

	gsl_min_fminimizer_x_upper (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.x_upper)
		end

	gsl_multifit_fsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER_TYPE]; a_n: NATURAL_32; a_p: NATURAL_32): CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]
			js: JUMP_STATE
		do
			create l_s.make

			if a_n < a_p then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("insufficient data points, n < p"), ce_string ("fsolver.c"), 36, 4)
					Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s := create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIFIT_FSOLVER}.make).structure_size.to_natural_32)))
				if l_s.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for multifit solver struct"), ce_string ("fsolver.c"), 44, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.x := init_source_inst.gsl_vector_calloc (a_p)
				if (l_s.item.x).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fsolver.c"), 52, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.f := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fsolver.c"), 61, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.dx := init_source_inst.gsl_vector_calloc (a_p)
				if (l_s.item.dx).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fsolver.c"), 71, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for multifit solver state"), ce_string ("fsolver.c"), 84, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n, a_p])
				if l_status /= 0 then
					((l_s.item.type).item.free).call ([l_s.item.state])
					free (l_s.item.state)
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to set solver"), ce_string ("fsolver.c"), 100, l_status)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.function := create {CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multifit_fsolver_free (a_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state)
				init_source_inst.gsl_vector_free (a_s.item.dx)
				init_source_inst.gsl_vector_free (a_s.item.x)
				init_source_inst.gsl_vector_free (a_s.item.f)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_multifit_fsolver_iterate (a_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.function, a_s.item.x, a_s.item.f, a_s.item.dx]))
		end

	gsl_multifit_fsolver_name (a_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_multifit_fsolver_position (a_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.x)
		end

	gsl_multifit_fsolver_set (a_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]; a_f: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_s.item.f).item.size /= a_f.item.n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("function size does not match solver"), ce_string ("fsolver.c"), 115, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then ((a_s.item.x).item.size /= a_x.item.size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector length does not match solver"), ce_string ("fsolver.c"), 120, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_s.item.function := a_f
				copy_source_inst.gsl_vector_memcpy (a_s.item.x, a_x).do_nothing
				Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.function, a_s.item.x, a_s.item.f, a_s.item.dx]))
			end
		end

	gsl_multiroot_fsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIROOT_FSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for multiroot solver struct"), ce_string ("fsolver.c"), 39, 8)
					Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.x := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.x).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fsolver.c"), 47, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.f := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fsolver.c"), 56, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.dx := init_source_inst.gsl_vector_calloc (a_n)
				if (l_s.item.dx).is_void then
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fsolver.c"), 66, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for multiroot solver state"), ce_string ("fsolver.c"), 79, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					((l_s.item.type).item.free).call ([l_s.item.state])
					free (l_s.item.state)
					init_source_inst.gsl_vector_free (l_s.item.dx)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.f)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to set solver"), ce_string ("fsolver.c"), 95, l_status)
						Result := (create {CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.function := create {CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multiroot_fsolver_dx (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.dx)
		end

	gsl_multiroot_fsolver_f (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.f)
		end

	gsl_multiroot_fsolver_free (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state)
				init_source_inst.gsl_vector_free (a_s.item.dx)
				init_source_inst.gsl_vector_free (a_s.item.x)
				init_source_inst.gsl_vector_free (a_s.item.f)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_multiroot_fsolver_iterate (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.function, a_s.item.x, a_s.item.f, a_s.item.dx]))
		end

	gsl_multiroot_fsolver_name (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_multiroot_fsolver_root (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.x)
		end

	gsl_multiroot_fsolver_set (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]; a_f: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_s.item.x).item.size /= a_f.item.n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("function incompatible with solver size"), ce_string ("fsolver.c"), 110, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_x.item.size /= a_f.item.n) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector length not compatible with function"), ce_string ("fsolver.c"), 115, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_s.item.function := a_f
				copy_source_inst.gsl_vector_memcpy (a_s.item.x, a_x).do_nothing
				Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.function, a_s.item.x, a_s.item.f, a_s.item.dx]))
			end
		end

	gsl_root_fsolver_alloc (a_T: CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]): CE_POINTER [PD_GSL_ROOT_FSOLVER]
		local
			l_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_ROOT_FSOLVER]}.make_cast ((malloc ((create {PD_GSL_ROOT_FSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for root solver struct"), ce_string ("fsolver.c"), 34, 8)
					Result := (create {CE_POINTER [PD_GSL_ROOT_FSOLVER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for root solver state"), ce_string ("fsolver.c"), 44, 8)
						Result := (create {CE_POINTER [PD_GSL_ROOT_FSOLVER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_s.item.function := create {CE_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_root_fsolver_free (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				free (a_s.item.state)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_root_fsolver_iterate (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.function, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_ROOT_FSOLVER}.make).offset_of ("root")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_ROOT_FSOLVER}.make).offset_of ("x_lower")), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_ROOT_FSOLVER}.make).offset_of ("x_upper"))]))
		end

	gsl_root_fsolver_name (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_root_fsolver_root (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]): REAL_64
		do
			Result := (a_s.item.root)
		end

	gsl_root_fsolver_set (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_lower: REAL_64; a_x_upper: REAL_64): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x_lower > a_x_upper then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("invalid interval (lower > upper)"), ce_string ("fsolver.c"), 58, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_s.item.function := a_f
				a_s.item.root := 0.5 * (a_x_lower + a_x_upper)
				a_s.item.x_lower := a_x_lower
				a_s.item.x_upper := a_x_upper
				Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.function, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + (create {PD_GSL_ROOT_FSOLVER}.make).offset_of ("root")), a_x_lower, a_x_upper]))
			end
		end

	gsl_root_fsolver_x_lower (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]): REAL_64
		do
			Result := (a_s.item.x_lower)
		end

	gsl_root_fsolver_x_upper (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]): REAL_64
		do
			Result := (a_s.item.x_upper)
		end

end
