class
	P_GAUSSINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_gaussian_Pinv (a_P___2: REAL_64; a_sigma: REAL_64): REAL_64
		do
			Result := (a_sigma * (gsl_cdf_ugaussian_Pinv (a_P___2)))
		end

	gsl_cdf_gaussian_Qinv (a_Q___1: REAL_64; a_sigma: REAL_64): REAL_64
		do
			Result := (a_sigma * (gsl_cdf_ugaussian_Qinv (a_Q___1)))
		end

	gsl_cdf_ugaussian_Pinv (a_P___2: REAL_64): REAL_64
		local
			l_r___3: REAL_64
			l_x: REAL_64
			l_pp: REAL_64
			l_dP: REAL_64
			js: JUMP_STATE
		do
			l_dP := a_P___2 - 0.5
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_P___2 = 0.0 then
				Result := (-(builtin_inff)).to_double
				js.return
			end
			if not js.return_called then
				if (fabs (l_dP)) <= 0.425 then
					l_x := small (l_dP)
					Result := l_x
					js.return
				end
			end
			if not js.return_called then
				if a_P___2 < 0.5 then
					l_pp := a_P___2
				else
					l_pp := 1.0 - a_P___2
				end
				l_r___3 := sqrt (-(log (l_pp)))
				if l_r___3 <= 5.0 then
					l_x := intermediate (l_r___3)
				else
					l_x := tail (l_r___3)
				end
				if a_P___2 < 0.5 then
					Result := (-l_x)
				else
					Result := l_x
				end
			end
		end

	gsl_cdf_ugaussian_Qinv (a_Q___1: REAL_64): REAL_64
		local
			l_r___3: REAL_64
			l_x: REAL_64
			l_pp: REAL_64
			l_dQ: REAL_64
			js: JUMP_STATE
		do
			l_dQ := a_Q___1 - 0.5
			if a_Q___1 = 1.0 then
				Result := (-(builtin_inff)).to_double
				js.return
			elseif a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				js.return
			end
			if not js.return_called then
				if (fabs (l_dQ)) <= 0.425 then
					l_x := small (l_dQ)
					Result := (-l_x)
					js.return
				end
			end
			if not js.return_called then
				if a_Q___1 < 0.5 then
					l_pp := a_Q___1
				else
					l_pp := 1.0 - a_Q___1
				end
				l_r___3 := sqrt (-(log (l_pp)))
				if l_r___3 <= 5.0 then
					l_x := intermediate (l_r___3)
				else
					l_x := tail (l_r___3)
				end
				if a_Q___1 < 0.5 then
					Result := l_x
				else
					Result := (-l_x)
				end
			end
		end

	intermediate (a_r___3: REAL_64): REAL_64
		local
			l_a___5: CE_ARRAY [REAL_64]
			l_b___0: CE_ARRAY [REAL_64]
			l_x: REAL_64
		do
			create l_a___5.make (<<8>>)
			create l_b___0.make (<<8>>)

			l_a___5[0] := 1.42343711074968357734
			l_a___5[1] := 4.6303378461565452959
			l_a___5[2] := 5.7694972214606914055
			l_a___5[3] := 3.64784832476320460504
			l_a___5[4] := 1.27045825245236838258
			l_a___5[5] := 0.24178072517745061177
			l_a___5[6] := 0.0227238449892691845833
			l_a___5[7] := 7.7454501427834140764e-4
			l_b___0[0] := 1.0
			l_b___0[1] := 2.05319162663775882187
			l_b___0[2] := 1.6763848301838038494
			l_b___0[3] := 0.68976733498510000455
			l_b___0[4] := 0.14810397642748007459
			l_b___0[5] := 0.0151986665636164571966
			l_b___0[6] := 5.475938084995344946e-4
			l_b___0[7] := 1.05075007164441684324e-9
			l_x := (rat_eval_inst.rat_eval (create {CE_POINTER [REAL_64]}.make_cast (l_a___5), (8).to_natural_32, create {CE_POINTER [REAL_64]}.make_cast (l_b___0), (8).to_natural_32, a_r___3 - 1.6))
			Result := l_x
		end

	small (a_q___3: REAL_64): REAL_64
		local
			l_a___5: CE_ARRAY [REAL_64]
			l_b___0: CE_ARRAY [REAL_64]
			l_r___3: REAL_64
			l_x: REAL_64
		do
			create l_a___5.make (<<8>>)
			create l_b___0.make (<<8>>)

			l_a___5[0] := 3.387132872796366608
			l_a___5[1] := 133.14166789178437745
			l_a___5[2] := 1971.5909503065514427
			l_a___5[3] := 13731.693765509461125
			l_a___5[4] := 45921.953931549871457
			l_a___5[5] := 67265.770927008700853
			l_a___5[6] := 33430.575583588128105
			l_a___5[7] := 2509.0809287301226727
			l_b___0[0] := 1.0
			l_b___0[1] := 42.313330701600911252
			l_b___0[2] := 687.1870074920579083
			l_b___0[3] := 5394.1960214247511077
			l_b___0[4] := 21213.794301586595867
			l_b___0[5] := 39307.89580009271061
			l_b___0[6] := 28729.085735721942674
			l_b___0[7] := 5226.495278852854561
			l_r___3 := 0.180625 - a_q___3 * a_q___3
			l_x := a_q___3 * (rat_eval_inst.rat_eval (create {CE_POINTER [REAL_64]}.make_cast (l_a___5), (8).to_natural_32, create {CE_POINTER [REAL_64]}.make_cast (l_b___0), (8).to_natural_32, l_r___3))
			Result := l_x
		end

	tail (a_r___3: REAL_64): REAL_64
		local
			l_a___5: CE_ARRAY [REAL_64]
			l_b___0: CE_ARRAY [REAL_64]
			l_x: REAL_64
		do
			create l_a___5.make (<<8>>)
			create l_b___0.make (<<8>>)

			l_a___5[0] := 6.6579046435011037772
			l_a___5[1] := 5.4637849111641143699
			l_a___5[2] := 1.7848265399172913358
			l_a___5[3] := 0.29656057182850489123
			l_a___5[4] := 0.026532189526576123093
			l_a___5[5] := 0.0012426609473880784386
			l_a___5[6] := 2.71155556874348757815e-5
			l_a___5[7] := 2.01033439929228813265e-7
			l_b___0[0] := 1.0
			l_b___0[1] := 0.59983220655588793769
			l_b___0[2] := 0.13692988092273580531
			l_b___0[3] := 0.0148753612908506148525
			l_b___0[4] := 7.868691311456132591e-4
			l_b___0[5] := 1.8463183175100546818e-5
			l_b___0[6] := 1.4215117583164458887e-7
			l_b___0[7] := 2.04426310338993978564e-15
			l_x := (rat_eval_inst.rat_eval (create {CE_POINTER [REAL_64]}.make_cast (l_a___5), (8).to_natural_32, create {CE_POINTER [REAL_64]}.make_cast (l_b___0), (8).to_natural_32, a_r___3 - 5.0))
			Result := l_x
		end

end
