class
	P_GAUSSZIG

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ktab.make (<<128>>)
			create wtab.make (<<128>>)
			create ytab.make (<<128>>)
		end

feature {ANY} -- attributes

	ktab: CE_ARRAY [NATURAL_32]

	wtab: CE_ARRAY [REAL_64]

	ytab: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_ran_gaussian_ziggurat (a_r___3: CE_POINTER [PD_GSL_RNG]; a_sigma: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sign: INTEGER_32
			l_x: REAL_64
			l_y: REAL_64
			l_range: NATURAL_32
			l_offset: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_k2: NATURAL_32
			l_y0___0: REAL_64
			l_y1___0: REAL_64
			l_U1: REAL_64
			l_U1___0: REAL_64
			l_U2: REAL_64
			js: JUMP_STATE
		do
			l_range := ((a_r___3.item.type).item.max - (a_r___3.item.type).item.min)
			l_offset := (a_r___3.item.type).item.min
			from
			until
				js.loop_done
			loop
				if l_range >= {NATURAL_32} 4_294_967_295 then
					l_k := (gsl_gsl_rng_inst.gsl_rng_get (a_r___3)) - l_offset
					l_i := (l_k).bit_and ({NATURAL_32} 255)
					l_j := (((l_k).bit_shift_right (8))).bit_and ({NATURAL_32} 16_777_215)
				elseif l_range >= {NATURAL_32} 16_777_215 then
					l_k1 := (gsl_gsl_rng_inst.gsl_rng_get (a_r___3)) - l_offset
					l_k2 := (gsl_gsl_rng_inst.gsl_rng_get (a_r___3)) - l_offset
					l_i := (l_k1).bit_and ({NATURAL_32} 255)
					l_j := (l_k2).bit_and ({NATURAL_32} 16_777_215)
				else
					l_i := gsl_gsl_rng_inst.gsl_rng_uniform_int (a_r___3, {NATURAL_32} 256)
					l_j := gsl_gsl_rng_inst.gsl_rng_uniform_int (a_r___3, {NATURAL_32} 16_777_216)
				end
				if ((l_i).bit_and ({NATURAL_32} 128)).to_boolean then
					l_sign := 1
				else
					l_sign := -1
				end
				l_i := (l_i).bit_and (({NATURAL_32} 127))
				l_x := (l_j.to_real_64 * wtab[l_i.to_integer_32])
				if l_j < ktab[l_i.to_integer_32] then
					js.break
				end
				if not js.loop_jumped then
					if l_i < {NATURAL_32} 127 then
						l_y0___0 := ytab[l_i.to_integer_32]
						l_y1___0 := ytab[(l_i + {NATURAL_32} 1).to_integer_32]
						l_U1 := gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)
						l_y := l_y1___0 + (l_y0___0 - l_y1___0) * l_U1
					else
						l_U1___0 := 1.0 - (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
						l_U2 := gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)
						l_x := 3.44428647676 - (log (l_U1___0)) / 3.44428647676
						l_y := (exp (-3.44428647676 * (l_x - 0.5 * 3.44428647676))) * l_U2
					end
					if l_y < (exp ((-0.5 * l_x) * l_x)) then
						js.break
					end
				end
			end
			Result := ((l_sign.to_double * a_sigma) * l_x)
		end

end
