class
	P_GEAR1

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gear1_type.make (<<1>>)
			create gsl_odeiv_step_gear1.make
		end

feature {ANY} -- attributes

	gear1_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

	gsl_odeiv_step_gear1: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_gear1

	set_gsl_odeiv_step_gear1 (a_gsl_odeiv_step_gear1: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_gear1 := a_gsl_odeiv_step_gear1
		end

feature {ANY} -- routines

	gear1_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_GEAR1_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR1_STATE_T]}.make_cast ((malloc ((create {PD_GEAR1_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for gear1_state"), ce_string ("gear1.c"), 56, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.k := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k"), ce_string ("gear1.c"), 64, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("gear1.c"), 73, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0_orig := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("gear1.c"), 83, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y_onestep := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y_onestep"), ce_string ("gear1.c"), 94, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	gear1_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear1_alloc)
		end

	gear1_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_GEAR1_STATE_T]
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_y0___0.make
			create l_y0_orig.make
			create l_y_onestep.make

			l_state := create {CE_POINTER [PD_GEAR1_STATE_T]}.make_cast (a_vstate)
			l_y0___0 := l_state.item.y0
			l_y0_orig := l_state.item.y0_orig
			l_y_onestep := l_state.item.y_onestep
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0_orig), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y_onestep), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			l_s := (gear1_step (l_y_onestep, l_state, a_h, a_t, a_dim, a_sys))
			if l_s /= 0 then
				Result := l_s
				js.return
			end
			if not js.return_called then
				l_s___0 := (gear1_step (a_y, l_state, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___1 := (gear1_step (a_y, l_state, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called and then (not a_dydt_out.is_void) then
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := 4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gear1_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear1_apply)
		end

	gear1_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_GEAR1_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR1_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	gear1_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear1_free)
		end

	gear1_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_GEAR1_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR1_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_GEAR1_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 1
		end

	gear1_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear1_order)
		end

	gear1_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_GEAR1_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR1_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	gear1_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear1_reset)
		end

	gear1_step (a_y: CE_POINTER [REAL_64]; a_state: CE_POINTER [PD_GEAR1_STATE_T]; a_h: REAL_64; a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_iter_steps: INTEGER_32
			l_nu: INTEGER_32
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_k: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			create l_y0___0.make
			create l_k.make

			l_iter_steps := 3
			l_y0___0 := a_state.item.y0
			l_k := a_state.item.k
			l_nu := 0
			from
			until
				not (not js.loop_done and then (l_nu < l_iter_steps))
			loop
				l_s := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, l_k, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
				if not js.return_called then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_dim)
					loop
						a_y[l_i.to_integer_32] := l_y0___0[l_i.to_integer_32] + a_h * l_k[l_i.to_integer_32]
						l_i := l_i + 1
					end
					l_nu := l_nu + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
