class
	P_GEAR2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gear2_type.make (<<1>>)
			create gsl_odeiv_step_gear2.make
		end

feature {ANY} -- attributes

	gear2_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

	gsl_odeiv_step_gear2: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_gear2

	set_gsl_odeiv_step_gear2 (a_gsl_odeiv_step_gear2: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_gear2 := a_gsl_odeiv_step_gear2
		end

feature {ANY} -- routines

	gear2_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR2_STATE_T]}.make_cast ((malloc ((create {PD_GEAR2_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for gear2_state"), ce_string ("gear2.c"), 56, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.yim1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.yim1).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for yim1"), ce_string ("gear2.c"), 64, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.k := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k"), ce_string ("gear2.c"), 73, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("gear2.c"), 83, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0_orig := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("gear2.c"), 94, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y_onestep := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("gear2.c"), 106, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.primed := 0
				l_state.item.primer := step_inst.gsl_odeiv_step_alloc (rk4imp_inst.gsl_odeiv_step_rk4imp, a_dim)
				if (l_state.item.primer).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for primer"), ce_string ("gear2.c"), 120, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.last_h := 0.0
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	gear2_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear2_alloc)
		end

	gear2_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
			l_status: INTEGER_32
			l_k: CE_POINTER [REAL_64]
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_yim1: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_i: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_k.make
			create l_y0___0.make
			create l_y0_orig.make
			create l_yim1.make
			create l_y_onestep.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
					l_state.item.stutter := 0
					if l_state.item.primed /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_t /= l_state.item.t_primed then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_h = l_state.item.last_h then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						l_status := step_inst.gsl_odeiv_step_apply (l_state.item.primer, a_t, a_h, a_y, a_yerr, a_dydt_in, a_dydt_out, a_sys)
						l_state.item.primed := 1
						l_state.item.t_primed := a_t
						l_state.item.last_h := a_h
						l_state.item.stutter := 1
						Result := l_status
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_k := l_state.item.k
						l_y0___0 := l_state.item.y0
						l_y0_orig := l_state.item.y0_orig
						l_yim1 := l_state.item.yim1
						l_y_onestep := l_state.item.y_onestep
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0_orig), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						if not a_dydt_out.is_void then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_k), create {CE_POINTER [ANY]}.make_cast (a_dydt_out), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						end
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_y_onestep), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						l_s := gear2_step (l_y_onestep, l_state, a_h, a_t, a_dim, a_sys)
						if l_s /= 0 then
							Result := l_s
							js.return
						end
						if not js.return_called then
							l_s := gear2_step (a_y, l_state, a_h / 2.0, a_t, a_dim, a_sys)
							if l_s /= 0 then
								memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
								Result := l_s
								js.return
							end
						end
						if not js.return_called then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
							l_s := gear2_step (a_y, l_state, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys)
							if l_s /= 0 then
								memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
								Result := l_s
								js.return
							end
						end
						if not js.return_called and then (not a_dydt_out.is_void) then
							l_s := (a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params])
							if l_s /= 0 then
								memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
								Result := l_s
								js.return
							end
						end
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (l_i < a_dim)
							loop
								a_yerr[l_i.to_integer_32] := 4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])
								l_yim1[l_i.to_integer_32] := l_y0___0[l_i.to_integer_32]
								l_i := l_i + 1
							end
							l_state.item.last_h := a_h
							Result := 0
						end
				when 10 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gear2_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear2_apply)
		end

	gear2_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
			step_inst.gsl_odeiv_step_free (l_state.item.primer)
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	gear2_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear2_free)
		end

	gear2_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_GEAR2_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 3
		end

	gear2_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear2_order)
		end

	gear2_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.yim1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			l_state.item.primed := 0
			l_state.item.last_h := 0.0
			Result := 0
		end

	gear2_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gear2_reset)
		end

	gear2_step (a_y: CE_POINTER [REAL_64]; a_state: CE_POINTER [PD_GEAR2_STATE_T]; a_h: REAL_64; a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_iter_steps: INTEGER_32
			l_nu: INTEGER_32
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_yim1: CE_POINTER [REAL_64]
			l_k: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			create l_y0___0.make
			create l_yim1.make
			create l_k.make

			l_iter_steps := 3
			l_y0___0 := a_state.item.y0
			l_yim1 := a_state.item.yim1
			l_k := a_state.item.k
			l_nu := 0
			from
			until
				not (not js.loop_done and then (l_nu < l_iter_steps))
			loop
				l_s := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, l_k, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
				if not js.return_called then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_dim)
					loop
						a_y[l_i.to_integer_32] := ((4.0 * l_y0___0[l_i.to_integer_32] - l_yim1[l_i.to_integer_32]) + (2.0 * a_h) * l_k[l_i.to_integer_32]) / 3.0
						l_i := l_i + 1
					end
					l_nu := l_nu + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
