class
	P_GENHERM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_eigen_genherm (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_eval: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_s: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_A___0.item.size1
					if l_N = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("genherm.c"), 122, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if l_N = a_B.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_N = a_B.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("B matrix dimensions must match A"), ce_string ("genherm.c"), 126, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if a_eval.item.size /= l_N then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("genherm.c"), 130, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						elseif a_w.item.size /= l_N then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("matrix size does not match workspace"), ce_string ("genherm.c"), 134, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_s := choleskyc_inst.gsl_linalg_complex_cholesky_decomp (a_B)
							if l_s /= 0 then
								Result := l_s
								js.return
							end
							if not js.return_called then
								gsl_eigen_genherm_standardize (a_A___0, a_B).do_nothing
								l_s := herm_inst.gsl_eigen_herm (a_A___0, a_eval, a_w.item.herm_workspace_p)
								Result := l_s
								js.return
							end
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_genherm_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("genherm.c"), 57, 4)
					Result := (create {CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_w := create {CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_GENHERM_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("genherm.c"), 64, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.size := a_n
				l_w.item.herm_workspace_p := herm_inst.gsl_eigen_herm_alloc (a_n)
				if (l_w.item.herm_workspace_p).is_void then
					gsl_eigen_genherm_free (l_w)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for herm workspace"), ce_string ("genherm.c"), 73, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := l_w
			end
		end

	gsl_eigen_genherm_free (a_w: CE_POINTER [PD_GSL_EIGEN_GENHERM_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if a_w.is_void then
				js.return
			end
			if not js.return_called then
				if (not (a_w.item.herm_workspace_p).is_void) then
					herm_inst.gsl_eigen_herm_free (a_w.item.herm_workspace_p)
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_eigen_genherm_standardize (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_y: PD_GSL_COMPLEX
			l_z: PD_GSL_COMPLEX
			l_ai: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_ma: CE_ARRAY [PD_GSL_MATRIX_COMPLEX_VIEW]
			l_bi: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]
			l_mb: CE_ARRAY [PD_GSL_MATRIX_COMPLEX_CONST_VIEW]
			js: JUMP_STATE
		do
			create l_y.make
			create l_z.make
			create l_ai.make (<<1>>)
			create l_ma.make (<<1>>)
			create l_bi.make (<<1>>)
			create l_mb.make (<<1>>)

			l_N := a_A___0.item.size1
			from
			until
				js.loop_done
			loop
				l_z.dat[1] := 0.0
				js.break
			end
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_N))
			loop
				l_y := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_i)).twin
				l_a___5 := l_y.dat[0]
				l_y := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_B, l_i, l_i)).twin
				l_b___0 := l_y.dat[0]
				l_a___5 := l_a___5 / (l_b___0 * l_b___0)
				from
				until
					js.loop_done
				loop
					l_z.dat[0] := l_a___5
					js.break
				end
				gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_i, l_z.twin)
				if l_i < l_N - {NATURAL_32} 1 then
					l_ai.item := (rowcol_source_inst.gsl_matrix_complex_subcolumn (a_A___0, l_i, l_i + {NATURAL_32} 1, (l_N - l_i) - {NATURAL_32} 1)).twin
					l_ma.item := (submatrix_source_inst.gsl_matrix_complex_submatrix (a_A___0, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, (l_N - l_i) - {NATURAL_32} 1, (l_N - l_i) - {NATURAL_32} 1)).twin
					l_bi.item := (rowcol_source_inst.gsl_matrix_complex_const_subcolumn (a_B, l_i, l_i + {NATURAL_32} 1, (l_N - l_i) - {NATURAL_32} 1)).twin
					l_mb.item := (submatrix_source_inst.gsl_matrix_complex_const_submatrix (a_B, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, (l_N - l_i) - {NATURAL_32} 1, (l_N - l_i) - {NATURAL_32} 1)).twin
					blas_inst.gsl_blas_zdscal (1.0 / l_b___0, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ai.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))
					from
					until
						js.loop_done
					loop
						l_z.dat[0] := -0.5 * l_a___5
						js.break
					end
					blas_inst.gsl_blas_zaxpy (l_z.twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bi.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ai.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
					blas_inst.gsl_blas_zher2 ({PC_CBLAS_UPLO}.CblasLower, (gsl_gsl_complex_math_inst.gsl_complex_rect (-1.0, 0.0)).twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ai.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bi.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (l_ma.item.c_pointer + (create {PD_GSL_MATRIX_COMPLEX_VIEW}.make).offset_of ("matrix"))).do_nothing
					blas_inst.gsl_blas_zaxpy (l_z.twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bi.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ai.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
					blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, (create {CE_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (l_mb.item.c_pointer + (create {PD_GSL_MATRIX_COMPLEX_CONST_VIEW}.make).offset_of ("matrix"))), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ai.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
				end
				l_i := l_i + 1
			end
			Result := 0
		end

end
