class
	P_GET

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_find (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (find_inst.find (a_h.item.n, a_h.item.range, a_x, a_i))
			if l_status.to_boolean then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("x not found in range of h"), ce_string ("get.c"), 65, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_histogram_get (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_i: NATURAL_32): REAL_64
		local
			l_n: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_h.item.n
			if a_i >= l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("index lies outside valid range of 0 .. n - 1"), ce_string ("get.c"), 34, 1)
					Result := (0).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (a_h.item.bin[a_i.to_integer_32])
			end
		end

	gsl_histogram_get_range (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_i: NATURAL_32; a_lower: CE_POINTER [REAL_64]; a_upper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_n: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_h.item.n
			if a_i >= l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("index lies outside valid range of 0 .. n - 1"), ce_string ("get.c"), 48, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_lower.item := a_h.item.range[a_i.to_integer_32]
				a_upper.item := a_h.item.range[(a_i + {NATURAL_32} 1).to_integer_32]
				Result := 0
			end
		end

end
