class
	P_HERMTD

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_hermtd_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_tau: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_zero: PD_GSL_COMPLEX
			l_one: PD_GSL_COMPLEX
			l_neg_one: PD_GSL_COMPLEX
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_v: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_tau_i: PD_GSL_COMPLEX
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_COMPLEX_VIEW]
			l_ei: PD_GSL_COMPLEX
			l_x: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_xv: CE_ARRAY [PD_GSL_COMPLEX]
			l_txv: PD_GSL_COMPLEX
			l_alpha: PD_GSL_COMPLEX
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_zero.make
			create l_one.make
			create l_neg_one.make
			create l_c___1.make (<<1>>)
			create l_v.make (<<1>>)
			create l_tau_i.make
			create l_m___4.make (<<1>>)
			create l_ei.make
			create l_x.make (<<1>>)
			create l_xv.make (<<1>>)
			create l_txv.make
			create l_alpha.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("hermitian tridiagonal decomposition requires square matrix"), ce_string ("hermtd.c"), 66, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 3 then -- else:
						if a_tau.item.size + {NATURAL_32} 1 = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("size of tau must be (matrix size - 1)"), ce_string ("hermtd.c"), 70, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 6 then -- else:
						l_N := a_A___0.item.size1
						l_zero := (gsl_gsl_complex_math_inst.gsl_complex_rect (0.0, 0.0)).twin
						l_one := (gsl_gsl_complex_math_inst.gsl_complex_rect (1.0, 0.0)).twin
						l_neg_one := (gsl_gsl_complex_math_inst.gsl_complex_rect (-1.0, 0.0)).twin
						l_i := (0).to_natural_32
				when 7 then -- loop condition:
						if not (l_i < l_N - {NATURAL_32} 1) then
							l_pos := -1 + 14 -- skip loop
						end
				when 8 then -- loop body:
						l_c___1.item := (rowcol_source_inst.gsl_matrix_complex_column (a_A___0, l_i)).twin
						l_v.item := (subvector_source_inst.gsl_vector_complex_subvector (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))).twin
						l_tau_i := (householdercomplex_inst.gsl_linalg_complex_householder_transform (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))).twin
						if not (l_i + {NATURAL_32} 1 < l_N - {NATURAL_32} 1) then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						if l_tau_i.dat[0] /= 0.0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_tau_i.dat[1] /= 0.0 then
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_m___4.item := (submatrix_source_inst.gsl_matrix_complex_submatrix (a_A___0, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))).twin
						l_ei := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), (0).to_natural_32)).twin
						l_x.item := (subvector_source_inst.gsl_vector_complex_subvector (a_tau, l_i, l_N - (l_i + {NATURAL_32} 1))).twin
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")), (0).to_natural_32, l_one.twin)
						blas_inst.gsl_blas_zhemv ({PC_CBLAS_UPLO}.CblasLower, l_tau_i.twin, (create {CE_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_COMPLEX_VIEW}.make).offset_of ("matrix"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), l_zero.twin, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
						blas_inst.gsl_blas_zdotc ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), l_xv).do_nothing
						l_txv := (math_inst.gsl_complex_mul (l_tau_i.twin, (l_xv.item).twin)).twin
						l_alpha := (math_inst.gsl_complex_mul_real (l_txv.twin, -0.5)).twin
						blas_inst.gsl_blas_zaxpy (l_alpha.twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
						blas_inst.gsl_blas_zher2 ({PC_CBLAS_UPLO}.CblasLower, l_neg_one.twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_COMPLEX_VIEW}.make).offset_of ("matrix"))).do_nothing
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")), (0).to_natural_32, l_ei.twin)
				when 13 then -- if done
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_tau, l_i, l_tau_i.twin)
						l_i := l_i + 1
						l_pos := -1 + 7 -- back to loop condition
				when 14 then -- loop done
						Result := 0
						js.return
				when 15 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_hermtd_unpack (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_tau: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_U: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_ti: PD_GSL_COMPLEX
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]
			l_h: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_COMPLEX_VIEW]
			l_tmp___3: NATURAL_32
			l_Aii: PD_GSL_COMPLEX
			l_Aji: PD_GSL_COMPLEX
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ti.make
			create l_c___1.make (<<1>>)
			create l_h.make (<<1>>)
			create l_m___4.make (<<1>>)
			create l_Aii.make
			create l_Aji.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrix A must be sqaure"), ce_string ("hermtd.c"), 136, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_tau.item.size + {NATURAL_32} 1 = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("size of tau must be (matrix size - 1)"), ce_string ("hermtd.c"), 140, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_U.item.size1 = a_A___0.item.size1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_U.item.size2 = a_A___0.item.size1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("size of U must match size of A"), ce_string ("hermtd.c"), 144, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if a_diag.item.size /= a_A___0.item.size1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("size of diagonal must match size of A"), ce_string ("hermtd.c"), 148, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						elseif a_sdiag.item.size + {NATURAL_32} 1 /= a_A___0.item.size1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("size of subdiagonal must be (matrix size - 1)"), ce_string ("hermtd.c"), 152, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_N := a_A___0.item.size1
							init_source_inst.gsl_matrix_complex_set_identity (a_U)
							l_i := l_N - {NATURAL_32} 1
							from
							until
								js.loop_done
							loop
								l_tmp___3 := l_i
								l_i := l_i - 1
								if not (l_tmp___3 > {NATURAL_32} 0) then
									js.break
								end
								if not js.loop_jumped then
									l_ti := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_tau, l_i)).twin
									l_c___1.item := (rowcol_source_inst.gsl_matrix_complex_const_column (a_A___0, l_i)).twin
									l_h.item := (subvector_source_inst.gsl_vector_complex_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))).twin
									l_m___4.item := (submatrix_source_inst.gsl_matrix_complex_submatrix (a_U, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))).twin
									householdercomplex_inst.gsl_linalg_complex_householder_hm (l_ti.twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_h.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_COMPLEX_VIEW}.make).offset_of ("matrix"))).do_nothing
								end
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_N)
							loop
								l_Aii := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_i)).twin
								gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_i, l_Aii.dat[0])
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_N - {NATURAL_32} 1)
							loop
								l_Aji := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i + {NATURAL_32} 1, l_i)).twin
								gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_i, l_Aji.dat[0])
								l_i := l_i + 1
							end
							Result := 0
							js.return
						end
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_hermtd_unpack_T (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_Aii: PD_GSL_COMPLEX
			l_Aji: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_Aii.make
			create l_Aji.make

			if a_A___0.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix A must be sqaure"), ce_string ("hermtd.c"), 206, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_diag.item.size /= a_A___0.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of diagonal must match size of A"), ce_string ("hermtd.c"), 210, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_sdiag.item.size + {NATURAL_32} 1 /= a_A___0.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of subdiagonal must be (matrix size - 1)"), ce_string ("hermtd.c"), 214, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_N := a_A___0.item.size1
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_Aii := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_i)).twin
					gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_i, l_Aii.dat[0])
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N - {NATURAL_32} 1)
				loop
					l_Aji := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i + {NATURAL_32} 1, l_i)).twin
					gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_i, l_Aji.dat[0])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
