class
	P_HYPERG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_hypergeometric (a_r___3: CE_POINTER [PD_GSL_RNG]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_t: NATURAL_32): NATURAL_32
		local
			l_t: NATURAL_32
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_a___5: NATURAL_32
			l_b___0: NATURAL_32
			l_k: NATURAL_32
			l_u: REAL_64
			l_u___0: REAL_64
			js: JUMP_STATE
		do
			l_t := a_t
			l_n := a_n1 + a_n2
			l_i := {NATURAL_32} 0
			l_a___5 := a_n1
			l_b___0 := a_n1 + a_n2
			l_k := {NATURAL_32} 0
			if l_t > l_n then
				l_t := l_n
			end
			if l_t < l_n // {NATURAL_32} 2 then
				l_i := {NATURAL_32} 0
				from
				until
					not (not js.loop_done and then (l_i < l_t))
				loop
					l_u := (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
					if l_b___0.to_real_64 * l_u < l_a___5.to_real_64 then
						l_k := l_k + 1
						if l_k = a_n1 then
							Result := l_k
							js.return
						end
						if not js.return_called then
							l_a___5 := l_a___5 - 1
						end
					end
					if not js.return_called then
						l_b___0 := l_b___0 - 1
						l_i := l_i + 1
					end
				end
				if not js.return_called then
					Result := l_k
				end
			else
				l_i := {NATURAL_32} 0
				from
				until
					not (not js.loop_done and then (l_i < l_n - l_t))
				loop
					l_u___0 := (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
					if l_b___0.to_real_64 * l_u___0 < l_a___5.to_real_64 then
						l_k := l_k + 1
						if l_k = a_n1 then
							Result := (a_n1 - l_k)
							js.return
						end
						if not js.return_called then
							l_a___5 := l_a___5 - 1
						end
					end
					if not js.return_called then
						l_b___0 := l_b___0 - 1
						l_i := l_i + 1
					end
				end
				if not js.return_called then
					Result := (a_n1 - l_k)
				end
			end
		end

	gsl_ran_hypergeometric_pdf (a_k: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32; a_t: NATURAL_32): REAL_64
		local
			l_t: NATURAL_32
			l_p: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_t := a_t
					if l_t > a_n1 + a_n2 then
						l_t := a_n1 + a_n2
					end
					if not (a_k > a_n1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (0).to_double
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (a_k > l_t) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (0).to_double
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_t > a_n2) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_k + a_n2 < l_t then
							Result := (0).to_double
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						l_c1___2 := (gamma_inst.gsl_sf_lnchoose (a_n1, a_k))
						l_c2___0 := (gamma_inst.gsl_sf_lnchoose (a_n2, l_t - a_k))
						l_c3___3 := (gamma_inst.gsl_sf_lnchoose (a_n1 + a_n2, l_t))
						l_p := exp ((l_c1___2 + l_c2___0) - l_c3___3)
						Result := l_p
				when 10 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_hyperg_1F1_large_b_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_u: REAL_64
			l_v: REAL_64
			l_pre: REAL_64
			l_uv: REAL_64
			l_uv2: REAL_64
			l_t1: REAL_64
			l_t2a: REAL_64
			l_t2b: REAL_64
			l_t2: REAL_64
			l_tmp___0: REAL_64
			js: JUMP_STATE
		do
			if (fabs (a_x / a_b___0)) < 1.0 then
				l_u := a_x / a_b___0
				l_v := 1.0 / (1.0 - l_u)
				l_pre := (pow (l_v, a_a___5))
				l_uv := l_u * l_v
				l_uv2 := l_uv * l_uv
				l_t1 := ((a_a___5 * (a_a___5 + 1.0)) / (2.0 * a_b___0)) * l_uv2
				l_t2a := ((a_a___5 * (a_a___5 + 1.0)) / ((24.0 * a_b___0) * a_b___0)) * l_uv2
				l_t2b := (12.0 + (16.0 * (a_a___5 + 2.0)) * l_uv) + ((3.0 * (a_a___5 + 2.0)) * (a_a___5 + 3.0)) * l_uv2
				l_t2 := l_t2a * l_t2b
				a_result.item.val := l_pre * ((1.0 - l_t1) + l_t2)
				l_tmp___0 := fabs (l_t1)
				a_result.item.err := (l_pre * 2.2204460492503131e-16) * ((1.0 + l_tmp___0) + (fabs (l_t2)))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg.c"), 123, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_hyperg_1F1_series_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_an: REAL_64
			l_bn: REAL_64
			l_n: REAL_64
			l_del: REAL_64
			l_abs_del: REAL_64
			l_max_abs_del: REAL_64
			l_sum_val: REAL_64
			l_sum_err: REAL_64
			l_u: REAL_64
			l_abs_u: REAL_64
			js: JUMP_STATE
		do
			l_an := a_a___5
			l_bn := a_b___0
			l_n := 1.0
			l_del := 1.0
			l_abs_del := 1.0
			l_max_abs_del := 1.0
			l_sum_val := 1.0
			l_sum_err := 0.0
			from
			until
				js.loop_done
			loop
				if not (l_abs_del / (fabs (l_sum_val)) > 0.25 * 2.2204460492503131e-16) then
					js.break
				end
				if not js.loop_jumped then
					if l_bn = 0.0 then
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg.c"), 55, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called and then (l_an = 0.0) then
						a_result.item.val := l_sum_val
						a_result.item.err := l_sum_err
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * l_n) * (fabs (l_sum_val)))
						Result := 0
						js.return
					end
					if not js.return_called and then (l_n > 10000.0) then
						a_result.item.val := l_sum_val
						a_result.item.err := l_sum_err
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("hypergeometric series failed to converge"), ce_string ("hyperg.c"), 68, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_u := a_x * (l_an / (l_bn * l_n))
						l_abs_u := fabs (l_u)
						if l_abs_u > 1.0 then
							if l_max_abs_del > 1.7976931348623157e+308 / l_abs_u then
								a_result.item.val := l_sum_val
								a_result.item.err := fabs (l_sum_val)
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg.c"), 76, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
						end
					end
					if not js.return_called then
						l_del := l_del * l_u
						l_sum_val := l_sum_val + l_del
						if (fabs (l_sum_val)) > 1.0e-5 * 1.7976931348623157e+308 then
							a_result.item.val := l_sum_val
							a_result.item.err := fabs (l_sum_val)
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg.c"), 83, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_abs_del := fabs (l_del)
						l_max_abs_del := gsl_gsl_minmax_inst.GSL_MAX_DBL (l_abs_del, l_max_abs_del)
						l_sum_err := l_sum_err + ((2.0 * 2.2204460492503131e-16) * l_abs_del)
						l_an := l_an + (1.0)
						l_bn := l_bn + (1.0)
						l_n := l_n + (1.0)
					end
				end
			end
			if not js.return_called then
				a_result.item.val := l_sum_val
				a_result.item.err := l_sum_err
				a_result.item.err := a_result.item.err + l_abs_del
				a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * l_n) * (fabs (l_sum_val)))
				Result := 0
			end
		end

	gsl_sf_hyperg_2F0_series_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_n_trunc: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_maxiter: INTEGER_32
			l_an: REAL_64
			l_bn: REAL_64
			l_n: REAL_64
			l_sum: REAL_64
			l_del: REAL_64
			l_abs_del: REAL_64
			l_max_abs_del: REAL_64
			l_last_abs_del: REAL_64
			l_u: REAL_64
			l_abs_u: REAL_64
			js: JUMP_STATE
		do
			l_maxiter := 2_000
			l_an := a_a___5
			l_bn := a_b___0
			l_n := 1.0
			l_sum := 1.0
			l_del := 1.0
			l_abs_del := 1.0
			l_max_abs_del := 1.0
			l_last_abs_del := 1.0
			from
			until
				js.loop_done
			loop
				if l_abs_del / (fabs (l_sum)) > 2.2204460492503131e-16 then
					if not (l_n < l_maxiter.to_double) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_u := l_an * ((l_bn / l_n) * a_x)
					l_abs_u := (fabs (l_u))
					if l_abs_u > 1.0 then
						if l_max_abs_del > 1.7976931348623157e+308 / l_abs_u then
							a_result.item.val := l_sum
							a_result.item.err := fabs (l_sum)
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg.c"), 263, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_del := l_del * l_u
						l_sum := l_sum + l_del
						l_abs_del := fabs (l_del)
						if l_abs_del > l_last_abs_del then
							js.break
						end
						if not js.loop_jumped then
							l_last_abs_del := l_abs_del
							if l_abs_del > l_max_abs_del then
								l_max_abs_del := l_abs_del
							else
								l_max_abs_del := l_max_abs_del
							end
							l_an := l_an + (1.0)
							l_bn := l_bn + (1.0)
							l_n := l_n + (1.0)
							if l_an = 0.0 then
								js.break
							elseif l_bn = 0.0 then
								js.break
							end
						end
						if not js.loop_jumped and then (a_n_trunc >= 0) then
							if l_n >= a_n_trunc.to_double then
								js.break
							end
						end
					end
				end
			end
			if not js.return_called then
				a_result.item.val := l_sum
				a_result.item.err := 2.2204460492503131e-16 * l_n + l_abs_del
				if l_n >= l_maxiter.to_double then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg.c"), 288, 11)
						Result := 11
						js.return
						if not js.return_called then
							js.break
						end
					end
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_hyperg_U_large_b_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_ln_multiplier: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_N: REAL_64
			l_eps: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_M: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___0: REAL_64
			l_lg_bm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_a: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___2: REAL_64
			l_lg_1mb: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_1pamb: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_epre: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e: INTEGER_32
			l_omb_lnx: REAL_64
			l_lg_1mb___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn_1mb: CE_ARRAY [REAL_64]
			l_lg_1pamb___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn_1pamb: CE_ARRAY [REAL_64]
			l_lg_bm1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn_bm1: CE_ARRAY [REAL_64]
			l_lg_a___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn_a: CE_ARRAY [REAL_64]
			l_M1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_M2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lnpre1_val: REAL_64
			l_lnpre2_val: REAL_64
			l_lnpre1_err: REAL_64
			l_lnpre2_err: REAL_64
			l_sgpre1: REAL_64
			l_sgpre2: REAL_64
			l_tmp___8: REAL_64
			l_max_lnpre_val: REAL_64
			l_tmp___10: REAL_64
			l_max_lnpre_err: REAL_64
			l_tmp___11: REAL_64
			l_lp1: REAL_64
			l_lp2: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_tmp___14: REAL_64
			l_tmp___16: REAL_64
			l_tmp___17: REAL_64
			l_t1___0: REAL_64
			l_t2___0: REAL_64
			l_tmp___22: REAL_64
			l_tmp___24: REAL_64
			l_tmp___25: REAL_64
			l_tmp___26: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_M.make (<<1>>)
			create l_lg_bm1.make (<<1>>)
			create l_lg_a.make (<<1>>)
			create l_lg_1mb.make (<<1>>)
			create l_lg_1pamb.make (<<1>>)
			create l_epre.make (<<1>>)
			create l_lg_1mb___0.make (<<1>>)
			create l_sgn_1mb.make (<<1>>)
			create l_lg_1pamb___0.make (<<1>>)
			create l_sgn_1pamb.make (<<1>>)
			create l_lg_bm1___0.make (<<1>>)
			create l_sgn_bm1.make (<<1>>)
			create l_lg_a___0.make (<<1>>)
			create l_sgn_a.make (<<1>>)
			create l_M1.make (<<1>>)
			create l_M2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := (floor (a_b___0))
					l_eps := a_b___0 - l_N
					if not ((fabs (l_eps)) < 1.4901161193847656e-08) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_b___0 > 1.0 then
							l_tmp___0 := (1.0 - a_b___0) * (log (a_x))
							gamma_inst.gsl_sf_lngamma_e (a_b___0 - 1.0, l_lg_bm1).do_nothing
							gamma_inst.gsl_sf_lngamma_e (a_a___5, l_lg_a).do_nothing
							l_lnpre_val := ((l_tmp___0 + a_x) + l_lg_bm1.item.val) - l_lg_a.item.val
							l_tmp___2 := fabs (a_x)
							l_lnpre_err := (l_lg_bm1.item.err + l_lg_a.item.err) + 2.2204460492503131e-16 * (l_tmp___2 + (fabs (l_tmp___0)))
							gsl_sf_hyperg_1F1_large_b_e (1.0 - a_a___5, 2.0 - a_b___0, -a_x, l_M).do_nothing
						else
							gamma_inst.gsl_sf_lngamma_e (1.0 - a_b___0, l_lg_1mb).do_nothing
							gamma_inst.gsl_sf_lngamma_e ((1.0 + a_a___5) - a_b___0, l_lg_1pamb).do_nothing
							l_lnpre_val := l_lg_1mb.item.val - l_lg_1pamb.item.val
							l_lnpre_err := l_lg_1mb.item.err + l_lg_1pamb.item.err
							gsl_sf_hyperg_1F1_large_b_e (a_a___5, a_b___0, a_x, l_M).do_nothing
						end
						if l_lnpre_val > 7.0978271289338397e+02 - 10.0 then
							a_result.item.val := l_M.item.val
							a_result.item.err := l_M.item.err
							a_ln_multiplier.item := l_lnpre_val
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg.c"), 165, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_stat_e := (exp_inst.gsl_sf_exp_err_e (l_lnpre_val, l_lnpre_err, l_epre))
							a_result.item.val := l_epre.item.val * l_M.item.val
							a_result.item.err := l_epre.item.val * l_M.item.err + l_epre.item.err * (fabs (l_M.item.val))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							a_ln_multiplier.item := 0.0
							Result := l_stat_e
							js.return
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						l_omb_lnx := (1.0 - a_b___0) * (log (a_x))
						gsl_sf_hyperg_1F1_large_b_e (a_a___5, a_b___0, a_x, l_M1).do_nothing
						gsl_sf_hyperg_1F1_large_b_e (1.0 - a_a___5, 2.0 - a_b___0, a_x, l_M2).do_nothing
						gamma_inst.gsl_sf_lngamma_sgn_e (1.0 - a_b___0, l_lg_1mb___0, l_sgn_1mb).do_nothing
						gamma_inst.gsl_sf_lngamma_sgn_e ((1.0 + a_a___5) - a_b___0, l_lg_1pamb___0, l_sgn_1pamb).do_nothing
						gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0 - 1.0, l_lg_bm1___0, l_sgn_bm1).do_nothing
						gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5, l_lg_a___0, l_sgn_a).do_nothing
						l_lnpre1_val := l_lg_1mb___0.item.val - l_lg_1pamb___0.item.val
						l_lnpre1_err := l_lg_1mb___0.item.err + l_lg_1pamb___0.item.err
						l_lnpre2_val := ((l_lg_bm1___0.item.val - l_lg_a___0.item.val) - l_omb_lnx) - a_x
						l_tmp___8 := fabs (l_omb_lnx)
						l_lnpre2_err := (l_lg_bm1___0.item.err + l_lg_a___0.item.err) + 2.2204460492503131e-16 * (l_tmp___8 + (fabs (a_x)))
						l_sgpre1 := l_sgn_1mb.item * l_sgn_1pamb.item
						l_sgpre2 := l_sgn_bm1.item * l_sgn_a.item
						if not (l_lnpre1_val > 7.0978271289338397e+02 - 10.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_lnpre2_val > 7.0978271289338397e+02 - 10.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_lnpre1_val > l_lnpre2_val then
							l_tmp___10 := l_lnpre1_val
						else
							l_tmp___10 := l_lnpre2_val
						end
						l_max_lnpre_val := l_tmp___10
						if l_lnpre1_err > l_lnpre2_err then
							l_tmp___11 := l_lnpre1_err
						else
							l_tmp___11 := l_lnpre2_err
						end
						l_max_lnpre_err := l_tmp___11
						l_lp1 := l_lnpre1_val - l_max_lnpre_val
						l_lp2 := l_lnpre2_val - l_max_lnpre_val
						l_t1 := l_sgpre1 * (exp (l_lp1))
						l_t2 := l_sgpre2 * (exp (l_lp2))
						a_result.item.val := l_t1 * l_M1.item.val + l_t2 * l_M2.item.val
						l_tmp___14 := fabs (l_t1)
						a_result.item.err := l_tmp___14 * l_M1.item.err + (fabs (l_t2)) * l_M2.item.err
						l_tmp___16 := exp (l_max_lnpre_err)
						l_tmp___17 := fabs (l_t1 * l_M1.item.val)
						a_result.item.err := a_result.item.err + ((2.2204460492503131e-16 * l_tmp___16) * (l_tmp___17 + (fabs (l_t2 * l_M2.item.val))))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						a_ln_multiplier.item := l_max_lnpre_val
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg.c"), 215, 16)
							Result := 16
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_t1___0 := l_sgpre1 * (exp (l_lnpre1_val))
						l_t2___0 := l_sgpre2 * (exp (l_lnpre2_val))
						a_result.item.val := l_t1___0 * l_M1.item.val + l_t2___0 * l_M2.item.val
						l_tmp___22 := fabs (l_t1___0)
						a_result.item.err := l_tmp___22 * l_M1.item.err + (fabs (l_t2___0)) * l_M2.item.err
						l_tmp___24 := exp (l_lnpre1_err)
						l_tmp___25 := fabs (l_t1___0 * l_M1.item.val)
						l_tmp___26 := exp (l_lnpre2_err)
						a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (l_tmp___24 * l_tmp___25 + l_tmp___26 * (fabs (l_t2___0 * l_M2.item.val))))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						a_ln_multiplier.item := 0.0
						Result := 0
						js.return
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
