class
	P_HYPERG_1F1

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_hyperg_1F1 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_hyperg_1F1_e (a_a___5, a_b___0, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_1F1_e(a, b, x, &result)"), ce_string ("hyperg_1F1.c"), 2_064, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hyperg_1F1_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_bma: REAL_64
			l_rinta: REAL_64
			l_rintb: REAL_64
			l_rintbma: REAL_64
			l_a_integer: INTEGER_32
			l_tmp___3: INTEGER_32
			l_b_integer: INTEGER_32
			l_tmp___5: INTEGER_32
			l_bma_integer: INTEGER_32
			l_tmp___7: INTEGER_32
			l_b_neg_integer: INTEGER_32
			l_tmp___8: INTEGER_32
			l_a_neg_integer: INTEGER_32
			l_tmp___9: INTEGER_32
			l_bma_neg_integer: INTEGER_32
			l_tmp___10: INTEGER_32
			l_exm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e: INTEGER_32
			l_sa: REAL_64
			l_tmp___15: REAL_64
			l_sb: REAL_64
			l_tmp___16: REAL_64
			l_lnab: REAL_64
			l_hx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_hx: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_m_arg: REAL_64
			l_F_renorm: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_F: INTEGER_32
			l_stat_m: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_Kummer_1F1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_Kummer_1F1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K___0: INTEGER_32
			l_stat_e___1: INTEGER_32
			l_tmp___40: INTEGER_32
			l_tmp___41: INTEGER_32
			l_K: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K___1: INTEGER_32
			l_stat_e___2: INTEGER_32
			l_tmp___46: INTEGER_32
			l_tmp___47: INTEGER_32
			l_K___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K___2: INTEGER_32
			l_stat_e___3: INTEGER_32
			l_tmp___51: INTEGER_32
			l_tmp___52: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_exm1.make (<<1>>)
			create l_hx.make (<<1>>)
			create l_F_renorm.make (<<1>>)
			create l_Kummer_1F1.make (<<1>>)
			create l_Kummer_1F1___0.make (<<1>>)
			create l_K.make (<<1>>)
			create l_K___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bma := a_b___0 - a_a___5
					l_rinta := (floor (a_a___5 + 0.5))
					l_rintb := (floor (a_b___0 + 0.5))
					l_rintbma := (floor (l_bma + 0.5))
					if (fabs (a_a___5 - l_rinta)) < 100.0 * 2.2204460492503131e-16 then
						if l_rinta > (-0x7fffffff - 1).to_double then
							if l_rinta < (2_147_483_647).to_double then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
					else
						l_tmp___3 := 0
					end
					l_a_integer := l_tmp___3
					if (fabs (a_b___0 - l_rintb)) < 100.0 * 2.2204460492503131e-16 then
						if l_rintb > (-0x7fffffff - 1).to_double then
							if l_rintb < (2_147_483_647).to_double then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
						else
							l_tmp___5 := 0
						end
					else
						l_tmp___5 := 0
					end
					l_b_integer := l_tmp___5
					if (fabs (l_bma - l_rintbma)) < 100.0 * 2.2204460492503131e-16 then
						if l_rintbma > (-0x7fffffff - 1).to_double then
							if l_rintbma < (2_147_483_647).to_double then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
						else
							l_tmp___7 := 0
						end
					else
						l_tmp___7 := 0
					end
					l_bma_integer := l_tmp___7
					if a_b___0 < -0.1 then
						if l_b_integer.to_boolean then
							l_tmp___8 := 1
						else
							l_tmp___8 := 0
						end
					else
						l_tmp___8 := 0
					end
					l_b_neg_integer := l_tmp___8
					if a_a___5 < -0.1 then
						if l_a_integer.to_boolean then
							l_tmp___9 := 1
						else
							l_tmp___9 := 0
						end
					else
						l_tmp___9 := 0
					end
					l_a_neg_integer := l_tmp___9
					if l_bma < -0.1 then
						if l_bma_integer.to_boolean then
							l_tmp___10 := 1
						else
							l_tmp___10 := 0
						end
					else
						l_tmp___10 := 0
					end
					l_bma_neg_integer := l_tmp___10
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 3 then -- else:
						if a_b___0 /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 1_871, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 6 then -- else:
						if a_a___5 /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 9 then -- else:
						if a_a___5 /= a_b___0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						Result := (exp_inst.gsl_sf_exp_e (a_x, a_result))
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 12 then -- else:
						if not ((fabs (a_b___0)) < 100.0 * 2.2204460492503131e-16) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (fabs (a_a___5)) < 100.0 * 2.2204460492503131e-16 then
							l_stat_e := (exp_inst.gsl_sf_expm1_e (a_x, l_exm1))
							if a_a___5 > 0.0 then
								l_tmp___15 := 1.0
							else
								l_tmp___15 := -1.0
							end
							l_sa := l_tmp___15
							if a_b___0 > 0.0 then
								l_tmp___16 := 1.0
							else
								l_tmp___16 := -1.0
							end
							l_sb := l_tmp___16
							l_lnab := (log ((fabs (a_a___5 / a_b___0))))
							l_stat_hx := (exp_inst.gsl_sf_exp_mult_err_e (l_lnab, 2.2204460492503131e-16 * (fabs (l_lnab)), (l_sa * l_sb) * l_exm1.item.val, l_exm1.item.err, l_hx))
							if l_hx.item.val = 1.7976931348623157e+308 then
								a_result.item.val := l_hx.item.val
							else
								a_result.item.val := 1.0 + l_hx.item.val
							end
							a_result.item.err := l_hx.item.err
							if l_stat_hx /= 0 then
								l_tmp___22 := l_stat_hx
							else
								if l_stat_e /= 0 then
									l_tmp___21 := l_stat_e
								else
									l_tmp___21 := 0
								end
								l_tmp___22 := l_tmp___21
							end
							Result := l_tmp___22
							js.return
						else
							l_pos := -1 + 15 -- goto _L___6
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 15 then -- else: | _L___6:
						if not ((fabs (a_b___0)) < 100.0 * 2.2204460492503131e-16) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (fabs (a_x * a_a___5)) < (1).to_double then
							l_m_arg := 1.0 / (0.5 * a_b___0)
							l_stat_F := (hyperg_1F1_renorm_b0 (a_a___5, a_x, l_F_renorm))
							l_stat_m := (elementary_inst.gsl_sf_multiply_err_e (l_m_arg, (2.0 * 2.2204460492503131e-16) * l_m_arg, 0.5 * l_F_renorm.item.val, 0.5 * l_F_renorm.item.err, a_result))
							if l_stat_m /= 0 then
								l_tmp___26 := l_stat_m
							else
								if l_stat_F /= 0 then
									l_tmp___25 := l_stat_F
								else
									l_tmp___25 := 0
								end
								l_tmp___26 := l_tmp___25
							end
							Result := l_tmp___26
							js.return
						else
							l_pos := -1 + 18 -- goto _L___5
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 18 then -- else: | _L___5:
						if not (l_a_integer.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_b_integer.to_boolean then
							Result := (gsl_sf_hyperg_1F1_int_e (l_rinta.truncated_to_integer, l_rintb.truncated_to_integer, a_x, a_result))
							js.return
						else
							l_pos := -1 + 21 -- goto _L___4
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else: | _L___4:
						if not (l_b_neg_integer.to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 22 then -- if:
						if not (l_a_neg_integer.to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if a_a___5 > a_b___0 then
							l_pos := -1 + 27 -- goto _L___2
						else
							l_pos := -1 + 25 -- goto _L___3
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___3:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 1_925, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 46
				when 27 then -- else: | _L___2:
						if not (l_a_neg_integer.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						Result := (hyperg_1F1_a_negint_lag (l_rinta.truncated_to_integer, a_b___0, a_x, a_result))
						js.return
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 30 then -- else:
						if not (a_b___0 > 0.0) then
							l_pos := -1 + 42 -- skip if block
						end
				when 31 then -- if:
						if not (-1.0 <= a_a___5) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if a_a___5 <= 1.0 then
							Result := (hyperg_1F1_small_a_bgt0 (a_a___5, a_b___0, a_x, a_result))
							js.return
						else
							l_pos := -1 + 34 -- goto _L___0
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 34 then -- else: | _L___0:
						if not (l_bma_neg_integer.to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_stat_K := (hyperg_1F1_a_negint_lag (l_rintbma.truncated_to_integer, a_b___0, -a_x, l_Kummer_1F1))
						l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (a_x, 2.2204460492503131e-16 * (fabs (a_x)), l_Kummer_1F1.item.val, l_Kummer_1F1.item.err, a_result))
						if l_stat_e___0 /= 0 then
							l_tmp___36 := l_stat_e___0
						else
							if l_stat_K /= 0 then
								l_tmp___35 := l_stat_K
							else
								l_tmp___35 := 0
							end
							l_tmp___36 := l_tmp___35
						end
						Result := l_tmp___36
						js.return
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 37 then -- else:
						if not (a_a___5 < 0.0) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if (fabs (a_x)) < (2).to_double * 7.0978271289338397e+02 then
							l_stat_K___0 := (hyperg_1F1_ab_pos (a_b___0 - a_a___5, a_b___0, -a_x, l_Kummer_1F1___0))
							l_stat_e___1 := (exp_inst.gsl_sf_exp_mult_err_e (a_x, 2.2204460492503131e-16 * (fabs (a_x)), l_Kummer_1F1___0.item.val, l_Kummer_1F1___0.item.err, a_result))
							if l_stat_e___1 /= 0 then
								l_tmp___41 := l_stat_e___1
							else
								if l_stat_K___0 /= 0 then
									l_tmp___40 := l_stat_K___0
								else
									l_tmp___40 := 0
								end
								l_tmp___41 := l_tmp___40
							end
							Result := l_tmp___41
							js.return
						else
							l_pos := -1 + 40 -- goto _L
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L:
						if a_a___5 > (0).to_double then
							Result := (hyperg_1F1_ab_pos (a_a___5, a_b___0, a_x, a_result))
							js.return
						else
							Result := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result))
							js.return
						end
				when 41 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 42 then -- else:
						if not (l_bma_neg_integer.to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if a_x < 0.0 then
							if a_a___5 < 0.0 then
								l_stat_K___1 := hyperg_1F1_a_negint_poly (l_rintbma.truncated_to_integer, a_b___0, -a_x, l_K)
							else
								l_stat_K___1 := hyperg_1F1_a_negint_lag (l_rintbma.truncated_to_integer, a_b___0, -a_x, l_K)
							end
							l_stat_e___2 := exp_inst.gsl_sf_exp_mult_err_e (a_x, 2.2204460492503131e-16 * (fabs (a_x)), l_K.item.val, l_K.item.err, a_result)
							if l_stat_e___2 /= 0 then
								l_tmp___47 := l_stat_e___2
							else
								if l_stat_K___1 /= 0 then
									l_tmp___46 := l_stat_K___1
								else
									l_tmp___46 := 0
								end
								l_tmp___47 := l_tmp___46
							end
							Result := l_tmp___47
							js.return
						else
							l_pos := -1 + 45 -- goto _L___1
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L___1:
						if a_a___5 > 0.0 then
							l_stat_K___2 := (hyperg_1F1_ab_neg (a_b___0 - a_a___5, a_b___0, -a_x, l_K___0))
							l_stat_e___3 := (exp_inst.gsl_sf_exp_mult_err_e (a_x, 2.2204460492503131e-16 * (fabs (a_x)), l_K___0.item.val, l_K___0.item.err, a_result))
							if l_stat_e___3 /= 0 then
								l_tmp___52 := l_stat_e___3
							else
								if l_stat_K___2 /= 0 then
									l_tmp___51 := l_stat_K___2
								else
									l_tmp___51 := 0
								end
								l_tmp___52 := l_tmp___51
							end
							Result := l_tmp___52
							js.return
						else
							Result := (hyperg_1F1_ab_neg (a_a___5, a_b___0, a_x, a_result))
							js.return
						end
				when 46 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 47 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_hyperg_1F1_int (a_m___4: INTEGER_32; a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_hyperg_1F1_int_e (a_m___4, a_n, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_1F1_int_e(m, n, x, &result)"), ce_string ("hyperg_1F1.c"), 2_059, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hyperg_1F1_int_e (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_Kummer_1F1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___14: REAL_64
			l_tmp___16: REAL_64
			l_tmp___19: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Kummer_1F1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 3 then -- else:
						if a_a___5 /= a_b___0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (exp_inst.gsl_sf_exp_e (a_x, a_result))
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 6 then -- else:
						if a_b___0 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 1_803, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 9 then -- else:
						if a_a___5 /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 12 then -- else:
						if not (a_b___0 < 0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if:
						if not (a_a___5 < a_b___0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not (a_a___5 > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___3:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 1_812, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 21 -- goto _L___2
				when 20 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else: | _L___2:
						if not (a_x > 100.0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_tmp___19 := gsl_gsl_minmax_inst.GSL_MAX_DBL (1.0, (fabs ((a_b___0 - a_a___5).to_double)))
						if l_tmp___19 * (gsl_gsl_minmax_inst.GSL_MAX_DBL (1.0, (fabs ((1 - a_a___5).to_double)))) < 0.5 * a_x then
							Result := (hyperg_1F1_asymp_posx (a_a___5.to_double, a_b___0.to_double, a_x, a_result))
							js.return
						else
							l_pos := -1 + 24 -- goto _L___1
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else: | _L___1:
						if not (a_x < -100.0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_tmp___14 := gsl_gsl_minmax_inst.GSL_MAX_DBL (1.0, (fabs (a_a___5.to_double)))
						l_tmp___16 := gsl_gsl_minmax_inst.GSL_MAX_DBL (1.0, (fabs (((1 + a_a___5) - a_b___0).to_double)))
						if l_tmp___14 * l_tmp___16 < 0.5 * (fabs (a_x)) then
							Result := (hyperg_1F1_asymp_negx (a_a___5.to_double, a_b___0.to_double, a_x, a_result))
							js.return
						else
							l_pos := -1 + 27 -- goto _L___0
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else: | _L___0:
						if not (a_a___5 < 0) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if a_b___0 < 0 then
							Result := (hyperg_1F1_ab_negint (a_a___5, a_b___0, a_x, a_result))
							js.return
						else
							l_pos := -1 + 30 -- goto _L
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L:
						if a_a___5 < 0 then
							if a_b___0 > 0 then
								l_stat_K := (hyperg_1F1_ab_posint (a_b___0 - a_a___5, a_b___0, -a_x, l_Kummer_1F1))
								l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (a_x, 2.2204460492503131e-16 * (fabs (a_x)), l_Kummer_1F1.item.val, l_Kummer_1F1.item.err, a_result))
								if l_stat_e /= 0 then
									l_tmp___11 := l_stat_e
								else
									if l_stat_K /= 0 then
										l_tmp___10 := l_stat_K
									else
										l_tmp___10 := 0
									end
									l_tmp___11 := l_tmp___10
								end
								Result := l_tmp___11
								js.return
							else
								l_tmp___12 := hyperg_1F1_ab_posint (a_a___5, a_b___0, a_x, a_result)
								Result := l_tmp___12
								js.return
							end
						else
							l_tmp___12 := hyperg_1F1_ab_posint (a_a___5, a_b___0, a_x, a_result)
							Result := l_tmp___12
							js.return
						end
				when 31 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 32 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_1F1_1 (a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_ib: REAL_64
			l_off: REAL_64
			l_bp: REAL_64
			l_M: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_s: INTEGER_32
			l_err_rat: REAL_64
			l_tmp___11: REAL_64
			l_tmp___16: REAL_64
			l_tmp___18: REAL_64
			l_tmp___20: REAL_64
			l_tmp___22: REAL_64
			l_tmp___26: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_M.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ax := (fabs (a_x))
					l_ib := (floor (a_b___0 + 0.1))
					if not (a_b___0 < 1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 352, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else:
						if a_b___0 /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (exp_inst.gsl_sf_exp_e (a_x, a_result))
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if not (a_b___0 >= 1.4 * l_ax) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						Result := (hyperg_1F1_1_series (a_b___0, a_x, a_result))
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else:
						if not ((fabs (a_b___0 - l_ib)) < 100.0 * 2.2204460492503131e-16) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_ib < (2_147_483_647).to_double then
							Result := (hyperg_1F1_1_int (l_ib.truncated_to_integer, a_x, a_result))
							js.return
						else
							l_pos := -1 + 12 -- goto _L___2
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else: | _L___2:
						if not (a_x > 0.0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 13 then -- if:
						if not (a_x > 100.0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if a_b___0 < 0.75 * a_x then
							Result := (hyperg_1F1_asymp_posx (1.0, a_b___0, a_x, a_result))
							js.return
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 16 then -- else: | _L___0:
						if not (a_b___0 < 1.0e+05) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_off := (ceil (1.4 * a_x - a_b___0)) + 1.0
						l_bp := a_b___0 + l_off
						l_stat_s := (hyperg_1F1_1_series (l_bp, a_x, l_M))
						l_err_rat := l_M.item.err / (fabs (l_M.item.val))
						from
						until
							not (l_bp > a_b___0 + 0.1)
						loop
							l_bp := l_bp - (1.0)
							l_M.item.val := 1.0 + (a_x / l_bp) * l_M.item.val
						end
						a_result.item.val := l_M.item.val
						a_result.item.err := l_err_rat * (fabs (l_M.item.val))
						l_tmp___11 := fabs (l_off)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___11 + 1.0)) * (fabs (l_M.item.val)))
						Result := l_stat_s
						js.return
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						l_tmp___18 := fabs (a_x)
						if not (l_tmp___18 < (fabs (a_b___0))) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_tmp___20 := fabs (a_x)
						l_tmp___22 := sqrt ((fabs (a_b___0)))
						if l_tmp___20 < l_tmp___22 * (fabs (a_b___0 - a_x)) then
							Result := (hyperg_1F1_largebx (1.0, a_b___0, a_x, a_result))
							js.return
						else
							l_pos := -1 + 22 -- goto _L
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						l_tmp___16 := fabs (a_x)
						if l_tmp___16 > (fabs (a_b___0)) then
							Result := (hyperg_1F1_1_series (a_b___0, a_x, a_result))
							js.return
						else
							Result := (hyperg_1F1_large2bm4a (1.0, a_b___0, a_x, a_result))
							js.return
						end
				when 23 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else:
						if not (l_ax < 10.0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if a_b___0 < 10.0 then
							Result := (hyperg_1F1_1_series (a_b___0, a_x, a_result))
							js.return
						else
							l_pos := -1 + 27 -- goto _L___1
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___1:
						if l_ax >= 100.0 then
							if (gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (2.0 - a_b___0)), 1.0)) < 0.99 * l_ax then
								Result := (hyperg_1F1_asymp_negx (1.0, a_b___0, a_x, a_result))
								js.return
							else
								l_tmp___26 := hyperg_1F1_luke (1.0, a_b___0, a_x, a_result)
								Result := l_tmp___26
								js.return
							end
						else
							l_tmp___26 := hyperg_1F1_luke (1.0, a_b___0, a_x, a_result)
							Result := l_tmp___26
							js.return
						end
				when 28 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_1F1_1_int (a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_b___0 < 1 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 322, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_b___0 = 1 then
				Result := (exp_inst.gsl_sf_exp_e (a_x, a_result))
				js.return
			elseif a_b___0 = 2 then
				Result := (exp_inst.gsl_sf_exprel_e (a_x, a_result))
				js.return
			elseif a_b___0 = 3 then
				Result := (exp_inst.gsl_sf_exprel_2_e (a_x, a_result))
				js.return
			else
				Result := (exp_inst.gsl_sf_exprel_n_e (a_b___0 - 1, a_x, a_result))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	hyperg_1F1_1_series (a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sum_val: REAL_64
			l_sum_err: REAL_64
			l_term: REAL_64
			l_n: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_sum_val := 1.0
			l_sum_err := 0.0
			l_term := 1.0
			l_n := 1.0
			from
			until
				js.loop_done
			loop
				if not ((fabs (l_term / l_sum_val)) > 0.25 * 2.2204460492503131e-16) then
					js.break
				end
				if not js.loop_jumped then
					l_term := l_term * (a_x / ((a_b___0 + l_n) - (1).to_double))
					l_sum_val := l_sum_val + l_term
					l_tmp := fabs (l_term)
					l_sum_err := l_sum_err + ((8.0 * 2.2204460492503131e-16) * l_tmp + 2.2204460492503131e-16 * (fabs (l_sum_val)))
					l_n := l_n + (1.0)
				end
			end
			a_result.item.val := l_sum_val
			a_result.item.err := l_sum_err
			a_result.item.err := a_result.item.err + (2.0 * (fabs (l_term)))
			Result := 0
		end

	hyperg_1F1_CF1_p_ser (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_maxiter: INTEGER_32
			l_sum: REAL_64
			l_pk: REAL_64
			l_rhok: REAL_64
			l_k: INTEGER_32
			l_ak: REAL_64
			js: JUMP_STATE
		do
			if a_a___5 = 0.0 then
				a_result.item := 0.0
				Result := 0
				js.return
			else
				l_maxiter := 5_000
				l_sum := 1.0
				l_pk := 1.0
				l_rhok := 0.0
				l_k := 1
				from
				until
					not (not js.loop_done and then (l_k < l_maxiter))
				loop
					l_ak := ((a_a___5 + l_k.to_double) * a_x) / ((((a_b___0 - a_x) + l_k.to_double) - 1.0) * ((a_b___0 - a_x) + l_k.to_double))
					l_rhok := (-l_ak * (1.0 + l_rhok)) / (1.0 + l_ak * (1.0 + l_rhok))
					l_pk := l_pk * l_rhok
					l_sum := l_sum + l_pk
					if (fabs (l_pk / l_sum)) < 2.0 * 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_k := l_k + 1
					end
				end
				a_result.item := (a_a___5 / (a_b___0 - a_x)) * l_sum
				if l_k = l_maxiter then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_1F1.c"), 580, 11)
						Result := 11
						js.return
						if not js.return_called then
							js.break
						end
					end
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	hyperg_1F1_U (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_bp: REAL_64
			l_ap: REAL_64
			l_lg_ap: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_bp: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sg_ap: CE_ARRAY [REAL_64]
			l_stat_lg0: INTEGER_32
			l_stat_lg1: INTEGER_32
			l_stat_lg2: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_t1: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_lg_2mbp: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_1papmbp: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sg_2mbp: CE_ARRAY [REAL_64]
			l_sg_1papmbp: CE_ARRAY [REAL_64]
			l_stat_lg3: INTEGER_32
			l_stat_lg4: INTEGER_32
			l_stat_lg5: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_lnc1_val: REAL_64
			l_lnc1_err: REAL_64
			l_tmp___9: REAL_64
			l_M: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_U: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_F: INTEGER_32
			l_stat_U: INTEGER_32
			l_stat_FU: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_term_M: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_e0: INTEGER_32
			l_ombp: REAL_64
			l_Uee_val: REAL_64
			l_Uee_err: REAL_64
			l_Mee_val: REAL_64
			l_Mee_err: REAL_64
			l_stat_e1: INTEGER_32
			l_factorM_val: REAL_64
			l_factorM_err: REAL_64
			l_inner_val: REAL_64
			l_inner_err: REAL_64
			l_tmp___20: REAL_64
			l_tmp___21: REAL_64
			l_tmp___22: REAL_64
			l_factorU_val: REAL_64
			l_factorU_err: REAL_64
			l_inner_val___0: REAL_64
			l_inner_err___0: REAL_64
			l_tmp___26: REAL_64
			l_tmp___27: REAL_64
			l_tmp___28: REAL_64
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
		do
			create l_lg_ap.make (<<1>>)
			create l_lg_bp.make (<<1>>)
			create l_sg_ap.make (<<1>>)
			create l_lg_2mbp.make (<<1>>)
			create l_lg_1papmbp.make (<<1>>)
			create l_sg_2mbp.make (<<1>>)
			create l_sg_1papmbp.make (<<1>>)
			create l_M.make (<<1>>)
			create l_U.make (<<1>>)
			create l_term_M.make (<<1>>)

			l_bp := 2.0 - a_b___0
			l_ap := (a_a___5 - a_b___0) + 1.0
			l_stat_lg0 := (gamma_inst.gsl_sf_lngamma_sgn_e (l_ap, l_lg_ap, l_sg_ap))
			l_stat_lg1 := (gamma_inst.gsl_sf_lngamma_e (l_bp, l_lg_bp))
			if l_stat_lg0 /= 0 then
				l_tmp___2 := l_stat_lg0
			else
				if l_stat_lg1 /= 0 then
					l_tmp___1 := l_stat_lg1
				else
					l_tmp___1 := 0
				end
				l_tmp___2 := l_tmp___1
			end
			l_stat_lg2 := l_tmp___2
			l_t1 := (l_bp - 1.0) * (log (a_x))
			l_lnpre_val := (l_lg_ap.item.val - l_lg_bp.item.val) + l_t1
			l_lnpre_err := (l_lg_ap.item.err + l_lg_bp.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_t1))
			l_stat_lg3 := (gamma_inst.gsl_sf_lngamma_sgn_e (2.0 - l_bp, l_lg_2mbp, l_sg_2mbp))
			l_stat_lg4 := (gamma_inst.gsl_sf_lngamma_sgn_e ((1.0 + l_ap) - l_bp, l_lg_1papmbp, l_sg_1papmbp))
			if l_stat_lg3 /= 0 then
				l_tmp___8 := l_stat_lg3
			else
				if l_stat_lg4 /= 0 then
					l_tmp___7 := l_stat_lg4
				else
					l_tmp___7 := 0
				end
				l_tmp___8 := l_tmp___7
			end
			l_stat_lg5 := l_tmp___8
			l_lnc1_val := l_lg_2mbp.item.val - l_lg_1papmbp.item.val
			l_tmp___9 := fabs (l_lg_2mbp.item.val)
			l_lnc1_err := (l_lg_2mbp.item.err + l_lg_1papmbp.item.err) + 2.2204460492503131e-16 * (l_tmp___9 + (fabs (l_lg_1papmbp.item.val)))
			l_stat_F := (gsl_sf_hyperg_1F1_e (l_ap, l_bp, a_x, l_M))
			l_stat_U := (hyperg_u_inst.gsl_sf_hyperg_U_e10_e (l_ap, l_bp, a_x, l_U))
			if l_stat_F /= 0 then
				l_tmp___14 := l_stat_F
			else
				if l_stat_U /= 0 then
					l_tmp___13 := l_stat_U
				else
					l_tmp___13 := 0
				end
				l_tmp___14 := l_tmp___13
			end
			l_stat_FU := l_tmp___14
			l_stat_e0 := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnc1_val, l_lnc1_err, (l_sg_2mbp.item * l_sg_1papmbp.item) * l_M.item.val, l_M.item.err, l_term_M))
			l_ombp := 1.0 - l_bp
			l_Uee_val := (l_U.item.e10).to_double * 2.30258509299404568402
			l_Uee_err := (2.0 * 2.2204460492503131e-16) * (fabs (l_Uee_val))
			l_Mee_val := (l_term_M.item.e10).to_double * 2.30258509299404568402
			l_Mee_err := (2.0 * 2.2204460492503131e-16) * (fabs (l_Mee_val))
			if l_Uee_val > l_Mee_val then
				l_factorM_val := (exp (l_Mee_val - l_Uee_val))
				l_factorM_err := ((2.0 * 2.2204460492503131e-16) * ((fabs (l_Mee_val - l_Uee_val)) + 1.0)) * l_factorM_val
				l_inner_val := l_term_M.item.val * l_factorM_val - l_ombp * l_U.item.val
				l_tmp___20 := fabs (l_ombp)
				l_tmp___21 := fabs (l_term_M.item.val)
				l_tmp___22 := fabs (l_term_M.item.val * l_factorM_val)
				l_inner_err := ((l_term_M.item.err * l_factorM_val + l_tmp___20 * l_U.item.err) + l_tmp___21 * l_factorM_err) + 2.2204460492503131e-16 * (l_tmp___22 + (fabs (l_ombp * l_U.item.val)))
				l_stat_e1 := exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val + l_Uee_val, l_lnpre_err + l_Uee_err, l_sg_ap.item * l_inner_val, l_inner_err, a_result)
			else
				l_factorU_val := (exp (l_Uee_val - l_Mee_val))
				l_factorU_err := ((2.0 * 2.2204460492503131e-16) * ((fabs (l_Mee_val - l_Uee_val)) + 1.0)) * l_factorU_val
				l_inner_val___0 := l_term_M.item.val - (l_ombp * l_factorU_val) * l_U.item.val
				l_tmp___26 := fabs ((l_ombp * l_factorU_val) * l_U.item.err)
				l_tmp___27 := fabs ((l_ombp * l_factorU_err) * l_U.item.val)
				l_tmp___28 := fabs (l_term_M.item.val)
				l_inner_err___0 := ((l_term_M.item.err + l_tmp___26) + l_tmp___27) + 2.2204460492503131e-16 * (l_tmp___28 + (fabs ((l_ombp * l_factorU_val) * l_U.item.val)))
				l_stat_e1 := exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val + l_Mee_val, l_lnpre_err + l_Mee_err, l_sg_ap.item * l_inner_val___0, l_inner_err___0, a_result)
			end
			if l_stat_e1 /= 0 then
				l_tmp___34 := l_stat_e1
			else
				if l_stat_e0 /= 0 then
					l_tmp___33 := l_stat_e0
				else
					if l_stat_FU /= 0 then
						l_tmp___32 := l_stat_FU
					else
						if l_stat_lg5 /= 0 then
							l_tmp___31 := l_stat_lg5
						else
							if l_stat_lg2 /= 0 then
								l_tmp___30 := l_stat_lg2
							else
								l_tmp___30 := 0
							end
							l_tmp___31 := l_tmp___30
						end
						l_tmp___32 := l_tmp___31
					end
					l_tmp___33 := l_tmp___32
				end
				l_tmp___34 := l_tmp___33
			end
			Result := l_tmp___34
		end

	hyperg_1F1_a_negint_lag (a_a___5: INTEGER_32; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_lag: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_l: INTEGER_32
			l_lnfact: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lng1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lng2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s1: CE_ARRAY [REAL_64]
			l_s2: CE_ARRAY [REAL_64]
			l_stat_f: INTEGER_32
			l_stat_g1: INTEGER_32
			l_stat_g2: INTEGER_32
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_lnbeta: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ln_term_val: REAL_64
			l_ln_term_err: REAL_64
			l_beta: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_b: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_ln_n: REAL_64
			l_ln_term_val___0: REAL_64
			l_ln_term_err___0: REAL_64
			l_stat_e___1: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
		do
			create l_lag.make (<<1>>)
			create l_lnfact.make (<<1>>)
			create l_lng1.make (<<1>>)
			create l_lng2.make (<<1>>)
			create l_s1.make (<<1>>)
			create l_s2.make (<<1>>)
			create l_lnbeta.make (<<1>>)
			create l_beta.make (<<1>>)

			l_n := -a_a___5
			l_stat_l := (laguerre_inst.gsl_sf_laguerre_n_e (l_n, a_b___0 - 1.0, a_x, l_lag))
			if a_b___0 < 0.0 then
				l_stat_f := (gamma_inst.gsl_sf_lnfact_e (l_n.to_natural_32, l_lnfact))
				l_stat_g1 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0 + l_n.to_double, l_lng1, l_s1))
				l_stat_g2 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0, l_lng2, l_s2))
				l_lnpre_val := l_lnfact.item.val - (l_lng1.item.val - l_lng2.item.val)
				l_lnpre_err := ((l_lnfact.item.err + l_lng1.item.err) + l_lng2.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_lnpre_val))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val, l_lnpre_err, (l_s1.item * l_s2.item) * l_lag.item.val, l_lag.item.err, a_result))
				if l_stat_e /= 0 then
					l_tmp___9 := l_stat_e
				else
					if l_stat_l /= 0 then
						l_tmp___8 := l_stat_l
					else
						if l_stat_g1 /= 0 then
							l_tmp___7 := l_stat_g1
						else
							if l_stat_g2 /= 0 then
								l_tmp___6 := l_stat_g2
							else
								if l_stat_f /= 0 then
									l_tmp___5 := l_stat_f
								else
									l_tmp___5 := 0
								end
								l_tmp___6 := l_tmp___5
							end
							l_tmp___7 := l_tmp___6
						end
						l_tmp___8 := l_tmp___7
					end
					l_tmp___9 := l_tmp___8
				end
				Result := l_tmp___9
			else
				beta_inst.gsl_sf_lnbeta_e (a_b___0, l_n.to_double, l_lnbeta).do_nothing
				if (fabs (l_lnbeta.item.val)) < 0.1 then
					l_ln_term_val := (log (1.25 * l_n.to_double))
					l_ln_term_err := (2.0 * 2.2204460492503131e-16) * l_ln_term_val
					l_stat_b := (beta_inst.gsl_sf_beta_e (a_b___0, l_n.to_double, l_beta))
					l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_term_val, l_ln_term_err, l_lag.item.val, l_lag.item.err, a_result))
					a_result.item.val := a_result.item.val * (l_beta.item.val / 1.25)
					a_result.item.err := a_result.item.err * (l_beta.item.val / 1.25)
					if l_stat_e___0 /= 0 then
						l_tmp___15 := l_stat_e___0
					else
						if l_stat_l /= 0 then
							l_tmp___14 := l_stat_l
						else
							if l_stat_b /= 0 then
								l_tmp___13 := l_stat_b
							else
								l_tmp___13 := 0
							end
							l_tmp___14 := l_tmp___13
						end
						l_tmp___15 := l_tmp___14
					end
					Result := l_tmp___15
				else
					l_ln_n := (log (l_n.to_double))
					l_ln_term_val___0 := l_lnbeta.item.val + l_ln_n
					l_ln_term_err___0 := l_lnbeta.item.err + (2.0 * 2.2204460492503131e-16) * (fabs (l_ln_n))
					l_stat_e___1 := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_term_val___0, l_ln_term_err___0, l_lag.item.val, l_lag.item.err, a_result))
					if l_stat_e___1 /= 0 then
						l_tmp___20 := l_stat_e___1
					else
						if l_stat_l /= 0 then
							l_tmp___19 := l_stat_l
						else
							l_tmp___19 := 0
						end
						l_tmp___20 := l_tmp___19
					end
					Result := l_tmp___20
				end
			end
		end

	hyperg_1F1_a_negint_poly (a_a___5: INTEGER_32; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_N: INTEGER_32
			l_poly: REAL_64
			l_k: INTEGER_32
			l_t: REAL_64
			l_r___3: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
		do
			if a_a___5 = 0 then
				a_result.item.val := 1.0
				a_result.item.err := 1.0
				Result := 0
			else
				l_N := -a_a___5
				l_poly := 1.0
				l_k := l_N - 1
				from
				until
					not (not js.loop_done and then (l_k >= 0))
				loop
					l_t := ((a_a___5 + l_k).to_double / (a_b___0 + l_k.to_double)) * (a_x / (l_k + 1).to_double)
					l_r___3 := l_t + 1.0 / l_poly
					if l_r___3 > (0.9 * 1.7976931348623157e+308) / l_poly then
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_inff).to_double
							a_result.item.err := (builtin_inff).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_1F1.c"), 1_198, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
					else
						l_poly := l_poly * l_r___3
					end
					if not js.return_called then
						l_k := l_k - 1
					end
				end
				if not js.return_called then
					a_result.item.val := l_poly
					l_tmp___1 := sqrt (l_N.to_double)
					a_result.item.err := ((2.0 * (l_tmp___1 + 1.0)) * 2.2204460492503131e-16) * (fabs (l_poly))
					Result := 0
				end
			end
		end

	hyperg_1F1_ab_neg (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_bma: REAL_64
			l_abs_x: REAL_64
			l_abs_a: REAL_64
			l_abs_b: REAL_64
			l_size_a: REAL_64
			l_tmp___2: REAL_64
			l_size_b: REAL_64
			l_tmp___3: REAL_64
			l_bma_integer: INTEGER_32
			l_tmp___5: INTEGER_32
			l_Kummer_1F1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___14: INTEGER_32
			l_status: INTEGER_32
			l_K_factor: REAL_64
			l_status___0: INTEGER_32
			l_tmp___19: REAL_64
			l_tmp___21: REAL_64
			l_tmp___24: REAL_64
			l_tmp___26: REAL_64
			l_tmp___34: REAL_64
			l_pos: INTEGER_32
		do
			create l_Kummer_1F1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bma := a_b___0 - a_a___5
					l_abs_x := (fabs (a_x))
					l_abs_a := (fabs (a_a___5))
					l_abs_b := (fabs (a_b___0))
					if l_abs_a > 1.0 then
						l_tmp___2 := l_abs_a
					else
						l_tmp___2 := 1.0
					end
					l_size_a := l_tmp___2
					if l_abs_b > 1.0 then
						l_tmp___3 := l_abs_b
					else
						l_tmp___3 := 1.0
					end
					l_size_b := l_tmp___3
					l_bma_integer := (l_bma - (floor (l_bma + 0.5)) < 100.0 * 2.2204460492503131e-16).to_integer
					if not (l_abs_a < 10.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_abs_b < 10.0 then
							if l_abs_x < 5.0 then
								l_tmp___5 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result)
								Result := l_tmp___5
							else
								l_pos := -1 + 3 -- goto _L___8
							end
						else
							l_pos := -1 + 3 -- goto _L___8
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 3 then -- else: | _L___8:
						if (fabs (a_a___5)) > 1.0 then
							l_tmp___34 := (fabs (a_a___5))
						else
							l_tmp___34 := 1.0
						end
						if not (a_b___0 > (0.8 * l_tmp___34) * (fabs (a_x))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___5 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result)
						Result := l_tmp___5
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if not (a_x > 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_size_b > l_size_a then
							if l_size_a * (log ((2.7182818284590452354 * a_x) / l_size_b)) < -3.6043653389117154e+01 + 7.0 then
								Result := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result))
							else
								l_pos := -1 + 9 -- goto _L___6
							end
						else
							l_pos := -1 + 9 -- goto _L___6
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else: | _L___6:
						if not (l_abs_x < 5.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (fabs (l_bma)) < 10.0 then
							if l_abs_b < 10.0 then
								l_pos := -1 + 13 -- goto _L___2
							else
								l_pos := -1 + 12 -- goto _L___4
							end
						else
							l_pos := -1 + 12 -- goto _L___4
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else: | _L___4:
						if not (a_b___0 > (0.8 * (gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (l_bma)), 1.0))) * l_abs_x) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L___2:
						l_stat_K := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (l_bma, a_b___0, -a_x, l_Kummer_1F1))
						l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (a_x, 2.2204460492503131e-16 * (fabs (a_x)), l_Kummer_1F1.item.val, l_Kummer_1F1.item.err, a_result))
						if l_stat_e /= 0 then
							l_tmp___11 := l_stat_e
						else
							if l_stat_K /= 0 then
								l_tmp___10 := l_stat_K
							else
								l_tmp___10 := 0
							end
							l_tmp___11 := l_tmp___10
						end
						Result := l_tmp___11
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if not (a_x < -30.0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_tmp___24 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_a___5)), 1.0)
						l_tmp___26 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs ((1.0 + a_a___5) - a_b___0)), 1.0)
						if l_tmp___24 * l_tmp___26 < 0.99 * (fabs (a_x)) then
							Result := (hyperg_1F1_asymp_negx (a_a___5, a_b___0, a_x, a_result))
						else
							l_pos := -1 + 18 -- goto _L___1
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else: | _L___1:
						if not (a_x > 100.0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_tmp___19 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (l_bma)), 1.0)
						l_tmp___21 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (1.0 - a_a___5)), 1.0)
						if l_tmp___19 * l_tmp___21 < 0.99 * (fabs (a_x)) then
							Result := (hyperg_1F1_asymp_posx (a_a___5, a_b___0, a_x, a_result))
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___0:
						if not (a_x > 0.0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_bma_integer.to_boolean then
							if l_bma > 0.0 then
								l_pos := -1 + 24 -- goto _L
							else
								l_tmp___14 := hyperg_1F1_U (a_a___5, a_b___0, a_x, a_result)
								Result := l_tmp___14
							end
						else
							l_tmp___14 := hyperg_1F1_U (a_a___5, a_b___0, a_x, a_result)
							Result := l_tmp___14
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L:
						if a_x < 0.0 then
							l_status := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_b___0 - a_a___5, a_b___0, -a_x, a_result))
							l_K_factor := (exp (a_x))
							a_result.item.val := a_result.item.val * l_K_factor
							a_result.item.err := a_result.item.err * l_K_factor
							Result := l_status
						else
							l_status___0 := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result))
							Result := l_status___0
						end
				when 25 then -- if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_1F1_ab_negint (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_K: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_K.make (<<1>>)

			if a_x = 0.0 then
				a_result.item.val := 1.0
				a_result.item.err := 0.0
				Result := 0
			elseif a_x > 0.0 then
				Result := (hyperg_1F1_a_negint_poly (a_a___5, a_b___0.to_double, a_x, a_result))
			else
				l_stat_K := (hyperg_1F1_a_negint_poly (a_b___0 - a_a___5, a_b___0.to_double, -a_x, l_K))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (a_x, (2.0 * 2.2204460492503131e-16) * (fabs (a_x)), l_K.item.val, l_K.item.err, a_result))
				if l_stat_e /= 0 then
					l_tmp___4 := l_stat_e
				else
					if l_stat_K /= 0 then
						l_tmp___3 := l_stat_K
					else
						l_tmp___3 := 0
					end
					l_tmp___4 := l_tmp___3
				end
				Result := l_tmp___4
			end
		end

	hyperg_1F1_ab_pos (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_tmp___0: INTEGER_32
			l_rap: CE_ARRAY [REAL_64]
			l_stat_CF1: INTEGER_32
			l_ra: REAL_64
			l_Ma: REAL_64
			l_Map1: REAL_64
			l_Mnp1: REAL_64
			l_Mn: REAL_64
			l_Mnm1: REAL_64
			l_Mn_true: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Mt: INTEGER_32
			l_n: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_Mn_true___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Mt___0: INTEGER_32
			l_rap___0: CE_ARRAY [REAL_64]
			l_stat_CF1___0: INTEGER_32
			l_ra___0: REAL_64
			l_Ma___0: REAL_64
			l_Mnm1___0: REAL_64
			l_Mn___0: REAL_64
			l_Mnp1___0: REAL_64
			l_n___0: REAL_64
			l_tmp___12: REAL_64
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_N2: REAL_64
			l_eps: REAL_64
			l_r_M0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_M1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_M0: REAL_64
			l_M1: REAL_64
			l_Mam1: REAL_64
			l_Ma___1: REAL_64
			l_Map1___0: REAL_64
			l_ap: REAL_64
			l_start_pair: REAL_64
			l_tmp___19: REAL_64
			l_minim_pair: REAL_64
			l_pair_ratio: REAL_64
			l_rat_0: REAL_64
			l_rat_1: REAL_64
			l_tmp___23: REAL_64
			l_tmp___25: REAL_64
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_eps___0: REAL_64
			l_r_Mnm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Mn: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0___0: INTEGER_32
			l_stat_1___0: INTEGER_32
			l_Mnm1___1: REAL_64
			l_Mn___1: REAL_64
			l_Mnp1___1: REAL_64
			l_n___1: REAL_64
			l_start_pair___0: REAL_64
			l_tmp___34: REAL_64
			l_minim_pair___0: REAL_64
			l_pair_ratio___0: REAL_64
			l_rat_0___0: REAL_64
			l_rat_1___0: REAL_64
			l_tmp___38: REAL_64
			l_tmp___40: REAL_64
			l_tmp___44: INTEGER_32
			l_tmp___45: INTEGER_32
			l_N___02: REAL_64
			l_eps___1: REAL_64
			l_r_Manp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Man: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0___1: INTEGER_32
			l_stat_1___1: INTEGER_32
			l_Manp1: REAL_64
			l_Man: REAL_64
			l_Manm1: REAL_64
			l_n___2: REAL_64
			l_start_pair___1: REAL_64
			l_tmp___49: REAL_64
			l_minim_pair___1: REAL_64
			l_pair_ratio___1: REAL_64
			l_rat_0___1: REAL_64
			l_rat_1___1: REAL_64
			l_tmp___53: REAL_64
			l_tmp___55: REAL_64
			l_tmp___57: INTEGER_32
			l_tmp___58: INTEGER_32
			l_epsa: REAL_64
			l_a0___2: REAL_64
			l_N___12: REAL_64
			l_epsb: REAL_64
			l_Ma0b: REAL_64
			l_Ma0bp1: REAL_64
			l_Ma0p1b: REAL_64
			l_stat_a0: INTEGER_32
			l_Mnm1___2: REAL_64
			l_Mn___2: REAL_64
			l_Mnp1___2: REAL_64
			l_n___3: REAL_64
			l_err_rat: REAL_64
			l_r_Ma0np1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Ma0n: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0___2: INTEGER_32
			l_stat_1___2: INTEGER_32
			l_Ma0np1: REAL_64
			l_Ma0n: REAL_64
			l_Ma0nm1: REAL_64
			l_tmp___64: REAL_64
			l_tmp___66: INTEGER_32
			l_tmp___67: REAL_64
			l_tmp___71: REAL_64
			l_tmp___73: REAL_64
			l_tmp___76: REAL_64
			l_tmp___78: REAL_64
			l_pos: INTEGER_32
		do
			create l_rap.make (<<1>>)
			create l_Mn_true.make (<<1>>)
			create l_Mn_true___0.make (<<1>>)
			create l_rap___0.make (<<1>>)
			create l_r_M0.make (<<1>>)
			create l_r_M1.make (<<1>>)
			create l_r_Mnm1.make (<<1>>)
			create l_r_Mn.make (<<1>>)
			create l_r_Manp1.make (<<1>>)
			create l_r_Man.make (<<1>>)
			create l_r_Ma0np1.make (<<1>>)
			create l_r_Ma0n.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ax := (fabs (a_x))
					if not (a_b___0 < 10.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_a___5 < 10.0 then
							if l_ax < 5.0 then
								l_tmp___0 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result)
								Result := l_tmp___0
							else
								l_pos := -1 + 3 -- goto _L___7
							end
						else
							l_pos := -1 + 3 -- goto _L___7
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 3 then -- else: | _L___7:
						if not (a_b___0 > a_a___5 * l_ax) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___0 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result)
						Result := l_tmp___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if not (a_b___0 > a_a___5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_ax < 5.0 then
							l_tmp___0 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result)
							Result := l_tmp___0
						else
							l_pos := -1 + 9 -- goto _L___5
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 9 then -- else: | _L___5:
						if not (a_x < -100.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___76 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_a___5)), 1.0)
						l_tmp___78 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs ((1.0 + a_a___5) - a_b___0)), 1.0)
						if l_tmp___76 * l_tmp___78 < 0.7 * (fabs (a_x)) then
							Result := (hyperg_1F1_asymp_negx (a_a___5, a_b___0, a_x, a_result))
						else
							l_pos := -1 + 12 -- goto _L___4
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 12 then -- else: | _L___4:
						if not (a_x > 100.0) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp___71 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_b___0 - a_a___5)), 1.0)
						l_tmp___73 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (1.0 - a_a___5)), 1.0)
						if l_tmp___71 * l_tmp___73 < 0.7 * (fabs (a_x)) then
							Result := (hyperg_1F1_asymp_posx (a_a___5, a_b___0, a_x, a_result))
						else
							l_pos := -1 + 15 -- goto _L___3
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 15 then -- else: | _L___3:
						if not ((fabs (a_b___0 - a_a___5)) <= 1.0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						Result := (hyperg_1F1_beps_bgt0 (a_a___5 - a_b___0, a_b___0, a_x, a_result))
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 18 then -- else:
						if not (a_b___0 > a_a___5) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_b___0 >= (2).to_double * a_a___5 + a_x then
							l_stat_CF1 := (hyperg_1F1_CF1_p_ser (a_a___5, a_b___0, a_x, l_rap))
							l_ra := 1.0 + (a_x / a_a___5) * l_rap.item
							l_Ma := 1.4916681462400413e-154
							l_Map1 := l_ra * l_Ma
							l_Mnp1 := l_Map1
							l_Mn := l_Ma
							l_n := a_a___5
							from
							until
								not (l_n > 0.5)
							loop
								l_Mnm1 := (l_n * l_Mnp1 - ((2.0 * l_n - a_b___0) + a_x) * l_Mn) / (a_b___0 - l_n)
								l_Mnp1 := l_Mn
								l_Mn := l_Mnm1
								l_n := l_n - (1.0)
							end
							l_stat_Mt := hyperg_1F1_small_a_bgt0 (l_n, a_b___0, a_x, l_Mn_true)
							a_result.item.val := (l_Ma / l_Mn) * l_Mn_true.item.val
							a_result.item.err := (fabs (l_Ma / l_Mn)) * l_Mn_true.item.err
							l_tmp___6 := fabs (a_a___5)
							a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___6 + 1.0)) * (fabs (a_result.item.val)))
							if l_stat_Mt /= 0 then
								l_tmp___9 := l_stat_Mt
							else
								if l_stat_CF1 /= 0 then
									l_tmp___8 := l_stat_CF1
								else
									l_tmp___8 := 0
								end
								l_tmp___9 := l_tmp___8
							end
							Result := l_tmp___9
						else
							l_pos := -1 + 21 -- goto _L___2
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 21 then -- else: | _L___2:
						if not (a_b___0 > a_a___5) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if a_b___0 < (2).to_double * a_a___5 + a_x then
							if a_b___0 > a_x then
								l_stat_CF1___0 := (hyperg_1F1_CF1_p_ser (a_a___5, a_b___0, a_x, l_rap___0))
								l_ra___0 := 1.0 + (a_x / a_a___5) * l_rap___0.item
								l_Ma___0 := 1.4916681462400413e-154
								l_Mnm1___0 := l_Ma___0
								l_Mn___0 := l_ra___0 * l_Mnm1___0
								l_n___0 := a_a___5 + 1.0
								from
								until
									not (l_n___0 < a_b___0 - 0.5)
								loop
									l_Mnp1___0 := ((a_b___0 - l_n___0) * l_Mnm1___0 + (((2).to_double * l_n___0 - a_b___0) + a_x) * l_Mn___0) / l_n___0
									l_Mnm1___0 := l_Mn___0
									l_Mn___0 := l_Mnp1___0
									l_n___0 := l_n___0 + (1.0)
								end
								l_stat_Mt___0 := hyperg_1F1_beps_bgt0 (l_n___0 - a_b___0, a_b___0, a_x, l_Mn_true___0)
								a_result.item.val := (l_Ma___0 / l_Mn___0) * l_Mn_true___0.item.val
								a_result.item.err := (fabs (l_Ma___0 / l_Mn___0)) * l_Mn_true___0.item.err
								l_tmp___12 := fabs (a_b___0 - a_a___5)
								a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___12 + 1.0)) * (fabs (a_result.item.val)))
								if l_stat_Mt___0 /= 0 then
									l_tmp___15 := l_stat_Mt___0
								else
									if l_stat_CF1___0 /= 0 then
										l_tmp___14 := l_stat_CF1___0
									else
										l_tmp___14 := 0
									end
									l_tmp___15 := l_tmp___14
								end
								Result := l_tmp___15
							else
								l_pos := -1 + 24 -- goto _L___1
							end
						else
							l_pos := -1 + 24 -- goto _L___1
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 24 then -- else: | _L___1:
						if not (a_x >= 0.0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if a_b___0 < a_a___5 then
							l_N2 := (floor (a_a___5 - a_b___0))
							l_eps := (a_a___5 - a_b___0) - l_N2
							l_stat_0 := (hyperg_1F1_beps_bgt0 (l_eps - 1.0, a_b___0, a_x, l_r_M0))
							l_stat_1 := (hyperg_1F1_beps_bgt0 (l_eps, a_b___0, a_x, l_r_M1))
							l_M0 := l_r_M0.item.val
							l_M1 := l_r_M1.item.val
							l_Mam1 := l_M0
							l_Ma___1 := l_M1
							l_tmp___19 := fabs (l_M0)
							l_start_pair := l_tmp___19 + (fabs (l_M1))
							l_minim_pair := 1.7976931348623157e+308
							l_rat_0 := (fabs (l_r_M0.item.err / l_r_M0.item.val))
							l_rat_1 := (fabs (l_r_M1.item.err / l_r_M1.item.val))
							l_ap := a_b___0 + l_eps
							from
							until
								not (l_ap < a_a___5 - 0.1)
							loop
								l_Map1___0 := ((a_b___0 - l_ap) * l_Mam1 + ((2.0 * l_ap - a_b___0) + a_x) * l_Ma___1) / l_ap
								l_Mam1 := l_Ma___1
								l_Ma___1 := l_Map1___0
								l_tmp___23 := fabs (l_Mam1)
								l_minim_pair := gsl_gsl_minmax_inst.GSL_MIN_DBL (l_tmp___23 + (fabs (l_Ma___1)), l_minim_pair)
								l_ap := l_ap + (1.0)
							end
							l_pair_ratio := l_start_pair / l_minim_pair
							a_result.item.val := l_Ma___1
							l_tmp___25 := fabs (a_b___0 - a_a___5)
							a_result.item.err := ((2.0 * ((l_rat_0 + l_rat_1) + 2.2204460492503131e-16)) * (l_tmp___25 + 1.0)) * (fabs (l_Ma___1))
							a_result.item.err := a_result.item.err + ((((2.0 * (l_rat_0 + l_rat_1)) * l_pair_ratio) * l_pair_ratio) * (fabs (l_Ma___1)))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_Ma___1)))
							if l_stat_0 /= 0 then
								l_tmp___30 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___29 := l_stat_1
								else
									l_tmp___29 := 0
								end
								l_tmp___30 := l_tmp___29
							end
							Result := l_tmp___30
						else
							l_eps___0 := a_a___5 - (floor (a_a___5))
							l_stat_0___0 := (hyperg_1F1_small_a_bgt0 (l_eps___0, a_b___0, a_x, l_r_Mnm1))
							l_stat_1___0 := (hyperg_1F1_small_a_bgt0 (l_eps___0 + 1.0, a_b___0, a_x, l_r_Mn))
							l_Mnm1___1 := l_r_Mnm1.item.val
							l_Mn___1 := l_r_Mn.item.val
							l_tmp___34 := fabs (l_Mn___1)
							l_start_pair___0 := l_tmp___34 + (fabs (l_Mnm1___1))
							l_minim_pair___0 := 1.7976931348623157e+308
							l_rat_0___0 := (fabs (l_r_Mnm1.item.err / l_r_Mnm1.item.val))
							l_rat_1___0 := (fabs (l_r_Mn.item.err / l_r_Mn.item.val))
							l_n___1 := l_eps___0 + 1.0
							from
							until
								not (l_n___1 < a_a___5 - 0.1)
							loop
								l_Mnp1___1 := ((a_b___0 - l_n___1) * l_Mnm1___1 + (((2).to_double * l_n___1 - a_b___0) + a_x) * l_Mn___1) / l_n___1
								l_Mnm1___1 := l_Mn___1
								l_Mn___1 := l_Mnp1___1
								l_tmp___38 := fabs (l_Mn___1)
								l_minim_pair___0 := gsl_gsl_minmax_inst.GSL_MIN_DBL (l_tmp___38 + (fabs (l_Mnm1___1)), l_minim_pair___0)
								l_n___1 := l_n___1 + (1).to_double
							end
							l_pair_ratio___0 := l_start_pair___0 / l_minim_pair___0
							a_result.item.val := l_Mn___1
							l_tmp___40 := fabs (a_a___5)
							a_result.item.err := ((2.0 * ((l_rat_0___0 + l_rat_1___0) + 2.2204460492503131e-16)) * (l_tmp___40 + 1.0)) * (fabs (l_Mn___1))
							a_result.item.err := a_result.item.err + ((((2.0 * (l_rat_0___0 + l_rat_1___0)) * l_pair_ratio___0) * l_pair_ratio___0) * (fabs (l_Mn___1)))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_Mn___1)))
							if l_stat_0___0 /= 0 then
								l_tmp___45 := l_stat_0___0
							else
								if l_stat_1___0 /= 0 then
									l_tmp___44 := l_stat_1___0
								else
									l_tmp___44 := 0
								end
								l_tmp___45 := l_tmp___44
							end
							Result := l_tmp___45
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 27 then -- else:
						if not (a_a___5 <= 0.5 * (a_b___0 - a_x)) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 30 then -- else:
						if not (a_a___5 >= -a_x) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L:
						l_N___02 := (floor (a_a___5 - a_b___0))
						l_eps___1 := ((1.0 + l_N___02) - a_a___5) + a_b___0
						l_stat_0___1 := (hyperg_1F1_beps_bgt0 (-l_eps___1, a_a___5 + l_eps___1, a_x, l_r_Manp1))
						l_stat_1___1 := (hyperg_1F1_beps_bgt0 (1.0 - l_eps___1, (a_a___5 + l_eps___1) - 1.0, a_x, l_r_Man))
						l_Manp1 := l_r_Manp1.item.val
						l_Man := l_r_Man.item.val
						l_tmp___49 := fabs (l_Manp1)
						l_start_pair___1 := l_tmp___49 + (fabs (l_Man))
						l_minim_pair___1 := 1.7976931348623157e+308
						l_rat_0___1 := (fabs (l_r_Manp1.item.err / l_r_Manp1.item.val))
						l_rat_1___1 := (fabs (l_r_Man.item.err / l_r_Man.item.val))
						l_n___2 := (a_a___5 + l_eps___1) - 1.0
						from
						until
							not (l_n___2 > a_b___0 + 0.1)
						loop
							l_Manm1 := ((-l_n___2 * (((1).to_double - l_n___2) - a_x)) * l_Man - (a_x * (l_n___2 - a_a___5)) * l_Manp1) / (l_n___2 * (l_n___2 - 1.0))
							l_Manp1 := l_Man
							l_Man := l_Manm1
							l_tmp___53 := fabs (l_Manp1)
							l_minim_pair___1 := gsl_gsl_minmax_inst.GSL_MIN_DBL (l_tmp___53 + (fabs (l_Man)), l_minim_pair___1)
							l_n___2 := l_n___2 - (1.0)
						end
						l_pair_ratio___1 := l_start_pair___1 / l_minim_pair___1
						a_result.item.val := l_Man
						l_tmp___55 := fabs (a_b___0 - a_a___5)
						a_result.item.err := ((2.0 * ((l_rat_0___1 + l_rat_1___1) + 2.2204460492503131e-16)) * (l_tmp___55 + 1.0)) * (fabs (l_Man))
						a_result.item.err := a_result.item.err * (l_pair_ratio___1 * l_pair_ratio___1 + 1.0)
						if l_stat_0___1 /= 0 then
							l_tmp___58 := l_stat_0___1
						else
							if l_stat_1___1 /= 0 then
								l_tmp___57 := l_stat_1___1
							else
								l_tmp___57 := 0
							end
							l_tmp___58 := l_tmp___57
						end
						Result := l_tmp___58
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_epsa := a_a___5 - (floor (a_a___5))
						l_a0___2 := (floor (0.5 * (a_b___0 - a_x))) + l_epsa
						l_N___12 := (floor (l_a0___2 - a_b___0))
						l_epsb := ((1.0 + l_N___12) - l_a0___2) + a_b___0
						l_stat_0___2 := (hyperg_1F1_beps_bgt0 (-l_epsb, l_a0___2 + l_epsb, a_x, l_r_Ma0np1))
						l_stat_1___2 := (hyperg_1F1_beps_bgt0 (1.0 - l_epsb, (l_a0___2 + l_epsb) - 1.0, a_x, l_r_Ma0n))
						l_Ma0np1 := l_r_Ma0np1.item.val
						l_Ma0n := l_r_Ma0n.item.val
						l_tmp___64 := fabs (l_r_Ma0np1.item.err / l_r_Ma0np1.item.val)
						l_err_rat := l_tmp___64 + (fabs (l_r_Ma0n.item.err / l_r_Ma0n.item.val))
						l_n___3 := (l_a0___2 + l_epsb) - 1.0
						from
						until
							not (l_n___3 > a_b___0 + 0.1)
						loop
							l_Ma0nm1 := ((-l_n___3 * (((1).to_double - l_n___3) - a_x)) * l_Ma0n - (a_x * (l_n___3 - l_a0___2)) * l_Ma0np1) / (l_n___3 * (l_n___3 - 1.0))
							l_Ma0np1 := l_Ma0n
							l_Ma0n := l_Ma0nm1
							l_n___3 := l_n___3 - (1.0)
						end
						l_Ma0bp1 := l_Ma0np1
						l_Ma0b := l_Ma0n
						l_Ma0p1b := ((a_b___0 * (l_a0___2 + a_x)) * l_Ma0b + (a_x * (l_a0___2 - a_b___0)) * l_Ma0bp1) / (l_a0___2 * a_b___0)
						if l_stat_0___2 /= 0 then
							l_stat_a0 := l_stat_0___2
						else
							if l_stat_1___2 /= 0 then
								l_tmp___66 := l_stat_1___2
							else
								l_tmp___66 := 0
							end
							l_stat_a0 := l_tmp___66
						end
						if l_a0___2 >= a_a___5 - 0.1 then
							l_Mn___2 := l_Ma0b
						elseif l_a0___2 + (1).to_double >= a_a___5 - 0.1 then
							l_Mn___2 := l_Ma0p1b
						else
							l_Mnm1___2 := l_Ma0b
							l_Mn___2 := l_Ma0p1b
							l_n___3 := l_a0___2 + 1.0
							from
							until
								not (l_n___3 < a_a___5 - 0.1)
							loop
								l_Mnp1___2 := ((a_b___0 - l_n___3) * l_Mnm1___2 + (((2).to_double * l_n___3 - a_b___0) + a_x) * l_Mn___2) / l_n___3
								l_Mnm1___2 := l_Mn___2
								l_Mn___2 := l_Mnp1___2
								l_n___3 := l_n___3 + (1.0)
							end
						end
						a_result.item.val := l_Mn___2
						l_tmp___67 := fabs (a_b___0 - a_a___5)
						a_result.item.err := ((l_err_rat + 2.2204460492503131e-16) * (l_tmp___67 + 1.0)) * (fabs (l_Mn___2))
						Result := l_stat_a0
				when 34 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_1F1_ab_posint (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_K: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_ex: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e___0: INTEGER_32
			l_ex___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e___1: INTEGER_32
			l_poly: REAL_64
			l_tmp___12: REAL_64
			l_tmp___16: INTEGER_32
			l_rap: CE_ARRAY [REAL_64]
			l_stat_CF1: INTEGER_32
			l_ra: REAL_64
			l_Ma: REAL_64
			l_Map1: REAL_64
			l_Mnp1: REAL_64
			l_Mn: REAL_64
			l_Mnm1: REAL_64
			l_n: INTEGER_32
			l_tmp___18: REAL_64
			l_rap___0: CE_ARRAY [REAL_64]
			l_stat_CF1___0: INTEGER_32
			l_ra___0: REAL_64
			l_ex___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_ex: INTEGER_32
			l_Ma___0: REAL_64
			l_Map1___0: REAL_64
			l_Mnm1___0: REAL_64
			l_Mn___0: REAL_64
			l_Mnp1___0: REAL_64
			l_n___0: INTEGER_32
			l_tmp___22: REAL_64
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_ex___2: REAL_64
			l_n___1: INTEGER_32
			l_Mnm1___1: REAL_64
			l_Mn___1: REAL_64
			l_Mnp1___1: REAL_64
			l_r_Mn: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_Mnm1___2: REAL_64
			l_Mn___2: REAL_64
			l_Mnp1___2: REAL_64
			l_n___2: INTEGER_32
			l_tmp___33: REAL_64
			l_tmp___34: REAL_64
			l_ex___3: REAL_64
			l_Manp1: REAL_64
			l_Man: REAL_64
			l_Manm1: REAL_64
			l_n___3: INTEGER_32
			l_tmp___38: REAL_64
			l_a0___2: INTEGER_32
			l_Ma0b: REAL_64
			l_Ma0bp1: REAL_64
			l_Ma0p1b: REAL_64
			l_Mnm1___3: REAL_64
			l_Mn___3: REAL_64
			l_Mnp1___3: REAL_64
			l_n___4: INTEGER_32
			l_ex___4: REAL_64
			l_Ma0np1: REAL_64
			l_Ma0n: REAL_64
			l_Ma0nm1: REAL_64
			l_tmp___43: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_K.make (<<1>>)
			create l_ex.make (<<1>>)
			create l_ex___0.make (<<1>>)
			create l_rap.make (<<1>>)
			create l_rap___0.make (<<1>>)
			create l_ex___1.make (<<1>>)
			create l_r_Mn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ax := (fabs (a_x))
					if a_a___5 /= a_b___0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (exp_inst.gsl_sf_exp_e (a_x, a_result))
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 3 then -- else:
						if a_a___5 /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (exp_inst.gsl_sf_exprel_n_e (a_b___0 - 1, a_x, a_result))
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 6 then -- else:
						if a_b___0 /= a_a___5 + 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_stat_K := (exp_inst.gsl_sf_exprel_n_e (a_a___5, -a_x, l_K))
						l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (a_x, (2.0 * 2.2204460492503131e-16) * (fabs (a_x)), l_K.item.val, l_K.item.err, a_result))
						if l_stat_e /= 0 then
							l_tmp___6 := l_stat_e
						else
							if l_stat_K /= 0 then
								l_tmp___5 := l_stat_K
							else
								l_tmp___5 := 0
							end
							l_tmp___6 := l_tmp___5
						end
						Result := l_tmp___6
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 9 then -- else:
						if a_a___5 /= a_b___0 + 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_stat_e___0 := (exp_inst.gsl_sf_exp_e (a_x, l_ex))
						a_result.item.val := l_ex.item.val * (1.0 + a_x / a_b___0.to_double)
						a_result.item.err := l_ex.item.err * (1.0 + a_x / a_b___0.to_double)
						a_result.item.err := a_result.item.err + ((l_ex.item.val * 2.2204460492503131e-16) * (1.0 + (fabs (a_x / a_b___0.to_double))))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := l_stat_e___0
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 12 then -- else:
						if a_a___5 /= a_b___0 + 2 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_stat_e___1 := (exp_inst.gsl_sf_exp_e (a_x, l_ex___0))
						l_poly := 1.0 + (a_x / a_b___0.to_double) * (2.0 + a_x / (a_b___0.to_double + 1.0))
						a_result.item.val := l_ex___0.item.val * l_poly
						a_result.item.err := l_ex___0.item.err * (fabs (l_poly))
						l_tmp___12 := fabs (a_x / a_b___0.to_double)
						a_result.item.err := a_result.item.err + ((l_ex___0.item.val * 2.2204460492503131e-16) * (1.0 + l_tmp___12 * (2.0 + (fabs (a_x / (a_b___0.to_double + 1.0))))))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := l_stat_e___1
						js.return
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 15 then -- else:
						if a_b___0 /= 2 * a_a___5 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						Result := (hyperg_1F1_beq2a_pos (a_a___5.to_double, a_x, a_result))
						js.return
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 18 then -- else:
						if not (a_b___0 < 10) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_a___5 < 10 then
							if l_ax < 5.0 then
								l_tmp___16 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5.to_double, a_b___0.to_double, a_x, a_result)
								Result := l_tmp___16
								js.return
							else
								l_pos := -1 + 21 -- goto _L___5
							end
						else
							l_pos := -1 + 21 -- goto _L___5
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 21 then -- else: | _L___5:
						if not (a_b___0.to_double > a_a___5.to_double * l_ax) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_tmp___16 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5.to_double, a_b___0.to_double, a_x, a_result)
						Result := l_tmp___16
						js.return
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 24 then -- else:
						if not (a_b___0 > a_a___5) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_ax < 5.0 then
							l_tmp___16 := hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5.to_double, a_b___0.to_double, a_x, a_result)
							Result := l_tmp___16
							js.return
						else
							l_pos := -1 + 27 -- goto _L___3
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 27 then -- else: | _L___3:
						if not (a_b___0 > a_a___5) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if a_b___0.to_double >= (2 * a_a___5).to_double + a_x then
							l_stat_CF1 := (hyperg_1F1_CF1_p_ser (a_a___5.to_double, a_b___0.to_double, a_x, l_rap))
							l_ra := 1.0 + (a_x / a_a___5.to_double) * l_rap.item
							l_Ma := 1.4916681462400413e-154
							l_Map1 := l_ra * l_Ma
							l_Mnp1 := l_Map1
							l_Mn := l_Ma
							l_n := a_a___5
							from
							until
								not (l_n > 0)
							loop
								l_Mnm1 := (l_n.to_double * l_Mnp1 - ((2 * l_n - a_b___0).to_double + a_x) * l_Mn) / (a_b___0 - l_n).to_double
								l_Mnp1 := l_Mn
								l_Mn := l_Mnm1
								l_n := l_n - 1
							end
							a_result.item.val := l_Ma / l_Mn
							l_tmp___18 := fabs (a_a___5.to_double)
							a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (l_tmp___18 + 1.0)) * (fabs (l_Ma / l_Mn))
							Result := l_stat_CF1
							js.return
						else
							l_pos := -1 + 30 -- goto _L___2
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 30 then -- else: | _L___2:
						if not (a_b___0 > a_a___5) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if a_b___0.to_double < (2 * a_a___5).to_double + a_x then
							if a_b___0.to_double > a_x then
								l_stat_CF1___0 := (hyperg_1F1_CF1_p_ser (a_a___5.to_double, a_b___0.to_double, a_x, l_rap___0))
								l_ra___0 := 1.0 + (a_x / a_a___5.to_double) * l_rap___0.item
								l_Ma___0 := 1.4916681462400413e-154
								l_Map1___0 := l_ra___0 * l_Ma___0
								l_Mnm1___0 := l_Ma___0
								l_Mn___0 := l_Map1___0
								l_n___0 := a_a___5 + 1
								from
								until
									not (l_n___0 < a_b___0)
								loop
									l_Mnp1___0 := ((a_b___0 - l_n___0).to_double * l_Mnm1___0 + ((2 * l_n___0 - a_b___0).to_double + a_x) * l_Mn___0) / l_n___0.to_double
									l_Mnm1___0 := l_Mn___0
									l_Mn___0 := l_Mnp1___0
									l_n___0 := l_n___0 + 1
								end
								l_stat_ex := exp_inst.gsl_sf_exp_e (a_x, l_ex___1)
								a_result.item.val := (l_ex___1.item.val * l_Ma___0) / l_Mn___0
								a_result.item.err := l_ex___1.item.err * (fabs (l_Ma___0 / l_Mn___0))
								l_tmp___22 := fabs ((a_b___0 - a_a___5).to_double)
								a_result.item.err := a_result.item.err + (((4.0 * 2.2204460492503131e-16) * (l_tmp___22 + 1.0)) * (fabs (a_result.item.val)))
								if l_stat_ex /= 0 then
									l_tmp___25 := l_stat_ex
								else
									if l_stat_CF1___0 /= 0 then
										l_tmp___24 := l_stat_CF1___0
									else
										l_tmp___24 := 0
									end
									l_tmp___25 := l_tmp___24
								end
								Result := l_tmp___25
								js.return
							else
								l_pos := -1 + 33 -- goto _L___1
							end
						else
							l_pos := -1 + 33 -- goto _L___1
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 33 then -- else: | _L___1:
						if not (a_x >= 0.0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if a_b___0 < a_a___5 then
							if a_x + (log ((fabs (a_x / a_b___0.to_double)))) < 7.0978271289338397e+02 - 2.0 then
								l_ex___2 := (exp (a_x))
								l_Mnm1___1 := l_ex___2
								l_Mn___1 := l_ex___2 * (1.0 + a_x / a_b___0.to_double)
								l_n___1 := a_b___0 + 1
								from
								until
									not (l_n___1 < a_a___5)
								loop
									l_Mnp1___1 := ((a_b___0 - l_n___1).to_double * l_Mnm1___1 + ((2 * l_n___1 - a_b___0).to_double + a_x) * l_Mn___1) / l_n___1.to_double
									l_Mnm1___1 := l_Mn___1
									l_Mn___1 := l_Mnp1___1
									l_n___1 := l_n___1 + 1
								end
								a_result.item.val := l_Mn___1
								a_result.item.err := ((a_x + 1.0) * 2.2204460492503131e-16) * (fabs (l_Mn___1))
								a_result.item.err := a_result.item.err * ((fabs ((a_a___5 - a_b___0).to_double)) + 1.0)
								Result := 0
								js.return
							else
								from
								until
									js.loop_done
								loop
									a_result.item.val := (builtin_inff).to_double
									a_result.item.err := (builtin_inff).to_double
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_1F1.c"), 1_062, 16)
										Result := 16
										js.return
										if not js.return_called then
											js.break
										end
									end
									if not js.return_called then
										js.break
									end
								end
							end
						else
							l_Mnm1___2 := 1.0
							exp_inst.gsl_sf_exprel_n_e (a_b___0 - 1, a_x, l_r_Mn).do_nothing
							l_Mn___2 := l_r_Mn.item.val
							l_n___2 := 1
							from
							until
								not (l_n___2 < a_a___5)
							loop
								l_Mnp1___2 := ((a_b___0 - l_n___2).to_double * l_Mnm1___2 + ((2 * l_n___2 - a_b___0).to_double + a_x) * l_Mn___2) / l_n___2.to_double
								l_Mnm1___2 := l_Mn___2
								l_Mn___2 := l_Mnp1___2
								l_n___2 := l_n___2 + 1
							end
							a_result.item.val := l_Mn___2
							l_tmp___33 := fabs (l_Mn___2)
							l_tmp___34 := fabs (a_a___5.to_double)
							a_result.item.err := (l_tmp___33 * (1.0 + l_tmp___34)) * (fabs (l_r_Mn.item.err / l_r_Mn.item.val))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_Mn___2)))
							Result := 0
							js.return
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 36 then -- else:
						if not (a_a___5.to_double <= 0.5 * (a_b___0.to_double - a_x)) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 39 then -- else:
						if not (a_a___5.to_double >= -a_x) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if: | _L:
						l_ex___3 := (exp (a_x))
						l_Manp1 := l_ex___3
						l_Man := l_ex___3 * (1.0 + a_x / (a_a___5.to_double - 1.0))
						l_n___3 := a_a___5 - 1
						from
						until
							not (l_n___3 > a_b___0)
						loop
							l_Manm1 := (((-l_n___3).to_double * ((1 - l_n___3).to_double - a_x)) * l_Man - (a_x * (l_n___3 - a_a___5).to_double) * l_Manp1) / (l_n___3.to_double * (l_n___3.to_double - 1.0))
							l_Manp1 := l_Man
							l_Man := l_Manm1
							l_n___3 := l_n___3 - 1
						end
						a_result.item.val := l_Man
						l_tmp___38 := fabs (a_x)
						a_result.item.err := ((l_tmp___38 + 1.0) * 2.2204460492503131e-16) * (fabs (l_Man))
						a_result.item.err := a_result.item.err * ((fabs ((a_b___0 - a_a___5).to_double)) + 1.0)
						Result := 0
						js.return
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						l_a0___2 := (ceil (0.5 * (a_b___0.to_double - a_x))).truncated_to_integer
						l_ex___4 := (exp (a_x))
						l_Ma0np1 := l_ex___4
						l_Ma0n := l_ex___4 * (1.0 + a_x / (l_a0___2.to_double - 1.0))
						l_n___4 := l_a0___2 - 1
						from
						until
							not (l_n___4 > a_b___0)
						loop
							l_Ma0nm1 := (((-l_n___4).to_double * ((1 - l_n___4).to_double - a_x)) * l_Ma0n - (a_x * (l_n___4 - l_a0___2).to_double) * l_Ma0np1) / (l_n___4.to_double * (l_n___4.to_double - 1.0))
							l_Ma0np1 := l_Ma0n
							l_Ma0n := l_Ma0nm1
							l_n___4 := l_n___4 - 1
						end
						l_Ma0bp1 := l_Ma0np1
						l_Ma0b := l_Ma0n
						l_Ma0p1b := ((a_b___0.to_double * (l_a0___2.to_double + a_x)) * l_Ma0b + (a_x * (l_a0___2 - a_b___0).to_double) * l_Ma0bp1) / (l_a0___2 * a_b___0).to_double
						if l_a0___2 >= a_a___5 then
							l_Mn___3 := l_Ma0b
						elseif l_a0___2 + 1 >= a_a___5 then
							l_Mn___3 := l_Ma0p1b
						else
							l_Mnm1___3 := l_Ma0b
							l_Mn___3 := l_Ma0p1b
							l_n___4 := l_a0___2 + 1
							from
							until
								not (l_n___4 < a_a___5)
							loop
								l_Mnp1___3 := ((a_b___0 - l_n___4).to_double * l_Mnm1___3 + ((2 * l_n___4 - a_b___0).to_double + a_x) * l_Mn___3) / l_n___4.to_double
								l_Mnm1___3 := l_Mn___3
								l_Mn___3 := l_Mnp1___3
								l_n___4 := l_n___4 + 1
							end
						end
						a_result.item.val := l_Mn___3
						l_tmp___43 := fabs (a_x)
						a_result.item.err := ((l_tmp___43 + 1.0) * 2.2204460492503131e-16) * (fabs (l_Mn___3))
						a_result.item.err := a_result.item.err * ((fabs ((a_b___0 - a_a___5).to_double)) + 1.0)
						Result := 0
						js.return
				when 43 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 44 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_1F1_asymp_negx (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lg_b: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_bma: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn_b: CE_ARRAY [REAL_64]
			l_sgn_bma: CE_ARRAY [REAL_64]
			l_stat_b: INTEGER_32
			l_stat_bma: INTEGER_32
			l_F___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_F: INTEGER_32
			l_ln_term_val: REAL_64
			l_ln_term_err: REAL_64
			l_tmp___3: REAL_64
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lg_b.make (<<1>>)
			create l_lg_bma.make (<<1>>)
			create l_sgn_b.make (<<1>>)
			create l_sgn_bma.make (<<1>>)
			create l_F___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stat_b := (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0, l_lg_b, l_sgn_b))
					l_stat_bma := (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0 - a_a___5, l_lg_bma, l_sgn_bma))
					if l_stat_b /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_stat_bma = 0 then
							l_stat_F := (hyperg_inst.gsl_sf_hyperg_2F0_series_e (a_a___5, (1.0 + a_a___5) - a_b___0, -1.0 / a_x, -1, l_F___0))
							if l_F___0.item.val /= (0).to_double then
								l_ln_term_val := a_a___5 * (log (-a_x))
								l_tmp___3 := fabs (a_a___5)
								l_ln_term_err := (2.0 * 2.2204460492503131e-16) * (l_tmp___3 + (fabs (l_ln_term_val)))
								l_ln_pre_val := (l_lg_b.item.val - l_lg_bma.item.val) - l_ln_term_val
								l_ln_pre_err := (l_lg_b.item.err + l_lg_bma.item.err) + l_ln_term_err
								l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre_val, l_ln_pre_err, (l_sgn_bma.item * l_sgn_b.item) * l_F___0.item.val, l_F___0.item.err, a_result))
								if l_stat_e /= 0 then
									l_tmp___7 := l_stat_e
								else
									if l_stat_F /= 0 then
										l_tmp___6 := l_stat_F
									else
										l_tmp___6 := 0
									end
									l_tmp___7 := l_tmp___6
								end
								Result := l_tmp___7
								js.return
							else
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_F
								js.return
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 75, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_1F1_asymp_posx (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lg_b: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_a: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn_b: CE_ARRAY [REAL_64]
			l_sgn_a: CE_ARRAY [REAL_64]
			l_stat_b: INTEGER_32
			l_stat_a: INTEGER_32
			l_F___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_F: INTEGER_32
			l_lnx: REAL_64
			l_ln_term_val: REAL_64
			l_ln_term_err: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lg_b.make (<<1>>)
			create l_lg_a.make (<<1>>)
			create l_sgn_b.make (<<1>>)
			create l_sgn_a.make (<<1>>)
			create l_F___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stat_b := (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0, l_lg_b, l_sgn_b))
					l_stat_a := (gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5, l_lg_a, l_sgn_a))
					if l_stat_a /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_stat_b = 0 then
							l_stat_F := (hyperg_inst.gsl_sf_hyperg_2F0_series_e (a_b___0 - a_a___5, 1.0 - a_a___5, 1.0 / a_x, -1, l_F___0))
							if l_stat_F = 0 then
								if l_F___0.item.val /= (0).to_double then
									l_lnx := (log (a_x))
									l_ln_term_val := (a_a___5 - a_b___0) * l_lnx
									l_tmp___3 := fabs (a_a___5)
									l_tmp___4 := fabs (a_b___0)
									l_tmp___5 := fabs (l_lnx)
									l_ln_term_err := ((2.0 * 2.2204460492503131e-16) * (l_tmp___3 + l_tmp___4)) * l_tmp___5 + (2.0 * 2.2204460492503131e-16) * (fabs (a_a___5 - a_b___0))
									l_ln_pre_val := ((l_lg_b.item.val - l_lg_a.item.val) + l_ln_term_val) + a_x
									l_ln_pre_err := ((l_lg_b.item.err + l_lg_a.item.err) + l_ln_term_err) + (2.0 * 2.2204460492503131e-16) * (fabs (a_x))
									l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre_val, l_ln_pre_err, (l_sgn_a.item * l_sgn_b.item) * l_F___0.item.val, l_F___0.item.err, a_result))
									if l_stat_e /= 0 then
										l_tmp___10 := l_stat_e
									else
										if l_stat_F /= 0 then
											l_tmp___9 := l_stat_F
										else
											l_tmp___9 := 0
										end
										l_tmp___10 := l_tmp___9
									end
									Result := l_tmp___10
									js.return
								else
									a_result.item.val := 0.0
									a_result.item.err := 0.0
									Result := l_stat_F
									js.return
								end
							else
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_F
								js.return
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_1F1.c"), 118, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_1F1_beps_bgt0 (a_eps: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_a___5: REAL_64
			l_exab: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e: INTEGER_32
			l_v2: REAL_64
			l_v3: REAL_64
			l_v: REAL_64
			l_f: REAL_64
			l_tmp___1: REAL_64
			l_Kummer_1F1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_exab.make (<<1>>)
			create l_Kummer_1F1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_b___0 > (fabs (a_x))) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (fabs (a_eps)) < 1.4901161193847656e-08 then
							l_a___5 := a_b___0 + a_eps
							l_stat_e := (exp_inst.gsl_sf_exp_e ((l_a___5 * a_x) / a_b___0, l_exab))
							l_v2 := l_a___5 / (((2.0 * a_b___0) * a_b___0) * (a_b___0 + 1.0))
							l_v3 := (l_a___5 * (a_b___0 - 2.0 * l_a___5)) / (((((3.0 * a_b___0) * a_b___0) * a_b___0) * (a_b___0 + 1.0)) * (a_b___0 + 2.0))
							l_v := l_v2 + l_v3 * a_x
							l_f := 1.0 - ((a_eps * a_x) * a_x) * l_v
							a_result.item.val := l_exab.item.val * l_f
							a_result.item.err := l_exab.item.err * (fabs (l_f))
							l_tmp___1 := fabs (l_exab.item.val)
							a_result.item.err := a_result.item.err + ((l_tmp___1 * 2.2204460492503131e-16) * (1.0 + (fabs (((a_eps * a_x) * a_x) * l_v))))
							a_result.item.err := a_result.item.err + ((4.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_e
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_stat_K := (hyperg_1F1_small_a_bgt0 (-a_eps, a_b___0, -a_x, l_Kummer_1F1))
						if l_Kummer_1F1.item.val /= 0.0 then
							l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (a_x, (2.0 * 2.2204460492503131e-16) * (fabs (a_x)), l_Kummer_1F1.item.val, l_Kummer_1F1.item.err, a_result))
							if l_stat_e___0 /= 0 then
								l_tmp___8 := l_stat_e___0
							else
								if l_stat_K /= 0 then
									l_tmp___7 := l_stat_K
								else
									l_tmp___7 := 0
								end
								l_tmp___8 := l_tmp___7
							end
							Result := l_tmp___8
						else
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := l_stat_K
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_1F1_beq2a_pos (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_I: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_I: INTEGER_32
			l_lg: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_g: INTEGER_32
			l_ln_term: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_tmp___5: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
		do
			create l_I.make (<<1>>)
			create l_lg.make (<<1>>)

			if a_x = 0.0 then
				a_result.item.val := 1.0
				a_result.item.err := 0.0
				Result := 0
			else
				l_stat_I := (bessel_inu_inst.gsl_sf_bessel_Inu_scaled_e (a_a___5 - 0.5, 0.5 * (fabs (a_x)), l_I))
				l_stat_g := (gamma_inst.gsl_sf_lngamma_e (a_a___5 + 0.5, l_lg))
				l_ln_term := (0.5 - a_a___5) * (log (0.25 * (fabs (a_x))))
				l_lnpre_val := (l_lg.item.val + (gsl_gsl_minmax_inst.GSL_MAX_DBL (a_x, 0.0))) + l_ln_term
				l_tmp___5 := fabs (l_ln_term)
				l_lnpre_err := l_lg.item.err + 2.2204460492503131e-16 * (l_tmp___5 + (fabs (a_x)))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val, l_lnpre_err, l_I.item.val, l_I.item.err, a_result))
				if l_stat_e /= 0 then
					l_tmp___10 := l_stat_e
				else
					if l_stat_g /= 0 then
						l_tmp___9 := l_stat_g
					else
						if l_stat_I /= 0 then
							l_tmp___8 := l_stat_I
						else
							l_tmp___8 := 0
						end
						l_tmp___9 := l_tmp___8
					end
					l_tmp___10 := l_tmp___9
				end
				Result := l_tmp___10
			end
		end

	hyperg_1F1_large2bm4a (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_eta: REAL_64
			l_cos2th: REAL_64
			l_sin2th: REAL_64
			l_th: REAL_64
			l_pre_h: REAL_64
			l_lg_b: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_lg: INTEGER_32
			l_t1: REAL_64
			l_t2: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_s1: REAL_64
			l_s2: REAL_64
			l_ser_val: REAL_64
			l_ser_err: REAL_64
			l_tmp___10: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
		do
			create l_lg_b.make (<<1>>)

			l_eta := 2.0 * a_b___0 - 4.0 * a_a___5
			l_cos2th := a_x / l_eta
			l_sin2th := 1.0 - l_cos2th
			l_th := (acos ((sqrt (l_cos2th))))
			l_pre_h := (((((0.25 * 3.14159265358979323846) * 3.14159265358979323846) * l_eta) * l_eta) * l_cos2th) * l_sin2th
			l_stat_lg := (gamma_inst.gsl_sf_lngamma_e (a_b___0, l_lg_b))
			l_t1 := (0.5 * (1.0 - a_b___0)) * (log ((0.25 * a_x) * l_eta))
			l_t2 := 0.25 * (log (l_pre_h))
			l_lnpre_val := ((l_lg_b.item.val + 0.5 * a_x) + l_t1) - l_t2
			l_tmp___4 := fabs (0.5 * a_x)
			l_tmp___5 := fabs (l_t1)
			l_lnpre_err := l_lg_b.item.err + (2.0 * 2.2204460492503131e-16) * ((l_tmp___4 + l_tmp___5) + (fabs (l_t2)))
			l_s1 := (sin (a_a___5 * 3.14159265358979323846))
			l_s2 := (sin ((0.25 * l_eta) * (2.0 * l_th - (sin (2.0 * l_th))) + 0.25 * 3.14159265358979323846))
			l_ser_val := l_s1 + l_s2
			l_tmp___10 := fabs (l_s1)
			l_ser_err := (2.0 * 2.2204460492503131e-16) * (l_tmp___10 + (fabs (l_s2)))
			l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val, l_lnpre_err, l_ser_val, l_ser_err, a_result))
			if l_stat_e /= 0 then
				l_tmp___14 := l_stat_e
			else
				if l_stat_lg /= 0 then
					l_tmp___13 := l_stat_lg
				else
					l_tmp___13 := 0
				end
				l_tmp___14 := l_tmp___13
			end
			Result := l_tmp___14
		end

	hyperg_1F1_largebx (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_f: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
		do
			l_y := a_x / a_b___0
			l_f := (exp (-a_a___5 * (log1p (-l_y))))
			l_t1 := -((a_a___5 * (a_a___5 + 1.0)) / ((2).to_double * a_b___0)) * (pow (l_y / (1.0 - l_y), 2.0))
			l_t2 := (((1).to_double / (((24).to_double * a_b___0) * a_b___0)) * ((((a_a___5 * (a_a___5 + (1).to_double)) * l_y) * l_y) / (pow ((1).to_double - l_y, (4).to_double)))) * (((12).to_double + ((8).to_double * ((2).to_double * a_a___5 + (1).to_double)) * l_y) + (((((3).to_double * a_a___5) * a_a___5 - a_a___5) - (2).to_double) * l_y) * l_y)
			l_tmp___3 := pow ((1).to_double - l_y, (6).to_double)
			l_t3 := (((-1).to_double / (((((48).to_double * a_b___0) * a_b___0) * a_b___0) * l_tmp___3)) * a_a___5) * ((a_a___5 + (1).to_double) * ((l_y * ((a_a___5 + (1).to_double) * (a_a___5 * (l_y * (l_y * ((l_y * (a_a___5 - (2).to_double) + (16).to_double) * (a_a___5 - (1).to_double)) + (72).to_double)) + (96).to_double)) + (24).to_double) * (pow (l_y, (2).to_double))))
			a_result.item.val := l_f * ((((1).to_double + l_t1) + l_t2) + l_t3)
			l_tmp___5 := fabs (l_f * l_t3)
			a_result.item.err := (2).to_double * l_tmp___5 + ((2).to_double * 2.2204460492503131e-16) * (fabs (a_result.item.val))
			Result := 0
		end

	hyperg_1F1_luke (a_a___5: REAL_64; a_c___1: REAL_64; a_xin: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_RECUR_BIG: REAL_64
			l_nmax: INTEGER_32
			l_n: INTEGER_32
			l_x: REAL_64
			l_x3___1: REAL_64
			l_t0: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_F___0: REAL_64
			l_prec: REAL_64
			l_Bnm3: REAL_64
			l_Bnm2: REAL_64
			l_Bnm1: REAL_64
			l_Anm3: REAL_64
			l_Anm2: REAL_64
			l_Anm1: REAL_64
			l_npam1: REAL_64
			l_npcm1: REAL_64
			l_npam2: REAL_64
			l_npcm2: REAL_64
			l_tnm1: REAL_64
			l_tnm3: REAL_64
			l_tnm5: REAL_64
			l_F1: REAL_64
			l_F2: REAL_64
			l_F3: REAL_64
			l_E: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_r___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.0e+50
					l_nmax := 5_000
					l_n := 3
					l_x := -a_xin
					l_x3___1 := (l_x * l_x) * l_x
					l_t0 := a_a___5 / a_c___1
					l_t1 := (a_a___5 + 1.0) / (2.0 * a_c___1)
					l_t2 := (a_a___5 + 2.0) / (2.0 * (a_c___1 + 1.0))
					l_F___0 := 1.0
					l_Bnm3 := 1.0
					l_Bnm2 := 1.0 + l_t1 * l_x
					l_Bnm1 := 1.0 + (l_t2 * l_x) * (1.0 + (l_t1 / 3.0) * l_x)
					l_Anm3 := 1.0
					l_Anm2 := l_Bnm2 - l_t0 * l_x
					l_Anm1 := (l_Bnm1 - (l_t0 * (1.0 + l_t2 * l_x)) * l_x) + (((l_t0 * l_t1) * (a_c___1 / (a_c___1 + 1.0))) * l_x) * l_x
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_npam1 := (l_n.to_double + a_a___5) - (1).to_double
						l_npcm1 := (l_n.to_double + a_c___1) - (1).to_double
						l_npam2 := (l_n.to_double + a_a___5) - (2).to_double
						l_npcm2 := (l_n.to_double + a_c___1) - (2).to_double
						l_tnm1 := (2 * l_n - 1).to_double
						l_tnm3 := (2 * l_n - 3).to_double
						l_tnm5 := (2 * l_n - 5).to_double
						l_F1 := ((l_n.to_double - a_a___5) - (2).to_double) / (((2).to_double * l_tnm3) * l_npcm1)
						l_F2 := ((l_n.to_double + a_a___5) * l_npam1) / (((((4).to_double * l_tnm1) * l_tnm3) * l_npcm2) * l_npcm1)
						l_F3 := ((-l_npam2 * l_npam1) * ((l_n.to_double - a_a___5) - (2).to_double)) / (((((((8).to_double * l_tnm3) * l_tnm3) * l_tnm5) * ((l_n.to_double + a_c___1) - (3).to_double)) * l_npcm2) * l_npcm1)
						l_E := (-l_npam1 * ((l_n.to_double - a_c___1) - (1).to_double)) / ((((2).to_double * l_tnm3) * l_npcm2) * l_npcm1)
						l_An := ((1.0 + l_F1 * l_x) * l_Anm1 + ((l_E + l_F2 * l_x) * l_x) * l_Anm2) + (l_F3 * l_x3___1) * l_Anm3
						l_Bn := ((1.0 + l_F1 * l_x) * l_Bnm1 + ((l_E + l_F2 * l_x) * l_x) * l_Bnm2) + (l_F3 * l_x3___1) * l_Bnm3
						l_r___3 := l_An / l_Bn
						l_prec := fabs ((l_F___0 - l_r___3) / l_F___0)
						l_F___0 := l_r___3
						if l_prec < 2.2204460492503131e-16 then
							js.break
						elseif l_n > l_nmax then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
						l_Anm3 := l_Anm3 / l_RECUR_BIG
						l_Bnm3 := l_Bnm3 / l_RECUR_BIG
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if not ((fabs (l_An)) < 1.0 / l_RECUR_BIG) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if not ((fabs (l_Bn)) < 1.0 / l_RECUR_BIG) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						l_An := l_An * l_RECUR_BIG
						l_Bn := l_Bn * l_RECUR_BIG
						l_Anm1 := l_Anm1 * l_RECUR_BIG
						l_Bnm1 := l_Bnm1 * l_RECUR_BIG
						l_Anm2 := l_Anm2 * l_RECUR_BIG
						l_Bnm2 := l_Bnm2 * l_RECUR_BIG
						l_Anm3 := l_Anm3 * l_RECUR_BIG
						l_Bnm3 := l_Bnm3 * l_RECUR_BIG
				when 14 then -- if done | if done | if done
						l_n := l_n + 1
						l_Bnm3 := l_Bnm2
						l_Bnm2 := l_Bnm1
						l_Bnm1 := l_Bn
						l_Anm3 := l_Anm2
						l_Anm2 := l_Anm1
						l_Anm1 := l_An
				when 15 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					a_result.item.val := l_F___0
					a_result.item.err := 2.0 * (fabs (l_F___0 * l_prec))
					a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_n.to_double - 1.0)) * (fabs (l_F___0)))
					Result := 0
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_1F1_renorm_b0 (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_eta: REAL_64
			l_root_eta: REAL_64
			l_I1_scaled: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_I: INTEGER_32
			l_tmp___1: INTEGER_32
			l_corr1: REAL_64
			l_tmp___2: REAL_64
			l_lnr_val: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_lnr_err: REAL_64
			l_tmp___7: REAL_64
			l_root_eta___0: REAL_64
			l_J1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_J: INTEGER_32
			l_tmp___12: INTEGER_32
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_t4: REAL_64
			l_lnr_val___0: REAL_64
			l_lnr_err___0: REAL_64
			l_tmp___16: REAL_64
			l_ex: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e: INTEGER_32
		do
			create l_I1_scaled.make (<<1>>)
			create l_J1.make (<<1>>)
			create l_ex.make (<<1>>)

			l_eta := a_a___5 * a_x
			if l_eta > 0.0 then
				l_root_eta := (sqrt (l_eta))
				l_stat_I := (bessel_i1_inst.gsl_sf_bessel_I1_scaled_e2 (2.0 * l_root_eta, l_I1_scaled))
				if l_I1_scaled.item.val <= 0.0 then
					a_result.item.val := 0.0
					a_result.item.err := 0.0
					if l_stat_I /= 0 then
						l_tmp___1 := l_stat_I
					else
						l_tmp___1 := 1
					end
					Result := l_tmp___1
				else
					l_tmp___2 := pow (a_x / (4.0 * a_a___5), 1.5)
					l_corr1 := (((2.0 / 3.0) * a_a___5) * l_tmp___2) * (bessel_in_inst.gsl_sf_bessel_In_scaled (2, 2.0 * l_root_eta))
					l_tmp___4 := log (l_eta)
					l_tmp___5 := fabs (2.0 * l_root_eta)
					l_lnr_val := ((0.5 * a_x + 0.5 * l_tmp___4) + l_tmp___5) + (log (l_I1_scaled.item.val + l_corr1))
					l_tmp___7 := fabs (a_x)
					l_lnr_err := 2.2204460492503131e-16 * (1.5 * l_tmp___7 + 1.0) + (fabs ((l_I1_scaled.item.err + l_corr1) / l_I1_scaled.item.val))
					Result := (exp_inst.gsl_sf_exp_err_e (l_lnr_val, l_lnr_err, a_result))
				end
			elseif l_eta = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
			else
				l_root_eta___0 := (sqrt (-l_eta))
				l_stat_J := (bessel_j1_inst.gsl_sf_bessel_J1_e (2.0 * l_root_eta___0, l_J1))
				if l_J1.item.val <= 0.0 then
					a_result.item.val := 0.0
					a_result.item.err := 0.0
					if l_stat_J /= 0 then
						l_tmp___12 := l_stat_J
					else
						l_tmp___12 := 1
					end
					Result := l_tmp___12
				else
					l_t1 := 0.5 * a_x
					l_t2 := 0.5 * (log (-l_eta))
					l_t3 := (fabs (a_x))
					l_t4 := (log (l_J1.item.val))
					l_lnr_val___0 := ((l_t1 + l_t2) + l_t3) + l_t4
					l_tmp___16 := fabs (a_x)
					l_lnr_err___0 := 2.2204460492503131e-16 * (1.5 * l_tmp___16 + 1.0) + (fabs (l_J1.item.err / l_J1.item.val))
					l_stat_e := (exp_inst.gsl_sf_exp_err_e (l_lnr_val___0, l_lnr_err___0, l_ex))
					a_result.item.val := -l_ex.item.val
					a_result.item.err := l_ex.item.err
					Result := l_stat_e
				end
			end
		end

	hyperg_1F1_small_a_bgt0 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_bma: REAL_64
			l_oma: REAL_64
			l_ap1mb: REAL_64
			l_abs_bma: REAL_64
			l_abs_oma: REAL_64
			l_abs_ap1mb: REAL_64
			l_ax: REAL_64
			l_b_del: REAL_64
			l_bp: REAL_64
			l_r_Mbp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Mb: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_Mbp1: REAL_64
			l_Mb: REAL_64
			l_Mbm1: REAL_64
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_err_rat: REAL_64
			l_tmp___11: REAL_64
			l_tmp___13: REAL_64
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: REAL_64
			l_tmp___22: REAL_64
			l_tmp___24: REAL_64
			l_tmp___28: INTEGER_32
			l_tmp___29: REAL_64
			l_pos: INTEGER_32
		do
			create l_r_Mbp1.make (<<1>>)
			create l_r_Mb.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bma := a_b___0 - a_a___5
					l_oma := 1.0 - a_a___5
					l_ap1mb := (1.0 + a_a___5) - a_b___0
					l_abs_bma := (fabs (l_bma))
					l_abs_oma := (fabs (l_oma))
					l_abs_ap1mb := (fabs (l_ap1mb))
					l_ax := (fabs (a_x))
					if a_a___5 /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if a_a___5 /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_b___0 >= 1.0 then
							Result := (hyperg_1F1_1 (a_b___0, a_x, a_result))
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else: | _L___1:
						if a_a___5 /= -1.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 1.0 + (a_a___5 / a_b___0) * a_x
						a_result.item.err := 2.2204460492503131e-16 * (1.0 + (fabs ((a_a___5 / a_b___0) * a_x)))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if not (a_b___0 >= 1.4 * l_ax) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						Result := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result))
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if not (a_x > 0.0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (a_x > 100.0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_abs_bma * l_abs_oma < 0.5 * a_x then
							Result := (hyperg_1F1_asymp_posx (a_a___5, a_b___0, a_x, a_result))
						else
							l_pos := -1 + 16 -- goto _L
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L:
						if a_b___0 < 5.0e+06 then
							l_b_del := (ceil (1.4 * a_x - a_b___0)) + 1.0
							l_bp := a_b___0 + l_b_del
							l_stat_0 := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, l_bp + 1.0, a_x, l_r_Mbp1))
							l_stat_1 := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, l_bp, a_x, l_r_Mb))
							l_tmp___11 := fabs (l_r_Mbp1.item.err / l_r_Mbp1.item.val)
							l_err_rat := l_tmp___11 + (fabs (l_r_Mb.item.err / l_r_Mb.item.val))
							l_Mbp1 := l_r_Mbp1.item.val
							l_Mb := l_r_Mb.item.val
							from
							until
								not (l_bp > a_b___0 + 0.1)
							loop
								l_Mbm1 := (((a_x + l_bp) - 1.0) * l_Mb - ((a_x * (l_bp - a_a___5)) / l_bp) * l_Mbp1) / (l_bp - 1.0)
								l_bp := l_bp - (1.0)
								l_Mbp1 := l_Mb
								l_Mb := l_Mbm1
							end
							a_result.item.val := l_Mb
							l_tmp___13 := fabs (l_b_del)
							a_result.item.err := (l_err_rat * (l_tmp___13 + 1.0)) * (fabs (l_Mb))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_Mb)))
							if l_stat_0 /= 0 then
								l_tmp___17 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___16 := l_stat_1
								else
									l_tmp___16 := 0
								end
								l_tmp___17 := l_tmp___16
							end
							Result := l_tmp___17
						else
							l_tmp___20 := fabs (a_x)
							if l_tmp___20 < (fabs (a_b___0)) then
								l_tmp___22 := fabs (a_a___5 * a_x)
								l_tmp___24 := sqrt ((fabs (a_b___0)))
								if l_tmp___22 < l_tmp___24 * (fabs (a_b___0 - a_x)) then
									Result := (hyperg_1F1_largebx (a_a___5, a_b___0, a_x, a_result))
								else
									l_tmp___19 := hyperg_1F1_large2bm4a (a_a___5, a_b___0, a_x, a_result)
									Result := l_tmp___19
								end
							else
								l_tmp___19 := hyperg_1F1_large2bm4a (a_a___5, a_b___0, a_x, a_result)
								Result := l_tmp___19
							end
						end
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not (l_ax < 10.0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_b___0 < 10.0 then
							Result := (hyperg_inst.gsl_sf_hyperg_1F1_series_e (a_a___5, a_b___0, a_x, a_result))
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___0:
						if l_ax >= 100.0 then
							if l_abs_ap1mb > 1.0 then
								l_tmp___29 := l_abs_ap1mb
							else
								l_tmp___29 := 1.0
							end
							if l_tmp___29 < 0.99 * l_ax then
								Result := (hyperg_1F1_asymp_negx (a_a___5, a_b___0, a_x, a_result))
							else
								l_tmp___28 := hyperg_1F1_luke (a_a___5, a_b___0, a_x, a_result)
								Result := l_tmp___28
							end
						else
							l_tmp___28 := hyperg_1F1_luke (a_a___5, a_b___0, a_x, a_result)
							Result := l_tmp___28
						end
				when 22 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
