class
	P_HYPERG_U

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	d9chu (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_EPS: REAL_64
			l_maxiter: INTEGER_32
			l_aa: CE_ARRAY [REAL_64]
			l_bb: CE_ARRAY [REAL_64]
			l_i: INTEGER_32
			l_bp: REAL_64
			l_ab: REAL_64
			l_ct2: REAL_64
			l_sab: REAL_64
			l_ct3: REAL_64
			l_anbn: REAL_64
			l_ct1: REAL_64
			l_j: INTEGER_32
			l_c2___0: REAL_64
			l_d1z: REAL_64
			l_g1: REAL_64
			l_g2: REAL_64
			l_g3: REAL_64
			l_x2i1: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_aa.make (<<4>>)
			create l_bb.make (<<4>>)

			l_EPS := 8.0 * 2.2204460492503131e-16
			l_maxiter := 500
			l_bp := (1.0 + a_a___5) - a_b___0
			l_ab := a_a___5 * l_bp
			l_ct2 := 2.0 * (a_x - l_ab)
			l_sab := a_a___5 + l_bp
			l_ct3 := (l_sab + 1.0) + l_ab
			l_anbn := (l_ct3 + l_sab) + 3.0
			l_ct1 := 1.0 + (2.0 * a_x) / l_anbn
			l_bb[0] := 1.0
			l_aa[0] := 1.0
			l_bb[1] := 1.0 + (2.0 * a_x) / l_ct3
			l_aa[1] := 1.0 + l_ct2 / l_ct3
			l_bb[2] := 1.0 + ((6.0 * l_ct1) * a_x) / l_ct3
			l_aa[2] := (1.0 + (6.0 * l_ab) / l_anbn) + ((3.0 * l_ct1) * l_ct2) / l_ct3
			l_i := 4
			from
			until
				not (not js.loop_done and then (l_i < l_maxiter))
			loop
				l_x2i1 := (2 * l_i - 3).to_double
				l_ct1 := l_x2i1 / (l_x2i1 - 2.0)
				l_anbn := l_anbn + (l_x2i1 + l_sab)
				l_ct2 := (l_x2i1 - 1.0) / l_anbn
				l_c2___0 := l_x2i1 * l_ct2 - 1.0
				l_d1z := ((2.0 * l_x2i1) * a_x) / l_anbn
				l_ct3 := l_sab * l_ct2
				l_g1 := l_d1z + l_ct1 * (l_c2___0 + l_ct3)
				l_g2 := l_d1z - l_c2___0
				l_g3 := l_ct1 * ((1.0 - l_ct3) - 2.0 * l_ct2)
				l_bb[3] := (l_g1 * l_bb[2] + l_g2 * l_bb[1]) + l_g3 * l_bb[0]
				l_aa[3] := (l_g1 * l_aa[2] + l_g2 * l_aa[1]) + l_g3 * l_aa[0]
				l_tmp := fabs (l_aa[3] * l_bb[0] - l_aa[0] * l_bb[3])
				if l_tmp < l_EPS * (fabs (l_bb[3] * l_bb[0])) then
					js.break
				end
				if not js.loop_jumped then
					l_j := 0
					from
					until
						not (l_j < 3)
					loop
						l_aa[l_j] := l_aa[l_j + 1]
						l_bb[l_j] := l_bb[l_j + 1]
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
			end
			a_result.item.val := l_aa[3] / l_bb[3]
			a_result.item.err := (8.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
			if l_i = l_maxiter then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 201, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_hyperg_U (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_hyperg_U_e (a_a___5, a_b___0, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_U_e(a, b, x, &result)"), ce_string ("hyperg_U.c"), 1_745, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hyperg_U_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_re: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_U: INTEGER_32
			l_stat_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create l_re.make (<<1>>)

			l_stat_U := (gsl_sf_hyperg_U_e10_e (a_a___5, a_b___0, a_x, l_re))
			l_stat_c := (result_inst.gsl_sf_result_smash_e (l_re, a_result))
			if l_stat_c /= 0 then
				l_tmp___2 := l_stat_c
			else
				if l_stat_U /= 0 then
					l_tmp___1 := l_stat_U
				else
					l_tmp___1 := 0
				end
				l_tmp___2 := l_tmp___1
			end
			Result := l_tmp___2
		end

	gsl_sf_hyperg_U_e10_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_rinta: REAL_64
			l_rintb: REAL_64
			l_a_integer: INTEGER_32
			l_b_integer: INTEGER_32
			l_lnx: REAL_64
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_tmp___10: REAL_64
			l_ap: REAL_64
			l_bp: REAL_64
			l_U: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_U: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_U.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rinta := (floor (a_a___5 + 0.5))
					l_rintb := (floor (a_b___0 + 0.5))
					l_a_integer := ((fabs (a_a___5 - l_rinta)) < 1000.0 * 2.2204460492503131e-16).to_integer
					l_b_integer := ((fabs (a_b___0 - l_rintb)) < 1000.0 * 2.2204460492503131e-16).to_integer
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_b___0 >= (1).to_double then
							from
							until
								js.loop_done
							loop
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								a_result.item.e10 := 0
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_U.c"), 1_673, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else: | _L___0:
						if a_a___5 /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						a_result.item.e10 := 0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						Result := (hyperg_U_origin (a_a___5, a_b___0, a_result))
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						Result := (hyperg_U_negx (a_a___5, a_b___0, a_x, a_result))
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (l_a_integer.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_b_integer.to_boolean then
							Result := (gsl_sf_hyperg_U_int_e10_e (l_rinta.truncated_to_integer, l_rintb.truncated_to_integer, a_x, a_result))
							js.return
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if a_b___0 >= 1.0 then
							Result := (hyperg_U_bge1 (a_a___5, a_b___0, a_x, a_result))
							js.return
						else
							l_lnx := (log (a_x))
							l_ln_pre_val := (1.0 - a_b___0) * l_lnx
							l_tmp___10 := fabs (l_lnx)
							l_ln_pre_err := ((l_tmp___10 * 2.0) * 2.2204460492503131e-16) * (1.0 + (fabs (a_b___0)))
							l_ap := (1.0 + a_a___5) - a_b___0
							l_bp := 2.0 - a_b___0
							l_stat_U := (hyperg_U_bge1 (l_ap, l_bp, a_x, l_U))
							l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_ln_pre_val + (l_U.item.e10).to_double * 2.30258509299404568402, l_ln_pre_err, l_U.item.val, l_U.item.err, a_result))
							if l_stat_e /= 0 then
								l_tmp___15 := l_stat_e
							else
								if l_stat_U /= 0 then
									l_tmp___14 := l_stat_U
								else
									l_tmp___14 := 0
								end
								l_tmp___15 := l_tmp___14
							end
							Result := l_tmp___15
							js.return
						end
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_hyperg_U_int (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_hyperg_U_int_e (a_a___5, a_b___0, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_U_int_e(a, b, x, &result)"), ce_string ("hyperg_U.c"), 1_740, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hyperg_U_int_e (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_re: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_stat_U: INTEGER_32
			l_stat_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create l_re.make (<<1>>)

			l_stat_U := (gsl_sf_hyperg_U_int_e10_e (a_a___5, a_b___0, a_x, l_re))
			l_stat_c := (result_inst.gsl_sf_result_smash_e (l_re, a_result))
			if l_stat_c /= 0 then
				l_tmp___2 := l_stat_c
			else
				if l_stat_U /= 0 then
					l_tmp___1 := l_stat_U
				else
					l_tmp___1 := 0
				end
				l_tmp___2 := l_tmp___1
			end
			Result := l_tmp___2
		end

	gsl_sf_hyperg_U_int_e10_e (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_U: CE_ARRAY [PD_GSL_SF_RESULT_E10_STRUCT]
			l_ln_x: REAL_64
			l_ap: INTEGER_32
			l_bp: INTEGER_32
			l_stat_e: INTEGER_32
			l_stat_U: INTEGER_32
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_tmp___6: REAL_64
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_U.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_b___0 >= 1 then
							from
							until
								js.loop_done
							loop
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								a_result.item.e10 := 0
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_U.c"), 1_628, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_x = 0.0 then
							Result := (hyperg_U_int_origin (a_a___5, a_b___0, a_result))
							js.return
						elseif a_x < 0.0 then
							Result := (hyperg_U_int_negx (a_a___5, a_b___0, a_x, a_result))
							js.return
						elseif a_b___0 >= 1 then
							Result := (hyperg_U_int_bge1 (a_a___5, a_b___0, a_x, a_result))
							js.return
						else
							l_ln_x := (log (a_x))
							l_ap := (1 + a_a___5) - a_b___0
							l_bp := 2 - a_b___0
							l_stat_U := (hyperg_U_int_bge1 (l_ap, l_bp, a_x, l_U))
							l_ln_pre_val := (1.0 - a_b___0.to_double) * l_ln_x
							l_tmp___6 := fabs (a_b___0.to_double)
							l_ln_pre_err := ((2.0 * 2.2204460492503131e-16) * (l_tmp___6 + 1.0)) * (fabs (l_ln_x))
							l_ln_pre_err := l_ln_pre_err + ((2.0 * 2.2204460492503131e-16) * (fabs (1.0 - a_b___0.to_double)))
							l_stat_e := exp_inst.gsl_sf_exp_mult_err_e10_e (l_ln_pre_val + (l_U.item.e10).to_double * 2.30258509299404568402, l_ln_pre_err, l_U.item.val, l_U.item.err, a_result)
							if l_stat_e /= 0 then
								l_tmp___10 := l_stat_e
							else
								if l_stat_U /= 0 then
									l_tmp___9 := l_stat_U
								else
									l_tmp___9 := 0
								end
								l_tmp___10 := l_tmp___9
							end
							Result := l_tmp___10
							js.return
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_U_CF1 (a_a___5: REAL_64; a_b___0: REAL_64; a_N: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [REAL_64]; a_count: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_RECUR_BIG: REAL_64
			l_maxiter: INTEGER_32
			l_n: INTEGER_32
			l_Anm2: REAL_64
			l_Bnm2: REAL_64
			l_Anm1: REAL_64
			l_Bnm1: REAL_64
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_an2: REAL_64
			l_bn2: REAL_64
			l_fn: REAL_64
			l_old_fn: REAL_64
			l_del: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.3407807929942596e+154
					l_maxiter := 20_000
					l_n := 1
					l_Anm2 := 1.0
					l_Bnm2 := 0.0
					l_Anm1 := 0.0
					l_Bnm1 := 1.0
					l_a1___4 := -(a_a___5 + a_N.to_double)
					l_b1___0 := ((a_b___0 - 2.0 * a_a___5) - a_x) - 2.0 * (a_N + 1).to_double
					l_An := l_b1___0 * l_Anm1 + l_a1___4 * l_Anm2
					l_Bn := l_b1___0 * l_Bnm1 + l_a1___4 * l_Bnm2
					l_fn := l_An / l_Bn
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_n < l_maxiter)) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_n := l_n + 1
						l_Anm2 := l_Anm1
						l_Bnm2 := l_Bnm1
						l_Anm1 := l_An
						l_Bnm1 := l_Bn
						l_an2 := -(((a_a___5 + a_N.to_double) + l_n.to_double) - a_b___0) * (((a_a___5 + a_N.to_double) + l_n.to_double) - 1.0)
						l_bn2 := ((a_b___0 - 2.0 * a_a___5) - a_x) - 2.0 * (a_N + l_n).to_double
						l_An := l_bn2 * l_Anm1 + l_an2 * l_Anm2
						l_Bn := l_bn2 * l_Bnm1 + l_an2 * l_Bnm2
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
				when 7 then -- if done
						l_old_fn := l_fn
						l_fn := l_An / l_Bn
						l_del := l_old_fn / l_fn
						if (fabs (l_del - 1.0)) < 10.0 * 2.2204460492503131e-16 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					a_result.item := l_fn
					a_count.item := l_n
					if l_n = l_maxiter then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 121, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
					else
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_U_bge1 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_rinta: REAL_64
			l_a_neg_integer: INTEGER_32
			l_tmp___1: INTEGER_32
			l_n: INTEGER_32
			l_sgn: REAL_64
			l_tmp___2: REAL_64
			l_lnfact: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_L: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_L: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_asymp: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_asymp: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_rU: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ln_multiplier: CE_ARRAY [REAL_64]
			l_stat_U: INTEGER_32
			l_stat_e___1: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_ser: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_ser: INTEGER_32
			l_scale_factor: REAL_64
			l_a0___2: REAL_64
			l_b0: REAL_64
			l_scale_count: INTEGER_32
			l_lm_0: CE_ARRAY [REAL_64]
			l_lm_1: CE_ARRAY [REAL_64]
			l_lm_max: REAL_64
			l_r_Uap1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Ua: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_stat_e___2: INTEGER_32
			l_Uap1: REAL_64
			l_Ua: REAL_64
			l_Uam1: REAL_64
			l_ap: REAL_64
			l_au0: REAL_64
			l_lnscale: REAL_64
			l_lnm: PD_GSL_SF_RESULT_STRUCT
			l_y: PD_GSL_SF_RESULT_STRUCT
			l_tmp___27: REAL_64
			l_tmp___29: REAL_64
			l_tmp___31: REAL_64
			l_tmp___33: REAL_64
			l_err_mult: REAL_64
			l_tmp___37: REAL_64
			l_lnscale___0: REAL_64
			l_lnm___0: PD_GSL_SF_RESULT_STRUCT
			l_y___0: PD_GSL_SF_RESULT_STRUCT
			l_Ubm1: REAL_64
			l_Ub: REAL_64
			l_Ubp1: REAL_64
			l_bp: REAL_64
			l_au0___0: REAL_64
			l_tmp___41: REAL_64
			l_tmp___43: REAL_64
			l_tmp___45: REAL_64
			l_tmp___50: INTEGER_32
			l_tmp___51: INTEGER_32
			l_tmp___52: INTEGER_32
			l_scale_count___0: INTEGER_32
			l_a0___3: REAL_64
			l_scale_factor___0: REAL_64
			l_lnscale___1: REAL_64
			l_lm_0___0: CE_ARRAY [REAL_64]
			l_lm_1___0: CE_ARRAY [REAL_64]
			l_lm_max___0: REAL_64
			l_r_Uam1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Ua___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0___0: INTEGER_32
			l_stat_1___0: INTEGER_32
			l_stat_e___3: INTEGER_32
			l_lnm___1: PD_GSL_SF_RESULT_STRUCT
			l_y___1: PD_GSL_SF_RESULT_STRUCT
			l_Uam1___0: REAL_64
			l_Ua___0: REAL_64
			l_Uap1___0: REAL_64
			l_ap___0: REAL_64
			l_au0___1: REAL_64
			l_tmp___59: REAL_64
			l_tmp___61: REAL_64
			l_tmp___63: REAL_64
			l_tmp___65: REAL_64
			l_tmp___69: INTEGER_32
			l_tmp___70: INTEGER_32
			l_tmp___71: INTEGER_32
			l_a0___4: REAL_64
			l_scale_factor___1: REAL_64
			l_scale_count___1: INTEGER_32
			l_lnm___2: PD_GSL_SF_RESULT_STRUCT
			l_y___2: PD_GSL_SF_RESULT_STRUCT
			l_lnscale___2: REAL_64
			l_lm_0___1: CE_ARRAY [REAL_64]
			l_Uap1___1: REAL_64
			l_Ua___1: REAL_64
			l_Uam1___1: REAL_64
			l_U0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ap___1: REAL_64
			l_ru2: CE_ARRAY [REAL_64]
			l_r___3: REAL_64
			l_CF1_count: CE_ARRAY [INTEGER_32]
			l_stat_CF1: INTEGER_32
			l_stat_U0: INTEGER_32
			l_stat_e___4: INTEGER_32
			l_au0___2: REAL_64
			l_tmp___75: REAL_64
			l_tmp___78: REAL_64
			l_tmp___80: INTEGER_32
			l_tmp___81: INTEGER_32
			l_tmp___82: INTEGER_32
			l_scale_count_for: INTEGER_32
			l_scale_count_bck: INTEGER_32
			l_scale_factor___2: REAL_64
			l_eps: REAL_64
			l_a0___5: REAL_64
			l_tmp___84: REAL_64
			l_a1___4: REAL_64
			l_lnm___3: PD_GSL_SF_RESULT_STRUCT
			l_y___3: PD_GSL_SF_RESULT_STRUCT
			l_lm_for: REAL_64
			l_lnscale___3: REAL_64
			l_Ua1_bck: REAL_64
			l_Ua1_for: REAL_64
			l_stat_for: INTEGER_32
			l_stat_bck: INTEGER_32
			l_stat_e___5: INTEGER_32
			l_CF1_count___0: CE_ARRAY [INTEGER_32]
			l_Uap1___2: REAL_64
			l_Ua___2: REAL_64
			l_Uam1___2: REAL_64
			l_ap___2: REAL_64
			l_ru___0: CE_ARRAY [REAL_64]
			l_r___4: REAL_64
			l_stat_CF1___0: INTEGER_32
			l_au0___3: REAL_64
			l_r_Uam1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Ua___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lm_0___2: CE_ARRAY [REAL_64]
			l_lm_1___1: CE_ARRAY [REAL_64]
			l_stat_0___1: INTEGER_32
			l_stat_1___1: INTEGER_32
			l_Uam1___3: REAL_64
			l_Ua___3: REAL_64
			l_Uap1___3: REAL_64
			l_ap___3: REAL_64
			l_au0___4: REAL_64
			l_tmp___93: INTEGER_32
			l_tmp___94: REAL_64
			l_tmp___95: REAL_64
			l_tmp___97: REAL_64
			l_tmp___99: INTEGER_32
			l_tmp___100: INTEGER_32
			l_tmp___101: INTEGER_32
			l_tmp___106: REAL_64
			l_tmp___108: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lnfact.make (<<1>>)
			create l_L.make (<<1>>)
			create l_asymp.make (<<1>>)
			create l_rU.make (<<1>>)
			create l_ln_multiplier.make (<<1>>)
			create l_ser.make (<<1>>)
			create l_lm_0.make (<<1>>)
			create l_lm_1.make (<<1>>)
			create l_r_Uap1.make (<<1>>)
			create l_r_Ua.make (<<1>>)
			create l_lnm.make
			create l_y.make
			create l_lnm___0.make
			create l_y___0.make
			create l_lm_0___0.make (<<1>>)
			create l_lm_1___0.make (<<1>>)
			create l_r_Uam1.make (<<1>>)
			create l_r_Ua___0.make (<<1>>)
			create l_lnm___1.make
			create l_y___1.make
			create l_lnm___2.make
			create l_y___2.make
			create l_lm_0___1.make (<<1>>)
			create l_U0.make (<<1>>)
			create l_ru2.make (<<1>>)
			create l_CF1_count.make (<<1>>)
			create l_lnm___3.make
			create l_y___3.make
			create l_CF1_count___0.make (<<1>>)
			create l_ru___0.make (<<1>>)
			create l_r_Uam1___0.make (<<1>>)
			create l_r_Ua___1.make (<<1>>)
			create l_lm_0___2.make (<<1>>)
			create l_lm_1___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rinta := (floor (a_a___5 + 0.5))
					if a_a___5 < 0.0 then
						if (fabs (a_a___5 - l_rinta)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
					else
						l_tmp___1 := 0
					end
					l_a_neg_integer := l_tmp___1
					if a_a___5 /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						a_result.item.e10 := 0
						Result := 0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 3 then -- else:
						if not (l_a_neg_integer.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (fabs (l_rinta)) < (2_147_483_647).to_double then
							l_n := -l_rinta.truncated_to_integer
							if ((l_n).bit_and (1)).to_boolean then
								l_tmp___2 := -1.0
							else
								l_tmp___2 := 1.0
							end
							l_sgn := l_tmp___2
							l_stat_L := (laguerre_inst.gsl_sf_laguerre_n_e (l_n, a_b___0 - 1.0, a_x, l_L))
							gamma_inst.gsl_sf_lnfact_e (l_n.to_natural_32, l_lnfact).do_nothing
							l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnfact.item.val, l_lnfact.item.err, l_sgn * l_L.item.val, l_L.item.err, a_result))
							if l_stat_e /= 0 then
								l_tmp___6 := l_stat_e
							else
								if l_stat_L /= 0 then
									l_tmp___5 := l_stat_L
								else
									l_tmp___5 := 0
								end
								l_tmp___6 := l_tmp___5
							end
							Result := l_tmp___6
						else
							l_pos := -1 + 6 -- goto _L___4
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else: | _L___4:
						l_tmp___106 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_a___5)), 1.0)
						l_tmp___108 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs ((1.0 + a_a___5) - a_b___0)), 1.0)
						if not (l_tmp___106 * l_tmp___108 < 0.99 * (fabs (a_x))) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_ln_pre_val := -a_a___5 * (log (a_x))
						l_ln_pre_err := (2.0 * 2.2204460492503131e-16) * (fabs (l_ln_pre_val))
						l_stat_asymp := (hyperg_zaU_asymp (a_a___5, a_b___0, a_x, l_asymp))
						l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_ln_pre_val, l_ln_pre_err, l_asymp.item.val, l_asymp.item.err, a_result))
						if l_stat_e___0 /= 0 then
							l_tmp___12 := l_stat_e___0
						else
							if l_stat_asymp /= 0 then
								l_tmp___11 := l_stat_asymp
							else
								l_tmp___11 := 0
							end
							l_tmp___12 := l_tmp___11
						end
						Result := l_tmp___12
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if not ((fabs (a_a___5)) <= 1.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_stat_U := (hyperg_U_small_a_bgt0 (a_a___5, a_b___0, a_x, l_rU, l_ln_multiplier))
						l_stat_e___1 := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_ln_multiplier.item, (2.0 * 2.2204460492503131e-16) * (fabs (l_ln_multiplier.item)), l_rU.item.val, l_rU.item.err, a_result))
						if l_stat_U /= 0 then
							l_tmp___17 := l_stat_U
						else
							if l_stat_e___1 /= 0 then
								l_tmp___16 := l_stat_e___1
							else
								l_tmp___16 := 0
							end
							l_tmp___17 := l_tmp___16
						end
						Result := l_tmp___17
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if not ((fabs (a_a___5)) < (5).to_double) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_b___0 < (5).to_double then
							if a_x < 2.0 then
								l_pos := -1 + 18 -- goto _L
							else
								l_pos := -1 + 15 -- goto _L___3
							end
						else
							l_pos := -1 + 15 -- goto _L___3
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___3:
						if not ((fabs (a_a___5)) < (10).to_double) then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if not (a_b___0 < (10).to_double) then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if not (a_x < 1.0) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L:
						l_stat_ser := (hyperg_U_series (a_a___5, a_b___0, a_x, l_ser))
						a_result.item.val := l_ser.item.val
						a_result.item.err := l_ser.item.err
						a_result.item.e10 := 0
						Result := l_stat_ser
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 24 -- goto _L___1
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___1
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___1:
						if a_a___5 < 0.0 then
							l_scale_factor := 1.3407807929942596e+154
							l_a0___2 := (a_a___5 - (floor (a_a___5))) - 1.0
							l_b0 := (a_b___0 - (floor (a_b___0))) + 1.0
							l_scale_count := 0
							l_stat_0 := (hyperg_U_small_a_bgt0 (l_a0___2 + 1.0, l_b0, a_x, l_r_Uap1, l_lm_0))
							l_stat_1 := (hyperg_U_small_a_bgt0 (l_a0___2, l_b0, a_x, l_r_Ua, l_lm_1))
							l_Uap1 := l_r_Uap1.item.val
							l_Ua := l_r_Ua.item.val
							if l_lm_0.item > l_lm_1.item then
								l_lm_max := l_lm_0.item
							else
								l_lm_max := l_lm_1.item
							end
							l_Uap1 := l_Uap1 * (exp (l_lm_0.item - l_lm_max))
							l_Ua := l_Ua * (exp (l_lm_1.item - l_lm_max))
							l_ap := l_a0___2
							from
							until
								not (not js.loop_done and then (l_ap > a_a___5 + 0.1))
							loop
								l_Uam1 := (l_ap * ((l_b0 - l_ap) - 1.0)) * l_Uap1 + ((a_x + 2.0 * l_ap) - l_b0) * l_Ua
								l_Uap1 := l_Ua
								l_Ua := l_Uam1
								from
								until
									js.loop_done
								loop
									l_au0 := (fabs (l_Ua))
									if l_au0 > l_scale_factor then
										l_Ua := l_Ua / l_scale_factor
										l_Uap1 := l_Uap1 / l_scale_factor
										l_scale_count := l_scale_count + 1
									elseif l_au0 < 1.0 / l_scale_factor then
										l_Ua := l_Ua * l_scale_factor
										l_Uap1 := l_Uap1 * l_scale_factor
										l_scale_count := l_scale_count - 1
									end
									js.break
								end
								l_ap := l_ap - (1.0)
							end
							if a_b___0 < 2.0 then
								l_lnscale := (log (l_scale_factor))
								l_lnm.val := l_lm_max + l_scale_count.to_double * l_lnscale
								l_tmp___27 := fabs (l_lm_max)
								l_lnm.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___27 + l_scale_count.to_double * (fabs (l_lnscale)))
								l_y.val := l_Ua
								l_tmp___29 := fabs (l_r_Uap1.item.err / l_r_Uap1.item.val)
								l_y.err := l_tmp___29 * (fabs (l_Ua))
								l_tmp___31 := fabs (l_r_Ua.item.err / l_r_Ua.item.val)
								l_y.err := l_y.err + (l_tmp___31 * (fabs (l_Ua)))
								l_tmp___33 := fabs (a_a___5 - l_a0___2)
								l_y.err := l_y.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___33 + 1.0)) * (fabs (l_Ua)))
								l_y.err := l_y.err * ((fabs (l_lm_0.item - l_lm_max)) + 1.0)
								l_y.err := l_y.err * ((fabs (l_lm_1.item - l_lm_max)) + 1.0)
								l_stat_e___2 := exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm.val, l_lnm.err, l_y.val, l_y.err, a_result)
							else
								l_tmp___37 := fabs (a_b___0 - l_b0)
								l_err_mult := (l_tmp___37 + (fabs (a_a___5 - l_a0___2))) + 1.0
								l_lnscale___0 := (log (l_scale_factor))
								l_Ubm1 := l_Ua
								l_Ub := ((a_a___5 * ((l_b0 - a_a___5) - 1.0)) * l_Uap1 + (a_a___5 + a_x) * l_Ua) / a_x
								l_bp := l_b0 + 1.0
								from
								until
									not (not js.loop_done and then (l_bp < a_b___0 - 0.1))
								loop
									l_Ubp1 := (((1.0 + a_a___5) - l_bp) * l_Ubm1 + ((l_bp + a_x) - 1.0) * l_Ub) / a_x
									l_Ubm1 := l_Ub
									l_Ub := l_Ubp1
									from
									until
										js.loop_done
									loop
										l_au0___0 := (fabs (l_Ub))
										if l_au0___0 > l_scale_factor then
											l_Ub := l_Ub / l_scale_factor
											l_Ubm1 := l_Ubm1 / l_scale_factor
											l_scale_count := l_scale_count + 1
										elseif l_au0___0 < 1.0 / l_scale_factor then
											l_Ub := l_Ub * l_scale_factor
											l_Ubm1 := l_Ubm1 * l_scale_factor
											l_scale_count := l_scale_count - 1
										end
										js.break
									end
									l_bp := l_bp + (1.0)
								end
								l_lnm___0.val := l_lm_max + l_scale_count.to_double * l_lnscale___0
								l_tmp___41 := fabs (l_lm_max)
								l_lnm___0.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___41 + (fabs (l_scale_count.to_double * l_lnscale___0)))
								l_y___0.val := l_Ub
								l_tmp___43 := fabs (l_r_Uap1.item.err / l_r_Uap1.item.val)
								l_y___0.err := ((2.0 * l_err_mult) * l_tmp___43) * (fabs (l_Ub))
								l_tmp___45 := fabs (l_r_Ua.item.err / l_r_Ua.item.val)
								l_y___0.err := l_y___0.err + (((2.0 * l_err_mult) * l_tmp___45) * (fabs (l_Ub)))
								l_y___0.err := l_y___0.err + (((2.0 * 2.2204460492503131e-16) * l_err_mult) * (fabs (l_Ub)))
								l_y___0.err := l_y___0.err * ((fabs (l_lm_0.item - l_lm_max)) + 1.0)
								l_y___0.err := l_y___0.err * ((fabs (l_lm_1.item - l_lm_max)) + 1.0)
								l_stat_e___2 := exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm___0.val, l_lnm___0.err, l_y___0.val, l_y___0.err, a_result)
							end
							if l_stat_e___2 /= 0 then
								l_tmp___52 := l_stat_e___2
							else
								if l_stat_0 /= 0 then
									l_tmp___51 := l_stat_0
								else
									if l_stat_1 /= 0 then
										l_tmp___50 := l_stat_1
									else
										l_tmp___50 := 0
									end
									l_tmp___51 := l_tmp___50
								end
								l_tmp___52 := l_tmp___51
							end
							Result := l_tmp___52
						elseif a_b___0 >= (2).to_double * a_a___5 + a_x then
							l_scale_count___0 := 0
							l_a0___3 := a_a___5 - (floor (a_a___5))
							l_scale_factor___0 := 1.3407807929942596e+154
							l_stat_0___0 := (hyperg_U_small_a_bgt0 (l_a0___3 - 1.0, a_b___0, a_x, l_r_Uam1, l_lm_0___0))
							l_stat_1___0 := (hyperg_U_small_a_bgt0 (l_a0___3, a_b___0, a_x, l_r_Ua___0, l_lm_1___0))
							l_Uam1___0 := l_r_Uam1.item.val
							l_Ua___0 := l_r_Ua___0.item.val
							if l_lm_0___0.item > l_lm_1___0.item then
								l_lm_max___0 := l_lm_0___0.item
							else
								l_lm_max___0 := l_lm_1___0.item
							end
							l_Uam1___0 := l_Uam1___0 * (exp (l_lm_0___0.item - l_lm_max___0))
							l_Ua___0 := l_Ua___0 * (exp (l_lm_1___0.item - l_lm_max___0))
							l_ap___0 := l_a0___3
							from
							until
								not (not js.loop_done and then (l_ap___0 < a_a___5 - 0.1))
							loop
								l_Uap1___0 := -(l_Uam1___0 + ((a_b___0 - 2.0 * l_ap___0) - a_x) * l_Ua___0) / (l_ap___0 * ((1.0 + l_ap___0) - a_b___0))
								l_Uam1___0 := l_Ua___0
								l_Ua___0 := l_Uap1___0
								from
								until
									js.loop_done
								loop
									l_au0___1 := (fabs (l_Ua___0))
									if l_au0___1 > l_scale_factor___0 then
										l_Ua___0 := l_Ua___0 / l_scale_factor___0
										l_Uam1___0 := l_Uam1___0 / l_scale_factor___0
										l_scale_count___0 := l_scale_count___0 + 1
									elseif l_au0___1 < 1.0 / l_scale_factor___0 then
										l_Ua___0 := l_Ua___0 * l_scale_factor___0
										l_Uam1___0 := l_Uam1___0 * l_scale_factor___0
										l_scale_count___0 := l_scale_count___0 - 1
									end
									js.break
								end
								l_ap___0 := l_ap___0 + (1.0)
							end
							l_lnscale___1 := log (l_scale_factor___0)
							l_lnm___1.val := l_lm_max___0 + l_scale_count___0.to_double * l_lnscale___1
							l_tmp___59 := fabs (l_lm_max___0)
							l_lnm___1.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___59 + (fabs (l_scale_count___0.to_double * l_lnscale___1)))
							l_y___1.val := l_Ua___0
							l_tmp___61 := fabs (l_r_Uam1.item.err / l_r_Uam1.item.val)
							l_y___1.err := l_tmp___61 * (fabs (l_Ua___0))
							l_tmp___63 := fabs (l_r_Ua___0.item.err / l_r_Ua___0.item.val)
							l_y___1.err := l_y___1.err + (l_tmp___63 * (fabs (l_Ua___0)))
							l_tmp___65 := fabs (a_a___5 - l_a0___3)
							l_y___1.err := l_y___1.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___65 + 1.0)) * (fabs (l_Ua___0)))
							l_y___1.err := l_y___1.err * ((fabs (l_lm_0___0.item - l_lm_max___0)) + 1.0)
							l_y___1.err := l_y___1.err * ((fabs (l_lm_1___0.item - l_lm_max___0)) + 1.0)
							l_stat_e___3 := exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm___1.val, l_lnm___1.err, l_y___1.val, l_y___1.err, a_result)
							if l_stat_e___3 /= 0 then
								l_tmp___71 := l_stat_e___3
							else
								if l_stat_0___0 /= 0 then
									l_tmp___70 := l_stat_0___0
								else
									if l_stat_1___0 /= 0 then
										l_tmp___69 := l_stat_1___0
									else
										l_tmp___69 := 0
									end
									l_tmp___70 := l_tmp___69
								end
								l_tmp___71 := l_tmp___70
							end
							Result := l_tmp___71
						elseif a_b___0 <= a_x then
							l_a0___4 := a_a___5 - (floor (a_a___5))
							l_scale_factor___1 := 1.3407807929942596e+154
							l_scale_count___1 := 0
							l_stat_CF1 := (hyperg_U_CF1 (a_a___5, a_b___0, 0, a_x, l_ru2, l_CF1_count))
							l_r___3 := l_ru2.item / a_a___5
							l_Ua___1 := 1.4916681462400413e-154
							l_Uap1___1 := l_r___3 * l_Ua___1
							l_ap___1 := a_a___5
							from
							until
								not (not js.loop_done and then (l_ap___1 > l_a0___4 + 0.1))
							loop
								l_Uam1___1 := -(((a_b___0 - 2.0 * l_ap___1) - a_x) * l_Ua___1 + (l_ap___1 * ((1.0 + l_ap___1) - a_b___0)) * l_Uap1___1)
								l_Uap1___1 := l_Ua___1
								l_Ua___1 := l_Uam1___1
								from
								until
									js.loop_done
								loop
									l_au0___2 := (fabs (l_Ua___1))
									if l_au0___2 > l_scale_factor___1 then
										l_Ua___1 := l_Ua___1 / l_scale_factor___1
										l_Uap1___1 := l_Uap1___1 / l_scale_factor___1
										l_scale_count___1 := l_scale_count___1 + 1
									elseif l_au0___2 < 1.0 / l_scale_factor___1 then
										l_Ua___1 := l_Ua___1 * l_scale_factor___1
										l_Uap1___1 := l_Uap1___1 * l_scale_factor___1
										l_scale_count___1 := l_scale_count___1 - 1
									end
									js.break
								end
								l_ap___1 := l_ap___1 - (1.0)
							end
							l_stat_U0 := hyperg_U_small_a_bgt0 (l_a0___4, a_b___0, a_x, l_U0, l_lm_0___1)
							l_lnscale___2 := log (l_scale_factor___1)
							l_lnm___2.val := l_lm_0___1.item - l_scale_count___1.to_double * l_lnscale___2
							l_tmp___75 := fabs (l_lm_0___1.item)
							l_lnm___2.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___75 + (fabs (l_scale_count___1.to_double * l_lnscale___2)))
							l_y___2.val := 1.4916681462400413e-154 * (l_U0.item.val / l_Ua___1)
							l_y___2.err := 1.4916681462400413e-154 * (l_U0.item.err / (fabs (l_Ua___1)))
							l_tmp___78 := fabs (l_a0___4 - a_a___5)
							l_y___2.err := l_y___2.err + (((2.0 * 2.2204460492503131e-16) * ((l_tmp___78 + (l_CF1_count.item).to_double) + 1.0)) * (fabs (l_y___2.val)))
							l_stat_e___4 := exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm___2.val, l_lnm___2.err, l_y___2.val, l_y___2.err, a_result)
							if l_stat_e___4 /= 0 then
								l_tmp___82 := l_stat_e___4
							else
								if l_stat_U0 /= 0 then
									l_tmp___81 := l_stat_U0
								else
									if l_stat_CF1 /= 0 then
										l_tmp___80 := l_stat_CF1
									else
										l_tmp___80 := 0
									end
									l_tmp___81 := l_tmp___80
								end
								l_tmp___82 := l_tmp___81
							end
							Result := l_tmp___82
						else
							l_scale_count_for := 0
							l_scale_count_bck := 0
							l_scale_factor___2 := 1.3407807929942596e+154
							l_eps := a_a___5 - (floor (a_a___5))
							if l_eps = 0.0 then
								l_tmp___84 := 1.0
							else
								l_tmp___84 := l_eps
							end
							l_a0___5 := l_tmp___84
							l_a1___4 := l_a0___5 + (ceil (0.5 * (a_b___0 - a_x) - l_a0___5))
							l_stat_CF1___0 := (hyperg_U_CF1 (a_a___5, a_b___0, 0, a_x, l_ru___0, l_CF1_count___0))
							l_r___4 := l_ru___0.item / a_a___5
							l_Ua___2 := 1.4916681462400413e-154
							l_Uap1___2 := l_r___4 * l_Ua___2
							l_ap___2 := a_a___5
							from
							until
								not (not js.loop_done and then (l_ap___2 > l_a1___4 + 0.1))
							loop
								l_Uam1___2 := -(((a_b___0 - 2.0 * l_ap___2) - a_x) * l_Ua___2 + (l_ap___2 * ((1.0 + l_ap___2) - a_b___0)) * l_Uap1___2)
								l_Uap1___2 := l_Ua___2
								l_Ua___2 := l_Uam1___2
								from
								until
									js.loop_done
								loop
									l_au0___3 := (fabs (l_Ua___2))
									if l_au0___3 > l_scale_factor___2 then
										l_Ua___2 := l_Ua___2 / l_scale_factor___2
										l_Uap1___2 := l_Uap1___2 / l_scale_factor___2
										l_scale_count_bck := l_scale_count_bck + 1
									elseif l_au0___3 < 1.0 / l_scale_factor___2 then
										l_Ua___2 := l_Ua___2 * l_scale_factor___2
										l_Uap1___2 := l_Uap1___2 * l_scale_factor___2
										l_scale_count_bck := l_scale_count_bck - 1
									end
									js.break
								end
								l_ap___2 := l_ap___2 - (1.0)
							end
							l_Ua1_bck := l_Ua___2
							l_stat_bck := l_stat_CF1___0
							l_stat_0___1 := (hyperg_U_small_a_bgt0 (l_a0___5 - 1.0, a_b___0, a_x, l_r_Uam1___0, l_lm_0___2))
							l_stat_1___1 := (hyperg_U_small_a_bgt0 (l_a0___5, a_b___0, a_x, l_r_Ua___1, l_lm_1___1))
							l_Uam1___3 := l_r_Uam1___0.item.val
							l_Ua___3 := l_r_Ua___1.item.val
							if l_lm_0___2.item > l_lm_1___1.item then
								l_lm_for := l_lm_0___2.item
							else
								l_lm_for := l_lm_1___1.item
							end
							l_Uam1___3 := l_Uam1___3 * (exp (l_lm_0___2.item - l_lm_for))
							l_Ua___3 := l_Ua___3 * (exp (l_lm_1___1.item - l_lm_for))
							l_ap___3 := l_a0___5
							from
							until
								not (not js.loop_done and then (l_ap___3 < l_a1___4 - 0.1))
							loop
								l_Uap1___3 := -(l_Uam1___3 + ((a_b___0 - 2.0 * l_ap___3) - a_x) * l_Ua___3) / (l_ap___3 * ((1.0 + l_ap___3) - a_b___0))
								l_Uam1___3 := l_Ua___3
								l_Ua___3 := l_Uap1___3
								from
								until
									js.loop_done
								loop
									l_au0___4 := (fabs (l_Ua___3))
									if l_au0___4 > l_scale_factor___2 then
										l_Ua___3 := l_Ua___3 / l_scale_factor___2
										l_Uam1___3 := l_Uam1___3 / l_scale_factor___2
										l_scale_count_for := l_scale_count_for + 1
									elseif l_au0___4 < 1.0 / l_scale_factor___2 then
										l_Ua___3 := l_Ua___3 * l_scale_factor___2
										l_Uam1___3 := l_Uam1___3 * l_scale_factor___2
										l_scale_count_for := l_scale_count_for - 1
									end
									js.break
								end
								l_ap___3 := l_ap___3 + (1.0)
							end
							l_Ua1_for := l_Ua___3
							if l_stat_0___1 /= 0 then
								l_stat_for := l_stat_0___1
							else
								if l_stat_1___1 /= 0 then
									l_tmp___93 := l_stat_1___1
								else
									l_tmp___93 := 0
								end
								l_stat_for := l_tmp___93
							end
							l_lnscale___3 := log (l_scale_factor___2)
							l_lnm___3.val := l_lm_for + (l_scale_count_for - l_scale_count_bck).to_double * l_lnscale___3
							l_tmp___94 := fabs (l_lm_for)
							l_tmp___95 := fabs ((l_scale_count_for - l_scale_count_bck).to_double)
							l_lnm___3.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___94 + l_tmp___95 * (fabs (l_lnscale___3)))
							l_y___3.val := (1.4916681462400413e-154 * l_Ua1_for) / l_Ua1_bck
							l_tmp___97 := fabs (a_a___5 - l_a0___5)
							l_y___3.err := ((2.0 * 2.2204460492503131e-16) * ((l_tmp___97 + (l_CF1_count___0.item).to_double) + 1.0)) * (fabs (l_y___3.val))
							l_stat_e___5 := exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm___3.val, l_lnm___3.err, l_y___3.val, l_y___3.err, a_result)
							if l_stat_e___5 /= 0 then
								l_tmp___101 := l_stat_e___5
							else
								if l_stat_bck /= 0 then
									l_tmp___100 := l_stat_bck
								else
									if l_stat_for /= 0 then
										l_tmp___99 := l_stat_for
									else
										l_tmp___99 := 0
									end
									l_tmp___100 := l_tmp___99
								end
								l_tmp___101 := l_tmp___100
							end
							Result := l_tmp___101
						end
				when 25 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_U_finite_sum (a_N: INTEGER_32; a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_xeps: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_i: INTEGER_32
			l_sum_val: REAL_64
			l_sum_err: REAL_64
			l_t_val: REAL_64
			l_t_err: REAL_64
			l_poch: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_poch: INTEGER_32
			l_xi1: REAL_64
			l_mult: REAL_64
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_M: INTEGER_32
			l_gbm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamr: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_gbm1: INTEGER_32
			l_stat_gamr: INTEGER_32
			l_t_val___0: REAL_64
			l_t_err___0: REAL_64
			l_mult___0: REAL_64
			l_tmp___7: REAL_64
			l_powx1N: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_p: INTEGER_32
			l_pe_val: REAL_64
			l_pe_err: REAL_64
			l_tmp___10: REAL_64
			l_coeff_val: REAL_64
			l_coeff_err: REAL_64
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_tmp___14: REAL_64
			l_tmp___16: REAL_64
		do
			create l_poch.make (<<1>>)
			create l_gbm1.make (<<1>>)
			create l_gamr.make (<<1>>)
			create l_powx1N.make (<<1>>)

			if a_N <= 0 then
				l_t_val := 1.0
				l_t_err := 0.0
				l_sum_val := 1.0
				l_sum_err := 0.0
				l_i := 1
				from
				until
					not (l_i <= -a_N)
				loop
					l_xi1 := (l_i - 1).to_double
					l_mult := ((a_a___5 + l_xi1) * a_x) / ((a_b___0 + l_xi1) * (l_xi1 + 1.0))
					l_t_val := l_t_val * l_mult
					l_tmp := fabs (l_mult)
					l_t_err := l_t_err + (l_tmp * l_t_err + (((fabs (l_t_val)) * 8.0) * 2.0) * 2.2204460492503131e-16)
					l_sum_val := l_sum_val + l_t_val
					l_sum_err := l_sum_err + l_t_err
					l_i := l_i + 1
				end
				l_stat_poch := poch_inst.gsl_sf_poch_e ((1.0 + a_a___5) - a_b___0, -a_a___5, l_poch)
				a_result.item.val := l_sum_val * l_poch.item.val
				l_tmp___1 := fabs (l_sum_val)
				a_result.item.err := l_tmp___1 * l_poch.item.err + l_sum_err * (fabs (l_poch.item.val))
				l_tmp___3 := fabs (l_poch.item.val)
				l_tmp___4 := fabs (a_N.to_double)
				a_result.item.err := a_result.item.err + (((l_tmp___3 * (l_tmp___4 + 2.0)) * 2.2204460492503131e-16) * (fabs (l_sum_val)))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				a_result.item.err := a_result.item.err * (2.0)
				Result := l_stat_poch
			else
				l_M := a_N - 2
				if l_M < 0 then
					a_result.item.val := 0.0
					a_result.item.err := 0.0
					Result := 0
				else
					l_t_val___0 := 1.0
					l_t_err___0 := 0.0
					l_sum_val := 1.0
					l_sum_err := 0.0
					l_i := 1
					from
					until
						not (l_i <= l_M)
					loop
						l_mult___0 := (((a_a___5 - a_b___0) + l_i.to_double) * a_x) / (((1.0 - a_b___0) + l_i.to_double) * l_i.to_double)
						l_t_val___0 := l_t_val___0 * l_mult___0
						l_tmp___7 := fabs (l_mult___0)
						l_t_err___0 := l_t_err___0 + (l_t_err___0 * l_tmp___7 + (((fabs (l_t_val___0)) * 8.0) * 2.0) * 2.2204460492503131e-16)
						l_sum_val := l_sum_val + l_t_val___0
						l_sum_err := l_sum_err + l_t_err___0
						l_i := l_i + 1
					end
					l_stat_gbm1 := gamma_inst.gsl_sf_gamma_e (a_b___0 - 1.0, l_gbm1)
					l_stat_gamr := gamma_inst.gsl_sf_gammainv_e (a_a___5, l_gamr)
					if l_stat_gbm1 = 0 then
						l_stat_p := (pow_int_inst.gsl_sf_pow_int_e (a_x, 1 - a_N, l_powx1N))
						l_pe_val := l_powx1N.item.val * a_xeps
						l_tmp___10 := fabs (a_xeps)
						l_pe_err := l_powx1N.item.err * l_tmp___10 + (2.0 * 2.2204460492503131e-16) * (fabs (l_pe_val))
						l_coeff_val := (l_gbm1.item.val * l_gamr.item.val) * l_pe_val
						l_tmp___12 := fabs (l_gamr.item.val * l_pe_val)
						l_tmp___13 := fabs (l_gbm1.item.val * l_pe_val)
						l_tmp___14 := fabs (l_gbm1.item.val * l_gamr.item.val)
						l_coeff_err := ((l_gbm1.item.err * l_tmp___12 + l_gamr.item.err * l_tmp___13) + l_tmp___14 * l_pe_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_coeff_val))
						a_result.item.val := l_sum_val * l_coeff_val
						l_tmp___16 := fabs (l_sum_val)
						a_result.item.err := l_tmp___16 * l_coeff_err + l_sum_err * (fabs (l_coeff_val))
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_M.to_double + 2.0)) * (fabs (a_result.item.val)))
						a_result.item.err := a_result.item.err * (2.0)
						Result := l_stat_p
					else
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := l_stat_gbm1
					end
				end
			end
		end

	hyperg_U_infinite_sum_improved (a_N: INTEGER_32; a_a___5: REAL_64; a_bint: REAL_64; a_b___0: REAL_64; a_beps: REAL_64; a_x: REAL_64; a_xeps: REAL_64; a_sum: PD_GSL_SF_RESULT_STRUCT; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_EPS: REAL_64
			l_lnx: REAL_64
			l_istrt: INTEGER_32
			l_tmp___0: INTEGER_32
			l_xi: REAL_64
			l_gamr: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_powx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_gamr: INTEGER_32
			l_stat_powx: INTEGER_32
			l_sarg: REAL_64
			l_sfact: REAL_64
			l_tmp___4: REAL_64
			l_factor_val: REAL_64
			l_tmp___5: REAL_64
			l_factor_err: REAL_64
			l_tmp___6: REAL_64
			l_tmp___7: REAL_64
			l_pochai: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamri1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamrni: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pochai: INTEGER_32
			l_stat_gamri1: INTEGER_32
			l_stat_gamrni: INTEGER_32
			l_stat_gam123: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_stat_gamall: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_pochaxibeps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamrxi1beps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pochaxibeps: INTEGER_32
			l_stat_gamrxi1beps: INTEGER_32
			l_stat_all: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_b0_val: REAL_64
			l_b0_err: REAL_64
			l_tmp___23: REAL_64
			l_tmp___24: REAL_64
			l_tmp___25: REAL_64
			l_tmp___26: REAL_64
			l_i: INTEGER_32
			l_pch1ai: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_pch1i: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_poch1bxibeps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pch1ai: INTEGER_32
			l_stat_pch1i: INTEGER_32
			l_stat_poch1bxibeps: INTEGER_32
			l_c0_t1_val: REAL_64
			l_c0_t1_err: REAL_64
			l_tmp___31: REAL_64
			l_tmp___32: REAL_64
			l_tmp___33: REAL_64
			l_tmp___34: REAL_64
			l_c0_t2_val: REAL_64
			l_c0_t2_err: REAL_64
			l_c0_val: REAL_64
			l_c0_err: REAL_64
			l_tmp___37: REAL_64
			l_tmp___38: REAL_64
			l_tmp___39: REAL_64
			l_tmp___40: REAL_64
			l_tmp___41: REAL_64
			l_dexprl: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_dexprl: INTEGER_32
			l_xeps1_val: REAL_64
			l_xeps1_err: REAL_64
			l_tmp___44: REAL_64
			l_tmp___45: REAL_64
			l_tmp___46: REAL_64
			l_dchu_val: REAL_64
			l_dchu_err: REAL_64
			l_tmp___48: REAL_64
			l_tmp___49: REAL_64
			l_tmp___50: REAL_64
			l_tmp___51: REAL_64
			l_tmp___52: REAL_64
			l_xn: REAL_64
			l_t_val: REAL_64
			l_t_err: REAL_64
			l_tmp___54: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___56: INTEGER_32
			l_tmp___57: INTEGER_32
			l_xi___0: REAL_64
			l_xi1: REAL_64
			l_tmp___58: REAL_64
			l_b0_multiplier: REAL_64
			l_c0_multiplier_1: REAL_64
			l_c0_multiplier_2: REAL_64
			l_tmp___59: REAL_64
			l_tmp___61: REAL_64
			l_tmp___62: REAL_64
			l_tmp___63: REAL_64
			l_tmp___68: REAL_64
			js: JUMP_STATE
		do
			create l_gamr.make (<<1>>)
			create l_powx.make (<<1>>)
			create l_pochai.make (<<1>>)
			create l_gamri1.make (<<1>>)
			create l_gamrni.make (<<1>>)
			create l_pochaxibeps.make (<<1>>)
			create l_gamrxi1beps.make (<<1>>)
			create l_pch1ai.make (<<1>>)
			create l_pch1i.make (<<1>>)
			create l_poch1bxibeps.make (<<1>>)
			create l_dexprl.make (<<1>>)

			l_EPS := 2.0 * 2.2204460492503131e-16
			l_lnx := (log (a_x))
			if a_N < 1 then
				l_tmp___0 := 1 - a_N
			else
				l_tmp___0 := 0
			end
			l_istrt := l_tmp___0
			l_xi := l_istrt.to_double
			l_stat_gamr := (gamma_inst.gsl_sf_gammainv_e ((1.0 + a_a___5) - a_b___0, l_gamr))
			l_stat_powx := (pow_int_inst.gsl_sf_pow_int_e (a_x, l_istrt, l_powx))
			l_sarg := a_beps * 3.14159265358979323846
			if l_sarg /= 0.0 then
				l_tmp___4 := l_sarg / (sin (l_sarg))
			else
				l_tmp___4 := 1.0
			end
			l_sfact := l_tmp___4
			if ((a_N).bit_and (1)).to_boolean then
				l_tmp___5 := -1.0
			else
				l_tmp___5 := 1.0
			end
			l_factor_val := ((l_sfact * l_tmp___5) * l_gamr.item.val) * l_powx.item.val
			l_tmp___6 := fabs (l_gamr.item.val)
			l_tmp___7 := fabs (l_powx.item.val)
			l_factor_err := (l_tmp___6 * l_powx.item.err + l_tmp___7 * l_gamr.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_factor_val))
			l_stat_pochai := (poch_inst.gsl_sf_poch_e (a_a___5, l_xi, l_pochai))
			l_stat_gamri1 := (gamma_inst.gsl_sf_gammainv_e (l_xi + 1.0, l_gamri1))
			l_stat_gamrni := (gamma_inst.gsl_sf_gammainv_e (a_bint + l_xi, l_gamrni))
			if l_stat_gamr /= 0 then
				l_tmp___14 := l_stat_gamr
			else
				if l_stat_gamri1 /= 0 then
					l_tmp___13 := l_stat_gamri1
				else
					if l_stat_gamrni /= 0 then
						l_tmp___12 := l_stat_gamrni
					else
						l_tmp___12 := 0
					end
					l_tmp___13 := l_tmp___12
				end
				l_tmp___14 := l_tmp___13
			end
			l_stat_gam123 := l_tmp___14
			if l_stat_gam123 /= 0 then
				l_tmp___17 := l_stat_gam123
			else
				if l_stat_pochai /= 0 then
					l_tmp___16 := l_stat_pochai
				else
					if l_stat_powx /= 0 then
						l_tmp___15 := l_stat_powx
					else
						l_tmp___15 := 0
					end
					l_tmp___16 := l_tmp___15
				end
				l_tmp___17 := l_tmp___16
			end
			l_stat_gamall := l_tmp___17
			l_stat_pochaxibeps := (poch_inst.gsl_sf_poch_e (a_a___5, l_xi - a_beps, l_pochaxibeps))
			l_stat_gamrxi1beps := (gamma_inst.gsl_sf_gammainv_e ((l_xi + 1.0) - a_beps, l_gamrxi1beps))
			if l_stat_gamall /= 0 then
				l_tmp___22 := l_stat_gamall
			else
				if l_stat_pochaxibeps /= 0 then
					l_tmp___21 := l_stat_pochaxibeps
				else
					if l_stat_gamrxi1beps /= 0 then
						l_tmp___20 := l_stat_gamrxi1beps
					else
						l_tmp___20 := 0
					end
					l_tmp___21 := l_tmp___20
				end
				l_tmp___22 := l_tmp___21
			end
			l_stat_all := l_tmp___22
			l_b0_val := ((l_factor_val * l_pochaxibeps.item.val) * l_gamrni.item.val) * l_gamrxi1beps.item.val
			l_tmp___23 := fabs ((l_factor_val * l_pochaxibeps.item.val) * l_gamrni.item.val)
			l_tmp___24 := fabs ((l_factor_val * l_pochaxibeps.item.val) * l_gamrxi1beps.item.val)
			l_tmp___25 := fabs ((l_factor_val * l_gamrni.item.val) * l_gamrxi1beps.item.val)
			l_tmp___26 := fabs ((l_pochaxibeps.item.val * l_gamrni.item.val) * l_gamrxi1beps.item.val)
			l_b0_err := (((l_tmp___23 * l_gamrxi1beps.item.err + l_tmp___24 * l_gamrni.item.err) + l_tmp___25 * l_pochaxibeps.item.err) + l_tmp___26 * l_factor_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_b0_val))
			l_stat_pch1ai := (poch_inst.gsl_sf_pochrel_e (a_a___5 + l_xi, -a_beps, l_pch1ai))
			l_stat_pch1i := (poch_inst.gsl_sf_pochrel_e ((l_xi + 1.0) - a_beps, a_beps, l_pch1i))
			l_stat_poch1bxibeps := (poch_inst.gsl_sf_pochrel_e (a_b___0 + l_xi, -a_beps, l_poch1bxibeps))
			l_c0_t1_val := (a_beps * l_pch1ai.item.val) * l_pch1i.item.val
			l_tmp___31 := fabs (a_beps)
			l_tmp___32 := fabs (l_pch1ai.item.val)
			l_tmp___33 := fabs (a_beps)
			l_tmp___34 := fabs (l_pch1i.item.val)
			l_c0_t1_err := ((l_tmp___31 * l_tmp___32) * l_pch1i.item.err + (l_tmp___33 * l_tmp___34) * l_pch1ai.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_c0_t1_val))
			l_c0_t2_val := ((-l_poch1bxibeps.item.val + l_pch1ai.item.val) - l_pch1i.item.val) + l_c0_t1_val
			l_c0_t2_err := (((l_poch1bxibeps.item.err + l_pch1ai.item.err) + l_pch1i.item.err) + l_c0_t1_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_c0_t2_val))
			l_c0_val := (((l_factor_val * l_pochai.item.val) * l_gamrni.item.val) * l_gamri1.item.val) * l_c0_t2_val
			l_tmp___37 := fabs (((l_factor_val * l_pochai.item.val) * l_gamrni.item.val) * l_gamri1.item.val)
			l_tmp___38 := fabs (((l_factor_val * l_pochai.item.val) * l_gamrni.item.val) * l_c0_t2_val)
			l_tmp___39 := fabs (((l_factor_val * l_pochai.item.val) * l_gamri1.item.val) * l_c0_t2_val)
			l_tmp___40 := fabs (((l_factor_val * l_gamrni.item.val) * l_gamri1.item.val) * l_c0_t2_val)
			l_tmp___41 := fabs (((l_pochai.item.val * l_gamrni.item.val) * l_gamri1.item.val) * l_c0_t2_val)
			l_c0_err := ((((l_tmp___37 * l_c0_t2_err + l_tmp___38 * l_gamri1.item.err) + l_tmp___39 * l_gamrni.item.err) + l_tmp___40 * l_pochai.item.err) + l_tmp___41 * l_factor_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_c0_val))
			l_stat_dexprl := (exp_inst.gsl_sf_exprel_e (-a_beps * l_lnx, l_dexprl))
			l_xeps1_val := l_lnx * l_dexprl.item.val
			l_tmp___44 := fabs (a_beps * l_lnx)
			l_tmp___45 := fabs (l_dexprl.item.val)
			l_tmp___46 := fabs (l_lnx)
			l_xeps1_err := (((2.0 * 2.2204460492503131e-16) * (1.0 + l_tmp___44)) * l_tmp___45 + l_tmp___46 * l_dexprl.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_xeps1_val))
			l_dchu_val := (a_sum.val + l_c0_val) + l_xeps1_val * l_b0_val
			l_tmp___48 := fabs (l_xeps1_val)
			l_tmp___49 := fabs (l_b0_val)
			l_tmp___50 := fabs (l_b0_val * l_lnx)
			l_tmp___51 := fabs (a_sum.val)
			l_tmp___52 := fabs (l_c0_val)
			l_dchu_err := ((((a_sum.err + l_c0_err) + l_tmp___48 * l_b0_err) + l_xeps1_err * l_tmp___49) + l_tmp___50 * l_dexprl.item.err) + (2.0 * 2.2204460492503131e-16) * ((l_tmp___51 + l_tmp___52) + (fabs (l_xeps1_val * l_b0_val)))
			l_xn := a_N.to_double
			if l_stat_all /= 0 then
				l_stat_all := l_stat_all
			else
				if l_stat_dexprl /= 0 then
					l_tmp___57 := l_stat_dexprl
				else
					if l_stat_poch1bxibeps /= 0 then
						l_tmp___56 := l_stat_poch1bxibeps
					else
						if l_stat_pch1i /= 0 then
							l_tmp___55 := l_stat_pch1i
						else
							if l_stat_pch1ai /= 0 then
								l_tmp___54 := l_stat_pch1ai
							else
								l_tmp___54 := 0
							end
							l_tmp___55 := l_tmp___54
						end
						l_tmp___56 := l_tmp___55
					end
					l_tmp___57 := l_tmp___56
				end
				l_stat_all := l_tmp___57
			end
			l_i := 1
			from
			until
				not (not js.loop_done and then (l_i < 2_000))
			loop
				l_xi___0 := (l_istrt + l_i).to_double
				l_xi1 := ((l_istrt + l_i) - 1).to_double
				l_tmp___58 := (a_a___5 - 1.0) * ((l_xn + 2.0 * l_xi___0) - 1.0) + l_xi___0 * (l_xi___0 - a_beps)
				l_b0_multiplier := (((a_a___5 + l_xi1) - a_beps) * a_x) / ((l_xn + l_xi1) * (l_xi___0 - a_beps))
				l_c0_multiplier_1 := ((a_a___5 + l_xi1) * a_x) / ((a_b___0 + l_xi1) * l_xi___0)
				l_c0_multiplier_2 := l_tmp___58 / ((l_xi___0 * (a_b___0 + l_xi1)) * ((a_a___5 + l_xi1) - a_beps))
				l_b0_val := l_b0_val * l_b0_multiplier
				l_tmp___59 := fabs (l_b0_multiplier)
				l_b0_err := l_b0_err + (l_tmp___59 * l_b0_err + (((fabs (l_b0_val)) * 8.0) * 2.0) * 2.2204460492503131e-16)
				l_c0_val := l_c0_multiplier_1 * l_c0_val - l_c0_multiplier_2 * l_b0_val
				l_tmp___61 := fabs (l_c0_multiplier_1)
				l_tmp___62 := fabs (l_c0_multiplier_2)
				l_tmp___63 := fabs (l_c0_val)
				l_c0_err := ((l_tmp___61 * l_c0_err + l_tmp___62 * l_b0_err) + ((l_tmp___63 * 8.0) * 2.0) * 2.2204460492503131e-16) + (((fabs (l_b0_val * l_c0_multiplier_2)) * 16.0) * 2.0) * 2.2204460492503131e-16
				l_t_val := l_c0_val + l_xeps1_val * l_b0_val
				l_t_err := l_c0_err + (fabs (l_xeps1_val)) * l_b0_err
				l_t_err := l_t_err + ((fabs (l_b0_val * l_lnx)) * l_dexprl.item.err)
				l_t_err := l_t_err + ((fabs (l_b0_val)) * l_xeps1_err)
				l_dchu_val := l_dchu_val + l_t_val
				l_dchu_err := l_dchu_err + l_t_err
				l_tmp___68 := fabs (l_t_val)
				if l_tmp___68 < l_EPS * (fabs (l_dchu_val)) then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			a_result.item.val := l_dchu_val
			a_result.item.err := 2.0 * l_dchu_err
			a_result.item.err := a_result.item.err + (2.0 * (fabs (l_t_val)))
			a_result.item.err := a_result.item.err + (((4.0 * 2.2204460492503131e-16) * (l_i.to_double + 2.0)) * (fabs (l_dchu_val)))
			a_result.item.err := a_result.item.err * (2.0)
			if l_i >= 2_000 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 664, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := l_stat_all
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	hyperg_U_infinite_sum_simple (a_N: INTEGER_32; a_a___5: REAL_64; a_bint: REAL_64; a_b___0: REAL_64; a_beps: REAL_64; a_x: REAL_64; a_xeps: REAL_64; a_sum: PD_GSL_SF_RESULT_STRUCT; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_EPS: REAL_64
			l_istrt: INTEGER_32
			l_tmp: INTEGER_32
			l_xi: REAL_64
			l_powx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_powx: INTEGER_32
			l_sarg: REAL_64
			l_sfact: REAL_64
			l_tmp___2: REAL_64
			l_factor_val: REAL_64
			l_tmp___3: REAL_64
			l_factor_err: REAL_64
			l_tmp___4: REAL_64
			l_pochai: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamri1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamrni: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pochai: INTEGER_32
			l_stat_gamri1: INTEGER_32
			l_stat_gamrni: INTEGER_32
			l_stat_gam123: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_stat_gamall: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_pochaxibeps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamrxi1beps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pochaxibeps: INTEGER_32
			l_stat_gamrxi1beps: INTEGER_32
			l_stat_all: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_X: REAL_64
			l_tmp___19: REAL_64
			l_tmp___20: REAL_64
			l_b0_val: REAL_64
			l_b0_err: REAL_64
			l_tmp___22: REAL_64
			l_tmp___23: REAL_64
			l_tmp___24: REAL_64
			l_tmp___25: REAL_64
			l_i: INTEGER_32
			l_dchu_val: REAL_64
			l_dchu_err: REAL_64
			l_t_val: REAL_64
			l_t_err: REAL_64
			l_gamr: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_dgamrbxi: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_gamr: INTEGER_32
			l_stat_dgamrbxi: INTEGER_32
			l_a0_val: REAL_64
			l_a0_err: REAL_64
			l_tmp___29: REAL_64
			l_tmp___30: REAL_64
			l_tmp___31: REAL_64
			l_tmp___32: REAL_64
			l_tmp___33: REAL_64
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___37: REAL_64
			l_tmp___39: REAL_64
			l_tmp___40: REAL_64
			l_xi___0: REAL_64
			l_xi1: REAL_64
			l_a0_multiplier: REAL_64
			l_b0_multiplier: REAL_64
			l_tmp___45: REAL_64
			js: JUMP_STATE
		do
			create l_powx.make (<<1>>)
			create l_pochai.make (<<1>>)
			create l_gamri1.make (<<1>>)
			create l_gamrni.make (<<1>>)
			create l_pochaxibeps.make (<<1>>)
			create l_gamrxi1beps.make (<<1>>)
			create l_gamr.make (<<1>>)
			create l_dgamrbxi.make (<<1>>)

			l_EPS := 2.0 * 2.2204460492503131e-16
			if a_N < 1 then
				l_tmp := 1 - a_N
			else
				l_tmp := 0
			end
			l_istrt := l_tmp
			l_xi := l_istrt.to_double
			l_stat_powx := (pow_int_inst.gsl_sf_pow_int_e (a_x, l_istrt, l_powx))
			l_sarg := a_beps * 3.14159265358979323846
			if l_sarg /= 0.0 then
				l_tmp___2 := l_sarg / (sin (l_sarg))
			else
				l_tmp___2 := 1.0
			end
			l_sfact := l_tmp___2
			if ((a_N).bit_and (1)).to_boolean then
				l_tmp___3 := -1.0
			else
				l_tmp___3 := 1.0
			end
			l_factor_val := (l_sfact * l_tmp___3) * l_powx.item.val
			l_tmp___4 := fabs (l_powx.item.err)
			l_factor_err := l_tmp___4 + (2.0 * 2.2204460492503131e-16) * (fabs (l_factor_val))
			l_stat_pochai := (poch_inst.gsl_sf_poch_e (a_a___5, l_xi, l_pochai))
			l_stat_gamri1 := (gamma_inst.gsl_sf_gammainv_e (l_xi + 1.0, l_gamri1))
			l_stat_gamrni := (gamma_inst.gsl_sf_gammainv_e (a_bint + l_xi, l_gamrni))
			if l_stat_gamri1 /= 0 then
				l_tmp___10 := l_stat_gamri1
			else
				if l_stat_gamrni /= 0 then
					l_tmp___9 := l_stat_gamrni
				else
					l_tmp___9 := 0
				end
				l_tmp___10 := l_tmp___9
			end
			l_stat_gam123 := l_tmp___10
			if l_stat_gam123 /= 0 then
				l_tmp___13 := l_stat_gam123
			else
				if l_stat_pochai /= 0 then
					l_tmp___12 := l_stat_pochai
				else
					if l_stat_powx /= 0 then
						l_tmp___11 := l_stat_powx
					else
						l_tmp___11 := 0
					end
					l_tmp___12 := l_tmp___11
				end
				l_tmp___13 := l_tmp___12
			end
			l_stat_gamall := l_tmp___13
			l_stat_pochaxibeps := (poch_inst.gsl_sf_poch_e (a_a___5, l_xi - a_beps, l_pochaxibeps))
			l_stat_gamrxi1beps := (gamma_inst.gsl_sf_gammainv_e ((l_xi + 1.0) - a_beps, l_gamrxi1beps))
			if l_stat_gamall /= 0 then
				l_tmp___18 := l_stat_gamall
			else
				if l_stat_pochaxibeps /= 0 then
					l_tmp___17 := l_stat_pochaxibeps
				else
					if l_stat_gamrxi1beps /= 0 then
						l_tmp___16 := l_stat_gamrxi1beps
					else
						l_tmp___16 := 0
					end
					l_tmp___17 := l_tmp___16
				end
				l_tmp___18 := l_tmp___17
			end
			l_stat_all := l_tmp___18
			if ((a_N).bit_and (1)).to_boolean then
				l_tmp___19 := -1.0
			else
				l_tmp___19 := 1.0
			end
			l_tmp___20 := poch_inst.gsl_sf_poch (((1).to_double + a_a___5) - a_b___0, ((l_xi - (1).to_double) + a_b___0) - a_beps)
			l_X := (((l_sfact * l_tmp___19) * l_powx.item.val) * l_tmp___20) * (gamma_inst.gsl_sf_gammainv (a_a___5))
			l_b0_val := (l_X * l_gamrni.item.val) * l_gamrxi1beps.item.val
			l_tmp___22 := fabs ((l_factor_val * l_pochaxibeps.item.val) * l_gamrni.item.val)
			l_tmp___23 := fabs ((l_factor_val * l_pochaxibeps.item.val) * l_gamrxi1beps.item.val)
			l_tmp___24 := fabs ((l_factor_val * l_gamrni.item.val) * l_gamrxi1beps.item.val)
			l_tmp___25 := fabs ((l_pochaxibeps.item.val * l_gamrni.item.val) * l_gamrxi1beps.item.val)
			l_b0_err := (((l_tmp___22 * l_gamrxi1beps.item.err + l_tmp___23 * l_gamrni.item.err) + l_tmp___24 * l_pochaxibeps.item.err) + l_tmp___25 * l_factor_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_b0_val))
			l_stat_gamr := (gamma_inst.gsl_sf_gammainv_e ((1.0 + a_a___5) - a_b___0, l_gamr))
			l_stat_dgamrbxi := (gamma_inst.gsl_sf_gammainv_e (a_b___0 + l_xi, l_dgamrbxi))
			l_a0_val := ((((l_factor_val * l_gamr.item.val) * l_pochai.item.val) * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps
			l_tmp___29 := fabs ((((l_factor_val * l_pochai.item.val) * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps)
			l_tmp___30 := fabs ((((l_factor_val * l_gamr.item.val) * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps)
			l_tmp___31 := fabs ((((l_factor_val * l_gamr.item.val) * l_pochai.item.val) * l_gamri1.item.val) / a_beps)
			l_tmp___32 := fabs ((((l_factor_val * l_gamr.item.val) * l_pochai.item.val) * l_dgamrbxi.item.val) / a_beps)
			l_tmp___33 := fabs ((((l_pochai.item.val * l_gamr.item.val) * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps)
			l_a0_err := ((((l_tmp___29 * l_gamr.item.err + l_tmp___30 * l_pochai.item.err) + l_tmp___31 * l_dgamrbxi.item.err) + l_tmp___32 * l_gamri1.item.err) + l_tmp___33 * l_factor_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_a0_val))
			if l_stat_all /= 0 then
				l_stat_all := l_stat_all
			else
				if l_stat_gamr /= 0 then
					l_tmp___36 := l_stat_gamr
				else
					if l_stat_dgamrbxi /= 0 then
						l_tmp___35 := l_stat_dgamrbxi
					else
						l_tmp___35 := 0
					end
					l_tmp___36 := l_tmp___35
				end
				l_stat_all := l_tmp___36
			end
			l_b0_val := (a_xeps * l_b0_val) / a_beps
			l_tmp___37 := fabs (a_xeps / a_beps)
			l_b0_err := l_tmp___37 * l_b0_err + (4.0 * 2.2204460492503131e-16) * (fabs (l_b0_val))
			l_dchu_val := (a_sum.val + l_a0_val) - l_b0_val
			l_tmp___39 := fabs (a_sum.val)
			l_tmp___40 := fabs (l_a0_val)
			l_dchu_err := ((a_sum.err + l_a0_err) + l_b0_err) + (2.0 * 2.2204460492503131e-16) * ((l_tmp___39 + l_tmp___40) + (fabs (l_b0_val)))
			l_i := 1
			from
			until
				not (not js.loop_done and then (l_i < 2_000))
			loop
				l_xi___0 := (l_istrt + l_i).to_double
				l_xi1 := ((l_istrt + l_i) - 1).to_double
				l_a0_multiplier := ((a_a___5 + l_xi1) * a_x) / ((a_b___0 + l_xi1) * l_xi___0)
				l_b0_multiplier := (((a_a___5 + l_xi1) - a_beps) * a_x) / ((a_bint + l_xi1) * (l_xi___0 - a_beps))
				l_a0_val := l_a0_val * l_a0_multiplier
				l_a0_err := l_a0_err + ((fabs (l_a0_multiplier)) * l_a0_err)
				l_b0_val := l_b0_val * l_b0_multiplier
				l_b0_err := l_b0_err + ((fabs (l_b0_multiplier)) * l_b0_err)
				l_t_val := l_a0_val - l_b0_val
				l_t_err := l_a0_err + l_b0_err
				l_dchu_val := l_dchu_val + l_t_val
				l_dchu_err := l_dchu_err + l_t_err
				if (finite (l_t_val)).to_boolean then
					l_tmp___45 := fabs (l_t_val)
					if l_tmp___45 < l_EPS * (fabs (l_dchu_val)) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			a_result.item.val := l_dchu_val
			a_result.item.err := 2.0 * l_dchu_err
			a_result.item.err := a_result.item.err + (2.0 * (fabs (l_t_val)))
			a_result.item.err := a_result.item.err + (((4.0 * 2.2204460492503131e-16) * (l_i.to_double + 2.0)) * (fabs (l_dchu_val)))
			a_result.item.err := a_result.item.err * (2.0)
			if l_i >= 2_000 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 537, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := l_stat_all
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	hyperg_U_infinite_sum_stable (a_N: INTEGER_32; a_a___5: REAL_64; a_bint: REAL_64; a_b___0: REAL_64; a_beps: REAL_64; a_x: REAL_64; a_xeps: REAL_64; a_sum: PD_GSL_SF_RESULT_STRUCT; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_EPS: REAL_64
			l_istrt: INTEGER_32
			l_tmp: INTEGER_32
			l_xi: REAL_64
			l_gamr: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_powx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_gamr: INTEGER_32
			l_stat_powx: INTEGER_32
			l_sarg: REAL_64
			l_sfact: REAL_64
			l_tmp___3: REAL_64
			l_factor_val: REAL_64
			l_tmp___4: REAL_64
			l_factor_err: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_pochai: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamri1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamrni: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pochai: INTEGER_32
			l_stat_gamri1: INTEGER_32
			l_stat_gamrni: INTEGER_32
			l_stat_gam123: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_stat_gamall: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_pochaxibeps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gamrxi1beps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pochaxibeps: INTEGER_32
			l_stat_gamrxi1beps: INTEGER_32
			l_stat_all: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_b0_val: REAL_64
			l_b0_err: REAL_64
			l_tmp___22: REAL_64
			l_tmp___23: REAL_64
			l_tmp___24: REAL_64
			l_tmp___25: REAL_64
			l_i: INTEGER_32
			l_dchu_val: REAL_64
			l_dchu_err: REAL_64
			l_t_val: REAL_64
			l_t_err: REAL_64
			l_dgamrbxi: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_dgamrbxi: INTEGER_32
			l_a0_val: REAL_64
			l_a0_err: REAL_64
			l_tmp___28: REAL_64
			l_tmp___29: REAL_64
			l_tmp___30: REAL_64
			l_tmp___31: REAL_64
			l_tmp___33: INTEGER_32
			l_tmp___34: REAL_64
			l_tmp___36: REAL_64
			l_tmp___37: REAL_64
			l_xi___0: REAL_64
			l_xi1: REAL_64
			l_a0_multiplier: REAL_64
			l_b0_multiplier: REAL_64
			l_tmp___41: REAL_64
			js: JUMP_STATE
		do
			create l_gamr.make (<<1>>)
			create l_powx.make (<<1>>)
			create l_pochai.make (<<1>>)
			create l_gamri1.make (<<1>>)
			create l_gamrni.make (<<1>>)
			create l_pochaxibeps.make (<<1>>)
			create l_gamrxi1beps.make (<<1>>)
			create l_dgamrbxi.make (<<1>>)

			l_EPS := 2.0 * 2.2204460492503131e-16
			if a_N < 1 then
				l_tmp := 1 - a_N
			else
				l_tmp := 0
			end
			l_istrt := l_tmp
			l_xi := l_istrt.to_double
			l_stat_gamr := (gamma_inst.gsl_sf_gammainv_e ((1.0 + a_a___5) - a_b___0, l_gamr))
			l_stat_powx := (pow_int_inst.gsl_sf_pow_int_e (a_x, l_istrt, l_powx))
			l_sarg := a_beps * 3.14159265358979323846
			if l_sarg /= 0.0 then
				l_tmp___3 := l_sarg / (sin (l_sarg))
			else
				l_tmp___3 := 1.0
			end
			l_sfact := l_tmp___3
			if ((a_N).bit_and (1)).to_boolean then
				l_tmp___4 := -1.0
			else
				l_tmp___4 := 1.0
			end
			l_factor_val := ((l_sfact * l_tmp___4) * l_gamr.item.val) * l_powx.item.val
			l_tmp___5 := fabs (l_gamr.item.val)
			l_tmp___6 := fabs (l_powx.item.val)
			l_factor_err := (l_tmp___5 * l_powx.item.err + l_tmp___6 * l_gamr.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_factor_val))
			l_stat_pochai := (poch_inst.gsl_sf_poch_e (a_a___5, l_xi, l_pochai))
			l_stat_gamri1 := (gamma_inst.gsl_sf_gammainv_e (l_xi + 1.0, l_gamri1))
			l_stat_gamrni := (gamma_inst.gsl_sf_gammainv_e (a_bint + l_xi, l_gamrni))
			if l_stat_gamr /= 0 then
				l_tmp___13 := l_stat_gamr
			else
				if l_stat_gamri1 /= 0 then
					l_tmp___12 := l_stat_gamri1
				else
					if l_stat_gamrni /= 0 then
						l_tmp___11 := l_stat_gamrni
					else
						l_tmp___11 := 0
					end
					l_tmp___12 := l_tmp___11
				end
				l_tmp___13 := l_tmp___12
			end
			l_stat_gam123 := l_tmp___13
			if l_stat_gam123 /= 0 then
				l_tmp___16 := l_stat_gam123
			else
				if l_stat_pochai /= 0 then
					l_tmp___15 := l_stat_pochai
				else
					if l_stat_powx /= 0 then
						l_tmp___14 := l_stat_powx
					else
						l_tmp___14 := 0
					end
					l_tmp___15 := l_tmp___14
				end
				l_tmp___16 := l_tmp___15
			end
			l_stat_gamall := l_tmp___16
			l_stat_pochaxibeps := (poch_inst.gsl_sf_poch_e (a_a___5, l_xi - a_beps, l_pochaxibeps))
			l_stat_gamrxi1beps := (gamma_inst.gsl_sf_gammainv_e ((l_xi + 1.0) - a_beps, l_gamrxi1beps))
			if l_stat_gamall /= 0 then
				l_tmp___21 := l_stat_gamall
			else
				if l_stat_pochaxibeps /= 0 then
					l_tmp___20 := l_stat_pochaxibeps
				else
					if l_stat_gamrxi1beps /= 0 then
						l_tmp___19 := l_stat_gamrxi1beps
					else
						l_tmp___19 := 0
					end
					l_tmp___20 := l_tmp___19
				end
				l_tmp___21 := l_tmp___20
			end
			l_stat_all := l_tmp___21
			l_b0_val := ((l_factor_val * l_pochaxibeps.item.val) * l_gamrni.item.val) * l_gamrxi1beps.item.val
			l_tmp___22 := fabs ((l_factor_val * l_pochaxibeps.item.val) * l_gamrni.item.val)
			l_tmp___23 := fabs ((l_factor_val * l_pochaxibeps.item.val) * l_gamrxi1beps.item.val)
			l_tmp___24 := fabs ((l_factor_val * l_gamrni.item.val) * l_gamrxi1beps.item.val)
			l_tmp___25 := fabs ((l_pochaxibeps.item.val * l_gamrni.item.val) * l_gamrxi1beps.item.val)
			l_b0_err := (((l_tmp___22 * l_gamrxi1beps.item.err + l_tmp___23 * l_gamrni.item.err) + l_tmp___24 * l_pochaxibeps.item.err) + l_tmp___25 * l_factor_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_b0_val))
			l_stat_dgamrbxi := (gamma_inst.gsl_sf_gammainv_e (a_b___0 + l_xi, l_dgamrbxi))
			l_a0_val := (((l_factor_val * l_pochai.item.val) * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps
			l_tmp___28 := fabs (((l_factor_val * l_pochai.item.val) * l_dgamrbxi.item.val) / a_beps)
			l_tmp___29 := fabs (((l_factor_val * l_pochai.item.val) * l_gamri1.item.val) / a_beps)
			l_tmp___30 := fabs (((l_factor_val * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps)
			l_tmp___31 := fabs (((l_pochai.item.val * l_dgamrbxi.item.val) * l_gamri1.item.val) / a_beps)
			l_a0_err := (((l_tmp___28 * l_gamri1.item.err + l_tmp___29 * l_dgamrbxi.item.err) + l_tmp___30 * l_pochai.item.err) + l_tmp___31 * l_factor_err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_a0_val))
			if l_stat_all /= 0 then
				l_stat_all := l_stat_all
			else
				if l_stat_dgamrbxi /= 0 then
					l_tmp___33 := l_stat_dgamrbxi
				else
					l_tmp___33 := 0
				end
				l_stat_all := l_tmp___33
			end
			l_b0_val := (a_xeps * l_b0_val) / a_beps
			l_tmp___34 := fabs (a_xeps / a_beps)
			l_b0_err := l_tmp___34 * l_b0_err + (4.0 * 2.2204460492503131e-16) * (fabs (l_b0_val))
			l_dchu_val := (a_sum.val + l_a0_val) - l_b0_val
			l_tmp___36 := fabs (a_sum.val)
			l_tmp___37 := fabs (l_a0_val)
			l_dchu_err := ((a_sum.err + l_a0_err) + l_b0_err) + (2.0 * 2.2204460492503131e-16) * ((l_tmp___36 + l_tmp___37) + (fabs (l_b0_val)))
			l_i := 1
			from
			until
				not (not js.loop_done and then (l_i < 2_000))
			loop
				l_xi___0 := (l_istrt + l_i).to_double
				l_xi1 := ((l_istrt + l_i) - 1).to_double
				l_a0_multiplier := ((a_a___5 + l_xi1) * a_x) / ((a_b___0 + l_xi1) * l_xi___0)
				l_b0_multiplier := (((a_a___5 + l_xi1) - a_beps) * a_x) / ((a_bint + l_xi1) * (l_xi___0 - a_beps))
				l_a0_val := l_a0_val * l_a0_multiplier
				l_a0_err := l_a0_err + ((fabs (l_a0_multiplier)) * l_a0_err)
				l_b0_val := l_b0_val * l_b0_multiplier
				l_b0_err := l_b0_err + ((fabs (l_b0_multiplier)) * l_b0_err)
				l_t_val := l_a0_val - l_b0_val
				l_t_err := l_a0_err + l_b0_err
				l_dchu_val := l_dchu_val + l_t_val
				l_dchu_err := l_dchu_err + l_t_err
				l_tmp___41 := fabs (l_t_val)
				if l_tmp___41 < l_EPS * (fabs (l_dchu_val)) then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			a_result.item.val := l_dchu_val
			a_result.item.err := 2.0 * l_dchu_err
			a_result.item.err := a_result.item.err + (2.0 * (fabs (l_t_val)))
			a_result.item.err := a_result.item.err + (((4.0 * 2.2204460492503131e-16) * (l_i.to_double + 2.0)) * (fabs (l_dchu_val)))
			a_result.item.err := a_result.item.err * (2.0)
			if l_i >= 2_000 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 438, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := l_stat_all
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	hyperg_U_int_bge1 (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_tmp: REAL_64
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_asymp: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_asymp: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_ser: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_ser: INTEGER_32
			l_scale_count: INTEGER_32
			l_scale_factor: REAL_64
			l_lnm: PD_GSL_SF_RESULT_STRUCT
			l_y: PD_GSL_SF_RESULT_STRUCT
			l_lnscale: REAL_64
			l_Uap1: REAL_64
			l_Ua: REAL_64
			l_Uam1: REAL_64
			l_ap: INTEGER_32
			l_au0: REAL_64
			l_tmp___13: REAL_64
			l_scale_count___0: INTEGER_32
			l_scale_factor___0: REAL_64
			l_r_Ua: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lnm___0: PD_GSL_SF_RESULT_STRUCT
			l_y___0: PD_GSL_SF_RESULT_STRUCT
			l_lnscale___0: REAL_64
			l_lm: CE_ARRAY [REAL_64]
			l_stat_1: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_Uam1___0: REAL_64
			l_Ua___0: REAL_64
			l_Uap1___0: REAL_64
			l_ap___0: INTEGER_32
			l_au0___0: REAL_64
			l_tmp___19: REAL_64
			l_tmp___21: REAL_64
			l_tmp___23: REAL_64
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_scale_factor___1: REAL_64
			l_scale_count___1: INTEGER_32
			l_stat_CF1: INTEGER_32
			l_ru: CE_ARRAY [REAL_64]
			l_CF1_count: CE_ARRAY [INTEGER_32]
			l_a_target: INTEGER_32
			l_lnU_target: REAL_64
			l_Ua___1: REAL_64
			l_Uap1___1: REAL_64
			l_Uam1___1: REAL_64
			l_ap___1: INTEGER_32
			l_au0___1: REAL_64
			l_lnscl: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_tmp___30: REAL_64
			l_oUa_err: REAL_64
			l_tmp___32: REAL_64
			l_stat_e___1: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_scale_factor___2: REAL_64
			l_scale_count_for: INTEGER_32
			l_scale_count_bck: INTEGER_32
			l_a0___2: INTEGER_32
			l_a1___4: INTEGER_32
			l_Ua1_bck_val: REAL_64
			l_Ua1_bck_err: REAL_64
			l_Ua1_for_val: REAL_64
			l_Ua1_for_err: REAL_64
			l_stat_for: INTEGER_32
			l_stat_bck: INTEGER_32
			l_lm_for: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ru___0: CE_ARRAY [REAL_64]
			l_CF1_count___0: CE_ARRAY [INTEGER_32]
			l_stat_CF1___0: INTEGER_32
			l_Ua___2: REAL_64
			l_Uap1___2: REAL_64
			l_Uam1___2: REAL_64
			l_ap___2: INTEGER_32
			l_au0___2: REAL_64
			l_tmp___40: REAL_64
			l_lnU00: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lnU12: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_U00: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_U12: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___42: REAL_64
			l_r_Ua___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_Uam1___3: REAL_64
			l_Ua___3: REAL_64
			l_Uap1___3: REAL_64
			l_ap___3: INTEGER_32
			l_lm_for_local: CE_ARRAY [REAL_64]
			l_au0___3: REAL_64
			l_tmp___47: REAL_64
			l_tmp___49: REAL_64
			l_lns: REAL_64
			l_ln_for_val: REAL_64
			l_ln_for_err: REAL_64
			l_ln_bck_val: REAL_64
			l_ln_bck_err: REAL_64
			l_lnr_val: REAL_64
			l_lnr_err: REAL_64
			l_tmp___58: REAL_64
			l_tmp___59: REAL_64
			l_tmp___60: REAL_64
			l_sgn: REAL_64
			l_tmp___62: INTEGER_32
			l_tmp___63: INTEGER_32
			l_stat_e___2: INTEGER_32
			l_tmp___65: INTEGER_32
			l_tmp___66: INTEGER_32
			l_tmp___67: INTEGER_32
			l_tmp___71: REAL_64
			l_tmp___73: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_asymp.make (<<1>>)
			create l_ser.make (<<1>>)
			create l_lnm.make
			create l_y.make
			create l_r_Ua.make (<<1>>)
			create l_lnm___0.make
			create l_y___0.make
			create l_lm.make (<<1>>)
			create l_ru.make (<<1>>)
			create l_CF1_count.make (<<1>>)
			create l_lm_for.make (<<1>>)
			create l_ru___0.make (<<1>>)
			create l_CF1_count___0.make (<<1>>)
			create l_lnU00.make (<<1>>)
			create l_lnU12.make (<<1>>)
			create l_U00.make (<<1>>)
			create l_U12.make (<<1>>)
			create l_r_Ua___0.make (<<1>>)
			create l_lm_for_local.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_a___5 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						a_result.item.e10 := 0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 3 then -- else:
						if a_a___5 /= -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := (-a_b___0).to_double + a_x
						l_tmp := fabs (a_b___0.to_double)
						a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp + (fabs (a_x)))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						a_result.item.e10 := 0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 6 then -- else:
						if a_b___0 /= a_a___5 + 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						Result := (exp_inst.gsl_sf_exp_e10_e ((-a_a___5).to_double * (log (a_x)), a_result))
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 9 then -- else:
						l_tmp___71 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_a___5.to_double)), 1.0)
						l_tmp___73 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs ((1.0 + a_a___5.to_double) - a_b___0.to_double)), 1.0)
						if not (l_tmp___71 * l_tmp___73 < 0.99 * (fabs (a_x))) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_ln_pre_val := (-a_a___5).to_double * (log (a_x))
						l_ln_pre_err := (2.0 * 2.2204460492503131e-16) * (fabs (l_ln_pre_val))
						l_stat_asymp := (hyperg_zaU_asymp (a_a___5.to_double, a_b___0.to_double, a_x, l_asymp))
						l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_ln_pre_val, l_ln_pre_err, l_asymp.item.val, l_asymp.item.err, a_result))
						if l_stat_e /= 0 then
							l_tmp___9 := l_stat_e
						else
							if l_stat_asymp /= 0 then
								l_tmp___8 := l_stat_asymp
							else
								l_tmp___8 := 0
							end
							l_tmp___9 := l_tmp___8
						end
						Result := l_tmp___9
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 12 then -- else:
						if not ((fabs (a_a___5.to_double)) < (5).to_double) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_b___0 < 5 then
							if a_x < 2.0 then
								l_pos := -1 + 18 -- goto _L___2
							else
								l_pos := -1 + 15 -- goto _L___6
							end
						else
							l_pos := -1 + 15 -- goto _L___6
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 15 then -- else: | _L___6:
						if not ((fabs (a_a___5.to_double)) < (10).to_double) then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if not (a_b___0 < 10) then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if not (a_x < 1.0) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___2:
						if (1 + a_a___5) - a_b___0 > 0 then
							l_stat_ser := (hyperg_U_series (a_a___5.to_double, a_b___0.to_double, a_x, l_ser))
							a_result.item.val := l_ser.item.val
							a_result.item.err := l_ser.item.err
							a_result.item.e10 := 0
							Result := l_stat_ser
							js.return
						else
							l_pos := -1 + 24 -- goto _L___4
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 24 -- goto _L___4
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___4
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 41
				when 24 then -- else: | _L___4:
						if not (a_a___5 < 0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_scale_count := 0
						l_scale_factor := 1.3407807929942596e+154
						l_Uap1 := 1.0
						l_Ua := (-a_b___0).to_double + a_x
						l_ap := -1
						from
						until
							not (not js.loop_done and then (l_ap > a_a___5))
						loop
							l_Uam1 := (l_ap.to_double * ((a_b___0 - l_ap).to_double - 1.0)) * l_Uap1 + ((a_x + 2.0 * l_ap.to_double) - a_b___0.to_double) * l_Ua
							l_Uap1 := l_Ua
							l_Ua := l_Uam1
							from
							until
								js.loop_done
							loop
								l_au0 := (fabs (l_Ua))
								if l_au0 > l_scale_factor then
									l_Ua := l_Ua / l_scale_factor
									l_Uap1 := l_Uap1 / l_scale_factor
									l_scale_count := l_scale_count + 1
								elseif l_au0 < 1.0 / l_scale_factor then
									l_Ua := l_Ua * l_scale_factor
									l_Uap1 := l_Uap1 * l_scale_factor
									l_scale_count := l_scale_count - 1
								end
								js.break
							end
							l_ap := l_ap - 1
						end
						l_lnscale := log (l_scale_factor)
						l_lnm.val := l_scale_count.to_double * l_lnscale
						l_lnm.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_lnm.val))
						l_y.val := l_Ua
						l_tmp___13 := fabs (a_a___5.to_double)
						l_y.err := ((4.0 * 2.2204460492503131e-16) * (l_tmp___13 + 1.0)) * (fabs (l_Ua))
						Result := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm.val, l_lnm.err, l_y.val, l_y.err, a_result))
						js.return
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 27 then -- else:
						if not (a_b___0.to_double >= 2.0 * a_a___5.to_double + a_x) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_scale_count___0 := 0
						l_scale_factor___0 := 1.3407807929942596e+154
						l_stat_1 := (hyperg_U_small_a_bgt0 (1.0, a_b___0.to_double, a_x, l_r_Ua, l_lm))
						l_Uam1___0 := 1.0
						l_Ua___0 := l_r_Ua.item.val
						l_Uam1___0 := l_Uam1___0 * (exp (-l_lm.item))
						l_ap___0 := 1
						from
						until
							not (not js.loop_done and then (l_ap___0 < a_a___5))
						loop
							l_Uap1___0 := -(l_Uam1___0 + ((a_b___0.to_double - 2.0 * l_ap___0.to_double) - a_x) * l_Ua___0) / (l_ap___0.to_double * ((1.0 + l_ap___0.to_double) - a_b___0.to_double))
							l_Uam1___0 := l_Ua___0
							l_Ua___0 := l_Uap1___0
							from
							until
								js.loop_done
							loop
								l_au0___0 := (fabs (l_Ua___0))
								if l_au0___0 > l_scale_factor___0 then
									l_Ua___0 := l_Ua___0 / l_scale_factor___0
									l_Uam1___0 := l_Uam1___0 / l_scale_factor___0
									l_scale_count___0 := l_scale_count___0 + 1
								elseif l_au0___0 < 1.0 / l_scale_factor___0 then
									l_Ua___0 := l_Ua___0 * l_scale_factor___0
									l_Uam1___0 := l_Uam1___0 * l_scale_factor___0
									l_scale_count___0 := l_scale_count___0 - 1
								end
								js.break
							end
							l_ap___0 := l_ap___0 + 1
						end
						l_lnscale___0 := log (l_scale_factor___0)
						l_lnm___0.val := l_lm.item + l_scale_count___0.to_double * l_lnscale___0
						l_tmp___19 := fabs (l_lm.item)
						l_lnm___0.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___19 + (fabs (l_scale_count___0.to_double * l_lnscale___0)))
						l_y___0.val := l_Ua___0
						l_tmp___21 := fabs (l_r_Ua.item.err / l_r_Ua.item.val)
						l_y___0.err := l_tmp___21 * (fabs (l_Ua___0))
						l_tmp___23 := fabs (a_a___5.to_double)
						l_y___0.err := l_y___0.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___23 + 1.0)) * (fabs (l_Ua___0)))
						l_stat_e___0 := exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnm___0.val, l_lnm___0.err, l_y___0.val, l_y___0.err, a_result)
						if l_stat_e___0 /= 0 then
							l_tmp___26 := l_stat_e___0
						else
							if l_stat_1 /= 0 then
								l_tmp___25 := l_stat_1
							else
								l_tmp___25 := 0
							end
							l_tmp___26 := l_tmp___25
						end
						Result := l_tmp___26
						js.return
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 30 then -- else:
						if not (a_b___0.to_double <= a_x) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_scale_factor___1 := 1.3407807929942596e+154
						l_scale_count___1 := 0
						if a_b___0 < a_a___5 + 1 then
							l_a_target := a_b___0 - 1
							l_lnU_target := (-l_a_target).to_double * (log (a_x))
						else
							l_a_target := 0
							l_lnU_target := 0.0
						end
						l_stat_CF1 := hyperg_U_CF1 (a_a___5.to_double, a_b___0.to_double, 0, a_x, l_ru, l_CF1_count)
						l_Ua___1 := 1.0
						l_Uap1___1 := (l_ru.item / a_a___5.to_double) * l_Ua___1
						l_ap___1 := a_a___5
						from
						until
							not (not js.loop_done and then (l_ap___1 > l_a_target))
						loop
							l_Uam1___1 := -(((a_b___0.to_double - 2.0 * l_ap___1.to_double) - a_x) * l_Ua___1 + (l_ap___1.to_double * ((1.0 + l_ap___1.to_double) - a_b___0.to_double)) * l_Uap1___1)
							l_Uap1___1 := l_Ua___1
							l_Ua___1 := l_Uam1___1
							from
							until
								js.loop_done
							loop
								l_au0___1 := (fabs (l_Ua___1))
								if l_au0___1 > l_scale_factor___1 then
									l_Ua___1 := l_Ua___1 / l_scale_factor___1
									l_Uap1___1 := l_Uap1___1 / l_scale_factor___1
									l_scale_count___1 := l_scale_count___1 + 1
								elseif l_au0___1 < 1.0 / l_scale_factor___1 then
									l_Ua___1 := l_Ua___1 * l_scale_factor___1
									l_Uap1___1 := l_Uap1___1 * l_scale_factor___1
									l_scale_count___1 := l_scale_count___1 - 1
								end
								js.break
							end
							l_ap___1 := l_ap___1 - 1
						end
						if l_Ua___1 = 0.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							a_result.item.e10 := 0
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 992, 12)
								Result := 12
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_lnscl := (-l_scale_count___1).to_double * (log (l_scale_factor___1))
							l_lnpre_val := l_lnU_target + l_lnscl
							l_tmp___30 := fabs (l_lnU_target)
							l_lnpre_err := (2.0 * 2.2204460492503131e-16) * (l_tmp___30 + (fabs (l_lnscl)))
							l_tmp___32 := fabs ((l_a_target - a_a___5).to_double)
							l_oUa_err := ((2.0 * ((l_tmp___32 + (l_CF1_count.item).to_double) + 1.0)) * 2.2204460492503131e-16) * (fabs (1.0 / l_Ua___1))
							l_stat_e___1 := (exp_inst.gsl_sf_exp_mult_err_e10_e (l_lnpre_val, l_lnpre_err, 1.0 / l_Ua___1, l_oUa_err, a_result))
							if l_stat_e___1 /= 0 then
								l_tmp___36 := l_stat_e___1
							else
								if l_stat_CF1 /= 0 then
									l_tmp___35 := l_stat_CF1
								else
									l_tmp___35 := 0
								end
								l_tmp___36 := l_tmp___35
							end
							Result := l_tmp___36
							js.return
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 33 then -- else:
						l_scale_factor___2 := 1.3407807929942596e+154
						l_scale_count_for := 0
						l_scale_count_bck := 0
						l_a0___2 := 1
						l_a1___4 := (l_a0___2.to_double + (ceil (0.5 * (a_b___0.to_double - a_x) - l_a0___2.to_double))).truncated_to_integer
						l_stat_CF1___0 := (hyperg_U_CF1 (a_a___5.to_double, a_b___0.to_double, 0, a_x, l_ru___0, l_CF1_count___0))
						l_Ua___2 := 1.0
						l_Uap1___2 := (l_ru___0.item / a_a___5.to_double) * l_Ua___2
						l_ap___2 := a_a___5
						from
						until
							not (not js.loop_done and then (l_ap___2 > l_a1___4))
						loop
							l_Uam1___2 := -(((a_b___0.to_double - 2.0 * l_ap___2.to_double) - a_x) * l_Ua___2 + (l_ap___2.to_double * ((1.0 + l_ap___2.to_double) - a_b___0.to_double)) * l_Uap1___2)
							l_Uap1___2 := l_Ua___2
							l_Ua___2 := l_Uam1___2
							from
							until
								js.loop_done
							loop
								l_au0___2 := (fabs (l_Ua___2))
								if l_au0___2 > l_scale_factor___2 then
									l_Ua___2 := l_Ua___2 / l_scale_factor___2
									l_Uap1___2 := l_Uap1___2 / l_scale_factor___2
									l_scale_count_bck := l_scale_count_bck + 1
								elseif l_au0___2 < 1.0 / l_scale_factor___2 then
									l_Ua___2 := l_Ua___2 * l_scale_factor___2
									l_Uap1___2 := l_Uap1___2 * l_scale_factor___2
									l_scale_count_bck := l_scale_count_bck - 1
								end
								js.break
							end
							l_ap___2 := l_ap___2 - 1
						end
						l_Ua1_bck_val := l_Ua___2
						l_tmp___40 := fabs ((l_a1___4 - a_a___5).to_double)
						l_Ua1_bck_err := ((2.0 * 2.2204460492503131e-16) * ((l_tmp___40 + (l_CF1_count___0.item).to_double) + 1.0)) * (fabs (l_Ua___2))
						l_stat_bck := l_stat_CF1___0
						if a_b___0 /= 2 * l_a1___4 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if l_a1___4 > 1 then
							hyperg_lnU_beq2a (l_a1___4.to_double, a_x, l_lm_for).do_nothing
							l_Ua1_for_val := 1.0
							l_Ua1_for_err := 0.0
							l_stat_for := 0
						else
							l_pos := -1 + 36 -- goto _L___0
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 36 then -- else: | _L___0:
						if a_b___0 /= 2 * l_a1___4 - 1 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_a1___4 > 1 then
							hyperg_lnU_beq2a (l_a1___4.to_double - 1.0, a_x, l_lnU00).do_nothing
							hyperg_lnU_beq2a (l_a1___4.to_double, a_x, l_lnU12).do_nothing
							if l_lnU00.item.val > l_lnU12.item.val then
								l_lm_for.item.val := l_lnU00.item.val
								l_lm_for.item.err := l_lnU00.item.err
								l_U00.item.val := 1.0
								l_U00.item.err := 0.0
								exp_inst.gsl_sf_exp_err_e (l_lnU12.item.val - l_lm_for.item.val, l_lnU12.item.err + l_lm_for.item.err, l_U12).do_nothing
							else
								l_lm_for.item.val := l_lnU12.item.val
								l_lm_for.item.err := l_lnU12.item.err
								l_U12.item.val := 1.0
								l_U12.item.err := 0.0
								exp_inst.gsl_sf_exp_err_e (l_lnU00.item.val - l_lm_for.item.val, l_lnU00.item.err + l_lm_for.item.err, l_U00).do_nothing
							end
							l_Ua1_for_val := (a_x * l_U12.item.val - l_U00.item.val) / (2.0 * l_a1___4.to_double - 2.0)
							l_tmp___42 := fabs (a_x)
							l_Ua1_for_err := (l_tmp___42 * l_U12.item.err + l_U00.item.err) / (fabs (2.0 * l_a1___4.to_double - 2.0))
							l_Ua1_for_err := l_Ua1_for_err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_Ua1_for_val)))
							l_stat_for := 0
						else
							l_pos := -1 + 39 -- goto _L
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else: | _L:
						l_Uam1___3 := 1.0
						l_stat_for := hyperg_U_small_a_bgt0 (l_a0___2.to_double, a_b___0.to_double, a_x, l_r_Ua___0, l_lm_for_local)
						l_Ua___3 := l_r_Ua___0.item.val
						l_Uam1___3 := l_Uam1___3 * (exp (-l_lm_for_local.item))
						l_lm_for.item.val := l_lm_for_local.item
						l_lm_for.item.err := 0.0
						l_ap___3 := l_a0___2
						from
						until
							not (not js.loop_done and then (l_ap___3 < l_a1___4))
						loop
							l_Uap1___3 := -(l_Uam1___3 + ((a_b___0.to_double - 2.0 * l_ap___3.to_double) - a_x) * l_Ua___3) / (l_ap___3.to_double * ((1.0 + l_ap___3.to_double) - a_b___0.to_double))
							l_Uam1___3 := l_Ua___3
							l_Ua___3 := l_Uap1___3
							from
							until
								js.loop_done
							loop
								l_au0___3 := (fabs (l_Ua___3))
								if l_au0___3 > l_scale_factor___2 then
									l_Ua___3 := l_Ua___3 / l_scale_factor___2
									l_Uam1___3 := l_Uam1___3 / l_scale_factor___2
									l_scale_count_for := l_scale_count_for + 1
								elseif l_au0___3 < 1.0 / l_scale_factor___2 then
									l_Ua___3 := l_Ua___3 * l_scale_factor___2
									l_Uam1___3 := l_Uam1___3 * l_scale_factor___2
									l_scale_count_for := l_scale_count_for - 1
								end
								js.break
							end
							l_ap___3 := l_ap___3 + 1
						end
						l_Ua1_for_val := l_Ua___3
						l_tmp___47 := fabs (l_Ua___3)
						l_Ua1_for_err := l_tmp___47 * (fabs (l_r_Ua___0.item.err / l_r_Ua___0.item.val))
						l_tmp___49 := fabs ((l_a1___4 - l_a0___2).to_double)
						l_Ua1_for_err := l_Ua1_for_err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___49 + 1.0)) * (fabs (l_Ua1_for_val)))
				when 40 then -- if done
						if l_Ua1_bck_val = 0.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							a_result.item.e10 := 0
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_U.c"), 1_117, 12)
								Result := 12
								js.return
								if not js.return_called then
									js.break
								end
							end
						elseif l_Ua1_for_val = 0.0 then
							from
							until
								js.loop_done
							loop
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								a_result.item.e10 := 0
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("hyperg_U.c"), 1_121, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_lns := (l_scale_count_for - l_scale_count_bck).to_double * (log (l_scale_factor___2))
							l_ln_for_val := (log ((fabs (l_Ua1_for_val))))
							l_ln_for_err := 2.2204460492503131e-16 + (fabs (l_Ua1_for_err / l_Ua1_for_val))
							l_ln_bck_val := (log ((fabs (l_Ua1_bck_val))))
							l_ln_bck_err := 2.2204460492503131e-16 + (fabs (l_Ua1_bck_err / l_Ua1_bck_val))
							l_lnr_val := ((l_lm_for.item.val + l_ln_for_val) - l_ln_bck_val) + l_lns
							l_tmp___58 := fabs (l_lm_for.item.val)
							l_tmp___59 := fabs (l_ln_for_val)
							l_tmp___60 := fabs (l_ln_bck_val)
							l_lnr_err := ((l_lm_for.item.err + l_ln_for_err) + l_ln_bck_err) + (2.0 * 2.2204460492503131e-16) * (((l_tmp___58 + l_tmp___59) + l_tmp___60) + (fabs (l_lns)))
							if l_Ua1_for_val >= 0.0 then
								l_tmp___62 := 1
							else
								l_tmp___62 := -1
							end
							if l_Ua1_bck_val >= 0.0 then
								l_tmp___63 := 1
							else
								l_tmp___63 := -1
							end
							l_sgn := (l_tmp___62 * l_tmp___63).to_double
							l_stat_e___2 := (exp_inst.gsl_sf_exp_err_e10_e (l_lnr_val, l_lnr_err, a_result))
							a_result.item.val := a_result.item.val * l_sgn
							if l_stat_e___2 /= 0 then
								l_tmp___67 := l_stat_e___2
							else
								if l_stat_bck /= 0 then
									l_tmp___66 := l_stat_bck
								else
									if l_stat_for /= 0 then
										l_tmp___65 := l_stat_for
									else
										l_tmp___65 := 0
									end
									l_tmp___66 := l_tmp___65
								end
								l_tmp___67 := l_tmp___66
							end
							Result := l_tmp___67
							js.return
						end
				when 41 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 42 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_U_int_negx (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		do
			Result := (hyperg_U_negx (a_a___5.to_double, a_b___0.to_double, a_x, a_result))
		end

	hyperg_U_int_origin (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		do
			Result := (hyperg_U_origin (a_a___5.to_double, a_b___0.to_double, a_result))
		end

	hyperg_U_negx (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_r1___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r2___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_1: INTEGER_32
			l_stat_2: INTEGER_32
			l_status: INTEGER_32
			l_a_int: INTEGER_32
			l_b_int: INTEGER_32
			l_T1: REAL_64
			l_T1_err: REAL_64
			l_T2: REAL_64
			l_T2_err: REAL_64
			l_Mr1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Mr1: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___10: INTEGER_32
			l_Mr2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Mr2: INTEGER_32
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_tmp___15: INTEGER_32
			l_x1mb: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r1___1.make (<<1>>)
			create l_r2___0.make (<<1>>)
			create l_Mr1.make (<<1>>)
			create l_Mr2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a_int := (a_a___5 = (floor (a_a___5))).to_integer
					l_b_int := (a_b___0 = (floor (a_b___0))).to_integer
					l_T1 := (0).to_double
					l_T1_err := (0).to_double
					l_T2 := (0).to_double
					l_T2_err := (0).to_double
					if not (l_b_int.to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_b___0 <= (0).to_double) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (l_a_int.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_a___5 <= (0).to_double then
							if a_a___5 >= a_b___0 then
								l_pos := -1 + 9 -- goto _L___2
							else
								l_pos := -1 + 5 -- goto _L___1
							end
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___1:
						a_result.item.val := (builtin_nanf (ce_string (""))).to_double
						a_result.item.err := (builtin_nanf (ce_string (""))).to_double
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("limit case integer b <= 0 unimplemented"), ce_string ("hyperg_U.c"), 1_538, 24)
							Result := 24
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___2
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___2:
						l_stat_1 := poch_inst.gsl_sf_poch_e (((1).to_double + a_a___5) - a_b___0, -a_a___5, l_r1___1)
						l_status := l_stat_1
						if l_r1___1.item.val /= 0.0 then
							l_stat_Mr1 := (hyperg_1f1_inst.gsl_sf_hyperg_1F1_e (a_a___5, a_b___0, a_x, l_Mr1))
							if l_status /= 0 then
								l_status := l_status
							else
								if l_stat_Mr1 /= 0 then
									l_tmp___4 := l_stat_Mr1
								else
									l_tmp___4 := 0
								end
								l_status := l_tmp___4
							end
							l_T1 := l_Mr1.item.val * l_r1___1.item.val
							l_tmp___5 := fabs (l_T1)
							l_tmp___6 := fabs (l_Mr1.item.err * l_r1___1.item.val)
							l_T1_err := ((2.0 * 2.2204460492503131e-16) * l_tmp___5 + l_tmp___6) + (fabs (l_Mr1.item.val * l_r1___1.item.err))
						end
				when 10 then
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 11 then -- if:
						if not (l_b_int.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if not (a_b___0 >= (2).to_double) then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (l_a_int.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if a_a___5 <= a_b___0 - (2).to_double then
							l_pos := -1 + 20 -- goto _L___7
						else
							l_pos := -1 + 16 -- goto _L___6
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___6:
						a_result.item.val := (builtin_nanf (ce_string (""))).to_double
						a_result.item.err := (builtin_nanf (ce_string (""))).to_double
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("limit case integer b >= 2 unimplemented"), ce_string ("hyperg_U.c"), 1_571, 24)
							Result := 24
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 20 -- goto _L___7
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 20 then -- else: | _L___7:
						if not (l_a_int.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if a_a___5 <= (0).to_double then
							if a_b___0 >= (1).to_double then
								l_r2___0.item.val := (0).to_double
								l_r2___0.item.err := (0).to_double
							else
								l_pos := -1 + 23 -- goto _L___4
							end
						else
							l_pos := -1 + 23 -- goto _L___4
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L___4:
						l_stat_2 := poch_inst.gsl_sf_poch_e (a_a___5, -(((1).to_double + a_a___5) - a_b___0), l_r2___0)
						if l_status /= 0 then
							l_status := l_status
						else
							if l_stat_2 /= 0 then
								l_tmp___10 := l_stat_2
							else
								l_tmp___10 := 0
							end
							l_status := l_tmp___10
						end
				when 24 then
						if l_r2___0.item.val /= 0.0 then
							l_stat_Mr2 := (hyperg_1f1_inst.gsl_sf_hyperg_1F1_e (((1).to_double + a_a___5) - a_b___0, (2).to_double - a_b___0, a_x, l_Mr2))
							l_T2 := l_Mr2.item.val * l_r2___0.item.val
							l_tmp___12 := fabs (l_T2)
							l_tmp___13 := fabs (l_Mr2.item.err * l_r2___0.item.val)
							l_T2_err := ((2.0 * 2.2204460492503131e-16) * l_tmp___12 + l_tmp___13) + (fabs (l_Mr2.item.val * l_r2___0.item.err))
							if l_status /= 0 then
								l_status := l_status
							else
								if l_stat_Mr2 /= 0 then
									l_tmp___15 := l_stat_Mr2
								else
									l_tmp___15 := 0
								end
								l_status := l_tmp___15
							end
							if l_T2 /= 0.0 then
								l_x1mb := (pow (a_x, (1).to_double - a_b___0))
								l_T2 := l_x1mb * l_T2
								l_T2_err := (fabs (l_x1mb)) * l_T2_err
							end
						end
				when 25 then -- if done
						if not js.return_called then
							a_result.item.val := l_T1 + l_T2
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)) + (l_T1_err + l_T2_err)
							a_result.item.e10 := 0
							Result := l_status
						end
				when 26 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_U_origin (a_a___5: REAL_64; a_b___0: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_r1___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r2___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_1: INTEGER_32
			l_stat_2: INTEGER_32
			l_factor: REAL_64
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_r1___1.make (<<1>>)
			create l_r2___0.make (<<1>>)

			l_stat_1 := (gamma_inst.gsl_sf_gammainv_e (((1).to_double + a_a___5) - a_b___0, l_r1___1))
			l_stat_2 := (gamma_inst.gsl_sf_gammainv_e (a_b___0, l_r2___0))
			l_factor := 3.14159265358979323846 / (sin (3.14159265358979323846 * a_b___0))
			a_result.item.val := (l_factor * l_r1___1.item.val) * l_r2___0.item.val
			a_result.item.err := (fabs (l_factor)) * (l_r1___1.item.err + l_r2___0.item.err)
			a_result.item.e10 := 0
			if l_stat_1 /= 0 then
				l_tmp___4 := l_stat_1
			else
				if l_stat_2 /= 0 then
					l_tmp___3 := l_stat_2
				else
					l_tmp___3 := 0
				end
				l_tmp___4 := l_tmp___3
			end
			Result := l_tmp___4
		end

	hyperg_U_series (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_SQRT_EPS: REAL_64
			l_lnr: REAL_64
			l_stat_e: INTEGER_32
			l_bint: REAL_64
			l_tmp___4: REAL_64
			l_beps: REAL_64
			l_N: INTEGER_32
			l_lnx: REAL_64
			l_xeps: REAL_64
			l_sum: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_sum: INTEGER_32
			l_stat_inf: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
		do
			create l_sum.make (<<1>>)

			l_SQRT_EPS := 1.41421356237309504880 * 1.4901161193847656e-08
			if (fabs ((1.0 + a_a___5) - a_b___0)) < l_SQRT_EPS then
				l_lnr := -a_a___5 * (log (a_x))
				l_stat_e := (exp_inst.gsl_sf_exp_e (l_lnr, a_result))
				a_result.item.err := a_result.item.err + ((2.0 * l_SQRT_EPS) * (fabs (a_result.item.val)))
				Result := l_stat_e
			else
				if a_b___0 < 0.0 then
					l_tmp___4 := (ceil (a_b___0 - 0.5))
				else
					l_tmp___4 := (floor (a_b___0 + 0.5))
				end
				l_bint := l_tmp___4
				l_beps := a_b___0 - l_bint
				l_N := l_bint.truncated_to_integer
				l_lnx := (log (a_x))
				l_xeps := (exp (-l_beps * l_lnx))
				l_stat_sum := (hyperg_U_finite_sum (l_N, a_a___5, a_b___0, a_x, l_xeps, l_sum))
				if (fabs (l_xeps - 1.0)) > 0.5 then
					l_stat_inf := hyperg_U_infinite_sum_stable (l_N, a_a___5, l_bint, a_b___0, l_beps, a_x, l_xeps, (l_sum.item).twin, a_result)
				elseif ((1).to_double + a_a___5) - a_b___0 < (0).to_double then
					if ((1).to_double + a_a___5) - a_b___0 = (floor (((1).to_double + a_a___5) - a_b___0)) then
						if l_beps /= (0).to_double then
							l_stat_inf := hyperg_U_infinite_sum_simple (l_N, a_a___5, l_bint, a_b___0, l_beps, a_x, l_xeps, (l_sum.item).twin, a_result)
						else
							l_stat_inf := hyperg_U_infinite_sum_improved (l_N, a_a___5, l_bint, a_b___0, l_beps, a_x, l_xeps, (l_sum.item).twin, a_result)
						end
					else
						l_stat_inf := hyperg_U_infinite_sum_improved (l_N, a_a___5, l_bint, a_b___0, l_beps, a_x, l_xeps, (l_sum.item).twin, a_result)
					end
				else
					l_stat_inf := hyperg_U_infinite_sum_improved (l_N, a_a___5, l_bint, a_b___0, l_beps, a_x, l_xeps, (l_sum.item).twin, a_result)
				end
				if l_stat_sum /= 0 then
					l_tmp___11 := l_stat_sum
				else
					if l_stat_inf /= 0 then
						l_tmp___10 := l_stat_inf
					else
						l_tmp___10 := 0
					end
					l_tmp___11 := l_tmp___10
				end
				Result := l_tmp___11
			end
		end

	hyperg_U_small_a_bgt0 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_ln_multiplier: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_stat: INTEGER_32
			l_eps: REAL_64
			l_b0: REAL_64
			l_r_Ubm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Ub: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_Ubm1: REAL_64
			l_Ub: REAL_64
			l_Ubp1: REAL_64
			l_bp: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_r_Ubm1.make (<<1>>)
			create l_r_Ub.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_a___5 /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 1.0
						a_ln_multiplier.item := 0.0
						Result := 0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not (a_b___0 > 5000.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x < 0.90 * (fabs (a_b___0)) then
							l_pos := -1 + 8 -- goto _L
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else: | _L___1:
						if not (a_b___0 > 500.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not (a_x < 0.50 * (fabs (a_b___0))) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_stat := (hyperg_inst.gsl_sf_hyperg_U_large_b_e (a_a___5, a_b___0, a_x, a_result, a_ln_multiplier))
						if l_stat = 16 then
							Result := 0
						else
							Result := l_stat
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___0
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if a_b___0 > 15.0 then
							l_eps := a_b___0 - (floor (a_b___0))
							l_b0 := 1.0 + l_eps
							l_stat_0 := (hyperg_U_small_ab (a_a___5, l_b0, a_x, l_r_Ubm1))
							l_stat_1 := (hyperg_U_small_ab (a_a___5, l_b0 + 1.0, a_x, l_r_Ub))
							l_Ubm1 := l_r_Ubm1.item.val
							l_Ub := l_r_Ub.item.val
							l_bp := l_b0 + 1.0
							from
							until
								not (l_bp < a_b___0 - 0.1)
							loop
								l_Ubp1 := (((1.0 + a_a___5) - l_bp) * l_Ubm1 + ((l_bp + a_x) - 1.0) * l_Ub) / a_x
								l_Ubm1 := l_Ub
								l_Ub := l_Ubp1
								l_bp := l_bp + (1.0)
							end
							a_result.item.val := l_Ub
							l_tmp___3 := fabs (l_r_Ubm1.item.err / l_r_Ubm1.item.val)
							l_tmp___4 := fabs (l_r_Ub.item.err / l_r_Ub.item.val)
							a_result.item.err := (l_tmp___3 + l_tmp___4) * (fabs (l_Ub))
							l_tmp___6 := fabs (a_b___0 - l_b0)
							a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___6 + 1.0)) * (fabs (l_Ub)))
							a_ln_multiplier.item := 0.0
							if l_stat_0 /= 0 then
								l_tmp___9 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___8 := l_stat_1
								else
									l_tmp___8 := 0
								end
								l_tmp___9 := l_tmp___8
							end
							Result := l_tmp___9
						else
							a_ln_multiplier.item := 0.0
							Result := (hyperg_U_small_ab (a_a___5, a_b___0, a_x, a_result))
						end
				when 13 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hyperg_U_small_ab (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tmp: REAL_64
			l_p: REAL_64
			l_asymp: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_asymp: INTEGER_32
			l_tmp___4: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: REAL_64
		do
			create l_asymp.make (<<1>>)

			if a_a___5 = -1.0 then
				a_result.item.val := -a_b___0 + a_x
				l_tmp := fabs (a_b___0)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp + (fabs (a_x)))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			elseif a_a___5 = 0.0 then
				a_result.item.val := 1.0
				a_result.item.err := 0.0
				Result := 0
			else
				l_tmp___9 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_a___5)), 1.0)
				l_tmp___11 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs ((1.0 + a_a___5) - a_b___0)), 1.0)
				if l_tmp___9 * l_tmp___11 < 0.99 * (fabs (a_x)) then
					l_p := (pow (a_x, -a_a___5))
					l_stat_asymp := (hyperg_zaU_asymp (a_a___5, a_b___0, a_x, l_asymp))
					a_result.item.val := l_asymp.item.val * l_p
					a_result.item.err := l_asymp.item.err * l_p
					l_tmp___4 := fabs (l_asymp.item.val)
					a_result.item.err := a_result.item.err + (((l_tmp___4 * 2.2204460492503131e-16) * (fabs (a_a___5))) * l_p)
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
					Result := l_stat_asymp
				else
					Result := (hyperg_U_series (a_a___5, a_b___0, a_x, a_result))
				end
			end
		end

	hyperg_lnU_beq2a (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lx: REAL_64
			l_nu: REAL_64
			l_lnpre: REAL_64
			l_lnK: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___0: REAL_64
		do
			create l_lnK.make (<<1>>)

			l_lx := (log (a_x))
			l_nu := a_a___5 - 0.5
			l_lnpre := 0.5 * (a_x - 1.14472988584940017414342735135) - l_nu * l_lx
			bessel_knu_inst.gsl_sf_bessel_lnKnu_e (l_nu, 0.5 * a_x, l_lnK).do_nothing
			a_result.item.val := l_lnpre + l_lnK.item.val
			l_tmp___0 := fabs (0.5 * a_x)
			a_result.item.err := (2.0 * 2.2204460492503131e-16) * ((l_tmp___0 + 0.5 * 1.14472988584940017414342735135) + (fabs (l_nu * l_lx)))
			a_result.item.err := a_result.item.err + (l_lnK.item.err)
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			Result := 0
		end

	hyperg_zaU_asymp (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ap: REAL_64
			l_bp: REAL_64
			l_rintap: REAL_64
			l_rintbp: REAL_64
			l_ap_neg_int: INTEGER_32
			l_tmp___2: INTEGER_32
			l_bp_neg_int: INTEGER_32
			l_tmp___4: INTEGER_32
			l_mxi: REAL_64
			l_nmax: REAL_64
			l_tmp___5: REAL_64
			l_tn: REAL_64
			l_sum: REAL_64
			l_n: REAL_64
			l_sum_err: REAL_64
			l_apn: REAL_64
			l_bpn: REAL_64
			l_tmp___7: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_a___5
					l_bp := (1.0 + a_a___5) - a_b___0
					l_rintap := (floor (l_ap + 0.5))
					l_rintbp := (floor (l_bp + 0.5))
					if l_ap < 0.0 then
						if (fabs (l_ap - l_rintap)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_ap_neg_int := l_tmp___2
					if l_bp < 0.0 then
						if (fabs (l_bp - l_rintbp)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___4 := 1
						else
							l_tmp___4 := 0
						end
					else
						l_tmp___4 := 0
					end
					l_bp_neg_int := l_tmp___4
					if not (l_ap_neg_int.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (l_bp_neg_int.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_mxi := -1.0 / a_x
						if l_ap < l_bp then
							l_tmp___5 := l_ap
						else
							l_tmp___5 := l_bp
						end
						l_nmax := (-(l_tmp___5 - 0.1).truncated_to_integer).to_double
						l_tn := 1.0
						l_sum := 1.0
						l_n := 1.0
						l_sum_err := 0.0
						from
						until
							not (l_n <= l_nmax)
						loop
							l_apn := (l_ap + l_n) - 1.0
							l_bpn := (l_bp + l_n) - 1.0
							l_tn := l_tn * (((l_apn / l_n) * l_mxi) * l_bpn)
							l_sum := l_sum + l_tn
							l_sum_err := l_sum_err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_tn)))
							l_n := l_n + (1.0)
						end
						a_result.item.val := l_sum
						a_result.item.err := l_sum_err
						l_tmp___7 := fabs (l_nmax)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___7 + 1.0)) * (fabs (l_sum)))
						Result := 0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						Result := (d9chu (a_a___5, a_b___0, a_x, a_result))
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
