class
	P_HYPOT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_hypot (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	gsl_hypot3 (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_zabs: REAL_64
			l_w: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_r___3: REAL_64
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			l_zabs := (fabs (a_z))
			if l_yabs > l_zabs then
				l_tmp___5 := l_yabs
			else
				l_tmp___5 := l_zabs
			end
			if l_xabs > l_tmp___5 then
				l_tmp___4 := l_xabs
			else
				if l_yabs > l_zabs then
					l_tmp___3 := l_yabs
				else
					l_tmp___3 := l_zabs
				end
				l_tmp___4 := l_tmp___3
			end
			l_w := l_tmp___4
			if l_w = 0.0 then
				Result := (0.0)
			else
				l_r___3 := l_w * (sqrt (((l_xabs / l_w) * (l_xabs / l_w) + (l_yabs / l_w) * (l_yabs / l_w)) + (l_zabs / l_w) * (l_zabs / l_w)))
				Result := l_r___3
			end
		end

	xhypot (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___0 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___1 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___2 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___3 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___4 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___5 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___6 (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				js.return
			end
			if not js.return_called then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

end
