class
	P_INFNAN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_finite (a_x: REAL_64): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
				l_tmp___3 := (finitef (a_x.truncated_to_real))
			else
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
					l_tmp___2 := (finite2 (a_x))
				else
					l_tmp___2 := (finitel (real_96_from_real_64 (a_x)))
				end
				l_tmp___3 := l_tmp___2
			end
			Result := l_tmp___3
		end

	gsl_isinf (a_x: REAL_64): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
				l_tmp___4 := (isinff (a_x.truncated_to_real))
			else
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
					l_tmp___3 := (isinf (a_x))
				else
					l_tmp___3 := (isinfl (real_96_from_real_64 (a_x)))
				end
				l_tmp___4 := l_tmp___3
			end
			if l_tmp___4.to_boolean then
				if a_x > (0).to_double then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
			else
				Result := 0
			end
		end

	gsl_isnan (a_x: REAL_64): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
				l_tmp___3 := (isnanf (a_x.truncated_to_real))
			else
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
					l_tmp___2 := (isnan (a_x))
				else
					l_tmp___2 := (isnanl (real_96_from_real_64 (a_x)))
				end
				l_tmp___3 := l_tmp___2
			end
			Result := l_tmp___3
		end

	gsl_nan: REAL_64
		do
			Result := (fdiv_inst.gsl_fdiv (0.0, 0.0))
		end

	gsl_neginf: REAL_64
		do
			Result := (fdiv_inst.gsl_fdiv (-1.0, 0.0))
		end

	gsl_posinf: REAL_64
		do
			Result := (fdiv_inst.gsl_fdiv (1.0, 0.0))
		end

end
