class
	P_LAGUERRE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_laguerre_1 (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_laguerre_1_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_laguerre_1_e(a, x, &result)"), ce_string ("laguerre.c"), 319, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_laguerre_1_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tmp: REAL_64
		do
			a_result.item.val := (1.0 + a_a___5) - a_x
			l_tmp := fabs (a_a___5)
			a_result.item.err := (2.0 * 2.2204460492503131e-16) * ((1.0 + l_tmp) + (fabs (a_x)))
			Result := 0
		end

	gsl_sf_laguerre_2 (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_laguerre_2_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_laguerre_2_e(a, x, &result)"), ce_string ("laguerre.c"), 324, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_laguerre_2_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
		do
			if a_a___5 = -2.0 then
				a_result.item.val := (0.5 * a_x) * a_x
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			else
				l_c0___0 := (0.5 * (2.0 + a_a___5)) * (1.0 + a_a___5)
				l_c1___2 := -(2.0 + a_a___5)
				l_c2___0 := -0.5 / (2.0 + a_a___5)
				a_result.item.val := l_c0___0 + (l_c1___2 * a_x) * (1.0 + l_c2___0 * a_x)
				l_tmp___0 := fabs (l_c0___0)
				l_tmp___1 := fabs (l_c1___2 * a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___0 + (2.0 * l_tmp___1) * (1.0 + 2.0 * (fabs (l_c2___0 * a_x))))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	gsl_sf_laguerre_3 (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_laguerre_3_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_laguerre_3_e(a, x, &result)"), ce_string ("laguerre.c"), 329, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_laguerre_3_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_x2_6: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_tmp___4: REAL_64
		do
			if a_a___5 = -2.0 then
				l_x2_6 := (a_x * a_x) / 6.0
				a_result.item.val := l_x2_6 * (3.0 - a_x)
				a_result.item.err := ((l_x2_6 * (3.0 + (fabs (a_x)))) * 2.0) * 2.2204460492503131e-16
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			elseif a_a___5 = -3.0 then
				a_result.item.val := (-a_x * a_x) / 6.0
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			else
				l_c0___0 := (((3.0 + a_a___5) * (2.0 + a_a___5)) * (1.0 + a_a___5)) / 6.0
				l_c1___2 := (-l_c0___0 * 3.0) / (1.0 + a_a___5)
				l_c2___0 := -1.0 / (2.0 + a_a___5)
				l_c3___3 := -1.0 / (3.0 * (3.0 + a_a___5))
				a_result.item.val := l_c0___0 + (l_c1___2 * a_x) * (1.0 + (l_c2___0 * a_x) * (1.0 + l_c3___3 * a_x))
				a_result.item.err := 1.0 + 2.0 * (fabs (l_c3___3 * a_x))
				a_result.item.err := 1.0 + (2.0 * (fabs (l_c2___0 * a_x))) * a_result.item.err
				l_tmp___4 := fabs (l_c0___0)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___4 + (2.0 * (fabs (l_c1___2 * a_x))) * a_result.item.err)
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	gsl_sf_laguerre_n (a_n: INTEGER_32; a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_laguerre_n_e (a_n, a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_laguerre_n_e(n, a, x, &result)"), ce_string ("laguerre.c"), 334, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_laguerre_n_e (a_n: INTEGER_32; a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tmp___1: REAL_64
			l_product: REAL_64
			l_k: INTEGER_32
			l_lg2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_lg2: INTEGER_32
			l_Lkm1: REAL_64
			l_Lk: REAL_64
			l_Lkp1: REAL_64
			l_k___0: INTEGER_32
			l_tmp___9: REAL_64
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lg2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_n < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("laguerre.c"), 244, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 3 then -- else:
						if a_n /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 6 then -- else:
						if a_n /= 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := (1.0 + a_a___5) - a_x
						l_tmp___1 := fabs (a_a___5)
						a_result.item.err := (2.0 * 2.2204460492503131e-16) * ((1.0 + l_tmp___1) + (fabs (a_x)))
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 9 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_product := a_a___5 + 1.0
						l_k := 2
						from
						until
							not (l_k <= a_n)
						loop
							l_product := l_product * ((a_a___5 + l_k.to_double) / l_k.to_double)
							l_k := l_k + 1
						end
						a_result.item.val := l_product
						a_result.item.err := ((2.0 * (a_n.to_double + 1.0)) * 2.2204460492503131e-16) * (fabs (l_product)) + 2.2204460492503131e-16
						Result := 0
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 12 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_a___5 > -1.0 then
							Result := (laguerre_n_cp (a_n, a_a___5, a_x, a_result))
							js.return
						else
							l_pos := -1 + 15 -- goto _L___5
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 15 then -- else: | _L___5:
						if not (a_n < 5) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 20 -- goto _L___3
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 18 then -- else:
						if not (a_x > 0.0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if not (a_a___5 < (-a_n - 1).to_double) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___3:
						if (laguerre_n_cp (a_n, a_a___5, a_x, a_result)) = 0 then
							Result := 0
							js.return
						else
							Result := (laguerre_n_poly_safe (a_n, a_a___5, a_x, a_result))
							js.return
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___4
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 24 then -- else: | _L___4:
						if not (a_n.to_double > 1.0e+07) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if a_x > 0.0 then
							if a_a___5 > -1.0 then
								if a_x < 2.0 * (a_a___5 + 1.0) + 4.0 * a_n.to_double then
									Result := (laguerre_large_n (a_n, a_a___5, a_x, a_result))
									js.return
								else
									l_pos := -1 + 27 -- goto _L___2
								end
							else
								l_pos := -1 + 27 -- goto _L___2
							end
						else
							l_pos := -1 + 27 -- goto _L___2
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 27 then -- else: | _L___2:
						if not (a_a___5 >= 0.0) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 32 -- goto _L
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 30 then -- else:
						if not (a_x > 0.0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 31 then -- if:
						if not (a_a___5 < (-a_n - 1).to_double) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L:
						l_stat_lg2 := (gsl_sf_laguerre_2_e (a_a___5, a_x, l_lg2))
						l_Lkm1 := (1.0 + a_a___5) - a_x
						l_Lk := l_lg2.item.val
						l_k___0 := 2
						from
						until
							not (l_k___0 < a_n)
						loop
							l_Lkp1 := (-(l_k___0.to_double + a_a___5) * l_Lkm1 + (((2.0 * l_k___0.to_double + a_a___5) + 1.0) - a_x) * l_Lk) / (l_k___0.to_double + 1.0)
							l_Lkm1 := l_Lk
							l_Lk := l_Lkp1
							l_k___0 := l_k___0 + 1
						end
						a_result.item.val := l_Lk
						l_tmp___9 := fabs (l_lg2.item.err / l_lg2.item.val)
						a_result.item.err := ((l_tmp___9 + 2.2204460492503131e-16) * a_n.to_double) * (fabs (l_Lk))
						Result := l_stat_lg2
						js.return
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_tmp___11 := laguerre_n_poly_safe (a_n, a_a___5, a_x, a_result)
						Result := l_tmp___11
						js.return
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_tmp___11 := laguerre_n_poly_safe (a_n, a_a___5, a_x, a_result)
						Result := l_tmp___11
						js.return
				when 37 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 38 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	laguerre_large_n (a_n: INTEGER_32; a_alpha: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_eta: REAL_64
			l_cos2th: REAL_64
			l_sin2th: REAL_64
			l_eps: REAL_64
			l_pre_h: REAL_64
			l_lg_b: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lnfact: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_lg: INTEGER_32
			l_stat_lf: INTEGER_32
			l_pre_term1: REAL_64
			l_pre_term2: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_tmp___5: REAL_64
			l_phi1: REAL_64
			l_ser_term1: REAL_64
			l_A1___0: REAL_64
			l_ser_term2: REAL_64
			l_tmp___9: REAL_64
			l_ser_val: REAL_64
			l_ser_err: REAL_64
			l_tmp___11: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
		do
			create l_lg_b.make (<<1>>)
			create l_lnfact.make (<<1>>)

			l_a___5 := (-a_n).to_double
			l_b___0 := a_alpha + 1.0
			l_eta := 2.0 * l_b___0 - 4.0 * l_a___5
			l_cos2th := a_x / l_eta
			l_sin2th := 1.0 - l_cos2th
			l_eps := (asin ((sqrt (l_cos2th))))
			l_pre_h := (((((0.25 * 3.14159265358979323846) * 3.14159265358979323846) * l_eta) * l_eta) * l_cos2th) * l_sin2th
			l_stat_lg := (gamma_inst.gsl_sf_lngamma_e (l_b___0 + a_n.to_double, l_lg_b))
			l_stat_lf := (gamma_inst.gsl_sf_lnfact_e (a_n.to_natural_32, l_lnfact))
			l_pre_term1 := (0.5 * (1.0 - l_b___0)) * (log ((0.25 * a_x) * l_eta))
			l_pre_term2 := 0.25 * (log (l_pre_h))
			l_lnpre_val := (((l_lg_b.item.val - l_lnfact.item.val) + 0.5 * a_x) + l_pre_term1) - l_pre_term2
			l_tmp___5 := fabs (l_pre_term1)
			l_lnpre_err := (l_lg_b.item.err + l_lnfact.item.err) + 2.2204460492503131e-16 * (l_tmp___5 + (fabs (l_pre_term2)))
			l_phi1 := (0.25 * l_eta) * ((2).to_double * l_eps + (sin (2.0 * l_eps)))
			l_ser_term1 := -(sin (l_phi1))
			l_A1___0 := (1.0 / 12.0) * ((5.0 / (4.0 * l_sin2th) + (((3.0 * l_b___0) * l_b___0 - 6.0 * l_b___0) + 2.0) * l_sin2th) - 1.0)
			l_tmp___9 := cos (l_phi1)
			l_ser_term2 := (-l_A1___0 * l_tmp___9) / ((0.25 * l_eta) * (sin (2.0 * l_eps)))
			l_ser_val := l_ser_term1 + l_ser_term2
			l_tmp___11 := fabs (l_ser_term1)
			l_ser_err := l_ser_term2 * l_ser_term2 + 2.2204460492503131e-16 * (l_tmp___11 + (fabs (l_ser_term2)))
			l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val, l_lnpre_err, l_ser_val, l_ser_err, a_result))
			a_result.item.err := a_result.item.err + ((2.0 * 1.4901161193847656e-08) * (fabs (a_result.item.val)))
			if l_stat_e /= 0 then
				l_tmp___17 := l_stat_e
			else
				if l_stat_lf /= 0 then
					l_tmp___16 := l_stat_lf
				else
					if l_stat_lg /= 0 then
						l_tmp___15 := l_stat_lg
					else
						l_tmp___15 := 0
					end
					l_tmp___16 := l_tmp___15
				end
				l_tmp___17 := l_tmp___16
			end
			Result := l_tmp___17
		end

	laguerre_n_cp (a_n: INTEGER_32; a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lnfact: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s1: CE_ARRAY [REAL_64]
			l_s2: CE_ARRAY [REAL_64]
			l_stat_f: INTEGER_32
			l_stat_g1: INTEGER_32
			l_stat_g2: INTEGER_32
			l_poly_1F1_val: REAL_64
			l_poly_1F1_err: REAL_64
			l_stat_e: INTEGER_32
			l_k: INTEGER_32
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_t: REAL_64
			l_r___3: REAL_64
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
		do
			create l_lnfact.make (<<1>>)
			create l_lg1.make (<<1>>)
			create l_lg2.make (<<1>>)
			create l_s1.make (<<1>>)
			create l_s2.make (<<1>>)

			l_stat_f := (gamma_inst.gsl_sf_lnfact_e (a_n.to_natural_32, l_lnfact))
			l_stat_g1 := (gamma_inst.gsl_sf_lngamma_sgn_e ((a_a___5 + 1.0) + a_n.to_double, l_lg1, l_s1))
			l_stat_g2 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5 + 1.0, l_lg2, l_s2))
			l_poly_1F1_val := 1.0
			l_poly_1F1_err := 0.0
			l_lnpre_val := (l_lg1.item.val - l_lg2.item.val) - l_lnfact.item.val
			l_lnpre_err := ((l_lg1.item.err + l_lg2.item.err) + l_lnfact.item.err) + (2.0 * 2.2204460492503131e-16) * (fabs (l_lnpre_val))
			l_k := a_n - 1
			from
			until
				not (not js.loop_done and then (l_k >= 0))
			loop
				l_t := ((-a_n + l_k).to_double / ((a_a___5 + 1.0) + l_k.to_double)) * (a_x / (l_k + 1).to_double)
				l_r___3 := l_t + 1.0 / l_poly_1F1_val
				if l_r___3 > (0.9 * 1.7976931348623157e+308) / l_poly_1F1_val then
					from
					until
						js.loop_done
					loop
						a_result.item.val := (builtin_inff).to_double
						a_result.item.err := (builtin_inff).to_double
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
				else
					l_poly_1F1_val := 1.0 + l_t * l_poly_1F1_val
					l_poly_1F1_err := l_poly_1F1_err + (2.2204460492503131e-16 + (fabs (l_t)) * l_poly_1F1_err)
				end
				if not js.return_called then
					l_k := l_k - 1
				end
			end
			if not js.return_called then
				l_stat_e := exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val, l_lnpre_err, l_poly_1F1_val, l_poly_1F1_err, a_result)
				if l_stat_e /= 0 then
					l_tmp___9 := l_stat_e
				else
					if l_stat_f /= 0 then
						l_tmp___8 := l_stat_f
					else
						if l_stat_g1 /= 0 then
							l_tmp___7 := l_stat_g1
						else
							if l_stat_g2 /= 0 then
								l_tmp___6 := l_stat_g2
							else
								l_tmp___6 := 0
							end
							l_tmp___7 := l_tmp___6
						end
						l_tmp___8 := l_tmp___7
					end
					l_tmp___9 := l_tmp___8
				end
				Result := l_tmp___9
			end
		end

	laguerre_n_poly_safe (a_n: INTEGER_32; a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_b___0: REAL_64
			l_mx: REAL_64
			l_tc_sgn: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tc: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_tc: INTEGER_32
			l_term: REAL_64
			l_sum_val: REAL_64
			l_sum_err: REAL_64
			l_k: INTEGER_32
		do
			create l_tc.make (<<1>>)

			l_b___0 := a_a___5 + 1.0
			l_mx := -a_x
			if a_x < 0.0 then
				l_tmp___0 := 1.0
			else
				if ((a_n).bit_and (1)).to_boolean then
					l_tmp := -1.0
				else
					l_tmp := 1.0
				end
				l_tmp___0 := l_tmp
			end
			l_tc_sgn := l_tmp___0
			l_stat_tc := (gamma_inst.gsl_sf_taylorcoeff_e (a_n, (fabs (a_x)), l_tc))
			if l_stat_tc = 0 then
				l_term := l_tc.item.val * l_tc_sgn
				l_sum_val := l_term
				l_sum_err := l_tc.item.err
				l_k := a_n - 1
				from
				until
					not (l_k >= 0)
				loop
					l_term := l_term * ((((l_b___0 + l_k.to_double) / (a_n - l_k).to_double) * (l_k.to_double + 1.0)) / l_mx)
					l_sum_val := l_sum_val + l_term
					l_sum_err := l_sum_err + ((4.0 * 2.2204460492503131e-16) * (fabs (l_term)))
					l_k := l_k - 1
				end
				a_result.item.val := l_sum_val
				a_result.item.err := l_sum_err + (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			elseif l_stat_tc = 16 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := l_stat_tc
			else
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := l_stat_tc
			end
		end

end
