class
	P_LANDAU

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create A1.make (<<3>>)
			create A2.make (<<2>>)
			create F.make (<<983>>)
			create P1.make (<<5>>)
			create P2.make (<<5>>)
			create P3.make (<<5>>)
			create P4.make (<<5>>)
			create P5.make (<<5>>)
			create P6.make (<<5>>)
			create Q1.make (<<5>>)
			create Q2.make (<<5>>)
			create Q3.make (<<5>>)
			create Q4.make (<<5>>)
			create Q5.make (<<5>>)
			create Q6.make (<<5>>)
		end

feature {ANY} -- attributes

	A1: CE_ARRAY [REAL_64]

	A2: CE_ARRAY [REAL_64]

	F: CE_ARRAY [REAL_64]

	P1: CE_ARRAY [REAL_64]

	P2: CE_ARRAY [REAL_64]

	P3: CE_ARRAY [REAL_64]

	P4: CE_ARRAY [REAL_64]

	P5: CE_ARRAY [REAL_64]

	P6: CE_ARRAY [REAL_64]

	Q1: CE_ARRAY [REAL_64]

	Q2: CE_ARRAY [REAL_64]

	Q3: CE_ARRAY [REAL_64]

	Q4: CE_ARRAY [REAL_64]

	Q5: CE_ARRAY [REAL_64]

	Q6: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_ran_landau (a_r___3: CE_POINTER [PD_GSL_RNG]): REAL_64
		local
			l_X: REAL_64
			l_U: REAL_64
			l_V: REAL_64
			l_RANLAN: REAL_64
			l_I: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_X := gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)
					l_U := 1000.0 * l_X
					l_I := l_U.truncated_to_integer
					l_U := l_U - l_I.to_double
					if not (l_I >= 70) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_I <= 800 then
							l_RANLAN := F[l_I] + l_U * (F[l_I + 1] - F[l_I])
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (l_I >= 7) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_I <= 980 then
							l_RANLAN := F[l_I] + l_U * ((F[l_I + 1] - F[l_I]) - (0.25 * ((1).to_double - l_U)) * (((F[l_I + 2] - F[l_I + 1]) - F[l_I]) + F[l_I - 1]))
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_I < 7 then
							l_V := log (l_X)
							l_U := (1).to_double / l_V
							l_RANLAN := ((0.99858950 + (3.45213058e1 + 1.70854528e1 * l_U) * l_U) / ((1).to_double + (3.41760202e1 + 4.01244582 * l_U) * l_U)) * (-(log (-0.91893853 - l_V)) - (1).to_double)
						else
							l_U := (1).to_double - l_X
							l_V := l_U * l_U
							if l_X <= 0.999 then
								l_RANLAN := ((1.00060006 + 2.63991156e2 * l_U) + 4.37320068e3 * l_V) / ((((1).to_double + 2.57368075e2 * l_U) + 3.41448018e3 * l_V) * l_U)
							else
								l_RANLAN := ((1.00001538 + 6.07514119e3 * l_U) + 7.34266409e5 * l_V) / ((((1).to_double + 6.06511919e3 * l_U) + 6.94021044e5 * l_V) * l_U)
							end
						end
				when 7 then -- if done
						Result := l_RANLAN
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_ran_landau_pdf (a_x: REAL_64): REAL_64
		local
			l_U: REAL_64
			l_V: REAL_64
			l_DENLAN: REAL_64
			l_tmp: REAL_64
			l_tmp___1: REAL_64
		do
			l_V := a_x
			if l_V < -5.5 then
				l_U := exp (l_V + 1.0)
				l_tmp := exp ((-1).to_double / l_U)
				l_DENLAN := (0.3989422803 * (l_tmp / (sqrt (l_U)))) * ((1).to_double + (A1[0] + (A1[1] + A1[2] * l_U) * l_U) * l_U)
			elseif l_V < (-1).to_double then
				l_U := exp (-l_V - (1).to_double)
				l_tmp___1 := exp (-l_U)
				l_DENLAN := ((l_tmp___1 * (sqrt (l_U))) * (P1[0] + (P1[1] + (P1[2] + (P1[3] + P1[4] * l_V) * l_V) * l_V) * l_V)) / (Q1[0] + (Q1[1] + (Q1[2] + (Q1[3] + Q1[4] * l_V) * l_V) * l_V) * l_V)
			elseif l_V < (1).to_double then
				l_DENLAN := (P2[0] + (P2[1] + (P2[2] + (P2[3] + P2[4] * l_V) * l_V) * l_V) * l_V) / (Q2[0] + (Q2[1] + (Q2[2] + (Q2[3] + Q2[4] * l_V) * l_V) * l_V) * l_V)
			elseif l_V < (5).to_double then
				l_DENLAN := (P3[0] + (P3[1] + (P3[2] + (P3[3] + P3[4] * l_V) * l_V) * l_V) * l_V) / (Q3[0] + (Q3[1] + (Q3[2] + (Q3[3] + Q3[4] * l_V) * l_V) * l_V) * l_V)
			elseif l_V < (12).to_double then
				l_U := (1).to_double / l_V
				l_DENLAN := ((l_U * l_U) * (P4[0] + (P4[1] + (P4[2] + (P4[3] + P4[4] * l_U) * l_U) * l_U) * l_U)) / (Q4[0] + (Q4[1] + (Q4[2] + (Q4[3] + Q4[4] * l_U) * l_U) * l_U) * l_U)
			elseif l_V < (50).to_double then
				l_U := (1).to_double / l_V
				l_DENLAN := ((l_U * l_U) * (P5[0] + (P5[1] + (P5[2] + (P5[3] + P5[4] * l_U) * l_U) * l_U) * l_U)) / (Q5[0] + (Q5[1] + (Q5[2] + (Q5[3] + Q5[4] * l_U) * l_U) * l_U) * l_U)
			elseif l_V < (300).to_double then
				l_U := (1).to_double / l_V
				l_DENLAN := ((l_U * l_U) * (P6[0] + (P6[1] + (P6[2] + (P6[3] + P6[4] * l_U) * l_U) * l_U) * l_U)) / (Q6[0] + (Q6[1] + (Q6[2] + (Q6[3] + Q6[4] * l_U) * l_U) * l_U) * l_U)
			else
				l_U := (1).to_double / (l_V - (l_V * (log (l_V))) / (l_V + (1).to_double))
				l_DENLAN := (l_U * l_U) * ((1).to_double + (A2[0] + A2[1] * l_U) * l_U)
			end
			Result := l_DENLAN
		end

end
