class
	P_LAPLACEINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_laplace_Pinv (a_P___2: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_x: REAL_64
			js: JUMP_STATE
		do
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_P___2 = 0.0 then
				Result := (-(builtin_inff)).to_double
				js.return
			end
			if not js.return_called then
				if a_P___2 < 0.5 then
					l_x := a_a___5 * (log ((2).to_double * a_P___2))
				else
					l_x := -a_a___5 * (log ((2).to_double * ((1).to_double - a_P___2)))
				end
				Result := l_x
			end
		end

	gsl_cdf_laplace_Qinv (a_Q___1: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_x: REAL_64
			js: JUMP_STATE
		do
			if a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_Q___1 = 1.0 then
				Result := (-(builtin_inff)).to_double
				js.return
			end
			if not js.return_called then
				if a_Q___1 < 0.5 then
					l_x := -a_a___5 * (log ((2).to_double * a_Q___1))
				else
					l_x := a_a___5 * (log ((2).to_double * ((1).to_double - a_Q___1)))
				end
				Result := l_x
			end
		end

end
