class
	P_LEVY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_levy (a_r___3: CE_POINTER [PD_GSL_RNG]; a_c___1: REAL_64; a_alpha: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_v: REAL_64
			l_t: REAL_64
			l_s: REAL_64
			l_tmp___0: REAL_64
			l_tmp___2: REAL_64
			js: JUMP_STATE
		do
			l_u := 3.14159265358979323846 * ((gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)) - 0.5)
			if a_alpha = (1).to_double then
				l_t := tan (l_u)
				Result := (a_c___1 * l_t)
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_v := exponential_inst.gsl_ran_exponential (a_r___3, 1.0)
					if l_v /= (0).to_double then
						js.break
					end
				end
				if a_alpha = (2).to_double then
					l_tmp___0 := sin (l_u)
					l_t := ((2).to_double * l_tmp___0) * (sqrt (l_v))
					Result := (a_c___1 * l_t)
					js.return
				end
			end
			if not js.return_called then
				l_tmp___2 := sin (a_alpha * l_u)
				l_t := l_tmp___2 / (pow ((cos (l_u)), (1).to_double / a_alpha))
				l_s := pow ((cos (((1).to_double - a_alpha) * l_u)) / l_v, ((1).to_double - a_alpha) / a_alpha)
				Result := ((a_c___1 * l_t) * l_s)
			end
		end

	gsl_ran_levy_skew (a_r___3: CE_POINTER [PD_GSL_RNG]; a_c___1: REAL_64; a_alpha: REAL_64; a_beta: REAL_64): REAL_64
		local
			l_V: REAL_64
			l_W: REAL_64
			l_X: REAL_64
			l_tmp___1: REAL_64
			l_t: REAL_64
			l_B: REAL_64
			l_S: REAL_64
			l_tmp___8: REAL_64
			l_tmp___10: REAL_64
			js: JUMP_STATE
		do
			if a_beta = (0).to_double then
				Result := (gsl_ran_levy (a_r___3, a_c___1, a_alpha))
				js.return
			end
			if not js.return_called then
				l_V := 3.14159265358979323846 * ((gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)) - 0.5)
				from
				until
					js.loop_done
				loop
					l_W := exponential_inst.gsl_ran_exponential (a_r___3, 1.0)
					if l_W /= (0).to_double then
						js.break
					end
				end
				if a_alpha = (1).to_double then
					l_tmp___1 := tan (l_V)
					l_X := ((1.57079632679489661923 + a_beta * l_V) * l_tmp___1 - a_beta * (log (((1.57079632679489661923 * l_W) * (cos (l_V))) / (1.57079632679489661923 + a_beta * l_V)))) / 1.57079632679489661923
					Result := (a_c___1 * (l_X + (a_beta * (log (a_c___1))) / 1.57079632679489661923))
				else
					l_t := a_beta * (tan (1.57079632679489661923 * a_alpha))
					l_B := (atan (l_t)) / a_alpha
					l_S := (pow ((1).to_double + l_t * l_t, (1).to_double / ((2).to_double * a_alpha)))
					l_tmp___8 := sin (a_alpha * (l_V + l_B))
					l_tmp___10 := pow ((cos (l_V)), (1).to_double / a_alpha)
					l_X := ((l_S * l_tmp___8) / l_tmp___10) * (pow ((cos (l_V - a_alpha * (l_V + l_B))) / l_W, ((1).to_double - a_alpha) / a_alpha))
					Result := (a_c___1 * l_X)
				end
			end
		end

end
