class
	P_LMDER

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_multifit_fdfsolver_lmder.make
			create gsl_multifit_fdfsolver_lmsder.make
			create lmder_type.make (<<1>>)
			create lmsder_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_multifit_fdfsolver_lmder: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE] assign set_gsl_multifit_fdfsolver_lmder

	set_gsl_multifit_fdfsolver_lmder (a_gsl_multifit_fdfsolver_lmder: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE])
		do
			gsl_multifit_fdfsolver_lmder := a_gsl_multifit_fdfsolver_lmder
		end

	gsl_multifit_fdfsolver_lmsder: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE] assign set_gsl_multifit_fdfsolver_lmsder

	set_gsl_multifit_fdfsolver_lmsder (a_gsl_multifit_fdfsolver_lmsder: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE])
		do
			gsl_multifit_fdfsolver_lmsder := a_gsl_multifit_fdfsolver_lmsder
		end

	lmder_type: CE_ARRAY [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]

	lmsder_type: CE_ARRAY [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]

feature {ANY} -- routines

	lmder_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32; a_p: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_newton: CE_POINTER [PD_GSL_VECTOR]
			l_gradient: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_sdiag: CE_POINTER [PD_GSL_VECTOR]
			l_rptdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_work1: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make
			create l_qtf.make
			create l_newton.make
			create l_gradient.make
			create l_x_trial.make
			create l_f_trial.make
			create l_df.make
			create l_sdiag.make
			create l_rptdx.make
			create l_w.make
			create l_work1.make
			create l_perm.make

			l_state := create {CE_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate)
			l_r___3 := init_source_inst.gsl_matrix_calloc (a_n, a_p)
			if l_r___3.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for r"), ce_string ("lmder.c"), 87, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.r := l_r___3
				if a_n < a_p then
					l_tmp := a_n
				else
					l_tmp := a_p
				end
				l_tau := init_source_inst.gsl_vector_calloc (l_tmp)
				if l_tau.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("lmder.c"), 98, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.tau := l_tau
				l_diag := init_source_inst.gsl_vector_calloc (a_p)
				if l_diag.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diag"), ce_string ("lmder.c"), 110, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.diag := l_diag
				l_qtf := init_source_inst.gsl_vector_calloc (a_n)
				if l_qtf.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for qtf"), ce_string ("lmder.c"), 123, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.qtf := l_qtf
				l_newton := init_source_inst.gsl_vector_calloc (a_p)
				if l_newton.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for newton"), ce_string ("lmder.c"), 137, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.newton := l_newton
				l_gradient := init_source_inst.gsl_vector_calloc (a_p)
				if l_gradient.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("lmder.c"), 152, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.gradient := l_gradient
				l_x_trial := init_source_inst.gsl_vector_calloc (a_p)
				if l_x_trial.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("lmder.c"), 168, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.x_trial := l_x_trial
				l_f_trial := init_source_inst.gsl_vector_calloc (a_n)
				if l_f_trial.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for f_trial"), ce_string ("lmder.c"), 185, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.f_trial := l_f_trial
				l_df := init_source_inst.gsl_vector_calloc (a_n)
				if l_df.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for df"), ce_string ("lmder.c"), 203, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.df := l_df
				l_sdiag := init_source_inst.gsl_vector_calloc (a_p)
				if l_sdiag.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for sdiag"), ce_string ("lmder.c"), 222, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.sdiag := l_sdiag
				l_rptdx := init_source_inst.gsl_vector_calloc (a_n)
				if l_rptdx.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_sdiag)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for rptdx"), ce_string ("lmder.c"), 243, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.rptdx := l_rptdx
				l_w := init_source_inst.gsl_vector_calloc (a_n)
				if l_w.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_sdiag)
					init_source_inst.gsl_vector_free (l_rptdx)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for w"), ce_string ("lmder.c"), 264, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.w := l_w
				l_work1 := init_source_inst.gsl_vector_calloc (a_p)
				if l_work1.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_sdiag)
					init_source_inst.gsl_vector_free (l_rptdx)
					init_source_inst.gsl_vector_free (l_w)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for work1"), ce_string ("lmder.c"), 286, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.work1 := l_work1
				l_perm := init_inst.gsl_permutation_calloc (a_p)
				if l_perm.is_void then
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_sdiag)
					init_source_inst.gsl_vector_free (l_rptdx)
					init_source_inst.gsl_vector_free (l_w)
					init_source_inst.gsl_vector_free (l_work1)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for perm"), ce_string ("lmder.c"), 309, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.perm := l_perm
				Result := 0
			end
		end

	lmder_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lmder_alloc)
		end

	lmder_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate)
			init_inst.gsl_permutation_free (l_state.item.perm)
			init_source_inst.gsl_vector_free (l_state.item.work1)
			init_source_inst.gsl_vector_free (l_state.item.w)
			init_source_inst.gsl_vector_free (l_state.item.rptdx)
			init_source_inst.gsl_vector_free (l_state.item.sdiag)
			init_source_inst.gsl_vector_free (l_state.item.df)
			init_source_inst.gsl_vector_free (l_state.item.f_trial)
			init_source_inst.gsl_vector_free (l_state.item.x_trial)
			init_source_inst.gsl_vector_free (l_state.item.gradient)
			init_source_inst.gsl_vector_free (l_state.item.newton)
			init_source_inst.gsl_vector_free (l_state.item.qtf)
			init_source_inst.gsl_vector_free (l_state.item.diag)
			init_source_inst.gsl_vector_free (l_state.item.tau)
			init_source_inst.gsl_matrix_free (l_state.item.r)
		end

	lmder_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lmder_free)
		end

	lmder_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (lmiterate_inst.iterate (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 0))
			Result := l_status
		end

	lmder_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lmder_iterate)
		end

	lmder_set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (lmset_inst.set (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 0))
			Result := l_status
		end

	lmder_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lmder_set)
		end

	lmsder_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (lmiterate_inst.iterate (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 1))
			Result := l_status
		end

	lmsder_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lmsder_iterate)
		end

	lmsder_set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (lmset_inst.set (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 1))
			Result := l_status
		end

	lmsder_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lmsder_set)
		end

end
