class
	P_LOGNORMAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_lognormal_P (a_x: REAL_64; a_zeta: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
		do
			l_u := ((log (a_x)) - a_zeta) / a_sigma
			l_P___2 := (gauss_inst.gsl_cdf_ugaussian_P (l_u))
			Result := l_P___2
		end

	gsl_cdf_lognormal_Q (a_x: REAL_64; a_zeta: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
		do
			l_u := ((log (a_x)) - a_zeta) / a_sigma
			l_Q___1 := (gauss_inst.gsl_cdf_ugaussian_Q (l_u))
			Result := l_Q___1
		end

	gsl_ran_lognormal (a_r___3: CE_POINTER [PD_GSL_RNG]; a_zeta: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_v: REAL_64
			l_r2___0: REAL_64
			l_normal: REAL_64
			l_z: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l_u := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_v := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_r2___0 := l_u * l_u + l_v * l_v
				if not (l_r2___0 > 1.0) then
					if l_r2___0 /= (0).to_double then
						js.break
					end
				end
			end
			l_normal := l_u * (sqrt ((-2.0 * (log (l_r2___0))) / l_r2___0))
			l_z := exp (a_sigma * l_normal + a_zeta)
			Result := l_z
		end

	gsl_ran_lognormal_pdf (a_x: REAL_64; a_zeta: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_u := ((log (a_x)) - a_zeta) / a_sigma
				l_tmp___0 := fabs (a_sigma)
				l_tmp___1 := sqrt ((2).to_double * 3.14159265358979323846)
				l_p := ((1).to_double / ((a_x * l_tmp___0) * l_tmp___1)) * (exp (-(l_u * l_u) / (2).to_double))
				Result := l_p
			end
		end

end
