class
	P_LOGNORMALINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_lognormal_Pinv (a_P___2: REAL_64; a_zeta: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_P___2 = 0.0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l_u := gaussinv_inst.gsl_cdf_ugaussian_Pinv (a_P___2)
				l_x := exp (a_zeta + a_sigma * l_u)
				Result := l_x
			end
		end

	gsl_cdf_lognormal_Qinv (a_Q___1: REAL_64; a_zeta: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_u: REAL_64
			js: JUMP_STATE
		do
			if a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_Q___1 = 1.0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l_u := gaussinv_inst.gsl_cdf_ugaussian_Qinv (a_Q___1)
				l_x := exp (a_zeta + a_sigma * l_u)
				Result := l_x
			end
		end

end
