class
	P_MT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_default.make
			create gsl_rng_mt19937.make
			create gsl_rng_mt19937_1998.make
			create gsl_rng_mt19937_1999.make
			create mt_1998_type.make (<<1>>)
			create mt_1999_type.make (<<1>>)
			create mt_type.make (<<1>>)
		end

feature {ANY} -- attributes

	LOWER_MASK: NATURAL_32 assign set_LOWER_MASK

	set_LOWER_MASK (a_LOWER_MASK: NATURAL_32)
		do
			LOWER_MASK := a_LOWER_MASK
		end

	UPPER_MASK: NATURAL_32 assign set_UPPER_MASK

	set_UPPER_MASK (a_UPPER_MASK: NATURAL_32)
		do
			UPPER_MASK := a_UPPER_MASK
		end

	gsl_rng_default: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_default

	set_gsl_rng_default (a_gsl_rng_default: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_default := a_gsl_rng_default
		end

	gsl_rng_default_seed: NATURAL_32 assign set_gsl_rng_default_seed

	set_gsl_rng_default_seed (a_gsl_rng_default_seed: NATURAL_32)
		do
			gsl_rng_default_seed := a_gsl_rng_default_seed
		end

	gsl_rng_mt19937: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_mt19937

	set_gsl_rng_mt19937 (a_gsl_rng_mt19937: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_mt19937 := a_gsl_rng_mt19937
		end

	gsl_rng_mt19937_1998: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_mt19937_1998

	set_gsl_rng_mt19937_1998 (a_gsl_rng_mt19937_1998: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_mt19937_1998 := a_gsl_rng_mt19937_1998
		end

	gsl_rng_mt19937_1999: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_mt19937_1999

	set_gsl_rng_mt19937_1999 (a_gsl_rng_mt19937_1999: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_mt19937_1999 := a_gsl_rng_mt19937_1999
		end

	mt_1998_type: CE_ARRAY [PD_GSL_RNG_TYPE]

	mt_1999_type: CE_ARRAY [PD_GSL_RNG_TYPE]

	mt_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	mt_1998_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_state.item.mt[0] := (l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_i := 1
			from
			until
				not (l_i < 624)
			loop
				l_state.item.mt[l_i] := ({NATURAL_32} 69_069 * l_state.item.mt[l_i - 1]).bit_and ({NATURAL_32} 4_294_967_295)
				l_i := l_i + 1
			end
			l_state.item.mti := l_i
		end

	mt_1998_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mt_1998_set)
		end

	mt_1999_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_i := 0
			from
			until
				not (l_i < 624)
			loop
				l_state.item.mt[l_i] := (l_s).bit_and ({NATURAL_32} 4_294_901_760)
				l_s := (({NATURAL_32} 69_069 * l_s + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
				l_state.item.mt[l_i] := (l_state.item.mt[l_i]).bit_or (((((l_s).bit_and ({NATURAL_32} 4_294_901_760))).bit_shift_right (16)))
				l_s := (({NATURAL_32} 69_069 * l_s + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
				l_i := l_i + 1
			end
			l_state.item.mti := l_i
		end

	mt_1999_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mt_1999_set)
		end

	mt_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_k: NATURAL_32
			l_mt: CE_POINTER [NATURAL_32]
			l_kk: INTEGER_32
			l_y: NATURAL_32
			l_tmp: NATURAL_32
			l_y___0: NATURAL_32
			l_tmp___0: NATURAL_32
			l_y___1: NATURAL_32
			l_tmp___1: NATURAL_32
		do
			create l_state.make
			create l_mt.make

			l_state := create {CE_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			l_mt := l_state.item.mt
			if l_state.item.mti >= 624 then
				l_kk := 0
				from
				until
					not (l_kk < 227)
				loop
					l_y := (((l_mt[l_kk]).bit_and (UPPER_MASK))).bit_or (((l_mt[(l_kk + 1)]).bit_and (LOWER_MASK)))
					if ((l_y).bit_and ({NATURAL_32} 1)).to_boolean then
						l_tmp := {NATURAL_32} 2_567_483_615
					else
						l_tmp := {NATURAL_32} 0
					end
					l_mt[l_kk] := (((l_mt[(l_kk + 397)]).bit_xor (((l_y).bit_shift_right (1))))).bit_xor (l_tmp)
					l_kk := l_kk + 1
				end
				from
				until
					not (l_kk < 623)
				loop
					l_y___0 := (((l_mt[l_kk]).bit_and (UPPER_MASK))).bit_or (((l_mt[(l_kk + 1)]).bit_and (LOWER_MASK)))
					if ((l_y___0).bit_and ({NATURAL_32} 1)).to_boolean then
						l_tmp___0 := {NATURAL_32} 2_567_483_615
					else
						l_tmp___0 := {NATURAL_32} 0
					end
					l_mt[l_kk] := (((l_mt[(l_kk + -227)]).bit_xor (((l_y___0).bit_shift_right (1))))).bit_xor (l_tmp___0)
					l_kk := l_kk + 1
				end
				l_y___1 := (((l_mt[623]).bit_and (UPPER_MASK))).bit_or (((l_mt[0]).bit_and (LOWER_MASK)))
				if ((l_y___1).bit_and ({NATURAL_32} 1)).to_boolean then
					l_tmp___1 := {NATURAL_32} 2_567_483_615
				else
					l_tmp___1 := {NATURAL_32} 0
				end
				l_mt[623] := (((l_mt[396]).bit_xor (((l_y___1).bit_shift_right (1))))).bit_xor (l_tmp___1)
				l_state.item.mti := 0
			end
			l_k := l_mt[l_state.item.mti]
			l_k := (l_k).bit_xor (((l_k).bit_shift_right (11)))
			l_k := (l_k).bit_xor (((((l_k).bit_shift_left (7))).bit_and ({NATURAL_32} 2_636_928_640)))
			l_k := (l_k).bit_xor (((((l_k).bit_shift_left (15))).bit_and ({NATURAL_32} 4_022_730_752)))
			l_k := (l_k).bit_xor (((l_k).bit_shift_right (18)))
			l_state.item.mti := (l_state.item.mti) + 1
			Result := l_k
		end

	mt_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mt_get)
		end

	mt_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((mt_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	mt_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mt_get_double)
		end

	mt_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MT_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_MT_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_state.item.mt[0] := (l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_i := 1
			from
			until
				not (l_i < 624)
			loop
				l_state.item.mt[l_i] := {NATURAL_32} 1_812_433_253 * ((l_state.item.mt[l_i - 1]).bit_xor (((l_state.item.mt[l_i - 1]).bit_shift_right (30)))) + l_i.to_natural_32
				l_state.item.mt[l_i] := (l_state.item.mt[l_i]).bit_and (({NATURAL_32} 4_294_967_295))
				l_i := l_i + 1
			end
			l_state.item.mti := l_i
		end

	mt_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mt_set)
		end

end
