class
	P_MULTINOMIAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_multinomial (a_r___3: CE_POINTER [PD_GSL_RNG]; a_K: NATURAL_32; a_N: NATURAL_32; a_p: CE_POINTER [REAL_64]; a_n2: CE_POINTER [NATURAL_32])
		local
			l_k: NATURAL_32
			l_norm___0: REAL_64
			l_sum_p: REAL_64
			l_sum_n: NATURAL_32
		do
			l_norm___0 := 0.0
			l_sum_p := 0.0
			l_sum_n := {NATURAL_32} 0
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_K)
			loop
				l_norm___0 := l_norm___0 + (a_p[l_k.to_integer_32])
				l_k := l_k + 1
			end
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_K)
			loop
				if a_p[l_k.to_integer_32] > 0.0 then
					a_n2[l_k.to_integer_32] := binomial_tpe_inst.gsl_ran_binomial (a_r___3, (a_p[l_k.to_integer_32] / (l_norm___0 - l_sum_p)), a_N - l_sum_n)
				else
					a_n2[l_k.to_integer_32] := {NATURAL_32} 0
				end
				l_sum_p := l_sum_p + (a_p[l_k.to_integer_32])
				l_sum_n := l_sum_n + (a_n2[l_k.to_integer_32])
				l_k := l_k + 1
			end
		end

	gsl_ran_multinomial_lnpdf (a_K: NATURAL_32; a_p: CE_POINTER [REAL_64]; a_n: CE_POINTER [NATURAL_32]): REAL_64
		local
			l_k: NATURAL_32
			l_N: NATURAL_32
			l_log_pdf: REAL_64
			l_norm___0: REAL_64
			l_tmp: REAL_64
		do
			l_N := {NATURAL_32} 0
			l_log_pdf := 0.0
			l_norm___0 := 0.0
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_K)
			loop
				l_N := l_N + (a_n[l_k.to_integer_32])
				l_k := l_k + 1
			end
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_K)
			loop
				l_norm___0 := l_norm___0 + (a_p[l_k.to_integer_32])
				l_k := l_k + 1
			end
			l_log_pdf := gamma_inst.gsl_sf_lnfact (l_N)
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_K)
			loop
				if a_n[l_k.to_integer_32] > {NATURAL_32} 0 then
					l_tmp := log ((a_p[l_k.to_integer_32] / l_norm___0))
					l_log_pdf := l_log_pdf + (l_tmp * (a_n[l_k.to_integer_32]).to_real_64 - (gamma_inst.gsl_sf_lnfact (a_n[l_k.to_integer_32])))
				end
				l_k := l_k + 1
			end
			Result := l_log_pdf
		end

	gsl_ran_multinomial_pdf (a_K: NATURAL_32; a_p: CE_POINTER [REAL_64]; a_n: CE_POINTER [NATURAL_32]): REAL_64
		do
			Result := (exp ((gsl_ran_multinomial_lnpdf (a_K, a_p, a_n))))
		end

end
