class
	P_MULTISET

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multiset_data (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): CE_POINTER [NATURAL_32]
		do
			Result := (a_c___1.item.data)
		end

	gsl_multiset_k (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): NATURAL_32
		do
			Result := (a_c___1.item.k)
		end

	gsl_multiset_memcpy (a_dest: CE_POINTER [PD_GSL_MULTISET_STRUCT]; a_src: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_src_n: NATURAL_32
			l_src_k: NATURAL_32
			l_dest_n: NATURAL_32
			l_dest_k: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_n := a_src.item.n
					l_src_k := a_src.item.k
					l_dest_n := a_dest.item.n
					l_dest_k := a_dest.item.k
					if l_src_n = l_dest_n then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_k = l_dest_k then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("multiset lengths are not equal"), ce_string ("multiset.c"), 168, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_src_k)
							loop
								a_dest.item.data[l_j.to_integer_32] := a_src.item.data[l_j.to_integer_32]
								l_j := l_j + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_multiset_n (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): NATURAL_32
		do
			Result := (a_c___1.item.n)
		end

	gsl_multiset_next (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_c___1.item.n
			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			if l_k = {NATURAL_32} 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_i := l_k - {NATURAL_32} 1
				from
				until
					js.loop_done
				loop
					if l_i > {NATURAL_32} 0 then
						if l_data[l_i.to_integer_32] /= l_n - {NATURAL_32} 1 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i - 1
					end
				end
				if l_i = {NATURAL_32} 0 then
					if l_data[0] = l_n - {NATURAL_32} 1 then
						Result := (-1)
						js.return
					end
				end
			end
			if not js.return_called then
				l_data[l_i.to_integer_32] := (l_data[l_i.to_integer_32]) + 1
				from
				until
					not (l_i < l_k - {NATURAL_32} 1)
				loop
					l_data[(l_i + {NATURAL_32} 1).to_integer_32] := l_data[l_i.to_integer_32]
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_multiset_prev (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_c___1.item.n
			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			if l_k = {NATURAL_32} 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_i := l_k - {NATURAL_32} 1
				from
				until
					js.loop_done
				loop
					if l_i > {NATURAL_32} 0 then
						if l_data[(l_i - {NATURAL_32} 1).to_integer_32] /= l_data[l_i.to_integer_32] then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i - 1
					end
				end
				if l_i = {NATURAL_32} 0 then
					if l_data[l_i.to_integer_32] = {NATURAL_32} 0 then
						Result := (-1)
						js.return
					end
				end
			end
			if not js.return_called then
				l_data[l_i.to_integer_32] := (l_data[l_i.to_integer_32]) - 1
				if l_data[l_i.to_integer_32] < l_n - {NATURAL_32} 1 then
					from
					until
						not (l_i < l_k - {NATURAL_32} 1)
					loop
						l_i := l_i + 1
						l_data[l_i.to_integer_32] := l_n - {NATURAL_32} 1
					end
				end
				Result := 0
			end
		end

	gsl_multiset_valid (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_ci: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_c___1.item.n
			l_k := a_c___1.item.k
			if l_k > l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("multiset has k greater than n"), ce_string ("multiset.c"), 55, -1)
					Result := (-1)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_k))
				loop
					l_ci := a_c___1.item.data[l_i.to_integer_32]
					if l_ci >= l_n then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("multiset index outside range"), ce_string ("multiset.c"), 63, -1)
							Result := (-1)
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_j := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_j < l_i))
						loop
							if a_c___1.item.data[l_j.to_integer_32] > l_ci then
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("multiset indices not in increasing order"), ce_string ("multiset.c"), 71, -1)
									Result := (-1)
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
							if not js.return_called then
								l_j := l_j + 1
							end
						end
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
