class
	P_NEWTON

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_multiroot_fdfsolver_newton.make
			create gsl_root_fdfsolver_newton.make
			create newton_type.make (<<1>>)
			create newton_type___0.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_multiroot_fdfsolver_newton: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE] assign set_gsl_multiroot_fdfsolver_newton

	set_gsl_multiroot_fdfsolver_newton (a_gsl_multiroot_fdfsolver_newton: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE])
		do
			gsl_multiroot_fdfsolver_newton := a_gsl_multiroot_fdfsolver_newton
		end

	gsl_root_fdfsolver_newton: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE] assign set_gsl_root_fdfsolver_newton

	set_gsl_root_fdfsolver_newton (a_gsl_root_fdfsolver_newton: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE])
		do
			gsl_root_fdfsolver_newton := a_gsl_root_fdfsolver_newton
		end

	newton_type: CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]

	newton_type___0: CE_ARRAY [PD_GSL_ROOT_FDFSOLVER_TYPE]

feature {ANY} -- routines

	newton_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T]
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			js: JUMP_STATE
		do
			create l_state.make
			create l_p.make
			create l_m___4.make

			l_state := create {CE_POINTER [PD_NEWTON_STATE_T]}.make_cast (a_vstate)
			l_m___4 := init_source_inst.gsl_matrix_calloc (a_n, a_n)
			if l_m___4.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("newton.c"), 56, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.lu := l_m___4
				l_p := init_inst.gsl_permutation_calloc (a_n)
				if l_p.is_void then
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("newton.c"), 67, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.permutation := l_p
				Result := 0
			end
		end

	newton_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent newton_alloc)
		end

	newton_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_NEWTON_STATE_T]}.make_cast (a_vstate)
			init_source_inst.gsl_matrix_free (l_state.item.lu)
			init_inst.gsl_permutation_free (l_state.item.permutation)
		end

	newton_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent newton_free)
		end

	newton_init (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T2]
			l_x: REAL_64
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_NEWTON_STATE_T2]}.make_cast (a_vstate)
			l_x := a_root.item
			l_state.item.f := (a_fdf.item.f).real_64_item ([l_x, a_fdf.item.params])
			l_state.item.df := (a_fdf.item.df).real_64_item ([l_x, a_fdf.item.params])
			Result := 0
		end

	newton_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent newton_init)
		end

	newton_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T]
			l_signum: CE_ARRAY [INTEGER_32]
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_e: REAL_64
			l_y: REAL_64
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_signum.make (<<1>>)

			l_state := create {CE_POINTER [PD_NEWTON_STATE_T]}.make_cast (a_vstate)
			l_n := a_fdf.item.n
			copy_source_inst.gsl_matrix_memcpy (l_state.item.lu, a_J).do_nothing
			lu_inst.gsl_linalg_LU_decomp (l_state.item.lu, l_state.item.permutation, l_signum).do_nothing
			lu_inst.gsl_linalg_LU_solve (l_state.item.lu, l_state.item.permutation, a_f, a_dx).do_nothing
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_e := (gsl_gsl_vector_double_inst.gsl_vector_get (a_dx, l_i))
				l_y := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, -l_e)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_i, l_y - l_e)
				l_i := l_i + 1
			end
			l_status := ((a_fdf.item.fdf).integer_32_item ([a_x, a_fdf.item.params, a_f, a_J]))
			if l_status /= 0 then
				Result := 9
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	newton_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent newton_iterate)
		end

	newton_iterate___0 (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T2]
			l_root_new: REAL_64
			l_f_new: CE_ARRAY [REAL_64]
			l_df_new: CE_ARRAY [REAL_64]
			js: JUMP_STATE
		do
			create l_state.make
			create l_f_new.make (<<1>>)
			create l_df_new.make (<<1>>)

			l_state := create {CE_POINTER [PD_NEWTON_STATE_T2]}.make_cast (a_vstate)
			if l_state.item.df = 0.0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("derivative is zero"), ce_string ("newton.c"), 74, 12)
					Result := 12
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_root_new := a_root.item - l_state.item.f / l_state.item.df
				a_root.item := l_root_new;
				(a_fdf.item.fdf).call ([l_root_new, a_fdf.item.params, l_f_new, l_df_new])
				l_state.item.f := l_f_new.item
				l_state.item.df := l_df_new.item
				if not (infnan_inst.gsl_finite (l_f_new.item)).to_boolean then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("newton.c"), 88, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				if not (infnan_inst.gsl_finite (l_df_new.item)).to_boolean then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("derivative value is not finite"), ce_string ("newton.c"), 93, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	newton_iterate___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent newton_iterate___0)
		end

	newton_set (a_vstate: CE_POINTER [ANY]; a_FDF: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T]
			l_i: NATURAL_32
			l_n: NATURAL_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_NEWTON_STATE_T]}.make_cast (a_vstate)
			l_n := a_FDF.item.n
			l_state := create {CE_POINTER [PD_NEWTON_STATE_T]}.make_shared (default_pointer);
			(a_FDF.item.fdf).call ([a_x, a_FDF.item.params, a_f, a_J])
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, 0.0)
				l_i := l_i + 1
			end
			Result := 0
		end

	newton_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent newton_set)
		end

end
