class
	P_NIEDERREITER_2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_qrng_niederreiter_2.make
			create nied2_type.make (<<1>>)
			create poly_degree.make (<<13>>)
			create primitive_poly.make (<<13, 6>>)
		end

feature {ANY} -- attributes

	gsl_qrng_niederreiter_2: CE_POINTER [PD_GSL_QRNG_TYPE] assign set_gsl_qrng_niederreiter_2

	set_gsl_qrng_niederreiter_2 (a_gsl_qrng_niederreiter_2: CE_POINTER [PD_GSL_QRNG_TYPE])
		do
			gsl_qrng_niederreiter_2 := a_gsl_qrng_niederreiter_2
		end

	nied2_type: CE_ARRAY [PD_GSL_QRNG_TYPE]

	poly_degree: CE_ARRAY [INTEGER_32]

	primitive_poly: CE_ARRAY [CE_ARRAY [INTEGER_32]]

	recip: REAL_64 assign set_recip

	set_recip (a_recip: REAL_64)
		do
			recip := a_recip
		end

feature {ANY} -- routines

	calculate_cj (a_ns: CE_POINTER [PD_NIED2_STATE_T]; a_dimension: NATURAL_32)
		local
			l_ci: CE_ARRAY [CE_ARRAY [INTEGER_32]]
			l_v: CE_ARRAY [INTEGER_32]
			l_r___3: INTEGER_32
			l_i_dim: NATURAL_32
			l_poly_index: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_u: INTEGER_32
			l_pb: CE_ARRAY [INTEGER_32]
			l_px: CE_ARRAY [INTEGER_32]
			l_px_degree: INTEGER_32
			l_pb_degree: CE_ARRAY [INTEGER_32]
			l_term: INTEGER_32
			js: JUMP_STATE
		do
			create l_ci.make (<<31, 31>>)
			create l_v.make (<<82>>)
			create l_pb.make (<<51>>)
			create l_px.make (<<51>>)
			create l_pb_degree.make (<<1>>)

			l_i_dim := {NATURAL_32} 0
			from
			until
				not (not js.loop_done and then (l_i_dim < a_dimension))
			loop
				l_poly_index := (l_i_dim + {NATURAL_32} 1).to_integer_32
				l_u := 0
				l_px_degree := poly_degree[l_poly_index]
				l_pb_degree.item := 0
				l_k := 0
				from
				until
					not (l_k <= l_px_degree)
				loop
					l_px[l_k] := (primitive_poly[l_poly_index])[l_k]
					l_pb[l_k] := 0
					l_k := l_k + 1
				end
				from
				until
					not (l_k < 51)
				loop
					l_px[l_k] := 0
					l_pb[l_k] := 0
					l_k := l_k + 1
				end
				l_pb[0] := 1
				l_j := 0
				from
				until
					not (not js.loop_done and then (l_j < 31))
				loop
					if l_u = 0 then
						calculate_v (create {CE_POINTER [INTEGER_32]}.make_cast (l_px), l_px_degree, l_pb, l_pb_degree, l_v, 81)
					end
					l_r___3 := 0
					from
					until
						not (l_r___3 < 31)
					loop
						(l_ci[l_r___3])[l_j] := l_v[l_r___3 + l_u]
						l_r___3 := l_r___3 + 1
					end
					l_u := l_u + 1
					if l_u = l_px_degree then
						l_u := 0
					end
					l_j := l_j + 1
				end
				l_r___3 := 0
				from
				until
					not (not js.loop_done and then (l_r___3 < 31))
				loop
					l_term := 0
					l_j := 0
					from
					until
						not (l_j < 31)
					loop
						l_term := 2 * l_term + (l_ci[l_r___3])[l_j]
						l_j := l_j + 1
					end
					(a_ns.item.cj[l_r___3])[l_i_dim.to_integer_32] := l_term
					l_r___3 := l_r___3 + 1
				end
				l_i_dim := l_i_dim + 1
			end
		end

	calculate_v (a_px: CE_POINTER [INTEGER_32]; a_px_degree: INTEGER_32; a_pb: CE_POINTER [INTEGER_32]; a_pb_degree: CE_POINTER [INTEGER_32]; a_v: CE_POINTER [INTEGER_32]; a_maxv: INTEGER_32)
		local
			l_nonzero_element: INTEGER_32
			l_arbitrary_element: INTEGER_32
			l_ph: CE_ARRAY [INTEGER_32]
			l_bigm: INTEGER_32
			l_m___4: INTEGER_32
			l_r___3: INTEGER_32
			l_k: INTEGER_32
			l_kj: INTEGER_32
			l_term: INTEGER_32
			l_term___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ph.make (<<51>>)

			l_nonzero_element := 1
			l_arbitrary_element := 1
			l_bigm := a_pb_degree.item
			l_k := 0
			from
			until
				not (l_k <= 50)
			loop
				l_ph[l_k] := a_pb[l_k]
				l_k := l_k + 1
			end
			poly_multiply (a_px, a_px_degree, a_pb, a_pb_degree.item, a_pb, a_pb_degree)
			l_m___4 := a_pb_degree.item
			l_kj := l_bigm
			l_r___3 := 0
			from
			until
				not (l_r___3 < l_kj)
			loop
				a_v[l_r___3] := 0
				l_r___3 := l_r___3 + 1
			end
			a_v[l_kj] := 1
			if l_kj >= l_bigm then
				l_r___3 := l_kj + 1
				from
				until
					not (l_r___3 < l_m___4)
				loop
					a_v[l_r___3] := l_arbitrary_element
					l_r___3 := l_r___3 + 1
				end
			else
				l_term := l_ph[l_kj] \\ 2
				l_r___3 := l_kj + 1
				from
				until
					not (l_r___3 < l_bigm)
				loop
					a_v[l_r___3] := l_arbitrary_element
					l_term := (l_term + (l_ph[l_r___3] * a_v[l_r___3]) \\ 2) \\ 2
					l_r___3 := l_r___3 + 1
				end
				a_v[l_bigm] := (l_nonzero_element + l_term) \\ 2
				l_r___3 := l_bigm + 1
				from
				until
					not (l_r___3 < l_m___4)
				loop
					a_v[l_r___3] := l_arbitrary_element
					l_r___3 := l_r___3 + 1
				end
			end
			l_r___3 := 0
			from
			until
				not (not js.loop_done and then (l_r___3 <= a_maxv - l_m___4))
			loop
				l_term___0 := 0
				l_k := 0
				from
				until
					not (l_k < l_m___4)
				loop
					l_term___0 := (l_term___0 + (a_pb[l_k] * a_v[(l_r___3 + l_k)]) \\ 2) \\ 2
					l_k := l_k + 1
				end
				a_v[(l_r___3 + l_m___4)] := l_term___0
				l_r___3 := l_r___3 + 1
			end
		end

	nied2_get (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32; a_v: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_n_state: CE_POINTER [PD_NIED2_STATE_T]
			l_r___3: INTEGER_32
			l_c___1: INTEGER_32
			l_i_dim: NATURAL_32
			js: JUMP_STATE
		do
			create l_n_state.make

			l_n_state := create {CE_POINTER [PD_NIED2_STATE_T]}.make_cast (a_state)
			l_i_dim := {NATURAL_32} 0
			from
			until
				not (l_i_dim < a_dimension)
			loop
				a_v[l_i_dim.to_integer_32] := ((l_n_state.item.nextq[l_i_dim.to_integer_32]).to_double * recip)
				l_i_dim := l_i_dim + 1
			end
			l_r___3 := 0
			l_c___1 := (l_n_state.item.sequence_count).to_integer_32
			from
			until
				js.loop_done
			loop
				if l_c___1 \\ 2 = 1 then
					l_r___3 := l_r___3 + 1
					l_c___1 := l_c___1 // (2)
				else
					js.break
				end
			end
			if l_r___3 >= 31 then
				Result := 5
				js.return
			end
			if not js.return_called then
				l_i_dim := {NATURAL_32} 0
				from
				until
					not (l_i_dim < a_dimension)
				loop
					l_n_state.item.nextq[l_i_dim.to_integer_32] := (l_n_state.item.nextq[l_i_dim.to_integer_32]).bit_xor (((l_n_state.item.cj[l_r___3])[l_i_dim.to_integer_32]))
					l_i_dim := l_i_dim + 1
				end
				l_n_state.item.sequence_count := (l_n_state.item.sequence_count) + 1
				Result := 0
			end
		end

	nied2_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nied2_get)
		end

	nied2_init (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32): INTEGER_32
		local
			l_n_state: CE_POINTER [PD_NIED2_STATE_T]
			l_i_dim: NATURAL_32
			js: JUMP_STATE
		do
			create l_n_state.make

			l_n_state := create {CE_POINTER [PD_NIED2_STATE_T]}.make_cast (a_state)
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				js.return
			elseif a_dimension > {NATURAL_32} 12 then
				Result := 4
				js.return
			end
			if not js.return_called then
				calculate_cj (l_n_state, a_dimension)
				l_i_dim := {NATURAL_32} 0
				from
				until
					not (l_i_dim < a_dimension)
				loop
					l_n_state.item.nextq[l_i_dim.to_integer_32] := 0
					l_i_dim := l_i_dim + 1
				end
				l_n_state.item.sequence_count := {NATURAL_32} 0
				Result := 0
			end
		end

	nied2_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nied2_init)
		end

	nied2_state_size (a_dimension: NATURAL_32): NATURAL_32
		do
			Result := ((create {PD_NIED2_STATE_T}.make).structure_size.to_natural_32)
		end

	nied2_state_size_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nied2_state_size)
		end

	poly_multiply (a_pa: CE_POINTER [INTEGER_32]; a_pa_degree: INTEGER_32; a_pb: CE_POINTER [INTEGER_32]; a_pb_degree: INTEGER_32; a_pc: CE_POINTER [INTEGER_32]; a_pc_degree: CE_POINTER [INTEGER_32])
		local
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_pt: CE_ARRAY [INTEGER_32]
			l_pt_degree: INTEGER_32
			l_term: INTEGER_32
			l_conv_term: INTEGER_32
			js: JUMP_STATE
		do
			create l_pt.make (<<51>>)

			l_pt_degree := a_pa_degree + a_pb_degree
			l_k := 0
			from
			until
				not (not js.loop_done and then (l_k <= l_pt_degree))
			loop
				l_term := 0
				l_j := 0
				from
				until
					not (l_j <= l_k)
				loop
					l_conv_term := ((a_pa[(l_k - l_j)] * a_pb[l_j]) \\ 2)
					l_term := (l_term + l_conv_term) \\ 2
					l_j := l_j + 1
				end
				l_pt[l_k] := l_term
				l_k := l_k + 1
			end
			l_k := 0
			from
			until
				not (l_k <= l_pt_degree)
			loop
				a_pc[l_k] := l_pt[l_k]
				l_k := l_k + 1
			end
			l_k := l_pt_degree + 1
			from
			until
				not (l_k <= 50)
			loop
				a_pc[l_k] := 0
				l_k := l_k + 1
			end
			a_pc_degree.item := l_pt_degree
		end

end
