class
	P_OPER_COMPLEX_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_complex_add (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 29, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								a_a___5.item.data[l_aij.to_integer_32] := a_a___5.item.data[l_aij.to_integer_32] + (a_b___0.item.data[l_bij.to_integer_32])
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_add_constant (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] + (a_x.dat[0])
					a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_add_diagonal (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_loop_lim: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_loop_lim := l_tmp
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_loop_lim)
			loop
				a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] + (a_x.dat[0])
				a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_div_elements (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			l_s: REAL_64
			l_sbr: REAL_64
			l_sbi: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 137, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := a_a___5.item.data[l_aij.to_integer_32]
								l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								l_s := 1.0 / (hypot (l_br, l_bi))
								l_sbr := l_s * l_br
								l_sbi := l_s * l_bi
								a_a___5.item.data[l_aij.to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_add (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 29, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								a_a___5.item.data[l_aij.to_integer_32] := a_a___5.item.data[l_aij.to_integer_32] + (a_b___0.item.data[l_bij.to_integer_32])
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_add_constant (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] + (a_x.dat[0])
					a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_float_add_diagonal (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_loop_lim: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_loop_lim := l_tmp
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_loop_lim)
			loop
				a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] + (a_x.dat[0])
				a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_float_div_elements (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_br: REAL_32
			l_bi: REAL_32
			l_s: REAL_32
			l_sbr: REAL_32
			l_sbi: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 137, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := a_a___5.item.data[l_aij.to_integer_32]
								l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								l_s := (1.0 / (hypot (l_br.to_double, l_bi.to_double))).truncated_to_real
								l_sbr := l_s * l_br
								l_sbi := l_s * l_bi
								a_a___5.item.data[l_aij.to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_mul_elements (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_br: REAL_32
			l_bi: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 97, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := a_a___5.item.data[l_aij.to_integer_32]
								l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								a_a___5.item.data[l_aij.to_integer_32] := l_ar * l_br - l_ai * l_bi
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_scale (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xr: REAL_32
			l_xi: REAL_32
			l_aij: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			js: JUMP_STATE
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_aij := {NATURAL_32} 2 * (l_i * l_tda + l_j)
					l_ar := a_a___5.item.data[l_aij.to_integer_32]
					l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
					a_a___5.item.data[l_aij.to_integer_32] := l_ar * l_xr - l_ai * l_xi
					a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_float_sub (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								a_a___5.item.data[l_aij.to_integer_32] := a_a___5.item.data[l_aij.to_integer_32] - (a_b___0.item.data[l_bij.to_integer_32])
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_long_double_add (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 29, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								a_a___5.item.data[l_aij.to_integer_32] := a_a___5.item.data[l_aij.to_integer_32] + (a_b___0.item.data[l_bij.to_integer_32])
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_long_double_add_constant (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_x: PD_GSL_COMPLEX_LONG_DOUBLE): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] + (a_x.dat[0])
					a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_long_double_add_diagonal (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_x: PD_GSL_COMPLEX_LONG_DOUBLE): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_loop_lim: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_loop_lim := l_tmp
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_loop_lim)
			loop
				a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] + (a_x.dat[0])
				a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_long_double_div_elements (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_96
			l_ai: REAL_96
			l_br: REAL_96
			l_bi: REAL_96
			l_s: REAL_96
			l_sbr: REAL_96
			l_sbi: REAL_96
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 137, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := a_a___5.item.data[l_aij.to_integer_32]
								l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								l_s := real_96_from_real_64 ((1.0 / (hypot (l_br.truncated_to_real_64, l_bi.truncated_to_real_64))))
								l_sbr := l_s * l_br
								l_sbi := l_s * l_bi
								a_a___5.item.data[l_aij.to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_long_double_mul_elements (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_96
			l_ai: REAL_96
			l_br: REAL_96
			l_bi: REAL_96
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 97, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := a_a___5.item.data[l_aij.to_integer_32]
								l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								a_a___5.item.data[l_aij.to_integer_32] := l_ar * l_br - l_ai * l_bi
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_long_double_scale (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_x: PD_GSL_COMPLEX_LONG_DOUBLE): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xr: REAL_96
			l_xi: REAL_96
			l_aij: NATURAL_32
			l_ar: REAL_96
			l_ai: REAL_96
			js: JUMP_STATE
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_aij := {NATURAL_32} 2 * (l_i * l_tda + l_j)
					l_ar := a_a___5.item.data[l_aij.to_integer_32]
					l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
					a_a___5.item.data[l_aij.to_integer_32] := l_ar * l_xr - l_ai * l_xi
					a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_long_double_sub (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								a_a___5.item.data[l_aij.to_integer_32] := a_a___5.item.data[l_aij.to_integer_32] - (a_b___0.item.data[l_bij.to_integer_32])
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_mul_elements (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 97, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := a_a___5.item.data[l_aij.to_integer_32]
								l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								a_a___5.item.data[l_aij.to_integer_32] := l_ar * l_br - l_ai * l_bi
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_scale (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xr: REAL_64
			l_xi: REAL_64
			l_aij: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			js: JUMP_STATE
		do
			l_M := a_a___5.item.size1
			l_N := a_a___5.item.size2
			l_tda := a_a___5.item.tda
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_aij := {NATURAL_32} 2 * (l_i * l_tda + l_j)
					l_ar := a_a___5.item.data[l_aij.to_integer_32]
					l_ai := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32]
					a_a___5.item.data[l_aij.to_integer_32] := l_ar * l_xr - l_ai * l_xi
					a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_sub (a_a___5: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_a___5.item.size1
					l_N := a_a___5.item.size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := a_a___5.item.tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								a_a___5.item.data[l_aij.to_integer_32] := a_a___5.item.data[l_aij.to_integer_32] - (a_b___0.item.data[l_bij.to_integer_32])
								a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(l_aij + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_vector_complex_add (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 27, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_add_constant (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_64
			l_xi: REAL_64
		do
			l_N := a_a___5.item.size
			l_stride := a_a___5.item.stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] + l_xr
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] + l_xi
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_div (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			l_s: REAL_64
			l_sbr: REAL_64
			l_sbi: REAL_64
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 111, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					l_s := 1.0 / (hypot (l_br, l_bi))
					l_sbr := l_s * l_br
					l_sbi := l_s * l_bi
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_float_add (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 27, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_float_add_constant (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_32
			l_xi: REAL_32
		do
			l_N := a_a___5.item.size
			l_stride := a_a___5.item.stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] + l_xr
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] + l_xi
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_float_div (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_br: REAL_32
			l_bi: REAL_32
			l_s: REAL_32
			l_sbr: REAL_32
			l_sbi: REAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 111, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					l_s := (1.0 / (hypot (l_br.to_double, l_bi.to_double))).truncated_to_real
					l_sbr := l_s * l_br
					l_sbi := l_s * l_bi
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_float_mul (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_br: REAL_32
			l_bi: REAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 79, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := l_ar * l_br - l_ai * l_bi
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_float_scale (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_32
			l_xi: REAL_32
			l_ar: REAL_32
			l_ai: REAL_32
		do
			l_N := a_a___5.item.size
			l_stride := a_a___5.item.stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32]
				l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32]
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := l_ar * l_xr - l_ai * l_xi
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_float_sub (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 53, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_long_double_add (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 27, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_long_double_add_constant (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_x: PD_GSL_COMPLEX_LONG_DOUBLE): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_96
			l_xi: REAL_96
		do
			l_N := a_a___5.item.size
			l_stride := a_a___5.item.stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] + l_xr
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] + l_xi
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_long_double_div (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_96
			l_ai: REAL_96
			l_br: REAL_96
			l_bi: REAL_96
			l_s: REAL_96
			l_sbr: REAL_96
			l_sbi: REAL_96
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 111, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					l_s := real_96_from_real_64 ((1.0 / (hypot (l_br.truncated_to_real_64, l_bi.truncated_to_real_64))))
					l_sbr := l_s * l_br
					l_sbi := l_s * l_bi
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_long_double_mul (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_96
			l_ai: REAL_96
			l_br: REAL_96
			l_bi: REAL_96
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 79, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := l_ar * l_br - l_ai * l_bi
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_long_double_scale (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_x: PD_GSL_COMPLEX_LONG_DOUBLE): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_96
			l_xi: REAL_96
			l_ar: REAL_96
			l_ai: REAL_96
		do
			l_N := a_a___5.item.size
			l_stride := a_a___5.item.stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32]
				l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32]
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := l_ar * l_xr - l_ai * l_xi
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_long_double_sub (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 53, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_mul (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 79, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := l_ar * l_br - l_ai * l_bi
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_vector_complex_scale (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_64
			l_xi: REAL_64
			l_ar: REAL_64
			l_ai: REAL_64
		do
			l_N := a_a___5.item.size
			l_stride := a_a___5.item.stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ar := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32]
				l_ai := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32]
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := l_ar * l_xr - l_ai * l_xi
				a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_sub (a_a___5: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 53, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := a_a___5.item.data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
