class
	P_PLAIN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_monte_plain_alloc (a_dim: NATURAL_32): CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]
		local
			l_s: CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]}.make_cast ((malloc ((create {PD_GSL_MONTE_PLAIN_STATE}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for state struct"), ce_string ("plain.c"), 114, 8)
					Result := (create {CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.x := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.x).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for working vector"), ce_string ("plain.c"), 123, 8)
						Result := (create {CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_s.item.dim := a_dim
				Result := l_s
			end
		end

	gsl_monte_plain_free (a_s: CE_POINTER [PD_GSL_MONTE_PLAIN_STATE])
		local
			js: JUMP_STATE
		do
			if a_s.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_s.item.x))
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_monte_plain_init (a_s: CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]): INTEGER_32
		local
			l_i: NATURAL_32
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_s.item.dim)
			loop
				a_s.item.x[l_i.to_integer_32] := 0.0
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_monte_plain_integrate (a_f: CE_POINTER [PD_GSL_MONTE_FUNCTION_STRUCT]; a_xl: CE_POINTER [REAL_64]; a_xu: CE_POINTER [REAL_64]; a_dim: NATURAL_32; a_calls: NATURAL_32; a_r___3: CE_POINTER [PD_GSL_RNG]; a_state: CE_POINTER [PD_GSL_MONTE_PLAIN_STATE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_vol: REAL_64
			l_m___4: REAL_64
			l_q___3: REAL_64
			l_x: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_fval: REAL_64
			l_d: REAL_64
			js: JUMP_STATE
		do
			create l_x.make

			l_m___4 := (0).to_double
			l_q___3 := (0).to_double
			l_x := a_state.item.x
			if a_dim /= a_state.item.dim then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("number of dimensions must match allocated size"), ce_string ("plain.c"), 45, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_dim))
				loop
					if a_xu[l_i.to_integer_32] <= a_xl[l_i.to_integer_32] then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("xu must be greater than xl"), ce_string ("plain.c"), 52, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called and then (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32] > 1.7976931348623157e+308) then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("Range of integration is too large, please rescale"), ce_string ("plain.c"), 58, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_vol := (1).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_vol := l_vol * (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_n := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_n < a_calls))
				loop
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_dim)
					loop
						l_x[l_i.to_integer_32] := (a_xl[l_i.to_integer_32] + ((gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)) * (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32])))
						l_i := l_i + 1
					end
					l_fval := ((a_f.item.f).real_64_item ([l_x, a_f.item.dim, a_f.item.params]))
					l_d := l_fval - l_m___4
					l_m___4 := l_m___4 + (l_d / (l_n.to_real_64 + 1.0))
					l_q___3 := l_q___3 + ((l_d * l_d) * (l_n.to_real_64 / (l_n.to_real_64 + 1.0)))
					l_n := l_n + 1
				end
				a_result.item := l_vol * l_m___4
				if a_calls < {NATURAL_32} 2 then
					a_abserr.item := (builtin_inff).to_double
				else
					a_abserr.item := l_vol * (sqrt (l_q___3 / (a_calls.to_real_64 * (a_calls.to_real_64 - 1.0))))
				end
				Result := 0
			end
		end

end
