class
	P_POCH

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create bern.make (<<21>>)
		end

feature {ANY} -- attributes

	bern: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_sf_lnpoch (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_lnpoch_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_lnpoch_e(a, x, &result)"), ce_string ("poch.c"), 454, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_lnpoch_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_a___5 <= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_a___5 + a_x <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("poch.c"), 287, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							Result := (lnpoch_pos (a_a___5, a_x, a_result))
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_lnpoch_sgn_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_sgn: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_result_pos: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
			l_f: REAL_64
			l_s: REAL_64
			l_tmp___3: INTEGER_32
			l_stat___0: INTEGER_32
			l_s___0: REAL_64
			l_tmp___7: INTEGER_32
			l_sin_1: REAL_64
			l_sin_2: REAL_64
			l_lnp_pos: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_pp: INTEGER_32
			l_lnterm: REAL_64
			l_tmp___18: REAL_64
			l_tmp___19: REAL_64
			l_lg_apn: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_a: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s_apn: CE_ARRAY [REAL_64]
			l_s_a: CE_ARRAY [REAL_64]
			l_stat_apn: INTEGER_32
			l_stat_a: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result_pos.make (<<1>>)
			create l_lnp_pos.make (<<1>>)
			create l_lg_apn.make (<<1>>)
			create l_lg_a.make (<<1>>)
			create l_s_apn.make (<<1>>)
			create l_s_a.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_sgn.item := 1.0
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 3 then -- else:
						if not (a_a___5 > 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_a___5 + a_x > 0.0 then
							a_sgn.item := 1.0
							Result := (lnpoch_pos (a_a___5, a_x, a_result))
							js.return
						else
							l_pos := -1 + 6 -- goto _L___5
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 6 then -- else: | _L___5:
						if not (a_a___5 <= (0).to_double) then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						if a_a___5 /= (floor (a_a___5)) then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						if not (a_a___5 + a_x < (0).to_double) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if a_x = (floor (a_x)) then
							l_stat := (lnpoch_pos (-a_a___5, -a_x, l_result_pos))
							l_f := (log (a_a___5 / (a_a___5 + a_x)))
							if (fmod (a_x, (2).to_double)) = (0).to_double then
								l_tmp___3 := 1
							else
								l_tmp___3 := -1
							end
							l_s := l_tmp___3.to_double
							a_result.item.val := l_f - l_result_pos.item.val
							a_result.item.err := l_result_pos.item.err + (2.0 * 2.2204460492503131e-16) * l_f
							a_sgn.item := l_s
							Result := l_stat
							js.return
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if a_a___5 + a_x = (0).to_double then
							l_stat___0 := (gamma_inst.gsl_sf_lngamma_sgn_e (-a_a___5 + (1).to_double, a_result, a_sgn))
							if (fmod (-a_a___5, (2).to_double)) = (0).to_double then
								l_tmp___7 := 1
							else
								l_tmp___7 := -1
							end
							l_s___0 := l_tmp___7.to_double
							a_sgn.item := a_sgn.item * l_s___0
							Result := l_stat___0
							js.return
						else
							a_result.item.val := (-(builtin_inff)).to_double
							a_result.item.err := 0.0
							a_sgn.item := (1).to_double
							Result := 0
							js.return
						end
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_pos := -1 + 15 -- goto _L___4
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 15 then -- else: | _L___4:
						if not (a_a___5 < 0.0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 16 then -- if:
						if not (a_a___5 + a_x < 0.0) then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						l_sin_1 := (sin (3.14159265358979323846 * (1.0 - a_a___5)))
						l_sin_2 := (sin (3.14159265358979323846 * ((1.0 - a_a___5) - a_x)))
						if l_sin_1 /= 0.0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else:
						if l_sin_2 /= 0.0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___0:
						a_sgn.item := 0.0
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("poch.c"), 349, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_stat_pp := (lnpoch_pos (1.0 - a_a___5, -a_x, l_lnp_pos))
						l_lnterm := (log ((fabs (l_sin_1 / l_sin_2))))
						a_result.item.val := l_lnterm - l_lnp_pos.item.val
						a_result.item.err := l_lnp_pos.item.err
						l_tmp___18 := fabs (1.0 - a_a___5)
						l_tmp___19 := fabs ((1.0 - a_a___5) - a_x)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___18 + l_tmp___19)) * (fabs (l_lnterm)))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if l_sin_1 * l_sin_2 >= 0.0 then
							a_sgn.item := (1).to_double
						else
							a_sgn.item := (-1).to_double
						end
						Result := l_stat_pp
						js.return
				when 24 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___3
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 27 then -- else: | _L___3:
						l_stat_apn := (gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5 + a_x, l_lg_apn, l_s_apn))
						l_stat_a := (gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5, l_lg_a, l_s_a))
						if l_stat_apn /= 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_stat_a = 0 then
							a_result.item.val := l_lg_apn.item.val - l_lg_a.item.val
							a_result.item.err := l_lg_apn.item.err + l_lg_a.item.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							a_sgn.item := l_s_a.item * l_s_apn.item
							Result := 0
							js.return
						else
							l_pos := -1 + 30 -- goto _L___2
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 30 then -- else: | _L___2:
						if l_stat_apn /= 1 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___1
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 33 then -- else:
						if l_stat_a /= 1 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if: | _L___1:
						a_sgn.item := 0.0
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("poch.c"), 380, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						a_sgn.item := 0.0
						Result := (-1)
						js.return
				when 37 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 38 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_poch (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_poch_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_poch_e(a, x, &result)"), ce_string ("poch.c"), 459, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_poch_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lnpoch: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn: CE_ARRAY [REAL_64]
			l_stat_lnpoch: INTEGER_32
			l_stat_exp: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			create l_lnpoch.make (<<1>>)
			create l_sgn.make (<<1>>)

			if a_x = 0.0 then
				a_result.item.val := 1.0
				a_result.item.err := 0.0
				Result := 0
			else
				l_stat_lnpoch := (gsl_sf_lnpoch_sgn_e (a_a___5, a_x, l_lnpoch, l_sgn))
				if l_lnpoch.item.val = (-(builtin_inff)).to_double then
					a_result.item.val := (0).to_double
					a_result.item.err := (0).to_double
					Result := l_stat_lnpoch
				else
					l_stat_exp := (exp_inst.gsl_sf_exp_err_e (l_lnpoch.item.val, l_lnpoch.item.err, a_result))
					a_result.item.val := a_result.item.val * (l_sgn.item)
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
					if l_stat_exp /= 0 then
						l_tmp___3 := l_stat_exp
					else
						if l_stat_lnpoch /= 0 then
							l_tmp___2 := l_stat_lnpoch
						else
							l_tmp___2 := 0
						end
						l_tmp___3 := l_tmp___2
					end
					Result := l_tmp___3
				end
			end
		end

	gsl_sf_pochrel (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_pochrel_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_pochrel_e(a, x, &result)"), ce_string ("poch.c"), 464, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_pochrel_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_absx: REAL_64
			l_absa: REAL_64
			l_lnpoch: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn: CE_ARRAY [REAL_64]
			l_stat_poch: INTEGER_32
			l_el: REAL_64
			l_tmp___6: REAL_64
			l_tmp___9: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lnpoch.make (<<1>>)
			create l_sgn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_absx := (fabs (a_x))
					l_absa := (fabs (a_a___5))
					if not (l_absx > 0.1 * l_absa) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_absa > 2.0 then
							l_tmp___9 := l_absa
						else
							l_tmp___9 := 2.0
						end
						if not (l_absx * (log (l_tmp___9)) > 0.1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_stat_poch := (gsl_sf_lnpoch_sgn_e (a_a___5, a_x, l_lnpoch, l_sgn))
						if l_lnpoch.item.val > 7.0978271289338397e+02 then
							from
							until
								js.loop_done
							loop
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("poch.c"), 432, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_el := (exp (l_lnpoch.item.val))
							a_result.item.val := (l_sgn.item * l_el - 1.0) / a_x
							a_result.item.err := (fabs (a_result.item.val)) * (l_lnpoch.item.err + 2.0 * 2.2204460492503131e-16)
							l_tmp___6 := fabs (l_sgn.item * l_el)
							a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___6 + 1.0)) / (fabs (a_x)))
							Result := l_stat_poch
							js.return
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						Result := (pochrel_smallx (a_a___5, a_x, a_result))
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	lnpoch_pos (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_absx: REAL_64
			l_g1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_g2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___1: REAL_64
			l_lg1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_1: INTEGER_32
			l_stat_2: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_eps: REAL_64
			l_den: REAL_64
			l_d3: REAL_64
			l_d5: REAL_64
			l_d7: REAL_64
			l_c1___2: REAL_64
			l_c3___3: REAL_64
			l_c5___1: REAL_64
			l_c7___0: REAL_64
			l_p8: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_a4: REAL_64
			l_a6: REAL_64
			l_ser_1: REAL_64
			l_ser_2: REAL_64
			l_ser: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_ln_1peps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___13: REAL_64
			l_tmp___14: REAL_64
			l_poch_rel: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_p: INTEGER_32
			l_eps___0: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_g1.make (<<1>>)
			create l_g2.make (<<1>>)
			create l_lg1.make (<<1>>)
			create l_lg2.make (<<1>>)
			create l_ln_1peps.make (<<1>>)
			create l_poch_rel.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_absx := (fabs (a_x))
					if not (l_absx > 0.1 * a_a___5) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not (l_absx * (log ((gsl_gsl_minmax_inst.GSL_MAX_DBL (a_a___5, 2.0)))) > 0.1) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if: | _L___1:
						if not (a_a___5 < 171.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if a_a___5 + a_x < 171.0 then
							gamma_inst.gsl_sf_gammainv_e (a_a___5, l_g1).do_nothing
							gamma_inst.gsl_sf_gammainv_e (a_a___5 + a_x, l_g2).do_nothing
							a_result.item.val := -(log (l_g2.item.val / l_g1.item.val))
							l_tmp___1 := fabs (l_g1.item.val)
							a_result.item.err := l_g1.item.err / l_tmp___1 + l_g2.item.err / (fabs (l_g2.item.val))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := 0
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_stat_1 := (gamma_inst.gsl_sf_lngamma_e (a_a___5, l_lg1))
						l_stat_2 := (gamma_inst.gsl_sf_lngamma_e (a_a___5 + a_x, l_lg2))
						a_result.item.val := l_lg2.item.val - l_lg1.item.val
						a_result.item.err := l_lg2.item.err + l_lg1.item.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if l_stat_1 /= 0 then
							l_tmp___8 := l_stat_1
						else
							if l_stat_2 /= 0 then
								l_tmp___7 := l_stat_2
							else
								l_tmp___7 := 0
							end
							l_tmp___8 := l_tmp___7
						end
						Result := l_tmp___8
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (l_absx < 0.1 * a_a___5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 > 15.0 then
							l_eps := a_x / a_a___5
							l_den := 1.0 + l_eps
							l_d3 := (l_den * l_den) * l_den
							l_d5 := (l_d3 * l_den) * l_den
							l_d7 := (l_d5 * l_den) * l_den
							l_c1___2 := -l_eps / l_den
							l_c3___3 := (-l_eps * (3.0 + l_eps * (3.0 + l_eps))) / l_d3
							l_c5___1 := (-l_eps * (5.0 + l_eps * (10.0 + l_eps * (10.0 + l_eps * (5.0 + l_eps))))) / l_d5
							l_c7___0 := (-l_eps * (7.0 + l_eps * (21.0 + l_eps * (35.0 + l_eps * (35.0 + l_eps * (21.0 + l_eps * (7.0 + l_eps))))))) / l_d7
							l_p8 := (pow_int_inst.gsl_sf_pow_int (1.0 + l_eps, 8))
							l_c8___0 := 1.0 / l_p8 - 1.0
							l_c9 := 1.0 / (l_p8 * (1.0 + l_eps)) - 1.0
							l_a4 := ((a_a___5 * a_a___5) * a_a___5) * a_a___5
							l_a6 := (l_a4 * a_a___5) * a_a___5
							l_ser_1 := ((l_c1___2 + l_c3___3 / ((30.0 * a_a___5) * a_a___5)) + l_c5___1 / (105.0 * l_a4)) + l_c7___0 / (140.0 * l_a6)
							l_ser_2 := l_c8___0 / (((99.0 * l_a6) * a_a___5) * a_a___5) - ((691.0 / 360360.0) * l_c9) / (l_a6 * l_a4)
							l_ser := (l_ser_1 + l_ser_2) / (12.0 * a_a___5)
							l_term1 := a_x * (log (a_a___5 / 2.7182818284590452354))
							log_inst.gsl_sf_log_1plusx_e (l_eps, l_ln_1peps).do_nothing
							l_term2 := ((a_x + a_a___5) - 0.5) * l_ln_1peps.item.val
							a_result.item.val := (l_term1 + l_term2) + l_ser
							a_result.item.err := 2.2204460492503131e-16 * (fabs (l_term1))
							a_result.item.err := a_result.item.err + (fabs (((a_x + a_a___5) - 0.5) * l_ln_1peps.item.err))
							l_tmp___13 := fabs (l_ln_1peps.item.val)
							l_tmp___14 := fabs (a_x)
							a_result.item.err := a_result.item.err + ((l_tmp___13 * 2.2204460492503131e-16) * ((l_tmp___14 + (fabs (a_a___5))) + 0.5))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := 0
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_stat_p := (pochrel_smallx (a_a___5, a_x, l_poch_rel))
						l_eps___0 := a_x * l_poch_rel.item.val
						l_stat_e := (log_inst.gsl_sf_log_1plusx_e (l_eps___0, a_result))
						a_result.item.err := 2.0 * (fabs ((a_x * l_poch_rel.item.err) / (1.0 + l_eps___0)))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if l_stat_e /= 0 then
							l_tmp___22 := l_stat_e
						else
							if l_stat_p /= 0 then
								l_tmp___21 := l_stat_p
							else
								l_tmp___21 := 0
							end
							l_tmp___22 := l_tmp___21
						end
						Result := l_tmp___22
				when 13 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	pochrel_smallx (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_SQTBIG: REAL_64
			l_ALNEPS: REAL_64
			l_bp: REAL_64
			l_tmp___0: REAL_64
			l_incr: INTEGER_32
			l_tmp___1: REAL_64
			l_b___0: REAL_64
			l_dpoch1: REAL_64
			l_dexprl: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_dexprl: INTEGER_32
			l_i: INTEGER_32
			l_var: REAL_64
			l_alnvar: REAL_64
			l_q___3: REAL_64
			l_poly1: REAL_64
			l_nterms: INTEGER_32
			l_var2: REAL_64
			l_rho: REAL_64
			l_term: REAL_64
			l_gbern: CE_ARRAY [REAL_64]
			l_k: INTEGER_32
			l_j: INTEGER_32
			l_gbk: REAL_64
			l_binv: REAL_64
			l_tmp___3: REAL_64
			l_sinpxx: REAL_64
			l_sinpx2: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_trig: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: REAL_64
			js: JUMP_STATE
		do
			create l_dexprl.make (<<1>>)
			create l_gbern.make (<<24>>)

			l_SQTBIG := 1.0 / (((2.0 * 1.41421356237309504880) * 1.73205080756887729352744634151) * 1.4916681462400413e-154)
			l_ALNEPS := -3.6043653389117154e+01 - 0.69314718055994530942
			if a_x = 0.0 then
				Result := (psi_inst.gsl_sf_psi_e (a_a___5, a_result))
			else
				if a_a___5 < -0.5 then
					l_tmp___0 := (1.0 - a_a___5) - a_x
				else
					l_tmp___0 := a_a___5
				end
				l_bp := l_tmp___0
				if l_bp < 10.0 then
					l_tmp___1 := 11.0 - l_bp
				else
					l_tmp___1 := (0).to_double
				end
				l_incr := l_tmp___1.truncated_to_integer
				l_b___0 := l_bp + l_incr.to_double
				l_var := l_b___0 + 0.5 * (a_x - 1.0)
				l_alnvar := (log (l_var))
				l_q___3 := a_x * l_alnvar
				l_poly1 := 0.0
				if l_var < l_SQTBIG then
					l_nterms := ((-0.5 * l_ALNEPS) / l_alnvar + 1.0).truncated_to_integer
					l_var2 := (1.0 / l_var) / l_var
					l_rho := 0.5 * (a_x + 1.0)
					l_term := l_var2
					l_gbern[1] := 1.0
					l_gbern[2] := -l_rho / 12.0
					l_poly1 := l_gbern[2] * l_term
					if l_nterms > 20 then
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("error"), ce_string ("poch.c"), 128, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := 2
						from
						until
							not (not js.loop_done and then (l_k <= l_nterms))
						loop
							l_gbk := 0.0
							l_j := 1
							from
							until
								not (l_j <= l_k)
							loop
								l_gbk := l_gbk + (bern[(l_k - l_j) + 1] * l_gbern[l_j])
								l_j := l_j + 1
							end
							l_gbern[l_k + 1] := (-l_rho * l_gbk) / l_k.to_double
							l_term := l_term * ((((2 * l_k - 2).to_double - a_x) * ((2 * l_k - 1).to_double - a_x)) * l_var2)
							l_poly1 := l_poly1 + (l_gbern[l_k + 1] * l_term)
							l_k := l_k + 1
						end
					end
				end
				if not js.return_called then
					l_stat_dexprl := exp_inst.gsl_sf_expm1_e (l_q___3, l_dexprl)
					if l_stat_dexprl /= 0 then
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := l_stat_dexprl
						js.return
					end
				end
				if not js.return_called then
					l_dexprl.item.val := l_dexprl.item.val / l_q___3
					l_poly1 := l_poly1 * (a_x - 1.0)
					l_dpoch1 := l_dexprl.item.val * (l_alnvar + l_q___3 * l_poly1) + l_poly1
					l_i := l_incr - 1
					from
					until
						not (l_i >= 0)
					loop
						l_binv := 1.0 / (l_bp + l_i.to_double)
						l_dpoch1 := (l_dpoch1 - l_binv) / (1.0 + a_x * l_binv)
						l_i := l_i - 1
					end
					if l_bp = a_a___5 then
						a_result.item.val := l_dpoch1
						l_tmp___3 := fabs (l_incr.to_double)
						a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (l_tmp___3 + 1.0)) * (fabs (a_result.item.val))
						Result := 0
					else
						l_sinpxx := (sin (3.14159265358979323846 * a_x)) / a_x
						l_sinpx2 := (sin ((0.5 * 3.14159265358979323846) * a_x))
						l_t1 := l_sinpxx / (tan (3.14159265358979323846 * l_b___0))
						l_t2 := (2.0 * l_sinpx2) * (l_sinpx2 / a_x)
						l_trig := l_t1 - l_t2
						a_result.item.val := l_dpoch1 * (1.0 + a_x * l_trig) + l_trig
						l_tmp___8 := fabs (l_dpoch1 * a_x)
						l_tmp___9 := fabs (l_t1)
						a_result.item.err := ((l_tmp___8 + 1.0) * 2.2204460492503131e-16) * (l_tmp___9 + (fabs (l_t2)))
						l_tmp___11 := fabs (l_incr.to_double)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___11 + 1.0)) * (fabs (a_result.item.val)))
						Result := 0
					end
				end
			end
		end

end
