class
	P_PSI

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create apsi_cs.make (<<1>>)
			create apsics_data.make (<<16>>)
			create psi_1_table.make (<<101>>)
			create psi_cs.make (<<1>>)
			create psi_table.make (<<101>>)
			create psics_data.make (<<23>>)
			create r1py_cs.make (<<1>>)
			create r1py_data.make (<<30>>)
		end

feature {ANY} -- attributes

	apsi_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	apsics_data: CE_ARRAY [REAL_64]

	c1___1: REAL_64 assign set_c1___1

	set_c1___1 (a_c1___1: REAL_64)
		do
			c1___1 := a_c1___1
		end

	c2: REAL_64 assign set_c2

	set_c2 (a_c2: REAL_64)
		do
			c2 := a_c2
		end

	c3___2: REAL_64 assign set_c3___2

	set_c3___2 (a_c3___2: REAL_64)
		do
			c3___2 := a_c3___2
		end

	psi_1_table: CE_ARRAY [REAL_64]

	psi_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	psi_table: CE_ARRAY [REAL_64]

	psics_data: CE_ARRAY [REAL_64]

	r1py_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	r1py_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_sf_complex_psi_e (a_x: REAL_64; a_y: REAL_64; a_result_re: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_result_im: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: PD_GSL_COMPLEX
			l_z___0: PD_GSL_COMPLEX
			l_omz: PD_GSL_COMPLEX
			l_zpi: PD_GSL_COMPLEX
			l_cotzpi: PD_GSL_COMPLEX
			l_ret_val: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_z.make
			create l_z___0.make
			create l_omz.make
			create l_zpi.make
			create l_cotzpi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x >= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_z := (gsl_gsl_complex_math_inst.gsl_complex_rect (a_x, a_y)).twin
						Result := (psi_complex_rhp (l_z.twin, a_result_re, a_result_im))
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						l_z___0 := (gsl_gsl_complex_math_inst.gsl_complex_rect (a_x, a_y)).twin
						l_omz := (gsl_gsl_complex_math_inst.gsl_complex_rect (1.0 - a_x, -a_y)).twin
						l_zpi := (math_inst.gsl_complex_mul_real (l_z___0.twin, 3.14159265358979323846)).twin
						l_cotzpi := (math_inst.gsl_complex_cot (l_zpi.twin)).twin
						l_ret_val := (psi_complex_rhp (l_omz.twin, a_result_re, a_result_im))
						if not ((infnan_inst.gsl_finite (l_cotzpi.dat[0])).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (infnan_inst.gsl_finite (l_cotzpi.dat[1])).to_boolean then
							a_result_re.item.val := a_result_re.item.val - (3.14159265358979323846 * l_cotzpi.dat[0])
							a_result_im.item.val := a_result_im.item.val - (3.14159265358979323846 * l_cotzpi.dat[1])
							Result := l_ret_val
							js.return
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("singularity"), ce_string ("psi.c"), 827, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_psi (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_psi_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_psi_e(x, &result)"), ce_string ("psi.c"), 845, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_psi_1_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_psi_1_e(x, &result)"), ce_string ("psi.c"), 860, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_M: INTEGER_32
			l_fx: REAL_64
			l_sum: REAL_64
			l_m___4: INTEGER_32
			l_stat_psi: INTEGER_32
			l_sin_px: REAL_64
			l_d: REAL_64
			l_r___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_psi___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r___3.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_x /= -1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_x /= -2.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 727, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if a_x > 0.0 then
							Result := (psi_n_xg0 (1, a_x, a_result))
							js.return
						elseif a_x > -5.0 then
							l_M := (-(floor (a_x))).truncated_to_integer
							l_fx := a_x + l_M.to_double
							l_sum := 0.0
							if l_fx = 0.0 then
								from
								until
									js.loop_done
								loop
									a_result.item.val := (builtin_nanf (ce_string (""))).to_double
									a_result.item.err := (builtin_nanf (ce_string (""))).to_double
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 742, 1)
										Result := 1
										js.return
										if not js.return_called then
											js.break
										end
									end
									if not js.return_called then
										js.break
									end
								end
							end
							if not js.return_called then
								l_m___4 := 0
								from
								until
									not (l_m___4 < l_M)
								loop
									l_sum := l_sum + (1.0 / ((a_x + l_m___4.to_double) * (a_x + l_m___4.to_double)))
									l_m___4 := l_m___4 + 1
								end
								l_stat_psi := (psi_n_xg0 (1, l_fx, a_result))
								a_result.item.val := a_result.item.val + l_sum
								a_result.item.err := a_result.item.err + ((l_M.to_double * 2.2204460492503131e-16) * l_sum)
								Result := l_stat_psi
								js.return
							end
						else
							l_sin_px := (sin (3.14159265358979323846 * a_x))
							l_d := (3.14159265358979323846 * 3.14159265358979323846) / (l_sin_px * l_sin_px)
							l_stat_psi___0 := (psi_n_xg0 (1, 1.0 - a_x, l_r___3))
							a_result.item.val := l_d - l_r___3.item.val
							a_result.item.err := l_r___3.item.err + (2.0 * 2.2204460492503131e-16) * l_d
							Result := l_stat_psi___0
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_psi_1_int (a_n: INTEGER_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_psi_1_int_e (a_n, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_psi_1_int_e(n, &result)"), ce_string ("psi.c"), 855, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1_int_e (a_n: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_ni2: REAL_64
			l_ser: REAL_64
			js: JUMP_STATE
		do
			if a_n <= 0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 699, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_n <= 100 then
				a_result.item.val := psi_1_table[a_n]
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			else
				l_c0___0 := -1.0 / 30.0
				l_c1___2 := 1.0 / 42.0
				l_c2___0 := -1.0 / 30.0
				l_ni2 := (1.0 / a_n.to_double) * (1.0 / a_n.to_double)
				l_ser := (l_ni2 * l_ni2) * (l_c0___0 + l_ni2 * (l_c1___2 + l_c2___0 * l_ni2))
				a_result.item.val := (((1.0 + 0.5 / a_n.to_double) + 1.0 / ((6.0 * a_n.to_double) * a_n.to_double)) + l_ser) / a_n.to_double
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_psi_1piy (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_psi_1piy_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_psi_1piy_e(x, &result)"), ce_string ("psi.c"), 850, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1piy_e (a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ay: REAL_64
			l_yi2: REAL_64
			l_lny: REAL_64
			l_sum: REAL_64
			l_tmp___1: REAL_64
			l_yi2___0: REAL_64
			l_lny___0: REAL_64
			l_sum___0: REAL_64
			l_tmp___4: REAL_64
			l_y2: REAL_64
			l_x: REAL_64
			l_v: REAL_64
			l_result_c: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___6: REAL_64
			l_M: INTEGER_32
			l_y2___0: REAL_64
			l_c0___0: REAL_64
			l_c2___0: REAL_64
			l_c4___2: REAL_64
			l_c6___2: REAL_64
			l_p: REAL_64
			l_sum___1: REAL_64
			l_v___0: REAL_64
			l_n: INTEGER_32
		do
			create l_result_c.make (<<1>>)

			l_ay := (fabs (a_y))
			if l_ay > 1000.0 then
				l_yi2 := 1.0 / (l_ay * l_ay)
				l_lny := (log (l_ay))
				l_sum := l_yi2 * ((1.0 / 12.0 + (1.0 / 120.0) * l_yi2) + ((1.0 / 252.0) * l_yi2) * l_yi2)
				a_result.item.val := l_lny + l_sum
				l_tmp___1 := fabs (l_lny)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___1 + (fabs (l_sum)))
				Result := 0
			elseif l_ay > 10.0 then
				l_yi2___0 := 1.0 / (l_ay * l_ay)
				l_lny___0 := (log (l_ay))
				l_sum___0 := l_yi2___0 * (1.0 / 12.0 + l_yi2___0 * (1.0 / 120.0 + l_yi2___0 * (1.0 / 252.0 + l_yi2___0 * (1.0 / 240.0 + l_yi2___0 * (1.0 / 132.0 + (691.0 / 32760.0) * l_yi2___0)))))
				a_result.item.val := l_lny___0 + l_sum___0
				l_tmp___4 := fabs (l_lny___0)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___4 + (fabs (l_sum___0)))
				Result := 0
			elseif l_ay > 1.0 then
				l_y2 := l_ay * l_ay
				l_x := (2.0 * l_ay - 11.0) / 9.0
				l_v := l_y2 * (1.0 / (1.0 + l_y2) + 0.5 / (4.0 + l_y2))
				cheb_eval_inst.cheb_eval_e (r1py_cs, l_x, l_result_c).do_nothing
				a_result.item.val := (l_result_c.item.val - 0.57721566490153286060651209008) + l_v
				a_result.item.err := l_result_c.item.err
				l_tmp___6 := fabs (l_v)
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * ((l_tmp___6 + 0.57721566490153286060651209008) + (fabs (l_result_c.item.val))))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				a_result.item.err := a_result.item.err * (5.0)
				Result := 0
			else
				l_M := 50
				l_y2___0 := a_y * a_y
				l_c0___0 := 0.00019603999466879846570
				l_c2___0 := 3.8426659205114376860e-08
				l_c4___2 := 1.0041592839497643554e-11
				l_c6___2 := 2.9516743763500191289e-15
				l_p := l_c0___0 + l_y2___0 * (-l_c2___0 + l_y2___0 * (l_c4___2 - l_y2___0 * l_c6___2))
				l_sum___1 := 0.0
				l_n := 1
				from
				until
					not (l_n <= l_M)
				loop
					l_sum___1 := l_sum___1 + (1.0 / (l_n.to_double * ((l_n * l_n).to_double + a_y * a_y)))
					l_n := l_n + 1
				end
				l_v___0 := l_y2___0 * (l_sum___1 + l_p)
				a_result.item.val := -0.57721566490153286060651209008 + l_v___0
				a_result.item.err := 2.2204460492503131e-16 * (0.57721566490153286060651209008 + (fabs (l_v___0)))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	gsl_sf_psi_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (psi_x (a_x, a_result))
		end

	gsl_sf_psi_int (a_n: INTEGER_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_psi_int_e (a_n, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_psi_int_e(n, &result)"), ce_string ("psi.c"), 840, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_int_e (a_n: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_ni2: REAL_64
			l_ser: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
		do
			if a_n <= 0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 587, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_n <= 100 then
				a_result.item.val := psi_table[a_n]
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_c2___0 := -1.0 / 12.0
				l_c3___3 := 1.0 / 120.0
				l_c4___2 := -1.0 / 252.0
				l_c5___1 := 1.0 / 240.0
				l_ni2 := (1.0 / a_n.to_double) * (1.0 / a_n.to_double)
				l_ser := l_ni2 * (l_c2___0 + l_ni2 * (l_c3___3 + l_ni2 * (l_c4___2 + l_ni2 * l_c5___1)))
				a_result.item.val := ((log (a_n.to_double)) - 0.5 / a_n.to_double) + l_ser
				l_tmp___4 := fabs ((log (a_n.to_double)))
				l_tmp___5 := fabs (0.5 / a_n.to_double)
				a_result.item.err := 2.2204460492503131e-16 * ((l_tmp___4 + l_tmp___5) + (fabs (l_ser)))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_psi_n (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_psi_n_e (a_n, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_psi_n_e(n, x, &result)"), ce_string ("psi.c"), 865, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_n_e (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ln_nf: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_hzeta: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_hz: INTEGER_32
			l_stat_nf: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ln_nf.make (<<1>>)
			create l_hzeta.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_n /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (gsl_sf_psi_e (a_x, a_result))
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_n /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (gsl_sf_psi_1_e (a_x, a_result))
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_n < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 781, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_stat_hz := (zeta_inst.gsl_sf_hzeta_e (a_n.to_double + 1.0, a_x, l_hzeta))
						l_stat_nf := (gamma_inst.gsl_sf_lnfact_e (a_n.to_natural_32, l_ln_nf))
						l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_nf.item.val, l_ln_nf.item.err, l_hzeta.item.val, l_hzeta.item.err, a_result))
						if not ((a_n).bit_and (1)).to_boolean then
							a_result.item.val := -a_result.item.val
						end
						if l_stat_e /= 0 then
							l_tmp___8 := l_stat_e
						else
							if l_stat_nf /= 0 then
								l_tmp___7 := l_stat_nf
							else
								if l_stat_hz /= 0 then
									l_tmp___6 := l_stat_hz
								else
									l_tmp___6 := 0
								end
								l_tmp___7 := l_tmp___6
							end
							l_tmp___8 := l_tmp___7
						end
						Result := l_tmp___8
						js.return
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	psi_complex_asymp (a_z: PD_GSL_COMPLEX): PD_GSL_COMPLEX
		local
			l_zi: PD_GSL_COMPLEX
			l_w: PD_GSL_COMPLEX
			l_cs: PD_GSL_COMPLEX
			l_sum: PD_GSL_COMPLEX
		do
			create l_zi.make
			create l_w.make
			create l_cs.make
			create l_sum.make

			l_zi := (math_inst.gsl_complex_inverse (a_z.twin)).twin
			l_w := (math_inst.gsl_complex_mul (l_zi.twin, l_zi.twin)).twin
			l_sum := (math_inst.gsl_complex_mul_real (l_w.twin, (c3___2 / c2))).twin
			l_sum := (math_inst.gsl_complex_add_real (l_sum.twin, 1.0)).twin
			l_sum := (math_inst.gsl_complex_mul_real (l_sum.twin, (c2 / c1___1))).twin
			l_sum := (math_inst.gsl_complex_mul (l_sum.twin, l_w.twin)).twin
			l_sum := (math_inst.gsl_complex_add_real (l_sum.twin, 1.0)).twin
			l_sum := (math_inst.gsl_complex_mul_real (l_sum.twin, c1___1)).twin
			l_sum := (math_inst.gsl_complex_mul (l_sum.twin, l_w.twin)).twin
			l_sum := (math_inst.gsl_complex_add_real (l_sum.twin, 1.0)).twin
			l_cs := (math_inst.gsl_complex_mul (l_sum.twin, l_w.twin)).twin
			l_cs := (math_inst.gsl_complex_mul_real (l_cs.twin, -1.0 / 12.0)).twin
			l_cs := (math_inst.gsl_complex_add (l_cs.twin, (math_inst.gsl_complex_mul_real (l_zi.twin, -0.5)).twin)).twin
			Result := (math_inst.gsl_complex_add ((math_inst.gsl_complex_log (a_z.twin)).twin, l_cs.twin)).twin
		end

	psi_complex_rhp (a_z: PD_GSL_COMPLEX; a_result_re: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_result_im: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_n_recurse: INTEGER_32
			l_i: INTEGER_32
			l_a___5: PD_GSL_COMPLEX
			l_sp: REAL_64
			l_sn: REAL_64
			l_rhs: REAL_64
			l_zn: PD_GSL_COMPLEX
			l_zn_inverse: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_a___5.make
			create l_zn.make
			create l_zn_inverse.make

			l_n_recurse := 0
			if a_z.dat[0] = 0.0 then
				if a_z.dat[1] = 0.0 then
					a_result_re.item.val := 0.0
					a_result_im.item.val := 0.0
					a_result_re.item.err := 0.0
					a_result_im.item.err := 0.0
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if a_z.dat[0] < 20.0 then
					if (fabs (a_z.dat[1])) < 20.0 then
						l_sp := (sqrt (20.0 + a_z.dat[1]))
						l_sn := (sqrt (20.0 - a_z.dat[1]))
						l_rhs := l_sp * l_sn - a_z.dat[0]
						if l_rhs > 0.0 then
							l_n_recurse := (ceil (l_rhs)).truncated_to_integer
						end
					end
				end
				l_a___5 := (psi_complex_asymp ((math_inst.gsl_complex_add_real (a_z.twin, l_n_recurse.to_double)).twin)).twin
				a_result_re.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_a___5.dat[0]))
				a_result_im.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_a___5.dat[1]))
				l_i := l_n_recurse
				from
				until
					not (l_i >= 1)
				loop
					l_zn := (math_inst.gsl_complex_add_real (a_z.twin, l_i.to_double - 1.0)).twin
					l_zn_inverse := (math_inst.gsl_complex_inverse (l_zn.twin)).twin
					l_a___5 := (math_inst.gsl_complex_sub (l_a___5.twin, l_zn_inverse.twin)).twin
					a_result_re.item.err := a_result_re.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_zn_inverse.dat[0])))
					a_result_im.item.err := a_result_im.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_zn_inverse.dat[1])))
					l_i := l_i - 1
				end
				a_result_re.item.val := l_a___5.dat[0]
				a_result_im.item.val := l_a___5.dat[1]
				a_result_re.item.err := a_result_re.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result_re.item.val)))
				a_result_im.item.err := a_result_im.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result_im.item.val)))
				Result := 0
			end
		end

	psi_n_xg0 (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ln_nf: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_hzeta: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_hz: INTEGER_32
			l_stat_nf: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
		do
			create l_ln_nf.make (<<1>>)
			create l_hzeta.make (<<1>>)

			if a_n = 0 then
				Result := (gsl_sf_psi_e (a_x, a_result))
			else
				l_stat_hz := (zeta_inst.gsl_sf_hzeta_e (a_n.to_double + 1.0, a_x, l_hzeta))
				l_stat_nf := (gamma_inst.gsl_sf_lnfact_e (a_n.to_natural_32, l_ln_nf))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_nf.item.val, l_ln_nf.item.err, l_hzeta.item.val, l_hzeta.item.err, a_result))
				if not ((a_n).bit_and (1)).to_boolean then
					a_result.item.val := -a_result.item.val
				end
				if l_stat_e /= 0 then
					l_tmp___5 := l_stat_e
				else
					if l_stat_nf /= 0 then
						l_tmp___4 := l_stat_nf
					else
						if l_stat_hz /= 0 then
							l_tmp___3 := l_stat_hz
						else
							l_tmp___3 := 0
						end
						l_tmp___4 := l_tmp___3
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
			end
		end

	psi_x (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_t: REAL_64
			l_result_c: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s: REAL_64
			l_c___1: REAL_64
			l_result_c___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_v: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_v___0: REAL_64
			l_t1___0: REAL_64
			l_t2___0: REAL_64
			l_tmp___16: REAL_64
			l_t1___1: REAL_64
			l_v___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result_c.make (<<1>>)
			create l_result_c___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_y := (fabs (a_x))
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_x /= -1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_x /= -2.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 385, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if l_y >= 2.0 then
							l_t := 8.0 / (l_y * l_y) - 1.0
							cheb_eval_inst.cheb_eval_e (apsi_cs, l_t, l_result_c).do_nothing
							if a_x < 0.0 then
								l_s := (sin (3.14159265358979323846 * a_x))
								l_c___1 := (cos (3.14159265358979323846 * a_x))
								if (fabs (l_s)) < 2.0 * 1.4916681462400413e-154 then
									from
									until
										js.loop_done
									loop
										a_result.item.val := (builtin_nanf (ce_string (""))).to_double
										a_result.item.err := (builtin_nanf (ce_string (""))).to_double
										from
										until
											js.loop_done
										loop
											error_inst.gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 395, 1)
											Result := 1
											js.return
											if not js.return_called then
												js.break
											end
										end
										if not js.return_called then
											js.break
										end
									end
								else
									a_result.item.val := (((log (l_y)) - 0.5 / a_x) + l_result_c.item.val) - (3.14159265358979323846 * l_c___1) / l_s
									a_result.item.err := ((3.14159265358979323846 * (fabs (a_x))) * 2.2204460492503131e-16) / (l_s * l_s)
									a_result.item.err := a_result.item.err + (l_result_c.item.err)
									a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
									Result := 0
									js.return
								end
							else
								a_result.item.val := ((log (l_y)) - 0.5 / a_x) + l_result_c.item.val
								a_result.item.err := l_result_c.item.err
								a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
								Result := 0
								js.return
							end
						elseif a_x < -1.0 then
							l_v := a_x + 2.0
							l_t1 := 1.0 / a_x
							l_t2 := 1.0 / (a_x + 1.0)
							l_t3 := 1.0 / l_v
							cheb_eval_inst.cheb_eval_e (psi_cs, 2.0 * l_v - 1.0, l_result_c___0).do_nothing
							a_result.item.val := -((l_t1 + l_t2) + l_t3) + l_result_c___0.item.val
							l_tmp___12 := fabs (l_t1)
							l_tmp___13 := fabs (a_x / (l_t2 * l_t2))
							a_result.item.err := 2.2204460492503131e-16 * ((l_tmp___12 + l_tmp___13) + (fabs (a_x / (l_t3 * l_t3))))
							a_result.item.err := a_result.item.err + (l_result_c___0.item.err)
							a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
							Result := 0
							js.return
						elseif a_x < 0.0 then
							l_v___0 := a_x + 1.0
							l_t1___0 := 1.0 / a_x
							l_t2___0 := 1.0 / l_v___0
							cheb_eval_inst.cheb_eval_e (psi_cs, 2.0 * l_v___0 - 1.0, l_result_c___0).do_nothing
							a_result.item.val := -(l_t1___0 + l_t2___0) + l_result_c___0.item.val
							l_tmp___16 := fabs (l_t1___0)
							a_result.item.err := 2.2204460492503131e-16 * (l_tmp___16 + (fabs (a_x / (l_t2___0 * l_t2___0))))
							a_result.item.err := a_result.item.err + (l_result_c___0.item.err)
							a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
							Result := 0
							js.return
						elseif a_x < 1.0 then
							l_t1___1 := 1.0 / a_x
							cheb_eval_inst.cheb_eval_e (psi_cs, 2.0 * a_x - 1.0, l_result_c___0).do_nothing
							a_result.item.val := -l_t1___1 + l_result_c___0.item.val
							a_result.item.err := 2.2204460492503131e-16 * l_t1___1
							a_result.item.err := a_result.item.err + (l_result_c___0.item.err)
							a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
							Result := 0
							js.return
						else
							l_v___1 := a_x - 1.0
							Result := (cheb_eval_inst.cheb_eval_e (psi_cs, 2.0 * l_v___1 - 1.0, a_result))
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
