class
	P_QAGS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_qagi (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_status: INTEGER_32
			l_f_transform: CE_ARRAY [PD_GSL_FUNCTION_STRUCT]
		do
			create l_f_transform.make (<<1>>)

			l_f_transform.item.function := i_transform_address
			l_f_transform.item.params := create {CE_POINTER [ANY]}.make_cast (a_f)
			l_status := qags (l_f_transform, 0.0, 1.0, a_epsabs, a_epsrel, a_limit, a_workspace, a_result, a_abserr, qk15_inst.gsl_integration_qk15_address)
			Result := l_status
		end

	gsl_integration_qagil (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_b___0: REAL_64; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_status: INTEGER_32
			l_f_transform: CE_ARRAY [PD_GSL_FUNCTION_STRUCT]
			l_transform_params: CE_ARRAY [PD_IL_PARAMS]
		do
			create l_f_transform.make (<<1>>)
			create l_transform_params.make (<<1>>)

			l_transform_params.item.b := a_b___0
			l_transform_params.item.f := a_f
			l_f_transform.item.function := il_transform_address
			l_f_transform.item.params := create {CE_POINTER [ANY]}.make_cast (l_transform_params)
			l_status := qags (l_f_transform, 0.0, 1.0, a_epsabs, a_epsrel, a_limit, a_workspace, a_result, a_abserr, qk15_inst.gsl_integration_qk15_address)
			Result := l_status
		end

	gsl_integration_qagiu (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_status: INTEGER_32
			l_f_transform: CE_ARRAY [PD_GSL_FUNCTION_STRUCT]
			l_transform_params: CE_ARRAY [PD_IU_PARAMS]
		do
			create l_f_transform.make (<<1>>)
			create l_transform_params.make (<<1>>)

			l_transform_params.item.a := a_a___5
			l_transform_params.item.f := a_f
			l_f_transform.item.function := iu_transform_address
			l_f_transform.item.params := create {CE_POINTER [ANY]}.make_cast (l_transform_params)
			l_status := qags (l_f_transform, 0.0, 1.0, a_epsabs, a_epsrel, a_limit, a_workspace, a_result, a_abserr, qk15_inst.gsl_integration_qk15_address)
			Result := l_status
		end

	gsl_integration_qags (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (qags (a_f, a_a___5, a_b___0, a_epsabs, a_epsrel, a_limit, a_workspace, a_result, a_abserr, qk21_inst.gsl_integration_qk21_address))
			Result := l_status
		end

	i_transform (a_t: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_x: REAL_64
			l_y: REAL_64
			l_tmp: REAL_64
		do
			create l_f.make

			l_f := create {CE_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_cast (a_params)
			l_x := ((1).to_double - a_t) / a_t
			l_tmp := (l_f.item.function).real_64_item ([l_x, l_f.item.params])
			l_y := l_tmp + ((l_f.item.function).real_64_item ([-l_x, l_f.item.params]))
			Result := ((l_y / a_t) / a_t)
		end

	i_transform_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent i_transform)
		end

	il_transform (a_t: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_IL_PARAMS]
			l_b___0: REAL_64
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_x: REAL_64
			l_y: REAL_64
		do
			create l_p.make
			create l_f.make

			l_p := create {CE_POINTER [PD_IL_PARAMS]}.make_cast (a_params)
			l_b___0 := l_p.item.b
			l_f := l_p.item.f
			l_x := l_b___0 - ((1).to_double - a_t) / a_t
			l_y := ((l_f.item.function).real_64_item ([l_x, l_f.item.params]))
			Result := ((l_y / a_t) / a_t)
		end

	il_transform_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent il_transform)
		end

	iu_transform (a_t: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_IU_PARAMS]
			l_a___5: REAL_64
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_x: REAL_64
			l_y: REAL_64
		do
			create l_p.make
			create l_f.make

			l_p := create {CE_POINTER [PD_IU_PARAMS]}.make_cast (a_params)
			l_a___5 := l_p.item.a
			l_f := l_p.item.f
			l_x := l_a___5 + ((1).to_double - a_t) / a_t
			l_y := ((l_f.item.function).real_64_item ([l_x, l_f.item.params]))
			Result := ((l_y / a_t) / a_t)
		end

	iu_transform_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent iu_transform)
		end

	qags (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]; a_q___3: CE_ROUTINE): INTEGER_32
		local
			l_area: REAL_64
			l_errsum: REAL_64
			l_res_ext: REAL_64
			l_err_ext: REAL_64
			l_result0: CE_ARRAY [REAL_64]
			l_abserr0: CE_ARRAY [REAL_64]
			l_resabs0: CE_ARRAY [REAL_64]
			l_resasc0: CE_ARRAY [REAL_64]
			l_tolerance: REAL_64
			l_ertest: REAL_64
			l_error_over_large_intervals: REAL_64
			l_reseps: CE_ARRAY [REAL_64]
			l_abseps: CE_ARRAY [REAL_64]
			l_correc: REAL_64
			l_ktmin: NATURAL_32
			l_roundoff_type1: INTEGER_32
			l_roundoff_type2: INTEGER_32
			l_roundoff_type3: INTEGER_32
			l_error_type: INTEGER_32
			l_error_type2: INTEGER_32
			l_iteration: NATURAL_32
			l_positive_integrand: INTEGER_32
			l_extrapolate: INTEGER_32
			l_disallow_extrapolation: INTEGER_32
			l_table: CE_ARRAY [PD_EXTRAPOLATION_TABLE]
			l_current_level: NATURAL_32
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_a2___3: REAL_64
			l_b2: REAL_64
			l_a_i: CE_ARRAY [REAL_64]
			l_b_i: CE_ARRAY [REAL_64]
			l_r_i: CE_ARRAY [REAL_64]
			l_e_i: CE_ARRAY [REAL_64]
			l_area1: CE_ARRAY [REAL_64]
			l_area2: CE_ARRAY [REAL_64]
			l_area12: REAL_64
			l_error1: CE_ARRAY [REAL_64]
			l_error2: CE_ARRAY [REAL_64]
			l_error12: REAL_64
			l_resasc1: CE_ARRAY [REAL_64]
			l_resasc2: CE_ARRAY [REAL_64]
			l_resabs1: CE_ARRAY [REAL_64]
			l_resabs2: CE_ARRAY [REAL_64]
			l_last_e_i: REAL_64
			l_delta___0: REAL_64
			l_tmp___1: REAL_64
			l_tmp___7: REAL_64
			l_max_area: REAL_64
			l_tmp___9: REAL_64
			l_ratio: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result0.make (<<1>>)
			create l_abserr0.make (<<1>>)
			create l_resabs0.make (<<1>>)
			create l_resasc0.make (<<1>>)
			create l_reseps.make (<<1>>)
			create l_abseps.make (<<1>>)
			create l_table.make (<<1>>)
			create l_a_i.make (<<1>>)
			create l_b_i.make (<<1>>)
			create l_r_i.make (<<1>>)
			create l_e_i.make (<<1>>)
			create l_area1.make (<<1>>)
			create l_area2.make (<<1>>)
			create l_error1.make (<<1>>)
			create l_error2.make (<<1>>)
			create l_resasc1.make (<<1>>)
			create l_resasc2.make (<<1>>)
			create l_resabs1.make (<<1>>)
			create l_resabs2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ertest := (0).to_double
					l_error_over_large_intervals := (0).to_double
					l_reseps.item := (0).to_double
					l_abseps.item := (0).to_double
					l_correc := (0).to_double
					l_ktmin := (0).to_natural_32
					l_roundoff_type1 := 0
					l_roundoff_type2 := 0
					l_roundoff_type3 := 0
					l_error_type := 0
					l_error_type2 := 0
					l_iteration := (0).to_natural_32
					l_positive_integrand := 0
					l_extrapolate := 0
					l_disallow_extrapolation := 0
					initialise_inst.initialise (a_workspace, a_a___5, a_b___0)
					a_result.item := (0).to_double
					a_abserr.item := (0).to_double
					if a_limit > a_workspace.item.limit then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("iteration limit exceeds available workspace"), ce_string ("qags.c"), 232, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not (not js.return_called and then (a_epsabs <= (0).to_double)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_epsrel < (50).to_double * 2.2204460492503131e-16) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_epsrel < 0.5e-28) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("tolerance cannot be acheived with given epsabs and epsrel"), ce_string ("qags.c"), 240, 13)
							Result := 13
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if:
							a_q___3.call ([a_f, a_a___5, a_b___0, l_result0, l_abserr0, l_resabs0, l_resasc0])
							set_initial_inst.set_initial_result (a_workspace, l_result0.item, l_abserr0.item)
							l_tolerance := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_result0.item)))
							if not (l_abserr0.item <= ((100).to_double * 2.2204460492503131e-16) * l_resabs0.item) then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							if l_abserr0.item > l_tolerance then
								a_result.item := l_result0.item
								a_abserr.item := l_abserr0.item
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("cannot reach tolerance because of roundoff erroron first attempt"), ce_string ("qags.c"), 257, 18)
									Result := 18
									js.return
									if not js.return_called then
										js.break
									end
								end
							else
								l_pos := -1 + 10 -- goto _L___1
							end
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 10 then -- else: | _L___1:
							if not (l_abserr0.item <= l_tolerance) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if l_abserr0.item /= l_resasc0.item then
								a_result.item := l_result0.item
								a_abserr.item := l_abserr0.item
								Result := 0
								js.return
							else
								l_pos := -1 + 13 -- goto _L___0
							end
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 13 then -- else: | _L___0:
							if l_abserr0.item = 0.0 then
								a_result.item := l_result0.item
								a_abserr.item := l_abserr0.item
								Result := 0
								js.return
							elseif a_limit = {NATURAL_32} 1 then
								a_result.item := l_result0.item
								a_abserr.item := l_abserr0.item
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("a maximum of one iteration was insufficient"), ce_string ("qags.c"), 271, 11)
									Result := 11
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
				when 14 then -- if done | if done
							if js.return_called then
								l_pos := -1 + 33 -- skip if block
							end
				when 15 then -- if:
								qelg_inst.initialise_table (l_table)
								qelg_inst.append_table (l_table, l_result0.item)
								l_area := l_result0.item
								l_errsum := l_abserr0.item
								l_res_ext := l_result0.item
								l_err_ext := 1.7976931348623157e+308
								l_positive_integrand := positivity_inst.test_positivity (l_result0.item, l_resabs0.item)
								l_iteration := (1).to_natural_32
				when 16 then -- loop condition:
								if js.loop_done then
									l_pos := -1 + 20 -- skip loop
								end
				when 17 then -- loop body:
								l_area1.item := (0).to_double
								l_area2.item := (0).to_double
								l_area12 := (0).to_double
								l_error1.item := (0).to_double
								l_error2.item := (0).to_double
								l_error12 := (0).to_double
								util_inst.retrieve (a_workspace, l_a_i, l_b_i, l_r_i, l_e_i)
								l_current_level := a_workspace.item.level[(a_workspace.item.i).to_integer_32] + {NATURAL_32} 1
								l_a1___4 := l_a_i.item
								l_b1___0 := 0.5 * (l_a_i.item + l_b_i.item)
								l_a2___3 := l_b1___0
								l_b2 := l_b_i.item
								l_iteration := l_iteration + 1
								a_q___3.call ([a_f, l_a1___4, l_b1___0, l_area1, l_error1, l_resabs1, l_resasc1])
								a_q___3.call ([a_f, l_a2___3, l_b2, l_area2, l_error2, l_resabs2, l_resasc2])
								l_area12 := l_area1.item + l_area2.item
								l_error12 := l_error1.item + l_error2.item
								l_last_e_i := l_e_i.item
								l_errsum := (l_errsum + l_error12) - l_e_i.item
								l_area := (l_area + l_area12) - l_r_i.item
								l_tolerance := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_area)))
								if l_resasc1.item /= l_error1.item then
									if l_resasc2.item /= l_error2.item then
										l_delta___0 := l_r_i.item - l_area12
										l_tmp___1 := fabs (l_delta___0)
										if l_tmp___1 <= 1.0e-5 * (fabs (l_area12)) then
											if l_error12 >= 0.99 * l_e_i.item then
												if not l_extrapolate.to_boolean then
													l_roundoff_type1 := l_roundoff_type1 + 1
												else
													l_roundoff_type2 := l_roundoff_type2 + 1
												end
											end
										end
										if l_iteration > {NATURAL_32} 10 then
											if l_error12 > l_e_i.item then
												l_roundoff_type3 := l_roundoff_type3 + 1
											end
										end
									end
								end
								if l_roundoff_type1 + l_roundoff_type2 >= 10 then
									l_error_type := 2
								elseif l_roundoff_type3 >= 20 then
									l_error_type := 2
								end
								if l_roundoff_type2 >= 5 then
									l_error_type2 := 1
								end
								if (util_inst.subinterval_too_small (l_a1___4, l_a2___3, l_b2)).to_boolean then
									l_error_type := 4
								end
								util_inst.update (a_workspace, l_a1___4, l_b1___0, l_area1.item, l_error1.item, l_a2___3, l_b2, l_area2.item, l_error2.item)
								if l_errsum <= l_tolerance then
									l_pos := -1 + 31 -- goto compute_result
								end
				when 18 then
								if l_error_type.to_boolean then
									js.break
								end
								if not js.loop_jumped and then (l_iteration >= a_limit - {NATURAL_32} 1) then
									l_error_type := 1
									js.break
								end
								if not js.loop_jumped and then (l_iteration = {NATURAL_32} 2) then
									l_error_over_large_intervals := l_errsum
									l_ertest := l_tolerance
									qelg_inst.append_table (l_table, l_area)
									js.continue
								end
								if not js.loop_jumped and then (l_disallow_extrapolation.to_boolean) then
									js.continue
								end
								if not js.loop_jumped then
									l_error_over_large_intervals := l_error_over_large_intervals + (-l_last_e_i)
									if l_current_level < a_workspace.item.maximum_level then
										l_error_over_large_intervals := l_error_over_large_intervals + l_error12
									end
									if not l_extrapolate.to_boolean then
										if (qpsrt2_inst.large_interval (a_workspace)).to_boolean then
											js.continue
										end
										if not js.loop_jumped then
											l_extrapolate := 1
											a_workspace.item.nrmax := (1).to_natural_32
										end
									end
								end
								if not js.loop_jumped and then (not l_error_type2.to_boolean) then
									if l_error_over_large_intervals > l_ertest then
										if (qpsrt2_inst.increase_nrmax (a_workspace)).to_boolean then
											js.continue
										end
									end
								end
								if not js.loop_jumped then
									qelg_inst.append_table (l_table, l_area)
									qelg_inst.qelg (l_table, l_reseps, l_abseps)
									l_ktmin := l_ktmin + 1
									if l_ktmin > {NATURAL_32} 5 then
										if l_err_ext < 0.001 * l_errsum then
											l_error_type := 5
										end
									end
									if l_abseps.item < l_err_ext then
										l_ktmin := (0).to_natural_32
										l_err_ext := l_abseps.item
										l_res_ext := l_reseps.item
										l_correc := l_error_over_large_intervals
										l_ertest := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_reseps.item)))
										if l_err_ext <= l_ertest then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									if l_table.item.n = {NATURAL_32} 1 then
										l_disallow_extrapolation := 1
									end
									if l_error_type = 5 then
										js.break
									end
								end
								if not js.loop_jumped then
									reset_inst.reset_nrmax (a_workspace)
									l_extrapolate := 0
									l_error_over_large_intervals := l_errsum
								end
								if js.loop_increment and then (not (l_iteration < a_limit)) then
									l_pos := -1 + 20 -- break
								end
				when 19 then
								l_pos := -1 + 16 -- back to loop condition
				when 20 then -- loop done
								a_result.item := l_res_ext
								a_abserr.item := l_err_ext
								if l_err_ext = 1.7976931348623157e+308 then
									l_pos := -1 + 31 -- goto compute_result
								end
				when 21 then
								if not (l_error_type.to_boolean) then
									l_pos := -1 + 24 -- skip if block
								end
				when 22 then -- if:
								l_pos := -1 + 25 -- goto _L___3
				when 23 then -- if block done, skip else block:
								l_pos := -1 + 29
				when 24 then -- else:
								if not (l_error_type2.to_boolean) then
									l_pos := -1 + 29 -- skip if block
								end
				when 25 then -- if: | _L___3:
								if l_error_type2.to_boolean then
									l_err_ext := l_err_ext + l_correc
								end
								if l_error_type = 0 then
									l_error_type := 3
								end
								if l_res_ext = 0.0 then
									l_pos := -1 + 28 -- skip if block
								end
				when 26 then -- if:
								if l_area /= 0.0 then
									l_tmp___7 := fabs (l_res_ext)
									if l_err_ext / l_tmp___7 > l_errsum / (fabs (l_area)) then
										l_pos := -1 + 31 -- goto compute_result
									end
								else
									l_pos := -1 + 28 -- goto _L___2
								end
				when 27 then -- if block done, skip else block:
								l_pos := -1 + 29
				when 28 then -- else: | _L___2:
								if l_err_ext > l_errsum then
									l_pos := -1 + 31 -- goto compute_result
								elseif l_area = 0.0 then
									l_pos := -1 + 32 -- goto return_error
								end
				when 29 then -- if done | if done
								l_tmp___9 := fabs (l_area)
								l_max_area := (gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (l_res_ext)), l_tmp___9))
								if not l_positive_integrand.to_boolean then
									if l_max_area < 0.01 * l_resabs0.item then
										l_pos := -1 + 32 -- goto return_error
									end
								end
				when 30 then
								l_ratio := l_res_ext / l_area
								if l_ratio < 0.01 then
									l_error_type := 6
								elseif l_ratio > 100.0 then
									l_error_type := 6
								elseif l_errsum > (fabs (l_area)) then
									l_error_type := 6
								end
								l_pos := -1 + 32 -- goto return_error
				when 31 then -- compute_result:
								a_result.item := util_inst.sum_results (a_workspace)
								a_abserr.item := l_errsum
				when 32 then -- return_error:
								if l_error_type > 2 then
									l_error_type := l_error_type - 1
								end
								if l_error_type = 0 then
									Result := 0
									js.return
								elseif l_error_type = 1 then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("number of iterations was insufficient"), ce_string ("qags.c"), 543, 11)
										Result := 11
										js.return
										if not js.return_called then
											js.break
										end
									end
								elseif l_error_type = 2 then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("cannot reach tolerance because of roundoff error"), ce_string ("qags.c"), 548, 18)
										Result := 18
										js.return
										if not js.return_called then
											js.break
										end
									end
								elseif l_error_type = 3 then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("bad integrand behavior found in the integration interval"), ce_string ("qags.c"), 553, 21)
										Result := 21
										js.return
										if not js.return_called then
											js.break
										end
									end
								elseif l_error_type = 4 then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("roundoff error detected in the extrapolation table"), ce_string ("qags.c"), 558, 18)
										Result := 18
										js.return
										if not js.return_called then
											js.break
										end
									end
								elseif l_error_type = 5 then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("integral is divergent, or slowly convergent"), ce_string ("qags.c"), 563, 22)
										Result := 22
										js.return
										if not js.return_called then
											js.break
										end
									end
								else
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("could not integrate function"), ce_string ("qags.c"), 567, 5)
										Result := 5
										js.return
										if not js.return_called then
											js.break
										end
									end
								end
				when 33 then -- if done
							if not js.return_called then
								Result := 0
							end
				when 34 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

end
