class
	P_QNG

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create w10.make (<<5>>)
			create w21a.make (<<5>>)
			create w21b.make (<<6>>)
			create w43a.make (<<10>>)
			create w43b.make (<<12>>)
			create w87a.make (<<21>>)
			create w87b.make (<<23>>)
			create x1.make (<<5>>)
			create x2.make (<<5>>)
			create x3.make (<<11>>)
			create x4.make (<<22>>)
		end

feature {ANY} -- attributes

	w10: CE_ARRAY [REAL_64]

	w21a: CE_ARRAY [REAL_64]

	w21b: CE_ARRAY [REAL_64]

	w43a: CE_ARRAY [REAL_64]

	w43b: CE_ARRAY [REAL_64]

	w87a: CE_ARRAY [REAL_64]

	w87b: CE_ARRAY [REAL_64]

	x1: CE_ARRAY [REAL_64]

	x2: CE_ARRAY [REAL_64]

	x3: CE_ARRAY [REAL_64]

	x4: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_integration_qng (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_epsabs: REAL_64; a_epsrel: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]; a_neval: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_fv1: CE_ARRAY [REAL_64]
			l_fv2: CE_ARRAY [REAL_64]
			l_fv3: CE_ARRAY [REAL_64]
			l_fv4: CE_ARRAY [REAL_64]
			l_savfun: CE_ARRAY [REAL_64]
			l_res10: REAL_64
			l_res21: REAL_64
			l_res43: REAL_64
			l_res87: REAL_64
			l_result_kronrod: REAL_64
			l_err: REAL_64
			l_resabs: REAL_64
			l_resasc: REAL_64
			l_half_length: REAL_64
			l_abs_half_length: REAL_64
			l_center: REAL_64
			l_f_center: REAL_64
			l_k: INTEGER_32
			l_abscissa: REAL_64
			l_fval1: REAL_64
			l_fval2: REAL_64
			l_fval: REAL_64
			l_tmp___4: REAL_64
			l_abscissa___0: REAL_64
			l_fval1___0: REAL_64
			l_fval2___0: REAL_64
			l_fval___0: REAL_64
			l_tmp___8: REAL_64
			l_mean: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_abscissa___1: REAL_64
			l_fval___1: REAL_64
			l_tmp___16: REAL_64
			l_abscissa___2: REAL_64
			l_tmp___19: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fv1.make (<<5>>)
			create l_fv2.make (<<5>>)
			create l_fv3.make (<<5>>)
			create l_fv4.make (<<5>>)
			create l_savfun.make (<<21>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_half_length := 0.5 * (a_b___0 - a_a___5)
					l_abs_half_length := (fabs (l_half_length))
					l_center := 0.5 * (a_b___0 + a_a___5)
					l_f_center := ((a_f.item.function).real_64_item ([l_center, a_f.item.params]))
					if not (a_epsabs <= (0).to_double) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_epsrel < (50).to_double * 2.2204460492503131e-16) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_epsrel < 0.5e-28) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						a_result.item := (0).to_double
						a_abserr.item := (0).to_double
						a_neval.item := (0).to_natural_32
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("tolerance cannot be acheived with given epsabs and epsrel"), ce_string ("qng.c"), 56, 13)
							Result := 13
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 6 then -- if done | if done
						if not js.return_called then
							l_res10 := (0).to_double
							l_res21 := (w21b[5] * l_f_center)
							l_resabs := (w21b[5] * (fabs (l_f_center)))
							l_k := 0
							from
							until
								not (l_k < 5)
							loop
								l_abscissa := l_half_length * x1[l_k]
								l_fval1 := ((a_f.item.function).real_64_item ([l_center + l_abscissa, a_f.item.params]))
								l_fval2 := ((a_f.item.function).real_64_item ([l_center - l_abscissa, a_f.item.params]))
								l_fval := l_fval1 + l_fval2
								l_res10 := l_res10 + (w10[l_k] * l_fval)
								l_res21 := l_res21 + (w21a[l_k] * l_fval)
								l_tmp___4 := fabs (l_fval1)
								l_resabs := l_resabs + (w21a[l_k] * (l_tmp___4 + (fabs (l_fval2))))
								l_savfun[l_k] := l_fval
								l_fv1[l_k] := l_fval1
								l_fv2[l_k] := l_fval2
								l_k := l_k + 1
							end
							l_k := 0
							from
							until
								not (l_k < 5)
							loop
								l_abscissa___0 := l_half_length * x2[l_k]
								l_fval1___0 := ((a_f.item.function).real_64_item ([l_center + l_abscissa___0, a_f.item.params]))
								l_fval2___0 := ((a_f.item.function).real_64_item ([l_center - l_abscissa___0, a_f.item.params]))
								l_fval___0 := l_fval1___0 + l_fval2___0
								l_res21 := l_res21 + (w21b[l_k] * l_fval___0)
								l_tmp___8 := fabs (l_fval1___0)
								l_resabs := l_resabs + (w21b[l_k] * (l_tmp___8 + (fabs (l_fval2___0))))
								l_savfun[l_k + 5] := l_fval___0
								l_fv3[l_k] := l_fval1___0
								l_fv4[l_k] := l_fval2___0
								l_k := l_k + 1
							end
							l_resabs := l_resabs * l_abs_half_length
							l_mean := 0.5 * l_res21
							l_resasc := (w21b[5] * (fabs (l_f_center - l_mean)))
							l_k := 0
							from
							until
								not (l_k < 5)
							loop
								l_tmp___11 := fabs (l_fv1[l_k] - l_mean)
								l_tmp___12 := fabs (l_fv2[l_k] - l_mean)
								l_tmp___13 := fabs (l_fv3[l_k] - l_mean)
								l_resasc := l_resasc + (w21a[l_k] * (l_tmp___11 + l_tmp___12) + w21b[l_k] * (l_tmp___13 + (fabs (l_fv4[l_k] - l_mean))))
								l_k := l_k + 1
							end
							l_resasc := l_resasc * l_abs_half_length
							l_result_kronrod := l_res21 * l_half_length
							l_err := err_inst.rescale_error ((l_res21 - l_res10) * l_half_length, l_resabs, l_resasc)
							if l_err < a_epsabs then
								a_result.item := l_result_kronrod
								a_abserr.item := l_err
								a_neval.item := (21).to_natural_32
								Result := 0
								js.return
							elseif l_err < a_epsrel * (fabs (l_result_kronrod)) then
								a_result.item := l_result_kronrod
								a_abserr.item := l_err
								a_neval.item := (21).to_natural_32
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_res43 := (w43b[11] * l_f_center)
							l_k := 0
							from
							until
								not (l_k < 10)
							loop
								l_res43 := l_res43 + (l_savfun[l_k] * w43a[l_k])
								l_k := l_k + 1
							end
							l_k := 0
							from
							until
								not (l_k < 11)
							loop
								l_abscissa___1 := l_half_length * x3[l_k]
								l_tmp___16 := (a_f.item.function).real_64_item ([l_center + l_abscissa___1, a_f.item.params])
								l_fval___1 := l_tmp___16 + ((a_f.item.function).real_64_item ([l_center - l_abscissa___1, a_f.item.params]))
								l_res43 := l_res43 + (l_fval___1 * w43b[l_k])
								l_savfun[l_k + 10] := l_fval___1
								l_k := l_k + 1
							end
							l_result_kronrod := l_res43 * l_half_length
							l_err := err_inst.rescale_error ((l_res43 - l_res21) * l_half_length, l_resabs, l_resasc)
							if l_err < a_epsabs then
								a_result.item := l_result_kronrod
								a_abserr.item := l_err
								a_neval.item := (43).to_natural_32
								Result := 0
								js.return
							elseif l_err < a_epsrel * (fabs (l_result_kronrod)) then
								a_result.item := l_result_kronrod
								a_abserr.item := l_err
								a_neval.item := (43).to_natural_32
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_res87 := (w87b[22] * l_f_center)
							l_k := 0
							from
							until
								not (l_k < 21)
							loop
								l_res87 := l_res87 + (l_savfun[l_k] * w87a[l_k])
								l_k := l_k + 1
							end
							l_k := 0
							from
							until
								not (l_k < 22)
							loop
								l_abscissa___2 := l_half_length * x4[l_k]
								l_tmp___19 := (a_f.item.function).real_64_item ([l_center + l_abscissa___2, a_f.item.params])
								l_res87 := l_res87 + (w87b[l_k] * (l_tmp___19 + ((a_f.item.function).real_64_item ([l_center - l_abscissa___2, a_f.item.params]))))
								l_k := l_k + 1
							end
							l_result_kronrod := l_res87 * l_half_length
							l_err := err_inst.rescale_error ((l_res87 - l_res43) * l_half_length, l_resabs, l_resasc)
							if l_err < a_epsabs then
								a_result.item := l_result_kronrod
								a_abserr.item := l_err
								a_neval.item := (87).to_natural_32
								Result := 0
								js.return
							elseif l_err < a_epsrel * (fabs (l_result_kronrod)) then
								a_result.item := l_result_kronrod
								a_abserr.item := l_err
								a_neval.item := (87).to_natural_32
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							a_result.item := l_result_kronrod
							a_abserr.item := l_err
							a_neval.item := (87).to_natural_32
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("failed to reach tolerance with highest-order rule"), ce_string ("qng.c"), 189, 14)
								Result := 14
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
