class
	P_QPSRT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	qpsrt (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE])
		local
			l_last: NATURAL_32
			l_limit: NATURAL_32
			l_elist: CE_POINTER [REAL_64]
			l_order: CE_POINTER [NATURAL_32]
			l_errmax: REAL_64
			l_errmin: REAL_64
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_top: INTEGER_32
			l_i_nrmax: NATURAL_32
			l_i_maxerr: NATURAL_32
			js: JUMP_STATE
		do
			create l_elist.make
			create l_order.make

			l_last := a_workspace.item.size - {NATURAL_32} 1
			l_limit := a_workspace.item.limit
			l_elist := a_workspace.item.elist
			l_order := a_workspace.item.order
			l_i_nrmax := a_workspace.item.nrmax
			l_i_maxerr := l_order[l_i_nrmax.to_integer_32]
			if l_last < {NATURAL_32} 2 then
				l_order[0] := (0).to_natural_32
				l_order[1] := (1).to_natural_32
				a_workspace.item.i := l_i_maxerr
				js.return
			end
			if not js.return_called then
				l_errmax := l_elist[l_i_maxerr.to_integer_32]
				from
				until
					js.loop_done
				loop
					if l_i_nrmax > {NATURAL_32} 0 then
						if not (l_errmax > l_elist[(l_order[(l_i_nrmax - {NATURAL_32} 1).to_integer_32]).to_integer_32]) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_order[l_i_nrmax.to_integer_32] := l_order[(l_i_nrmax - {NATURAL_32} 1).to_integer_32]
						l_i_nrmax := l_i_nrmax - 1
					end
				end
				if l_last < l_limit // {NATURAL_32} 2 + {NATURAL_32} 2 then
					l_top := l_last.to_integer_32
				else
					l_top := ((l_limit - l_last) + {NATURAL_32} 1).to_integer_32
				end
				l_i := (l_i_nrmax + {NATURAL_32} 1).to_integer_32
				from
				until
					js.loop_done
				loop
					if l_i < l_top then
						if not (l_errmax < l_elist[(l_order[l_i]).to_integer_32]) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_order[(l_i - 1)] := l_order[l_i]
						l_i := l_i + 1
					end
				end
				l_order[(l_i - 1)] := l_i_maxerr
				l_errmin := l_elist[l_last.to_integer_32]
				l_k := l_top - 1
				from
				until
					js.loop_done
				loop
					if l_k > l_i - 2 then
						if not (l_errmin >= l_elist[(l_order[l_k]).to_integer_32]) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_order[(l_k + 1)] := l_order[l_k]
						l_k := l_k - 1
					end
				end
				l_order[(l_k + 1)] := l_last
				l_i_maxerr := l_order[l_i_nrmax.to_integer_32]
				a_workspace.item.i := l_i_maxerr
				a_workspace.item.nrmax := l_i_nrmax
			end
		end

end
