class
	P_QUANTILES_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_stats_char_quantile_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_double
				end
				Result := l_result
			end
		end

	gsl_stats_float_quantile_from_sorted_data (a_sorted_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_double
				end
				Result := l_result
			end
		end

	gsl_stats_int_quantile_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_double
				end
				Result := l_result
			end
		end

	gsl_stats_long_double_quantile_from_sorted_data (a_sorted_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).truncated_to_real_64
				else
					l_result := (real_96_from_real_64 (((1).to_double - l_delta___0)) * a_sorted_data[(l_lhs * a_stride).to_integer_32] + real_96_from_real_64 (l_delta___0) * a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).truncated_to_real_64
				end
				Result := l_result
			end
		end

	gsl_stats_long_quantile_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_double
				end
				Result := l_result
			end
		end

	gsl_stats_quantile_from_sorted_data (a_sorted_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := a_sorted_data[(l_lhs * a_stride).to_integer_32]
				else
					l_result := ((1).to_double - l_delta___0) * a_sorted_data[(l_lhs * a_stride).to_integer_32] + l_delta___0 * a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]
				end
				Result := l_result
			end
		end

	gsl_stats_short_quantile_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_double
				end
				Result := l_result
			end
		end

	gsl_stats_uchar_quantile_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64 + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64
				end
				Result := l_result
			end
		end

	gsl_stats_uint_quantile_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64 + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64
				end
				Result := l_result
			end
		end

	gsl_stats_ulong_quantile_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64 + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64
				end
				Result := l_result
			end
		end

	gsl_stats_ushort_quantile_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32; a_f: REAL_64): REAL_64
		local
			l_index: REAL_64
			l_lhs: NATURAL_32
			l_delta___0: REAL_64
			l_result: REAL_64
			js: JUMP_STATE
		do
			l_index := a_f * (a_n - {NATURAL_32} 1).to_real_64
			l_lhs := (l_index.truncated_to_integer).to_natural_32
			l_delta___0 := l_index - l_lhs.to_real_64
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				if l_lhs = a_n - {NATURAL_32} 1 then
					l_result := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_result := ((1).to_double - l_delta___0) * (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64 + l_delta___0 * (a_sorted_data[((l_lhs + {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64
				end
				Result := l_result
			end
		end

end
