class
	P_RAN2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_ran2.make
			create ran2_type.make (<<1>>)
		end

feature {ANY} -- attributes

	a12: INTEGER_32 assign set_a12

	set_a12 (a_a12: INTEGER_32)
		do
			a12 := a_a12
		end

	a22: INTEGER_32 assign set_a22

	set_a22 (a_a22: INTEGER_32)
		do
			a22 := a_a22
		end

	gsl_rng_ran2: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_ran2

	set_gsl_rng_ran2 (a_gsl_rng_ran2: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_ran2 := a_gsl_rng_ran2
		end

	m1___0: INTEGER_32 assign set_m1___0

	set_m1___0 (a_m1___0: INTEGER_32)
		do
			m1___0 := a_m1___0
		end

	m2___0: INTEGER_32 assign set_m2___0

	set_m2___0 (a_m2___0: INTEGER_32)
		do
			m2___0 := a_m2___0
		end

	q12: INTEGER_32 assign set_q12

	set_q12 (a_q12: INTEGER_32)
		do
			q12 := a_q12
		end

	q22: INTEGER_32 assign set_q22

	set_q22 (a_q22: INTEGER_32)
		do
			q22 := a_q22
		end

	r1: INTEGER_32 assign set_r1

	set_r1 (a_r1: INTEGER_32)
		do
			r1 := a_r1
		end

	r2: INTEGER_32 assign set_r2

	set_r2 (a_r2: INTEGER_32)
		do
			r2 := a_r2
		end

	ran2_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran2_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN2_STATE_T]
			l_x: NATURAL_32
			l_y: NATURAL_32
			l_h1: INTEGER_32
			l_t1: INTEGER_32
			l_h2: INTEGER_32
			l_t2: INTEGER_32
			l_j: NATURAL_32
			l_delta___0: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN2_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_y := l_state.item.y
			l_h1 := (l_x // q12.to_natural_32).to_integer_32
			l_t1 := (a12.to_natural_32 * (l_x - (l_h1 * q12).to_natural_32) - (l_h1 * r1).to_natural_32).to_integer_32
			l_h2 := (l_y // q22.to_natural_32).to_integer_32
			l_t2 := (a22.to_natural_32 * (l_y - (l_h2 * q22).to_natural_32) - (l_h2 * r2).to_natural_32).to_integer_32
			if l_t1 < 0 then
				l_t1 := l_t1 + m1___0
			end
			if l_t2 < 0 then
				l_t2 := l_t2 + m2___0
			end
			l_state.item.x := l_t1.to_natural_32
			l_state.item.y := l_t2.to_natural_32
			l_j := l_state.item.n // {NATURAL_32} 67_108_862
			l_delta___0 := (l_state.item.shuffle[l_j.to_integer_32] - l_t2.to_natural_32).to_integer_32
			if l_delta___0 < 1 then
				l_delta___0 := l_delta___0 + (m1___0 - 1)
			end
			l_state.item.n := l_delta___0.to_natural_32
			l_state.item.shuffle[l_j.to_integer_32] := l_t1.to_natural_32
			Result := (l_state.item.n)
		end

	ran2_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran2_get)
		end

	ran2_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_x_max: REAL_32
			l_x: REAL_32
			js: JUMP_STATE
		do
			l_x_max := (1).to_real - {REAL_32} 1.2e-7
			l_x := (ran2_get (a_vstate)).to_real_32 / {REAL_32} 2147483563.0
			if l_x > l_x_max then
				Result := l_x_max.to_double
				js.return
			end
			if not js.return_called then
				Result := l_x.to_double
			end
		end

	ran2_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran2_get_double)
		end

	ran2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN2_STATE_T]
			l_i: INTEGER_32
			l_h: INTEGER_32
			l_t: INTEGER_32
			l_h___0: INTEGER_32
			l_t___0: INTEGER_32
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_RAN2_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.y := l_s
			l_i := 0
			from
			until
				not (l_i < 8)
			loop
				l_h := (l_s // q12.to_natural_32).to_integer_32
				l_t := (a12.to_natural_32 * (l_s - (l_h * q12).to_natural_32) - (l_h * r1).to_natural_32).to_integer_32
				if l_t < 0 then
					l_t := l_t + m1___0
				end
				l_s := l_t.to_natural_32
				l_i := l_i + 1
			end
			l_i := 31
			from
			until
				not (l_i >= 0)
			loop
				l_h___0 := (l_s // q12.to_natural_32).to_integer_32
				l_t___0 := (a12.to_natural_32 * (l_s - (l_h___0 * q12).to_natural_32) - (l_h___0 * r1).to_natural_32).to_integer_32
				if l_t___0 < 0 then
					l_t___0 := l_t___0 + m1___0
				end
				l_s := l_t___0.to_natural_32
				l_state.item.shuffle[l_i] := l_s
				l_i := l_i - 1
			end
			l_state.item.x := l_s
			l_state.item.n := l_s
		end

	ran2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran2_set)
		end

end
