class
	P_RANF

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_ranf.make
			create ranf_type.make (<<1>>)
		end

feature {ANY} -- attributes

	a0: NATURAL_16 assign set_a0

	set_a0 (a_a0: NATURAL_16)
		do
			a0 := a_a0
		end

	a1___0: NATURAL_16 assign set_a1___0

	set_a1___0 (a_a1___0: NATURAL_16)
		do
			a1___0 := a_a1___0
		end

	a2___0: NATURAL_16 assign set_a2___0

	set_a2___0 (a_a2___0: NATURAL_16)
		do
			a2___0 := a_a2___0
		end

	gsl_rng_ranf: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_ranf

	set_gsl_rng_ranf (a_gsl_rng_ranf: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_ranf := a_gsl_rng_ranf
		end

	ranf_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ranf_advance (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RANF_STATE_T]
			l_x0: NATURAL_32
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_r___3: NATURAL_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			l_x0 := (l_state.item.x0).to_natural_32
			l_x1___0 := (l_state.item.x1).to_natural_32
			l_x2___1 := (l_state.item.x2).to_natural_32
			l_r___3 := a0.to_natural_32 * l_x0
			l_state.item.x0 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + (a0.to_natural_32 * l_x1___0 + a1___0.to_natural_32 * l_x0)
			l_state.item.x1 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + ((a0.to_natural_32 * l_x2___1 + a1___0.to_natural_32 * l_x1___0) + a2___0.to_natural_32 * l_x0)
			l_state.item.x2 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
		end

	ranf_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_state: CE_POINTER [PD_RANF_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			ranf_advance (create {CE_POINTER [ANY]}.make_cast (l_state))
			l_x1___0 := (l_state.item.x1).to_natural_32
			l_x2___1 := (l_state.item.x2).to_natural_32
			Result := (((l_x2___1).bit_shift_left (16)) + l_x1___0)
		end

	ranf_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranf_get)
		end

	ranf_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RANF_STATE_T]
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			ranf_advance (create {CE_POINTER [ANY]}.make_cast (l_state))
			l_tmp := ldexp ((l_state.item.x2).to_real_64, -16)
			l_tmp___0 := ldexp ((l_state.item.x1).to_real_64, -32)
			Result := ((l_tmp + l_tmp___0) + (ldexp ((l_state.item.x0).to_real_64, -48)))
		end

	ranf_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranf_get_double)
		end

	ranf_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANF_STATE_T]
			l_x0: NATURAL_16
			l_x1___0: NATURAL_16
			l_x2___1: NATURAL_16
			l_r___3: NATURAL_32
			l_b0: NATURAL_32
			l_b1___0: NATURAL_32
			l_b2: NATURAL_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			l_b0 := {NATURAL_32} 55_005
			l_b1___0 := {NATURAL_32} 47_252
			l_b2 := {NATURAL_32} 23_790
			if a_s = {NATURAL_32} 0 then
				l_x0 := (40_145).to_natural_16
				l_x1___0 := (21_500).to_natural_16
				l_x2___1 := (38_018).to_natural_16
			else
				l_x0 := ((((a_s).bit_or ({NATURAL_32} 1))).bit_and ({NATURAL_32} 65_535)).to_natural_16
				l_x1___0 := ((((a_s).bit_shift_right (16))).bit_and ({NATURAL_32} 65_535)).to_natural_16
				l_x2___1 := (0).to_natural_16
			end
			l_r___3 := l_b0 * l_x0.to_natural_32
			l_state.item.x0 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + (l_b0 * l_x1___0.to_natural_32 + l_b1___0 * l_x0.to_natural_32)
			l_state.item.x1 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + ((l_b0 * l_x2___1.to_natural_32 + l_b1___0 * l_x1___0.to_natural_32) + l_b2 * l_x0.to_natural_32)
			l_state.item.x2 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
		end

	ranf_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranf_set)
		end

end
