class
	P_RANLXD

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_ranlxd1.make
			create gsl_rng_ranlxd2.make
			create next___0.make (<<12>>)
			create ranlxd1_type.make (<<1>>)
			create ranlxd2_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_ranlxd1: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_ranlxd1

	set_gsl_rng_ranlxd1 (a_gsl_rng_ranlxd1: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_ranlxd1 := a_gsl_rng_ranlxd1
		end

	gsl_rng_ranlxd2: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_ranlxd2

	set_gsl_rng_ranlxd2 (a_gsl_rng_ranlxd2: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_ranlxd2 := a_gsl_rng_ranlxd2
		end

	next___0: CE_ARRAY [INTEGER_32]

	one_bit___0: REAL_64 assign set_one_bit___0

	set_one_bit___0 (a_one_bit___0: REAL_64)
		do
			one_bit___0 := a_one_bit___0
		end

	ranlxd1_type: CE_ARRAY [PD_GSL_RNG_TYPE]

	ranlxd2_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	increment_state___0 (a_state: CE_POINTER [PD_RANLXD_STATE_T])
		local
			l_k: INTEGER_32
			l_kmax___0: INTEGER_32
			l_y1: REAL_64
			l_y2: REAL_64
			l_y3: REAL_64
			l_xdbl: CE_POINTER [REAL_64]
			l_carry: REAL_64
			l_ir: NATURAL_32
			l_jr: NATURAL_32
		do
			create l_xdbl.make

			l_xdbl := a_state.item.xdbl
			l_carry := a_state.item.carry
			l_ir := a_state.item.ir
			l_jr := a_state.item.jr
			l_k := 0
			from
			until
				not (l_ir > {NATURAL_32} 0)
			loop
				l_y1 := l_xdbl[l_jr.to_integer_32] - l_xdbl[l_ir.to_integer_32]
				l_y2 := l_y1 - l_carry
				if l_y2 < (0).to_double then
					l_carry := one_bit___0
					l_y2 := l_y2 + (1).to_double
				else
					l_carry := (0).to_double
				end
				l_xdbl[l_ir.to_integer_32] := l_y2
				l_ir := (next___0[l_ir.to_integer_32]).to_natural_32
				l_jr := (next___0[l_jr.to_integer_32]).to_natural_32
				l_k := l_k + 1
			end
			l_kmax___0 := (a_state.item.pr - {NATURAL_32} 12).to_integer_32
			from
			until
				not (l_k <= l_kmax___0)
			loop
				l_y1 := l_xdbl[7] - l_xdbl[0]
				l_y1 := l_y1 - l_carry
				l_y2 := l_xdbl[8] - l_xdbl[1]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - one_bit___0
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[0] := l_y1
				l_y3 := l_xdbl[9] - l_xdbl[2]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - one_bit___0
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[1] := l_y2
				l_y1 := l_xdbl[10] - l_xdbl[3]
				if l_y3 < (0).to_double then
					l_y1 := l_y1 - one_bit___0
					l_y3 := l_y3 + (1).to_double
				end
				l_xdbl[2] := l_y3
				l_y2 := l_xdbl[11] - l_xdbl[4]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - one_bit___0
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[3] := l_y1
				l_y3 := l_xdbl[0] - l_xdbl[5]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - one_bit___0
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[4] := l_y2
				l_y1 := l_xdbl[1] - l_xdbl[6]
				if l_y3 < (0).to_double then
					l_y1 := l_y1 - one_bit___0
					l_y3 := l_y3 + (1).to_double
				end
				l_xdbl[5] := l_y3
				l_y2 := l_xdbl[2] - l_xdbl[7]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - one_bit___0
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[6] := l_y1
				l_y3 := l_xdbl[3] - l_xdbl[8]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - one_bit___0
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[7] := l_y2
				l_y1 := l_xdbl[4] - l_xdbl[9]
				if l_y3 < (0).to_double then
					l_y1 := l_y1 - one_bit___0
					l_y3 := l_y3 + (1).to_double
				end
				l_xdbl[8] := l_y3
				l_y2 := l_xdbl[5] - l_xdbl[10]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - one_bit___0
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[9] := l_y1
				l_y3 := l_xdbl[6] - l_xdbl[11]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - one_bit___0
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[10] := l_y2
				if l_y3 < (0).to_double then
					l_carry := one_bit___0
					l_y3 := l_y3 + (1).to_double
				else
					l_carry := (0).to_double
				end
				l_xdbl[11] := l_y3
				l_k := l_k + (12)
			end
			l_kmax___0 := (a_state.item.pr).to_integer_32
			from
			until
				not (l_k < l_kmax___0)
			loop
				l_y1 := l_xdbl[l_jr.to_integer_32] - l_xdbl[l_ir.to_integer_32]
				l_y2 := l_y1 - l_carry
				if l_y2 < (0).to_double then
					l_carry := one_bit___0
					l_y2 := l_y2 + (1).to_double
				else
					l_carry := (0).to_double
				end
				l_xdbl[l_ir.to_integer_32] := l_y2
				l_ir := (next___0[l_ir.to_integer_32]).to_natural_32
				l_jr := (next___0[l_jr.to_integer_32]).to_natural_32
				l_k := l_k + 1
			end
			a_state.item.ir := l_ir
			a_state.item.ir_old := l_ir
			a_state.item.jr := l_jr
			a_state.item.carry := l_carry
		end

	ranlxd1_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxd_set_lux (a_vstate, a_s, {NATURAL_32} 202)
		end

	ranlxd1_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlxd1_set)
		end

	ranlxd2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxd_set_lux (a_vstate, a_s, {NATURAL_32} 397)
		end

	ranlxd2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlxd2_set)
		end

	ranlxd_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		do
			Result := ((ranlxd_get_double (a_vstate)) * 4294967296.0).truncated_to_integer_64.to_natural_32
		end

	ranlxd_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlxd_get)
		end

	ranlxd_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RANLXD_STATE_T]
			l_ir: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RANLXD_STATE_T]}.make_cast (a_vstate)
			l_ir := (l_state.item.ir).to_integer_32
			l_state.item.ir := (next___0[l_ir]).to_natural_32
			if l_state.item.ir = l_state.item.ir_old then
				increment_state___0 (l_state)
			end
			Result := (l_state.item.xdbl[(l_state.item.ir).to_integer_32])
		end

	ranlxd_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlxd_get_double)
		end

	ranlxd_set_lux (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32; a_luxury: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANLXD_STATE_T]
			l_ibit: INTEGER_32
			l_jbit: INTEGER_32
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_l: INTEGER_32
			l_xbit: CE_ARRAY [INTEGER_32]
			l_x: REAL_64
			l_y: REAL_64
			l_seed: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_xbit.make (<<31>>)

			l_s := a_s
			l_state := create {CE_POINTER [PD_RANLXD_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_seed := l_s.to_integer_32
			l_i := ((l_seed.to_natural_32).bit_and ({NATURAL_32} 4_294_967_295)).to_integer_32
			l_k := 0
			from
			until
				not (l_k < 31)
			loop
				l_xbit[l_k] := l_i \\ 2
				l_i := l_i // (2)
				l_k := l_k + 1
			end
			l_ibit := 0
			l_jbit := 18
			l_k := 0
			from
			until
				not (not js.loop_done and then (l_k < 12))
			loop
				l_x := (0).to_double
				l_l := 1
				from
				until
					not (l_l <= 48)
				loop
					l_y := ((l_xbit[l_ibit] + 1) \\ 2).to_double
					l_x := l_x + (l_x + l_y)
					l_xbit[l_ibit] := (l_xbit[l_ibit] + l_xbit[l_jbit]) \\ 2
					l_ibit := (l_ibit + 1) \\ 31
					l_jbit := (l_jbit + 1) \\ 31
					l_l := l_l + 1
				end
				l_state.item.xdbl[l_k] := (one_bit___0 * l_x)
				l_k := l_k + 1
			end
			l_state.item.carry := (0).to_double
			l_state.item.ir := {NATURAL_32} 11
			l_state.item.jr := {NATURAL_32} 7
			l_state.item.ir_old := {NATURAL_32} 0
			l_state.item.pr := a_luxury
		end

end
