class
	P_REAL_MAIN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_fft_real_float_transform (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]; a_work: CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]): INTEGER_32
		local
			l_nf: NATURAL_32
			l_i: NATURAL_32
			l_q___3: NATURAL_32
			l_product: NATURAL_32
			l_tskip: NATURAL_32
			l_product_1: NATURAL_32
			l_scratch: CE_POINTER [REAL_32]
			l_twiddle1: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle2: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle3: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle4: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_state: NATURAL_32
			l_in: CE_POINTER [REAL_32]
			l_istride: NATURAL_32
			l_out: CE_POINTER [REAL_32]
			l_ostride: NATURAL_32
			l_factor: NATURAL_32
			js: JUMP_STATE
		do
			create l_scratch.make
			create l_twiddle1.make
			create l_twiddle2.make
			create l_twiddle3.make
			create l_twiddle4.make
			create l_in.make
			create l_out.make

			l_nf := a_wavetable.item.nf
			l_product := (1).to_natural_32
			l_scratch := a_work.item.scratch
			l_state := (0).to_natural_32
			l_in := a_data
			l_istride := a_stride
			l_out := l_scratch
			l_ostride := (1).to_natural_32
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_main.c"), 54, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_n = {NATURAL_32} 1) then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_n /= a_wavetable.item.n) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("wavetable does not match length of data"), ce_string ("real_main.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_n /= a_work.item.n) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("workspace does not match length of data"), ce_string ("real_main.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nf)
				loop
					l_factor := a_wavetable.item.factor[l_i.to_integer_32]
					l_product_1 := l_product
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					l_tskip := (l_product_1 + {NATURAL_32} 1) // {NATURAL_32} 2 - {NATURAL_32} 1
					if l_state = {NATURAL_32} 0 then
						l_in := a_data
						l_istride := a_stride
						l_out := l_scratch
						l_ostride := (1).to_natural_32
						l_state := (1).to_natural_32
					else
						l_in := l_scratch
						l_istride := (1).to_natural_32
						l_out := a_data
						l_ostride := a_stride
						l_state := (0).to_natural_32
					end
					if l_factor = {NATURAL_32} 2 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						real_pass_2_inst.fft_real_float_pass_2 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1)
					elseif l_factor = {NATURAL_32} 3 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						l_twiddle2 := l_twiddle1 + l_tskip.to_integer_32
						real_pass_3_inst.fft_real_float_pass_3 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1, l_twiddle2)
					elseif l_factor = {NATURAL_32} 4 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						l_twiddle2 := l_twiddle1 + l_tskip.to_integer_32
						l_twiddle3 := l_twiddle2 + l_tskip.to_integer_32
						real_pass_4_inst.fft_real_float_pass_4 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3)
					elseif l_factor = {NATURAL_32} 5 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						l_twiddle2 := l_twiddle1 + l_tskip.to_integer_32
						l_twiddle3 := l_twiddle2 + l_tskip.to_integer_32
						l_twiddle4 := l_twiddle3 + l_tskip.to_integer_32
						real_pass_5_inst.fft_real_float_pass_5 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4)
					else
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						real_pass_n_inst.fft_real_float_pass_n (l_in, l_istride, l_out, l_ostride, l_factor, l_product, a_n, l_twiddle1)
					end
					l_i := l_i + 1
				end
				if l_state = {NATURAL_32} 1 then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_n)
					loop
						a_data[(a_stride * l_i).to_integer_32] := l_scratch[l_i.to_integer_32]
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_fft_real_transform (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]; a_work: CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]): INTEGER_32
		local
			l_nf: NATURAL_32
			l_i: NATURAL_32
			l_q___3: NATURAL_32
			l_product: NATURAL_32
			l_tskip: NATURAL_32
			l_product_1: NATURAL_32
			l_scratch: CE_POINTER [REAL_64]
			l_twiddle1: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle2: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle3: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle4: CE_POINTER [PD_GSL_COMPLEX]
			l_state: NATURAL_32
			l_in: CE_POINTER [REAL_64]
			l_istride: NATURAL_32
			l_out: CE_POINTER [REAL_64]
			l_ostride: NATURAL_32
			l_factor: NATURAL_32
			js: JUMP_STATE
		do
			create l_scratch.make
			create l_twiddle1.make
			create l_twiddle2.make
			create l_twiddle3.make
			create l_twiddle4.make
			create l_in.make
			create l_out.make

			l_nf := a_wavetable.item.nf
			l_product := (1).to_natural_32
			l_scratch := a_work.item.scratch
			l_state := (0).to_natural_32
			l_in := a_data
			l_istride := a_stride
			l_out := l_scratch
			l_ostride := (1).to_natural_32
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_main.c"), 54, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_n = {NATURAL_32} 1) then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_n /= a_wavetable.item.n) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("wavetable does not match length of data"), ce_string ("real_main.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_n /= a_work.item.n) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("workspace does not match length of data"), ce_string ("real_main.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nf)
				loop
					l_factor := a_wavetable.item.factor[l_i.to_integer_32]
					l_product_1 := l_product
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					l_tskip := (l_product_1 + {NATURAL_32} 1) // {NATURAL_32} 2 - {NATURAL_32} 1
					if l_state = {NATURAL_32} 0 then
						l_in := a_data
						l_istride := a_stride
						l_out := l_scratch
						l_ostride := (1).to_natural_32
						l_state := (1).to_natural_32
					else
						l_in := l_scratch
						l_istride := (1).to_natural_32
						l_out := a_data
						l_ostride := a_stride
						l_state := (0).to_natural_32
					end
					if l_factor = {NATURAL_32} 2 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						real_pass_2_inst.fft_real_pass_2 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1)
					elseif l_factor = {NATURAL_32} 3 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						l_twiddle2 := l_twiddle1 + l_tskip.to_integer_32
						real_pass_3_inst.fft_real_pass_3 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1, l_twiddle2)
					elseif l_factor = {NATURAL_32} 4 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						l_twiddle2 := l_twiddle1 + l_tskip.to_integer_32
						l_twiddle3 := l_twiddle2 + l_tskip.to_integer_32
						real_pass_4_inst.fft_real_pass_4 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3)
					elseif l_factor = {NATURAL_32} 5 then
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						l_twiddle2 := l_twiddle1 + l_tskip.to_integer_32
						l_twiddle3 := l_twiddle2 + l_tskip.to_integer_32
						l_twiddle4 := l_twiddle3 + l_tskip.to_integer_32
						real_pass_5_inst.fft_real_pass_5 (l_in, l_istride, l_out, l_ostride, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4)
					else
						l_twiddle1 := a_wavetable.item.twiddle[l_i.to_integer_32]
						real_pass_n_inst.fft_real_pass_n (l_in, l_istride, l_out, l_ostride, l_factor, l_product, a_n, l_twiddle1)
					end
					l_i := l_i + 1
				end
				if l_state = {NATURAL_32} 1 then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_n)
					loop
						a_data[(a_stride * l_i).to_integer_32] := l_scratch[l_i.to_integer_32]
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

end
