class
	P_REAL_PASS_2

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	fft_real_float_pass_2 (a_in: CE_POINTER [REAL_32]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_32]; a_ostride: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle: CE_POINTER [PD_GSL_COMPLEX_FLOAT])
		local
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_factor: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_product_1: NATURAL_32
			l_from0: NATURAL_32
			l_from1: NATURAL_32
			l_r0: REAL_32
			l_r1___1: REAL_32
			l_s0: REAL_32
			l_s1: REAL_32
			l_to0: NATURAL_32
			l_to1: NATURAL_32
			l_w_real: REAL_32
			l_w_imag: REAL_32
			l_from0___0: NATURAL_32
			l_from1___0: NATURAL_32
			l_f0_real: REAL_32
			l_f0_imag: REAL_32
			l_f1_real: REAL_32
			l_f1_imag: REAL_32
			l_z0_real: REAL_32
			l_z0_imag: REAL_32
			l_z1_real: REAL_32
			l_z1_imag: REAL_32
			l_x0_real: REAL_32
			l_x0_imag: REAL_32
			l_x1_real: REAL_32
			l_x1_imag: REAL_32
			l_to0___0: NATURAL_32
			l_to1___0: NATURAL_32
			l_from0___1: NATURAL_32
			l_from1___1: NATURAL_32
			l_to0___1: NATURAL_32
			js: JUMP_STATE
		do
			l_factor := (2).to_natural_32
			l_m___4 := a_n // l_factor
			l_q___3 := a_n // a_product
			l_product_1 := a_product // l_factor
			l_k1 := (0).to_natural_32
			from
			until
				not (l_k1 < l_q___3)
			loop
				l_from0 := l_k1 * l_product_1
				l_from1 := l_from0 + l_m___4
				l_r0 := a_in[(a_istride * l_from0).to_integer_32]
				l_r1___1 := a_in[(a_istride * l_from1).to_integer_32]
				l_s0 := l_r0 + l_r1___1
				l_s1 := l_r0 - l_r1___1
				l_to0 := a_product * l_k1
				l_to1 := (l_to0 + a_product) - {NATURAL_32} 1
				a_out[(a_ostride * l_to0).to_integer_32] := l_s0
				a_out[(a_ostride * l_to1).to_integer_32] := l_s1
				l_k1 := l_k1 + 1
			end
			if l_product_1 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				l_k := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < (l_product_1 + {NATURAL_32} 1) // {NATURAL_32} 2))
				loop
					l_w_real := (a_twiddle + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w_imag := -(a_twiddle + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_k1 := (0).to_natural_32
					from
					until
						not (l_k1 < l_q___3)
					loop
						l_from0___0 := (l_k1 * l_product_1 + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_from1___0 := l_from0___0 + l_m___4
						l_f0_real := a_in[(a_istride * l_from0___0).to_integer_32]
						l_f0_imag := a_in[(a_istride * (l_from0___0 + {NATURAL_32} 1)).to_integer_32]
						l_f1_real := a_in[(a_istride * l_from1___0).to_integer_32]
						l_f1_imag := a_in[(a_istride * (l_from1___0 + {NATURAL_32} 1)).to_integer_32]
						l_z0_real := l_f0_real
						l_z0_imag := l_f0_imag
						l_z1_real := l_w_real * l_f1_real - l_w_imag * l_f1_imag
						l_z1_imag := l_w_real * l_f1_imag + l_w_imag * l_f1_real
						l_x0_real := l_z0_real + l_z1_real
						l_x0_imag := l_z0_imag + l_z1_imag
						l_x1_real := l_z0_real - l_z1_real
						l_x1_imag := l_z0_imag - l_z1_imag
						l_to0___0 := (l_k1 * a_product + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_to1___0 := ((l_k1 * a_product + a_product) - {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						a_out[(a_ostride * l_to0___0).to_integer_32] := l_x0_real
						a_out[(a_ostride * (l_to0___0 + {NATURAL_32} 1)).to_integer_32] := l_x0_imag
						a_out[(a_ostride * l_to1___0).to_integer_32] := l_x1_real
						a_out[(a_ostride * (l_to1___0 + {NATURAL_32} 1)).to_integer_32] := -l_x1_imag
						l_k1 := l_k1 + 1
					end
					l_k := l_k + 1
				end
				if l_product_1 \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					js.return
				end
			end
			if not js.return_called then
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_q___3)
				loop
					l_from0___1 := (l_k1 * l_product_1 + l_product_1) - {NATURAL_32} 1
					l_from1___1 := l_from0___1 + l_m___4
					l_to0___1 := (l_k1 * a_product + l_product_1) - {NATURAL_32} 1
					a_out[(a_ostride * l_to0___1).to_integer_32] := a_in[(a_istride * l_from0___1).to_integer_32]
					a_out[(a_ostride * (l_to0___1 + {NATURAL_32} 1)).to_integer_32] := (-a_in[(a_istride * l_from1___1).to_integer_32])
					l_k1 := l_k1 + 1
				end
			end
		end

	fft_real_pass_2 (a_in: CE_POINTER [REAL_64]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_64]; a_ostride: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle: CE_POINTER [PD_GSL_COMPLEX])
		local
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_factor: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_product_1: NATURAL_32
			l_from0: NATURAL_32
			l_from1: NATURAL_32
			l_r0: REAL_64
			l_r1___1: REAL_64
			l_s0: REAL_64
			l_s1: REAL_64
			l_to0: NATURAL_32
			l_to1: NATURAL_32
			l_w_real: REAL_64
			l_w_imag: REAL_64
			l_from0___0: NATURAL_32
			l_from1___0: NATURAL_32
			l_f0_real: REAL_64
			l_f0_imag: REAL_64
			l_f1_real: REAL_64
			l_f1_imag: REAL_64
			l_z0_real: REAL_64
			l_z0_imag: REAL_64
			l_z1_real: REAL_64
			l_z1_imag: REAL_64
			l_x0_real: REAL_64
			l_x0_imag: REAL_64
			l_x1_real: REAL_64
			l_x1_imag: REAL_64
			l_to0___0: NATURAL_32
			l_to1___0: NATURAL_32
			l_from0___1: NATURAL_32
			l_from1___1: NATURAL_32
			l_to0___1: NATURAL_32
			js: JUMP_STATE
		do
			l_factor := (2).to_natural_32
			l_m___4 := a_n // l_factor
			l_q___3 := a_n // a_product
			l_product_1 := a_product // l_factor
			l_k1 := (0).to_natural_32
			from
			until
				not (l_k1 < l_q___3)
			loop
				l_from0 := l_k1 * l_product_1
				l_from1 := l_from0 + l_m___4
				l_r0 := a_in[(a_istride * l_from0).to_integer_32]
				l_r1___1 := a_in[(a_istride * l_from1).to_integer_32]
				l_s0 := l_r0 + l_r1___1
				l_s1 := l_r0 - l_r1___1
				l_to0 := a_product * l_k1
				l_to1 := (l_to0 + a_product) - {NATURAL_32} 1
				a_out[(a_ostride * l_to0).to_integer_32] := l_s0
				a_out[(a_ostride * l_to1).to_integer_32] := l_s1
				l_k1 := l_k1 + 1
			end
			if l_product_1 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				l_k := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < (l_product_1 + {NATURAL_32} 1) // {NATURAL_32} 2))
				loop
					l_w_real := (a_twiddle + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w_imag := -(a_twiddle + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_k1 := (0).to_natural_32
					from
					until
						not (l_k1 < l_q___3)
					loop
						l_from0___0 := (l_k1 * l_product_1 + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_from1___0 := l_from0___0 + l_m___4
						l_f0_real := a_in[(a_istride * l_from0___0).to_integer_32]
						l_f0_imag := a_in[(a_istride * (l_from0___0 + {NATURAL_32} 1)).to_integer_32]
						l_f1_real := a_in[(a_istride * l_from1___0).to_integer_32]
						l_f1_imag := a_in[(a_istride * (l_from1___0 + {NATURAL_32} 1)).to_integer_32]
						l_z0_real := l_f0_real
						l_z0_imag := l_f0_imag
						l_z1_real := l_w_real * l_f1_real - l_w_imag * l_f1_imag
						l_z1_imag := l_w_real * l_f1_imag + l_w_imag * l_f1_real
						l_x0_real := l_z0_real + l_z1_real
						l_x0_imag := l_z0_imag + l_z1_imag
						l_x1_real := l_z0_real - l_z1_real
						l_x1_imag := l_z0_imag - l_z1_imag
						l_to0___0 := (l_k1 * a_product + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_to1___0 := ((l_k1 * a_product + a_product) - {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						a_out[(a_ostride * l_to0___0).to_integer_32] := l_x0_real
						a_out[(a_ostride * (l_to0___0 + {NATURAL_32} 1)).to_integer_32] := l_x0_imag
						a_out[(a_ostride * l_to1___0).to_integer_32] := l_x1_real
						a_out[(a_ostride * (l_to1___0 + {NATURAL_32} 1)).to_integer_32] := -l_x1_imag
						l_k1 := l_k1 + 1
					end
					l_k := l_k + 1
				end
				if l_product_1 \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					js.return
				end
			end
			if not js.return_called then
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_q___3)
				loop
					l_from0___1 := (l_k1 * l_product_1 + l_product_1) - {NATURAL_32} 1
					l_from1___1 := l_from0___1 + l_m___4
					l_to0___1 := (l_k1 * a_product + l_product_1) - {NATURAL_32} 1
					a_out[(a_ostride * l_to0___1).to_integer_32] := a_in[(a_istride * l_from0___1).to_integer_32]
					a_out[(a_ostride * (l_to0___1 + {NATURAL_32} 1)).to_integer_32] := (-a_in[(a_istride * l_from1___1).to_integer_32])
					l_k1 := l_k1 + 1
				end
			end
		end

end
