class
	P_REVERSEHALTON

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_qrng_reversehalton.make
			create prime_numbers.make (<<1_229>>)
			create reversehalton_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_qrng_reversehalton: CE_POINTER [PD_GSL_QRNG_TYPE] assign set_gsl_qrng_reversehalton

	set_gsl_qrng_reversehalton (a_gsl_qrng_reversehalton: CE_POINTER [PD_GSL_QRNG_TYPE])
		do
			gsl_qrng_reversehalton := a_gsl_qrng_reversehalton
		end

	prime_numbers: CE_ARRAY [INTEGER_32]

	reversehalton_type: CE_ARRAY [PD_GSL_QRNG_TYPE]

feature {ANY} -- routines

	reversehalton_get (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32; a_v: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_h_state: CE_POINTER [PD_REVERSEHALTON_STATE_T]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_h_state.make

			l_h_state := create {CE_POINTER [PD_REVERSEHALTON_STATE_T]}.make_cast (a_state)
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				js.return
			elseif a_dimension > {NATURAL_32} 1_229 then
				Result := 4
				js.return
			end
			if not js.return_called then
				l_h_state.item.sequence_count := (l_h_state.item.sequence_count) + 1
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < a_dimension)
				loop
					a_v[l_i.to_integer_32] := vdcorput ((l_h_state.item.sequence_count).to_integer_32, prime_numbers[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	reversehalton_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent reversehalton_get)
		end

	reversehalton_init (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32): INTEGER_32
		local
			l_h_state: CE_POINTER [PD_REVERSEHALTON_STATE_T]
			js: JUMP_STATE
		do
			create l_h_state.make

			l_h_state := create {CE_POINTER [PD_REVERSEHALTON_STATE_T]}.make_cast (a_state)
			l_h_state.item.sequence_count := {NATURAL_32} 0
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				js.return
			elseif a_dimension > {NATURAL_32} 1_229 then
				Result := 4
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	reversehalton_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent reversehalton_init)
		end

	reversehalton_state_size (a_dimension: NATURAL_32): NATURAL_32
		do
			Result := ((create {PD_REVERSEHALTON_STATE_T}.make).structure_size.to_natural_32)
		end

	reversehalton_state_size_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent reversehalton_state_size)
		end

	vdcorput (a_x: INTEGER_32; a_b___0: INTEGER_32): REAL_64
		local
			l_x: INTEGER_32
			l_r___3: REAL_64
			l_v: REAL_64
			l_binv: REAL_64
			l_tmp: INTEGER_32
		do
			l_x := a_x
			l_r___3 := 0.
			l_v := 1.
			l_binv := 1. / a_b___0.to_double
			from
			until
				not (l_x > 0)
			loop
				l_v := l_v * l_binv
				if l_x \\ a_b___0 = 0 then
					l_tmp := 0
				else
					l_tmp := a_b___0 - l_x \\ a_b___0
				end
				l_r___3 := l_r___3 + (l_v * l_tmp.to_double)
				l_x := l_x // a_b___0
			end
			Result := l_r___3
		end

end
