class
	P_RK2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_odeiv_step_rk2.make
			create rk2_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_odeiv_step_rk2: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_rk2

	set_gsl_odeiv_step_rk2 (a_gsl_odeiv_step_rk2: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_rk2 := a_gsl_odeiv_step_rk2
		end

	rk2_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rk2_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK2_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2_STATE_T]}.make_cast ((malloc ((create {PD_RK2_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rk2_state"), ce_string ("rk2.c"), 52, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.k1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k1).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k1"), ce_string ("rk2.c"), 60, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.k2 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k2).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k2"), ce_string ("rk2.c"), 69, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.k3 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k3).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k3"), ce_string ("rk2.c"), 79, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ytmp := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk2.c"), 90, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rk2_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2_alloc)
		end

	rk2_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2_STATE_T]
			l_i: NATURAL_32
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_ksum3: REAL_64
			l_s___2: INTEGER_32
			l_ksum3___0: REAL_64
			js: JUMP_STATE
		do
			create l_state.make
			create l_k1.make
			create l_k2.make
			create l_k3.make
			create l_ytmp.make

			l_state := create {CE_POINTER [PD_RK2_STATE_T]}.make_cast (a_vstate)
			l_k1 := l_state.item.k1
			l_k2 := l_state.item.k2
			l_k3 := l_state.item.k3
			l_ytmp := l_state.item.ytmp
			if not a_dydt_in.is_void then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k1), create {CE_POINTER [ANY]}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, a_y, l_k1, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (0.5 * a_h) * l_k1[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_s___0 := ((a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_ytmp, l_k2, a_sys.item.params]))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (-l_k1[l_i.to_integer_32] + 2.0 * l_k2[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___1 := ((a_sys.item.function).integer_32_item ([a_t + a_h, l_ytmp, l_k3, a_sys.item.params]))
				if l_s___1 /= 0 then
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32]
					l_ksum3 := ((l_k1[l_i.to_integer_32] + 4.0 * l_k2[l_i.to_integer_32]) + l_k3[l_i.to_integer_32]) / 6.0
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_ksum3)
					l_i := l_i + 1
				end
				if not a_dydt_out.is_void then
					l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
					if l_s___2 /= 0 then
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_ytmp), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						Result := l_s___2
						js.return
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ksum3___0 := ((l_k1[l_i.to_integer_32] + 4.0 * l_k2[l_i.to_integer_32]) + l_k3[l_i.to_integer_32]) / 6.0
					a_yerr[l_i.to_integer_32] := a_h * (l_k2[l_i.to_integer_32] - l_ksum3___0)
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk2_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2_apply)
		end

	rk2_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK2_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rk2_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2_free)
		end

	rk2_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK2_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_RK2_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 2
		end

	rk2_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2_order)
		end

	rk2_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk2_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2_reset)
		end

end
