class
	P_RK4IMP

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_odeiv_step_rk4imp.make
			create rk4imp_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_odeiv_step_rk4imp: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_rk4imp

	set_gsl_odeiv_step_rk4imp (a_gsl_odeiv_step_rk4imp: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_rk4imp := a_gsl_odeiv_step_rk4imp
		end

	rk4imp_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rk4imp_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4IMP_STATE_T]}.make_cast ((malloc ((create {PD_RK4IMP_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rk4imp_state"), ce_string ("rk4imp.c"), 60, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.k1nu := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k1nu).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k1nu"), ce_string ("rk4imp.c"), 68, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.k2nu := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k2nu).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k2nu"), ce_string ("rk4imp.c"), 77, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ytmp1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp1).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp1"), ce_string ("rk4imp.c"), 87, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ytmp2 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp2).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp2"), ce_string ("rk4imp.c"), 98, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk4imp.c"), 110, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0_orig := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("rk4imp.c"), 123, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y_onestep := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y_onestep"), ce_string ("rk4imp.c"), 137, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rk4imp_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4imp_alloc)
		end

	rk4imp_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_k1nu: CE_POINTER [REAL_64]
			l_k2nu: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_y0___0.make
			create l_y0_orig.make
			create l_y_onestep.make
			create l_k1nu.make
			create l_k2nu.make

			l_state := create {CE_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			l_y0___0 := l_state.item.y0
			l_y0_orig := l_state.item.y0_orig
			l_y_onestep := l_state.item.y_onestep
			l_k1nu := l_state.item.k1nu
			l_k2nu := l_state.item.k2nu
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0_orig), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			if not a_dydt_in.is_void then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k1nu), create {CE_POINTER [ANY]}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, a_y, l_k1nu, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k2nu), create {CE_POINTER [ANY]}.make_cast (l_k1nu), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y_onestep), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___0 := (rk4imp_step (l_y_onestep, l_state, a_h, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				l_s___1 := (rk4imp_step (a_y, l_state, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h / 2.0, a_y, l_k1nu, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k2nu), create {CE_POINTER [ANY]}.make_cast (l_k1nu), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___3 := (rk4imp_step (a_y, l_state, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___3 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___3
					js.return
				end
			end
			if not js.return_called and then (not a_dydt_out.is_void) then
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___4 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___4
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := ((8.0 * 0.5) * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 15.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk4imp_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4imp_apply)
		end

	rk4imp_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp2))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rk4imp_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4imp_free)
		end

	rk4imp_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_RK4IMP_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 4
		end

	rk4imp_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4imp_order)
		end

	rk4imp_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1nu), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2nu), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp2), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk4imp_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4imp_reset)
		end

	rk4imp_step (a_y: CE_POINTER [REAL_64]; a_state: CE_POINTER [PD_RK4IMP_STATE_T]; a_h: REAL_64; a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_ir3: REAL_64
			l_iter_steps: INTEGER_32
			l_nu: INTEGER_32
			l_i: NATURAL_32
			l_k1nu: CE_POINTER [REAL_64]
			l_k2nu: CE_POINTER [REAL_64]
			l_ytmp1: CE_POINTER [REAL_64]
			l_ytmp2: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_d_i: REAL_64
			js: JUMP_STATE
		do
			create l_k1nu.make
			create l_k2nu.make
			create l_ytmp1.make
			create l_ytmp2.make

			l_ir3 := 1.0 / 1.73205080756887729352744634151
			l_iter_steps := 3
			l_k1nu := a_state.item.k1nu
			l_k2nu := a_state.item.k2nu
			l_ytmp1 := a_state.item.ytmp1
			l_ytmp2 := a_state.item.ytmp2
			l_nu := 0
			from
			until
				not (not js.loop_done and then (l_nu < l_iter_steps))
			loop
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp1[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (0.25 * l_k1nu[l_i.to_integer_32] + (0.5 * (0.5 - l_ir3)) * l_k2nu[l_i.to_integer_32])
					l_ytmp2[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (0.25 * l_k2nu[l_i.to_integer_32] + (0.5 * (0.5 + l_ir3)) * l_k1nu[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s := ((a_sys.item.function).integer_32_item ([a_t + (0.5 * a_h) * (1.0 - l_ir3), l_ytmp1, l_k1nu, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
				if not js.return_called then
					l_s___0 := ((a_sys.item.function).integer_32_item ([a_t + (0.5 * a_h) * (1.0 + l_ir3), l_ytmp2, l_k2nu, a_sys.item.params]))
					if l_s___0 /= 0 then
						Result := l_s___0
						js.return
					end
				end
				if not js.return_called then
					l_nu := l_nu + 1
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_d_i := 0.5 * (l_k1nu[l_i.to_integer_32] + l_k2nu[l_i.to_integer_32])
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_d_i)
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
