class
	P_SAXPY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_saxpy (a_N: INTEGER_32; a_alpha: REAL_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32; a_Y: CE_POINTER [REAL_32]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_m___4: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_alpha.to_double = 0.0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if a_incX /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_incY = 1 then
							l_m___4 := a_N \\ 4
							l_i := 0
							from
							until
								not (l_i < l_m___4)
							loop
								a_Y[l_i] := a_Y[l_i] + (a_alpha * a_X[l_i])
								l_i := l_i + 1
							end
							l_i := l_m___4
							from
							until
								not (l_i + 3 < a_N)
							loop
								a_Y[l_i] := a_Y[l_i] + (a_alpha * a_X[l_i])
								a_Y[(l_i + 1)] := a_Y[(l_i + 1)] + (a_alpha * a_X[(l_i + 1)])
								a_Y[(l_i + 2)] := a_Y[(l_i + 2)] + (a_alpha * a_X[(l_i + 2)])
								a_Y[(l_i + 3)] := a_Y[(l_i + 3)] + (a_alpha * a_X[(l_i + 3)])
								l_i := l_i + (4)
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if a_incX > 0 then
							l_tmp := 0
						else
							l_tmp := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp
						if a_incY > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incY
						end
						l_iy := l_tmp___0
						l_i := 0
						from
						until
							not (l_i < a_N)
						loop
							a_Y[l_iy] := a_Y[l_iy] + (a_alpha * a_X[l_ix])
							l_ix := l_ix + a_incX
							l_iy := l_iy + a_incY
							l_i := l_i + 1
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
