class
	P_SCNRM2

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_scnrm2 (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32): REAL_32
		local
			l_scale: REAL_32
			l_ssq: REAL_32
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_x: REAL_32
			l_y: REAL_32
			l_ax: REAL_32
			l_ay: REAL_32
			js: JUMP_STATE
		do
			l_scale := (0.0).truncated_to_real
			l_ssq := (1.0).truncated_to_real
			l_ix := 0
			if a_N = 0 then
				Result := (0).to_real
				js.return
			elseif a_incX < 1 then
				Result := (0).to_real
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
					l_y := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
					if l_x.to_double /= 0.0 then
						l_ax := (fabs (l_x.to_double)).truncated_to_real
						if l_scale < l_ax then
							l_ssq := (1.0 + ((l_ssq * (l_scale / l_ax)) * (l_scale / l_ax)).to_double).truncated_to_real
							l_scale := l_ax
						else
							l_ssq := l_ssq + ((l_ax / l_scale) * (l_ax / l_scale))
						end
					end
					if l_y.to_double /= 0.0 then
						l_ay := (fabs (l_y.to_double)).truncated_to_real
						if l_scale < l_ay then
							l_ssq := (1.0 + ((l_ssq * (l_scale / l_ay)) * (l_scale / l_ay)).to_double).truncated_to_real
							l_scale := l_ay
						else
							l_ssq := l_ssq + ((l_ay / l_scale) * (l_ay / l_scale))
						end
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := (l_scale.to_double * (sqrt (l_ssq.to_double))).truncated_to_real
			end
		end

end
