class
	P_SHUFFLE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	copy2 (a_dest: CE_POINTER [ANY]; a_i: NATURAL_32; a_src: CE_POINTER [ANY]; a_j: NATURAL_32; a_size: NATURAL_32)
		local
			l_a___5: CE_POINTER [INTEGER_8]
			l_b___0: CE_POINTER [INTEGER_8]
			l_s: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_a___5.make
			create l_b___0.make
			create l_tmp.make
			create l_tmp___0.make

			l_a___5 := create {CE_POINTER [INTEGER_8]}.make_cast (a_dest) + (a_size * a_i).to_integer_32
			l_b___0 := create {CE_POINTER [INTEGER_8]}.make_cast (a_src) + (a_size * a_j).to_integer_32
			l_s := a_size
			from
			until
				js.loop_done
			loop
				l_tmp := l_a___5
				l_a___5 := l_a___5 + 1
				l_tmp___0 := l_b___0
				l_b___0 := l_b___0 + 1
				l_tmp[0] := l_tmp___0[0]
				l_s := l_s - 1
				if not (l_s > {NATURAL_32} 0) then
					js.break
				end
			end
		end

	gsl_ran_choose (a_r___3: CE_POINTER [PD_GSL_RNG]; a_dest: CE_POINTER [ANY]; a_k: NATURAL_32; a_src: CE_POINTER [ANY]; a_n: NATURAL_32; a_size: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_j := (0).to_natural_32
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("k is greater than n, cannot sample more than n items"), ce_string ("shuffle.c"), 95, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					js.loop_done
				loop
					if l_i < a_n then
						if not (l_j < a_k) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (a_n - l_i).to_real_64 * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)) < (a_k - l_j).to_real_64 then
							copy2 (a_dest, l_j, a_src, l_i, a_size)
							l_j := l_j + 1
						end
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_ran_sample (a_r___3: CE_POINTER [PD_GSL_RNG]; a_dest: CE_POINTER [ANY]; a_k: NATURAL_32; a_src: CE_POINTER [ANY]; a_n: NATURAL_32; a_size: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_j := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_k)
			loop
				l_j := (gsl_gsl_rng_inst.gsl_rng_uniform_int (a_r___3, a_n.to_natural_32)).to_natural_32
				copy2 (a_dest, l_i, a_src, l_j, a_size)
				l_i := l_i + 1
			end
		end

	gsl_ran_shuffle (a_r___3: CE_POINTER [PD_GSL_RNG]; a_base: CE_POINTER [ANY]; a_n: NATURAL_32; a_size: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_i := a_n - {NATURAL_32} 1
			from
			until
				not (l_i > {NATURAL_32} 0)
			loop
				l_j := (gsl_gsl_rng_inst.gsl_rng_uniform_int (a_r___3, (l_i + {NATURAL_32} 1).to_natural_32)).to_natural_32
				swap (a_base, a_size, l_i, l_j)
				l_i := l_i - 1
			end
		end

	swap (a_base: CE_POINTER [ANY]; a_size: NATURAL_32; a_i: NATURAL_32; a_j: NATURAL_32)
		local
			l_a___5: CE_POINTER [INTEGER_8]
			l_b___0: CE_POINTER [INTEGER_8]
			l_s: NATURAL_32
			l_tmp: INTEGER_8
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_a___5.make
			create l_b___0.make
			create l_tmp___0.make
			create l_tmp___1.make

			l_a___5 := create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (a_size * a_i).to_integer_32
			l_b___0 := create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (a_size * a_j).to_integer_32
			l_s := a_size
			if a_i = a_j then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_tmp := l_a___5[0]
					l_tmp___0 := l_a___5
					l_a___5 := l_a___5 + 1
					l_tmp___0[0] := l_b___0[0]
					l_tmp___1 := l_b___0
					l_b___0 := l_b___0 + 1
					l_tmp___1[0] := l_tmp
					l_s := l_s - 1
					if not (l_s > {NATURAL_32} 0) then
						js.break
					end
				end
			end
		end

end
