class
	P_SIMPLEX

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_multimin_fminimizer_nmsimplex.make
			create nmsimplex_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_multimin_fminimizer_nmsimplex: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE] assign set_gsl_multimin_fminimizer_nmsimplex

	set_gsl_multimin_fminimizer_nmsimplex (a_gsl_multimin_fminimizer_nmsimplex: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE])
		do
			gsl_multimin_fminimizer_nmsimplex := a_gsl_multimin_fminimizer_nmsimplex
		end

	nmsimplex_type: CE_ARRAY [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]

feature {ANY} -- routines

	nmsimplex_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("invalid number of parameters specified"), ce_string ("simplex.c"), 196, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.x1 := init_source_inst.gsl_matrix_alloc (a_n + {NATURAL_32} 1, a_n)
				if (l_state.item.x1).is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x1"), ce_string ("simplex.c"), 203, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y1 := init_source_inst.gsl_vector_alloc (a_n + {NATURAL_32} 1)
				if (l_state.item.y1).is_void then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y"), ce_string ("simplex.c"), 211, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ws1 := init_source_inst.gsl_vector_alloc (a_n)
				if (l_state.item.ws1).is_void then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ws1"), ce_string ("simplex.c"), 220, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ws2 := init_source_inst.gsl_vector_alloc (a_n)
				if (l_state.item.ws2).is_void then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					init_source_inst.gsl_vector_free (l_state.item.ws1)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ws2"), ce_string ("simplex.c"), 230, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	nmsimplex_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_alloc)
		end

	nmsimplex_calc_center (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]; a_mp: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_val: REAL_64
			js: JUMP_STATE
		do
			create l_x1___0.make

			l_x1___0 := a_state.item.x1
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_x1___0.item.size2))
			loop
				l_val := 0.0
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_x1___0.item.size1)
				loop
					l_val := l_val + (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, l_i, l_j))
					l_i := l_i + 1
				end
				l_val := l_val / (l_x1___0.item.size1).to_real_64
				gsl_gsl_vector_double_inst.gsl_vector_set (a_mp, l_j, l_val)
				l_j := l_j + 1
			end
			Result := 0
		end

	nmsimplex_contract_by_best (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]; a_best: NATURAL_32; a_xc: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]): INTEGER_32
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_y1___0: CE_POINTER [PD_GSL_VECTOR]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_newval: REAL_64
			l_status: INTEGER_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_x1___0.make
			create l_y1___0.make

			l_x1___0 := a_state.item.x1
			l_y1___0 := a_state.item.y1
			l_status := 0
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_x1___0.item.size1))
			loop
				if l_i /= a_best then
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_x1___0.item.size2)
					loop
						l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, l_i, l_j)
						l_newval := 0.5 * (l_tmp + (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, a_best, l_j)))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (l_x1___0, l_i, l_j, l_newval)
						l_j := l_j + 1
					end
					getset_source_inst.gsl_matrix_get_row (a_xc, l_x1___0, l_i).do_nothing
					l_newval := (a_f.item.f).real_64_item ([a_xc, a_f.item.params])
					gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_i, l_newval)
					if not (infnan_inst.gsl_finite (l_newval)).to_boolean then
						l_status := 9
					end
				end
				l_i := l_i + 1
			end
			Result := l_status
		end

	nmsimplex_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
			init_source_inst.gsl_matrix_free (l_state.item.x1)
			init_source_inst.gsl_vector_free (l_state.item.y1)
			init_source_inst.gsl_vector_free (l_state.item.ws1)
			init_source_inst.gsl_vector_free (l_state.item.ws2)
		end

	nmsimplex_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_free)
		end

	nmsimplex_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_fval: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
			l_xc: CE_POINTER [PD_GSL_VECTOR]
			l_xc2: CE_POINTER [PD_GSL_VECTOR]
			l_y1___0: CE_POINTER [PD_GSL_VECTOR]
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_hi: NATURAL_32
			l_s_hi: NATURAL_32
			l_lo: NATURAL_32
			l_dhi: REAL_64
			l_ds_hi: REAL_64
			l_dlo: REAL_64
			l_status: INTEGER_32
			l_val: REAL_64
			l_val2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_xc.make
			create l_xc2.make
			create l_y1___0.make
			create l_x1___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
					l_xc := l_state.item.ws1
					l_xc2 := l_state.item.ws2
					l_y1___0 := l_state.item.y1
					l_x1___0 := l_state.item.x1
					l_n := l_y1___0.item.size
					if l_xc.item.size /= a_x.item.size then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex.c"), 340, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_dlo := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, (0).to_natural_32)
						l_dhi := l_dlo
						l_hi := (0).to_natural_32
						l_lo := (0).to_natural_32
						l_ds_hi := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, (1).to_natural_32)
						l_s_hi := (1).to_natural_32
						l_i := (1).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_val := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_i)
							if l_val < l_dlo then
								l_dlo := l_val
								l_lo := l_i
							elseif l_val > l_dhi then
								l_ds_hi := l_dhi
								l_s_hi := l_hi
								l_dhi := l_val
								l_hi := l_i
							elseif l_val > l_ds_hi then
								l_ds_hi := l_val
								l_s_hi := l_i
							end
							l_i := l_i + 1
						end
						l_val := nmsimplex_move_corner (-1.0, l_state, l_hi, l_xc, a_f)
						if not ((infnan_inst.gsl_finite (l_val)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_val < (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_lo)) then
							l_val2 := nmsimplex_move_corner (-2.0, l_state, l_hi, l_xc2, a_f)
							if (infnan_inst.gsl_finite (l_val2)).to_boolean then
								if l_val2 < (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_lo)) then
									getset_source_inst.gsl_matrix_set_row (l_x1___0, l_hi, l_xc2).do_nothing
									gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_hi, l_val2)
								else
									getset_source_inst.gsl_matrix_set_row (l_x1___0, l_hi, l_xc).do_nothing
									gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_hi, l_val)
								end
							else
								getset_source_inst.gsl_matrix_set_row (l_x1___0, l_hi, l_xc).do_nothing
								gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_hi, l_val)
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else: | _L___1:
						if not ((infnan_inst.gsl_finite (l_val)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not (l_val > (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_s_hi))) then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | _L___0:
						if (infnan_inst.gsl_finite (l_val)).to_boolean then
							if l_val <= (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_hi)) then
								getset_source_inst.gsl_matrix_set_row (l_x1___0, l_hi, l_xc).do_nothing
								gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_hi, l_val)
							end
						end
						l_val2 := nmsimplex_move_corner (0.5, l_state, l_hi, l_xc2, a_f)
						if not ((infnan_inst.gsl_finite (l_val2)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_val2 <= (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_hi)) then
							getset_source_inst.gsl_matrix_set_row (l_state.item.x1, l_hi, l_xc2).do_nothing
							gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_hi, l_val2)
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						l_status := nmsimplex_contract_by_best (l_state, l_lo, l_xc, a_f)
						if l_status /= 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("nmsimplex_contract_by_best failed"), ce_string ("simplex.c"), 430, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						getset_source_inst.gsl_matrix_set_row (l_x1___0, l_hi, l_xc).do_nothing
						gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_hi, l_val)
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_pos := -1 + 6 -- goto _L___0
				when 14 then -- if done | if done
						if not js.return_called then
							l_lo := minmax_source_inst.gsl_vector_min_index (l_y1___0)
							getset_source_inst.gsl_matrix_get_row (a_x, l_x1___0, l_lo).do_nothing
							a_fval.item := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_lo)
							a_size.item := nmsimplex_size (l_state)
							Result := 0
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	nmsimplex_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_iterate)
		end

	nmsimplex_move_corner (a_coeff: REAL_64; a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]; a_corner: NATURAL_32; a_xc: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]): REAL_64
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_newval: REAL_64
			l_mp: REAL_64
			js: JUMP_STATE
		do
			create l_x1___0.make

			l_x1___0 := a_state.item.x1
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_x1___0.item.size2))
			loop
				l_mp := 0.0
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_x1___0.item.size1)
				loop
					if l_i /= a_corner then
						l_mp := l_mp + (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, l_i, l_j))
					end
					l_i := l_i + 1
				end
				l_mp := l_mp / (l_x1___0.item.size1 - {NATURAL_32} 1).to_real_64
				l_newval := l_mp - a_coeff * (l_mp - (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, a_corner, l_j)))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_xc, l_j, l_newval)
				l_j := l_j + 1
			end
			l_newval := (a_f.item.f).real_64_item ([a_xc, a_f.item.params])
			Result := l_newval
		end

	nmsimplex_set (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_val: REAL_64
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
			l_xtemp: CE_POINTER [PD_GSL_VECTOR]
			l_tmp___0: REAL_64
			js: JUMP_STATE
		do
			create l_state.make
			create l_xtemp.make

			l_state := create {CE_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
			l_xtemp := l_state.item.ws1
			if l_xtemp.item.size /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex.c"), 251, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (l_xtemp.item.size /= a_step_size.item.size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("incompatible size of step_size"), ce_string ("simplex.c"), 256, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_val := (a_f.item.f).real_64_item ([a_x, a_f.item.params])
				if not (infnan_inst.gsl_finite (l_val)).to_boolean then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex.c"), 265, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				getset_source_inst.gsl_matrix_set_row (l_state.item.x1, (0).to_natural_32, a_x).do_nothing
				gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.y1, (0).to_natural_32, l_val)
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_x.item.size))
				loop
					l_status := copy_source_inst.gsl_vector_memcpy (l_xtemp, a_x)
					if l_status /= 0 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("vector memcopy failed"), ce_string ("simplex.c"), 279, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_tmp___0 := gsl_gsl_vector_double_inst.gsl_vector_get (l_xtemp, l_i)
						l_val := l_tmp___0 + (gsl_gsl_vector_double_inst.gsl_vector_get (a_step_size, l_i))
						gsl_gsl_vector_double_inst.gsl_vector_set (l_xtemp, l_i, l_val)
						l_val := (a_f.item.f).real_64_item ([l_xtemp, a_f.item.params])
						if not (infnan_inst.gsl_finite (l_val)).to_boolean then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex.c"), 288, 9)
								Result := 9
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						getset_source_inst.gsl_matrix_set_row (l_state.item.x1, l_i + {NATURAL_32} 1, l_xtemp).do_nothing
						gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.y1, l_i + {NATURAL_32} 1, l_val)
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				a_size.item := nmsimplex_size (l_state)
				Result := 0
			end
		end

	nmsimplex_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_set)
		end

	nmsimplex_size (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]): REAL_64
		local
			l_s: CE_POINTER [PD_GSL_VECTOR]
			l_mp: CE_POINTER [PD_GSL_VECTOR]
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_i: NATURAL_32
			l_ss: REAL_64
		do
			create l_s.make
			create l_mp.make
			create l_x1___0.make

			l_s := a_state.item.ws1
			l_mp := a_state.item.ws2
			l_x1___0 := a_state.item.x1
			l_ss := 0.0
			nmsimplex_calc_center (a_state, l_mp).do_nothing
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_x1___0.item.size1)
			loop
				getset_source_inst.gsl_matrix_get_row (l_s, l_x1___0, l_i).do_nothing
				blas_inst.gsl_blas_daxpy (-1.0, l_mp, l_s).do_nothing
				l_ss := l_ss + (blas_inst.gsl_blas_dnrm2 (l_s))
				l_i := l_i + 1
			end
			Result := (l_ss / (l_x1___0.item.size1).to_real_64)
		end

end
