class
	P_SININT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ci_cs.make (<<1>>)
			create ci_data.make (<<13>>)
			create f1_cs.make (<<1>>)
			create f1_data.make (<<20>>)
			create f2_cs.make (<<1>>)
			create f2_data.make (<<29>>)
			create g1_cs___0.make (<<1>>)
			create g1_data.make (<<21>>)
			create g2_cs___0.make (<<1>>)
			create g2_data.make (<<34>>)
			create si_cs.make (<<1>>)
			create si_data.make (<<12>>)
		end

feature {ANY} -- attributes

	ci_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	ci_data: CE_ARRAY [REAL_64]

	f1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	f1_data: CE_ARRAY [REAL_64]

	f2_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	f2_data: CE_ARRAY [REAL_64]

	g1_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	g1_data: CE_ARRAY [REAL_64]

	g2_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	g2_data: CE_ARRAY [REAL_64]

	si_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	si_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	fg_asymp (a_x: REAL_64; a_f: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_g: CE_POINTER [PD_GSL_SF_RESULT_STRUCT])
		local
			l_xbig: REAL_64
			l_xmaxf: REAL_64
			l_xmaxg: REAL_64
			l_xbnd: REAL_64
			l_x2___1: REAL_64
			l_result_c1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c2___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_result_c1.make (<<1>>)
			create l_result_c2.make (<<1>>)
			create l_result_c1___0.make (<<1>>)
			create l_result_c2___0.make (<<1>>)

			l_xbig := 1.0 / 1.4901161193847656e-08
			l_xmaxf := 1.0 / 2.2250738585072014e-308
			l_xmaxg := 1.0 / 1.4916681462400413e-154
			l_xbnd := 7.07106781187
			l_x2___1 := a_x * a_x
			if a_x <= l_xbnd then
				cheb_eval_inst.cheb_eval_e (f1_cs, (1.0 / l_x2___1 - 0.04125) / 0.02125, l_result_c1).do_nothing
				cheb_eval_inst.cheb_eval_e (g1_cs___0, (1.0 / l_x2___1 - 0.04125) / 0.02125, l_result_c2).do_nothing
				a_f.item.val := (1.0 + l_result_c1.item.val) / a_x
				a_g.item.val := (1.0 + l_result_c2.item.val) / l_x2___1
				a_f.item.err := l_result_c1.item.err / a_x + (2.0 * 2.2204460492503131e-16) * (fabs (a_f.item.val))
				a_g.item.err := l_result_c2.item.err / l_x2___1 + (2.0 * 2.2204460492503131e-16) * (fabs (a_g.item.val))
			elseif a_x <= l_xbig then
				cheb_eval_inst.cheb_eval_e (f2_cs, 100.0 / l_x2___1 - 1.0, l_result_c1___0).do_nothing
				cheb_eval_inst.cheb_eval_e (g2_cs___0, 100.0 / l_x2___1 - 1.0, l_result_c2___0).do_nothing
				a_f.item.val := (1.0 + l_result_c1___0.item.val) / a_x
				a_g.item.val := (1.0 + l_result_c2___0.item.val) / l_x2___1
				a_f.item.err := l_result_c1___0.item.err / a_x + (2.0 * 2.2204460492503131e-16) * (fabs (a_f.item.val))
				a_g.item.err := l_result_c2___0.item.err / l_x2___1 + (2.0 * 2.2204460492503131e-16) * (fabs (a_g.item.val))
			else
				if a_x < l_xmaxf then
					a_f.item.val := 1.0 / a_x
				else
					a_f.item.val := 0.0
				end
				if a_x < l_xmaxg then
					a_g.item.val := 1.0 / l_x2___1
				else
					a_g.item.val := 0.0
				end
				a_f.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_f.item.val))
				a_g.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_g.item.val))
			end
		end

	gsl_sf_Ci (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_Ci_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_Ci_e(x, &result)"), ce_string ("sinint.c"), 401, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_Ci_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lx: REAL_64
			l_y: REAL_64
			l_result_c: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sin_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_cos_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_sin: INTEGER_32
			l_stat_cos: INTEGER_32
			l_f: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_g: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_result_c.make (<<1>>)
			create l_sin_result.make (<<1>>)
			create l_cos_result.make (<<1>>)
			create l_f.make (<<1>>)
			create l_g.make (<<1>>)

			if a_x <= 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("sinint.c"), 359, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x <= 4.0 then
				l_lx := (log (a_x))
				l_y := (a_x * a_x - 8.0) * 0.125
				cheb_eval_inst.cheb_eval_e (ci_cs, l_y, l_result_c).do_nothing
				a_result.item.val := (l_lx - 0.5) + l_result_c.item.val
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * ((fabs (l_lx)) + 0.5) + l_result_c.item.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			else
				l_stat_sin := (trig_inst.gsl_sf_sin_e (a_x, l_sin_result))
				l_stat_cos := (trig_inst.gsl_sf_cos_e (a_x, l_cos_result))
				fg_asymp (a_x, l_f, l_g)
				a_result.item.val := l_f.item.val * l_sin_result.item.val - l_g.item.val * l_cos_result.item.val
				a_result.item.err := fabs (l_f.item.err * l_sin_result.item.val)
				a_result.item.err := a_result.item.err + (fabs (l_g.item.err * l_cos_result.item.val))
				a_result.item.err := a_result.item.err + (fabs (l_f.item.val * l_sin_result.item.err))
				a_result.item.err := a_result.item.err + (fabs (l_g.item.val * l_cos_result.item.err))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if l_stat_sin /= 0 then
					l_tmp___11 := l_stat_sin
				else
					if l_stat_cos /= 0 then
						l_tmp___10 := l_stat_cos
					else
						l_tmp___10 := 0
					end
					l_tmp___11 := l_tmp___10
				end
				Result := l_tmp___11
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_Si (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_Si_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_Si_e(x, &result)"), ce_string ("sinint.c"), 396, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_Si_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_result_c: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_f: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_g: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___1: REAL_64
		do
			create l_result_c.make (<<1>>)
			create l_f.make (<<1>>)
			create l_g.make (<<1>>)

			l_ax := (fabs (a_x))
			if l_ax < 1.4901161193847656e-08 then
				a_result.item.val := a_x
				a_result.item.err := 0.0
				Result := 0
			elseif l_ax <= 4.0 then
				cheb_eval_inst.cheb_eval_e (si_cs, (a_x * a_x - 8.0) * 0.125, l_result_c).do_nothing
				a_result.item.val := a_x * (0.75 + l_result_c.item.val)
				a_result.item.err := l_ax * l_result_c.item.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			else
				fg_asymp (l_ax, l_f, l_g)
				l_tmp___1 := cos (l_ax)
				a_result.item.val := (0.5 * 3.14159265358979323846 - l_f.item.val * l_tmp___1) - l_g.item.val * (sin (l_ax))
				a_result.item.err := l_f.item.err + l_g.item.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if a_x < 0.0 then
					a_result.item.val := -a_result.item.val
				end
				Result := 0
			end
		end

end
