class
	P_SORTVEC_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sort (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_char (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_char_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_char_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_float (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_float_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_float_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_int (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_int_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_int_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_long (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_long_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_long_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_long_double (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_long_double_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_long_double_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_short (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_short_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_short_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_uchar (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_uchar_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_uchar_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_uint (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_uint_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_uint_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_ulong (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_ulong_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_ulong_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_ushort (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_n - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					my_ushort_downheap (a_data, a_stride, l_N, l_k)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_data[({NATURAL_32} 0).to_integer_32]
					a_data[({NATURAL_32} 0).to_integer_32] := a_data[(l_N * a_stride).to_integer_32]
					a_data[(l_N * a_stride).to_integer_32] := l_tmp
					l_N := l_N - 1
					my_ushort_downheap (a_data, a_stride, l_N, (0).to_natural_32)
				end
			end
		end

	gsl_sort_vector (a_v: CE_POINTER [PD_GSL_VECTOR])
		do
			gsl_sort (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_char (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR])
		do
			gsl_sort_char (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_float (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT])
		do
			gsl_sort_float (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_int (a_v: CE_POINTER [PD_GSL_VECTOR_INT])
		do
			gsl_sort_int (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_long (a_v: CE_POINTER [PD_GSL_VECTOR_LONG])
		do
			gsl_sort_long (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_long_double (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE])
		do
			gsl_sort_long_double (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_short (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT])
		do
			gsl_sort_short (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_uchar (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR])
		do
			gsl_sort_uchar (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_uint (a_v: CE_POINTER [PD_GSL_VECTOR_UINT])
		do
			gsl_sort_uint (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_ulong (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG])
		do
			gsl_sort_ulong (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	gsl_sort_vector_ushort (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT])
		do
			gsl_sort_ushort (a_v.item.data, a_v.item.stride, a_v.item.size)
		end

	my_char_downheap (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: INTEGER_8
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_data[(l_j * a_stride).to_integer_32]).to_integer_32 < (a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32]).to_integer_32 then
						l_j := l_j + 1
					end
				end
				if not (l_v.to_integer_32 < (a_data[(l_j * a_stride).to_integer_32]).to_integer_32) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_downheap (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: REAL_64
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_float_downheap (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: REAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_int_downheap (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: INTEGER_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_long_double_downheap (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: REAL_96
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_long_downheap (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: INTEGER_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_short_downheap (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: INTEGER_16
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_data[(l_j * a_stride).to_integer_32]).to_integer_32 < (a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32]).to_integer_32 then
						l_j := l_j + 1
					end
				end
				if not (l_v.to_integer_32 < (a_data[(l_j * a_stride).to_integer_32]).to_integer_32) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_uchar_downheap (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: NATURAL_8
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_data[(l_j * a_stride).to_integer_32]).to_integer_32 < (a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32]).to_integer_32 then
						l_j := l_j + 1
					end
				end
				if not (l_v.to_integer_32 < (a_data[(l_j * a_stride).to_integer_32]).to_integer_32) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_uint_downheap (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_ulong_downheap (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if a_data[(l_j * a_stride).to_integer_32] < a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32] then
						l_j := l_j + 1
					end
				end
				if not (l_v < a_data[(l_j * a_stride).to_integer_32]) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

	my_ushort_downheap (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_v: NATURAL_16
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_v := a_data[(l_k * a_stride).to_integer_32]
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_data[(l_j * a_stride).to_integer_32]).to_integer_32 < (a_data[((l_j + {NATURAL_32} 1) * a_stride).to_integer_32]).to_integer_32 then
						l_j := l_j + 1
					end
				end
				if not (l_v.to_integer_32 < (a_data[(l_j * a_stride).to_integer_32]).to_integer_32) then
					js.break
				end
				if not js.loop_jumped then
					a_data[(l_k * a_stride).to_integer_32] := a_data[(l_j * a_stride).to_integer_32]
					l_k := l_j
				end
			end
			a_data[(l_k * a_stride).to_integer_32] := l_v
		end

end
