class
	P_SPLINE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_spline_alloc (a_T: CE_POINTER [PD_GSL_INTERP_TYPE]; a_size: NATURAL_32): CE_POINTER [PD_GSL_SPLINE]
		local
			l_spline: CE_POINTER [PD_GSL_SPLINE]
			js: JUMP_STATE
		do
			create l_spline.make

			l_spline := create {CE_POINTER [PD_GSL_SPLINE]}.make_cast ((malloc ((create {PD_GSL_SPLINE}.make).structure_size.to_natural_32)))
			if l_spline.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for spline struct"), ce_string ("spline.c"), 34, 8)
					Result := (create {CE_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_spline.item.interp := interp_inst.gsl_interp_alloc (a_T, a_size)
				if (l_spline.item.interp).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_spline))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for interp"), ce_string ("spline.c"), 42, 8)
						Result := (create {CE_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_spline.item.x := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_spline.item.x).is_void then
					interp_inst.gsl_interp_free (l_spline.item.interp)
					free (create {CE_POINTER [ANY]}.make_cast (l_spline))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("spline.c"), 51, 8)
						Result := (create {CE_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_spline.item.y := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_spline.item.y).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_spline.item.x))
					interp_inst.gsl_interp_free (l_spline.item.interp)
					free (create {CE_POINTER [ANY]}.make_cast (l_spline))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y"), ce_string ("spline.c"), 61, 8)
						Result := (create {CE_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_spline.item.size := a_size
				Result := l_spline
			end
		end

	gsl_spline_eval (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]): REAL_64
		do
			Result := (interp_inst.gsl_interp_eval (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_x, a_a___5))
		end

	gsl_spline_eval_deriv (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]): REAL_64
		do
			Result := (interp_inst.gsl_interp_eval_deriv (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_x, a_a___5))
		end

	gsl_spline_eval_deriv2 (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]): REAL_64
		do
			Result := (interp_inst.gsl_interp_eval_deriv2 (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_x, a_a___5))
		end

	gsl_spline_eval_deriv2_e (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_d2: CE_POINTER [REAL_64]): INTEGER_32
		do
			Result := (interp_inst.gsl_interp_eval_deriv2_e (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_x, a_a___5, a_d2))
		end

	gsl_spline_eval_deriv_e (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_dydx: CE_POINTER [REAL_64]): INTEGER_32
		do
			Result := (interp_inst.gsl_interp_eval_deriv_e (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_x, a_a___5, a_dydx))
		end

	gsl_spline_eval_e (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y: CE_POINTER [REAL_64]): INTEGER_32
		do
			Result := (interp_inst.gsl_interp_eval_e (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_x, a_a___5, a_y))
		end

	gsl_spline_eval_integ (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_a___5: REAL_64; a_b___0: REAL_64; a_acc: CE_POINTER [PD_GSL_INTERP_ACCEL]): REAL_64
		do
			Result := (interp_inst.gsl_interp_eval_integ (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_a___5, a_b___0, a_acc))
		end

	gsl_spline_eval_integ_e (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_a___5: REAL_64; a_b___0: REAL_64; a_acc: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_result: CE_POINTER [REAL_64]): INTEGER_32
		do
			Result := (interp_inst.gsl_interp_eval_integ_e (a_spline.item.interp, a_spline.item.x, a_spline.item.y, a_a___5, a_b___0, a_acc, a_result))
		end

	gsl_spline_free (a_spline: CE_POINTER [PD_GSL_SPLINE])
		local
			js: JUMP_STATE
		do
			if a_spline.is_void then
				js.return
			end
			if not js.return_called then
				interp_inst.gsl_interp_free (a_spline.item.interp)
				free (create {CE_POINTER [ANY]}.make_cast (a_spline.item.x))
				free (create {CE_POINTER [ANY]}.make_cast (a_spline.item.y))
				free (create {CE_POINTER [ANY]}.make_cast (a_spline))
			end
		end

	gsl_spline_init (a_spline: CE_POINTER [PD_GSL_SPLINE]; a_x_array: CE_POINTER [REAL_64]; a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			if a_size /= a_spline.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("data must match size of spline object"), ce_string ("spline.c"), 74, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (a_spline.item.x), create {CE_POINTER [ANY]}.make_cast (a_x_array), a_size * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_POINTER [ANY]}.make_cast (a_spline.item.y), create {CE_POINTER [ANY]}.make_cast (a_y_array), a_size * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_status := (interp_inst.gsl_interp_init (a_spline.item.interp, a_x_array, a_y_array, a_size))
				Result := l_status
			end
		end

	gsl_spline_min_size (a_spline: CE_POINTER [PD_GSL_SPLINE]): NATURAL_32
		do
			Result := (interp_inst.gsl_interp_min_size (a_spline.item.interp))
		end

	gsl_spline_name (a_spline: CE_POINTER [PD_GSL_SPLINE]): CE_POINTER [INTEGER_8]
		do
			Result := (interp_inst.gsl_interp_name (a_spline.item.interp))
		end

end
