class
	P_STREAM

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_stream.make
			create gsl_stream_handler.make
		end

feature {ANY} -- attributes

	gsl_stream: CE_POINTER [SD_IO_FILE] assign set_gsl_stream

	set_gsl_stream (a_gsl_stream: CE_POINTER [SD_IO_FILE])
		do
			gsl_stream := a_gsl_stream
		end

	gsl_stream_handler: CE_ROUTINE assign set_gsl_stream_handler

	set_gsl_stream_handler (a_gsl_stream_handler: CE_ROUTINE)
		do
			gsl_stream_handler := a_gsl_stream_handler
		end

feature {ANY} -- routines

	gsl_set_stream (a_new_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [SD_IO_FILE]
		local
			l_previous_stream: CE_POINTER [SD_IO_FILE]
		do
			create l_previous_stream.make

			if gsl_stream.is_void then
				gsl_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
			end
			l_previous_stream := gsl_stream
			gsl_stream := a_new_stream
			Result := l_previous_stream
		end

	gsl_set_stream_handler (a_new_handler: CE_ROUTINE): CE_ROUTINE
		local
			l_previous_handler: CE_ROUTINE
		do
			create l_previous_handler.make

			l_previous_handler := gsl_stream_handler
			gsl_stream_handler := a_new_handler
			Result := l_previous_handler
		end

	gsl_stream_printf (a_label: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [INTEGER_8]; a_line: INTEGER_32; a_reason: CE_POINTER [INTEGER_8])
		local
			js: JUMP_STATE
		do
			if gsl_stream.is_void then
				gsl_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
			end
			if (not gsl_stream_handler.is_void) then
				gsl_stream_handler.call ([a_label, a_file, a_line, a_reason])
				js.return
			end
			if not js.return_called then
				fprintf ([gsl_stream, ce_string ("gsl: %%s:%%d: %%s: %%s%N"), a_file, a_line, a_label, a_reason]).do_nothing
			end
		end

end
