class
	P_SUBSETIND_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sort_char_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_8
			l_i1: NATURAL_32
			l_xi: INTEGER_8
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 <= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 < (a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_char_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_8
			l_i1: NATURAL_32
			l_xi: INTEGER_8
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 >= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 > (a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_float_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: REAL_32
			l_i1: NATURAL_32
			l_xi: REAL_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_float_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: REAL_32
			l_i1: NATURAL_32
			l_xi: REAL_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_int_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_32
			l_i1: NATURAL_32
			l_xi: INTEGER_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_int_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_32
			l_i1: NATURAL_32
			l_xi: INTEGER_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: REAL_64
			l_i1: NATURAL_32
			l_xi: REAL_64
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_long_double_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: REAL_96
			l_i1: NATURAL_32
			l_xi: REAL_96
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_long_double_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: REAL_96
			l_i1: NATURAL_32
			l_xi: REAL_96
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_long_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_32
			l_i1: NATURAL_32
			l_xi: INTEGER_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_long_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_32
			l_i1: NATURAL_32
			l_xi: INTEGER_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_short_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_16
			l_i1: NATURAL_32
			l_xi: INTEGER_16
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 <= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 < (a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_short_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: INTEGER_16
			l_i1: NATURAL_32
			l_xi: INTEGER_16
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 >= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 > (a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: REAL_64
			l_i1: NATURAL_32
			l_xi: REAL_64
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_uchar_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_8
			l_i1: NATURAL_32
			l_xi: NATURAL_8
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 <= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 < (a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_uchar_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_8
			l_i1: NATURAL_32
			l_xi: NATURAL_8
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 >= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 > (a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_uint_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_32
			l_i1: NATURAL_32
			l_xi: NATURAL_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_uint_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_32
			l_i1: NATURAL_32
			l_xi: NATURAL_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_ulong_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_32
			l_i1: NATURAL_32
			l_xi: NATURAL_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi <= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi < a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_ulong_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_32
			l_i1: NATURAL_32
			l_xi: NATURAL_32
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi >= l_xbound then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi > a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32] then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_ushort_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_16
			l_i1: NATURAL_32
			l_xi: NATURAL_16
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 93, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 <= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 < (a_src[(a_stride * a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_stride * a_p[(l_j - {NATURAL_32} 1).to_integer_32]).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_ushort_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_src: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xbound: NATURAL_16
			l_i1: NATURAL_32
			l_xi: NATURAL_16
			js: JUMP_STATE
		do
			if a_k > a_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("subset length k exceeds vector length n"), ce_string ("subsetind_source.c"), 28, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_k = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif a_n = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (1).to_natural_32
				l_xbound := a_src[({NATURAL_32} 0).to_integer_32]
				a_p[0] := (0).to_natural_32
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_n))
				loop
					l_xi := a_src[(l_i * a_stride).to_integer_32]
					if l_j < a_k then
						l_j := l_j + 1
					elseif l_xi.to_integer_32 >= l_xbound.to_integer_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_i1 := l_j - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_i1 > {NATURAL_32} 0))
						loop
							if l_xi.to_integer_32 > (a_src[(a_p[(l_i1 - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								a_p[l_i1.to_integer_32] := a_p[(l_i1 - {NATURAL_32} 1).to_integer_32]
								l_i1 := l_i1 - 1
							end
						end
						a_p[l_i1.to_integer_32] := l_i
						l_xbound := a_src[(a_p[(l_j - {NATURAL_32} 1).to_integer_32] * a_stride).to_integer_32]
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_sort_vector_char_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		do
			Result := (gsl_sort_char_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_char_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		do
			Result := (gsl_sort_char_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_float_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		do
			Result := (gsl_sort_float_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_float_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		do
			Result := (gsl_sort_float_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_int_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		do
			Result := (gsl_sort_int_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_int_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		do
			Result := (gsl_sort_int_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		do
			Result := (gsl_sort_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_long_double_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		do
			Result := (gsl_sort_long_double_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_long_double_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		do
			Result := (gsl_sort_long_double_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_long_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		do
			Result := (gsl_sort_long_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_long_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		do
			Result := (gsl_sort_long_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_short_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		do
			Result := (gsl_sort_short_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_short_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		do
			Result := (gsl_sort_short_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		do
			Result := (gsl_sort_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_uchar_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		do
			Result := (gsl_sort_uchar_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_uchar_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		do
			Result := (gsl_sort_uchar_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_uint_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		do
			Result := (gsl_sort_uint_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_uint_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		do
			Result := (gsl_sort_uint_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_ulong_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		do
			Result := (gsl_sort_ulong_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_ulong_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		do
			Result := (gsl_sort_ulong_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_ushort_largest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		do
			Result := (gsl_sort_ushort_largest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

	gsl_sort_vector_ushort_smallest_index (a_p: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		do
			Result := (gsl_sort_ushort_smallest_index (a_p, a_k, a_v.item.data, a_v.item.stride, a_v.item.size))
		end

end
