class
	P_SVD

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_SV_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_V: CE_POINTER [PD_GSL_MATRIX]; a_S: CE_POINTER [PD_GSL_VECTOR]; a_work: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_a___5: NATURAL_32
			l_b___0: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_iter: NATURAL_32
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_K: NATURAL_32
			l_tmp: NATURAL_32
			l_column: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_norm___0: REAL_64
			l_f: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_fbm1: REAL_64
			l_fam1: REAL_64
			l_n_block: NATURAL_32
			l_S_block: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_f_block: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_U_block: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_V_block: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_rescale: INTEGER_32
			l_scale: REAL_64
			l_norm___1: REAL_64
			l_s_i: REAL_64
			l_a___6: REAL_64
			l_f_i: REAL_64
			l_a___7: REAL_64
			l_Sj: REAL_64
			l_Vij: REAL_64
			l_S_max: REAL_64
			l_i_max: NATURAL_32
			l_Sj___0: REAL_64
			js: JUMP_STATE
		do
			create l_column.make (<<1>>)
			create l_f.make (<<1>>)
			create l_S_block.make (<<1>>)
			create l_f_block.make (<<1>>)
			create l_U_block.make (<<1>>)
			create l_V_block.make (<<1>>)

			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_K := l_tmp
			if l_M < l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("svd of MxN matrix, M<N, is not implemented"), ce_string ("svd.c"), 61, 24)
					Result := 24
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_V.item.size1 /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("square matrix V must match second dimension of matrix A"), ce_string ("svd.c"), 66, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_V.item.size1 /= a_V.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix V must be square"), ce_string ("svd.c"), 70, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_S.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of vector S must match second dimension of matrix A"), ce_string ("svd.c"), 75, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_work.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of workspace must match second dimension of matrix A"), ce_string ("svd.c"), 80, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (l_N = {NATURAL_32} 1) then
				l_column.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, (0).to_natural_32)).twin
				l_norm___0 := (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_S, (0).to_natural_32, l_norm___0)
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, (0).to_natural_32, (0).to_natural_32, 1.0)
				if l_norm___0 /= 0.0 then
					blas_inst.gsl_blas_dscal (1.0 / l_norm___0, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				l_f.item := (subvector_source_inst.gsl_vector_subvector (a_work, (0).to_natural_32, l_K - {NATURAL_32} 1)).twin
				bidiag_inst.gsl_linalg_bidiag_decomp (a_A___0, a_S, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
				bidiag_inst.gsl_linalg_bidiag_unpack2 (a_A___0, a_S, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), a_V).do_nothing
				svdstep_inst.chop_small_elements___3 (a_S, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				l_b___0 := l_N - {NATURAL_32} 1
				l_iter := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_b___0 > {NATURAL_32} 0))
				loop
					l_fbm1 := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_b___0 - {NATURAL_32} 1))
					if l_fbm1 = 0.0 then
						l_b___0 := l_b___0 - 1
						js.continue
					elseif (infnan_inst.gsl_isnan (l_fbm1)).to_boolean then
						l_b___0 := l_b___0 - 1
						js.continue
					end
					if not js.loop_jumped then
						l_a___5 := l_b___0 - {NATURAL_32} 1
						from
						until
							not (not js.loop_done and then (l_a___5 > {NATURAL_32} 0))
						loop
							l_fam1 := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_a___5 - {NATURAL_32} 1))
							if l_fam1 = 0.0 then
								js.break
							elseif (infnan_inst.gsl_isnan (l_fam1)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_a___5 := l_a___5 - 1
							end
						end
						l_iter := l_iter + 1
						if l_iter > {NATURAL_32} 100 * l_N then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("SVD decomposition failed to converge"), ce_string ("svd.c"), 149, 11)
								Result := 11
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
						if not js.return_called then
							l_n_block := (l_b___0 - l_a___5) + {NATURAL_32} 1
							l_S_block.item := (subvector_source_inst.gsl_vector_subvector (a_S, l_a___5, l_n_block)).twin
							l_f_block.item := (subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_a___5, l_n_block - {NATURAL_32} 1)).twin
							l_U_block.item := (submatrix_source_inst.gsl_matrix_submatrix (a_A___0, (0).to_natural_32, l_a___5, a_A___0.item.size1, l_n_block)).twin
							l_V_block.item := (submatrix_source_inst.gsl_matrix_submatrix (a_V, (0).to_natural_32, l_a___5, a_V.item.size1, l_n_block)).twin
							l_rescale := 0
							l_scale := (1).to_double
							l_norm___1 := (0).to_double
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_n_block)
							loop
								l_s_i := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_S_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_i))
								l_a___6 := (fabs (l_s_i))
								if l_a___6 > l_norm___1 then
									l_norm___1 := l_a___6
								end
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_n_block - {NATURAL_32} 1)
							loop
								l_f_i := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_i))
								l_a___7 := (fabs (l_f_i))
								if l_a___7 > l_norm___1 then
									l_norm___1 := l_a___7
								end
								l_i := l_i + 1
							end
							if l_norm___1 > 1.3407807929942596e+154 then
								l_scale := l_norm___1 / 1.3407807929942596e+154
								l_rescale := 1
							elseif l_norm___1 < 1.4916681462400413e-154 then
								if l_norm___1 > (0).to_double then
									l_scale := l_norm___1 / 1.4916681462400413e-154
									l_rescale := 1
								end
							end
							if l_rescale.to_boolean then
								blas_inst.gsl_blas_dscal (1.0 / l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_S_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
								blas_inst.gsl_blas_dscal (1.0 / l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
							end
							svdstep_inst.qrstep___3 (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_S_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_U_block.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_V_block.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")))
							svdstep_inst.chop_small_elements___3 (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_S_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
							if l_rescale.to_boolean then
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_S_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_f_block.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
							end
						end
					end
				end
			end
			if not js.return_called then
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_K))
				loop
					l_Sj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_j))
					if l_Sj < 0.0 then
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_N)
						loop
							l_Vij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, l_j))
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, l_j, -l_Vij)
							l_i := l_i + 1
						end
						gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, -l_Sj)
					end
					l_j := l_j + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_K))
				loop
					l_S_max := (gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_i))
					l_i_max := l_i
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < l_K)
					loop
						l_Sj___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_j))
						if l_Sj___0 > l_S_max then
							l_S_max := l_Sj___0
							l_i_max := l_j
						end
						l_j := l_j + 1
					end
					if l_i_max /= l_i then
						swap_source_inst.gsl_vector_swap_elements (a_S, l_i, l_i_max).do_nothing
						swap_source_inst.gsl_matrix_swap_columns (a_A___0, l_i, l_i_max).do_nothing
						swap_source_inst.gsl_matrix_swap_columns (a_V, l_i, l_i_max).do_nothing
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_linalg_SV_decomp_jacobi (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_S: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_count: INTEGER_32
			l_sweep: INTEGER_32
			l_sweepmax: INTEGER_32
			l_tolerance: REAL_64
			l_cj: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_sj: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_p: CE_ARRAY [REAL_64]
			l_q___3: REAL_64
			l_cosine: REAL_64
			l_sine: REAL_64
			l_v: REAL_64
			l_abserr_a: REAL_64
			l_abserr_b: REAL_64
			l_sorted: INTEGER_32
			l_orthog: INTEGER_32
			l_noisya: INTEGER_32
			l_noisyb: INTEGER_32
			l_cj___0: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_ck: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
			l_Aik: REAL_64
			l_Aij: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: REAL_64
			l_Qij: REAL_64
			l_Qik: REAL_64
			l_prev_norm: REAL_64
			l_column: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_norm___0: REAL_64
			js: JUMP_STATE
		do
			create l_cj.make (<<1>>)
			create l_p.make (<<1>>)
			create l_cj___0.make (<<1>>)
			create l_ck.make (<<1>>)
			create l_column.make (<<1>>)

			if a_A___0.item.size1 < a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("svd of MxN matrix, M<N, is not implemented"), ce_string ("svd.c"), 504, 24)
					Result := 24
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_Q___1.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("square matrix Q must match second dimension of matrix A"), ce_string ("svd.c"), 509, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_Q___1.item.size1 /= a_Q___1.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix Q must be square"), ce_string ("svd.c"), 513, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_S.item.size /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of vector S must match second dimension of matrix A"), ce_string ("svd.c"), 518, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_M := a_A___0.item.size1
				l_N := a_A___0.item.size2
				l_count := 1
				l_sweep := 0
				l_sweepmax := ({NATURAL_32} 5 * l_N).to_integer_32
				l_tolerance := ({NATURAL_32} 10 * l_M).to_real_64 * 2.2204460492503131e-16
				if l_sweepmax > 12 then
					l_sweepmax := l_sweepmax
				else
					l_sweepmax := 12
				end
				init_source_inst.gsl_matrix_set_identity (a_Q___1)
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_cj.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_j)).twin
					l_sj := (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_cj.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, 2.2204460492503131e-16 * l_sj)
					l_j := l_j + 1
				end
				from
				until
					js.loop_done
				loop
					if l_count > 0 then
						if not (l_sweep <= l_sweepmax) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_count := ((l_N * (l_N - {NATURAL_32} 1)) // {NATURAL_32} 2).to_integer_32
						l_j := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_j < l_N - {NATURAL_32} 1))
						loop
							l_k := l_j + {NATURAL_32} 1
							from
							until
								not (not js.loop_done and then (l_k < l_N))
							loop
								l_a___5 := 0.0
								l_b___0 := 0.0
								l_p.item := 0.0
								l_q___3 := 0.0
								l_cj___0.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_j)).twin
								l_ck.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_k)).twin
								blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_cj___0.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ck.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_p).do_nothing
								l_p.item := l_p.item * (2.0)
								l_a___5 := blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_cj___0.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
								l_b___0 := blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ck.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
								l_q___3 := l_a___5 * l_a___5 - l_b___0 * l_b___0
								l_v := hypot (l_p.item, l_q___3)
								l_abserr_a := gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_j)
								l_abserr_b := gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_k)
								l_tmp___3 := coerce_inst.gsl_coerce_double (l_a___5)
								l_sorted := (l_tmp___3 >= (coerce_inst.gsl_coerce_double (l_b___0))).to_integer
								l_tmp___5 := fabs (l_p.item)
								l_orthog := (l_tmp___5 <= l_tolerance * (coerce_inst.gsl_coerce_double (l_a___5 * l_b___0))).to_integer
								l_noisya := (l_a___5 < l_abserr_a).to_integer
								l_noisyb := (l_b___0 < l_abserr_b).to_integer
								if l_sorted.to_boolean then
									if l_orthog.to_boolean then
										l_count := l_count - 1
										js.continue
									elseif l_noisya.to_boolean then
										l_count := l_count - 1
										js.continue
									elseif l_noisyb.to_boolean then
										l_count := l_count - 1
										js.continue
									end
								end
								if not js.loop_jumped then
									if l_v = (0).to_double then
										l_cosine := 0.0
										l_sine := 1.0
									elseif not l_sorted.to_boolean then
										l_cosine := 0.0
										l_sine := 1.0
									else
										l_cosine := sqrt ((l_v + l_q___3) / (2.0 * l_v))
										l_sine := l_p.item / ((2.0 * l_v) * l_cosine)
									end
									l_i := (0).to_natural_32
									from
									until
										not (l_i < l_M)
									loop
										l_Aik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_k))
										l_Aij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j))
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_j, l_Aij * l_cosine + l_Aik * l_sine)
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_k, -l_Aij * l_sine + l_Aik * l_cosine)
										l_i := l_i + 1
									end
									l_tmp___9 := fabs (l_cosine)
									gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, l_tmp___9 * l_abserr_a + (fabs (l_sine)) * l_abserr_b)
									l_tmp___11 := fabs (l_sine)
									gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_k, l_tmp___11 * l_abserr_a + (fabs (l_cosine)) * l_abserr_b)
									l_i := (0).to_natural_32
									from
									until
										not (l_i < l_N)
									loop
										l_Qij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Q___1, l_i, l_j))
										l_Qik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Q___1, l_i, l_k))
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_Q___1, l_i, l_j, l_Qij * l_cosine + l_Qik * l_sine)
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_Q___1, l_i, l_k, -l_Qij * l_sine + l_Qik * l_cosine)
										l_i := l_i + 1
									end
								end
								if js.loop_increment then
									l_k := l_k + 1
								end
							end
							l_j := l_j + 1
						end
						l_sweep := l_sweep + 1
					end
				end
				l_prev_norm := -1.0
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_column.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_j)).twin
					l_norm___0 := (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))))
					if l_norm___0 = 0.0 then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, 0.0)
						init_source_inst.gsl_vector_set_zero (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
						l_prev_norm := 0.0
					elseif l_prev_norm = 0.0 then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, 0.0)
						init_source_inst.gsl_vector_set_zero (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
						l_prev_norm := 0.0
					elseif l_j > {NATURAL_32} 0 then
						if l_norm___0 <= l_tolerance * l_prev_norm then
							gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, 0.0)
							init_source_inst.gsl_vector_set_zero (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
							l_prev_norm := 0.0
						else
							gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, l_norm___0)
							oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), 1.0 / l_norm___0).do_nothing
							l_prev_norm := l_norm___0
						end
					else
						gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_j, l_norm___0)
						oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), 1.0 / l_norm___0).do_nothing
						l_prev_norm := l_norm___0
					end
					l_j := l_j + 1
				end
				if l_count > 0 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("Jacobi iterations did not reach desired tolerance"), ce_string ("svd.c"), 674, 14)
						Result := 14
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_SV_decomp_mod (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_X: CE_POINTER [PD_GSL_MATRIX]; a_V: CE_POINTER [PD_GSL_MATRIX]; a_S: CE_POINTER [PD_GSL_VECTOR]; a_work: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_column: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_norm___0: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_v: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tau_i: REAL_64
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_Aii: REAL_64
			l_Aij: REAL_64
			l_tj: REAL_64
			l_m___5: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tmp___9: NATURAL_32
			l_sum: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_L_i: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_Lij: REAL_64
			l_X_j: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			js: JUMP_STATE
		do
			create l_column.make (<<1>>)
			create l_c___1.make (<<1>>)
			create l_v.make (<<1>>)
			create l_m___4.make (<<1>>)
			create l_m___5.make (<<1>>)
			create l_sum.make (<<1>>)
			create l_L_i.make (<<1>>)
			create l_X_j.make (<<1>>)

			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M < l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("svd of MxN matrix, M<N, is not implemented"), ce_string ("svd.c"), 286, 24)
					Result := 24
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_V.item.size1 /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("square matrix V must match second dimension of matrix A"), ce_string ("svd.c"), 291, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_V.item.size1 /= a_V.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix V must be square"), ce_string ("svd.c"), 295, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_X.item.size1 /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("square matrix X must match second dimension of matrix A"), ce_string ("svd.c"), 300, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_X.item.size1 /= a_X.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix X must be square"), ce_string ("svd.c"), 304, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_S.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of vector S must match second dimension of matrix A"), ce_string ("svd.c"), 309, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_work.item.size /= l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of workspace must match second dimension of matrix A"), ce_string ("svd.c"), 314, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (l_N = {NATURAL_32} 1) then
				l_column.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, (0).to_natural_32)).twin
				l_norm___0 := (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_S, (0).to_natural_32, l_norm___0)
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, (0).to_natural_32, (0).to_natural_32, 1.0)
				if l_norm___0 /= 0.0 then
					blas_inst.gsl_blas_dscal (1.0 / l_norm___0, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_c___1.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_i)).twin
					l_v.item := (subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_i, l_M - l_i)).twin
					l_tau_i := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
					if l_i + {NATURAL_32} 1 < l_N then
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i, l_i + {NATURAL_32} 1, l_M - l_i, l_N - (l_i + {NATURAL_32} 1))).twin
						householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (a_S, l_i, l_tau_i)
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_N))
				loop
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_i)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_X, l_i, l_j, 0.0)
						l_j := l_j + 1
					end
					l_Aii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_X, l_i, l_i, l_Aii)
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < l_N)
					loop
						l_Aij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_X, l_i, l_j, l_Aij)
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_j := l_N
				from
				until
					js.loop_done
				loop
					l_tmp___9 := l_j
					l_j := l_j - 1
					if not (l_tmp___9 > {NATURAL_32} 0) then
						js.break
					end
					if not js.loop_jumped then
						l_tj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_j))
						l_m___5.item := (submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_j, l_j, l_M - l_j, l_N - l_j)).twin
						householder_inst.gsl_linalg_householder_hm1 (l_tj, create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___5.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
					end
				end
				gsl_linalg_SV_decomp (a_X, a_V, a_S, a_work).do_nothing
				l_sum.item := (subvector_source_inst.gsl_vector_subvector (a_work, (0).to_natural_32, l_N)).twin
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_M))
				loop
					l_L_i.item := (rowcol_source_inst.gsl_matrix_row (a_A___0, l_i)).twin
					init_source_inst.gsl_vector_set_zero (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sum.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_N)
					loop
						l_Lij := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_L_i.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_j))
						l_X_j.item := (rowcol_source_inst.gsl_matrix_row (a_X, l_j)).twin
						blas_inst.gsl_blas_daxpy (l_Lij, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_X_j.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sum.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
						l_j := l_j + 1
					end
					copy_source_inst.gsl_vector_memcpy (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_L_i.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sum.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))).do_nothing
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_linalg_SV_solve (a_U: CE_POINTER [PD_GSL_MATRIX]; a_V: CE_POINTER [PD_GSL_MATRIX]; a_S: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_wi: REAL_64
			l_alpha: REAL_64
			js: JUMP_STATE
		do
			create l_w.make

			if a_U.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first dimension of matrix U must size of vector b"), ce_string ("svd.c"), 430, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_U.item.size2 /= a_S.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of vector S must match second dimension of matrix U"), ce_string ("svd.c"), 435, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_V.item.size1 /= a_V.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix V must be square"), ce_string ("svd.c"), 439, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_S.item.size /= a_V.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length of vector S must match size of matrix V"), ce_string ("svd.c"), 444, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_V.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of matrix V must match size of vector x"), ce_string ("svd.c"), 448, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_N := a_U.item.size2
				l_w := (init_source_inst.gsl_vector_calloc (l_N))
				blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasTrans, 1.0, a_U, a_b___0, 0.0, l_w).do_nothing
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_wi := (gsl_gsl_vector_double_inst.gsl_vector_get (l_w, l_i))
					l_alpha := (gsl_gsl_vector_double_inst.gsl_vector_get (a_S, l_i))
					if l_alpha /= (0).to_double then
						l_alpha := 1.0 / l_alpha
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (l_w, l_i, l_alpha * l_wi)
					l_i := l_i + 1
				end
				blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, a_V, l_w, 0.0, a_x).do_nothing
				init_source_inst.gsl_vector_free (l_w)
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
