class
	P_SVDSTEP

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	chase_out_intermediate_zero (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_U: CE_POINTER [PD_GSL_MATRIX]; a_k0: NATURAL_32)
		local
			l_M: NATURAL_32
			l_n: NATURAL_32
			l_c___1: CE_ARRAY [REAL_64]
			l_s: CE_ARRAY [REAL_64]
			l_x: REAL_64
			l_y: REAL_64
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_Uip: REAL_64
			l_Uiq: REAL_64
			l_z: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_s.make (<<1>>)

			l_M := a_U.item.size1
			l_n := a_d.item.size
			l_x := gsl_gsl_vector_double_inst.gsl_vector_get (a_f, a_k0)
			l_y := gsl_gsl_vector_double_inst.gsl_vector_get (a_d, a_k0 + {NATURAL_32} 1)
			l_k := a_k0
			from
			until
				not (not js.loop_done and then (l_k < l_n - {NATURAL_32} 1))
			loop
				qrstep_inst.create_givens (l_y, -l_x, l_c___1, l_s)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_M)
				loop
					l_Uip := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, a_k0))
					l_Uiq := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, l_k + {NATURAL_32} 1))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, a_k0, l_c___1.item * l_Uip - l_s.item * l_Uiq)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, l_k + {NATURAL_32} 1, l_s.item * l_Uip + l_c___1.item * l_Uiq)
					l_i := l_i + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, l_k + {NATURAL_32} 1, l_s.item * l_x + l_c___1.item * l_y)
				if l_k = a_k0 then
					gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_k, l_c___1.item * l_x - l_s.item * l_y)
				end
				if l_k < l_n - {NATURAL_32} 2 then
					l_z := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_k + {NATURAL_32} 1))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_k + {NATURAL_32} 1, l_c___1.item * l_z)
					l_x := -l_s.item * l_z
					l_y := gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_k + {NATURAL_32} 2)
				end
				l_k := l_k + 1
			end
		end

	chase_out_trailing_zero (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_V: CE_POINTER [PD_GSL_MATRIX])
		local
			l_N: NATURAL_32
			l_n2: NATURAL_32
			l_c___1: CE_ARRAY [REAL_64]
			l_s: CE_ARRAY [REAL_64]
			l_x: REAL_64
			l_y: REAL_64
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_Vip: REAL_64
			l_Viq: REAL_64
			l_z: REAL_64
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_s.make (<<1>>)

			l_N := a_V.item.size1
			l_n2 := a_d.item.size
			l_x := gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_n2 - {NATURAL_32} 2)
			l_y := gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_n2 - {NATURAL_32} 2)
			l_k := l_n2 - {NATURAL_32} 1
			from
			until
				js.loop_done
			loop
				l_tmp___2 := l_k
				l_k := l_k - 1
				if not (l_tmp___2 > {NATURAL_32} 0) then
					js.break
				end
				if not js.loop_jumped then
					qrstep_inst.create_givens (l_x, l_y, l_c___1, l_s)
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_N)
					loop
						l_Vip := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, l_k))
						l_Viq := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, l_n2 - {NATURAL_32} 1))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, l_k, l_c___1.item * l_Vip - l_s.item * l_Viq)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, l_n2 - {NATURAL_32} 1, l_s.item * l_Vip + l_c___1.item * l_Viq)
						l_i := l_i + 1
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (a_d, l_k, l_c___1.item * l_x - l_s.item * l_y)
					if l_k = l_n2 - {NATURAL_32} 2 then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_k, l_s.item * l_x + l_c___1.item * l_y)
					end
					if l_k > {NATURAL_32} 0 then
						l_z := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_k - {NATURAL_32} 1))
						gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_k - {NATURAL_32} 1, l_c___1.item * l_z)
						l_x := gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_k - {NATURAL_32} 1)
						l_y := l_s.item * l_z
					end
				end
			end
		end

	chop_small_elements___3 (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR])
		local
			l_N: NATURAL_32
			l_d_i: REAL_64
			l_i: NATURAL_32
			l_f_i: REAL_64
			l_d_ip1: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
		do
			l_N := a_d.item.size
			l_d_i := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, (0).to_natural_32))
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N - {NATURAL_32} 1)
			loop
				l_f_i := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_d_ip1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_i + {NATURAL_32} 1))
				l_tmp___2 := fabs (l_f_i)
				l_tmp___3 := fabs (l_d_i)
				if l_tmp___2 < 2.2204460492503131e-16 * (l_tmp___3 + (fabs (l_d_ip1))) then
					gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_i, 0.0)
				end
				l_d_i := l_d_ip1
				l_i := l_i + 1
			end
		end

	create_schur (a_d0: REAL_64; a_f0: REAL_64; a_d1: REAL_64; a_c___1: CE_POINTER [REAL_64]; a_s: CE_POINTER [REAL_64])
		local
			l_d0: REAL_64
			l_f0: REAL_64
			l_d1: REAL_64
			l_apq: REAL_64
			l_scale: REAL_64
			l_d0_exp: CE_ARRAY [INTEGER_32]
			l_f0_exp: CE_ARRAY [INTEGER_32]
			l_t: REAL_64
			l_tau: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_d0_exp.make (<<1>>)
			create l_f0_exp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d0 := a_d0
					l_f0 := a_f0
					l_d1 := a_d1
					l_apq := (2.0 * l_d0) * l_f0
					if l_d0 = (0).to_double then
						a_c___1.item := 1.0
						a_s.item := 0.0
						js.return
					elseif l_f0 = (0).to_double then
						a_c___1.item := 1.0
						a_s.item := 0.0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if not ((fabs (l_d0)) < 1.4916681462400413e-154) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if not ((fabs (l_d0)) > 1.3407807929942596e+154) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						if not ((fabs (l_f0)) < 1.4916681462400413e-154) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if not ((fabs (l_f0)) > 1.3407807929942596e+154) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if not ((fabs (l_d1)) < 1.4916681462400413e-154) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not ((fabs (l_d1)) > 1.3407807929942596e+154) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						frexp (l_d0, l_d0_exp).do_nothing
						frexp (l_f0, l_f0_exp).do_nothing
						l_scale := ldexp (1.0, -(l_d0_exp.item + l_f0_exp.item) // 4)
						l_d0 := l_d0 * l_scale
						l_f0 := l_f0 * l_scale
						l_d1 := l_d1 * l_scale
						l_apq := (2.0 * l_d0) * l_f0
				when 18 then -- if done | if done | if done | if done | if done
						if l_apq /= 0.0 then
							l_tau := (l_f0 * l_f0 + (l_d1 + l_d0) * (l_d1 - l_d0)) / l_apq
							if l_tau >= 0.0 then
								l_t := 1.0 / (l_tau + (hypot (1.0, l_tau)))
							else
								l_t := -1.0 / (-l_tau + (hypot (1.0, l_tau)))
							end
							a_c___1.item := 1.0 / (hypot (1.0, l_t))
							a_s.item := l_t * a_c___1.item
						else
							a_c___1.item := 1.0
							a_s.item := 0.0
						end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qrstep___3 (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_U: CE_POINTER [PD_GSL_MATRIX]; a_V: CE_POINTER [PD_GSL_MATRIX])
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_n2: NATURAL_32
			l_y: REAL_64
			l_z: REAL_64
			l_ak: REAL_64
			l_bk: REAL_64
			l_zk: REAL_64
			l_ap: REAL_64
			l_bp: REAL_64
			l_aq: REAL_64
			l_bq: REAL_64
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_d_i: REAL_64
			l_d_nm1: REAL_64
			l_d0: REAL_64
			l_f0: REAL_64
			l_d1: REAL_64
			l_f1: REAL_64
			l_mu: REAL_64
			l_c___1: CE_ARRAY [REAL_64]
			l_s: CE_ARRAY [REAL_64]
			l_Vip: REAL_64
			l_Viq: REAL_64
			l_bk1: REAL_64
			l_ap1: REAL_64
			l_bp1: REAL_64
			l_zp1: REAL_64
			l_aq1: REAL_64
			l_Uip: REAL_64
			l_Uiq: REAL_64
			l_ak1: REAL_64
			l_bk1___0: REAL_64
			l_zk1: REAL_64
			l_ap1___0: REAL_64
			l_bp1___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_s.make (<<1>>)

			l_M := a_U.item.size1
			l_N := a_V.item.size1
			l_n2 := a_d.item.size
			if l_n2 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called and then (l_n2 = {NATURAL_32} 2) then
				svd2 (a_d, a_f, a_U, a_V)
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_n2 - {NATURAL_32} 1))
				loop
					l_d_i := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_i))
					if l_d_i = 0.0 then
						chase_out_intermediate_zero (a_d, a_f, a_U, l_i)
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_d_nm1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_n2 - {NATURAL_32} 1))
				if l_d_nm1 = 0.0 then
					chase_out_trailing_zero (a_d, a_f, a_V)
					js.return
				end
			end
			if not js.return_called then
				l_d0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, (0).to_natural_32))
				l_f0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, (0).to_natural_32))
				l_d1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, (1).to_natural_32))
				l_f1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, (1).to_natural_32))
				l_mu := (trailing_eigenvalue___3 (a_d, a_f))
				l_y := l_d0 * l_d0 - l_mu
				l_z := l_d0 * l_f0
				l_ak := (0).to_double
				l_bk := (0).to_double
				l_ap := l_d0
				l_bp := l_f0
				l_aq := l_d1
				l_bq := l_f1
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < l_n2 - {NATURAL_32} 1))
				loop
					qrstep_inst.create_givens (l_y, l_z, l_c___1, l_s)
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_N)
					loop
						l_Vip := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, l_k))
						l_Viq := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, l_k + {NATURAL_32} 1))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, l_k, l_c___1.item * l_Vip - l_s.item * l_Viq)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, l_k + {NATURAL_32} 1, l_s.item * l_Vip + l_c___1.item * l_Viq)
						l_i := l_i + 1
					end
					l_bk1 := l_c___1.item * l_bk - l_s.item * l_z
					l_ap1 := l_c___1.item * l_ap - l_s.item * l_bp
					l_bp1 := l_s.item * l_ap + l_c___1.item * l_bp
					l_zp1 := -l_s.item * l_aq
					l_aq1 := l_c___1.item * l_aq
					if l_k > {NATURAL_32} 0 then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_k - {NATURAL_32} 1, l_bk1)
					end
					l_ak := l_ap1
					l_bk := l_bp1
					l_zk := l_zp1
					l_ap := l_aq1
					if l_k < l_n2 - {NATURAL_32} 2 then
						l_bp := gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_k + {NATURAL_32} 1)
					else
						l_bp := 0.0
					end
					l_y := l_ak
					l_z := l_zk
					qrstep_inst.create_givens (l_y, l_z, l_c___1, l_s)
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_M)
					loop
						l_Uip := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, l_k))
						l_Uiq := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, l_k + {NATURAL_32} 1))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, l_k, l_c___1.item * l_Uip - l_s.item * l_Uiq)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, l_k + {NATURAL_32} 1, l_s.item * l_Uip + l_c___1.item * l_Uiq)
						l_i := l_i + 1
					end
					l_ak1 := l_c___1.item * l_ak - l_s.item * l_zk
					l_bk1___0 := l_c___1.item * l_bk - l_s.item * l_ap
					l_zk1 := -l_s.item * l_bp
					l_ap1___0 := l_s.item * l_bk + l_c___1.item * l_ap
					l_bp1___0 := l_c___1.item * l_bp
					gsl_gsl_vector_double_inst.gsl_vector_set (a_d, l_k, l_ak1)
					l_ak := l_ak1
					l_bk := l_bk1___0
					l_zk := l_zk1
					l_ap := l_ap1___0
					l_bp := l_bp1___0
					if l_k < l_n2 - {NATURAL_32} 2 then
						l_aq := gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_k + {NATURAL_32} 2)
					else
						l_aq := 0.0
					end
					l_y := l_bk
					l_z := l_zk
					l_k := l_k + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_f, l_n2 - {NATURAL_32} 2, l_bk)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, l_n2 - {NATURAL_32} 1, l_ap)
			end
		end

	svd2 (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_U: CE_POINTER [PD_GSL_MATRIX]; a_V: CE_POINTER [PD_GSL_MATRIX])
		local
			l_i: NATURAL_32
			l_c___1: CE_ARRAY [REAL_64]
			l_s: CE_ARRAY [REAL_64]
			l_a11: REAL_64
			l_a12: REAL_64
			l_a21: REAL_64
			l_a22: REAL_64
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_d0: REAL_64
			l_f0: REAL_64
			l_d1: REAL_64
			l_Uip: REAL_64
			l_Uiq: REAL_64
			l_Vip: REAL_64
			l_Viq: REAL_64
			l_Vip___0: REAL_64
			l_Viq___0: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_tmp___8: REAL_64
			l_Uip___0: REAL_64
			l_Uiq___0: REAL_64
		do
			create l_c___1.make (<<1>>)
			create l_s.make (<<1>>)

			l_M := a_U.item.size1
			l_N := a_V.item.size1
			l_d0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, (0).to_natural_32))
			l_f0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, (0).to_natural_32))
			l_d1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, (1).to_natural_32))
			if l_d0 = 0.0 then
				qrstep_inst.create_givens (l_f0, l_d1, l_c___1, l_s)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, (0).to_natural_32, l_c___1.item * l_f0 - l_s.item * l_d1)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_f, (0).to_natural_32, l_s.item * l_f0 + l_c___1.item * l_d1)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, (1).to_natural_32, 0.0)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_M)
				loop
					l_Uip := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, (0).to_natural_32))
					l_Uiq := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, (1).to_natural_32))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, (0).to_natural_32, l_c___1.item * l_Uip - l_s.item * l_Uiq)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, (1).to_natural_32, l_s.item * l_Uip + l_c___1.item * l_Uiq)
					l_i := l_i + 1
				end
				swap_source_inst.gsl_matrix_swap_columns (a_V, (0).to_natural_32, (1).to_natural_32).do_nothing
			elseif l_d1 = 0.0 then
				qrstep_inst.create_givens (l_d0, l_f0, l_c___1, l_s)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, (0).to_natural_32, l_d0 * l_c___1.item - l_f0 * l_s.item)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_f, (0).to_natural_32, 0.0)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_Vip := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, (0).to_natural_32))
					l_Viq := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, (1).to_natural_32))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, (0).to_natural_32, l_c___1.item * l_Vip - l_s.item * l_Viq)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, (1).to_natural_32, l_s.item * l_Vip + l_c___1.item * l_Viq)
					l_i := l_i + 1
				end
			else
				create_schur (l_d0, l_f0, l_d1, l_c___1, l_s)
				l_a11 := l_c___1.item * l_d0 - l_s.item * l_f0
				l_a21 := -l_s.item * l_d1
				l_a12 := l_s.item * l_d0 + l_c___1.item * l_f0
				l_a22 := l_c___1.item * l_d1
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_Vip___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, (0).to_natural_32))
					l_Viq___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_V, l_i, (1).to_natural_32))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, (0).to_natural_32, l_c___1.item * l_Vip___0 - l_s.item * l_Viq___0)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_V, l_i, (1).to_natural_32, l_s.item * l_Vip___0 + l_c___1.item * l_Viq___0)
					l_i := l_i + 1
				end
				l_tmp___8 := hypot (l_a11, l_a21)
				if l_tmp___8 < (hypot (l_a12, l_a22)) then
					l_t1 := l_a11
					l_a11 := l_a12
					l_a12 := l_t1
					l_t2 := l_a21
					l_a21 := l_a22
					l_a22 := l_t2
					swap_source_inst.gsl_matrix_swap_columns (a_V, (0).to_natural_32, (1).to_natural_32).do_nothing
				end
				qrstep_inst.create_givens (l_a11, l_a21, l_c___1, l_s)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, (0).to_natural_32, l_c___1.item * l_a11 - l_s.item * l_a21)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_f, (0).to_natural_32, l_c___1.item * l_a12 - l_s.item * l_a22)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_d, (1).to_natural_32, l_s.item * l_a12 + l_c___1.item * l_a22)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_M)
				loop
					l_Uip___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, (0).to_natural_32))
					l_Uiq___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_U, l_i, (1).to_natural_32))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, (0).to_natural_32, l_c___1.item * l_Uip___0 - l_s.item * l_Uiq___0)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_U, l_i, (1).to_natural_32, l_s.item * l_Uip___0 + l_c___1.item * l_Uiq___0)
					l_i := l_i + 1
				end
			end
		end

	trailing_eigenvalue___3 (a_d: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_n: NATURAL_32
			l_da: REAL_64
			l_db: REAL_64
			l_fa: REAL_64
			l_tmp___2: REAL_64
			l_fb: REAL_64
			l_mu: REAL_64
			l_ta: REAL_64
			l_tb: REAL_64
			l_tab: REAL_64
			l_dt: REAL_64
			l_S: REAL_64
			l_da2: REAL_64
			l_db2: REAL_64
			l_fa2: REAL_64
			l_fb2: REAL_64
			l_P___2: REAL_64
			l_D: REAL_64
			l_r1___1: REAL_64
		do
			l_n := a_d.item.size
			l_da := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_n - {NATURAL_32} 2))
			l_db := (gsl_gsl_vector_double_inst.gsl_vector_get (a_d, l_n - {NATURAL_32} 1))
			if l_n > {NATURAL_32} 2 then
				l_tmp___2 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_n - {NATURAL_32} 3))
			else
				l_tmp___2 := 0.0
			end
			l_fa := l_tmp___2
			l_fb := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_n - {NATURAL_32} 2))
			l_ta := l_da * l_da + l_fa * l_fa
			l_tb := l_db * l_db + l_fb * l_fb
			l_tab := l_da * l_fb
			l_dt := (l_ta - l_tb) / 2.0
			l_S := l_ta + l_tb
			l_da2 := l_da * l_da
			l_db2 := l_db * l_db
			l_fa2 := l_fa * l_fa
			l_fb2 := l_fb * l_fb
			l_P___2 := (l_da2 * l_db2 + l_fa2 * l_db2) + l_fa2 * l_fb2
			l_D := (hypot (l_dt, l_tab))
			l_r1___1 := l_S / (2).to_double + l_D
			if l_dt >= (0).to_double then
				if l_r1___1 > (0).to_double then
					l_mu := l_P___2 / l_r1___1
				else
					l_mu := 0.0
				end
			else
				l_mu := l_r1___1
			end
			Result := l_mu
		end

end
