class
	P_SYMMTD

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_symmtd_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_v: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tau_i: REAL_64
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_ei: REAL_64
			l_x: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_xv: CE_ARRAY [REAL_64]
			l_alpha: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_v.make (<<1>>)
			create l_m___4.make (<<1>>)
			create l_x.make (<<1>>)
			create l_xv.make (<<1>>)

			if a_A___0.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("symmetric tridiagonal decomposition requires square matrix"), ce_string ("symmtd.c"), 69, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_tau.item.size + {NATURAL_32} 1 /= a_A___0.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of tau must be (matrix size - 1)"), ce_string ("symmtd.c"), 73, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_N := a_A___0.item.size1
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N - {NATURAL_32} 2)
				loop
					l_c___1.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_i)).twin
					l_v.item := (subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))).twin
					l_tau_i := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
					if l_tau_i /= 0.0 then
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))).twin
						l_ei := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (0).to_natural_32))
						l_x.item := (subvector_source_inst.gsl_vector_subvector (a_tau, l_i, l_N - (l_i + {NATURAL_32} 1))).twin
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), (0).to_natural_32, 1.0)
						blas_inst.gsl_blas_dsymv ({PC_CBLAS_UPLO}.CblasLower, l_tau_i, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), 0.0, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
						blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_xv).do_nothing
						l_alpha := -(l_tau_i / 2.0) * l_xv.item
						blas_inst.gsl_blas_daxpy (l_alpha, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
						blas_inst.gsl_blas_dsyr2 ({PC_CBLAS_UPLO}.CblasLower, -1.0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), (0).to_natural_32, l_ei)
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (a_tau, l_i, l_tau_i)
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_symmtd_unpack (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_h: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_ti: REAL_64
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tmp___3: NATURAL_32
			l_Aii: REAL_64
			l_Aji: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c___1.make (<<1>>)
			create l_h.make (<<1>>)
			create l_m___4.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("symmtd.c"), 132, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_tau.item.size + {NATURAL_32} 1 = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("size of tau must be (matrix size - 1)"), ce_string ("symmtd.c"), 136, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_Q___1.item.size1 = a_A___0.item.size1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_Q___1.item.size2 = a_A___0.item.size1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("size of Q must match size of A"), ce_string ("symmtd.c"), 140, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if a_diag.item.size /= a_A___0.item.size1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("size of diagonal must match size of A"), ce_string ("symmtd.c"), 144, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						elseif a_sdiag.item.size + {NATURAL_32} 1 /= a_A___0.item.size1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("size of subdiagonal must be (matrix size - 1)"), ce_string ("symmtd.c"), 148, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_N := a_A___0.item.size1
							init_source_inst.gsl_matrix_set_identity (a_Q___1)
							l_i := l_N - {NATURAL_32} 2
							from
							until
								js.loop_done
							loop
								l_tmp___3 := l_i
								l_i := l_i - 1
								if not (l_tmp___3 > {NATURAL_32} 0) then
									js.break
								end
								if not js.loop_jumped then
									l_c___1.item := (rowcol_source_inst.gsl_matrix_const_column (a_A___0, l_i)).twin
									l_h.item := (subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))).twin
									l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
									l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_Q___1, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))).twin
									householder_inst.gsl_linalg_householder_hm (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
								end
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_N)
							loop
								l_Aii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_i, l_Aii)
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_N - {NATURAL_32} 1)
							loop
								l_Aji := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i + {NATURAL_32} 1, l_i))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_i, l_Aji)
								l_i := l_i + 1
							end
							Result := 0
							js.return
						end
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_symmtd_unpack_T (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_Aii: REAL_64
			l_Aij: REAL_64
			js: JUMP_STATE
		do
			if a_A___0.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("symmtd.c"), 198, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_diag.item.size /= a_A___0.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of diagonal must match size of A"), ce_string ("symmtd.c"), 202, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_sdiag.item.size + {NATURAL_32} 1 /= a_A___0.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of subdiagonal must be (matrix size - 1)"), ce_string ("symmtd.c"), 206, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_N := a_A___0.item.size1
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_Aii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_i, l_Aii)
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N - {NATURAL_32} 1)
				loop
					l_Aij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i + {NATURAL_32} 1, l_i))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_i, l_Aij)
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
