class
	P_TDIST

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cornish_fisher (a_t: REAL_64; a_n: REAL_64): REAL_64
		local
			l_coeffs6: CE_ARRAY [REAL_64]
			l_coeffs5: CE_ARRAY [REAL_64]
			l_coeffs4: CE_ARRAY [REAL_64]
			l_coeffs3: CE_ARRAY [REAL_64]
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_z2: REAL_64
			l_z: REAL_64
			l_p5: REAL_64
			l_p4: REAL_64
			l_p3: REAL_64
			l_p2: REAL_64
			l_p1: REAL_64
			l_p0: REAL_64
			l_y: REAL_64
		do
			create l_coeffs6.make (<<10>>)
			create l_coeffs5.make (<<8>>)
			create l_coeffs4.make (<<6>>)
			create l_coeffs3.make (<<4>>)

			l_coeffs6[0] := 0.265974025974025974026
			l_coeffs6[1] := 5.449696969696969696970
			l_coeffs6[2] := 122.20294372294372294372
			l_coeffs6[3] := 2354.7298701298701298701
			l_coeffs6[4] := 37625.00902597402597403
			l_coeffs6[5] := 486996.1392857142857143
			l_coeffs6[6] := 4960870.65
			l_coeffs6[7] := 37978595.55
			l_coeffs6[8] := 201505390.875
			l_coeffs6[9] := 622437908.625
			l_coeffs5[0] := 0.2742857142857142857142
			l_coeffs5[1] := 4.499047619047619047619
			l_coeffs5[2] := 78.45142857142857142857
			l_coeffs5[3] := 1118.710714285714285714
			l_coeffs5[4] := 12387.6
			l_coeffs5[5] := 101024.55
			l_coeffs5[6] := 559494.0
			l_coeffs5[7] := 1764959.625
			l_coeffs4[0] := 0.3047619047619047619048
			l_coeffs4[1] := 3.752380952380952380952
			l_coeffs4[2] := 46.67142857142857142857
			l_coeffs4[3] := 427.5
			l_coeffs4[4] := 2587.5
			l_coeffs4[5] := 8518.5
			l_coeffs3[0] := 0.4
			l_coeffs3[1] := 3.3
			l_coeffs3[2] := 24.0
			l_coeffs3[3] := 85.5
			l_a___5 := a_n - 0.5
			l_b___0 := (48.0 * l_a___5) * l_a___5
			l_z2 := l_a___5 * (log1p ((a_t * a_t) / a_n))
			l_z := (sqrt (l_z2))
			l_p5 := l_z * (poly_eval (create {CE_POINTER [REAL_64]}.make_cast (l_coeffs6), {NATURAL_32} 9, l_z2))
			l_p4 := -l_z * (poly_eval (create {CE_POINTER [REAL_64]}.make_cast (l_coeffs5), {NATURAL_32} 7, l_z2))
			l_p3 := l_z * (poly_eval (create {CE_POINTER [REAL_64]}.make_cast (l_coeffs4), {NATURAL_32} 5, l_z2))
			l_p2 := -l_z * (poly_eval (create {CE_POINTER [REAL_64]}.make_cast (l_coeffs3), {NATURAL_32} 3, l_z2))
			l_p1 := l_z * (l_z2 + 3.0)
			l_p0 := l_z
			l_y := l_p5
			l_y := l_y / l_b___0 + l_p4
			l_y := l_y / l_b___0 + l_p3
			l_y := l_y / l_b___0 + l_p2
			l_y := l_y / l_b___0 + l_p1
			l_y := l_y / l_b___0 + l_p0
			if a_t < (0).to_double then
				l_y := l_y * (-1).to_double
			end
			Result := l_y
		end

	gsl_cdf_tdist_P (a_x: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_x2___1: REAL_64
			l_u: REAL_64
			l_u___0: REAL_64
			l_eps: REAL_64
			l_v: REAL_64
			l_eps___0: REAL_64
			js: JUMP_STATE
		do
			l_x2___1 := a_x * a_x
			if a_nu > (30).to_double then
				if l_x2___1 < (10).to_double * a_nu then
					l_u := (cornish_fisher (a_x, a_nu))
					l_P___2 := gauss_inst.gsl_cdf_ugaussian_P (l_u)
					Result := l_P___2
					js.return
				end
			end
			if not js.return_called then
				if l_x2___1 < a_nu then
					l_u___0 := l_x2___1 / a_nu
					l_eps := l_u___0 / ((1).to_double + l_u___0)
					if a_x >= (0).to_double then
						l_P___2 := beta_inc_inst.beta_inc_AXPY___1 (0.5, 0.5, 0.5, a_nu / 2.0, l_eps)
					else
						l_P___2 := beta_inc_inst.beta_inc_AXPY___1 (-0.5, 0.5, 0.5, a_nu / 2.0, l_eps)
					end
				else
					l_v := a_nu / (a_x * a_x)
					l_eps___0 := l_v / ((1).to_double + l_v)
					if a_x >= (0).to_double then
						l_P___2 := beta_inc_inst.beta_inc_AXPY___1 (-0.5, 1.0, a_nu / 2.0, 0.5, l_eps___0)
					else
						l_P___2 := beta_inc_inst.beta_inc_AXPY___1 (0.5, 0.0, a_nu / 2.0, 0.5, l_eps___0)
					end
				end
				Result := l_P___2
			end
		end

	gsl_cdf_tdist_Q (a_x: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_x2___1: REAL_64
			l_u: REAL_64
			l_u___0: REAL_64
			l_eps: REAL_64
			l_v: REAL_64
			l_eps___0: REAL_64
			js: JUMP_STATE
		do
			l_x2___1 := a_x * a_x
			if a_nu > (30).to_double then
				if l_x2___1 < (10).to_double * a_nu then
					l_u := (cornish_fisher (a_x, a_nu))
					l_Q___1 := gauss_inst.gsl_cdf_ugaussian_Q (l_u)
					Result := l_Q___1
					js.return
				end
			end
			if not js.return_called then
				if l_x2___1 < a_nu then
					l_u___0 := l_x2___1 / a_nu
					l_eps := l_u___0 / ((1).to_double + l_u___0)
					if a_x >= (0).to_double then
						l_Q___1 := beta_inc_inst.beta_inc_AXPY___1 (-0.5, 0.5, 0.5, a_nu / 2.0, l_eps)
					else
						l_Q___1 := beta_inc_inst.beta_inc_AXPY___1 (0.5, 0.5, 0.5, a_nu / 2.0, l_eps)
					end
				else
					l_v := a_nu / (a_x * a_x)
					l_eps___0 := l_v / ((1).to_double + l_v)
					if a_x >= (0).to_double then
						l_Q___1 := beta_inc_inst.beta_inc_AXPY___1 (0.5, 0.0, a_nu / 2.0, 0.5, l_eps___0)
					else
						l_Q___1 := beta_inc_inst.beta_inc_AXPY___1 (-0.5, 1.0, a_nu / 2.0, 0.5, l_eps___0)
					end
				end
				Result := l_Q___1
			end
		end

	gsl_ran_tdist (a_r___3: CE_POINTER [PD_GSL_RNG]; a_nu: REAL_64): REAL_64
		local
			l_Y1: REAL_64
			l_Y2: REAL_64
			l_t: REAL_64
			l_Y1___0: REAL_64
			l_Y2___0: REAL_64
			l_Z: REAL_64
			l_t___0: REAL_64
			js: JUMP_STATE
		do
			if a_nu <= (2).to_double then
				l_Y1 := (gauss_inst.gsl_ran_ugaussian (a_r___3))
				l_Y2 := (chisq_inst.gsl_ran_chisq (a_r___3, a_nu))
				l_t := l_Y1 / (sqrt (l_Y2 / a_nu))
				Result := l_t
			else
				from
				until
					js.loop_done
				loop
					l_Y1___0 := gauss_inst.gsl_ran_ugaussian (a_r___3)
					l_Y2___0 := exponential_inst.gsl_ran_exponential (a_r___3, (1).to_double / (a_nu / (2).to_double - (1).to_double))
					l_Z := (l_Y1___0 * l_Y1___0) / (a_nu - (2).to_double)
					if not ((1).to_double - l_Z < (0).to_double) then
						if not ((exp (-l_Y2___0 - l_Z)) > (1).to_double - l_Z) then
							js.break
						end
					end
				end
				l_t___0 := l_Y1___0 / (sqrt (((1).to_double - (2).to_double / a_nu) * ((1).to_double - l_Z)))
				Result := l_t___0
			end
		end

	gsl_ran_tdist_pdf (a_x: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lg1: REAL_64
			l_lg2: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
		do
			l_lg1 := (gamma_inst.gsl_sf_lngamma (a_nu / (2).to_double))
			l_lg2 := (gamma_inst.gsl_sf_lngamma ((a_nu + (1).to_double) / (2).to_double))
			l_tmp___1 := exp (l_lg2 - l_lg1)
			l_tmp___2 := sqrt (3.14159265358979323846 * a_nu)
			l_p := (l_tmp___1 / l_tmp___2) * (pow ((1).to_double + (a_x * a_x) / a_nu, -(a_nu + (1).to_double) / (2).to_double))
			Result := l_p
		end

	poly_eval (a_c___1: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_x: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_y: REAL_64
		do
			l_y := (a_c___1[0] * a_x)
			l_i := {NATURAL_32} 1
			from
			until
				not (l_i < a_n)
			loop
				l_y := a_x * (l_y + a_c___1[l_i.to_integer_32])
				l_i := l_i + 1
			end
			l_y := l_y + (a_c___1[a_n.to_integer_32])
			Result := l_y
		end

end
