class
	P_TDISTINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_tdist_Pinv (a_P___2: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_ptail: REAL_64
			l_xg: REAL_64
			l_beta: REAL_64
			l_tmp___4: REAL_64
			l_tmp___6: REAL_64
			l_tmp___9: REAL_64
			l_dP: REAL_64
			l_phi: REAL_64
			l_n: NATURAL_32
			l_tmp___12: NATURAL_32
			l_lambda: REAL_64
			l_step0: REAL_64
			l_step1: REAL_64
			l_step: REAL_64
			l_tmp___13: REAL_64
			l_tmp___15: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_P___2 = 1.0 then
						Result := (builtin_inff).to_double
						js.return
					elseif a_P___2 = 0.0 then
						Result := (-(builtin_inff)).to_double
						js.return
					end
					if not js.return_called then
						if a_nu = 1.0 then
							l_x := tan (3.14159265358979323846 * (a_P___2 - 0.5))
							Result := l_x
							js.return
						elseif a_nu = 2.0 then
							l_x := ((2).to_double * a_P___2 - (1).to_double) / (sqrt (((2).to_double * a_P___2) * ((1).to_double - a_P___2)))
							Result := l_x
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_P___2 < 0.5 then
							l_ptail := a_P___2
						else
							l_ptail := (1).to_double - a_P___2
						end
						l_tmp___9 := sqrt ((3.14159265358979323846 * a_nu) / (2).to_double)
						if l_tmp___9 * l_ptail > (pow (0.05, a_nu / (2).to_double)) then
							l_xg := (gaussinv_inst.gsl_cdf_ugaussian_Pinv (a_P___2))
							l_x := inv_cornish_fisher (l_xg, a_nu)
						else
							l_beta := (beta_inst.gsl_sf_beta (0.5, a_nu / (2).to_double))
							if a_P___2 < 0.5 then
								l_tmp___4 := sqrt (a_nu)
								l_x := -l_tmp___4 * (pow ((l_beta * a_nu) * a_P___2, -1.0 / a_nu))
							else
								l_tmp___6 := sqrt (a_nu)
								l_x := l_tmp___6 * (pow ((l_beta * a_nu) * ((1).to_double - a_P___2), -1.0 / a_nu))
							end
							l_x := l_x / (sqrt ((1).to_double + a_nu / (l_x * l_x)))
						end
						l_n := {NATURAL_32} 0
				when 2 then -- start:
						l_dP := a_P___2 - (tdist_inst.gsl_cdf_tdist_P (l_x, a_nu))
						l_phi := tdist_inst.gsl_ran_tdist_pdf (l_x, a_nu)
						if l_dP = 0.0 then
							l_pos := -1 + 8 -- goto end
						else
							l_tmp___12 := l_n
							l_n := l_n + 1
							if l_tmp___12 > {NATURAL_32} 32 then
								l_pos := -1 + 8 -- goto end
							end
						end
				when 3 then
						l_lambda := l_dP / l_phi
						l_step0 := l_lambda
						l_step1 := (((a_nu + (1).to_double) * l_x) / (l_x * l_x + a_nu)) * ((l_lambda * l_lambda) / 4.0)
						l_step := l_step0
						l_tmp___13 := fabs (l_step1)
						if l_tmp___13 < (fabs (l_step0)) then
							l_step := l_step + l_step1
						end
						if not (a_P___2 > 0.5) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_x + l_step < (0).to_double then
							l_x := l_x / (2).to_double
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_P___2 < 0.5 then
							if l_x + l_step > (0).to_double then
								l_x := l_x / (2).to_double
							else
								l_x := l_x + l_step
							end
						else
							l_x := l_x + l_step
						end
				when 7 then
						l_tmp___15 := fabs (l_step)
						if l_tmp___15 > 1.e-10 * (fabs (l_x)) then
							l_pos := -1 + 2 -- goto start
						end
				when 8 then -- end:
						if (fabs (l_dP)) > 1.4901161193847656e-08 * a_P___2 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("inverse failed to converge"), ce_string ("tdistinv.c"), 139, 5)
								Result := (builtin_nanf (ce_string (""))).to_double
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
				when 9 then -- if done
					if not js.return_called then
						Result := l_x
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_cdf_tdist_Qinv (a_Q___1: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_qtail: REAL_64
			l_xg: REAL_64
			l_beta: REAL_64
			l_tmp___4: REAL_64
			l_tmp___6: REAL_64
			l_tmp___9: REAL_64
			l_dQ: REAL_64
			l_phi: REAL_64
			l_n: NATURAL_32
			l_tmp___12: NATURAL_32
			l_lambda: REAL_64
			l_step0: REAL_64
			l_step1: REAL_64
			l_step: REAL_64
			l_tmp___13: REAL_64
			l_tmp___15: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_Q___1 = 0.0 then
						Result := (builtin_inff).to_double
						js.return
					elseif a_Q___1 = 1.0 then
						Result := (-(builtin_inff)).to_double
						js.return
					end
					if not js.return_called then
						if a_nu = 1.0 then
							l_x := tan (3.14159265358979323846 * (0.5 - a_Q___1))
							Result := l_x
							js.return
						elseif a_nu = 2.0 then
							l_x := ((1).to_double - (2).to_double * a_Q___1) / (sqrt (((2).to_double * a_Q___1) * ((1).to_double - a_Q___1)))
							Result := l_x
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Q___1 < 0.5 then
							l_qtail := a_Q___1
						else
							l_qtail := (1).to_double - a_Q___1
						end
						l_tmp___9 := sqrt ((3.14159265358979323846 * a_nu) / (2).to_double)
						if l_tmp___9 * l_qtail > (pow (0.05, a_nu / (2).to_double)) then
							l_xg := (gaussinv_inst.gsl_cdf_ugaussian_Qinv (a_Q___1))
							l_x := inv_cornish_fisher (l_xg, a_nu)
						else
							l_beta := (beta_inst.gsl_sf_beta (0.5, a_nu / (2).to_double))
							if a_Q___1 < 0.5 then
								l_tmp___4 := sqrt (a_nu)
								l_x := l_tmp___4 * (pow ((l_beta * a_nu) * a_Q___1, -1.0 / a_nu))
							else
								l_tmp___6 := sqrt (a_nu)
								l_x := -l_tmp___6 * (pow ((l_beta * a_nu) * ((1).to_double - a_Q___1), -1.0 / a_nu))
							end
							l_x := l_x / (sqrt ((1).to_double + a_nu / (l_x * l_x)))
						end
						l_n := {NATURAL_32} 0
				when 2 then -- start:
						l_dQ := a_Q___1 - (tdist_inst.gsl_cdf_tdist_Q (l_x, a_nu))
						l_phi := tdist_inst.gsl_ran_tdist_pdf (l_x, a_nu)
						if l_dQ = 0.0 then
							l_pos := -1 + 8 -- goto end
						else
							l_tmp___12 := l_n
							l_n := l_n + 1
							if l_tmp___12 > {NATURAL_32} 32 then
								l_pos := -1 + 8 -- goto end
							end
						end
				when 3 then
						l_lambda := -l_dQ / l_phi
						l_step0 := l_lambda
						l_step1 := (((a_nu + (1).to_double) * l_x) / (l_x * l_x + a_nu)) * ((l_lambda * l_lambda) / 4.0)
						l_step := l_step0
						l_tmp___13 := fabs (l_step1)
						if l_tmp___13 < (fabs (l_step0)) then
							l_step := l_step + l_step1
						end
						if not (a_Q___1 < 0.5) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_x + l_step < (0).to_double then
							l_x := l_x / (2).to_double
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_Q___1 > 0.5 then
							if l_x + l_step > (0).to_double then
								l_x := l_x / (2).to_double
							else
								l_x := l_x + l_step
							end
						else
							l_x := l_x + l_step
						end
				when 7 then
						l_tmp___15 := fabs (l_step)
						if l_tmp___15 > 1.e-10 * (fabs (l_x)) then
							l_pos := -1 + 2 -- goto start
						end
				when 8 then -- end:
						Result := l_x
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	inv_cornish_fisher (a_z: REAL_64; a_nu: REAL_64): REAL_64
		local
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_cf1: REAL_64
			l_cf2: REAL_64
			l_y: REAL_64
			l_t: REAL_64
			l_tmp: INTEGER_32
		do
			l_a___5 := (1).to_double / (a_nu - 0.5)
			l_b___0 := 48.0 / (l_a___5 * l_a___5)
			l_cf1 := a_z * ((3).to_double + a_z * a_z)
			l_cf2 := a_z * ((945).to_double + (a_z * a_z) * ((360).to_double + (a_z * a_z) * ((63).to_double + (a_z * a_z) * (4).to_double)))
			l_y := (a_z - l_cf1 / l_b___0) + l_cf2 / (((10).to_double * l_b___0) * l_b___0)
			if a_z >= 0.0 then
				l_tmp := 1
			else
				l_tmp := -1
			end
			l_t := l_tmp.to_double * (sqrt (a_nu * (expm1 ((l_a___5 * l_y) * l_y))))
			Result := l_t
		end

end
