class
	P_ZUF

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_zuf.make
			create zuf_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_zuf: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_zuf

	set_gsl_rng_zuf (a_gsl_rng_zuf: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_zuf := a_gsl_rng_zuf
		end

	zuf_randmax: NATURAL_32 assign set_zuf_randmax

	set_zuf_randmax (a_zuf_randmax: NATURAL_32)
		do
			zuf_randmax := a_zuf_randmax
		end

	zuf_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	zuf_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_ZUF_STATE_T]
			l_n: INTEGER_32
			l_m___4: INTEGER_32
			l_t: NATURAL_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_ZUF_STATE_T]}.make_cast (a_vstate)
			l_n := l_state.item.n
			l_m___4 := ((l_n - 273) + 607) \\ 607
			l_t := l_state.item.u[l_n] + l_state.item.u[l_m___4]
			from
			until
				not (l_t > zuf_randmax)
			loop
				l_t := l_t - zuf_randmax
			end
			l_state.item.u[l_n] := l_t
			if l_n = 606 then
				l_state.item.n := 0
			else
				l_state.item.n := l_n + 1
			end
			Result := l_t
		end

	zuf_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent zuf_get)
		end

	zuf_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((zuf_get (a_vstate)).to_real_64 / 16777216.0)
		end

	zuf_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent zuf_get_double)
		end

	zuf_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_kl: INTEGER_32
			l_ij: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_l: INTEGER_32
			l_m___4: INTEGER_32
			l_x: REAL_64
			l_y: REAL_64
			l_ii: INTEGER_32
			l_jj: INTEGER_32
			l_state: CE_POINTER [PD_ZUF_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_s := a_s
			l_kl := 9_373
			l_ij := 1_802
			l_state := create {CE_POINTER [PD_ZUF_STATE_T]}.make_cast (a_vstate)
			l_state.item.n := 0
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1_802
			end
			l_ij := l_s.to_integer_32
			l_i := (l_ij // 177) \\ 177 + 2
			l_j := l_ij \\ 177 + 2
			l_k := (l_kl // 169) \\ 178 + 1
			l_l := l_kl \\ 169
			l_ii := 0
			from
			until
				not (not js.loop_done and then (l_ii < 607))
			loop
				l_x := 0.0
				l_y := 0.5
				l_jj := 1
				from
				until
					not (l_jj <= 24)
				loop
					l_m___4 := (((l_i * l_j) \\ 179) * l_k) \\ 179
					l_i := l_j
					l_j := l_k
					l_k := l_m___4
					l_l := (l_l * 53 + 1) \\ 169
					if (l_l * l_m___4) \\ 64 >= 32 then
						l_x := l_x + l_y
					end
					l_y := l_y * (0.5)
					l_jj := l_jj + 1
				end
				l_state.item.u[l_ii] := (l_x * zuf_randmax.to_real_64).truncated_to_integer_64.to_natural_32
				l_ii := l_ii + 1
			end
		end

	zuf_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent zuf_set)
		end

end
