deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a___stream.c_pointer)
		end

	c_fclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fclose($a___stream);"
		end

	feof (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_feof (a___stream.c_pointer)
		end

	c_feof (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return feof($a___stream);"
		end

	fflush (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a___stream.c_pointer)
		end

	c_fflush (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fflush($a___stream);"
		end

	fopen (a___filename: CE_POINTER [INTEGER_8]; a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a___filename.c_pointer, a___modes.c_pointer))
		end

	c_fopen (a___filename: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return fopen($a___filename, $a___modes);"
		end

	fprintf (a_args: TUPLE [a___stream: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return &fprintf;"
		end

	fputc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a___c, a___stream.c_pointer)
		end

	c_fputc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fputc($a___c, $a___stream);"
		end

	fread (a___ptr: CE_POINTER [ANY]; a___size: NATURAL_32; a___n: NATURAL_32; a___stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a___ptr.c_pointer, a___size, a___n, a___stream.c_pointer)
		end

	c_fread (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___stream: POINTER): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fread($a___ptr, $a___size, $a___n, $a___stream);"
		end

	fscanf (a_args: TUPLE [a___stream: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fscanf)).integer_32_item (a_args)
		end

	c_fscanf: POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return &fscanf;"
		end

	fwrite (a___ptr: CE_POINTER [ANY]; a___size: NATURAL_32; a___n: NATURAL_32; a___s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a___ptr.c_pointer, a___size, a___n, a___s.c_pointer)
		end

	c_fwrite (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___s: POINTER): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fwrite($a___ptr, $a___size, $a___n, $a___s);"
		end

	printf (a_args: TUPLE [a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return &printf;"
		end

	vfprintf (a___s: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]; a___arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a___s.c_pointer, a___format.c_pointer, a___arg.c_pointer)
		end

	c_vfprintf (a___s: POINTER; a___format: POINTER; a___arg: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return vfprintf($a___s, $a___format, $a___arg);"
		end

	vprintf (a___format: CE_POINTER [INTEGER_8]; a___arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vprintf (a___format.c_pointer, a___arg.c_pointer)
		end

	c_vprintf (a___format: POINTER; a___arg: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return vprintf($a___format, $a___arg);"
		end

end
