class
	P_QUICKFIX

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create buf___2.make (<<20>>)
			create cc.make (<<3>>)
			create dir_stack.make (<<1>>)
			create e_no_more_items.make
			create fmt_pat.make (<<10>>)
			create ql_info.make (<<1>>)
		end

feature {ANY} -- attributes

	buf___2: CE_ARRAY [NATURAL_8]

	cc: CE_ARRAY [NATURAL_8]

	dir_stack: CE_ARRAY [CE_POINTER [PD_DIR_STACK_T]]

	e_no_more_items: CE_POINTER [NATURAL_8] assign set_e_no_more_items

	set_e_no_more_items (a_e_no_more_items: CE_POINTER [NATURAL_8])
		do
			e_no_more_items := a_e_no_more_items
		end

	fmt_pat: CE_ARRAY [PD_FMTPATTERN]

	off: INTEGER_32 assign set_off

	set_off (a_off: INTEGER_32)
		do
			off := a_off
		end

	ql_info: CE_ARRAY [PD_QF_INFO_S]

	start___0: INTEGER_32 assign set_start___0

	set_start___0 (a_start___0: INTEGER_32)
		do
			start___0 := a_start___0
		end

feature {ANY} -- routines

	bt_dontwrite (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		do
			Result := ((a_buf___6.item.b_p_bt[0]).to_integer_32 = 110).to_integer
		end

	bt_dontwrite_msg (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (bt_dontwrite (a_buf___6)).to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E382: Cannot write, %'buftype%' option is set"))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	bt_nofile (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_buf___6.item.b_p_bt[0]).to_integer_32 /= 110 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_buf___6.item.b_p_bt[2]).to_integer_32 = 102 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (a_buf___6.item.b_p_bt[0]).to_integer_32 = 97 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bt_quickfix (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		do
			Result := ((a_buf___6.item.b_p_bt[0]).to_integer_32 = 113).to_integer
		end

	buf_hide (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_buf___6.item.b_p_bh[0]).to_integer_32 -- switch 1 head
					when 117 then l_pos := -1 + 1
					when 119 then l_pos := -1 + 1
					when 100 then l_pos := -1 + 1
					when 104 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 117 | switch 1, case 119 | switch 1, case 100
					Result := 0
					js.return
				when 2 then -- switch 1, case 104
					if not js.return_called then
						Result := 1
						js.return
					end
				when 3 then -- switch 1, done:
					if not js.return_called then
						if (option_inst.p_hid.item).to_boolean then
							l_tmp := 1
						elseif (globals_inst.cmdmod.item.hide).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
						Result := l_tmp
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copy_loclist (a_from: CE_POINTER [PD_WINDOW_S]; a_to: CE_POINTER [PD_WINDOW_S])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: CE_POINTER [PD_QF_INFO_S]
			l_from_qfl: CE_POINTER [PD_QF_LIST_S]
			l_to_qfl: CE_POINTER [PD_QF_LIST_S]
			l_from_qfp: CE_POINTER [PD_QFLINE_S]
			l_prevp: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			js: JUMP_STATE
		do
			create l_qi.make
			create l_tmp___0.make
			create l_from_qfl.make
			create l_to_qfl.make
			create l_from_qfp.make
			create l_prevp.make (<<1>>)

			if (bt_quickfix (a_from.item.w_buffer)).to_boolean then
				if not (a_from.item.w_llist_ref).is_void then
					l_qi := a_from.item.w_llist_ref
				else
					l_qi := a_from.item.w_llist
				end
			else
				l_qi := a_from.item.w_llist
			end
			if l_qi.is_void then
				js.return
			end
			if not js.return_called then
				l_tmp___0 := ll_new_list
				a_to.item.w_llist := l_tmp___0
				if l_tmp___0.is_void then
					js.return
				end
			end
			if not js.return_called then
				(a_to.item.w_llist).item.qf_listcount := l_qi.item.qf_listcount
				l_idx := 0
				from
				until
					not (not js.loop_done and then (l_idx < l_qi.item.qf_listcount))
				loop
					(a_to.item.w_llist).item.qf_curlist := l_idx
					l_from_qfl := l_qi.item.qf_lists + l_idx
					l_to_qfl := (a_to.item.w_llist).item.qf_lists + l_idx
					l_to_qfl.item.qf_nonevalid := l_from_qfl.item.qf_nonevalid
					l_to_qfl.item.qf_count := 0
					l_to_qfl.item.qf_index := 0
					l_to_qfl.item.qf_start := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_to_qfl.item.qf_ptr := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					if not (l_from_qfl.item.qf_title).is_void then
						l_to_qfl.item.qf_title := misc2_inst.vim_strsave (l_from_qfl.item.qf_title)
					else
						l_to_qfl.item.qf_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (l_from_qfl.item.qf_count).to_boolean then
						l_prevp.item := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
						l_i___0 := 0
						l_from_qfp := l_from_qfl.item.qf_start
						from
						until
							not (not js.loop_done and then (l_i___0 < l_from_qfl.item.qf_count))
						loop
							if (qf_add_entry (a_to.item.w_llist, l_prevp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_from_qfp.item.qf_text, l_from_qfp.item.qf_lnum, l_from_qfp.item.qf_col, (l_from_qfp.item.qf_viscol).to_integer_32, l_from_qfp.item.qf_pattern, l_from_qfp.item.qf_nr, 0, (l_from_qfp.item.qf_valid).to_integer_32)) = 0 then
								qf_free_all (a_to)
								js.return
							end
							if not js.return_called then
								l_prevp.item.item.qf_fnum := l_from_qfp.item.qf_fnum
								l_prevp.item.item.qf_type := l_from_qfp.item.qf_type
								if (l_from_qfl.item.qf_ptr).is_equal (l_from_qfp) then
									l_to_qfl.item.qf_ptr := l_prevp.item
								end
								l_i___0 := l_i___0 + 1
								l_from_qfp := l_from_qfp.item.qf_next
							end
						end
					end
					if not js.return_called then
						l_to_qfl.item.qf_index := l_from_qfl.item.qf_index
						if l_to_qfl.item.qf_nonevalid = 1 then
							l_to_qfl.item.qf_ptr := l_to_qfl.item.qf_start
						end
						l_idx := l_idx + 1
					end
				end
			end
			if not js.return_called then
				(a_to.item.w_llist).item.qf_curlist := l_qi.item.qf_curlist
			end
		end

	ex_cbuffer (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_qf_title: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_qi.make
			create l_tmp___4.make
			create l_qf_title.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_qi := ql_info
					if a_eap.item.cmdidx /= 202 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_eap.item.cmdidx /= 214 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_eap.item.cmdidx /= 199 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_qi := ll_get_or_alloc_list (globals_inst.curwin)
						if l_qi.is_void then
							js.return
						end
				when 8 then -- if done | if done
						if not js.return_called then
							if ((a_eap.item.arg).item).to_integer_32 = 0 then
								l_buf___6 := globals_inst.curbuf
							elseif ((charset_inst.skipwhite ((charset_inst.skipdigits (a_eap.item.arg)))).item).to_integer_32 = 0 then
								l_buf___6 := buffer_inst.buflist_findnr ((atoi (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))))
							end
							if l_buf___6.is_void then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
							elseif (l_buf___6.item.b_ml.ml_mfp).is_void then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E681: Buffer is not loaded"))))).do_nothing
							else
								if a_eap.item.addr_count = 0 then
									a_eap.item.line1 := (1).to_integer_32
									a_eap.item.line2 := l_buf___6.item.b_ml.ml_line_count
								end
								if a_eap.item.line1 < 1 then
									l_tmp___4 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
								elseif a_eap.item.line1 > l_buf___6.item.b_ml.ml_line_count then
									l_tmp___4 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
								elseif a_eap.item.line2 < 1 then
									l_tmp___4 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
								elseif a_eap.item.line2 > l_buf___6.item.b_ml.ml_line_count then
									l_tmp___4 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
								else
									l_qf_title := (a_eap.item.cmdlinep).item
									if (not (l_buf___6.item.b_sfname).is_void) then
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%s (%%s)"), create {CE_POINTER [INTEGER_8]}.make_cast (l_qf_title), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6.item.b_sfname)]).do_nothing
										l_qf_title := globals_inst.IObuff
									end
									if a_eap.item.cmdidx /= 47 then
										if a_eap.item.cmdidx /= 199 then
											l_tmp___5 := 1
										else
											l_tmp___5 := 0
										end
									else
										l_tmp___5 := 0
									end
									if (qf_init_ext (l_qi, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buf___6, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer), option_inst.p_efm.item, l_tmp___5, a_eap.item.line1, a_eap.item.line2, l_qf_title)) > 0 then
										if a_eap.item.cmdidx = 52 then
											qf_jump (l_qi, 0, 0, a_eap.item.forceit)
										elseif a_eap.item.cmdidx = 202 then
											qf_jump (l_qi, 0, 0, a_eap.item.forceit)
										end
									end
								end
							end
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_cbuffer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cbuffer)
		end

	ex_cc (a_eap: CE_POINTER [PD_EXARG])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					if a_eap.item.cmdidx /= 219 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if a_eap.item.cmdidx /= 237 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if a_eap.item.cmdidx /= 212 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if a_eap.item.cmdidx /= 220 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_loclist))))).do_nothing
							js.return
						end
				when 11 then -- if done | if done | if done
						if not js.return_called then
							if a_eap.item.addr_count > 0 then
								l_tmp___4 := (a_eap.item.line2).to_integer_32
							else
								if a_eap.item.cmdidx = 53 then
									l_tmp___3 := 0
								elseif a_eap.item.cmdidx = 219 then
									l_tmp___3 := 0
								else
									if a_eap.item.cmdidx = 91 then
										l_tmp___2 := 1
									elseif a_eap.item.cmdidx = 237 then
										l_tmp___2 := 1
									elseif a_eap.item.cmdidx = 59 then
										l_tmp___2 := 1
									elseif a_eap.item.cmdidx = 212 then
										l_tmp___2 := 1
									else
										l_tmp___2 := 32_767
									end
									l_tmp___3 := l_tmp___2
								end
								l_tmp___4 := l_tmp___3
							end
							qf_jump (l_qi, 0, l_tmp___4, a_eap.item.forceit)
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_cc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cc)
		end

	ex_cclose (a_eap: CE_POINTER [PD_EXARG])
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_qi: CE_POINTER [PD_QF_INFO_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_win.make
			create l_qi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_win := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
					l_qi := ql_info
					if a_eap.item.cmdidx /= 205 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_eap.item.cmdidx /= 245 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							l_win := qf_find_win (l_qi)
							if not l_win.is_void then
								window_inst.win_close (l_win, 0)
							end
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_cclose_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cclose)
		end

	ex_cexpr (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tv: CE_POINTER [PD_TYPVAL_T]
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tv.make
			create l_qi.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					if a_eap.item.cmdidx /= 210 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_eap.item.cmdidx /= 215 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_eap.item.cmdidx /= 198 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_qi := ll_get_or_alloc_list (globals_inst.curwin)
						if l_qi.is_void then
							js.return
						end
				when 8 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 9 then -- if:
							l_tv := eval_inst.eval_expr (a_eap.item.arg, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
							if l_tv.is_void then
								l_pos := -1 + 21 -- skip if block
							end
				when 10 then -- if:
							if (l_tv.item.v_type).to_integer_32 /= 2 then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if not (l_tv.item.vval.v_string).is_void then
								l_pos := -1 + 15 -- goto _L___0
							else
								l_pos := -1 + 13 -- goto _L___1
							end
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 13 then -- else: | _L___1:
							if (l_tv.item.v_type).to_integer_32 /= 4 then
								l_pos := -1 + 19 -- skip if block
							end
				when 14 then -- if:
							if (l_tv.item.vval.v_list).is_void then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if: | _L___0:
							if a_eap.item.cmdidx /= 48 then
								if a_eap.item.cmdidx /= 198 then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
							if (qf_init_ext (l_qi, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_tv, option_inst.p_efm.item, l_tmp, (0).to_integer_32, (0).to_integer_32, (a_eap.item.cmdlinep).item)) > 0 then
								if a_eap.item.cmdidx = 57 then
									qf_jump (l_qi, 0, 0, a_eap.item.forceit)
								elseif a_eap.item.cmdidx = 210 then
									qf_jump (l_qi, 0, 0, a_eap.item.forceit)
								end
							end
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 18
				when 17 then -- else:
							l_tmp___1 := gettext (ce_string ("E777: String or List expected"))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
				when 18 then -- if done | if block done, skip else block:
							l_pos := -1 + 20
				when 19 then -- else:
							l_tmp___1 := gettext (ce_string ("E777: String or List expected"))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
				when 20 then -- if done
							eval_inst.free_tv (l_tv)
				when 21 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_cexpr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cexpr)
		end

	ex_cfile (a_eap: CE_POINTER [PD_EXARG])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_browse_file: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_qi.make
			create l_browse_file.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_wp___0 := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
					l_qi := ql_info
					if a_eap.item.cmdidx = 211 then
						l_wp___0 := globals_inst.curwin
					elseif a_eap.item.cmdidx = 213 then
						l_wp___0 := globals_inst.curwin
					elseif a_eap.item.cmdidx = 200 then
						l_wp___0 := globals_inst.curwin
					end
					if (globals_inst.cmdmod.item.browse).to_boolean then
						l_browse_file := (message_inst.do_browse (0, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Error file")))), a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("All Files (*)%T*%N")), create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)))
						if l_browse_file.is_void then
							js.return
						end
						if not js.return_called then
							option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ef")), -1, l_browse_file, 1, 0)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_browse_file))
						end
					elseif ((a_eap.item.arg).item).to_integer_32 /= 0 then
						option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ef")), -1, a_eap.item.arg, 1, 0)
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if a_eap.item.cmdidx /= 49 then
							if a_eap.item.cmdidx /= 200 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						if not ((qf_init (l_wp___0, option_inst.p_ef.item, option_inst.p_efm.item, l_tmp___3, (a_eap.item.cmdlinep).item)) > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if a_eap.item.cmdidx /= 58 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if a_eap.item.cmdidx /= 211 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if not l_wp___0.is_void then
							if (bt_quickfix (l_wp___0.item.w_buffer)).to_boolean then
								if not (l_wp___0.item.w_llist_ref).is_void then
									l_qi := l_wp___0.item.w_llist_ref
								else
									l_qi := l_wp___0.item.w_llist
								end
							else
								l_qi := l_wp___0.item.w_llist
							end
						end
						qf_jump (l_qi, 0, 0, a_eap.item.forceit)
				when 7 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_cfile_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cfile)
		end

	ex_cnext (a_eap: CE_POINTER [PD_EXARG])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					if a_eap.item.cmdidx /= 226 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 3 then -- else:
						if a_eap.item.cmdidx /= 194 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 6 then -- else:
						if a_eap.item.cmdidx /= 235 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if a_eap.item.cmdidx /= 228 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						if a_eap.item.cmdidx /= 195 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if a_eap.item.cmdidx /= 236 then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_loclist))))).do_nothing
							js.return
						end
				when 17 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							if a_eap.item.addr_count > 0 then
								l_tmp___2 := (a_eap.item.line2).to_integer_32
							else
								l_tmp___2 := 1
							end
							if a_eap.item.cmdidx = 73 then
								l_tmp___5 := 1
							elseif a_eap.item.cmdidx = 226 then
								l_tmp___5 := 1
							else
								if a_eap.item.cmdidx = 75 then
									l_tmp___4 := 3
								elseif a_eap.item.cmdidx = 228 then
									l_tmp___4 := 3
								else
									if a_eap.item.cmdidx = 89 then
										l_tmp___3 := -3
									elseif a_eap.item.cmdidx = 236 then
										l_tmp___3 := -3
									elseif a_eap.item.cmdidx = 44 then
										l_tmp___3 := -3
									elseif a_eap.item.cmdidx = 195 then
										l_tmp___3 := -3
									else
										l_tmp___3 := -1
									end
									l_tmp___4 := l_tmp___3
								end
								l_tmp___5 := l_tmp___4
							end
							qf_jump (l_qi, l_tmp___5, l_tmp___2, a_eap.item.forceit)
						end
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_cnext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cnext)
		end

	ex_copen (a_eap: CE_POINTER [PD_EXARG])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_height: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_prevtab: CE_POINTER [PD_TABPAGE_S]
			l_qf_buf: CE_POINTER [PD_FILE_BUFFER]
			l_oldwin: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qi.make
			create l_win.make
			create l_prevtab.make
			create l_qf_buf.make
			create l_oldwin.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					l_prevtab := globals_inst.curtab
					l_oldwin := globals_inst.curwin
					if a_eap.item.cmdidx /= 234 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_eap.item.cmdidx /= 245 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_loclist))))).do_nothing
							js.return
						end
				when 5 then -- if done
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
							if a_eap.item.addr_count /= 0 then
								l_height := (a_eap.item.line2).to_integer_32
							else
								l_height := 10
							end
							normal_inst.reset_VIsual_and_resel
							globals_inst.need_mouse_correct := 1
							l_win := qf_find_win (l_qi)
							if l_win.is_void then
								l_pos := -1 + 9 -- skip if block
							end
				when 7 then -- if:
							if globals_inst.cmdmod.item.tab = 0 then
								window_inst.win_goto (l_win)
							else
								l_pos := -1 + 9 -- goto _L___0
							end
				when 8 then -- if block done, skip else block:
							l_pos := -1 + 10
				when 9 then -- else: | _L___0:
							l_qf_buf := qf_find_buf (l_qi)
							l_win := globals_inst.curwin
							if a_eap.item.cmdidx = 87 then
								window_inst.win_goto (globals_inst.lastwin)
							elseif a_eap.item.cmdidx = 97 then
								window_inst.win_goto (globals_inst.lastwin)
							end
							if (window_inst.win_split (l_height, 160)) = 0 then
								js.return
							end
							if not js.return_called then
								globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
								if a_eap.item.cmdidx = 234 then
									globals_inst.curwin.item.w_llist_ref := l_win.item.w_llist;
									(l_win.item.w_llist).item.qf_refcount := ((l_win.item.w_llist).item.qf_refcount) + 1
								elseif a_eap.item.cmdidx = 245 then
									globals_inst.curwin.item.w_llist_ref := l_win.item.w_llist;
									(l_win.item.w_llist).item.qf_refcount := ((l_win.item.w_llist).item.qf_refcount) + 1
								end
								if not l_oldwin.is_equal (globals_inst.curwin) then
									l_oldwin := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
								end
								if not l_qf_buf.is_void then
									ex_cmds_inst.do_ecmd (l_qf_buf.item.b_fnum, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, l_oldwin).do_nothing
								else
									ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 1, l_oldwin).do_nothing
									option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("swf")), 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 4)
									option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bt")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("quickfix")), 4)
									option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bh")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("wipe")), 4)
									globals_inst.curwin.item.w_onebuf_opt.wo_diff := 0
									option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fdm")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("manual")), 4)
								end
								if globals_inst.curtab.is_equal (l_prevtab) then
									if (globals_inst.curwin.item.w_width).to_integer_32 = globals_inst.Columns.item then
										window_inst.win_setheight (l_height)
									end
								end
								globals_inst.curwin.item.w_onebuf_opt.wo_wfh := 1
								if (window_inst.win_valid (l_win)).to_boolean then
									globals_inst.prevwin := l_win
								end
							end
				when 10 then -- if done
							if not js.return_called then
								qf_fill_buffer (l_qi)
								if not (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_title).is_void then
									eval_inst.set_internal_string_var (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("w:quickfix_title")), l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_title)
								end
								globals_inst.curwin.item.w_cursor.lnum := (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index).to_integer_32
								globals_inst.curwin.item.w_cursor.col := 0
								misc2_inst.check_cursor
								move_inst.update_topline
							end
				when 11 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_copen_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_copen)
		end

	ex_cwindow (a_eap: CE_POINTER [PD_EXARG])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_win: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qi.make
			create l_win.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					if a_eap.item.cmdidx = 245 then
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_win := qf_find_win (l_qi)
						if not ((l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_qi.item.qf_curlist >= l_qi.item.qf_listcount) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if not l_win.is_void then
							ex_cclose (a_eap)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if l_win.is_void then
							ex_copen (a_eap)
						end
				when 8 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_cwindow_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cwindow)
		end

	ex_helpgrep (a_eap: CE_POINTER [PD_EXARG])
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_save_cpo: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fcount: CE_ARRAY [INTEGER_32]
			l_fnames: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_fi: INTEGER_32
			l_prevp: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_lnum: INTEGER_32
			l_lang: CE_POINTER [NATURAL_8]
			l_qi: CE_ARRAY [CE_POINTER [PD_QF_INFO_S]]
			l_new_qi: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_regmatch___0.make (<<1>>)
			create l_save_cpo.make
			create l_p___0.make (<<1>>)
			create l_fcount.make (<<1>>)
			create l_fnames.make (<<1>>)
			create l_fd.make
			create l_prevp.make (<<1>>)
			create l_lang.make
			create l_qi.make (<<1>>)
			create l_wp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prevp.item := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_qi.item := ql_info
					l_new_qi := 0
					l_save_cpo := option_inst.p_cpo.item
					option_inst.p_cpo.item := globals_inst.empty_option
					l_lang := ex_cmds_inst.check_help_lang (a_eap.item.arg)
					if a_eap.item.cmdidx = 218 then
						l_wp___0 := globals_inst.firstwin
						from
						until
							not (not js.loop_done and then (not l_wp___0.is_void))
						loop
							if not (l_wp___0.item.w_buffer).is_void then
								if ((l_wp___0.item.w_buffer).item.b_help).to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								l_wp___0 := l_wp___0.item.w_next
							end
						end
						if l_wp___0.is_void then
							l_qi.item := create {CE_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer)
						else
							l_qi.item := l_wp___0.item.w_llist
						end
						if (l_qi.item).is_void then
							l_qi.item := ll_new_list
							if (l_qi.item).is_void then
								js.return
							end
							if not js.return_called then
								l_new_qi := 1
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_regmatch___0.item.regprog := regexp_inst.vim_regcomp (a_eap.item.arg, 3)
						l_regmatch___0.item.rm_ic := 0
						if not (l_regmatch___0.item.regprog).is_void then
							qf_new_list (l_qi.item, (a_eap.item.cmdlinep).item)
							l_p___0.item := option_inst.p_rtp.item
							from
							until
								js.loop_done
							loop
								if (l_p___0.item.item).to_integer_32 /= 0 then
									if globals_inst.got_int.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									misc2_inst.copy_option_part (l_p___0, globals_inst.NameBuff.item, 4_096, ce_string (",")).do_nothing
									misc1_inst.add_pathsep (globals_inst.NameBuff.item)
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item), ce_string ("doc/*.\(txt\|??x\)")).do_nothing
									if (misc1_inst.gen_expand_wildcards (1, globals_inst.NameBuff, l_fcount, l_fnames, 34)) = 1 then
										if l_fcount.item > 0 then
											l_fi := 0
											from
											until
												js.loop_done
											loop
												if l_fi < l_fcount.item then
													if globals_inst.got_int.to_boolean then
														js.break
													end
												else
													js.break
												end
												if not js.loop_jumped and then (not l_lang.is_void) then
													if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang), create {CE_POINTER [INTEGER_8]}.make_cast (((l_fnames.item[l_fi] + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames.item[l_fi]))).to_integer_32) - 3)), (2).to_natural_32)) /= 0 then
														if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang), ce_string ("en"), (2).to_natural_32)) = 0 then
															if (strncasecmp (ce_string ("txt"), create {CE_POINTER [INTEGER_8]}.make_cast (((l_fnames.item[l_fi] + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames.item[l_fi]))).to_integer_32) - 3)), (3).to_natural_32)) /= 0 then
																js.continue
															end
														else
															js.continue
														end
													end
												end
												if not js.loop_jumped then
													l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames.item[l_fi]), ce_string ("r"))
													if not l_fd.is_void then
														l_lnum := 1
														from
														until
															js.loop_done
														loop
															if (fileio_inst.vim_fgets (globals_inst.IObuff, 1_025, l_fd)).to_boolean then
																js.break
															elseif globals_inst.got_int.to_boolean then
																js.break
															end
															if not js.loop_jumped then
																if (regexp_inst.vim_regexec (l_regmatch___0, globals_inst.IObuff, 0)).to_boolean then
																	l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32
																	from
																	until
																		js.loop_done
																	loop
																		if l_l > 0 then
																			if not ((globals_inst.IObuff[(l_l - 1)]).to_integer_32 <= 32) then
																				js.break
																			end
																		else
																			js.break
																		end
																		if not js.loop_jumped then
																			l_l := l_l - 1
																			globals_inst.IObuff[l_l] := (('%/0/').code).to_natural_8
																		end
																	end
																	if (qf_add_entry (l_qi.item, l_prevp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_fnames.item[l_fi], 0, globals_inst.IObuff, l_lnum, ((l_regmatch___0.item.startp[0]).distance (globals_inst.IObuff)) + 1, 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1, 1)) = 0 then
																		globals_inst.got_int := 1
																		js.break
																	end
																end
															end
															if not js.loop_jumped then
																l_lnum := l_lnum + 1
																misc1_inst.line_breakcheck
															end
														end
														fclose (l_fd).do_nothing
													end
												end
												if js.loop_increment then
													l_fi := l_fi + 1
												end
											end
											misc1_inst.FreeWild (l_fcount.item, l_fnames.item)
										end
									end
								end
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.item.regprog))
							l_qi.item.item.qf_lists[l_qi.item.item.qf_curlist].qf_nonevalid := 0
							l_qi.item.item.qf_lists[l_qi.item.item.qf_curlist].qf_ptr := l_qi.item.item.qf_lists[l_qi.item.item.qf_curlist].qf_start
							l_qi.item.item.qf_lists[l_qi.item.item.qf_curlist].qf_index := 1
						end
						if (option_inst.p_cpo.item).is_equal (globals_inst.empty_option) then
							option_inst.p_cpo.item := l_save_cpo
						else
							option_inst.free_string_option (l_save_cpo)
						end
						qf_update_buffer (l_qi.item)
						if l_qi.item.item.qf_lists[l_qi.item.item.qf_curlist].qf_count > 0 then
							qf_jump (l_qi.item, 0, 0, 0)
						else
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch2)))), a_eap.item.arg).do_nothing
						end
						if a_eap.item.cmdidx /= 218 then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if ((globals_inst.curwin.item.w_buffer).item.b_help).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not ((globals_inst.curwin.item.w_llist).is_equal (l_qi.item)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if l_new_qi.to_boolean then
							ll_free_all (l_qi)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						if (globals_inst.curwin.item.w_llist).is_void then
							globals_inst.curwin.item.w_llist := l_qi.item
						end
				when 9 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_helpgrep_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_helpgrep)
		end

	ex_make (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_res: INTEGER_32
			l_au_name: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_cmd.make
			create l_wp___0.make
			create l_qi.make
			create l_au_name.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_wp___0 := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
					l_qi := ql_info
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					inspect a_eap.item.cmdidx -- switch 1 head
					when 249 then l_pos := -1 + 1
					when 224 then l_pos := -1 + 2
					when 157 then l_pos := -1 + 3
					when 216 then l_pos := -1 + 4
					when 158 then l_pos := -1 + 5
					when 217 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 249
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("make"))
					l_pos := -1 + 8 -- switch 1; break
				when 2 then -- switch 1, case 224
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lmake"))
					l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 157
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("grep"))
					l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 216
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgrep"))
					l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 158
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("grepadd"))
					l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 217
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgrepadd"))
					l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
					l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
					if not l_au_name.is_void then
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPRE, l_au_name, globals_inst.curbuf.item.b_fname, 1, globals_inst.curbuf).do_nothing
						if globals_inst.did_throw.to_boolean then
							js.return
						elseif globals_inst.force_abort.to_boolean then
							js.return
						end
					end
					if not js.return_called then
						if (grep_internal (a_eap.item.cmdidx)).to_boolean then
							ex_vimgrep (a_eap)
							js.return
						end
					end
					if not js.return_called then
						if a_eap.item.cmdidx = 224 then
							l_wp___0 := globals_inst.curwin
						elseif a_eap.item.cmdidx = 216 then
							l_wp___0 := globals_inst.curwin
						elseif a_eap.item.cmdidx = 217 then
							l_wp___0 := globals_inst.curwin
						end
						ex_cmds2_inst.autowrite_all
						l_fname := get_mef_name
						if l_fname.is_void then
							js.return
						end
					end
					if not js.return_called then
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)).do_nothing
						l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shq.item))
						l_len := (l_tmp___0 * {NATURAL_32} 2 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg)))) + {NATURAL_32} 1
						if (option_inst.p_sp.item.item).to_integer_32 /= 0 then
							l_tmp___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sp.item))
							l_len := l_len + ((l_tmp___2 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)))) + {NATURAL_32} 3)
						end
						l_cmd := misc2_inst.alloc (l_len)
						if l_cmd.is_void then
							js.return
						end
					end
					if not js.return_called then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), ce_string ("%%s%%s%%s"), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shq.item), create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shq.item)]).do_nothing
						if (option_inst.p_sp.item.item).to_integer_32 /= 0 then
							ex_cmds_inst.append_redir (l_cmd, l_len.to_integer_32, option_inst.p_sp.item, l_fname)
						end
						if globals_inst.msg_col = 0 then
							globals_inst.msg_didout := 0
						end
						message_inst.msg_start
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":!")))
						message_inst.msg_outtrans (l_cmd).do_nothing
						if (option_inst.p_sp.item.item).to_integer_32 /= 0 then
							l_tmp___4 := 8
						else
							l_tmp___4 := 0
						end
						ex_cmds_inst.do_shell (l_cmd, l_tmp___4)
						if a_eap.item.cmdidx /= 158 then
							if a_eap.item.cmdidx /= 217 then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
						else
							l_tmp___5 := 0
						end
						if a_eap.item.cmdidx /= 249 then
							if a_eap.item.cmdidx /= 224 then
								l_tmp___6 := option_inst.p_gefm.item
							else
								l_tmp___6 := option_inst.p_efm.item
							end
						else
							l_tmp___6 := option_inst.p_efm.item
						end
						l_res := qf_init (l_wp___0, l_fname, l_tmp___6, l_tmp___5, (a_eap.item.cmdlinep).item)
						if not l_au_name.is_void then
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPOST, l_au_name, globals_inst.curbuf.item.b_fname, 1, globals_inst.curbuf).do_nothing
						end
						if l_res > 0 then
							if not (a_eap.item.forceit).to_boolean then
								if not l_wp___0.is_void then
									if (bt_quickfix (l_wp___0.item.w_buffer)).to_boolean then
										if not (l_wp___0.item.w_llist_ref).is_void then
											l_qi := l_wp___0.item.w_llist_ref
										else
											l_qi := l_wp___0.item.w_llist
										end
									else
										l_qi := l_wp___0.item.w_llist
									end
								end
								qf_jump (l_qi, 0, 0, 0)
							end
						end
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd))
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_make_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_make)
		end

	ex_vimgrep (a_eap: CE_POINTER [PD_EXARG])
		local
			l_regmatch___0: CE_ARRAY [PD_REGMMATCH_T]
			l_fcount: CE_ARRAY [INTEGER_32]
			l_fnames: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_fname: CE_POINTER [NATURAL_8]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_fi: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_prevp: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_lnum: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_duplicate_name: INTEGER_32
			l_using_dummy: INTEGER_32
			l_redraw_for_dummy: INTEGER_32
			l_found_match: INTEGER_32
			l_first_match_buf: CE_POINTER [PD_FILE_BUFFER]
			l_seconds: INTEGER_32
			l_save_mls: INTEGER_32
			l_save_ei: CE_POINTER [NATURAL_8]
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
			l_flags___0: CE_ARRAY [INTEGER_32]
			l_col: INTEGER_32
			l_tomatch: INTEGER_32
			l_dirname_start: CE_ARRAY [NATURAL_8]
			l_dirname_now: CE_ARRAY [NATURAL_8]
			l_target_dir: CE_POINTER [NATURAL_8]
			l_au_name: CE_POINTER [NATURAL_8]
			l_ea: CE_ARRAY [PD_EXARG]
			l_ea___0: CE_ARRAY [PD_EXARG]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_regmatch___0.make (<<1>>)
			create l_fcount.make (<<1>>)
			create l_fnames.make (<<1>>)
			create l_fname.make
			create l_s.make (<<1>>)
			create l_p___0.make
			create l_qi.make
			create l_prevp.make (<<1>>)
			create l_buf___6.make
			create l_first_match_buf.make
			create l_save_ei.make
			create l_aco.make (<<1>>)
			create l_flags___0.make (<<1>>)
			create l_dirname_start.make (<<4_096>>)
			create l_dirname_now.make (<<4_096>>)
			create l_target_dir.make
			create l_au_name.make
			create l_ea.make (<<1>>)
			create l_ea___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					l_prevp.item := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_duplicate_name := 0
					l_redraw_for_dummy := 0
					l_first_match_buf := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_seconds := (0).to_integer_32
					l_save_ei := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_flags___0.item := 0
					l_target_dir := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					inspect a_eap.item.cmdidx -- switch 1 head
					when 467 then l_pos := -1 + 1
					when 243 then l_pos := -1 + 2
					when 468 then l_pos := -1 + 3
					when 244 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 467
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vimgrep"))
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 243
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lvimgrep"))
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 468
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vimgrepadd"))
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 244
					l_au_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lvimgrepadd"))
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					if not l_au_name.is_void then
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPRE, l_au_name, globals_inst.curbuf.item.b_fname, 1, globals_inst.curbuf).do_nothing
						if globals_inst.did_throw.to_boolean then
							js.return
						elseif globals_inst.force_abort.to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:
						if a_eap.item.cmdidx /= 216 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if a_eap.item.cmdidx /= 243 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if a_eap.item.cmdidx /= 217 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if a_eap.item.cmdidx /= 244 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						l_qi := ll_get_or_alloc_list (globals_inst.curwin)
						if l_qi.is_void then
							js.return
						end
				when 18 then -- if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 61 -- skip if block
						end
				when 19 then -- if:
							if a_eap.item.addr_count > 0 then
								l_tomatch := a_eap.item.line2
							else
								l_tomatch := 2_147_483_647
							end
							l_regmatch___0.item.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
							l_p___0 := skip_vimgrep_pat (a_eap.item.arg, l_s, l_flags___0)
							if l_p___0.is_void then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invalpat))))).do_nothing
								l_pos := -1 + 60 -- goto theend
							end
				when 20 then
							l_regmatch___0.item.regprog := regexp_inst.vim_regcomp (l_s.item, 1)
							if (l_regmatch___0.item.regprog).is_void then
								l_pos := -1 + 60 -- goto theend
							end
				when 21 then
							l_regmatch___0.item.rmm_ic := option_inst.p_ic.item
							l_regmatch___0.item.rmm_maxcol := 0
							l_p___0 := charset_inst.skipwhite (l_p___0)
							if (l_p___0.item).to_integer_32 = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E683: File name missing or invalid pattern"))))).do_nothing
								l_pos := -1 + 60 -- goto theend
							end
				when 22 then
							if a_eap.item.cmdidx = 158 then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							if a_eap.item.cmdidx /= 217 then
								if a_eap.item.cmdidx /= 468 then
									if a_eap.item.cmdidx /= 244 then
										qf_new_list (l_qi, (a_eap.item.cmdlinep).item)
									else
										l_pos := -1 + 25 -- goto _L___2
									end
								else
									l_pos := -1 + 25 -- goto _L___2
								end
							else
								l_pos := -1 + 25 -- goto _L___2
							end
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 25 then -- else: | _L___2:
							if l_qi.item.qf_curlist = l_qi.item.qf_listcount then
								qf_new_list (l_qi, (a_eap.item.cmdlinep).item)
							elseif l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count > 0 then
								l_prevp.item := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
								from
								until
									(l_prevp.item.item.qf_next).is_equal (l_prevp.item)
								loop
									l_prevp.item := l_prevp.item.item.qf_next
								end
							end
				when 26 then
							if (ex_cmds2_inst.get_arglist_exp (l_p___0, l_fcount, l_fnames)) = 0 then
								l_pos := -1 + 60 -- goto theend
							end
				when 27 then
							if l_fcount.item = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch))))).do_nothing
								l_pos := -1 + 60 -- goto theend
							end
				when 28 then
							os_unix_inst.mch_dirname (l_dirname_start, 4_096).do_nothing
							l_seconds := (0).to_integer_32
							l_fi := 0
				when 29 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 59 -- skip loop
							end
				when 30 then -- loop body:
							if l_fi < l_fcount.item then
								if not globals_inst.got_int.to_boolean then
									if not (l_tomatch > 0) then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 58 -- skip if block
							end
				when 31 then -- if:
							l_fname := fileio_inst.shorten_fname1 (l_fnames.item[l_fi])
							if (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) > l_seconds then
								l_seconds := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								message_inst.msg_start
								l_p___0 := message_inst.msg_strtrunc (l_fname, 1)
								if l_p___0.is_void then
									message_inst.msg_outtrans (l_fname).do_nothing
								else
									message_inst.msg_outtrans (l_p___0).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
								message_inst.msg_clr_eos
								globals_inst.msg_didout := 0
								globals_inst.msg_nowait := 1
								globals_inst.msg_col := 0
								term_inst.out_flush
							end
							l_buf___6 := buffer_inst.buflist_findname_exp (l_fnames.item[l_fi])
							if not (l_buf___6.is_void) then
								l_pos := -1 + 34 -- skip if block
							end
				when 32 then -- if:
							l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 38
				when 34 then -- else:
							if not ((l_buf___6.item.b_ml.ml_mfp).is_void) then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if: | _L___3:
							l_duplicate_name := (not l_buf___6.is_void).to_integer
							l_using_dummy := 1
							l_redraw_for_dummy := 1
							l_save_ei := fileio_inst.au_event_disable (ce_string (",Filetype"))
							l_save_mls := (option_inst.p_mls.item).to_integer_32
							option_inst.p_mls.item := 0
							l_buf___6 := load_dummy_buffer (l_fname)
							os_unix_inst.mch_dirname (l_dirname_now, 4_096).do_nothing
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirname_start), create {CE_POINTER [INTEGER_8]}.make_cast (l_dirname_now))) /= 0 then
								l_ea.item.arg := l_dirname_start
								l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_lcd
								ex_docmd_inst.ex_cd (l_ea)
							end
							option_inst.p_mls.item := l_save_mls.to_integer_32
							fileio_inst.au_event_restore (l_save_ei)
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 38
				when 37 then -- else:
							l_using_dummy := 0
				when 38 then -- if done
							if not (l_buf___6.is_void) then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if:
							if not globals_inst.got_int.to_boolean then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Cannot open file %"%%s%"")))), l_fname]).do_nothing
							end
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 57
				when 41 then -- else:
							l_found_match := 0
							l_lnum := 1
							from
							until
								js.loop_done
							loop
								if l_lnum <= l_buf___6.item.b_ml.ml_line_count then
									if not (l_tomatch > 0) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_col := 0
									from
									until
										js.loop_done
									loop
										if not ((regexp_inst.vim_regexec_multi (l_regmatch___0, globals_inst.curwin, l_buf___6, l_lnum, l_col, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))) > 0) then
											js.break
										end
										if not js.loop_jumped then
											if (qf_add_entry (l_qi, l_prevp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_fname, 0, (memline_inst.ml_get_buf (l_buf___6, l_regmatch___0.item.startpos[0].lnum + l_lnum, 0)), l_regmatch___0.item.startpos[0].lnum + l_lnum, l_regmatch___0.item.startpos[0].col + 1, 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 0, 1)) = 0 then
												globals_inst.got_int := 1
												js.break
											end
										end
										if not js.loop_jumped then
											l_found_match := 1
											l_tomatch := l_tomatch - 1
											if l_tomatch = 0 then
												js.break
											end
										end
										if not js.loop_jumped then
											if ((l_flags___0.item).bit_and (1)) = 0 then
												js.break
											elseif l_regmatch___0.item.endpos[0].lnum > 0 then
												js.break
											end
										end
										if not js.loop_jumped then
											l_col := l_regmatch___0.item.endpos[0].col + (l_col = l_regmatch___0.item.endpos[0].col).to_integer
											if l_col > (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_buf (l_buf___6, l_lnum, 0))))).to_integer_32 then
												js.break
											end
										end
									end
									misc1_inst.line_breakcheck
									if globals_inst.got_int.to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									l_lnum := l_lnum + 1
								end
							end
							if not (l_using_dummy.to_boolean) then
								l_pos := -1 + 57 -- skip if block
							end
				when 42 then -- if:
							if l_found_match.to_boolean then
								if l_first_match_buf.is_void then
									l_first_match_buf := l_buf___6
								end
							end
							if not (l_duplicate_name.to_boolean) then
								l_pos := -1 + 45 -- skip if block
							end
				when 43 then -- if:
							wipe_dummy_buffer (l_buf___6)
							l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
				when 44 then -- if block done, skip else block:
							l_pos := -1 + 56
				when 45 then -- else:
							if (globals_inst.cmdmod.item.hide).to_boolean then
								l_pos := -1 + 48 -- skip if block
							end
				when 46 then -- if:
							l_pos := -1 + 55 -- goto _L___4
				when 47 then -- if block done, skip else block:
							l_pos := -1 + 56
				when 48 then -- else:
							if (l_buf___6.item.b_p_bh[0]).to_integer_32 /= 117 then
								l_pos := -1 + 51 -- skip if block
							end
				when 49 then -- if:
							l_pos := -1 + 55 -- goto _L___4
				when 50 then -- if block done, skip else block:
							l_pos := -1 + 56
				when 51 then -- else:
							if (l_buf___6.item.b_p_bh[0]).to_integer_32 /= 119 then
								l_pos := -1 + 54 -- skip if block
							end
				when 52 then -- if:
							l_pos := -1 + 55 -- goto _L___4
				when 53 then -- if block done, skip else block:
							l_pos := -1 + 56
				when 54 then -- else:
							if (l_buf___6.item.b_p_bh[0]).to_integer_32 /= 100 then
								l_pos := -1 + 56 -- skip if block
							end
				when 55 then -- if: | _L___4:
							if not l_found_match.to_boolean then
								wipe_dummy_buffer (l_buf___6)
								l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
							elseif not l_buf___6.is_equal (l_first_match_buf) then
								unload_dummy_buffer (l_buf___6)
								l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
							elseif ((l_flags___0.item).bit_and (2)).to_boolean then
								unload_dummy_buffer (l_buf___6)
								l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
							end
				when 56 then -- if done | if done | if done | if done
							if not l_buf___6.is_void then
								if l_buf___6.is_equal (l_first_match_buf) then
									if l_target_dir.is_void then
										if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirname_start), create {CE_POINTER [INTEGER_8]}.make_cast (l_dirname_now))) /= 0 then
											l_target_dir := misc2_inst.vim_strsave (l_dirname_now)
										end
									end
								end
								fileio_inst.aucmd_prepbuf (l_aco, l_buf___6)
								fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_FILETYPE, l_buf___6.item.b_p_ft, l_buf___6.item.b_fname, 1, l_buf___6).do_nothing
								buffer_inst.do_modelines (32)
								fileio_inst.aucmd_restbuf (l_aco)
							end
				when 57 then -- if done | if done
							l_fi := l_fi + 1
				when 58 then -- if done
							l_pos := -1 + 29 -- back to loop condition
				when 59 then -- loop done
							misc1_inst.FreeWild (l_fcount.item, l_fnames.item)
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid := 0
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := 1
							qf_update_buffer (l_qi)
							if not l_au_name.is_void then
								fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPOST, l_au_name, globals_inst.curbuf.item.b_fname, 1, globals_inst.curbuf).do_nothing
							end
							if l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count > 0 then
								if ((l_flags___0.item).bit_and (2)) = 0 then
									l_buf___6 := globals_inst.curbuf
									qf_jump (l_qi, 0, 0, a_eap.item.forceit)
									if not l_buf___6.is_equal (globals_inst.curbuf) then
										l_redraw_for_dummy := 0
									end
									if globals_inst.curbuf.is_equal (l_first_match_buf) then
										if not l_target_dir.is_void then
											l_ea___0.item.arg := l_target_dir
											l_ea___0.item.cmdidx := {PC_CMD_INDEX}.CMD_lcd
											ex_docmd_inst.ex_cd (l_ea___0)
										end
									end
								end
							else
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch2)))), l_s.item).do_nothing
							end
							if l_redraw_for_dummy.to_boolean then
								fold_inst.foldUpdateAll (globals_inst.curwin)
							end
				when 60 then -- theend:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_target_dir))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.item.regprog))
				when 61 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_vimgrep_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_vimgrep)
		end

	get_errorlist (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_list: CE_POINTER [PD_LISTVAR_S]): INTEGER_32
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_i___0: INTEGER_32
			l_bufnum: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_qi.make
			create l_dict.make
			create l_buf___6.make (<<2>>)
			create l_qfp.make
			create l_tmp___8.make
			create l_tmp___10.make

			l_qi := ql_info
			if not a_wp___0.is_void then
				if (bt_quickfix (a_wp___0.item.w_buffer)).to_boolean then
					if not (a_wp___0.item.w_llist_ref).is_void then
						l_qi := a_wp___0.item.w_llist_ref
					else
						l_qi := a_wp___0.item.w_llist
					end
				else
					l_qi := a_wp___0.item.w_llist
				end
				if l_qi.is_void then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_qi.item.qf_curlist >= l_qi.item.qf_listcount then
					Result := 0
					js.return
				elseif l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_qfp := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
				l_i___0 := 1
				from
				until
					js.loop_done
				loop
					if not globals_inst.got_int.to_boolean then
						if not (l_i___0 <= l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_bufnum := l_qfp.item.qf_fnum
						if l_bufnum /= 0 then
							if (buffer_inst.buflist_findnr (l_bufnum)).is_void then
								l_bufnum := 0
							end
						end
						l_dict := eval_inst.dict_alloc
						if l_dict.is_void then
							Result := 0
							js.return
						end
						if not js.return_called then
							if (eval_inst.list_append_dict (a_list, l_dict)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_buf___6[0] := l_qfp.item.qf_type
							l_buf___6[1] := (('%/0/').code).to_natural_8
							if (eval_inst.dict_add_nr_str (l_dict, ce_string ("bufnr"), l_bufnum.to_integer_32, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
								Result := 0
								js.return
							elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("lnum"), l_qfp.item.qf_lnum, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
								Result := 0
								js.return
							elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("col"), (l_qfp.item.qf_col).to_integer_32, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
								Result := 0
								js.return
							elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("vcol"), (l_qfp.item.qf_viscol).to_integer_32, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
								Result := 0
								js.return
							elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("nr"), (l_qfp.item.qf_nr).to_integer_32, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
								Result := 0
								js.return
							else
								if (l_qfp.item.qf_pattern).is_void then
									l_tmp___8 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
								else
									l_tmp___8 := l_qfp.item.qf_pattern
								end
								if (eval_inst.dict_add_nr_str (l_dict, ce_string ("pattern"), 0, l_tmp___8)) = 0 then
									Result := 0
									js.return
								else
									if (l_qfp.item.qf_text).is_void then
										l_tmp___10 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
									else
										l_tmp___10 := l_qfp.item.qf_text
									end
									if (eval_inst.dict_add_nr_str (l_dict, ce_string ("text"), 0, l_tmp___10)) = 0 then
										Result := 0
										js.return
									elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("type"), 0, l_buf___6)) = 0 then
										Result := 0
										js.return
									elseif (eval_inst.dict_add_nr_str (l_dict, ce_string ("valid"), (l_qfp.item.qf_valid).to_integer_32, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
										Result := 0
										js.return
									end
								end
							end
						end
						if not js.return_called then
							l_qfp := l_qfp.item.qf_next
							l_i___0 := l_i___0 + 1
						end
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	get_mef_name: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_sb: CE_ARRAY [SD_STAT]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_name___1.make
			create l_sb.make (<<1>>)

			if (option_inst.p_mef.item.item).to_integer_32 = 0 then
				l_name___1 := fileio_inst.vim_tempname (('e').code)
				if l_name___1.is_void then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notmp))))).do_nothing
				end
				Result := l_name___1
				js.return
			end
			if not js.return_called then
				l_p___0 := option_inst.p_mef.item
				from
				until
					not (not js.loop_done and then ((l_p___0.item).to_boolean))
				loop
					if (l_p___0[0]).to_integer_32 = 35 then
						if (l_p___0[1]).to_integer_32 = 35 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
				if (l_p___0.item).to_integer_32 = 0 then
					Result := (misc2_inst.vim_strsave (option_inst.p_mef.item))
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if start___0 = -1 then
						start___0 := (os_unix_inst.mch_get_pid).to_integer_32
					else
						off := off + (19)
					end
					l_name___1 := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_mef.item))) + {NATURAL_32} 30)
					if l_name___1.is_void then
						js.break
					end
					if not js.loop_jumped then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_mef.item)).do_nothing
						sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1) + (l_p___0.distance ((option_inst.p_mef.item)))), ce_string ("%%d%%d"), start___0, off]).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 2))).do_nothing
						if (os_unix_inst.mch_getperm (l_name___1)) < 0 then
							if (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), l_sb)) < 0 then
								js.break
							end
						end
					end
					if not js.loop_jumped then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
					end
				end
				Result := l_name___1
			end
		end

	grep_internal (a_cmdidx: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_cmdidx /= 157 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_cmdidx /= 216 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_cmdidx /= 158 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_cmdidx /= 217 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if ((globals_inst.curbuf.item.b_p_gp).item).to_integer_32 = 0 then
							l_tmp := option_inst.p_gp.item
						else
							l_tmp := globals_inst.curbuf.item.b_p_gp
						end
						if (strcmp (ce_string ("internal"), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp))) = 0 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_tmp___1 := 0
				when 13 then -- if done | if done | if done
						Result := l_tmp___1
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	is_qf_win (a_win: CE_POINTER [PD_WINDOW_S]; a_qi: CE_POINTER [PD_QF_INFO_S]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((bt_quickfix (a_win.item.w_buffer)).to_boolean) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (a_qi.is_equal (ql_info)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_win.item.w_llist_ref).is_void then
							Result := 1
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not a_qi.is_equal (ql_info) then
							if (a_win.item.w_llist_ref).is_equal (a_qi) then
								Result := 1
								js.return
							end
						end
				when 5 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ll_free_all (a_pqi: CE_POINTER [CE_POINTER [PD_QF_INFO_S]])
		local
			l_i___0: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			js: JUMP_STATE
		do
			create l_qi.make

			l_qi := a_pqi.item
			if l_qi.is_void then
				js.return
			end
			if not js.return_called then
				a_pqi.item := create {CE_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer)
				l_qi.item.qf_refcount := (l_qi.item.qf_refcount) - 1
				if l_qi.item.qf_refcount < 1 then
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_qi.item.qf_listcount)
					loop
						qf_free (l_qi, l_i___0)
						l_i___0 := l_i___0 + 1
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_qi))
				end
			end
		end

	ll_get_or_alloc_list (a_wp___0: CE_POINTER [PD_WINDOW_S]): CE_POINTER [PD_QF_INFO_S]
		local
			js: JUMP_STATE
		do
			if (bt_quickfix (a_wp___0.item.w_buffer)).to_boolean then
				if not (a_wp___0.item.w_llist_ref).is_void then
					Result := (a_wp___0.item.w_llist_ref)
					js.return
				end
			end
			if not js.return_called then
				ll_free_all (create {CE_POINTER [CE_POINTER [PD_QF_INFO_S]]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_llist_ref")))
				if (a_wp___0.item.w_llist).is_void then
					a_wp___0.item.w_llist := ll_new_list
				end
				Result := (a_wp___0.item.w_llist)
			end
		end

	ll_new_list: CE_POINTER [PD_QF_INFO_S]
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
		do
			create l_qi.make

			l_qi := create {CE_POINTER [PD_QF_INFO_S]}.make_cast ((misc2_inst.alloc ((create {PD_QF_INFO_S}.make).structure_size.to_natural_32)))
			if not l_qi.is_void then
				memset (create {CE_POINTER [ANY]}.make_cast (l_qi), 0, (create {PD_QF_INFO_S}.make).structure_size.to_natural_32).do_nothing
				l_qi.item.qf_refcount := (l_qi.item.qf_refcount) + 1
			end
			Result := l_qi
		end

	load_dummy_buffer (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FILE_BUFFER]
		local
			l_newbuf: CE_POINTER [PD_FILE_BUFFER]
			l_failed: INTEGER_32
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
			js: JUMP_STATE
		do
			create l_newbuf.make
			create l_aco.make (<<1>>)

			l_failed := 1
			l_newbuf := buffer_inst.buflist_new (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (1).to_integer_32, 4)
			if l_newbuf.is_void then
				Result := (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				option_inst.buf_copy_options (l_newbuf, 5)
				if (memline_inst.ml_open (l_newbuf)) = 1 then
					fileio_inst.aucmd_prepbuf (l_aco, l_newbuf)
					buffer_inst.setfname (globals_inst.curbuf, a_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0).do_nothing
					memline_inst.check_need_swap (1)
					globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_and ((-129))
					if (fileio_inst.readfile (a_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (0).to_integer_32, (0).to_integer_32, 2_147_483_647, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), 17)) = 1 then
						if not globals_inst.got_int.to_boolean then
							if not ((globals_inst.curbuf.item.b_flags).bit_and (16)).to_boolean then
								l_failed := 0
								if not globals_inst.curbuf.is_equal (l_newbuf) then
									if (buffer_inst.buf_valid (l_newbuf)).to_boolean then
										buffer_inst.wipe_buffer (l_newbuf, 0)
									end
									l_newbuf := globals_inst.curbuf
								end
							end
						end
					end
					fileio_inst.aucmd_restbuf (l_aco)
				end
				if not (buffer_inst.buf_valid (l_newbuf)).to_boolean then
					Result := (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called and then (l_failed.to_boolean) then
				wipe_dummy_buffer (l_newbuf)
				Result := (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := l_newbuf
			end
		end

	qf_add_entry (a_qi: CE_POINTER [PD_QF_INFO_S]; a_prevp: CE_POINTER [CE_POINTER [PD_QFLINE_S]]; a_dir___0: CE_POINTER [NATURAL_8]; a_fname: CE_POINTER [NATURAL_8]; a_bufnum: INTEGER_32; a_mesg: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32; a_col: INTEGER_32; a_vis_col: INTEGER_32; a_pattern: CE_POINTER [NATURAL_8]; a_nr: INTEGER_32; a_type: INTEGER_32; a_valid: INTEGER_32): INTEGER_32
		local
			l_type: INTEGER_32
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_qfp.make
			create l_tmp___0.make
			create l_tmp___1.make

			l_type := a_type
			l_qfp := create {CE_POINTER [PD_QFLINE_S]}.make_cast ((misc2_inst.alloc ((create {PD_QFLINE_S}.make).structure_size.to_natural_32)))
			if l_qfp.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_bufnum /= 0 then
					l_qfp.item.qf_fnum := a_bufnum
				else
					l_qfp.item.qf_fnum := qf_get_fnum (a_dir___0, a_fname)
				end
				l_tmp___0 := misc2_inst.vim_strsave (a_mesg)
				l_qfp.item.qf_text := l_tmp___0
				if l_tmp___0.is_void then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_qfp))
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_qfp.item.qf_lnum := a_lnum
				l_qfp.item.qf_col := a_col
				l_qfp.item.qf_viscol := a_vis_col.to_natural_8
				if a_pattern.is_void then
					l_qfp.item.qf_pattern := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				elseif (a_pattern.item).to_integer_32 = 0 then
					l_qfp.item.qf_pattern := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				else
					l_tmp___1 := misc2_inst.vim_strsave (a_pattern)
					l_qfp.item.qf_pattern := l_tmp___1
					if l_tmp___1.is_void then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_qfp.item.qf_text))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_qfp))
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				l_qfp.item.qf_nr := a_nr
				if l_type /= 1 then
					if not (charset_inst.vim_isprintc (l_type)).to_boolean then
						l_type := 0
					end
				end
				l_qfp.item.qf_type := l_type.to_natural_8
				l_qfp.item.qf_valid := a_valid.to_natural_8
				if a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count = 0 then
					a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start := l_qfp
					l_qfp.item.qf_prev := l_qfp
				else
					l_qfp.item.qf_prev := a_prevp.item;
					(a_prevp.item).item.qf_next := l_qfp
				end
				l_qfp.item.qf_next := l_qfp
				l_qfp.item.qf_cleared := (0).to_natural_8
				a_prevp.item := l_qfp
				a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count := (a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count) + 1
				if a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index = 0 then
					if (l_qfp.item.qf_valid).to_boolean then
						a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count
						a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr := l_qfp
					end
				end
				Result := 1
			end
		end

	qf_age (a_eap: CE_POINTER [PD_EXARG])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_count___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					if a_eap.item.cmdidx /= 233 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_eap.item.cmdidx /= 227 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_loclist))))).do_nothing
							js.return
						end
				when 5 then -- if done
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 6 then -- if:
							if a_eap.item.addr_count /= 0 then
								l_count___2 := (a_eap.item.line2).to_integer_32
							else
								l_count___2 := 1
							end
				when 7 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 17 -- skip loop
							end
				when 8 then -- loop body:
							l_tmp___4 := l_count___2
							l_count___2 := l_count___2 - 1
							if not l_tmp___4.to_boolean then
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 16 -- skip if block
							end
				when 9 then -- if:
							if a_eap.item.cmdidx /= 80 then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 12 then -- else:
							if a_eap.item.cmdidx /= 233 then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if: | _L___0:
							if l_qi.item.qf_curlist = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E380: At bottom of quickfix stack"))))).do_nothing
								js.return
							end
							if not js.return_called then
								l_qi.item.qf_curlist := (l_qi.item.qf_curlist) - 1
							end
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 15 then -- else:
							if l_qi.item.qf_curlist >= l_qi.item.qf_listcount - 1 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E381: At top of quickfix stack"))))).do_nothing
								js.return
							end
							if not js.return_called then
								l_qi.item.qf_curlist := (l_qi.item.qf_curlist) + 1
							end
				when 16 then -- if done | if done
							l_pos := -1 + 7 -- back to loop condition
				when 17 then -- loop done | if done
							if not js.return_called then
								qf_msg (l_qi)
							end
				when 18 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	qf_age_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent qf_age)
		end

	qf_clean_dir_stack (a_stackptr: CE_POINTER [CE_POINTER [PD_DIR_STACK_T]])
		local
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			js: JUMP_STATE
		do
			create l_ds_ptr.make

			from
			until
				js.loop_done
			loop
				l_ds_ptr := a_stackptr.item
				if l_ds_ptr.is_void then
					js.break
				end
				if not js.loop_jumped then
					a_stackptr.item := (a_stackptr.item).item.next
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr.item.dirname))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr))
				end
			end
		end

	qf_current_entry (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
		do
			create l_qi.make

			l_qi := ql_info
			if (bt_quickfix (a_wp___0.item.w_buffer)).to_boolean then
				if not (a_wp___0.item.w_llist_ref).is_void then
					l_qi := a_wp___0.item.w_llist_ref
				end
			end
			Result := (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index).to_integer_32
		end

	qf_fill_buffer (a_qi: CE_POINTER [PD_QF_INFO_S])
		local
			l_lnum: INTEGER_32
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_errbuf___0: CE_POINTER [PD_FILE_BUFFER]
			l_len: INTEGER_32
			l_old_KeyTyped: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_qfp.make
			create l_errbuf___0.make
			create l_tmp___10.make

			l_old_KeyTyped := globals_inst.KeyTyped
			from
			until
				((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)) /= 0
			loop
				memline_inst.ml_delete ((1).to_integer_32, 0).do_nothing
			end
			if a_qi.item.qf_curlist < a_qi.item.qf_listcount then
				l_qfp := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
				l_lnum := (0).to_integer_32
				from
				until
					not (not js.loop_done and then (l_lnum < (a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count).to_integer_32))
				loop
					if l_qfp.item.qf_fnum /= 0 then
						l_errbuf___0 := buffer_inst.buflist_findnr (l_qfp.item.qf_fnum)
						if not l_errbuf___0.is_void then
							if not (l_errbuf___0.item.b_fname).is_void then
								if (l_qfp.item.qf_type).to_integer_32 = 1 then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (l_errbuf___0.item.b_fname)))).do_nothing
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_errbuf___0.item.b_fname)).do_nothing
								end
								l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32
							else
								l_len := 0
							end
						else
							l_len := 0
						end
					else
						l_len := 0
					end
					l_tmp___1 := l_len
					l_len := l_len + 1
					globals_inst.IObuff[l_tmp___1] := (('|').code).to_natural_8
					if l_qfp.item.qf_lnum > 0 then
						sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_len), ce_string ("%%ld"), l_qfp.item.qf_lnum]).do_nothing
						l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
						if l_qfp.item.qf_col > 0 then
							sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_len), ce_string (" col %%d"), l_qfp.item.qf_col]).do_nothing
							l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
						end
						sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_len), ce_string ("%%s"), create {CE_POINTER [INTEGER_8]}.make_cast ((qf_types ((l_qfp.item.qf_type).to_integer_32, l_qfp.item.qf_nr)))]).do_nothing
						l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
					elseif not (l_qfp.item.qf_pattern).is_void then
						qf_fmt_text (l_qfp.item.qf_pattern, globals_inst.IObuff + l_len, 1_025 - l_len)
						l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
					end
					l_tmp___7 := l_len
					l_len := l_len + 1
					globals_inst.IObuff[l_tmp___7] := (('|').code).to_natural_8
					l_tmp___8 := l_len
					l_len := l_len + 1
					globals_inst.IObuff[l_tmp___8] := ((' ').code).to_natural_8
					if l_len > 3 then
						l_tmp___10 := (charset_inst.skipwhite (l_qfp.item.qf_text))
					else
						l_tmp___10 := l_qfp.item.qf_text
					end
					qf_fmt_text (l_tmp___10, globals_inst.IObuff + l_len, 1_025 - l_len)
					if (memline_inst.ml_append (l_lnum, globals_inst.IObuff, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32 + 1, 0)) = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_qfp := l_qfp.item.qf_next
						l_lnum := l_lnum + 1
					end
				end
				memline_inst.ml_delete (l_lnum + 1, 0).do_nothing
			end
			window_inst.check_lnums (1)
			option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ft")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("qf")), 4)
			globals_inst.curbuf.item.b_p_ma := 0
			globals_inst.keep_filetype := 1
			fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("quickfix")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("quickfix")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			globals_inst.keep_filetype := 0
			screen_inst.redraw_curbuf_later (40)
			globals_inst.KeyTyped := l_old_KeyTyped
		end

	qf_find_buf (a_qi: CE_POINTER [PD_QF_INFO_S]): CE_POINTER [PD_FILE_BUFFER]
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_win: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_tp.make
			create l_win.make

			l_tp := globals_inst.first_tabpage
			from
			until
				not (not js.loop_done and then (not l_tp.is_void))
			loop
				if l_tp.is_equal (globals_inst.curtab) then
					l_win := globals_inst.firstwin
				else
					l_win := l_tp.item.tp_firstwin
				end
				from
				until
					not (not js.loop_done and then (not l_win.is_void))
				loop
					if (is_qf_win (l_win, a_qi)).to_boolean then
						Result := (l_win.item.w_buffer)
						js.return
					end
					if not js.return_called then
						l_win := l_win.item.w_next
					end
				end
				if not js.return_called then
					l_tp := l_tp.item.tp_next
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
			end
		end

	qf_find_win (a_qi: CE_POINTER [PD_QF_INFO_S]): CE_POINTER [PD_WINDOW_S]
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_win.make

			l_win := globals_inst.firstwin
			from
			until
				not (not js.loop_done and then (not l_win.is_void))
			loop
				if (is_qf_win (l_win, a_qi)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_win := l_win.item.w_next
				end
			end
			Result := l_win
		end

	qf_fmt_text (a_text: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [NATURAL_8]; a_bufsize: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_p___0 := a_text
			l_i___0 := 0
			from
			until
				js.loop_done
			loop
				if (l_p___0.item).to_integer_32 /= 0 then
					if not (l_i___0 < a_bufsize - 1) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_p___0.item).to_integer_32 = 10 then
						a_buf___6[l_i___0] := ((' ').code).to_natural_8
						from
						until
							js.loop_done
						loop
							l_p___0 := l_p___0 + 1
							if (l_p___0.item).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped and then ((l_p___0.item).to_integer_32 /= 32) then
								if (l_p___0.item).to_integer_32 /= 9 then
									if (l_p___0.item).to_integer_32 /= 10 then
										js.break
									end
								end
							end
						end
					else
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						a_buf___6[l_i___0] := l_tmp.item
					end
					l_i___0 := l_i___0 + 1
				end
			end
			a_buf___6[l_i___0] := (('%/0/').code).to_natural_8
		end

	qf_free (a_qi: CE_POINTER [PD_QF_INFO_S]; a_idx: INTEGER_32)
		local
			l_qfp: CE_POINTER [PD_QFLINE_S]
		do
			create l_qfp.make

			from
			until
				not ((a_qi.item.qf_lists[a_idx].qf_count).to_boolean)
			loop
				l_qfp := (a_qi.item.qf_lists[a_idx].qf_start).item.qf_next
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((a_qi.item.qf_lists[a_idx].qf_start).item.qf_text))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((a_qi.item.qf_lists[a_idx].qf_start).item.qf_pattern))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_qi.item.qf_lists[a_idx].qf_start))
				a_qi.item.qf_lists[a_idx].qf_start := l_qfp
				a_qi.item.qf_lists[a_idx].qf_count := (a_qi.item.qf_lists[a_idx].qf_count) - 1
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_qi.item.qf_lists[a_idx].qf_title))
		end

	qf_free_all (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_i___0: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
		do
			create l_qi.make

			l_qi := ql_info
			if not a_wp___0.is_void then
				ll_free_all (create {CE_POINTER [CE_POINTER [PD_QF_INFO_S]]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_llist")))
				ll_free_all (create {CE_POINTER [CE_POINTER [PD_QF_INFO_S]]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_llist_ref")))
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_qi.item.qf_listcount)
				loop
					qf_free (l_qi, l_i___0)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	qf_get_fnum (a_directory: CE_POINTER [NATURAL_8]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_directory: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_fnum___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_directory.make
			create l_ptr.make

			l_directory := a_directory
			if a_fname.is_void then
				Result := 0
				js.return
			elseif (a_fname.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (not l_directory.is_void) then
				if not (window_inst.vim_isAbsName (a_fname)).to_boolean then
					l_ptr := misc1_inst.concat_fnames (l_directory, a_fname, 1)
					if not l_ptr.is_void then
						if (os_unix_inst.mch_getperm (l_ptr)) < 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ptr))
							l_directory := qf_guess_filepath (a_fname)
							if (not l_directory.is_void) then
								l_ptr := misc1_inst.concat_fnames (l_directory, a_fname, 1)
							else
								l_ptr := misc2_inst.vim_strsave (a_fname)
							end
						end
						l_fnum___0 := buffer_inst.buflist_add (l_ptr, 0)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ptr))
						Result := l_fnum___0
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (buffer_inst.buflist_add (a_fname, 0))
			end
		end

	qf_guess_filepath (a_filename: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			l_ds_tmp: CE_POINTER [PD_DIR_STACK_T]
			l_fullname: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_ds_ptr.make
			create l_ds_tmp.make
			create l_fullname.make
			create l_tmp___0.make

			if (dir_stack.item).is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_ds_ptr := dir_stack.item.item.next
				l_fullname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				from
				until
					not (not js.loop_done and then (not l_ds_ptr.is_void))
				loop
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fullname))
					l_fullname := misc1_inst.concat_fnames (l_ds_ptr.item.dirname, a_filename, 1)
					if not l_fullname.is_void then
						if (os_unix_inst.mch_getperm (l_fullname)) >= 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_ds_ptr := l_ds_ptr.item.next
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fullname))
				from
				until
					(dir_stack.item.item.next).is_equal (l_ds_ptr)
				loop
					l_ds_tmp := dir_stack.item.item.next
					dir_stack.item.item.next := (dir_stack.item.item.next).item.next
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_tmp.item.dirname))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_tmp))
				end
				if l_ds_ptr.is_void then
					l_tmp___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				else
					l_tmp___0 := l_ds_ptr.item.dirname
				end
				Result := l_tmp___0
			end
		end

	qf_init (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_efile: CE_POINTER [NATURAL_8]; a_errorformat: CE_POINTER [NATURAL_8]; a_newlist: INTEGER_32; a_qf_title: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			js: JUMP_STATE
		do
			create l_qi.make

			l_qi := ql_info
			if a_efile.is_void then
				Result := 0
				js.return
			end
			if not js.return_called and then (not a_wp___0.is_void) then
				l_qi := ll_get_or_alloc_list (a_wp___0)
				if l_qi.is_void then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (qf_init_ext (l_qi, a_efile, globals_inst.curbuf, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer), a_errorformat, a_newlist, (0).to_integer_32, (0).to_integer_32, a_qf_title))
			end
		end

	qf_init_ext (a_qi: CE_POINTER [PD_QF_INFO_S]; a_efile: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_tv: CE_POINTER [PD_TYPVAL_T]; a_errorformat: CE_POINTER [NATURAL_8]; a_newlist: INTEGER_32; a_lnumfirst: INTEGER_32; a_lnumlast: INTEGER_32; a_qf_title: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_namebuf: CE_POINTER [NATURAL_8]
			l_errmsg: CE_POINTER [NATURAL_8]
			l_pattern: CE_POINTER [NATURAL_8]
			l_fmtstr: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_use_viscol: NATURAL_8
			l_type: INTEGER_32
			l_valid: INTEGER_32
			l_buflnum: INTEGER_32
			l_lnum: INTEGER_32
			l_enr: INTEGER_32
			l_fd: CE_POINTER [SD_IO_FILE]
			l_qfprev: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_efmp: CE_POINTER [NATURAL_8]
			l_fmt_first: CE_POINTER [PD_EFM_S]
			l_fmt_last: CE_POINTER [PD_EFM_S]
			l_fmt_ptr: CE_POINTER [PD_EFM_S]
			l_fmt_start: CE_POINTER [PD_EFM_S]
			l_efm: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_srcptr: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_round: INTEGER_32
			l_idx: INTEGER_32
			l_multiline: INTEGER_32
			l_multiignore: INTEGER_32
			l_multiscan: INTEGER_32
			l_retval: INTEGER_32
			l_directory: CE_POINTER [NATURAL_8]
			l_currfile: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_p_str: CE_POINTER [NATURAL_8]
			l_p_li: CE_POINTER [PD_LISTITEM_S]
			l_file_stack: CE_ARRAY [CE_POINTER [PD_DIR_STACK_T]]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: NATURAL_8
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: NATURAL_8
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___20: CE_POINTER [NATURAL_8]
			l_tmp___21: NATURAL_8
			l_tmp___22: CE_POINTER [NATURAL_8]
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___25: CE_POINTER [NATURAL_8]
			l_tmp___26: CE_POINTER [NATURAL_8]
			l_tmp___27: CE_POINTER [NATURAL_8]
			l_tmp___33: CE_POINTER [NATURAL_8]
			l_tmp___35: CE_POINTER [NATURAL_8]
			l_tmp___36: CE_POINTER [NATURAL_8]
			l_tmp___37: CE_POINTER [PD_REGPROG_T]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___41: INTEGER_32
			l_c: INTEGER_32
			l_tmp___56: CE_POINTER [NATURAL_8]
			l_tmp___57: CE_POINTER [NATURAL_8]
			l_tmp___59: NATURAL_32
			l_tmp___65: CE_POINTER [NATURAL_8]
			l_tmp___66: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_namebuf.make
			create l_errmsg.make
			create l_pattern.make
			create l_fmtstr.make
			create l_fd.make
			create l_qfprev.make (<<1>>)
			create l_efmp.make
			create l_fmt_first.make
			create l_fmt_last.make
			create l_fmt_ptr.make
			create l_fmt_start.make
			create l_efm.make
			create l_ptr.make
			create l_srcptr.make
			create l_directory.make
			create l_currfile.make
			create l_tail.make
			create l_p_str.make
			create l_p_li.make
			create l_file_stack.make (<<1>>)
			create l_regmatch___0.make (<<1>>)
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___16.make
			create l_tmp___19.make
			create l_tmp___20.make
			create l_tmp___22.make
			create l_tmp___23.make
			create l_tmp___25.make
			create l_tmp___26.make
			create l_tmp___27.make
			create l_tmp___33.make
			create l_tmp___35.make
			create l_tmp___36.make
			create l_tmp___37.make
			create l_p___0.make
			create l_tmp___56.make
			create l_tmp___57.make
			create l_tmp___65.make
			create l_tmp___66.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fmtstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_col := 0
					l_use_viscol := (0).to_natural_8
					l_type := 0
					l_buflnum := a_lnumfirst
					l_lnum := 0
					l_enr := 0
					l_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_qfprev.item := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_fmt_first := create {CE_POINTER [PD_EFM_S]}.make_shared (default_pointer)
					l_fmt_last := create {CE_POINTER [PD_EFM_S]}.make_shared (default_pointer)
					l_fmt_start := create {CE_POINTER [PD_EFM_S]}.make_shared (default_pointer)
					l_idx := 0
					l_multiline := 0
					l_multiignore := 0
					l_multiscan := 0
					l_retval := -1
					l_directory := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_currfile := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_tail := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_p_str := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_p_li := create {CE_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)
					l_file_stack.item := create {CE_POINTER [PD_DIR_STACK_T]}.make_shared (default_pointer)
					l_namebuf := misc2_inst.alloc ({NATURAL_32} 1_025)
					l_errmsg := misc2_inst.alloc ({NATURAL_32} 1_025)
					l_pattern := misc2_inst.alloc ({NATURAL_32} 1_025)
					if l_namebuf.is_void then
						l_pos := -1 + 110 -- goto qf_init_end
					elseif l_errmsg.is_void then
						l_pos := -1 + 110 -- goto qf_init_end
					elseif l_pattern.is_void then
						l_pos := -1 + 110 -- goto qf_init_end
					end
				when 1 then
					if not a_efile.is_void then
						l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_efile), ce_string ("r"))
						if l_fd.is_void then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_openerrf)))), a_efile).do_nothing
							l_pos := -1 + 110 -- goto qf_init_end
						end
					end
				when 2 then
					if a_newlist.to_boolean then
						qf_new_list (a_qi, a_qf_title)
					elseif a_qi.item.qf_curlist = a_qi.item.qf_listcount then
						qf_new_list (a_qi, a_qf_title)
					elseif a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count > 0 then
						l_qfprev.item := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
						from
						until
							(l_qfprev.item.item.qf_next).is_equal (l_qfprev.item)
						loop
							l_qfprev.item := l_qfprev.item.item.qf_next
						end
					end
					if a_errorformat.is_equal (option_inst.p_efm.item) then
						if a_tv.is_void then
							if ((a_buf___6.item.b_p_efm).item).to_integer_32 /= 0 then
								l_efm := a_buf___6.item.b_p_efm
							else
								l_efm := a_errorformat
							end
						else
							l_efm := a_errorformat
						end
					else
						l_efm := a_errorformat
					end
					l_i___0 := 30 + (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_efm))).to_integer_32).bit_shift_left (2))
					l_round := 10
					from
					until
						not (l_round > 0)
					loop
						l_round := l_round - 1
						l_i___0 := l_i___0 + (strlen (fmt_pat[l_round].pattern)).to_integer_32
					end
					l_i___0 := l_i___0 + (2)
					l_fmtstr := misc2_inst.alloc (l_i___0.to_natural_32)
					if l_fmtstr.is_void then
						l_pos := -1 + 108 -- goto error2
					end
				when 3 then
					if not (not js.loop_done and then ((l_efm[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 40 -- skip loop
					end
				when 4 then -- loop body:
						l_fmt_ptr := create {CE_POINTER [PD_EFM_S]}.make_cast ((misc2_inst.alloc_clear ((create {PD_EFM_S}.make).structure_size.to_natural_32)))
						if l_fmt_ptr.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 5 then
						if l_fmt_first.is_void then
							l_fmt_first := l_fmt_ptr
						else
							l_fmt_last.item.next := l_fmt_ptr
						end
						l_fmt_last := l_fmt_ptr
						l_len := 0
						from
						until
							js.loop_done
						loop
							if (l_efm[l_len]).to_integer_32 /= 0 then
								if (l_efm[l_len]).to_integer_32 = 44 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_efm[l_len]).to_integer_32 = 92 then
									if (l_efm[(l_len + 1)]).to_integer_32 /= 0 then
										l_len := l_len + 1
									end
								end
								l_len := l_len + 1
							end
						end
						l_ptr := l_fmtstr
						l_tmp___3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___3.item := (('^').code).to_natural_8
						l_round := 0
						l_efmp := l_efm
				when 6 then -- loop condition:
						if not (not js.loop_done and then ((l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 38 -- skip loop
						end
				when 7 then -- loop body:
						if (l_efmp.item).to_integer_32 /= 37 then
							l_pos := -1 + 32 -- skip if block
						end
				when 8 then -- if:
						l_efmp := l_efmp + 1
						l_idx := 0
						from
						until
							not (not js.loop_done and then (l_idx < 10))
						loop
							if (fmt_pat[l_idx].convchar).to_integer_32 = (l_efmp.item).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								l_idx := l_idx + 1
							end
						end
						if not (l_idx < 10) then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if (l_fmt_ptr.item.addr[l_idx]).to_boolean then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), (gettext (ce_string ("E372: Too many %%%%%%c in format string"))), (l_efmp.item).to_integer_32]).do_nothing
							message_inst.emsg (l_errmsg).do_nothing
							l_pos := -1 + 108 -- goto error2
						end
				when 10 then
						if not (l_idx.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_idx < 6 then
							if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("DXOPQ")), (l_fmt_ptr.item.prefix2).to_integer_32)).is_void then
								l_tmp___5 := gettext (ce_string ("E373: Unexpected %%%%%%c in format string"))
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), l_tmp___5, (l_efmp.item).to_integer_32]).do_nothing
								message_inst.emsg (l_errmsg).do_nothing
								l_pos := -1 + 108 -- goto error2
							else
								l_pos := -1 + 13 -- goto _L___0
							end
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						if l_idx = 6 then
							if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPQ")), (l_fmt_ptr.item.prefix2).to_integer_32)).is_void then
								l_tmp___5 := gettext (ce_string ("E373: Unexpected %%%%%%c in format string"))
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), l_tmp___5, (l_efmp.item).to_integer_32]).do_nothing
								message_inst.emsg (l_errmsg).do_nothing
								l_pos := -1 + 108 -- goto error2
							end
						end
				when 14 then
						l_round := l_round + 1
						l_fmt_ptr.item.addr[l_idx] := l_round.to_natural_8
						l_tmp___8 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___8.item := (('\').code).to_natural_8
						l_tmp___9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___9.item := (('(').code).to_natural_8
						if (l_efmp.item).to_integer_32 /= 102 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_efmp[1]).to_integer_32 /= 0 then
							if (l_efmp[1]).to_integer_32 /= 92 then
								if (l_efmp[1]).to_integer_32 /= 37 then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string (".\{-1,}")).do_nothing
									l_ptr := l_ptr + (7)
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("\f\+")).do_nothing
									l_ptr := l_ptr + (4)
								end
							else
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("\f\+")).do_nothing
								l_ptr := l_ptr + (4)
							end
						else
							l_pos := -1 + 17 -- goto _L___1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___1:
						l_srcptr := create {CE_POINTER [NATURAL_8]}.make_cast (fmt_pat[l_idx].pattern)
						from
						until
							js.loop_done
						loop
							l_tmp___11 := l_srcptr
							l_srcptr := l_srcptr + 1
							l_tmp___10 := l_tmp___11.item
							l_ptr.item := l_tmp___10
							if l_tmp___10.to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_ptr := l_ptr + 1
							end
						end
				when 18 then
						l_tmp___12 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___12.item := (('\').code).to_natural_8
						l_tmp___13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___13.item := ((')').code).to_natural_8
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 20 then -- else:
						if (l_efmp.item).to_integer_32 /= 42 then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						l_efmp := l_efmp + 1
						if (l_efmp.item).to_integer_32 /= 91 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 24 then -- else:
						if (l_efmp.item).to_integer_32 /= 92 then
							l_pos := -1 + 28 -- skip if block
						end
				when 25 then -- if: | _L___2:
						l_tmp___20 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___21 := l_efmp.item
						l_tmp___20.item := l_tmp___21
						if l_tmp___21.to_integer_32 = 91 then
							if (l_efmp[1]).to_integer_32 = 94 then
								l_tmp___14 := l_ptr
								l_ptr := l_ptr + 1
								l_efmp := l_efmp + 1
								l_tmp___14.item := l_efmp.item
							end
							if (l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___15 := l_ptr
								l_ptr := l_ptr + 1
								l_efmp := l_efmp + 1
								l_tmp___15.item := l_efmp.item
								from
								until
									js.loop_done
								loop
									if (l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
										l_tmp___16 := l_ptr
										l_ptr := l_ptr + 1
										l_efmp := l_efmp + 1
										l_tmp___17 := l_efmp.item
										l_tmp___16.item := l_tmp___17
										if l_tmp___17.to_integer_32 = 93 then
											js.break
										end
									else
										js.break
									end
								end
								if l_efmp.is_equal (l_efm + l_len) then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E374: Missing ] in format string"))))).do_nothing
									l_pos := -1 + 108 -- goto error2
								end
							end
						elseif (l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___19 := l_ptr
							l_ptr := l_ptr + 1
							l_efmp := l_efmp + 1
							l_tmp___19.item := l_efmp.item
						end
				when 26 then
						l_tmp___22 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___22.item := (('\').code).to_natural_8
						l_tmp___23 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___23.item := (('+').code).to_natural_8
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), (gettext (ce_string ("E375: Unsupported %%%%%%c in format string"))), (l_efmp.item).to_integer_32]).do_nothing
						message_inst.emsg (l_errmsg).do_nothing
						l_pos := -1 + 108 -- goto error2
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%\.^$~[")), (l_efmp.item).to_integer_32)).is_void then
							l_tmp___25 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___25.item := l_efmp.item
						elseif (l_efmp.item).to_integer_32 = 35 then
							l_tmp___26 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___26.item := (('*').code).to_natural_8
						elseif (l_efmp.item).to_integer_32 = 62 then
							l_fmt_ptr.item.conthere := 1
						elseif l_efmp.is_equal (l_efm + 1) then
							if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("+-")), (l_efmp.item).to_integer_32)).is_void then
								l_tmp___27 := l_efmp
								l_efmp := l_efmp + 1
								l_fmt_ptr.item.flags := l_tmp___27.item
							end
							if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("DXAEWICZGOPQ")), (l_efmp.item).to_integer_32)).is_void then
								l_fmt_ptr.item.prefix2 := l_efmp.item
							else
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), (gettext (ce_string ("E376: Invalid %%%%%%c in format string prefix"))), (l_efmp.item).to_integer_32]).do_nothing
								message_inst.emsg (l_errmsg).do_nothing
								l_pos := -1 + 108 -- goto error2
							end
						else
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), (gettext (ce_string ("E377: Invalid %%%%%%c in format string"))), (l_efmp.item).to_integer_32]).do_nothing
							message_inst.emsg (l_errmsg).do_nothing
							l_pos := -1 + 108 -- goto error2
						end
				when 31 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 37
				when 32 then -- else:
						if (l_efmp.item).to_integer_32 /= 92 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if ((l_efmp + 1).c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
							l_efmp := l_efmp + 1
						else
							l_pos := -1 + 35 -- goto _L___3
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | _L___3:
						if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".*^$~[")), (l_efmp.item).to_integer_32)).is_void then
							l_tmp___33 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___33.item := (('\').code).to_natural_8
						end
				when 36 then
						if (l_efmp.item).to_boolean then
							l_tmp___35 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___35.item := l_efmp.item
						end
				when 37 then
						l_efmp := l_efmp + 1
						l_pos := -1 + 6 -- back to loop condition
				when 38 then -- loop done
						l_tmp___36 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___36.item := (('$').code).to_natural_8
						l_ptr.item := (('%/0/').code).to_natural_8
						l_tmp___37 := regexp_inst.vim_regcomp (l_fmtstr, 3)
						l_fmt_ptr.item.prog := l_tmp___37
						if l_tmp___37.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 39 then
						l_efm := misc1_inst.skip_to_option_part (l_efm + l_len)
						l_pos := -1 + 3 -- back to loop condition
				when 40 then -- loop done
					if l_fmt_first.is_void then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E378: %'errorformat%' contains no pattern"))))).do_nothing
						l_pos := -1 + 108 -- goto error2
					end
				when 41 then
					globals_inst.got_int := 0
					l_regmatch___0.item.rm_ic := 1
					if not a_tv.is_void then
						if (a_tv.item.v_type).to_integer_32 = 2 then
							l_p_str := a_tv.item.vval.v_string
						elseif (a_tv.item.v_type).to_integer_32 = 4 then
							l_p_li := (a_tv.item.vval.v_list).item.lv_first
						end
					end
				when 42 then -- loop condition:
					if not (not js.loop_done and then (not globals_inst.got_int.to_boolean)) then
						l_pos := -1 + 102 -- skip loop
					end
				when 43 then -- loop body:
						if l_fd.is_void then
							if not a_tv.is_void then
								if (a_tv.item.v_type).to_integer_32 = 2 then
									if not (l_p_str.item).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_p___0 := misc2_inst.vim_strchr (l_p_str, ('%N').code)
										if (not l_p___0.is_void) then
											l_len := (l_p___0.distance (l_p_str)) + 1
										else
											l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_str))).to_integer_32
										end
										if l_len > 1_022 then
											misc2_inst.vim_strncpy (globals_inst.IObuff, l_p_str, (1_022).to_natural_32)
										else
											misc2_inst.vim_strncpy (globals_inst.IObuff, l_p_str, l_len.to_natural_32)
										end
										l_p_str := l_p_str + l_len
									end
								elseif (a_tv.item.v_type).to_integer_32 = 4 then
									from
									until
										js.loop_done
									loop
										if (not l_p_li.is_void) then
											if (l_p_li.item.li_tv.v_type).to_integer_32 = 2 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_p_li := l_p_li.item.li_next
										end
									end
									if l_p_li.is_void then
										js.break
									end
									if not js.loop_jumped then
										l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_li.item.li_tv.vval.v_string))).to_integer_32
										if l_len > 1_022 then
											l_len := 1_022
										end
										misc2_inst.vim_strncpy (globals_inst.IObuff, l_p_li.item.li_tv.vval.v_string, l_len.to_natural_32)
										l_p_li := l_p_li.item.li_next
									end
								end
							else
								if l_buflnum > a_lnumlast then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___41 := l_buflnum
									l_buflnum := l_buflnum + 1
									misc2_inst.vim_strncpy (globals_inst.IObuff, (memline_inst.ml_get_buf (a_buf___6, l_tmp___41, 0)), (1_022).to_natural_32)
								end
							end
						elseif (fgets (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), 1_022, l_fd)).is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 98 -- skip if block
						end
				when 44 then -- if:
						globals_inst.IObuff[1_022] := (('%/0/').code).to_natural_8
						l_efmp := misc2_inst.vim_strrchr (globals_inst.IObuff, ('%N').code)
						if not l_efmp.is_void then
							l_efmp.item := (('%/0/').code).to_natural_8
						end
						if l_fmt_start.is_void then
							l_fmt_ptr := l_fmt_first
						else
							l_fmt_ptr := l_fmt_start
							l_fmt_start := create {CE_POINTER [PD_EFM_S]}.make_shared (default_pointer)
						end
						l_valid := 1
				when 45 then -- restofline:
						if not (not js.loop_done and then (not l_fmt_ptr.is_void)) then
							l_pos := -1 + 60 -- skip loop
						end
				when 46 then -- loop body:
						l_idx := (l_fmt_ptr.item.prefix2).to_integer_32
						if l_multiscan.to_boolean then
							if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPQ")), l_idx)).is_void then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 59 -- skip if block
						end
				when 47 then -- if:
						l_namebuf[0] := (('%/0/').code).to_natural_8
						l_pattern[0] := (('%/0/').code).to_natural_8
						if not l_multiscan.to_boolean then
							l_errmsg[0] := (('%/0/').code).to_natural_8
						end
						l_lnum := 0
						l_col := 0
						l_use_viscol := (0).to_natural_8
						l_enr := -1
						l_type := 0
						l_tail := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_regmatch___0.item.regprog := l_fmt_ptr.item.prog
						if not ((regexp_inst.vim_regexec (l_regmatch___0, globals_inst.IObuff, 0)).to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 48 then -- if:
						if l_idx /= 67 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if l_idx /= 90 then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L___4:
						if not l_multiline.to_boolean then
							js.continue
						end
				when 53 then -- if done
						if not js.loop_jumped then
							if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("EWI")), l_idx)).is_void then
								l_type := l_idx
							else
								l_type := 0
							end
							l_i___0 := (l_fmt_ptr.item.addr[0]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_c := ((l_regmatch___0.item.endp[l_i___0]).item).to_integer_32;
									(l_regmatch___0.item.endp[l_i___0]).item := (('%/0/').code).to_natural_8
									misc1_inst.expand_env (l_regmatch___0.item.startp[l_i___0], l_namebuf, 1_024);
									(l_regmatch___0.item.endp[l_i___0]).item := l_c.to_natural_8
									if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPQ")), l_idx)).is_void then
										if (os_unix_inst.mch_getperm (l_namebuf)) = -1 then
											js.continue
										end
									end
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[1]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_enr := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_regmatch___0.item.startp[l_i___0]))).to_integer_32
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[2]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_lnum := atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_regmatch___0.item.startp[l_i___0]))
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[3]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_col := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_regmatch___0.item.startp[l_i___0]))).to_integer_32
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[4]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_type := ((l_regmatch___0.item.startp[l_i___0]).item).to_integer_32
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 58 -- skip if block
						end
				when 54 then -- if:
						if (l_fmt_ptr.item.flags).to_integer_32 /= 43 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if not l_multiscan.to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff)).do_nothing
						else
							l_pos := -1 + 57 -- goto _L___5
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else: | _L___5:
						l_i___0 := (l_fmt_ptr.item.addr[5]).to_integer_32
						if l_i___0 > 0 then
							if (l_regmatch___0.item.startp[l_i___0]).is_void then
								js.continue
							elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
								js.continue
							end
							if not js.loop_jumped then
								l_len := (l_regmatch___0.item.endp[l_i___0]).distance ((l_regmatch___0.item.startp[l_i___0]))
								misc2_inst.vim_strncpy (l_errmsg, l_regmatch___0.item.startp[l_i___0], l_len.to_natural_32)
							end
						end
				when 58 then -- if done
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[6]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_tail := l_regmatch___0.item.startp[l_i___0]
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[7]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_col := ((l_regmatch___0.item.endp[l_i___0]).distance ((l_regmatch___0.item.startp[l_i___0]))) + 1
									if ((l_regmatch___0.item.startp[l_i___0]).item).to_integer_32 /= 9 then
										l_use_viscol := (1).to_natural_8
									end
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[8]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_col := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_regmatch___0.item.startp[l_i___0]))).to_integer_32
									l_use_viscol := (1).to_natural_8
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := (l_fmt_ptr.item.addr[9]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									js.continue
								elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
									js.continue
								end
								if not js.loop_jumped then
									l_len := (l_regmatch___0.item.endp[l_i___0]).distance ((l_regmatch___0.item.startp[l_i___0]))
									if l_len > 1_019 then
										l_len := 1_019
									end
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_pattern), ce_string ("^\V")).do_nothing
									strncat (create {CE_POINTER [INTEGER_8]}.make_cast (l_pattern), create {CE_POINTER [INTEGER_8]}.make_cast (l_regmatch___0.item.startp[l_i___0]), l_len.to_natural_32).do_nothing
									l_pattern[(l_len + 3)] := (('\').code).to_natural_8
									l_pattern[(l_len + 4)] := (('$').code).to_natural_8
									l_pattern[(l_len + 5)] := (('%/0/').code).to_natural_8
								end
							end
						end
						if not js.loop_jumped then
							js.break
						end
				when 59 then -- if done | if done
						if js.loop_increment then
							l_fmt_ptr := l_fmt_ptr.item.next
						end
						l_pos := -1 + 45 -- back to loop condition
				when 60 then -- loop done
						l_multiscan := 0
						if not (l_fmt_ptr.is_void) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_pos := -1 + 67 -- goto _L___8
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 63 then -- else:
						if l_idx /= 68 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						l_pos := -1 + 67 -- goto _L___8
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 66 then -- else:
						if l_idx /= 88 then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if: | _L___8:
						if l_fmt_ptr.is_void then
							l_pos := -1 + 73 -- skip if block
						end
				when 68 then -- if:
						if l_idx /= 68 then
							l_pos := -1 + 72 -- skip if block
						end
				when 69 then -- if:
						if (l_namebuf.item).to_integer_32 = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E379: Missing or empty directory name"))))).do_nothing
							l_pos := -1 + 108 -- goto error2
						end
				when 70 then
						l_directory := qf_push_dir (l_namebuf, dir_stack)
						if l_directory.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 72 then -- else:
						if l_idx = 88 then
							l_directory := qf_pop_dir (dir_stack)
						end
				when 73 then -- if done
						l_namebuf[0] := (('%/0/').code).to_natural_8
						l_lnum := 0
						l_valid := 0
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff)).do_nothing
						if l_fmt_ptr.is_void then
							l_multiignore := 0
							l_multiline := l_multiignore
						end
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 75 then -- else:
						if l_fmt_ptr.is_void then
							l_pos := -1 + 98 -- skip if block
						end
				when 76 then -- if:
						if (l_fmt_ptr.item.conthere).to_boolean then
							l_fmt_start := l_fmt_ptr
						end
						if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("AEWI")), l_idx)).is_void then
							l_pos := -1 + 79 -- skip if block
						end
				when 77 then -- if:
						l_multiline := 1
				when 78 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 79 then -- else:
						if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("CZ")), l_idx)).is_void then
							l_pos := -1 + 87 -- skip if block
						end
				when 80 then -- if:
						if (l_qfprev.item).is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 81 then
						if not ((l_errmsg.item).to_boolean) then
							l_pos := -1 + 85 -- skip if block
						end
				when 82 then -- if:
						if l_multiignore.to_boolean then
							l_pos := -1 + 85 -- skip if block
						end
				when 83 then -- if:
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_qfprev.item.item.qf_text))).to_integer_32
						l_ptr := misc2_inst.alloc ((l_len.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg)))) + {NATURAL_32} 2)
						if l_ptr.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 84 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_qfprev.item.item.qf_text)).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_qfprev.item.item.qf_text))
						l_qfprev.item.item.qf_text := l_ptr
						l_ptr := l_ptr + l_len
						l_ptr.item := (('%N').code).to_natural_8
						l_ptr := l_ptr + 1
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg)).do_nothing
				when 85 then -- if done | if done
						if l_qfprev.item.item.qf_nr = -1 then
							l_qfprev.item.item.qf_nr := l_enr
						end
						if (charset_inst.vim_isprintc (l_type)).to_boolean then
							if not (l_qfprev.item.item.qf_type).to_boolean then
								l_qfprev.item.item.qf_type := l_type.to_natural_8
							end
						end
						if not (l_qfprev.item.item.qf_lnum).to_boolean then
							l_qfprev.item.item.qf_lnum := l_lnum
						end
						if not (l_qfprev.item.item.qf_col).to_boolean then
							l_qfprev.item.item.qf_col := l_col
						end
						l_qfprev.item.item.qf_viscol := l_use_viscol
						if not (l_qfprev.item.item.qf_fnum).to_boolean then
							if (l_namebuf.item).to_boolean then
								l_tmp___57 := l_namebuf
							elseif (not l_directory.is_void) then
								l_tmp___57 := l_namebuf
							else
								if (not l_currfile.is_void) then
									if l_valid.to_boolean then
										l_tmp___56 := l_currfile
									else
										l_tmp___56 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									end
								else
									l_tmp___56 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								end
								l_tmp___57 := l_tmp___56
							end
							l_qfprev.item.item.qf_fnum := qf_get_fnum (l_directory, l_tmp___57)
						end
						if l_idx = 90 then
							l_multiignore := 0
							l_multiline := l_multiignore
						end
						misc1_inst.line_breakcheck
						js.continue
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 87 then -- else:
						if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPQ")), l_idx)).is_void then
							l_pos := -1 + 97 -- skip if block
						end
				when 88 then -- if:
						l_valid := 0
						if (l_namebuf.item).to_integer_32 /= 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 89 then -- if:
						l_pos := -1 + 92 -- goto _L___7
				when 90 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 91 then -- else:
						if not ((os_unix_inst.mch_getperm (l_namebuf)) >= 0) then
							l_pos := -1 + 97 -- skip if block
						end
				when 92 then -- if: | _L___7:
						if not ((l_namebuf.item).to_boolean) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						if l_idx = 80 then
							l_currfile := qf_push_dir (l_namebuf, l_file_stack)
						else
							l_pos := -1 + 95 -- goto _L___6
						end
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 95 then -- else: | _L___6:
						if l_idx = 81 then
							l_currfile := qf_pop_dir (l_file_stack)
						end
				when 96 then
						l_namebuf.item := (('%/0/').code).to_natural_8
						if (not l_tail.is_void) then
							if (l_tail.item).to_boolean then
								l_tmp___59 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.skipwhite (l_tail))))
								memmove (create {CE_POINTER [ANY]}.make_cast (globals_inst.IObuff), create {CE_POINTER [ANY]}.make_cast ((charset_inst.skipwhite (l_tail))), l_tmp___59 + {NATURAL_32} 1).do_nothing
								l_multiscan := 1
								l_pos := -1 + 45 -- goto restofline
							end
						end
				when 97 then -- if done | if done | if done | if done
						if not js.loop_jumped and then ((l_fmt_ptr.item.flags).to_integer_32 = 45) then
							if l_multiline.to_boolean then
								l_multiignore := 1
							end
							js.continue
						end
				when 98 then -- if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						if (l_namebuf.item).to_boolean then
							l_tmp___66 := l_namebuf
						elseif (not l_directory.is_void) then
							l_tmp___66 := l_namebuf
						else
							if (not l_currfile.is_void) then
								if l_valid.to_boolean then
									l_tmp___65 := l_currfile
								else
									l_tmp___65 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								end
							else
								l_tmp___65 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
							l_tmp___66 := l_tmp___65
						end
						if (qf_add_entry (a_qi, l_qfprev, l_directory, l_tmp___66, 0, l_errmsg, l_lnum, l_col, l_use_viscol.to_integer_32, l_pattern, l_enr, l_type, l_valid)) = 0 then
							l_pos := -1 + 108 -- goto error2
						end
				when 100 then
						misc1_inst.line_breakcheck
				when 101 then -- if done
						l_pos := -1 + 42 -- back to loop condition
				when 102 then -- loop done
					if not (l_fd.is_void) then
						l_pos := -1 + 105 -- skip if block
					end
				when 103 then -- if:
						l_pos := -1 + 106 -- goto _L___9
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 107
				when 105 then -- else:
						if (ferror (l_fd)).to_boolean then
							l_pos := -1 + 107 -- skip if block
						end
				when 106 then -- if: | _L___9:
						if a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index = 0 then
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index := 1
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_nonevalid := 1
						else
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_nonevalid := 0
							if (a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr).is_void then
								a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
							end
						end
						l_retval := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count
						l_pos := -1 + 109 -- goto qf_init_ok
				when 107 then -- if done
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_readerrf))))).do_nothing
				when 108 then -- error2:
						qf_free (a_qi, a_qi.item.qf_curlist)
						a_qi.item.qf_listcount := (a_qi.item.qf_listcount) - 1
						if a_qi.item.qf_curlist > 0 then
							a_qi.item.qf_curlist := (a_qi.item.qf_curlist) - 1
						end
				when 109 then -- qf_init_ok:
						if not l_fd.is_void then
							fclose (l_fd).do_nothing
						end
						l_fmt_ptr := l_fmt_first
						from
						until
							l_fmt_ptr.is_void
						loop
							l_fmt_first := l_fmt_ptr.item.next
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fmt_ptr.item.prog))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fmt_ptr))
							l_fmt_ptr := l_fmt_first
						end
						qf_clean_dir_stack (dir_stack)
						qf_clean_dir_stack (l_file_stack)
				when 110 then -- qf_init_end:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_namebuf))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_errmsg))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pattern))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fmtstr))
						qf_update_buffer (a_qi)
						Result := l_retval
				when 111 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	qf_jump (a_qi: CE_POINTER [PD_QF_INFO_S]; a_dir___0: INTEGER_32; a_errornr: INTEGER_32; a_forceit: INTEGER_32)
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_errornr: INTEGER_32
			l_ll_ref: CE_POINTER [PD_QF_INFO_S]
			l_qf_ptr: CE_POINTER [PD_QFLINE_S]
			l_old_qf_ptr: CE_POINTER [PD_QFLINE_S]
			l_qf_index: INTEGER_32
			l_old_qf_fnum: INTEGER_32
			l_old_qf_index: INTEGER_32
			l_prev_index: INTEGER_32
			l_err: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_lnum: INTEGER_32
			l_screen_col: INTEGER_32
			l_char_col: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_old_swb: CE_POINTER [NATURAL_8]
			l_old_swb_flags: NATURAL_32
			l_opened_window: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_altwin: CE_POINTER [PD_WINDOW_S]
			l_flags___0: INTEGER_32
			l_oldwin: CE_POINTER [PD_WINDOW_S]
			l_print_message: INTEGER_32
			l_len: INTEGER_32
			l_old_KeyTyped: INTEGER_32
			l_ok: INTEGER_32
			l_usable_win: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_wp___1: CE_POINTER [PD_WINDOW_S]
			l_tmp___11: CE_POINTER [PD_WINDOW_S]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_save_cursor: PD_POS_T
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qi.make
			create l_ll_ref.make
			create l_qf_ptr.make
			create l_old_qf_ptr.make
			create l_err.make
			create l_old_curbuf.make
			create l_line.make
			create l_old_swb.make
			create l_win.make
			create l_altwin.make
			create l_oldwin.make
			create l_tmp.make
			create l_wp___0.make
			create l_tp.make
			create l_wp___1.make
			create l_tmp___11.make
			create l_tmp___13.make
			create l_save_cursor.make
			create l_tmp___15.make
			create l_tmp___17.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := a_qi
					l_errornr := a_errornr
					l_err := e_no_more_items
					l_old_swb := option_inst.p_swb.item
					l_old_swb_flags := option_inst.swb_flags.item
					l_opened_window := 0
					l_oldwin := globals_inst.curwin
					l_print_message := 1
					l_old_KeyTyped := globals_inst.KeyTyped
					l_ok := 1
					if l_qi.is_void then
						l_qi := ql_info
					end
					if l_qi.item.qf_curlist >= l_qi.item.qf_listcount then
						l_tmp := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_quickfix))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						js.return
					elseif l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count = 0 then
						l_tmp := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_quickfix))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 90 -- skip if block
					end
				when 1 then -- if:
						l_qf_ptr := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr
						l_old_qf_ptr := l_qf_ptr
						l_qf_index := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index
						l_old_qf_index := l_qf_index
						if a_dir___0 /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___4
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 4 then -- else:
						if a_dir___0 /= 3 then
							l_pos := -1 + 24 -- skip if block
						end
				when 5 then -- if: | _L___4:
						if js.loop_done then
							l_pos := -1 + 23 -- skip loop
						end
				when 6 then -- loop body:
						l_tmp___1 := l_errornr
						l_errornr := l_errornr - 1
						if not l_tmp___1.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 22 -- skip if block
						end
				when 7 then -- if:
						l_old_qf_ptr := l_qf_ptr
						l_prev_index := l_qf_index
						l_old_qf_fnum := l_qf_ptr.item.qf_fnum
				when 8 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 21 -- skip loop
						end
				when 9 then -- loop body:
						if l_qf_index /= l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 12 then -- else:
						if not ((l_qf_ptr.item.qf_next).is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						l_qf_ptr := l_old_qf_ptr
						l_qf_index := l_prev_index
						if not l_err.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (l_err))))).do_nothing
							l_pos := -1 + 89 -- goto theend
						end
				when 14 then
						l_errornr := 0
						js.break
				when 15 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 16 then -- if:
						l_qf_index := l_qf_index + 1
						l_qf_ptr := l_qf_ptr.item.qf_next
						if (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid).to_boolean then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (l_qf_ptr.item.qf_valid).to_boolean then
							l_pos := -1 + 19 -- goto _L___0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___0:
						if a_dir___0 = 3 then
							if l_qf_ptr.item.qf_fnum /= l_old_qf_fnum then
								js.break
							end
						else
							js.break
						end
				when 20 then -- if done
						l_pos := -1 + 8 -- back to loop condition
				when 21 then -- loop done
						l_err := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				when 22 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 23 then -- loop done | if block done, skip else block:
						l_pos := -1 + 48
				when 24 then -- else:
						if a_dir___0 /= -1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___3
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 27 then -- else:
						if a_dir___0 /= -3 then
							l_pos := -1 + 47 -- skip if block
						end
				when 28 then -- if: | _L___3:
						if js.loop_done then
							l_pos := -1 + 46 -- skip loop
						end
				when 29 then -- loop body:
						l_tmp___3 := l_errornr
						l_errornr := l_errornr - 1
						if not l_tmp___3.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 45 -- skip if block
						end
				when 30 then -- if:
						l_old_qf_ptr := l_qf_ptr
						l_prev_index := l_qf_index
						l_old_qf_fnum := l_qf_ptr.item.qf_fnum
				when 31 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 44 -- skip loop
						end
				when 32 then -- loop body:
						if l_qf_index /= 1 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___1
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 35 then -- else:
						if not ((l_qf_ptr.item.qf_prev).is_void) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___1:
						l_qf_ptr := l_old_qf_ptr
						l_qf_index := l_prev_index
						if not l_err.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (l_err))))).do_nothing
							l_pos := -1 + 89 -- goto theend
						end
				when 37 then
						l_errornr := 0
						js.break
				when 38 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 43 -- skip if block
						end
				when 39 then -- if:
						l_qf_index := l_qf_index - 1
						l_qf_ptr := l_qf_ptr.item.qf_prev
						if (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid).to_boolean then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						if (l_qf_ptr.item.qf_valid).to_boolean then
							l_pos := -1 + 42 -- goto _L___2
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else: | _L___2:
						if a_dir___0 = -3 then
							if l_qf_ptr.item.qf_fnum /= l_old_qf_fnum then
								js.break
							end
						else
							js.break
						end
				when 43 then -- if done
						l_pos := -1 + 31 -- back to loop condition
				when 44 then -- loop done
						l_err := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				when 45 then -- if done
						l_pos := -1 + 28 -- back to loop condition
				when 46 then -- loop done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						if l_errornr /= 0 then
							from
							until
								js.loop_done
							loop
								if l_errornr < l_qf_index then
									if l_qf_index > 1 then
										if (l_qf_ptr.item.qf_prev).is_void then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_qf_index := l_qf_index - 1
									l_qf_ptr := l_qf_ptr.item.qf_prev
								end
							end
							from
							until
								js.loop_done
							loop
								if l_errornr > l_qf_index then
									if l_qf_index < l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count then
										if (l_qf_ptr.item.qf_next).is_void then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_qf_index := l_qf_index + 1
									l_qf_ptr := l_qf_ptr.item.qf_next
								end
							end
						end
				when 48 then -- if done | if done | if done
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := l_qf_index
						if (qf_win_pos_update (l_qi, l_old_qf_index)).to_boolean then
							l_print_message := 0
						end
						if (l_qf_ptr.item.qf_type).to_integer_32 /= 1 then
							l_pos := -1 + 59 -- skip if block
						end
				when 49 then -- if:
						if ((globals_inst.curwin.item.w_buffer).item.b_help).to_boolean then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 53 -- goto _L___6
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 52 then -- else:
						if globals_inst.cmdmod.item.tab = 0 then
							l_pos := -1 + 59 -- skip if block
						end
				when 53 then -- if: | _L___6:
						if globals_inst.cmdmod.item.tab /= 0 then
							l_wp___0 := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
						else
							l_wp___0 := globals_inst.firstwin
							from
							until
								not (not js.loop_done and then (not l_wp___0.is_void))
							loop
								if not (l_wp___0.item.w_buffer).is_void then
									if ((l_wp___0.item.w_buffer).item.b_help).to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									l_wp___0 := l_wp___0.item.w_next
								end
							end
						end
						if l_wp___0.is_void then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						if (l_wp___0.item.w_buffer).item.b_nwindows > 0 then
							window_inst.win_enter (l_wp___0, 1)
						else
							l_pos := -1 + 56 -- goto _L___5
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 56 then -- else: | _L___5:
						l_flags___0 := 16
						if globals_inst.cmdmod.item.split = 0 then
							if (globals_inst.curwin.item.w_width).to_integer_32 /= globals_inst.Columns.item then
								if globals_inst.curwin.item.w_width < 80 then
									l_flags___0 := (l_flags___0).bit_or ((4))
								end
							end
						end
						if not l_qi.is_equal (ql_info) then
							l_flags___0 := (l_flags___0).bit_or ((128))
						end
						if (window_inst.win_split (0, l_flags___0)) = 0 then
							l_pos := -1 + 89 -- goto theend
						end
				when 57 then
						l_opened_window := 1
						if (globals_inst.curwin.item.w_height).to_integer_32 < option_inst.p_hh.item then
							window_inst.win_setheight ((option_inst.p_hh.item).to_integer_32)
						end
						if not l_qi.is_equal (ql_info) then
							globals_inst.curwin.item.w_llist := l_qi
							l_qi.item.qf_refcount := (l_qi.item.qf_refcount) + 1
						end
				when 58 then
						if not (option_inst.p_im.item).to_boolean then
							globals_inst.restart_edit := 0
						end
				when 59 then -- if done | if done
						if not ((bt_quickfix (globals_inst.curbuf)).to_boolean) then
							l_pos := -1 + 79 -- skip if block
						end
				when 60 then -- if:
						if l_opened_window.to_boolean then
							l_pos := -1 + 79 -- skip if block
						end
				when 61 then -- if:
						if l_qf_ptr.item.qf_fnum = 0 then
							l_pos := -1 + 89 -- goto theend
						end
				when 62 then
						l_usable_win := 0
						l_win := globals_inst.firstwin
						from
						until
							not (not js.loop_done and then (not l_win.is_void))
						loop
							if ((l_win.item.w_buffer).item.b_p_bt[0]).to_integer_32 = 0 then
								l_usable_win := 1
								js.break
							end
							if not js.loop_jumped then
								l_win := l_win.item.w_next
							end
						end
						if l_usable_win.to_boolean then
							l_pos := -1 + 71 -- skip if block
						end
				when 63 then -- if:
						if not (((option_inst.swb_flags.item).bit_and ({NATURAL_32} 2)).to_boolean) then
							l_pos := -1 + 71 -- skip if block
						end
				when 64 then -- if:
						l_tp := globals_inst.first_tabpage
				when 65 then -- loop condition:
						if not (not js.loop_done and then (not l_tp.is_void)) then
							l_pos := -1 + 71 -- skip loop
						end
				when 66 then -- loop body:
						if l_tp.is_equal (globals_inst.curtab) then
							l_wp___1 := globals_inst.firstwin
						else
							l_wp___1 := l_tp.item.tp_firstwin
						end
				when 67 then -- loop condition:
						if l_wp___1.is_void then
							l_pos := -1 + 70 -- skip loop
						end
				when 68 then -- loop body:
						if (l_wp___1.item.w_buffer).item.b_fnum = l_qf_ptr.item.qf_fnum then
							window_inst.goto_tabpage_win (l_tp, l_wp___1)
							l_usable_win := 1
							l_pos := -1 + 71 -- goto win_found
						end
				when 69 then
						l_wp___1 := l_wp___1.item.w_next
						l_pos := -1 + 67 -- back to loop condition
				when 70 then -- loop done
						l_tp := l_tp.item.tp_next
						l_pos := -1 + 65 -- back to loop condition
				when 71 then -- loop done | if done | win_found:
						if not (globals_inst.firstwin.is_equal (globals_inst.lastwin)) then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if:
						if (bt_quickfix (globals_inst.curbuf)).to_boolean then
							l_pos := -1 + 75 -- goto _L___7
						else
							l_pos := -1 + 74 -- goto _L___8
						end
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 74 then -- else: | _L___8:
						if l_usable_win.to_boolean then
							l_pos := -1 + 78 -- skip if block
						end
				when 75 then -- if: | _L___7:
						l_ll_ref := globals_inst.curwin.item.w_llist_ref
						l_flags___0 := 64
						if not l_ll_ref.is_void then
							l_flags___0 := (l_flags___0).bit_or ((128))
						end
						if (window_inst.win_split (0, l_flags___0)) = 0 then
							l_pos := -1 + 88 -- goto failed
						end
				when 76 then
						l_opened_window := 1
						option_inst.p_swb.item := globals_inst.empty_option
						option_inst.swb_flags.item := {NATURAL_32} 0
						globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
						if not l_ll_ref.is_void then
							globals_inst.curwin.item.w_llist := l_ll_ref
							l_ll_ref.item.qf_refcount := (l_ll_ref.item.qf_refcount) + 1
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 78 then -- else:
						if not (globals_inst.curwin.item.w_llist_ref).is_void then
							l_ll_ref := globals_inst.curwin.item.w_llist_ref
							l_win := globals_inst.firstwin
							from
							until
								not (not js.loop_done and then (not l_win.is_void))
							loop
								if (l_win.item.w_llist).is_equal (l_ll_ref) then
									js.break
								end
								if not js.loop_jumped then
									l_win := l_win.item.w_next
								end
							end
							if l_win.is_void then
								l_win := globals_inst.firstwin
								from
								until
									not (not js.loop_done and then (not l_win.is_void))
								loop
									if (l_win.item.w_buffer).item.b_fnum = l_qf_ptr.item.qf_fnum then
										js.break
									end
									if not js.loop_jumped then
										l_win := l_win.item.w_next
									end
								end
								if l_win.is_void then
									l_win := globals_inst.curwin
									from
									until
										not (not js.loop_done and then (((l_win.item.w_buffer).item.b_p_bt[0]).to_integer_32 /= 0))
									loop
										if (l_win.item.w_prev).is_void then
											l_win := globals_inst.lastwin
										else
											l_win := l_win.item.w_prev
										end
										if l_win.is_equal (globals_inst.curwin) then
											js.break
										end
									end
								end
							end
							window_inst.win_goto (l_win)
							if (l_win.item.w_llist).is_void then
								l_win.item.w_llist := l_ll_ref
								l_ll_ref.item.qf_refcount := (l_ll_ref.item.qf_refcount) + 1
							end
						else
							l_win := globals_inst.curwin
							l_altwin := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
							from
							until
								not (not js.loop_done and then ((l_win.item.w_buffer).item.b_fnum /= l_qf_ptr.item.qf_fnum))
							loop
								if (l_win.item.w_prev).is_void then
									l_win := globals_inst.lastwin
								else
									l_win := l_win.item.w_prev
								end
								if (bt_quickfix (l_win.item.w_buffer)).to_boolean then
									if (l_win.item.w_llist_ref).is_void then
										if not l_altwin.is_void then
											l_win := l_altwin
										elseif not (globals_inst.curwin.item.w_prev).is_void then
											l_win := globals_inst.curwin.item.w_prev
										else
											l_win := globals_inst.curwin.item.w_next
										end
										js.break
									end
								end
								if not js.loop_jumped and then (l_altwin.is_void) then
									if not (l_win.item.w_onebuf_opt.wo_pvw).to_boolean then
										if ((l_win.item.w_buffer).item.b_p_bt[0]).to_integer_32 = 0 then
											l_altwin := l_win
										end
									end
								end
							end
							window_inst.win_goto (l_win)
						end
				when 79 then -- if done | if done | if done
						l_old_curbuf := globals_inst.curbuf
						l_old_lnum := globals_inst.curwin.item.w_cursor.lnum
						if l_qf_ptr.item.qf_fnum /= 0 then
							if (l_qf_ptr.item.qf_type).to_integer_32 = 1 then
								if (ex_cmds2_inst.can_abandon (globals_inst.curbuf, a_forceit)).to_boolean then
									if l_oldwin.is_equal (globals_inst.curwin) then
										l_tmp___11 := globals_inst.curwin
									else
										l_tmp___11 := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
									end
									l_ok := ex_cmds_inst.do_ecmd (l_qf_ptr.item.qf_fnum, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 3, l_tmp___11)
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nowrtmsg))))).do_nothing
									l_ok := 0
								end
							else
								l_ok := buffer_inst.buflist_getfile (l_qf_ptr.item.qf_fnum, (1).to_integer_32, 5, a_forceit)
							end
						end
						if l_ok /= 1 then
							l_pos := -1 + 87 -- skip if block
						end
				when 80 then -- if:
						if globals_inst.curbuf.is_equal (l_old_curbuf) then
							mark_inst.setpcmark
						end
						if (l_qf_ptr.item.qf_pattern).is_void then
							l_i___0 := l_qf_ptr.item.qf_lnum
							if l_i___0 > 0 then
								if l_i___0 > globals_inst.curbuf.item.b_ml.ml_line_count then
									l_i___0 := globals_inst.curbuf.item.b_ml.ml_line_count
								end
								globals_inst.curwin.item.w_cursor.lnum := l_i___0
							end
							if l_qf_ptr.item.qf_col > 0 then
								globals_inst.curwin.item.w_cursor.col := l_qf_ptr.item.qf_col - 1
								if (l_qf_ptr.item.qf_viscol).to_integer_32 = 1 then
									l_line := memline_inst.ml_get_curline
									l_screen_col := 0
									l_char_col := 0
									from
									until
										not (not js.loop_done and then (l_char_col < globals_inst.curwin.item.w_cursor.col))
									loop
										if (l_line.item).to_integer_32 = 0 then
											js.break
										end
										if not js.loop_jumped then
											l_tmp___13 := l_line
											l_line := l_line + 1
											if (l_tmp___13.item).to_integer_32 = 9 then
												globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col - (7 - l_screen_col \\ 8)
												l_screen_col := l_screen_col + (8 - l_screen_col \\ 8)
											else
												l_screen_col := l_screen_col + 1
											end
											l_char_col := l_char_col + 1
										end
									end
								end
								misc2_inst.check_cursor
							else
								edit_inst.beginline (5)
							end
						else
							l_save_cursor := (globals_inst.curwin.item.w_cursor).twin
							globals_inst.curwin.item.w_cursor.lnum := (0).to_integer_32
							if not (search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_qf_ptr.item.qf_pattern, 1, 1_024, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
								globals_inst.curwin.item.w_cursor := l_save_cursor.twin
							end
						end
						if ((option_inst.fdo_flags.item).bit_and ({NATURAL_32} 32)).to_boolean then
							if l_old_KeyTyped.to_boolean then
								fold_inst.foldOpenCursor
							end
						end
						if not (l_print_message.to_boolean) then
							l_pos := -1 + 86 -- skip if block
						end
				when 81 then -- if:
						move_inst.update_topline_redraw
						l_tmp___15 := qf_types ((l_qf_ptr.item.qf_type).to_integer_32, l_qf_ptr.item.qf_nr)
						if (l_qf_ptr.item.qf_cleared).to_boolean then
							l_tmp___17 := (gettext (ce_string (" (line deleted)")))
						else
							l_tmp___17 := ce_string ("")
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("(%%d of %%d)%%s%%s: "))), l_qf_index, l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count, l_tmp___17, create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___15)]).do_nothing
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32
						qf_fmt_text ((charset_inst.skipwhite (l_qf_ptr.item.qf_text)), globals_inst.IObuff + l_len, 1_025 - l_len)
						l_i___0 := globals_inst.msg_scroll.to_integer_32
						if not (globals_inst.curbuf.is_equal (l_old_curbuf)) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if globals_inst.curwin.item.w_cursor.lnum = l_old_lnum then
							globals_inst.msg_scroll := 1
						else
							l_pos := -1 + 84 -- goto _L___9
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___9:
						if not globals_inst.msg_scrolled.to_boolean then
							if (option_inst.shortmess (('O').code)).to_boolean then
								globals_inst.msg_scroll := 0
							end
						end
				when 85 then
						message_inst.msg_attr_keep (globals_inst.IObuff, 0, 1).do_nothing
						globals_inst.msg_scroll := l_i___0.to_integer_32
				when 86 then -- if done | if block done, skip else block:
						l_pos := -1 + 89
				when 87 then -- else:
						if l_opened_window.to_boolean then
							window_inst.win_close (globals_inst.curwin, 1)
						end
						if l_qf_ptr.item.qf_fnum = 0 then
							l_pos := -1 + 89 -- skip if block
						end
				when 88 then -- if: | failed:
						l_qf_ptr := l_old_qf_ptr
						l_qf_index := l_old_qf_index
				when 89 then -- if done | theend:
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr := l_qf_ptr
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := l_qf_index
						if not (option_inst.p_swb.item).is_equal (l_old_swb) then
							if l_opened_window.to_boolean then
								if (option_inst.p_swb.item).is_equal (globals_inst.empty_option) then
									option_inst.p_swb.item := l_old_swb
									option_inst.swb_flags.item := l_old_swb_flags
								else
									option_inst.free_string_option (l_old_swb)
								end
							end
						end
				when 90 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qf_list (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fname: CE_POINTER [NATURAL_8]
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_i___0: INTEGER_32
			l_idx1: CE_ARRAY [INTEGER_32]
			l_idx2: CE_ARRAY [INTEGER_32]
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_all: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_fname.make
			create l_qfp.make
			create l_idx1.make (<<1>>)
			create l_idx2.make (<<1>>)
			create l_arg.make (<<1>>)
			create l_qi.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___6.make
			create l_tmp___8.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx1.item := 1
					l_idx2.item := -1
					l_arg.item := a_eap.item.arg
					l_all := a_eap.item.forceit
					l_qi := ql_info
					if a_eap.item.cmdidx = 221 then
						if (bt_quickfix (globals_inst.curwin.item.w_buffer)).to_boolean then
							if not (globals_inst.curwin.item.w_llist_ref).is_void then
								l_qi := globals_inst.curwin.item.w_llist_ref
							else
								l_qi := globals_inst.curwin.item.w_llist
							end
						else
							l_qi := globals_inst.curwin.item.w_llist
						end
						if l_qi.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_loclist))))).do_nothing
							js.return
						end
					end
					if not js.return_called then
						if l_qi.item.qf_curlist >= l_qi.item.qf_listcount then
							l_tmp___2 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_quickfix))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
							js.return
						elseif l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count = 0 then
							l_tmp___2 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_quickfix))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
							js.return
						end
					end
					if not js.return_called then
						if (ex_getln_inst.get_list_range (l_arg, l_idx1, l_idx2)).to_boolean then
							if (l_arg.item.item).to_integer_32 /= 0 then
								l_tmp___3 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)).do_nothing
								js.return
							end
						else
							l_tmp___3 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)).do_nothing
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_i___0 := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count
						if l_idx1.item < 0 then
							if -l_idx1.item > l_i___0 then
								l_idx1.item := 0
							else
								l_idx1.item := (l_idx1.item + l_i___0) + 1
							end
						end
						if l_idx2.item < 0 then
							if -l_idx2.item > l_i___0 then
								l_idx2.item := 0
							else
								l_idx2.item := (l_idx2.item + l_i___0) + 1
							end
						end
						if (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid).to_boolean then
							l_all := 1
						end
						l_qfp := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
						l_i___0 := 1
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						if not globals_inst.got_int.to_boolean then
							if not (l_i___0 <= l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not ((l_qfp.item.qf_valid).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_all.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if l_idx1.item <= l_i___0 then
							if l_i___0 <= l_idx2.item then
								message_inst.msg_putchar (('%N').code)
								if globals_inst.got_int.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									if l_qfp.item.qf_fnum /= 0 then
										l_buf___6 := buffer_inst.buflist_findnr (l_qfp.item.qf_fnum)
										if not l_buf___6.is_void then
											l_fname := l_buf___6.item.b_fname
											if (l_qfp.item.qf_type).to_integer_32 = 1 then
												l_fname := misc1_inst.gettail (l_fname)
											end
										end
									end
									if l_fname.is_void then
										sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%2d"), l_i___0]).do_nothing
									else
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%2d %%s"), l_i___0, create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)]).do_nothing
									end
									if l_i___0 = l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index then
										l_tmp___5 := globals_inst.highlight_attr[6]
									else
										l_tmp___5 := globals_inst.highlight_attr[2]
									end
									message_inst.msg_outtrans_attr (globals_inst.IObuff, l_tmp___5).do_nothing
									if l_qfp.item.qf_lnum = 0 then
										globals_inst.IObuff[0] := (('%/0/').code).to_natural_8
									elseif l_qfp.item.qf_col = 0 then
										sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string (":%%ld"), l_qfp.item.qf_lnum]).do_nothing
									else
										sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string (":%%ld col %%d"), l_qfp.item.qf_lnum, l_qfp.item.qf_col]).do_nothing
									end
									l_tmp___6 := qf_types ((l_qfp.item.qf_type).to_integer_32, l_qfp.item.qf_nr)
									sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32), ce_string ("%%s:"), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___6)]).do_nothing
									message_inst.msg_puts_attr (globals_inst.IObuff, globals_inst.highlight_attr[9])
									if not (l_qfp.item.qf_pattern).is_void then
										qf_fmt_text (l_qfp.item.qf_pattern, globals_inst.IObuff, 1_025)
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string (":")).do_nothing
										message_inst.msg_puts (globals_inst.IObuff)
									end
									message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
									if not l_fname.is_void then
										l_tmp___8 := charset_inst.skipwhite (l_qfp.item.qf_text)
										l_tmp___9 := l_tmp___8
									elseif l_qfp.item.qf_lnum /= 0 then
										l_tmp___8 := charset_inst.skipwhite (l_qfp.item.qf_text)
										l_tmp___9 := l_tmp___8
									else
										l_tmp___9 := l_qfp.item.qf_text
									end
									qf_fmt_text (l_tmp___9, globals_inst.IObuff, 1_025)
									message_inst.msg_prt_line (globals_inst.IObuff, 0)
									term_inst.out_flush
								end
							end
						end
				when 9 then -- if done | if done
						if not js.loop_jumped then
							l_qfp := l_qfp.item.qf_next
							l_i___0 := l_i___0 + 1
							ui_inst.ui_breakcheck
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	qf_list_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent qf_list)
		end

	qf_mark_adjust (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_line1: INTEGER_32; a_line2: INTEGER_32; a_amount: INTEGER_32; a_amount_after: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_idx: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qfp.make
			create l_qi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info
					if not a_wp___0.is_void then
						if (a_wp___0.item.w_llist).is_void then
							js.return
						end
						if not js.return_called then
							l_qi := a_wp___0.item.w_llist
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_idx := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_idx < l_qi.item.qf_listcount)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						if not ((l_qi.item.qf_lists[l_idx].qf_count).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_i___0 := 0
						l_qfp := l_qi.item.qf_lists[l_idx].qf_start
				when 5 then -- loop condition:
						if not (l_i___0 < l_qi.item.qf_lists[l_idx].qf_count) then
							l_pos := -1 + 12 -- skip loop
						end
				when 6 then -- loop body:
						if l_qfp.item.qf_fnum /= globals_inst.curbuf.item.b_fnum then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						if not (l_qfp.item.qf_lnum >= a_line1) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_qfp.item.qf_lnum <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_qfp.item.qf_cleared := (1).to_natural_8
							else
								l_qfp.item.qf_lnum := l_qfp.item.qf_lnum + a_amount
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if a_amount_after.to_boolean then
							if l_qfp.item.qf_lnum > a_line2 then
								l_qfp.item.qf_lnum := l_qfp.item.qf_lnum + a_amount_after
							end
						end
				when 11 then -- if done
						l_i___0 := l_i___0 + 1
						l_qfp := l_qfp.item.qf_next
						l_pos := -1 + 5 -- back to loop condition
				when 12 then -- loop done | if done
						l_idx := l_idx + 1
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	qf_msg (a_qi: CE_POINTER [PD_QF_INFO_S])
		do
			message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("error list %%d of %%d; %%d errors")))), a_qi.item.qf_curlist + 1, a_qi.item.qf_listcount, a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count]).do_nothing
			qf_update_buffer (a_qi)
		end

	qf_new_list (a_qi: CE_POINTER [PD_QF_INFO_S]; a_qf_title: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			from
			until
				not (a_qi.item.qf_listcount > a_qi.item.qf_curlist + 1)
			loop
				a_qi.item.qf_listcount := (a_qi.item.qf_listcount) - 1
				qf_free (a_qi, a_qi.item.qf_listcount)
			end
			if a_qi.item.qf_listcount = 10 then
				qf_free (a_qi, 0)
				l_i___0 := 1
				from
				until
					not (l_i___0 < 10)
				loop
					a_qi.item.qf_lists[l_i___0 - 1] := (a_qi.item.qf_lists[l_i___0]).twin
					l_i___0 := l_i___0 + 1
				end
				a_qi.item.qf_curlist := 9
			else
				l_tmp := a_qi.item.qf_listcount
				a_qi.item.qf_listcount := (a_qi.item.qf_listcount) + 1
				a_qi.item.qf_curlist := l_tmp
			end
			a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index := 0
			a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count := 0
			if not a_qf_title.is_void then
				l_p___0 := (misc2_inst.alloc (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_qf_title))).to_integer_32 + 2).to_natural_32))
				a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_title := l_p___0
				if not l_p___0.is_void then
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string (":%%s"), create {CE_POINTER [INTEGER_8]}.make_cast (a_qf_title)]).do_nothing
				end
			else
				a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_title := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	qf_pop_dir (a_stackptr: CE_POINTER [CE_POINTER [PD_DIR_STACK_T]]): CE_POINTER [NATURAL_8]
		local
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_ds_ptr.make
			create l_tmp.make

			if not (a_stackptr.item).is_void then
				l_ds_ptr := a_stackptr.item
				a_stackptr.item := (a_stackptr.item).item.next
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr.item.dirname))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr))
			end
			if (not (a_stackptr.item).is_void) then
				l_tmp := (a_stackptr.item).item.dirname
			else
				l_tmp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			Result := l_tmp
		end

	qf_push_dir (a_dirbuf: CE_POINTER [NATURAL_8]; a_stackptr: CE_POINTER [CE_POINTER [PD_DIR_STACK_T]]): CE_POINTER [NATURAL_8]
		local
			l_ds_new: CE_POINTER [PD_DIR_STACK_T]
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ds_new.make
			create l_ds_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ds_new := create {CE_POINTER [PD_DIR_STACK_T]}.make_cast ((misc2_inst.alloc ((create {PD_DIR_STACK_T}.make).structure_size.to_natural_32)))
					if l_ds_new.is_void then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_ds_new.item.next := a_stackptr.item
						a_stackptr.item := l_ds_new
						if not ((window_inst.vim_isAbsName (a_dirbuf)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then; -- if:
						(a_stackptr.item).item.dirname := misc2_inst.vim_strsave (a_dirbuf)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if not (((a_stackptr.item).item.next).is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then; -- if:
						(a_stackptr.item).item.dirname := misc2_inst.vim_strsave (a_dirbuf)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (a_stackptr.item).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (dir_stack.item).is_equal (a_stackptr.item) then
							(a_stackptr.item).item.dirname := misc2_inst.vim_strsave (a_dirbuf)
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_ds_new := (a_stackptr.item).item.next;
						(a_stackptr.item).item.dirname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						from
						until
							not (not js.loop_done and then (not l_ds_new.is_void))
						loop
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((a_stackptr.item).item.dirname));
							(a_stackptr.item).item.dirname := misc1_inst.concat_fnames (l_ds_new.item.dirname, a_dirbuf, 1)
							if (os_unix_inst.mch_isdir ((a_stackptr.item).item.dirname)) = 1 then
								js.break
							end
							if not js.loop_jumped then
								l_ds_new := l_ds_new.item.next
							end
						end
						from
						until
							((a_stackptr.item).item.next).is_equal (l_ds_new)
						loop
							l_ds_ptr := (a_stackptr.item).item.next;
							(a_stackptr.item).item.next := ((a_stackptr.item).item.next).item.next
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr.item.dirname))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr))
						end
						if l_ds_new.is_void then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((a_stackptr.item).item.dirname));
							(a_stackptr.item).item.dirname := misc2_inst.vim_strsave (a_dirbuf)
						end
				when 11 then -- if done | if done
						if not ((a_stackptr.item).item.dirname).is_void then
							Result := ((a_stackptr.item).item.dirname)
						else
							l_ds_ptr := a_stackptr.item
							a_stackptr.item := (a_stackptr.item).item.next
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ds_ptr))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qf_types (a_c: INTEGER_32; a_nr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c /= 87 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" warning"))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if a_c /= 119 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" warning"))
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if a_c /= 73 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" info"))
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if a_c /= 105 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" info"))
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if a_c /= 69 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" error"))
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if a_c /= 101 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" error"))
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if a_c /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_nr > 0 then
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" error"))
						else
							l_pos := -1 + 21 -- goto _L
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L:
						if a_c = 0 then
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						elseif a_c = 1 then
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						else
							cc[0] := ((' ').code).to_natural_8
							cc[1] := a_c.to_natural_8
							cc[2] := (('%/0/').code).to_natural_8
							l_p___0 := cc
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						if a_nr <= 0 then
							Result := l_p___0
							js.return
						end
						if not js.return_called then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (buf___2), ce_string ("%%s %%3d"), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), a_nr]).do_nothing
							Result := buf___2
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	qf_update_buffer (a_qi: CE_POINTER [PD_QF_INFO_S])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
		do
			create l_buf___6.make
			create l_aco.make (<<1>>)

			l_buf___6 := qf_find_buf (a_qi)
			if not l_buf___6.is_void then
				fileio_inst.aucmd_prepbuf (l_aco, l_buf___6)
				qf_fill_buffer (a_qi)
				fileio_inst.aucmd_restbuf (l_aco)
				qf_win_pos_update (a_qi, 0).do_nothing
			end
		end

	qf_win_pos_update (a_qi: CE_POINTER [PD_QF_INFO_S]; a_old_qf_index: INTEGER_32): INTEGER_32
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_qf_index: INTEGER_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
		do
			create l_win.make
			create l_old_curwin___1.make

			l_qf_index := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index
			l_win := qf_find_win (a_qi)
			if not l_win.is_void then
				if l_qf_index.to_integer_32 <= (l_win.item.w_buffer).item.b_ml.ml_line_count then
					if a_old_qf_index /= l_qf_index then
						l_old_curwin___1 := globals_inst.curwin
						globals_inst.curwin := l_win
						globals_inst.curbuf := l_win.item.w_buffer
						if l_qf_index > a_old_qf_index then
							globals_inst.curwin.item.w_redraw_top := a_old_qf_index.to_integer_32
							globals_inst.curwin.item.w_redraw_bot := l_qf_index.to_integer_32
						else
							globals_inst.curwin.item.w_redraw_top := l_qf_index.to_integer_32
							globals_inst.curwin.item.w_redraw_bot := a_old_qf_index.to_integer_32
						end
						globals_inst.curwin.item.w_cursor.lnum := l_qf_index.to_integer_32
						globals_inst.curwin.item.w_cursor.col := 0
						move_inst.update_topline
						screen_inst.redraw_later (10)
						globals_inst.curwin.item.w_redr_status := 1
						globals_inst.curwin := l_old_curwin___1
						globals_inst.curbuf := globals_inst.curwin.item.w_buffer
					end
				end
			end
			Result := (not l_win.is_void).to_integer
		end

	set_errorlist (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_list: CE_POINTER [PD_LISTVAR_S]; a_action: INTEGER_32; a_title: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_d: CE_POINTER [PD_DICTVAR_S]
			l_filename: CE_POINTER [NATURAL_8]
			l_pattern: CE_POINTER [NATURAL_8]
			l_text: CE_POINTER [NATURAL_8]
			l_type: CE_POINTER [NATURAL_8]
			l_bufnum: INTEGER_32
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_nr: INTEGER_32
			l_vcol: INTEGER_32
			l_prevp: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_valid: INTEGER_32
			l_status: INTEGER_32
			l_retval: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_did_bufnr_emsg: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_li.make
			create l_d.make
			create l_filename.make
			create l_pattern.make
			create l_text.make
			create l_type.make
			create l_prevp.make (<<1>>)
			create l_qi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prevp.item := create {CE_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_retval := 1
					l_qi := ql_info
					l_did_bufnr_emsg := 0
					if not a_wp___0.is_void then
						l_qi := ll_get_or_alloc_list (a_wp___0)
						if l_qi.is_void then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						if a_action /= 32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						qf_new_list (l_qi, a_title)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_qi.item.qf_curlist /= l_qi.item.qf_listcount then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						qf_new_list (l_qi, a_title)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if a_action /= 97 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count > 0 then
							l_prevp.item := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
							from
							until
								(l_prevp.item.item.qf_next).is_equal (l_prevp.item)
							loop
								l_prevp.item := l_prevp.item.item.qf_next
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if a_action = 114 then
							qf_free (l_qi, l_qi.item.qf_curlist)
						end
				when 11 then -- if done | if done
						l_li := a_list.item.lv_first
				when 12 then -- loop condition:
						if not (not js.loop_done and then (not l_li.is_void)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 13 then -- loop body:
						if (l_li.item.li_tv.v_type).to_integer_32 /= 5 then
							js.continue
						end
						if not js.loop_jumped then
							l_d := l_li.item.li_tv.vval.v_dict
							if l_d.is_void then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						l_filename := eval_inst.get_dict_string (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filename")), 1)
						l_bufnum := (eval_inst.get_dict_number (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bufnr")))).to_integer_32
						l_lnum := eval_inst.get_dict_number (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lnum")))
						l_col := (eval_inst.get_dict_number (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("col")))).to_integer_32
						l_vcol := (eval_inst.get_dict_number (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vcol")))).to_integer_32
						l_nr := (eval_inst.get_dict_number (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nr")))).to_integer_32
						l_type := eval_inst.get_dict_string (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type")), 1)
						l_pattern := eval_inst.get_dict_string (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("pattern")), 1)
						l_text := eval_inst.get_dict_string (l_d, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text")), 1)
						if l_text.is_void then
							l_text := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						l_valid := 1
						if not (l_filename.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if l_bufnum = 0 then
							l_valid := 0
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if l_lnum = 0 then
							if l_pattern.is_void then
								l_valid := 0
							end
						end
				when 18 then
						if l_bufnum /= 0 then
							if (buffer_inst.buflist_findnr (l_bufnum)).is_void then
								if not l_did_bufnr_emsg.to_boolean then
									l_did_bufnr_emsg := 1
									misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E92: Buffer %%ld not found")))), l_bufnum.to_integer_32).do_nothing
								end
								l_valid := 0
								l_bufnum := 0
							end
						end
						if l_type.is_void then
							l_tmp___5 := ('%/0/').code
						else
							l_tmp___5 := (l_type.item).to_integer_32
						end
						l_status := qf_add_entry (l_qi, l_prevp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_filename, l_bufnum, l_text, l_lnum, l_col, l_vcol, l_pattern, l_nr, l_tmp___5, l_valid)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_filename))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pattern))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_type))
						if l_status = 0 then
							l_retval := 0
							js.break
						end
				when 19 then -- if done
						if js.loop_increment then
							l_li := l_li.item.li_next
						end
						l_pos := -1 + 12 -- back to loop condition
				when 20 then -- loop done
						if l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index = 0 then
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid := 1
						else
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid := 0
						end
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := 1
						qf_update_buffer (l_qi)
						Result := l_retval
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skip_vimgrep_pat (a_p___0: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_flags___0: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_p___0 := a_p___0
			if (charset_inst.vim_isIDc ((l_p___0.item).to_integer_32)).to_boolean then
				if not a_s.is_void then
					a_s.item := l_p___0
				end
				l_p___0 := charset_inst.skiptowhite (l_p___0)
				if not a_s.is_void then
					if (l_p___0.item).to_integer_32 /= 0 then
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp.item := (('%/0/').code).to_natural_8
					end
				end
			else
				if not a_s.is_void then
					a_s.item := l_p___0 + 1
				end
				l_c := (l_p___0.item).to_integer_32
				l_p___0 := regexp_inst.skip_regexp (l_p___0 + 1, l_c, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
				if (l_p___0.item).to_integer_32 /= l_c then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
				if not js.return_called then
					if not a_s.is_void then
						l_p___0.item := (('%/0/').code).to_natural_8
					end
					l_p___0 := l_p___0 + 1
					from
					until
						js.loop_done
					loop
						if (l_p___0.item).to_integer_32 /= 103 then
							if (l_p___0.item).to_integer_32 /= 106 then
								js.break
							end
						end
						if not js.loop_jumped then
							if not a_flags___0.is_void then
								if (l_p___0.item).to_integer_32 = 103 then
									a_flags___0.item := (a_flags___0.item).bit_or ((1))
								else
									a_flags___0.item := (a_flags___0.item).bit_or ((2))
								end
							end
							l_p___0 := l_p___0 + 1
						end
					end
				end
			end
			if not js.return_called then
				Result := l_p___0
			end
		end

	unload_dummy_buffer (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if not globals_inst.curbuf.is_equal (a_buf___6) then
				buffer_inst.close_buffer (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), a_buf___6, 2)
			end
		end

	wipe_dummy_buffer (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_cs: CE_ARRAY [PD_CLEANUP_STUFF]
		do
			create l_cs.make (<<1>>)

			if not globals_inst.curbuf.is_equal (a_buf___6) then
				ex_eval_inst.enter_cleanup (l_cs)
				buffer_inst.wipe_buffer (a_buf___6, 0)
				ex_eval_inst.leave_cleanup (l_cs)
			end
		end

end
