class
	LIBGMP_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm1 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm1 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long lo = *(unsigned long *)$op1;
				unsigned long cin = *(unsigned long *)$op2;
				unsigned long * up = *(unsigned long * *)$op3;
				long i = *(long *)$op4;
				unsigned long vl_shifted = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (lo), "=d" (cin)
						: "%0" ((unsigned int)*(up + i)), "rm" ((unsigned int)vl_shifted)
					);

				*(unsigned long *)$op1 = lo;
				*(unsigned long *)$op2 = cin;
				*(unsigned long * *)$op3 = up;
				*(long *)$op4 = i;
				*(unsigned long *)$op5 = vl_shifted;
			]"
		end

	asm2 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm2 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm2 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long next_lo = *(unsigned long *)$op1;
				unsigned long hi = *(unsigned long *)$op2;
				unsigned long * up = *(unsigned long * *)$op3;
				long i = *(long *)$op4;
				unsigned long vl_shifted = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (next_lo), "=d" (hi)
						: "%0" ((unsigned int)*(up + i)), "rm" ((unsigned int)vl_shifted)
					);

				*(unsigned long *)$op1 = next_lo;
				*(unsigned long *)$op2 = hi;
				*(unsigned long * *)$op3 = up;
				*(long *)$op4 = i;
				*(unsigned long *)$op5 = vl_shifted;
			]"
		end

	asm3 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm3 (op1.c_pointer, op2.c_pointer)
		end

	c_asm3 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * wp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (wp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = wp;
			]"
		end

	asm4 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm4 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm4 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * wp = *(unsigned long * *)$op2;
				long wsize = *(long *)$op3;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (wp + wsize)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = wp;
				*(long *)$op3 = wsize;
			]"
		end

	asm5 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm5 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm5 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long k0 = *(unsigned long *)$op1;
				unsigned long k1 = *(unsigned long *)$op2;
				unsigned long kacc = *(unsigned long *)$op3;
				unsigned long i = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (k0), "=d" (k1)
						: "%0" ((unsigned int)kacc), "rm" ((unsigned int)i)
					);

				*(unsigned long *)$op1 = k0;
				*(unsigned long *)$op2 = k1;
				*(unsigned long *)$op3 = kacc;
				*(unsigned long *)$op4 = i;
			]"
		end

	asm6 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm6 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm6 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n0 = *(unsigned long *)$op1;
				unsigned long n1 = *(unsigned long *)$op2;
				unsigned long nacc = *(unsigned long *)$op3;
				unsigned long j = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (n0), "=d" (n1)
						: "%0" ((unsigned int)nacc), "rm" ((unsigned int)j)
					);

				*(unsigned long *)$op1 = n0;
				*(unsigned long *)$op2 = n1;
				*(unsigned long *)$op3 = nacc;
				*(unsigned long *)$op4 = j;
			]"
		end

	asm7 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm7 (op1.c_pointer, op2.c_pointer)
		end

	c_asm7 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm8 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm8 (op1.c_pointer, op2.c_pointer)
		end

	c_asm8 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm9 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm9 (op1.c_pointer, op2.c_pointer)
		end

	c_asm9 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * wp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (wp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = wp;
			]"
		end

	asm10 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm10 (op1.c_pointer, op2.c_pointer)
		end

	c_asm10 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __dst___0 = *(unsigned long * *)$op1;
				unsigned long * __src___0 = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*__dst___0)
						: "0" (*__src___0)
					);

				*(unsigned long * *)$op1 = __dst___0;
				*(unsigned long * *)$op2 = __src___0;
			]"
		end

	asm11 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm11 (op1.c_pointer, op2.c_pointer)
		end

	c_asm11 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __dst___1 = *(unsigned long * *)$op1;
				unsigned long * __src___1 = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*__dst___1)
						: "0" (*__src___1)
					);

				*(unsigned long * *)$op1 = __dst___1;
				*(unsigned long * *)$op2 = __src___1;
			]"
		end

	asm12 (op1: CE_ARRAY [CE_ARRAY [NATURAL_32]]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm12 (op1.c_pointer, op2.c_pointer)
		end

	c_asm12 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * d = (unsigned long *)$op1;
				unsigned long n = *(unsigned long *)$op2;

				__asm__ volatile ("mull %3"
						: "=a" (d[0]), "=d" (d[1])
						: "%0" ((unsigned int)n), "rm" ((unsigned int)3160155467ul)
					);

				*(unsigned long *)$op2 = n;
			]"
		end

	asm13 (op1: CE_ARRAY [CE_ARRAY [NATURAL_32]]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm13 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm13 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * d = (unsigned long *)$op1;
				unsigned long n = *(unsigned long *)$op2;
				unsigned long z = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (d[0]), "=d" (d[1])
						: "%0" ((unsigned int)n), "rm" ((unsigned int)z)
					);

				*(unsigned long *)$op2 = n;
				*(unsigned long *)$op3 = z;
			]"
		end

	asm14 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [INTEGER_32])
		do
			c_asm14 (op1.c_pointer, op2.c_pointer)
		end

	c_asm14 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long __dst = *(unsigned long *)$op1;
				long z = *(long *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (__dst)
						: "0" (z)
					);

				*(unsigned long *)$op1 = __dst;
				*(long *)$op2 = z;
			]"
		end

	asm15 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm15 (op1.c_pointer, op2.c_pointer)
		end

	c_asm15 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm16 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm16 (op1.c_pointer, op2.c_pointer)
		end

	c_asm16 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm17 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm17 (op1.c_pointer, op2.c_pointer)
		end

	c_asm17 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __dst = *(unsigned long * *)$op1;
				unsigned long * __src = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*__dst)
						: "0" (*__src)
					);

				*(unsigned long * *)$op1 = __dst;
				*(unsigned long * *)$op2 = __src;
			]"
		end

	asm18 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm18 (op1.c_pointer, op2.c_pointer)
		end

	c_asm18 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long elimb = *(unsigned long *)$op1;
				unsigned long * ep = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (elimb)
						: "0" (*ep)
					);

				*(unsigned long *)$op1 = elimb;
				*(unsigned long * *)$op2 = ep;
			]"
		end

	asm19 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm19 (op1.c_pointer, op2.c_pointer)
		end

	c_asm19 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long slimb = *(unsigned long *)$op1;
				unsigned long * sp = *(unsigned long * *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (slimb)
						: "0" (*sp)
					);

				*(unsigned long *)$op1 = slimb;
				*(unsigned long * *)$op2 = sp;
			]"
		end

	asm20 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm20 (op1.c_pointer, op2.c_pointer)
		end

	c_asm20 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * lp = *(unsigned long * *)$op2;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (lp), "ri" ((unsigned long)4l)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = lp;
			]"
		end

	asm21 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm21 (op1.c_pointer, op2.c_pointer)
		end

	c_asm21 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (xp), "ri" ((unsigned long)2l)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = xp;
			]"
		end

	asm22 (op1: CE_ARRAY [INTEGER_8]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm22 (op1.c_pointer, op2.c_pointer)
		end

	c_asm22 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				char __p = *(char *)$op1;
				unsigned long __n___0 = *(unsigned long *)$op2;

				__asm__ volatile ("xorb %h1, %b1\n\t" "setpo %0"
						: "=Qm" (__p), "=Q" (__n___0)
						: "1" (__n___0)
					);

				*(char *)$op1 = __p;
				*(unsigned long *)$op2 = __n___0;
			]"
		end

	asm23 (op1: CE_ARRAY [CE_POINTER [INTEGER_8]]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm23 (op1.c_pointer, op2.c_pointer)
		end

	c_asm23 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				char * bp = *(char * *)$op1;
				unsigned long xlimb = *(unsigned long *)$op2;

				__asm__ volatile ("bswap %0"
						: "=r" (*((unsigned long *)bp))
						: "0" (xlimb)
					);

				*(char * *)$op1 = bp;
				*(unsigned long *)$op2 = xlimb;
			]"
		end

	asm24 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm24 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm24 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long p0 = *(unsigned long *)$op1;
				unsigned long p1 = *(unsigned long *)$op2;
				unsigned long p = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (p0), "=d" (p1)
						: "%0" ((unsigned int)p), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = p0;
				*(unsigned long *)$op2 = p1;
				*(unsigned long *)$op3 = p;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm25 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm25 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm25 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long bi = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp + bi / 32ul), "ri" (1ul << bi % 32ul)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = bi;
			]"
		end

	asm26 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm26 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm26 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * dp = *(unsigned long * *)$op2;
				long limb_index = *(long *)$op3;
				unsigned long bit_index = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (dp + limb_index), "ri" (1ul << bit_index % 32ul)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = dp;
				*(long *)$op3 = limb_index;
				*(unsigned long *)$op4 = bit_index;
			]"
		end

	asm27 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm27 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm27 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long dummy = *(unsigned long *)$op1;
				unsigned long r = *(unsigned long *)$op2;
				unsigned long n0 = *(unsigned long *)$op3;
				unsigned long d = *(unsigned long *)$op4;

				__asm__ volatile ("divl %4"
						: "=a" (dummy), "=d" (r)
						: "0" ((unsigned int)n0), "1" ((unsigned int)r), "rm" ((unsigned int)d)
					);

				*(unsigned long *)$op1 = dummy;
				*(unsigned long *)$op2 = r;
				*(unsigned long *)$op3 = n0;
				*(unsigned long *)$op4 = d;
			]"
		end

	asm28 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm28 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm28 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long inv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)r), "rm" ((unsigned int)inv)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = inv;
			]"
		end

	asm29 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [INTEGER_32]; op6: CE_ARRAY [NATURAL_32])
		do
			c_asm29 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm29 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh = *(unsigned long *)$op1;
				unsigned long _ql = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long n1 = *(unsigned long *)$op4;
				int cnt = *(int *)$op5;
				unsigned long n0 = *(unsigned long *)$op6;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh), "=&r" (_ql)
						: "0" ((unsigned int)_qh), "g" ((unsigned int)(r + 1ul)), "%1" ((unsigned int)_ql), "g" ((unsigned int)((n1 << cnt) | (n0 >> (32 - cnt))))
					);

				*(unsigned long *)$op1 = _qh;
				*(unsigned long *)$op2 = _ql;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = n1;
				*(int *)$op5 = cnt;
				*(unsigned long *)$op6 = n0;
			]"
		end

	asm30 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm30 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm30 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql___0 = *(unsigned long *)$op1;
				unsigned long _qh___0 = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long inv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql___0), "=d" (_qh___0)
						: "%0" ((unsigned int)r), "rm" ((unsigned int)inv)
					);

				*(unsigned long *)$op1 = _ql___0;
				*(unsigned long *)$op2 = _qh___0;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = inv;
			]"
		end

	asm31 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm31 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm31 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh___0 = *(unsigned long *)$op1;
				unsigned long _ql___0 = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long n1 = *(unsigned long *)$op4;
				int cnt = *(int *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh___0), "=&r" (_ql___0)
						: "0" ((unsigned int)_qh___0), "g" ((unsigned int)(r + 1ul)), "%1" ((unsigned int)_ql___0), "g" ((unsigned int)(n1 << cnt))
					);

				*(unsigned long *)$op1 = _qh___0;
				*(unsigned long *)$op2 = _ql___0;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = n1;
				*(int *)$op5 = cnt;
			]"
		end

	asm32 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm32 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm32 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long inv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)r), "rm" ((unsigned int)inv)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = inv;
			]"
		end

	asm33 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm33 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm33 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh = *(unsigned long *)$op1;
				unsigned long _ql = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long n0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh), "=&r" (_ql)
						: "0" ((unsigned int)_qh), "g" ((unsigned int)(r + 1ul)), "%1" ((unsigned int)_ql), "g" ((unsigned int)n0)
					);

				*(unsigned long *)$op1 = _qh;
				*(unsigned long *)$op2 = _ql;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = n0;
			]"
		end

	asm34 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm34 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm34 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long dummy = *(unsigned long *)$op1;
				unsigned long r = *(unsigned long *)$op2;
				unsigned long n0 = *(unsigned long *)$op3;
				unsigned long d = *(unsigned long *)$op4;

				__asm__ volatile ("divl %4"
						: "=a" (dummy), "=d" (r)
						: "0" ((unsigned int)n0), "1" ((unsigned int)r), "rm" ((unsigned int)d)
					);

				*(unsigned long *)$op1 = dummy;
				*(unsigned long *)$op2 = r;
				*(unsigned long *)$op3 = n0;
				*(unsigned long *)$op4 = d;
			]"
		end

	asm35 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm35 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm35 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)r), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm36 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm36 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm36 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh = *(unsigned long *)$op1;
				unsigned long _ql = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long n0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh), "=&r" (_ql)
						: "0" ((unsigned int)_qh), "g" ((unsigned int)(r + 1ul)), "%1" ((unsigned int)_ql), "g" ((unsigned int)n0)
					);

				*(unsigned long *)$op1 = _qh;
				*(unsigned long *)$op2 = _ql;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = n0;
			]"
		end

	asm37 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm37 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm37 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long B1modb = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)B1modb), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = B1modb;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm38 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm38 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm38 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)*(ap + (n - 1l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm39 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [CE_POINTER [NATURAL_32]]; op6: CE_ARRAY [INTEGER_32])
		do
			c_asm39 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm39 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;
				unsigned long * ap = *(unsigned long * *)$op5;
				long n = *(long *)$op6;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + (n - 2l)))
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
				*(unsigned long * *)$op5 = ap;
				*(long *)$op6 = n;
			]"
		end

	asm40 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm40 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm40 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long rl = *(unsigned long *)$op3;
				unsigned long B1modb = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)rl), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long *)$op3 = rl;
				*(unsigned long *)$op4 = B1modb;
			]"
		end

	asm41 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm41 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm41 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long i = *(long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + i))
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = i;
			]"
		end

	asm42 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm42 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm42 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long B2modb = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (rl), "=d" (rh)
						: "%0" ((unsigned int)rh), "rm" ((unsigned int)B2modb)
					);

				*(unsigned long *)$op1 = rl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long *)$op3 = B2modb;
			]"
		end

	asm43 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm43 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm43 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)ph), "%1" ((unsigned int)rl), "g" ((unsigned int)pl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
			]"
		end

	asm44 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm44 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm44 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long rh = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)rh), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = rh;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm45 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm45 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm45 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh = *(unsigned long *)$op1;
				unsigned long _ql = *(unsigned long *)$op2;
				unsigned long rh = *(unsigned long *)$op3;
				unsigned long rl = *(unsigned long *)$op4;
				int cnt = *(int *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh), "=&r" (_ql)
						: "0" ((unsigned int)_qh), "g" ((unsigned int)(rh + 1ul)), "%1" ((unsigned int)_ql), "g" ((unsigned int)(rl << cnt))
					);

				*(unsigned long *)$op1 = _qh;
				*(unsigned long *)$op2 = _ql;
				*(unsigned long *)$op3 = rh;
				*(unsigned long *)$op4 = rl;
				*(int *)$op5 = cnt;
			]"
		end

	asm46 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm46 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm46 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long B1modb = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)B1modb), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = B1modb;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm47 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm47 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm47 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql___0 = *(unsigned long *)$op1;
				unsigned long _qh___0 = *(unsigned long *)$op2;
				unsigned long B2modb = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql___0), "=d" (_qh___0)
						: "%0" ((unsigned int)B2modb), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql___0;
				*(unsigned long *)$op2 = _qh___0;
				*(unsigned long *)$op3 = B2modb;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm48 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm48 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm48 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long rl = *(unsigned long *)$op3;
				int cnt = *(int *)$op4;
				unsigned long bi = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)(rl >> (32 - cnt))), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = rl;
				*(int *)$op4 = cnt;
				*(unsigned long *)$op5 = bi;
			]"
		end

	asm49 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm49 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm49 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh = *(unsigned long *)$op1;
				unsigned long _ql = *(unsigned long *)$op2;
				unsigned long rl = *(unsigned long *)$op3;
				int cnt = *(int *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh), "=&r" (_ql)
						: "0" ((unsigned int)_qh), "g" ((unsigned int)((rl >> (32 - cnt)) + 1ul)), "%1" ((unsigned int)_ql), "g" ((unsigned int)(rl << cnt))
					);

				*(unsigned long *)$op1 = _qh;
				*(unsigned long *)$op2 = _ql;
				*(unsigned long *)$op3 = rl;
				*(int *)$op4 = cnt;
			]"
		end

	asm50 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm50 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm50 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)*(ap + (n - 2l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm51 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm51 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm51 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + (n - 3l)))
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
			]"
		end

	asm52 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm52 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm52 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B2modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (rl), "=d" (rh)
						: "%0" ((unsigned int)*(ap + (n - 1l))), "rm" ((unsigned int)B2modb)
					);

				*(unsigned long *)$op1 = rl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B2modb;
			]"
		end

	asm53 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm53 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm53 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)ph), "%1" ((unsigned int)rl), "g" ((unsigned int)pl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
			]"
		end

	asm54 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm54 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm54 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (rl), "=d" (rh)
						: "%0" ((unsigned int)*(ap + (n - 1l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = rl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm55 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm55 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm55 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)0), "%1" ((unsigned int)rl), "g" ((unsigned int)*(ap + (n - 2l)))
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
			]"
		end

	asm56 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm56 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm56 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long i = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)*(ap + (i + 1l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = i;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm57 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm57 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm57 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long i = *(long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + i))
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = i;
			]"
		end

	asm58 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm58 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm58 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long cl = *(unsigned long *)$op1;
				unsigned long ch = *(unsigned long *)$op2;
				unsigned long rl = *(unsigned long *)$op3;
				unsigned long B2modb = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (cl), "=d" (ch)
						: "%0" ((unsigned int)rl), "rm" ((unsigned int)B2modb)
					);

				*(unsigned long *)$op1 = cl;
				*(unsigned long *)$op2 = ch;
				*(unsigned long *)$op3 = rl;
				*(unsigned long *)$op4 = B2modb;
			]"
		end

	asm59 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm59 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm59 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long ch = *(unsigned long *)$op3;
				unsigned long cl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)ch), "%1" ((unsigned int)pl), "g" ((unsigned int)cl)
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long *)$op3 = ch;
				*(unsigned long *)$op4 = cl;
			]"
		end

	asm60 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm60 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm60 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long B3modb = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (rl), "=d" (rh)
						: "%0" ((unsigned int)rh), "rm" ((unsigned int)B3modb)
					);

				*(unsigned long *)$op1 = rl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long *)$op3 = B3modb;
			]"
		end

	asm61 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm61 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm61 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)ph), "%1" ((unsigned int)rl), "g" ((unsigned int)pl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
			]"
		end

	asm62 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm62 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm62 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long cl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long B1modb = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (cl), "=d" (rh)
						: "%0" ((unsigned int)rh), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = cl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long *)$op3 = B1modb;
			]"
		end

	asm63 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm63 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm63 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long cl = *(unsigned long *)$op3;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)0), "%1" ((unsigned int)rl), "g" ((unsigned int)cl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = cl;
			]"
		end

	asm64 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm64 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm64 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql___0 = *(unsigned long *)$op1;
				unsigned long _qh___0 = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql___0), "=d" (_qh___0)
						: "%0" ((unsigned int)r), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql___0;
				*(unsigned long *)$op2 = _qh___0;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm65 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm65 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm65 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh___0 = *(unsigned long *)$op1;
				unsigned long _ql___0 = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long rl = *(unsigned long *)$op4;
				int cnt = *(int *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh___0), "=&r" (_ql___0)
						: "0" ((unsigned int)_qh___0), "g" ((unsigned int)(r + 1ul)), "%1" ((unsigned int)_ql___0), "g" ((unsigned int)(rl << cnt))
					);

				*(unsigned long *)$op1 = _qh___0;
				*(unsigned long *)$op2 = _ql___0;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = rl;
				*(int *)$op5 = cnt;
			]"
		end

	asm66 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm66 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm66 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long B1modb = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)B1modb), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = B1modb;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm67 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm67 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm67 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql___0 = *(unsigned long *)$op1;
				unsigned long _qh___0 = *(unsigned long *)$op2;
				unsigned long B2modb = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql___0), "=d" (_qh___0)
						: "%0" ((unsigned int)B2modb), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql___0;
				*(unsigned long *)$op2 = _qh___0;
				*(unsigned long *)$op3 = B2modb;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm68 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm68 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm68 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql___1 = *(unsigned long *)$op1;
				unsigned long _qh___1 = *(unsigned long *)$op2;
				unsigned long B3modb = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql___1), "=d" (_qh___1)
						: "%0" ((unsigned int)B3modb), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql___1;
				*(unsigned long *)$op2 = _qh___1;
				*(unsigned long *)$op3 = B3modb;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm69 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm69 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm69 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)*(ap + (n - 2l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm70 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm70 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm70 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + (n - 3l)))
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
			]"
		end

	asm71 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm71 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm71 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B2modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (rl), "=d" (rh)
						: "%0" ((unsigned int)*(ap + (n - 1l))), "rm" ((unsigned int)B2modb)
					);

				*(unsigned long *)$op1 = rl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B2modb;
			]"
		end

	asm72 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm72 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm72 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)ph), "%1" ((unsigned int)rl), "g" ((unsigned int)pl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
			]"
		end

	asm73 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm73 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm73 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)*(ap + (n - 1l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm74 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [CE_POINTER [NATURAL_32]]; op6: CE_ARRAY [INTEGER_32])
		do
			c_asm74 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm74 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;
				unsigned long * ap = *(unsigned long * *)$op5;
				long n = *(long *)$op6;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + (n - 2l)))
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
				*(unsigned long * *)$op5 = ap;
				*(long *)$op6 = n;
			]"
		end

	asm75 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm75 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm75 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long pl = *(unsigned long *)$op1;
				unsigned long ph = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long i = *(long *)$op4;
				unsigned long B1modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (pl), "=d" (ph)
						: "%0" ((unsigned int)*(ap + (i + 1l))), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = pl;
				*(unsigned long *)$op2 = ph;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = i;
				*(unsigned long *)$op5 = B1modb;
			]"
		end

	asm76 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm76 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm76 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long i = *(long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)0), "%1" ((unsigned int)pl), "g" ((unsigned int)*(ap + i))
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = i;
			]"
		end

	asm77 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm77 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm77 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long cl = *(unsigned long *)$op1;
				unsigned long ch = *(unsigned long *)$op2;
				unsigned long * ap = *(unsigned long * *)$op3;
				long i = *(long *)$op4;
				unsigned long B2modb = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (cl), "=d" (ch)
						: "%0" ((unsigned int)*(ap + (i + 2l))), "rm" ((unsigned int)B2modb)
					);

				*(unsigned long *)$op1 = cl;
				*(unsigned long *)$op2 = ch;
				*(unsigned long * *)$op3 = ap;
				*(long *)$op4 = i;
				*(unsigned long *)$op5 = B2modb;
			]"
		end

	asm78 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm78 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm78 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long ch = *(unsigned long *)$op3;
				unsigned long cl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)ch), "%1" ((unsigned int)pl), "g" ((unsigned int)cl)
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long *)$op3 = ch;
				*(unsigned long *)$op4 = cl;
			]"
		end

	asm79 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm79 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm79 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long cl = *(unsigned long *)$op1;
				unsigned long ch = *(unsigned long *)$op2;
				unsigned long rl = *(unsigned long *)$op3;
				unsigned long B3modb = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (cl), "=d" (ch)
						: "%0" ((unsigned int)rl), "rm" ((unsigned int)B3modb)
					);

				*(unsigned long *)$op1 = cl;
				*(unsigned long *)$op2 = ch;
				*(unsigned long *)$op3 = rl;
				*(unsigned long *)$op4 = B3modb;
			]"
		end

	asm80 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm80 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm80 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ph = *(unsigned long *)$op1;
				unsigned long pl = *(unsigned long *)$op2;
				unsigned long ch = *(unsigned long *)$op3;
				unsigned long cl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (ph), "=&r" (pl)
						: "0" ((unsigned int)ph), "g" ((unsigned int)ch), "%1" ((unsigned int)pl), "g" ((unsigned int)cl)
					);

				*(unsigned long *)$op1 = ph;
				*(unsigned long *)$op2 = pl;
				*(unsigned long *)$op3 = ch;
				*(unsigned long *)$op4 = cl;
			]"
		end

	asm81 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm81 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm81 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long B4modb = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (rl), "=d" (rh)
						: "%0" ((unsigned int)rh), "rm" ((unsigned int)B4modb)
					);

				*(unsigned long *)$op1 = rl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long *)$op3 = B4modb;
			]"
		end

	asm82 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm82 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm82 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long ph = *(unsigned long *)$op3;
				unsigned long pl = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)ph), "%1" ((unsigned int)rl), "g" ((unsigned int)pl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = ph;
				*(unsigned long *)$op4 = pl;
			]"
		end

	asm83 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm83 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm83 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long cl = *(unsigned long *)$op1;
				unsigned long rh = *(unsigned long *)$op2;
				unsigned long B1modb = *(unsigned long *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (cl), "=d" (rh)
						: "%0" ((unsigned int)rh), "rm" ((unsigned int)B1modb)
					);

				*(unsigned long *)$op1 = cl;
				*(unsigned long *)$op2 = rh;
				*(unsigned long *)$op3 = B1modb;
			]"
		end

	asm84 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm84 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm84 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long rh = *(unsigned long *)$op1;
				unsigned long rl = *(unsigned long *)$op2;
				unsigned long cl = *(unsigned long *)$op3;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (rh), "=&r" (rl)
						: "0" ((unsigned int)rh), "g" ((unsigned int)0), "%1" ((unsigned int)rl), "g" ((unsigned int)cl)
					);

				*(unsigned long *)$op1 = rh;
				*(unsigned long *)$op2 = rl;
				*(unsigned long *)$op3 = cl;
			]"
		end

	asm85 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm85 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm85 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _ql = *(unsigned long *)$op1;
				unsigned long _qh = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long bi = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_ql), "=d" (_qh)
						: "%0" ((unsigned int)r), "rm" ((unsigned int)bi)
					);

				*(unsigned long *)$op1 = _ql;
				*(unsigned long *)$op2 = _qh;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = bi;
			]"
		end

	asm86 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm86 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm86 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _qh = *(unsigned long *)$op1;
				unsigned long _ql = *(unsigned long *)$op2;
				unsigned long r = *(unsigned long *)$op3;
				unsigned long rl = *(unsigned long *)$op4;
				int cnt = *(int *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (_qh), "=&r" (_ql)
						: "0" ((unsigned int)_qh), "g" ((unsigned int)(r + 1ul)), "%1" ((unsigned int)_ql), "g" ((unsigned int)(rl << cnt))
					);

				*(unsigned long *)$op1 = _qh;
				*(unsigned long *)$op2 = _ql;
				*(unsigned long *)$op3 = r;
				*(unsigned long *)$op4 = rl;
				*(int *)$op5 = cnt;
			]"
		end

	asm87 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm87 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm87 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (prodp + vn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm88 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm88 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm88 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (prodp + vn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm89 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm89 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm89 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy___2 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___5)
						: "0" (prodp + vn), "ri" (cy___2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy___2;
			]"
		end

	asm90 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm90 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm90 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy___2 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___6)
						: "0" (prodp + vn), "ri" (cy___2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy___2;
			]"
		end

	asm91 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm91 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm91 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy___1 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (prodp + vn), "ri" (cy___1)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy___1;
			]"
		end

	asm92 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm92 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm92 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy___1 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (prodp + vn), "ri" (cy___1)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy___1;
			]"
		end

	asm93 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm93 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm93 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (prodp + vn), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy___0;
			]"
		end

	asm94 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm94 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm94 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * prodp = *(unsigned long * *)$op2;
				long vn = *(long *)$op3;
				unsigned long cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (prodp + vn), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = prodp;
				*(long *)$op3 = vn;
				*(unsigned long *)$op4 = cy___0;
			]"
		end

	asm95 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm95 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm95 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * r = *(unsigned long * *)$op2;
				unsigned long cc = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (r), "ri" (cc)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = r;
				*(unsigned long *)$op3 = cc;
			]"
		end

	asm96 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm96 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm96 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * r = *(unsigned long * *)$op2;
				unsigned long cc = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (r), "ri" (cc)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = r;
				*(unsigned long *)$op3 = cc;
			]"
		end

	asm97 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm97 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm97 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * r = *(unsigned long * *)$op2;
				unsigned long x___2 = *(unsigned long *)$op3;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (r), "ri" (x___2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = r;
				*(unsigned long *)$op3 = x___2;
			]"
		end

	asm98 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm98 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm98 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * r = *(unsigned long * *)$op2;
				unsigned long x___2 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (r), "ri" (x___2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = r;
				*(unsigned long *)$op3 = x___2;
			]"
		end

	asm99 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm99 (op1.c_pointer, op2.c_pointer)
		end

	c_asm99 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * ap = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (ap)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = ap;
			]"
		end

	asm100 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm100 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm100 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long bi = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp + bi / 32ul), "ri" (1ul << bi % 32ul)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = bi;
			]"
		end

	asm101 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm101 (op1.c_pointer, op2.c_pointer)
		end

	c_asm101 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm102 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm102 (op1.c_pointer, op2.c_pointer)
		end

	c_asm102 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * sp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (sp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = sp;
			]"
		end

	asm103 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32])
		do
			c_asm103 (op1.c_pointer, op2.c_pointer)
		end

	c_asm103 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long frac = *(unsigned long *)$op1;
				unsigned long digit = *(unsigned long *)$op2;

				__asm__ volatile ("mull %3"
						: "=a" (frac), "=d" (digit)
						: "%0" ((unsigned int)frac), "rm" ((unsigned int)10)
					);

				*(unsigned long *)$op1 = frac;
				*(unsigned long *)$op2 = digit;
			]"
		end

	asm104 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm104 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm104 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long frac___0 = *(unsigned long *)$op1;
				unsigned long digit___0 = *(unsigned long *)$op2;
				int base = *(int *)$op3;

				__asm__ volatile ("mull %3"
						: "=a" (frac___0), "=d" (digit___0)
						: "%0" ((unsigned int)frac___0), "rm" ((unsigned int)base)
					);

				*(unsigned long *)$op1 = frac___0;
				*(unsigned long *)$op2 = digit___0;
				*(int *)$op3 = base;
			]"
		end

	asm105 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm105 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm105 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				long ln = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp + ln), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(long *)$op3 = ln;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm106 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm106 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm106 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long l = *(unsigned long *)$op1;
				unsigned long h = *(unsigned long *)$op2;
				unsigned long k = *(unsigned long *)$op3;
				unsigned long y = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (l), "=d" (h)
						: "%0" ((unsigned int)k), "rm" ((unsigned int)y)
					);

				*(unsigned long *)$op1 = l;
				*(unsigned long *)$op2 = h;
				*(unsigned long *)$op3 = k;
				*(unsigned long *)$op4 = y;
			]"
		end

	asm107 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm107 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm107 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___0 = *(unsigned long *)$op1;
				unsigned long t1___0 = *(unsigned long *)$op2;
				unsigned long * new_dp = *(unsigned long * *)$op3;
				long dn = *(long *)$op4;
				unsigned long v___0 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___0), "=d" (t1___0)
						: "%0" ((unsigned int)*(new_dp + (dn - 2l))), "rm" ((unsigned int)v___0)
					);

				*(unsigned long *)$op1 = t0___0;
				*(unsigned long *)$op2 = t1___0;
				*(unsigned long * *)$op3 = new_dp;
				*(long *)$op4 = dn;
				*(unsigned long *)$op5 = v___0;
			]"
		end

	asm108 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm108 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm108 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0 = *(unsigned long *)$op1;
				unsigned long t1 = *(unsigned long *)$op2;
				unsigned long * new_dp = *(unsigned long * *)$op3;
				long dn = *(long *)$op4;
				unsigned long v = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0), "=d" (t1)
						: "%0" ((unsigned int)*(new_dp + (dn - 2l))), "rm" ((unsigned int)v)
					);

				*(unsigned long *)$op1 = t0;
				*(unsigned long *)$op2 = t1;
				*(unsigned long * *)$op3 = new_dp;
				*(long *)$op4 = dn;
				*(unsigned long *)$op5 = v;
			]"
		end

	asm109 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm109 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm109 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___2 = *(unsigned long *)$op1;
				unsigned long t1___2 = *(unsigned long *)$op2;
				unsigned long * dp = *(unsigned long * *)$op3;
				long dn = *(long *)$op4;
				unsigned long v___2 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___2), "=d" (t1___2)
						: "%0" ((unsigned int)*(dp + (dn - 2l))), "rm" ((unsigned int)v___2)
					);

				*(unsigned long *)$op1 = t0___2;
				*(unsigned long *)$op2 = t1___2;
				*(unsigned long * *)$op3 = dp;
				*(long *)$op4 = dn;
				*(unsigned long *)$op5 = v___2;
			]"
		end

	asm110 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm110 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm110 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___1 = *(unsigned long *)$op1;
				unsigned long t1___1 = *(unsigned long *)$op2;
				unsigned long * dp = *(unsigned long * *)$op3;
				long dn = *(long *)$op4;
				unsigned long v___1 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___1), "=d" (t1___1)
						: "%0" ((unsigned int)*(dp + (dn - 2l))), "rm" ((unsigned int)v___1)
					);

				*(unsigned long *)$op1 = t0___1;
				*(unsigned long *)$op2 = t1___1;
				*(unsigned long * *)$op3 = dp;
				*(long *)$op4 = dn;
				*(unsigned long *)$op5 = v___1;
			]"
		end

	asm111 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm111 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm111 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___4 = *(unsigned long *)$op1;
				unsigned long t1___4 = *(unsigned long *)$op2;
				unsigned long * new_dp = *(unsigned long * *)$op3;
				long qn = *(long *)$op4;
				unsigned long v___4 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___4), "=d" (t1___4)
						: "%0" ((unsigned int)*(new_dp + (qn - 1l))), "rm" ((unsigned int)v___4)
					);

				*(unsigned long *)$op1 = t0___4;
				*(unsigned long *)$op2 = t1___4;
				*(unsigned long * *)$op3 = new_dp;
				*(long *)$op4 = qn;
				*(unsigned long *)$op5 = v___4;
			]"
		end

	asm112 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm112 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm112 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___3 = *(unsigned long *)$op1;
				unsigned long t1___3 = *(unsigned long *)$op2;
				unsigned long * new_dp = *(unsigned long * *)$op3;
				long qn = *(long *)$op4;
				unsigned long v___3 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___3), "=d" (t1___3)
						: "%0" ((unsigned int)*(new_dp + (qn - 1l))), "rm" ((unsigned int)v___3)
					);

				*(unsigned long *)$op1 = t0___3;
				*(unsigned long *)$op2 = t1___3;
				*(unsigned long * *)$op3 = new_dp;
				*(long *)$op4 = qn;
				*(unsigned long *)$op5 = v___3;
			]"
		end

	asm113 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm113 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm113 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___6 = *(unsigned long *)$op1;
				unsigned long t1___6 = *(unsigned long *)$op2;
				unsigned long * new_dp = *(unsigned long * *)$op3;
				long qn = *(long *)$op4;
				unsigned long v___6 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___6), "=d" (t1___6)
						: "%0" ((unsigned int)*(new_dp + (qn - 1l))), "rm" ((unsigned int)v___6)
					);

				*(unsigned long *)$op1 = t0___6;
				*(unsigned long *)$op2 = t1___6;
				*(unsigned long * *)$op3 = new_dp;
				*(long *)$op4 = qn;
				*(unsigned long *)$op5 = v___6;
			]"
		end

	asm114 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm114 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm114 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___5 = *(unsigned long *)$op1;
				unsigned long t1___5 = *(unsigned long *)$op2;
				unsigned long * new_dp = *(unsigned long * *)$op3;
				long qn = *(long *)$op4;
				unsigned long v___5 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___5), "=d" (t1___5)
						: "%0" ((unsigned int)*(new_dp + (qn - 1l))), "rm" ((unsigned int)v___5)
					);

				*(unsigned long *)$op1 = t0___5;
				*(unsigned long *)$op2 = t1___5;
				*(unsigned long * *)$op3 = new_dp;
				*(long *)$op4 = qn;
				*(unsigned long *)$op5 = v___5;
			]"
		end

	asm115 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm115 (op1.c_pointer, op2.c_pointer)
		end

	c_asm115 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm116 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm116 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm116 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0 = *(unsigned long *)$op1;
				unsigned long t1 = *(unsigned long *)$op2;
				unsigned long * d2p___0 = *(unsigned long * *)$op3;
				long dn = *(long *)$op4;
				unsigned long v = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0), "=d" (t1)
						: "%0" ((unsigned int)*(d2p___0 + (dn - 2l))), "rm" ((unsigned int)v)
					);

				*(unsigned long *)$op1 = t0;
				*(unsigned long *)$op2 = t1;
				*(unsigned long * *)$op3 = d2p___0;
				*(long *)$op4 = dn;
				*(unsigned long *)$op5 = v;
			]"
		end

	asm117 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm117 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm117 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q0 = *(unsigned long *)$op1;
				unsigned long r0 = *(unsigned long *)$op2;
				unsigned long * n2p___1 = *(unsigned long * *)$op3;
				unsigned long * d2p___1 = *(unsigned long * *)$op4;

				__asm__ volatile ("divl %4"
						: "=a" (q0), "=d" (r0)
						: "0" ((unsigned int)*(n2p___1 + 0)), "1" ((unsigned int)*(n2p___1 + 1)), "rm" ((unsigned int)*(d2p___1 + 0))
					);

				*(unsigned long *)$op1 = q0;
				*(unsigned long *)$op2 = r0;
				*(unsigned long * *)$op3 = n2p___1;
				*(unsigned long * *)$op4 = d2p___1;
			]"
		end

	asm118 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm118 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm118 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0___0 = *(unsigned long *)$op1;
				unsigned long t1___0 = *(unsigned long *)$op2;
				unsigned long * d2p___1 = *(unsigned long * *)$op3;
				long qn = *(long *)$op4;
				unsigned long v___0 = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0___0), "=d" (t1___0)
						: "%0" ((unsigned int)*(d2p___1 + (qn - 2l))), "rm" ((unsigned int)v___0)
					);

				*(unsigned long *)$op1 = t0___0;
				*(unsigned long *)$op2 = t1___0;
				*(unsigned long * *)$op3 = d2p___1;
				*(long *)$op4 = qn;
				*(unsigned long *)$op5 = v___0;
			]"
		end

	asm119 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm119 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm119 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long dummy = *(unsigned long *)$op1;
				unsigned long h = *(unsigned long *)$op2;
				unsigned long x___2 = *(unsigned long *)$op3;
				unsigned long * qp = *(unsigned long * *)$op4;
				long qn = *(long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (dummy), "=d" (h)
						: "%0" ((unsigned int)x___2), "rm" ((unsigned int)*(qp + (qn - 1l)))
					);

				*(unsigned long *)$op1 = dummy;
				*(unsigned long *)$op2 = h;
				*(unsigned long *)$op3 = x___2;
				*(unsigned long * *)$op4 = qp;
				*(long *)$op5 = qn;
			]"
		end

	asm120 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm120 (op1.c_pointer, op2.c_pointer)
		end

	c_asm120 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm121 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm121 (op1.c_pointer, op2.c_pointer)
		end

	c_asm121 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm122 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm122 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm122 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long nh = *(unsigned long *)$op1;
				unsigned long nl = *(unsigned long *)$op2;
				unsigned long dh = *(unsigned long *)$op3;
				unsigned long dl = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (nh), "=&r" (nl)
						: "0" ((unsigned int)nh), "g" ((unsigned int)dh), "1" ((unsigned int)nl), "g" ((unsigned int)dl)
					);

				*(unsigned long *)$op1 = nh;
				*(unsigned long *)$op2 = nl;
				*(unsigned long *)$op3 = dh;
				*(unsigned long *)$op4 = dl;
			]"
		end

	asm123 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm123 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm123 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long nh = *(unsigned long *)$op1;
				unsigned long nl = *(unsigned long *)$op2;
				unsigned long dh = *(unsigned long *)$op3;
				unsigned long dl = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (nh), "=&r" (nl)
						: "0" ((unsigned int)nh), "g" ((unsigned int)dh), "1" ((unsigned int)nl), "g" ((unsigned int)dl)
					);

				*(unsigned long *)$op1 = nh;
				*(unsigned long *)$op2 = nl;
				*(unsigned long *)$op3 = dh;
				*(unsigned long *)$op4 = dl;
			]"
		end

	asm124 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm124 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm124 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long nh = *(unsigned long *)$op1;
				unsigned long nl = *(unsigned long *)$op2;
				unsigned long dh = *(unsigned long *)$op3;
				unsigned long dl = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (nh), "=&r" (nl)
						: "0" ((unsigned int)nh), "g" ((unsigned int)dh), "1" ((unsigned int)nl), "g" ((unsigned int)dl)
					);

				*(unsigned long *)$op1 = nh;
				*(unsigned long *)$op2 = nl;
				*(unsigned long *)$op3 = dh;
				*(unsigned long *)$op4 = dl;
			]"
		end

	asm125 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm125 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm125 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long nh = *(unsigned long *)$op1;
				unsigned long nl = *(unsigned long *)$op2;
				unsigned long dh = *(unsigned long *)$op3;
				unsigned long dl = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (nh), "=&r" (nl)
						: "0" ((unsigned int)nh), "g" ((unsigned int)dh), "1" ((unsigned int)nl), "g" ((unsigned int)dl)
					);

				*(unsigned long *)$op1 = nh;
				*(unsigned long *)$op2 = nl;
				*(unsigned long *)$op3 = dh;
				*(unsigned long *)$op4 = dl;
			]"
		end

	asm126 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm126 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm126 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ah = *(unsigned long *)$op1;
				unsigned long al = *(unsigned long *)$op2;
				unsigned long bh = *(unsigned long *)$op3;
				unsigned long bl = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (ah), "=&r" (al)
						: "0" ((unsigned int)ah), "g" ((unsigned int)bh), "1" ((unsigned int)al), "g" ((unsigned int)bl)
					);

				*(unsigned long *)$op1 = ah;
				*(unsigned long *)$op2 = al;
				*(unsigned long *)$op3 = bh;
				*(unsigned long *)$op4 = bl;
			]"
		end

	asm127 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm127 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm127 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long bh = *(unsigned long *)$op1;
				unsigned long bl = *(unsigned long *)$op2;
				unsigned long ah = *(unsigned long *)$op3;
				unsigned long al = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (bh), "=&r" (bl)
						: "0" ((unsigned int)bh), "g" ((unsigned int)ah), "1" ((unsigned int)bl), "g" ((unsigned int)al)
					);

				*(unsigned long *)$op1 = bh;
				*(unsigned long *)$op2 = bl;
				*(unsigned long *)$op3 = ah;
				*(unsigned long *)$op4 = al;
			]"
		end

	asm128 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm128 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm128 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long ah = *(unsigned long *)$op1;
				unsigned long al = *(unsigned long *)$op2;
				unsigned long bh = *(unsigned long *)$op3;
				unsigned long bl = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (ah), "=&r" (al)
						: "0" ((unsigned int)ah), "g" ((unsigned int)bh), "1" ((unsigned int)al), "g" ((unsigned int)bl)
					);

				*(unsigned long *)$op1 = ah;
				*(unsigned long *)$op2 = al;
				*(unsigned long *)$op3 = bh;
				*(unsigned long *)$op4 = bl;
			]"
		end

	asm129 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm129 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm129 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long bh = *(unsigned long *)$op1;
				unsigned long bl = *(unsigned long *)$op2;
				unsigned long ah = *(unsigned long *)$op3;
				unsigned long al = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (bh), "=&r" (bl)
						: "0" ((unsigned int)bh), "g" ((unsigned int)ah), "1" ((unsigned int)bl), "g" ((unsigned int)al)
					);

				*(unsigned long *)$op1 = bh;
				*(unsigned long *)$op2 = bl;
				*(unsigned long *)$op3 = ah;
				*(unsigned long *)$op4 = al;
			]"
		end

	asm130 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm130 (op1.c_pointer, op2.c_pointer)
		end

	c_asm130 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (tp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = tp;
			]"
		end

	asm131 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm131 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm131 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy2 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (pp + 2l * n), "ri" (cy2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy2;
			]"
		end

	asm132 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm132 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm132 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (pp + 3l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm133 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm133 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm133 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___1)
						: "0" (pp + 3l * n)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
			]"
		end

	asm134 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm134 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm134 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (scratch + n), "ri" (cy + *(scratch + 2l * n))
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm135 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm135 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm135 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				int hi = *(int *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (scratch + n), "ri" (hi)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = n;
				*(int *)$op4 = hi;
			]"
		end

	asm136 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm136 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm136 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				int hi = *(int *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (scratch + n), "ri" (hi)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = n;
				*(int *)$op4 = hi;
			]"
		end

	asm137 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm137 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm137 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				int hi = *(int *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (pp + 4l * n), "ri" (-hi)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(int *)$op4 = hi;
			]"
		end

	asm138 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm138 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm138 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				int hi = *(int *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (pp + 4l * n), "ri" (hi)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(int *)$op4 = hi;
			]"
		end

	asm139 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm139 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm139 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * bs2 = *(unsigned long * *)$op2;
				long t = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (bs2 + t), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = bs2;
				*(long *)$op3 = t;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm140 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm140 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm140 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy2 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (pp + 2l * n), "ri" (cy2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy2;
			]"
		end

	asm141 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm141 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm141 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (pp + 3l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm142 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm142 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm142 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___1)
						: "0" (pp + 3l * n)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
			]"
		end

	asm143 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm143 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm143 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * c3 = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (c3 + 1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = c3;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm144 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm144 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm144 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * v2 = *(unsigned long * *)$op2;
				long twor = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (v2 + twor), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = v2;
				*(long *)$op3 = twor;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm145 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm145 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm145 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * c3 = *(unsigned long * *)$op2;
				long kk1 = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (c3 + kk1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = c3;
				*(long *)$op3 = kk1;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm146 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm146 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm146 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * v1 = *(unsigned long * *)$op2;
				long twor = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (v1 + twor), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = v1;
				*(long *)$op3 = twor;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm147 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm147 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm147 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * v1 = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (v1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = v1;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm148 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm148 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm148 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * vinf = *(unsigned long * *)$op2;
				unsigned long vinf0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (vinf), "ri" (vinf0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = vinf;
				*(unsigned long *)$op3 = vinf0;
			]"
		end

	asm149 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm149 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm149 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" ((pp + 3l * n) + 1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm150 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm150 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm150 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * w2 = *(unsigned long * *)$op2;
				long w0n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (w2 + w0n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = w2;
				*(long *)$op3 = w0n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm151 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm151 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm151 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (pp + 2l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm152 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm152 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm152 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * w1 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (w1 + n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = w1;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm153 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm153 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm153 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy4 = *(unsigned long *)$op4;
				unsigned long cy6 = *(unsigned long *)$op5;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (pp + 4l * n), "ri" (cy4 - cy6)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy4;
				*(unsigned long *)$op5 = cy6;
			]"
		end

	asm154 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm154 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm154 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy6 = *(unsigned long *)$op4;
				unsigned long cy4 = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (pp + 4l * n), "ri" (cy6 - cy4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy6;
				*(unsigned long *)$op5 = cy4;
			]"
		end

	asm155 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm155 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm155 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long w0n = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___5)
						: "0" ((pp + 3l * n) + w0n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(long *)$op4 = w0n;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm156 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm156 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm156 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy6 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___6)
						: "0" ((pp + 5l * n) + n), "ri" (cy6)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy6;
			]"
		end

	asm157 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm157 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm157 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___7 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy4 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___7)
						: "0" (pp + 4l * n), "ri" (cy4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___7;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy4;
			]"
		end

	asm158 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32]; op6: CE_ARRAY [NATURAL_32])
		do
			c_asm158 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm158 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___8 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long w0n = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;
				unsigned long cy6 = *(unsigned long *)$op6;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___8)
						: "0" ((pp + 3l * n) + w0n), "ri" (cy + cy6)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___8;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(long *)$op4 = w0n;
				*(unsigned long *)$op5 = cy;
				*(unsigned long *)$op6 = cy6;
			]"
		end

	asm159 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm159 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm159 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (((rp + 2l * n) + n) + 1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm160 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm160 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm160 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * w3 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * rp = *(unsigned long * *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (w3 + n), "ri" (*((rp + 2l * n) + 2l * n) + cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = w3;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = rp;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm161 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm161 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm161 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * w4 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * w3 = *(unsigned long * *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (w4 + n), "ri" (*(w3 + 2l * n) + cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = w4;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = w3;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm162 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm162 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm162 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * w5 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * w4 = *(unsigned long * *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (w5 + n), "ri" (*(w4 + 2l * n) + cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = w5;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = w4;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm163 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm163 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm163 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * pp = *(unsigned long * *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (r3 + n), "ri" (*(pp + 0) >> 4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = pp;
			]"
		end

	asm164 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm164 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm164 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long __cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (((r3 + n) + 2l * n) - 1), "ri" (__cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = __cy;
			]"
		end

	asm165 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm165 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm165 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (r3 + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = spt;
				*(long *)$op4 = cy;
			]"
		end

	asm166 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm166 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm166 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * pp = *(unsigned long * *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (r5 + n), "ri" (*(pp + 0) >> 2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = pp;
			]"
		end

	asm167 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm167 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm167 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long __cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (((r5 + n) + 2l * n) - 1), "ri" (__cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = __cy___0;
			]"
		end

	asm168 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm168 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm168 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (r5 + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = spt;
				*(long *)$op4 = cy;
			]"
		end

	asm169 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm169 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm169 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * r7 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___5)
						: "0" (r7 + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = r7;
				*(long *)$op3 = spt;
				*(long *)$op4 = cy;
			]"
		end

	asm170 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm170 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm170 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * r7 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___6)
						: "0" (r7 + n)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = r7;
				*(long *)$op3 = n;
			]"
		end

	asm171 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm171 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm171 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___7 = *(unsigned long * *)$op1;
				unsigned long * r7 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___7)
						: "0" (r7 + n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___7;
				*(unsigned long * *)$op2 = r7;
				*(long *)$op3 = n;
				*(long *)$op4 = cy;
			]"
		end

	asm172 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm172 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm172 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___8 = *(unsigned long * *)$op1;
				unsigned long * r7 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___8)
						: "0" (r7 + 2l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___8;
				*(unsigned long * *)$op2 = r7;
				*(long *)$op3 = n;
				*(long *)$op4 = cy;
			]"
		end

	asm173 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm173 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm173 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___9 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___9)
						: "0" ((r5 + n) + 1)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___9;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = n;
			]"
		end

	asm174 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm174 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm174 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___10 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___10)
						: "0" ((r5 + n) + 1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___10;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = n;
				*(long *)$op4 = cy;
			]"
		end

	asm175 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm175 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm175 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___11 = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___11)
						: "0" (r3 + 2l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___11;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = n;
				*(long *)$op4 = cy;
			]"
		end

	asm176 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm176 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm176 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___12 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long cy = *(long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___12)
						: "0" (pp + 8l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___12;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(long *)$op4 = cy;
			]"
		end

	asm177 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm177 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm177 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (r3 + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm178 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm178 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm178 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long spt = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" ((pp + 7l * n) + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(long *)$op4 = spt;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm179 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm179 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm179 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				unsigned long * pp = *(unsigned long * *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (r5), "ri" (*((pp + 11l * n) + 0) >> 2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = r5;
				*(unsigned long * *)$op3 = pp;
				*(long *)$op4 = n;
			]"
		end

	asm180 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm180 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm180 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long __cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" ((r5 + spt) - 1), "ri" (__cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = __cy;
			]"
		end

	asm181 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm181 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm181 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * r1 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (r1 + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = r1;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm182 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm182 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm182 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n3 = *(long *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (pp + n3), "ri" (*((pp + 11l * n) + 0) >> 4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n3;
				*(long *)$op4 = n;
			]"
		end

	asm183 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm183 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm183 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n3 = *(long *)$op3;
				long spt = *(long *)$op4;
				unsigned long __cy___0 = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___5)
						: "0" (((pp + n3) + spt) - 1), "ri" (__cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n3;
				*(long *)$op4 = spt;
				*(unsigned long *)$op5 = __cy___0;
			]"
		end

	asm184 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm184 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm184 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * r1 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * pp = *(unsigned long * *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___6)
						: "0" (r1 + n), "ri" (*(pp + 0) >> 4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = r1;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = pp;
			]"
		end

	asm185 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm185 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm185 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___7 = *(unsigned long * *)$op1;
				unsigned long * r1 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long __cy___1 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___7)
						: "0" (((r1 + n) + 2l * n) - 1), "ri" (__cy___1)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___7;
				*(unsigned long * *)$op2 = r1;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = __cy___1;
			]"
		end

	asm186 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm186 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm186 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___8 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___8)
						: "0" ((pp + 7l * n) + n), "ri" (*(pp + 0) >> 2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___8;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
			]"
		end

	asm187 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm187 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm187 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___9 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long __cy___2 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___9)
						: "0" ((((pp + 7l * n) + n) + 2l * n) - 1), "ri" (__cy___2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___9;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = __cy___2;
			]"
		end

	asm188 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm188 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm188 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___10 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n3 = *(long *)$op3;
				long n = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___10)
						: "0" ((pp + n3) + n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___10;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n3;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm189 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm189 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm189 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___11 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___11)
						: "0" (pp + 8l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___11;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm190 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm190 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm190 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___12 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n3 = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___12)
						: "0" (pp + 4l * n3), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___12;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n3;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm191 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm191 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm191 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long spt = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" ((pp + 7l * n) + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(long *)$op4 = spt;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm192 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm192 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm192 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (r3 + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm193 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm193 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm193 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n3 = *(long *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (pp + n3), "ri" (*((pp + 15l * n) + 0) >> 2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n3;
				*(long *)$op4 = n;
			]"
		end

	asm194 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm194 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm194 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n3 = *(long *)$op3;
				long spt = *(long *)$op4;
				unsigned long __cy = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (((pp + n3) + spt) - 1), "ri" (__cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n3;
				*(long *)$op4 = spt;
				*(unsigned long *)$op5 = __cy;
			]"
		end

	asm195 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm195 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm195 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long spt = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" ((pp + 11l * n) + spt), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(long *)$op4 = spt;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm196 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm196 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm196 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				unsigned long * pp = *(unsigned long * *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (r5), "ri" (*((pp + 15l * n) + 0) >> 4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = r5;
				*(unsigned long * *)$op3 = pp;
				*(long *)$op4 = n;
			]"
		end

	asm197 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm197 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm197 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * r5 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long __cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___5)
						: "0" ((r5 + spt) - 1), "ri" (__cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = r5;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = __cy___0;
			]"
		end

	asm198 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm198 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm198 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * r1 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___6)
						: "0" ((r1 + spt) + 1), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = r1;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm199 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm199 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm199 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___7 = *(unsigned long * *)$op1;
				unsigned long * r7 = *(unsigned long * *)$op2;
				unsigned long * pp = *(unsigned long * *)$op3;
				long n = *(long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___7)
						: "0" (r7), "ri" (*((pp + 15l * n) + 0) >> 6)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___7;
				*(unsigned long * *)$op2 = r7;
				*(unsigned long * *)$op3 = pp;
				*(long *)$op4 = n;
			]"
		end

	asm200 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm200 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm200 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___8 = *(unsigned long * *)$op1;
				unsigned long * r7 = *(unsigned long * *)$op2;
				long spt = *(long *)$op3;
				unsigned long __cy___1 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___8)
						: "0" ((r7 + spt) - 1), "ri" (__cy___1)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___8;
				*(unsigned long * *)$op2 = r7;
				*(long *)$op3 = spt;
				*(unsigned long *)$op4 = __cy___1;
			]"
		end

	asm201 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm201 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm201 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___9 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___9)
						: "0" ((pp + 11l * n) + n), "ri" (*(pp + 0) >> 4)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___9;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
			]"
		end

	asm202 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm202 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm202 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___10 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long __cy___2 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___10)
						: "0" ((((pp + 11l * n) + n) + 2l * n) - 1), "ri" (__cy___2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___10;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = __cy___2;
			]"
		end

	asm203 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm203 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm203 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___11 = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * pp = *(unsigned long * *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___11)
						: "0" (r3 + n), "ri" (*(pp + 0) >> 2)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___11;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = pp;
			]"
		end

	asm204 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm204 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm204 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___12 = *(unsigned long * *)$op1;
				unsigned long * r3 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long __cy___3 = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___12)
						: "0" (((r3 + n) + 2l * n) - 1), "ri" (__cy___3)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___12;
				*(unsigned long * *)$op2 = r3;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = __cy___3;
			]"
		end

	asm205 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm205 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm205 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___13 = *(unsigned long * *)$op1;
				unsigned long * r1 = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long * pp = *(unsigned long * *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___13)
						: "0" (r1 + n), "ri" (*(pp + 0) >> 6)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___13;
				*(unsigned long * *)$op2 = r1;
				*(long *)$op3 = n;
				*(unsigned long * *)$op4 = pp;
			]"
		end

	asm206 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm206 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm206 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___14 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___14)
						: "0" (pp + 4l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___14;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm207 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm207 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm207 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___15 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___15)
						: "0" (pp + 8l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___15;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm208 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm208 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm208 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___16 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___16)
						: "0" (pp + 12l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___16;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm209 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm209 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm209 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___17 = *(unsigned long * *)$op1;
				unsigned long * pp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___17)
						: "0" (pp + 16l * n), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___17;
				*(unsigned long * *)$op2 = pp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm210 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm210 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm210 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0 = *(unsigned long *)$op1;
				unsigned long t1 = *(unsigned long *)$op2;
				unsigned long * dp = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long v = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0), "=d" (t1)
						: "%0" ((unsigned int)*(dp + (n - 2l))), "rm" ((unsigned int)v)
					);

				*(unsigned long *)$op1 = t0;
				*(unsigned long *)$op2 = t1;
				*(unsigned long * *)$op3 = dp;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = v;
			]"
		end

	asm211 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm211 (op1.c_pointer, op2.c_pointer)
		end

	c_asm211 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * ip = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (ip)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = ip;
			]"
		end

	asm212 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [INTEGER_32]; op6: CE_ARRAY [NATURAL_32])
		do
			c_asm212 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm212 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long mn = *(long *)$op4;
				long rn = *(long *)$op5;
				unsigned long cy = *(unsigned long *)$op6;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" ((xp + n) - (mn - rn)), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = xp;
				*(long *)$op3 = n;
				*(long *)$op4 = mn;
				*(long *)$op5 = rn;
				*(unsigned long *)$op6 = cy;
			]"
		end

	asm213 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm213 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm213 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;
				long rn = *(long *)$op3;
				long n = *(long *)$op4;
				long mn = *(long *)$op5;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (((xp + rn) + n) - mn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = xp;
				*(long *)$op3 = rn;
				*(long *)$op4 = n;
				*(long *)$op5 = mn;
			]"
		end

	asm214 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm214 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm214 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;
				long mn = *(long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (xp), "ri" (*(xp + mn) - 1ul)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = xp;
				*(long *)$op3 = mn;
			]"
		end

	asm215 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm215 (op1.c_pointer, op2.c_pointer)
		end

	c_asm215 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___2)
						: "0" (xp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = xp;
			]"
		end

	asm216 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm216 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm216 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * ip = *(unsigned long * *)$op2;
				long rn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (ip - rn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = ip;
				*(long *)$op3 = rn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm217 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm217 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm217 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * xp = *(unsigned long * *)$op2;
				unsigned long method = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (xp), "ri" (method)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = xp;
				*(unsigned long *)$op3 = method;
			]"
		end

	asm218 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32])
		do
			c_asm218 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm218 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * ip = *(unsigned long * *)$op2;
				long rn = *(long *)$op3;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___5)
						: "0" (ip - rn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = ip;
				*(long *)$op3 = rn;
			]"
		end

	asm219 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm219 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm219 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * ip = *(unsigned long * *)$op2;
				long rn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___6)
						: "0" (ip - rn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = ip;
				*(long *)$op3 = rn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm220 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm220 (op1.c_pointer, op2.c_pointer)
		end

	c_asm220 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * ip = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy)
						: "0" (ip)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = ip;
			]"
		end

	asm221 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm221 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm221 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long t0 = *(unsigned long *)$op1;
				unsigned long t1 = *(unsigned long *)$op2;
				unsigned long * dp = *(unsigned long * *)$op3;
				long n = *(long *)$op4;
				unsigned long v = *(unsigned long *)$op5;

				__asm__ volatile ("mull %3"
						: "=a" (t0), "=d" (t1)
						: "%0" ((unsigned int)*(dp + (n - 2l))), "rm" ((unsigned int)v)
					);

				*(unsigned long *)$op1 = t0;
				*(unsigned long *)$op2 = t1;
				*(unsigned long * *)$op3 = dp;
				*(long *)$op4 = n;
				*(unsigned long *)$op5 = v;
			]"
		end

	asm222 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm222 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm222 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm223 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm223 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm223 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm224 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm224 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm224 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (tp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = tp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm225 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm225 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm225 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (tp + n), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy___0;
			]"
		end

	asm226 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm226 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm226 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" ((tp + 2l * n) + 2), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy___0;
			]"
		end

	asm227 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm227 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm227 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" ((((tp + 2l * n) + 2) + n) + 1), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy___0;
			]"
		end

	asm228 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm228 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm228 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (tp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = tp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm229 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm229 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm229 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___5)
						: "0" (rp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm230 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm230 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm230 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___6 = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___6)
						: "0" (rp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___6;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm231 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm231 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm231 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm232 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm232 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm232 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm233 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm233 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm233 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm234 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm234 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm234 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (tp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = tp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm235 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm235 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm235 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				unsigned long cy___0 = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" ((tp + 2l * n) + 2), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = n;
				*(unsigned long *)$op4 = cy___0;
			]"
		end

	asm236 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm236 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm236 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___2)
						: "0" (tp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = tp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm237 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm237 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm237 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" (rp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm238 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm238 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm238 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy___0 = *(unsigned long *)$op3;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" (rp), "ri" (cy___0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy___0;
			]"
		end

	asm239 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32])
		do
			c_asm239 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm239 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * rp = *(unsigned long * *)$op2;
				unsigned long cy = *(unsigned long *)$op3;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (rp), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = rp;
				*(unsigned long *)$op3 = cy;
			]"
		end

	asm240 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm240 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm240 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm241 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm241 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm241 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm242 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm242 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm242 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm243 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm243 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm243 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0 = *(unsigned long *)$op1;
				unsigned long _t1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0), "=d" (_t1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0;
				*(unsigned long *)$op2 = _t1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm244 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm244 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm244 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1 = *(unsigned long *)$op3;
				unsigned long _t0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1;
				*(unsigned long *)$op4 = _t0;
			]"
		end

	asm245 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm245 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm245 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm246 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm246 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm246 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm247 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm247 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm247 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm248 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm248 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm248 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0___0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0___0), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0___0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm249 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm249 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm249 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0___0 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0___0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0___0), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0___0;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm250 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm250 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm250 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm251 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm251 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm251 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0___0 = *(unsigned long *)$op1;
				unsigned long _t1___0 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0___0), "=d" (_t1___0)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0___0;
				*(unsigned long *)$op2 = _t1___0;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm252 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm252 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm252 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1___0 = *(unsigned long *)$op3;
				unsigned long _t0___0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1___0), "1" ((unsigned int)n0), "g" ((unsigned int)_t0___0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1___0;
				*(unsigned long *)$op4 = _t0___0;
			]"
		end

	asm253 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm253 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm253 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask___0 = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask___0 & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask___0 & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask___0;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm254 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm254 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm254 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm255 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm255 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm255 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm256 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm256 (op1.c_pointer, op2.c_pointer)
		end

	c_asm256 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * np = *(unsigned long * *)$op1;
				unsigned long * dp = *(unsigned long * *)$op2;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (*(np + 1)), "=&r" (*(np + 0))
						: "0" ((unsigned int)*(np + 1)), "g" ((unsigned int)*(dp + 1)), "%1" ((unsigned int)*(np + 0)), "g" ((unsigned int)*(dp + 0))
					);

				*(unsigned long * *)$op1 = np;
				*(unsigned long * *)$op2 = dp;
			]"
		end

	asm257 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm257 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm257 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0___1 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0___1), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0___1;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm258 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm258 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm258 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0___1 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0___1)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0___1), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0___1;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm259 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm259 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm259 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm260 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm260 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm260 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0___1 = *(unsigned long *)$op1;
				unsigned long _t1___1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0___1), "=d" (_t1___1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0___1;
				*(unsigned long *)$op2 = _t1___1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm261 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm261 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm261 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1___1 = *(unsigned long *)$op3;
				unsigned long _t0___1 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1___1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0___1)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1___1;
				*(unsigned long *)$op4 = _t0___1;
			]"
		end

	asm262 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm262 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm262 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask___1 = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask___1 & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask___1 & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask___1;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm263 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm263 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm263 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm264 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm264 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm264 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm265 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm265 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm265 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm266 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm266 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm266 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm267 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm267 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm267 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm268 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm268 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm268 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0 = *(unsigned long *)$op1;
				unsigned long _t1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0), "=d" (_t1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0;
				*(unsigned long *)$op2 = _t1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm269 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm269 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm269 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1 = *(unsigned long *)$op3;
				unsigned long _t0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1;
				*(unsigned long *)$op4 = _t0;
			]"
		end

	asm270 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm270 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm270 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm271 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm271 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm271 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm272 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm272 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm272 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm273 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm273 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm273 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm274 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm274 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm274 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm275 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm275 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm275 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm276 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm276 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm276 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0 = *(unsigned long *)$op1;
				unsigned long _t1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0), "=d" (_t1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0;
				*(unsigned long *)$op2 = _t1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm277 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm277 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm277 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1 = *(unsigned long *)$op3;
				unsigned long _t0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1;
				*(unsigned long *)$op4 = _t0;
			]"
		end

	asm278 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm278 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm278 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm279 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm279 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm279 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm280 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm280 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm280 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm281 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm281 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm281 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0___0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0___0), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0___0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm282 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm282 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm282 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0___0 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0___0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0___0), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0___0;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm283 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm283 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm283 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm284 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm284 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm284 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0___0 = *(unsigned long *)$op1;
				unsigned long _t1___0 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0___0), "=d" (_t1___0)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0___0;
				*(unsigned long *)$op2 = _t1___0;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm285 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm285 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm285 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1___0 = *(unsigned long *)$op3;
				unsigned long _t0___0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1___0), "1" ((unsigned int)n0), "g" ((unsigned int)_t0___0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1___0;
				*(unsigned long *)$op4 = _t0___0;
			]"
		end

	asm286 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm286 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm286 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask___0 = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask___0 & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask___0 & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask___0;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm287 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm287 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm287 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm288 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm288 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm288 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm289 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm289 (op1.c_pointer, op2.c_pointer)
		end

	c_asm289 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * np = *(unsigned long * *)$op1;
				unsigned long * dp = *(unsigned long * *)$op2;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (*(np + 1)), "=&r" (*(np + 0))
						: "0" ((unsigned int)*(np + 1)), "g" ((unsigned int)*(dp + 1)), "%1" ((unsigned int)*(np + 0)), "g" ((unsigned int)*(dp + 0))
					);

				*(unsigned long * *)$op1 = np;
				*(unsigned long * *)$op2 = dp;
			]"
		end

	asm290 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm290 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm290 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0___1 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long dinv = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0___1), "=d" (q)
						: "%0" ((unsigned int)n1), "rm" ((unsigned int)dinv)
					);

				*(unsigned long *)$op1 = _q0___1;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n1;
				*(unsigned long *)$op4 = dinv;
			]"
		end

	asm291 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm291 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm291 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0___1 = *(unsigned long *)$op2;
				unsigned long n1 = *(unsigned long *)$op3;
				unsigned long * np = *(unsigned long * *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0___1)
						: "0" ((unsigned int)q), "g" ((unsigned int)n1), "%1" ((unsigned int)_q0___1), "g" ((unsigned int)*(np + 1))
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0___1;
				*(unsigned long *)$op3 = n1;
				*(unsigned long * *)$op4 = np;
			]"
		end

	asm292 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm292 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm292 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm293 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm293 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm293 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0___1 = *(unsigned long *)$op1;
				unsigned long _t1___1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0___1), "=d" (_t1___1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0___1;
				*(unsigned long *)$op2 = _t1___1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm294 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm294 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm294 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1___1 = *(unsigned long *)$op3;
				unsigned long _t0___1 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1___1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0___1)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1___1;
				*(unsigned long *)$op4 = _t0___1;
			]"
		end

	asm295 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm295 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm295 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask___1 = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask___1 & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask___1 & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask___1;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm296 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm296 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm296 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm297 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm297 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm297 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm298 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [PD_GMP_PI1_T]])
		do
			c_asm298 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm298 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n2 = *(unsigned long *)$op3;
				gmp_pi1_t * dinv = *(gmp_pi1_t * *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0), "=d" (q)
						: "%0" ((unsigned int)n2), "rm" ((unsigned int)dinv->inv32)
					);

				*(unsigned long *)$op1 = _q0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n2;
				*(gmp_pi1_t * *)$op4 = dinv;
			]"
		end

	asm299 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm299 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm299 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0 = *(unsigned long *)$op2;
				unsigned long n2 = *(unsigned long *)$op3;
				unsigned long n1 = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n2), "%1" ((unsigned int)_q0), "g" ((unsigned int)n1)
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0;
				*(unsigned long *)$op3 = n2;
				*(unsigned long *)$op4 = n1;
			]"
		end

	asm300 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm300 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm300 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm301 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm301 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm301 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0 = *(unsigned long *)$op1;
				unsigned long _t1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0), "=d" (_t1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0;
				*(unsigned long *)$op2 = _t1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm302 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm302 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm302 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1 = *(unsigned long *)$op3;
				unsigned long _t0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1;
				*(unsigned long *)$op4 = _t0;
			]"
		end

	asm303 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm303 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm303 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm304 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm304 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm304 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm305 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm305 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm305 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm306 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [CE_POINTER [PD_GMP_PI1_T]])
		do
			c_asm306 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm306 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _q0 = *(unsigned long *)$op1;
				unsigned long q = *(unsigned long *)$op2;
				unsigned long n2 = *(unsigned long *)$op3;
				gmp_pi1_t * dinv = *(gmp_pi1_t * *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_q0), "=d" (q)
						: "%0" ((unsigned int)n2), "rm" ((unsigned int)dinv->inv32)
					);

				*(unsigned long *)$op1 = _q0;
				*(unsigned long *)$op2 = q;
				*(unsigned long *)$op3 = n2;
				*(gmp_pi1_t * *)$op4 = dinv;
			]"
		end

	asm307 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm307 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm307 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long q = *(unsigned long *)$op1;
				unsigned long _q0 = *(unsigned long *)$op2;
				unsigned long n2 = *(unsigned long *)$op3;
				unsigned long n1 = *(unsigned long *)$op4;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (q), "=&r" (_q0)
						: "0" ((unsigned int)q), "g" ((unsigned int)n2), "%1" ((unsigned int)_q0), "g" ((unsigned int)n1)
					);

				*(unsigned long *)$op1 = q;
				*(unsigned long *)$op2 = _q0;
				*(unsigned long *)$op3 = n2;
				*(unsigned long *)$op4 = n1;
			]"
		end

	asm308 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm308 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm308 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm309 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm309 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm309 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _t0 = *(unsigned long *)$op1;
				unsigned long _t1 = *(unsigned long *)$op2;
				unsigned long d0 = *(unsigned long *)$op3;
				unsigned long q = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_t0), "=d" (_t1)
						: "%0" ((unsigned int)d0), "rm" ((unsigned int)q)
					);

				*(unsigned long *)$op1 = _t0;
				*(unsigned long *)$op2 = _t1;
				*(unsigned long *)$op3 = d0;
				*(unsigned long *)$op4 = q;
			]"
		end

	asm310 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm310 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm310 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _t1 = *(unsigned long *)$op3;
				unsigned long _t0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)_t1), "1" ((unsigned int)n0), "g" ((unsigned int)_t0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _t1;
				*(unsigned long *)$op4 = _t0;
			]"
		end

	asm311 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm311 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm311 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long _mask = *(unsigned long *)$op3;
				unsigned long d1 = *(unsigned long *)$op4;
				unsigned long d0 = *(unsigned long *)$op5;

				__asm__ volatile ("addl %5,%k1\n\tadcl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)(_mask & d1)), "%1" ((unsigned int)n0), "g" ((unsigned int)(_mask & d0))
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = _mask;
				*(unsigned long *)$op4 = d1;
				*(unsigned long *)$op5 = d0;
			]"
		end

	asm312 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm312 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm312 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm313 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm313 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm313 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long n1 = *(unsigned long *)$op1;
				unsigned long n0 = *(unsigned long *)$op2;
				unsigned long d1 = *(unsigned long *)$op3;
				unsigned long d0 = *(unsigned long *)$op4;

				__asm__ volatile ("subl %5,%k1\n\tsbbl %3,%k0"
						: "=r" (n1), "=&r" (n0)
						: "0" ((unsigned int)n1), "g" ((unsigned int)d1), "1" ((unsigned int)n0), "g" ((unsigned int)d0)
					);

				*(unsigned long *)$op1 = n1;
				*(unsigned long *)$op2 = n0;
				*(unsigned long *)$op3 = d1;
				*(unsigned long *)$op4 = d0;
			]"
		end

	asm314 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm314 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm314 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				unsigned long cx = *(unsigned long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (scratch), "ri" (cx - cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = scratch;
				*(unsigned long *)$op3 = cx;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm315 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm315 (op1.c_pointer, op2.c_pointer)
		end

	c_asm315 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm316 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm316 (op1.c_pointer, op2.c_pointer)
		end

	c_asm316 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___1)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm317 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm317 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm317 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long dn = *(long *)$op3;
				unsigned long cx = *(unsigned long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (scratch + dn), "ri" (cx - cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = dn;
				*(unsigned long *)$op4 = cx;
				*(unsigned long *)$op5 = cy;
			]"
		end

	asm318 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm318 (op1.c_pointer, op2.c_pointer)
		end

	c_asm318 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm319 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm319 (op1.c_pointer, op2.c_pointer)
		end

	c_asm319 (op1: POINTER; op2: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * qp = *(unsigned long * *)$op2;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___1)
						: "0" (qp)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = qp;
			]"
		end

	asm320 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm320 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm320 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long dummy = *(unsigned long *)$op1;
				unsigned long h = *(unsigned long *)$op2;
				unsigned long l = *(unsigned long *)$op3;
				unsigned long d = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (dummy), "=d" (h)
						: "%0" ((unsigned int)l), "rm" ((unsigned int)d)
					);

				*(unsigned long *)$op1 = dummy;
				*(unsigned long *)$op2 = h;
				*(unsigned long *)$op3 = l;
				*(unsigned long *)$op4 = d;
			]"
		end

	asm321 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [NATURAL_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm321 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm321 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long dummy = *(unsigned long *)$op1;
				unsigned long h = *(unsigned long *)$op2;
				unsigned long l = *(unsigned long *)$op3;
				unsigned long d = *(unsigned long *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (dummy), "=d" (h)
						: "%0" ((unsigned int)l), "rm" ((unsigned int)d)
					);

				*(unsigned long *)$op1 = dummy;
				*(unsigned long *)$op2 = h;
				*(unsigned long *)$op3 = l;
				*(unsigned long *)$op4 = d;
			]"
		end

	asm322 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm322 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm322 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long qn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (tp + qn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = qn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm323 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm323 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm323 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long lo = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (tp + lo), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = lo;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm324 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm324 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm324 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long hi = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (tp + hi), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = hi;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm325 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm325 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm325 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long qn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (tp + qn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = qn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm326 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [NATURAL_32])
		do
			c_asm326 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm326 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * tp = *(unsigned long * *)$op2;
				long qn = *(long *)$op3;
				unsigned long cy = *(unsigned long *)$op4;

				__asm__ volatile ("addl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___0)
						: "0" (tp + qn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = tp;
				*(long *)$op3 = qn;
				*(unsigned long *)$op4 = cy;
			]"
		end

	asm327 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [INTEGER_32]; op6: CE_ARRAY [INTEGER_32])
		do
			c_asm327 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm327 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;
				long wn = *(long *)$op5;
				int c0 = *(int *)$op6;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" (((scratch + in) + dn) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
				*(long *)$op5 = wn;
				*(int *)$op6 = c0;
			]"
		end

	asm328 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm328 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm328 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" (((scratch + in) + dn) + dn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
			]"
		end

	asm329 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [INTEGER_32]; op6: CE_ARRAY [INTEGER_32])
		do
			c_asm329 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer, op6.c_pointer)
		end

	c_asm329 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER; op6: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;
				long wn = *(long *)$op5;
				int c0 = *(int *)$op6;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" (((scratch + in) + dn) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
				*(long *)$op5 = wn;
				*(int *)$op6 = c0;
			]"
		end

	asm330 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm330 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm330 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___2)
						: "0" (((scratch + in) + dn) + dn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
			]"
		end

	asm331 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [INTEGER_32])
		do
			c_asm331 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm331 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long wn = *(long *)$op4;
				int c0 = *(int *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" ((scratch + in) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = wn;
				*(int *)$op5 = c0;
			]"
		end

	asm332 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm332 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm332 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long wn = *(long *)$op4;
				unsigned long c0 = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" ((scratch + in) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = wn;
				*(unsigned long *)$op5 = c0;
			]"
		end

	asm333 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm333 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm333 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___0 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___0)
						: "0" ((scratch + in) + dn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___0;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
			]"
		end

	asm334 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm334 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm334 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___1 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long wn = *(long *)$op4;
				unsigned long c0 = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___1)
						: "0" ((scratch + in) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___1;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = wn;
				*(unsigned long *)$op5 = c0;
			]"
		end

	asm335 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm335 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm335 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___2 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___2)
						: "0" ((scratch + in) + dn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___2;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
			]"
		end

	asm336 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm336 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm336 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___3 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long wn = *(long *)$op4;
				unsigned long c0 = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___3)
						: "0" ((scratch + in) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___3;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = wn;
				*(unsigned long *)$op5 = c0;
			]"
		end

	asm337 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm337 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm337 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___4 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long wn = *(long *)$op4;
				unsigned long c0 = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy___4)
						: "0" ((scratch + in) + wn), "ri" (c0)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___4;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = wn;
				*(unsigned long *)$op5 = c0;
			]"
		end

	asm338 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32])
		do
			c_asm338 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm338 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy___5 = *(unsigned long * *)$op1;
				unsigned long * scratch = *(unsigned long * *)$op2;
				long in = *(long *)$op3;
				long dn = *(long *)$op4;

				__asm__ volatile ("\n" ".L" "asm_%=_" "top" ":\n" "\t" "addl" " $1, (%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top"
						: "=r" (__ptr_dummy___5)
						: "0" ((scratch + in) + dn)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy___5;
				*(unsigned long * *)$op2 = scratch;
				*(long *)$op3 = in;
				*(long *)$op4 = dn;
			]"
		end

	asm339 (op1: CE_ARRAY [NATURAL_32]; op2: CE_ARRAY [NATURAL_32]; op3: CE_ARRAY [CE_POINTER [NATURAL_32]]; op4: CE_ARRAY [CE_POINTER [NATURAL_32]])
		do
			c_asm339 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer)
		end

	c_asm339 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long _pl = *(unsigned long *)$op1;
				unsigned long _ph = *(unsigned long *)$op2;
				unsigned long * mip = *(unsigned long * *)$op3;
				unsigned long * up = *(unsigned long * *)$op4;

				__asm__ volatile ("mull %3"
						: "=a" (_pl), "=d" (_ph)
						: "%0" ((unsigned int)*(mip + 0)), "rm" ((unsigned int)*(up + 0))
					);

				*(unsigned long *)$op1 = _pl;
				*(unsigned long *)$op2 = _ph;
				*(unsigned long * *)$op3 = mip;
				*(unsigned long * *)$op4 = up;
			]"
		end

	asm340 (op1: CE_ARRAY [CE_POINTER [NATURAL_32]]; op2: CE_ARRAY [CE_POINTER [NATURAL_32]]; op3: CE_ARRAY [INTEGER_32]; op4: CE_ARRAY [INTEGER_32]; op5: CE_ARRAY [NATURAL_32])
		do
			c_asm340 (op1.c_pointer, op2.c_pointer, op3.c_pointer, op4.c_pointer, op5.c_pointer)
		end

	c_asm340 (op1: POINTER; op2: POINTER; op3: POINTER; op4: POINTER; op5: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"[
				unsigned long * __ptr_dummy = *(unsigned long * *)$op1;
				unsigned long * yp = *(unsigned long * *)$op2;
				long n = *(long *)$op3;
				long rn = *(long *)$op4;
				unsigned long cy = *(unsigned long *)$op5;

				__asm__ volatile ("subl" " %2,(%0)\n" "\tjnc " ".L" "asm_%=_" "done" "\n" ".L" "asm_%=_" "top" ":\n" "\t" "subl" " $1,4(%0)\n" "\tleal 4(%0),%0\n" "\tjc " ".L" "asm_%=_" "top" "\n" ".L" "asm_%=_" "done" ":\n"
						: "=r" (__ptr_dummy)
						: "0" ((yp + 2l * n) - rn), "ri" (cy)
						: "memory"
					);

				*(unsigned long * *)$op1 = __ptr_dummy;
				*(unsigned long * *)$op2 = yp;
				*(long *)$op3 = n;
				*(long *)$op4 = rn;
				*(unsigned long *)$op5 = cy;
			]"
		end

end
